
(*
:Mathematica Version: 4.0
*)
(*
:Package Version: 1.0.4
*)
(*
:Copyright: public domain
*)
(*
:Name: fNBookForm2`
*)
(*
:Title: fNBookForm2
*)
(*
:Author: John Hendrickson (debguy@sourceforge.net)
*)
(*
:History: None
*)
(*
:Keywords: fNBookForm2 NumberForm
*)
(*
:Requirements: None
*)
(*
:Sources: all code is origional by author
*)
(*
:Summary:
	oops it's in help browser file for package jutils
		jutils.help.nb
		some usage is defined below
	NOTE:
		some funs are result of CreateModule used in
		PeriodTableOfElements (to edit these funs use that)

	by: John Hendrickson (debguy@sourceforge.net), 2013, public domain
		credit to many authors of math in general
*)
(*
:History: 

improved packaging

unlikely obscure problem due to mis-spelling. 1.0 had FractionalPart \
mispelled in one place.  If rounding, and acc and prec were both specified \
(remember mm doesn't allow it) and fractional and both equal excepting their \
fractional parts, would effect contest of prec frac winning between two close \
calls if acc had not already won, which then only might effect rounding style \
(the slope of % error eq.)
*)
(*
setup
*)
(*
(* suggested , see the mm book *)
If[False,
  (* On[MemoryConserve] *)(* may be causing crashes *)
  (* 
    turn off has similar spelling messages *)
  Off[General::"spell"];
  Unprotect[In, Out];
  Clear[In, Out];
  Protect[In, Out];
  $HistoryLength = 5;
  MemoryInUse[];
  ]
*)
Needs["Miscellaneous`Units`"];
(*
Needs["Miscellaneous`ChemicalElements`"];
Needs["Miscellaneous`PhysicalConstants`"];
Needs["Months`"];
Needs["Miscellaneous`Calendar`"];
*)
Needs["jutils`"];
(*
Map[Clear, Names["c2`p`*"]];
*)
(*
Map[Clear, Names["c2`*"]];
*)
(*
Map[(Clear[ToString["fNBookForm2`" <> #]]) &, {powerstab, powerstable, 
      powerstab1, powerstab2, powerstab3, powers, bookpower, powerstab3, 
      powerstab4, powerbook, bookexp, booknum, Sep, Units, fNBookForm2, sd, 
      opts, sep, u, showprec, printstate, rounding, commas, fill, sigzeros, 
      fNBookForm2Short, fNBookForm2Arb}];
*)
(*
Map[(Clear[ToString["fNBookForm2`Private`" <> #]]) &, {x, y, u, v, w, z, n, s,
       k, ee, EE, units, sep, n, k, y, e, num, den, debug, b, s1, s2}];
*)
BeginPackage["fNBookForm2`", {"Miscellaneous`Units`", "jutils`"}];
powers::usage = "powers array";
powerstab3::usage = "powers table";
powerstab4::usage = "powers table";
powerstable::usage = "powers table";
powerbook::usage = 
    "powerbook[int|string]  given n returns symbol, in style u, or e1 exp \
style if it was applicable but not in table.  1 is digit form, 2 is symbol \
form, 3 is letter form, 4 is string form. ie powerbook[3] -> k";
powerbook::notinteger = "`1`";
booknum::usage = 
    "booknum[num_String,opts]  \"num unit\".  Converts fNBookForm output \
string to Expression.  The interpretation is a little wider, but it tries to \
restore precision as read from book to mm.  num can also be Symbol.  unit can \
be powers letter, e1 style exponent, missing, or Symbol.  opt Unit is for \
bookexp[, Unit].  If Symbol isn't recognized it is reflected.  For (ie. Tera) \
Convert[Tera,1] is an alternative.  Commas in input are ignored.  ie. \
booknum[\"3 m\"]->0.003";
booknum::fields = "error too many fields in: " <> "\"" <> "`1`" <> "\"";
booknum::nosplit = "no fields on split: " <> "\"" <> "`1`" <> "\"";
bookexp::usage = 
    "bookexp[Integer|String|Symbol]  looks up object in powers table and \
returns requested alias.  Default is type 1.  1 numberic  2 Symbol  3 letter  \
4 String.  ie. bookexp[Milli] == -3";
fNBookForm2::usage = 
    "fNBookForm2[num,opts]  Output to string using letter powers.  Condenses \
automatically while preserving significance.  Input can be InputForm.  Output \
form is also decided by preserving input style; letter formatting aside.  \
Options@fNBookForm2 == \
{c2`p`sd->4,c2`p`u->3,c2`p`sep->space,c2`p`showprec->False,c2`p`printstate->\
False,c2`p`rounding->0}.  sd is tot. width.  Rounding is off.  {0,1,2,3}.  On \
1st estimated digit boundry (on .7 of `1.7):  1. don't round est dig but show \
 2. round into est dig and show  3. round off est dig (do not show).  Try \
fNBookForm2Arb for arbitrary numbers, booknum to import book nums, and \
fNBookForm2Short (shortest showprec).";
fNBookForm2::"unformatted" = "`1`";
fNBookForm2::"extra input" = "`1` : `2`";
fNBookForm2::"fractional exponent" = "`1`";
fNBookForm2::"unexpected error" = "`1`";
fNBookForm2::"prec flooded acc" = 
    "too many precise digits left of decimal left no room for accuracy, but \
were kept: `1`";
fNBookForm2Short::usage = 
    "fNBookForm2Short[___]  Shows shorter of the two results of \
showprec->True and showprec->False.  See ? fNBookForm2.";
fNBookForm2Arb::usage = 
    "fNBookForm2Arb[Rational|Integer,u:2]  Offers a version of Arbitrary \
Precision number with powers Symbol (ie, Milli) used to reduce.  With u 3 or \
4 be prettier. Use for base 10 untested other bases.";
Begin["`Private`"];
(*
powers
*)
(*
Before the symbol was standardized as da with the introduction of the \
International System of Units in 1960, various other symbols were more \
common, such as "dk", "D", and "Da". (in last release i couldn't find thes in \
CRC'72 or my book and used "" and fNBookForm assumed no abbrev. was avail.)
	CRC'72 used dkgr for dekagram, dg for decigram.  today they say "dag" or \
"dg"
	and call "deka" and unofficial spelling of deca (i doubt this, but ok)
	i'm correct: deka is 10 in old Greek, deca is the "new" spelling
i'll leave "da" in but for real use I'd use "D" or maybe "d".  it may mess up \
a column alignment, but may come in handy if comparing to something else or \
appended to something else
*)
powers = {
      {24, 21, 18, 15, 12, 9, 6, 3, 2, 1, -1, -2, -3
        , -6, -9, -12, -15, -18, -21, -24}
      , {Yotta, Zetta, Exa, Peta, Tera, Giga, Mega
        , Kilo, Hecto, Deca, Deci, Centi, Milli, Micro
        , Nano, Pico, Femto, Atto, Zepto, Yocto}
      , {"Y", "Z", "E", "P", "T", "G", "M", "k", "h", "da", "d", "c", "m", 
        "\[Micro]", "n", "p", "f", "a", "z", "y"}
      , {"Yotta", "Zetta", "Exa", "Peta", "Tera", "Giga", "Mega"
        , "Kilo", "Hecto", "Deca", "Deci", "Centi", "Milli", "Micro"
        , "Nano", "Pico", "Femto", "Atto", "Zepto", "Yocto"}
      (* NOTE : \[Micro] is Micro not \[Mu] Mu *)
      };
(*
powerstable
*)
powerstab3 = Module[{n, s},
      Table[
        s = ToString[powers[[1, i]]];
        {
          "\!\(10" <> "\^" <> s <> "\)"
          , ToString[powers[[2, i]]]
          , ToString[powers[[3, i]]]
          }
        , {i, 1, Length[powers[[1]]]}
        ]];
powerstab4 = 
    Table[Flatten[{powerstab3[[i]], "  ", powerstab3[[i + 10]]}], {i, 1, 10}];
  
powerstab4 = 
    Prepend[powerstab4, {"Power", "Prefix", "Ab", "  ", "Power", "Prefix", 
        "Ab"}];
powerstable = 
    GridBox[powerstab4, RowLines -> True, ColumnLines -> True, 
        GridFrame -> True] // DisplayForm;
(*
GridBox[powerstab3, RowLines -> True, ColumnLines -> True] // DisplayForm
*)
(*
powerbook --  function
*)
powerbook[z_Integer | z_String, u_:3] := Module[{n, k, y},
    k = ToExpression[z];(*NumberFormat uses String*)
    
    If[\[Not] IntegerQ[k], Message[powerbook::"notinteger", k]; Return[z]];
    n = Position[powers[[1]], k];
    If[Length[n] == 0, "e" <> ToString[k],
      y = powers[[u, n[[1, 1]]]];
      If[y === "", "e" <> ToString[k], y]
      ]]
(*
{powerbook[-6], powerbook["3"], powerbook["1.2"], powerbook[{}], 
  powerbook[snf2], powerbook[-7], powerbook[25], powerbook[3, 1], 
  powerbook[3, 2], powerbook[3, 3], powerbook[3, 4]}
*)
(*
{"\[Micro]", "k", "1.2", powerbook[{}], 
  powerbook[snf2], "e-7", "e25", 3, Kilo, "k", "Kilo"}
*)
(*
bookexp --  function
*)
bookexp[x_, w_ : 1] := Module[{v},
v = Position[powers, x];
If[Length[v] > 0,
        v = v[[1]];
        If[Length[v] == 2,
          v = v[[2]];
          v = powers[[w, v]];
          ]
        , v = {};
        ];
v
];
(*
booknum --  function
*)
(*
this (and fNBookForm2) are right on the edge of needing a parser
	but external things are not widely supported
	and both have "unusual actions" during parsing
*)
Options[booknum] = {Sep -> {" ", "\[ThinSpace]"}, Units -> 1};
booknum[x_String, opts___] := Module[{v, s, ee, EE, sep, units},
sep = Sep /. {opts} /. Options[booknum];
units = Units /. {opts} /. Options[booknum];
If[StringLength[x] < 1, Return[x]];
xx = StringReplace[x, "," -> ""];
base = 10;
s = Null;
ee = Null;
EE = StringPosition[xx, "^^"];
If[EE != {}, base = ToExpression[StringTake[xx, EE[[1, 1]] - 1]]];
v = groupadjacent[Characters[xx], true, (Intersection[sep, {#}] == {}) &];
EE = Length@v;
If[Length@v == 1,
        v = 
          groupadjacent[Characters[xx], 
            true, (DigitQ[#] || 
                  Intersection[{"^", ".", "`", "*"}, {#}] != {} &)];
        EE = Length@v;
        If[EE < 1, Message[booknum::"nosplit", x]; Return[x]];
        If[EE > 1 && base <= 10 && NumericQ[ToExpression@StringJoin@v[[1]]], 
          v = StringJoin@{v[[1]], sep[[1]], Rest[v]}, v = xx];
        v = 
          groupadjacent[Characters[v], 
            true, (Intersection[sep, {#}] == {}) &];
        ];
If[Position[Characters[xx], "`"] == {},
        EE = groupadjacent[v[[1]], true, (# != "*") &];
        s = ToExpression[StringJoin[EE[[1]]]];
        EE = 
          Length@Cases[Characters@ToString@s, _?(DigitQ[#] || LetterQ[#] &)];
        ee = 777;
        ];
s = ToExpression[StringJoin[v[[1]]]];
If[ee == 777, s = SetPrecision[s, EE]];
ee = Null;
If[Length@v > 1, v = Drop[v, 2], v = Drop[v, 1]];
If[Length@v > 1, While[Intersection[sep, v[[1]]] != {}, v = Drop[v, 1]]];
EE = Length@v;
If[EE == 0, Return[s]];
If[EE > 1, Message[booknum::"fields", x]; Return[x]];
EE = groupadjacent[v[[1]], true, (Intersection[{"e", "E"}, {#}] == {}) &];
If[Length@EE >= 2,
        EE = Drop[EE, 1];
        If[NumericQ@ToExpression@StringJoin@EE,
          units = 777; v = EE;
          ];];
EE = StringJoin@v;
If[units == 777,
        ee = base^ToExpression@EE;
        ,
        ee = bookexp[EE, units];
        If[units == 1 && NumericQ[ee], ee = base^ee];
        If[ee === {}, ee = ToExpression@EE];
        ];
If[ee =!= Null, s = s ee];
s
];
(*
Remove[xxx, x];
*)
(*
x = 5;
*)
(*
{ booknum["2.0 \[Micro]"], booknum["2 \[Micro]", Units -> 2], 
  booknum["2 \[Micro]", Units -> 3], booknum["2e0"], 1/10 booknum["2 Ampere"],
   booknum["20.0 xyx"], , booknum["2.0 + 3"], booknum[1], booknum[zzz], 
  booknum["zzz"], booknum["12 da"], booknum["1.1h"], booknum["1.11e2"], 
  booknum["123"], booknum["16^^10 e3"], booknum["123`2 e2"], 
  booknum["123``0"], booknum["1 Micro"], booknum["1 Micro", Units -> 3], 
  booknum["16^^10`3*^1"], booknum["16^^10 da"], booknum["16^^10*^1"], 
  booknum["x a"], booknum["xxx a"] // N, booknum["2,000 \[Micro]"]}
*)
(*
\!\({2.`1*^-6, 2.`1\ Micro, 2.`1\ "\[Micro]", 2.`1, 
    0.19999999995343`1\ Ampere, 20.`2\ xyx, Null, "2.0 + 3", booknum[1], 
    booknum[zzz], zzz, 120.`2, 109.99999999999979`2, 110.99999999999994`3, 
    123.`3, 65536.`2, 12300.`2, 123.`2.0899, 1.`1*^-6, 1.`1\ "\[Micro]", 
    256.`3.6124, 256.`2, 256.`2, 4.999999999999999`1*^-18, 1.`*^-18\ xxx, 
    0.002`4}\)
*)
(*
Remove[head, cell, s, v, x, xx, sep, opts, ee, EE, units, base];
*)
(*
recheck if rounding 16^^10*^2 is using right (4096 or 64)
*)
(*
{ booknum["2.0 \[Micro]"], booknum["2 \[Micro]", Units -> 2], 
  booknum["2 \[Micro]", Units -> 3], booknum["2e0"], 1/10 booknum["2 Ampere"],
   booknum["20.0 xyx"], , booknum["2.0 + 3"], booknum[1], booknum[zzz], 
  booknum["zzz"], booknum["12 da"], booknum["1.1h"], booknum["1.11e2"], 
  booknum["123"], booknum["16^^10 e3"], booknum["123`2 e2"], 
  booknum["123``0"], booknum["1 Micro"], booknum["1 Micro", Units -> 3], 
  booknum["16^^10`3*^1"], booknum["16^^10 da"], booknum["16^^10*^1"], 
  booknum["x a"], booknum["xxx a"] // N, booknum["2,000 \[Micro]"]}
*)
(*
fNBookForm2 - test / debug / define
*)
(*
the code handles cases regular sig, sigzero, fill, ``, `, `` `
	i'd never have used 1 fun for all that
		it just accumulated a step at a time it was easier at the time
	it is way too many things to handle at once
		see fNBookForm2Short offloads one task
		--> sigzero and fill should be their own functions
	well it's done.
		and 1 fun is easier than 3 to update and more convenient to use
	**	however i would not __dare try add a single extra load on it
	**  its complicated enough as it is
because of that it needs to be modular and is pretty well so by design, ie \
...
	rounding must not add a "0" since how to react to it later would be awful
	rounding must use ++nexp instead
*)
(*
RunToBoundryCell
*)
(*
c2`p` keeps "p"arameters in separate area from the rest.
If your wondering why bother using c2` and c2`p see Remove note at end of \
section.
*)
(*
Map[Remove, Names["c2`p`*"]];
*)
(*
Map[Remove, Names["c2`*"]];
*)
(*
Remove[fNBookForm2, x];
*)
(*
Remove[opts, sd, u, sep, showprec, printstate, rounding, commas, fill, 
    sigzeros];
*)
(*
{Names["c2`*"], Names["c2`p`*"]}
*)
(*
{{}, {}}
*)
(*
NOTE:  vars4 isn't used for CreateModule anymore - now automatic.
*)
(*
vars4={"c2`q","c2`t","c2`w","c2`s","c2`k","c2`sign","c2`mant","c2`sig","c2`\
base","c2`acc","c2`exp","c2`prec""c2`nprec","c2`nacc","c2`nexp","c2`sd","c2`\
u","c2`sep","c2`showprec","c2`printstate","c2`rounding","c2`commas"};
*)
(*
Map[Remove,vars4];
*)
(*
test values - note Global`x is only to show it is NOT interfering
*)
Options[fNBookForm2] = {c2`p`sd -> 4, c2`p`u -> 3, c2`p`sep -> "\[ThinSpace]",
       c2`p`showprec -> False, c2`p`printstate -> False, c2`p`rounding -> 0, 
      c2`p`commas -> False, c2`p`fill -> False, c2`p`sigzeros -> False};
fNBookForm2[c2`p`x_Integer | c2`p`x_Real | c2`p`x_String, c2`p`opts___] := 
    Module[{c2`acc, c2`base, c2`c1, c2`c2, c2`commas, c2`debug, c2`exp, 
        c2`fexp, c2`fill, c2`getp, c2`k, c2`mant, c2`nacc, c2`nexp, c2`nprec, 
        c2`oldxw, c2`p, c2`prec, c2`printstate, c2`q, c2`rounding, c2`roundok,
         c2`s, c2`sd, c2`sep, c2`showprec, c2`sig, c2`sign, c2`sigzeros, c2`t,
         c2`u, c2`w},
c2`s = c2`p`x;
If[Head[c2`p`x] == Integer || Head[c2`p`x] == Real,
        c2`s = ToString[InputForm[c2`p`x]]];
c2`sd = c2`p`sd /. {c2`p`opts} /. Options[fNBookForm2];
c2`u = c2`p`u /. {c2`p`opts} /. Options[fNBookForm2];
c2`sep = c2`p`sep /. {c2`p`opts} /. Options[fNBookForm2];
c2`showprec = c2`p`showprec /. {c2`p`opts} /. Options[fNBookForm2];
c2`printstate = c2`p`printstate /. {c2`p`opts} /. Options[fNBookForm2];
c2`rounding = c2`p`rounding /. {c2`p`opts} /. Options[fNBookForm2];
c2`commas = c2`p`commas /. {c2`p`opts} /. Options[fNBookForm2];
c2`fill = c2`p`fill /. {c2`p`opts} /. Options[fNBookForm2];
c2`sigzeros = c2`p`sigzeros /. {c2`p`opts} /. Options[fNBookForm2];
c2`mant = {}; c2`sig = {}; c2`base = {}; c2`prec = {}; c2`acc = {}; 
      c2`exp = {};
c2`nprec = False; c2`nacc = False; c2`nexp = False;
c2`sign = "";
If[c2`printstate, Print[c2`s]];
c2`s = StringReplace[
          c2`s, {"\\" -> "", ".^" -> "^", ".``" -> "``", ".`" -> "`", 
            ".*" -> "*", "`." -> "`0."}];
If[StringTake[c2`s, -1] == "`" || StringMatchQ[c2`s, "*`\\**"],
        c2`w = StringReplace[c2`s, {"``*" -> "*"}];
        If[
          StringLength@c2`w != StringLength@c2`s || 
            StringTake[c2`s, -2] == "``",
          If[StringTake[c2`s, -2] == "``", c2`w = StringDrop[c2`s, -2]];
          c2`s = c2`w;
          If[NumberQ[c2`printstate],
            c2`nacc = c2`printstate
            ,
            c2`nacc = Accuracy[1`]
            ]];
        c2`w = StringReplace[c2`s, {"`*" -> "*"}];
        If[StringLength@c2`w != StringLength@c2`s || 
            StringTake[c2`s, -1] == "`",
          If[StringTake[c2`s, -1] == "`", c2`w = StringDrop[c2`w, -1]];
          c2`s = c2`w;
          If[NumberQ[c2`printstate],
            c2`nprec = c2`printstate;
            ,
            c2`nprec = Precision[1`];
            ]];
        ];
c2`w = Characters[c2`s];
Length[c2`w] > 0 || Return[c2`p`x];
If[c2`w[[1]] == "-",
        c2`sign = "-";
        c2`w = Drop[c2`w, 1]
        ];
c2`q = (Intersection[{"^", ".", "`", "*", " "}, {#}] == {}) &;
c2`w = groupadjacent[c2`w, true, c2`q];
Length[c2`w] > 0 || Return[c2`p`x];
c2`debug[] := 
        If[c2`printstate == True, 
          Print[{{"c2`t", c2`t}, {"w", c2`w}, {" S ", c2`sign}, {" s ", 
                c2`sig}, {" m ", c2`mant}, {" p ", c2`prec, " ", 
                c2`nprec}, {" a ", c2`acc, " ", c2`nacc}, {" e ", c2`exp, " ",
                 c2`nexp, " ", c2`fexp}, {"sd=", c2`sd}, {"r=", 
                c2`rounding}}]
          ];
SetAttributes[c2`getp, HoldFirst];
c2`getp[p_Symbol] := If[Length[c2`w] > 0 && c2`q@c2`w[[1, 1]],
          p = Join[p, c2`w[[1]]]; c2`w = Rest[c2`w]; True, False];
c2`getp[p_Symbol, c_] := 
        If[Length[c2`w] > 1 && c2`w[[1, 1]] == c, 
          If[c2`q@c2`w[[2, 1]], p = Join[p, c2`w[[2]]]; c2`w = Drop[c2`w, 2]; 
            True, Message[fNBookForm2::"unformatted", c2`s]; -1], False];
c2`getp[p_Symbol, c1_, c2_] := 
        If[Length[c2`w] > 2 && c2`w[[1, 1]] == c1 && c2`w[[2, 1]] == c2, 
          c2`w = Rest[c2`w]; c2`getp[p, c2], False;];
If[c2`getp[c2`mant, "."] == -1, Return[c2`p`x]];
c2`getp[c2`sig];
If[c2`getp[c2`base, "^", "^"] == -1, Return[c2`p`x]];
If[c2`base != {},
        c2`k = c2`sig;
        c2`sig = c2`base;
        c2`base = c2`k;
        ];
If[c2`getp[c2`mant, "."] == -1, Return[c2`p`x]];
c2`mant == {} && c2`sig == {} && Return[c2`p`x];
If[c2`getp[c2`acc, "`", "`"] == -1, Return[c2`p`x]];
c2`t = {};
If[c2`getp[c2`t, "."] == -1, Return[c2`p`x]];
If[Length[c2`t] > 0, c2`acc = Join[c2`acc, {"."}, c2`t]];
If[c2`getp[c2`prec, "`"] == -1, Return[c2`p`x]];
c2`t = {};
If[c2`getp[c2`t, "."] == -1, Return[c2`p`x]];
If[Length[c2`t] > 0, c2`prec = Join[c2`prec, {"."}, c2`t]];
If[c2`getp[c2`acc, "`", "`"] == -1, Return[c2`p`x]];
c2`t = {};
If[c2`getp[c2`t, "."] == -1, Return[c2`p`x]];
If[Length[c2`t] > 0, c2`acc = Join[c2`acc, {"."}, c2`t]];
If[c2`getp[c2`exp, "*", "^"] == -1, Return[c2`p`x]];
c2`t = {};
If[c2`getp[c2`t, "."] == -1, Return[c2`p`x]];
If[Length@c2`w =!= 0 && c2`w =!= {{"."}}, 
        Message[fNBookForm2::"extra input", c2`s, c2`w]; Return[c2`p`x]];
If[Length[c2`t] > 0, c2`exp = Join[c2`exp, {"."}, c2`t]];
If[Length[c2`acc] > 0,
        c2`nacc = ToExpression[StringJoin[c2`acc]]];
If[Length[c2`prec] > 0,
        c2`nprec = ToExpression[StringJoin[c2`prec]]];
c2`nexp = If[Length[c2`exp] > 0,
          ToExpression[StringJoin[c2`exp]], 0];
c2`fexp = FractionalPart@c2`nexp;
c2`nexp = IntegerPart@c2`nexp;
If[Length[c2`base] > 0, c2`base = ToExpression@StringJoin@c2`base; 
        If[c2`base == 1, c2`rounding = 0], c2`base = 10];
If[c2`base <= 0, Message[fNBookForm2::"unformatted", c2`s]; Return[c2`p`x]];
c2`roundok = True;
c2`debug[];
c2`w = Length[c2`sig];
If[\[Not] c2`sigzeros,
        If[c2`w > 1 && c2`sig[[1]] == "0",
          c2`t = 1;
          While[c2`w > c2`t && c2`sig[[c2`t + 1]] == "0", ++c2`t];
          c2`sig = Drop[c2`sig, c2`t];
          If[c2`sig == {} && c2`mant == {}, c2`sig = {"0"}];
          c2`w = Length[c2`sig];
          ];
        If[
          c2`w == 0 || (c2`w == 1 && c2`sig[[1]] == "0" && c2`mant != {}) && 
              c2`base > 1,
          c2`q = Length@c2`mant;
          If[c2`q == 0, Return[c2`p`x]];
          c2`sig = {}; c2`w = 0; c2`t = 0;
          While[c2`t + 1 <= c2`q && c2`mant[[c2`t + 1]] == "0", ++c2`t];
          If[c2`t == c2`q, --c2`t; c2`roundok = False];
          If[c2`t > 0, c2`mant = Drop[c2`mant, c2`t]];
          c2`nexp -= c2`t];
        ];
c2`sig = Join[c2`sig, c2`mant];
c2`mant = {};
c2`debug[];
c2`q = Length[c2`sig];
c2`acc = c2`sd;
c2`oldxw = {c2`nexp, c2`w};
c2`k = False;
If[c2`nprec < c2`sd && c2`q + c2`nacc > c2`nprec, 
        Message[fNBookForm2::"prec flooded acc", c2`s]];
If[c2`sd <= 0, c2`roundok = False];
If[c2`fill && c2`showprec === False && 
          c2`acc > 0 && (c2`sig != {"0"} || c2`sigzeros),
        If[c2`printstate, Print["s0=", c2`sig, " ne=", c2`nexp]];
        If[c2`printstate, Print["add left acc 0's"]; c2`debug[]];
        c2`q = Length@c2`sig;
        c2`exp = c2`nexp - (c2`q - c2`w);
        If[NumberQ@c2`nacc, c2`t = c2`nacc, 
          If[NumberQ@c2`nprec, c2`t = c2`nprec, c2`t = c2`q]];
        c2`prec = c2`exp + c2`q;
        If[c2`printstate, 
          Print["s1=", c2`sig, " pr=", c2`prec, " e=", c2`exp, " q=", c2`q, 
            " t=", c2`t]];
        If[c2`prec < 0 && c2`t >= 0,
          c2`prec = -c2`prec;
          c2`t = Ceiling@c2`t;
          If[c2`prec > c2`sd,
            c2`sig = {}; c2`roundok = False; c2`prec = c2`sd
            ,
            
            If[NumberQ@c2`nacc && c2`prec > c2`t, c2`prec = c2`t; 
              c2`roundok = False; c2`sig = {}]
            ];
          c2`sig = Join[Table["0", {c2`s, 1, c2`prec}], c2`sig];
          c2`nexp = 0; c2`w = 0;
          c2`q = Length[c2`sig];
          c2`fill = c2`prec;
          
          If[c2`printstate, 
            Print["n1=", c2`nexp, " p=", c2`prec, " acc=", c2`acc, " fill=", 
              c2`fill]; c2`debug[]]
          ]
        ];
If[c2`nacc =!= False,
        c2`t = If[c2`rounding == 3, Floor[c2`nacc], Ceiling[c2`nacc]];
        c2`exp = c2`nexp - (c2`q - c2`w);
        If[c2`exp <= -c2`t,
          
          If[c2`printstate, 
            Print["t=", c2`t, " q=", c2`q, " e=", c2`exp, " a=", 
              c2`q + c2`exp + c2`t]];
          c2`t = c2`q + c2`exp + c2`t;
          If[c2`t <= c2`sd, c2`sd = c2`t; c2`k = c2`nacc]
          ]];
If[c2`nprec =!= False,
        c2`t = If[c2`rounding == 3, Floor[c2`nprec], Ceiling[c2`nprec]];
        If[c2`fill > 0, c2`t += c2`fill];
        If[c2`t <= c2`sd,
          c2`sd = c2`t;
          If[c2`sd == 0 && c2`rounding != 3, c2`roundok = False];
          
          If[c2`k == False || 
              FractionalPart@c2`nprec <= FractionalPart@c2`nacc, 
            c2`k = c2`nprec];
          If[c2`nprec <= 0, c2`sd = 0; c2`roundok = False]
          ]];
If[c2`q > c2`sd,
        If[c2`sd < 0, c2`sd = 0; c2`roundok = False];
        If[c2`sd < c2`fill, c2`fill = c2`sd];
        c2`mant = Drop[c2`sig, c2`sd];
        c2`sig = Take[c2`sig, c2`sd]
        ];
If[c2`printstate, Print["before rounding", " rok=", c2`roundok, " k=", c2`k]; 
        c2`debug[]];
If[c2`rounding > 0 && Length[c2`mant] > 0 && 
          c2`roundok && (\[Not] (c2`k =!= False && c2`rounding == 1)),
        If[c2`printstate, Print["will check rounding"]; c2`debug[];];
        If[c2`k =!= False,
          If[c2`base != 10,
            
            c2`t = ToExpression[
                ToString[c2`base] <> "^^" <> StringJoin[c2`mant]]
            , c2`t = ToExpression@StringJoin@c2`mant
            ];
          c2`t = c2`base c2`t/Power[c2`base, Length@c2`mant];
          c2`prec = c2`base (1 - FractionalPart[Abs[c2`k]]);
          If[c2`prec >= c2`base, c2`t = 0, c2`t -= c2`prec]
          , c2`t = ToExpression@c2`mant[[1]]
          ];
        If[c2`t >= c2`base/2,
          c2`s = False;
          
          If[c2`sig == {}, c2`sig = {"0"}, 
            If[c2`sig[[1]] == "0", c2`s = True; c2`exp = Length@c2`sig]];
          If[c2`base != 10,
            
            c2`t = ToExpression[
                ToString[c2`base] <> "^^" <> StringJoin[c2`sig]]
            , c2`t = ToExpression@StringJoin@c2`sig
            ];
          
          If[\[Not] NumberQ@c2`t, 
            Message[fNBookForm2::"unexpected error", c2`sig]; 
            Return[c2`p`x]];
          ++c2`t;
          If[c2`base == 10,
            c2`sig = Characters@ToString@c2`t
            ,
            c2`t = Characters@ToString@BaseForm[c2`t, c2`base];
            c2`prec = Position[c2`t, "\n"];
            If[c2`prec != {}, c2`t = Take[c2`t, c2`prec[[1, 1]] - 1]];
            c2`sig = c2`t
            ];
          If[c2`s,
            c2`s = Table["0", {c2`prec, 1, c2`exp - Length@c2`sig}];
            c2`sig = Join[c2`s, c2`sig];
            If[c2`fill > 0, If[c2`sig[[c2`fill]] != "0",
                --c2`fill; If[Last@c2`sig == "0", c2`sig = Drop[c2`sig, -1]]
                ]]
            ];
          c2`q = Length@c2`sig;
          If[c2`q > c2`sd,
            ++c2`nexp;
            
            If[c2`sd == 
                  0 && (c2`rounding == 
                      3 || (c2`k =!= False && c2`k =!= c2`nprec)),
              c2`sd = 1, c2`sig = Take[c2`sig, c2`sd]
              ]
            ];
          c2`mant[[1]] = "0"
          ]];
c2`q = Length@c2`sig;
If[c2`fill >= 0 && c2`sigzeros === False && c2`q > 0 && c2`sig[[1]] == "0" && 
          Complement[c2`sig, {"0"}] == {},
        If[c2`printstate, Print["fixup 0's"]; c2`debug[]];
        {c2`nexp, c2`w} = c2`oldxw; c2`sig = {"0"}; c2`fill = 0; c2`q = 1
        ];
If[c2`acc > 0,
        If[c2`nacc =!= False,
          c2`t = If[c2`rounding == 3, Floor[c2`nacc], Ceiling[c2`nacc]];
          If[c2`showprec == False,
            If[c2`printstate, Print["add right acc 0's"]; c2`debug[]];
            If[c2`printstate, Print["s0=", c2`sig, " ne=", c2`nexp]];
            c2`exp = c2`nexp - (c2`q - c2`w);
            c2`prec = c2`t + c2`exp;
            
            If[\[Not] (c2`sigzeros === 
                      False && (c2`q == 0 || c2`sig == {"0"})),
              c2`s = c2`prec;
              If[c2`s + c2`q > c2`acc, c2`s = c2`acc - c2`q];
              
              If[c2`s > 0, 
                c2`sig = Join[c2`sig, Table["0", {c2`prec, 1, c2`s}]]]
              ]
            ];
          If[c2`printstate, Print["s2=", c2`sig, " t=", c2`t, " q=", c2`q]];
          If[c2`q == 0 || c2`sig == {"0"}, c2`sig = {"0"};
            c2`nexp = -c2`t + 1; c2`w = 0;
            
            If[c2`rounding == 3 && 
                Abs@FractionalPart@c2`nacc > .5, --c2`nexp];
            If[c2`printstate, Print["lo0"]]];
          
          If[c2`printstate, 
            Print["s2=", c2`sig, " ne=", c2`nexp, " e=", c2`exp]]
          ];
        If[c2`nprec >= 0 && c2`nacc == False,
          c2`t = If[c2`rounding == 3, Floor[c2`nprec], Ceiling[c2`nprec]];
          c2`exp = c2`nexp - (c2`q - c2`w);
          If[c2`showprec == False,
            If[c2`printstate, Print["add prec 0's"]; c2`debug[]];
            If[c2`printstate, Print["s0=", c2`sig, " ne=", c2`nexp]];
            If[c2`fill > 0, c2`t += c2`fill];
            
            If[\[Not] (c2`sigzeros === 
                      False && (c2`q == 0 || c2`sig == {"0"})),
              c2`s = c2`t - c2`q;
              If[c2`s + c2`q > c2`acc, c2`s = c2`acc - c2`q];
              
              If[c2`s > 0, 
                c2`sig = Join[c2`sig, Table["0", {c2`prec, 1, c2`s}]]];
              ]
            ];
          If[c2`printstate, Print["s2=", c2`sig, " t=", c2`t, " q=", c2`q]];
          If[c2`q == 0 || c2`sig == {"0"}, c2`sig = {"0"};
            c2`nexp = c2`exp - c2`t + 2; c2`w = 0;
            If[c2`q == 0, --c2`nexp];
            
            If[c2`rounding == 3 && 
                Abs@FractionalPart@c2`nprec > .5, --c2`nexp];
            If[c2`printstate, Print["lo0"]]
            ];
          
          If[c2`printstate, 
            Print["s2=", c2`sig, " ne=", c2`nexp, " e=", c2`exp]]
          ]
        ];
c2`q = Length[c2`sig];
c2`nexp = c2`nexp - (c2`q - c2`w);
c2`debug[];
c2`t = 0;
If[c2`nexp < 0 && c2`q > 1 && c2`u > 0,
        If[-c2`q >= c2`nexp, c2`k = -c2`q + 1, c2`k = c2`nexp];
        c2`t = c2`k; c2`nexp -= c2`k; c2`q += c2`k];
If[Mod[c2`nexp, 3] != 0 && Abs[c2`nexp] >= 3 && c2`u > 0,
        c2`k = 3 - Mod[c2`nexp, 3];
        If[c2`q > c2`k && (c2`nexp < 0 || -c2`t <= 3 - c2`k),
          c2`nexp += c2`k; c2`t -= c2`k; c2`k = 0;
          ];
        If[c2`k != 0 && -c2`t >= 3 - c2`k,
          c2`nexp -= (3 - c2`k); c2`t += (3 - c2`k)
          ]];
If[c2`t != 0, c2`sig = Insert[c2`sig, ".", c2`t - 1]];
c2`debug[];
If[c2`commas,
        c2`q = Length@c2`sig;
        c2`w = Position[c2`sig, "."];
        If[c2`w != {}, c2`q = c2`w[[1, 1]] - 1];
        c2`w = 1;
        While[c2`q > 1, 
          If[Mod[c2`w, 3] == 0, 
            c2`sig = Insert[c2`sig, ",", c2`q]]; --c2`q; ++c2`w]
        ];
c2`w = "";
If[c2`showprec =!= False,
        If[c2`base != 10, c2`sign = ToString[c2`base] <> "^^" <> c2`sign];
        If[c2`nacc == False && c2`nprec == False,
          c2`nacc = -(c2`t + (c2`nexp + c2`fexp));
          c2`nprec = c2`q - c2`t
          ];
        If[NumberQ@c2`nacc, c2`w = c2`w <> "``" <> ToString[c2`nacc]];
        If[NumberQ@c2`nprec, c2`w = c2`w <> "`" <> ToString[c2`nprec]];
        If[c2`showprec == All,
          If[c2`fexp === 0,
            c2`w = c2`w <> "*^" <> ToString[c2`nexp];
            , c2`w = c2`w <> "*^" <> ToString@InputForm@(c2`nexp + c2`fexp)];
          c2`nexp = 0; c2`fexp = 0
          ]];
c2`t = ""; c2`s = Abs@c2`u;
If[c2`sig != {} && c2`nexp + c2`fexp != 0,
        If[c2`fexp === 0 && c2`s > 1,
          c2`t = ToString@powerbook[ToString[c2`nexp], c2`s]
          ,
          c2`t = "e" <> ToString@InputForm@(c2`nexp + c2`fexp)
          ]
        ];
If[c2`showprec =!= False && Length@c2`sig == 0 && c2`sd > 0, c2`sig = {"0"}];
If[c2`t == "", c2`sep = ""];
c2`s = c2`sign <> c2`sig <> c2`w <> c2`sep <> c2`t;
c2`s
];
(*
(* 
Remove[vars4]; no longer needed, c2`* does this
Map[Remove,Names["c2`p`*"]]; do NOT do this, param. vars are used by module
*)
*)
(*
Map[Remove, Names["c2`*"]];
Remove[head, cell];
(*needed?*)

Remove[opts, sd, u, sep, showprec, PrintState, rounding, commas, fill, 
    sigzeros]; 
Remove[x];
*)
(*
If[c2`printstate,Print["n=",c2`k,"sd=",c2`sd,"rnd=",c2`rounding]];
If[c2`printstate,Print[{c2`sig,c2`nexp,c2`sd}];];
Print["q=",c2`q," acc/ti=",c2`t," nexp=",c2`nexp," w=",c2`w," \
expf=",c2`nexp-(c2`q-c2`w)," tf=",c2`t+c2`nexp-(c2`q-c2`w)];
Print["q=",c2`q," p=",c2`nprec," t=",c2`t," sd=",c2`sd," sig=",c2`sig];
*)
(*
 PrettyDate[]
*)
(*
"Sunday, October 13 2013.  4:45:22 p.m. -4\[ThinSpace]GMT"
*)
(*
fNBookForm2Short
*)
fNBookForm2Short[x___] := Module[{s1, s2},
    s1 = fNBookForm2[x, c2`p`showprec -> False];
    s2 = fNBookForm2[x, c2`p`showprec -> True];
    If[StringLength@s2 < StringLength@s1, s2, s1]
    ]
(*
fNBookForm2Arb
*)
(*
arbitrary powers suggester
*)
fNBookForm2Arb[x_Rational | x_Integer, u_Integer:2] := 
    Module[{n, k, y, e, num, den, debug = False, b},
      b = 10;
      e = First@Rest@MantissaExponent[N[x]];
      If[e > 0, --e, --e];
      If[e == 0, Return[x]];
      k = 1; n = 1;
      If[Abs[e] > 3 && Mod[e, 3] =!= 0,
        If[e < 0,
            k = Mod[e, 3];
            e -= k;
            k = b^k;
            ,
            k = 3 - Mod[e, 3];
            e += k;
            k = 1/(b^k);
            ];
        ];
      If[e > 24, k *= b^(e - 24); e = 24];
      If[e < -24, k *= b^(24 + e); e = -24];
      If[e != 0, n = powerbook[e, u]];
      If[debug, Print["nk=", n k, " n=", n, " k=", k, " e=", e, " b=", b]];
      If[u == 3 || u == 4,
        y = x (b^-e);
        num = Numerator@y;
        den = Denominator@y;
        If[den != 1,
          DisplayForm[RowBox[{FractionBox[num, den], " ", n}]]
          , DisplayForm[RowBox[{num, " ", n}]]
          ]
        , x (b^-e) n]
      ];
(*
x = 200000000000000000000;
*)
(*
fNBookForm2[N[x, 30]]
*)
(*
"200.0\[ThinSpace]E"
*)
(*
fNBookForm2Arb[x] // N
*)
(*
0.2 Zetta
*)
(*
200 10^18 == .2 10^21
*)
(*
True
*)
(*
{10^-7 (1/35) // N, 20/7 // N}
*)
(*
\!\({2.857142857142857`*^-9, 2.857142857142857`}\)
*)
(*
{fNBookForm2Arb[10^-7 (1/35), 3], fNBookForm2Arb[30, 3], 
  fNBookForm2Arb[2/10, 3]}
*)
(*
\!\(\*
  RowBox[{"{", 
    RowBox[{
      TagBox[\(20\/7\ n\),
        DisplayForm], ",", 
      TagBox[\(3\ da\),
        DisplayForm], ",", 
      TagBox[\(2\ d\),
        DisplayForm]}], "}"}]\)
*)
(*
{fNBookForm2Arb[10^-7 (1/35), 4], fNBookForm2Arb[30, 4], 
  fNBookForm2Arb[2/10, 4]}
*)
(*
\!\(\*
  RowBox[{"{", 
    RowBox[{
      TagBox[\(20\/7\ Nano\),
        DisplayForm], ",", 
      TagBox[\(3\ Deca\),
        DisplayForm], ",", 
      TagBox[\(2\ Deci\),
        DisplayForm]}], "}"}]\)
*)
(*
Remove[x];
*)
(*
end package
*)
End[];
EndPackage[];
(*
On[General::"spell"];
*)
