(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    108036,       3231]*)
(*NotebookOutlinePosition[    109414,       3277]*)
(*  CellTagsIndexPosition[    109315,       3270]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
paste this in Periodic Tables if you are editing these.  the below \
uses CreateModule which automatically turns code sections run into functions, \
which can be helpful.  result should be exactly the same.\
\>", "Text"],

Cell[CellGroupData[{

Cell["\<\
paste just after INITIAL  CHEM.M  SETUP  (mess, efun, powers, \
...)\
\>", "Subsubsection"],

Cell[BoxData[
    \(\(Remove[powerstab, powerstab1, powerstab2, powerstab3, powers, 
        bookpower];\)\)], "Input"],

Cell[TextData[{
  "Before the symbol was standardized as da with the introduction of the \
International System of Units in 1960, various other symbols were more \
common, such as \"dk\", \"D\", and \"Da\". (in last release i couldn't find \
thes in CRC'72 or my book and used \"\" and fNBookForm assumed no abbrev. was \
avail.)\n\tCRC'72 used dkgr for dekagram, dg for decigram.  today they say \
\"dag\" or \"dg\"\n\tand call \"deka\" and unofficial spelling of deca (i \
doubt this, but ok)\n\ti'm correct: deka is 10 in old Greek, deca is the \
\"new\" spelling\ni'll leave \"da\" in but for real use I'd use \"D\" or \
maybe \"",
  StyleBox["d\"",
    FontSlant->"Italic"],
  ".  it may mess up a column alignment, but may come in handy if comparing \
to something else or appended to something else"
}], "Text"],

Cell[BoxData[
    \(\(powers = {\[IndentingNewLine]{24, 21, 18, 15, 12, 9, 6, 3, 2, 
            1, \(-1\), \(-2\), \(-3\)\[IndentingNewLine], \(-6\), \(-9\), \
\(-12\), \(-15\), \(-18\), \(-21\), \(-24\)}\[IndentingNewLine], {Yotta, 
            Zetta, Exa, Peta, Tera, Giga, Mega\[IndentingNewLine], Kilo, 
            Hecto, Deca, Deci, Centi, Milli, Micro\[IndentingNewLine], Nano, 
            Pico, Femto, Atto, Zepto, 
            Yocto}\[IndentingNewLine], {"\<Y\>", "\<Z\>", "\<E\>", "\<P\>", "\
\<T\>", "\<G\>", "\<M\>", "\<k\>", "\<h\>", "\<da\>", "\<d\>", "\<c\>", \
"\<m\>", "\<\[Micro]\>", "\<n\>", "\<p\>", "\<f\>", "\<a\>", "\<z\>", \
"\<y\>"}\[IndentingNewLine], {"\<Yotta\>", "\<Zetta\>", "\<Exa\>", \
"\<Peta\>", "\<Tera\>", "\<Giga\>", "\<Mega\>"\[IndentingNewLine], \
"\<Kilo\>", "\<Hecto\>", "\<Deca\>", "\<Deci\>", "\<Centi\>", "\<Milli\>", \
"\<Micro\>"\[IndentingNewLine], "\<Nano\>", "\<Pico\>", "\<Femto\>", \
"\<Atto\>", "\<Zepto\>", "\<Yocto\>"}\[IndentingNewLine] (*\ 
            NOTE : \ \[Micro]\ is\ Micro\ not\ \[Mu]\ Mu\ \
*) \[IndentingNewLine]};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["powerstab -- make charts of powers", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(padit[powers[\([3, 10]\)], 1]\)], "Input"],

Cell[BoxData[
    \("d"\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(powerstab = 
        Module[{n, 
            s}, \[IndentingNewLine]Table[\[IndentingNewLine]s = 
              ToString[powers[\([1, i]\)]]; \[IndentingNewLine]n = 
              Length[Characters[
                  s]]; \[IndentingNewLine]{\[IndentingNewLine]"\<\!\(10\>" <> \
"\<\^\>" <> s <> "\<\)\>" <> 
                padit["\<\>", 2 + \((3 - n)\)]\[IndentingNewLine], 
              padit[powers[\([2, i]\)], 7]\[IndentingNewLine], 
              padit[powers[\([3, i]\)], 
                2]\[IndentingNewLine]}\[IndentingNewLine], {i, 1, 
              Length[powers[\([1]\)]]}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(powerstab1 = 
        Module[{v}, v = "\<\>"; 
          Table[StringJoin[powerstab[\([i]\)]], {i, 1, 
              Length[powerstab]}]];\)\)], "Input"],

Cell[BoxData[
    \(\(powerstab2 = 
        Module[{v}, v = "\<\>"; 
          Do[v = v <> StringJoin[powerstab[\([i]\)]] <> "\<\n\>", {i, 1, 
              Length[powerstab]}]; StringDrop[v, \(-1\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(FlattenAt[\[IndentingNewLine]{"\<Power  \>" <> "\<Prefix \>" <> "\<Ab \
   \>" <> "\<Power \>" <> "\<Prefix \>" <> "\<Ab\>", 
          Table[StringJoin[powerstab1[\([i]\)], "\<     \>", 
              powerstab1[\([i + 10]\)]], {i, 1, 10}]\[IndentingNewLine]}, 
        2];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Power  Prefix Ab    Power Prefix Ab\"\>"},
          {"\<\"\\!\\(10\\^24\\)   Yotta  Y      \\!\\(10\\^-1\\)   Deci   d \
\"\>"},
          {"\<\"\\!\\(10\\^21\\)   Zetta  Z      \\!\\(10\\^-2\\)   Centi  c \
\"\>"},
          {"\<\"\\!\\(10\\^18\\)   Exa    E      \\!\\(10\\^-3\\)   Milli  m \
\"\>"},
          {"\<\"\\!\\(10\\^15\\)   Peta   P      \\!\\(10\\^-6\\)   Micro  \
\[Micro] \"\>"},
          {"\<\"\\!\\(10\\^12\\)   Tera   T      \\!\\(10\\^-9\\)   Nano   n \
\"\>"},
          {"\<\"\\!\\(10\\^9\\)    Giga   G      \\!\\(10\\^-12\\)  Pico   p \
\"\>"},
          {"\<\"\\!\\(10\\^6\\)    Mega   M      \\!\\(10\\^-15\\)  Femto  f \
\"\>"},
          {"\<\"\\!\\(10\\^3\\)    Kilo   k      \\!\\(10\\^-18\\)  Atto   a \
\"\>"},
          {"\<\"\\!\\(10\\^2\\)    Hecto  h      \\!\\(10\\^-21\\)  Zepto  z \
\"\>"},
          {"\<\"\\!\\(10\\^1\\)    Deca   da     \\!\\(10\\^-24\\)  Yocto  y \
\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {"Power  Prefix Ab    Power Prefix Ab", 
        "\!\(10\^24\)   Yotta  Y      \!\(10\^-1\)   Deci   d ", 
        "\!\(10\^21\)   Zetta  Z      \!\(10\^-2\)   Centi  c ", 
        "\!\(10\^18\)   Exa    E      \!\(10\^-3\)   Milli  m ", 
        "\!\(10\^15\)   Peta   P      \!\(10\^-6\)   Micro  \[Micro] ", 
        "\!\(10\^12\)   Tera   T      \!\(10\^-9\)   Nano   n ", 
        "\!\(10\^9\)    Giga   G      \!\(10\^-12\)  Pico   p ", 
        "\!\(10\^6\)    Mega   M      \!\(10\^-15\)  Femto  f ", 
        "\!\(10\^3\)    Kilo   k      \!\(10\^-18\)  Atto   a ", 
        "\!\(10\^2\)    Hecto  h      \!\(10\^-21\)  Zepto  z ", 
        "\!\(10\^1\)    Deca   da     \!\(10\^-24\)  Yocto  y "}]]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(powerstab3 = 
        Module[{n, 
            s}, \[IndentingNewLine]Table[\[IndentingNewLine]s = 
              ToString[
                powers[\([1, 
                    i]\)]]; \
\[IndentingNewLine]{\[IndentingNewLine]"\<\!\(10\>" <> "\<\^\>" <> 
                s <> "\<\)\>"\[IndentingNewLine], 
              ToString[powers[\([2, i]\)]]\[IndentingNewLine], 
              ToString[
                powers[\([3, 
                    i]\)]]\[IndentingNewLine]}\[IndentingNewLine], {i, 1, 
              Length[powers[\([1]\)]]}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        StyleBox[
          RowBox[{"In", 
            StyleBox["InputForm",
              "MR"], "and", 
            StyleBox["StandardForm",
              "MR"]}]], " ", "\[Backslash]", 
        RowBox[{
          StyleBox["(",
            "MR"], 
          RowBox[{
            StyleBox["form",
              "TI"], 
            StyleBox["\[Backslash]",
              "TI"], 
            StyleBox[
              RowBox[{
                StyleBox["`",
                  "MR"], 
                StyleBox["input",
                  "TI"]}]], 
            StyleBox["\[Backslash]",
              "TI"]}], 
          StyleBox[")",
            "MR"]}]}], 
      RowBox[{
        RowBox[{
          RowBox[{
            StyleBox[
              RowBox[{"yields", 
                StyleBox["FormBox",
                  "MR"]}]], 
            StyleBox["[",
              "MR"], 
            RowBox[{
              StyleBox["input",
                "TI"], 
              StyleBox[",",
                "MR"], " ", 
              StyleBox["form",
                "TI"]}], 
            StyleBox["]",
              "MR"]}], ".", "\[FilledSmallSquare]"}], "\[Backslash]", 
        RowBox[{
          StyleBox["(",
            "MR"], 
          RowBox[{
            StyleBox["\[Backslash]",
              "MR"], 
            StyleBox[
              RowBox[{
                StyleBox["`",
                  "MR"], 
                StyleBox["input",
                  "TI"]}]], 
            StyleBox["\[Backslash]",
              "TI"]}], 
          StyleBox[")",
            "MR"]}]}], 
      RowBox[{
        RowBox[{
          StyleBox[
            RowBox[{"yields", 
              StyleBox["FormBox",
                "MR"]}]], 
          StyleBox["[",
            "MR"], 
          RowBox[{
            StyleBox["input",
              "TI"], 
            StyleBox[",",
              "MR"], " ", 
            StyleBox["RawForm",
              "MR"]}], 
          StyleBox["]",
            "MR"]}], ".", "\[FilledSmallSquare]"}], " ", 
      StyleBox[
        RowBox[{"See", 
          StyleBox["The",
            "TI"]}]], 
      StyleBox[" ",
        "TI"], 
      StyleBox["Mathematica",
        "TI"], 
      StyleBox[" ",
        "TI"], 
      RowBox[{
        StyleBox["Book",
          "TI"], 
        StyleBox[":",
          "TI"], 
        StyleBox[" ",
          "TI"], 
        RowBox[{
          ButtonBox[\(Section\ 2.8  .10\),
            ButtonData:>{"2.8.10", "10.23"},
            ButtonStyle->"MainBookLink"], "."}]}]}]], "Text"],

Cell[TextData[{
  "$NumberMarks apparently doesn't turn off ",
  Cell[BoxData[
      \(TraditionalForm\`1. \^14\)]],
  " though book says, but \"\\!\\(10\"<>\"\\^\"<>s<>\"\\)\" is ok."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(GridBox[powerstab3, RowLines \[Rule] True, ColumnLines \[Rule] True] // 
      DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {\(10\^24\), "Yotta", "Y"},
          {\(10\^21\), "Zetta", "Z"},
          {\(10\^18\), "Exa", "E"},
          {\(10\^15\), "Peta", "P"},
          {\(10\^12\), "Tera", "T"},
          {\(10\^9\), "Giga", "G"},
          {\(10\^6\), "Mega", "M"},
          {\(10\^3\), "Kilo", "k"},
          {\(10\^2\), "Hecto", "h"},
          {\(10\^1\), "Deca", "da"},
          {\(10\^\(-1\)\), "Deci", "d"},
          {\(10\^\(-2\)\), "Centi", "c"},
          {\(10\^\(-3\)\), "Milli", "m"},
          {\(10\^\(-6\)\), "Micro", "\[Micro]"},
          {\(10\^\(-9\)\), "Nano", "n"},
          {\(10\^\(-12\)\), "Pico", "p"},
          {\(10\^\(-15\)\), "Femto", "f"},
          {\(10\^\(-18\)\), "Atto", "a"},
          {\(10\^\(-21\)\), "Zepto", "z"},
          {\(10\^\(-24\)\), "Yocto", "y"}
          },
        RowLines->True,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Table[
        Flatten[{powerstab3[\([i]\)], "\<  \>", 
            powerstab3[\([i + 10]\)]}], {i, 1, 10}];\)\)], "Input"],

Cell[BoxData[
    \(\(Prepend[%, {"\<Power\>", "\<Prefix\>", "\<Ab\>", "\<  \>", \
"\<Power\>", "\<Prefix\>", "\<Ab\>"}];\)\)], "Input"],

Cell[BoxData[
    \(powerstable = 
      GridBox[%, RowLines \[Rule] True, ColumnLines \[Rule] True, 
          GridFrame \[Rule] True] // DisplayForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["powerbook --  function", "Subsubsection"],

Cell[BoxData[
    \(powerbook[z_Integer | z_String, u_:  3] := 
      Module[{n, k, y}, \[IndentingNewLine]k = 
          ToExpression[
            z];  (*NumberFormat\ uses\ String*) \[IndentingNewLine]If[\[Not] \
IntegerQ[k], Message[powerbook::"\<notinteger\>", k]; 
          Return[z]]; \[IndentingNewLine]n = 
          Position[powers[\([1]\)], k]; \[IndentingNewLine]If[
          Length[n] == 0, "\<e\>" <> ToString[k], \[IndentingNewLine]y = 
            powers[\([u, n[\([1, 1]\)]]\)]; \[IndentingNewLine]If[
            y === "\<\>", "\<e\>" <> ToString[k], 
            y]\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(\(powerbook::usage = "\<powerbook[int|string]  given n returns symbol, \
in style u, or e1 exp style if it was applicable but not in table.  1 is \
digit form, 2 is symbol form, 3 is letter form, 4 is string form. ie \
powerbook[3] -> k\>";\)\)], "Input"],

Cell[BoxData[
    \(\(powerbook::notinteger = "\<`1`\>";\)\)], "Input"],

Cell[BoxData[
    \({powerbook[\(-6\)], powerbook["\<3\>"], powerbook["\<1.2\>"], 
      powerbook[{}], powerbook[snf2], powerbook[\(-7\)], powerbook[25], 
      powerbook[3, 1], powerbook[3, 2], powerbook[3, 3], 
      powerbook[3, 4]}\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["bookexp --  function", "Subsubsection"],

Cell[BoxData[
    \(\(Remove[w, x, bookexp];\)\)], "Input"],

Cell[BoxData[
    \(\(head = bookexp[x_, w_:  1];\)\)], "Input"],

Cell[BoxData[
    \(x = Tera; w = 2;\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(v = Position[powers, x];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Length[v] > 0, \[IndentingNewLine]v = 
          v[\([1]\)]; \[IndentingNewLine]If[
          Length[v] \[Equal] 2, \[IndentingNewLine]v = 
            v[\([2]\)]; \[IndentingNewLine]v = 
            powers[\([w, 
                v]\)];\[IndentingNewLine]]\[IndentingNewLine], \(v = {};\)\
\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(v\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(cell = CombineCells[];\)\)], "Input"],

Cell[BoxData[
    \(CreateModule[head, cell, Vars \[Rule] {"\<v\>"}]\)], "Input"],

Cell[BoxData[
    \(bookexp["\<\[Micro]\>"]\)], "Input"],

Cell[BoxData[
    \(\(bookexp::usage = "\<bookexp[Integer|String|Symbol]  looks up object \
in powers table and returns requested alias.  Default is type 1.  1 numberic  \
2 Symbol  3 letter  4 String.  ie. bookexp[Milli] == -3\>";\)\)], "Input"],

Cell[BoxData[
    \(\(?bookexp\)\)], "Input"],

Cell[BoxData[
    \(Remove[w, x, v]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["booknum --  function", "Subsubsection"],

Cell["\<\
this (and fNBookForm2) are right on the edge of needing a parser
\tbut external things are not widely supported
\tand both have \"unusual actions\" during parsing\
\>", "Text"],

Cell[BoxData[
    \(\(Remove[v, xx, x, sep, opts, ee, EE, units, booknum, 
        base];\)\)], "Input"],

Cell[BoxData[
    \(\(Options[booknum] = {Sep \[Rule] {"\< \>", "\<\[ThinSpace]\>"}, 
          Units \[Rule] 1};\)\)], "Input"],

Cell[BoxData[
    \(\(head = booknum[x_String, opts___];\)\)], "Input"],

Cell[BoxData[
    \(\(opts = 
        Sequence[Sep \[Rule] {"\< \>", "\<\[ThinSpace]\>"}, 
          Units \[Rule] 1];\)\)], "Input"],

Cell[BoxData[
    \(\(x = "\<2.0 \[Micro]\>";\)\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(sep = \(Sep /. {opts}\) /. Options[booknum];\)\)], "Input"],

Cell[BoxData[
    \(\(units = \(Units /. {opts}\) /. Options[booknum];\)\)], "Input"],

Cell[BoxData[
    \(\(If[StringLength[x] < 1, Return[x]];\)\)], "Input"],

Cell[BoxData[
    \(\(xx = StringReplace[x, "\<,\>" \[Rule] "\<\>"];\)\)], "Input"],

Cell["\<\
old v=groupadjacent[Characters[x],true,((\[Not]LetterQ[#]&&#\
\[NotEqual]\"\[Micro]\")||#\[Equal]\".\"&)];\
\>", "Text"],

Cell["\<\
(* Print[\" v \",v,\" Lv \",Length[v],\" v1 \",v[[1]],\" v2 \
\",v[[2]], \" v3 \",v[[3]]]; *) \
\>", "Text"],

Cell[BoxData[
    \(\(base = 10;\)\)], "Input"],

Cell[BoxData[
    \(\(s = Null;\)\)], "Input"],

Cell[BoxData[
    \(\(ee = Null;\)\)], "Input"],

Cell[BoxData[
    \(\(EE = StringPosition[xx, "\<^^\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(If[EE != {}, 
        base = ToExpression[
            StringTake[xx, EE[\([1, 1]\)] - 1]]];\)\)], "Input"],

Cell["\<\
allow 1.1n or 1.1e2 ; insert a space between if v[[1]] is a number \
and it split in (two).  there are many cases to not allow trying\
\>", "Text"],

Cell[BoxData[
    \(\(v = 
        groupadjacent[Characters[xx], 
          true, \((Intersection[sep, {#}] == {})\) &];\)\)], "Input"],

Cell[BoxData[
    \(\(EE = Length@v;\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Length@v \[Equal] 1, \[IndentingNewLine]v = 
          groupadjacent[Characters[xx], 
            true, \((DigitQ[#] || 
                  Intersection[{"\<^\>", "\<.\>", "\<`\>", "\<*\>"}, {#}] \
\[NotEqual] {} &)\)]; \[IndentingNewLine]EE = Length@v; \[IndentingNewLine]If[
          EE < 1, Message[booknum::"\<nosplit\>", x]; 
          Return[x]]; \[IndentingNewLine]If[
          EE > 1 && base \[LessEqual] 10 && 
            NumericQ[ToExpression@\(StringJoin@v[\([1]\)]\)], 
          v = StringJoin@{v[\([1]\)], sep[\([1]\)], Rest[v]}, 
          v = xx]; \[IndentingNewLine]v = 
          groupadjacent[Characters[v], 
            true, \((Intersection[
                    sep, {#}] == {})\) &];\[IndentingNewLine]];\)\)], "Input"],

Cell["old  v=groupadjacent[Characters[x],true,(#!=\" \"&&#!=\"e\"&)];", "Text"],

Cell["\<\
strip exp \"*^\", it will falsely increase prec if evaluated \
in\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        Position[
            Characters[xx], "\<`\>"] \[Equal] {}, \[IndentingNewLine]EE = 
          groupadjacent[v[\([1]\)], 
            true, \((# != "\<*\>")\) &]; \[IndentingNewLine]s = 
          ToExpression[StringJoin[EE[\([1]\)]]]; \[IndentingNewLine]EE = 
          Length@Cases[
              Characters@\(ToString@
                  s\), _?\((DigitQ[#] || 
                      LetterQ[#] &)\)]; \[IndentingNewLine]ee = 
          777;\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(s = ToExpression[StringJoin[v[\([1]\)]]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[ee \[Equal] 777, s = SetPrecision[s, EE]];\)\)], "Input"],

Cell[BoxData[
    \(\(ee = Null;\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length@v > 1, v = Drop[v, 2], v = Drop[v, 1]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length@v > 1, 
        While[Intersection[sep, v[\([1]\)]] != {}, 
          v = Drop[v, 1]]];\)\)], "Input"],

Cell[BoxData[
    \(\(EE = Length@v;\)\)], "Input"],

Cell[BoxData[
    \(\(If[EE \[Equal] 0, Return[s]];\)\)], "Input"],

Cell["we can't handle a whole expr - must be first and only pair", "Text"],

Cell[BoxData[
    \(\(If[EE > 1, Message[booknum::"\<fields\>", x]; 
        Return[x]];\)\)], "Input"],

Cell[BoxData[
    \(\(EE = 
        groupadjacent[v[\([1]\)], 
          true, \((Intersection[{"\<e\>", "\<E\>"}, {#}] == {})\) &];\)\)], \
"Input"],

Cell[BoxData[
    \(\(If[
        Length@EE \[GreaterEqual] 2, \[IndentingNewLine]EE = 
          Drop[EE, 1]; \[IndentingNewLine]If[
          NumericQ@\(ToExpression@\(StringJoin@
                EE\)\), \[IndentingNewLine]units = 777; 
          v = EE;\[IndentingNewLine]];];\)\)], "Input"],

Cell[BoxData[
    \(\(EE = StringJoin@v;\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        units \[Equal] 
          777, \[IndentingNewLine]\(ee = 
            base^ToExpression@
                EE;\)\[IndentingNewLine], \[IndentingNewLine]ee = 
          bookexp[EE, units]; \[IndentingNewLine]If[
          units \[Equal] 1 && NumericQ[ee], 
          ee = base^ee]; \[IndentingNewLine]If[ee === {}, 
          ee = ToExpression@EE];\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[ee =!= Null, s = s\ ee];\)\)], "Input"],

Cell[BoxData[
    \(s\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(cell = CombineCells[];\)\)], "Input"],

Cell[BoxData[
    \(CreateModule[head, cell, 
      Vars \[Rule] {"\<v\>", "\<s\>", "\<ee\>", "\<EE\>", "\<sep\>", "\<units\
\>"}]\)], "Input"],

Cell[BoxData[
    \(\(booknum::usage = "\<booknum[num_String,opts]  \"num unit\".  Converts \
fNBookForm output string to Expression.  The interpretation is a little \
wider, but it tries to restore precision as read from book to mm.  num can \
also be Symbol.  unit can be powers letter, e1 style exponent, missing, or \
Symbol.  opt Unit is for bookexp[, Unit].  If Symbol isn't recognized it is \
reflected.  For (ie. Tera) Convert[Tera,1] is an alternative.  Commas in \
input are ignored.  ie. booknum[\"3 m\"]->0.003\>";\)\)], "Input"],

Cell[BoxData[
    \(\(booknum::fields = "\<error too many fields in: \>" <> "\<\"\>" <> \
"\<`1`\>" <> "\<\"\>";\)\)], "Input"],

Cell[BoxData[
    \(\(booknum::nosplit = "\<no fields on split: \>" <> "\<\"\>" <> \
"\<`1`\>" <> "\<\"\>";\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[xxx, x];\)\)], "Input"],

Cell[BoxData[
    \(\(x = 5;\)\)], "Input"],

Cell[BoxData[
    \({\ booknum["\<2.0 \[Micro]\>"], 
      booknum["\<2 \[Micro]\>", Units \[Rule] 2], 
      booknum["\<2 \[Micro]\>", Units \[Rule] 3], booknum["\<2e0\>"], 
      1/10\ booknum["\<2 Ampere\>"], booknum["\<20.0 xyx\>"], , 
      booknum["\<2.0 + 3\>"], booknum[1], booknum[zzz], booknum["\<zzz\>"], 
      booknum["\<12 da\>"], booknum["\<1.1h\>"], booknum["\<1.11e2\>"], 
      booknum["\<123\>"], booknum["\<16^^10 e3\>"], booknum["\<123`2 e2\>"], 
      booknum["\<123``0\>"], booknum["\<1 Micro\>"], 
      booknum["\<1 Micro\>", Units \[Rule] 3], booknum["\<16^^10`3*^1\>"], 
      booknum["\<16^^10 da\>"], booknum["\<16^^10*^1\>"], booknum["\<x a\>"], 
      booknum["\<xxx a\>"] // N, booknum["\<2,000 \[Micro]\>"]}\)], "Input"],

Cell[BoxData[
    \(\(Remove[head, \ cell, s, v, x, xx, sep, opts, ee, EE, units, 
        base];\)\)], "Input"],

Cell["recheck if rounding 16^^10*^2 is using right (4096 or 64)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["reset / remove fNBookForm", "Subsubsection"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c`p`*\>"]];\)\)], "Input",
  CellTags->{"S1.4.1", "1.1"}],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c`*\>"]];\)\)], "Input",
  CellTags->{"S1.4.1", "1.1"}],

Cell[BoxData[
    \(\(Remove[fNBookForm, x];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[opts, sd, u, sep, showprec, PrintState];\)\)], "Input"],

Cell[BoxData[
    \(Names["\<c`*\>"]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["fNbookForm - test / debug / define", "Subsubsection"],

Cell["\<\
one change:
\tgiven 999 sd->2, it had choosen \"990\" not \"99 e1\"
\t\twas purely asthetic, assumed powertab had no abbrev for e1
\t\tassumed equality (they are) and rounding was not an isue
\tlet 999 sd->2 be \"99 da\" not \"990\"
\t(both were correct as to orig fNBookForm)
\tsee Text cell: \"NOTE: this line can be skipped now.\"\
\>", "Text"],

Cell["RunToBoundryCell", "Text"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c`p`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[fNBookForm, x];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[opts, sd, u, sep, showprec, PrintState];\)\)], "Input"],

Cell[BoxData[
    \({Names["\<c`*\>"], Names["\<c`p`*\>"]}\)], "Input"],

Cell[BoxData[
    \(\(Remove[fNBookForm];\)\)], "Input"],

Cell["\<\
NOTE:  vars4 isn't used for CreateModule anymore - now \
automatic\
\>", "Text"],

Cell[BoxData[
    \(\(vars4 = {"\<c`char\>", "\<c`n\>", "\<c`t\>", "\<c`w\>", \
"\<c`char2\>", "\<c`s\>", "\<c`k\>", "\<c`sign\>", "\<c`mant\>", "\<c`exp\>", \
"\<c`sig\>", "\<c`base\>", "\<c`prec\>", "\<c`acc\>", "\<c`nprec\>", \
"\<c`nacc\>", "\<c`nexp\>", "\<c`noldsig\>", "\<c`sd\>", "\<c`u\>", \
"\<c`sep\>", "\<c`showprec\>", "\<c`printstate\>", "\<c`tmp\>"}\ ;\)\)], \
"Input"],

Cell[BoxData[
    \(\(Map[Remove, vars4];\)\)], "Input"],

Cell[BoxData[
    \(\(head = 
        fNBookForm[\[IndentingNewLine]c`p`x_Integer | c`p`x_Real | 
            c`p`x_String, \[IndentingNewLine]c`p`opts___];\)\)], "Input"],

Cell["\<\
test values - note Global`x is only to show it is NOT interfering\
\
\>", "Text"],

Cell[BoxData[
    \(x = 5\)], "Input"],

Cell[BoxData[
    \(\(c`p`x = \(- .0000723232344\);\)\)], "Input"],

Cell[BoxData[
    \(\(c`p`x = "\<-100.040`5*^5\>";\)\)], "Input"],

Cell[BoxData[
    \(\(c`p`x = "\<1000*^-3\>";\)\)], "Input"],

Cell[BoxData[
    \(\(c`p`x = "\<0.12\>";\)\)], "Input"],

Cell[BoxData[
    \(c`p`x = "\<100000000``4.5`6*^2\>"\)], "Input"],

Cell[BoxData[
    \(\(c`p`x = "\<10^^123\>";\)\)], "Input"],

Cell[BoxData[
    \(\(c`p`x = "\<100\>";\)\)], "Input"],

Cell[BoxData[
    \(\(Options[fNBookForm] := {c`p`sd \[Rule] 4, c`p`u \[Rule] 3, 
          c`p`sep \[Rule] "\<\[ThinSpace]\>", c`p`showprec \[Rule] False, 
          c`p`printstate \[Rule] False};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(c`p`opts = 
        Sequence[c`p`printstate -> True, c`p`showprec \[Rule] True, 
          c`p`sd \[Rule] 8];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(x = 3\)], "Input"],

Cell[BoxData[
    \($Context\)], "Input"],

Cell[BoxData[
    \(\(Begin["\<c`\>"];\)\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(c`s = c`p`x;\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Head[c`p`x] \[Equal] Integer\  || \ 
          Head[c`p`x] \[Equal] Real, \[IndentingNewLine]c`s = 
          ToString[InputForm[c`p`x]]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`sd = \(c`p`sd /. {c`p`opts}\) /. Options[fNBookForm];\)\)], "Input"],

Cell[BoxData[
    \(\(c`u = \(c`p`u /. {c`p`opts}\) /. Options[fNBookForm];\)\)], "Input"],

Cell[BoxData[
    \(\(c`sep = \(c`p`sep /. {c`p`opts}\) /. 
          Options[fNBookForm];\)\)], "Input"],

Cell[BoxData[
    \(\(c`showprec = \(c`p`showprec /. {c`p`opts}\) /. 
          Options[fNBookForm];\)\)], "Input"],

Cell[BoxData[
    \(\(c`printstate = \(c`p`printstate /. {c`p`opts}\) /. 
          Options[fNBookForm];\)\)], "Input"],

Cell[BoxData[
    \(\(c`prec = \(c`acc = \(c`mant = \(c`sig = \(c`exp = \(c`base = {}\)\)\)\
\)\);\)\)], "Input"],

Cell[BoxData[
    \(\(c`nprec = \(c`nacc = \(c`nexp = \(c`noldsig = \(c`k = 
                False\)\)\)\);\)\)], "Input"],

Cell[BoxData[
    \(\(c`sign = "\<\>";\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`printstate, Print[c`s]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`s = 
        StringReplace[
          c`s, {"\<\\\>" -> "\<\>", "\<.^\>" -> "\<^\>", "\<.``\>" -> \
"\<`\>", "\<.`\>" -> "\<`\>"}];\)\)], "Input"],

Cell[BoxData[
    \(\(c`t = 
        StringReplace[
          c`s, {"\<.*\>" -> "\<*\>", "\<``*\>" -> "\<*\>", "\<`*\>" -> \
"\<*\>"}];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c`t \[NotEqual] c`s, \[IndentingNewLine]c`s = 
          c`t; \[IndentingNewLine]c`nacc = 
          Accuracy[1`]; \[IndentingNewLine]c`nprec = 
          Precision[1`]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`t = Characters[c`s];\)\)], "Input"],

Cell[BoxData[
    \(\(Length[c`t] > 0 || Return[c`p`x];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c`t[\([1]\)] \[Equal] "\<-\>", \[IndentingNewLine]c`sign = "\<-\>"; \
\[IndentingNewLine]c`t = Drop[c`t, 1]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`n = Length[c`t];\)\)], "Input"],

Cell[BoxData[
    \(\(c`w = groupadjacent[c`t, true, DigitQ];\)\)], "Input"],

Cell[BoxData[
    \(\(Length[c`w] > 0 || Return[c`p`x];\)\)], "Input"],

Cell[BoxData[
    \(\(c`debug[] := 
        If[c`printstate, 
          Print[{{"\<c`t\>", c`t}, \ {"\<w\>", c`w}, \ {"\< S \>", 
                c`sign}, {"\< s \>", c`sig}, {"\< m \>", c`mant}, {"\< p \>", 
                c`prec, "\< \>", c`nprec}, {"\< a \>", c`acc, "\< \>", 
                c`nacc}, {"\< e \>", c`exp, "\< \>", 
                c`nexp}}]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(SetAttributes[c`getp, HoldFirst];\)\)], "Input"],

Cell[BoxData[
    \(\(c`getp[p_Symbol] := 
        If[Length[c`w] > 0 && DigitQ[c`w[\([1, 1]\)]], 
          p = Join[p, c`w[\([1]\)]]; c`w = Rest[c`w]; True, 
          False];\)\)], "Input"],

Cell[BoxData[
    \(\(c`getp[p_Symbol, c_] := 
        If[Length[c`w] > 1 && 
            c`w[\([1, 1]\)] \[Equal] c, \[IndentingNewLine]If[
            DigitQ[c`w[\([2, 1]\)]], p = Join[p, c`w[\([2]\)]]; 
            c`w = Drop[c`w, 2]; True, Print["\<unformatted\>"]; \(-1\)], 
          False];\)\)], "Input"],

Cell[BoxData[
    \(\(c`getp[p_Symbol, c1_, c2_] := 
        If[Length[c`w] > 2 && c`w[\([1, 1]\)] \[Equal] c1 && 
            c`w[\([2, 1]\)] \[Equal] c2, c`w = Rest[c`w]; 
          c`getp[p, c2], \(False;\)];\)\)], "Input"],

Cell["\<\
a mini parser (it does not absorb c`w unless it finds what it asked \
for)\
\>", "Text"],

Cell[BoxData[
    \(c`w\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`mant, "\<.\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`getp[c`sig];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`base, "\<^\>", "\<^\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c`base \[NotEqual] {}, \[IndentingNewLine]If[
          c`sig \[NotEqual] {"\<1\>", "\<0\>"} && 
            c`mant \[NotEqual] {}, \
\[IndentingNewLine]Print["\<unformatted\>"]; 
          Return[c`p`x]]; \[IndentingNewLine]c`w = 
          c`base; \[IndentingNewLine]c`base = {};\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(If[c`getp[c`mant, "\<.\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`mant \[Equal] {} && c`sig \[Equal] {} && 
        Return[c`p`x];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`acc, "\<`\>", "\<`\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`tmp = {};\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`tmp, "\<.\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c`tmp] > 0, 
        c`acc = Join[c`acc, {"\<.\>"}, c`tmp]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`prec, "\<`\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`tmp = {};\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`tmp, "\<.\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c`tmp] > 0, 
        c`prec = Join[c`prec, {"\<.\>"}, c`tmp]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`acc, "\<`\>", "\<`\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`tmp = {};\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`tmp, "\<.\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c`tmp] > 0, 
        c`acc = Join[c`acc, {"\<.\>"}, c`tmp]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`k = 1;\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Length[c`w] > 3 && c`w[\([1, 1]\)] \[Equal] "\<*\>" && 
          c`w[\([2, 1]\)] \[Equal] "\<^\>" && 
          c`w[\([3, 1]\)] \[Equal] "\<-\>" && c`k \[Equal] 1, c`k = \(-1\); 
        c`w = Delete[c`w, 3]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`getp[c`exp, "\<*\>", "\<^\>"] \[Equal] \(-1\), 
        Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`w \[NotEqual] {} && c`w \[NotEqual] {{"\<.\>"}}, 
        Print["\<unformatted\>"]; Return[c`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`base = {"\<1\>", "\<0\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c`exp] > 0 && c`k \[Equal] \(-1\), 
        c`exp = Join[{"\<-\>"}, c`exp]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`debug[];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Length[c`acc] > 0, \[IndentingNewLine]c`nacc = 
          ToExpression[StringJoin[c`acc]]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`sd < c`nacc, c`nacc = c`sd];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Length[c`prec] > 0, \[IndentingNewLine]c`nprec = 
          ToExpression[StringJoin[c`prec]]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`sd < c`nprec, c`nprec = c`sd];\)\)], "Input"],

Cell[BoxData[
    \(\(c`nexp = 
        If[Length[c`exp] > 0, \[IndentingNewLine]ToExpression[
            StringJoin[c`exp]], 0];\)\)], "Input"],

Cell[BoxData[
    \(\(c`debug[];\)\)], "Input"],

Cell["\<\
the below first normalizes to just sig and exp then adjusts decimal \
if needed\
\>", "Text"],

Cell["zap useless zeros", "Text"],

Cell[BoxData[
    \(\(While[
        Length[c`sig] > 1 && 
          c`sig[\([1]\)] \[Equal] "\<0\>", \(c`sig = 
            Drop[c`sig, 1];\)];\)\)], "Input"],

Cell[BoxData[
    \(\(c`noldsig = Length[c`sig];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(c`k = Length[c`sig] + Length[c`mant];\)\)\)], "Input"],

Cell["\<\
add any zeros if  prec / acc is higher than we got; when not \
showprec\
\>", "Text"],

Cell[BoxData[
    \(\(If[\[Not] c`showprec, 
        While[Floor[c`nprec] > c`k && c`k < c`sd, \ 
          AppendTo[c`mant, "\<0\>"]; \(++c`k\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[\[Not] c`showprec, 
        While[Floor[c`nacc] > \ c`k && c`k < c`sd, \ 
          AppendTo[c`mant, "\<0\>"]; \(++c`k\)]];\)\)], "Input"],

Cell["adjust mant if 0.0001 so it can be 1000 e-7 (oops, 1 e-4)", "Text"],

Cell["old, see changelog: Join[Drop[c`mant,c`k],Take[c`mant,c`k]]", "Text"],

Cell[BoxData[
    \(\(c`k = 0;\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`noldsig > 0 && c`sig[\([1]\)] \[Equal] "\<0\>", 
        c`n = Length@c`mant; \[IndentingNewLine]While[
          c`k + 1 \[LessEqual] c`n && 
            c`mant[\([c`k + 
                    1]\)] \[Equal] "\<0\>", \(++c`k\)]; \[IndentingNewLine]If[
          c`k \[Equal] c`n, c`k = 0; c`nexp = 1]; \[IndentingNewLine]If[
          c`k > 0, 
          c`mant = Drop[c`mant, c`k]];\[IndentingNewLine]];\)\)], "Input"],

Cell["finally, join sig and mant", "Text"],

Cell[BoxData[
    \(\(If[
        c`noldsig \[Equal] 1 && 
          c`sig[\([1]\)] \[Equal] "\<0\>", \[IndentingNewLine]If[
          c`mant \[NotEqual] {}, \[IndentingNewLine]If[c`nexp \[Equal] False, 
            c`nexp = 0]; \[IndentingNewLine]c`sig = 
            c`mant; \[IndentingNewLine]c`noldsig = 
            0; \[IndentingNewLine]c`nexp -= 
            c`k;\[IndentingNewLine], \[IndentingNewLine]\(If[
              Complement[c`sig, {"\<0\>"}] \[Equal] {}, 
              c`nexp = 
                0];\)\[IndentingNewLine]]\[IndentingNewLine], \
\[IndentingNewLine]If[
          c`sig \[Equal] {} && Complement[c`mant, {"\<0\>"}] \[Equal] {}, 
          c`nexp = 1]; \[IndentingNewLine]c`sig = 
          Join[c`sig, c`mant];\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`mant = {};\)\)], "Input"],

Cell[BoxData[
    \(\(c`debug[];\)\)], "Input"],

Cell["chop for sd", "Text"],

Cell[BoxData[
    \(\(c`k = Length[c`sig];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`sd > Floor[c`nprec], c`sd = Floor[c`nprec]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`sd > Floor[c`nacc], c`sd = Floor[c`nacc]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`k > c`sd, c`sig = Take[c`sig, c`sd]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`n = Length[c`sig];\)\)], "Input"],

Cell[BoxData[
    \(\(c`nexp = c`nexp - \((c`n - c`noldsig)\);\)\)], "Input"],

Cell["now have just sig and expoent (normalized form)", "Text"],

Cell[BoxData[
    \(\(If[c`printstate, Print["\<---------\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`printstate, Print["\< c`nexp \>", c`nexp]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`debug[];\)\)], "Input"],

Cell["\<\
adjust decimal left if needed (reduce neg. powers), note c`t -> \
mant\
\>", "Text"],

Cell[BoxData[
    \(\(c`t = 0;\)\)], "Input",
  GeneratedCell->True],

Cell[BoxData[
    \(\(If[
        c`nexp < 0 && c`n > 1, \[IndentingNewLine]If[\(-c`n\) >= c`nexp, 
          c`k = \(-c`n\) + 1, c`k = c`nexp]; \[IndentingNewLine]c`t = c`k; 
        c`nexp -= c`k; c`n += c`k\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
if \".\" can be added to allow %3 for powerbook it can only be 1 or \
2 places left
or , with c`t, right (also: reduce nexp when choosing L/R if given choice)
{c`t,c`sig,c`mant,c`k,c`nexp,c`n,777,c`noldsig,c`nexp-(c`n-c`noldsig),c`s}\
\>\
", "Text"],

Cell[BoxData[
    \(\(If[
        Mod[c`nexp, 3] \[NotEqual] 0 && 
          Abs[c`nexp] \[GreaterEqual] 3, \[IndentingNewLine]c`k = 
          3 - Mod[c`nexp, 3]; \[IndentingNewLine]If[
          c`n > c`k && \((c`nexp < 0 || \(-c`t\) \[LessEqual] 
                  3 - c`k)\), \[IndentingNewLine]c`nexp += c`k; c`t -= c`k; 
          c`k = 0;\[IndentingNewLine]]; \[IndentingNewLine]If[
          c`k \[NotEqual] 0 && \(-c`t\) \[GreaterEqual] 
              3 - c`k, \[IndentingNewLine]c`nexp -= \((3 - c`k)\); 
          c`t += \((3 - 
                c`k)\);\[IndentingNewLine]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(If[c`t \[NotEqual] 0, 
        c`sig = Insert[c`sig, "\<.\>", c`t - 1]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`printstate, Print["\<---------\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`debug[];\)\)], "Input"],

Cell["print results sign sig exp and maybe showprec", "Text"],

Cell[BoxData[
    \(\(c`char = "\<\>";\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c`showprec, \[IndentingNewLine]If[c`nacc > 0, 
          c`char = 
            c`char <> "\<``\>" <> ToString[c`nacc]]; \[IndentingNewLine]If[
          c`nprec > 0, 
          c`char = 
            c`char <> "\<`\>" <> 
              ToString[c`nprec]]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(c`char2 = "\<\>";\)\)], "Input"],

Cell[BoxData[
    \(\(If[c`nexp \[NotEqual] 0, 
        c`char2 = powerbook[ToString[c`nexp], c`u]];\)\)], "Input"],

Cell["NOTE: this line can be skipped now.", "Text"],

Cell["\<\
If[c`nexp\[Equal]1,AppendTo[c`sig,\"0\"]];\
\>", "Text"],

Cell[BoxData[
    \(\(c`s = c`sign <> c`sig <> c`char <> c`sep <> c`char2;\)\)], "Input"],

Cell[BoxData[
    \(c`s\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(Global`cell = CombineCells[];\)\)], "Input"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(Options[fNBookForm] = {c`p`sd \[Rule] 4, c`p`u \[Rule] 3, 
          c`p`sep \[Rule] "\<\[ThinSpace]\>", c`p`showprec \[Rule] False, 
          c`p`printstate \[Rule] False};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(Options[fNBookForm]\)], "Input"],

Cell[BoxData[
    \(CreateModule[head, cell, Context -> "\<c`\>"]\)], "Input"],

Cell["\<\
clean up , c`* were used for testing / writing but module doesn't \
now need
note how easy cleanup of allow of mess is\
\>", "Text"],

Cell[BoxData[{
    \( (*\ \[IndentingNewLine]Map[Remove, Names["\<c`p`*\>"]]; \n
      Map[Remove, Names["\<c`*\>"]]; \[IndentingNewLine]Remove[
        fNBookForm];\[IndentingNewLine]*) \[IndentingNewLine]\(Remove[
        c`p`opts];\)\), "\[IndentingNewLine]", 
    \(\(Remove[head, cell];\)\), "\[IndentingNewLine]", 
    \(\(Remove[opts, sd, u, sep, showprec, PrintState];\)\  (*\ 
      was\ that\ \(\(needed\)\(\ \)\(?\)\)\ *) \), "\[IndentingNewLine]", 
    \(\(Remove[x, vars4];\)\)}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["basic tests for fNBookForm", "Subsubsection"],

Cell[BoxData[
    \(\(\(\ \)\(PrettyDate[]\)\)\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<-100.040`5*^5\>", c`p`sd \[Rule] 4]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<-100.040`5*^5\>", c`p`sd \[Rule] 5]\)], "Input"],

Cell[BoxData[
    \(10^^ - 100.040`5*^5\)], "Input"],

Cell[BoxData[
    \(fNBookForm[\(-10^^100.040`5*^5\)]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<-100.040`5*^5\>", c`p`sd \[Rule] 5]\)], "Input"],

Cell[BoxData[
    \(fNBookForm[\(-100.040`5\)*10^5, c`p`sd \[Rule] 5]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<-100.040`5*^5\>", c`p`sd \[Rule] 1]\)], "Input"],

Cell[BoxData[
    \(fNBookForm[\(-100.040`5*^5\), c`p`sd \[Rule] 1]\)], "Input"],

Cell[BoxData[
    \(\(y = \(-100.040`5\)*10^5;\)\)], "Input"],

Cell[BoxData[
    \(fNBookForm[100*y, c`p`sd -> 5, c`p`printstate \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(\(yy = 1`12*^-9;\)\)], "Input"],

Cell[BoxData[
    \(InputForm[yy]\)], "Input"],

Cell[BoxData[
    \(fNBookForm[yy, c`p`sd \[Rule] 5]\)], "Input"],

Cell[BoxData[
    \(fNBookForm[ .001, c`p`sd \[Rule] 7, 
      c`p`printstate \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(x = 10000000001.1001; fNBookForm[x, c`p`sd \[Rule] 20]\)], "Input"],

Cell[BoxData[{
    \(OLD\  - \ before\ left\ dec\ allowed\), "\[IndentingNewLine]", 
    \(\t\ "10000000001100.1\[ThinSpace]m"\)}], "Text"],

Cell[BoxData[
    \(x = \(- .0000723232344\); fNBookForm[x, c`p`sd \[Rule] 20]\)], "Input"],

Cell[BoxData[{
    \(OLD\  - \ before\ left\ dec\ allowed\), "\[IndentingNewLine]", 
    \(\t"-72323234400.00\[ThinSpace]f"\)}], "Text"],

Cell[BoxData[
    \(x = 0.0000723232344; fNBookForm[x, c`p`sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(x = \(- .0000723232344\); fNBookForm[x]\)], "Input"],

Cell[BoxData[
    \(fNBookForm[\(-100.040`5\)*10^\(-5\)]\)], "Input"],

Cell[BoxData[
    \(fNBookForm[\(-100.040`5\)*10^\(-5\), c`p`sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(fNBookForm[12.00\ 10^19, sd \[Rule] 7]\)], "Input"],

Cell["\<\
note \".\" can only adjust left 2, but sig is only 2 (thus e \
notation)\
\>", "Text"],

Cell[BoxData[
    \(fNBookForm[SetPrecision[12.00\ 10^19, 5], sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<1.2`5*^20\>"]\)], "Input"],

Cell[BoxData[
    \({fNBookForm[1.001], fNBookForm[0], fNBookForm["\<0*^0\>"], 
      fNBookForm["\<2*^1\>"], fNBookForm["\<2*^-2\>"], fNBookForm["\<2^2\>"], 
      fNBookForm["\<2*3\>"], fNBookForm[0\^0]}\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<1000*^-3\>"]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<1000*^-6\>"]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<0.01*^-7\>"]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<1`*^2\>", c`p`sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<1`16*^2\>", c`p`sd \[Rule] 32]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<1`*^-3\>", c`p`sd \[Rule] 32]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<1``16`5*^2\>", c`p`sd \[Rule] 8, 
      c`p`showprec \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<100000000``4`6*^2\>", c`p`sd \[Rule] 8, 
      c`p`showprec \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<100000000``4.5`6*^2\>", c`p`sd \[Rule] 8]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<100000000``4.5`6*^2\>", c`p`sd \[Rule] 8, 
      c`p`showprec \[Rule] True, c`p`printstate \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(fNBookForm["\<100000000``4.5`6*^2\>", c`p`sd \[Rule] 3, 
      c`p`showprec \[Rule] True]\)], "Input"],

Cell["previously 1`*^-3 would be ~ 10000000000 a", "Text"],

Cell[BoxData[
    \(bookexp["\<a\>"]\)], "Input"],

Cell[BoxData[
    \(Remove[x, y, yy]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["fNBookForm Table tests", "Subsubsection"],

Cell[BoxData[
    \(\(\(\ \)\(PrettyDate[]\)\)\)], "Input"],

Cell[BoxData[
    \(Partition[Table[fNBookForm[10^i // N], {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[{fNBookForm[12\ 10^i // N], 12\ 10^i // N}, {i, \(-25\), 25}], 
        6] // TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[{fNBookForm[12\ 10^i // N], 12\ 10^i // N}, {i, \(-25\), 25}], 
        6] // TableForm\)], "Input"],

Cell["\<\
the above  12.00 \[Mu] == 0.000012   shows 3 0's of accuracy \
missing ?
\toops - NO - note default cut is 4 , and it's 4 :)\
\>", "Text"],

Cell[BoxData[
    \(Partition[
        Table[booknum[fNBookForm[12\ 10^i // N]] // N, {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[fNBookForm["\<1012*^\>" <> ToString[i]], {i, \(-26\), 26}], 6] // 
      TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[fNBookForm["\<123*^\>" <> ToString[i]], {i, \(-26\), 26}], 6] // 
      TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[booknum[fNBookForm["\<123*^\>" <> ToString[i]], 
            Units \[Rule] 2], {i, \(-26\), 26}], 6] // TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[booknum[fNBookForm["\<123*^\>" <> ToString[i]]] // 
            N, {i, \(-26\), 26}], 6] // TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[Table[1012\ 10^i // N, {i, \(-26\), 26}], 6] // 
      TableForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["reset / remove fNBookForm2", "Subsubsection"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c2`p`*\>"]];\)\)], "Input",
  CellTags->{"S1.4.1", "1.1"}],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c2`*\>"]];\)\)], "Input",
  CellTags->{"S1.4.1", "1.1"}],

Cell[BoxData[
    \(\(Remove[fNBookForm2, x];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[opts, sd, u, sep, showprec, PrintState];\)\)], "Input"],

Cell[BoxData[
    \(Names["\<c2`*\>"]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["fNBookForm2 - test / debug / define", "Subsubsection"],

Cell["\<\
the code handles cases regular sig, sigzero, fill, ``, `, `` `
\ti'd never have used 1 fun for all that
\t\tit just accumulated a step at a time it was easier at the time
\tit is way too many things to handle at once
\t\tsee fNBookForm2Short offloads one task
\t\t--> sigzero and fill should be their own functions
\twell it's done.
\t\tand 1 fun is easier than 3 to update and more convenient to use
\t**\thowever i would not __dare try add a single extra load on it
\t**  its complicated enough as it is
because of that it needs to be modular and is pretty well so by design, ie \
...
\trounding must not add a \"0\" since how to react to it later would be awful
\trounding must use ++nexp instead\
\>", "Text"],

Cell["RunToBoundryCell", "Text"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell["\<\
c2`p` keeps \"p\"arameters in separate area from the rest.
If your wondering why bother using c2` and c2`p see Remove note at end of \
section.\
\>", "Text"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c2`p`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Map[Remove, Names["\<c2`*\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[fNBookForm2, x];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[opts, sd, u, sep, showprec, printstate, rounding, commas, 
        fill, sigzeros];\)\)], "Input"],

Cell[BoxData[
    \({Names["\<c2`*\>"], Names["\<c2`p`*\>"]}\)], "Input"],

Cell[BoxData[
    \(\(Remove[fNBookForm2];\)\)], "Input"],

Cell["\<\
NOTE:  vars4 isn't used for CreateModule anymore - now automatic.\
\
\>", "Text"],

Cell["\<\
vars4={\"c2`q\",\"c2`t\",\"c2`w\",\"c2`s\",\"c2`k\",\"c2`sign\",\"\
c2`mant\",\"c2`sig\",\"c2`base\",\"c2`acc\",\"c2`exp\",\"c2`prec\"\"c2`nprec\"\
,\"c2`nacc\",\"c2`nexp\",\"c2`sd\",\"c2`u\",\"c2`sep\",\"c2`showprec\",\"c2`\
printstate\",\"c2`rounding\",\"c2`commas\"};\
\>", "Text"],

Cell["Map[Remove,vars4];", "Text"],

Cell[BoxData[
    \(\(head = 
        fNBookForm2[\[IndentingNewLine]c2`p`x_Integer | c2`p`x_Real | 
            c2`p`x_String, \[IndentingNewLine]c2`p`opts___];\)\)], "Input"],

Cell["\<\
test values - note Global`x is only to show it is NOT interfering\
\
\>", "Text"],

Cell[BoxData[
    \(x = 5\)], "Input"],

Cell[BoxData[
    \(\(c2`p`x = "\<-100.040`5*^5\>";\)\)], "Input"],

Cell[BoxData[
    \(\(c2`p`x = "\<1000*^-3\>";\)\)], "Input"],

Cell[BoxData[
    \(\(c2`p`x = "\<0.12\>";\)\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<100000000``4.5`6*^2\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<1.55``4.5*^-9\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<16^^abc123\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<1`*^-3\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<1.``*^-22\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<918`0.7\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<0.001``4\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<1``\>"\)], "Input"],

Cell[BoxData[
    \(c2`p`x = "\<999``3*^-4\>"\)], "Input"],

Cell[BoxData[
    \(\(Options[fNBookForm2] := {c2`p`sd \[Rule] 4, c2`p`u \[Rule] 3, 
          c2`p`sep \[Rule] "\<\[ThinSpace]\>", c2`p`showprec \[Rule] False, 
          c2`p`printstate \[Rule] False, c2`p`rounding \[Rule] 0, 
          c2`p`commas \[Rule] False, c2`p`fill \[Rule] False, 
          c2`p`sigzeros \[Rule] False};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(c2`p`opts = 
        Sequence[c2`p`printstate -> True, c2`p`showprec \[Rule] True, 
          c2`p`sd \[Rule] 8, c2`p`rounding \[Rule] 0, 
          c2`p`commas \[Rule] False, c2`p`fill \[Rule] False, 
          c2`p`sigzeros \[Rule] False];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(c2`p`opts = 
        Sequence[c2`p`printstate -> True, c2`p`sd \[Rule] 2, 
          c2`p`rounding \[Rule] 1, c2`p`commas \[Rule] False, 
          c2`p`fill \[Rule] True, c2`p`sigzeros \[Rule] False];\)\)], "Input",\

  InitializationCell->True],

Cell[BoxData[
    \(x = 3\)], "Input"],

Cell[BoxData[
    \($Context\)], "Input"],

Cell[BoxData[
    \(\(Begin["\<c2`\>"];\)\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(c2`s = c2`p`x;\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Head[c2`p`x] \[Equal] Integer\  || \ 
          Head[c2`p`x] \[Equal] Real, \[IndentingNewLine]c2`s = 
          ToString[InputForm[c2`p`x]]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`sd = \(c2`p`sd /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`u = \(c2`p`u /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`sep = \(c2`p`sep /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`showprec = \(c2`p`showprec /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`printstate = \(c2`p`printstate /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`rounding = \(c2`p`rounding /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`commas = \(c2`p`commas /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`fill = \(c2`p`fill /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`sigzeros = \(c2`p`sigzeros /. {c2`p`opts}\) /. 
          Options[fNBookForm2];\)\)], "Input"],

Cell[BoxData[
    \(c2`mant = {}; c2`sig = {}; c2`base = {}; c2`prec = {}; c2`acc = {}; 
    c2`exp = {};\)], "Input"],

Cell[BoxData[
    \(c2`nprec = False; c2`nacc = False; c2`nexp = False;\)], "Input"],

Cell["these will get defined: c2`roundok=True;c2`fexp=0;", "Text"],

Cell[BoxData[
    \(\(c2`sign = "\<\>";\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`printstate, Print[c2`s]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`s = 
        StringReplace[
          c2`s, {"\<\\\>" -> "\<\>", "\<.^\>" -> "\<^\>", "\<.``\>" -> \
"\<``\>", "\<.`\>" -> "\<`\>", "\<.*\>" -> "\<*\>", "\<`.\>" \[Rule] \
"\<`0.\>"}];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        StringTake[c2`s, \(-1\)] \[Equal] "\<`\>" || 
          StringMatchQ[c2`s, "\<*`\\**\>"], \[IndentingNewLine]c2`w = 
          StringReplace[c2`s, {"\<``*\>" -> "\<*\>"}]; \[IndentingNewLine]If[
          StringLength@c2`w \[NotEqual] StringLength@c2`s || 
            StringTake[c2`s, \(-2\)] \[Equal] "\<``\>", \[IndentingNewLine]If[
            StringTake[c2`s, \(-2\)] \[Equal] "\<``\>", 
            c2`w = StringDrop[c2`s, \(-2\)]]; \[IndentingNewLine]c2`s = 
            c2`w; \[IndentingNewLine]If[
            NumberQ[c2`printstate], \[IndentingNewLine]c2`nacc = 
              c2`printstate\[IndentingNewLine], \[IndentingNewLine]c2`nacc = 
              Accuracy[1`]\[IndentingNewLine]]]; \[IndentingNewLine]c2`w = 
          StringReplace[c2`s, {"\<`*\>" -> "\<*\>"}]; \[IndentingNewLine]If[
          StringLength@c2`w \[NotEqual] StringLength@c2`s || 
            StringTake[c2`s, \(-1\)] \[Equal] "\<`\>", \[IndentingNewLine]If[
            StringTake[c2`s, \(-1\)] \[Equal] "\<`\>", 
            c2`w = StringDrop[c2`w, \(-1\)]]; \[IndentingNewLine]c2`s = 
            c2`w; \[IndentingNewLine]If[
            NumberQ[c2`printstate], \[IndentingNewLine]\(c2`nprec = 
                c2`printstate;\)\[IndentingNewLine], \
\[IndentingNewLine]\(c2`nprec = 
                Precision[
                  1`];\)\[IndentingNewLine]]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(c2`w = Characters[c2`s];\)\)], "Input"],

Cell[BoxData[
    \(\(Length[c2`w] > 0 || Return[c2`p`x];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c2`w[\([1]\)] \[Equal] "\<-\>", \[IndentingNewLine]c2`sign = "\<-\>"; \
\[IndentingNewLine]c2`w = Drop[c2`w, 1]\[IndentingNewLine]];\)\)], "Input"],

Cell["was groupadjacent[c2`w,true,DigitQ];", "Text"],

Cell[BoxData[
    \(\(c2`q = \((Intersection[{"\<^\>", "\<.\>", "\<`\>", "\<*\>", "\< \>"}, \
{#}] \[Equal] {})\) &;\)\)], "Input"],

Cell[BoxData[
    \(\(c2`w = groupadjacent[c2`w, true, c2`q];\)\)], "Input"],

Cell[BoxData[
    \(\(Length[c2`w] > 0 || Return[c2`p`x];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`debug[] := 
        If[c2`printstate \[Equal] True, 
          Print[{{"\<c2`t\>", c2`t}, \ {"\<w\>", c2`w}, \ {"\< S \>", 
                c2`sign}, {"\< s \>", c2`sig}, {"\< m \>", 
                c2`mant}, {"\< p \>", c2`prec, "\< \>", 
                c2`nprec}, {"\< a \>", c2`acc, "\< \>", c2`nacc}, {"\< e \>", 
                c2`exp, "\< \>", c2`nexp, "\< \>", c2`fexp}, {"\<sd=\>", 
                c2`sd}, {"\<r=\>", 
                c2`rounding}}]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(SetAttributes[c2`getp, HoldFirst];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`getp[p_Symbol] := 
        If[Length[c2`w] > 0 && c2`q@c2`w[\([1, 1]\)], \[IndentingNewLine]p = 
            Join[p, c2`w[\([1]\)]]; c2`w = Rest[c2`w]; True, 
          False];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`getp[p_Symbol, c_] := 
        If[Length[c2`w] > 1 && c2`w[\([1, 1]\)] \[Equal] c, 
          If[c2`q@c2`w[\([2, 1]\)], p = Join[p, c2`w[\([2]\)]]; 
            c2`w = Drop[c2`w, 2]; True, 
            Message[fNBookForm2::"\<unformatted\>", c2`s]; \(-1\)], 
          False];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`getp[p_Symbol, c1_, c2_] := 
        If[Length[c2`w] > 2 && c2`w[\([1, 1]\)] \[Equal] c1 && 
            c2`w[\([2, 1]\)] \[Equal] c2, c2`w = Rest[c2`w]; c2`getp[p, c2], 
          False];\)\)], "Input"],

Cell["\<\
a mini parser (it does not absorb c2`w unless it finds what it \
asked for)\
\>", "Text"],

Cell[BoxData[
    \(\(If[c2`getp[c2`mant, "\<.\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`getp[c2`sig];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`base, "\<^\>", "\<^\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c2`base \[NotEqual] {}, \[IndentingNewLine]c2`k = 
          c2`sig; \[IndentingNewLine]c2`sig = 
          c2`base; \[IndentingNewLine]c2`base = 
          c2`k;\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`mant, "\<.\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`mant \[Equal] {} && c2`sig \[Equal] {} && 
        Return[c2`p`x];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`acc, "\<`\>", "\<`\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`t = {};\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c2`t] > 0, 
        c2`acc = Join[c2`acc, {"\<.\>"}, c2`t]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`prec, "\<`\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`t = {};\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c2`t] > 0, 
        c2`prec = Join[c2`prec, {"\<.\>"}, c2`t]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`acc, "\<`\>", "\<`\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`t = {};\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c2`t] > 0, 
        c2`acc = Join[c2`acc, {"\<.\>"}, c2`t]];\)\)], "Input"],

Cell["\<\
-----------------------
this avoids wierd exp.  but i think bark is worse than bite.
c2`k=1;
If[Length[c2`w]>3&&c2`w[[1,1]]\[Equal]\"*\"&&c2`w[[2,1]]\[Equal]\"^\"&&c2`w[[\
3,1]]\[Equal]\"-\"&&c2`k\[Equal]1,c2`k=-1;c2`w=Delete[c2`w,3]];
If[c2`getp[c2`exp,\"*\",\"^\"]\[Equal]-1,Return[c2`p`x]];
If[c2`w\[NotEqual]{}&&c2`w\[NotEqual]{{\".\"}},Message[fNBookForm2::\"\
unformatted\",c2`s];Return[c2`p`x]];
If[Length[c2`exp]>0&&c2`k\[Equal]-1,c2`exp=Join[{\"-\"},c2`exp]];
-----------------------\
\>", "Text"],

Cell[BoxData[
    \(\(If[c2`getp[c2`exp, "\<*\>", "\<^\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`t = {};\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`getp[c2`t, "\<.\>"] \[Equal] \(-1\), 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length@c2`w =!= 0 && c2`w =!= {{"\<.\>"}}, 
        Message[fNBookForm2::"\<extra input\>", c2`s, c2`w]; 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[Length[c2`t] > 0, 
        c2`exp = Join[c2`exp, {"\<.\>"}, c2`t]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Length[c2`acc] > 0, \[IndentingNewLine]c2`nacc = 
          ToExpression[StringJoin[c2`acc]]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        Length[c2`prec] > 0, \[IndentingNewLine]c2`nprec = 
          ToExpression[StringJoin[c2`prec]]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`nexp = 
        If[Length[c2`exp] > 0, \[IndentingNewLine]ToExpression[
            StringJoin[c2`exp]], 0];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`fexp = FractionalPart@c2`nexp;\)\)], "Input"],

Cell[BoxData[
    \(\(c2`nexp = IntegerPart@c2`nexp;\)\)], "Input"],

Cell["\<\
If[FractionalPart@N@c2`nexp\[NotEqual]0,Message[fNBookForm2::\"\
fractional exponent\",c2`s];Return[c2`p`x]];\
\>", "Text"],

Cell[BoxData[
    \(\(If[Length[c2`base] > 0, 
        c2`base = ToExpression@\(StringJoin@c2`base\); 
        If[c2`base \[Equal] 1, c2`rounding = 0], c2`base = 10];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`base \[LessEqual] 0, 
        Message[fNBookForm2::"\<unformatted\>", c2`s]; 
        Return[c2`p`x]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`roundok = True;\)\)], "Input"],

Cell[BoxData[
    \(\(c2`debug[];\)\)], "Input"],

Cell["\<\
the below first normalizes to just sig and exp then adjusts decimal \
if needed\
\>", "Text"],

Cell["\<\
c2`w is orig length sig from here on.
\tc2`{k,q,t,acc,prec,exp} are free. q is preffered as Length@c2`sig\
\>", \
"Text"],

Cell[BoxData[
    \(\(c2`w = Length[c2`sig];\)\)], "Input"],

Cell["\<\
i tried many \"smart ways\" for improving 0's formatting that all \
led to conflicts between varied inputs.  best policy is: do not try improve \
it\
\>", "Text"],

Cell["\<\
if sig is .0001 for form 1000 e-4 (exp adjusted below).  t==q is \
all 0's\
\>", "Text"],

Cell["\<\
0's stripped to 1st sig dig for sci form, and exp adjusted \
considering
\tthe forms can mix (except at 0.00) by testing for leading 0.
\thowever the added confusion if that isn't wanted is too high\
\>", "Text"],

Cell[BoxData[
    \(\(If[\[Not] c2`sigzeros, \[IndentingNewLine]If[
          c2`w > 1 && 
            c2`sig[\([1]\)] \[Equal] "\<0\>", \[IndentingNewLine]c2`t = 
            1; \[IndentingNewLine]While[
            c2`w > c2`t && 
              c2`sig[\([c2`t + 
                      1]\)] \[Equal] "\<0\>", \(++c2`t\)]; \
\[IndentingNewLine]c2`sig = Drop[c2`sig, c2`t]; \[IndentingNewLine]If[
            c2`sig \[Equal] {} && c2`mant \[Equal] {}, 
            c2`sig = {"\<0\>"}]; \[IndentingNewLine]\(c2`w = 
              Length[c2`sig];\)\[IndentingNewLine]]; \[IndentingNewLine]If[
          c2`w \[Equal] 
              0 || \((c2`w \[Equal] 1 && c2`sig[\([1]\)] \[Equal] "\<0\>" && 
                  c2`mant \[NotEqual] {})\) && 
              c2`base > 1, \[IndentingNewLine]c2`q = 
            Length@c2`mant; \[IndentingNewLine]If[c2`q \[Equal] 0, 
            Return[c2`p`x]]; \[IndentingNewLine]c2`sig = {}; c2`w = 0; 
          c2`t = 0; \[IndentingNewLine]While[
            c2`t + 1 \[LessEqual] c2`q && 
              c2`mant[\([c2`t + 
                      1]\)] \[Equal] "\<0\>", \(++c2`t\)]; \
\[IndentingNewLine]If[c2`t \[Equal] c2`q, \(--c2`t\); 
            c2`roundok = False]; \[IndentingNewLine]If[c2`t > 0, 
            c2`mant = Drop[c2`mant, c2`t]]; \[IndentingNewLine]c2`nexp -= 
            c2`t];\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`sig = Join[c2`sig, c2`mant];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`mant = {};\)\)], "Input"],

Cell[BoxData[
    \(\(c2`debug[];\)\)], "Input"],

Cell["\<\
Section: (fill 0s L) , chop sig for sd or if prec and acc claim \
digis are chaff , round if asked , when done adjust using noldsig, (fill 0s \
R).  (exception: rounding==3 occurs for sd==0).  NOTE: in this area digits \
can be added and removed freely because exponent will adjust later: adjust \
nexp only if auto adjust at end will be wrong.\
\>", "Text"],

Cell[BoxData[
    \(\(c2`q = Length[c2`sig];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`acc = c2`sd;\)\)], "Input"],

Cell[BoxData[
    \(\(c2`oldxw = {c2`nexp, c2`w};\)\)], "Input"],

Cell[BoxData[
    \(\(c2`k = False;\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`nprec < c2`sd && c2`q + c2`nacc\  > c2`nprec, 
        Message[fNBookForm2::"\<prec flooded acc\>", c2`s]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`sd \[LessEqual] 0, c2`roundok = False];\)\)], "Input"],

Cell["\<\
if Fill put in left 0's now (more work to try to put off till after \
rounding)  see also: significant-figures.nb about why.  fill can be 0 only \
for `` or ` (signal below it happened that way). note est dig can get filled. \
 avoid adding any if >>sd, so that large exp are functional.\
\>", "Text"],

Cell["\<\
new: seems to work with c2`q and nexp easily, ok
If[c2`fill&&(c2`nacc=!=False||c2`nprec=!=False)&&c2`showprec===False&&c2`acc>\
0,\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        c2`fill && c2`showprec === False && 
          c2`acc > 
            0 && \((c2`sig \[NotEqual] {"\<0\>"} || 
              c2`sigzeros)\), \[IndentingNewLine]If[c2`printstate, 
          Print["\<s0=\>", c2`sig, "\< ne=\>", 
            c2`nexp]]; \[IndentingNewLine]If[c2`printstate, 
          Print["\<add left acc 0's\>"]; 
          c2`debug[]]; \[IndentingNewLine]c2`q = 
          Length@c2`sig; \[IndentingNewLine]c2`exp = 
          c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]If[NumberQ@c2`nacc, 
          c2`t = c2`nacc, 
          If[NumberQ@c2`nprec, c2`t = c2`nprec, 
            c2`t = c2`q]]; \[IndentingNewLine]c2`prec = 
          c2`exp + c2`q; \[IndentingNewLine]If[c2`printstate, 
          Print["\<s1=\>", c2`sig, "\< pr=\>", c2`prec, "\< e=\>", 
            c2`exp, "\< q=\>", c2`q, "\< t=\>", c2`t]]; \[IndentingNewLine]If[
          c2`prec < 0 && 
            c2`t \[GreaterEqual] 
              0, \[IndentingNewLine]c2`prec = \(-c2`prec\); \
\[IndentingNewLine]c2`t = Ceiling@c2`t; \[IndentingNewLine]If[
            c2`prec > c2`sd, \[IndentingNewLine]c2`sig = {}; 
            c2`roundok = False; 
            c2`prec = c2`sd\[IndentingNewLine], \[IndentingNewLine]If[
              NumberQ@c2`nacc && c2`prec > c2`t, c2`prec = c2`t; 
              c2`roundok = False; 
              c2`sig = {}]\[IndentingNewLine]]; \[IndentingNewLine]c2`sig = 
            Join[Table["\<0\>", {c2`s, 1, c2`prec}], 
              c2`sig]; \[IndentingNewLine]c2`nexp = 0; 
          c2`w = 0; \[IndentingNewLine]c2`q = 
            Length[c2`sig]; \[IndentingNewLine]c2`fill = 
            c2`prec; \[IndentingNewLine]If[c2`printstate, 
            Print["\<n1=\>", c2`nexp, "\< p=\>", c2`prec, "\< acc=\>", 
              c2`acc, \ "\< fill=\>", c2`fill]; 
            c2`debug[]]\[IndentingNewLine]]\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
mm says acc < 1 deletes digits left, ok.  (exp-t)==digstorem. \
(local sd - hidden digs) simplified is (q-d2r), ~ 9 vars 4 expr.  see \
significant-figures.nb  if fill==T already did cut and was easier\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        c2`nacc =!= False, \[IndentingNewLine]c2`t = 
          If[c2`rounding \[Equal] 3, Floor[c2`nacc], 
            Ceiling[c2`nacc]]; \[IndentingNewLine]c2`exp = 
          c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]If[
          c2`exp <= \(-c2`t\), \[IndentingNewLine]If[c2`printstate, 
            Print["\<t=\>", c2`t, "\< q=\>", c2`q, "\< e=\>", 
              c2`exp, "\< a=\>", 
              c2`q + c2`exp + c2`t]]; \[IndentingNewLine]c2`t = 
            c2`q + c2`exp + c2`t; \[IndentingNewLine]If[c2`t <= c2`sd, 
            c2`sd = c2`t; c2`k = c2`nacc]\[IndentingNewLine]]];\)\)], "Input"],

Cell["\<\
mm does not allow neg prec. note \"tmp (le not eq) sd\": if sd won, \
FractionalPart of prec would be ignored for rounding. ` can win k (can effect \
chop1 after rounding)\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        c2`nprec =!= False, \[IndentingNewLine]c2`t = 
          If[c2`rounding == 3, Floor[c2`nprec], 
            Ceiling[c2`nprec]]; \[IndentingNewLine]If[c2`fill > 0, 
          c2`t += c2`fill]; \[IndentingNewLine]If[
          c2`t \[LessEqual] c2`sd, \[IndentingNewLine]c2`sd = 
            c2`t; \[IndentingNewLine]If[
            c2`sd == 0 && c2`rounding \[NotEqual] 3, 
            c2`roundok = False]; \[IndentingNewLine]If[
            c2`k \[Equal] False || 
              FractionalPart@c2`nprec \[LessEqual] FractionalPart@c2`nacc, 
            c2`k = c2`nprec]; \[IndentingNewLine]If[c2`nprec \[LessEqual] 0, 
            c2`sd = 0; c2`roundok = False]\[IndentingNewLine]]];\)\)], "Input"],

Cell["\<\
all fluff beyond 1st est is used in rounding because mm does, \
assume it's \"better\"
if fill q<=sd already.\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        c2`q > c2`sd, \[IndentingNewLine]If[c2`sd < 0, c2`sd = 0; 
          c2`roundok = False]; \[IndentingNewLine]If[c2`sd < c2`fill, 
          c2`fill = c2`sd]; \[IndentingNewLine]c2`mant = 
          Drop[c2`sig, c2`sd]; \[IndentingNewLine]c2`sig = 
          Take[c2`sig, c2`sd]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`printstate, 
        Print["\<before rounding\>", "\< rok=\>", c2`roundok, "\< k=\>", 
          c2`k]; c2`debug[]];\)\)], "Input"],

Cell["\<\
rounding.  note if c2`k (acc/prec set sd) and frac is 0 we do not \
round: 18`1 doesnt round.
a work-around adds leading 0's ToExpression removed\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        c2`rounding > 0 && Length[c2`mant] > 0 && 
          c2`roundok && \((\[Not] \((c2`k =!= False && 
                  c2`rounding \[Equal] 1)\))\), \[IndentingNewLine]If[
          c2`printstate, Print["\<will check rounding\>"]; 
          c2`debug[];]; \[IndentingNewLine]If[
          c2`k =!= False, \[IndentingNewLine]If[
            c2`base \[NotEqual] 10, \[IndentingNewLine]c2`t = 
              ToExpression[
                ToString[c2`base] <> "\<^^\>" <> 
                  StringJoin[c2`mant]]\[IndentingNewLine], 
            c2`t = ToExpression@\(StringJoin@
                  c2`mant\)\[IndentingNewLine]]; \[IndentingNewLine]c2`t = 
            c2`base\ c2`t/
                Power[c2`base, Length@c2`mant]; \[IndentingNewLine]c2`prec = 
            c2`base\ \((1 - 
                  FractionalPart[Abs[c2`k]])\); \[IndentingNewLine]If[
            c2`prec \[GreaterEqual] c2`base, c2`t = 0, 
            c2`t -= c2`prec]\[IndentingNewLine], 
          c2`t = ToExpression@
              c2`mant[\([1]\)]\[IndentingNewLine]]; \[IndentingNewLine]If[
          c2`t \[GreaterEqual] c2`base/2, \[IndentingNewLine]c2`s = 
            False; \[IndentingNewLine]If[c2`sig \[Equal] {}, 
            c2`sig = {"\<0\>"}, 
            If[c2`sig[\([1]\)] == "\<0\>", c2`s = True; 
              c2`exp = Length@c2`sig]]; \[IndentingNewLine]If[
            c2`base \[NotEqual] 10, \[IndentingNewLine]c2`t = 
              ToExpression[
                ToString[c2`base] <> "\<^^\>" <> 
                  StringJoin[c2`sig]]\[IndentingNewLine], 
            c2`t = ToExpression@\(StringJoin@
                  c2`sig\)\[IndentingNewLine]]; \[IndentingNewLine]If[\[Not] \
NumberQ@c2`t, Message[fNBookForm2::"\<unexpected error\>", c2`sig]; 
            Return[c2`p`x]]; \[IndentingNewLine]\(++c2`t\); \
\[IndentingNewLine]If[
            c2`base == 10, \[IndentingNewLine]c2`sig = 
              Characters@\(ToString@
                  c2`t\)\[IndentingNewLine], \[IndentingNewLine]c2`t = 
              Characters@\(ToString@
                  BaseForm[c2`t, c2`base]\); \[IndentingNewLine]c2`prec = 
              Position[c2`t, "\<\n\>"]; \[IndentingNewLine]If[
              c2`prec \[NotEqual] {}, 
              c2`t = Take[c2`t, 
                  c2`prec[\([1, 1]\)] - 1]]; \[IndentingNewLine]c2`sig = 
              c2`t\[IndentingNewLine]]; \[IndentingNewLine]If[
            c2`s, \[IndentingNewLine]c2`s = 
              Table["\<0\>", {c2`prec, 1, 
                  c2`exp - Length@c2`sig}]; \[IndentingNewLine]c2`sig = 
              Join[c2`s, c2`sig]; \[IndentingNewLine]If[c2`fill > 0, 
              If[c2`sig[\([c2`fill]\)] \[NotEqual] "\<0\>", \
\[IndentingNewLine]\(--c2`fill\); 
                If[Last@c2`sig \[Equal] "\<0\>", 
                  c2`sig = 
                    Drop[c2`sig, \(-1\)]]\[IndentingNewLine]]]\
\[IndentingNewLine]]; \[IndentingNewLine]c2`q = 
            Length@c2`sig; \[IndentingNewLine]If[
            c2`q > c2`sd, \[IndentingNewLine]\(++c2`nexp\); \
\[IndentingNewLine]If[
              c2`sd == 0 && \((c2`rounding \[Equal] 
                      3 || \((c2`k =!= False && 
                        c2`k =!= c2`nprec)\))\), \[IndentingNewLine]c2`sd = 
                1, c2`sig = 
                Take[c2`sig, 
                  c2`sd]\[IndentingNewLine]]\[IndentingNewLine]]; \
\[IndentingNewLine]c2`mant[\([1]\)] = "\<0\>"\[IndentingNewLine]]];\)\)], \
"Input"],

Cell["\<\
above:
\trounding into fill \"hides\" a sig fig in fill area, maybe 0 after, realize \
situation
\t++nexp if removing 0 that went past sd (atmost one, as ++t is on chopped \
sig)
\tif sd==0 note `` with rounding==2 can cause round in like r3 for diff. \
reason
\t\tie, .29``.2, is sig{2} mant{9} after sd chop
\t\tie, .09``.7, is sig{}  mant{9} after sd chop, causes round-in to {}
\tnote ++nexp though Take[{?},sd==0] is nothing below needed if acc < -sd, \
t=0
If[c2`fill>0&&Last@c2`sig\[Equal]\"0\",\
\>", "Text"],

Cell["\<\
one special fix due to method.  keep sci form \"0^n\", 0.00d can be \
created by fill-chop (the only way it can get wrong).  note fill can be 0 \
only for `` ` in which case leave it be\
\>", "Text"],

Cell[BoxData[
    \(\(c2`q = Length@c2`sig;\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c2`fill \[GreaterEqual] 0 && c2`sigzeros === False && c2`q > 0 && 
          c2`sig[\([1]\)] \[Equal] "\<0\>" && 
          Complement[c2`sig, {"\<0\>"}] \[Equal] {}, \[IndentingNewLine]If[
          c2`printstate, Print["\<fixup 0's\>"]; 
          c2`debug[]]; \[IndentingNewLine]{c2`nexp, c2`w} = c2`oldxw; 
        c2`sig = {"\<0\>"}; c2`fill = 0; 
        c2`q = 1\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
add 0's for acc. 1``1*^1==10.0 (add) 1``4*^-2==1.00c (no fill) \
1``4*^-2==0.100d (fill) and  1``-2==0h (ignore junk dig) and 1``-2*^4==100h \
(mid fill).  sig=={} or sig=={0} is acceptable conditionally, checked.  \
tedious but not complicated.  note shortcut forms.\
\>", "Text"],

Cell["\<\
and similar to above but for prec.  r3 may reclaim dig of prec for \
0 if p>.5.\
\>", "Text"],

Cell["lsd adjusted for 0 here `` ` even if no 0's are added.", "Text"],

Cell["\<\
If[c2`printstate,Print[\"## s2=\",c2`sig,\" t=\",c2`t,\" q=\",c2`q,\
\" fil=\",c2`fill,\" nprec=\",c2`nprec,\" acc=\",c2`acc,\" \
round=\",c2`rounding]];\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        c2`acc > 0, \[IndentingNewLine]If[
          c2`nacc =!= False, \[IndentingNewLine]c2`t = 
            If[c2`rounding \[Equal] 3, Floor[c2`nacc], 
              Ceiling[c2`nacc]]; \[IndentingNewLine]If[
            c2`showprec \[Equal] False, \[IndentingNewLine]If[c2`printstate, 
              Print["\<add right acc 0's\>"]; 
              c2`debug[]]; \[IndentingNewLine]If[c2`printstate, 
              Print["\<s0=\>", c2`sig, "\< ne=\>", 
                c2`nexp]]; \[IndentingNewLine]c2`exp = 
              c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]c2`prec = 
              c2`t + c2`exp; \[IndentingNewLine]If[\[Not] \((c2`sigzeros === 
                      False && \((c2`q == 0 || 
                        c2`sig == {"\<0\>"})\))\), \[IndentingNewLine]c2`s = 
                c2`prec; \[IndentingNewLine]If[c2`s + c2`q > c2`acc, 
                c2`s = c2`acc - c2`q]; \[IndentingNewLine]If[c2`s > 0, 
                c2`sig = 
                  Join[c2`sig, 
                    Table["\<0\>", {c2`prec, 1, 
                        c2`s}]]]\[IndentingNewLine]]\[IndentingNewLine]]; \
\[IndentingNewLine]If[c2`printstate, 
            Print["\<s2=\>", c2`sig, "\< t=\>", c2`t, "\< q=\>", 
              c2`q]]; \[IndentingNewLine]If[
            c2`q \[Equal] 0 || c2`sig \[Equal] {"\<0\>"}, 
            c2`sig = {"\<0\>"}; \[IndentingNewLine]c2`nexp = \(-c2`t\) + 1; 
            c2`w = 0; \[IndentingNewLine]If[
              c2`rounding \[Equal] 3 && 
                Abs@\(FractionalPart@
                      c2`nacc\) >  .5, \(--c2`nexp\)]; \[IndentingNewLine]If[
              c2`printstate, Print["\<lo0\>"]]]; \[IndentingNewLine]If[
            c2`printstate, 
            Print["\<s2=\>", c2`sig, "\< ne=\>", c2`nexp, "\< e=\>", 
              c2`exp]]\[IndentingNewLine]]; \[IndentingNewLine]If[
          c2`nprec \[GreaterEqual] 0 && 
            c2`nacc \[Equal] False, \[IndentingNewLine]c2`t = 
            If[c2`rounding == 3, Floor[c2`nprec], 
              Ceiling[c2`nprec]]; \[IndentingNewLine]c2`exp = 
            c2`nexp - \((c2`q - c2`w)\); \[IndentingNewLine]If[
            c2`showprec \[Equal] False, \[IndentingNewLine]If[c2`printstate, 
              Print["\<add prec 0's\>"]; c2`debug[]]; \[IndentingNewLine]If[
              c2`printstate, 
              Print["\<s0=\>", c2`sig, "\< ne=\>", 
                c2`nexp]]; \[IndentingNewLine]If[c2`fill > 0, 
              c2`t += c2`fill]; \[IndentingNewLine]If[\[Not] \((c2`sigzeros === 
                      False && \((c2`q == 0 || 
                        c2`sig == {"\<0\>"})\))\), \[IndentingNewLine]c2`s = 
                c2`t - c2`q; \[IndentingNewLine]If[c2`s + c2`q > c2`acc, 
                c2`s = c2`acc - c2`q]; \[IndentingNewLine]If[c2`s > 0, 
                c2`sig = 
                  Join[c2`sig, 
                    Table["\<0\>", {c2`prec, 1, 
                        c2`s}]]];\[IndentingNewLine]]\[IndentingNewLine]]; \
\[IndentingNewLine]If[c2`printstate, 
            Print["\<s2=\>", c2`sig, "\< t=\>", c2`t, "\< q=\>", 
              c2`q]]; \[IndentingNewLine]If[
            c2`q \[Equal] 0 || c2`sig \[Equal] {"\<0\>"}, 
            c2`sig = {"\<0\>"}; \[IndentingNewLine]c2`nexp = 
              c2`exp - c2`t + 2; 
            c2`w = 0; \[IndentingNewLine]If[
              c2`q \[Equal] 0, \(--c2`nexp\)]; \[IndentingNewLine]If[
              c2`rounding \[Equal] 3 && 
                Abs@\(FractionalPart@
                      c2`nprec\) >  .5, \(--c2`nexp\)]; \[IndentingNewLine]If[
              c2`printstate, 
              Print["\<lo0\>"]]\[IndentingNewLine]]; \[IndentingNewLine]If[
            c2`printstate, 
            Print["\<s2=\>", c2`sig, "\< ne=\>", c2`nexp, "\< e=\>", 
              c2`exp]]\[IndentingNewLine]]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`q = Length[c2`sig];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`nexp = c2`nexp - \((c2`q - c2`w)\);\)\)], "Input"],

Cell["now have just sig and expoent (normalized form)", "Text"],

Cell[BoxData[
    \(\(c2`debug[];\)\)], "Input"],

Cell["\<\
adjust decimal left if we can to reduce neg. powers, note c`t marks \
place in mant.
ie, 10000 e-5 -> 1.0000 e-1 t==-4, but also does this: \"10^-1\" -> \"1.0\"
(there should be no diff in prec)\
\>", "Text"],

Cell[BoxData[
    \(\(c2`t = 0;\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c2`nexp < 0 && c2`q > 1 && 
          c2`u > 0, \[IndentingNewLine]If[\(-c2`q\) \[GreaterEqual] c2`nexp, 
          c2`k = \(-c2`q\) + 1, c2`k = c2`nexp]; \[IndentingNewLine]c2`t = 
          c2`k; c2`nexp -= c2`k; c2`q += c2`k];\)\)], "Input"],

Cell["\<\
if \".\" can be added to allow %3 for powerbook it can only be 1 or \
2 places left
or , with c`t, right (also: reduce nexp when choosing L/R if given choice)
{c`t,c`sig,c`mant,c`k,c`nexp,c`n,777,c`noldsig,c`nexp-(c`n-c`noldsig),c`s}\
\>\
", "Text"],

Cell[BoxData[
    \(\(If[\(Mod[c2`nexp, 3] \[NotEqual] 0 && 
            Abs[c2`nexp] \[GreaterEqual] 3\) && 
          c2`u > 0, \[IndentingNewLine]c2`k = 
          3 - Mod[c2`nexp, 3]; \[IndentingNewLine]If[
          c2`q > c2`k && \((c2`nexp < 0 || \(-c2`t\) \[LessEqual] 
                  3 - c2`k)\), \[IndentingNewLine]c2`nexp += c2`k; 
          c2`t -= c2`k; c2`k = 0;\[IndentingNewLine]]; \[IndentingNewLine]If[
          c2`k \[NotEqual] 0 && \(-c2`t\) \[GreaterEqual] 
              3 - c2`k, \[IndentingNewLine]c2`nexp -= \((3 - c2`k)\); 
          c2`t += \((3 - c2`k)\)\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`t \[NotEqual] 0, 
        c2`sig = Insert[c2`sig, "\<.\>", c2`t - 1]];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`debug[];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c2`commas, \[IndentingNewLine]c2`q = 
          Length@c2`sig; \[IndentingNewLine]c2`w = 
          Position[c2`sig, "\<.\>"]; \[IndentingNewLine]If[
          c2`w \[NotEqual] {}, 
          c2`q = c2`w[\([1, 1]\)] - 1]; \[IndentingNewLine]c2`w = 
          1; \[IndentingNewLine]While[c2`q > 1, 
          If[Mod[c2`w, 3] \[Equal] 0, 
            c2`sig = 
              Insert[c2`sig, "\<,\>", 
                c2`q]]; \(--c2`q\); \(++c2`w\)]\[IndentingNewLine]];\)\)], \
"Input"],

Cell["\<\
print results sign sig exp and maybe showprec
If[c2`printstate\[Equal]\"fill\",c2`nprec=False];\
\>", "Text"],

Cell[BoxData[
    \(\(c2`w = "\<\>";\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        c2`showprec =!= False, \[IndentingNewLine]If[c2`base \[NotEqual] 10, 
          c2`sign = 
            ToString[c2`base] <> "\<^^\>" <> c2`sign]; \[IndentingNewLine]If[
          c2`nacc \[Equal] False && 
            c2`nprec \[Equal] 
              False, \[IndentingNewLine]c2`nacc = \(-\((c2`t + \((c2`nexp + 
                      c2`fexp)\))\)\); \[IndentingNewLine]c2`nprec = 
            c2`q - c2`t\[IndentingNewLine]]; \[IndentingNewLine]If[
          NumberQ@c2`nacc, 
          c2`w = c2`w <> "\<``\>" <> 
              ToString[c2`nacc]]; \[IndentingNewLine]If[NumberQ@c2`nprec, 
          c2`w = c2`w <> "\<`\>" <> 
              ToString[c2`nprec]]; \[IndentingNewLine]If[
          c2`showprec \[Equal] All, \[IndentingNewLine]If[
            c2`fexp === 
              0, \[IndentingNewLine]\(c2`w = 
                c2`w <> "\<*^\>" <> ToString[c2`nexp];\)\[IndentingNewLine], 
            c2`w = c2`w <> "\<*^\>" <> 
                ToString@\(InputForm@\((c2`nexp + 
                        c2`fexp)\)\)]; \[IndentingNewLine]c2`nexp = 0; 
          c2`fexp = 0\[IndentingNewLine]]];\)\)], "Input"],

Cell["\<\
c2`k=Length@Cases[c2`sig,_?(DigitQ[#]||LetterQ[#]&)];
c2`w=c2`w<>\"`\"<>ToString@c2`k;\
\>", "Text"],

Cell[BoxData[
    \(c2`t = "\<\>"; c2`s = Abs@c2`u;\)], "Input"],

Cell[BoxData[
    \(\(If[
        c2`sig \[NotEqual] {} && 
          c2`nexp + c2`fexp \[NotEqual] 0, \[IndentingNewLine]If[
          c2`fexp === 0 && c2`s > 1, \[IndentingNewLine]c2`t = 
            ToString@
              powerbook[ToString[c2`nexp], 
                c2`s]\[IndentingNewLine], \[IndentingNewLine]c2`t = "\<e\>" <> 
              ToString@\(InputForm@\((c2`nexp + 
                      c2`fexp)\)\)\[IndentingNewLine]]\[IndentingNewLine]];\)\
\)], "Input"],

Cell["\<\
c2`nacc=!=False new: show 0's for `0 and might be `0^*2 or \
what\
\>", "Text"],

Cell[BoxData[
    \(\(If[c2`showprec =!= False && Length@c2`sig \[Equal] 0 && c2`sd > 0, 
        c2`sig = {"\<0\>"}];\)\)], "Input"],

Cell[BoxData[
    \(\(If[c2`t \[Equal] "\<\>", c2`sep = "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(c2`s = c2`sign <> c2`sig <> c2`w <> c2`sep <> c2`t;\)\)], "Input"],

Cell[BoxData[
    \(c2`s\)], "Input"],

Cell["BoundryCell", "Text"],

Cell[BoxData[
    \(\(Global`cell = CombineCells[];\)\)], "Input"],

Cell[BoxData[
    \(\(End[];\)\)], "Input"],

Cell[BoxData[
    \(\(Options[fNBookForm2] = {c2`p`sd \[Rule] 4, c2`p`u \[Rule] 3, 
          c2`p`sep \[Rule] "\<\[ThinSpace]\>", c2`p`showprec \[Rule] False, 
          c2`p`printstate \[Rule] False, c2`p`rounding \[Rule] 0, 
          c2`p`commas \[Rule] False, c2`p`fill \[Rule] False, 
          c2`p`sigzeros \[Rule] False};\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(CreateModule[head, cell, Context -> "\<c2`\>"]\)], "Input"],

Cell["\<\
NotebookObject[FrontEndObject[LinkObject[\"ParentLink\", 1, 1]], \
16]\
\>", "Text"],

Cell["\<\
(* 
Remove[vars4]; no longer needed, c2`* does this
Map[Remove,Names[\"c2`p`*\"]]; do NOT do this, param. vars are used by module
*)\
\>", "Text"],

Cell[BoxData[{
    \(\(Map[Remove, Names["\<c2`*\>"]];\)\), "\[IndentingNewLine]", 
    \(\(Remove[head, 
        cell];\)\[IndentingNewLine] (*\(needed\)\(?\)*) \), "\
\[IndentingNewLine]", 
    \(\(Remove[opts, sd, u, sep, showprec, PrintState, rounding, commas, 
        fill, sigzeros];\)\ \), "\[IndentingNewLine]", 
    \(\(Remove[x];\)\)}], "Input"],

Cell[BoxData[
    \(\(fNBookForm2::usage = "\<fNBookForm2[num,opts]  Output to string using \
letter powers.  Condenses automatically while preserving significance.  Input \
can be InputForm.  Output form is also decided by preserving input style; \
letter formatting aside.  Options@fNBookForm2 == {c2`p`sd\[Rule]4,c2`p`u\
\[Rule]3,c2`p`sep\[Rule]space,c2`p`showprec\[Rule]False,c2`p`printstate\[Rule]\
False,c2`p`rounding\[Rule]0}.  sd is tot. width.  Rounding is off.  \
{0,1,2,3}.  On 1st estimated digit boundry (on .7 of `1.7):  1. don't round \
est dig but show  2. round into est dig and show  3. round off est dig (do \
not show).  Try fNBookForm2Arb for arbitrary numbers, booknum to import book \
nums, and fNBookForm2Short (shortest showprec).\>";\)\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2::"\<unformatted\>" = "\<`1`\>";\)\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2::"\<extra input\>" = "\<`1` : `2`\>";\)\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2::"\<fractional exponent\>" = "\<`1`\>";\)\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2::"\<unexpected error\>" = "\<`1`\>";\)\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2::"\<prec flooded acc\>" = "\<too many precise digits left \
of decimal left no room for accuracy, but were kept: `1`\>";\)\)], "Input"],

Cell["\<\
If[c2`printstate,Print[\"n=\",c2`k,\"sd=\",c2`sd,\"rnd=\",c2`\
rounding]];
If[c2`printstate,Print[{c2`sig,c2`nexp,c2`sd}];];
Print[\"q=\",c2`q,\" acc/ti=\",c2`t,\" nexp=\",c2`nexp,\" w=\",c2`w,\" \
expf=\",c2`nexp-(c2`q-c2`w),\" tf=\",c2`t+c2`nexp-(c2`q-c2`w)];
Print[\"q=\",c2`q,\" p=\",c2`nprec,\" t=\",c2`t,\" sd=\",c2`sd,\" \
sig=\",c2`sig];\
\>", "Text"],

Cell[BoxData[
    \(\(Remove@fNBookForm2Short;\)\)], "Input"],

Cell[BoxData[
    \(fNBookForm2Short[x___] := 
      Module[{s1, s2}, \[IndentingNewLine]s1 = 
          fNBookForm2[x, 
            c2`p`showprec \[Rule] False]; \[IndentingNewLine]s2 = 
          fNBookForm2[x, c2`p`showprec \[Rule] True]; \[IndentingNewLine]If[
          StringLength@s2 < StringLength@s1, s2, 
          s1]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2Short::usage = "\<fNBookForm2Short[___]  Shows shorter of \
the two results of showprec->True and showprec->False.  See ? \
fNBookForm2.\>";\)\)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(PrettyDate[]\)\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["fNBookForm2Arb", "Subsubsection"],

Cell["arbitrary powers suggester", "Text"],

Cell[BoxData[
    \(\(fNBookForm2Arb // Remove;\)\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2Arb[x_Rational | x_Integer, u_Integer:  2] := 
        Module[{n, k, y, e, num, den, debug = False, 
            b}, \[IndentingNewLine]b = 10; \[IndentingNewLine]e = 
            First@\(Rest@MantissaExponent[N[x]]\); \[IndentingNewLine]If[
            e > 0, \(--e\), \(--e\)]; \[IndentingNewLine]If[e \[Equal] 0, 
            Return[x]]; \[IndentingNewLine]k = 1; 
          n = 1; \[IndentingNewLine]If[
            Abs[e] > 3 && 
              Mod[e, 3] =!= 0, \[IndentingNewLine]\(If[
                e < 0, \[IndentingNewLine]k = 
                  Mod[e, 3]; \[IndentingNewLine]e -= 
                  k; \[IndentingNewLine]k = 
                  b^k;\[IndentingNewLine], \[IndentingNewLine]k = 
                  3 - Mod[e, 3]; \[IndentingNewLine]e += 
                  k; \[IndentingNewLine]k = 
                  1/\((b^k)\);\[IndentingNewLine]];\)\[IndentingNewLine]]; \
\[IndentingNewLine]If[e > 24, k *= b^\((e - 24)\); 
            e = 24]; \[IndentingNewLine]If[e < \(-24\), k *= b^\((24 + e)\); 
            e = \(-24\)]; \[IndentingNewLine]If[e \[NotEqual] 0, 
            n = powerbook[e, u]]; \[IndentingNewLine]If[debug, 
            Print["\<nk=\>", n\ k, "\< n=\>", n, "\< k=\>", k, "\< e=\>", 
              e, "\< b=\>", b]]; \[IndentingNewLine]If[
            u \[Equal] 3 || u \[Equal] 4, \[IndentingNewLine]y = 
              x\ \((b^\(-e\))\); \[IndentingNewLine]num = 
              Numerator@y; \[IndentingNewLine]den = 
              Denominator@y; \[IndentingNewLine]If[
              den \[NotEqual] 1, \[IndentingNewLine]DisplayForm[
                RowBox[{FractionBox[num, den], "\< \>", 
                    n}]]\[IndentingNewLine], 
              DisplayForm[
                RowBox[{num, "\< \>", 
                    n}]]\[IndentingNewLine]]\[IndentingNewLine], 
            x\ \((b^\(-e\))\)\ n]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(fNBookForm2Arb::usage = "\<fNBookForm2Arb[Rational|Integer,u:2]  \
Offers a version of Arbitrary Precision number with powers Symbol (ie, Milli) \
used to reduce.  With u 3 or 4 be prettier. Use for base 10 untested other \
bases.\>";\)\)], "Input"],

Cell[BoxData[
    \(\(x = 200000000000000000000;\)\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[N[x, 30]]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2Arb[x] // N\)], "Input"],

Cell[BoxData[
    \(200\ 10^18 \[Equal]  .2\ 10^21\)], "Input"],

Cell[BoxData[
    \({10^\(-7\)\ \((1/35)\) // N, 20/7 // N}\)], "Input"],

Cell[BoxData[
    \({fNBookForm2Arb[10^\(-7\)\ \((1/35)\), 3], fNBookForm2Arb[30, 3], 
      fNBookForm2Arb[2/10, 3]}\)], "Input"],

Cell[BoxData[
    \({fNBookForm2Arb[10^\(-7\)\ \((1/35)\), 4], fNBookForm2Arb[30, 4], 
      fNBookForm2Arb[2/10, 4]}\)], "Input"],

Cell[BoxData[
    \(\(Remove[x];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["basic tests for fNBookForm2", "Subsubsection"],

Cell[BoxData[
    \(\(\(\ \)\(PrettyDate[]\)\)\)], "Input"],

Cell["\<\
\"Saturday, July 27 2013.  5:30:5 a.m. -4\[ThinSpace]GMT\"  \
passed\
\>", "Text"],

Cell[BoxData[
    \(fNBookForm2["\<-100.040`5*^5\>", c2`p`sd \[Rule] 4]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<-100.040`5*^5\>", c2`p`sd \[Rule] 5]\)], "Input"],

Cell["10^^-100.040`5*^5", "Text"],

Cell[BoxData[
    \(fNBookForm2[\(-10^^100.040`5*^5\)]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<-100.040`5*^5\>", c2`p`sd \[Rule] 5]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[\(-100.040`5\)*10^5, c2`p`sd \[Rule] 5]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<-100.040`5*^5\>", c2`p`sd \[Rule] 1]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[\(-100.040`5*^5\), c2`p`sd \[Rule] 1]\)], "Input"],

Cell[BoxData[
    \(\(y = \(-100.040`5\)*10^5;\)\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[100*y, c2`p`sd -> 5, 
      c2`p`printstate \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(\(yy = 1`12*^-9;\)\)], "Input"],

Cell[BoxData[
    \(InputForm[yy]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[yy, c2`p`sd \[Rule] 5]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[ .001, c2`p`sd \[Rule] 7, 
      c2`p`printstate \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(x = 10000000001.1001; fNBookForm2[x, c2`p`sd \[Rule] 20]\)], "Input"],

Cell[BoxData[{
    \(OLD\  - \ before\ left\ dec\ allowed\), "\[IndentingNewLine]", 
    \(\t\ "10000000001100.1\[ThinSpace]m"\)}], "Text"],

Cell[BoxData[
    \(x = \(- .0000723232344\); fNBookForm2[x, c2`p`sd \[Rule] 20]\)], "Input"],

Cell[BoxData[{
    \(OLD\  - \ before\ left\ dec\ allowed\), "\[IndentingNewLine]", 
    \(\t"-72323234400.00\[ThinSpace]f"\)}], "Text"],

Cell[BoxData[
    \(x = 0.0000723232344; fNBookForm2[x, c2`p`sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(x = \(- .0000723232344\); fNBookForm2[x]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[\(-100.040`5\)*10^\(-5\)]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[\(-100.040`5\)*10^\(-5\), c2`p`sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[12.00\ 10^19, sd \[Rule] 7]\)], "Input"],

Cell["\<\
note \".\" can only adjust left 2, but sig is only 2 (thus e \
notation)\
\>", "Text"],

Cell[BoxData[
    \(fNBookForm2[SetPrecision[12.00\ 10^19, 5], sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<1.2`5*^20\>"]\)], "Input"],

Cell[BoxData[
    \({fNBookForm2[1.001], fNBookForm2[0], fNBookForm2["\<0*^0\>"], 
      fNBookForm2["\<2*^1\>"], fNBookForm2["\<2*^-2\>"], 
      fNBookForm2["\<2^2\>"], fNBookForm2["\<2*3\>"], 
      fNBookForm2[0\^0]}\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<1000*^-3\>"]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<1000*^-6\>"]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<0.01*^-7\>"]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<1`*^2\>", c2`p`sd \[Rule] 7]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<1`16*^2\>", c2`p`sd \[Rule] 32]\)], "Input"],

Cell["new value.  note 13 + m == 16 which is ", "Text"],

Cell[BoxData[
    \(Precision[1`]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<1`*^-3\>", c2`p`sd \[Rule] 32]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<100000000``4`6*^2\>", c2`p`sd \[Rule] 8, 
      c2`p`showprec \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<100000000``4.5`6*^2\>", c2`p`sd \[Rule] 8]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<100000000``4.5`6*^2\>", c2`p`sd \[Rule] 8, 
      c2`p`showprec \[Rule] True, c2`p`printstate \[Rule] True]\)], "Input"],

Cell[BoxData[
    \(fNBookForm2["\<100000000``4.5`6*^2\>", c2`p`sd \[Rule] 3, 
      c2`p`showprec \[Rule] True]\)], "Input"],

Cell["previously 1`*^-3 would be ~ 10000000000 a", "Text"],

Cell[BoxData[
    \(bookexp["\<a\>"]\)], "Input"],

Cell[BoxData[
    \(Remove[x, y, yy]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["fNBookForm2 Table tests", "Subsubsection"],

Cell[BoxData[
    \(\(\(\ \)\(PrettyDate[]\)\)\)], "Input"],

Cell["\<\
\"Saturday, July 27 2013.  5:58:23 a.m. -4\[ThinSpace]GMT\"  passed\
\
\>", "Text"],

Cell["\<\
NOTE TO CASUAL READER: the tests using input 10^i//N look spurious \
but it is the InputForm of 10^i//N that is spurious.  fNBookForm2 treats this \
more properly than fNBookForm though fNBookForm appears \"cleaner\"\
\>", \
"Text"],

Cell["\<\
old before fix - would be right for ``* but actually `* was given \
(see fix2 further below)
good news: if so challenged it works\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Partition[Table[fNBookForm2[10^i // N], {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"99.99\[ThinSpace]e-27\"\>", "\<\"1.000\[ThinSpace]y\"\>", "\<\
\"10.00\[ThinSpace]y\"\>", "\<\"\[ThinSpace]\"\>", "\<\"\[ThinSpace]\"\>", \
"\<\"\[ThinSpace]\"\>"},
          {"\<\"\[ThinSpace]\"\>", "\<\"\[ThinSpace]\"\>", \
"\<\"\[ThinSpace]\"\>", "\<\"1\[ThinSpace]e-16\"\>", \
"\<\"1\[ThinSpace]f\"\>", "\<\"10\[ThinSpace]f\"\>"},
          {"\<\"100\[ThinSpace]f\"\>", "\<\"1.000\[ThinSpace]p\"\>", \
"\<\"10.00\[ThinSpace]p\"\>", "\<\"100.0\[ThinSpace]p\"\>", "\<\"1.000\
\[ThinSpace]n\"\>", "\<\"10.00\[ThinSpace]n\"\>"},
          {"\<\"100.0\[ThinSpace]n\"\>", "\<\"1.000\[ThinSpace]\[Micro]\"\>", \
"\<\"10.00\[ThinSpace]\[Micro]\"\>", "\<\"100.0\[ThinSpace]\[Micro]\"\>", "\<\
\"1.00\[ThinSpace]m\"\>", "\<\"1.0\[ThinSpace]c\"\>"},
          {"\<\"1\[ThinSpace]d\"\>", "\<\"1\[ThinSpace]\"\>", "\<\"10\
\[ThinSpace]\"\>", "\<\"100\[ThinSpace]\"\>", "\<\"1000\[ThinSpace]\"\>", "\<\
\"10000\[ThinSpace]\"\>"},
          {"\<\"1000\[ThinSpace]h\"\>", "\<\"1000\[ThinSpace]k\"\>", \
"\<\"10.00\[ThinSpace]M\"\>", "\<\"100.0\[ThinSpace]M\"\>", "\<\"1000\
\[ThinSpace]M\"\>", "\<\"10.00\[ThinSpace]G\"\>"},
          {"\<\"100.0\[ThinSpace]G\"\>", "\<\"1000\[ThinSpace]G\"\>", \
"\<\"10.00\[ThinSpace]T\"\>", "\<\"100.0\[ThinSpace]T\"\>", "\<\"1000\
\[ThinSpace]T\"\>", "\<\"10.00\[ThinSpace]P\"\>"},
          {"\<\"100.0\[ThinSpace]P\"\>", "\<\"1000\[ThinSpace]P\"\>", \
"\<\"10.00\[ThinSpace]E\"\>", "\<\"100.0\[ThinSpace]E\"\>", "\<\"1000\
\[ThinSpace]E\"\>", "\<\"10.00\[ThinSpace]Z\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Closed]],

Cell[BoxData[
    RowBox[{
      TagBox[GridBox[{
            {"\"\<99.99\[ThinSpace]e-27\>\"", "\"\<1.000\[ThinSpace]y\>\"", 
              "\"\<10.00\[ThinSpace]y\>\"", "\"\<\[ThinSpace]\>\"", 
              "\"\<\[ThinSpace]\>\"", "\"\<\[ThinSpace]\>\""},
            {"\"\<\[ThinSpace]\>\"", "\"\<\[ThinSpace]\>\"", 
              "\"\<\[ThinSpace]\>\"", "\"\<1\[ThinSpace]e-16\>\"", 
              "\"\<1\[ThinSpace]f\>\"", "\"\<10\[ThinSpace]f\>\""},
            {"\"\<100\[ThinSpace]f\>\"", "\"\<1.000\[ThinSpace]p\>\"", 
              "\"\<10.00\[ThinSpace]p\>\"", "\"\<100.0\[ThinSpace]p\>\"", 
              "\"\<1.000\[ThinSpace]n\>\"", "\"\<10.00\[ThinSpace]n\>\""},
            {"\"\<100.0\[ThinSpace]n\>\"", 
              "\"\<1.000\[ThinSpace]\[Micro]\>\"", 
              "\"\<10.00\[ThinSpace]\[Micro]\>\"", 
              "\"\<100.0\[ThinSpace]\[Micro]\>\"", 
              "\"\<1.00\[ThinSpace]m\>\"", "\"\<1.0\[ThinSpace]c\>\""},
            {"\"\<1\[ThinSpace]d\>\"", "\"\<1\[ThinSpace]\>\"", 
              "\"\<10\[ThinSpace]\>\"", "\"\<100\[ThinSpace]\>\"", 
              "\"\<1000\[ThinSpace]\>\"", "\"\<10000\[ThinSpace]\>\""},
            {"\"\<1000\[ThinSpace]h\>\"", "\"\<1000\[ThinSpace]k\>\"", 
              "\"\<10.00\[ThinSpace]M\>\"", "\"\<100.0\[ThinSpace]M\>\"", 
              "\"\<1000\[ThinSpace]M\>\"", "\"\<10.00\[ThinSpace]G\>\""},
            {"\"\<100.0\[ThinSpace]G\>\"", "\"\<1000\[ThinSpace]G\>\"", 
              "\"\<10.00\[ThinSpace]T\>\"", "\"\<100.0\[ThinSpace]T\>\"", 
              "\"\<1000\[ThinSpace]T\>\"", "\"\<10.00\[ThinSpace]P\>\""},
            {"\"\<100.0\[ThinSpace]P\>\"", "\"\<1000\[ThinSpace]P\>\"", 
              "\"\<10.00\[ThinSpace]E\>\"", "\"\<100.0\[ThinSpace]E\>\"", 
              "\"\<1000\[ThinSpace]E\>\"", "\"\<10.00\[ThinSpace]Z\>\""}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        (TableForm[ #]&)], " "}]], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(Partition[Table[10^i // N, {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[GridBox[{
          {"9.999999999999999`*^-26", "1.0000000000000001`*^-24", 
            "1.0000000000000001`*^-23", "1.`*^-22", "1.`*^-21", "1.`*^-20"},
          {"1.`*^-19", "1.`*^-18", "1.`*^-17", "1.`*^-16", "1.`*^-15", 
            "1.`*^-14"},
          {"1.`*^-13", "1.`*^-12", "1.`*^-11", "1.`*^-10", "1.`*^-9", 
            "1.`*^-8"},
          {"1.`*^-7", "1.`*^-6", "0.00001`", "0.0001`", "0.001`", "0.01`"},
          {"0.1`", "1.`", "10.`", "100.`", "1000.`", "10000.`"},
          {"100000.`", "1.`*^6", "1.`*^7", "1.`*^8", "1.`*^9", "1.`*^10"},
          {"1.`*^11", "1.`*^12", "1.`*^13", "1.`*^14", "1.`*^15", "1.`*^16"},
          {"1.`*^17", "1.`*^18", "1.`*^19", "1.`*^20", "1.`*^21", "1.`*^22"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output",
  Editable->False]
}, Closed]],

Cell[BoxData[
    RowBox[{
      TagBox[GridBox[{
            {"9.999999999999999`*^-26", "1.0000000000000001`*^-24", 
              "1.0000000000000001`*^-23", "1.`*^-22", "1.`*^-21", 
              "1.`*^-20"},
            {"1.`*^-19", "1.`*^-18", "1.`*^-17", "1.`*^-16", "1.`*^-15", 
              "1.`*^-14"},
            {"1.`*^-13", "1.`*^-12", "1.`*^-11", "1.`*^-10", "1.`*^-9", 
              "1.`*^-8"},
            {"1.`*^-7", "1.`*^-6", "0.00001`", "0.0001`", "0.001`", "0.01`"},
            {"0.1`", "1.`", "10.`", "100.`", "1000.`", "10000.`"},
            {"100000.`", "1.`*^6", "1.`*^7", "1.`*^8", "1.`*^9", "1.`*^10"},
            {"1.`*^11", "1.`*^12", "1.`*^13", "1.`*^14", "1.`*^15", 
              "1.`*^16"},
            {"1.`*^17", "1.`*^18", "1.`*^19", "1.`*^20", "1.`*^21", 
              "1.`*^22"}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        (TableForm[ #]&)], " "}]], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ToExpression@"\<1.000000000000000000000000000000000000000000000``22*^-\
22\>"\)], "Input"],

Cell[BoxData[
    \("\<1.000000000000000000000000000000000000000000000``22*^-22\>" // 
      fNBookForm2\)], "Input"],

Cell[TextData[{
  "note its a ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " bug to show 1 when default prec is 16.  note there's no way around it in \
text mode - meaning if I \"fix\" it then it breaks InputForm \"1`*^10\" and \
it breaks it because it's valid input who's precision must be assumed to be \
Precision[1`]."
}], "Text"],

Cell[BoxData[
    \($MachinePrecision = 32\)], "Input"],

Cell[BoxData[
    \(Accuracy[1``]\)], "Input"],

Cell[BoxData[
    \(Accuracy[1^22 // N]\)], "Input"],

Cell["old before fix: this helps not allot", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Partition[
        Table[fNBookForm2[SetPrecision[10^i, 32] // N], {i, \(-25\), 25}], 
        6] // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"\[ThinSpace]\"\>", "\<\"\[ThinSpace]\"\>", \
"\<\"\[ThinSpace]\"\>", "\<\"\[ThinSpace]\"\>", "\<\"\[ThinSpace]\"\>", "\<\"\
\[ThinSpace]\"\>"},
          {"\<\"\[ThinSpace]\"\>", "\<\"\[ThinSpace]\"\>", \
"\<\"\[ThinSpace]\"\>", "\<\"1\[ThinSpace]e-16\"\>", \
"\<\"1\[ThinSpace]f\"\>", "\<\"10\[ThinSpace]f\"\>"},
          {"\<\"100\[ThinSpace]f\"\>", "\<\"1.000\[ThinSpace]p\"\>", \
"\<\"10.00\[ThinSpace]p\"\>", "\<\"100.0\[ThinSpace]p\"\>", "\<\"1.000\
\[ThinSpace]n\"\>", "\<\"10.00\[ThinSpace]n\"\>"},
          {"\<\"100.0\[ThinSpace]n\"\>", "\<\"1.000\[ThinSpace]\[Micro]\"\>", \
"\<\"10.00\[ThinSpace]\[Micro]\"\>", "\<\"100.0\[ThinSpace]\[Micro]\"\>", "\<\
\"1.00\[ThinSpace]m\"\>", "\<\"1.0\[ThinSpace]c\"\>"},
          {"\<\"1\[ThinSpace]d\"\>", "\<\"1\[ThinSpace]\"\>", "\<\"10\
\[ThinSpace]\"\>", "\<\"100\[ThinSpace]\"\>", "\<\"1000\[ThinSpace]\"\>", "\<\
\"10000\[ThinSpace]\"\>"},
          {"\<\"1000\[ThinSpace]h\"\>", "\<\"1000\[ThinSpace]k\"\>", \
"\<\"10.00\[ThinSpace]M\"\>", "\<\"100.0\[ThinSpace]M\"\>", "\<\"1000\
\[ThinSpace]M\"\>", "\<\"10.00\[ThinSpace]G\"\>"},
          {"\<\"100.0\[ThinSpace]G\"\>", "\<\"1000\[ThinSpace]G\"\>", \
"\<\"10.00\[ThinSpace]T\"\>", "\<\"100.0\[ThinSpace]T\"\>", "\<\"1000\
\[ThinSpace]T\"\>", "\<\"10.00\[ThinSpace]P\"\>"},
          {"\<\"100.0\[ThinSpace]P\"\>", "\<\"1000\[ThinSpace]P\"\>", \
"\<\"10.00\[ThinSpace]E\"\>", "\<\"100.0\[ThinSpace]E\"\>", "\<\"1000\
\[ThinSpace]E\"\>", "\<\"10.00\[ThinSpace]Z\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Closed]],

Cell[BoxData[
    RowBox[{
      TagBox[GridBox[{
            {"\"\<\[ThinSpace]\>\"", "\"\<\[ThinSpace]\>\"", 
              "\"\<\[ThinSpace]\>\"", "\"\<\[ThinSpace]\>\"", 
              "\"\<\[ThinSpace]\>\"", "\"\<\[ThinSpace]\>\""},
            {"\"\<\[ThinSpace]\>\"", "\"\<\[ThinSpace]\>\"", 
              "\"\<\[ThinSpace]\>\"", "\"\<1\[ThinSpace]e-16\>\"", 
              "\"\<1\[ThinSpace]f\>\"", "\"\<10\[ThinSpace]f\>\""},
            {"\"\<100\[ThinSpace]f\>\"", "\"\<1.000\[ThinSpace]p\>\"", 
              "\"\<10.00\[ThinSpace]p\>\"", "\"\<100.0\[ThinSpace]p\>\"", 
              "\"\<1.000\[ThinSpace]n\>\"", "\"\<10.00\[ThinSpace]n\>\""},
            {"\"\<100.0\[ThinSpace]n\>\"", 
              "\"\<1.000\[ThinSpace]\[Micro]\>\"", 
              "\"\<10.00\[ThinSpace]\[Micro]\>\"", 
              "\"\<100.0\[ThinSpace]\[Micro]\>\"", 
              "\"\<1.00\[ThinSpace]m\>\"", "\"\<1.0\[ThinSpace]c\>\""},
            {"\"\<1\[ThinSpace]d\>\"", "\"\<1\[ThinSpace]\>\"", 
              "\"\<10\[ThinSpace]\>\"", "\"\<100\[ThinSpace]\>\"", 
              "\"\<1000\[ThinSpace]\>\"", "\"\<10000\[ThinSpace]\>\""},
            {"\"\<1000\[ThinSpace]h\>\"", "\"\<1000\[ThinSpace]k\>\"", 
              "\"\<10.00\[ThinSpace]M\>\"", "\"\<100.0\[ThinSpace]M\>\"", 
              "\"\<1000\[ThinSpace]M\>\"", "\"\<10.00\[ThinSpace]G\>\""},
            {"\"\<100.0\[ThinSpace]G\>\"", "\"\<1000\[ThinSpace]G\>\"", 
              "\"\<10.00\[ThinSpace]T\>\"", "\"\<100.0\[ThinSpace]T\>\"", 
              "\"\<1000\[ThinSpace]T\>\"", "\"\<10.00\[ThinSpace]P\>\""},
            {"\"\<100.0\[ThinSpace]P\>\"", "\"\<1000\[ThinSpace]P\>\"", 
              "\"\<10.00\[ThinSpace]E\>\"", "\"\<100.0\[ThinSpace]E\>\"", 
              "\"\<1000\[ThinSpace]E\>\"", "\"\<10.00\[ThinSpace]Z\>\""}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        (TableForm[ #]&)], " "}]], "Input",
  Evaluatable->False],

Cell["this shows too many 0's", "Text"],

Cell[BoxData[
    \(Partition[
        Table[fNBookForm2["\<1`32*^\>" <> ToString@i], {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input"],

Cell[TextData[{
  "fix1 - changed fNBookForm2 so user can get around the fact so that even if \
``* is given one can bypass the default because ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " might and one might need to get around that"
}], "Text"],

Cell[BoxData[
    \(Partition[
        Table[fNBookForm2[10^i // N, 
            c2`p`printstate \[Rule] 32], {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input"],

Cell["\<\
fix2 - changed fNBookForm2 to see ``* and `* separately (now makes \
a diff).  the problem above was `* was also setting ``* which wasn't asked.  \
it also uncovers that fNBookForm, due to this, was displaying too many 0's, \
though really `* support was hacked in as there was documentedly no full \
support for SetPrecision functions.  There still isn't full support I'd \
guess.

Note how (old issue working fine) 1 e-22 now dipslays.  .1 z isn't allowed \
(too hard to see .) and 0.1 isn't allowed (permiscuous 0) and of course 10 e \
y displays an extra digit of precision we don't have.  HOWEVER.  some DO.  \
why?  Because (look at 99...) because N sometimes gives extra digits \
sometimes not !!  see above.  not an fNBookForm issue but an output -> input \
fau pau.\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      TagBox[GridBox[{
            {"9.999999999999999`*^-26", "1.0000000000000001`*^-24", 
              "1.0000000000000001`*^-23", "1.`*^-22", "1.`*^-21", 
              "1.`*^-20"},
            {"1.`*^-19", "1.`*^-18", "1.`*^-17", "1.`*^-16", "1.`*^-15", 
              "1.`*^-14"},
            {"1.`*^-13", "1.`*^-12", "1.`*^-11", "1.`*^-10", "1.`*^-9", 
              "1.`*^-8"},
            {"1.`*^-7", "1.`*^-6", "0.00001`", "0.0001`", "0.001`", "0.01`"},
            {"0.1`", "1.`", "10.`", "100.`", "1000.`", "10000.`"},
            {"100000.`", "1.`*^6", "1.`*^7", "1.`*^8", "1.`*^9", "1.`*^10"},
            {"1.`*^11", "1.`*^12", "1.`*^13", "1.`*^14", "1.`*^15", 
              "1.`*^16"},
            {"1.`*^17", "1.`*^18", "1.`*^19", "1.`*^20", "1.`*^21", 
              "1.`*^22"}
            },
          RowSpacings->1,
          ColumnSpacings->3,
          RowAlignments->Baseline,
          ColumnAlignments->{Left}],
        (TableForm[ #]&)], " "}]], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Partition[Table[fNBookForm[10^i // N], {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[Table[fNBookForm2[10^i // N], {i, \(-25\), 25}], 6] // 
      TableForm\)], "Input"],

Cell["\<\
note: do not be tricked into thinking they should look and print \
alike: see InputForm of //N above\
\>", "Text"],

Cell[BoxData[
    \(Partition[
        Table[{fNBookForm2[12\ 10^i // N], 12\ 10^i // N}, {i, \(-25\), 25}], 
        6] // TableForm\)], "Input"],

Cell["\<\
the above  12.00 \[Mu] == 0.000012   shows 3 0's of accuracy \
missing ?
\toops - NO - note default cut is 4 , and it's 4 :)\
\>", "Text"],

Cell[BoxData[
    \(Partition[
        Table[booknum[fNBookForm2[12\ 10^i // N]] // N, {i, \(-25\), 25}], 
        6] // TableForm\)], "Input"],

Cell["with clean InputForm input expect a clean table", "Text"],

Cell[BoxData[
    \(Partition[
        Table[fNBookForm["\<1012*^\>" <> ToString[i]], {i, \(-26\), 26}], 6] // 
      TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[fNBookForm2["\<1012*^\>" <> ToString[i]], {i, \(-26\), 26}], 
        6] // TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[fNBookForm2["\<123*^\>" <> ToString[i]], {i, \(-26\), 26}], 6] // 
      TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[booknum[fNBookForm2["\<123*^\>" <> ToString[i]], 
            Units \[Rule] 2], {i, \(-26\), 26}], 6] // TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[
        Table[booknum[fNBookForm2["\<123*^\>" <> ToString[i]]] // 
            N, {i, \(-26\), 26}], 6] // TableForm\)], "Input"],

Cell[BoxData[
    \(Partition[Table[1012\ 10^i // N, {i, \(-26\), 26}], 6] // 
      TableForm\)], "Input"]
}, Closed]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
WindowSize->{520, 600},
WindowMargins->{{Automatic, 139}, {Automatic, 174}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "S1.4.1"->{
    Cell[22831, 697, 100, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}],
    Cell[22934, 701, 98, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}],
    Cell[45506, 1507, 101, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}],
    Cell[45610, 1511, 99, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}]},
  "1.1"->{
    Cell[22831, 697, 100, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}],
    Cell[22934, 701, 98, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}],
    Cell[45506, 1507, 101, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}],
    Cell[45610, 1511, 99, 2, 52, "Input",
      CellTags->{"S1.4.1", "1.1"}]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"S1.4.1", 108653, 3248},
  {"1.1", 108977, 3257}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 230, 4, 82, "Text"],

Cell[CellGroupData[{
Cell[1972, 57, 101, 3, 42, "Subsubsection"],
Cell[2076, 62, 119, 2, 56, "Input"],
Cell[2198, 66, 818, 14, 253, "Text"],
Cell[3019, 82, 1098, 16, 264, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[4154, 103, 59, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[4238, 107, 62, 1, 40, "Input"],
Cell[4303, 110, 37, 1, 40, "Output"]
}, Closed]],
Cell[4355, 114, 646, 12, 200, "Input"],
Cell[5004, 128, 175, 4, 40, "Input"],
Cell[5182, 134, 216, 4, 56, "Input"],
Cell[5401, 140, 311, 5, 88, "Input"],

Cell[CellGroupData[{
Cell[5737, 149, 47, 1, 40, "Input"],
Cell[5787, 152, 1850, 38, 240, "Output"]
}, Closed]],
Cell[7652, 193, 592, 13, 184, "Input"],
Cell[8247, 208, 2574, 98, 45, "Text"],
Cell[10824, 308, 196, 5, 31, "Text"],

Cell[CellGroupData[{
Cell[11045, 317, 123, 2, 40, "Input"],
Cell[11171, 321, 925, 25, 440, "Output"]
}, Closed]],
Cell[12111, 349, 145, 3, 40, "Input"],
Cell[12259, 354, 136, 2, 40, "Input"],
Cell[12398, 358, 163, 3, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[12598, 366, 47, 0, 28, "Subsubsection"],
Cell[12648, 368, 619, 11, 152, "Input"],
Cell[13270, 381, 275, 4, 88, "Input"],
Cell[13548, 387, 71, 1, 40, "Input"],
Cell[13622, 390, 249, 4, 72, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[13908, 399, 45, 0, 28, "Subsubsection"],
Cell[13956, 401, 59, 1, 40, "Input"],
Cell[14018, 404, 64, 1, 40, "Input"],
Cell[14085, 407, 49, 1, 40, "Input"],
Cell[14137, 410, 27, 0, 31, "Text"],
Cell[14167, 412, 61, 1, 40, "Input"],
Cell[14231, 415, 360, 8, 152, "Input"],
Cell[14594, 425, 34, 1, 40, "Input"],
Cell[14631, 428, 27, 0, 31, "Text"],
Cell[14661, 430, 59, 1, 40, "Input"],
Cell[14723, 433, 81, 1, 40, "Input"],
Cell[14807, 436, 56, 1, 40, "Input"],
Cell[14866, 439, 246, 3, 88, "Input"],
Cell[15115, 444, 45, 1, 40, "Input"],
Cell[15163, 447, 48, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[15248, 453, 45, 0, 28, "Subsubsection"],
Cell[15296, 455, 186, 4, 65, "Text"],
Cell[15485, 461, 104, 2, 40, "Input"],
Cell[15592, 465, 128, 2, 40, "Input"],
Cell[15723, 469, 71, 1, 40, "Input"],
Cell[15797, 472, 133, 3, 40, "Input"],
Cell[15933, 477, 60, 1, 40, "Input"],
Cell[15996, 480, 27, 0, 31, "Text"],
Cell[16026, 482, 81, 1, 40, "Input"],
Cell[16110, 485, 85, 1, 40, "Input"],
Cell[16198, 488, 72, 1, 40, "Input"],
Cell[16273, 491, 83, 1, 40, "Input"],
Cell[16359, 494, 130, 3, 31, "Text"],
Cell[16492, 499, 118, 3, 31, "Text"],
Cell[16613, 504, 47, 1, 40, "Input"],
Cell[16663, 507, 46, 1, 40, "Input"],
Cell[16712, 510, 47, 1, 40, "Input"],
Cell[16762, 513, 71, 1, 40, "Input"],
Cell[16836, 516, 129, 3, 40, "Input"],
Cell[16968, 521, 157, 3, 48, "Text"],
Cell[17128, 526, 135, 3, 40, "Input"],
Cell[17266, 531, 51, 1, 40, "Input"],
Cell[17320, 534, 777, 15, 168, "Input"],
Cell[18100, 551, 79, 0, 31, "Text"],
Cell[18182, 553, 89, 3, 31, "Text"],
Cell[18274, 558, 513, 11, 120, "Input"],
Cell[18790, 571, 78, 1, 40, "Input"],
Cell[18871, 574, 82, 1, 40, "Input"],
Cell[18956, 577, 47, 1, 40, "Input"],
Cell[19006, 580, 86, 1, 40, "Input"],
Cell[19095, 583, 134, 3, 40, "Input"],
Cell[19232, 588, 51, 1, 40, "Input"],
Cell[19286, 591, 66, 1, 40, "Input"],
Cell[19355, 594, 74, 0, 31, "Text"],
Cell[19432, 596, 103, 2, 40, "Input"],
Cell[19538, 600, 149, 4, 40, "Input"],
Cell[19690, 606, 294, 6, 104, "Input"],
Cell[19987, 614, 55, 1, 40, "Input"],
Cell[20045, 617, 415, 9, 136, "Input"],
Cell[20463, 628, 64, 1, 40, "Input"],
Cell[20530, 631, 34, 1, 40, "Input"],
Cell[20567, 634, 27, 0, 31, "Text"],
Cell[20597, 636, 59, 1, 40, "Input"],
Cell[20659, 639, 143, 3, 40, "Input"],
Cell[20805, 644, 541, 7, 136, "Input"],
Cell[21349, 653, 127, 2, 40, "Input"],
Cell[21479, 657, 122, 2, 40, "Input"],
Cell[21604, 661, 52, 1, 40, "Input"],
Cell[21659, 664, 43, 1, 40, "Input"],
Cell[21705, 667, 753, 11, 136, "Input"],
Cell[22461, 680, 112, 2, 40, "Input"],
Cell[22576, 684, 73, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[22686, 689, 50, 0, 28, "Subsubsection"],
Cell[22739, 691, 43, 1, 40, "Input"],
Cell[22785, 694, 43, 1, 40, "Input"],
Cell[22831, 697, 100, 2, 52, "Input",
  CellTags->{"S1.4.1", "1.1"}],
Cell[22934, 701, 98, 2, 52, "Input",
  CellTags->{"S1.4.1", "1.1"}],
Cell[23035, 705, 59, 1, 40, "Input"],
Cell[23097, 708, 84, 1, 40, "Input"],
Cell[23184, 711, 49, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[23270, 717, 59, 0, 28, "Subsubsection"],
Cell[23332, 719, 357, 8, 133, "Text"],
Cell[23692, 729, 32, 0, 31, "Text"],
Cell[23727, 731, 43, 1, 40, "Input"],
Cell[23773, 734, 43, 1, 40, "Input"],
Cell[23819, 737, 69, 1, 40, "Input"],
Cell[23891, 740, 67, 1, 40, "Input"],
Cell[23961, 743, 59, 1, 40, "Input"],
Cell[24023, 746, 84, 1, 40, "Input"],
Cell[24110, 749, 71, 1, 40, "Input"],
Cell[24184, 752, 56, 1, 40, "Input"],
Cell[24243, 755, 90, 3, 31, "Text"],
Cell[24336, 760, 384, 6, 72, "Input"],
Cell[24723, 768, 56, 1, 40, "Input"],
Cell[24782, 771, 171, 3, 72, "Input"],
Cell[24956, 776, 91, 3, 31, "Text"],
Cell[25050, 781, 38, 1, 40, "Input"],
Cell[25091, 784, 66, 1, 40, "Input"],
Cell[25160, 787, 65, 1, 40, "Input"],
Cell[25228, 790, 60, 1, 40, "Input"],
Cell[25291, 793, 56, 1, 40, "Input"],
Cell[25350, 796, 66, 1, 40, "Input"],
Cell[25419, 799, 59, 1, 40, "Input"],
Cell[25481, 802, 55, 1, 40, "Input"],
Cell[25539, 805, 240, 4, 56, "Input",
  InitializationCell->True],
Cell[25782, 811, 174, 4, 40, "Input",
  InitializationCell->True],
Cell[25959, 817, 38, 1, 40, "Input"],
Cell[26000, 820, 41, 1, 40, "Input"],
Cell[26044, 823, 53, 1, 40, "Input"],
Cell[26100, 826, 27, 0, 31, "Text"],
Cell[26130, 828, 49, 1, 40, "Input"],
Cell[26182, 831, 187, 4, 56, "Input"],
Cell[26372, 837, 92, 1, 40, "Input"],
Cell[26467, 840, 90, 1, 40, "Input"],
Cell[26560, 843, 105, 2, 40, "Input"],
Cell[26668, 847, 115, 2, 40, "Input"],
Cell[26786, 851, 119, 2, 40, "Input"],
Cell[26908, 855, 113, 2, 40, "Input"],
Cell[27024, 859, 122, 2, 40, "Input"],
Cell[27149, 863, 53, 1, 40, "Input"],
Cell[27205, 866, 66, 1, 40, "Input"],
Cell[27274, 869, 170, 4, 40, "Input"],
Cell[27447, 875, 150, 4, 40, "Input"],
Cell[27600, 881, 238, 5, 104, "Input"],
Cell[27841, 888, 59, 1, 40, "Input"],
Cell[27903, 891, 70, 1, 40, "Input"],
Cell[27976, 894, 177, 3, 88, "Input"],
Cell[28156, 899, 55, 1, 40, "Input"],
Cell[28214, 902, 76, 1, 40, "Input"],
Cell[28293, 905, 70, 1, 40, "Input"],
Cell[28366, 908, 396, 7, 104, "Input"],
Cell[28765, 917, 70, 1, 40, "Input"],
Cell[28838, 920, 192, 4, 56, "Input"],
Cell[29033, 926, 312, 6, 72, "Input"],
Cell[29348, 934, 226, 4, 56, "Input"],
Cell[29577, 940, 98, 3, 31, "Text"],
Cell[29678, 945, 36, 1, 40, "Input"],
Cell[29717, 948, 105, 2, 40, "Input"],
Cell[29825, 952, 51, 1, 40, "Input"],
Cell[29879, 955, 114, 2, 40, "Input"],
Cell[29996, 959, 353, 8, 120, "Input"],
Cell[30352, 969, 105, 2, 40, "Input"],
Cell[30460, 973, 103, 2, 40, "Input"],
Cell[30566, 977, 113, 2, 40, "Input"],
Cell[30682, 981, 48, 1, 40, "Input"],
Cell[30733, 984, 104, 2, 40, "Input"],
Cell[30840, 988, 107, 2, 40, "Input"],
Cell[30950, 992, 105, 2, 40, "Input"],
Cell[31058, 996, 48, 1, 40, "Input"],
Cell[31109, 999, 104, 2, 40, "Input"],
Cell[31216, 1003, 109, 2, 40, "Input"],
Cell[31328, 1007, 113, 2, 40, "Input"],
Cell[31444, 1011, 48, 1, 40, "Input"],
Cell[31495, 1014, 104, 2, 40, "Input"],
Cell[31602, 1018, 107, 2, 40, "Input"],
Cell[31712, 1022, 45, 1, 40, "Input"],
Cell[31760, 1025, 259, 5, 56, "Input"],
Cell[32022, 1032, 113, 2, 40, "Input"],
Cell[32138, 1036, 141, 2, 40, "Input"],
Cell[32282, 1040, 65, 1, 40, "Input"],
Cell[32350, 1043, 123, 2, 40, "Input"],
Cell[32476, 1047, 47, 1, 40, "Input"],
Cell[32526, 1050, 140, 3, 56, "Input"],
Cell[32669, 1055, 70, 1, 40, "Input"],
Cell[32742, 1058, 143, 3, 56, "Input"],
Cell[32888, 1063, 72, 1, 40, "Input"],
Cell[32963, 1066, 145, 3, 56, "Input"],
Cell[33111, 1071, 47, 1, 40, "Input"],
Cell[33161, 1074, 103, 3, 31, "Text"],
Cell[33267, 1079, 33, 0, 31, "Text"],
Cell[33303, 1081, 159, 4, 40, "Input"],
Cell[33465, 1087, 63, 1, 40, "Input"],
Cell[33531, 1090, 84, 1, 40, "Input"],
Cell[33618, 1093, 95, 3, 31, "Text"],
Cell[33716, 1098, 162, 3, 40, "Input"],
Cell[33881, 1103, 163, 3, 40, "Input"],
Cell[34047, 1108, 73, 0, 31, "Text"],
Cell[34123, 1110, 75, 0, 31, "Text"],
Cell[34201, 1112, 45, 1, 40, "Input"],
Cell[34249, 1115, 445, 8, 104, "Input"],
Cell[34697, 1125, 42, 0, 31, "Text"],
Cell[34742, 1127, 776, 15, 232, "Input"],
Cell[35521, 1144, 49, 1, 40, "Input"],
Cell[35573, 1147, 47, 1, 40, "Input"],
Cell[35623, 1150, 27, 0, 31, "Text"],
Cell[35653, 1152, 57, 1, 40, "Input"],
Cell[35713, 1155, 86, 1, 40, "Input"],
Cell[35802, 1158, 84, 1, 40, "Input"],
Cell[35889, 1161, 79, 1, 40, "Input"],
Cell[35971, 1164, 57, 1, 40, "Input"],
Cell[36031, 1167, 77, 1, 40, "Input"],
Cell[36111, 1170, 63, 0, 31, "Text"],
Cell[36177, 1172, 78, 1, 40, "Input"],
Cell[36258, 1175, 85, 1, 40, "Input"],
Cell[36346, 1178, 47, 1, 40, "Input"],
Cell[36396, 1181, 94, 3, 31, "Text"],
Cell[36493, 1186, 68, 2, 40, "Input"],
Cell[36564, 1190, 245, 4, 88, "Input"],
Cell[36812, 1196, 259, 6, 65, "Text"],
Cell[37074, 1204, 622, 12, 168, "Input"],
Cell[37699, 1218, 109, 2, 40, "Input"],
Cell[37811, 1222, 78, 1, 40, "Input"],
Cell[37892, 1225, 47, 1, 40, "Input"],
Cell[37942, 1228, 61, 0, 31, "Text"],
Cell[38006, 1230, 53, 1, 40, "Input"],
Cell[38062, 1233, 323, 8, 88, "Input"],
Cell[38388, 1243, 54, 1, 40, "Input"],
Cell[38445, 1246, 115, 2, 40, "Input"],
Cell[38563, 1250, 51, 0, 31, "Text"],
Cell[38617, 1252, 66, 2, 31, "Text"],
Cell[38686, 1256, 89, 1, 40, "Input"],
Cell[38778, 1259, 36, 1, 40, "Input"],
Cell[38817, 1262, 27, 0, 31, "Text"],
Cell[38847, 1264, 66, 1, 40, "Input"],
Cell[38916, 1267, 43, 1, 40, "Input"],
Cell[38962, 1270, 239, 4, 56, "Input",
  InitializationCell->True],
Cell[39204, 1276, 52, 1, 40, "Input"],
Cell[39259, 1279, 78, 1, 40, "Input"],
Cell[39340, 1282, 142, 4, 48, "Text"],
Cell[39485, 1288, 502, 8, 168, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[40024, 1301, 51, 0, 28, "Subsubsection"],
Cell[40078, 1303, 59, 1, 40, "Input"],
Cell[40140, 1306, 82, 1, 40, "Input"],
Cell[40225, 1309, 82, 1, 40, "Input"],
Cell[40310, 1312, 52, 1, 40, "Input"],
Cell[40365, 1315, 66, 1, 40, "Input"],
Cell[40434, 1318, 82, 1, 40, "Input"],
Cell[40519, 1321, 82, 1, 40, "Input"],
Cell[40604, 1324, 82, 1, 40, "Input"],
Cell[40689, 1327, 80, 1, 40, "Input"],
Cell[40772, 1330, 61, 1, 40, "Input"],
Cell[40836, 1333, 92, 1, 40, "Input"],
Cell[40931, 1336, 51, 1, 40, "Input"],
Cell[40985, 1339, 46, 1, 40, "Input"],
Cell[41034, 1342, 65, 1, 40, "Input"],
Cell[41102, 1345, 104, 2, 40, "Input"],
Cell[41209, 1349, 87, 1, 40, "Input"],
Cell[41299, 1352, 139, 2, 45, "Text"],
Cell[41441, 1356, 91, 1, 40, "Input"],
Cell[41535, 1359, 136, 2, 45, "Text"],
Cell[41674, 1363, 85, 1, 40, "Input"],
Cell[41762, 1366, 72, 1, 40, "Input"],
Cell[41837, 1369, 69, 1, 40, "Input"],
Cell[41909, 1372, 87, 1, 40, "Input"],
Cell[41999, 1375, 71, 1, 40, "Input"],
Cell[42073, 1378, 96, 3, 31, "Text"],
Cell[42172, 1383, 88, 1, 40, "Input"],
Cell[42263, 1386, 60, 1, 40, "Input"],
Cell[42326, 1389, 218, 3, 62, "Input"],
Cell[42547, 1394, 59, 1, 40, "Input"],
Cell[42609, 1397, 59, 1, 40, "Input"],
Cell[42671, 1400, 59, 1, 40, "Input"],
Cell[42733, 1403, 74, 1, 40, "Input"],
Cell[42810, 1406, 77, 1, 40, "Input"],
Cell[42890, 1409, 76, 1, 40, "Input"],
Cell[42969, 1412, 113, 2, 40, "Input"],
Cell[43085, 1416, 120, 2, 40, "Input"],
Cell[43208, 1420, 88, 1, 40, "Input"],
Cell[43299, 1423, 151, 2, 40, "Input"],
Cell[43453, 1427, 122, 2, 40, "Input"],
Cell[43578, 1431, 58, 0, 31, "Text"],
Cell[43639, 1433, 49, 1, 40, "Input"],
Cell[43691, 1436, 49, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[43777, 1442, 47, 0, 28, "Subsubsection"],
Cell[43827, 1444, 59, 1, 40, "Input"],
Cell[43889, 1447, 113, 2, 40, "Input"],
Cell[44005, 1451, 145, 3, 40, "Input"],
Cell[44153, 1456, 145, 3, 40, "Input"],
Cell[44301, 1461, 148, 4, 48, "Text"],
Cell[44452, 1467, 140, 3, 40, "Input"],
Cell[44595, 1472, 140, 3, 40, "Input"],
Cell[44738, 1477, 139, 3, 40, "Input"],
Cell[44880, 1482, 171, 3, 56, "Input"],
Cell[45054, 1487, 159, 3, 56, "Input"],
Cell[45216, 1492, 107, 2, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[45360, 1499, 51, 0, 28, "Subsubsection"],
Cell[45414, 1501, 43, 1, 40, "Input"],
Cell[45460, 1504, 43, 1, 40, "Input"],
Cell[45506, 1507, 101, 2, 52, "Input",
  CellTags->{"S1.4.1", "1.1"}],
Cell[45610, 1511, 99, 2, 52, "Input",
  CellTags->{"S1.4.1", "1.1"}],
Cell[45712, 1515, 60, 1, 40, "Input"],
Cell[45775, 1518, 84, 1, 40, "Input"],
Cell[45862, 1521, 50, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[45949, 1527, 60, 0, 28, "Subsubsection"],
Cell[46012, 1529, 723, 15, 235, "Text"],
Cell[46738, 1546, 32, 0, 31, "Text"],
Cell[46773, 1548, 43, 1, 40, "Input"],
Cell[46819, 1551, 43, 1, 40, "Input"],
Cell[46865, 1554, 167, 4, 48, "Text"],
Cell[47035, 1560, 70, 1, 40, "Input"],
Cell[47108, 1563, 68, 1, 40, "Input"],
Cell[47179, 1566, 60, 1, 40, "Input"],
Cell[47242, 1569, 127, 2, 40, "Input"],
Cell[47372, 1573, 73, 1, 40, "Input"],
Cell[47448, 1576, 57, 1, 40, "Input"],
Cell[47508, 1579, 91, 3, 31, "Text"],
Cell[47602, 1584, 294, 5, 65, "Text"],
Cell[47899, 1591, 34, 0, 31, "Text"],
Cell[47936, 1593, 176, 3, 72, "Input"],
Cell[48115, 1598, 91, 3, 31, "Text"],
Cell[48209, 1603, 38, 1, 40, "Input"],
Cell[48250, 1606, 66, 1, 40, "Input"],
Cell[48319, 1609, 61, 1, 40, "Input"],
Cell[48383, 1612, 57, 1, 40, "Input"],
Cell[48443, 1615, 67, 1, 40, "Input"],
Cell[48513, 1618, 61, 1, 40, "Input"],
Cell[48577, 1621, 58, 1, 40, "Input"],
Cell[48638, 1624, 54, 1, 40, "Input"],
Cell[48695, 1627, 57, 1, 40, "Input"],
Cell[48755, 1630, 55, 1, 40, "Input"],
Cell[48813, 1633, 56, 1, 40, "Input"],
Cell[48872, 1636, 51, 1, 40, "Input"],
Cell[48926, 1639, 58, 1, 40, "Input"],
Cell[48987, 1642, 374, 6, 72, "Input",
  InitializationCell->True],
Cell[49364, 1650, 306, 6, 56, "Input",
  InitializationCell->True],
Cell[49673, 1658, 268, 6, 56, "Input",
  InitializationCell->True],
Cell[49944, 1666, 38, 1, 40, "Input"],
Cell[49985, 1669, 41, 1, 40, "Input"],
Cell[50029, 1672, 54, 1, 40, "Input"],
Cell[50086, 1675, 27, 0, 31, "Text"],
Cell[50116, 1677, 51, 1, 40, "Input"],
Cell[50170, 1680, 191, 4, 56, "Input"],
Cell[50364, 1686, 107, 2, 40, "Input"],
Cell[50474, 1690, 105, 2, 40, "Input"],
Cell[50582, 1694, 109, 2, 40, "Input"],
Cell[50694, 1698, 119, 2, 40, "Input"],
Cell[50816, 1702, 123, 2, 40, "Input"],
Cell[50942, 1706, 119, 2, 40, "Input"],
Cell[51064, 1710, 115, 2, 40, "Input"],
Cell[51182, 1714, 111, 2, 40, "Input"],
Cell[51296, 1718, 119, 2, 40, "Input"],
Cell[51418, 1722, 118, 2, 40, "Input"],
Cell[51539, 1726, 84, 1, 40, "Input"],
Cell[51626, 1729, 66, 0, 31, "Text"],
Cell[51695, 1731, 54, 1, 40, "Input"],
Cell[51752, 1734, 68, 1, 40, "Input"],
Cell[51823, 1737, 224, 5, 56, "Input"],
Cell[52050, 1744, 1416, 24, 344, "Input"],
Cell[53469, 1770, 61, 1, 40, "Input"],
Cell[53533, 1773, 72, 1, 40, "Input"],
Cell[53608, 1776, 181, 3, 88, "Input"],
Cell[53792, 1781, 52, 0, 31, "Text"],
Cell[53847, 1783, 131, 2, 40, "Input"],
Cell[53981, 1787, 76, 1, 40, "Input"],
Cell[54060, 1790, 72, 1, 40, "Input"],
Cell[54135, 1793, 521, 9, 104, "Input"],
Cell[54659, 1804, 71, 1, 40, "Input"],
Cell[54733, 1807, 216, 4, 56, "Input"],
Cell[54952, 1813, 316, 6, 72, "Input"],
Cell[55271, 1821, 228, 4, 56, "Input"],
Cell[55502, 1827, 99, 3, 31, "Text"],
Cell[55604, 1832, 108, 2, 40, "Input"],
Cell[55715, 1836, 53, 1, 40, "Input"],
Cell[55771, 1839, 117, 2, 40, "Input"],
Cell[55891, 1843, 232, 5, 104, "Input"],
Cell[56126, 1850, 108, 2, 40, "Input"],
Cell[56237, 1854, 106, 2, 40, "Input"],
Cell[56346, 1858, 116, 2, 40, "Input"],
Cell[56465, 1862, 47, 1, 40, "Input"],
Cell[56515, 1865, 105, 2, 40, "Input"],
Cell[56623, 1869, 107, 2, 40, "Input"],
Cell[56733, 1873, 108, 2, 40, "Input"],
Cell[56844, 1877, 47, 1, 40, "Input"],
Cell[56894, 1880, 105, 2, 40, "Input"],
Cell[57002, 1884, 109, 2, 40, "Input"],
Cell[57114, 1888, 116, 2, 40, "Input"],
Cell[57233, 1892, 47, 1, 40, "Input"],
Cell[57283, 1895, 105, 2, 40, "Input"],
Cell[57391, 1899, 107, 2, 40, "Input"],
Cell[57501, 1903, 516, 11, 167, "Text"],
Cell[58020, 1916, 116, 2, 40, "Input"],
Cell[58139, 1920, 47, 1, 40, "Input"],
Cell[58189, 1923, 105, 2, 40, "Input"],
Cell[58297, 1927, 170, 3, 56, "Input"],
Cell[58470, 1932, 107, 2, 40, "Input"],
Cell[58580, 1936, 143, 3, 56, "Input"],
Cell[58726, 1941, 146, 3, 56, "Input"],
Cell[58875, 1946, 148, 3, 56, "Input"],
Cell[59026, 1951, 70, 1, 40, "Input"],
Cell[59099, 1954, 67, 1, 40, "Input"],
Cell[59169, 1957, 133, 3, 31, "Text"],
Cell[59305, 1962, 181, 3, 56, "Input"],
Cell[59489, 1967, 145, 3, 40, "Input"],
Cell[59637, 1972, 55, 1, 40, "Input"],
Cell[59695, 1975, 48, 1, 40, "Input"],
Cell[59746, 1978, 103, 3, 31, "Text"],
Cell[59852, 1983, 131, 4, 48, "Text"],
Cell[59986, 1989, 59, 1, 40, "Input"],
Cell[60048, 1992, 172, 4, 48, "Text"],
Cell[60223, 1998, 98, 3, 31, "Text"],
Cell[60324, 2003, 222, 5, 65, "Text"],
Cell[60549, 2010, 1369, 25, 296, "Input"],
Cell[61921, 2037, 68, 1, 40, "Input"],
Cell[61992, 2040, 50, 1, 40, "Input"],
Cell[62045, 2043, 48, 1, 40, "Input"],
Cell[62096, 2046, 368, 6, 82, "Text"],
Cell[62467, 2054, 59, 1, 40, "Input"],
Cell[62529, 2057, 52, 1, 40, "Input"],
Cell[62584, 2060, 64, 1, 40, "Input"],
Cell[62651, 2063, 50, 1, 40, "Input"],
Cell[62704, 2066, 150, 2, 40, "Input"],
Cell[62857, 2070, 82, 1, 40, "Input"],
Cell[62942, 2073, 311, 5, 65, "Text"],
Cell[63256, 2080, 154, 4, 48, "Text"],
Cell[63413, 2086, 1892, 35, 424, "Input"],
Cell[65308, 2123, 225, 4, 48, "Text"],
Cell[65536, 2129, 637, 11, 152, "Input"],
Cell[66176, 2142, 195, 4, 48, "Text"],
Cell[66374, 2148, 732, 13, 168, "Input"],
Cell[67109, 2163, 133, 4, 48, "Text"],
Cell[67245, 2169, 347, 6, 120, "Input"],
Cell[67595, 2177, 159, 3, 40, "Input"],
Cell[67757, 2182, 169, 4, 48, "Text"],
Cell[67929, 2188, 3456, 66, 744, "Input"],
Cell[71388, 2256, 526, 13, 150, "Text"],
Cell[71917, 2271, 209, 4, 48, "Text"],
Cell[72129, 2277, 58, 1, 40, "Input"],
Cell[72190, 2280, 439, 8, 104, "Input"],
Cell[72632, 2290, 291, 5, 65, "Text"],
Cell[72926, 2297, 103, 3, 31, "Text"],
Cell[73032, 2302, 70, 0, 31, "Text"],
Cell[73105, 2304, 177, 4, 48, "Text"],
Cell[73285, 2310, 3839, 68, 728, "Input"],
Cell[77127, 2380, 59, 1, 40, "Input"],
Cell[77189, 2383, 75, 1, 40, "Input"],
Cell[77267, 2386, 63, 0, 31, "Text"],
Cell[77333, 2388, 48, 1, 40, "Input"],
Cell[77384, 2391, 218, 5, 65, "Text"],
Cell[77605, 2398, 46, 1, 40, "Input"],
Cell[77654, 2401, 278, 5, 72, "Input"],
Cell[77935, 2408, 259, 6, 65, "Text"],
Cell[78197, 2416, 623, 10, 152, "Input"],
Cell[78823, 2428, 113, 2, 40, "Input"],
Cell[78939, 2432, 48, 1, 40, "Input"],
Cell[78990, 2435, 517, 12, 136, "Input"],
Cell[79510, 2449, 119, 3, 48, "Text"],
Cell[79632, 2454, 51, 1, 40, "Input"],
Cell[79686, 2457, 1151, 22, 248, "Input"],
Cell[80840, 2481, 110, 3, 48, "Text"],
Cell[80953, 2486, 64, 1, 40, "Input"],
Cell[81020, 2489, 477, 10, 136, "Input"],
Cell[81500, 2501, 89, 3, 31, "Text"],
Cell[81592, 2506, 133, 2, 40, "Input"],
Cell[81728, 2510, 79, 1, 40, "Input"],
Cell[81810, 2513, 88, 1, 40, "Input"],
Cell[81901, 2516, 37, 1, 40, "Input"],
Cell[81941, 2519, 27, 0, 31, "Text"],
Cell[81971, 2521, 66, 1, 40, "Input"],
Cell[82040, 2524, 43, 1, 40, "Input"],
Cell[82086, 2527, 373, 6, 72, "Input",
  InitializationCell->True],
Cell[82462, 2535, 79, 1, 40, "Input"],
Cell[82544, 2538, 94, 3, 31, "Text"],
Cell[82641, 2543, 156, 5, 82, "Text"],
Cell[82800, 2550, 356, 7, 104, "Input"],
Cell[83159, 2559, 774, 10, 184, "Input"],
Cell[83936, 2571, 80, 1, 40, "Input"],
Cell[84019, 2574, 86, 1, 40, "Input"],
Cell[84108, 2577, 88, 1, 40, "Input"],
Cell[84199, 2580, 85, 1, 40, "Input"],
Cell[84287, 2583, 169, 2, 56, "Input"],
Cell[84459, 2587, 369, 8, 99, "Text"],
Cell[84831, 2597, 61, 1, 40, "Input"],
Cell[84895, 2600, 361, 7, 104, "Input"],
Cell[85259, 2609, 188, 3, 72, "Input"],
Cell[85450, 2614, 59, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[85546, 2620, 39, 0, 28, "Subsubsection"],
Cell[85588, 2622, 42, 0, 31, "Text"],
Cell[85633, 2624, 62, 1, 40, "Input"],
Cell[85698, 2627, 1907, 33, 536, "Input"],
Cell[87608, 2662, 271, 4, 88, "Input"],
Cell[87882, 2668, 63, 1, 40, "Input"],
Cell[87948, 2671, 54, 1, 40, "Input"],
Cell[88005, 2674, 55, 1, 40, "Input"],
Cell[88063, 2677, 63, 1, 40, "Input"],
Cell[88129, 2680, 72, 1, 40, "Input"],
Cell[88204, 2683, 130, 2, 40, "Input"],
Cell[88337, 2687, 130, 2, 40, "Input"],
Cell[88470, 2691, 47, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[88554, 2697, 52, 0, 28, "Subsubsection"],
Cell[88609, 2699, 59, 1, 40, "Input"],
Cell[88671, 2702, 92, 3, 31, "Text"],
Cell[88766, 2707, 84, 1, 40, "Input"],
Cell[88853, 2710, 84, 1, 40, "Input"],
Cell[88940, 2713, 33, 0, 31, "Text"],
Cell[88976, 2715, 67, 1, 40, "Input"],
Cell[89046, 2718, 84, 1, 40, "Input"],
Cell[89133, 2721, 84, 1, 40, "Input"],
Cell[89220, 2724, 84, 1, 40, "Input"],
Cell[89307, 2727, 82, 1, 40, "Input"],
Cell[89392, 2730, 61, 1, 40, "Input"],
Cell[89456, 2733, 102, 2, 40, "Input"],
Cell[89561, 2737, 51, 1, 40, "Input"],
Cell[89615, 2740, 46, 1, 40, "Input"],
Cell[89664, 2743, 67, 1, 40, "Input"],
Cell[89734, 2746, 107, 2, 40, "Input"],
Cell[89844, 2750, 89, 1, 40, "Input"],
Cell[89936, 2753, 139, 2, 45, "Text"],
Cell[90078, 2757, 93, 1, 40, "Input"],
Cell[90174, 2760, 136, 2, 45, "Text"],
Cell[90313, 2764, 87, 1, 40, "Input"],
Cell[90403, 2767, 73, 1, 40, "Input"],
Cell[90479, 2770, 70, 1, 40, "Input"],
Cell[90552, 2773, 89, 1, 40, "Input"],
Cell[90644, 2776, 72, 1, 40, "Input"],
Cell[90719, 2779, 96, 3, 31, "Text"],
Cell[90818, 2784, 89, 1, 40, "Input"],
Cell[90910, 2787, 61, 1, 40, "Input"],
Cell[90974, 2790, 233, 4, 79, "Input"],
Cell[91210, 2796, 60, 1, 40, "Input"],
Cell[91273, 2799, 60, 1, 40, "Input"],
Cell[91336, 2802, 60, 1, 40, "Input"],
Cell[91399, 2805, 76, 1, 40, "Input"],
Cell[91478, 2808, 79, 1, 40, "Input"],
Cell[91560, 2811, 55, 0, 31, "Text"],
Cell[91618, 2813, 46, 1, 40, "Input"],
Cell[91667, 2816, 78, 1, 40, "Input"],
Cell[91748, 2819, 123, 2, 56, "Input"],
Cell[91874, 2823, 90, 1, 40, "Input"],
Cell[91967, 2826, 155, 2, 56, "Input"],
Cell[92125, 2830, 125, 2, 56, "Input"],
Cell[92253, 2834, 58, 0, 31, "Text"],
Cell[92314, 2836, 49, 1, 40, "Input"],
Cell[92366, 2839, 49, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[92452, 2845, 48, 0, 28, "Subsubsection"],
Cell[92503, 2847, 59, 1, 40, "Input"],
Cell[92565, 2850, 93, 3, 31, "Text"],
Cell[92661, 2855, 242, 5, 82, "Text"],
Cell[92906, 2862, 153, 4, 65, "Text"],

Cell[CellGroupData[{
Cell[93084, 2870, 136, 3, 43, "Input",
  Evaluatable->False],
Cell[93223, 2875, 1718, 31, 153, "Output"]
}, Closed]],
Cell[94956, 2909, 2027, 35, 153, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[97008, 2948, 123, 3, 27, "Input",
  Evaluatable->False],
Cell[97134, 2953, 928, 19, 167, "Output"]
}, Closed]],
Cell[98077, 2975, 1031, 23, 153, "Input",
  Evaluatable->False],
Cell[99111, 3000, 110, 2, 56, "Input"],
Cell[99224, 3004, 117, 2, 56, "Input"],
Cell[99344, 3008, 347, 8, 100, "Text"],
Cell[99694, 3018, 55, 1, 40, "Input"],
Cell[99752, 3021, 46, 1, 40, "Input"],
Cell[99801, 3024, 52, 1, 40, "Input"],
Cell[99856, 3027, 52, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[99933, 3031, 165, 4, 43, "Input",
  Evaluatable->False],
Cell[100101, 3037, 1697, 31, 153, "Output"]
}, Closed]],
Cell[101813, 3071, 2006, 35, 153, "Input",
  Evaluatable->False],
Cell[103822, 3108, 39, 0, 31, "Text"],
Cell[103864, 3110, 140, 3, 56, "Input"],
Cell[104007, 3115, 259, 6, 67, "Text"],
Cell[104269, 3123, 164, 4, 56, "Input"],
Cell[104436, 3129, 798, 14, 252, "Text"],
Cell[105237, 3145, 1031, 23, 153, "Input",
  Evaluatable->False],
Cell[106271, 3170, 113, 2, 56, "Input"],
Cell[106387, 3174, 114, 2, 56, "Input"],
Cell[106504, 3178, 124, 3, 48, "Text"],
Cell[106631, 3183, 146, 3, 56, "Input"],
Cell[106780, 3188, 148, 4, 65, "Text"],
Cell[106931, 3194, 143, 3, 56, "Input"],
Cell[107077, 3199, 63, 0, 31, "Text"],
Cell[107143, 3201, 140, 3, 56, "Input"],
Cell[107286, 3206, 143, 3, 56, "Input"],
Cell[107432, 3211, 140, 3, 56, "Input"],
Cell[107575, 3216, 172, 3, 72, "Input"],
Cell[107750, 3221, 160, 3, 72, "Input"],
Cell[107913, 3226, 107, 2, 56, "Input"]
}, Closed]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

