(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    361861,      11234]*)
(*NotebookOutlinePosition[    363500,      11289]*)
(*  CellTagsIndexPosition[    363425,      11283]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
NOTE: to edit and evaluate after full run evaluate BEGIN PACKAGE \
and END PACKAGE when done.  alternatively, remove these before evaluating \
full run.  (they keep Global` cleaner and safer).  the blue areas are of \
interest when editing, look for blue\
\>", "Text"],

Cell[CellGroupData[{

Cell["Discussion and Forward", "Subsubsection"],

Cell["\<\
The (see HELP SECTION).  It has a layout of functions and their \
general use.\
\>", "Text",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell["\<\
Look for Cyan shaded cells they are there to point out areas of \
interest if changing or re-making charts.\
\>", "Text",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell["There are further discussions in some sub-sections.", "Text",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell["Forward", "Text"],

Cell["\<\
The most important thing about the chart is it's Layout.  It can be \
printed small and still be very readable.  (also it can pull data, format it, \
and place it in the chart and change chart layout).  Most periodic charts \
(online) are not well enough layed out to be shrunk or enlarged much and \
still have \"realistic layout\".   For instance: a poorly made chart if \
enlarge greatly would take up far more paper than necessary and have \
dis-proportionately wide spaces when enlarged , but if printed small (ie in \
book) have areas impossible to read.  It's more than a matter of scalable \
font its their relativity to one another (which a book needs certainly - but \
also an image with will be zoomed in and out).\
\>", "Text"],

Cell["\<\
There are many things that are made that aren't in final chart, \
such as dictionary text.\
\>", "Text"],

Cell["\<\
The over-all method takes some efforts that are un-necessary which \
wasn't of course known until later.
\tie, showfe[] was made to made to make 3D models of fill order of electons
\t     easy to dipict in 3D ball and stick models: but they are never made
\tie, {s,p,d,f} is used to build arrays but are then corrected.  had I known \
that there
\t      are no equations on earth able to describe the table easily - i'd \
likely have
\t      just entered the whole table by hand (a full simulation was never a \
goal
\t      hoped for with little notebook anyway)\
\>", "Text"],

Cell["\<\
2D and 3D were done incase I got painted into a corner with one or \
the other: turns out both worked fine.\
\>", "Text"],

Cell["\<\
Layout is by specific placement (ie, item offset from center of \
element).  This is a pain in one way and complete freedom in another (ie, one \
is never frustrated by surprise alignments or dis-allowed placement or \
connectivity unwanted or which grid text box restrictions: nor with the \
programming and typing for that).  I'm neither happy with a position matrix \
or without it.  Simply using positions works.\
\>", "Text"],

Cell["\<\
Text is not in 3D fully.  If the whole chart object (or view \
angle?) is rotated the text will face the camera (this is the mathematica \
default and is not yet avoided).\
\>", "Text"],

Cell["\<\
Dictionary entries (not in chart) are a re-format of Jay Kominek's \
<jkominek@miranda.org> compilation of physical and chemical data about the \
element (Debian package dict-elements)\
\>", "Text"],

Cell[TextData[{
  "chem.m is ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 4.0's chem.m with added data and added ability to print data's errata"
}], "Text"],

Cell[TextData[{
  "In hindsight, 2D formatting and output given table data here would be \
easier and far more efficent using gs(1) or pic(1) language.  But if done no \
further manipulation in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " would be efficient, except as ps graphic."
}], "Text"],

Cell[TextData[{
  "If you are young or a student.  This notebook was made during forced \
downtime.  ",
  StyleBox["Otherwise it I wouldn't have had the time to do a thing like \
this.",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  "  The lack of \"saleability\" is quite intended (I had legal problems \
don't ask).  This was intended not to be a hot items for particular others \
steal.  But please enjoy if you like these kinds of things :)  I'd rather not \
have release all of jutils` maybe, yet I need work posted and selling work is \
about impossible these days anyhow (a problem for all engineers and coders), \
so oh well.  Note i'm not only not paid and given no charity but illegally \
billed during the production, unlike many other software productions: a big \
difference.  I don't want to promote the idea work like this un-paid is a \
good idea.  It was not that way and not done so."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
errata and or notebook re-eval things
\tTODO - DICT and chem.m  unstable isotope disagree terribly !\
\>", \
"Subsubsection"],

Cell[TextData[{
  "FIXME or not:  launch ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " from this directory or activate this so that charts are printed to here \
(or both...)"
}], "Text"],

Cell[BoxData[
    \(\(\(\ \)\(SetDirectory["\<~/PeriodicTableOfElements\>"]\)\)\)], "Input"],

Cell["\<\
FIXME or not:  prefer
\t\"Kernel -> Delete All Output\" then
\t\"Kernel -> Evaluate Notebook\" for a fresh start\
\>", "Text"],

Cell[TextData[{
  "FIXME:\n\tgraphics area has memory climb for \"re-evaluating\" (like % %% \
stored)\n\tif software is not %100 you'll get a desktop freeze\n\t\t",
  Cell[BoxData[
      \(MemoryInUse[]\)], "Input"],
  "\n\t\t",
  Cell[BoxData[
      \(9797504\)], "Output"],
  "\n\t\t",
  Cell[BoxData[
      \(\(\(100901372\)\(\ \)\)\)], "Input"]
}], "Text"],

Cell[BoxData[
    \(\(Unprotect[In, Out];\)\)], "Input"],

Cell[BoxData[
    \(\(Clear[In, Out];\)\)], "Input"],

Cell[BoxData[
    \(\(Protect[In, Out];\)\)], "Input"],

Cell[BoxData[
    \(\($HistoryLength = 5;\)\)], "Input"],

Cell[BoxData[
    \(MemoryInUse[]\)], "Input"],

Cell[TextData[{
  "(*\n NOTE:\n\tbe careful with Remove[] only use it if var will redefined \
immediately after\n\tor \"is certain to be reset before any use and isn't \
used anywhere else above\"\n\tex.  if a function has var name in it and \
that's Removed the function\n\t       becomes unusable until the fuction is \
re-defined\n\t       ( ! if evaluating  notebook it won't be ! )\n\nFIXME:  \
do NOT remove or assign m2 function.  might cause mathematica to quit if one \
clobbers it , reloads chem.m again , and keeps trying to \"find it\".  \
(below, mess={} , get Element value , m2 == message : again never assign to \
m2 though.)\n\nATOMIC DATA BUGS:\n\t* ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s AtomicRadius doesn't say which CRC chart it's from which\n\t   is very \
important.  Not presentable without that.  CRC 52nd istoo incomplete.\n\t   \
Gets into crystalline structure and quickly varies widely yet sometimes\n\t   \
deceivingly close but not close enough depending on question.\n\t   Use \
Angstrom , volume , density , weight is just as well without key.\n\t   \tie, \
Ar Francium is -2.7  ... negative radius ? from what expected ?\n\t* \
ElectronAffinity doesn't show <0 or >0 and these don't follow trends.\n\t   \
however EA is sporadic and somewhat incomplete and unless chart is\n\t   \
electro centric FIP and EN are more common choices.\n\nTODO  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " says this has no stable isotope but dict says ...\n\n\
ElementDescription[Technetium] ^= \"Radioactive metallic transition element. \
Can\nbe detected in some stars and the fission products of uranium. First \
made by Per\nrier and Segre by bombarding molybdenum with deutrons, giving \
them Tc-97. Tc-99\nis the most stable isotope with a half-life of 2.6*10^6 \
years. Sixteen isotopes\nare known. Organic technetium compounds are used in \
bone imaging. Chemical prope\nrties are intermediate between rhenium and \
manganese. \"\n\n*)"
}], "Text"],

Cell["RunToBoundryCell", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["HELP SECTION for tables, funs, vars (up to chart gen sec)", "Subsection"],

Cell[CellGroupData[{

Cell["setup mess, efun, ...", "Subsubsection"],

Cell[BoxData[GridBox[{
        {"mess", \(allows\ messages\ to\ be\ captured\ as\ text\)},
        {"efuns", \(list\ of\ functions, \ ie, \ SpecificHeat\)},
        {"efunsab", \(abbreviations\ of\ efuns\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["charts / tables", "Subsubsection"],

Cell[BoxData[GridBox[{
        {\(elec\ \(\(conf\)\(.\)\)\), \(2\ very\ simple\ Tables\)},
        {"VerboseElement", \(uses\ efuns[i]\ for\ verbosity\)},
        {"Dict", \(tab : \ elem . \ dict\ entries\)},
        {"Key", \(tab : \ efun\ abbreviations\ /\ names\)},
        {"FullElement", \(tab : \ \(\(elem\ data\)\(\ \)\(+\)\(\ \)\)\)},
        {"ElementData", \(tab : \ just\ elem . \ data\)},
        {"ColumnChart", \(tab : \ abbrev\  + \ data\[IndentingNewLine]
          \((typical\ periodic\ cell)\)\n
          with\ use\ of\ fNBookForm2\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["data - static / manual arrays", "Subsubsection"],

Cell["\<\
e[] returns a List of 1's showing electron place in shell, \
subshell, orbit and pairing *\
\>", "Text"],

Cell["\<\
It's important to note that there is important difference between \
\"natural order\" and \"fill order\" **\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"data", \(see : \ data - static/manual\ arrays\n
          that\ section\ \((better\ viewed)\)\[IndentingNewLine]
          associated\ data\ describing\ fe[]\ and\ e[]\)},
        {\(e[]\), \(returns\ full\ array\ \((An\ 110)\)\ of\ \
\[IndentingNewLine]
          
          elec . \ conf . \ , \ \ 1' 
            s\ format\ , \[IndentingNewLine]by\ increasing\ value\ order\
\[IndentingNewLine]
          \((\(\(...\)\(\ \)\(3\)  \(p\)\(\ \)\(4\)  \(s\)\(\ \)\(4\)  \
\(p\)\)\  ... )\)\)},
        {\(fe[]\), \(fill\ order\ elec . \ 
              conf . \[IndentingNewLine]format\ is\ order\ being\ filled\
\[IndentingNewLine]
          
          each\ 1\ represents\ 1\ elec . \[IndentingNewLine]use\ f\ funs\ or\ \
data\ with\ fe[]\)},
        {\(nord, \ fcord\), \(MISNOMER : \ ord\ should\ be\ subshell\n
          \t\((18\ subshells\ for\ elem\ 112)\)\n
          \tnsubshell, \ fnsubshell\n
          \tcsubshell, \ fcsubshell\n
          various\ data\ associated\ with\n
          using\ or\ making\ e[], \ ie, \ {s, p, d, f}\n
          n\ \((numberic)\)\ c \((by\ character)\)\)},
        {\(ge[]\ gfe[]\), \(unused\ /\ unsupported\)},
        {"gxord", \(grouped\ 1' s\  - \ not\ used\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}],

Cell["\<\
* 1's lists are first more lengthy to make but easier to print or \
show (see elecfmt[e_]).  Note there's no quick easy way to calculate the \
info: see note \"investigating  \[Rho]subshells\" last in this section.\
\>", \
"Text"],

Cell[TextData[{
  "**\tseen on periodic:  4 ",
  Cell[BoxData[
      \(TraditionalForm\`f\^14\)]],
  " 5 ",
  Cell[BoxData[
      \(TraditionalForm\`d\^10\)]],
  " 6 ",
  Cell[BoxData[
      \(TraditionalForm\`s\^2\)]],
  " \n\tfills in this order: 6 ",
  Cell[BoxData[
      \(TraditionalForm\`s\^2\)]],
  "  ",
  Cell[BoxData[
      \(TraditionalForm\`f\^14\)]],
  " 5 ",
  Cell[BoxData[
      \(TraditionalForm\`d\^10\)]],
  "\nWhile outer-most electrons are ",
  StyleBox["most",
    FontSlant->"Italic"],
  " important",
  " ",
  "to bonding (6s2) , the \"quantum character\" of bonds (ie, why we see ",
  Cell[BoxData[
      \(TraditionalForm\`H\_2\)]],
  "but never ",
  Cell[BoxData[
      \(TraditionalForm\`He\_2\)]],
  " and also the columns of a periodic chart show ",
  StyleBox["fill order",
    FontSlant->"Italic"],
  ".  A good chart show depict both outer-most and fill-order electron \
configuration succinctly, for quick reference."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["funs - variety of utility funs", "Subsubsection"],

Cell["\<\
note : some may not work after \"irregularities\" are \"fixed\" \
(see irr. below)\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"ecnt", \(total\ electrons\ seen\ in\[IndentingNewLine]
          all\ subshells\ 1 - n\ \ so\ far\[IndentingNewLine]
          ie, \ \(2\ 4\ 10\  ... \)\ 112\)},
        {\(height[e]\), \(for\ some\ e_\)},
        {\(width[e]\), "ditto"},
        {\(subheight[e]\), \(2  nd\ dim\ heights\)},
        {\(subwidth[e]\), "ditto"},
        {\(shells[an | An]\), \(outermost\ shell\ for\ elem\)},
        {"shellsarr", \(array\ of\ shells\ for\ all\ elem\)},
        {\(inord[e_, 
            n_]\), \(counts\ of\ e\ in\ a\ shell\ should\ be\ \
\[IndentingNewLine]
          for\ any\ obj\ only\ \((for\ ford\ only)\)\)},
        {\(finord[fe_, n_]\), "ditto"},
        {\(ordnum[n_]\), \(position\ in\ fcord\ or\ fcord\[IndentingNewLine]
          being\ filled\ ; \ which\ is\[IndentingNewLine]
          the\ nth\ s, p, d\ or\ f\)},
        {\(fordnum[n_]\), "ditto"},
        {\(ford2ord[e_]\), \(covert\ ford \[Rule] ord\[IndentingNewLine]
          fe[]\  \[Rule] \ e[]\)},
        {\(ord2ford[e_]\), "ditto"}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["create elements elec. tables 1's format", "Subsubsection"],

Cell["\<\
creates each element's electron array by starting full (last \
element) and removing electrons one at a time.  why is: it works reguarless \
of structure / grouping style.\
\>", "Text"],

Cell["\<\
note : only need to make these 1x  (can store and load table after \
making 1x).  note: see correction below.\
\>", "Text"],

Cell[BoxData[GridBox[{
        {\(laste[e_]\), \(position\ of\ last\ 1\ in\ any\ \((f)\) e[]\)},
        {\(takee[e_]\), \(take\ off\ last\ 1\)},
        {\(takee[e_, n_]\), \(take\ off\ last\ n\ 1' s\)},
        {"elements", \(all\ chem\ elem, \ 
          1' s\ format, \[IndentingNewLine]irregulars\ not\ yet\ \
corrected\)},
        {"felements", "ditto"}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}],

Cell["\<\
  these would maybe be better created manually ... but oh well , \
done now.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["correct the \"irregularities\"", "Subsubsection"],

Cell["\<\
will take e here, add e there.  the general fill rule needs several \
corrections applied (quantum physics provides corrections important to use in \
chemistry).  works only for fe[] but does get applied to elements \
automatically.\
\>", "Text"],

Cell["\<\
note : only need to make these 1x but it's setup to work on demand \
too\
\>", "Text"],

Cell[BoxData[GridBox[{
        {\(rnullpat[e_]\), \(helper\ for\ correct\)},
        {\(correct[e_]\), \(removes\ a\ style\ of\ irregularity\n
          \((take\ 1\ e\ from\ last\ add\ to\ next)\)\)},
        {\(correct2[e_]\), \(see\ table\ in\ code\ \(\(descr\)\(.\)\)\)},
        {\(rcorrect[e_]\), "\[Placeholder]"},
        {\(rcorrect2[e_]\), "\[Placeholder]"},
        {\(correctlistb[An_, f]\), \(given\ Atomic\ Number\[IndentingNewLine]
          applies\ fix\ to\ \ both\[IndentingNewLine]
          elements\ and\ felements\)},
        {\(--\(--\(---\)\)\), \(--\(--\(---\)\)\)},
        {\(correctlist[
            An_\ list]\), \(these\ apply\ changes\[IndentingNewLine]
          
          to\ a\ list\ of\ names, \[IndentingNewLine]assinging\ results\ back\
\[IndentingNewLine]
          in\ elements\ and\ felements\)},
        {"correctlist2", "rcorrectlist"},
        {"rcorrectlist2", "correctlist2x"},
        {"correctlist2x2", "correctlist"},
        {\(--\(--\(---\)\)\), \(--\(--\(----\)\)\)},
        {"correct2x2", \(special\ use\ to\ correct\[IndentingNewLine]
          a\ single\ elem . \ e_\)},
        {"correct2x", "\[Placeholder]"},
        {"correctarr", \(Atomic\ Symbol\ data\[IndentingNewLine]
          for\ correction\)},
        {\(correction[An_]\), \(show\ which\ correct\ fun\[IndentingNewLine]
          to\ apply\)},
        {\(correction[e_, 
            An_]\), \(given\ elem\ and\ atomic\ num\[IndentingNewLine]
          return\ the\ same\ corrected\[IndentingNewLine]
          \((uses\ table\ to\ apply\ right\ fix)\)\)},
        {\(--\(--\(--\(----\)\)\)\), \(--\(--\(--\(--\(----\)\)\)\)\)},
        {\(debug\ left - \(\(overs\)\(:\)\)\), "\[Placeholder]"},
        {\(showfe[An_]\), \(pretty\ print\[IndentingNewLine]
          felements\ given\ atomic\ symbol\)},
        {\(showfe[e_]\), \(pretty\ print\[IndentingNewLine]
          fe_\ \((drop\ f\ for\ e)\)\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["elecfmtv - printing electron conf. from arrays", "Subsubsection"],

Cell[TextData[{
  "like ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s ElectronConfiguration(Format) but output is simpler for use with \
printing (to pick out last two, typical use in charts, simplicity is \
preffered)"
}], "Text"],

Cell[BoxData[GridBox[{
        {\(elecfmtv[
            Symbol | 
              list]\), \(product\ simple\ text\ array\[IndentingNewLine]
          {shell\ , \ subhell, \ count\ in}\n
          {{1, s, 2},  ... }\n
          per\ shell\)},
        {\(elecfmt[e_]\), \(product\ simple\ text\ strings\n
          {1*s^2, \ 2*s^2,  ... }\n
          per\ shell\)},
        {\(elecfmtm[e_]\), \(product\ array\ of\ strings\n
          the\ 2  D\ text\ boxing\ is\ Mathematica\n
          specific\ and\ works\ in\ plots\)},
        {\(elecfmtpm[e_]\), \(ditto\ but\ one\ long\ string\)},
        {\(elecfmtb[e_]\), \(produces\ text\ for\ normal\ 2  D\ boxing\n
          elecfmtb[Aluminum] // DisplayForm\n
          apply\ DisplayForm\ so\ front - end\n
          knows\ to\ render\ it\ as\ 2  D\ text\)},
        {\(elecfmtpb[e_]\), \(ditto\ but\ one\ long\ string\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["funs - Chart generation", "Subsubsection"],

Cell["See notes in that section - this is not complete...", "Text"],

Cell["\<\
Finally !  create a Spark like period chart from the above.  These \
charts contain allot of data packed visually for quick reference.\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"per", \(base\ table\ , \ \(\(abbrev\)\(.\)\)\ , \
\[IndentingNewLine]each\ row\ is\ a\ shell\)},
        {"ch2", \(base\ of\ chart, \ per\ in\ bocked\ format\)},
        {"ch2b", \(is\ an\ nxm\ array\ of\ element\ text\ that\ has\n
          
          positional\ nxm\ format\ of\ typical\ table\ of\ elem . \n
              but\ lanthenide\ series\ left\ in\ place\ for\ work\)},
        {"trials", \(ignore\ this\  - \ graphics\ tests\)},
        {"setup", \(makes\ ch2b\)},
        {\(Chart\ Generation\), \(\(see\ code\  ... \)\ this\ is\ not\ \
complete ... \)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}],

Cell["\<\
La / Ac series not yet removed - these should be abled to be \
snapped out later after more info is added.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
scratch -  investigating  \[Rho]subshells  ,  n s < (n-2) f < (n-1) \
d < n p\
\>", "Subsubsection"],

Cell[TextData[{
  "Shows the obvious, that weights for s,p,d,f can be used in equation, and \
what weights.  However it isn't used - the sequence is easier entered \
manually.\n\nNote the generic fill rule is a simple and BROKEN one : several \
corrections need be applied !  In general to pre-calculate orbits correctly \
is a large part of quantum physics (not even a complicated equation places \
all orbits correctly , unless tweeked to do so) and to calculate overlaps or \
sharing between such electron fields is about the rest of it !\n\nFinal note: \
see unfinished xxx[e_] which is a (broken) elecfmtv1[e_] to see why using ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s plain ElectronConfig (which is incomplete natural order array) to print \
fill ordering is allot more a pain than one would guess."
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["need packages", "Subsection"],

Cell[BoxData[
    \(\(Needs["\<Miscellaneous`Units`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Miscellaneous`ChemicalElements`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Miscellaneous`PhysicalConstants`\>"];\)\)], "Input"],

Cell["Needs[\"Miscellaneous`ResonanceAbsorptionLines`\"];", "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Graphics`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Legend`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Graphics3D`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Shapes`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`MultipleListPlot`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Geometry`Rotations`\>"];\)\)], "Input"],

Cell["Needs[\"Geometry`Polytopes`\"];", "Input"],

Cell["Needs[\"Graphics`Arrow`\"];", "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Polyhedra`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Spline`\>"];\)\)], "Input"],

Cell["local needs", "Text"],

Cell[BoxData[
    \(\(Needs["\<jutils`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<fNBookForm2`\>"];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["BEGIN PACKAGE", "Section",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
NOTE: to edit either evaluate these two (end END PACKAGE far below) \
or remove these sections and run as notebook ...\
\>", "Text"],

Cell["\<\
use of package here is for keeping Global` cleaner.  you can remove \
Begins and Ends and eval. notebook if you don't care about this. (not for \
making a .m per say)\
\>", "Text"],

Cell[BoxData[
    \(\(BeginPackage["\<PeriodicTableOfElements`\>", {"\<Miscellaneous`Units`\
\>", "\<Miscellaneous`ChemicalElements`\>", \
"\<Miscellaneous`ResonanceAbsorptionLines`\>", "\<Graphics`Graphics`\>", \
"\<Graphics`Legend`\>", "\<Graphics`Graphics3D`\>", "\<Graphics`Shapes`\>", "\
\<Graphics`MultipleListPlot`\>", "\<Geometry`Rotations`\>", \
"\<Geometry`Polytopes`\>", "\<Graphics`Arrow`\>", "\<Graphics`Polyhedra`\>", \
"\<Graphics`Spline`\>", "\<jutils`\>", "\<fNBookForm2`\>"}];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Begin["\<`Private`\>"];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["helper funs for tables / charts with chem data", "Section"],

Cell[CellGroupData[{

Cell["Basic Setup", "Subsection"],

Cell[CellGroupData[{

Cell["to fundamental test", "Subsubsection"],

Cell[BoxData[
    \(ToFund[x_] := 
      x //. Miscellaneous`Units`Private`$ToFundamental\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToFund[Newton]\)], "Input"],

Cell[BoxData[
    \(\(Kilogram\ Meter\)\/Second\^2\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell["note to check , ie implications of $ToIntermediate", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["making messages work , mess", "Subsubsection"],

Cell[BoxData[
    \(Remove[ff, m, p1, p2, p3, mess, mm, fff]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(m = "\<Melting point is for the `2` form of `1`.\>";\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ff[m_, p1_: "\<\>", p2_: "\<\>", p3_: "\<\>"] := 
      StringReplacePart[m, {p1, p2, p3}, 
        StringPosition[m, {"\<`1`\>", "\<`2`\>", "\<`3`\>"}]]\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(ff["\<Melting point is for the `2` form of `1` dang `3`.\>", \
"\<wack\>", "\<wackonium\>", "\<wack3\>"]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \("Melting point is for the wack form of wackonium dang wack3."\)], \
"Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ff["\<Melting point is for the `2` form of `1` dang `3`.\>", \
"\<wack\>", "\<wackonium\>"]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \("Melting point is for the wack form of wackonium dang ."\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Miscellaneous`ChemicalElements`Private`M2\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \("Miscellaneous`ChemicalElements`Private`M2"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell[BoxData[
    \(<< "\<~/PeriodicTableOfElements/chem.m\>"\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(mess = {};\)\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(Density[Hydrogen]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(76.`\ Kilogram\)\/Meter\^3\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Miscellaneous`ChemicalElements`Private`mess\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \({"Density is for Hydrogen at 11 Kelvin."}\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell[BoxData[
    \(Remove[ff, m, p1, p2, p3, mess, mm, fff]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["INITIAL  CHEM.M  SETUP  (mess, efun, powers, ...)", "Subsubsection"],

Cell["\<\
mess={};

M2[m_, p1_:\"\"] := AppendTo[mess,StringReplacePart[m, {ToString[p1]}, \
StringPosit
ion[m, {\"`1`\"}]]]

M2[m_, p1_:\"\", p2_:\"\"] := AppendTo[mess,StringReplacePart[m, \
{ToString[p1], ToSt
ring[p2]}, StringPosition[m, {\"`1`\", \"`2`\"}]]]

M2[m_, p1_:\"\", p2_:\"\", p3_:\"\"] := AppendTo[mess,StringReplacePart[m, \
{ToString[p
1], ToString[p2], ToString[p3]}, StringPosition[m, {\"`1`\", \"`2`\", \
\"`3`\"}]]]\
\>", "Text"],

Cell["don't forget ", "Text"],

Cell[BoxData[
    \(<< "\<~/PeriodicTableOfElements/chem.m\>"\)], "Input"],

Cell[BoxData[
    \(\(\( (*\ 
      don' t\ forget\ to\ reset\ to\ {}\ between\ uses\ *) \)\(\
\[IndentingNewLine]\)\(mess = 
        Miscellaneous`ChemicalElements`Private`mess;\)\)\)], "Input"],

Cell[BoxData[{
    \( (*\ Elements >> 
        elem . mx\ and\ see\ elem . 
            sh\ *) \[IndentingNewLine]\(<< \ \
"\<~/PeriodicTableOfElements/elem-dsc.mx\>";\)\), "\[IndentingNewLine]", 
    \(\(SetAttributes[ElementDescription, Listable];\)\)}], "Input"],

Cell[BoxData[
    \(\(Miscellaneous`ChemicalElements`Private`mess = {};\)\)], "Input"],

Cell[BoxData[
    \(\(m2 := Miscellaneous`ChemicalElements`Private`mess;\)\)], "Input"],

Cell[BoxData[
    \(\(efuns = {Abbreviation, AtomicNumber, AtomicWeight, StableIsotopes, 
          MeltingPoint, BoilingPoint, HeatOfFusion, HeatOfVaporization, 
          Density, ThermalConductivity, IonizationPotential, SpecificHeat, 
          SolarSystemAbundance, EarthCrustAbundance, EarthOceanAbundance, 
          OxidationStates, ElectronNegativity, ElectronAffinity, 
          AtomicRadius, ElectronConfiguration, 
          ElectronConfigurationFormat};\)\)], "Input"],

Cell[BoxData[
    \(\(efunsab = {"\<Ab\>", "\<AN\>", \*"\"\<\!\(m\_A\)\>\"", "\<SI\>", \
\*"\"\<\!\(T\_M\)\>\"", \*"\"\<\!\(T\_B\)\>\"", \*"\"\<\!\(L\_f\)\>\"", \*"\"\
\<\!\(L\_v\)\>\""\ , "\<\[Rho]\>", "\<Q\[Sigma]\>", "\<FIP\>", \
\*"\"\<\!\(Q\_c\)\>\"", "\<SsA\>", "\<EcA\>", "\<EoA\>", "\<OS\>", "\<EN\>", \
"\<EA\>", "\<AR\>", "\<EC\>", "\<ECF\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(efunsab = {"\<Ab \>", "\<AN \>", "\<AW \>", "\<SI \>", "\<Tm \>", \
"\<Tb \>", "\<Lf \>", "\<Lv \>"\ , "\<p  \>", "\<Qs \>", "\<FIP\>", "\<Qc \
\>", "\<SsA\>", "\<EcA\>", "\<EoA\>", "\<OS \>", "\<EN \>", "\<EA \>", "\<AR \
\>", "\<EC \>", "\<ECF\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(ELEMENTS = Length[Elements];\)\)], "Input"],

Cell[TextData[{
  "* note font aligning is highly comples so all abbrev get \"same shape\" \
and no subscripts - this also allows much more compact chart.  Also while ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " can do \[Rho] ghostview won't unless \"extra efforts\" are made, so \"p\" \
is used"
}], "Text"],

Cell["\<\
* note chart borrows abbrev eC eCF to mean \"shell order\" and \
\"fill order\"\
\>", "Text"],

Cell[BoxData[
    \(\(efunsunits = {1, 1, \(Gram\/Mole\) \((Gram\/Mole)\)\^\(-1\), 1, 
          Kelvin, Kelvin, \(Joule\ Kilo\)\/Mole, \(Joule\ Kilo\)\/Mole, \(\(\ \
\)\(Kilogram\)\)\/Meter\^3, Watt\/\(Kelvin\ Meter\), 
          ElectronVolt, \(Joule\ Kelvin\)\/Gram, Percent/Percent, 
          Percent/Percent, Percent/Percent, 1, ElectronVolt, 
          Kilo\ Joule/Mole, Angstrom};\)\)], "Input"],

Cell[BoxData[
    \(\(efunsunitsb = {"\<\>", "\<\>", Gram\/Mole, "\<\>", Kelvin, 
          Kelvin, \(Joule\ Kilo\)\/Mole, \(Joule\ Kilo\)\/Mole, \(\(\ \
\)\(Kilogram\)\)\/Meter\^3, Watt\/\(Kelvin\ Meter\), 
          ElectronVolt, \(Joule\ Kelvin\)\/Gram, Percent, Percent, 
          Percent, "\<\>", ElectronVolt, Kilo\ Joule/Mole, 
          Angstrom, "\<\>", "\<\>", "\<\>", "\<\>", "\<\>", "\<\>", "\<\>", "\
\<\>"};\)\)], "Input"],

Cell["\<\
(* chicken or egg if you have An ok , Element ok , but Abbrev you \
gotta lookup. *)\
\>", "Text"],

Cell["(* stick with using Elements or An in code where possible *)", "Text"],

Cell["\<\
(* NOTE:  Elements[[n]] -> AtomicNumber to Name --> either *)\
\>", \
"Text"],

Cell[BoxData[
    \(ElementFromAbbreviation[s_] := 
      Module[{p, p2}, \[IndentingNewLine]p = 
          Position[ElementAbbreviations, ToString[s]]; \[IndentingNewLine]If[
          p =!= {}, Elements[\([p[\([1, 1]\)]]\)]\[IndentingNewLine], 
          Null]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(Map[ElementFromAbbreviation, {Cu, xxx}]\)], "Input"],

Cell[BoxData[
    \(\(ElementsString = 
        Table[ToString[Elements[\([i]\)]], {i, 
            Length[Elements]}];\)\)], "Input"],

Cell[BoxData[
    \(ElementFromEither[s_] := 
      Module[{p, p2, str}, 
        str = ToString[s]; \[IndentingNewLine]p = 
          Position[ElementAbbreviations, str]; \[IndentingNewLine]If[
          p =!= {}, 
          Return[Elements[\([p[\([1, 1]\)]]\)]]]; \[IndentingNewLine]p = 
          Position[ElementsString, str]; \[IndentingNewLine]If[p =!= {}, 
          Return[Elements[\([p[\([1, 
                    1]\)]]\)]]]; \
\[IndentingNewLine]Null\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(Map[ElementFromEither, {"\<Cr\>", Cr, Chromium, xxx}]\)], "Input"],

Cell[BoxData[
    \(AbbreviationFromEither[s_] := 
      Module[{p, p2, str}, 
        str = ToString[s]; \[IndentingNewLine]p = 
          Position[ElementAbbreviations, str]; \[IndentingNewLine]If[
          p =!= {}, 
          Return[ElementAbbreviations[\([p[\([1, 
                    1]\)]]\)]]]; \[IndentingNewLine]p = 
          Position[ElementsString, str]; \[IndentingNewLine]If[p =!= {}, 
          Return[ElementAbbreviations[\([p[\([1, 
                    1]\)]]\)]]]; \
\[IndentingNewLine]Null\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(Map[AbbreviationFromEither, {"\<Cr\>", Cr, Chromium, xxx}]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["snf and efunsnum (misc funs used in charts to print numbers)", \
"Subsubsection"],

Cell[BoxData[
    \(\(snf = \((EngineeringForm[#, 4\[IndentingNewLine], 
              NumberFormat \[Rule] \((SequenceForm[#1, "\<e\>", #3] &)\)\
\[IndentingNewLine]] &)\);\)\)], "Input"],

Cell[BoxData[
    \(\(snf = \((fNBookForm2[#] &)\);\)\)], "Input"],

Cell[BoxData[
    \(snf2[z_] := 
      EngineeringForm[N[z, 100], {3, 3}, 
        NumberPoint \[Rule] "\<.\>", \[IndentingNewLine]NumberFormat \[Rule] \
\((SequenceForm[#1, #2, "\<\[ThinSpace]\>", 
                powerbook[#3]] &)\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(efunsnum = {\((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] \
&)\), \((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] &)\), \
\((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] \
&)\), \((Identity[#] &)\), \((Identity[#] &)\), snf, snf, 
          snf, \((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] &)\), \
\((Identity[#] &)\)};\)\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic Charts", "Subsection"],

Cell[CellGroupData[{

Cell["chart of Electron Config  {all ElectronConfiguration }", "Subsubsection"],

Cell[BoxData[
    \(Partition[\[IndentingNewLine]Table[\[IndentingNewLine]{\
\[IndentingNewLine]Abbreviation[
              Elements[\([i]\)]], \[IndentingNewLine]ElectronConfiguration[
              Elements[\([i]\)]]\[IndentingNewLine]}, {i, 
            Length[Elements]\[IndentingNewLine]}\[IndentingNewLine]]\
\[IndentingNewLine], 2]\[IndentingNewLine] // TableForm\)], "Input"],

Cell[BoxData[
    \(\(Map[ElectronConfiguration, Elements] // TableForm;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
chart VerboseElement {all efun values, message per value , efuns , \
efun usage }\
\>", "Subsubsection"],

Cell[BoxData[
    \(VerboseElement[
        i_] := \[IndentingNewLine]FlattenAt[{{i, Element, i::usage, 
            Elements::usage}, 
          Table[\[IndentingNewLine]Miscellaneous`ChemicalElements`Private`\
mess = {}; \[IndentingNewLine]{\(efuns[\([j]\)]\)[
                i], \[IndentingNewLine]m2, \[IndentingNewLine]efuns[\([j]\)], \
\[IndentingNewLine]\(Evaluate[
                  efuns[\([j]\)]]\)::usage\[IndentingNewLine]}, {j, 1, 
              Length[efuns]}\[IndentingNewLine]]}, 2]\)], "Input"],

Cell[BoxData[
    \(VerboseElement[Hydrogen] // MatrixForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["chart Dict { name, abbrev, AtomicNumber , dict entry }", "Subsubsection"],

Cell[BoxData[
    \(\(dict[] := 
        Table[\[IndentingNewLine]{Elements[\([j]\)], 
            ElementDescription[Elements[\([j]\)]]\[IndentingNewLine]}, {j, 1, 
            Length[Elements]}];\)\)], "Input"],

Cell[BoxData[
    \(\(Dict = 
        Partition[{Elements, Abbreviation[Elements], AtomicNumber[Elements], 
            ElementDescription[Elements]}, 4];\)\)], "Input"],

Cell[BoxData[
    \(Dict // TableForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["chart Key { efunsab , efuns , unit , efun usage }", "Subsubsection"],

Cell[BoxData[
    \(\(Key = \[IndentingNewLine]FlattenAt[{\[IndentingNewLine]Table[\
\[IndentingNewLine]{\[IndentingNewLine]efunsab[\([j]\)], \
\[IndentingNewLine]efuns[\([j]\)], \[IndentingNewLine]efunsunitsb[\([j]\)], \
\[IndentingNewLine]\(Evaluate[
                    efuns[\([j]\)]]\)::usage\[IndentingNewLine]}, {j, 1, 
                Length[efuns]}\[IndentingNewLine]]\[IndentingNewLine], {"\<\
\[Element]\>", "\<Element\>", "\<\>", Elements::usage}\[IndentingNewLine]}, 
          1];\)\)], "Input"],

Cell[BoxData[
    \(Key // TableForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["chart FullElement { all efun values , any message per }", \
"Subsubsection"],

Cell[BoxData[
    \(FullElement[
        i_] := \[IndentingNewLine]FlattenAt[{{i, Element}, 
          Table[\[IndentingNewLine]Miscellaneous`ChemicalElements`Private`\
mess = {}; \[IndentingNewLine]{\(efuns[\([j]\)]\)[
                i], \[IndentingNewLine]m2\[IndentingNewLine]}, {j, 1, 
              Length[efuns]}\[IndentingNewLine]]}, 2]\)], "Input"],

Cell[BoxData[
    \(FullElement[Helium] // TableForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["chart ElementData { all efuns values }", "Subsubsection"],

Cell[BoxData[
    \(ElementData[
        i_] := \[IndentingNewLine]Flatten[{i, {\[IndentingNewLine]Table[\
\[IndentingNewLine]{\(efuns[\([j]\)]\)[i]}, {j, 1, 
                Length[efuns]}\[IndentingNewLine]]}}]\)], "Input"],

Cell[BoxData[
    \(ElementData[Hydrogen] // TableForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["chart ColumnChart { efunsab , all efuns values }", "Subsubsection"],

Cell[BoxData[
    \(ColumnChart[] \
:= \[IndentingNewLine]Table[\[IndentingNewLine]Flatten[{efunsab[\([j]\)], \
\(efuns[\([j]\)]\)[Elements]}]\[IndentingNewLine], {j, 1, 
          Length[efuns] - 2}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(TableForm[ColumnChart[]]\)], "Input"],

Cell["\<\
13 supposes that SsA is at 13 and the rest are for this \"ex mini \
chart\"\
\>", "Text"],

Cell[BoxData[
    \(ColumnChart2[] \
:= \[IndentingNewLine]Table[\[IndentingNewLine]Flatten[{efunsab[\([j]\)], \
\(efuns[\([j]\)]\)[Elements]}]\[IndentingNewLine], {j, 13, 
          Length[efuns] - 2}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(TableForm[ColumnChart2[]]\)], "Input"],

Cell[BoxData[
    \(\(Remove[xxx, xxx2];\)\)], "Input"],

Cell[BoxData[
    \(\(xxx2 := 
        Module[{i, j, m, n, z, v}\[IndentingNewLine], 
          v = ColumnChart[]; \[IndentingNewLine]m = 
            Length[v]; \[IndentingNewLine]n = 
            Length[v[\([1]\)]]; \[IndentingNewLine]Table[\[IndentingNewLine]z \
= v[\([i, j]\)]; \[IndentingNewLine]If[
              Head[z] =!= String, \[IndentingNewLine]If[Head[z] === Times, 
                z = Take[z, 1]]; \[IndentingNewLine]z = \(efunsnum[\([i]\)]\)[
                  z]\[IndentingNewLine]]; \[IndentingNewLine]z\
\[IndentingNewLine], {i, 13, m}\[IndentingNewLine], {j, 1, 
              n}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(xxx2;\)\)], "Input"],

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    \(\(xxx := 
        Module[{i, j, m, n, z, v}\[IndentingNewLine], 
          v = ColumnChart[]; \[IndentingNewLine]m = 
            Length[v]; \[IndentingNewLine]n = 
            Length[v[\([1]\)]]; \[IndentingNewLine]Table[\[IndentingNewLine]z \
= v[\([i, j]\)]; \[IndentingNewLine]If[
              Head[z] =!= String, \[IndentingNewLine]If[Head[z] === Times, 
                z = Take[z, 1]]; \[IndentingNewLine]z = \(efunsnum[\([i]\)]\)[
                  z]\[IndentingNewLine]]; \[IndentingNewLine]z\
\[IndentingNewLine], {i, 1, m}\[IndentingNewLine], {j, 1, 
              n}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(xxx;\)\)], "Input"],

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    \(EarthCrustAbundance[Helium]\)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(8.`*^-9\)\)\)], "Input"],

Cell[TextData[{
  "NOTE:  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " provided bogus data: Accuracy should be 1 not \"machine\" I'd guess."
}], "Text"],

Cell[BoxData[
    \(ScientificForm[%, 3]\)], "Input"],

Cell["\<\
ScientificForm[%,3,NumberFormat \
->(SequenceForm[#1,\"e\",#3]&)]\
\>", "Input",
  CellTags->"S2.8.7"],

Cell["take 1st (cull units the easy way)", "Text"],

Cell[BoxData[
    \(\(efunsnum[\([1]\)]\)[1.111111111*10\^9]\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"Take", "[", 
        RowBox[{
          FractionBox[
            RowBox[{
              RowBox[{"(", 
                InterpretationBox[\("\<8.24\>"\[Times]10\^"\<-1\>"\),
                  0.82399999999999995,
                  AutoDelete->True], ")"}], " ", "Joule", " ", "Kelvin"}], 
            "Gram"], ",", "1"}], "]"}],
      (ScientificForm[ #, 5]&)]], "Input"],

Cell[BoxData[
    \(\(Remove[xxx, xxx2];\)\)], "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Electron Configuration", "Section"],

Cell[CellGroupData[{

Cell["spec", "Subsubsection"],

Cell["\<\
note thsi is way oversimplified for how complex the real problem is \
!!\
\>", "Text"],

Cell[TextData[{
  "\telectron fill order is ...\n\tdecide WHERE e are ",
  StyleBox["GENERALLY",
    FontSlant->"Italic"],
  " (counted up from AtN)\n\t\tCRAP - my chembook gave a \"rule\"\n\t\tit's \
",
  StyleBox["WRONG  (not always true)",
    FontSlant->"Italic"],
  "\n\torder in CHART is by AtN\n\tcan be sorted to SHOW\n\t\t1) THOSE IN \
OUTER-MOST SHELL\n\t\t2) SHELL LAST ELECTRON FILLED"
}], "Text"],

Cell["\<\
subshell type NAMES in fill order , partitioned by subshell and ?
\t? fill order within a line of the typical periodic chart
\t? why grouped this way ?\
\>", "Text"],

Cell["\<\
expand to matrices having one position for each electron ; grouped \
by subshell / type\
\>", "Text"],

Cell["\<\
electrons partitioned by subshell type in fill order , and \
\"character\" names
shell level the nth subshell the above is filling
\tgrouping : maybe by period (already grouped by Group)
CRAP - WRONG
\tmy \"chem book\" never mentioned excetions.
\teither: proceede and poke in exceptions or drop the whole idea
Oh well!
\tmay as well - since I think calculating orbit
\tapparently also does not work (without tweaking to cause it to)\
\>", "Text"],

Cell[TextData[{
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s periodic palette uses cell boxes and decides placement with \"\" \
entries."
}], "Text"],

Cell["\<\
ChemicalElements.m stores eC, periodic uses\"\"

Due to the above - simply an ability to fill arrays / use them is enough.
\tit's \"preferred\" to use chem.m's arrays HOWEVER
\tthey are not fill ordered or necessarily always compatible\
\>", "Text"],

Cell["\<\
this fills all in order easily
\tOOPS
\t\tfill is one thing
\t\t\toddly ordered
\t\tBUT outer shell is for BONDING
\t\t\te in [highest] level
\t\t\t\tdoes NOT incl. even those after not
\t\t\t\tin that level
want
\tpartial fills
\t\tdo by removal
\treport when asked
\t\tshell last is in, OK
\t\t\tshells[]
\t\tsubshell last is in, OK
\t\t\tordnum[]
\t\torbital last is in
\t\t\t1st, 2nd, num
\t\t\tinord[]
\touter?most  shell report
\t\t\tinord[]\
\>", "Text"],

Cell["\<\
what if any are needed ?  at least first 2 ...
\tmathematica has 1 , but is the array format compat ?

ElectronFillOrder[ Element[[i]] ]
ElectronShellOrder[ Element[[i]] ]
ElectronLastShell[ Element[[i]] ]
\tshells[i]
ElectronLastSubshell[ Element[[i]] ]
\tsubshell
\t\t? in fill order ?
\t\t? in shell order ?
ElectronLastOrbit[ Element[[i]] ]
\tLength[ subshell ]
\t\t? in fill order ?
\t\t? in shell order ?
ElectronShells[ Element[[i]] ]
\t? returns list \
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["data - static / manual arrays", "Subsubsection"],

Cell[BoxData[{
    \(\(asubshells = {"\<s\>", "\<p\>", "\<d\>", "\<f\>"};\)\), "\n", 
    \(\(nsubshells = {1, 3, 5, 7};\)\), "\n", 
    \(\(\[Rho]subshells = {1, 2/3, 3/2, 4};\)\), "\n", 
    \(\(porb[c_] := \(Position[asubshells, c]\)[\([1, 1]\)];\)\), "\n", 
    \(\(zorb[c_] := nsubshells[\([porb[c]]\)];\)\[IndentingNewLine]\), "\n", 
    \(\(nord = {1, 2, 2, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 
          7};\)\), "\n", 
    \(\(cord = {"\<s\>", "\<s\>", "\<p\>", "\<s\>", "\<p\>", "\<d\>", \
"\<s\>", "\<p\>", "\<d\>", "\<f\>", "\<s\>", "\<p\>", "\<d\>", "\<f\>", \
"\<s\>", "\<p\>", "\<d\>", "\<s\>"};\)\), "\n", 
    \(\(gcord = {{"\<s\>"}, {"\<s\>", "\<p\>"}, {"\<s\>", "\<p\>", "\<d\>"}, \
{"\<s\>", "\<p\>", "\<d\>", "\<f\>"}, {"\<s\>", "\<p\>", "\<d\>", "\<f\>"}, \
{"\<s\>", "\<p\>", "\<d\>"}, {"\<s\>"}};\)\), "\n", 
    \(\(gnord = {{1}, {2, 3}, {4, 5, 6}, {7, 8, 9, 10}, {11, 12, 13, 
            14}, {15, 16, 17}, {18}};\)\[IndentingNewLine]\), "\n", 
    \(\(fnord = {1, 2, 2, 3, 3, 4, 3, 4, 5, 4, 5, 6, 4, 5, 6, 7, 5, 
          6};\)\), "\n", 
    \(\(fcord = {"\<s\>", "\<s\>", "\<p\>", "\<s\>", "\<p\>", "\<s\>", \
"\<d\>", "\<p\>", "\<s\>", "\<d\>", "\<p\>", "\<s\>", "\<f\>", "\<d\>", \
"\<p\>", "\<s\>", "\<f\>", "\<d\>"};\)\), "\n", 
    \(\(fgcord = {{"\<s\>"}, {"\<s\>", "\<p\>"}, {"\<s\>", "\<p\>"}, \
{"\<s\>", "\<d\>", "\<p\>"}, {"\<s\>", "\<d\>", "\<p\>"}, {"\<s\>", "\<f\>", \
"\<d\>", "\<p\>"}, {"\<s\>", "\<f\>", "\<d\>"}};\)\), "\[IndentingNewLine]", 
    \(\(fgnord = {{1}, {2, 3}, {4, 5, 7}, {6, 8, 10, 13}, {9, 11, 14, 
            17}, {12, 15, 18}, {16}};\)\[IndentingNewLine] (*\ 
      FGNORD\ IS\ WRONG\ *) \), "\[IndentingNewLine]", 
    \(\(fgnord3 = {{1}, {2, 2}, {3, 3}, {4, 3, 4}, {5, 4, 5}, {6, 4, 5, 
            6}, {7, 5, 6}};\)\[IndentingNewLine] (*\ 
      note\ incremental\ numbering\ may\ not\ be\ useful\ *) \), "\
\[IndentingNewLine]", 
    \(\(fgnord2 = {{1}, {2, 3}, {4, 5}, {6, 7, 8}, {9, 10, 11}, {12, 13, 14, 
            15}, {16, 17, 18}};\)\)}], "Input"],

Cell[BoxData[
    \(\(ncord = 
        Table[{nord[\([i]\)], cord[\([i]\)]}, {i, 1, 18}];\)\)], "Input"],

Cell[BoxData[
    \(\(fncord = 
        Table[{fnord[\([i]\)], fcord[\([i]\)]}, {i, 1, 18}];\)\)], "Input"],

Cell[BoxData[
    \(\(gncord = Table[{i, gcord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell["\<\
f\t\tg\t\tn\t\tc\t\t\tord
fill order,  grouped by shell, having number and letter for subshell, for \
each subshell\
\>", "Text"],

Cell[BoxData[
    \(\(fgncord = Table[{i, fgcord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell[BoxData[
    \(\(gnnord = Table[{i, gnord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell[BoxData[
    \(\(fgnnord = Table[{i, fgnord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell["\<\
ncord is not useful with partially filled e[]
becuase shell nums positionally change (try showe[] to see this)\
\>", "Text"],

Cell[BoxData[
    \(ncord\)], "Input"],

Cell["this can be used against any fe[]", "Text"],

Cell[BoxData[
    \(fgnnord\)], "Input"],

Cell["\<\
s is left, d middle, p right , and f (lanthanide / actinide \
seriers)\
\>", "Text"],

Cell[BoxData[
    \(fe[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, f1}; \[IndentingNewLine]ford = {s, s, p, s, p, s, d, p, s, 
            d, p, s, f, d, p, s, f, d}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(gfe[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, 
            f1}; \[IndentingNewLine]gford = {{s}, {s, p}, {s, p}, {s, d, 
              p}, {s, d, p}, {s . f, d, p}, {s, f, 
              d}}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(e[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, f1}; \[IndentingNewLine]ord = {s, s, p, s, p, d, s, p, d, f, 
            s, p, d, f, s, p, d, s}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(ge[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, 
            f1}; \[IndentingNewLine]gford = {{s}, {s, p}, {s, p, d}, {s, p, 
              d, f}, {s, p, d, f}, {s, p, 
              d}, {s}}\[IndentingNewLine]]\)], "Input"],

Cell["quantum chart isn't used in elements chart, currently unused", "Text"],

Cell[BoxData[
    \(\(pqnlabel = \[IndentingNewLine]{"\<n\>", "\<\[ScriptL]\>", \
\*"\"\<\!\(m\_\[ScriptL]\)\>\"", \*"\"\<\!\(m\_s\)\>\"", \*"\"\<\!\(1\/2\)\
\[HBar]\>\"", \*"\"\<-\!\(1\/2\)\[HBar]\>\""};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["quantum number state tables with function to create", "Subsubsection"],

Cell["NOTE:  abbreviated but making full is easy, see chart below", "Text"],

Cell["\<\
fixme ?  CRC 52nd 1972 lists \"O-P-Q\" on shell 7,  but Serway Phy \
3rd I used shows only \"...\".   I'd believe anything over P is unused by \
known elements except CRC says yes.  Thus I've added a guess for Q e 7 not \
yet checked against the / a book.  (the guess is that \"e\" is arrived at the \
same way h, g, f, ... meaning, looking at last two pqnlabel, no new state is \
added.  OOOH CRC says Q is shell 7.  ok\
\>", "Text"],

Cell[BoxData[
    \(\(pqnlevel = {"\<K\>", "\<L\>", "\<M\>", "\<O\>", "\<N\>", "\<P\>", \
"\<Q\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(oqnlevel = {"\<s\>", "\<p\>", "\<d\>", "\<f\>", "\<g\>", "\<h\>", \
"\<e\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(pqnstate::usage = "\<pqnstate[number of shells] := \
{shells,subshells,electrons states} where each is a running total across all \
(principle quantum number state totals)\>";\)\)], "Input"],

Cell[BoxData[
    \(pqnstate[n_] := 
      Module[{j, k}, \[IndentingNewLine]{n, \[Sum]\+\(j = 1\)\%n j, 
          n + \[Sum]\+\(j = 1\)\%\(n - 1\)\(\[Sum]\+\(k = 1\)\%j\((2  k + 
                    1)\)\)\[IndentingNewLine], 
          2 \((n + \[Sum]\+\(j = 1\)\%\(n - 1\)\(\[Sum]\+\(k = 1\)\%j\((2  
                          k + 1)\)\))\)}]\)], "Input"],

Cell["\<\
a chart from a physics books use during introducing n,l,ml,ms
\tsee notes above: guess / Q / 7 is a guess I haven't bothered checking\
\>", \
"Text"],

Cell[BoxData[
    \(\(create::usage = \*"\"\<create[n Shells]  creates a quantum state \
table (emperical allowable energies of hydrogen, also the periodic table \
(fill order aside)). n=K,L,M... are the shells (principle qauntum number \
p.q.n.), n-1=\[ScriptL]=s,p,d... are subshells (orbital q.n.), \!\(m\_\
\[ScriptL]\) = -\[ScriptL]...\[ScriptL] the (o. magnetic q.n.), and \
\!\(m\_s\) the opposing radial energy pair of electrons.  n must be a whole \
number by observation, an easy explanation by de Broglie is an n standing \
wave division, \!\(m\_\[ScriptL]\) (yet more spectrum lines) are due to \
submagnets of electron motion\>\"";\)\)], "Input"],

Cell["\<\
... and no two electrons can occupy the same space: which fills the \
table above when exclusions (due to n being integral) are made.  where a \
state is not allowed, latent energy is held between states (observed).  the \
integer model in the table fits the spectrum grouping of absorbed or released \
wavelengths of hydrogen.  note the table does not match the periodic table \
exactly for several elements (yet more dynamic issues).  m_s integral(2) and \
not a span of vectors why? due to the precision uncertainty of using anything \
< h in any calculation, but the result of pairs matches the spectral lines \
where standing waves patters are seen.  p=yh (h is related to energy and \
frequency), so whole measures of h or n, and standing wave numbers, is not \
coincidence.\
\>", "Text"],

Cell[BoxData[
    \(create[nx_] := 
      Module[{v, p, d, k, n, 
          z}, \[IndentingNewLine]p[d : 7] := {pqnlabel[\([6]\)], 
            pqnlabel[\([7]\)]}; \  (*\ 
          guess\ *) \[IndentingNewLine]p[d : 5] := {pqnlabel[\([5]\)], 
            pqnlabel[\([6]\)]}; \[IndentingNewLine]p[d : 4] := 
          ToEach[Range[\(-k\), k], p[d + 1]]; \[IndentingNewLine]p[d : 3] := 
          Table[{oqnlevel[\([k + 1]\)], p[d + 1]}, {k, 0, 
              n - 1}]; \[IndentingNewLine]p[d : 2] := {pqnlevel[\([n]\)], 
            p[d + 1]}; \[IndentingNewLine]p[d : 1] := 
          Table[k = \(-1\); p[d + 1], {n, 1, nx}]; \[IndentingNewLine]p[
            d : 0] := {"\<Allowable Quantum States\>", 
            p[d + 1]}; \[IndentingNewLine]p[0]]\)], "Input"],

Cell[BoxData[
    \(create[3] // TableForm\)], "Input"],

Cell[BoxData[
    \(pqnstate[3]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
stateskel:
(makes an \"allowed quant num states\" array of just the allowed states given \
n\
\>", "Subsubsection"],

Cell["\<\
Quantum states show us why we have \"s, p, d, f\" and their size.  \
However note they do not predict \"irregularities\" and infact irregularities \
are questionably calculated and arguable in modern physics.  (in this program \
the corrections are given not calculated by any favorite formula)\
\>", "Text"],

Cell[BoxData[
    \(stateskel[n_] := 
      Module[{l, ml, ms}, \[IndentingNewLine]l = 
          Range[0, n - 1]; \[IndentingNewLine]ml = 
          Range[\(-l\), l]; \[IndentingNewLine]ms = 
          Range[\(-1\)/2, 1/2]; \[IndentingNewLine]{l, ml, 
          ms}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(stateskel[3]\)], "Input"],

Cell["\<\
as in Serway Phy 3rd p. 1227 tab 42.3 \"allowed quantum num for an \
atom\"
\tNOTE: create[] table above is easier to use / make table of\
\>", "Text"],

Cell[BoxData[
    \({\[IndentingNewLine]{pqnlabel[\([1]\)], {3}}, \
\[IndentingNewLine]{"\<\>"}, \[IndentingNewLine]{pqnlabel[\([2]\)], \
\(stateskel[
              3]\)[\([1]\)]}, \[IndentingNewLine]{"\<\>"}, \
\[IndentingNewLine]{pqnlabel[\([3]\)], \(stateskel[
              3]\)[\([2]\)]}, \[IndentingNewLine]{"\<\>"}, \
\[IndentingNewLine]{pqnlabel[\([4]\)], \(stateskel[
              3]\)[\([3]\)]}\[IndentingNewLine]} // TableForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["funs - variety of utility funs", "Subsubsection"],

Cell["\<\
IMPORTANT:  felements / elements are built from these further below \
(aren't be avail yet)\
\>", "Text"],

Cell["\<\
total electrons so far for the Nth subshell
\t* note flatten is used to count 1's
\t* use ecnt[x][[subshell]] for a one subshell\
\>", "Text"],

Cell[BoxData[
    \(\(ecnt[e_List] := 
        Table[\[IndentingNewLine]Length[
            Flatten[Take[e, i]]]\[IndentingNewLine], {i, 1, 
            Length[e]}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(ecnt[felements[\([90]\)]]\)], "Input"],

Cell[BoxData[
    \(\(ecnt[an_Symbol] := 
        ecnt[elements[\([AtomicNumber[an]]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(fecnt[an_Symbol] := 
        ecnt[felements[\([AtomicNumber[an]]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(ecnt[an_Integer] := ecnt[elements[\([an]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(fecnt[an_Integer] := ecnt[felements[\([an]\)]];\)\)], "Input"],

Cell[BoxData[
    \(ecnt[fe[]]\)], "Input"],

Cell[BoxData[
    \(ecnt[] := ecnt[e[]]\)], "Input"],

Cell[BoxData[
    \(fecnt[] := ecnt[fe[]]\)], "Input"],

Cell[BoxData[
    \(fecnt[e_List] := ecnt[e]\)], "Input"],

Cell[BoxData[
    \(\(height[e_] := Length[e];\)\)], "Input"],

Cell[BoxData[
    \(width[e_] := 
      Module[{h}, h = height[e]; 
        Max[Table[\ Length[e[\([i]\)]], {i, 1, h}]]]\)], "Input"],

Cell["sub length , len at each width position", "Text"],

Cell[BoxData[
    \(subheight[e_] := 
      Module[{h}, h = height[e]; 
        Table[\ Length[e[\([i]\)]], {i, 1, h}]]\)], "Input"],

Cell[BoxData[
    \(subwidth[e_] := 
      Module[{w}, w = width[e]; 
        Table[\ Length[e[\([i]\)]], {i, 1, w}]]\)], "Input"],

Cell["shell level elem is in ElectronConfiguration", "Text"],

Cell[BoxData[
    \(shells[x_Integer] := \[IndentingNewLine]Module[{ec, len}, 
        len = 0; \[IndentingNewLine]If[
          x > 0 && \ x \[LessEqual] Length[Elements], \[IndentingNewLine]ec = 
            ElectronConfiguration[Elements[\([x]\)]]; \[IndentingNewLine]If[
            SameQ[ec, Unknown], len = 7, 
            len = Length[
                ec]]; \[IndentingNewLine]If[\(! SameQ[ec, Unknown]\) && 
              Length[ec[\([len]\)]] > 2, len + 1, 
            len]\[IndentingNewLine]]]\)], "Input"],

Cell["shell level elem is in ElectronConfiguration", "Text"],

Cell[BoxData[
    \(shells[n_Symbol] := \[IndentingNewLine]Module[{ec, len, x}, 
        len = 0; \[IndentingNewLine]x = 
          AtomicNumber[n]; \[IndentingNewLine]If[
          x > 0 && \ x \[LessEqual] Length[Elements], \[IndentingNewLine]ec = 
            ElectronConfiguration[Elements[\([x]\)]]; \[IndentingNewLine]If[
            SameQ[ec, Unknown], len = 7, 
            len = Length[
                ec]]; \[IndentingNewLine]If[\(! SameQ[ec, Unknown]\) && 
              Length[ec[\([len]\)]] > 2, len + 1, 
            len]\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(\(shells[e_List] := Max[Take[fnord, {1, Length[e]}]];\)\)], "Input"],

Cell["shellsarr [ Atomic Number ] == outermost shell of element", "Text"],

Cell[BoxData[
    \(shellsarr = Table[shells[i], {i, 1, Length[Elements]}]\)], "Input"],

Cell["\<\
counts of e in each of [1-18] orbitals separately (unlike ecnt not \
a running sum)\
\>", "Text"],

Cell[BoxData[
    \(ineachsubshell[an_Integer] := 
      Table[\[IndentingNewLine]Length[
          Flatten[\(felements[\([an]\)]\)[\([i]\)]]]\[IndentingNewLine], {i, 
          1, Length[felements[\([an]\)]]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(ineachsubshell[e_List] := 
      Table[\[IndentingNewLine]Length[
          Flatten[e[\([i]\)]]]\[IndentingNewLine], {i, 1, 
          Length[e]}\[IndentingNewLine]]\)], "Input"],

Cell["ignore these", "Text"],

Cell[BoxData[
    \(inorb2[elem_, n_] := 
      Length[Flatten[Part[elem, Flatten[Position[nord, n]]]]]\)], "Input"],

Cell[BoxData[
    \(finorb2[felem_, n_] := 
      Length[Flatten[Part[felem, Flatten[Position[fnord, n]]]]]\)], "Input"],

Cell["\<\
counts of e in Orbital n (of 7 orbitals) : not the same as e in a \
shell for fill order\
\>", "Text"],

Cell[BoxData[
    \(fineashell[elem_, n_] := 
      Module[{len, sublist, v, nn, once}, \[IndentingNewLine]once = 0; 
        len = Length[elem]; \[IndentingNewLine]sublist = 
          Flatten[Position[fnord, 
              n]]; \[IndentingNewLine]v = {}; \[IndentingNewLine]Do[\
\[IndentingNewLine]If[sublist[\([i]\)] \[LessEqual] len, 
            once = 1; \[IndentingNewLine]v = 
              Append[v, 
                Part[elem, sublist[\([i]\)]]]\[IndentingNewLine]], {i, 1, 
            Length[sublist]}\[IndentingNewLine]]; \[IndentingNewLine]nn = 
          Length[Flatten[v]]; \[IndentingNewLine]If[once \[Equal] 1, 
          nn]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(ineashell[elem_, n_] := fineashell[ord2ford[elem], n];\)\)], "Input"],

Cell["\<\
counts of e in subshell n
\tThis works but is same as inorb / finorb\
\>", "Text"],

Cell[BoxData[
    \( (*\[IndentingNewLine]finord[elem_, n_] := 
        Module[{len, sublist, v, nn}, \[IndentingNewLine]len = 
            Length[elem]; \[IndentingNewLine]sublist = 
            fgnord[\([n]\)]; \[IndentingNewLine]v = {}; \
\[IndentingNewLine]Do[\[IndentingNewLine]If[
              sublist[\([i]\)] \[LessEqual] len, 
              v = Append[v, 
                  Part[elem, sublist[\([i]\)]]]\[IndentingNewLine]], {i, 1, 
              Length[sublist]}\[IndentingNewLine]]; \[IndentingNewLine]nn = 
            Length[Flatten[v]]; \[IndentingNewLine]If[nn =!= 0, 
            nn]\[IndentingNewLine]]\[IndentingNewLine]*) \)], "Input"],

Cell[BoxData[
    \( (*\ \(inord[elem_, n_] := finord[ord2ford[elem], n];\)\ *) \)], "Input"],

Cell[BoxData[
    \(Table[ineashell[elements[\([55]\)], i], {i, 1, 7}]\)], "Input"],

Cell[BoxData[
    \(ineachsubshell[felements[\([55]\)]]\)], "Input"],

Cell[BoxData[
    \(ineachsubshell[elements[\([55]\)]]\)], "Input"],

Cell[BoxData[
    \(\(ecnt[felements[\([55]\)]]\)[\([12]\)] - \(ecnt[
          felements[\([55]\)]]\)[\([11]\)]\)], "Input"],

Cell[BoxData[
    \(shellsarr[\([55]\)]\)], "Input"],

Cell[BoxData[
    \(ecnt[felements[\([55]\)]]\)], "Input"],

Cell[BoxData[
    \(showfe[Caesium]\)], "Input"],

Cell["\<\
ignore:  ordnum
\tornum does NOT count irregularities
\tfor that use felements[]
\tNOTE:  nothing uses these
for example,
\tgiven n an AtomicNumber
\tthe position in fcord or fcord being filled (last subshell)
\twhich is the nth s,p,d or f (there are 18 subshells for 112th elem)
\tNOTE: exact input (full felements[]) is NOT needed\
\>", "Text"],

Cell[BoxData[
    \(ordnum[n_] := 
      Module[\[IndentingNewLine]{i}, i = 0; 
        If[n < 1 || n > ELEMENTS, 
          False, \[IndentingNewLine]While[\(++i\) < 
                18 && \(ecnt[]\)[\([i]\)] < 
                n]; \[IndentingNewLine]i]]\)], "Input"],

Cell[BoxData[
    \(fordnum[n_] := 
      Module[\[IndentingNewLine]{i}, i = 0; 
        If[n < 1 || n > ELEMENTS, 
          False, \[IndentingNewLine]While[\(++i\) < 
                18 && \(fecnt[]\)[\([i]\)] < 
                n]; \[IndentingNewLine]i]]\)], "Input"],

Cell["\<\
Map[ordnum,Table[i,{i,1,112}]]
Map[fordnum,Table[i,{i,1,112}]]\
\>", "Text"],

Cell[BoxData[
    \(\(\( (*\ 
      ex . \ Boron\ will\ fill\ first\ 3\ \((s\ s\ p)\)\ \((not\ all)\)\ \
*) \)\(\[IndentingNewLine]\)\(ordnum[5] \[Equal] 3\)\)\)], "Input"],

Cell["\<\
IMPORTANT:  see notes above
\tcovert ord -> ford or ford -> ord\
\>", "Text"],

Cell[BoxData[
    \(ford2ord[
        e_List] := \(Sort[\[IndentingNewLine]Table[{fnord[\([i]\)], 
              porb[fcord[\([i]\)]], i, e[\([i]\)]}\[IndentingNewLine], {i, 1, 
              Length[e]}]]\)[\([All, 4]\)]\)], "Input"],

Cell[BoxData[
    \(\(ford2ordarr[
          e_] := \(Sort[\[IndentingNewLine]Table[{fnord[\([i]\)], 
                porb[fcord[\([i]\)]], i, e[\([i]\)]}\[IndentingNewLine], {i, 
                1, Length[e]}]]\)[\([All, 3]\)];\)\)], "Input"],

Cell["\<\
more complicated: but \"easy\" if taken as reverse of order \
ford2ord would do\
\>", "Text"],

Cell[BoxData[
    \(ord2ford[
        e_] := \(Module[{sarr}, \[IndentingNewLine]sarr = ford2ordarr[e]; 
          Sort[\[IndentingNewLine]Table[{sarr[\([i]\)], e[\([i]\)]}, {i, 1, 
                Length[e]}]\[IndentingNewLine]]]\)[\([All, 2]\)]\)], "Input"],

Cell[BoxData[
    \(ford2ord[fe[]] \[Equal] e[]\)], "Input"],

Cell["\<\
Table Below:
\t* INTERESTING: right column shows orbital fill order for this element
\t* porb[ fcord[[i]] ] fcord[[i]] is [1-18]th \"s,p,d,f\" in fcord
\t   (that's the orbital being / that is last filled at i) and porb shows \
[1-4]
\t   (and is not req. to show or for sorting)\
\>", "Text"],

Cell[BoxData[
    \(\(\( (*\ 
      works\ only\ after\ felements\ built\ *) \)\(\ \
\)\(\[IndentingNewLine]\)\(\(Table[{fnord[\([i]\)], porb[fcord[\([i]\)]], 
            i, \(felements[\([57]\)]\)[\([i]\)]}, {i, 1, 
            Length[felements[\([57]\)]]}] // Sort\) // 
      MatrixForm\)\)\)], "Input"],

Cell[BoxData[
    \(showfe[e_List] := 
      Table[{fnord[\([i]\)], fcord[\([i]\)], 
            e[\([i]\)]}\[IndentingNewLine], {i, 1, Length[e]}] // 
        MatrixForm\)], "Input"],

Cell[BoxData[
    \(showfe[x_Symbol] := 
      Module[{an, z}, \[IndentingNewLine]an = 
            AtomicNumber[x]; \[IndentingNewLine]showfe[
            felements[\([an]\)]]\[IndentingNewLine]] // MatrixForm\)], "Input"],

Cell["\<\
note how showfe won't work for showe - would mistake shells / \
orbits\
\>", "Text"],

Cell[BoxData[
    \(showe[e_List] := 
      Module[{v, w}, 
          v = ord2ford[e]; \[IndentingNewLine]w = 
            Table[\[IndentingNewLine]{fnord[\([i]\)], porb[fcord[\([i]\)]], 
                fcord[\([i]\)], v[\([i]\)]}\[IndentingNewLine], {i, 1, 
                Length[v]}\[IndentingNewLine]]; \[IndentingNewLine]v = 
            Sort[w]; \[IndentingNewLine]Map[\((Delete[#, 2] &)\), 
            v]\[IndentingNewLine]] // MatrixForm\)], "Input"],

Cell[BoxData[
    \(showe[x_Symbol] := 
      Module[{an, z}, \[IndentingNewLine]an = 
            AtomicNumber[x]; \[IndentingNewLine]showe[
            elements[\([an]\)]]\[IndentingNewLine]] // MatrixForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["create elements elec. tables 1's format", "Subsubsection"],

Cell["\<\
begins with fe[] (112) and removes one at a time.
\tstandard form used is to include only non-empty orbits (to remove empties)
\tso Helium is just {{1,1}} which is 110 removals from 112\
\>", "Text"],

Cell["\<\
laste returns: Position[] of the last electron in e given (Deleted \
once to get each element).  also used by correct[] further below\
\>", "Text"],

Cell[BoxData[
    \(laste[e_] := 
      Module[{d, l, v}, \[IndentingNewLine]v = e; l = Length[v]; 
        d = {}; \[IndentingNewLine]While[
          l > 0, \[IndentingNewLine]d = Append[d, l]; \[IndentingNewLine]v = 
            Last[v]; \[IndentingNewLine]l = 
            Length[v];]; \[IndentingNewLine] (*\(If[v \[Equal] {}, 
              d = Append[d, 1]];\)*) \[IndentingNewLine]d]\)], "Input"],

Cell[BoxData[
    \(\(Module[{v, w}, v = e[]; 
        w = {}; \[IndentingNewLine]While[v \[NotEqual] w, w = v; 
          v = Last[v]]; v];\)\)], "Input"],

Cell["\<\
takee is not general
\tit assumes last is the object to be deleted
\tit removes empties\
\>", "Text"],

Cell[BoxData[
    \(takee[e_] := 
      Module[{v}, \[IndentingNewLine]v = 
          Delete[e, laste[e]]; \[IndentingNewLine] (*\ 
          empties\ are\ not\ kept\ *) \[IndentingNewLine]While[
          Extract[v, laste[v]] \[Equal] {} && Length[v] \[NotEqual] 0, 
          v = Delete[v, laste[v]]]; \[IndentingNewLine]v]\)], "Input"],

Cell["\<\
empties not kepts as variously Length[] is used to count electrons \
and {} would count as 1\
\>", "Text"],

Cell[BoxData[
    \(takee[e_, n_] := 
      Module[{i, v}, \[IndentingNewLine]i = n; 
        v = e; \[IndentingNewLine]While[\(i--\) \[NotEqual] 0, 
          v = takee[v]]; \[IndentingNewLine]v]\)], "Input"],

Cell["create table of elements of full electron table", "Text"],

Cell[BoxData[
    \(\(\(Clear[felements, elements]\)\(\[IndentingNewLine]\)\( (*\ 
      oops\ showfe\ uses\ already\ Remove[felements, 
          elements]\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(Module[{i, f}, i = 113; 
      felements = Array[f, ELEMENTS]; \[IndentingNewLine]While[\(--i\) > 0, 
        felements[\([i]\)] = 
          takee[fe[], ELEMENTS - i]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(elements = 
        Table[ford2ord[felements[\([i]\)]], {i, 1, ELEMENTS}];\)\)], "Input"],

Cell[BoxData[
    \(Module[{i, f}, i = 113; 
      elements = Array[f, ELEMENTS]; \[IndentingNewLine]While[\(--i\) > 0, 
        elements[\([i]\)] = 
          takee[e[], ELEMENTS - i]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell["\<\
keep for later is sometimes useful to see non-adjusted for \
comparison\
\>", "Text"],

Cell[BoxData[
    \(\(elementsNa = elements;\)\)], "Input"],

Cell[BoxData[
    \(\(felementsNa = felements;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["correct the \"irregularities\"", "Subsubsection"],

Cell["\<\
takes e here , add e there , but ... not as easy as hoped / planned

\tNO ERROR CHECKING (ie, none there to take)
\t** corrections should be know to be applicable before tried
\t** probably manual correction / replacements would have better
\tnote we correct fe / fill order only and convert to e[] after corrections\
\
\>", "Text"],

Cell["\<\
correct:\t \tadd e to last , take from next to last
correct2x:\tadd e to last , take from next to last, done twice
correct2:\tadd e to last , take from 2 before last
correct2x2:\tadd e to last , take from 2 before last, done twice
rcorrect: \tadd e after last, take from last
rcorrect2: \tadd e after last, take from last, add e to last take from last \
(correct)\
\>", "Text"],

Cell[BoxData[
    \(rnullpat[e_] := 
      Module[{p}, \[IndentingNewLine]p = 
          Position[e, {_, {}}]; \[IndentingNewLine]If[
          Length[p] == 1, \[IndentingNewLine]Delete[e, 
            Flatten[{p, 2}]]\[IndentingNewLine], 
          e\[IndentingNewLine]]]\)], "Input"],

Cell["\<\
special case to remove dangling {}
\t(standard form when created / include only non-empty orbits)
\tsome code won't expect dangling {}\
\>", "Text"],

Cell[BoxData[
    \(rnullpat[{{1, 1}, {}}]\)], "Input"],

Cell["\<\
add e to last , take from next to last
\tworks nice but removes\
\>", "Text"],

Cell[BoxData[
    \(correct[e_] := 
      Module[{v, w}, \[IndentingNewLine]v = 
          Take[e, \(-1\)]; \[IndentingNewLine]v = 
          Insert[v, 1, laste[v]]; \[IndentingNewLine]w = 
          Take[e, Length[e] - 1]; \[IndentingNewLine] (*\ \(w = 
              takee[w];\)*) \[IndentingNewLine]w = 
          Delete[w, laste[w]]; \[IndentingNewLine]Append[w, 
          v]\[IndentingNewLine]]\)], "Input"],

Cell["add e to last , take from 2 before last", "Text"],

Cell[BoxData[
    \(correct2[e_] := 
      Module[{v, w, x}, \[IndentingNewLine]x = 
          Take[e, \(-2\)]; \[IndentingNewLine]w = 
          Take[e, Length[e] - 2]; \[IndentingNewLine]v = 
          Last[x]; \[IndentingNewLine]x = \(Take[x, 
              Length[x] - 1]\)[\([1]\)]; \[IndentingNewLine]v = 
          Insert[v, 1, laste[v]]; \[IndentingNewLine]w = 
          Delete[w, laste[w]]; \[IndentingNewLine]Append[Append[w, x], 
          v]\[IndentingNewLine]]\)], "Input"],

Cell["add e after last, take from last", "Text"],

Cell[BoxData[
    \(rcorrect[e_] := 
      Module[{l, v, w}, \[IndentingNewLine]w = 
          Delete[e, laste[e]]; \[IndentingNewLine]rnullpat[
          Append[w, {1}]]\[IndentingNewLine]]\)], "Input"],

Cell["this appears to take 1 e but add 2 e - test before using it", "Text"],

Cell[BoxData[
    \(rcorrect2[e_] := 
      Module[{l, v, w}, \[IndentingNewLine]w = 
          Delete[e, laste[e]]; \[IndentingNewLine]w = 
          Delete[w, laste[w]]; \[IndentingNewLine]rnullpat[
          Append[w, {{1, 1}}]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(rcorrect2[felementsNa[\([90]\)]] \[Equal] 
      correct[rcorrect[felementsNa[\([90]\)]]]\)], "Input"],

Cell[BoxData[
    \(correctlistb[v_, f_] := 
      Module[{n, an, i}, \[IndentingNewLine]n = Length[v]; 
        i = 0; \[IndentingNewLine]While[\(++i\) \[LessEqual] 
            n, \[IndentingNewLine]an = AtomicNumber[v[\([i]\)]]; 
          felements[\([an]\)] = 
            f[felements[\([an]\)]]; \[IndentingNewLine]elements[\([an]\)] = 
            ford2ord[
              felements[\([an]\)]];\[IndentingNewLine]]; \[IndentingNewLine]v\
\  (*\ allow\ nesting\ *) \[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(correctlist[v_] := correctlistb[v, correct]\)], "Input"],

Cell[BoxData[
    \(correctlist2[v_] := correctlistb[v, correct2]\)], "Input"],

Cell[BoxData[
    \(rcorrectlist[v_] := correctlistb[v, rcorrect]\)], "Input"],

Cell[BoxData[
    \(rcorrectlist2[v_] := correctlistb[v, rcorrect2]\)], "Input"],

Cell["preffered", "Text"],

Cell[BoxData[
    \(rcorrectlist2[v_] := \((correctlistb[v, rcorrect]; 
        correctlistb[v, correct])\)\)], "Input"],

Cell[BoxData[
    \(correctlist2x[v_] := correctlist[correctlist[v]]\)], "Input"],

Cell[BoxData[
    \(correctlist2x[v_] := \((correctlist[v]; correctlist[v])\)\)], "Input"],

Cell[BoxData[
    \(correctlist2x2[v_] := correctlist2[correctlist2[v]]\)], "Input"],

Cell[BoxData[
    \(correctlist2x2[v_] := \((correctlist2[v]; correctlist2[v])\)\)], "Input"],

Cell[BoxData[
    \(correct2x[v_] := correct[correct[v]]\)], "Input"],

Cell[BoxData[
    \(correct2x2[v_] := correct2[correct2[v]]\)], "Input"],

Cell["quick test rcorrect before overwriting corrections", "Text"],

Cell[BoxData[
    \(\(rcorrect[felements[\([AtomicNumber[Cm]]\)]];\)\)], "Input"],

Cell[BoxData[
    \(showfe[%]\)], "Input"],

Cell["\<\
ACTUALLY CORRECT felements and elements
\tcorrect list ended up a pain in the butt but is easier to read ...\
\>", \
"Text"],

Cell[BoxData[
    \(correctlist[{Cr, Cu, Nb, Mo, Tc, Ru, Rh, Ag}]\)], "Input"],

Cell[BoxData[
    \(correctlist2x[{Pd}]\)], "Input"],

Cell[BoxData[
    \(rcorrectlist[{La, Gd, Ac, Pa, U, Np, Cm}]\)], "Input"],

Cell[BoxData[
    \(correctlist2x2[{Ir}]\)], "Input"],

Cell[BoxData[
    \(correctlist2[{Pt, Au}]\)], "Input"],

Cell[BoxData[
    \(rcorrectlist2[{Th}]\)], "Input"],

Cell["\<\
tell us which elem gets which correction (used as lookup later to \
show config)\
\>", "Text"],

Cell[BoxData[
    \(\(correctarr = {{"\<Cr\>", correct}, {"\<Cu\>", correct}, {"\<Nb\>", 
            correct}, {"\<Mo\>", correct}, {"\<Tc\>", correct}, {"\<Ru\>", 
            correct}, {"\<Rh\>", correct}, {"\<Ag\>", correct}, {"\<Pd\>", 
            correct2x}, {"\<La\>", rcorrect}, {"\<Gd\>", 
            rcorrect}, {"\<Ac\>", rcorrect}, {"\<Pa\>", rcorrect}, {"\<U\>", 
            rcorrect}, {"\<Np\>", rcorrect}, {"\<Cm\>", rcorrect}, {"\<Ir\>", 
            correct2x2}, {"\<Pt\>", correct2}, {"\<Au\>", 
            correct2}, {"\<Th\>", rcorrect2}};\)\)], "Input"],

Cell[BoxData[
    \(correction[an_] := 
      Module[{p, s}, \[IndentingNewLine]s = 
          Abbreviation[an]; \[IndentingNewLine]p = 
          Position[correctarr, {ToString[s], _}]; \[IndentingNewLine]If[
          p =!= {}, \(correctarr[\([p[\([1]\)]]\)]\)[\([1, 
              2]\)], {}]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ correction[e_, an_] := 
        Module[{f}, \[IndentingNewLine]f = correction[an]; 
            f[e]]\ useless\ *) \)], "Input"],

Cell[BoxData[
    \(correction[Ac]\)], "Input"],

Cell["as is Use: Apply[correction[Ac], elem]", "Text"],

Cell["note: no data on Uuu or Uub", "Text"],

Cell[BoxData[
    \(showe[Uun]\)], "Input"],

Cell[BoxData[
    \(ElectronConfigurationFormat[Uuu]\)], "Input"],

Cell[BoxData[
    \(ElectronConfiguration[Uun]\)], "Input"],

Cell[BoxData[
    \(AtomicNumber[Ir]\)], "Input"],

Cell["Keep a close eye on double corrected elems like Ir.", "Text"],

Cell[BoxData[
    \(ElectronConfigurationFormat[Ir]\)], "Input"],

Cell[BoxData[
    \(showe[Ir]\)], "Input"],

Cell[BoxData[
    \(showfe[Ir]\)], "Input"],

Cell[BoxData[
    \(showe[felementsNa[\([77]\)]]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["elecfmtv - printing electron conf. from arrays", "Subsubsection"],

Cell[TextData[{
  "IMPORTANT:  DO NOT USE   elecfmt[List] OR elecfmtv[List]  with  elements[] \
 USE ONLY  felements[].  (see examples, List is for fill order only, Symbol \
goes by ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s array from chem.m)"
}], "Text"],

Cell["\<\
this uses mathematica's array to show electronconfig
\t* it does not yet work for 1's format
\t\t? why not use this to make the 1's output ?
\t\t** see section above
\t* it's formatting is more appropriate later use w/ Boxes\
\>", "Text"],

Cell[TextData[{
  "origional order / shell order (uses ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s array)"
}], "Text"],

Cell[BoxData[
    \(elecfmtv[elem_Symbol] := 
      Module[{I, i, j}, 
        I = ElectronConfiguration[elem]; \[IndentingNewLine]Partition[
          Flatten[\[IndentingNewLine]Table[
              Table[\[IndentingNewLine]{i, asubshells[\([j]\)], 
                  I[\([i, j]\)]}, \[IndentingNewLine]{j, 1, 
                  Length[I[\([i]\)]]}\[IndentingNewLine]], {i, 1, 
                Length[I]}\[IndentingNewLine]]], 3]]\)], "Input"],

Cell["fill order / uses felements", "Text"],

Cell[BoxData[
    \(elecfmtv[e_List] := 
      Module[{i, n}, \[IndentingNewLine]n = 
          Length[e]; \[IndentingNewLine]Partition[
          Flatten[\[IndentingNewLine]Table[\[IndentingNewLine]{fnord[\([i]\)],\
 fcord[\([i]\)], Length[Flatten[e[\([i]\)]]]}\[IndentingNewLine], {i, 1, 
                n}\[IndentingNewLine]]], 3]]\)], "Input"],

Cell["add irregularities indication if Element is 2nd parameter", "Text"],

Cell["\<\
correct:\t \tadd e to last , take from next to last
correct2x:\tadd e to last , take from next to last, done twice
correct2:\tadd e to last , take from 2 before last
correct2x2:\tadd e to last , take from 2 before last, done twice
rcorrect: \tadd e after last, take from last
rcorrect2: \tadd e after last, take from last, add e to last take from last \
(correct)\
\>", "Text"],

Cell[BoxData[
    \(elecfmtv[e_List, an_Symbol] := 
      Module[{i, n, c, cc}, \[IndentingNewLine]n = 
          Length[e]; \[IndentingNewLine]cc = 
          correction[an]; \[IndentingNewLine]Partition[
          Flatten[\[IndentingNewLine]Table[\[IndentingNewLine]\
\[IndentingNewLine]c = cc; \[IndentingNewLine]If[
                c =!= {}, \[IndentingNewLine]If[
                  c \[Equal] correct && i \[Equal] n, 
                  c = "\<+\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct && i \[Equal] n - 1, 
                  c = "\<-\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x && i \[Equal] n, 
                  c = "\<++\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x && i \[Equal] n - 1, 
                  c = "\<--\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2 && i \[Equal] n, 
                  c = "\<+\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2 && i \[Equal] n - 2, 
                  c = "\<-\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x2 && i \[Equal] n, 
                  c = "\<++\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x2 && i \[Equal] n - 2, 
                  c = "\<--\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect && i \[Equal] n, 
                  c = "\<+\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect && i \[Equal] n - 1, 
                  c = "\<-\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect2 && i \[Equal] n, 
                  c = "\<++\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect2 && i \[Equal] n - 1, 
                  c = "\<--\>"]; \[IndentingNewLine]\[IndentingNewLine]If[
                  c \[Equal] correct || c \[Equal] correct2x || 
                    c \[Equal] rcorrect || c \[Equal] rcorrect2 || 
                    c \[Equal] correct2 || c \[Equal] correct2x2, 
                  c = {}];\[IndentingNewLine]]; \[IndentingNewLine]If[
                c =!= {}, \[IndentingNewLine]{fnord[\([i]\)], fcord[\([i]\)], 
                  Length[Flatten[e[\([i]\)]]], 
                  c}, \[IndentingNewLine]{fnord[\([i]\)], fcord[\([i]\)], 
                  Length[Flatten[
                      e[\([i]\)]]], "\<\>"}\[IndentingNewLine]]\
\[IndentingNewLine], {i, 1, n}\[IndentingNewLine]]], 4]]\)], "Input"],

Cell["\<\
unused for charts.  The text of.  Difficult to use to make 2D text \
with: it will pre-evaluate and remove essentials with, ie, \
ToExpression.\
\>", "Text"],

Cell[BoxData[
    \(elecfmt[e_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> "\<\>" <> \[IndentingNewLine]ToString[
              x[\([i, 2]\)]] <> "\<^\>" <> \[IndentingNewLine]ToString[
              x[\([i, 3]\)]]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(elecfmt[e_, an_Symbol] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e, an]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> "\<\>" <> \[IndentingNewLine]ToString[
              x[\([i, 2]\)]] <> "\<^\>" <> \[IndentingNewLine]ToString[
              x[\([i, 3]\)]] <> "\< \>" <> 
            x[\([i, 4]\)]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[TextData[{
  "specific to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Text"],

Cell[BoxData[
    \(elecfmtm[e_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> "\<\!\(\>" <> \[IndentingNewLine]ToString[
              x[\([i, 2]\)]] <> "\<\^\>" <> \[IndentingNewLine]ToString[
              x[\([i, 3]\)]] <> "\<\)\>"\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell["uses extra boxing wrap to keep \"++\"  with exp", "Text"],

Cell[BoxData[
    \(elecfmtm[e_, an_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e, an]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> \[IndentingNewLine]"\<\!\(\>" <> 
            ToString[x[\([i, 2]\)]]\[IndentingNewLine] <> "\<\^\(\>" <> 
            ToString[x[\([i, 3]\)]] <> 
            x[\([i, 4]\)]\[IndentingNewLine] <> \
"\<\)\)\>"\[IndentingNewLine], {i, 1, len}\[IndentingNewLine]]]\)], "Input"],

Cell[TextData[{
  "less specific to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Text"],

Cell[BoxData[
    \(elecfmtb[e_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]RowBox[{ToString[
                x[\([i, 1]\)]], "\< \>", 
              SuperscriptBox[ToString[x[\([i, 2]\)]], 
                ToString[x[\([i, 3]\)]]]}]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtb[e_, an_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e, an]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]RowBox[{ToString[
                x[\([i, 1]\)]], "\< \>", 
              SuperscriptBox[ToString[x[\([i, 2]\)]], 
                ToString[x[\([i, 3]\)]]\  <> 
                  x[\([i, 4]\)]\ \ ]}]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpb[
        e_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtb[e], "\< \>"]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpb[e_, 
        an_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtb[e, an], "\< \>"]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpm[
        e_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtm[e], "\< \>"]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpm[e_, 
        an_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtm[e, an], "\< \>"]]]\)], "Input"],

Cell[BoxData[
    \(elecfmt[Lanthanum]\)], "Input"],

Cell[BoxData[
    \(elecfmt[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell["\<\
IMPORTANT:  DO NOT USE   elecfmt[List] OR elecfmtv[List]  with  \
elements[]  USE ONLY  felements[].  (see examples)\
\>", "Text"],

Cell[BoxData[
    \(\(\(elecfmt[elements[\([AtomicNumber[Lanthanum]]\)]]\)\(\ \)\( (*\ 
      WRONG\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(\(elecfmtv[elements[\([AtomicNumber[Lanthanum]]\)]]\)\( (*\ 
      WRONG\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(elecfmtb[felements[\([AtomicNumber[Lanthanum]]\)]] // 
      DisplayForm\)], "Input"],

Cell[BoxData[
    \(elecfmtm[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpm[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell[TextData[{
  "FIXME / OOPS - note how ",
  StyleBox["Mathematica's",
    FontSlant->"Italic"],
  " array omitts 4f^0.  but fixing it might pooch their modules.  it's a \
preference thing anyhow."
}], "Text"],

Cell[BoxData[
    \(elecfmtpm[Lanthanum]\)], "Input"],

Cell[BoxData[
    \(ElectronConfiguration[Lanthanum]\)], "Input"],

Cell[BoxData[
    \(elecfmtpb[felements[\([AtomicNumber[Lanthanum]]\)]] // 
      DisplayForm\)], "Input"],

Cell[BoxData[
    \(ToBoxes[\(elecfmtm[
          felements[\([AtomicNumber[Lanthanum]]\)]]\)[\([1]\)]]\)], "Input"],

Cell[BoxData[
    \(ToBoxes[\*"\"\<1\!\(s\^0\)\>\""]\)], "Input"],

Cell[BoxData[
    \(ElectronConfigurationFormat[Lanthanum]\)], "Input"],

Cell[BoxData[
    \(elecfmt[La]\)], "Input"],

Cell[BoxData[
    \(elecfmt[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell[BoxData[
    \(\(showe[felements[\([AtomicNumber[Lanthanum]]\)]];\)\)], "Input"],

Cell[BoxData[
    \(showfe[Lanthanum]\)], "Input"],

Cell[TextData[{
  "Assume 1's aren't needed to be generated or on chart anywhere ,\nAssume \
wish to move from elecfmtv to fill order same fmt.\n\tI'm LEARY there is no \
measure to check against\n\tfor fill order , due to corrections , using ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s alone\n\t\twhich is one reason I though 1s would be easier\n\ndang - \
also the sort trick above won't work for elecfmtv ...\n\tmathematic omitts {} \
... alignment\n\t... and ford2ordarr doesn't include \"corrections\" (fall \
forward / back)\nPosition might work\n\twith {} left to remove ... and NOT \
remove ?\n\t\nThat being said and 1's being done\n\n\tnew elecfmt1 is easier \
i think"
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart trials - template, 2D, 3D tests", "Section"],

Cell[CellGroupData[{

Cell["trials", "Subsection"],

Cell["\<\
trials show Graphics3D is better for this task:
\t3D is harder at outset but mathematica has best support of
\t\t+ allows after-thought adding, re-scaling, anything
\tediting complex things in RTF editor ...
\t\t- seems attractive : ends up frustrating and timely too\
\>", "Text"],

Cell["chart Names into Shells by Lists length", "Text"],

Cell[BoxData[
    \(period = Table[{i}, {i, 7}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Table[\[IndentingNewLine]{\[IndentingNewLine]AppendTo[\
\[IndentingNewLine]\ period[\([shellsarr[\([i]\)]]\)], 
            Abbreviation[
              Elements[\([i]\)]]\[IndentingNewLine]]\[IndentingNewLine]}, {i, 
          Length[Elements]}\ \[IndentingNewLine] (*\ \(-2\)\ as\ eC\ is\ 0\ \
for\ 111\ and\ 112\ *) \[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Drop[period, 0, 1];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(% // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(per = Drop[period, 0, 1];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(perlens = 
        Table[Length[per[\([i]\)]], {i, 1, Length[per]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(mw = 
        Max[Table[Length[per[\([i]\)]], {i, 1, Length[per]}]];\)\)], "Input",
  Evaluatable->False],

Cell["\<\
Start with periodic which is already laid out by period.  Also \
Insert to spread right.\
\>", "Text"],

Cell[BoxData[
    \(\(ch2 = 
        Module[{gap, h, w, j, i, lst}, \[IndentingNewLine]ch1 = 
            per; \[IndentingNewLine]h = 
            Length[ch1]; \[IndentingNewLine]Table[\[IndentingNewLine]gap = 
              mw - perlens[\([i]\)]; \[IndentingNewLine]w = 
              mw - gap; \[IndentingNewLine]lst = 
              Table["\<\[CenterDot]\>", {j, 1, 
                  gap}]; \[IndentingNewLine]Flatten[\[IndentingNewLine]If[
                gap \[NotEqual] 0, \[IndentingNewLine]Insert[ch1[\([i]\)], 
                  lst, If[i > 1, 1, 0] + 
                    2], \[IndentingNewLine]ch1[\([i]\)]\[IndentingNewLine]]]\
\[IndentingNewLine], {i, 1, h}\[IndentingNewLine]]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(StyleBox["\<bob\>", FontWeight \[Rule] "\<Bold\>"]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch3 = ch2; 
    Table[\[IndentingNewLine]Table[\[IndentingNewLine]DisplayForm[\
\[IndentingNewLine]StyleBox[ch3[\([i, j]\)], 
            FontWeight \[Rule] "\<Bold\>"]\[IndentingNewLine]]\
\[IndentingNewLine], {j, 1, 
          Length[ch3[\([i]\)]]}\[IndentingNewLine]]\[IndentingNewLine], {i, 
        1, Length[ch3]}\[IndentingNewLine]];\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch3 = %;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch3[\([1, 1]\)]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(% // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Append[ch3, 
        Table[If[i \[LessEqual] 16, "\<-\>", "\<+\>"], {i, 1, mw}]] // 
      MatrixForm\)], "Input",
  Evaluatable->False],

Cell["\<\
Can use Take at 7,3 8,3 for (Lanthanum/Actinum) for \"lanthanide \
actinide series\"\
\>", "Text"],

Cell["Dang - there's a bad problem.  See below (below chart).", "Text"],

Cell[BoxData[
    \(Append[%, \[IndentingNewLine]Table[\[IndentingNewLine]Take[\
\[IndentingNewLine]elecfmtpm[\[IndentingNewLine]Elements[\([\(Position[
                      Abbreviation[Elements], ch1[\([6, i]\)]]\)[\([1, 
                      1]\)]]\)]\[IndentingNewLine]]\[IndentingNewLine], \
\(-4\)]\[IndentingNewLine], {i, 1, 
            mw}\[IndentingNewLine]]\[IndentingNewLine]] // 
      MatrixForm\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell[TextData[{
  "***************\nnothing \"easy\" from here maybe\n\nwith boxes:\n\t\
perfect result\n\tcan use simple editor\n\t\tHOWEVER editing is difficult\n\t\
\tand limited to limited rules conflicting with goal\n\tkerned\nwith boxes \
you have to have to build up or hack away\n\n\t(wrong , try again)\n\t",
  Cell[BoxData[
      \(Append[ch3[\([1, 1]\)], "\<bob\>"]\)], "Input"],
  "\n\t",
  Cell[BoxData[
      \(DisplayForm[
        StyleBox["H", \[IndentingNewLine]FontWeight \[Rule] "Bold"], 
        "bob"]\)], "Output"]
}], "Text"],

Cell["\<\
with graphics
\tperfection only if you hit on the right method you don't know

\t* 4 main \"paths\"
\t\tgraphics array
\t\t\teasy for 32x7
\t\t\t\"CANNOT BE COMBINED WITH
\t\t\t~Graphics~\"\t\t\t
\t\tarray of 2D graphics
\t\t3D graphics
\t\tShow combines 2D and 3D
\t* if you go by unit you must
\t\t0) no one can use editor / (is ps, maybe not svg ?)
\t\t1a) task of positioning units
\t\t1b) units get hard-coded , task of scaling each
\t\t3) loose any relations between blocks
\t\t\tie, cannot set property that applies to all\
\>", "Text"],

Cell["\<\
\t* gr needs vert as :
\t\teach item (each text, each pos, a matrix )
\t\teach vert must be functions
\t\titem style must be functions
\t\t\t\"a box\"
\t\t\tcontiains placeholders
\t\t\tscaling / ops can occur

\t* 2D may NOT be easier
\t\tno way to include 3D , diff. to convert to
\t\tmore \"built in interpretations\"\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["...", "Subsubsection"],

Cell["\<\
Graphics[Text[\"H\", 
  Scaled[{0, 0.3}, 
   {0.5, 0.5}], TextStyle -> 
   {FontSize -> 16, 
    FontWeight -> \"Bold\", 
    FontSlant -> \"Italic\"}, 
  Background -> Hue[0.5]]]\
\>", "Output"],

Cell[BoxData[
    \(\(tpos = \[IndentingNewLine]Table[\[IndentingNewLine]{j, 
            i}\[IndentingNewLine], {i, 1, 7}\[IndentingNewLine], {j, 1, 
            32}\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(tpos = Partition[Flatten[tpos], 2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(txt = \[IndentingNewLine]Table[\[IndentingNewLine]ch2[\([7 - i + 1, 
              j]\)]\[IndentingNewLine], {i, 1, 7}\[IndentingNewLine], {j, 1, 
            32}\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(txt = Flatten[txt];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[{
    \(\(Remove[gtxt1];\)\), "\[IndentingNewLine]", 
    \(\(gtxt1 = Table[i, {i, 1, 2\ ELEMENTS}];\)\)}], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Module[{i}, \[IndentingNewLine]i = 
        0; \[IndentingNewLine]While[\(++i\) \[LessEqual] 
          2\ ELEMENTS, \[IndentingNewLine]\(gtxt1[\([i]\)] = 
            Graphics[\[IndentingNewLine]sc = {N[1/\((1.1\ 32)\)], 
                  N[1/\((1.1\ 7)\)]}; \[IndentingNewLine]Text[\
\[IndentingNewLine]txt[\([i]\)]\[IndentingNewLine] (*\(,\)\(Scaled[
                    sc*tpos[\([i]\)], { .01,  .01}]\)*) \[IndentingNewLine] \
(*\ \(,\)\(r[{0.015, \(- .01\)} + 
                      sc*tpos[\([i]\)]]\)\ *) \[IndentingNewLine], {0, 
                  0}\[IndentingNewLine], 
                TextStyle -> {FontSize \[Rule] 8, 
                    FontSlant \[Rule] "\<Italic\>"}, 
                Background \[Rule] 
                  Hue[ .50]\[IndentingNewLine]]\[IndentingNewLine]];\)\
\[IndentingNewLine]]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(r[n_] := Rotate2D[n, N[2  \[Pi]]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Rotate2D[{1, 1}, N[\[Pi]]]\)], "Input",
  Evaluatable->False],

Cell["\<\

***********************************************
\
\>", "Text"],

Cell[BoxData[{
    \(\(Remove[gtxt];\)\), "\[IndentingNewLine]", 
    \(\(gtxt = Table[i, {i, 1, 2\ ELEMENTS}];\)\)}], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Module[{i}, \[IndentingNewLine]i = 
        0; \[IndentingNewLine]While[\(++i\) \[LessEqual] 
          2\ ELEMENTS, \[IndentingNewLine]sc = {N[1/\((1.1\ 32)\)], 
            N[1/\((1.1\ 7)\)]}; \[IndentingNewLine]gtxt[\([i]\)] = 
          Text[\[IndentingNewLine]txt[\([i]\)]\[IndentingNewLine] \
(*\(,\)\(Scaled[sc*tpos[\([i]\)], { .01,  .01}]\)*) \[IndentingNewLine], 
            r[{ .5, \(- .5\)} + {30, i}*tpos[\([i]\)]]\[IndentingNewLine], 
            TextStyle -> {FontSize \[Rule] 8, 
                FontSlant \[Rule] "\<Italic\>"}, 
            Background \[Rule] 
              Hue[ .50]\[IndentingNewLine]]\[IndentingNewLine]]\
\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(p = 
        Graphics[\[IndentingNewLine]{\[IndentingNewLine]GrayLevel[
              0.85]\[IndentingNewLine], 
            Rectangle[\[IndentingNewLine]r[{0, 0}], 
              r[{1000, 
                  1000}]\[IndentingNewLine]]\[IndentingNewLine]}\
\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(r[n_] := Rotate2D[n, \(-N[\[Pi]/2]\)];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go = 
      Show[p, \[IndentingNewLine]Graphics[\[IndentingNewLine]Table[
            gtxt[\([i]\)], {i, 1, 2\ ELEMENTS}]\[IndentingNewLine], 
          RotateLabel \[Rule] False\[IndentingNewLine], 
          ImageSize \[Rule] {6\ 72, 4\ 72}\[IndentingNewLine], 
          ImageRotated \[Rule] False\[IndentingNewLine], 
          PlotRange \[Rule] { .5,  \
.5}\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(gtxt2 = Partition[gtxt1, 32];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(gtxt3 = Array[f, {7, 32}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(i = 0; 
    While[\(++i\) \[LessEqual] 
        7, \[IndentingNewLine]\(gtxt3[\([i]\)] = 
          gtxt2[\([7 - i + 1]\)];\)\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g5 = GraphicsArray[gtxt3]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[GraphicsArray[gtxt3]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[p, g5]\)], "Input",
  Evaluatable->False],

Cell["Scaled moves L normal units from normal coord center R", "Text"],

Cell[BoxData[
    \(\(vertices = {{0, 0}, {0, 1}, {0, 1}, {1, 0}, {1, 1}};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(p = 
        Graphics[{GrayLevel[0.85], Rectangle[{0, 0}, {1, 1}]}];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(l = 
        Graphics[{Thickness[ .02], RGBColor[0, 0, 1], 
            Line[{{0, 1}, {0, 0}, {0, 0}, {1, 0}}]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(t1 = 
      Graphics[\[IndentingNewLine]Text[\[IndentingNewLine]ch2[\([1, 
              1]\)]\[IndentingNewLine], 
          Scaled[{0,  .3}, { .5,  .5}]\[IndentingNewLine], 
          TextStyle -> {FontSize \[Rule] 16, FontWeight \[Rule] "\<Bold\>", 
              FontSlant \[Rule] "\<Italic\>"}, 
          Background \[Rule] 
            Hue[ .50]\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(InputForm[%]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(t2 = 
      Graphics[\[IndentingNewLine]Text[\[IndentingNewLine]elecfmtpm[
            H]\[IndentingNewLine], { .5,  .5}\[IndentingNewLine], 
          TextStyle -> {FontSize \[Rule] 16, FontWeight \[Rule] "\<Bold\>", 
              FontSlant \[Rule] "\<Italic\>"}, 
          Background \[Rule] 
            Automatic\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g2 = Show[t1, t2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g1 = Show[p, l];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Show[g1, g2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Show[p, l, t1, t2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g1 = 
      Graphics3D[{\[IndentingNewLine]Cuboid[\[IndentingNewLine]Scaled[{ .5,  \
.5,  .5}]\[IndentingNewLine], 
            Scaled[{ .6,  .6,  .6}]\[IndentingNewLine]]}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g2 = 
      Graphics3D[{\[IndentingNewLine]Cuboid[\[IndentingNewLine]Scaled[{ .8,  \
.5, 0}]\[IndentingNewLine], 
            Scaled[{ .9,  .9,  .9}]\[IndentingNewLine]]}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g3 = 
      Graphics3D[\[IndentingNewLine]{\[IndentingNewLine]Text[\
\[IndentingNewLine]"\<hi bob !\>"\[IndentingNewLine], 
            Scaled[{ .5,  .1,  .5}]\[IndentingNewLine]\[IndentingNewLine], 
            TextStyle \[Rule] \[IndentingNewLine]{FontSize \[Rule] 8, 
                FontSlant \[Rule] "\<Italic\>"}\[IndentingNewLine], 
            Background \[Rule] 
              Hue[ .50]\[IndentingNewLine]\[IndentingNewLine]]\
\[IndentingNewLine]}\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(InputForm[%]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]{Point[{0, 0, 0}], 
              Point[Scaled[{0, 0, 0}, {0, 
                    0, \(- .2\)}]]}\[IndentingNewLine], {Text["\<a point\>", 
                Scaled[{ .5,  .5,  .5}]]}\[IndentingNewLine]}];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]\[IndentingNewLine]{Line[{{0, 0, 
                    0}, {1, 0, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 1, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 0, 
                    1}}]}\[IndentingNewLine]\[IndentingNewLine]\
\[IndentingNewLine], {Line[ .95 {{0, 0, 0}, {1, 0, 
                      0}, { .95,  .1,  .1}}]}\[IndentingNewLine], {Line[ .95 \
{{0, 0, 0}, {0, 1, 
                      0}, { .1,  .95,  .1}}]}\[IndentingNewLine], {Line[ .95 \
{{0, 0, 0}, {0, 0, 
                      1}, { .1,  .1,  .95}}]}\[IndentingNewLine]\
\[IndentingNewLine]\[IndentingNewLine], {Text["\<+X1\>", 
                Scaled[{ .1,  .05,  .05},  .80 {1, 0, 
                      0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<+Y1\>", 
                Scaled[{ .01,  .1,  .01},  .80 {0, 1, 
                      0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<+Z1\>", 
                Scaled[{ .01,  .01,  .1},  .80 {0, 0, 
                      1}]]}\[IndentingNewLine]\[IndentingNewLine]\
\[IndentingNewLine], {Text["\<X0\>", 
                Scaled[{ .01,  .01,  .01}, { .1, 0, 
                    0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<Y0\>", 
                Scaled[{ .01,  .01,  .01}, {0,  .1, 
                    0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<Z0\>", 
                Scaled[{ .01,  .01,  .01}, {0, 
                    0,  .1}]]}\[IndentingNewLine]\[IndentingNewLine]}\
\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[g1, g2, g3, g4]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Remove[p, l, r, g1, g2, g3, g4, g5, t1, t2, vertices, gtxt, gtxt1, 
        gtxt2, period, per, perlens, mw, ch2, ch3, tpos, txt, sc, 
        go];\)\)], "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart generation", "Subsubtitle",
  FontSize->21,
  Background->GrayLevel[0.900008]],

Cell["\<\
after any changes made re-evaluate this section (or parts of).  the \
above text charts / chem data are assume to be made.\
\>", "Text"],

Cell[CellGroupData[{

Cell["discussions", "Section"],

Cell[CellGroupData[{

Cell["Discuss / Editing Element Data Directions", "Subsubsection"],

Cell[TextData[{
  "copy and past a data item.  change it's data source.  see layout below \
(placement offset relative to center of cell).\n\nadvanced: makes template \
table , data items fill data where in chart the template has elem  and uses \
layout3 as to placement from center of cell, then use cmat (offset, rotation, \
scale) to do any \"whole chart\" translation.  legends are handled separately \
(except helpcell is made automatically)\n\nbad news is it's free form.  good \
news is it's free form.  each item is placed separately (though with helper \
fun for positions) so there are no firm rules as to what can be done. **\n\n\
The below makes 2D color, 2D black & white, 3D chart.\n\nIf there is one \
glitch in the process below (and it's turning out to be a one) it is that \
it's not easy to go between color and b&w fonts because ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " adds neer unknowable offsets for \"boxing\".  Unless you can export math \
fonts for your purpose one needs to avoid symbols: meaning one can't truely \
avoid it if \"/\" will be printed (see geninit) - and really it must be - \
which is why b&w chart was first viewed.\n\nKeep in mind the above prepares \
to provide data and below to make the chart and are completely separate \
projects per say: the 3D chart is complete hobbish due to (snip story).  \
Arguably it'd be better to have a Cell to edit which has markers where to \
assign data and program copy these.  However if that is done the 3D ability \
is ruined.  Unless one about hacks into ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " and PS boxing, kerning, etc to get per-character positions: the value of \
that is at least as highly questionable.  Maybe a good argument is to drop \
automated 3D assembling of the table of elements.  Maybe so but it is hobby \
work\n\n-----------------------------------\n\n** while it's a clunky to \
provide a position for [most/each] text  specifically - when it comes to ways \
and means to print: it means things are not jumping around and ruining graph. \
 boxing problems can be endless if you choose \"an imperfect choice\" toward \
getting a layout.  See \"Group Alias\" section for an example."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["TODO  warnings for chart", "Subsubsection"],

Cell["\<\
check other pre-made charts above or even arrays
\tpage 2
\tdon't put (most desired) in plot but on normal page\
\>", "Text"],

Cell["trends in notes ascii or spcl arrows & text", "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart template ch2b - template of the periodic table", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
To make it \"doable\".  needs to be \"use or not\" able
\t*  text / data tables in 32x7 format (if not edited otherwise)
\t*  vert. in 32x7 tables (add, scaling, rot)
\t*  each data attrib , font size  font face, separately
\t*  flatten : ++ i  scanned

* use functions ... allow unexpected changes
* generic loop may reduce the above
* \"rule\" : remember Ac / La are moved later , lines later
* { x \[RightArrow] , y (into) , z \[UpArrow] }  from LL screen\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["ch2 / base", "Subsubsection"],

Cell[BoxData[
    \(period = Table[{i}, {i, 7}]\)], "Input"],

Cell[BoxData[
    \(\(Table[\[IndentingNewLine]{\[IndentingNewLine]AppendTo[\
\[IndentingNewLine]\ period[\([shellsarr[\([i]\)]]\)], 
            Abbreviation[
              Elements[\([i]\)]]\[IndentingNewLine]]\[IndentingNewLine]}, {i, 
          Length[Elements]}\ \[IndentingNewLine] (*\ \(-2\)\ as\ eC\ is\ 0\ \
for\ 111\ and\ 112\ *) \[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Drop[period, 0, 1];\)\)], "Input"],

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    \(\(per = Drop[period, 0, 1];\)\)], "Input"],

Cell["OOPS - need full names more really...", "Text"],

Cell[BoxData[
    \(periodlong = Table[{i}, {i, 7}]\)], "Input"],

Cell[BoxData[
    \(\(Table[\[IndentingNewLine]{AppendTo[\[IndentingNewLine]\ 
            periodlong[\([shellsarr[\([i]\)]]\)], 
            Elements[\([i]\)]\[IndentingNewLine]]}, {i, 
          Length[Elements]}\ ];\)\)], "Input"],

Cell[BoxData[
    \(\(Drop[periodlong, 0, 1];\)\)], "Input"],

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    \(\(perlong = Drop[periodlong, 0, 1];\)\)], "Input"],

Cell[BoxData[
    \(\(perlens = 
        Table[Length[per[\([i]\)]], {i, 1, Length[per]}];\)\)], "Input"],

Cell[BoxData[
    \(\(mw = 
        Max[Table[Length[per[\([i]\)]], {i, 1, Length[per]}]];\)\)], "Input"],

Cell["\<\
Start with periodic which is already laid out by period.  Also \
Insert to spread right.\
\>", "Text"],

Cell[BoxData[
    \(\(ch2 = 
        Module[{gap, h, w, j, i, lst}, \[IndentingNewLine]ch1 = 
            per; \[IndentingNewLine]h = 
            Length[ch1]; \[IndentingNewLine]Table[\[IndentingNewLine]gap = 
              mw - perlens[\([i]\)]; \[IndentingNewLine]w = 
              mw - gap; \[IndentingNewLine]lst = 
              Table["\<\>", {j, 1, 
                  gap}]; \[IndentingNewLine]Flatten[\[IndentingNewLine]If[
                gap \[NotEqual] 0, \[IndentingNewLine]Insert[ch1[\([i]\)], 
                  lst, If[i > 1, 1, 0] + 
                    2], \[IndentingNewLine]ch1[\([i]\)]\[IndentingNewLine]]]\
\[IndentingNewLine], {i, 1, h}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(ch2\  // TableForm\)], "Input"],

Cell[BoxData[
    \(\(ch2b = 
        Module[{gap, h, w, j, i, lst}, \[IndentingNewLine]ch1 = 
            perlong; \[IndentingNewLine]h = 
            Length[ch1]; \[IndentingNewLine]Table[\[IndentingNewLine]gap = 
              mw - perlens[\([i]\)]; \[IndentingNewLine]w = 
              mw - gap; \[IndentingNewLine]lst = 
              Table["\<\>", {j, 1, 
                  gap}]; \[IndentingNewLine]Flatten[\[IndentingNewLine]If[
                gap \[NotEqual] 0, \[IndentingNewLine]Insert[ch1[\([i]\)], 
                  lst, If[i > 1, 1, 0] + 
                    2], \[IndentingNewLine]ch1[\([i]\)]\[IndentingNewLine]]]\
\[IndentingNewLine], {i, 1, h}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(docolor = 1;\)\)], "Input"],

Cell["the chart code below assumes long names are used", "Text"],

Cell[BoxData[
    \(ch2b // TableForm\)], "Input"],

Cell[BoxData[
    \(n = Dimensions[ch2b]\)], "Input"],

Cell["no clobber .ps filename", "Text"],

Cell[BoxData[
    \(\(widechart = True;\)\)], "Input"],

Cell[BoxData[
    \(\(ch2bsave = ch2b;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
(*   Optional:  Rearrange text of Table of Elements
ex. to make La / Ac series.   Mark this section as eval or non-eval.   \
*)\
\>", "Subsection",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
(* 
this secion works only for possibly col 4 min through col 16 max
\tit knows how to move around 2 rows only that is
*)\
\>", "Text"],

Cell[BoxData[
    \(\(widechart = False;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = ch2bsave;\)\)], "Input",
  Evaluatable->False],

Cell["\<\
(* see in lower / lan act series.  note things move to left 10 not \
11 *)\
\>", "Text"],

Cell[BoxData[
    \(\(groupdrop = {4, 11};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(groupdrop = {4, 10};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(groupdrop = {4, 13};\)\)], "Input",
  Evaluatable->False],

Cell["(* what to chop out of group if chart is squeezed *)", "Text"],

Cell[BoxData[
    \(\(n = Dimensions[ch2b];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(chartheight = n[\([1]\)];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(chartwidth = n[\([2]\)];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(n =. ;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch =. ; cw =. ;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch = chartheight; cw = chartwidth;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2bAlt = ch2b;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = ch2bAlt;\)\)], "Input",
  Evaluatable->False],

Cell["(* ignore , just show cell numbers we're moving down *)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Flatten[
      Table[Table[\((i - 1)\) 32 + j, {j, First[groupdrop], 
            Last[groupdrop]}], {i, 6, 7}]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \({164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 196, 197, 198, 199, 
      200, 201, 202, 203, 204, 205}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Append[{{1, 2}, {3, 4}}, {5, 6}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \({{1, 2}, {3, 4}, {5, 6}}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(ch2bAlt = ch2b;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = ch2bAlt;\)\)], "Input",
  Evaluatable->False],

Cell["\<\
(* add 3 rows at bottom of table *)
\t(* 32 across to start with , elements are const that way *)\
\>", "Text"],

Cell[BoxData[
    \(\(ch2b = Append[ch2b, Table["\<\>", {j, 32}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = Append[ch2b, Table["\<\>", {j, 32}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = Append[ch2b, Table["\<\>", {j, 32}]];\)\)], "Input",
  Evaluatable->False],

Cell["\<\
(* copy 2 lines 3 down *)
\t(* here 6 7 refer to last two shell lines, 3 means we cp them 3 rows down \
*)\
\>", "Text"],

Cell[BoxData[
    \(Do[Do[\[IndentingNewLine]ch2b[\([i + 3, j]\)] = 
          ch2b[\([i, j]\)]; \[IndentingNewLine]ch2b[\([i, 
              j]\)] = "\<\>";\[IndentingNewLine], {j, First[groupdrop], 
          Last[groupdrop] + 1}]\[IndentingNewLine], {i, 6, 
        7}\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(ch2b[\([6 + 3, 4]\)]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Cerium\)], "Output"]
}, Closed]],

Cell["\<\
(* copy the right part of chart n spaces left (part one of moving \
left to squeeze chart in).  (could move 8 but one less, 7, is prettier it \
shows an empty cell for emphasis) *)\
\>", "Text"],

Cell[BoxData[
    \(Do[Do[\[IndentingNewLine]\(ch2b[\([i, 
                j - \((Last[groupdrop] - First[groupdrop] + 1)\)]\)] = 
            ch2b[\([i, j]\)];\)\[IndentingNewLine], {j, Last[groupdrop] + 2, 
          32}], {i, 
        1, \((Last[groupdrop] - First[groupdrop] - 1)\)}]\)], "Input",
  Evaluatable->False],

Cell["\<\
(* shows there's chaff on right to remove due to underlap / \
pinching *)\
\>", "Text"],

Cell[BoxData[
    \(ch2b // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \( (*\ Do[
        Do[\[IndentingNewLine]\(ch2b[\([i, 
                  j]\)] = "\<\>";\)\[IndentingNewLine], {j, 26, 32}], {i, 1, 
          7}]*) \)], "Input",
  Evaluatable->False],

Cell["\<\
(* this takes the chaff off left after col 32 do Copy to left - so \
as to finish a Move to left *)
\t(* 10 is number of row total == 7 old + 3 new *)\
\>", "Text"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]\(ch2b[\([i]\)] = 
          Take[ch2b[\([i]\)], 
            32 - \((Last[groupdrop] - First[groupdrop] + 
                  1)\)];\)\[IndentingNewLine], {i, 1, 10}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch2b // TableForm\)], "Input",
  Evaluatable->False],

Cell["(* ignore *)", "Text"],

Cell[BoxData[
    \(\(Flatten[
        Table[Table[\[IndentingNewLine]\((i - 1)\) 32\  + 
              j\[IndentingNewLine], {j, 12, 32}], {i, 1, 7}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Flatten[{\[IndentingNewLine]Range[0\ cw + 4, 
            0\ cw + 10 + 1], \[IndentingNewLine]Range[1\ cw + 4, 
            1\ cw + 10 + 1], \[IndentingNewLine]Range[\((ch - 1)\)\ cw + 
              4, \((ch - 1)\)\ cw + 10 + 
              1]\[IndentingNewLine]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Flatten[{\[IndentingNewLine]Range[0\ cw + 12, 
            1\ cw + cw], \[IndentingNewLine]Range[1\ cw + 12, 
            2\ cw + cw], \[IndentingNewLine]Range[2\ cw + 12, 
            3\ cw + cw], \[IndentingNewLine]Range[3\ cw + 12, 
            4\ cw + cw], \[IndentingNewLine]Range[4\ cw + 12, 
            5\ cw + cw], \[IndentingNewLine]Range[5\ cw + 12, 
            6\ cw + cw], \[IndentingNewLine]Range[6\ cw + 12, 
            6\ cw + cw]\[IndentingNewLine]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch =. ; cw =. ;\)], "Input",
  Evaluatable->False],

Cell["\<\
(* one may want to quit kernel and re-eval notebook between changes \
though not required. *)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["finish up", "Subsection",
  Evaluatable->True],

Cell["(* make sure dimensions are square and regular *)", "Text",
  Evaluatable->True],

Cell[BoxData[
    \(n = Dimensions[ch2b]\)], "Input"],

Cell[BoxData[
    \(\(chartheight = n[\([1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(chartwidth = n[\([2]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(n =. ;\)\)], "Input"],

Cell["\<\
(* reset these here since there may be graphic leftovers seen if \
not HOWEVER don't do it after defining functions do it only before function \
def *)\
\>", "Text",
  Evaluatable->True],

Cell[BoxData[
    \(\(Remove[go, gr, go2D, gr2D];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[go2, gr2, go22D, gr22D, go2DBW];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[odat, opos, odir, oattr];\)\)], "Input"],

Cell[BoxData[
    \(go =. ; gr =. ; go2D =. ; gr2D =. ;\)], "Input"],

Cell[BoxData[
    \(go2 =. ; gr2 =. ; go22D =. ; gr22D =. ; go2DBW =. ;\)], "Input"],

Cell[BoxData[
    \(odat =. ; opos =. ; odir =. ; oattr =. ;\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["elements text and data  (reset)", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["\<\
discuss pos / opos (discussion of Center of Cell graphics \
posotioning)\
\>", "Subsubsection"],

Cell[TextData[{
  StyleBox["(*\n\nMathematica",
    FontSlant->"Italic"],
  "'s default is { x \[RightArrow] , y \[CircleTimes] , z \[UpArrow] } from \
{LL, LL, Screen)\n(\[CircleDot] is out of, \[CircleTimes] is into)\neach \
element datum adds offset from center from where cell center is\nthat is: \n\t\
i , take whereami in ch2b element table (1,1 to 32,7) (centerpos)\n\tadd fake \
elements (ie, {1,1} to make room for labels) (centertrans)\n\tdialate or \
contract the table (centerscale)\n\trotate whole deal (centerrot)\n\tadd any \
final offset for plot fitting chart (plottrans)\n\t==> C center of element in \
table offset position from here\n\t(obviously Center of Cell has no offset)\n\
\t\t* now each item in chart sets layou[] and uses opos[]\n\t\t   so \
placement is relative to center of cell for element\nelements may rotate \
their offset to same rotation here (see layout),\n\t(table read horiz or \
vert)\nelements can deal with width by:\n\tpadding data\n\tor by using \
functional in it's layout[] entry\n\t\t(meaning has custom calc. from center \
C)\nbecuase it's a plot\n\textra data / graphics that don't fit into ch2b \
cells\n\twell would be overlaid later\n*)"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["common / graphics", "Subsection",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(*
Set up things so each thing plotted text is done by this:
\tTable [ Graphicsxx [ Text[ odat[o,i], opos[o,i], oattr[o,i] ] ] xx ]
\todat (ie elemnt name) , opos (use cmat to place text), attr (look of text)
Each of these are place in the plot separately.  (see below) opos per text \
uses convenience functions so that each element's text is grouped together by \
a center posotion for that element.
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["setup", "Subsubsection",
  Background->GrayLevel[0.900008]],

Cell[BoxData[
    \(\(defdepth =  .1;\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(do3D = 1\) \)\(;\)\(\ \)\( (*\ 
      whether\ to\ do\ 3  d\ chart\ as\ well\ *) \)\)\)], "Input"],

Cell["\<\
(* number of items per element defined below (tot. items per \
element).  could use ++objects per object but that is obstructive to some \
tasks *)\
\>", "Text"],

Cell[BoxData[
    \(\(textobjects = 38;\)\)], "Input",
  Background->RGBColor[0.8, 1, 1]],

Cell[BoxData[
    \(\(objects = 1;\)\)], "Input"],

Cell[BoxData[
    \(\(leftalign = 1;\)\)], "Input"],

Cell["(* ? have not set up units - that will be a pain later *)", "Text"],

Cell["(* other objects need for lookup *)", "Text"],

Cell["\<\
(* elem only names where atomic name from ch2b is in odat, all \
others start from 0 and up *)\
\>", "Text"],

Cell[BoxData[
    \(\(elem =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(\(elem = 1000;\)\(\ \)\( (*\ 
      odat[elem, n]\ is\ an\ atomic\ name\ *) \)\)\)], "Input"],

Cell["\<\
(* make element table flat \"since graphics are list\".  unsure if \
this is productive but all of the below use it this way and Show cannot show \
complex list graphics anyhow. *)\
\>", "Text"],

Cell[BoxData[
    \(\(elemdat = 
        Table[ch2b[\([chartheight - i + 1, j]\)], {i, 1, chartheight}, {j, 1, 
            chartwidth}];\)\)], "Input"],

Cell["(* generic item in chart *)", "Text"],

Cell[BoxData[
    \(\(elemdat = Flatten[elemdat];\)\)], "Input"],

Cell[BoxData[
    \(\(objlen = Length[elemdat];\)\)], "Input"],

Cell["\<\
(* odat is an empty array - each \"item\" in chart puts data into \
it below *)\
\>", "Text"],

Cell[BoxData[
    \(\(odat[elem, i_] := elemdat[\([i]\)];\)\)], "Input"],

Cell["\<\
(* table is numbered weird these might help ...
(there's likely no reason for table to be upside down from here on - though \
there had been in initial trials) *)\
\>", "Text"],

Cell[BoxData[
    \(whereis[s_Symbol] := 
      Module[{v}, v = Position[elemdat, s]; 
        If[v \[NotEqual] {}, v[\([1, 1]\)]]]\)], "Input"],

Cell[BoxData[
    \(whereis2D[s_Symbol] := 
      Module[{v}, v = Position[ch2b, s]; 
        If[v \[NotEqual] {}, v[\([1, 1]\)] = 8 - v[\([1, 1]\)]; 
          v[\([1]\)]]]\)], "Input"],

Cell[BoxData[
    \(whatis[i_Integer] := odat[elem, i]\)], "Input"],

Cell[BoxData[
    \({whereis[Lanthanum], whatis[35], whereis2D[Lanthanum]}\)], "Input"],

Cell[BoxData[
    \(\(helpcell = whereis[Magnesium] + 4;\)\)], "Input"],

Cell[BoxData[
    \(\(helpcell = whereis[ (*Sodium*) Lithium] + 4;\)\)], "Input"],

Cell[BoxData[
    \(whereis[ (*Sodium*) Lithium] + 4\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["cmat", "Subsubsection"],

Cell["\<\
fixme:   cmat was define below with layout but ...
\topos is used/evaluated in data/text 
\tand for some reason needs to be above now
cmat simply holds vecs for
\t{ centertrans, centerrot, centerscale,  plottrans }
\t* only centerscale is in use
\t** If one thinks cmat needs to be changed it probably doesn't.
\t* only centerscale is in use
\t* it only changes distance between cells
\t* it doesn't effect contents or data placements from the center
\t* if cells are added or remvoed doesn't effect this
\t   (holding all other things held constant)

---------------------------
** the plot is set so the smallest font, 1, works with two columns with \
normal accuracy numbers (it's atomic).  However!  See Show the fonts can be \
get \"spread out\" just by choosing ImageSize and subst fonts.  If needing to \
rotate or zoom in: use gv(1) it does that and has a zoom 64x pop-up.

Q:  when does cmat need to be changed ?
A:  most anything can be done elsewise (ie, see above, ie rotating is easier \
with print / viewer).  more likely only in 3D plot \"movement\" situations \
where the chart is itself only one item among others\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"cmatb", "=", GridBox[{
              {"0", "0", "0"},
              {\(1/\((1.1\ 32)\)\), "0", \(1/\((1.1\ 7)\)\)},
              {"0", "0", "0"},
              {"0", "0", "0"}
              }]}], ";"}], 
      RowBox[{"(*", " ", GridBox[{
            {\(extra\ elem\)},
            {\(ch\ scale\)},
            {\(ch\ rot\)},
            {\(plot\ \(\(off\)\(.\)\)\)}
            }], "*)"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"cmat", "=", 
        RowBox[{"cmatb", " ", 
          RowBox[{"(", GridBox[{
                {"1", "1", "1"},
                {"12", "1", "3"},
                {"1", "1", "1"},
                {"1", "1", "1"}
                }], ")"}], " ", "100"}]}], ";"}]], "Input"],

Cell["\<\
for x lower numbers make cells thinner, for y smaller numbers make \
cells shorter\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{"cmat", "=", 
        RowBox[{"cmatb", " ", 
          RowBox[{"(", GridBox[{
                {"1", "1", "1"},
                {"10.2", "1", "2.70"},
                {"1", "1", "1"},
                {"1", "1", "1"}
                }], ")"}], " ", "100"}]}], ";"}]], "Input"],

Cell[BoxData[
    \(cmat // MatrixForm\)], "Input"],

Cell["\<\
(* generic position helper function:
\tdata items per element to plot offset from centerpos of element's cell
\t\t* allows data plotting to follow the same placement for every element
\t\t   ie, place to put An within each element box if An is used at all
\t\t* see: discuss pos / opos in Center of Cell definition above *)\
\>", \
"Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["setup continued", "Subsubsection"],

Cell[BoxData[
    \(\(opos[o_, i_] := 
        N[\[IndentingNewLine]opos[1, 
              i] + \[IndentingNewLine]Rotate3D[\[IndentingNewLine]layout[\([o]\
\)]\[IndentingNewLine], Sequence @@ N[cmat[\([3]\)]]\[IndentingNewLine], 
              opos[1, i]\[IndentingNewLine]]\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \( (*\(opos[1, i_] := 
          N[plottrans + 
              centerrot[\[IndentingNewLine]\((centerscale\ \((centertrans + 
                        centerpos[\([i]\)])\))\)\[IndentingNewLine]]];\)*) \
\)], "Input"],

Cell["(* offset allows left aligned text *)", "Text"],

Cell["\<\
(* OOPs there is no z text direction and note no z offset  either \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        leftalign === 
          1, \[IndentingNewLine]ooffset[o_, i_] := {\(-1\), 
            0}, \[IndentingNewLine]ooffset[o_, i_] := {0, 
            0}\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
(* should allow verticle text - but does not comletely work (ok, \
unused anyhow) *)\
\>", "Text"],

Cell[BoxData[
    \(\(odir[o_, i_] := {1, 0, 0};\)\)], "Input"],

Cell["\<\
(* OOPs there is no z text direction and note no z offset  either \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(odir[o_, i_] := {1, 0};\)\)], "Input"],

Cell["(* and no default ooffset *)", "Text"],

Cell["\<\
(* used if efuns[[i]] (ie, Abbreviation) is same as text wanted for \
dat *)\
\>", "Text"],

Cell[BoxData[
    \(\(gendat[fun_, pad_] := 
        Module[{v}, \[IndentingNewLine]Table[\[IndentingNewLine]v = 
              odat[elem, i]; \[IndentingNewLine]v = 
              If[v =!= "\<\>", 
                fun[odat[elem, i]], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", 
              If[\[Not] StringQ[v], 
                v = ToString[v]]]; \[IndentingNewLine]padit[v, 
              pad]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(gendat[fun_] := 
        Module[{v}, \[IndentingNewLine]Table[\[IndentingNewLine]v = 
              odat[elem, i]; \[IndentingNewLine]v = 
              If[v =!= "\<\>", 
                fun[odat[elem, i]], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", 
              If[\[Not] StringQ[v], 
                v = ToString[
                    v]]]; \[IndentingNewLine]v\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ v = 
        StringJoin[
            v]\ join\ was\ for\ \(\(what\)\(\ \)\(?\)\)\ *) \)], "Input"],

Cell["\<\
(*

howto printing numbers the correct / long way
units:  First is allot easier to remove units and always works for many efuns
bookform:  only Abunances need fNbookForm, others are already ok for chart
Below: does it all

NOTE: most dat items set \"funname=getnum\" and call getdat[ fun ] which \
kinda preens it or at one time was needed for numbers.  getdat is expected to \
return text not expr.

*)\
\>", "Text"],

Cell[BoxData[
    \( (*\[IndentingNewLine]slightly\ improved\ one\ \
below\[IndentingNewLine]getnum[funname_, element_] := 
        Module[{fip, funnum, num}, \[IndentingNewLine]fip = 
            funname[element]; \[IndentingNewLine]If[fip === Unknown, 
            Return["\<?\>"]]; 
          funnum = \(Position[efuns, funname]\)[\([1, 
                1]\)]; \[IndentingNewLine]fip = 
            fip\ \((1/
                  efunsunits[\([funnum]\)])\); \[IndentingNewLine]num = \
\(efunsnum[\([funnum]\)]\)[
              fip]; \[IndentingNewLine]num\[IndentingNewLine] (*\ 
            Map[efunsnum[\([funnum]\)], 
              funname[Elements]\ \((1/
                    efunsunits[\([funnum]\)])\)\ ]\ *) \[IndentingNewLine] \
(*\ \(efunsnum[\([funnum]\)]\)[
                funname[element]]\ \((1/
                  efunsunits[\([funnum]\)])\)\ *) \[IndentingNewLine]]\
\[IndentingNewLine]*) \)], "Input"],

Cell[TextData[{
  "(*\npurpose:\n\t* if it's on the chart it needs to \"not lie\"\n\t* some \
things need message side , most can be on chart\n\t   avoid use of messages \
and don't want both surely\nnotes: \n\t* very specific to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " chem data\n\t* ignore unstable isotopes that have known atomic weights, \
there are many\n\t* for old CRC OS dat, if {} the odat just leaves it blank, \
like chart was\n\t* for ElectronAffinity 0's don't show <0>0 or -0 and leave \
it as a note\n\t* there are only \n*)"
}], "Text"],

Cell[BoxData[
    \(ve[elem_Symbol | elem_String, fun_Symbol] := 
      Module[{v, p, ab, e}, \[IndentingNewLine]p = 
          Position[efuns, fun]; \[IndentingNewLine]If[p \[Equal] {}, 
          Return[Null]]; \[IndentingNewLine]p = 
          p[\([1, 1]\)]; \[IndentingNewLine]ab = 
          AbbreviationFromEither[elem]; \[IndentingNewLine]If[
          ab \[Equal] Null, Return[Null]]; \[IndentingNewLine]e = 
          ElementFromEither[
            elem]; \[IndentingNewLine]Miscellaneous`ChemicalElements`Private`\
mess = {}; \[IndentingNewLine]{fun[e], ab, efunsab[\([p]\)], 
          m2}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(ve2[elem_Symbol | elem_String, fun_Symbol] := 
      Module[{v}, \[IndentingNewLine]v = ve[elem, fun]; \[IndentingNewLine]If[
          v \[Equal] Null, Return[]]; \[IndentingNewLine]v = 
          Append[v, 0]; \[IndentingNewLine]If[v[\([1]\)] \[Equal] Unknown, 
          Return["\<?\>"]]; \[IndentingNewLine]If[
          v[\([4]\)] \[NotEqual] {}, \[IndentingNewLine]v[\([5]\)] = 
            1; \[IndentingNewLine]If[
            StringMatchQ[
              v[\([4, 1]\)], "\<No * exists.\>"], \[IndentingNewLine] (*\ 
              no\ stabel\ isotope\ , \ 
              show\ in\ chart\ *) \[IndentingNewLine]v[\([5]\)] = 
              2\[IndentingNewLine] (*\ 
              else\ its\ a\ needed\ message\ about\ data\ v[\([5]\)] \[Equal] 
                1\ already\ *) \[IndentingNewLine]];\[IndentingNewLine]]; \
\[IndentingNewLine]v\[IndentingNewLine]]\)], "Input"],

Cell["\<\
(*
purpose:
\t* just return string for number without units
\t* new: use ve2 to mark \"un\" unstable or \"*\" see notes
\t* baked
\t   should be done after returning number as to whether it is ok
\t   to convert num to string but that means doing it like 30 times
\t   anyhow the layout is for the same not for 2D boxed nums
*)\
\>", "Text"],

Cell[BoxData[
    \(\(\( (*\ 
      returns\ string\ not\ expr\ *) \)\(\[IndentingNewLine]\)\(getnum[
        funname_, element_] := 
      Module[{fip, funnum, num, v}, \[IndentingNewLine]fip = 
          funname[element]; \[IndentingNewLine]If[fip === Unknown, 
          Return["\<?\>"]]; \[IndentingNewLine]funnum = \(Position[efuns, 
              funname]\)[\([1, 1]\)]; \[IndentingNewLine]v = 
          ve2[element, funname]; \[IndentingNewLine]If[v \[Equal] Null, 
          Return["\<\>"]]; \[IndentingNewLine]If[
          v[\([1]\)] \[Equal] "\<none\>", 
          Return["\<none\>"]]; \ \[IndentingNewLine]fip = 
          fip\ \((1/
                efunsunits[\([funnum]\)])\); \[IndentingNewLine]num = \
\(efunsnum[\([funnum]\)]\)[fip]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          tostring\ to\ insure\ NumberMark\ is\ gone\ \ \
*) \[IndentingNewLine]If[NumberQ[num], num = ToString[num]]; \n
        If[StringTake[num, \(-1\)] \[Equal] "\<.\>", 
          num = StringDrop[num, \(-1\)]]; \n
        If[StringTake[num, \(-2\)] \[Equal] "\<.*\>", 
          num = StringDrop[
                n, \(-2\)] <> "\<*\>"]; \
\[IndentingNewLine]\[IndentingNewLine] (*\ \(If[v[\([5]\)] \[Equal] 2, 
              num = SuperscriptBox[num, u]];\)\ *) \[IndentingNewLine]If[
          v[\([5]\)] \[Equal] 2, 
          num = ToString[num] <> "\< un\>"]; \[IndentingNewLine]If[
          v[\([5]\)] \[Equal] 1, 
          num = ToString[
                num] <> "\<*\>"]; \
\[IndentingNewLine]num\[IndentingNewLine]]\)\)\)], "Input"],

Cell["\<\
If[NumberQ[num],num=ToString[num]];
If[StringTake[num,-1]\[Equal]\".\",
    num=StringDrop[num,-1];
    ];
If[StringTake[num,-2]\[Equal]\".*\",
    num=StringDrop[n,-2]<>\"*\";
    ];\
\>", "Text"],

Cell["\<\
(* Map[efunsnum[[funnum]],funname[Elements] \
(1/efunsunits[[funnum]]) ] *)
(* efunsnum[[funnum]][funname[element]] (1/efunsunits[[funnum]]) *)\
\>", \
"Text"],

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(getnum[Density, Hydrogen]\)\)\)], "Input"],

Cell[BoxData[
    \(Density[Hydrogen]\ 1/efunsunits[\([9]\)]\)], "Input"],

Cell["(* \"---\" looks better but ? means something *)", "Text"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["DATA / TEXT for Elements", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["Center of Cell", "Subsection"],

Cell["\tplace a \".\" in center to help when doing layout", "Text"],

Cell[BoxData[
    \(\(oncehelppos = False;\)\)], "Input"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(cdot =. ; 
    cdot = \[IndentingNewLine]Table[\[IndentingNewLine]"\<\>"\
\[IndentingNewLine], {i, 1, chartheight}\[IndentingNewLine], {j, 1, 
          chartwidth}\[IndentingNewLine]];\)], "Input"],

Cell[BoxData[
    \(\(cdot = Flatten[cdot];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[1, i_] := cdot[\([i]\)];\)\)], "Input"],

Cell["OOPs there is no z text offset", "Text"],

Cell[BoxData[
    \(\(ooffset[1, i_] := {0, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["pos ", "Subsubsection"],

Cell[BoxData[
    \(\(centerpos = \[IndentingNewLine]Table[\[IndentingNewLine]{j, 
            defdepth, \ i}\[IndentingNewLine], {i, 1, 
            chartheight}\[IndentingNewLine], {j, 1, 
            chartwidth}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(centerpos = Partition[Flatten[centerpos], 3];\)\)], "Input"],

Cell["\<\
(* cmat is below in layout because it can be though it could be \
here
only cmat[[2]] centerscale is used
\t* this only changes distance between cells
\t* it doesn't effect contents or data placements from the center *)\
\>", \
"Text"],

Cell[BoxData[
    \(\(centerscale := cmat[\([2]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(centertrans := cmat[\([1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(plottrans := cmat[\([4]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(centerrot[n_] := Rotate3D[n, Sequence @@ cmat[\([3]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(opos[1, i_] := 
        N[plottrans + 
            centerrot[\[IndentingNewLine]\((centerscale\ \((centertrans + 
                      centerpos[\([i]\)])\))\)\[IndentingNewLine]]];\)\)], \
"Input"],

Cell["\<\
(* cmat simply holds vecs for
\tplottrans, centerrot, centerscale, centertrans
(centerpos is done as ch2b's i, j)
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[1, i_] := 
      Sequence[\[IndentingNewLine]TextStyle -> {FontSize \[Rule] 3, 
            FontColor \[Rule] 
              RGBColor[1, 0, 0]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell["edit or add elemental data Below", "Subsection",
  Background->RGBColor[0.8, 1, 1]],

Cell[CellGroupData[{

Cell["Abbreviation", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \( (*\ \(old\ Table[
            ch2[\([7\  - \ i\  + \ 1, \ j]\)], \ {i, \ 1, \ 7}, \ {j, \ 1, \ 
              32}];\)\ *) \)], "Input"],

Cell[BoxData[
    \(txt =. ; txt = gendat[Abbreviation, 3];\)], "Input"],

Cell[BoxData[
    \(\(odat[2, i_] := 
        If[odat[elem, i] =!= "\<\>", txt[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[2, helpcell] := "\<Elem\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[2, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 4, 
            FontWeight \[Rule] "\<Bold\>", \[IndentingNewLine]FontColor \
\[Rule] RGBColor[ .85, 0, 
                0]}\[IndentingNewLine] (*\ \(,\)\(Background \[Rule] 
            Hue[ .50]\)\ *) \[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Shell Configuration - Outermost 2", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[TextData[{
  "(* IMPORTANT:  DO NOT USE   elecfmt[List] OR elecfmtv[List]  with  \
elements[]  USE ONLY  felements[].  (see examples, List is for fill order \
only, Symbol goes by ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s array from chem.m) *)"
}], "Text"],

Cell[BoxData[
    \(\(ecdat = 
        Module[{i, s, 
            n}, \[IndentingNewLine]Table[\[IndentingNewLine]If[\
\[IndentingNewLine]Head[odat[elem, i]] === Symbol, \[IndentingNewLine]s = 
                odat[elem, i]; \[IndentingNewLine]n = 
                Length[elecfmtpm[
                    s]]; \[IndentingNewLine]Take[\[IndentingNewLine]elecfmtpm[\
\[IndentingNewLine]odat[elem, i]\[IndentingNewLine]]\[IndentingNewLine], 
                If[n > 6, \(-6\), \(-n\)]\[IndentingNewLine]]\
\[IndentingNewLine], "\<\>"\[IndentingNewLine]]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[3, i_] := 
        If[odat[elem, i] =!= "\<\>", ecdat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[3, 
          helpcell] := "\<Shell Order Electron Configuration\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[3, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Shell Configuration - Fill Order 2
\tFIXME is 2 terms enough ? see crc tab\
\>", "Subsection"],

Cell[BoxData[
    \( (*\ Table[
        correction[Abbreviation[Element[\([i]\)]]], {i, 1, 
          112}]\ *) \)], "Input"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(fecdat = 
        Module[{i, s, n, an, e, 
            t}, \[IndentingNewLine]Table[\[IndentingNewLine]If[\
\[IndentingNewLine]Head[odat[elem, i]] === Symbol, \[IndentingNewLine]s = 
                odat[elem, i]; \[IndentingNewLine]an = 
                AtomicNumber[s]; \[IndentingNewLine]e = 
                felements[\([an]\)]; \[IndentingNewLine]t = 
                elecfmtpm[e, s]; \[IndentingNewLine]n = 
                Length[t]; \[IndentingNewLine]Take[
                t, \[IndentingNewLine]If[
                  n > 6, \(-6\), \(-n\)]\[IndentingNewLine]]\
\[IndentingNewLine], "\<\>"\[IndentingNewLine]]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[4, i_] := 
        If[odat[elem, i] =!= "\<\>", fecdat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[4, 
          helpcell] := "\<Fill Order Electron Configuration\>";\)\)], "Input"],

Cell[TextData[{
  "(* another ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " bug\n\tfile save corruption ...\n\tif the above has a superscript \
containing just 1 space then somehow\n\t.nb cell  markup symbols appear in \
string above after file is re-loaded\n\t(was being used to get text boxing to \
line up - but not worth it now) *)"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[4, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ \(,\)\(Background \[Rule] RGBColor[ .9, 1,  .9]\)\ *) \)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Atomic Number", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \( (*\ \(gendat\ does\ this\ Module[{an}, \[IndentingNewLine]Table[
              an = AtomicNumber[odat[elem, i]]; \[IndentingNewLine]If[
                IntegerQ[an], ToString[an], "\<\>"]\[IndentingNewLine], {i, 
                1, objlen}]];\)\ *) \)], "Input"],

Cell["(* should be same result as if getnum is used *)", "Text"],

Cell[BoxData[
    \(andat =. ; andat = gendat[AtomicNumber, 3];\)], "Input"],

Cell[BoxData[
    \(\(odat[5, i_] := 
        If[odat[elem, i] =!= "\<\>", andat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[5, helpcell] := "\<Atomic Number\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[5, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 3, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[ .85, 0, 
                0]}\[IndentingNewLine] (*\ \(,\)\(Background \[Rule] 
            Hue[ .50]\)\ *) \[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Shell, Outer Electrons, Element", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(shfun[i_] := shellsarr[\([AtomicNumber[i]]\)];\)\)], "Input"],

Cell[BoxData[
    \( (*\ shdat = 
        Flatten[Table[{7 - i + 1, j}, {i, 1, 7}, {j, 1, 
              32}]]; \ \[IndentingNewLine]shdat = 
        Partition[shdat, 2];\ *) \)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(shdat = gendat[shfun]\ ;\)\)\)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(shdat2 = 
        Module[{dat, an, 
            shell}, \[IndentingNewLine]Table[\[IndentingNewLine]dat = 
              odat[elem, i]; \[IndentingNewLine]an = 
              AtomicNumber[dat]; \[IndentingNewLine]shell = 
              ToExpression[shdat[\([i]\)]]; \[IndentingNewLine]If[
              dat =!= "\<\>", \[IndentingNewLine]fineashell[
                felements[\([an]\)], shell]\[IndentingNewLine], 
              Null]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]\[IndentingNewLine]];\)\)\)], "Input"],

Cell[BoxData[
    \(fineashell[felements[\([77]\)], 5]\)], "Input"],

Cell[BoxData[
    \(fineashell[felements[\([77]\)], 6]\)], "Input"],

Cell[BoxData[
    \(fineashell[felements[\([77]\)], 7]\)], "Input"],

Cell[BoxData[
    \(showfe[felements[\([77]\)]]\)], "Input"],

Cell[BoxData[
    \(\(shdat3 = 
        Table[shdat[\([i]\)] <> \ "\<, \>"\  <> \ 
            ToString[shdat2[\([i]\)]] <> "\<  \>"\[IndentingNewLine] <> 
            ToString[odat[elem, i]], {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[6, i_] := 
        If[odat[elem, i] =!= "\<\>", shdat3[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[6, 
          helpcell] := "\<Shell, Outer Electrons, Element\>";\)\)], "Input"],

Cell[BoxData[
    \(\(ooffset[6, i_] := {0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(odir[6, i_] := {1, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[6, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0,  .55, 0]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FIP ab", "Subsection"],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(* First is easier than units and IP doesn't need bookform *)\
\>", \
"Text"],

Cell[BoxData[
    \( (*\ ipfun[i_] := 
        Module[{fip, n}, \[IndentingNewLine]fip = 
            IonizationPotential[i]; \[IndentingNewLine]n = 
            If[Head[fip] === Times, \ 
              First[fip], "\<\>"]; \[IndentingNewLine]n]\ *) \)], "Input"],

Cell["(* but use getnum anyho *)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, IonizationPotential]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(fipstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[7, i_] := 
        If[odat[elem, i] =!= "\<\>", fipstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[7, helpcell] := fipstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[7, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FIP n", "Subsection"],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(* First is easier than units and IP doesn't need bookform *)\
\>", \
"Text"],

Cell[BoxData[
    \( (*\ ipfun[i_] := 
        Module[{fip, n}, \[IndentingNewLine]fip = 
            IonizationPotential[i]; \[IndentingNewLine]n = 
            If[Head[fip] === Times, \ 
              First[fip], "\<\>"]; \[IndentingNewLine]n]\ *) \)], "Input"],

Cell["(* but use getnum anyho *)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(ipfun[i_] := getnum[IonizationPotential, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(ipdat =. \) \)\(;\)\(\(ipdat = 
        gendat[ipfun]\) \)\(;\)\(\ \)\( (*\ pad\ 6\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[8, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ipdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[8, helpcell] := "\<Ionization Potential  eV\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[8, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_M\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, MeltingPoint]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(tmstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[9, i_] := 
        If[odat[elem, i] =!= "\<\>", tmstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[9, helpcell] := tmstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[9, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_M\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(tmfun[i_] := getnum[MeltingPoint, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(tmdat =. \) \)\(;\)\(\(tmdat = 
        gendat[tmfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[10, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[tmdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[10, helpcell] := "\<Melting Point  K\>"~padit~26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[10, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
    \("\!\(m\_A\)"\)]]], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(awfun[i_] := getnum[AtomicWeight, i];\)\)], "Input"],

Cell[BoxData[
    \(awdat =. ; awdat = gendat[awfun];\)], "Input"],

Cell[BoxData[
    \( (*\ \(funnum = \(Position[efuns, AtomicWeight]\)[\([1, 
              1]\)];\)\ *) \)], "Input"],

Cell[BoxData[
    \( (*\ \(awstr = efunsab[\([funnum]\)];\)\ *) \)], "Input"],

Cell["(* odat[9,i_]:=awstr<>\"  \"<>padit[awdat[[i]],10]; *)", "Text"],

Cell[BoxData[
    \( (*\ \(odat[11, i_] := 
          If[odat[elem, i] =!= "\<\>", 
            padit[awdat[\([i]\)], 8], "\<\>"];\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(odat[11, i_] := 
        If[odat[elem, i] =!= "\<\>", awdat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        leftalign === 
          0, \[IndentingNewLine]odat[11, 
            helpcell] := "\<      Atomic Weight  amu\>", \
\[IndentingNewLine]odat[11, 
            helpcell] := "\<Atomic Weight  amu\>"];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[11, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[ .55, 0, 0]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SI ab", "Subsection"],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(* First is easier than units and IP doesn't need bookform *)\
\>", \
"Text"],

Cell[BoxData[
    \( (*\ ipfun[i_] := 
        Module[{fip, n}, \[IndentingNewLine]fip = 
            IonizationPotential[i]; \[IndentingNewLine]n = 
            If[Head[fip] === Times, \ 
              First[fip], "\<\>"]; \[IndentingNewLine]n]\ *) \)], "Input"],

Cell["(* but use getnum anyho *)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, StableIsotopes]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(sistr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[12, i_] := 
        If[odat[elem, i] =!= "\<\>", sistr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[12, helpcell] := sistr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[12, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SI n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(StableIsotopes[Tin]\)], "Input"],

Cell["(* for a condensed chart even this won't fit *)", "Text"],

Cell[BoxData[
    \(StableIsotopes[Tin] - Round[AtomicWeight[Tin]]\)], "Input"],

Cell[BoxData[
    \( (*\ Table[
          StableIsotopes[Elements[\([i]\)]] - 
            Round[AtomicWeight[Elements[\([i]\)]]], {i, 1, 112}] // 
        TableForm\ *) \)], "Input"],

Cell[BoxData[
    \(\(sidat2 = 
        Module[{si, dat, 
            v}, \[IndentingNewLine]Table[\[IndentingNewLine]dat = 
              odat[elem, i]; \[IndentingNewLine]si = 
              StableIsotopes[odat[elem, i]]; \[IndentingNewLine]v = 
              If[dat =!= "\<\>" && si =!= {}, \[IndentingNewLine]ToString[
                  si - Round[
                      AtomicWeight[dat]]], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<{\>" \[Rule] "\<\>", "\<}\>" \[Rule] "\<\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>"}]; \[IndentingNewLine]v = \
"\<+\>" <> StringReplace[
                    v, {"\< \>" \[Rule] "\< +\>"}]; \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>", "\<+-\>" \[Rule] "\<-\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<+0\>" \[Rule] "\<0\>"}]; \[IndentingNewLine] (*\ 
                sqeeze\ a\ few\ long\ ones\ *) \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-5 -4 -3 -2 -1\>" \[Rule] "\<-5,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-4 -3 -2 -1\>" \[Rule] "\<-4,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-3 -2 -1\>" \[Rule] "\<-3,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-4 -2 -1\>" \[Rule] "\<-4,2,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<+1 +2 +4\>" \[Rule] \
"\<+1,2,4\>"}]\[IndentingNewLine], "\<\>"\[IndentingNewLine]]\
\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[13, i_] := 
        If[odat[elem, i] =!= "\<\>" && sidat2[\([i]\)] =!= "\<{0}\>", 
          sidat2[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[13, helpcell] := "\<Stable Isotopes *\>";\)\)], "Input"],

Cell[TextData[{
  "(* From what i see so far ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s chem.m may use {} to mean only natural isotope is exactly atomic weight \
or for (ie, Cs) {133} (cmp to 132.905) may mean nearly the same.  Being \
abbrev. \"\" is used in tab for both. *)"
}], "Text"],

Cell["(* {} are stripped because they don't render for Enc. PS *)", "Text"],

Cell[BoxData[
    \( (*\ \(dict[]\)[\([55]\)]\ *) \)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[13, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_B\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, BoilingPoint]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(tbstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[14, i_] := 
        If[odat[elem, i] =!= "\<\>", tbstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[14, helpcell] := tbstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[14, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_B\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(tbfun[i_] := getnum[BoilingPoint, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(tbdat =. \) \)\(;\)\(\(tbdat = 
        gendat[tbfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[15, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[tbdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[15, helpcell] := "\<Boiling Point  K\>"~padit~26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[15, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`SsA\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, SolarSystemAbundance]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(ssastr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[16, i_] := 
        If[odat[elem, i] =!= "\<\>", ssastr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[16, helpcell] := ssastr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[16, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`SsA\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["\<\
\tMicro is a mathematica font.  at printing time mu or \"u\" will \
be easier for all.
\tbut font rendering may break \[Mu] in size 2 while allowing others!  plain \
u here.\
\>", "Text"],

Cell[BoxData[
    \(\(ssafun[i_] := getnum[SolarSystemAbundance, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(ssadat =. \) \)\(;\)\(\(ssadat = 
        gendat[ssafun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(ssadat = 
        Table[StringReplace[
            ssadat[\([i]\)], "\<\[Micro]\>" \[Rule] "\<u\>"], {i, 1, 
            Length@ssadat}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[17, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ssadat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[17, helpcell] := "\<Solar System Abundance %\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[17, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EcA\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, EarthCrustAbundance]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(ecastr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[18, i_] := 
        If[odat[elem, i] =!= "\<\>", ecastr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[18, helpcell] := ecastr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[18, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EcA\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(ecafun[i_] := getnum[EarthCrustAbundance, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(ecadat =. \) \)\(;\)\(\(ecadat = 
        gendat[ecafun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(ecadat = 
        Table[StringReplace[
            ecadat[\([i]\)], "\<\[Micro]\>" \[Rule] "\<u\>"], {i, 1, 
            Length@ecadat}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[19, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ecadat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[19, helpcell] := "\<Earth Crust Abundance  %\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[19, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EoA\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, EarthOceanAbundance]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(eoastr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[20, i_] := 
        If[odat[elem, i] =!= "\<\>", eoastr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[20, helpcell] := eoastr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[20, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EoA\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(eoafun[i_] := getnum[EarthOceanAbundance, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(eoadat =. \) \)\(;\)\(\(eoadat = 
        gendat[eoafun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(eoadat = 
        Table[StringReplace[
            eoadat[\([i]\)], "\<\[Micro]\>" \[Rule] "\<u\>"], {i, 1, 
            Length@eoadat}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[21, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[eoadat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[21, helpcell] := "\<Earth Ocean Abundance  %\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[21, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\[Rho] ab", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, Density]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(dstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[22, i_] := 
        If[odat[elem, i] =!= "\<\>", dstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[22, helpcell] := dstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[22, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\[Rho] n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(dfun[i_] := getnum[Density, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(ddat =. \) \)\(;\)\(\(ddat = gendat[dfun]\) \)\(;\)\(\ \)\( (*\ 
      pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[23, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ddat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[23, helpcell] := "\<Density  kg/m^3 @298K\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[23, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(L\_f\)"\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, HeatOfFusion]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(lfstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[24, i_] := 
        If[odat[elem, i] =!= "\<\>", lfstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[24, helpcell] := lfstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[24, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(L\_f\)"\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(lffun[i_] := getnum[HeatOfFusion, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(lfdat =. \) \)\(;\)\(\(lfdat = 
        gendat[lffun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[25, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[lfdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[25, helpcell] := "\<Heat of Fusion  kj/mol\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[25, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(L\_v\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, HeatOfVaporization]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(lvstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[26, i_] := 
        If[odat[elem, i] =!= "\<\>", lvstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[26, helpcell] := lvstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[26, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(L\_v\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(lvfun[i_] := getnum[HeatOfVaporization, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(lvdat =. \) \)\(;\)\(\(lvdat = 
        gendat[lvfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[27, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[lvdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[27, helpcell] := "\<Heat of Vaporization\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[27, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(Q\_c\)"\)]],
  " ab  (spec. heat qc)"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, SpecificHeat]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(qcstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[28, i_] := 
        If[odat[elem, i] =!= "\<\>", qcstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[28, helpcell] := qcstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[28, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(Q\_c\)"\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(qcfun[i_] := getnum[SpecificHeat, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(qcdat =. \) \)\(;\)\(\(qcdat = 
        gendat[qcfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[29, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[qcdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[29, helpcell] := "\<Specific Heat  kj/g\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[29, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Q\[Sigma] ab (therm. cond. tc)", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, ThermalConductivity]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(tcstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[30, i_] := 
        If[odat[elem, i] =!= "\<\>", tcstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[30, helpcell] := tcstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[30, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Q\[Sigma] n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(tcfun[i_] := getnum[ThermalConductivity, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(tcdat =. \) \)\(;\)\(\(tcdat = 
        gendat[tcfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[31, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[tcdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[31, helpcell] := "\<Therm Conduct  W/Km @300K\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[31, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
orig order ab  (shell order ab)\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* note borrowing of abbrev *)", "Text"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, ElectronConfiguration]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(oostr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[32, i_] := 
        If[odat[elem, i] =!= "\<\>", oostr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[32, helpcell] := oostr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[32, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["fill order ab", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* note borrowing of abbrev *)", "Text"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, ElectronConfigurationFormat]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(fostr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[33, i_] := 
        If[odat[elem, i] =!= "\<\>", fostr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[33, helpcell] := fostr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[33, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OS ab", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, OxidationStates]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(osstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[34, i_] := 
        If[odat[elem, i] =!= "\<\>", osstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[34, helpcell] := osstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[34, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OS n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* sifun[i_]:=StableIsotopes[i]; *)", "Text"],

Cell["(* sidat=.;sidat=gendat[StableIsotopes]; *)", "Text"],

Cell[BoxData[
    \(\(osdat2 = 
        Module[{si, dat, 
            v}, \[IndentingNewLine]Table[\[IndentingNewLine]dat = 
              odat[elem, i]; \[IndentingNewLine]si = 
              OxidationStates[odat[elem, i]]; \[IndentingNewLine]v = 
              If[dat =!= "\<\>" && si =!= {}, 
                ToString[si], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<{\>" \[Rule] "\<\>", "\<}\>" \[Rule] "\<\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>"}]; \[IndentingNewLine]v = \
"\<+\>" <> StringReplace[
                    v, {"\< \>" \[Rule] "\< +\>"}]; \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>", "\<+-\>" \[Rule] "\<-\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<+0\>" \[Rule] "\<0\>"}]; \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-3 -2 -1\>" \[Rule] "\<-3,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<1 2 3\>" \[Rule] "\<+1,3\>"}]\[IndentingNewLine], \
"\<\>"\[IndentingNewLine]]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[35, i_] := 
        If[odat[elem, i] =!= "\<\>" && osdat2[\([i]\)] =!= "\<{0}\>", 
          osdat2[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[35, helpcell] := "\<Oxidation States\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[35, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, 
            FontColor \[Rule] 
              RGBColor[ .55, 0, 0]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(oattr[35, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"],

Cell["\<\
(* this renders text down but at 90deg unreadable rotation in \
gv/ggv maybe notebook 
too (ok - don't need it now).  to fix have to ? keep in mind chart is rotated \
i think
(but note -1 is to read down 1 to read up)
*)\
\>", "Text"],

Cell[BoxData[
    \( (*\ \(odir[35, i_] := {0, 0, \(-1\)};\)\ *) \)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["element type", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["\<\
(* was going to mark lyquid solid gas.  but really they are all \
abundantly obvious from what is already marked and need elemnt desc is \
better.  more is not always better. *)\
\>", "Text"],

Cell[BoxData[
    \(\(gases = {1, 2, 7, 8, 9, 10, 17, 18, 36, 54, 86};\)\)], "Input"],

Cell[BoxData[
    \(\(liquids = {35, 80};\)\)], "Input"],

Cell[BoxData[
    \(\(soids = 
        Complement[Range[1, ELEMENTS], Union[gases, liquids]];\)\)], "Input"],

Cell["(* skip - \"iupac 2003\" *)", "Text"],

Cell[BoxData[
    \(\(posttransitionmetals = {13, 31, 49, 50, 81, 82, 83, 84};\)\)], "Input"],

Cell["(* skip - \"uipac 2003\" *)", "Text"],

Cell[BoxData[
    \(\(\( (*\ if\ non - metals\ halogens, \ 
      nobels\ marked\ instead\ *) \)\(\[IndentingNewLine]\)\(nonmetals = {1, 
          6, 7, 8, 15, 16, 34};\)\)\)], "Input"],

Cell["instead be simpler by 3 parts", "Text"],

Cell[BoxData[
    \(\(nonmetals = {1, 2, 6, 7, 8, 9, 10, 15, 16, 17, 18, 34, 35, 36, 53, 
          54, 86};\)\)], "Input"],

Cell[BoxData[
    \(\(metalloids = {5, 14, 32, 33, 51, 52, 85};\)\)], "Input"],

Cell[BoxData[
    \(\(metals = 
        Complement[Range[1, ELEMENTS], 
          Union[nonmetals, metalloids]];\)\)], "Input"],

Cell["(* note: marked by col header *)", "Text"],

Cell[BoxData[
    \(\(nobels = {2, 10, 18, 36, 54, 86};\)\)], "Input"],

Cell[BoxData[
    \(\(halogens = {9, 17, 35, 53, 85};\)\)], "Input"],

Cell[BoxData[
    \(\(alkalineearthmetals = {4, 12, 20, 38, 56, 88};\)\)], "Input"],

Cell[BoxData[
    \(\(transitionmetals = 
        Range[21, 30] \[Union] Range[39, 48] \[Union] Range[72, 80] \[Union] 
          Range[104, 108] \[Union] {112};\)\)], "Input"],

Cell["(* note: marked in legend *)", "Text"],

Cell[BoxData[
    \(\(lanthenides = Range[58, 71];\)\)], "Input"],

Cell[BoxData[
    \(\(actinides = Range[90, 103];\)\)], "Input"],

Cell[BoxData[
    \(Intersection[metals, nonmetals] == Intersection[metals, metalloids] == 
      Intersection[nonmetals, metalloids] \[Equal] {}\)], "Input"],

Cell[BoxData[
    \(Union[metals, nonmetals, metalloids] \[Equal] 
      Range[1, ELEMENTS]\)], "Input"],

Cell[BoxData[
    \(\(mtdat = Table["\<\>", {i, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(Module[{n}, 
        Do[\[IndentingNewLine]n = 
            AtomicNumber[odat[elem, i]]; \[IndentingNewLine]If[
            IntegerQ[n], \[IndentingNewLine]If[
              Intersection[{n}, metals] \[NotEqual] {}, 
              mtdat[\([i]\)] = "\<M\>"]; \[IndentingNewLine]If[
              Intersection[{n}, metalloids] \[NotEqual] {}, 
              mtdat[\([i]\)] = "\<L\>"]; \[IndentingNewLine]If[
              Intersection[{n}, nonmetals] \[NotEqual] {}, 
              mtdat[\([i]\)] = "\<n\>"];\[IndentingNewLine]]\
\[IndentingNewLine], {i, objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[36, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[mtdat[\([i]\)], 2], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[36, helpcell] := "\<non-Metal-Loid\>";\)\)], "Input"],

Cell[BoxData[
    \( (*\ Table[odat[36, i], {i, 224}]\ *) \)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[36, i_] := 
      Module[{n}, \[IndentingNewLine]n = 
          AtomicNumber[
            odat[elem, 
              i]]; \[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \
\[Rule] {\[IndentingNewLine]FontSize \[Rule] 
                2, \[IndentingNewLine]FontColor \[Rule] 
                RGBColor[\[IndentingNewLine]If[
                    Intersection[{n}, metals] \[NotEqual] {},  .90, 0], 
                  If[Intersection[{n}, nonmetals] \[NotEqual] {},  .90, 0], 
                  If[Intersection[{n}, metalloids] \[NotEqual] {},  .90, 
                    0]]\[IndentingNewLine]}]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["col alias", "Subsection"],

Cell[CellGroupData[{

Cell["\<\
graph discuss from far above (top chart graph discuss \
section)\
\>", "Subsubsection"],

Cell[TextData[{
  "(*\nthis \"easy task\" to print the below is a good example of how boxing \
and layout provided by front end can waste more time than save when it comes \
down to the line (literally).\n\n\t18\n\tnobel gases\n\nFrom Discussion (way \
above).  Below tying text together (coltxt) is tried and fails.  (we'd like \
to preserve, as form Output is very efficient and low cost to print).    When \
FormatType is changed text centering is lost (could try paditc) and worse: \
the spacing between text lines becomes variable depending upon how printed.  \
If boxing is used for this it caused a need to change geninit2D to wrap odat \
with DisplayForm which itself worked.  \n\t* point: making a layout that can \
print condensed (good use of space)\n\t   that remains readable and looking \
good: isn't easy\n\t* the row spacing changes depending upon FormatType\n\t* \
the row spacing for color gets doubled & doesn't fit\n\t* using the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " function to HALF RowSpacings->xxx\n\t\t* doesn't appear to change spacing\
\n\t\t* next question: when will it - when it does 1/2 will look wrong\n\t\t\
(",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " itself isn't perfect in all objectives)\n\t* the row spacing for color is \
OUTSIDE the box provided\n\t\ttrying to fix and tie in box and print row \
spacing size?\n\t\ti simply doubt it\n\nQ:  but it's so much harder.\nA:  not \
really: just cut & past an item and choose placement.  if you do it rather \
than think about it it's not bad.\n\nQ:  so why is boxing used to display \
exponents and a few other things ?\n A: because those are known to work (not \
alter chart) by trial and error and why they work is partly because they are \
place individualy by layout (if they change a little they are still within \
the space allotted , and also becaue they are horizontal and pertain to one \
item that is tied to nothing else, visibly speaking).\n \nbelow there was \
allot of problems with \"/\" dissapearing (now solved) due to font style \
which depended upon font availability and font mapping.  and still one should \
keep in mind to use even \"simple symbols like /\" unless the standard chart \
required it - and it doesn't hardly.\n\nQ:  what would the effect be of \
ignoring layout ?\nA:  allot of void in a printed chart and mismatch between \
sizes which would be awkward to print large to fix and in effect never be \
very useful except to see on screen maybe.  which would change (and even be \
wrong) depending on how printed\n\nQ: now you'll say: no way use the editor \
and print it.\nA1:  oh.  but if you change fonts (ie, not avail) your layout \
changes who knows how bad it may not print.  Guess what?  sometimes fonts \
with same name are not the same and this can change if you \"update\".\nA2:  \
you trying re-editing a whole chart for each \"editor limitation\" that pops \
up!@.  it's a big chart to re-edit.\n\nQ:  but individual layout requires \
allot of fixups in \"run geninit & do fix-ups\"\nA:  only for help cell - and \
it's a special convenience to have that be automatic\n*)"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["old", "Subsubsection"],

Cell[BoxData[
    \(\(coltxt = {\[IndentingNewLine]"\<1\nH &\nAlkali Metals\>", \
\[IndentingNewLine]"\<2\nAlkaline Earth\nMetals\>", \[IndentingNewLine]"\<3\n\
Transition\nMetals\>", \[IndentingNewLine]"\<4\n->\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<5\>", \[IndentingNewLine]"\<6\>", \
\[IndentingNewLine]"\<7\>", \[IndentingNewLine]"\<8\>", \
\[IndentingNewLine]"\<9\>", \[IndentingNewLine]"\<10\>", \[IndentingNewLine]"\
\<11\n<-\>", \[IndentingNewLine]"\<12\nVolitile Metals\>", \
\[IndentingNewLine]"\<13\nEarth Metals\>", \[IndentingNewLine]"\<14\n\
Tetragens\>", \[IndentingNewLine]"\<15\nPnictogens\>", \
\[IndentingNewLine]"\<16\nChalcogens\>", \[IndentingNewLine]"\<17\n\
Halogens\>", \[IndentingNewLine]"\<18\nNobel \
Gases\>"\[IndentingNewLine]};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(coltxt = {\[IndentingNewLine]GridBox[{{"\<1\>"}, {"\<H &\>"}, \
{"\<Alkali Metals\>"}}], \[IndentingNewLine]GridBox[{{"\<2\>"}, {"\<Alkaline \
Earth\>"}, {"\<Metals\>"}}], \[IndentingNewLine]GridBox[{{"\<3\>"}, \
{"\<Transition\>"}, {"\<Metals\>"}}], \[IndentingNewLine]GridBox[{{"\<4\>"}, \
{"\<->\>"}}], \[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<5\>", \[IndentingNewLine]"\<6\>", \
\[IndentingNewLine]"\<7\>", \[IndentingNewLine]"\<8\>", \
\[IndentingNewLine]"\<9\>", \[IndentingNewLine]"\<10\>", \
\[IndentingNewLine]GridBox[{{"\<11\>"}, {"\<<-\>"}}], \
\[IndentingNewLine]GridBox[{{"\<12\>"}, {"\<Volitile Metals\>"}}], \
\[IndentingNewLine]GridBox[{{"\<13\>"}, {"\<Earth Metals\>"}}], \
\[IndentingNewLine]GridBox[{{"\<14\>"}, {"\<Tetragens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<15\>"}, {"\<Pnictogens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<16\>"}, {"\<Chalcogens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<17\>"}, {"\<Halogens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<18\>"}, {"\<Nobel Gases\>"}}]\
\[IndentingNewLine]};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(x =. ;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(coltxt = 
        coltxt /. GridBox[{x__}, y___] \[Rule] 
            GridBox[{x}, y, ColumnAlignments \[Rule] Center, 
              RowSpacings \[Rule]  .2];\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* use opos[ i , coltops[i] ] for placing directly above *)", "Text"],

Cell[BoxData[
    \(\(coltops = {7, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 4, 4, 
          4, 4, 4, 4, 4, 4, 4, 6, 6, 6, 6, 6, 7};\)\)], "Input"],

Cell["\<\
(* note: WHAT this uses boxing to tie rows?  here we tied to text \
lines together which is OK as long as we know there  are no effects and \
accept the look of it (hardly worth the thinking it takes - MAKING ANOTHER \
DATA ITEM to begin with might be wiser *)\
\>", "Text"],

Cell[BoxData[
    \(\(coltxt = {\[IndentingNewLine]"\<H &\nAlkali Metals\>", \
\[IndentingNewLine]"\<Alkaline Earth\nMetals\>", \
\[IndentingNewLine]"\<Transition\nMetals \[RightArrow]\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<Volitile Metals\>", \[IndentingNewLine]"\<Earth \
Metals\>", \[IndentingNewLine]"\<Tetragens\>", \
\[IndentingNewLine]"\<Pnictogens\>", \[IndentingNewLine]"\<Chalcogens\>", \
\[IndentingNewLine]"\<Halogens\>", \[IndentingNewLine]"\<Nobel Gases\>"\
\[IndentingNewLine]};\)\)], "Input"],

Cell[BoxData[
    \(If[widechart \[Equal] 
        False, \n\(coltxt = 
          Drop[coltxt, groupdrop];\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(odat[37, i_] := 
      If[i \[LessEqual] objlen && 
          i \[GreaterEqual] \((objlen - chartwidth + 1)\), 
        coltxt[\([i - \((objlen - chartwidth)\)]\)], "\<\>"]\)], "Input"],

Cell[BoxData[
    \( (*\ Table[odat[37, i], {i, 1, 224}]\ *) \)], "Input"],

Cell[BoxData[
    \(\(odat[37, helpcell] := "\<Group Alias\>";\)\)], "Input"],

Cell[BoxData[
    \(\(ooffset[37, i_] := {0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(odir[37, i_] := {1, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[37, i_] := 
      Module[{n, clr, cw}, \[IndentingNewLine]cw = 
          chartwidth; \[IndentingNewLine]n = 
          i - \((objlen - cw)\); \[IndentingNewLine]clr = 
          FontColor \[Rule] RGBColor[0, 0, 0]; \[IndentingNewLine]If[
          n \[Equal] cw, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .5,  .8]]; \[IndentingNewLine]If[
          n \[Equal] cw - 1, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .7,  .4]]; \[IndentingNewLine]If[
          n \[Equal] cw - 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .9,  .4, 0]]; \[IndentingNewLine]If[n \[Equal] 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .4, 0,  .4]]; \[IndentingNewLine]If[n \[Equal] 1, 
          clr = FontColor \[Rule] 
              RGBColor[
                1,  .2,  .5]]; \
\[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \
\[Rule] 3, clr}]]\)], "Input"],

Cell[BoxData[
    \(oattr[37, helpcell] := 
      Module[{n, clr, cw}, \[IndentingNewLine]cw = 
          chartwidth; \[IndentingNewLine]n = 
          i - \((objlen - cw)\); \[IndentingNewLine]clr = 
          FontColor \[Rule] RGBColor[0, 0, 0]; \[IndentingNewLine]If[
          n \[Equal] cw, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .5,  .8]]; \[IndentingNewLine]If[
          n \[Equal] cw - 1, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .7,  .4]]; \[IndentingNewLine]If[
          n \[Equal] cw - 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .9,  .4, 0]]; \[IndentingNewLine]If[n \[Equal] 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .4, 0,  .4]]; \[IndentingNewLine]If[n \[Equal] 1, 
          clr = FontColor \[Rule] 
              RGBColor[
                1,  .2,  .5]]; \
\[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \
\[Rule] 2, clr}]]\)], "Input"],

Cell[BoxData[
    \( (*\ \(If[Intersection[{n}, {32, 31, 30, 2, 1}] \[Equal] {}, 
          FontColor \[Rule] RGBColor[0, 0, 0]];\)\ *) \)], "Input"],

Cell[BoxData[
    \( (*\(Show[
          Graphics[
            Text[DisplayForm[coltxt[\([1]\)]], {1, 1}, 
              TextStyle \[Rule] {FontSize \[Rule] 12, 
                  FontColor \[Rule] 
                    RGBColor[ .9,  .4, 0]}]]];\)*) \)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["col group", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* use opos[ i , coltops[i] ] for placing directly above *)", "Text"],

Cell[BoxData[
    \( (*\ \(coltops = {7, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 4, 
            4, 4, 4, 4, 4, 4, 4, 4, 6, 6, 6, 6, 6, 7};\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(grptxt = {\[IndentingNewLine]"\<1a, 1\>", \[IndentingNewLine]"\<2a, 2\
\>", \[IndentingNewLine]"\<3b, 3\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<5b, 5\>", \[IndentingNewLine]"\<6b, 6\>", \
\[IndentingNewLine]"\<7b, 7\>", \[IndentingNewLine]"\<8,  8\>", \
\[IndentingNewLine]"\<8,  9\>", \[IndentingNewLine]"\<8,  10\>", \
\[IndentingNewLine]"\<1b, 11\>", \[IndentingNewLine]"\<2b, 12\>", \
\[IndentingNewLine]"\<3a, 13\>", \[IndentingNewLine]"\<4a 4b, 14\>", \
\[IndentingNewLine]"\<5a, 15\>", \[IndentingNewLine]"\<6a, 16\>", \
\[IndentingNewLine]"\<7a, 17\>", \[IndentingNewLine]"\<8a-0, 18\>"\
\[IndentingNewLine]};\)\)], "Input"],

Cell[BoxData[
    \(If[widechart \[Equal] 
        False, \n\(grptxt = 
          Drop[grptxt, groupdrop];\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(odat[38, i_] := 
      If[i \[LessEqual] objlen && 
          i \[GreaterEqual] \((objlen - chartwidth + 1)\), 
        grptxt[\([i - \((objlen - chartwidth)\)]\)], "\<\>"]\)], "Input"],

Cell[BoxData[
    \( (*\ Table[odat[38, i], {i, 1, 224}]\ *) \)], "Input"],

Cell[BoxData[
    \(\(odat[38, helpcell] := "\<Group old ref, new\>";\)\)], "Input"],

Cell[BoxData[
    \(\(ooffset[38, i_] := {0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(odir[38, i_] := {1, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[38, 
        i_] := \[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \
\[Rule] {FontSize \[Rule] 3}]\)], "Input"],

Cell[BoxData[
    \(oattr[38, 
        helpcell] := \[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \
\[Rule] {FontSize \[Rule] 2}]\)], "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["layout and Graphics setup", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["define funs (geninit, boxpt, snaptxt, printcell, etc)", "Subsection",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["DISCUSS  layout of data", "Subsubsection"],

Cell["\<\
big note is odta gets wrapped  DisplayForm [ odat ... ]
\twhich should only help not hurt with reliable layout

\t\t--> it is NOT required , should not be relied on
\t\t and if found to be problematic can be removed\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxpts[ cent , sc , .... , two? ]
boxgr[ boxpts ]\
\>", "Subsubsection"],

Cell[BoxData[
    \(\(boxpts[cent_, sc_, ul_, ll_, lr_, ur_, two_:  True] := \ 
        Module[{pt}, \[IndentingNewLine]pt = {cent + ul\ sc, cent + ll\ sc, 
              cent + lr\ sc, cent\  + ur\ sc, 
              cent + ul\ sc}\ ; \[IndentingNewLine]If[
            two === True, \[IndentingNewLine]Delete[
              pt, \[IndentingNewLine]{{1, 2}, {2, 2}, {3, 2}, {4, 2}, {5, 
                  2}}\[IndentingNewLine]]\[IndentingNewLine], 
            pt]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(boxgr[boxpts_] := 
      Graphics[{\[IndentingNewLine]Thickness[ .0001], 
          RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[
            boxpts]\[IndentingNewLine]}]\)], "Input"],

Cell[BoxData[
    \(boxgr3D[boxpts_] := 
      Graphics3D[{\[IndentingNewLine]Thickness[ .0001], 
          RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[
            boxpts]\[IndentingNewLine]}]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxcurvecorners2D[ pt , linemul, curvemul ]
no 3D , uses Spline of type Graphic\
\>", "Subsubsection"],

Cell["\<\
lovely but spline, if portable, only works with Graphics, do a 3D \
plot and cols could loose boxes.  this is \"liveable\" for legends but would \
be a pain for col headers\
\>", "Text"],

Cell[BoxData[
    \(boxcurvecorners2D[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, \(-dh\)}; \
\[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 
            0}; \[IndentingNewLine]\[IndentingNewLine]s1 = {l1[\([2]\)], \
\((l1[\([2]\)] + l2[\([1]\)])\)/2, 
            l2[\([1]\)]}; \[IndentingNewLine]s2 = {l2[\([2]\)], \
\((l2[\([2]\)] + l3[\([1]\)])\)/2, 
            l3[\([1]\)]}; \[IndentingNewLine]s3 = {l3[\([2]\)], \
\((l3[\([2]\)] + l4[\([1]\)])\)/2, 
            l4[\([1]\)]}; \[IndentingNewLine]s4 = {l4[\([2]\)], \
\((l4[\([2]\)] + l1[\([1]\)])\)/2, 
            l1[\([1]\)]}; \[IndentingNewLine]s1[\([2]\)] += {\(-dw\), \
\(-dh\)}/curvemul; \[IndentingNewLine]s2[\([2]\)] += {dw, \(-dh\)}/
            curvemul; \[IndentingNewLine]s3[\([2]\)] += {dw, dh}/
            curvemul; \[IndentingNewLine]s4[\([2]\)] += {\(-dw\), dh}/
            curvemul; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = Line[l4]; \[IndentingNewLine]s1 = 
          Spline[s1, CompositeBezier]; \[IndentingNewLine]s2 = 
          Spline[s2, CompositeBezier]; \[IndentingNewLine]s3 = 
          Spline[s3, CompositeBezier]; \[IndentingNewLine]s4 = 
          Spline[s4, 
            CompositeBezier]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          Graphics[{l1, l2, l3, l4, \ s1, s2, s3, 
              s4}]\ *) \[IndentingNewLine]{l1, s1, l2, s2, l3, s3, l4, 
          s4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxcurvecorners2D[
          v,  .1, 2]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Show[Graphics[%]];\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxnocorners[ pt , linemul, curvemul ]
 is 2D or 3D dep. on pt\
\>", "Subsubsection"],

Cell[BoxData[
    \(boxnocorners3D[pt_, linemul_, 
        curvemul___] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, 0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 0, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, 
            0, \(-dh\)}; \[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 0, 
            0}; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = 
          Line[l4]; \[IndentingNewLine]\[IndentingNewLine]{l1, l2, l3, 
          l4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxnocorners2D[pt_, linemul_, 
        curvemul___] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, \(-dh\)}; \
\[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 
            0}; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = 
          Line[l4]; \[IndentingNewLine]\[IndentingNewLine]{l1, l2, l3, 
          l4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxnocorners[pt_, linemul_, 
        curvemul___] := \(If[Length[pt[\([1]\)]] === 2, boxnocorners2D, 
          boxnocorners3D]\)[pt, linemul]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxnocorners[
          v,  .1]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(Show[Graphics[%]]\)], "Input"],

Cell[BoxData[
    \(Show[Graphics[{First[%%], Take[%%, \(-2\)]}]]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            False]; \[IndentingNewLine]\[IndentingNewLine]boxnocorners[
          v,  .1]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(Show[Graphics3D[%]]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxwithcorners[ pt , linemul, curvemul ]
 is 2D or 3D dep. on pt\
\>", "Subsubsection"],

Cell[BoxData[
    \(boxwithcorners3D[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, 0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 0, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, 
            0, \(-dh\)}; \[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 0, 
            0}; \[IndentingNewLine]\[IndentingNewLine]s1 = {l1[\([2]\)], \
\((l1[\([2]\)] + l2[\([1]\)])\)/2, 
            l2[\([1]\)]}; \[IndentingNewLine]s2 = {l2[\([2]\)], \
\((l2[\([2]\)] + l3[\([1]\)])\)/2, 
            l3[\([1]\)]}; \[IndentingNewLine]s3 = {l3[\([2]\)], \
\((l3[\([2]\)] + l4[\([1]\)])\)/2, 
            l4[\([1]\)]}; \[IndentingNewLine]s4 = {l4[\([2]\)], \
\((l4[\([2]\)] + l1[\([1]\)])\)/2, 
            l1[\([1]\)]}; \[IndentingNewLine]\[IndentingNewLine]s1[\([2]\)] += \
{\(-dw\), 0, \(-dh\)}/
            curvemul; \[IndentingNewLine]s2[\([2]\)] += {dw, 0, \(-dh\)}/
            curvemul; \[IndentingNewLine]s3[\([2]\)] += {dw, 0, dh}/
            curvemul; \[IndentingNewLine]s4[\([2]\)] += {\(-dw\), 0, dh}/
            curvemul; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = Line[l4]; \[IndentingNewLine]s1 = 
          Line[s1]; \[IndentingNewLine]s2 = Line[s2]; \[IndentingNewLine]s3 = 
          Line[s3]; \[IndentingNewLine]s4 = 
          Line[s4]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          Graphics[{l1, l2, l3, l4, \ s1, s2, s3, 
              s4}]\ *) \[IndentingNewLine]{l1, s1, l2, s2, l3, s3, l4, 
          s4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxwithcorners2D[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, \(-dh\)}; \
\[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 
            0}; \[IndentingNewLine]\[IndentingNewLine]s1 = {l1[\([2]\)], \
\((l1[\([2]\)] + l2[\([1]\)])\)/2, 
            l2[\([1]\)]}; \[IndentingNewLine]s2 = {l2[\([2]\)], \
\((l2[\([2]\)] + l3[\([1]\)])\)/2, 
            l3[\([1]\)]}; \[IndentingNewLine]s3 = {l3[\([2]\)], \
\((l3[\([2]\)] + l4[\([1]\)])\)/2, 
            l4[\([1]\)]}; \[IndentingNewLine]s4 = {l4[\([2]\)], \
\((l4[\([2]\)] + l1[\([1]\)])\)/2, 
            l1[\([1]\)]}; \[IndentingNewLine]s1[\([2]\)] += {\(-dw\), \
\(-dh\)}/curvemul; \[IndentingNewLine]s2[\([2]\)] += {dw, \(-dh\)}/
            curvemul; \[IndentingNewLine]s3[\([2]\)] += {dw, dh}/
            curvemul; \[IndentingNewLine]s4[\([2]\)] += {\(-dw\), dh}/
            curvemul; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = Line[l4]; \[IndentingNewLine]s1 = 
          Line[s1]; \[IndentingNewLine]s2 = Line[s2]; \[IndentingNewLine]s3 = 
          Line[s3]; \[IndentingNewLine]s4 = 
          Line[s4]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          Graphics[{l1, l2, l3, l4, \ s1, s2, s3, 
              s4}]\ *) \[IndentingNewLine]{l1, s1, l2, s2, l3, s3, l4, 
          s4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxwithcorners[pt_, linemul_, 
        curvemul_] := \(If[Length[pt[\([1]\)]] === 2, boxwithcorners2D, 
          boxwithcorners3D]\)[pt, linemul, curvemul]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxwithcorners[
          v,  .1, \(-50\)]\[IndentingNewLine]\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(Show[Graphics[%]]\)], "Input"],

Cell[BoxData[
    \(Show[Graphics[{First[%%], Take[%%, \(-4\)]}]]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            False]; \[IndentingNewLine]\[IndentingNewLine]boxwithcorners[
          v,  .1, \(-50\)]\[IndentingNewLine]\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(Show[Graphics3D[%]]\)], "Input"],

Cell[BoxData[
    \(Show[Graphics3D[{First[%%], Take[%%, \(-4\)]}]]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxcorners[ pt , linemul, curvemul ] 
is 2D or 3D dep. on pt\
\>", "Subsubsection"],

Cell[BoxData[
    \(boxcorners[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Extract[\[IndentingNewLine]\(If[
            Length[pt[\([1]\)]] === 2, boxwithcorners2D, boxwithcorners3D]\)[
          pt, linemul, 
          curvemul]\[IndentingNewLine], {{2}, {4}, {6}, {8}}\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxcorners[v,  .1, 
          2]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(Show[Graphics[%]]\)], "Input"],

Cell[BoxData[
    \(Show[Graphics[{%%[\([2]\)], %%[\([4]\)]}]]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            False]; \[IndentingNewLine]\[IndentingNewLine]boxcorners[v,  .1, 
          2]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(Show[Graphics3D[%]]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["showit", "Subsubsection"],

Cell[BoxData[
    \(showit[g1_, g2_, r_] := 
      Show[g1, g2\[IndentingNewLine], 
        ViewPoint \[Rule] {0, \(-1\), 0}\[IndentingNewLine], 
        LightSources \[Rule] {\[IndentingNewLine]{{0, \(-4\), 0}, 
              RGBColor[ .7,  .1,  .1]}\[IndentingNewLine], {{4, 0, 0}, 
              RGBColor[ .1,  .7,  .1]}\[IndentingNewLine], {{0, 0, 4}, 
              RGBColor[ .1,  .1,  .7]}\[IndentingNewLine], {{1.3, \(-2.4\), 
                2}, RGBColor[ .5,  .5,  .5]}\[IndentingNewLine], {{0, \(-2\), 
                0}, GrayLevel[ .5]}}\[IndentingNewLine], 
        AmbientLight \[Rule] 
          RGBColor[ .25,  .25,  .25]\[IndentingNewLine]\[IndentingNewLine], 
        Axes \[Rule] True, 
        AxesLabel \[Rule] {"\<x\>", "\<y\>", "\<z\>"}\[IndentingNewLine]\
\[IndentingNewLine], PlotRange \[Rule] r\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(showit2D[g1_, g2_, r_] := 
      Show[g1, g2\[IndentingNewLine], Axes \[Rule] False\[IndentingNewLine], 
        PlotRange \[Rule] Delete[r, 2]\[IndentingNewLine]]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
genboxes3D  named go2  gr2
\talso SET box size and style (placement is automatic)\
\>", "Subsubsection",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
(* shfun[i_]:=shells[AtomicNumber[i]]; *)
table of abbrev.
table of sci. num.\
\>", "Text"],

Cell[BoxData[
    \(\(genboxes3D[len_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, ni}, \[IndentingNewLine]n = 
            Length[len]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            low\ x\ is\ thinner, \ 
            high\ x\ is\ taller\ *) \[IndentingNewLine]sc = {3.5, 
                1, \((17.0/
                    4.0)\)}\ 100; \[IndentingNewLine]\(ul = {\(- .04\),  .01, \
 .04};\)\n\(ll = {\(- .04\),  .01, \(- .04\)};\)\n\(lr = { .04,  .01, \(- .04\
\)};\)\n\(ur = { .04,  .01,  .04}\); \
\[IndentingNewLine]\[IndentingNewLine]Do[\[IndentingNewLine]i = 
              len[\([ni]\)]; \[IndentingNewLine]If[
              odat[elem, i] =!= "\<\>" || 
                i === helpcell, \[IndentingNewLine]pt = 
                opos[1, i]; \[IndentingNewLine]v = 
                boxpts[opos[1, i], sc, ul, ll, lr, ur, 
                  False]; \[IndentingNewLine]gr2[\([1, i]\)] = 
                boxgr3D[v];\[IndentingNewLine], 
              gr2[\([1, i]\)] = Graphics3D[{}]\[IndentingNewLine]], {ni, 
              n}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go2 = 
            Table[i = len[\([ni]\)]; 
              gr2[\([o, i]\)], {o, 1, 1}, {ni, 1, 
                n}];\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
(* ooops gr2 == go2 now but don't assume that further below \
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["gentext3D  named go  gr", "Subsubsection"],

Cell["\<\
(* shfun[i_]:=shells[AtomicNumber[i]]; *)
table of abbrev.
table of sci. num.\
\>", "Text"],

Cell[BoxData[
    \(\(gentext3D[len_List, items_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, m, n, ni, 
            mo}, \[IndentingNewLine]n = Length[len]; \[IndentingNewLine]m = 
            Length[items]; \[IndentingNewLine]\[IndentingNewLine]Do[
            Do[\[IndentingNewLine]i = len[\([ni]\)]; \[IndentingNewLine]o = 
                items[\([mo]\)]; \[IndentingNewLine]gr[\([o, 
                    i]\)] = \[IndentingNewLine]If[
                  leftalign === 0, \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], opos[o, i], 
                    oattr[o, i]], \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], opos[o, i], ooffset[o, i], 
                    odir[o, i], oattr[o, i]]\[IndentingNewLine]], {ni, 
                n}\[IndentingNewLine]], {mo, 
              m}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go = 
            Graphics3D[\[IndentingNewLine]Table[i = len[\([ni]\)]; 
                o = items[\([mo]\)]; 
                gr[\([o, i]\)], {mo, 1, m}, {ni, 1, 
                  n}]\[IndentingNewLine]];\[IndentingNewLine]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
genboxes2D  named  go22D  gr22D
\talso SET box size and style (placement is automatic)\
\>", "Subsubsection",
  Background->RGBColor[0.8, 1, 1]],

Cell[BoxData[
    \(\(genboxes2D[len_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, v, n, 
            ni}, \[IndentingNewLine]n = 
            Length[len]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            low\ x\ is\ thinner, \ 
            high\ x\ is\ taller\ *) \[IndentingNewLine]sc = {3.5, 
                1, \((17.0/
                    4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
          ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]Do[\
\[IndentingNewLine]i = len[\([ni]\)]; \[IndentingNewLine]If[
              odat[elem, i] =!= "\<\>" || 
                i === helpcell, \[IndentingNewLine]v = 
                boxpts[opos[1, i], sc, ul, ll, lr, ur, 
                  True]; \[IndentingNewLine]gr22D[\([1, i]\)] = 
                boxgr[v];\[IndentingNewLine], 
              gr22D[\([1, i]\)] = Graphics[{}]\[IndentingNewLine]], {ni, 
              n}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go22D = 
            Table[i = len[\([ni]\)]; 
              gr22D[\([o, i]\)], {o, 1, 1}, {ni, 1, 
                n}];\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["gentext2D  named  go2D  gr2D", "Subsubsection"],

Cell[BoxData[
    \(\(gentext2D[len_List, items_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, v, m, n, ni, 
            mo}, \[IndentingNewLine]n = Length[len]; \[IndentingNewLine]m = 
            Length[items]; \[IndentingNewLine]Do[
            Do[\[IndentingNewLine]i = len[\([ni]\)]; \[IndentingNewLine]o = 
                items[\([mo]\)]; \[IndentingNewLine]gr2D[\([o, 
                    i]\)] = \[IndentingNewLine]If[
                  leftalign === 0, \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], Delete[opos[o, i], 2], 
                    oattr[o, i]], \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], Delete[opos[o, i], 2], 
                    ooffset[o, i], odir[o, i], 
                    oattr[o, i]]\[IndentingNewLine]], {ni, 
                n}\[IndentingNewLine]], {mo, 
              m}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go2D = 
            Graphics[\[IndentingNewLine]Table[i = len[\([ni]\)]; 
                o = items[\([mo]\)]; 
                gr2D[\([o, i]\)], {mo, 1, m}, {ni, 1, 
                  n}]\[IndentingNewLine]];\[IndentingNewLine]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["snaptxt[]    gets contents of cell above it (incl Cell)", \
"Subsubsection"],

Cell[BoxData[
    \(\(snaptxt[] := 
        Module[{nb, nbsel, newnb, cell}, \[IndentingNewLine]nb =. ; 
          newnb =. ; 
          nbsel =. ; \[IndentingNewLine]nb = 
            EvaluationNotebook[]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, EvaluationCell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, Cell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine] (*\ 
            fixed?\[IndentingNewLine]SelectionMove[nb, All, Cell, 
              AutoScroll \[Rule] False]; \[IndentingNewLine]nbsel = 
              NotebookSelection[nb]; \[IndentingNewLine]NotebookPrint[
              nbsel, "\<warntxt.3.eps\>"];\[IndentingNewLine]\
*) \[IndentingNewLine]SelectionMove[nb, All, TextParagraph, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]cell = 
            NotebookRead[nb]; \[IndentingNewLine] (*\ 
            WORKS\ newnb =. ; \[IndentingNewLine]newnb = 
              NotebookCreate[]; \[IndentingNewLine]NotebookWrite[newnb, 
              warntxt]; \[IndentingNewLine]NotebookPrint[
              newnb, "\<warntxt.2.eps\>"];\ \
*) \[IndentingNewLine]SelectionMove[nb, After, EvaluationCell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]nb =. ; newnb =. ; 
          nbsel =. ; \[IndentingNewLine]cell\[IndentingNewLine]];\)\)], \
"Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
printcell[file,nbopts]  print PS of cell abve,allow print options\
\
\>", "Subsubsection"],

Cell["\<\
this prints cell directly above it notebook.  intent was to print \
cell only (but Display can do cell per say)\
\>", "Text"],

Cell[BoxData[
    \(\(printcell[file_String, nbopts___] := 
        Module[{nb, nbsel, newnb, cell, v, xxx}, \[IndentingNewLine]nb =. ; 
          newnb =. ; 
          nbsel =. ; \[IndentingNewLine]nb = 
            EvaluationNotebook[]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, EvaluationCell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, Cell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine] (*\ 
            fixed?\[IndentingNewLine]SelectionMove[nb, All, Cell, 
              AutoScroll \[Rule] False]; \[IndentingNewLine]nbsel = 
              NotebookSelection[nb]; \[IndentingNewLine]NotebookPrint[
              nbsel, "\<warntxt.3.eps\>"];\[IndentingNewLine]\
*) \[IndentingNewLine]SelectionMove[nb, All, TextParagraph, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]cell = 
            NotebookRead[
              nb]; \[IndentingNewLine]newnb =. ; \[IndentingNewLine]newnb = 
            NotebookCreate[
              Visible \[Rule] False]; \[IndentingNewLine]SelectionMove[newnb, 
            All, Notebook, 
            AutoScroll \[Rule] 
              False]; \[IndentingNewLine] (*\ \[IndentingNewLine]bug\ if\ \
opts\ not\ defined\ short\ circuits\ most\ tests\[IndentingNewLine]\
*) \[IndentingNewLine]If[
            Length[{nbopts}] =!= 
              0, \[IndentingNewLine] (*\(SetOptions[EvaluationNotebook[], 
                  nbopts];\)*) \[IndentingNewLine]\(SetOptions[newnb, 
                nbopts];\)\[IndentingNewLine]]; \
\[IndentingNewLine]NotebookWrite[newnb, 
            cell]; \[IndentingNewLine]NotebookPrint[newnb, 
            file]; \[IndentingNewLine]SelectionMove[newnb, All, Notebook, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]nbsel = 
            NotebookSelection[newnb]; \[IndentingNewLine]v = 
            Options[newnb]; \[IndentingNewLine]NotebookClose[
            newnb]; \[IndentingNewLine]nb =. ; newnb =. ; 
          nbsel =. ; \[IndentingNewLine]v\[IndentingNewLine]];\)\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Reset gr, cmat, layout", "Subsection",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["init gr tables and cmat (overall chart position vecs)", "Subsubsection"],

Cell["\<\
these are just resets for further below they hold graphics \
\"primatives\" text\
\>", "Text"],

Cell[BoxData[
    \(\(gr = Table[i, {o, 1, textobjects}, {i, 1, objlen}];\)\)], "Input"],

Cell["\<\
not a good idea - geninit will need to be redefined if this is done\
\
\>", "Text"],

Cell[BoxData[
    \( (*\ \(Remove[go, gr, go2D, gr2D];\)\ *) \)], "Input"],

Cell[BoxData[
    \(go =. ; gr =. ; go2D =. ; gr2D =. ;\)], "Input"],

Cell[BoxData[
    \(\(gr = Table[i, {o, 1, textobjects}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(gr2D = Table[i, {o, 1, textobjects}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \( (*\ \(Remove[go2, gr2, go22D, gr22D];\)\ *) \)], "Input"],

Cell[BoxData[
    \(go2 =. ; gr2 =. ; go22D =. ; gr22D =. ;\)], "Input"],

Cell[BoxData[
    \(\(gr2 = Table[i, {o, 1, objects}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(gr22D = Table[i, {o, 1, objects}, {i, 1, objlen}];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["old layout / work area", "Subsubsection"],

Cell["\<\
cram forms ~ 1000 x 100 plot.
below: 1-1 scalar multiply not dot product.  convenient row op!\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{"layout", "=", 
        RowBox[{
          RowBox[{"(", GridBox[{
                {"0", "0", "0"},
                {".01", "0", ".01"},
                {\(- .01\), "0", \(- .01\)},
                {".01", "0", \(- .01\)},
                {".009", "0", ".02"}
                }], ")"}], 
          RowBox[{"(", GridBox[{
                {"1", "1", "1"},
                {"3", "1", "0"},
                {"3", "1", "3"},
                {"3", "1", "3"},
                {"3", "1", "1"}
                }], ")"}], "200"}]}], ";"}]], "Input"],

Cell["\<\
\"corrections\"
\tallows various kinds of corrections to item or whole table
\tthese can be combined into a single column by: layout // MatrixForm
( x  z  y ) (scale of offsets)
\twhere each triplet is pos for object n for odat[n]
\twhere -x is left and -y is down\
\>", "Text"],

Cell[BoxData[
    \(add =. ; mul =. ; add2 =. ; add4 =. ; mul4 =. ;\)], "Input"],

Cell["older table, unused (actually, layout2 is same)", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout", "=", 
          RowBox[{
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {".005", "0", \(- .008\)},
                  {".001", "0", \(- .065\)},
                  {".001", "0", \(- .077\)},
                  {".005", "0", ".01"},
                  {"0", "0", ".06"},
                  {\(- .014\), "0", \(- .03\)},
                  {\(- .002\), "0", \(- .03\)},
                  {\(- .014\), "0", ".03"},
                  {\(- .002\), "0", ".03"},
                  {".002", "0", \(- .025\)},
                  {".015", "0", \(- .03\)},
                  {"0", "0", \(- .04\)},
                  {\(- .014\), "0", ".02"},
                  {\(- .002\), "0", ".02"},
                  {"0", "0", ".04"},
                  {".010", "0", ".04"},
                  {"0", "0", ".03"},
                  {".010", "0", ".03"},
                  {"0", "0", ".02"},
                  {".010", "0", ".02"},
                  {\(- .014\), "0", ".04"},
                  {\(- .002\), "0", ".04"},
                  {\(- .014\), "0", ".01"},
                  {\(- .002\), "0", ".01"},
                  {\(- .014\), "0", "0"},
                  {\(- .002\), "0", "0"},
                  {\(- .014\), "0", \(- .01\)},
                  {\(- .002\), "0", \(- .01\)},
                  {\(- .014\), "0", \(- .02\)},
                  {\(- .002\), "0", \(- .02\)},
                  {\(- .014\), "0", \(- .065\)},
                  {\(- .014\), "0", \(- .08\)},
                  {\(- .014\), "0", \(- .052\)},
                  {"0", "0", \(- .052\)}
                  }], ")"}], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"add2", "=", 
          RowBox[{"(", GridBox[{
                {"0", "0", "0"},
                {"0", "0", ".005"},
                {"0", "0", ".0025"},
                {"0", "0", "0"},
                {"0", "0", ".001"},
                {"0", "0", "0"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".005"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0025"},
                {"0", "0", "0"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
this older table is ok if Text offset isn't left (though even with \
padding text won't alight well but looks ok if fonts aren't changed).  see \
thing about (\\\\220) in init below \"/\" (see discussion in init \
below)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout2", "=", 
          RowBox[{
            TagBox[
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0", "0", "0"},
                    {"6.4", "0", "1.2"},
                    {"4", "0", \(-10.5\)},
                    {"4", "0", \(-13.4\)},
                    {"6.4", "0", "4.2"},
                    {"3", "0", "14"},
                    {\(-10\), "0", \(-2.9\)},
                    {\(-3\), "0", \(-2.9\)},
                    {\(-10\), "0", "9.1"},
                    {\(-3\), "0", "9.1"},
                    {"4.6", "0", \(-2\)},
                    {\(-10\), "0", \(-4.9\)},
                    {"2", "0", \(-4.9\)},
                    {\(-10\), "0", "7.1"},
                    {\(-3\), "0", "7.1"},
                    {"2", "0", "11.1"},
                    {"9.4", "0", "11.1"},
                    {"2", "0", "9.1"},
                    {"9.4", "0", "9.1"},
                    {"2", "0", "7.1"},
                    {"9.4", "0", "7.1"},
                    {\(-10\), "0", "11.1"},
                    {\(-3\), "0", "11.1"},
                    {\(-10\), "0", "5.1"},
                    {\(-3\), "0", "5.1"},
                    {\(-10\), "0", "3.1"},
                    {\(-3\), "0", "3.1"},
                    {\(-10\), "0", "1.1"},
                    {\(-3\), "0", "1.1"},
                    {\(-10\), "0", \(-0.9\)},
                    {\(-3\), "0", \(-0.9\)},
                    {\(-10\), "0", \(-10.5\)},
                    {\(-10\), "0", \(-14\)},
                    {\(-10\), "0", \(-7.3\)},
                    {"2", "0", \(-7.3\)},
                    {"8", "0", "15"},
                    {"0", "0", "23"},
                    {"0", "0", "27"}
                    }], "\[NoBreak]", ")"}],
              (MatrixForm[ #]&)], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout3", "=", 
          RowBox[{
            TagBox[
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0", "0", "0"},
                    {"0", "0", "1.2"},
                    {\(-8\), "0", \(-10.5\)},
                    {\(-8\), "0", \(-14\)},
                    {"0", "0", "4.2"},
                    {"0", "0", "14"},
                    {\(-16\), "0", \(-2.9\)},
                    {\(-8\), "0", \(-2.9\)},
                    {\(-16\), "0", "9.1"},
                    {\(-8\), "0", "9.1"},
                    {"0", "0", \(-2\)},
                    {\(-16\), "0", \(-4.9\)},
                    {\(-8\), "0", \(-4.9\)},
                    {\(-16\), "0", "7.1"},
                    {\(-8\), "0", "7.1"},
                    {\(-4\), "0", "11.1"},
                    {"4", "0", "11.1"},
                    {\(-4\), "0", "9.1"},
                    {"4", "0", "9.1"},
                    {\(-4\), "0", "7.1"},
                    {"4", "0", "7.1"},
                    {\(-16\), "0", "11.1"},
                    {\(-8\), "0", "11.1"},
                    {\(-16\), "0", "5.1"},
                    {\(-8\), "0", "5.1"},
                    {\(-16\), "0", "3.1"},
                    {\(-8\), "0", "3.1"},
                    {\(-16\), "0", "1.1"},
                    {\(-8\), "0", "1.1"},
                    {\(-16\), "0", \(-0.9\)},
                    {\(-8\), "0", \(-0.9\)},
                    {\(-16\), "0", \(-10.5\)},
                    {\(-16\), "0", \(-14\)},
                    {\(-16\), "0", \(-7.3\)},
                    {\(-8\), "0", \(-7.3\)},
                    {"8", "0", "15"},
                    {"0", "0", "23"},
                    {"0", "0", "27"}
                    }], "\[NoBreak]", ")"}],
              (MatrixForm[ #]&)], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    \(\(If[leftalign === 1, layout2 = layout3];\)\)], "Input"],

Cell["\<\
unused: list of what is text (datem) or what is label
\t0 is label  1 is datem  2 datem / other kind
\t3 special datem  4 always centered datem\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"istxt", "=", 
          RowBox[{"(", GridBox[{
                {"4"},
                {"3"},
                {"2"},
                {"2"},
                {"3"},
                {"4"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"3"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"1"},
                {"4"},
                {"4"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
for help cell, what gets bumped to right
\tthis is usu. labels using mathfonts (ie, colored labels)
\t\t(these go left due to multiple of label space)
\thowever uses table because a few are work-arounds anyhow\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxthelp", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(co\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
for BW only, labels that also loose mathfonts and will need to be \
bumped right (see create go2DBW).  centered text or special are not \
bumped\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtbw", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
list of datem to disable use of MathMono-Bold for
\t(currently uses OutputFormt)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtfont", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    \(\(add = 
        Table[\[IndentingNewLine]If[
            layout[\([i, 1]\)] =!= 0, \[IndentingNewLine]If[
              layout[\([i, 1]\)] \[LessEqual] 0, {\(- .02\) +  .012, 0, 
                0 +  .01}, { .005 +  .012, 0, 
                0 +  .01}]\[IndentingNewLine], {0 +  .01, 0, 
              0 +  .01}]\[IndentingNewLine], {i, 1, 
            Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add2[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(add[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(mul = Table[{1, 1, 1}, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(mul4 = Table[{1, 1, 1}, {i, 1, Length[layout2]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add4 = Table[{0, 0, 0}, {i, 1, Length[layout2]}];\)\)], "Input"],

Cell[BoxData[
    \(\(mul[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(mul4[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(add4[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(layout = \((layout\  + add + add2)\) 200\ mul;\)\)], "Input"],

Cell[BoxData[
    \(\(layout2 = \((layout2\  + add4)\) 1\ mul4;\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[BoxData[
    \( (*\ layout // TableForm\ *) \)], "Input"],

Cell[BoxData[
    \(\(Remove[add, mul, add2];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["layout of data  (relative to any center)", "Subsubsection",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
(*
give position of cell data relative to cell center.   also add1/0 as yes/no \
for what help, b&w, font fixes will be applied to item.
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout", "=", 
          RowBox[{
            TagBox[
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0", "0", "0"},
                    {"0", "0", "1.2"},
                    {\(-8\), "0", \(-10.5\)},
                    {\(-8\), "0", \(-14\)},
                    {"0", "0", "4.2"},
                    {"0", "0", "14"},
                    {\(-16\), "0", \(-2.9\)},
                    {\(-8\), "0", \(-2.9\)},
                    {\(-16\), "0", "9.1"},
                    {\(-8\), "0", "9.1"},
                    {"0", "0", \(-2\)},
                    {\(-16\), "0", \(-4.9\)},
                    {\(-8\), "0", \(-4.9\)},
                    {\(-16\), "0", "7.1"},
                    {\(-8\), "0", "7.1"},
                    {\(-4\), "0", "11.1"},
                    {"4", "0", "11.1"},
                    {\(-4\), "0", "9.1"},
                    {"4", "0", "9.1"},
                    {\(-4\), "0", "7.1"},
                    {"4", "0", "7.1"},
                    {\(-16\), "0", "11.1"},
                    {\(-8\), "0", "11.1"},
                    {\(-16\), "0", "5.1"},
                    {\(-8\), "0", "5.1"},
                    {\(-16\), "0", "3.1"},
                    {\(-8\), "0", "3.1"},
                    {\(-16\), "0", "1.1"},
                    {\(-8\), "0", "1.1"},
                    {\(-16\), "0", \(-0.9\)},
                    {\(-8\), "0", \(-0.9\)},
                    {\(-16\), "0", \(-10.5\)},
                    {\(-16\), "0", \(-14\)},
                    {\(-16\), "0", \(-7.3\)},
                    {\(-8\), "0", \(-7.3\)},
                    {"8", "0", "15"},
                    {"0", "0", "23"},
                    {"0", "0", "27"}
                    }], "\[NoBreak]", ")"}],
              (MatrixForm[ #]&)], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
(*
for help cell, what gets bumped to right
\tthis is usu. labels using mathfonts (ie, colored labels)
\t\t(these go left due to multiple of label space)
\thowever uses table because a few are work-arounds anyhow
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxthelp", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(co\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
(*
for BW only, labels that also loose mathfonts and will need to be bumped \
right (see create go2DBW).  centered text or special are not bumped
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtbw", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
(*
list of datem to disable use of MathMono-Bold for
\t(currently uses OutputFormt)
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtfont", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
diversion
\tspecial fix bump down helpcell's col alias adn col group\
\>", "Subsection"],

Cell["\<\
(*
these mod bumps items col alias and col group down a little for help cell \
only
\tit requires re-evaluating Center of Cell above and layout if changed
\t\twon't work first time if left in Data and Text section above
\tprobably not the best way but it's a one-off deal so...
*)\
\>", "Text"],

Cell[BoxData[
    \(If[oncehelppos === False, opos[37, helpcell] += {0, 0, 17}]\)], "Input"],

Cell[BoxData[
    \(If[oncehelppos === False, opos[38, helpcell] += {0, 0, 17}]\)], "Input"],

Cell[BoxData[
    \(\(oncehelppos = True;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Run   geninit\n",
  StyleBox["and do fix-ups to automate making the helpcell",
    FontSize->11]
}], "Subsection"],

Cell[CellGroupData[{

Cell["generate and discuss", "Subsubsection"],

Cell["(* make go2 *)", "Text"],

Cell[BoxData[
    \(\(If[do3D === 1, genboxes3D[Range[1, objlen]]];\)\)], "Input"],

Cell["(* make go *)", "Text"],

Cell[BoxData[
    \(\(If[do3D === 1, 
        gentext3D[Range[1, objlen], Range[1, textobjects]]];\)\)], "Input"],

Cell[BoxData[
    \(\(genboxes2D[Range[1, objlen]];\)\)], "Input"],

Cell[BoxData[
    \(\(gentext2D[Range[1, objlen], Range[1, textobjects]];\)\)], "Input"],

Cell["\<\
(*
now replace some things so that each data item need not do so
\tnote: for easier rules it's assumed
\t\tTextStyle->FontSize is present for each datem
*)\
\>", "Text"],

Cell["\<\
(*
go / go2D  text graphics, made larger for front-end.  go is for Graphics3D
go4 go42D copy of text graphics \"condensed sizes\".  go4 is for Graphics3D
go2 go22D boxes.  same boxes used either way.  go2 is for Graphics3D
gr.... are same objects but not wrapped in Graphics (hardly different)
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["double go go2 fonts", "Subsubsection"],

Cell["\<\
(*
scale font sizes so we don't need to edit them
\told news: had 2x fonts when go4 was used
*)\
\>", "Text"],

Cell[BoxData[
    \(x =. ; y =. ; z =. ; w =. ; q =. ;\)], "Input"],

Cell[BoxData[
    \(\(go[\([1]\)] = 
        go[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .5)\), y}, w];\)\)], "Input"],

Cell[BoxData[
    \(go[\([1, 2, 1]\)]\)], "Input"],

Cell[BoxData[
    \(\(go2D[\([1]\)] = 
        go2D[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .5)\), y}, w];\)\)], "Input"],

Cell[BoxData[
    \(go2D[\([1, 2, 1]\)]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["change some to NOT Math2Mono-Bold (use FormatType Output)", \
"Subsubsection"],

Cell[TextData[{
  StyleBox["(*\nMathematica",
    FontSlant->"Italic"],
  " uses \\\\220 for \"/\" Math2Mono-Bold and GhostScript won't like it (and \
also renders all strings one char at a time).  Maybe some option can force \
fonts to be included for EPS but instead FormatType is set so Math2Mono-Bold \
is not attempted.  I'd guess ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " does that so rendering expressions in plots is hands-free.\n\nBelow if \
one /. \"(\\\\220) show\" with \"(/) show\" AFTER Show[] that takes care of \
the only font problem this chart currently uses without (changing all fonts \
or messing with including fonts in output).  So it would need to be rendered \
2x every time.\n*)"
}], "Text"],

Cell[BoxData[
    \(\(Show[
        Graphics[{Text["\<W / Km\>", {0, 
                0}, \[IndentingNewLine]TextStyle \[Rule] {FontWeight \[Rule] 
                    7, FontFamily \[Rule] "\<Courier\>", 
                  FontColor \[Rule] 
                    RGBColor[0.85`, 0, 0]\[IndentingNewLine]}, 
              FormatType \[Rule] OutputForm]\[IndentingNewLine]}], 
        ImageSize \[Rule] {100, 50}];\)\)], "Input"],

Cell["\<\
(*
\tOOPS: FormatType doesn't allow color but renders allot faster
\tOOPS: without FormatType, FontFamily slows rendering terribly slow
\tHowever: together they create a nice Black & White chart
\tnote:  replace rule assumes nothing above added font family
*)\
\>", "Text"],

Cell["\<\
(*
test.
\trender nums / help strings as simplified text
\tfaster and less \"font needy\" but no color ? ...
*)\
\>", "Text"],

Cell[BoxData[
    \(x =. ; w =. ; z =. ; w =. ; q =. ;\)], "Input"],

Cell[BoxData[
    \(go2D[\([1, 31, 1]\)]\)], "Input"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]\(If[
          fixtxtfont[\([j, 1]\)] === 
            1, \[IndentingNewLine]\(go2D[\([1, j]\)] = 
              go2D[\([1, j]\)] /. \[IndentingNewLine]Text[z__, 
                    TextStyle -> {y___}, 
                    w___] \[Rule] \[IndentingNewLine]Text[z, 
                    TextStyle -> {y\  (*\(,\)\(FontFamily \[Rule] \
"\<Courier\>"\)*) }, w\ , 
                    FormatType -> 
                      OutputForm];\)\[IndentingNewLine]];\)\[IndentingNewLine]\
, {j, textobjects}\[IndentingNewLine]]\)], "Input"],

Cell["\<\
(*
NEW
\t3D's go seems to want to be like go2D
\t3D was left somewhat un-tested a while
\tas noted for 2DBW both above and below
\tchange boxing for b&w nums only: but looks fine
\tonly OS n SI n even have squares to see and look maybe better
*)\
\>", "Text"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]\(If[
          fixtxtfont[\([j, 1]\)] === 
            1, \[IndentingNewLine]\(go[\([1, j]\)] = 
              go[\([1, j]\)] /. \[IndentingNewLine]Text[z__, 
                    TextStyle -> {y___}, 
                    w___] \[Rule] \[IndentingNewLine]Text[z, 
                    TextStyle -> {y\  (*\(,\)\(FontFamily \[Rule] \
"\<Courier\>"\)*) }, w\ , 
                    FormatType -> 
                      OutputForm];\)\[IndentingNewLine]];\)\[IndentingNewLine]\
, {j, textobjects}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(go2D[\([1, 31, 1]\)]\)], "Input"],

Cell["\<\
(* instead use OutputForm for most numbers, since none are \
formatted anyhow *)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["create go2DBW", "Subsubsection"],

Cell["\<\
(* unfortunately left align at {x, y} is not \"pure\" ...
\t\"boxed\" fonts do not line up with regular ps text
\t
magic 3 is added to x on all boxed fonts that aren't boxed for 2DBW

this is \"wrong\" as it causes boxing problems - a better way that is as \
efficient but for friendly needs to be found that works color, does ascii w/o \
require PS hacking or OutputForm
*)\
\>", "Text"],

Cell["\<\
Do[go2DBW[[1,o,i,2]]=+={3,0}; ,{i,objlen}];
(*\tis so slow as to be considered broken / not be usable
\tdamn can't remember there is a way that does work ?? v[[1]] *)\
\>", "Text"],

Cell[BoxData[
    \(\(add =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(layout2 = layout;\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout + Table[{3, 0, 0}, {i, 1, textobjects}];\)\)], "Input"],

Cell["\<\
(* could save go2D, remake new with geninit , swap back :   instead \
update effected ... *)\
\>", "Text"],

Cell[BoxData[
    \(\(go2DBW = go2D;\)\)], "Input"],

Cell[BoxData[
    \(If[leftalign === 
        1, \[IndentingNewLine]Do[\[IndentingNewLine]If[
          fixtxtfont[\([o, 1]\)] \[Equal] 0 && 
            fixtxtbw[\([o, 1]\)] \[Equal] 
              1, \[IndentingNewLine]Do[\[IndentingNewLine]go2DBW[\([1, o, 
                  i]\)] = \[IndentingNewLine]Text[DisplayForm[odat[o, i]], 
                Delete[opos[o, i], 2], ooffset[o, i], odir[o, i], 
                oattr[o, i]]\[IndentingNewLine], {i, 
              objlen}\[IndentingNewLine]]], {o, 
          textobjects}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(If[leftalign === 
        1, \[IndentingNewLine]Do[\[IndentingNewLine]If[
          fixtxtfont[\([o, 1]\)] \[Equal] 0 && 
            fixtxtbw[\([o, 1]\)] \[Equal] 
              1, \[IndentingNewLine]Do[\[IndentingNewLine]\(go2DBW[\([1, 
                    o]\)] = 
                go2DBW[\([1, o, All]\)] /. 
                  Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                      w___] \[Rule] 
                    Text[z, TextStyle -> {FontSize -> \((x\ \  .5)\), y}, 
                      w];\)\[IndentingNewLine]]], {o, 
          textobjects}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(go2DBW[\([1, 7, 1]\)]\)], "Input"],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[BoxData[
    \(go2DBW[\([1, 7, 1]\)]\)], "Input"],

Cell["\<\
(* with that problem and the one below (that dialating causes wrong \
spacing) maybe
a template should be used to make element cells.  though note it's using the \
same layout
for both color and BW that causes a work-around *)\
\>", "Text"],

Cell[BoxData[
    \(\(go2DBW[\([1]\)] = 
        go2DBW[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {y___}, w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {y\  (*\ \(,\)\(FontFamily \[Rule] "\<Courier\>"\)\
\ *) \ }, w\ , FormatType -> OutputForm];\)\)], "Input"],

Cell[BoxData[
    \(go2DBW[\([1, 2, 1]\)]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["double help cell font / move as necessary", "Subsubsection"],

Cell["(* change font bigger for helpcell *)", "Text"],

Cell[BoxData[
    \(\(Do[\(go[\([1, i, helpcell]\)] = 
            go[\([1, i, helpcell]\)] /. 
              Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                  w___] \[Rule] 
                Text[z, TextStyle -> {FontSize -> \((x\ \ 2)\), y}, 
                  w];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\(go2D[\([1, i, helpcell]\)] = 
            go2D[\([1, i, helpcell]\)] /. 
              Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                  w___] \[Rule] 
                Text[z, TextStyle -> {FontSize -> \((x\ \ 2)\), y}, 
                  w];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\(go2DBW[\([1, i, helpcell]\)] = 
            go2DBW[\([1, i, helpcell]\)] /. 
              Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                  w___] \[Rule] 
                Text[z, TextStyle -> {FontSize -> \((x\ \ 2)\), y}, 
                  w];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(go[\([1, 31, helpcell]\)]\)], "Input"],

Cell[BoxData[
    \(go2D[\([1, 31, helpcell]\)]\)], "Input"],

Cell["\<\
(* scale position of text for help cell (needs 2x tall and 4x wide) \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(layout2 = layout;\)\)], "Input"],

Cell["\<\
(* any other boxed pinned to benear help box below needs to know *)\
\
\>", "Text"],

Cell[BoxData[
    \(\(\(helpcellmul = {6, 1, 2};\)\(\ \)\)\)], "Input"],

Cell[BoxData[
    \(add =. ; mul =. ;\)], "Input"],

Cell[BoxData[
    \(\(mul = Table[helpcellmul, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add = 
        Table[{If[fixtxthelp[\([i]\)] === {0}, 35, 0], 0, 
            0} (*\(+{\(-850\), 0, \(-176\)}\)*) , {i, 1, 
            Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add = 
        Table[\[IndentingNewLine]{If[fixtxthelp[\([i, 1]\)] === 1, 35, 0], 0, 
            0}, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add[\([36]\)] += {\(-10\), 0, 0};\)\)], "Input"],

Cell["\<\
{-850,0,-176} if not using opos (that is, using mul and add \
directly on position)\
\>", "Text"],

Cell[BoxData[
    \(\(layout = \((layout\ mul)\) + add;\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\[IndentingNewLine]\(go[\([1, i, helpcell, 2]\)] = 
            opos[i, helpcell];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\[IndentingNewLine]\(go2D[\([1, i, helpcell, 2]\)] = 
            Delete[opos[i, helpcell], 2];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[BoxData[
    \(add2 =. ; mul2 =. ;\)], "Input"],

Cell[BoxData[
    \(\(layout2 = layout;\)\)], "Input"],

Cell[BoxData[
    \(\(mul2 = Table[helpcellmul, {i, 1, Length[layout]}];\)\)], "Input"],

Cell["\<\
(* if label or non-label and not fixed and not centered, add 35 \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(add2 = 
        Table[\[IndentingNewLine]{If[fixtxthelp[\([i, 1]\)] === 1, 35, 0], 0, 
            0}, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add2[\([36]\)] += {\(-10\), 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(layout = \((layout\ mul2)\) + add2;\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\[IndentingNewLine]\(go2DBW[\([1, i, helpcell, 2]\)] = 
            Delete[opos[i, helpcell], 2];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[BoxData[
    \(go2D[\([1, 2, {helpcell, 1}]\)]\)], "Input"],

Cell[BoxData[
    \(go2DBW[\([1, 2, {helpcell, 1}]\)]\)], "Input"],

Cell[BoxData[
    \(go[\([1, 3, {200, 1}]\)]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["unused: make go4 series (same with diff font)", "Subsubsection"],

Cell["unused now", "Text"],

Cell["\<\
reduce font from 2x above to 1/4 (1/2 spec. that is) for printout
why ?
\t* to examine just 2 cells usin plotrange large font need
\t* instead BW is faster and EPS viewed with gv is better\
\>", "Text"],

Cell[BoxData[
    \(go4 = go; go42D = go2D; go42DBW = go2DBW;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go4[\([1]\)] = 
        go[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .25)\), y}, w];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(go42D[\([1]\)] = 
        go2D[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .25)\), y}, w];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(go42DBW[\([1]\)] = 
        go2DBW[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .25)\), y}, w];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(go42D[\([1, 34, {190, 1}]\)]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["help cell box", "Subsubsection"],

Cell["\<\
(*
double size box for help cell for 3D
\t.35 left visually appears to have too much margin because strings on right
\tare (too) long, so compensate ul,ll,lr,ur for that
*)\
\>", "Text"],

Cell[BoxData[
    \(\(go2 = Table[gr2[\([o, i]\)], {o, 1, 1}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(\( (*\ 
      scale\ box\ *) \)\(\[IndentingNewLine]\)\(Module[{o, i, pt, ul, ll, lr, 
          ur, sc, dx}, 
        i = 0; \[IndentingNewLine]\[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .0325\),  .01, \
 .04}; \n\(ll = {\(- .0325\),  .01, \(- .04\)};\)\n\(lr = { .0415,  .01, \(- \
.04\)};\)\n\(ur = { .0415,  .01,  .04}\); \[IndentingNewLine] (*\ 
          tighter\ *) \[IndentingNewLine]ul = {\(- .031\),  .01,  .04}; \n
        ll = {\(- .031\),  .01, \(- .04\)}; \n
        lr = { .040,  .01, \(- .04\)}; \n
        ur = { .040,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]dx = \
{3, 1, 1}; \[IndentingNewLine]i = 
          helpcell; \[IndentingNewLine]gr2[\([1, 
              i]\)] = \[IndentingNewLine]Graphics3D[{\[IndentingNewLine]\
Thickness[ .0001], RGBColor[ .1,  .1,  .6], 
              Line[boxpts[opos[1, i], sc\ 2, ul\ dx, ll\ dx, lr\ dx, ur\ dx, 
                  False]]\[IndentingNewLine]}]; \[IndentingNewLine]\
\[IndentingNewLine]go2[\([1, helpcell]\)] = 
          gr2[\([1, helpcell]\)];\[IndentingNewLine]];\)\)\)], "Input"],

Cell["ditto for 2D", "Text"],

Cell[BoxData[
    \(\(go22D = 
        Table[gr22D[\([o, i]\)], {o, 1, 1}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(\( (*\ 
      scale\ box\ *) \)\(\[IndentingNewLine]\)\(Module[{o, i, pt, ul, ll, lr, 
          ur, sc, dx}, 
        i = 0; \[IndentingNewLine]\[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .0325\),  .01, \
 .04}; \nll = {\(- .0325\),  .01, \(- .04\)}; \n
        lr = { .0415,  .01, \(- .04\)}; \n
        ur = { .0415,  .01,  .04}; \[IndentingNewLine] (*\ 
          tighter\ *) \[IndentingNewLine]ul = {\(- .031\),  .01,  .04}; \n
        ll = {\(- .031\),  .01, \(- .04\)}; \n
        lr = { .040,  .01, \(- .04\)}; \n
        ur = { .040,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]dx = \
{3, 1, 1}; \[IndentingNewLine]i = 
          helpcell; \[IndentingNewLine]gr22D[\([1, 
              i]\)] = \[IndentingNewLine]Graphics[{\[IndentingNewLine]\
Thickness[ .0001], 
              RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[
                boxpts[opos[1, i], sc\ 2, ul\ dx, ll\ dx, lr\ dx, ur\ dx, 
                  True]]\[IndentingNewLine]}]; \[IndentingNewLine]\
\[IndentingNewLine]go22D[\([1, helpcell]\)] = 
          gr22D[\([1, helpcell]\)];\[IndentingNewLine]];\)\)\)], "Input"],

Cell[BoxData[
    RowBox[{"Show", "[", 
      RowBox[{"Graphics3D", "[", 
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox["\"\<8a-0, 18\>\"",
              DisplayForm], 
            ",", \({724.4318181818181`, 0.`, 377.64935064935065`}\), 
            ",", \({0, 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 3}\)}], "]"}], "]"}], 
      "]"}]], "Input"],

Cell[BoxData[
    \(Show[Graphics3D[gr[\([2]\)]]]\)], "Input"],

Cell[BoxData[
    \(go22D[\([1, 200]\)]\)], "Input"],

Cell[BoxData[
    \(go22D[\([1, 201]\)]\)], "Input"],

Cell[BoxData[
    \(Show[%, %%]\)], "Input"],

Cell[BoxData[
    \(go2[\([1, 200]\)]\)], "Input"],

Cell[BoxData[
    \(go2[\([1, 201]\)]\)], "Input"],

Cell[BoxData[
    \(Show[%, %%]\)], "Input"],

Cell[BoxData[
    \(Show[go2]\)], "Input"],

Cell[BoxData[
    \(Show[go22D]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["make legends", "Subsection"],

Cell["\<\
(*
 most non-periodic table / text is not programatic they are just regular text \
(but uses opos to place is all)
*)\
\>", "Text"],

Cell[CellGroupData[{

Cell["disuss and print options", "Subsubsection"],

Cell["\<\
ps files have 612 x 792 sizes, condensed layout charts should fit \
landscape fine, 9.7\"x2.9\"\
\>", "Text"],

Cell[BoxData[
    \({700, 210}/72 // N\)], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"printopts", "=", 
        RowBox[{"Sequence", "[", "\[IndentingNewLine]", 
          RowBox[{
            RowBox[{
              StyleBox["FirstPageHeader",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{
              StyleBox["FirstPageFooter",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{
              StyleBox["RestPagesHeader",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{
              StyleBox["RestPagesFooter",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{"(*", " ", 
              RowBox[{
                RowBox[{
                  StyleBox["PageHeaderLines",
                    FontFamily->"Courier"], "\[Rule]", \({False, False}\)}], 
                ","}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{
              StyleBox["PrintRegistrationMarks",
                FontFamily->"Courier"], "->", "False"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
              StyleBox["IncludeSpecialFonts",
                FontFamily->"Courier"], "->", "True"}], ",", "\n", 
            RowBox[{
              StyleBox["IncludePostScriptResourceDirectives",
                FontFamily->"Courier"], "->", "True"}], ",", "\n", 
            RowBox[{
              StyleBox["UsePostScriptOutputFile",
                FontFamily->"Courier"], "->", "True"}], ",", "\n", 
            RowBox[{"(*", " ", 
              RowBox[{
                RowBox[{
                  StyleBox["PostScriptOutputFile",
                    FontFamily->"Courier"], "\[Rule]", "file"}], ","}], " ", 
              "*)"}], "\n", 
            RowBox[{
              StyleBox["Magnification",
                FontFamily->"Courier"], "\[Rule]", "1"}], ",", "\n", 
            RowBox[{
              StyleBox["PaperSize",
                FontFamily->"Courier"], "\[Rule]", \({700, 210}\)}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
              RowBox[{
                RowBox[{
                  StyleBox["PageSize",
                    FontFamily->"Courier"], "\[Rule]", \({700, 210}\)}], 
                ","}], " ", "*)"}], "\n", 
            RowBox[{
              StyleBox["PrintingMargins",
                FontFamily->"Courier"], "\[Rule]", \({{0, 0}, {0, 0}}\)}]}], 
          "\[IndentingNewLine]", "]"}]}], ";"}]], "Input"],

Cell["\<\
helpcell isn't considered a \"legend\" because it draws as if it's \
another element\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["powers table gr  (created far above in basic setup)", "Subsubsection"],

Cell["pin to top rows of chart since bottom moves around", "Text"],

Cell[BoxData[
    \( (*\ can\ also\ be\ \(used : \ whereis[Lithium] + 9\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(ptgrc = 
        go2D[\([1, 1, whereis[Boron] - 2, 2]\)] + {0, \(-10\)};\)\)], "Input"],

Cell["note bug FontSize>1 so that lines are visible", "Text"],

Cell[BoxData[
    \(\(ptgr = 
        Graphics[
          Text[powerstable, ptgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(ptgr3D = 
        Graphics3D[
          Text[powerstable, Insert[ptgrc, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["conversion table(s)  gr(s)  (several snaptxt)", "Subsubsection"],

Cell[BoxData[
    \(Convert[AtomicMassUnit, Kilo\ Gram]\)], "Input"],

Cell[BoxData[
    \(1.6605402`*^-27\ 1000\)], "Input"],

Cell[BoxData[
    \(Convert[1\ Mole, AvogadroConstant\ Mole]\)], "Input"],

Cell[BoxData[
    \(Convert[ElectronVolt, Kilo\ Joule]\)], "Input"],

Cell[BoxData[
    \(Convert[%, Joule]\)], "Input"],

Cell[BoxData[
    \(Options[fNBookForm2]\)], "Input"],

Cell[BoxData[
    \(Convert[Angstrom, Meter] // N\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[%/Meter]\)], "Input"],

Cell[BoxData[
    \(Convert[Watt, Joule/\ Second] // InputForm\)], "Input"],

Cell[BoxData[
    \(Convert[AtomicMassUnit, Gram/Mole]\)], "Input"],

Cell[BoxData[
    \(\(\(12\)\(\ \)\(Gram\/6.0221367`*^23\)\( (*\ 
        one\ atom\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(Convert[\((1.66054\[Times]10\^\(-27\)\ Kilo\ Gram)\) 12, 
      Gram]\)], "Input"],

Cell[BoxData[
    \(AvogadroConstant\)], "Input"],

Cell[BoxData[
    \(Convert[1000\ 9.109\ \ 10\^\(-31\)\ \ Gram, Gram\ Yocto]\)], "Input"],

Cell[BoxData[
    \(910.9\ \[Micro]y\ Gram\)], "Input"],

Cell[BoxData[
    \(9.109\ \(10\^\(-31\)\) k\ Gram\)], "Input"],

Cell[BoxData[
    \(% // fNBookForm2\)], "Input"],

Cell[BoxData[
    \(Convert[2.997`*^8, Mega]\)], "Input"],

Cell[BoxData[
    \(\(10\^\(-31\)\) 1000 // N\)], "Input"],

Cell[BoxData[
    \(29.97\ 10^6\)], "Input"],

Cell[BoxData[
    \(6.37\ 10\^6\  // fNBookForm2\)], "Input"],

Cell[BoxData[
    \(6.37\ 10\^6\)], "Input"],

Cell[BoxData[
    \(1.66054\[Times]10\^\(-27\)\ \ 1000\)], "Input"],

Cell[BoxData[
    \(1.66054`*^-24 // fNBookForm2\)], "Input"],

Cell[BoxData[
    \(1.60218\[Times]10\^\(-19\) // fNBookForm2\)], "Input"],

Cell["\<\
(*
this likely is less helpful - read the book you'd know to look

some facts seem very important , like \[CapitalDelta]EN , however there are \
very many such , like resitivity and triple points and ...

there's room for one or two extra charts try to stick to chemistry or very \
practical and for chemistry try to stick to most amazing numbers and trends \
(like pH 7 , ion donor , 22.4 L gas / mole).  look at highlights later maybe.
*)\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"Trends", " ", " "},
        {"\[Placeholder]", " ", " "},
        {\(\(\(\[DownArrow]\)\(\ \)\(more\)\)\ metalic\), 
          " ", \(G13 \[RightArrow] \ less\ metalic\)},
        {\(Atomic\ Radius\), 
          " ", \(\(\[LeftArrow]\)\(\ \)\(\[DownArrow]\)\)},
        {"FIP", " ", \(\(\[RightArrow]\)\(\ \)\(\[UpArrow]\)\)},
        {"subshells", 
          "\[Placeholder]", \(fill\ one\ at\ a\ time\[IndentingNewLine]
          then\ double\ up\)},
        {\(s\ p\ d\ f\), "\[Placeholder]", \(2\ 3\ 5\ 7\)}
        }]], "Text"],

Cell[BoxData[GridBox[{
        {"amu", "AtomicMassUnit", 
          "=", \(Gram\ \ /\ \ \((Mole\ \ or\ \ N\_A)\)\)},
        {\(N\_A\), 
          FormBox["AvogadroConstant",
            "InputForm"], "=", \(6.02214\[Times]10\^23\ \ Atoms\)},
        {" ", \(one\ amu\ weighs\), 
          "=", \(1.66054\[Times]10\^\(-24\)\ \ Gram\)},
        {"eV", "ElectronVolt", "=", \(1.60217733`*^-22\ Joule\ \ Kilo\)},
        {"\[Angstrom]", "Angstrom", "=", \(1.`*^-10\ Meter\)},
        {"W", "Watt", "=", \(Joule/Second\)},
        {" ", \(La\ Ac\ elem\ series\), "=", \(58 - 71\ and\ 90 - 103\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt = snaptxt[];\)\)], "Input"],

Cell[BoxData[GridBox[{
        {"Brief", "Soluability", "Table"},
        {\(if\ free\ to\ mix\), \(ex . \ 
              dissolved\ in\ water\), \(\(\ \)\(terms\)\)},
        {\(ions\^-\), \(\(alkali\^+\) or\ \(NH\_4\%+\)\), "ammonia"},
        {\(ions\^+\), \(\(C\_2\) \(H\_3\) \(O\_2\%-\) \(NO\_3\%-\)\), 
          "acetate"},
        {\(compounds\ with\ SO\_4\%\(\(2\)\(-\)\)\), \(except\ with\ \
Ba\^\(\(2\)\(+\)\)\ \ Sr\^\(\(2\)\(+\)\)\ \ Pb\^\(\(2\)\(+\)\)\), "nitrate"},
        {\(comp\ with\ \(Br\^-\)\ \ Cl\^\(\(-\)\(\ \)\)\ \(I\^-\)\), \(except\
\ with\ \(Ag\^+\)\ \ Hg\^\(\(2\)\(+\)\)\ \ Pb\^\(\(2\)\(+\)\)\), "sulfate"},
        {\(compounds\ with\ \(HCO\_3\^-\)\), \(only\ with\ \(alkali\^+\)\ or\
\ \ \(NH\_4\%+\)\[IndentingNewLine]
          earth\ alkaline\^\(\(2\)\(+\)\)\), \(carbonic\[IndentingNewLine]
          acid\)},
        {\(OH\^-\), \(only\ with\ \
\(alkali\^+\)\ \ \(NH\_4\%+\)\ \ Ba\^\(\(2\)\(+\)\)\), "hydroxide"},
        {\(\(CO\_3\^-\)\ \ PO\_4\%\(\(3\)\(-\)\)\ \ S\^\(\(2\)\(-\)\)\), \
\(only\ with\ \(alkali\^+\)\ or\ \(NH\_4\%+\)\), \(carbonate\
\[IndentingNewLine]
          phosphate\)},
        {\(if\ dissasociation\[IndentingNewLine]
          or\ association\ or\[IndentingNewLine]
          \(\(equilibria\)\(\ \)\(shift\)\(\ \)\)\), \(froms\ \((more)\) 
            water\ salt\ precipitate\[IndentingNewLine]
          gas\ pressure\ heat\ light\ resistance\[IndentingNewLine]
          \(\(equilibria\)\(\ \)\(\[LeftArrow]\)\) \[Rule] \ 
            or\ weight\ change\), "titrates"}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt2 = snaptxt[];\)\)], "Input"],

Cell[BoxData[GridBox[{
        {" ", \(Other\ Data\), " ", " "},
        {\(m\_e\), \(Electron\ Mass\), 
          "=", \(9.109\[Times]10\^\(-28\)\ \ Gram\)},
        {"C", \(Electron\ Charge\), "=", \(eV\ \ \ Joules\ of\ Work\)},
        {"c", \(Speed\ of\ Light\), 
          "=", \(\(2.997\[Times]10\^6\)\ \ Meter\ /\ Second\)},
        {" ", "STP", "=", \(0\ \[Degree]\ Celsius\ , 1\ \ Atmosphere\)},
        {\(\(\ \)\(Vg\)\), \(Gas\ Volume\), 
          "=", \(22.4\ \ Liters\ /\ Mole\ \ @\ STP\)},
        {"R", \(Gas\ Constant\), "=", \(8.20\ c\ Vg\ , \ P\ V = mol\ R\ T\)},
        {"R", \(Gas\ Constant\), "=", \(8.314\ \ J/K\ mol\)},
        {" ", \(Earth\ Radius\), "=", \(6.37`*^6\ \ Meter\)},
        {"Ge", \(Earth\ Gravity\), "=", \(9.80\ Meter\ /\ Second\^2\)},
        {"G", \(Gravity\ \((m\ m`/r\^2)\)\), 
          "=", \(6.672\ \ 10\^\(-11\)\ N\ m\^2/kg\^2\)},
        {" ", \(Air\ Density\), 
          "=", \(1.2\ k\ Gram\ /\ \(Meter\^3\)\ \ @20  \[Degree]\ C\)},
        {" ", \(Water\ Density\), "=", \(10\^6\ \ Gram\ /\ Meter\^3\)},
        {"pH", "acids", "<", \(water\ \((7)\)\  < \ bases\)},
        {\(32  \[Degree]\ F\), \(273.15\ Kelvin\), 
          "=", \(32 + 0  Celsius\ 9/5\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt3 = snaptxt[];\)\)], "Input"],

Cell[BoxData[
    \(n\)], "Input"],

Cell[BoxData[GridBox[{
        {" ", "Conversions", " ", " "},
        {"amu", "AtomicMassUnit", 
          "=", \(Gram\ \ /\ \ \((Mole\ \ or\ \ N\_A)\)\)},
        {\(N\_A\), 
          FormBox["AvogadroConstant",
            "InputForm"], "=", \(6.02214\[Times]10\^23\ \ Atoms\)},
        {" ", \(one\ amu\ weighs\), 
          "=", \(1.66054\[Times]10\^\(-24\)\ \ Gram\)},
        {"eV", "ElectronVolt", 
          "=", \(\(1.60218\[Times]10\^\(-19\)\)\ \ Joule\)},
        {"\[Angstrom]", "Angstrom", "=", \(1.`*^-10\ \ Meter\)},
        {"W", "Watt", "=", \(Joule\ /\ Second\)},
        {"\[Placeholder]", \(1\ \ Columb\), 
          "=", \(1\ \ eV\ \ Joule\ of\ Work\)},
        {\(32  \[Degree]\), \(F\  = \ 273.15\ Kelvin\), 
          "=", \(32 + 0  Celsius\ 9/5\)},
        {\(F\ d\), \(Work\  = \ Energy\), 
          "=", \(mass\ \ acceleration\ dist\)},
        {" ", "Lanthenides", "=", \(Elems\ \ 58 - 71\)},
        {" ", "Actinides", "=", \(Elems\ \ 90 - 103\)},
        {" ", \(acids\ donate\), "=", \(bases\ \(take : \ ions\)\)},
        {" ", "amu", "~", \(6.2\ /\ specific\ heat\)},
        {" ", \(ionic\ bonds\ pair\), "=", \(outer\ elec\ totaling\ 8\)},
        {" ", \( .5 < 1.5 < EN\), 
          "=", \(covalent < polar < ionic\[IndentingNewLine]
          polar\ if\ \ en1 \[NotEqual] en2\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt4 = snaptxt[];\)\)], "Input"],

Cell[BoxData[
    \(\(Module[{v, 
          msg}, \[IndentingNewLine]msg = {}; \[IndentingNewLine]Do[\
\[IndentingNewLine]\(Do[\[IndentingNewLine]v = 
                ve2[Elements[\([i]\)], efuns[\([j]\)]]; \[IndentingNewLine]If[
                Length[v] \[NotEqual] 5, Return[v]]; \[IndentingNewLine]If[
                v[\([5]\)] \[Equal] 1, \[IndentingNewLine]msg = 
                  Append[msg, {v[\([2]\)], v[\([3]\)], 
                      v[\([4, 1]\)]}]; \[IndentingNewLine]\(Return[
                    msg];\)\[IndentingNewLine]];\[IndentingNewLine], {j, 
                Length[efuns] - 
                  2}\[IndentingNewLine]];\)\[IndentingNewLine], {i, 
            Length[Elements]}\[IndentingNewLine]]; \[IndentingNewLine]msg\
\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Append[%, \[IndentingNewLine]{"\<un\>", "\<AW\>", "\<* Atomic Weight \
un unstable formation or decay of isotopes\>"}\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(convdisp5 = 
      GridBox[%, RowLines \[Rule] False, ColumnLines \[Rule] True, 
          GridFrame \[Rule] True, ColumnAlignments \[Rule] {Left}] // 
        DisplayForm\)], "Input"],

Cell[BoxData[
    \(convdisp = 
      GridBox[convtxt[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    \(convdisp2 = 
      GridBox[convtxt2[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    \(convdisp3 = 
      GridBox[convtxt3[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    \(convdisp4 = 
      GridBox[convtxt4[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    \( (*\ convdisp5\ done\ *) \)], "Input"],

Cell["(* pin to top rows of chart since bottom moves around *)", "Text"],

Cell[BoxData[
    \(dh =. ; dw =. ;\)], "Input"],

Cell[BoxData[
    \(dh = \((opos[1, whereis[Lithium]] - 
            opos[1, whereis[Magnesium]])\)[\([3]\)]\)], "Input"],

Cell[BoxData[
    \(dw = \((opos[1, whereis[Magnesium]] - 
            opos[1, whereis[Lithium]])\)[\([1]\)]\)], "Input"],

Cell[BoxData[
    \(\(convgrc = 
        go2D[\([1, 1, \((\((chartheight - 2)\)\ chartwidth)\) + 13, 
              2]\)] + {14, \(-18\)};\)\)], "Input"],

Cell[BoxData[
    \(\(convgrc = 
        go2D[\([1, 1, whereis[Strontium] + 5, 2]\)] + {15, 10};\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        widechart === False, \[IndentingNewLine]convgrc = 
          go2D[\([1, 1, whereis[Ununnilium] - 1, 2]\)] + {0, \(-dh\)\ 2.25}, 
        convgrc = 
          go2D[\([1, 1, whereis[Strontium] + 5, 2]\)] + {15, 
              10}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ go2D[\([1, 1, whereis[Beryllium] + 11, 2]\)]\ *) \)], "Input"],

Cell[BoxData[
    \(go2D[\([1, 1, whereis[Boron] - 7, 2]\)] + {0, 0}\n == 
      go2D[\([1, 1, whereis[Beryllium] + 11, 2]\)]\)], "Input"],

Cell[BoxData[
    \(\(convgrc2 = 
        go2D[\([1, 1, whereis[ (*Boron*) Carbon] - 6, 2]\)] + {\(-15\), 
            0};\)\)], "Input"],

Cell[BoxData[
    \(\(convgrc3 = 
        go2D[\([1, 1, \((\((chartheight - 2)\)\ chartwidth)\) + 13, 
              2]\)] + {14, \(-18\)};\)\)], "Input"],

Cell[BoxData[
    \(\(convgrc4 = 
        go2D[\([1, 1, \((\((chartheight - 2)\)\ chartwidth)\) + 13, 
              2]\)] + {14, \(-18\)};\)\)], "Input"],

Cell["\<\
(* if so this may change aspect ratio and would anyway may be \
chopped , so move it safely above with other stuff *)\
\>", "Text"],

Cell[BoxData[
    \(\(If[widechart === False, 
        convgrc5 = \[IndentingNewLine]go2D[\([1, 
                1, \[IndentingNewLine]whereis[Americium]\[IndentingNewLine] + 
                  Last[groupdrop] - First[groupdrop] + 
                  2, \[IndentingNewLine]2]\)] + {0, \(-dh\)\ 2.25}, \
\[IndentingNewLine]convgrc5 = 
          go2D[\([1, 1, whereis[Strontium] + 9, 2]\)] + {0, 
              15}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr = 
        Graphics[
          Text[convdisp, convgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr3D = 
        Graphics3D[
          Text[convdisp, Insert[convgrc, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr2 = 
        Graphics[
          Text[convdisp2, convgrc2, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr23D = 
        Graphics3D[
          Text[convdisp2, Insert[convgrc2, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr3 = 
        Graphics[
          Text[convdisp3, convgrc3, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr33D = 
        Graphics3D[
          Text[convdisp3, Insert[convgrc3, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr4 = 
        Graphics[
          Text[convdisp4, convgrc4, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr43D = 
        Graphics3D[
          Text[convdisp4, Insert[convgrc4, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr5 = 
        Graphics[
          Text[convdisp5, convgrc5, 
            TextStyle \[Rule] {FontSize \[Rule] 1.1}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr53D = 
        Graphics3D[
          Text[convdisp5, Insert[convgrc5, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.1}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "unused conversion table - OLD\n",
  StyleBox["\tOutputForm is broken / missing fonts for EPS with tables at \
least",
    FontSize->10]
}], "Subsubsection"],

Cell[BoxData[GridBox[{
        {"amu", "AtomicMassUnit", "=", \(1.6605402`*^-27\ Gram\ \ Kilo\)},
        {"mol", "Mole", "=", 
          FormBox[\(AvogadroConstant\ \ Atoms\),
            "InputForm"]},
        {\(N\_A\), 
          FormBox["AvogadroConstant",
            "InputForm"], "=", "6.0221367`*^23"},
        {"eV", "ElectronVolt", "=", \(1.60217733`*^-22\ Joule\ \ Kilo\)},
        {"A", "Angstrom", "=", \(1.`*^-10\ Meter\)},
        {"W", "Watt", "=", \(Joule/Second\)},
        {" ", "Lanthenides", "=", \(Elems\ \ 58, 17\)},
        {" ", "Actinides", "=", \(Elems\ \ 90, 103\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxtbw = snaptxt[];\)\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(convdispbw = 
      GridBox[convtxtbw[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[GridBox[{
          {"amu", "AtomicMassUnit", "=", \(1.6605402`*^-27\ Gram\ \ Kilo\)},
          {"mol", "Mole", "=", 
            FormBox[\(AvogadroConstant\ \ Atoms\),
              "InputForm"]},
          {\(N\_A\), 
            FormBox["AvogadroConstant",
              "InputForm"], "=", "6.0221367`*^23"},
          {"eV", "ElectronVolt", "=", \(1.60217733`*^-22\ Joule\ \ Kilo\)},
          {"A", "Angstrom", "=", \(1.`*^-10\ Meter\)},
          {"W", "Watt", "=", \(Joule/Second\)},
          {" ", "Lanthenides", "=", \(Elems\ \ 58, 17\)},
          {" ", "Actinides", "=", \(Elems\ \ 90, 103\)}
          },
        ColumnAlignments->{Center},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell["\<\
Output form of table this is still broken, missing \"/\" fonts at \
least, for EPS and worse it spreads columsn way far apart if OutputForm is \
used.  Not interested in providing a fix or substitute for legends as they \
are easily made upon particular need.

OutputForm does boxing for expressions nicely, but it's table output is poor \
/ practically non-existent.

Because of this printcell[] is made.  This does B&W and Color both better \
than OutputForm (noting allot of odat[] data is still using Output form).  \
Tis broken with or without.\
\>", "Text"],

Cell[BoxData[
    \(\(convgrbw = 
        Graphics[
          Text[\(convdispbw, convgrc, 
                TextStyle \[Rule] {FontSize \[Rule] 1.5}\) (*\ 
                  BROKEN\ *) \ \ FormatType -> OutputForm\ ]];\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["notes gr   -  errata  (diff style)", "Subsubsection"],

Cell["\<\
\t* CRC 52nd B-3 reports: physical properties of elements may \
change
      drastically with small ammounts of impurity,also that some
      allotropes data's may be tentative.
\t** fill order CRC 52nd B-2,but shell order CRC 79th says chem.m
      (difference left \"as-is\").  fill order shows+-for irregularies to
      \"simple\" fill rule (actual rules can change)
\t* ElectronAffinity if shown will not indicate direction of a value
       of 0 and note EA is rather erratic and 0s  direction is erratic.
      \t* FIP, if 0, does not if know to be <0 or >0.\
\>", "Text"],

Cell[BoxData[
    TagBox[GridBox[{
          {\(\(\(*\)\(\ \)\(CRC\)\(\ \)\(52\)  \(nd\)\(\ \)\(B\)\) - 
              3\ \(\(reports\)\(:\)\)\ physical\ properties\ of\ elements\ \
may\ change\ drastically\ with\ small\ ammounts\ of\ \(\(impurity\)\(,\)\)\ \
also\ that\ some\ allotropes\ data' 
                s\ may\ be\ \(\(tentative\)\(.\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \)\)\)},
          {\(\(\(*\)\(\ \)\(fill\)\(\ \)\(order\)\(\ \)\(CRC\)\(\ \)\(52\)  \
\(nd\)\(\ \)\(B\)\) - 
              2\ but\ shell\ order\ CRC\ 79  
                th\ says\ chem . 
                  m\ \((difference\ left\ "as-is")\) . \ \ fill\ order\ shows\
\  + \(-\ 
                  for\)\ irregularies\ to\ "simple"\ fill\ rule\ \((actual\ \
rules\ can\ change)\)\)},
          {\(\(\(*\)\(\ \)\(ElectronAffinity\)\(\ \)\(if\)\(\ \)\(shown\)\(\ \
\)\(will\)\(\ \)\(not\)\(\ \)\(indicate\)\(\ \)\(direction\)\)\
\[IndentingNewLine]
            \ \ \ of\ a\ value\ of\ 0\ and\ note\ EA\ is\ erratic\ and\ \
direction\ as\ \(\(well\)\(.\)\)\)},
          {\(\(\(*\)\(\ \)\(ie . \ IIIA\)\(\ \)\(IIIB\)\), \ 
            B\ is\ used\ in\ various\ texts\ ad - hoc\)}
          },
        ColumnWidths->32,
        ColumnAlignments->{Left},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      (ColumnsEqual -> True)]], "Text"],

Cell[BoxData[
    \(\(notes = snaptxt[];\)\)], "Input"],

Cell[BoxData[
    \(\(notesdisp = 
        GridBox[notes[\([1, 1, 1, 1]\)], ColumnAlignments \[Rule] {Left}, 
            ColumnWidths \[Rule] 32, ColumnLines \[Rule] False, 
            RowSpacings \[Rule] 2.0, GridFrame \[Rule] False, 
            RowLines \[Rule] True, ColumnsEqual \[Rule] True] // 
          DisplayForm;\)\)], "Input"],

Cell[BoxData[
    \(dh =. ; dw =. ;\)], "Input"],

Cell[BoxData[
    \(dh = \((opos[1, 1 + chartwidth] - opos[1, 1])\)[\([3]\)]\)], "Input"],

Cell[BoxData[
    \(\(dh *= helpcellmul[\([3]\)];\)\)], "Input"],

Cell[BoxData[
    \(dw = \((opos[1, 2] - opos[1, 1])\)[\([1]\)]\)], "Input"],

Cell[BoxData[
    \(\(dw *= helpcellmul[\([1]\)]/2;\)\)], "Input"],

Cell["\<\
pin just below helpcell slightly haphazardously, using most current \
values for it.\
\>", "Text"],

Cell[BoxData[
    \(\(notesgrc = 
        Delete[opos[1, helpcell], 2] + {\(-dw\)/2, \(-dh\)} + {20, 
            15};\)\)], "Input"],

Cell[BoxData[
    \(dh =. ; dw =. ;\)], "Input"],

Cell[BoxData[
    \(\(notesgr = 
        Graphics[
          Text[notesdisp, notesgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ Show[%]*) \)], "Input"],

Cell[BoxData[
    \(\(notesgr3D = 
        Graphics3D[
          Text[notesdisp, Insert[notesgrc, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
unused: warntxt same as notes but shows a way to snap plain text \
into plot\
\>", "Subsubsection"],

Cell["\<\
\t* CRC 52nd B-3 reports: physical properties of elements may \
change
      drastically with small ammounts of impurity,also that some
      allotropes data's may be tentative.
\t** fill order CRC 52nd B-2,but shell order CRC 79th says chem.m
      (difference left \"as-is\").  fill order shows+-for irregularies to
      \"simple\" fill rule (actual rules can change)\
\>", "Text"],

Cell[BoxData[
    \(\(warntxt = snaptxt[];\)\)], "Input"],

Cell["\<\
(*
WORKS better than NotebookCreate, but prolog et al are in this, and Graphics \
wants only \"included code\"
*)\
\>", "Text"],

Cell[BoxData[
    \( (*\ \(epstxt = 
          StringJoin[
            Import["\<warntxt.eps\>", "\<Lines\>"]];\)\ *) \)], "Input"],

Cell[TextData[{
  "(*\nanother bug: ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Import used Windows font though Options say not to and file uses \
\"Times\". \n*)"
}], "Text"],

Cell[TextData[{
  "(*\nanother bug: ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " writes PS differently than it reads it here.  Import takes (\"text\") \
show text literally.  But example \"\\)\" is ) but it BECOMES \
Text[\"\\)\",TextStyle->{FontFamily->Windows}] which ain't useful.  Obviously \
when Exported \")\" became \"\\)\" and gv likes or needs that.  Didn't expect \
perfect PS importi anyway i guess.  I've tried it before with no luck.  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s PS output is complex but it reader is not: it has no \"distiller\".\n\
*)"
}], "Text"],

Cell[BoxData[
    \( (*\ WORKS\ SOME\ Export["\<warntxt.eps\>", warntxt, "\<EPS\>"]; \n
      eps = Import["\<warntxt.eps\>", "\<EPS\>"]; Show[eps];*) \)], "Input"],

Cell["\<\
(*
SO.  Using Text to make Graphics is easier as far as getting things into the \
Plot.  Graphics can't combine eps into plots.
*)\
\>", "Text"],

Cell[BoxData[
    \(\(warntxtgrc = 
        go2D[\([1, 1, \((2\ chartwidth)\) + 5, 2]\)] + {\(-10\), 
            0};\)\)], "Input"],

Cell[BoxData[
    \(\(warntxtgr = 
        Graphics[
          Text[warntxt[\([1]\)], warntxtgrc + {0, 25}, 
            TextStyle \[Rule] {FontSize \[Rule] 1, 
                PageWidth \[Rule] 150}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["editors mark", "Subsubsection"],

Cell[BoxData[
    \(\(edgrc = go2D[\([1, 1, helpcell, 2]\)] + {70, \(-30\)};\)\)], "Input"],

Cell[BoxData[
    \(\(edgr = 
        Graphics[
          Text["\<-- JH\>", edgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1}]];\)\)], "Input"],

Cell[BoxData[
    \(\(edgr3D = 
        Graphics3D[
          Text["\<-- JH\>", 
            Insert[edgrc, 1, 
              2], \[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
                  1}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["title gr", "Subsubsection"],

Cell[BoxData[
    \(\(titlegrc = 
        go2D[\([1, 1, whereis[Helium] - 5, 2]\)] + {20, 7};\)\)], "Input"],

Cell[BoxData[
    \(\(titlegr = 
        Graphics[
          Text["\<Periodic Table of the Elements\>", titlegrc, 
            TextStyle \[Rule] {FontSize \[Rule] 6}]];\)\)], "Input"],

Cell[BoxData[
    \(\(titlegr3D = 
        Graphics3D[
          Text["\<Periodic Table of the Elements\>", 
            Insert[titlegrc, 1, 
              2], \[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
                  6}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["colheadgr2D  xxx  boxes", "Subsubsection"],

Cell[BoxData[
    \(\(colhead2D =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(colhead2D = Table[{}, {i, chartwidth}];\)\)], "Input"],

Cell[BoxData[
    \(\(colhead3D =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(colhead3D = Table[{}, {i, chartwidth}];\)\)], "Input"],

Cell["unused:  use to get on top of / resting on", "Text"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, v, w, i, j, 
          dh}, \[IndentingNewLine]sc = {3.5, 
              1, \((10.0/
                  4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]dh = 
          opos[1, objlen] - 
            opos[1, objlen - 
                chartwidth]; \[IndentingNewLine]dh *=  .8; \
\[IndentingNewLine]w = {7, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 4, 
            4, 4, 4, 4, 4, 4, 4, 4, 6, 6, 6, 6, 6, 7}; \[IndentingNewLine]j = 
          Table[\[IndentingNewLine]\((\((w[\([i]\)] - 1)\)\ chartwidth)\) + 
              i\[IndentingNewLine], {i, 
              chartwidth}\[IndentingNewLine]]; \[IndentingNewLine]Do[\
\[IndentingNewLine]v = 
            boxpts[opos[1, j[\([i]\)]] + dh, sc, ul, ll, lr, ur, 
              True]; \[IndentingNewLine]colhead2D[\([i]\)] = 
            boxnocorners[v,  .1];\[IndentingNewLine], {i, 
            chartwidth}\[IndentingNewLine]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell["\<\
todo ? some like these designations # s[1-2] d[3-12] p[13-18] f[for \
actinide]\
\>", "Text"],

Cell[BoxData[
    \( (*\[IndentingNewLine]\(Do[\[IndentingNewLine]v = 
            boxpts[opos[1, \((\((chartheight - 1)\)\ chartwidth)\) + i] + dh, 
              sc, ul, ll, lr, ur, 
              True]; \[IndentingNewLine]colhead2D[\([i]\)] = 
            boxnocorners[v,  .1];\[IndentingNewLine], {i, 
            32}\[IndentingNewLine]];\)\[IndentingNewLine]*) \)], "Input"],

Cell[BoxData[
    \( (*\ \(Show[Graphics[{First[%%], Take[%%, \(-2\)]}]];\)\ *) \)], "Input"],

Cell["straight across top", "Text"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, v, w, i, j, 
          dh}, \[IndentingNewLine]sc = {3.5, 
              1, \((5.0/
                  4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]dh = 
          opos[1, objlen] - 
            opos[1, objlen - chartwidth]; \[IndentingNewLine]dh *=  .71;  (*\ 
          lower\ moves\ box\ down\ *) \[IndentingNewLine]Do[\
\[IndentingNewLine]v = 
            boxpts[opos[1, \((\((chartheight - 1)\)\ chartwidth)\) + i] + dh, 
              sc, ul, ll, lr, ur, 
              True]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            w = boxnocorners[
                v,  .1]; \[IndentingNewLine]colhead2D[\([i]\)] = {First[w], 
                Take[w, \(-2\)]};*) \[IndentingNewLine]\[IndentingNewLine]w = 
            boxcorners[v,  .1, 2]; \[IndentingNewLine]colhead2D[\([i]\)] = 
            w;\[IndentingNewLine]\[IndentingNewLine], {i, 
            chartwidth}\[IndentingNewLine]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(colhead2Dgr = 
        Graphics[{Thickness[ .0001], RGBColor[ .2, 0,  .2], 
            colhead2D}];\)\)], "Input"],

Cell["(* same for 3D *)", "Text"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, v, w, i, j, 
          dh}, \[IndentingNewLine]sc = {3.5, 
              1, \((5.0/
                  4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]dh = 
          opos[1, objlen] - 
            opos[1, objlen - chartwidth]; \[IndentingNewLine]dh *=  .71;  (*\ 
          lower\ moves\ box\ down\ *) \[IndentingNewLine]Do[\
\[IndentingNewLine]v = 
            boxpts[opos[1, \((\((chartheight - 1)\)\ chartwidth)\) + i] + dh, 
              sc, ul, ll, lr, ur, 
              False]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            w = boxnocorners[
                v,  .1]; \[IndentingNewLine]colhead3D[\([i]\)] = {First[w], 
                Take[w, \(-2\)]};*) \[IndentingNewLine]\[IndentingNewLine]w = 
            boxcorners[v,  .1, 2]; \[IndentingNewLine]colhead3D[\([i]\)] = 
            w;\[IndentingNewLine]\[IndentingNewLine], {i, 
            chartwidth}\[IndentingNewLine]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(colhead3Dgr = 
        Graphics3D[{Thickness[ .0001], RGBColor[ .2, 0,  .2], 
            colhead3D}];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["wtf  arrow", "Subsubsection"],

Cell[BoxData[
    \(\(laline = \[IndentingNewLine]Graphics[{Thickness[ .0001], 
            RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[{\
\[IndentingNewLine]go22D[\([1, whereis[Lanthanum], 1, 3, 1, 
                    3]\)], \[IndentingNewLine]go22D[\([1, whereis[Cerium], 1, 
                    3, 1, 1]\)]\[IndentingNewLine]}]\[IndentingNewLine]}];\)\)\
], "Input"],

Cell[BoxData[
    \(\(laline = 
        Module[{v, 
            w}, \[IndentingNewLine]v = {go22D[\([1, whereis[Lanthanum], 1, 3, 
                  1, 3]\)], \[IndentingNewLine]go22D[\([1, whereis[Cerium], 
                  1, 3, 1, 
                  1]\)]}; \[IndentingNewLine]\(w = \((v[\([2]\)] - 
                      v[\([1]\)])\)/
                  4;\)\[IndentingNewLine]\(v = {v[\([1]\)] + {4, \(-4\)}, 
                v[\([1]\)] + 
                  w + {4, \(-4\)}}\); \[IndentingNewLine]Graphics[{Thickness[ \
.0001], RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Arrow[v[\([1]\)], 
                v[\([2]\)], \ 
                HeadScaling \[Rule] 
                  Relative]\[IndentingNewLine]}]];\)\)], "Input"],

Cell["(* snafu - need to make arrow anyhow *)", "Text"],

Cell[BoxData[
    \(\(laline3D = 
        Module[{v, 
            w}, \[IndentingNewLine]v = {go2[\([1, whereis[Lanthanum], 1, 3, 
                  1, 3]\)], \[IndentingNewLine]go2[\([1, whereis[Cerium], 1, 
                  3, 1, 1]\)]}; \[IndentingNewLine]\(w = \((v[\([2]\)] - 
                      v[\([1]\)])\)/
                  4;\)\[IndentingNewLine]\(v = {v[\([1]\)] + {4, 0, \(-4\)}, 
                v[\([1]\)] + 
                  w + {4, 
                    0, \(-4\)}}\); \[IndentingNewLine]Graphics3D[{Thickness[ \
.0001], RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[{v[\([1]\)], 
                  v[\([2]\)]}], \[IndentingNewLine]Line[{v[\([2]\)], 
                  v[\([2]\)] + {2, 0, 
                      4}}] (*\(,\)\(\[IndentingNewLine]\)\(\ \
\)\(Line[{v[\([2]\)], 
                    v[\([2]\)] + {\(-2\), 0, 
                        4}}]\)\ *) \[IndentingNewLine]}]\[IndentingNewLine]];\
\)\)], "Input"],

Cell[BoxData[
    \(Show[%]\)], "Input"],

Cell[BoxData[
    \(If[widechart \[Equal] True, \(laline = Graphics[{}];\)]\)], "Input"],

Cell["\<\
(*
is for Graphics only so disable for now
*)\
\>", "Text"],

Cell[BoxData[
    \(If[widechart === True, \(laline3D = Graphics3D[{}];\)]\)], "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Show and Print the Charts", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
postcript page output is nice easy and quick.  always do that\
\>", \
"Text"],

Cell["\<\
image has problem: many conversion methods, for the color chart, \
take 500X the disk space (and time). 1/2 Gigabyte or more.  reason: i beleive \
papers size, it renders far too much that wasn't asked for (always does, but \
for small files one doesn't notice.)\
\>", "Text"],

Cell["\<\
gs can do the color chart, despite beginning with a 6mb file (7x \
the size of bw) in just seconds more.  and the output, nearly the same size \
file and dimensions.\
\>", "Text"],

Cell["\<\
there is one problem is fitting postscript itself is pagewidth \
limited to pages it knows of.  unless planning to ask everyone to hack in \
custom ones (and some distros make it impossible).  so another objective is \
while planning for image export to work at all well: not to alter the \
postscript in ways that would make printing or viewing unlikely.\
\>", "Text"],

Cell["\<\
SUMMARY: for image it seems a waste of time to calculate size to \
crop: doesn't mm do it (not) isn't it easier to photoshop?  until it's \
\"crunch time\" you'll wish you had taken a little time aside (if you knew \
to).  all kinds of crazy \"letter size\" things go on in .ps and options are \
difficult.  avoid it.  ps is excellent for anything that fits on pages so \
plan on a layout that by any scaling is in units of 72 pts than regular page \
size.\
\>", "Text"],

Cell["\<\
for mm Aspect and ImageSize are NOT img scale/skewing.  all things \
keep 1:1 aspect and centers are adjusted to fit across page (protects fonts). \
 too small things overlap, too large and there is useless white space in \
chart.  at \"perfect\" planned layout, as an editor's mark: the last digit of \
Tm (melting point) of Silver (Ag) and a few others overlaps the E of ECA. \
this one digit overlap \"mark\" shows good width.  height is more \
optional\
\>", "Text"],

Cell["\<\
chart shouldn't be width chopped if postscript print is used (it's \
possible to do)

psrender(1) won't do color (see dobw just below) and gs(1) has no crop \
options.

finally. all the psrender/gs options are a pain and very likely to \
frustratingly leave one short of actualy printing\
\>", "Text"],

Cell["the following is problematic when printing or converting !", "Text"],

Cell[BoxData[
    \(\(If[dobw \[Equal] 1, 
        g9 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2DBW, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] 
              Automatic, \[IndentingNewLine]ImageSize \[Rule] {\(700\/32\) 
                  chartwidth, 30\ chartheight}]];\)\)], "Text"],

Cell[TextData[{
  "i try setting aspect ratio. result is i end up with CROPPING probles. in \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " if aspect doesn't match img size, need cropping.  but whenever they are \
made to match: all scaling is removed."
}], "Text"],

Cell["\<\
((chartheight+(3/10)+(chartheight+(3/10)) \
(1/32))/((chartwidth+chartwidth (1/32))))
          
0.29253   FullOptions if Automatic is used (see above)
0.228125  actual h/w is too wide to fit in a .ps, not condensed
          needs more spacing on h (have more to burn here)
0.285714  1/3.5 is very close \
\>", "Text"],

Cell["\<\
squash=.3;spacew=1/32;

ara=(((chartheight+(3/10+spacew)+(chartheight+(3/10)) \
spacew))/(((chartwidth+chartwidth spacew))))((1+squash)/(1-squash));

imsi=55{(((chartwidth+chartwidth \
spacew)))/2,((chartheight+(3/10+spacew)+(chartheight+(3/10)) \
spacew))/2}{(1-squash),(1+squash)};\
\>", "Text"],

Cell["\<\
If[dobw\[Equal]1,g10=Show[
        colhead2Dgr,titlegr,edgr,notesgr,ptgr,convgr,convgr5,convgr2,go22D,\
go2DBW,laline,
        AspectRatio\[Rule]ara,
        ImageSize\[Rule]imsi,
        PlotRange\[Rule]{{5,950},{10,290}}
        ]];\
\>", "Text"],

Cell["\<\
gs likes this, places it same size, would need cropping (by hand).  \
but with aspect 1 there is no way to select spacing (except that the notebook \
above can when creating, or also multiplying all coord will).  but gs likes \
many things spuriously.

psrender displays nothing, though i assume selecting offsets woudl show \
results after efforts.  it's still bw.

problem with this is with a policy of absolute coordinates the whole chart \
would have to change for every resolution or layout or spacing change.  and \
while it'd seem an a safer route: there's no way to know what hang-ups are \
waiting\
\>", "Text"],

Cell["\<\
If[dobw\[Equal]1,g9=Show[
        colhead2Dgr,titlegr,edgr,notesgr,ptgr,convgr,convgr5,convgr2,go22D,\
go2DBW,laline,
        AspectRatio\[Rule]1,
        ImageSize\[Rule]{7 72,7 72},
        PlotRange\[Rule]{{5,950},{10,290}}
        ]];\
\>", "Text"],

Cell["\<\
by what magic i don't know but gs can render bw.ps and c.ps \
psrender cannot.  crashes on c.  and for bw the following is needed.  the \
result is good though.

psrender-bin -format gif -width 550 -height 200 -xoff -25 -yoff -585 -xdpi \
1000
-ydpi 1000 $outfile $*

very strange since mm uses psrender to make to .ps files !

not very strange: .gif for c.ps doesnt' work in shell or in mm. it's \
beleivable mm has env setup and uses all the right tricks and it won't work \
then at commandline it won't either.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["BW", "Subsubsection"],

Cell[BoxData[
    \(\(file =. ;\)\)], "Input"],

Cell[BoxData[{
    \(\(If[widechart === True, file = "\<graph.bw\>", 
        file = "\<graph.bw.la\>"];\)\), "\[IndentingNewLine]", 
    \(\(doPSIbw = 0;\)\), "\n", 
    \(\(dobw = 1;\)\), "\n", 
    \(\(doGIFbw = 0;\)\), "\n", 
    \(\(doEPSbw = 0;\)\)}], "Input"],

Cell[BoxData[
    \(\(If[dobw === 1 && widechart === True, 
        g9 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2DBW, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((3\ 72 + 
                    34)\)/\((9\ 72 + 
                    34)\), \[IndentingNewLine]ImageSize \[Rule] {9\ 72 + 34, 
                3\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  950}, {10, 290}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell["\<\
printcell note! must have \";\" after Plot[]; cell directly above. \
also check % is a gr\
\>", "Text"],

Cell["Printed to .ps file Above ^^^", "Text",
  Background->RGBColor[0.8, 1, 1]],

Cell[BoxData[
    \(ImageSize \[Rule] {6\ 72 + 17, 4\ 72 + 34}\)], "Input"],

Cell[BoxData[
    \(\(If[dobw === 1 && widechart === False, 
        g9 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2DBW, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((4\ 72 + 
                    34)\)/\((6\ 72 + 
                    17)\), \[IndentingNewLine]ImageSize \[Rule] {6\ 72 + 17, 
                4\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  660}, {10, 390}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell[BoxData[
    \(\(\( (*\ a\ more\ general\ use\ subst*) \)\(\[IndentingNewLine]\)\( (*\ 
      AspectRatio \[Rule] Automatic, \ 
      ImageSize \[Rule] {\((700/32)\) chartwidth, 
          30\ chartheight}\ *) \)\)\)], "Text"],

Cell["\<\
----------------------
suggested:\
\>", "Text"],

Cell["Run[\"chart-to-jpeg-faster -r 1000 graph.bw.ps\"];", "Text"],

Cell["\<\
see: chart-to-jpeg-faster.  it will make an image in good time and \
crop too.\
\>", "Text"],

Cell["\<\
SUMMARY: why the suggestion?  mm 4 psrender / Display is slow and \
may inf wait on color chart. also don't expect gs or psrender to get a nice \
cropped results they aren't built for that: you'll need (a cropping \
tool)\
\>", "Text"],

Cell["\<\
-----------------------------------------
Edit->save selection as->EPS
\tdoes not work with gs at all , no png
\tpsrender needs -psinit switch and chops output
\t\tpsrender-gif doesn't add -psinit
\t\twhich sometimes works: other times it hangs, working off same Cell\
\>", \
"Text"],

Cell["\<\
EPS will chop the chart for wide chart.  it won't contain fonts \
others need to print.  it will be randomly \"poorly\" cropped (unless orig. \
is already correct)\
\>", "Text"],

Cell["\<\
gs and psrender have chopped output, while gv likes it\
\>", "Text"],

Cell[BoxData[
    \(\(If[doEPSbw \[Equal] 1, 
        Export[file <> "\<.ex.eps\>", g9, "\<EPS\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[doEPSbw \[Equal] 1, 
        Display[file <> "\<.eps\>", g9, "\<EPS\>"]];\)\)], "Input"],

Cell["\<\
note for psrender(1) read file ./psrender-graph about shell \
environment outside mm.\
\>", "Text"],

Cell["\<\
Display this seems like a good idea.  but it won't include fonts \
(will be missing) and for color takes 500x longer\
\>", "Text"],

Cell[BoxData[
    \(\(If[doGIFbw \[Equal] 1, 
        Display["\<graph.bw.gif\>", g9, "\<GIF\>", 
          ImageResolution \[Rule] {1500, 1500}]];\)\)], "Input"],

Cell["\<\
going route of using pdfimages(1) need img in .ps, again for color \
it will take too long\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        doJPEGBW \[Equal] 1, \[IndentingNewLine]Export[file <> "\<.psi\>", 
          g9, "\<PsImage\>", 
          ImageResolution \[Rule] 
            1000]; \[IndentingNewLine]Run["\<chart-to-jpeg-faster\>" <> "\< \
\>" <> file <> "\<.psi\>"];\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
gs creates no png, psrender chops largess of chart, while gv likes \
it allot.\
\>", "Text"],

Cell[BoxData[
    \(\(If[True \[Equal] False, 
        Export["\<ex.eps\>", g9, "\<EPS\>"]];\)\)], "Input"],

Cell["\<\
mm 4 psrender run by psrender-bin can crop (using unknowable \
-height Y -width X  -xoff x -yoff y) but it won't do color .ps file anyway.  \
psrender-bin sometimes needs .ps edited to remove missing fonts.  it does eps \
(well) but gs hardly does eps.\
\>", "Text"],

Cell[BoxData[
    \(\(Remove[g9];\)\)], "Input"],

Cell[BoxData[
    \(MemoryInUse[] // fNBookForm2\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Color", "Subsubsection"],

Cell[BoxData[
    \(\(filec =. ;\)\)], "Input"],

Cell[BoxData[{
    \(\(If[widechart === True, filec = "\<graph.c\>", 
        filec = "\<graph.c.la\>"];\)\), "\[IndentingNewLine]", 
    \(\(doPSIc = 0;\)\), "\n", 
    \(\(docolor = 1;\)\), "\n", 
    \(\(doGIFc = 0;\)\), "\n", 
    \(\(doEPSc = 0;\)\)}], "Input"],

Cell[BoxData[
    \(\(If[docolor === 1 && widechart === True, 
        g8 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2D, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((3\ 72 + 
                    34)\)/\((9\ 72 + 
                    34)\), \[IndentingNewLine]ImageSize \[Rule] {9\ 72 + 34, 
                3\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  950}, {10, 290}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell[BoxData[
    \(\(If[docolor === 1 && widechart === False, 
        g8 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2D, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((4\ 72 + 
                    34)\)/\((6\ 72 + 
                    17)\), \[IndentingNewLine]ImageSize \[Rule] {6\ 72 + 17, 
                4\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  660}, {10, 390}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell["\<\
----------------------
suggested:\
\>", "Text"],

Cell["Run[\"chart-to-jpeg-faster -r 1000 graph.c.ps\"];", "Text"],

Cell["\<\
----------------------
not suggested\
\>", "Text"],

Cell["warning: this doesn't create file (in many minutes waiting)", "Text"],

Cell["\<\
Display[\"graph.c.gif\",g8,\"GIF\",ImageResolution\[Rule]{1000,1000}\
];\
\>", "Text"],

Cell["\<\
warning: this works well, creates file quickly, but hangs \
infinitely waiting for psrender to exit.  but really it's just getting a .ps \
from mm and outputing a .ps so shouldn't it work ?\
\>", "Text"],

Cell["Display[\"disp.c.eps\",g8,\"EPS\"];", "Text"],

Cell["\<\
this takes 3x as long file is 33x the size, enlarges (ie, see in \
gv), but does not hang\
\>", "Text"],

Cell["Export[\"ex.c.eps\",g8,\"EPS\"];", "Text"],

Cell[BoxData[
    \(\(Remove[g8];\)\)], "Input"],

Cell[BoxData[
    \(MemoryInUse[] // fNBookForm2\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["3D Color", "Subsubsection"],

Cell[BoxData[
    \(\(file3 =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(If[widechart === True, file3 = "\<graph.c.3d\>", 
        file3 = "\<graph.c.3d.la\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(\(do3D = 0;\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ 
      note\ this\ is\ in\ general\ setup\ too\ to\ control\ if\ 3  
        D\ gr\ arrays\ are\ even\ made\ *) \)\)\)], "Input"],

Cell[BoxData[
    \( (*\[IndentingNewLine]ImageSize \[Rule] {\(700\/32\) chartwidth, 
          30\ chartheight}; \[IndentingNewLine]ImageSize \[Rule] {700, 
          210};  (*\ old\ *) \[IndentingNewLine]*) \)], "Text"],

Cell[BoxData[
    \(\(If[do3D === 1, 
        g8 = Show[colhead3Dgr, titlegr3D, edgr3D, notesgr3D, ptgr3D, 
            convgr3D, convgr53D, convgr23D, go2, go, 
            laline3D, \[IndentingNewLine]\[IndentingNewLine]AspectRatio \
\[Rule] Automatic, \[IndentingNewLine]ImageSize \[Rule] {\(700\/32\) 
                  chartwidth, \((30)\)\ chartheight}, \
\[IndentingNewLine]ViewPoint \[Rule] {0, \(-1\), 
                0}, \[IndentingNewLine]LightSources \[Rule] {{{0, \(-4\), 0}, 
                  RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
                  RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
                  RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
                  RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, 
                  GrayLevel[ .5]}}, 
            AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], 
            Axes \[Rule] False\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file3 <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file3 <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ThreeScript  but  broken", "Subsubsection"],

Cell["\<\
(*
\tThreeScript can't do Text[].
\tCould Render each Text to image separately and put in Graphics3D maybe
\t\tBut no benefit as only \"gain\" is text could
\t\tanimate / rotate separately from boxes - so what.
\t\tOther apps can rotate whole deal as 3D anyhow.
AHA !!!
\tcan replace Text[] with function that renders a primative it does know
\tthen use that to awk text in saved pov file mathview3d makes.
At any rate not \"worth it\".
\tit's work i have no order for
\tlikely someone has a .ps to 3d tool
\tlikely ML for browser or xml'ish .ps for browser exists
*)\
\>", "Text"],

Cell["(* about what u get *)", "Text"],

Cell[BoxData[
    \(Show[go2[\([1]\)]]\)], "Input"],

Cell[BoxData[
    \(\(If[
        do3D === 1, \[IndentingNewLine]ThreeScript["\<object.ts\>", 
          g8]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ \(! \(! object . ts\)\)\ *) \)], "Input"],

Cell[BoxData[
    \( (*\ \(Run["\<~/mgl/MathView3D/Source/mathview3d -mvfile \
~/PeriodicTableOfElements/object.ts object.pov\>"];\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(Remove[g8];\)\)], "Input"],

Cell[BoxData[
    \(MemoryInUse[] // fNBookForm2\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["OLD   b&w  lanthanide / actinide  (modified)", "Subsubsection"],

Cell["\<\
each cell can be moved around easy enough for any preferred layout
one thing to keep in mind (seeing below) is where NOT to put things
so they are not trapped by parts of the chart moving around\
\>", "Text"],

Cell["\<\
this was written quickly and works terribly slowly - and maybe \
there's a easier better way considering

it needs to be modified for Group and due to recent changes the offsets are a \
little \"off\" 

maybe just let it eat.  but it shows ANYTHING can be done - and howto

another method would be drawing part of chart (gen funs take ranges) , \
changing cmat , drawing the rest

however changing the template to start with is far easier and that's why it \
began there was the hope / idea\
\>", "Text"],

Cell[BoxData[
    \(\(gobw = go2D;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(gobwbox = go22D;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Module[{yoff, voff, n, m}, \[IndentingNewLine]xoff = 0; 
        yoff = \(-87\); 
        voff = Table[{0, yoff/34.8}, {n, 5}]; \[IndentingNewLine]Do[
          Do[Do[\[IndentingNewLine]m = \((\((chartheight - 
                          i)\)\ chartwidth)\) + 
                  j; \[IndentingNewLine]gobw[\([1, k, m, 2]\)] += {xoff, 
                  yoff}; \[IndentingNewLine]If[
                gobwbox[\([1, m, 
                      1]\)] \[NotEqual] {}, \
\[IndentingNewLine]\(gobwbox[\([1, m, 1, 3, 1]\)] += 
                    voff;\)\[IndentingNewLine]]\[IndentingNewLine], {k, 
                textobjects}\[IndentingNewLine]], {j, 4, 11}], {i, 6, 
            7}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Module[{xoff, voff, n, m}, \[IndentingNewLine]xoff = \(-180\); 
        yoff = 0; 
        voff = Table[{xoff/34.8, 0}, {n, 5}]; \[IndentingNewLine]Do[
          Do[Do[\[IndentingNewLine]m = \((\((chartheight - 
                          i)\)\ chartwidth)\) + 
                  j; \[IndentingNewLine]gobw[\([1, k, m, 2]\)] += {xoff, 
                  yoff}; \[IndentingNewLine]If[
                gobwbox[\([1, m, 
                      1]\)] \[NotEqual] {}, \
\[IndentingNewLine]\(gobwbox[\([1, m, 1, 3, 1]\)] += 
                    voff;\)\[IndentingNewLine]]\[IndentingNewLine], {k, 
                textobjects}\[IndentingNewLine]], {j, 12, chartwidth}], {i, 
            1, chartheight}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(laline = 
        Graphics[{Hue[
              0], \[IndentingNewLine]Arrow[\[IndentingNewLine]gobwbox[\([1, 
                  35, 1, 3, 1, 3]\)], \[IndentingNewLine]gobwbox[\([1, 36, 1, 
                  3, 1, 1]\)], \[IndentingNewLine]HeadScaling \[Rule] 
                Relative\[IndentingNewLine]]\[IndentingNewLine] (*\(,\)\(\
\[IndentingNewLine]\)\(Spline[{\[IndentingNewLine]gobwbox[\([1, 35, 1, 3, 1, 
                      3]\)], \[IndentingNewLine]gobwbox[\([1, 36, 1, 3, 1, 
                      1]\)], \[IndentingNewLine]gobwbox[\([1, 43, 1, 3, 1, 
                      4]\)]\[IndentingNewLine]}, 
                CompositeBezier]\)\[IndentingNewLine]*) \[IndentingNewLine]}];\
\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Show[colhead2Dgr, titlegr, edgr, notesgr, ptgr, convgr, gobw, 
        gobwbox, 
        laline, \[IndentingNewLine]AspectRatio \[Rule] 
          Automatic, \[IndentingNewLine]ImageSize \[Rule] {600, 
            300}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    RowBox[{
      RowBox[{"printcell", "[", 
        RowBox[{"\"\<graph.3.ps\>\"", ",", 
          StyleBox[\(PrintingOptions -> {printopts}\),
            FontFamily->"Courier"], 
          StyleBox[",",
            FontFamily->"Courier"], 
          RowBox[{
            StyleBox["PageHeaderLines",
              FontFamily->"Courier"], "\[Rule]", \({False, False}\)}]}], 
        "]"}], ";"}]], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["old / short / 2 cell larger font", "Subsubsection"],

Cell["\<\
good news is 2d adn 3d charts superimpose well.  don't forget \
WARNINGS & tables\
\>", "Text"],

Cell[BoxData[
    \(go8a =. ; go8b =. ;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go8a = Table[go2D[\([1, All, i]\)], {i, 1, 64}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go8b = Table[go22D[\([1, i]\)], {i, 1, 64}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(showit2D[Graphics[go8a], 
      go8b, {{110, 175}, {\(-1\), 1}, {40, 100}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(showit2D[go2D, go22D, {{10, 86}, {\(-1\), 1}, {1, 48}}]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["etc format output", "Subsubsection"],

Cell["\<\
(* 
ABOVE:
to render EPS (post script encapsulated / one page)
ImageSize is needed to:
\t limit width (won't fit on page)
\tlock font size to box size (otherwise fonts are 2x size / dont' fit in box)
not PlotRange: apparently this doesn't effect output (see help: says \"\")
*)\
\>", "Text"],

Cell[BoxData[
    \(Display[go7, \ ImageRotated \[Rule] True]\)], "Input",
  Evaluatable->False],

Cell["\<\
(* this works but takes a good long while - 15 min i'd guess \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(Display["\<graph.eps\>", 
        Plot[Cos[x], {x, 0, 2  \[Pi]}], "\<EPS\>"];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(2 + 2\)], "Input"],

Cell[BoxData[
    \(\(Display["\<graph.jpg\>", g7, "\<JPG\>"];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Display["\<graph.pdf\>", 
        Plot[Cos[x], {x, 0, 2  \[Pi]}], "\<PDF\>"];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(do3D = 1;\)\)], "Input"],

Cell[BoxData[
    \(\(If[do3D === 1, 
        Show[go, go2, AspectRatio \[Rule] Automatic, 
          ImageSize \[Rule] {700, 210}\[IndentingNewLine], 
          ViewPoint \[Rule] {0, \(-1\), 0}, 
          LightSources \[Rule] {{{0, \(-4\), 0}, 
                RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
                RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
                RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
                RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, GrayLevel[ .5]}}, 
          AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], 
          Axes \[Rule] False\[IndentingNewLine]]];\)\)], "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["scratch", "Subsubtitle"],

Cell[CellGroupData[{

Cell["etc primatives (none of these used, genit does now)", "Subsection"],

Cell["\<\
p is backdrop for 2d cell: Rectangle is 2d only (line is \
both)\
\>", "Text"],

Cell[BoxData[
    \(\(p = 
        Graphics[{GrayLevel[0.85], Rectangle[{0, 0}, {1, 1}]}];\)\)], "Input",\

  Evaluatable->False],

Cell["l is the L shaped in Section trials above", "Text"],

Cell[BoxData[
    \(\(l = 
        Graphics[{Thickness[ .02], RGBColor[0, 0, 1], 
            Line[{{0, 1}, {0, 0}, {0, 0}, {1, 0}}]}];\)\)], "Input",
  Evaluatable->False],

Cell["junk from  Section trials above", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = 
      Graphics3D[{\[IndentingNewLine]Cuboid[\[IndentingNewLine]Scaled[{ .8,  \
.5, 0}]\[IndentingNewLine], 
            Scaled[{ .9,  .9,  .9}]\[IndentingNewLine]]}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]{Point[{0, 0, 0}], 
              Point[Scaled[{0, 0, 0}, {0, 
                    0, \(- .2\)}]]}\[IndentingNewLine], {Text["\<a point\>", 
                Scaled[{ .5,  .5,  .5}]]}\[IndentingNewLine]}\
\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]\[IndentingNewLine]{Line[{{0, 0, 
                    0}, {1, 0, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 1, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 0, 
                    1}}]}\[IndentingNewLine]\[IndentingNewLine] \
(*\[IndentingNewLine]\(,\)\({Line[ .95 {{0, 0, 0}, {1, 0, 
                        0}, { .95,  .1,  .1}}]}\)\(\[IndentingNewLine]\)\(,\)\
\({Line[ .95 {{0, 0, 0}, {0, 1, 
                        0}, { .1,  .95,  .1}}]}\)\(\[IndentingNewLine]\)\(,\)\
\({Line[ .95 {{0, 0, 0}, {0, 0, 
                        1}, { .1,  .1,  .95}}]}\)\(\[IndentingNewLine]\)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(,\)\({Text["\<+X1\>", 
                  Scaled[{ .1,  .05,  .05},  .80 {1, 0, 
                        0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\
\(,\)\({Text["\<+Y1\>", 
                  Scaled[{ .01,  .1,  .01},  .80 {0, 1, 
                        0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\
\(,\)\({Text["\<+Z1\>", 
                  Scaled[{ .01,  .01,  .1},  .80 {0, 0, 
                        1}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\
\(\[IndentingNewLine]\)\(,\)\({Text["\<X0\>", 
                  Scaled[{ .01,  .01,  .01}, { .1, 0, 
                      0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(,\
\)\({Text["\<Y0\>", 
                  Scaled[{ .01,  .01,  .01}, {0,  .1, 
                      0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(,\
\)\({Text["\<Z0\>", 
                  Scaled[{ .01,  .01,  .01}, {0, 
                      0,  .1}]]}\)\[IndentingNewLine]*) \[IndentingNewLine]\
\[IndentingNewLine]}\[IndentingNewLine]\[IndentingNewLine]\[IndentingNewLine] \
(*\[IndentingNewLine]\(,\)\(FaceGrids \[Rule] 
              All\)\(\[IndentingNewLine]\)\(,\)\(BoxRatios \[Rule] {1, 1, 
                1}\)\(\[IndentingNewLine]\)\(,\)\(PlotRange \[Rule] {{0, 
                  1}, {0, 1}, {0, 
                  1}}\)\[IndentingNewLine]*) \[IndentingNewLine]];\)\)], \
"Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(g5 = 
      Graphics3D[AxesLabel \[Rule] {"\<x\>", "\<y\>", "\<z\>"}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g1 = 
      Graphics3D[\[IndentingNewLine]{\[IndentingNewLine]Cuboid[\
\[IndentingNewLine]1.1 { .25,  .04,  .25}\[IndentingNewLine], 
            1.3 { .75,  .04,  .75}\[IndentingNewLine]]\[IndentingNewLine]}\
\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(Remove[p, l, g1, g2, g3, g4, g5]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
GraphicsArray OLD broken split chart into 3 separate combinable \
pieces\
\>", "Subsection"],

Cell["\<\
(* { go[[1,2,1]],go[[1,3,1]]};
genit[2 32]; showit[{{15,70},{-1,1},{1,40}}] *)\
\>", "Text"],

Cell["\<\
CANNOT get 3D or 2D  Graphics array to display right and done with \
trying.
\t* top guess is that PlotRange isn't copying to go5 what it shows
\t* could be GraphicsArray doesn't like that boxes and text are together in \
each
\t* doubt the go arrays contain \"shadow copies\" that GraphicsArray is doing
FIXME
\t* I used arrays of graphics and graphics array didn't like arrays
\t   to split the chart into 6 parts for \"printing easier\"
\t    (could try re-organizing arrays)
\t* I used Show to pre-render and graphics array
\t   refuses to consider each block rendered as being the same size
\t   it always dialates and contracts the parts rendered and
\t   after trying 1hr i don't yet see the option to turn it off\
\>", "Text"],

Cell[BoxData[
    \(showit[{{15, 175}, {\(-1\), 1}, {1, 100}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[go, go2, ViewPoint \[Rule] {0, \(-1\), 0}, 
      LightSources \[Rule] {{{0, \(-4\), 0}, 
            RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
            RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
            RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
            RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, GrayLevel[ .5]}}, 
      AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], Axes \[Rule] False, 
      PlotRange \[Rule] {{10, 596}, {\(-1\), 1}, {10, 300}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[go, go2, ViewPoint \[Rule] {0, \(-1\), 0}, 
      LightSources \[Rule] {{{0, \(-4\), 0}, 
            RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
            RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
            RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
            RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, GrayLevel[ .5]}}, 
      AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], Axes \[Rule] False, 
      PlotRange \[Rule] {{597, 1109}, {\(-1\), 1}, {10, 300}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5 = Table[i, {j, 1, 2}, {i, 1, 3}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 1]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{10, 363 + 29}, {135, 300}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 2]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{363 - 12, \((363*2)\) + 41}, {135, 
                300}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 3]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{41 + 363*2, 363*3 + 20}, {135, 
                300}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 1]\)] = 
      Show[go42D, go22D, Axes \[Rule] False, 
        PlotRange \[Rule] {{10, 363 + 29}, {10, 135}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 2]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{363 - 12, \((363*2)\)} + 41, {10, 
                135}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 3]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{41 + 363*2, 363*3 + 20}, {10, 
                135}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[ch2]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{{go5[\([1, 1]\)], go5[\([1, 2]\)], 
            go5[\([1, 3]\)]}\[IndentingNewLine], {go5[\([2, 1]\)], 
            go5[\([2, 2]\)], 
            go5[\([2, 
                3]\)]}\ \[IndentingNewLine]}\[IndentingNewLine]]]\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[ch2]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch2 // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5 = Table[i, {j, 1, 7}, {i, 1, 3}];\)\)], "Input",
  Evaluatable->False],

Cell["note: runs LL (Francium) to UR (He) L-R", "Text"],

Cell[BoxData[
    \(\(go5[\([1, 1]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 0, 
            3}, {i, 1, 11}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([1, 1]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 1]\)] = Flatten[go5[\([1, 1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([1, 1]\)] = 
      Show[go5[\([1, 1]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 2]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 0, 
            3}, {i, 12, 12 + 10}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([1, 2]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 2]\)] = Flatten[go5[\([1, 2]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([1, 2]\)] = 
      Show[go5[\([1, 2]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 3]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 0, 
            3}, {i, 12 + 11, 12 + 11 + 10 - 1}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([1, 3]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 3]\)] = Flatten[go5[\([1, 3]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([1, 3]\)] = 
      Show[go5[\([1, 3]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell["note: runs LL (Francium) to UR (He) L-R", "Text"],

Cell[BoxData[
    \(\(go5[\([2, 1]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 4, 
            6}, {i, 1, 11}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([2, 1]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 1]\)] = Flatten[go5[\([2, 1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 1]\)] = 
      Show[go5[\([2, 1]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 2]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 4, 
            6}, {i, 12, 12 + 10}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([2, 2]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 2]\)] = Flatten[go5[\([2, 2]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 2]\)] = 
      Show[go5[\([2, 2]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 3]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 4, 
            6}, {i, 12 + 11, 12 + 11 + 10 - 1}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([2, 3]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 3]\)] = Flatten[go5[\([2, 1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 3]\)] = 
      Show[go5[\([2, 3]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{go5[\([2, 1]\)], 
          go5[\([2, 2]\)]}\[IndentingNewLine]], 
      GraphicsSpacing \[Rule] \(- .035\), 
      AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{{go5[\([2, 1]\)], go5[\([2, 2]\)], 
            go5[\([2, 3]\)]}\[IndentingNewLine], {go5[\([1, 1]\)], 
            go5[\([1, 2]\)], 
            go5[\([1, 3]\)]}\ \[IndentingNewLine]}\[IndentingNewLine]], 
      GraphicsSpacing \[Rule] \(- .035\), 
      AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5 =. ;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6 = {1, 2, 3};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([1]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 7, 
            0, \(-1\)}, {i, 1, 11}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([1]\)] = Flatten[go6[\([1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go6[\([1]\)] = 
      Show[go6[\([1]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([2]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 7, 
            1, \(-1\)}, {i, 12, 12 + 10}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([2]\)] = Flatten[go6[\([2]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go6[\([2]\)] = 
      Show[go6[\([2]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([3]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 7, 
            1, \(-1\)}, {i, 12 + 11, 12 + 11 + 10 - 1}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([3]\)] = Flatten[go6[\([3]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go6[\([3]\)] = 
      Show[go6[\([3]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{go6[\([1]\)], go6[\([2]\)], 
          go6[\([3]\)]}\[IndentingNewLine]], 
      GraphicsSpacing \[Rule] \(- .05\), 
      AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6 =. ;\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["scratch area", "Subsection"],

Cell["\<\
(*
showit[{{1,1200},{-1,1},{1,300}}]
{8.5,11}2
{1110/4,300/2}//N
go3={1,1,1,1,1,1};
go3=Table[
    Show[go,go2
      ,ViewPoint\[Rule]{0,-1,0}
      ,LightSources\[Rule]{
          {{0,-4,0},RGBColor[.7,.1,.1]}
          ,{{4,0,0},RGBColor[.1,.7,.1]}
          ,{{0,0,4},RGBColor[.1,.1,.7]}
          ,{{1.3,-2.4,2},RGBColor[.5,.5,.5]}
          ,{{0,-2,0},GrayLevel[.5]}}
      ,AmbientLight\[Rule]RGBColor[.25,.25,.25]
      ,Axes\[Rule]False,PlotRange\[Rule]{{10+(1109/3)(i-1),10+(1109/3) \
i},{-1,1},{10+150(j-1),10+150 j}}]
    ,{i,1,3},{j,1,2}
    ]
Show[GraphicsArray[go3[[All]]]]
Remove[go3]
PlotRange\[Rule]{{597,1109},{-1,1},{10,300}};
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["scratch area", "Subsection"],

Cell["\<\
ViewPoint\tcannot go inside bounding box
{0,0,0}\t\twhere camera points
{1.3,-2.4,2}  \tdefault is above and right
{0,-1,0}\t\tfront
ViewPoint\[Rule]{1.3,-2.4,2},
ViewPoint\[Rule]{0,-1,0},

(*
  Graphics3D[{
      {Line[{{0,0,0},{.1,0,0}}]}
      ,{Line[{{0,0,0},{0,.1,0}}]}
      ,{Line[{{0,0,0},{0,0,.1}}]}
      }],
  *)
,FaceGrids\[Rule]All
,BoxRatios\[Rule]{1,1,1}
(* ,PlotRange\[Rule]{{.025,.035},{-.1,.1},{.13,.14}} *)
,Axes\[Rule]True,AxesLabel\[Rule]{\"x\",\"y\",\"z\"}
  (*
  ,FaceGrids\[Rule]All
  ,BoxRatios\[Rule]{1,1,1}
  ,PlotRange\[Rule]{{0,1},{0,1},{0,1}}
  *)\
\>", "Text"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["END PACKAGE", "Subsubtitle"],

Cell[BoxData[
    \(\(End[];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(EndPackage[];\)\)], "Input",
  InitializationCell->True]
}, Closed]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
ShowPageBreaks->False,
Evaluator->"Local",
PrintAction->"SeparateCells",
WindowSize->{793, 635},
WindowMargins->{{Automatic, 96}, {Automatic, 82}},
PrintingPageRange->{Automatic, Automatic},
PageHeaderLines->{False, False},
PrintingOptions->{"PrintingMargins"->{{0, 0}, {0, 0}},
"PaperSize"->{700, 210},
"PaperOrientation"->"Portrait",
"PrintCellBrackets"->False,
"PrintRegistrationMarks"->False,
"PrintMultipleHorizontalPages"->False,
"FirstPageHeader"->False,
"FirstPageFooter"->False,
"RestPagesHeader"->False,
"RestPagesFooter"->False,
"IncludeSpecialFonts"->True,
"IncludePostScriptResourceDirectives"->True,
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "jdh", \
"PeriodicTableOfElements"}, "x.ps", CharacterEncoding -> "ISO8859-1"],
"UsePostScriptOutputFile"->True,
"Magnification"->1},
IndexCreationOptions->{"Format"->"Hyperlinks"},
ShowCellTags->True,
InputAutoReplacements->{},
Magnification->1
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "S2.8.7"->{
    Cell[41518, 1261, 112, 4, 40, "Input",
      CellTags->"S2.8.7"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"S2.8.7", 363329, 11276}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 278, 5, 65, "Text"],

Cell[CellGroupData[{
Cell[2020, 58, 47, 0, 42, "Subsubsection"],
Cell[2070, 60, 147, 5, 32, "Text"],
Cell[2220, 67, 176, 5, 50, "Text"],
Cell[2399, 74, 112, 2, 32, "Text"],
Cell[2514, 78, 23, 0, 31, "Text"],
Cell[2540, 80, 749, 11, 133, "Text"],
Cell[3292, 93, 114, 3, 31, "Text"],
Cell[3409, 98, 587, 12, 133, "Text"],
Cell[3999, 112, 131, 3, 48, "Text"],
Cell[4133, 117, 440, 7, 82, "Text"],
Cell[4576, 126, 195, 4, 48, "Text"],
Cell[4774, 132, 208, 4, 48, "Text"],
Cell[4985, 138, 170, 5, 32, "Text"],
Cell[5158, 145, 307, 7, 66, "Text"],
Cell[5468, 154, 920, 16, 152, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[6425, 175, 135, 4, 44, "Subsubsection"],
Cell[6563, 181, 199, 6, 49, "Text"],
Cell[6765, 189, 92, 1, 27, "Input"],
Cell[6860, 192, 136, 4, 65, "Text"],
Cell[6999, 198, 361, 11, 116, "Text"],
Cell[7363, 211, 56, 1, 27, "Input"],
Cell[7422, 214, 52, 1, 27, "Input"],
Cell[7477, 217, 54, 1, 27, "Input"],
Cell[7534, 220, 56, 1, 27, "Input"],
Cell[7593, 223, 46, 1, 27, "Input"],
Cell[7642, 226, 2008, 31, 577, "Text"],
Cell[9653, 259, 32, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[9722, 264, 79, 0, 29, "Subsection"],

Cell[CellGroupData[{
Cell[9826, 268, 46, 0, 42, "Subsubsection"],
Cell[9875, 270, 461, 14, 111, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[10373, 289, 40, 0, 42, "Subsubsection"],
Cell[10416, 291, 808, 20, 263, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[11261, 316, 54, 0, 42, "Subsubsection"],
Cell[11318, 318, 114, 3, 31, "Text"],
Cell[11435, 323, 131, 3, 31, "Text"],
Cell[11569, 328, 1491, 37, 415, "Text"],
Cell[13063, 367, 240, 5, 65, "Text"],
Cell[13306, 374, 964, 35, 118, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[14307, 414, 55, 0, 42, "Subsubsection"],
Cell[14365, 416, 106, 3, 31, "Text"],
Cell[14474, 421, 1298, 32, 505, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[15809, 458, 64, 0, 42, "Subsubsection"],
Cell[15876, 460, 195, 4, 48, "Text"],
Cell[16074, 466, 133, 3, 48, "Text"],
Cell[16210, 471, 614, 18, 185, "Text"],
Cell[16827, 491, 100, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[16964, 499, 55, 0, 42, "Subsubsection"],
Cell[17022, 501, 256, 5, 65, "Text"],
Cell[17281, 508, 96, 3, 31, "Text"],
Cell[17380, 513, 2174, 48, 849, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[19591, 566, 71, 0, 42, "Subsubsection"],
Cell[19665, 568, 246, 7, 49, "Text"],
Cell[19914, 577, 1121, 29, 351, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[21072, 611, 48, 0, 42, "Subsubsection"],
Cell[21123, 613, 67, 0, 31, "Text"],
Cell[21193, 615, 158, 3, 48, "Text"],
Cell[21354, 620, 855, 22, 245, "Text"],
Cell[22212, 644, 130, 3, 48, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[22379, 652, 110, 3, 42, "Subsubsection"],
Cell[22492, 657, 837, 13, 202, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[23378, 676, 35, 0, 29, "Subsection"],
Cell[23416, 678, 71, 1, 27, "Input"],
Cell[23490, 681, 82, 1, 27, "Input"],
Cell[23575, 684, 83, 1, 27, "Input"],
Cell[23661, 687, 68, 0, 27, "Input"],
Cell[23732, 689, 69, 1, 27, "Input"],
Cell[23804, 692, 67, 1, 27, "Input"],
Cell[23874, 695, 71, 1, 27, "Input"],
Cell[23948, 698, 67, 1, 27, "Input"],
Cell[24018, 701, 77, 1, 27, "Input"],
Cell[24098, 704, 70, 1, 27, "Input"],
Cell[24171, 707, 48, 0, 27, "Input"],
Cell[24222, 709, 44, 0, 27, "Input"],
Cell[24269, 711, 70, 1, 27, "Input"],
Cell[24342, 714, 67, 1, 27, "Input"],
Cell[24412, 717, 27, 0, 31, "Text"],
Cell[24442, 719, 58, 1, 27, "Input"],
Cell[24503, 722, 63, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[24603, 728, 67, 1, 56, "Section"],
Cell[24673, 731, 142, 3, 48, "Text"],
Cell[24818, 736, 190, 4, 48, "Text"],
Cell[25011, 742, 537, 8, 107, "Input",
  InitializationCell->True],
Cell[25551, 752, 88, 2, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[25676, 759, 65, 0, 40, "Section"],

Cell[CellGroupData[{
Cell[25766, 763, 33, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[25824, 767, 44, 0, 42, "Subsubsection"],
Cell[25871, 769, 102, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[25998, 775, 47, 1, 27, "Input"],
Cell[26048, 778, 116, 3, 45, "Output"]
}, Closed]],
Cell[26179, 784, 66, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[26282, 789, 52, 0, 42, "Subsubsection"],
Cell[26337, 791, 95, 2, 27, "Input",
  Evaluatable->False],
Cell[26435, 795, 111, 2, 27, "Input",
  Evaluatable->False],
Cell[26549, 799, 208, 4, 43, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[26782, 807, 159, 3, 27, "Input",
  Evaluatable->False],
Cell[26944, 812, 97, 2, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[27078, 819, 146, 3, 27, "Input",
  Evaluatable->False],
Cell[27227, 824, 90, 1, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[27354, 830, 101, 2, 27, "Input",
  Evaluatable->False],
Cell[27458, 834, 128, 3, 23, "Print"]
}, Closed]],
Cell[27601, 840, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[27700, 844, 69, 2, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[27794, 850, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[27869, 854, 114, 3, 44, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[28020, 862, 98, 2, 27, "Input",
  Evaluatable->False],
Cell[28121, 866, 127, 3, 27, "Output"]
}, Closed]],
Cell[28263, 872, 95, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[28395, 879, 74, 0, 42, "Subsubsection"],
Cell[28472, 881, 451, 15, 184, "Text"],
Cell[28926, 898, 29, 0, 31, "Text"],
Cell[28958, 900, 74, 1, 27, "Input"],
Cell[29035, 903, 195, 4, 43, "Input"],
Cell[29233, 909, 265, 5, 59, "Input"],
Cell[29501, 916, 86, 1, 27, "Input"],
Cell[29590, 919, 87, 1, 27, "Input"],
Cell[29680, 922, 482, 7, 91, "Input"],
Cell[30165, 931, 368, 5, 43, "Input"],
Cell[30536, 938, 287, 4, 43, "Input"],
Cell[30826, 944, 65, 1, 27, "Input"],
Cell[30894, 947, 322, 7, 66, "Text"],
Cell[31219, 956, 103, 3, 31, "Text"],
Cell[31325, 961, 403, 6, 103, "Input"],
Cell[31731, 969, 437, 7, 101, "Input"],
Cell[32171, 978, 108, 3, 31, "Text"],
Cell[32282, 983, 76, 0, 31, "Text"],
Cell[32361, 985, 87, 3, 31, "Text"],
Cell[32451, 990, 295, 5, 91, "Input"],
Cell[32749, 997, 72, 1, 27, "Input"],
Cell[32824, 1000, 134, 3, 27, "Input"],
Cell[32961, 1005, 493, 10, 123, "Input"],
Cell[33457, 1017, 86, 1, 27, "Input"],
Cell[33546, 1020, 543, 11, 123, "Input"],
Cell[34092, 1033, 91, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[34220, 1039, 87, 1, 42, "Subsubsection"],
Cell[34310, 1042, 188, 3, 59, "Input"],
Cell[34501, 1047, 66, 1, 27, "Input"],
Cell[34570, 1050, 267, 5, 59, "Input"],
Cell[34840, 1057, 419, 6, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[35308, 1069, 34, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[35367, 1073, 79, 0, 42, "Subsubsection"],
Cell[35449, 1075, 383, 6, 171, "Input"],
Cell[35835, 1083, 87, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[35959, 1089, 114, 3, 42, "Subsubsection"],
Cell[36076, 1094, 512, 9, 155, "Input"],
Cell[36591, 1105, 71, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[36699, 1111, 79, 0, 42, "Subsubsection"],
Cell[36781, 1113, 212, 4, 59, "Input"],
Cell[36996, 1119, 169, 3, 43, "Input"],
Cell[37168, 1124, 50, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[37255, 1130, 74, 0, 42, "Subsubsection"],
Cell[37332, 1132, 509, 8, 203, "Input"],
Cell[37844, 1142, 49, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[37930, 1148, 82, 1, 42, "Subsubsection"],
Cell[38015, 1151, 357, 6, 123, "Input"],
Cell[38375, 1159, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[38477, 1165, 63, 0, 42, "Subsubsection"],
Cell[38543, 1167, 225, 4, 91, "Input"],
Cell[38771, 1173, 67, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[38875, 1179, 73, 0, 42, "Subsubsection"],
Cell[38951, 1181, 232, 4, 91, "Input"],
Cell[39186, 1187, 57, 1, 27, "Input"],
Cell[39246, 1190, 99, 3, 31, "Text"],
Cell[39348, 1195, 234, 4, 91, "Input"],
Cell[39585, 1201, 58, 1, 27, "Input"],
Cell[39646, 1204, 55, 1, 27, "Input"],
Cell[39704, 1207, 638, 11, 235, "Input"],
Cell[40345, 1220, 42, 1, 27, "Input"],
Cell[40390, 1223, 47, 1, 27, "Input"],
Cell[40440, 1226, 636, 11, 235, "Input"],
Cell[41079, 1239, 41, 1, 27, "Input"],
Cell[41123, 1242, 47, 1, 27, "Input"],
Cell[41173, 1245, 60, 1, 27, "Input"],
Cell[41236, 1248, 54, 1, 27, "Input"],
Cell[41293, 1251, 166, 5, 32, "Text"],
Cell[41462, 1258, 53, 1, 27, "Input"],
Cell[41518, 1261, 112, 4, 40, "Input",
  CellTags->"S2.8.7"],
Cell[41633, 1267, 50, 0, 31, "Text"],
Cell[41686, 1269, 73, 1, 31, "Input"],
Cell[41762, 1272, 410, 11, 46, "Input"],
Cell[42175, 1285, 55, 1, 27, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[42291, 1293, 41, 0, 40, "Section"],

Cell[CellGroupData[{
Cell[42357, 1297, 29, 0, 42, "Subsubsection"],
Cell[42389, 1299, 96, 3, 31, "Text"],
Cell[42488, 1304, 409, 10, 152, "Text"],
Cell[42900, 1316, 175, 4, 65, "Text"],
Cell[43078, 1322, 111, 3, 31, "Text"],
Cell[43192, 1327, 457, 11, 167, "Text"],
Cell[43652, 1340, 162, 5, 32, "Text"],
Cell[43817, 1347, 259, 6, 99, "Text"],
Cell[44079, 1355, 471, 22, 371, "Text"],
Cell[44553, 1379, 483, 18, 303, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[45073, 1402, 54, 0, 28, "Subsubsection"],
Cell[45130, 1404, 2031, 32, 347, "Input"],
Cell[47164, 1438, 104, 2, 27, "Input"],
Cell[47271, 1442, 107, 2, 27, "Input"],
Cell[47381, 1446, 84, 1, 27, "Input"],
Cell[47468, 1449, 139, 4, 48, "Text"],
Cell[47610, 1455, 86, 1, 27, "Input"],
Cell[47699, 1458, 84, 1, 27, "Input"],
Cell[47786, 1461, 86, 1, 27, "Input"],
Cell[47875, 1464, 134, 3, 48, "Text"],
Cell[48012, 1469, 38, 1, 27, "Input"],
Cell[48053, 1472, 49, 0, 31, "Text"],
Cell[48105, 1474, 40, 1, 27, "Input"],
Cell[48148, 1477, 94, 3, 31, "Text"],
Cell[48245, 1482, 380, 6, 91, "Input"],
Cell[48628, 1490, 427, 8, 91, "Input"],
Cell[49058, 1500, 378, 6, 91, "Input"],
Cell[49439, 1508, 425, 8, 91, "Input"],
Cell[49867, 1518, 76, 0, 31, "Text"],
Cell[49946, 1520, 219, 3, 62, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[50202, 1528, 76, 0, 28, "Subsubsection"],
Cell[50281, 1530, 75, 0, 31, "Text"],
Cell[50359, 1532, 444, 7, 82, "Text"],
Cell[50806, 1541, 114, 2, 27, "Input"],
Cell[50923, 1545, 114, 2, 27, "Input"],
Cell[51040, 1549, 212, 3, 59, "Input"],
Cell[51255, 1554, 359, 6, 126, "Input"],
Cell[51617, 1562, 159, 4, 48, "Text"],
Cell[51779, 1568, 659, 9, 139, "Input"],
Cell[52441, 1579, 804, 12, 150, "Text"],
Cell[53248, 1593, 764, 13, 155, "Input"],
Cell[54015, 1608, 55, 1, 27, "Input"],
Cell[54073, 1611, 44, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[54154, 1617, 125, 4, 44, "Subsubsection"],
Cell[54282, 1623, 318, 5, 65, "Text"],
Cell[54603, 1630, 299, 6, 107, "Input"],
Cell[54905, 1638, 45, 1, 27, "Input"],
Cell[54953, 1641, 161, 4, 48, "Text"],
Cell[55117, 1647, 451, 8, 155, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[55605, 1660, 55, 0, 28, "Subsubsection"],
Cell[55663, 1662, 115, 3, 31, "Text"],
Cell[55781, 1667, 152, 4, 65, "Text"],
Cell[55936, 1673, 199, 4, 75, "Input"],
Cell[56138, 1679, 58, 1, 27, "Input"],
Cell[56199, 1682, 104, 2, 27, "Input"],
Cell[56306, 1686, 106, 2, 27, "Input"],
Cell[56415, 1690, 82, 1, 27, "Input"],
Cell[56500, 1693, 84, 1, 27, "Input"],
Cell[56587, 1696, 43, 1, 27, "Input"],
Cell[56633, 1699, 52, 1, 27, "Input"],
Cell[56688, 1702, 54, 1, 27, "Input"],
Cell[56745, 1705, 57, 1, 27, "Input"],
Cell[56805, 1708, 61, 1, 27, "Input"],
Cell[56869, 1711, 133, 3, 27, "Input"],
Cell[57005, 1716, 55, 0, 31, "Text"],
Cell[57063, 1718, 132, 3, 27, "Input"],
Cell[57198, 1723, 130, 3, 27, "Input"],
Cell[57331, 1728, 60, 0, 31, "Text"],
Cell[57394, 1730, 517, 9, 123, "Input"],
Cell[57914, 1741, 60, 0, 31, "Text"],
Cell[57977, 1743, 570, 10, 139, "Input"],
Cell[58550, 1755, 88, 1, 27, "Input"],
Cell[58641, 1758, 73, 0, 31, "Text"],
Cell[58717, 1760, 87, 1, 27, "Input"],
Cell[58807, 1763, 107, 3, 31, "Text"],
Cell[58917, 1768, 242, 4, 75, "Input"],
Cell[59162, 1774, 198, 4, 75, "Input"],
Cell[59363, 1780, 28, 0, 31, "Text"],
Cell[59394, 1782, 116, 2, 27, "Input"],
Cell[59513, 1786, 120, 2, 27, "Input"],
Cell[59636, 1790, 112, 3, 31, "Text"],
Cell[59751, 1795, 676, 12, 203, "Input"],
Cell[60430, 1809, 91, 1, 27, "Input"],
Cell[60524, 1812, 92, 3, 48, "Text"],
Cell[60619, 1817, 655, 11, 219, "Input"],
Cell[61277, 1830, 93, 1, 27, "Input"],
Cell[61373, 1833, 83, 1, 27, "Input"],
Cell[61459, 1836, 68, 1, 27, "Input"],
Cell[61530, 1839, 67, 1, 27, "Input"],
Cell[61600, 1842, 125, 2, 27, "Input"],
Cell[61728, 1846, 52, 1, 27, "Input"],
Cell[61783, 1849, 58, 1, 27, "Input"],
Cell[61844, 1852, 48, 1, 27, "Input"],
Cell[61895, 1855, 356, 10, 167, "Text"],
Cell[62254, 1867, 268, 6, 75, "Input"],
Cell[62525, 1875, 270, 6, 75, "Input"],
Cell[62798, 1883, 86, 3, 48, "Text"],
Cell[62887, 1888, 172, 3, 43, "Input"],
Cell[63062, 1893, 87, 3, 48, "Text"],
Cell[63152, 1898, 233, 4, 59, "Input"],
Cell[63388, 1904, 243, 4, 59, "Input"],
Cell[63634, 1910, 103, 3, 31, "Text"],
Cell[63740, 1915, 259, 4, 75, "Input"],
Cell[64002, 1921, 60, 1, 27, "Input"],
Cell[64065, 1924, 303, 7, 99, "Text"],
Cell[64371, 1933, 307, 6, 59, "Input"],
Cell[64681, 1941, 183, 4, 43, "Input"],
Cell[64867, 1947, 223, 4, 75, "Input"],
Cell[65093, 1953, 94, 3, 31, "Text"],
Cell[65190, 1958, 460, 8, 139, "Input"],
Cell[65653, 1968, 220, 4, 75, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[65910, 1977, 64, 0, 28, "Subsubsection"],
Cell[65977, 1979, 209, 4, 65, "Text"],
Cell[66189, 1985, 157, 3, 48, "Text"],
Cell[66349, 1990, 404, 7, 139, "Input"],
Cell[66756, 1999, 155, 3, 43, "Input"],
Cell[66914, 2004, 111, 4, 65, "Text"],
Cell[67028, 2010, 338, 6, 91, "Input"],
Cell[67369, 2018, 116, 3, 31, "Text"],
Cell[67488, 2023, 209, 4, 75, "Input"],
Cell[67700, 2029, 63, 0, 31, "Text"],
Cell[67766, 2031, 178, 3, 43, "Input"],
Cell[67947, 2036, 221, 4, 59, "Input"],
Cell[68171, 2042, 111, 2, 27, "Input"],
Cell[68285, 2046, 240, 5, 59, "Input",
  Evaluatable->False],
Cell[68528, 2053, 95, 3, 31, "Text"],
Cell[68626, 2058, 59, 1, 27, "Input"],
Cell[68688, 2061, 61, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[68786, 2067, 55, 0, 28, "Subsubsection"],
Cell[68844, 2069, 342, 8, 116, "Text"],
Cell[69189, 2079, 387, 8, 116, "Text"],
Cell[69579, 2089, 285, 6, 107, "Input"],
Cell[69867, 2097, 158, 4, 65, "Text"],
Cell[70028, 2103, 55, 1, 27, "Input"],
Cell[70086, 2106, 87, 3, 48, "Text"],
Cell[70176, 2111, 413, 8, 139, "Input"],
Cell[70592, 2121, 55, 0, 31, "Text"],
Cell[70650, 2123, 487, 9, 155, "Input"],
Cell[71140, 2134, 48, 0, 31, "Text"],
Cell[71191, 2136, 203, 4, 75, "Input"],
Cell[71397, 2142, 75, 0, 31, "Text"],
Cell[71475, 2144, 264, 5, 91, "Input"],
Cell[71742, 2151, 122, 2, 27, "Input"],
Cell[71867, 2155, 503, 9, 139, "Input"],
Cell[72373, 2166, 76, 1, 27, "Input"],
Cell[72452, 2169, 78, 1, 27, "Input"],
Cell[72533, 2172, 78, 1, 27, "Input"],
Cell[72614, 2175, 80, 1, 27, "Input"],
Cell[72697, 2178, 25, 0, 31, "Text"],
Cell[72725, 2180, 120, 2, 27, "Input"],
Cell[72848, 2184, 81, 1, 27, "Input"],
Cell[72932, 2187, 90, 1, 27, "Input"],
Cell[73025, 2190, 84, 1, 27, "Input"],
Cell[73112, 2193, 93, 1, 27, "Input"],
Cell[73208, 2196, 69, 1, 27, "Input"],
Cell[73280, 2199, 72, 1, 27, "Input"],
Cell[73355, 2202, 66, 0, 31, "Text"],
Cell[73424, 2204, 81, 1, 27, "Input"],
Cell[73508, 2207, 42, 1, 27, "Input"],
Cell[73553, 2210, 134, 4, 48, "Text"],
Cell[73690, 2216, 78, 1, 27, "Input"],
Cell[73771, 2219, 52, 1, 27, "Input"],
Cell[73826, 2222, 74, 1, 27, "Input"],
Cell[73903, 2225, 53, 1, 27, "Input"],
Cell[73959, 2228, 55, 1, 27, "Input"],
Cell[74017, 2231, 52, 1, 27, "Input"],
Cell[74072, 2234, 104, 3, 31, "Text"],
Cell[74179, 2239, 577, 8, 91, "Input"],
Cell[74759, 2249, 327, 6, 91, "Input"],
Cell[75089, 2257, 153, 3, 43, "Input"],
Cell[75245, 2262, 47, 1, 27, "Input"],
Cell[75295, 2265, 54, 0, 31, "Text"],
Cell[75352, 2267, 43, 0, 31, "Text"],
Cell[75398, 2269, 43, 1, 27, "Input"],
Cell[75444, 2272, 65, 1, 27, "Input"],
Cell[75512, 2275, 59, 1, 27, "Input"],
Cell[75574, 2278, 49, 1, 27, "Input"],
Cell[75626, 2281, 67, 0, 31, "Text"],
Cell[75696, 2283, 64, 1, 27, "Input"],
Cell[75763, 2286, 42, 1, 27, "Input"],
Cell[75808, 2289, 43, 1, 27, "Input"],
Cell[75854, 2292, 61, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[75952, 2298, 71, 0, 28, "Subsubsection"],
Cell[76026, 2300, 274, 7, 49, "Text"],
Cell[76303, 2309, 248, 6, 99, "Text"],
Cell[76554, 2317, 135, 5, 32, "Text"],
Cell[76692, 2324, 444, 8, 123, "Input"],
Cell[77139, 2334, 43, 0, 31, "Text"],
Cell[77185, 2336, 348, 6, 123, "Input"],
Cell[77536, 2344, 73, 0, 31, "Text"],
Cell[77612, 2346, 387, 8, 116, "Text"],
Cell[78002, 2356, 2397, 41, 491, "Input"],
Cell[80402, 2399, 167, 4, 48, "Text"],
Cell[80572, 2405, 471, 9, 139, "Input"],
Cell[81046, 2416, 527, 10, 139, "Input"],
Cell[81576, 2428, 96, 4, 32, "Text"],
Cell[81675, 2434, 489, 9, 139, "Input"],
Cell[82167, 2445, 63, 0, 31, "Text"],
Cell[82233, 2447, 536, 10, 155, "Input"],
Cell[82772, 2459, 101, 4, 32, "Text"],
Cell[82876, 2465, 446, 9, 107, "Input"],
Cell[83325, 2476, 497, 10, 123, "Input"],
Cell[83825, 2488, 171, 3, 59, "Input"],
Cell[83999, 2493, 180, 3, 59, "Input"],
Cell[84182, 2498, 171, 3, 59, "Input"],
Cell[84356, 2503, 180, 3, 59, "Input"],
Cell[84539, 2508, 51, 1, 27, "Input"],
Cell[84593, 2511, 82, 1, 27, "Input"],
Cell[84678, 2514, 140, 3, 48, "Text"],
Cell[84821, 2519, 121, 2, 27, "Input"],
Cell[84945, 2523, 116, 2, 27, "Input"],
Cell[85064, 2527, 105, 2, 27, "Input"],
Cell[85172, 2531, 83, 1, 27, "Input"],
Cell[85258, 2534, 84, 1, 27, "Input"],
Cell[85345, 2537, 212, 6, 49, "Text"],
Cell[85560, 2545, 53, 1, 27, "Input"],
Cell[85616, 2548, 65, 1, 27, "Input"],
Cell[85684, 2551, 106, 2, 27, "Input"],
Cell[85793, 2555, 116, 2, 27, "Input"],
Cell[85912, 2559, 65, 1, 31, "Input"],
Cell[85980, 2562, 71, 1, 27, "Input"],
Cell[86054, 2565, 44, 1, 27, "Input"],
Cell[86101, 2568, 82, 1, 27, "Input"],
Cell[86186, 2571, 85, 1, 27, "Input"],
Cell[86274, 2574, 50, 1, 27, "Input"],
Cell[86327, 2577, 708, 12, 270, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[87084, 2595, 56, 0, 40, "Section"],

Cell[CellGroupData[{
Cell[87165, 2599, 28, 0, 45, "Subsection"],
Cell[87196, 2601, 291, 6, 99, "Text"],
Cell[87490, 2609, 55, 0, 31, "Text"],
Cell[87548, 2611, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[87633, 2615, 398, 7, 139, "Input",
  Evaluatable->False],
Cell[88034, 2624, 78, 2, 27, "Input",
  Evaluatable->False],
Cell[88115, 2628, 69, 2, 27, "Input",
  Evaluatable->False],
Cell[88187, 2632, 84, 2, 27, "Input",
  Evaluatable->False],
Cell[88274, 2636, 127, 3, 27, "Input",
  Evaluatable->False],
Cell[88404, 2641, 127, 3, 27, "Input",
  Evaluatable->False],
Cell[88534, 2646, 112, 3, 31, "Text"],
Cell[88649, 2651, 730, 13, 235, "Input",
  Evaluatable->False],
Cell[89382, 2666, 105, 2, 27, "Input",
  Evaluatable->False],
Cell[89490, 2670, 395, 8, 155, "Input",
  Evaluatable->False],
Cell[89888, 2680, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[89958, 2684, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[90031, 2688, 69, 2, 27, "Input",
  Evaluatable->False],
Cell[90103, 2692, 156, 4, 27, "Input",
  Evaluatable->False],
Cell[90262, 2698, 108, 3, 31, "Text"],
Cell[90373, 2703, 71, 0, 31, "Text"],
Cell[90447, 2705, 446, 8, 171, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[90918, 2717, 32, 0, 42, "Subsubsection"],
Cell[90953, 2719, 548, 12, 266, "Text"],
Cell[91504, 2733, 553, 18, 303, "Text"],
Cell[92060, 2753, 344, 12, 201, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[92441, 2770, 28, 0, 42, "Subsubsection"],
Cell[92472, 2772, 205, 8, 117, "Output"],
Cell[92680, 2782, 224, 4, 107, "Input",
  Evaluatable->False],
Cell[92907, 2788, 94, 2, 27, "Input",
  Evaluatable->False],
Cell[93004, 2792, 242, 4, 107, "Input",
  Evaluatable->False],
Cell[93249, 2798, 78, 2, 27, "Input",
  Evaluatable->False],
Cell[93330, 2802, 151, 3, 43, "Input",
  Evaluatable->False],
Cell[93484, 2807, 871, 16, 235, "Input",
  Evaluatable->False],
Cell[94358, 2825, 93, 2, 27, "Input",
  Evaluatable->False],
Cell[94454, 2829, 81, 2, 27, "Input",
  Evaluatable->False],
Cell[94538, 2833, 73, 4, 65, "Text"],
Cell[94614, 2839, 149, 3, 43, "Input",
  Evaluatable->False],
Cell[94766, 2844, 718, 13, 203, "Input",
  Evaluatable->False],
Cell[95487, 2859, 336, 8, 139, "Input",
  Evaluatable->False],
Cell[95826, 2869, 97, 2, 27, "Input",
  Evaluatable->False],
Cell[95926, 2873, 457, 9, 155, "Input",
  Evaluatable->False],
Cell[96386, 2884, 88, 2, 27, "Input",
  Evaluatable->False],
Cell[96477, 2888, 85, 2, 27, "Input",
  Evaluatable->False],
Cell[96565, 2892, 200, 5, 59, "Input",
  Evaluatable->False],
Cell[96768, 2899, 80, 2, 27, "Input",
  Evaluatable->False],
Cell[96851, 2903, 81, 2, 27, "Input",
  Evaluatable->False],
Cell[96935, 2907, 66, 2, 27, "Input",
  Evaluatable->False],
Cell[97004, 2911, 70, 0, 31, "Text"],
Cell[97077, 2913, 111, 2, 27, "Input",
  Evaluatable->False],
Cell[97191, 2917, 129, 4, 27, "Input",
  Evaluatable->False],
Cell[97323, 2923, 172, 4, 27, "Input",
  Evaluatable->False],
Cell[97498, 2929, 447, 9, 139, "Input",
  Evaluatable->False],
Cell[97948, 2940, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[98018, 2944, 413, 8, 139, "Input",
  Evaluatable->False],
Cell[98434, 2954, 77, 2, 27, "Input",
  Evaluatable->False],
Cell[98514, 2958, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[98592, 2962, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[98667, 2966, 78, 2, 27, "Input",
  Evaluatable->False],
Cell[98748, 2970, 228, 5, 91, "Input",
  Evaluatable->False],
Cell[98979, 2977, 226, 5, 91, "Input",
  Evaluatable->False],
Cell[99208, 2984, 531, 10, 219, "Input",
  Evaluatable->False],
Cell[99742, 2996, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[99812, 3000, 310, 7, 75, "Input",
  Evaluatable->False],
Cell[100125, 3009, 1611, 32, 443, "Input",
  Evaluatable->False],
Cell[101739, 3043, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[101817, 3047, 206, 4, 43, "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[102084, 3058, 90, 2, 68, "Subsubtitle"],
Cell[102177, 3062, 146, 3, 48, "Text"],

Cell[CellGroupData[{
Cell[102348, 3069, 30, 0, 60, "Section"],

Cell[CellGroupData[{
Cell[102403, 3073, 66, 0, 42, "Subsubsection"],
Cell[102472, 3075, 2236, 33, 560, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[104745, 3113, 49, 0, 42, "Subsubsection"],
Cell[104797, 3115, 135, 4, 65, "Text"],
Cell[104935, 3121, 59, 0, 31, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[105043, 3127, 106, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[105174, 3132, 32, 0, 42, "Subsubsection"],
Cell[105209, 3134, 482, 11, 184, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[105728, 3150, 35, 0, 28, "Subsubsection"],
Cell[105766, 3152, 60, 1, 27, "Input"],
Cell[105829, 3155, 376, 6, 139, "Input"],
Cell[106208, 3163, 56, 1, 27, "Input"],
Cell[106267, 3166, 47, 1, 27, "Input"],
Cell[106317, 3169, 62, 1, 27, "Input"],
Cell[106382, 3172, 53, 0, 31, "Text"],
Cell[106438, 3174, 64, 1, 27, "Input"],
Cell[106505, 3177, 233, 4, 75, "Input"],
Cell[106741, 3183, 60, 1, 27, "Input"],
Cell[106804, 3186, 47, 1, 27, "Input"],
Cell[106854, 3189, 70, 1, 27, "Input"],
Cell[106927, 3192, 105, 2, 27, "Input"],
Cell[107035, 3196, 105, 2, 27, "Input"],
Cell[107143, 3200, 112, 3, 31, "Text"],
Cell[107258, 3205, 696, 12, 235, "Input"],
Cell[107957, 3219, 51, 1, 27, "Input"],
Cell[108011, 3222, 701, 12, 235, "Input"],
Cell[108715, 3236, 49, 1, 27, "Input"],
Cell[108767, 3239, 64, 0, 31, "Text"],
Cell[108834, 3241, 50, 1, 27, "Input"],
Cell[108887, 3244, 53, 1, 27, "Input"],
Cell[108943, 3247, 39, 0, 31, "Text"],
Cell[108985, 3249, 54, 1, 27, "Input"],
Cell[109042, 3252, 53, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[109132, 3258, 192, 5, 62, "Subsection"],
Cell[109327, 3265, 145, 5, 82, "Text"],
Cell[109475, 3272, 77, 2, 27, "Input",
  Evaluatable->False],
Cell[109555, 3276, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[109633, 3280, 98, 3, 31, "Text"],
Cell[109734, 3285, 79, 2, 27, "Input",
  Evaluatable->False],
Cell[109816, 3289, 79, 2, 27, "Input",
  Evaluatable->False],
Cell[109898, 3293, 79, 2, 27, "Input",
  Evaluatable->False],
Cell[109980, 3297, 68, 0, 31, "Text"],
Cell[110051, 3299, 80, 2, 27, "Input",
  Evaluatable->False],
Cell[110134, 3303, 84, 2, 27, "Input",
  Evaluatable->False],
Cell[110221, 3307, 83, 2, 27, "Input",
  Evaluatable->False],
Cell[110307, 3311, 65, 2, 27, "Input",
  Evaluatable->False],
Cell[110375, 3315, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[110448, 3319, 89, 2, 27, "Input",
  Evaluatable->False],
Cell[110540, 3323, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[110617, 3327, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[110694, 3331, 71, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[110790, 3335, 167, 4, 27, "Input",
  Evaluatable->False],
Cell[110960, 3341, 141, 2, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[111138, 3348, 87, 2, 24, "Input",
  Evaluatable->False],
Cell[111228, 3352, 58, 1, 27, "Output"]
}, Closed]],
Cell[111301, 3356, 74, 2, 24, "Input",
  Evaluatable->False],
Cell[111378, 3360, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[111455, 3364, 121, 3, 48, "Text"],
Cell[111579, 3369, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[111685, 3373, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[111791, 3377, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[111897, 3381, 130, 4, 48, "Text"],
Cell[112030, 3387, 326, 6, 107, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[112381, 3397, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[112459, 3401, 40, 1, 27, "Output"]
}, Closed]],
Cell[112514, 3405, 204, 4, 45, "Text"],
Cell[112721, 3411, 322, 6, 59, "Input",
  Evaluatable->False],
Cell[113046, 3419, 97, 3, 31, "Text"],
Cell[113146, 3424, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[113221, 3428, 202, 5, 59, "Input",
  Evaluatable->False],
Cell[113426, 3435, 174, 4, 48, "Text"],
Cell[113603, 3441, 243, 5, 59, "Input",
  Evaluatable->False],
Cell[113849, 3448, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[113924, 3452, 28, 0, 31, "Text"],
Cell[113955, 3454, 189, 4, 59, "Input",
  Evaluatable->False],
Cell[114147, 3460, 325, 6, 91, "Input",
  Evaluatable->False],
Cell[114475, 3468, 529, 9, 155, "Input",
  Evaluatable->False],
Cell[115007, 3479, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[115080, 3483, 117, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[115234, 3491, 52, 1, 29, "Subsection",
  Evaluatable->True],
Cell[115289, 3494, 86, 1, 31, "Text",
  Evaluatable->True],
Cell[115378, 3497, 53, 1, 27, "Input"],
Cell[115434, 3500, 62, 1, 27, "Input"],
Cell[115499, 3503, 61, 1, 27, "Input"],
Cell[115563, 3506, 43, 1, 27, "Input"],
Cell[115609, 3509, 196, 5, 48, "Text",
  Evaluatable->True],
Cell[115808, 3516, 64, 1, 27, "Input"],
Cell[115875, 3519, 76, 1, 27, "Input"],
Cell[115954, 3522, 69, 1, 27, "Input"],
Cell[116026, 3525, 68, 1, 27, "Input"],
Cell[116097, 3528, 84, 1, 27, "Input"],
Cell[116184, 3531, 73, 1, 27, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[116306, 3538, 85, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[116416, 3543, 105, 3, 42, "Subsubsection"],
Cell[116524, 3548, 1203, 18, 442, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[117764, 3571, 74, 1, 45, "Subsection"],

Cell[CellGroupData[{
Cell[117863, 3576, 32, 0, 42, "Subsubsection"],
Cell[117898, 3578, 428, 9, 133, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[118363, 3592, 65, 1, 58, "Subsubsection"],
Cell[118431, 3595, 52, 1, 27, "Input"],
Cell[118486, 3598, 124, 2, 27, "Input"],
Cell[118613, 3602, 171, 4, 48, "Text"],
Cell[118787, 3608, 89, 2, 43, "Input"],
Cell[118879, 3612, 49, 1, 27, "Input"],
Cell[118931, 3615, 51, 1, 27, "Input"],
Cell[118985, 3618, 73, 0, 31, "Text"],
Cell[119061, 3620, 51, 0, 31, "Text"],
Cell[119115, 3622, 118, 3, 31, "Text"],
Cell[119236, 3627, 46, 1, 27, "Input"],
Cell[119285, 3630, 115, 2, 27, "Input"],
Cell[119403, 3634, 204, 4, 48, "Text"],
Cell[119610, 3640, 152, 3, 27, "Input"],
Cell[119765, 3645, 43, 0, 31, "Text"],
Cell[119811, 3647, 64, 1, 27, "Input"],
Cell[119878, 3650, 62, 1, 27, "Input"],
Cell[119943, 3653, 103, 3, 31, "Text"],
Cell[120049, 3658, 72, 1, 27, "Input"],
Cell[120124, 3661, 186, 4, 65, "Text"],
Cell[120313, 3667, 144, 3, 27, "Input"],
Cell[120460, 3672, 186, 4, 43, "Input"],
Cell[120649, 3678, 67, 1, 27, "Input"],
Cell[120719, 3681, 87, 1, 27, "Input"],
Cell[120809, 3684, 71, 1, 27, "Input"],
Cell[120883, 3687, 81, 1, 27, "Input"],
Cell[120967, 3690, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[121069, 3696, 29, 0, 42, "Subsubsection"],
Cell[121101, 3698, 1154, 24, 388, "Text"],
Cell[122258, 3724, 462, 14, 81, "Input"],
Cell[122723, 3740, 310, 9, 81, "Input"],
Cell[123036, 3751, 106, 3, 31, "Text"],
Cell[123145, 3756, 315, 9, 81, "Input"],
Cell[123463, 3767, 51, 1, 27, "Input"],
Cell[123517, 3770, 349, 7, 99, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[123903, 3782, 40, 0, 42, "Subsubsection"],
Cell[123946, 3784, 313, 6, 139, "Input"],
Cell[124262, 3792, 233, 5, 59, "Input"],
Cell[124498, 3799, 53, 0, 31, "Text"],
Cell[124554, 3801, 94, 3, 31, "Text"],
Cell[124651, 3806, 219, 5, 75, "Input"],
Cell[124873, 3813, 108, 3, 31, "Text"],
Cell[124984, 3818, 63, 1, 27, "Input"],
Cell[125050, 3821, 94, 3, 31, "Text"],
Cell[125147, 3826, 60, 1, 27, "Input"],
Cell[125210, 3829, 44, 0, 31, "Text"],
Cell[125257, 3831, 100, 3, 31, "Text"],
Cell[125360, 3836, 502, 10, 139, "Input"],
Cell[125865, 3848, 490, 10, 139, "Input"],
Cell[126358, 3860, 123, 3, 27, "Input"],
Cell[126484, 3865, 427, 13, 201, "Text"],
Cell[126914, 3880, 919, 18, 203, "Input"],
Cell[127836, 3900, 571, 10, 219, "Text"],
Cell[128410, 3912, 633, 11, 171, "Input"],
Cell[129046, 3925, 899, 15, 251, "Input"],
Cell[129948, 3942, 351, 10, 167, "Text"],
Cell[130302, 3954, 1545, 29, 347, "Input"],
Cell[131850, 3985, 207, 8, 133, "Text"],
Cell[132060, 3995, 169, 5, 48, "Text"],
Cell[132232, 4002, 89, 1, 43, "Input"],
Cell[132324, 4005, 73, 1, 27, "Input"],
Cell[132400, 4008, 64, 0, 31, "Text"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[132525, 4015, 78, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[132628, 4020, 36, 0, 45, "Subsection"],
Cell[132667, 4022, 67, 0, 31, "Text"],
Cell[132737, 4024, 57, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[132819, 4029, 28, 0, 42, "Subsubsection"],
Cell[132850, 4031, 218, 4, 107, "Input"],
Cell[133071, 4037, 58, 1, 27, "Input"],
Cell[133132, 4040, 66, 1, 27, "Input"],
Cell[133201, 4043, 46, 0, 31, "Text"],
Cell[133250, 4045, 62, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[133349, 4051, 29, 0, 42, "Subsubsection"],
Cell[133381, 4053, 250, 4, 107, "Input"],
Cell[133634, 4059, 82, 1, 27, "Input"],
Cell[133719, 4062, 245, 7, 82, "Text"],
Cell[133967, 4071, 66, 1, 27, "Input"],
Cell[134036, 4074, 66, 1, 27, "Input"],
Cell[134105, 4077, 64, 1, 27, "Input"],
Cell[134172, 4080, 93, 1, 27, "Input"],
Cell[134268, 4083, 221, 5, 59, "Input"],
Cell[134492, 4090, 140, 5, 82, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[134669, 4100, 29, 0, 42, "Subsubsection"],
Cell[134701, 4102, 202, 4, 59, "Input"]
}, Closed]]
}, Closed]],
Cell[134930, 4110, 89, 1, 61, "Subsection"],

Cell[CellGroupData[{
Cell[135044, 4115, 34, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[135103, 4119, 28, 0, 42, "Subsubsection"],
Cell[135134, 4121, 156, 3, 27, "Input"],
Cell[135293, 4126, 72, 1, 27, "Input"],
Cell[135368, 4129, 112, 2, 27, "Input"],
Cell[135483, 4133, 69, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[135589, 4139, 29, 0, 42, "Subsubsection"],
Cell[135621, 4141, 364, 7, 107, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[136034, 4154, 55, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[136114, 4158, 28, 0, 42, "Subsubsection"],
Cell[136145, 4160, 280, 7, 66, "Text"],
Cell[136428, 4169, 634, 11, 267, "Input"],
Cell[137065, 4182, 114, 2, 27, "Input"],
Cell[137182, 4186, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[137329, 4193, 29, 0, 42, "Subsubsection"],
Cell[137361, 4195, 163, 3, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[137573, 4204, 104, 3, 62, "Subsection"],
Cell[137680, 4209, 125, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[137830, 4216, 28, 0, 42, "Subsubsection"],
Cell[137861, 4218, 726, 13, 267, "Input"],
Cell[138590, 4233, 115, 2, 27, "Input"],
Cell[138708, 4237, 109, 2, 27, "Input"],
Cell[138820, 4241, 361, 8, 100, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[139218, 4254, 29, 0, 42, "Subsubsection"],
Cell[139250, 4256, 163, 3, 75, "Input"],
Cell[139416, 4261, 92, 1, 27, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[139557, 4268, 35, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[139617, 4272, 28, 0, 42, "Subsubsection"],
Cell[139648, 4274, 283, 4, 75, "Input"],
Cell[139934, 4280, 64, 0, 31, "Text"],
Cell[140001, 4282, 76, 1, 27, "Input"],
Cell[140080, 4285, 114, 2, 27, "Input"],
Cell[140197, 4289, 78, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[140312, 4295, 29, 0, 42, "Subsubsection"],
Cell[140344, 4297, 358, 7, 91, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[140751, 4310, 53, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[140829, 4314, 28, 0, 42, "Subsubsection"],
Cell[140860, 4316, 83, 1, 27, "Input"],
Cell[140946, 4319, 188, 4, 43, "Input"],
Cell[141137, 4325, 71, 1, 27, "Input"],
Cell[141211, 4328, 572, 10, 187, "Input"],
Cell[141786, 4340, 67, 1, 27, "Input"],
Cell[141856, 4343, 67, 1, 27, "Input"],
Cell[141926, 4346, 67, 1, 27, "Input"],
Cell[141996, 4349, 60, 1, 27, "Input"],
Cell[142059, 4352, 224, 4, 43, "Input"],
Cell[142286, 4358, 115, 2, 27, "Input"],
Cell[142404, 4362, 107, 2, 27, "Input"],
Cell[142514, 4366, 62, 1, 27, "Input"],
Cell[142579, 4369, 59, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[142675, 4375, 29, 0, 42, "Subsubsection"],
Cell[142707, 4377, 262, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[143018, 4388, 28, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[143071, 4392, 32, 0, 42, "Subsubsection"],
Cell[143106, 4394, 87, 3, 31, "Text"],
Cell[143196, 4399, 263, 5, 75, "Input"],
Cell[143462, 4406, 42, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[143541, 4411, 28, 0, 42, "Subsubsection"],
Cell[143572, 4413, 112, 2, 27, "Input"],
Cell[143687, 4417, 68, 1, 27, "Input"],
Cell[143758, 4420, 106, 2, 27, "Input"],
Cell[143867, 4424, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[143969, 4430, 29, 0, 42, "Subsubsection"],
Cell[144001, 4432, 262, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[144312, 4443, 27, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[144364, 4447, 32, 0, 42, "Subsubsection"],
Cell[144399, 4449, 87, 3, 31, "Text"],
Cell[144489, 4454, 263, 5, 75, "Input"],
Cell[144755, 4461, 42, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[144834, 4466, 28, 0, 42, "Subsubsection"],
Cell[144865, 4468, 81, 1, 27, "Input"],
Cell[144949, 4471, 130, 2, 27, "Input"],
Cell[145082, 4475, 136, 3, 27, "Input"],
Cell[145221, 4480, 109, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[145367, 4487, 29, 0, 42, "Subsubsection"],
Cell[145399, 4489, 157, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[145605, 4498, 92, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[145722, 4506, 28, 0, 42, "Subsubsection"],
Cell[145753, 4508, 92, 1, 27, "Input"],
Cell[145848, 4511, 67, 1, 27, "Input"],
Cell[145918, 4514, 105, 2, 27, "Input"],
Cell[146026, 4518, 64, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[146127, 4524, 29, 0, 42, "Subsubsection"],
Cell[146159, 4526, 262, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[146470, 4537, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[146586, 4545, 28, 0, 42, "Subsubsection"],
Cell[146617, 4547, 74, 1, 27, "Input"],
Cell[146694, 4550, 130, 2, 27, "Input"],
Cell[146827, 4554, 137, 3, 27, "Input"],
Cell[146967, 4559, 91, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[147095, 4565, 29, 0, 42, "Subsubsection"],
Cell[147127, 4567, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[147334, 4576, 66, 1, 43, "Subsection"],

Cell[CellGroupData[{
Cell[147425, 4581, 28, 0, 42, "Subsubsection"],
Cell[147456, 4583, 74, 1, 27, "Input"],
Cell[147533, 4586, 66, 1, 27, "Input"],
Cell[147602, 4589, 117, 2, 27, "Input"],
Cell[147722, 4593, 77, 1, 27, "Input"],
Cell[147802, 4596, 70, 0, 31, "Text"],
Cell[147875, 4598, 150, 3, 27, "Input"],
Cell[148028, 4603, 115, 2, 27, "Input"],
Cell[148146, 4607, 245, 6, 59, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[148428, 4618, 29, 0, 42, "Subsubsection"],
Cell[148460, 4620, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[148772, 4631, 27, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[148824, 4635, 32, 0, 42, "Subsubsection"],
Cell[148859, 4637, 87, 3, 31, "Text"],
Cell[148949, 4642, 263, 5, 75, "Input"],
Cell[149215, 4649, 42, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[149294, 4654, 28, 0, 42, "Subsubsection"],
Cell[149325, 4656, 107, 2, 27, "Input"],
Cell[149435, 4660, 67, 1, 27, "Input"],
Cell[149505, 4663, 106, 2, 27, "Input"],
Cell[149614, 4667, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[149716, 4673, 29, 0, 42, "Subsubsection"],
Cell[149748, 4675, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[150060, 4686, 26, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[150111, 4690, 28, 0, 42, "Subsubsection"],
Cell[150142, 4692, 52, 1, 27, "Input"],
Cell[150197, 4695, 63, 0, 31, "Text"],
Cell[150263, 4697, 79, 1, 27, "Input"],
Cell[150345, 4700, 183, 4, 43, "Input"],
Cell[150531, 4706, 1845, 39, 379, "Input"],
Cell[152379, 4747, 160, 3, 27, "Input"],
Cell[152542, 4752, 83, 1, 27, "Input"],
Cell[152628, 4755, 307, 7, 66, "Text"],
Cell[152938, 4764, 75, 0, 31, "Text"],
Cell[153016, 4766, 63, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[153116, 4772, 29, 0, 42, "Subsubsection"],
Cell[153148, 4774, 164, 3, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[153361, 4783, 92, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[153478, 4791, 28, 0, 42, "Subsubsection"],
Cell[153509, 4793, 92, 1, 27, "Input"],
Cell[153604, 4796, 67, 1, 27, "Input"],
Cell[153674, 4799, 106, 2, 27, "Input"],
Cell[153783, 4803, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[153885, 4809, 29, 0, 42, "Subsubsection"],
Cell[153917, 4811, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[154229, 4822, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[154345, 4830, 28, 0, 42, "Subsubsection"],
Cell[154376, 4832, 74, 1, 27, "Input"],
Cell[154453, 4835, 130, 2, 27, "Input"],
Cell[154586, 4839, 137, 3, 27, "Input"],
Cell[154726, 4844, 91, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[154854, 4850, 29, 0, 42, "Subsubsection"],
Cell[154886, 4852, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[155093, 4861, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[155209, 4869, 28, 0, 42, "Subsubsection"],
Cell[155240, 4871, 113, 2, 27, "Input"],
Cell[155356, 4875, 68, 1, 27, "Input"],
Cell[155427, 4878, 107, 2, 27, "Input"],
Cell[155537, 4882, 66, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[155640, 4888, 29, 0, 42, "Subsubsection"],
Cell[155672, 4890, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[155984, 4901, 90, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[156099, 4909, 28, 0, 42, "Subsubsection"],
Cell[156130, 4911, 197, 5, 48, "Text"],
Cell[156330, 4918, 83, 1, 27, "Input"],
Cell[156416, 4921, 133, 2, 27, "Input"],
Cell[156552, 4925, 174, 4, 27, "Input"],
Cell[156729, 4931, 138, 3, 27, "Input"],
Cell[156870, 4936, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[157017, 4943, 29, 0, 42, "Subsubsection"],
Cell[157049, 4945, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[157256, 4954, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[157372, 4962, 28, 0, 42, "Subsubsection"],
Cell[157403, 4964, 112, 2, 27, "Input"],
Cell[157518, 4968, 68, 1, 27, "Input"],
Cell[157589, 4971, 107, 2, 27, "Input"],
Cell[157699, 4975, 66, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[157802, 4981, 29, 0, 42, "Subsubsection"],
Cell[157834, 4983, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[158146, 4994, 90, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[158261, 5002, 28, 0, 42, "Subsubsection"],
Cell[158292, 5004, 82, 1, 27, "Input"],
Cell[158377, 5007, 133, 2, 27, "Input"],
Cell[158513, 5011, 174, 4, 27, "Input"],
Cell[158690, 5017, 138, 3, 27, "Input"],
Cell[158831, 5022, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[158978, 5029, 29, 0, 42, "Subsubsection"],
Cell[159010, 5031, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[159217, 5040, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[159333, 5048, 28, 0, 42, "Subsubsection"],
Cell[159364, 5050, 112, 2, 27, "Input"],
Cell[159479, 5054, 68, 1, 27, "Input"],
Cell[159550, 5057, 107, 2, 27, "Input"],
Cell[159660, 5061, 66, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[159763, 5067, 29, 0, 42, "Subsubsection"],
Cell[159795, 5069, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[160107, 5080, 90, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[160222, 5088, 28, 0, 42, "Subsubsection"],
Cell[160253, 5090, 82, 1, 27, "Input"],
Cell[160338, 5093, 133, 2, 27, "Input"],
Cell[160474, 5097, 174, 4, 27, "Input"],
Cell[160651, 5103, 138, 3, 27, "Input"],
Cell[160792, 5108, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[160939, 5115, 29, 0, 42, "Subsubsection"],
Cell[160971, 5117, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[161178, 5126, 31, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[161234, 5130, 28, 0, 42, "Subsubsection"],
Cell[161265, 5132, 87, 1, 27, "Input"],
Cell[161355, 5135, 66, 1, 27, "Input"],
Cell[161424, 5138, 105, 2, 27, "Input"],
Cell[161532, 5142, 64, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[161633, 5148, 29, 0, 42, "Subsubsection"],
Cell[161665, 5150, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[161977, 5161, 30, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[162032, 5165, 28, 0, 42, "Subsubsection"],
Cell[162063, 5167, 68, 1, 27, "Input"],
Cell[162134, 5170, 125, 2, 27, "Input"],
Cell[162262, 5174, 136, 3, 27, "Input"],
Cell[162401, 5179, 107, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[162545, 5186, 29, 0, 42, "Subsubsection"],
Cell[162577, 5188, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[162784, 5197, 83, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[162892, 5205, 28, 0, 42, "Subsubsection"],
Cell[162923, 5207, 92, 1, 27, "Input"],
Cell[163018, 5210, 67, 1, 27, "Input"],
Cell[163088, 5213, 106, 2, 27, "Input"],
Cell[163197, 5217, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[163299, 5223, 29, 0, 42, "Subsubsection"],
Cell[163331, 5225, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[163643, 5236, 82, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[163750, 5244, 28, 0, 42, "Subsubsection"],
Cell[163781, 5246, 74, 1, 27, "Input"],
Cell[163858, 5249, 130, 2, 27, "Input"],
Cell[163991, 5253, 137, 3, 27, "Input"],
Cell[164131, 5258, 108, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[164276, 5265, 29, 0, 42, "Subsubsection"],
Cell[164308, 5267, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[164515, 5276, 75, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[164615, 5284, 28, 0, 42, "Subsubsection"],
Cell[164646, 5286, 111, 2, 27, "Input"],
Cell[164760, 5290, 67, 1, 27, "Input"],
Cell[164830, 5293, 106, 2, 27, "Input"],
Cell[164939, 5297, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[165041, 5303, 29, 0, 42, "Subsubsection"],
Cell[165073, 5305, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[165385, 5316, 74, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[165484, 5324, 28, 0, 42, "Subsubsection"],
Cell[165515, 5326, 80, 1, 27, "Input"],
Cell[165598, 5329, 130, 2, 27, "Input"],
Cell[165731, 5333, 137, 3, 27, "Input"],
Cell[165871, 5338, 106, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[166014, 5345, 29, 0, 42, "Subsubsection"],
Cell[166046, 5347, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[166253, 5356, 100, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[166378, 5364, 28, 0, 42, "Subsubsection"],
Cell[166409, 5366, 92, 1, 27, "Input"],
Cell[166504, 5369, 67, 1, 27, "Input"],
Cell[166574, 5372, 106, 2, 27, "Input"],
Cell[166683, 5376, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[166785, 5382, 29, 0, 42, "Subsubsection"],
Cell[166817, 5384, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[167129, 5395, 82, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[167236, 5403, 28, 0, 42, "Subsubsection"],
Cell[167267, 5405, 74, 1, 27, "Input"],
Cell[167344, 5408, 130, 2, 27, "Input"],
Cell[167477, 5412, 137, 3, 27, "Input"],
Cell[167617, 5417, 105, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[167759, 5424, 29, 0, 42, "Subsubsection"],
Cell[167791, 5426, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[167998, 5435, 52, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[168075, 5439, 28, 0, 42, "Subsubsection"],
Cell[168106, 5441, 112, 2, 27, "Input"],
Cell[168221, 5445, 67, 1, 27, "Input"],
Cell[168291, 5448, 106, 2, 27, "Input"],
Cell[168400, 5452, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[168502, 5458, 29, 0, 42, "Subsubsection"],
Cell[168534, 5460, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[168846, 5471, 33, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[168904, 5475, 28, 0, 42, "Subsubsection"],
Cell[168935, 5477, 81, 1, 27, "Input"],
Cell[169019, 5480, 130, 2, 27, "Input"],
Cell[169152, 5484, 137, 3, 27, "Input"],
Cell[169292, 5489, 111, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[169440, 5496, 29, 0, 42, "Subsubsection"],
Cell[169472, 5498, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[169679, 5507, 61, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[169765, 5513, 28, 0, 42, "Subsubsection"],
Cell[169796, 5515, 46, 0, 31, "Text"],
Cell[169845, 5517, 114, 2, 27, "Input"],
Cell[169962, 5521, 67, 1, 27, "Input"],
Cell[170032, 5524, 106, 2, 27, "Input"],
Cell[170141, 5528, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[170243, 5534, 29, 0, 42, "Subsubsection"],
Cell[170275, 5536, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[170587, 5547, 35, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[170647, 5551, 28, 0, 42, "Subsubsection"],
Cell[170678, 5553, 46, 0, 31, "Text"],
Cell[170727, 5555, 120, 2, 27, "Input"],
Cell[170850, 5559, 67, 1, 27, "Input"],
Cell[170920, 5562, 106, 2, 27, "Input"],
Cell[171029, 5566, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[171131, 5572, 29, 0, 42, "Subsubsection"],
Cell[171163, 5574, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[171475, 5585, 27, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[171527, 5589, 28, 0, 42, "Subsubsection"],
Cell[171558, 5591, 108, 2, 27, "Input"],
Cell[171669, 5595, 67, 1, 27, "Input"],
Cell[171739, 5598, 106, 2, 27, "Input"],
Cell[171848, 5602, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[171950, 5608, 29, 0, 42, "Subsubsection"],
Cell[171982, 5610, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[172294, 5621, 26, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[172345, 5625, 28, 0, 42, "Subsubsection"],
Cell[172376, 5627, 51, 0, 31, "Text"],
Cell[172430, 5629, 59, 0, 31, "Text"],
Cell[172492, 5631, 1337, 27, 299, "Input"],
Cell[173832, 5660, 160, 3, 27, "Input"],
Cell[173995, 5665, 82, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[174114, 5671, 29, 0, 42, "Subsubsection"],
Cell[174146, 5673, 232, 5, 75, "Input"],
Cell[174381, 5680, 164, 3, 75, "Input"],
Cell[174548, 5685, 244, 7, 82, "Text"],
Cell[174795, 5694, 78, 1, 27, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[174922, 5701, 34, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[174981, 5705, 28, 0, 42, "Subsubsection"],
Cell[175012, 5707, 201, 4, 48, "Text"],
Cell[175216, 5713, 85, 1, 27, "Input"],
Cell[175304, 5716, 56, 1, 27, "Input"],
Cell[175363, 5719, 108, 2, 27, "Input"],
Cell[175474, 5723, 43, 0, 31, "Text"],
Cell[175520, 5725, 93, 1, 27, "Input"],
Cell[175616, 5728, 43, 0, 31, "Text"],
Cell[175662, 5730, 186, 3, 43, "Input"],
Cell[175851, 5735, 45, 0, 31, "Text"],
Cell[175899, 5737, 123, 2, 27, "Input"],
Cell[176025, 5741, 78, 1, 27, "Input"],
Cell[176106, 5744, 127, 3, 27, "Input"],
Cell[176236, 5749, 48, 0, 31, "Text"],
Cell[176287, 5751, 70, 1, 27, "Input"],
Cell[176360, 5754, 68, 1, 27, "Input"],
Cell[176431, 5757, 83, 1, 27, "Input"],
Cell[176517, 5760, 176, 3, 27, "Input"],
Cell[176696, 5765, 44, 0, 31, "Text"],
Cell[176743, 5767, 65, 1, 27, "Input"],
Cell[176811, 5770, 64, 1, 27, "Input"],
Cell[176878, 5773, 158, 2, 43, "Input"],
Cell[177039, 5777, 104, 2, 27, "Input"],
Cell[177146, 5781, 72, 1, 27, "Input"],
Cell[177221, 5784, 619, 11, 155, "Input"],
Cell[177843, 5797, 136, 3, 27, "Input"],
Cell[177982, 5802, 80, 1, 27, "Input"],
Cell[178065, 5805, 71, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[178173, 5811, 29, 0, 42, "Subsubsection"],
Cell[178205, 5813, 639, 12, 155, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[178893, 5831, 31, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[178949, 5835, 97, 3, 42, "Subsubsection"],
Cell[179049, 5840, 3152, 45, 917, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[182238, 5890, 28, 0, 42, "Subsubsection"],
Cell[182269, 5892, 1190, 20, 555, "Input",
  Evaluatable->False],
Cell[183462, 5914, 1474, 24, 555, "Input",
  Evaluatable->False],
Cell[184939, 5940, 65, 2, 27, "Input",
  Evaluatable->False],
Cell[185007, 5944, 218, 5, 43, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[185262, 5954, 28, 0, 42, "Subsubsection"],
Cell[185293, 5956, 75, 0, 31, "Text"],
Cell[185371, 5958, 155, 2, 27, "Input"],
Cell[185529, 5962, 284, 5, 65, "Text"],
Cell[185816, 5969, 1113, 19, 555, "Input"],
Cell[186932, 5990, 141, 3, 59, "Input"],
Cell[187076, 5995, 205, 4, 27, "Input"],
Cell[187284, 6001, 74, 1, 27, "Input"],
Cell[187361, 6004, 77, 1, 27, "Input"],
Cell[187441, 6007, 63, 1, 27, "Input"],
Cell[187507, 6010, 60, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[187604, 6016, 29, 0, 42, "Subsubsection"],
Cell[187636, 6018, 962, 21, 187, "Input"],
Cell[188601, 6041, 968, 21, 187, "Input"],
Cell[189572, 6064, 149, 2, 27, "Input"],
Cell[189724, 6068, 263, 6, 43, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[190036, 6080, 31, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[190092, 6084, 28, 0, 42, "Subsubsection"],
Cell[190123, 6086, 75, 0, 31, "Text"],
Cell[190201, 6088, 167, 2, 27, "Input"],
Cell[190371, 6092, 1136, 17, 555, "Input"],
Cell[191510, 6111, 141, 3, 59, "Input"],
Cell[191654, 6116, 205, 4, 27, "Input"],
Cell[191862, 6122, 74, 1, 27, "Input"],
Cell[191939, 6125, 84, 1, 27, "Input"],
Cell[192026, 6128, 63, 1, 27, "Input"],
Cell[192092, 6131, 60, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[192189, 6137, 29, 0, 42, "Subsubsection"],
Cell[192221, 6139, 147, 3, 59, "Input"],
Cell[192371, 6144, 153, 3, 59, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[192585, 6154, 79, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[192689, 6159, 110, 1, 61, "Subsection"],

Cell[CellGroupData[{
Cell[192824, 6164, 48, 0, 42, "Subsubsection"],
Cell[192875, 6166, 239, 6, 99, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[193151, 6177, 82, 3, 58, "Subsubsection"],
Cell[193236, 6182, 501, 8, 139, "Input"],
Cell[193740, 6192, 207, 4, 75, "Input"],
Cell[193950, 6198, 211, 4, 75, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[194198, 6207, 112, 3, 58, "Subsubsection"],
Cell[194313, 6212, 196, 4, 48, "Text"],
Cell[194512, 6218, 2419, 41, 667, "Input"],
Cell[196934, 6261, 567, 10, 203, "Input"],
Cell[197504, 6273, 77, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[197618, 6280, 95, 3, 58, "Subsubsection"],
Cell[197716, 6285, 1380, 23, 443, "Input"],
Cell[199099, 6310, 1345, 23, 443, "Input"],
Cell[200447, 6335, 175, 3, 43, "Input"],
Cell[200625, 6340, 559, 10, 203, "Input"],
Cell[201187, 6352, 50, 1, 27, "Input"],
Cell[201240, 6355, 78, 1, 27, "Input"],
Cell[201321, 6358, 560, 10, 203, "Input"],
Cell[201884, 6370, 52, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[201973, 6376, 97, 3, 58, "Subsubsection"],
Cell[202073, 6381, 2378, 40, 667, "Input"],
Cell[204454, 6423, 2318, 39, 667, "Input"],
Cell[206775, 6464, 189, 3, 43, "Input"],
Cell[206967, 6469, 572, 11, 203, "Input"],
Cell[207542, 6482, 50, 1, 27, "Input"],
Cell[207595, 6485, 78, 1, 27, "Input"],
Cell[207676, 6488, 573, 11, 203, "Input"],
Cell[208252, 6501, 52, 1, 27, "Input"],
Cell[208307, 6504, 80, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[208424, 6510, 93, 3, 58, "Subsubsection"],
Cell[208520, 6515, 318, 6, 91, "Input"],
Cell[208841, 6523, 560, 10, 203, "Input"],
Cell[209404, 6535, 50, 1, 27, "Input"],
Cell[209457, 6538, 75, 1, 27, "Input"],
Cell[209535, 6541, 561, 10, 203, "Input"],
Cell[210099, 6553, 52, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[210188, 6559, 31, 0, 42, "Subsubsection"],
Cell[210222, 6561, 853, 14, 235, "Input"],
Cell[211078, 6577, 196, 3, 75, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[211311, 6585, 149, 4, 74, "Subsubsection"],
Cell[211463, 6591, 101, 4, 65, "Text"],
Cell[211567, 6597, 1281, 23, 379, "Input"],
Cell[212851, 6622, 88, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[212976, 6630, 48, 0, 42, "Subsubsection"],
Cell[213027, 6632, 101, 4, 65, "Text"],
Cell[213131, 6638, 1140, 19, 331, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[214308, 6662, 154, 4, 74, "Subsubsection"],
Cell[214465, 6668, 1231, 22, 363, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[215733, 6695, 53, 0, 42, "Subsubsection"],
Cell[215789, 6697, 1171, 20, 331, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[216997, 6722, 82, 1, 42, "Subsubsection"],
Cell[217082, 6725, 1365, 24, 331, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[218484, 6754, 100, 3, 42, "Subsubsection"],
Cell[218587, 6759, 135, 3, 48, "Text"],
Cell[218725, 6764, 2057, 36, 507, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[220831, 6806, 79, 1, 61, "Subsection"],

Cell[CellGroupData[{
Cell[220935, 6811, 78, 0, 42, "Subsubsection"],
Cell[221016, 6813, 104, 3, 31, "Text"],
Cell[221123, 6818, 88, 1, 27, "Input"],
Cell[221214, 6821, 93, 3, 31, "Text"],
Cell[221310, 6826, 74, 1, 27, "Input"],
Cell[221387, 6829, 68, 1, 27, "Input"],
Cell[221458, 6832, 88, 1, 27, "Input"],
Cell[221549, 6835, 90, 1, 27, "Input"],
Cell[221642, 6838, 78, 1, 27, "Input"],
Cell[221723, 6841, 72, 1, 27, "Input"],
Cell[221798, 6844, 85, 1, 27, "Input"],
Cell[221886, 6847, 87, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[222010, 6853, 47, 0, 42, "Subsubsection"],
Cell[222060, 6855, 117, 3, 48, "Text"],
Cell[222180, 6860, 579, 17, 99, "Input"],
Cell[222762, 6879, 288, 7, 116, "Text"],
Cell[223053, 6888, 80, 1, 27, "Input"],
Cell[223136, 6891, 63, 0, 31, "Text"],
Cell[223202, 6893, 4044, 116, 639, "Input"],
Cell[227249, 7011, 2484, 78, 639, "Input"],
Cell[229736, 7091, 244, 5, 65, "Text"],
Cell[229983, 7098, 4402, 127, 693, "Input"],
Cell[234388, 7227, 4409, 127, 693, "Input"],
Cell[238800, 7356, 76, 1, 27, "Input"],
Cell[238879, 7359, 167, 4, 65, "Text"],
Cell[239049, 7365, 2166, 84, 693, "Input"],
Cell[241218, 7451, 233, 5, 82, "Text"],
Cell[241454, 7458, 2170, 84, 693, "Input"],
Cell[243627, 7544, 168, 4, 48, "Text"],
Cell[243798, 7550, 2169, 84, 693, "Input"],
Cell[245970, 7636, 104, 3, 48, "Text"],
Cell[246077, 7641, 2171, 84, 693, "Input"],
Cell[248251, 7727, 406, 8, 91, "Input"],
Cell[248660, 7737, 63, 1, 27, "Input"],
Cell[248726, 7740, 62, 1, 27, "Input"],
Cell[248791, 7743, 84, 1, 27, "Input"],
Cell[248878, 7746, 86, 1, 27, "Input"],
Cell[248967, 7749, 86, 1, 27, "Input"],
Cell[249056, 7752, 62, 1, 27, "Input"],
Cell[249121, 7755, 63, 1, 27, "Input"],
Cell[249187, 7758, 63, 1, 27, "Input"],
Cell[249253, 7761, 83, 1, 27, "Input"],
Cell[249339, 7764, 78, 1, 27, "Input"],
Cell[249420, 7767, 54, 1, 27, "Input"],
Cell[249477, 7770, 62, 1, 27, "Input"],
Cell[249542, 7773, 60, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[249639, 7779, 100, 1, 58, "Subsubsection"],
Cell[249742, 7782, 163, 5, 82, "Text"],
Cell[249908, 7789, 4408, 127, 693, "Input"],
Cell[254319, 7918, 239, 7, 116, "Text"],
Cell[254561, 7927, 2170, 84, 693, "Input"],
Cell[256734, 8013, 172, 5, 82, "Text"],
Cell[256909, 8020, 2169, 84, 693, "Input"],
Cell[259081, 8106, 110, 5, 82, "Text"],
Cell[259194, 8113, 2171, 84, 693, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[261414, 8203, 98, 3, 62, "Subsection"],
Cell[261515, 8208, 304, 8, 116, "Text"],
Cell[261822, 8218, 92, 1, 27, "Input"],
Cell[261917, 8221, 92, 1, 27, "Input"],
Cell[262012, 8224, 56, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[262105, 8230, 133, 4, 58, "Subsection"],

Cell[CellGroupData[{
Cell[262263, 8238, 45, 0, 42, "Subsubsection"],
Cell[262311, 8240, 30, 0, 31, "Text"],
Cell[262344, 8242, 82, 1, 27, "Input"],
Cell[262429, 8245, 29, 0, 31, "Text"],
Cell[262461, 8247, 113, 2, 27, "Input"],
Cell[262577, 8251, 66, 1, 27, "Input"],
Cell[262646, 8254, 88, 1, 27, "Input"],
Cell[262737, 8257, 179, 6, 99, "Text"],
Cell[262919, 8265, 320, 7, 116, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[263276, 8277, 44, 0, 42, "Subsubsection"],
Cell[263323, 8279, 119, 5, 82, "Text"],
Cell[263445, 8286, 67, 1, 27, "Input"],
Cell[263515, 8289, 286, 5, 59, "Input"],
Cell[263804, 8296, 50, 1, 27, "Input"],
Cell[263857, 8299, 290, 5, 59, "Input"],
Cell[264150, 8306, 52, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[264239, 8312, 84, 1, 42, "Subsubsection"],
Cell[264326, 8315, 734, 14, 187, "Text"],
Cell[265063, 8331, 427, 8, 75, "Input"],
Cell[265493, 8341, 283, 7, 116, "Text"],
Cell[265779, 8350, 135, 6, 99, "Text"],
Cell[265917, 8358, 67, 1, 27, "Input"],
Cell[265987, 8361, 53, 1, 27, "Input"],
Cell[266043, 8364, 571, 11, 139, "Input"],
Cell[266617, 8377, 269, 9, 150, "Text"],
Cell[266889, 8388, 567, 11, 139, "Input"],
Cell[267459, 8401, 53, 1, 27, "Input"],
Cell[267515, 8404, 104, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[267656, 8412, 38, 0, 42, "Subsubsection"],
Cell[267697, 8414, 398, 10, 150, "Text"],
Cell[268098, 8426, 190, 4, 65, "Text"],
Cell[268291, 8432, 45, 1, 27, "Input"],
Cell[268339, 8435, 54, 1, 27, "Input"],
Cell[268396, 8438, 93, 1, 27, "Input"],
Cell[268492, 8441, 116, 3, 31, "Text"],
Cell[268611, 8446, 51, 1, 27, "Input"],
Cell[268665, 8449, 562, 10, 155, "Input"],
Cell[269230, 8461, 626, 12, 139, "Input"],
Cell[269859, 8475, 54, 1, 27, "Input"],
Cell[269916, 8478, 54, 1, 27, "Input"],
Cell[269973, 8481, 54, 1, 27, "Input"],
Cell[270030, 8484, 250, 6, 65, "Text"],
Cell[270283, 8492, 315, 5, 59, "Input"],
Cell[270601, 8499, 54, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[270692, 8505, 66, 0, 42, "Subsubsection"],
Cell[270761, 8507, 53, 0, 31, "Text"],
Cell[270817, 8509, 372, 7, 107, "Input"],
Cell[271192, 8518, 376, 7, 107, "Input"],
Cell[271571, 8527, 380, 7, 107, "Input"],
Cell[271954, 8536, 58, 1, 27, "Input"],
Cell[272015, 8539, 60, 1, 27, "Input"],
Cell[272078, 8542, 96, 3, 31, "Text"],
Cell[272177, 8547, 54, 1, 27, "Input"],
Cell[272234, 8550, 93, 3, 31, "Text"],
Cell[272330, 8555, 71, 1, 27, "Input"],
Cell[272404, 8558, 50, 1, 27, "Input"],
Cell[272457, 8561, 86, 1, 27, "Input"],
Cell[272546, 8564, 190, 4, 27, "Input"],
Cell[272739, 8570, 163, 3, 43, "Input"],
Cell[272905, 8575, 70, 1, 27, "Input"],
Cell[272978, 8578, 107, 3, 31, "Text"],
Cell[273088, 8583, 70, 1, 27, "Input"],
Cell[273161, 8586, 193, 3, 75, "Input"],
Cell[273357, 8591, 206, 3, 75, "Input"],
Cell[273566, 8596, 54, 1, 27, "Input"],
Cell[273623, 8599, 52, 1, 27, "Input"],
Cell[273678, 8602, 54, 1, 27, "Input"],
Cell[273735, 8605, 87, 1, 27, "Input"],
Cell[273825, 8608, 92, 3, 31, "Text"],
Cell[273920, 8613, 164, 3, 43, "Input"],
Cell[274087, 8618, 71, 1, 27, "Input"],
Cell[274161, 8621, 72, 1, 27, "Input"],
Cell[274236, 8624, 208, 3, 75, "Input"],
Cell[274447, 8629, 54, 1, 27, "Input"],
Cell[274504, 8632, 64, 1, 27, "Input"],
Cell[274571, 8635, 66, 1, 27, "Input"],
Cell[274640, 8638, 57, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[274734, 8644, 70, 0, 42, "Subsubsection"],
Cell[274807, 8646, 26, 0, 31, "Text"],
Cell[274836, 8648, 212, 5, 82, "Text"],
Cell[275051, 8655, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[275150, 8659, 312, 7, 59, "Input",
  Evaluatable->False],
Cell[275465, 8668, 316, 7, 59, "Input",
  Evaluatable->False],
Cell[275784, 8677, 320, 7, 59, "Input",
  Evaluatable->False],
Cell[276107, 8686, 83, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[276227, 8693, 38, 0, 42, "Subsubsection"],
Cell[276268, 8695, 196, 6, 99, "Text"],
Cell[276467, 8703, 93, 1, 27, "Input"],
Cell[276563, 8706, 1160, 20, 395, "Input"],
Cell[277726, 8728, 28, 0, 31, "Text"],
Cell[277757, 8730, 106, 2, 27, "Input"],
Cell[277866, 8734, 1205, 22, 395, "Input"],
Cell[279074, 8758, 408, 10, 43, "Input"],
Cell[279485, 8770, 62, 1, 27, "Input"],
Cell[279550, 8773, 52, 1, 27, "Input"],
Cell[279605, 8776, 52, 1, 27, "Input"],
Cell[279660, 8779, 44, 1, 27, "Input"],
Cell[279707, 8782, 50, 1, 27, "Input"],
Cell[279760, 8785, 50, 1, 27, "Input"],
Cell[279813, 8788, 44, 1, 27, "Input"],
Cell[279860, 8791, 42, 1, 27, "Input"],
Cell[279905, 8794, 44, 1, 27, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[279998, 8801, 34, 0, 45, "Subsection"],
Cell[280035, 8803, 141, 5, 82, "Text"],

Cell[CellGroupData[{
Cell[280201, 8812, 49, 0, 42, "Subsubsection"],
Cell[280253, 8814, 119, 3, 31, "Text"],
Cell[280375, 8819, 51, 1, 27, "Input"],
Cell[280429, 8822, 2489, 58, 267, "Input"],
Cell[282921, 8882, 108, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[283066, 8890, 76, 0, 42, "Subsubsection"],
Cell[283145, 8892, 66, 0, 31, "Text"],
Cell[283214, 8894, 91, 1, 27, "Input"],
Cell[283308, 8897, 109, 2, 27, "Input"],
Cell[283420, 8901, 61, 0, 31, "Text"],
Cell[283484, 8903, 154, 4, 27, "Input"],
Cell[283641, 8909, 172, 4, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[283850, 8918, 70, 0, 42, "Subsubsection"],
Cell[283923, 8920, 68, 1, 27, "Input"],
Cell[283994, 8923, 54, 1, 27, "Input"],
Cell[284051, 8926, 73, 1, 27, "Input"],
Cell[284127, 8929, 67, 1, 27, "Input"],
Cell[284197, 8932, 50, 1, 27, "Input"],
Cell[284250, 8935, 53, 1, 27, "Input"],
Cell[284306, 8938, 62, 1, 27, "Input"],
Cell[284371, 8941, 53, 1, 27, "Input"],
Cell[284427, 8944, 75, 1, 27, "Input"],
Cell[284505, 8947, 67, 1, 27, "Input"],
Cell[284575, 8950, 105, 2, 43, "Input"],
Cell[284683, 8954, 102, 2, 31, "Input"],
Cell[284788, 8958, 49, 1, 27, "Input"],
Cell[284840, 8961, 89, 1, 31, "Input"],
Cell[284932, 8964, 55, 1, 27, "Input"],
Cell[284990, 8967, 63, 1, 29, "Input"],
Cell[285056, 8970, 49, 1, 27, "Input"],
Cell[285108, 8973, 57, 1, 27, "Input"],
Cell[285168, 8976, 58, 1, 29, "Input"],
Cell[285229, 8979, 44, 1, 27, "Input"],
Cell[285276, 8982, 61, 1, 29, "Input"],
Cell[285340, 8985, 44, 1, 29, "Input"],
Cell[285387, 8988, 67, 1, 29, "Input"],
Cell[285457, 8991, 61, 1, 27, "Input"],
Cell[285521, 8994, 74, 1, 29, "Input"],
Cell[285598, 8997, 464, 11, 184, "Text"],
Cell[286065, 9010, 565, 12, 153, "Text"],
Cell[286633, 9024, 612, 12, 145, "Text"],
Cell[287248, 9038, 57, 1, 27, "Input"],
Cell[287308, 9041, 1554, 28, 267, "Text"],
Cell[288865, 9071, 58, 1, 27, "Input"],
Cell[288926, 9074, 1234, 22, 295, "Text"],
Cell[290163, 9098, 58, 1, 27, "Input"],
Cell[290224, 9101, 34, 1, 27, "Input"],
Cell[290261, 9104, 1340, 27, 323, "Text"],
Cell[291604, 9133, 58, 1, 27, "Input"],
Cell[291665, 9136, 782, 13, 267, "Input"],
Cell[292450, 9151, 177, 3, 59, "Input"],
Cell[292630, 9156, 204, 4, 59, "Input"],
Cell[292837, 9162, 227, 4, 59, "Input"],
Cell[293067, 9168, 229, 4, 59, "Input"],
Cell[293299, 9174, 229, 4, 59, "Input"],
Cell[293531, 9180, 229, 4, 59, "Input"],
Cell[293763, 9186, 58, 1, 27, "Input"],
Cell[293824, 9189, 72, 0, 31, "Text"],
Cell[293899, 9191, 48, 1, 27, "Input"],
Cell[293950, 9194, 121, 2, 27, "Input"],
Cell[294074, 9198, 121, 2, 27, "Input"],
Cell[294198, 9202, 153, 3, 27, "Input"],
Cell[294354, 9207, 111, 2, 27, "Input"],
Cell[294468, 9211, 297, 6, 75, "Input"],
Cell[294768, 9219, 87, 1, 27, "Input"],
Cell[294858, 9222, 138, 2, 43, "Input"],
Cell[294999, 9226, 137, 3, 27, "Input"],
Cell[295139, 9231, 154, 3, 27, "Input"],
Cell[295296, 9236, 154, 3, 27, "Input"],
Cell[295453, 9241, 141, 3, 48, "Text"],
Cell[295597, 9246, 447, 8, 123, "Input"],
Cell[296047, 9256, 155, 4, 27, "Input"],
Cell[296205, 9262, 173, 4, 27, "Input"],
Cell[296381, 9268, 158, 4, 27, "Input"],
Cell[296542, 9274, 176, 4, 27, "Input"],
Cell[296721, 9280, 158, 4, 27, "Input"],
Cell[296882, 9286, 176, 4, 27, "Input"],
Cell[297061, 9292, 158, 4, 27, "Input"],
Cell[297222, 9298, 176, 4, 27, "Input"],
Cell[297401, 9304, 158, 4, 27, "Input"],
Cell[297562, 9310, 176, 4, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[297775, 9319, 175, 5, 56, "Subsubsection"],
Cell[297953, 9326, 615, 13, 163, "Text"],
Cell[298571, 9341, 81, 2, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[298677, 9347, 253, 5, 59, "Input",
  Evaluatable->False],
Cell[298933, 9354, 787, 19, 175, "Output"]
}, Closed]],
Cell[299735, 9376, 573, 12, 167, "Text"],
Cell[300311, 9390, 254, 6, 59, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[300602, 9401, 59, 0, 42, "Subsubsection"],
Cell[300664, 9403, 589, 11, 167, "Text"],
Cell[301256, 9416, 1353, 29, 177, "Text"],
Cell[302612, 9447, 55, 1, 27, "Input"],
Cell[302670, 9450, 341, 6, 59, "Input"],
Cell[303014, 9458, 48, 1, 27, "Input"],
Cell[303065, 9461, 89, 1, 27, "Input"],
Cell[303157, 9464, 64, 1, 27, "Input"],
Cell[303224, 9467, 76, 1, 27, "Input"],
Cell[303303, 9470, 66, 1, 27, "Input"],
Cell[303372, 9473, 108, 3, 31, "Text"],
Cell[303483, 9478, 133, 3, 27, "Input"],
Cell[303619, 9483, 48, 1, 27, "Input"],
Cell[303670, 9486, 158, 4, 27, "Input"],
Cell[303831, 9492, 48, 1, 27, "Input"],
Cell[303882, 9495, 176, 4, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[304095, 9504, 109, 3, 42, "Subsubsection"],
Cell[304207, 9509, 394, 8, 116, "Text"],
Cell[304604, 9519, 57, 1, 27, "Input"],
Cell[304664, 9522, 137, 5, 82, "Text"],
Cell[304804, 9529, 131, 3, 27, "Input"],
Cell[304938, 9534, 190, 6, 66, "Text"],
Cell[305131, 9542, 610, 13, 135, "Text"],
Cell[305744, 9557, 164, 2, 43, "Input"],
Cell[305911, 9561, 154, 5, 82, "Text"],
Cell[306068, 9568, 132, 3, 27, "Input"],
Cell[306203, 9573, 217, 5, 43, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[306457, 9583, 37, 0, 42, "Subsubsection"],
Cell[306497, 9585, 91, 1, 27, "Input"],
Cell[306591, 9588, 152, 4, 27, "Input"],
Cell[306746, 9594, 223, 6, 43, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[307006, 9605, 33, 0, 42, "Subsubsection"],
Cell[307042, 9607, 108, 2, 27, "Input"],
Cell[307153, 9611, 183, 4, 27, "Input"],
Cell[307339, 9617, 254, 6, 43, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[307630, 9628, 48, 0, 42, "Subsubsection"],
Cell[307681, 9630, 51, 1, 27, "Input"],
Cell[307735, 9633, 76, 1, 27, "Input"],
Cell[307814, 9636, 51, 1, 27, "Input"],
Cell[307868, 9639, 76, 1, 27, "Input"],
Cell[307947, 9642, 58, 0, 31, "Text"],
Cell[308008, 9644, 1108, 20, 315, "Input"],
Cell[309119, 9666, 103, 3, 31, "Text"],
Cell[309225, 9671, 379, 6, 123, "Input"],
Cell[309607, 9679, 93, 1, 27, "Input"],
Cell[309703, 9682, 35, 0, 31, "Text"],
Cell[309741, 9684, 1123, 20, 331, "Input"],
Cell[310867, 9706, 137, 3, 27, "Input"],
Cell[311007, 9711, 33, 0, 31, "Text"],
Cell[311043, 9713, 1124, 20, 331, "Input"],
Cell[312170, 9735, 139, 3, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[312346, 9743, 35, 0, 42, "Subsubsection"],
Cell[312384, 9745, 375, 6, 123, "Input"],
Cell[312762, 9753, 730, 14, 139, "Input"],
Cell[313495, 9769, 55, 0, 31, "Text"],
Cell[313553, 9771, 940, 18, 187, "Input"],
Cell[314496, 9791, 40, 1, 27, "Input"],
Cell[314539, 9794, 88, 1, 27, "Input"],
Cell[314630, 9797, 69, 4, 65, "Text"],
Cell[314702, 9803, 87, 1, 27, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[314850, 9811, 79, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[314954, 9816, 32, 0, 42, "Subsubsection"],
Cell[314989, 9818, 87, 3, 31, "Text"],
Cell[315079, 9823, 286, 5, 65, "Text"],
Cell[315368, 9830, 189, 4, 48, "Text"],
Cell[315560, 9836, 379, 6, 82, "Text"],
Cell[315942, 9844, 480, 8, 99, "Text"],
Cell[316425, 9854, 480, 8, 99, "Text"],
Cell[316908, 9864, 311, 9, 116, "Text"],
Cell[317222, 9875, 74, 0, 31, "Text"],
Cell[317299, 9877, 377, 6, 104, "Text"],
Cell[317679, 9885, 278, 7, 49, "Text"],
Cell[317960, 9894, 329, 8, 116, "Text"],
Cell[318292, 9904, 307, 9, 133, "Text"],
Cell[318602, 9915, 258, 8, 116, "Text"],
Cell[318863, 9925, 630, 13, 184, "Text"],
Cell[319496, 9940, 262, 8, 116, "Text"],
Cell[319761, 9950, 537, 14, 184, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[320335, 9969, 27, 0, 28, "Subsubsection"],
Cell[320365, 9971, 46, 1, 40, "Input"],
Cell[320414, 9974, 266, 6, 104, "Input"],
Cell[320683, 9982, 525, 8, 136, "Input"],
Cell[321211, 9992, 1486, 34, 136, "Input"],
Cell[322700, 10028, 113, 3, 31, "Text"],
Cell[322816, 10033, 80, 1, 47, "Text"],
Cell[322899, 10036, 75, 1, 40, "Input"],
Cell[322977, 10039, 526, 8, 133, "Input"],
Cell[323506, 10049, 1486, 34, 136, "Input"],
Cell[324995, 10085, 231, 4, 45, "Text"],
Cell[325229, 10091, 57, 3, 48, "Text"],
Cell[325289, 10096, 66, 0, 31, "Text"],
Cell[325358, 10098, 102, 3, 31, "Text"],
Cell[325463, 10103, 245, 5, 65, "Text"],
Cell[325711, 10110, 293, 8, 116, "Text"],
Cell[326007, 10120, 187, 4, 48, "Text"],
Cell[326197, 10126, 78, 2, 31, "Text"],
Cell[326278, 10130, 115, 2, 40, "Input"],
Cell[326396, 10134, 113, 2, 40, "Input"],
Cell[326512, 10138, 109, 3, 31, "Text"],
Cell[326624, 10143, 140, 3, 48, "Text"],
Cell[326767, 10148, 162, 3, 40, "Input"],
Cell[326932, 10153, 114, 3, 31, "Text"],
Cell[327049, 10158, 308, 6, 88, "Input"],
Cell[327360, 10166, 102, 3, 31, "Text"],
Cell[327465, 10171, 107, 2, 40, "Input"],
Cell[327575, 10175, 276, 5, 65, "Text"],
Cell[327854, 10182, 48, 1, 40, "Input"],
Cell[327905, 10185, 61, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[328003, 10191, 30, 0, 42, "Subsubsection"],
Cell[328036, 10193, 47, 1, 40, "Input"],
Cell[328086, 10196, 266, 6, 104, "Input"],
Cell[328355, 10204, 526, 8, 136, "Input"],
Cell[328884, 10214, 1488, 34, 136, "Input"],
Cell[330375, 10250, 527, 8, 136, "Input"],
Cell[330905, 10260, 1488, 34, 136, "Input"],
Cell[332396, 10296, 57, 3, 48, "Text"],
Cell[332456, 10301, 65, 0, 31, "Text"],
Cell[332524, 10303, 60, 3, 48, "Text"],
Cell[332587, 10308, 75, 0, 31, "Text"],
Cell[332665, 10310, 96, 3, 31, "Text"],
Cell[332764, 10315, 213, 4, 48, "Text"],
Cell[332980, 10321, 51, 0, 31, "Text"],
Cell[333034, 10323, 113, 3, 31, "Text"],
Cell[333150, 10328, 48, 0, 31, "Text"],
Cell[333201, 10330, 48, 1, 40, "Input"],
Cell[333252, 10333, 61, 1, 40, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[333350, 10339, 33, 0, 28, "Subsubsection"],
Cell[333386, 10341, 47, 1, 27, "Input"],
Cell[333436, 10344, 124, 2, 27, "Input"],
Cell[333563, 10348, 217, 3, 59, "Input"],
Cell[333783, 10353, 221, 3, 85, "Text"],
Cell[334007, 10358, 899, 15, 217, "Input"],
Cell[334909, 10375, 1488, 34, 123, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[336434, 10414, 49, 0, 28, "Subsubsection"],
Cell[336486, 10416, 591, 15, 252, "Text"],
Cell[337080, 10433, 38, 0, 31, "Text"],
Cell[337121, 10435, 51, 1, 27, "Input"],
Cell[337175, 10438, 144, 3, 59, "Input"],
Cell[337322, 10443, 66, 1, 27, "Input"],
Cell[337391, 10446, 150, 2, 43, "Input"],
Cell[337544, 10450, 48, 1, 27, "Input"],
Cell[337595, 10453, 61, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[337693, 10459, 69, 0, 28, "Subsubsection"],
Cell[337765, 10461, 218, 4, 65, "Text"],
Cell[337986, 10467, 514, 14, 218, "Text"],
Cell[338503, 10483, 71, 2, 27, "Input",
  Evaluatable->False],
Cell[338577, 10487, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[338655, 10491, 736, 14, 171, "Input",
  Evaluatable->False],
Cell[339394, 10507, 756, 14, 171, "Input",
  Evaluatable->False],
Cell[340153, 10523, 754, 13, 235, "Input",
  Evaluatable->False],
Cell[340910, 10538, 279, 6, 59, "Input",
  Evaluatable->False],
Cell[341192, 10546, 443, 12, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[341672, 10563, 57, 0, 28, "Subsubsection"],
Cell[341732, 10565, 105, 3, 31, "Text"],
Cell[341840, 10570, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[341917, 10574, 107, 2, 27, "Input",
  Evaluatable->False],
Cell[342027, 10578, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[342133, 10582, 130, 3, 27, "Input",
  Evaluatable->False],
Cell[342266, 10587, 110, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[342413, 10594, 42, 0, 28, "Subsubsection"],
Cell[342458, 10596, 301, 9, 150, "Text"],
Cell[342762, 10607, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[342861, 10611, 89, 3, 31, "Text"],
Cell[342953, 10616, 136, 3, 27, "Input",
  Evaluatable->False],
Cell[343092, 10621, 38, 1, 27, "Input"],
Cell[343133, 10624, 99, 2, 27, "Input",
  Evaluatable->False],
Cell[343235, 10628, 136, 3, 27, "Input",
  Evaluatable->False],
Cell[343374, 10633, 46, 1, 27, "Input"],
Cell[343423, 10636, 646, 12, 107, "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[344130, 10655, 30, 0, 42, "Subsubtitle"],

Cell[CellGroupData[{
Cell[344185, 10659, 73, 0, 45, "Subsection"],
Cell[344261, 10661, 88, 3, 31, "Text"],
Cell[344352, 10666, 129, 4, 27, "Input",
  Evaluatable->False],
Cell[344484, 10672, 57, 0, 31, "Text"],
Cell[344544, 10674, 172, 4, 27, "Input",
  Evaluatable->False],
Cell[344719, 10680, 47, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[344791, 10684, 226, 5, 91, "Input",
  Evaluatable->False],
Cell[345020, 10691, 132, 3, 27, "Output"]
}, Closed]],
Cell[345167, 10697, 329, 7, 91, "Input",
  Evaluatable->False],
Cell[345499, 10706, 2131, 38, 571, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[347655, 10748, 124, 3, 27, "Input",
  Evaluatable->False],
Cell[347782, 10753, 132, 3, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[347951, 10761, 285, 6, 139, "Input",
  Evaluatable->False],
Cell[348239, 10769, 132, 3, 27, "Output"]
}, Closed]],
Cell[348386, 10775, 87, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[348510, 10782, 102, 3, 45, "Subsection"],
Cell[348615, 10787, 102, 3, 48, "Text"],
Cell[348720, 10792, 744, 15, 218, "Text"],
Cell[349467, 10809, 97, 2, 27, "Input",
  Evaluatable->False],
Cell[349567, 10813, 522, 9, 91, "Input",
  Evaluatable->False],
Cell[350092, 10824, 524, 9, 91, "Input",
  Evaluatable->False],
Cell[350619, 10835, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[350718, 10839, 184, 4, 27, "Input",
  Evaluatable->False],
Cell[350905, 10845, 215, 5, 27, "Input",
  Evaluatable->False],
Cell[351123, 10852, 211, 5, 27, "Input",
  Evaluatable->False],
Cell[351337, 10859, 174, 4, 27, "Input",
  Evaluatable->False],
Cell[351514, 10865, 214, 5, 27, "Input",
  Evaluatable->False],
Cell[351731, 10872, 210, 5, 27, "Input",
  Evaluatable->False],
Cell[351944, 10879, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[352017, 10883, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[352090, 10887, 325, 8, 91, "Input",
  Evaluatable->False],
Cell[352418, 10897, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[352491, 10901, 71, 2, 27, "Input",
  Evaluatable->False],
Cell[352565, 10905, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[352664, 10909, 55, 0, 31, "Text"],
Cell[352722, 10911, 275, 6, 59, "Input",
  Evaluatable->False],
Cell[353000, 10919, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[353085, 10923, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[353190, 10927, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[353325, 10932, 281, 6, 59, "Input",
  Evaluatable->False],
Cell[353609, 10940, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[353694, 10944, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[353799, 10948, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[353934, 10953, 295, 6, 59, "Input",
  Evaluatable->False],
Cell[354232, 10961, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[354317, 10965, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[354422, 10969, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[354557, 10974, 55, 0, 31, "Text"],
Cell[354615, 10976, 275, 6, 59, "Input",
  Evaluatable->False],
Cell[354893, 10984, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[354978, 10988, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[355083, 10992, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[355218, 10997, 281, 6, 59, "Input",
  Evaluatable->False],
Cell[355502, 11005, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[355587, 11009, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[355692, 11013, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[355827, 11018, 483, 10, 107, "Input",
  Evaluatable->False],
Cell[356313, 11030, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[356398, 11034, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[356503, 11038, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[356638, 11043, 247, 6, 59, "Input",
  Evaluatable->False],
Cell[356888, 11051, 387, 8, 91, "Input",
  Evaluatable->False],
Cell[357278, 11061, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[357348, 11065, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[357426, 11069, 468, 10, 107, "Input",
  Evaluatable->False],
Cell[357897, 11081, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[357996, 11085, 126, 3, 27, "Input",
  Evaluatable->False],
Cell[358125, 11090, 474, 10, 107, "Input",
  Evaluatable->False],
Cell[358602, 11102, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[358701, 11106, 126, 3, 27, "Input",
  Evaluatable->False],
Cell[358830, 11111, 488, 10, 107, "Input",
  Evaluatable->False],
Cell[359321, 11123, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[359420, 11127, 126, 3, 27, "Input",
  Evaluatable->False],
Cell[359549, 11132, 254, 6, 59, "Input",
  Evaluatable->False],
Cell[359806, 11140, 67, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[359910, 11147, 34, 0, 45, "Subsection"],
Cell[359947, 11149, 672, 24, 388, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[360656, 11178, 34, 0, 45, "Subsection"],
Cell[360693, 11180, 601, 24, 405, "Text"],
Cell[361297, 11206, 130, 3, 27, "Output"],
Cell[361430, 11211, 132, 3, 27, "Output"],
Cell[361565, 11216, 42, 1, 27, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[361656, 11223, 34, 0, 42, "Subsubtitle"],
Cell[361693, 11225, 71, 2, 27, "Input",
  InitializationCell->True],
Cell[361767, 11229, 78, 2, 27, "Input",
  InitializationCell->True]
}, Closed]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

