(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   1540729,      43141]*)
(*NotebookOutlinePosition[   1542372,      43196]*)
(*  CellTagsIndexPosition[   1542296,      43190]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["\<\
NOTE: to edit and evaluate after full run evaluate BEGIN PACKAGE \
and END PACKAGE when done.  alternatively, remove these before evaluating \
full run.  (they keep Global` cleaner and safer).  the blue areas are of \
interest when editing, look for blue\
\>", "Text"],

Cell[CellGroupData[{

Cell["Discussion and Forward", "Subsubsection"],

Cell["\<\
The (see HELP SECTION).  It has a layout of functions and their \
general use.\
\>", "Text",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell["\<\
Look for Cyan shaded cells they are there to point out areas of \
interest if changing or re-making charts.\
\>", "Text",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell["There are further discussions in some sub-sections.", "Text",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell["Forward", "Text"],

Cell["\<\
The most important thing about the chart is it's Layout.  It can be \
printed small and still be very readable.  (also it can pull data, format it, \
and place it in the chart and change chart layout).  Most periodic charts \
(online) are not well enough layed out to be shrunk or enlarged much and \
still have \"realistic layout\".   For instance: a poorly made chart if \
enlarge greatly would take up far more paper than necessary and have \
dis-proportionately wide spaces when enlarged , but if printed small (ie in \
book) have areas impossible to read.  It's more than a matter of scalable \
font its their relativity to one another (which a book needs certainly - but \
also an image with will be zoomed in and out).\
\>", "Text"],

Cell["\<\
There are many things that are made that aren't in final chart, \
such as dictionary text.\
\>", "Text"],

Cell["\<\
The over-all method takes some efforts that are un-necessary which \
wasn't of course known until later.
\tie, showfe[] was made to made to make 3D models of fill order of electons
\t     easy to dipict in 3D ball and stick models: but they are never made
\tie, {s,p,d,f} is used to build arrays but are then corrected.  had I known \
that there
\t      are no equations on earth able to describe the table easily - i'd \
likely have
\t      just entered the whole table by hand (a full simulation was never a \
goal
\t      hoped for with little notebook anyway)\
\>", "Text"],

Cell["\<\
2D and 3D were done incase I got painted into a corner with one or \
the other: turns out both worked fine.\
\>", "Text"],

Cell["\<\
Layout is by specific placement (ie, item offset from center of \
element).  This is a pain in one way and complete freedom in another (ie, one \
is never frustrated by surprise alignments or dis-allowed placement or \
connectivity unwanted or which grid text box restrictions: nor with the \
programming and typing for that).  I'm neither happy with a position matrix \
or without it.  Simply using positions works.\
\>", "Text"],

Cell["\<\
Text is not in 3D fully.  If the whole chart object (or view \
angle?) is rotated the text will face the camera (this is the mathematica \
default and is not yet avoided).\
\>", "Text"],

Cell["\<\
Dictionary entries (not in chart) are a re-format of Jay Kominek's \
<jkominek@miranda.org> compilation of physical and chemical data about the \
element (Debian package dict-elements)\
\>", "Text"],

Cell[TextData[{
  "chem.m is ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " 4.0's chem.m with added data and added ability to print data's errata"
}], "Text"],

Cell[TextData[{
  "In hindsight, 2D formatting and output given table data here would be \
easier and far more efficent using gs(1) or pic(1) language.  But if done no \
further manipulation in ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " would be efficient, except as ps graphic."
}], "Text"],

Cell[TextData[{
  "If you are young or a student.  This notebook was made during forced \
downtime.  ",
  StyleBox["Otherwise it I wouldn't have had the time to do a thing like \
this.",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  "  The lack of \"saleability\" is quite intended (I had legal problems \
don't ask).  This was intended not to be a hot items for particular others \
steal.  But please enjoy if you like these kinds of things :)  I'd rather not \
have release all of jutils` maybe, yet I need work posted and selling work is \
about impossible these days anyhow (a problem for all engineers and coders), \
so oh well.  Note i'm not only not paid and given no charity but illegally \
billed during the production, unlike many other software productions: a big \
difference.  I don't want to promote the idea work like this un-paid is a \
good idea.  It was not that way and not done so."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
errata and or notebook re-eval things
\tTODO - DICT and chem.m  unstable isotope disagree terribly !\
\>", \
"Subsubsection"],

Cell[TextData[{
  "FIXME or not:  launch ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " from this directory or activate this so that charts are printed to here \
(or both...)"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\(SetDirectory["\<~/PeriodicTableOfElements\>"]\)\)\)], "Input"],

Cell[BoxData[
    \("/home/jdh/PeriodicTableOfElements"\)], "Output"]
}, Closed]],

Cell["\<\
FIXME or not:  prefer
\t\"Kernel -> Delete All Output\" then
\t\"Kernel -> Evaluate Notebook\" for a fresh start\
\>", "Text"],

Cell[TextData[{
  "FIXME:\n\tgraphics area has memory climb for \"re-evaluating\" (like % %% \
stored)\n\tif software is not %100 you'll get a desktop freeze\n\t\t",
  Cell[BoxData[
      \(MemoryInUse[]\)], "Input"],
  "\n\t\t",
  Cell[BoxData[
      \(9797504\)], "Output"],
  "\n\t\t",
  Cell[BoxData[
      \(\(\(100901372\)\(\ \)\)\)], "Input"]
}], "Text"],

Cell[BoxData[
    \(\(Unprotect[In, Out];\)\)], "Input"],

Cell[BoxData[
    \(\(Clear[In, Out];\)\)], "Input"],

Cell[BoxData[
    \(\(Protect[In, Out];\)\)], "Input"],

Cell[BoxData[
    \(\($HistoryLength = 5;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MemoryInUse[]\)], "Input"],

Cell[BoxData[
    \(4227992\)], "Output"]
}, Closed]],

Cell[TextData[{
  "(*\n NOTE:\n\tbe careful with Remove[] only use it if var will redefined \
immediately after\n\tor \"is certain to be reset before any use and isn't \
used anywhere else above\"\n\tex.  if a function has var name in it and \
that's Removed the function\n\t       becomes unusable until the fuction is \
re-defined\n\t       ( ! if evaluating  notebook it won't be ! )\n\nFIXME:  \
do NOT remove or assign m2 function.  might cause mathematica to quit if one \
clobbers it , reloads chem.m again , and keeps trying to \"find it\".  \
(below, mess={} , get Element value , m2 == message : again never assign to \
m2 though.)\n\nATOMIC DATA BUGS:\n\t* ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s AtomicRadius doesn't say which CRC chart it's from which\n\t   is very \
important.  Not presentable without that.  CRC 52nd istoo incomplete.\n\t   \
Gets into crystalline structure and quickly varies widely yet sometimes\n\t   \
deceivingly close but not close enough depending on question.\n\t   Use \
Angstrom , volume , density , weight is just as well without key.\n\t   \tie, \
Ar Francium is -2.7  ... negative radius ? from what expected ?\n\t* \
ElectronAffinity doesn't show <0 or >0 and these don't follow trends.\n\t   \
however EA is sporadic and somewhat incomplete and unless chart is\n\t   \
electro centric FIP and EN are more common choices.\n\nTODO  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " says this has no stable isotope but dict says ...\n\n\
ElementDescription[Technetium] ^= \"Radioactive metallic transition element. \
Can\nbe detected in some stars and the fission products of uranium. First \
made by Per\nrier and Segre by bombarding molybdenum with deutrons, giving \
them Tc-97. Tc-99\nis the most stable isotope with a half-life of 2.6*10^6 \
years. Sixteen isotopes\nare known. Organic technetium compounds are used in \
bone imaging. Chemical prope\nrties are intermediate between rhenium and \
manganese. \"\n\n*)"
}], "Text"],

Cell["RunToBoundryCell", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["HELP SECTION for tables, funs, vars (up to chart gen sec)", "Subsection"],

Cell[CellGroupData[{

Cell["setup mess, efun, ...", "Subsubsection"],

Cell[BoxData[GridBox[{
        {"mess", \(allows\ messages\ to\ be\ captured\ as\ text\)},
        {"efuns", \(list\ of\ functions, \ ie, \ SpecificHeat\)},
        {"efunsab", \(abbreviations\ of\ efuns\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["charts / tables", "Subsubsection"],

Cell[BoxData[GridBox[{
        {\(elec\ \(\(conf\)\(.\)\)\), \(2\ very\ simple\ Tables\)},
        {"VerboseElement", \(uses\ efuns[i]\ for\ verbosity\)},
        {"Dict", \(tab : \ elem . \ dict\ entries\)},
        {"Key", \(tab : \ efun\ abbreviations\ /\ names\)},
        {"FullElement", \(tab : \ \(\(elem\ data\)\(\ \)\(+\)\(\ \)\)\)},
        {"ElementData", \(tab : \ just\ elem . \ data\)},
        {"ColumnChart", \(tab : \ abbrev\  + \ data\[IndentingNewLine]
          \((typical\ periodic\ cell)\)\n
          with\ use\ of\ fNBookForm2\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["data - static / manual arrays", "Subsubsection"],

Cell["\<\
e[] returns a List of 1's showing electron place in shell, \
subshell, orbit and pairing *\
\>", "Text"],

Cell["\<\
It's important to note that there is important difference between \
\"natural order\" and \"fill order\" **\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"data", \(see : \ data - static/manual\ arrays\n
          that\ section\ \((better\ viewed)\)\[IndentingNewLine]
          associated\ data\ describing\ fe[]\ and\ e[]\)},
        {\(e[]\), \(returns\ full\ array\ \((An\ 110)\)\ of\ \
\[IndentingNewLine]
          
          elec . \ conf . \ , \ \ 1' 
            s\ format\ , \[IndentingNewLine]by\ increasing\ value\ order\
\[IndentingNewLine]
          \((\(\(...\)\(\ \)\(3\)  \(p\)\(\ \)\(4\)  \(s\)\(\ \)\(4\)  \
\(p\)\)\  ... )\)\)},
        {\(fe[]\), \(fill\ order\ elec . \ 
              conf . \[IndentingNewLine]format\ is\ order\ being\ filled\
\[IndentingNewLine]
          
          each\ 1\ represents\ 1\ elec . \[IndentingNewLine]use\ f\ funs\ or\ \
data\ with\ fe[]\)},
        {\(nord, \ fcord\), \(MISNOMER : \ ord\ should\ be\ subshell\n
          \t\((18\ subshells\ for\ elem\ 112)\)\n
          \tnsubshell, \ fnsubshell\n
          \tcsubshell, \ fcsubshell\n
          various\ data\ associated\ with\n
          using\ or\ making\ e[], \ ie, \ {s, p, d, f}\n
          n\ \((numberic)\)\ c \((by\ character)\)\)},
        {\(ge[]\ gfe[]\), \(unused\ /\ unsupported\)},
        {"gxord", \(grouped\ 1' s\  - \ not\ used\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}],

Cell["\<\
* 1's lists are first more lengthy to make but easier to print or \
show (see elecfmt[e_]).  Note there's no quick easy way to calculate the \
info: see note \"investigating  \[Rho]subshells\" last in this section.\
\>", \
"Text"],

Cell[TextData[{
  "**\tseen on periodic:  4 ",
  Cell[BoxData[
      \(TraditionalForm\`f\^14\)]],
  " 5 ",
  Cell[BoxData[
      \(TraditionalForm\`d\^10\)]],
  " 6 ",
  Cell[BoxData[
      \(TraditionalForm\`s\^2\)]],
  " \n\tfills in this order: 6 ",
  Cell[BoxData[
      \(TraditionalForm\`s\^2\)]],
  "  ",
  Cell[BoxData[
      \(TraditionalForm\`f\^14\)]],
  " 5 ",
  Cell[BoxData[
      \(TraditionalForm\`d\^10\)]],
  "\nWhile outer-most electrons are ",
  StyleBox["most",
    FontSlant->"Italic"],
  " important",
  " ",
  "to bonding (6s2) , the \"quantum character\" of bonds (ie, why we see ",
  Cell[BoxData[
      \(TraditionalForm\`H\_2\)]],
  "but never ",
  Cell[BoxData[
      \(TraditionalForm\`He\_2\)]],
  " and also the columns of a periodic chart show ",
  StyleBox["fill order",
    FontSlant->"Italic"],
  ".  A good chart show depict both outer-most and fill-order electron \
configuration succinctly, for quick reference."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["funs - variety of utility funs", "Subsubsection"],

Cell["\<\
note : some may not work after \"irregularities\" are \"fixed\" \
(see irr. below)\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"ecnt", \(total\ electrons\ seen\ in\[IndentingNewLine]
          all\ subshells\ 1 - n\ \ so\ far\[IndentingNewLine]
          ie, \ \(2\ 4\ 10\  ... \)\ 112\)},
        {\(height[e]\), \(for\ some\ e_\)},
        {\(width[e]\), "ditto"},
        {\(subheight[e]\), \(2  nd\ dim\ heights\)},
        {\(subwidth[e]\), "ditto"},
        {\(shells[an | An]\), \(outermost\ shell\ for\ elem\)},
        {"shellsarr", \(array\ of\ shells\ for\ all\ elem\)},
        {\(inord[e_, 
            n_]\), \(counts\ of\ e\ in\ a\ shell\ should\ be\ \
\[IndentingNewLine]
          for\ any\ obj\ only\ \((for\ ford\ only)\)\)},
        {\(finord[fe_, n_]\), "ditto"},
        {\(ordnum[n_]\), \(position\ in\ fcord\ or\ fcord\[IndentingNewLine]
          being\ filled\ ; \ which\ is\[IndentingNewLine]
          the\ nth\ s, p, d\ or\ f\)},
        {\(fordnum[n_]\), "ditto"},
        {\(ford2ord[e_]\), \(covert\ ford \[Rule] ord\[IndentingNewLine]
          fe[]\  \[Rule] \ e[]\)},
        {\(ord2ford[e_]\), "ditto"}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["create elements elec. tables 1's format", "Subsubsection"],

Cell["\<\
creates each element's electron array by starting full (last \
element) and removing electrons one at a time.  why is: it works reguarless \
of structure / grouping style.\
\>", "Text"],

Cell["\<\
note : only need to make these 1x  (can store and load table after \
making 1x).  note: see correction below.\
\>", "Text"],

Cell[BoxData[GridBox[{
        {\(laste[e_]\), \(position\ of\ last\ 1\ in\ any\ \((f)\) e[]\)},
        {\(takee[e_]\), \(take\ off\ last\ 1\)},
        {\(takee[e_, n_]\), \(take\ off\ last\ n\ 1' s\)},
        {"elements", \(all\ chem\ elem, \ 
          1' s\ format, \[IndentingNewLine]irregulars\ not\ yet\ \
corrected\)},
        {"felements", "ditto"}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}],

Cell["\<\
  these would maybe be better created manually ... but oh well , \
done now.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["correct the \"irregularities\"", "Subsubsection"],

Cell["\<\
will take e here, add e there.  the general fill rule needs several \
corrections applied (quantum physics provides corrections important to use in \
chemistry).  works only for fe[] but does get applied to elements \
automatically.\
\>", "Text"],

Cell["\<\
note : only need to make these 1x but it's setup to work on demand \
too\
\>", "Text"],

Cell[BoxData[GridBox[{
        {\(rnullpat[e_]\), \(helper\ for\ correct\)},
        {\(correct[e_]\), \(removes\ a\ style\ of\ irregularity\n
          \((take\ 1\ e\ from\ last\ add\ to\ next)\)\)},
        {\(correct2[e_]\), \(see\ table\ in\ code\ \(\(descr\)\(.\)\)\)},
        {\(rcorrect[e_]\), "\[Placeholder]"},
        {\(rcorrect2[e_]\), "\[Placeholder]"},
        {\(correctlistb[An_, f]\), \(given\ Atomic\ Number\[IndentingNewLine]
          applies\ fix\ to\ \ both\[IndentingNewLine]
          elements\ and\ felements\)},
        {\(--\(--\(---\)\)\), \(--\(--\(---\)\)\)},
        {\(correctlist[
            An_\ list]\), \(these\ apply\ changes\[IndentingNewLine]
          
          to\ a\ list\ of\ names, \[IndentingNewLine]assinging\ results\ back\
\[IndentingNewLine]
          in\ elements\ and\ felements\)},
        {"correctlist2", "rcorrectlist"},
        {"rcorrectlist2", "correctlist2x"},
        {"correctlist2x2", "correctlist"},
        {\(--\(--\(---\)\)\), \(--\(--\(----\)\)\)},
        {"correct2x2", \(special\ use\ to\ correct\[IndentingNewLine]
          a\ single\ elem . \ e_\)},
        {"correct2x", "\[Placeholder]"},
        {"correctarr", \(Atomic\ Symbol\ data\[IndentingNewLine]
          for\ correction\)},
        {\(correction[An_]\), \(show\ which\ correct\ fun\[IndentingNewLine]
          to\ apply\)},
        {\(correction[e_, 
            An_]\), \(given\ elem\ and\ atomic\ num\[IndentingNewLine]
          return\ the\ same\ corrected\[IndentingNewLine]
          \((uses\ table\ to\ apply\ right\ fix)\)\)},
        {\(--\(--\(--\(----\)\)\)\), \(--\(--\(--\(--\(----\)\)\)\)\)},
        {\(debug\ left - \(\(overs\)\(:\)\)\), "\[Placeholder]"},
        {\(showfe[An_]\), \(pretty\ print\[IndentingNewLine]
          felements\ given\ atomic\ symbol\)},
        {\(showfe[e_]\), \(pretty\ print\[IndentingNewLine]
          fe_\ \((drop\ f\ for\ e)\)\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["elecfmtv - printing electron conf. from arrays", "Subsubsection"],

Cell[TextData[{
  "like ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s ElectronConfiguration(Format) but output is simpler for use with \
printing (to pick out last two, typical use in charts, simplicity is \
preffered)"
}], "Text"],

Cell[BoxData[GridBox[{
        {\(elecfmtv[
            Symbol | 
              list]\), \(product\ simple\ text\ array\[IndentingNewLine]
          {shell\ , \ subhell, \ count\ in}\n
          {{1, s, 2},  ... }\n
          per\ shell\)},
        {\(elecfmt[e_]\), \(product\ simple\ text\ strings\n
          {1*s^2, \ 2*s^2,  ... }\n
          per\ shell\)},
        {\(elecfmtm[e_]\), \(product\ array\ of\ strings\n
          the\ 2  D\ text\ boxing\ is\ Mathematica\n
          specific\ and\ works\ in\ plots\)},
        {\(elecfmtpm[e_]\), \(ditto\ but\ one\ long\ string\)},
        {\(elecfmtb[e_]\), \(produces\ text\ for\ normal\ 2  D\ boxing\n
          elecfmtb[Aluminum] // DisplayForm\n
          apply\ DisplayForm\ so\ front - end\n
          knows\ to\ render\ it\ as\ 2  D\ text\)},
        {\(elecfmtpb[e_]\), \(ditto\ but\ one\ long\ string\)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}]
}, Closed]],

Cell[CellGroupData[{

Cell["funs - Chart generation", "Subsubsection"],

Cell["See notes in that section - this is not complete...", "Text"],

Cell["\<\
Finally !  create a Spark like period chart from the above.  These \
charts contain allot of data packed visually for quick reference.\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"per", \(base\ table\ , \ \(\(abbrev\)\(.\)\)\ , \
\[IndentingNewLine]each\ row\ is\ a\ shell\)},
        {"ch2", \(base\ of\ chart, \ per\ in\ bocked\ format\)},
        {"ch2b", \(is\ an\ nxm\ array\ of\ element\ text\ that\ has\n
          
          positional\ nxm\ format\ of\ typical\ table\ of\ elem . \n
              but\ lanthenide\ series\ left\ in\ place\ for\ work\)},
        {"trials", \(ignore\ this\  - \ graphics\ tests\)},
        {"setup", \(makes\ ch2b\)},
        {\(Chart\ Generation\), \(\(see\ code\  ... \)\ this\ is\ not\ \
complete ... \)}
        }]], "Text",
  AutoIndent->False,
  TextAlignment->Left,
  TextJustification->0,
  Hyphenation->False,
  GridBoxOptions->{ColumnSpacings->2,
  ColumnAlignments->{Left},
  GridFrame->True,
  RowLines->True,
  ColumnLines->True,
  RowMinHeight->2}],

Cell["\<\
La / Ac series not yet removed - these should be abled to be \
snapped out later after more info is added.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
scratch -  investigating  \[Rho]subshells  ,  n s < (n-2) f < (n-1) \
d < n p\
\>", "Subsubsection"],

Cell[TextData[{
  "Shows the obvious, that weights for s,p,d,f can be used in equation, and \
what weights.  However it isn't used - the sequence is easier entered \
manually.\n\nNote the generic fill rule is a simple and BROKEN one : several \
corrections need be applied !  In general to pre-calculate orbits correctly \
is a large part of quantum physics (not even a complicated equation places \
all orbits correctly , unless tweeked to do so) and to calculate overlaps or \
sharing between such electron fields is about the rest of it !\n\nFinal note: \
see unfinished xxx[e_] which is a (broken) elecfmtv1[e_] to see why using ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s plain ElectronConfig (which is incomplete natural order array) to print \
fill ordering is allot more a pain than one would guess."
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["need packages", "Subsection"],

Cell[BoxData[
    \(\(Needs["\<Miscellaneous`Units`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Miscellaneous`ChemicalElements`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Miscellaneous`PhysicalConstants`\>"];\)\)], "Input"],

Cell["Needs[\"Miscellaneous`ResonanceAbsorptionLines`\"];", "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Graphics`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Legend`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Graphics3D`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Shapes`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`MultipleListPlot`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Geometry`Rotations`\>"];\)\)], "Input"],

Cell["Needs[\"Geometry`Polytopes`\"];", "Input"],

Cell["Needs[\"Graphics`Arrow`\"];", "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Polyhedra`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<Graphics`Spline`\>"];\)\)], "Input"],

Cell["local needs", "Text"],

Cell[BoxData[
    \(\(Needs["\<jutils`\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(Needs["\<fNBookForm2`\>"];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["BEGIN PACKAGE", "Section",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
NOTE: to edit either evaluate these two (end END PACKAGE far below) \
or remove these sections and run as notebook ...\
\>", "Text"],

Cell["\<\
use of package here is for keeping Global` cleaner.  you can remove \
Begins and Ends and eval. notebook if you don't care about this. (not for \
making a .m per say)\
\>", "Text"],

Cell[BoxData[
    \(\(BeginPackage["\<PeriodicTableOfElements`\>", {"\<Miscellaneous`Units`\
\>", "\<Miscellaneous`ChemicalElements`\>", \
"\<Miscellaneous`ResonanceAbsorptionLines`\>", "\<Graphics`Graphics`\>", \
"\<Graphics`Legend`\>", "\<Graphics`Graphics3D`\>", "\<Graphics`Shapes`\>", "\
\<Graphics`MultipleListPlot`\>", "\<Geometry`Rotations`\>", \
"\<Geometry`Polytopes`\>", "\<Graphics`Arrow`\>", "\<Graphics`Polyhedra`\>", \
"\<Graphics`Spline`\>", "\<jutils`\>", "\<fNBookForm2`\>"}];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(Begin["\<`Private`\>"];\)\)], "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["helper funs for tables / charts with chem data", "Section"],

Cell[CellGroupData[{

Cell["Basic Setup", "Subsection"],

Cell[CellGroupData[{

Cell["to fundamental test", "Subsubsection"],

Cell[BoxData[
    \(ToFund[x_] := 
      x //. Miscellaneous`Units`Private`$ToFundamental\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToFund[Newton]\)], "Input"],

Cell[BoxData[
    \(\(Miscellaneous`SIUnits`Kilogram\ Miscellaneous`SIUnits`Meter\)\/Second\
\^2\)], "Output"],

Cell[BoxData[
    \(\(Kilogram\ Meter\)\/Second\^2\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell["note to check , ie implications of $ToIntermediate", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["making messages work , mess", "Subsubsection"],

Cell[BoxData[
    \(Remove[ff, m, p1, p2, p3, mess, mm, fff]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(m = "\<Melting point is for the `2` form of `1`.\>";\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ff[m_, p1_: "\<\>", p2_: "\<\>", p3_: "\<\>"] := 
      StringReplacePart[m, {p1, p2, p3}, 
        StringPosition[m, {"\<`1`\>", "\<`2`\>", "\<`3`\>"}]]\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(ff["\<Melting point is for the `2` form of `1` dang `3`.\>", \
"\<wack\>", "\<wackonium\>", "\<wack3\>"]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \("Melting point is for the wack form of wackonium dang wack3."\)], \
"Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ff["\<Melting point is for the `2` form of `1` dang `3`.\>", \
"\<wack\>", "\<wackonium\>"]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \("Melting point is for the wack form of wackonium dang ."\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(?Miscellaneous`ChemicalElements`Private`M2\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \("Miscellaneous`ChemicalElements`Private`M2"\)], "Print",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell[BoxData[
    \(<< "\<~/PeriodicTableOfElements/chem.m\>"\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(mess = {};\)\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(Density[Hydrogen]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(76.`\ Kilogram\)\/Meter\^3\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Miscellaneous`ChemicalElements`Private`mess\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \({"Density is for Hydrogen at 11 Kelvin."}\)], "Output",
  GeneratedCell->False,
  CellAutoOverwrite->False]
}, Closed]],

Cell[BoxData[
    \(Remove[ff, m, p1, p2, p3, mess, mm, fff]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["INITIAL  CHEM.M  SETUP  (mess, efun, powers, ...)", "Subsubsection"],

Cell["\<\
mess={};

M2[m_, p1_:\"\"] := AppendTo[mess,StringReplacePart[m, {ToString[p1]}, \
StringPosit
ion[m, {\"`1`\"}]]]

M2[m_, p1_:\"\", p2_:\"\"] := AppendTo[mess,StringReplacePart[m, \
{ToString[p1], ToSt
ring[p2]}, StringPosition[m, {\"`1`\", \"`2`\"}]]]

M2[m_, p1_:\"\", p2_:\"\", p3_:\"\"] := AppendTo[mess,StringReplacePart[m, \
{ToString[p
1], ToString[p2], ToString[p3]}, StringPosition[m, {\"`1`\", \"`2`\", \
\"`3`\"}]]]\
\>", "Text"],

Cell["don't forget ", "Text"],

Cell[BoxData[
    \(<< "\<~/PeriodicTableOfElements/chem.m\>"\)], "Input"],

Cell[BoxData[
    \(\(\( (*\ 
      don' t\ forget\ to\ reset\ to\ {}\ between\ uses\ *) \)\(\
\[IndentingNewLine]\)\(mess = 
        Miscellaneous`ChemicalElements`Private`mess;\)\)\)], "Input"],

Cell[BoxData[{
    \( (*\ Elements >> 
        elem . mx\ and\ see\ elem . 
            sh\ *) \[IndentingNewLine]\(<< \ \
"\<~/PeriodicTableOfElements/elem-dsc.mx\>";\)\), "\[IndentingNewLine]", 
    \(\(SetAttributes[ElementDescription, Listable];\)\)}], "Input"],

Cell[BoxData[
    \(\(Miscellaneous`ChemicalElements`Private`mess = {};\)\)], "Input"],

Cell[BoxData[
    \(\(m2 := Miscellaneous`ChemicalElements`Private`mess;\)\)], "Input"],

Cell[BoxData[
    \(\(efuns = {Abbreviation, AtomicNumber, AtomicWeight, StableIsotopes, 
          MeltingPoint, BoilingPoint, HeatOfFusion, HeatOfVaporization, 
          Density, ThermalConductivity, IonizationPotential, SpecificHeat, 
          SolarSystemAbundance, EarthCrustAbundance, EarthOceanAbundance, 
          OxidationStates, ElectronNegativity, ElectronAffinity, 
          AtomicRadius, ElectronConfiguration, 
          ElectronConfigurationFormat};\)\)], "Input"],

Cell[BoxData[
    \(\(efunsab = {"\<Ab\>", "\<AN\>", \*"\"\<\!\(m\_A\)\>\"", "\<SI\>", \
\*"\"\<\!\(T\_M\)\>\"", \*"\"\<\!\(T\_B\)\>\"", \*"\"\<\!\(L\_f\)\>\"", \*"\"\
\<\!\(L\_v\)\>\""\ , "\<\[Rho]\>", "\<Q\[Sigma]\>", "\<FIP\>", \
\*"\"\<\!\(Q\_c\)\>\"", "\<SsA\>", "\<EcA\>", "\<EoA\>", "\<OS\>", "\<EN\>", \
"\<EA\>", "\<AR\>", "\<EC\>", "\<ECF\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(efunsab = {"\<Ab \>", "\<AN \>", "\<AW \>", "\<SI \>", "\<Tm \>", \
"\<Tb \>", "\<Lf \>", "\<Lv \>"\ , "\<p  \>", "\<Qs \>", "\<FIP\>", "\<Qc \
\>", "\<SsA\>", "\<EcA\>", "\<EoA\>", "\<OS \>", "\<EN \>", "\<EA \>", "\<AR \
\>", "\<EC \>", "\<ECF\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(ELEMENTS = Length[Elements];\)\)], "Input"],

Cell[TextData[{
  "* note font aligning is highly comples so all abbrev get \"same shape\" \
and no subscripts - this also allows much more compact chart.  Also while ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " can do \[Rho] ghostview won't unless \"extra efforts\" are made, so \"p\" \
is used"
}], "Text"],

Cell["\<\
* note chart borrows abbrev eC eCF to mean \"shell order\" and \
\"fill order\"\
\>", "Text"],

Cell[BoxData[
    \(\(efunsunits = {1, 1, \(Gram\/Mole\) \((Gram\/Mole)\)\^\(-1\), 1, 
          Kelvin, Kelvin, \(Joule\ Kilo\)\/Mole, \(Joule\ Kilo\)\/Mole, \(\(\ \
\)\(Kilogram\)\)\/Meter\^3, Watt\/\(Kelvin\ Meter\), 
          ElectronVolt, \(Joule\ Kelvin\)\/Gram, Percent/Percent, 
          Percent/Percent, Percent/Percent, 1, ElectronVolt, 
          Kilo\ Joule/Mole, Angstrom};\)\)], "Input"],

Cell[BoxData[
    \(\(efunsunitsb = {"\<\>", "\<\>", Gram\/Mole, "\<\>", Kelvin, 
          Kelvin, \(Joule\ Kilo\)\/Mole, \(Joule\ Kilo\)\/Mole, \(\(\ \
\)\(Kilogram\)\)\/Meter\^3, Watt\/\(Kelvin\ Meter\), 
          ElectronVolt, \(Joule\ Kelvin\)\/Gram, Percent, Percent, 
          Percent, "\<\>", ElectronVolt, Kilo\ Joule/Mole, 
          Angstrom, "\<\>", "\<\>", "\<\>", "\<\>", "\<\>", "\<\>", "\<\>", "\
\<\>"};\)\)], "Input"],

Cell["\<\
(* chicken or egg if you have An ok , Element ok , but Abbrev you \
gotta lookup. *)\
\>", "Text"],

Cell["(* stick with using Elements or An in code where possible *)", "Text"],

Cell["\<\
(* NOTE:  Elements[[n]] -> AtomicNumber to Name --> either *)\
\>", \
"Text"],

Cell[BoxData[
    \(ElementFromAbbreviation[s_] := 
      Module[{p, p2}, \[IndentingNewLine]p = 
          Position[ElementAbbreviations, ToString[s]]; \[IndentingNewLine]If[
          p =!= {}, Elements[\([p[\([1, 1]\)]]\)]\[IndentingNewLine], 
          Null]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[ElementFromAbbreviation, {Cu, xxx}]\)], "Input"],

Cell[BoxData[
    \({Copper, Null}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(ElementsString = 
        Table[ToString[Elements[\([i]\)]], {i, 
            Length[Elements]}];\)\)], "Input"],

Cell[BoxData[
    \(ElementFromEither[s_] := 
      Module[{p, p2, str}, 
        str = ToString[s]; \[IndentingNewLine]p = 
          Position[ElementAbbreviations, str]; \[IndentingNewLine]If[
          p =!= {}, 
          Return[Elements[\([p[\([1, 1]\)]]\)]]]; \[IndentingNewLine]p = 
          Position[ElementsString, str]; \[IndentingNewLine]If[p =!= {}, 
          Return[Elements[\([p[\([1, 
                    1]\)]]\)]]]; \
\[IndentingNewLine]Null\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[ElementFromEither, {"\<Cr\>", Cr, Chromium, xxx}]\)], "Input"],

Cell[BoxData[
    \({Chromium, Chromium, Chromium, Null}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(AbbreviationFromEither[s_] := 
      Module[{p, p2, str}, 
        str = ToString[s]; \[IndentingNewLine]p = 
          Position[ElementAbbreviations, str]; \[IndentingNewLine]If[
          p =!= {}, 
          Return[ElementAbbreviations[\([p[\([1, 
                    1]\)]]\)]]]; \[IndentingNewLine]p = 
          Position[ElementsString, str]; \[IndentingNewLine]If[p =!= {}, 
          Return[ElementAbbreviations[\([p[\([1, 
                    1]\)]]\)]]]; \
\[IndentingNewLine]Null\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[AbbreviationFromEither, {"\<Cr\>", Cr, Chromium, xxx}]\)], "Input"],

Cell[BoxData[
    \({"Cr", "Cr", "Cr", Null}\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["snf and efunsnum (misc funs used in charts to print numbers)", \
"Subsubsection"],

Cell[BoxData[
    \(\(snf = \((EngineeringForm[#, 4\[IndentingNewLine], 
              NumberFormat \[Rule] \((SequenceForm[#1, "\<e\>", #3] &)\)\
\[IndentingNewLine]] &)\);\)\)], "Input"],

Cell[BoxData[
    \(\(snf = \((fNBookForm2[#] &)\);\)\)], "Input"],

Cell[BoxData[
    \(snf2[z_] := 
      EngineeringForm[N[z, 100], {3, 3}, 
        NumberPoint \[Rule] "\<.\>", \[IndentingNewLine]NumberFormat \[Rule] \
\((SequenceForm[#1, #2, "\<\[ThinSpace]\>", 
                powerbook[#3]] &)\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(efunsnum = {\((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] \
&)\), \((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] &)\), \
\((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] \
&)\), \((Identity[#] &)\), \((Identity[#] &)\), snf, snf, 
          snf, \((Identity[#] &)\), \((Identity[#] &)\), \((Identity[#] &)\), \
\((Identity[#] &)\)};\)\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic Charts", "Subsection"],

Cell[CellGroupData[{

Cell["chart of Electron Config  {all ElectronConfiguration }", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Partition[\[IndentingNewLine]Table[\[IndentingNewLine]{\
\[IndentingNewLine]Abbreviation[
              Elements[\([i]\)]], \[IndentingNewLine]ElectronConfiguration[
              Elements[\([i]\)]]\[IndentingNewLine]}, {i, 
            Length[Elements]\[IndentingNewLine]}\[IndentingNewLine]]\
\[IndentingNewLine], 2]\[IndentingNewLine] // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {"\<\"H\"\>"},
                {GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"He\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Li\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Be\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"B\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"C\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"N\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"O\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"F\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ne\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Na\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Mg\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Al\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Si\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"P\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"S\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Cl\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ar\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"K\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ca\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Sc\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ti\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"V\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Cr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Mn\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Fe\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Co\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ni\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"8"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Cu\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Zn\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Ga\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ge\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"As\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Se\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Br\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Kr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Rb\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Sr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Y\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Zr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Nb\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Mo\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Tc\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ru\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Rh\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"8"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Pd\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Ag\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Cd\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"In\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Sn\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Sb\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Te\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"I\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Xe\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Cs\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ba\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"La\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ce\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Pr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Nd\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Pm\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Sm\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Eu\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Gd\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Tb\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"9"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Dy\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Ho\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"11"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Er\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"12"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Tm\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"13"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Yb\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Lu\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Hf\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Ta\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"W\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Re\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Os\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Ir\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Pt\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"9"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Au\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Hg\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Tl\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Pb\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Bi\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Po\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"At\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Rn\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Fr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Ra\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Ac\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Th\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Pa\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"U\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Np\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Pu\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Am\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Cm\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Bk\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"9"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Cf\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Es\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"11"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Fm\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"12"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Md\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"13"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"No\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Lr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"1"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Rf\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Db\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"3"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Sg\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"4"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Bh\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"5"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Hs\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Mt\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"7"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Uun\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"10"},
                      {"14"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"},
                      {"6"},
                      {"8"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"2"}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {GridBox[{
                {"\<\"Uuu\"\>"},
                {"Unknown"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Uub\"\>"},
                {"Unknown"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{"H", {{1}}}, {"He", {{2}}}}, {{"Li", {{2}, {1}}}, {
        "Be", {{2}, {2}}}}, {{"B", {{2}, {2, 1}}}, {"C", {{2}, {2, 2}}}}, {{
        "N", {{2}, {2, 3}}}, {"O", {{2}, {2, 4}}}}, {{"F", {{2}, {2, 5}}}, {
        "Ne", {{2}, {2, 6}}}}, {{"Na", {{2}, {2, 6}, {1}}}, {"Mg", {{2}, {2, 
        6}, {2}}}}, {{"Al", {{2}, {2, 6}, {2, 1}}}, {"Si", {{2}, {2, 6}, {2, 
        2}}}}, {{"P", {{2}, {2, 6}, {2, 3}}}, {"S", {{2}, {2, 6}, {2, 
        4}}}}, {{"Cl", {{2}, {2, 6}, {2, 5}}}, {"Ar", {{2}, {2, 6}, {2, 
        6}}}}, {{"K", {{2}, {2, 6}, {2, 6}, {1}}}, {"Ca", {{2}, {2, 6}, {2, 
        6}, {2}}}}, {{"Sc", {{2}, {2, 6}, {2, 6, 1}, {2}}}, {"Ti", {{2}, {2, 
        6}, {2, 6, 2}, {2}}}}, {{"V", {{2}, {2, 6}, {2, 6, 3}, {2}}}, {
        "Cr", {{2}, {2, 6}, {2, 6, 5}, {1}}}}, {{"Mn", {{2}, {2, 6}, {2, 6, 
        5}, {2}}}, {"Fe", {{2}, {2, 6}, {2, 6, 6}, {2}}}}, {{"Co", {{2}, {2, 
        6}, {2, 6, 7}, {2}}}, {"Ni", {{2}, {2, 6}, {2, 6, 8}, {2}}}}, {{
        "Cu", {{2}, {2, 6}, {2, 6, 10}, {1}}}, {"Zn", {{2}, {2, 6}, {2, 6, 
        10}, {2}}}}, {{"Ga", {{2}, {2, 6}, {2, 6, 10}, {2, 1}}}, {"Ge", {{
        2}, {2, 6}, {2, 6, 10}, {2, 2}}}}, {{"As", {{2}, {2, 6}, {2, 6, 10}, {
        2, 3}}}, {"Se", {{2}, {2, 6}, {2, 6, 10}, {2, 4}}}}, {{"Br", {{2}, {2,
         6}, {2, 6, 10}, {2, 5}}}, {"Kr", {{2}, {2, 6}, {2, 6, 10}, {2, 
        6}}}}, {{"Rb", {{2}, {2, 6}, {2, 6, 10}, {2, 6}, {1}}}, {"Sr", {{2}, {
        2, 6}, {2, 6, 10}, {2, 6}, {2}}}}, {{"Y", {{2}, {2, 6}, {2, 6, 10}, {
        2, 6, 1}, {2}}}, {"Zr", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 2}, {
        2}}}}, {{"Nb", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 4}, {1}}}, {"Mo", {{
        2}, {2, 6}, {2, 6, 10}, {2, 6, 5}, {1}}}}, {{"Tc", {{2}, {2, 6}, {2, 
        6, 10}, {2, 6, 5}, {2}}}, {"Ru", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 
        7}, {1}}}}, {{"Rh", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 8}, {1}}}, {
        "Pd", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10}}}}, {{"Ag", {{2}, {2, 6}, {
        2, 6, 10}, {2, 6, 10}, {1}}}, {"Cd", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 
        10}, {2}}}}, {{"In", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 1}}}, {
        "Sn", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 2}}}}, {{"Sb", {{2}, {
        2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 3}}}, {"Te", {{2}, {2, 6}, {2, 6, 
        10}, {2, 6, 10}, {2, 4}}}}, {{"I", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 
        10}, {2, 5}}}, {"Xe", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 
        6}}}}, {{"Cs", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 6}, {1}}}, {
        "Ba", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 6}, {2}}}}, {{"La", {{
        2}, {2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 6, 1}, {2}}}, {"Ce", {{2}, {2,
         6}, {2, 6, 10}, {2, 6, 10, 2}, {2, 6}, {2}}}}, {{"Pr", {{2}, {2, 
        6}, {2, 6, 10}, {2, 6, 10, 3}, {2, 6}, {2}}}, {"Nd", {{2}, {2, 6}, {2,
         6, 10}, {2, 6, 10, 4}, {2, 6}, {2}}}}, {{"Pm", {{2}, {2, 6}, {2, 6, 
        10}, {2, 6, 10, 5}, {2, 6}, {2}}}, {"Sm", {{2}, {2, 6}, {2, 6, 10}, {
        2, 6, 10, 6}, {2, 6}, {2}}}}, {{"Eu", {{2}, {2, 6}, {2, 6, 10}, {2, 6,
         10, 7}, {2, 6}, {2}}}, {"Gd", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 
        7}, {2, 6, 1}, {2}}}}, {{"Tb", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 
        9}, {2, 6}, {2}}}, {"Dy", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 10}, {
        2, 6}, {2}}}}, {{"Ho", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 11}, {2, 
        6}, {2}}}, {"Er", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 12}, {2, 6}, {
        2}}}}, {{"Tm", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 13}, {2, 6}, {
        2}}}, {"Yb", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6}, {
        2}}}}, {{"Lu", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 1}, {
        2}}}, {"Hf", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 2}, {
        2}}}}, {{"Ta", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 3}, {
        2}}}, {"W", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 4}, {
        2}}}}, {{"Re", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 5}, {
        2}}}, {"Os", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 6}, {
        2}}}}, {{"Ir", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 7}, {
        2}}}, {"Pt", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 9}, {
        1}}}}, {{"Au", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10}, {
        1}}}, {"Hg", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10}, {
        2}}}}, {{"Tl", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10}, {
        2, 1}}}, {"Pb", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 
        10}, {2, 2}}}}, {{"Bi", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 
        6, 10}, {2, 3}}}, {"Po", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2,
         6, 10}, {2, 4}}}}, {{"At", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 
        14}, {2, 6, 10}, {2, 5}}}, {"Rn", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10,
         14}, {2, 6, 10}, {2, 6}}}}, {{"Fr", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 
        10, 14}, {2, 6, 10}, {2, 6}, {1}}}, {"Ra", {{2}, {2, 6}, {2, 6, 10}, {
        2, 6, 10, 14}, {2, 6, 10}, {2, 6}, {2}}}}, {{"Ac", {{2}, {2, 6}, {2, 
        6, 10}, {2, 6, 10, 14}, {2, 6, 10}, {2, 6, 1}, {2}}}, {"Th", {{2}, {2,
         6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10}, {2, 6, 2}, {2}}}}, {{
        "Pa", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 2}, {2, 6, 
        1}, {2}}}, {"U", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 
        3}, {2, 6, 1}, {2}}}}, {{"Np", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 
        14}, {2, 6, 10, 4}, {2, 6, 1}, {2}}}, {"Pu", {{2}, {2, 6}, {2, 6, 
        10}, {2, 6, 10, 14}, {2, 6, 10, 6}, {2, 6}, {2}}}}, {{"Am", {{2}, {2, 
        6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 7}, {2, 6}, {2}}}, {
        "Cm", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 7}, {2, 6, 
        1}, {2}}}}, {{"Bk", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 
        10, 9}, {2, 6}, {2}}}, {"Cf", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 
        14}, {2, 6, 10, 10}, {2, 6}, {2}}}}, {{"Es", {{2}, {2, 6}, {2, 6, 
        10}, {2, 6, 10, 14}, {2, 6, 10, 11}, {2, 6}, {2}}}, {"Fm", {{2}, {2, 
        6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 12}, {2, 6}, {2}}}}, {{
        "Md", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 13}, {2, 
        6}, {2}}}, {"No", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10,
         14}, {2, 6}, {2}}}}, {{"Lr", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 
        14}, {2, 6, 10, 14}, {2, 6, 1}, {2}}}, {"Rf", {{2}, {2, 6}, {2, 6, 
        10}, {2, 6, 10, 14}, {2, 6, 10, 14}, {2, 6, 2}, {2}}}}, {{"Db", {{
        2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 14}, {2, 6, 3}, {
        2}}}, {"Sg", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 
        14}, {2, 6, 4}, {2}}}}, {{"Bh", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 
        14}, {2, 6, 10, 14}, {2, 6, 5}, {2}}}, {"Hs", {{2}, {2, 6}, {2, 6, 
        10}, {2, 6, 10, 14}, {2, 6, 10, 14}, {2, 6, 6}, {2}}}}, {{"Mt", {{
        2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 14}, {2, 6, 7}, {
        2}}}, {"Uun", {{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 
        14}, {2, 6, 8}, {2}}}}, {{"Uuu", Unknown}, {"Uub", 
        Unknown}}}]]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Map[ElectronConfiguration, Elements] // TableForm;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
chart VerboseElement {all efun values, message per value , efuns , \
efun usage }\
\>", "Subsubsection"],

Cell[BoxData[
    \(VerboseElement[
        i_] := \[IndentingNewLine]FlattenAt[{{i, Element, i::usage, 
            Elements::usage}, 
          Table[\[IndentingNewLine]Miscellaneous`ChemicalElements`Private`\
mess = {}; \[IndentingNewLine]{\(efuns[\([j]\)]\)[
                i], \[IndentingNewLine]m2, \[IndentingNewLine]efuns[\([j]\)], \
\[IndentingNewLine]\(Evaluate[
                  efuns[\([j]\)]]\)::usage\[IndentingNewLine]}, {j, 1, 
              Length[efuns]}\[IndentingNewLine]]}, 2]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(VerboseElement[Hydrogen] // MatrixForm\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"Hydrogen", 
              "Element", "\<\"Hydrogen is a chemical element.\"\>", \
"\<\"Elements is a list of the chemical elements described in the \
ChemicalElements package.\"\>"},
            {"\<\"H\"\>", \({}\), 
              "Abbreviation", "\<\"Abbreviation[element] gives the standard \
abbreviation of the specified element.\"\>"},
            {"1", \({}\), 
              "AtomicNumber", "\<\"AtomicNumber[element] gives the atomic \
number of the specified element.\"\>"},
            {"1.00794`", \({}\), 
              "AtomicWeight", "\<\"AtomicWeight[element] gives the atomic \
weight of the specified element.\"\>"},
            {\({1, 2}\), \({}\), 
              "StableIsotopes", "\<\"StableIsotopes[element] gives a list of \
the stable isotopes of the specified element.\"\>"},
            {\(14.01`\ Kelvin\), \({}\), 
              "MeltingPoint", "\<\"MeltingPoint[element] gives the melting \
point of the specified element.\"\>"},
            {\(20.28`\ Kelvin\), \({}\), 
              "BoilingPoint", "\<\"BoilingPoint[element] gives the boiling \
point of the specified element.\"\>"},
            {\(\(0.12`\ Joule\ Kilo\)\/Mole\), \({}\), 
              "HeatOfFusion", "\<\"HeatOfFusion[element] gives the heat of \
fusion of the  specified element.\"\>"},
            {\(\(0.46`\ Joule\ Kilo\)\/Mole\), \({}\), 
              "HeatOfVaporization", "\<\"HeatOfVaporization[element] gives \
the heat of vaporization of the specified element.\"\>"},
            {\(\(76.`\ Kilogram\)\/Meter\^3\), \({"Density is for Hydrogen at \
11 Kelvin."}\), 
              "Density", "\<\"Density[element] gives the density of the \
specified element, usually at 298 Kelvin.  A message is issued for other \
temperatures and for special forms of the element.\"\>"},
            {\(\(0.1815`\ Watt\)\/\(Kelvin\ Meter\)\), \({"Thermal \
conductivity is for the Hydrogen form of gaseous."}\), 
              "ThermalConductivity", "\<\"ThermalConductivity[element] gives \
the thermal conductivity of the specified element at 300 K.\"\>"},
            {\(13.598`\ ElectronVolt\), \({}\), 
              "IonizationPotential", "\<\"IonizationPotential[element] gives \
the ionization potential of the specified element.\"\>"},
            {\(\(14.304`\ Joule\ Kelvin\)\/Gram\), \({}\), 
              "SpecificHeat", "\<\"SpecificHeat[element] gives the specific \
heat of the specified element.\"\>"},
            {"0.91`", \({}\), 
              "SolarSystemAbundance", "\<\"SolarSystemAbundance[element] \
gives the relative abundance in the solar system of the specified \
element.\"\>"},
            {"0.0014`", \({}\), 
              "EarthCrustAbundance", "\<\"EarthCrustAbundance[element] gives \
the relative abundance in the Earth's crust of the specified element.\"\>"},
            {"0.108`", \({}\), 
              "EarthOceanAbundance", "\<\"EarthOceanAbundance[element] gives \
the relative abundance in the Earth's oceans of the specified element.\"\>"},
            {\({\(-1\), 1}\), \({}\), 
              "OxidationStates", "\<\"OxidationStates[element] gives a list \
of the oxidation numbers of the specified element.\"\>"},
            {\(2.2`\ ElectronVolt\), \({}\), 
              "ElectronNegativity", "\<\"ElectonNegativity[element] gives a \
list of the electron negativity of the specified element.\"\>"},
            {\(\(72.77`\ Joule\ Kilo\)\/Mole\), \({}\), 
              "ElectronAffinity", "\<\"ElectronAffinity[element] gives a list \
of the electron affinity of the specified element.\"\>"},
            {\(0.37`\ Angstrom\), \({}\), 
              "AtomicRadius", "\<\"AtomicRadius[element] gives a list of the \
atomic radii of the specified element.\"\>"},
            {\({{1}}\), \({}\), 
              "ElectronConfiguration", "\<\"ElectronConfiguration[element] \
depicts the electron configuration of the specified element in a list of the \
form {{1s},{2s,2p},{3s,3p,3d},{4s,4p,4d,4f},{5s,5p,5d,5f},{6s,6p,6d},{7s}}.\"\
\>"},
            {
              InterpretationBox[
                RowBox[{"\<\"1\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
                  "\[InvisibleSpace]", 
                  InterpretationBox[\(\[Null]\^1\),
                    Superscript[ 1],
                    Editable->False]}],
                SequenceForm[ "1", "s", 
                  Superscript[ 1]],
                Editable->False], \({}\), 
              "ElectronConfigurationFormat", \
"\<\"ElectronConfigurationFormat[element] puts the electron configuration of \
the specified element in standard notation.\"\>"}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart Dict { name, abbrev, AtomicNumber , dict entry }", "Subsubsection"],

Cell[BoxData[
    \(\(dict[] := 
        Table[\[IndentingNewLine]{Elements[\([j]\)], 
            ElementDescription[Elements[\([j]\)]]\[IndentingNewLine]}, {j, 1, 
            Length[Elements]}];\)\)], "Input"],

Cell[BoxData[
    \(\(Dict = 
        Partition[{Elements, Abbreviation[Elements], AtomicNumber[Elements], 
            ElementDescription[Elements]}, 4];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Dict // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {GridBox[{
                {"Hydrogen"},
                {"Helium"},
                {"Lithium"},
                {"Beryllium"},
                {"Boron"},
                {"Carbon"},
                {"Nitrogen"},
                {"Oxygen"},
                {"Fluorine"},
                {"Neon"},
                {"Sodium"},
                {"Magnesium"},
                {"Aluminium"},
                {"Silicon"},
                {"Phosphorus"},
                {"Sulfur"},
                {"Chlorine"},
                {"Argon"},
                {"Potassium"},
                {"Calcium"},
                {"Scandium"},
                {"Titanium"},
                {"Vanadium"},
                {"Chromium"},
                {"Manganese"},
                {"Iron"},
                {"Cobalt"},
                {"Nickel"},
                {"Copper"},
                {"Zinc"},
                {"Gallium"},
                {"Germanium"},
                {"Arsenic"},
                {"Selenium"},
                {"Bromine"},
                {"Krypton"},
                {"Rubidium"},
                {"Strontium"},
                {"Yttrium"},
                {"Zirconium"},
                {"Niobium"},
                {"Molybdenum"},
                {"Technetium"},
                {"Ruthenium"},
                {"Rhodium"},
                {"Palladium"},
                {"Silver"},
                {"Cadmium"},
                {"Indium"},
                {"Tin"},
                {"Antimony"},
                {"Tellurium"},
                {"Iodine"},
                {"Xenon"},
                {"Caesium"},
                {"Barium"},
                {"Lanthanum"},
                {"Cerium"},
                {"Praseodymium"},
                {"Neodymium"},
                {"Promethium"},
                {"Samarium"},
                {"Europium"},
                {"Gadolinium"},
                {"Terbium"},
                {"Dysprosium"},
                {"Holmium"},
                {"Erbium"},
                {"Thulium"},
                {"Ytterbium"},
                {"Lutetium"},
                {"Hafnium"},
                {"Tantalum"},
                {"Tungsten"},
                {"Rhenium"},
                {"Osmium"},
                {"Iridium"},
                {"Platinum"},
                {"Gold"},
                {"Mercury"},
                {"Thallium"},
                {"Lead"},
                {"Bismuth"},
                {"Polonium"},
                {"Astatine"},
                {"Radon"},
                {"Francium"},
                {"Radium"},
                {"Actinium"},
                {"Thorium"},
                {"Protactinium"},
                {"Uranium"},
                {"Neptunium"},
                {"Plutonium"},
                {"Americium"},
                {"Curium"},
                {"Berkelium"},
                {"Californium"},
                {"Einsteinium"},
                {"Fermium"},
                {"Mendelevium"},
                {"Nobelium"},
                {"Lawrencium"},
                {"Rutherfordium"},
                {"Dubnium"},
                {"Seaborgium"},
                {"Bohrium"},
                {"Hassium"},
                {"Meitnerium"},
                {"Ununnilium"},
                {"Unununium"},
                {"Ununbium"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"H\"\>"},
                {"\<\"He\"\>"},
                {"\<\"Li\"\>"},
                {"\<\"Be\"\>"},
                {"\<\"B\"\>"},
                {"\<\"C\"\>"},
                {"\<\"N\"\>"},
                {"\<\"O\"\>"},
                {"\<\"F\"\>"},
                {"\<\"Ne\"\>"},
                {"\<\"Na\"\>"},
                {"\<\"Mg\"\>"},
                {"\<\"Al\"\>"},
                {"\<\"Si\"\>"},
                {"\<\"P\"\>"},
                {"\<\"S\"\>"},
                {"\<\"Cl\"\>"},
                {"\<\"Ar\"\>"},
                {"\<\"K\"\>"},
                {"\<\"Ca\"\>"},
                {"\<\"Sc\"\>"},
                {"\<\"Ti\"\>"},
                {"\<\"V\"\>"},
                {"\<\"Cr\"\>"},
                {"\<\"Mn\"\>"},
                {"\<\"Fe\"\>"},
                {"\<\"Co\"\>"},
                {"\<\"Ni\"\>"},
                {"\<\"Cu\"\>"},
                {"\<\"Zn\"\>"},
                {"\<\"Ga\"\>"},
                {"\<\"Ge\"\>"},
                {"\<\"As\"\>"},
                {"\<\"Se\"\>"},
                {"\<\"Br\"\>"},
                {"\<\"Kr\"\>"},
                {"\<\"Rb\"\>"},
                {"\<\"Sr\"\>"},
                {"\<\"Y\"\>"},
                {"\<\"Zr\"\>"},
                {"\<\"Nb\"\>"},
                {"\<\"Mo\"\>"},
                {"\<\"Tc\"\>"},
                {"\<\"Ru\"\>"},
                {"\<\"Rh\"\>"},
                {"\<\"Pd\"\>"},
                {"\<\"Ag\"\>"},
                {"\<\"Cd\"\>"},
                {"\<\"In\"\>"},
                {"\<\"Sn\"\>"},
                {"\<\"Sb\"\>"},
                {"\<\"Te\"\>"},
                {"\<\"I\"\>"},
                {"\<\"Xe\"\>"},
                {"\<\"Cs\"\>"},
                {"\<\"Ba\"\>"},
                {"\<\"La\"\>"},
                {"\<\"Ce\"\>"},
                {"\<\"Pr\"\>"},
                {"\<\"Nd\"\>"},
                {"\<\"Pm\"\>"},
                {"\<\"Sm\"\>"},
                {"\<\"Eu\"\>"},
                {"\<\"Gd\"\>"},
                {"\<\"Tb\"\>"},
                {"\<\"Dy\"\>"},
                {"\<\"Ho\"\>"},
                {"\<\"Er\"\>"},
                {"\<\"Tm\"\>"},
                {"\<\"Yb\"\>"},
                {"\<\"Lu\"\>"},
                {"\<\"Hf\"\>"},
                {"\<\"Ta\"\>"},
                {"\<\"W\"\>"},
                {"\<\"Re\"\>"},
                {"\<\"Os\"\>"},
                {"\<\"Ir\"\>"},
                {"\<\"Pt\"\>"},
                {"\<\"Au\"\>"},
                {"\<\"Hg\"\>"},
                {"\<\"Tl\"\>"},
                {"\<\"Pb\"\>"},
                {"\<\"Bi\"\>"},
                {"\<\"Po\"\>"},
                {"\<\"At\"\>"},
                {"\<\"Rn\"\>"},
                {"\<\"Fr\"\>"},
                {"\<\"Ra\"\>"},
                {"\<\"Ac\"\>"},
                {"\<\"Th\"\>"},
                {"\<\"Pa\"\>"},
                {"\<\"U\"\>"},
                {"\<\"Np\"\>"},
                {"\<\"Pu\"\>"},
                {"\<\"Am\"\>"},
                {"\<\"Cm\"\>"},
                {"\<\"Bk\"\>"},
                {"\<\"Cf\"\>"},
                {"\<\"Es\"\>"},
                {"\<\"Fm\"\>"},
                {"\<\"Md\"\>"},
                {"\<\"No\"\>"},
                {"\<\"Lr\"\>"},
                {"\<\"Rf\"\>"},
                {"\<\"Db\"\>"},
                {"\<\"Sg\"\>"},
                {"\<\"Bh\"\>"},
                {"\<\"Hs\"\>"},
                {"\<\"Mt\"\>"},
                {"\<\"Uun\"\>"},
                {"\<\"Uuu\"\>"},
                {"\<\"Uub\"\>"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"1"},
                {"2"},
                {"3"},
                {"4"},
                {"5"},
                {"6"},
                {"7"},
                {"8"},
                {"9"},
                {"10"},
                {"11"},
                {"12"},
                {"13"},
                {"14"},
                {"15"},
                {"16"},
                {"17"},
                {"18"},
                {"19"},
                {"20"},
                {"21"},
                {"22"},
                {"23"},
                {"24"},
                {"25"},
                {"26"},
                {"27"},
                {"28"},
                {"29"},
                {"30"},
                {"31"},
                {"32"},
                {"33"},
                {"34"},
                {"35"},
                {"36"},
                {"37"},
                {"38"},
                {"39"},
                {"40"},
                {"41"},
                {"42"},
                {"43"},
                {"44"},
                {"45"},
                {"46"},
                {"47"},
                {"48"},
                {"49"},
                {"50"},
                {"51"},
                {"52"},
                {"53"},
                {"54"},
                {"55"},
                {"56"},
                {"57"},
                {"58"},
                {"59"},
                {"60"},
                {"61"},
                {"62"},
                {"63"},
                {"64"},
                {"65"},
                {"66"},
                {"67"},
                {"68"},
                {"69"},
                {"70"},
                {"71"},
                {"72"},
                {"73"},
                {"74"},
                {"75"},
                {"76"},
                {"77"},
                {"78"},
                {"79"},
                {"80"},
                {"81"},
                {"82"},
                {"83"},
                {"84"},
                {"85"},
                {"86"},
                {"87"},
                {"88"},
                {"89"},
                {"90"},
                {"91"},
                {"92"},
                {"93"},
                {"94"},
                {"95"},
                {"96"},
                {"97"},
                {"98"},
                {"99"},
                {"100"},
                {"101"},
                {"102"},
                {"103"},
                {"104"},
                {"105"},
                {"106"},
                {"107"},
                {"108"},
                {"109"},
                {"110"},
                {"111"},
                {"112"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"Colourless, odourless gaseous chemical element. \
Lightest and most abundant element in the universe. Present in water and in \
all organic compounds. Chemically reacts with most elements. Discovered by \
Henry Cavendish in 1776. \"\>"},
                {"\<\"Colourless, odourless gaseous nonmetallic element. \
Belongs to group 18 of the periodic table. Lowest boiling point of all \
elements and can only be solidified under pressure. Chemically inert, no \
known compounds. Discovered in the solar spectrum in 1868 by Lockyer. \"\>"},
                {"\<\"Socket silvery metal. First member of group 1 of the \
periodic table. Lithium salts are used in psychomedicine. \"\>"},
                {"\<\"Grey metallic element of group 2 of the periodic table. \
Is toxic and can cause severe lung diseases and dermatitis. Shows high \
covalent character. It was isolated independently by F. Wohler and A.A. Bussy \
in 1828. \"\>"},
                {"\<\"An element of group 13 of the periodic table. There are \
two allotropes, amorphous boron is a brown power, but metallic boron is \
black. The metallic form is hard (9.3 on Mohs' scale) and a bad conductor in \
room temperatures. It is never found free in nature. Boron-10 is used in \
nuclear reactor control rods and shields. It was discovered in 1808 by Sir \
Humphry Davy and by J.L. Gay-Lussac and L.J. Thenard. \"\>"},
                {"\<\"Carbon is a member of group 14 of the periodic table. \
It has three allotropic forms of it, diamonds, graphite and fullerite. \
Carbon-14 is commonly used in radioactive dating. Carbon occurs in all \
organic life and is the basis of organic chemistry. Carbon has the \
interesting chemical property of being able to bond with itself, and a wide \
variety of other elements. \"\>"},
                {"\<\"Colourless, gaseous element which belongs to group 15 \
of the periodic table. Constitutes ~78% of the atmosphere and is an essential \
part of the ecosystem. Nitrogen for industrial purposes is acquired by the \
fractional distillation of liquid air. Chemically inactive, reactive \
generally only at high temperatures or in electrical discharges. It was \
discovered in 1772 by D. Rutherford. \"\>"},
                {"\<\"A colourless, odourless gaseous element belonging to \
group 16 of the periodic table. It is the most abundant element present in \
the earth's crust. It also makes up 20.8% of the Earth's atmosphere. For \
industrial purposes, it is separated from liquid air by fractional \
distillation. It is used in high temperature welding, and in breathing. It \
commonly comes in the form of Oxygen, but is found as Ozone in the upper \
atmosphere. It was discovered by Priestley in 1774. \"\>"},
                {"\<\"A poisonous pale yellow gaseous element belonging to \
group 17 of the periodic table (The halogens). It is the most chemically \
reactive and electronegative element. It is highly dangerous, causing severe \
chemical burns on contact with flesh. Fluorine was identified by Scheele in \
1771 and first isolated by Moissan in 1886. \"\>"},
                {"\<\"Colourless gaseous element of group 18 on the periodic \
table (noble gases). Neon occurs in the atmosphere, and comprises 0.0018% of \
the volume of the atmosphere. It has a distinct reddish glow when used in \
discharge tubes and neon based lamps. It forms almost no chemical compounds. \
Neon was discovered in 1898 by Sir William Ramsey and M.W. Travers. \"\>"},
                {"\<\"Soft silvery reactive element belonging to group 1 of \
the periodic table (alkali metals). It is highly reactive, oxidizing in air \
and reacting violently with water, forcing it to be kept under oil. It was \
first isolated by Humphrey Davy in 1807. \"\>"},
                {"\<\"Silvery metallic element belonging to group 2 of the \
periodic table (alkaline-earth metals). It is essential for living organisms, \
and is used in a number of light alloys. Chemically very reactive, it forms a \
protective oxide coating when exposed to air and burns with an intense white \
flame. It also reacts with sulphur, nitrogen and the halogens. First isolated \
by Bussy in 1828. \"\>"},
                {"\<\"Silvery metallic element belonging to group 2 of the \
periodic table (alkaline-earth metals). It is essential for living organisms, \
and is used in a number of light alloys. Chemically very reactive, it forms a \
protective oxide coating when exposed to air and burns with an intense white \
flame. It also reacts with sulphur, nitrogen and the halogens. First isolated \
by Bussy in 1828. \"\>"},
                {"\<\"Metalloid element belonging to group 14 of the periodic \
table. It is the second most abundant element in the Earth's crust, making up \
25.7% of it by weight. Chemically less reactive than carbon. First identified \
by Lavoisier in 1787 and first isolated in 1823 by Berzelius. \"\>"},
                {"\<\"Non-metallic element belonging to group 15 of the \
periodic table. Has a multiple allotropic forms. Essential element for living \
organisms. It was discovered by Brandt in 1669. \"\>"},
                {"\<\"Non-metallic element belonging to group 15 of the \
periodic table. Has a multiple allotropic forms. Essential element for living \
organisms. It was discovered by Brandt in 1669. \"\>"},
                {"\<\"Halogen element. Poisonous greenish-yellow gas. Occurs \
widely in nature as sodium chloride in seawater. Reacts directly with many \
elements and compounds, strong oxidizing agent. Discovered by Karl Scheele in \
1774. Humphrey David confirmed it as an element in 1810. \"\>"},
                {"\<\"Monatomic noble gas. Makes up 0.93% of the air. \
Colourless, odorless. Is inert and has no true compounds. Lord Rayleigh and \
Sir William Ramsey identified argon in 1894. \"\>"},
                {"\<\"Soft silvery metallic element belonging to group 1 of \
the periodic table (alkali metals). Occurs naturally in seawater and a many \
minerals. Highly reactive, chemically, it resembles sodium in its behavior \
and compounds. Discovered by Sir Humphry Davy in 1807. \"\>"},
                {"\<\"Soft grey metallic element belonging to group 2 of the \
periodic table. Used a reducing agent in the extraction of thorium, zirconium \
and uranium. Essential element for living organisms. \"\>"},
                {"\<\"Rare soft silvery metallic element belonging to group 3 \
of the periodic table. There are ten isotopes, nine of which are radioactive \
and have short half-lives. Predicted in 1869 by Mendeleev, isolated by Nilson \
in 1879. \"\>"},
                {"\<\"White metallic transition element. Occurs in numerous \
minerals. Used in strong, light corrosion-resistant alloys. Forms a passive \
oxide coating when exposed to air. First discovered by Gregor in 1789. \
\"\>"},
                {"\<\"Soft and ductile, bright white metal. Good resistance \
to corrosion by alkalis, sulphuric and hydrochloric acid. It oxidizes readily \
about 933K. There are two naturally occurring isotopes of vanadium, and 5 \
radioisotopes, V-49 having the longest half-life at 337 days. Vanadium has \
nuclear applications, the foil is used in cladding titanium to steel, and \
vanadium-gallium tape is used to produce a superconductive magnet. Originally \
discovered by Andres Manuel del Rio of Mexico City in 1801. His discovery \
went unheeded, however, and in 1820, Nils Gabriel Sefstron of Sweden \
rediscovered it. Metallic vanadium was isolated by Henry Enfield Roscoe in \
1867. The name vanadium comes from {Vanadis}, a goddess of Scandinavian \
mythology. Silvery-white metallic transition element. Vanadium is essential \
to {ascidian}s. Rats and chickens are also known to require it. Metal powder \
is a fire hazard, and vanadium compounds should be considered highly toxic. \
May cause lung cancer if inhaled. \"\>"},
                {"\<\"Hard silvery transition element. Used in decorative \
electroplating. Discovered in 1797 by Vauquelin. \"\>"},
                {"\<\"Grey brittle metallic transition element. Rather \
electropositive, combines with some non-metals when heated. Discovered in \
1774 by Scheele. \"\>"},
                {"\<\"Silvery malleable and ductile metallic transition \
element. Has nine isotopes and is the fourth most abundant element in the \
earth's crust. Required by living organisms as a trace element (used in \
hemoglobin in humans.) Quite reactive, oxidizes in moist air, displaces \
hydrogen from dilute acids and combines with nonmetallic elements. \"\>"},
                {"\<\"Light grey transition element. Some meteorites contain \
small amounts of metallic cobalt. Generally alloyed for use. Mammals require \
small amounts of cobalt salts. Cobalt-60, an artificially produced \
radioactive isotope of Cobalt is an important radioactive tracer and \
cancer-treatment agent. Discovered by G. Brandt in 1737. \"\>"},
                {"\<\"Malleable ductile silvery metallic transition element. \
Discovered by A.F. Cronstedt in 1751. \"\>"},
                {"\<\"Red-brown transition element. Known by the Romans as \
'cuprum.' Extracted and used for thousands of years. Malleable, ductile and \
an excellent conductor of heat and electricity. When in moist conditions, a \
greenish layer forms on the outside. \"\>"},
                {"\<\"Blue-white metallic element. Occurs in multiple \
compounds naturally. Five stable isotopes and six radioactive isotopes have \
been found. Chemically a reactive metal, combines with oxygen and other \
non-metals, reacts with dilute acids to release hydrogen. \"\>"},
                {"\<\"Soft silvery metallic element, belongs to group 13 of \
the periodic table. The two stable isotopes are Ga-69 and Ga-71. Eight \
radioactive isotopes are known, all having short half-lives. Gallium Arsenide \
is used as a semiconductor. Corrodes most other metals by diffusing into \
their lattice. First identified by Francois Lecoq de Boisbaudran in 1875. \
\"\>"},
                {"\<\"Lustrous hard metalloid element, belongs to group 14 of \
the periodic table. Forms a large number of organometallic compounds. \
Predicted by Mendeleev in 1871, it was actually found in 1886 by Winkler. \
\"\>"},
                {"\<\"Metalloid element of group 15. There are three \
allotropes, yellow, black, and grey. Reacts with halogens, concentrated \
oxidizing acids and hot alkalis. Albertus Magnus is believed to have been the \
first to isolate the element in 1250. \"\>"},
                {"\<\"Metalloid element, belongs to group 16 of the periodic \
table. Multiple allotropic forms exist. Chemically resembles sulphur. \
Discovered in 1817 by Jons J. Berzelius. \"\>"},
                {"\<\"Halogen element. Red volatile liquid at room \
temperature. Its reactivity is somewhere between chlorine and iodine. Harmful \
to human tissue in a liquid state, the vapour irritates eyes and throat. \
Discovered in 1826 by Antoine Balard. \"\>"},
                {"\<\"Colorless gaseous element, belongs to the noble gases. \
Occurs in the air, 0.0001% by volume. It can be extracted from liquid air by \
fractional distillation. Generally not isolated, but used with other inert \
gases in fluorescent lamps. Five natural isotopes, and five radioactive \
isotopes. Kr-85, the most stable radioactive isotope, has a half-life of \
10.76 years and is produced in fission reactors. Practically inert, though \
known to form compounds with {fluorine}. \"\>"},
                {"\<\"Soft silvery metallic element, belongs to group 1 of \
the periodic table. Rb-97, the naturally occurring isotope, is radioactive. \
It is highly reactive, with properties similar to other elements in group 1, \
like igniting spontaneously in air. Discovered spectroscopically in 1861 by \
W. Bunsen and G.R. Kirchoff. \"\>"},
                {"\<\"Soft yellowish metallic element, belongs to group 2 of \
the periodic table. Highly reactive chemically. Sr-90 is present in \
radioactive fallout and has a half-life of 28 years. Discovered in 1798 by \
Klaproth and Hope, isolated in 1808 by Humphry Davy. \"\>"},
                {"\<\"Silvery-grey metallic element of group 3 on the \
periodic table. Found in uranium ores. The only natural isotope is Y-89, \
there are 14 other artificial isotopes. Chemically resembles the lanthanoids. \
Stable in the air below 400 degrees, celsius. Discovered in 1828 by Friedrich \
Wohler. \"\>"},
                {"\<\"Grey-white metallic transition element. Five natural \
isotopes and six radioactive isotopes are known. Used in nuclear reactors for \
a {neutron} absorber. Discovered in 1789 by Martin Klaproth, isolated in 1824 \
by Berzelius. \"\>"},
                {"\<\"Soft, ductile grey-blue metallic transition element. \
Used in special steels and in welded joints to increase strength. Combines \
with halogens and oxidizes in air at 200 degrees celsius. Discovered by \
Charles Hatchett in 1801 and isolated by Blomstrand in 1864. Called \
{columbium} originally. \"\>"},
                {"\<\"Silvery-white, hard metallic transition element. It is \
chemically unreactive and is not affected by most acids. It oxidizes at high \
temperatures. There are seven natural isotopes, and four radioisotopes, Mo-93 \
being the most stable with a half-life of 3500 years. Molybdenum is used in \
almost all high-strength steels, it has nuclear applications, and is a \
catalyst in petroleum refining. Discovered in 1778 by Carl Welhelm Scheele of \
Sweden. Impure metal was prepared in 1782 by Peter Jacob Hjelm. The name \
comes from the Greek word molybdos which means lead. Trace amounts of \
molybdenum are required for all known forms of life. All molybdenum compounds \
should be considered highly toxic, and will also cause severe birth defects. \
\"\>"},
                {"\<\"Radioactive metallic transition element. Can be \
detected in some stars and the fission products of uranium. First made by \
Perrier and Segre by bombarding molybdenum with deutrons, giving them Tc-97. \
Tc-99 is the most stable isotope with a half-life of 2.6*10^6 years. Sixteen \
isotopes are known. Organic technetium compounds are used in bone imaging. \
Chemical properties are intermediate between rhenium and manganese. \"\>"},
                {"\<\"Hard white metallic transition element. Found with \
platinum, used as a catalyst in some platinum alloys. Dissolves in fused \
alkalis, and is not attacked by acids. Reacts with halogens and oxygen at \
high temperatures. Isolated in 1844 by K.K. Klaus. \"\>"},
                {"\<\"Silvery white metallic transition element. Found with \
platinum and used in some platinum alloys. Not attacked by acids, dissolves \
only in aqua regia. Discovered in 1803 by W.H. Wollaston. \"\>"},
                {"\<\"Soft white ductile transition element. Found with some \
copper and nickel ores. Does not react with oxygen at normal temperatures. \
Dissolves slowly in hydrochloric acid. Discovered in 1803 by W.H. Wollaston. \
\"\>"},
                {"\<\"White lustrous soft metallic transition element. Found \
in both its elemental form and in minerals. Used in jewelry, tableware and so \
on. Less reactive than silver, chemically. \"\>"},
                {"\<\"Soft bluish metal belonging to group 12 of the periodic \
table. Extremely toxic even in low concentrations. Chemically similar to \
zinc, but lends itself to more complex compounds. Discovered in 1817 by F. \
Stromeyer. \"\>"},
                {"\<\"Soft silvery element belonging to group 13 of the \
periodic table. The most common natural isotope is In-115, which has a \
half-life of 6*10^4 years. Five other radioisotopes exist. Discovered in 1863 \
by Reich and Richter. \"\>"},
                {"\<\"Silvery malleable metallic element belonging to group \
14 of the periodic table. Twenty-six isotopes are known, five of which are \
radioactive. Chemically reactive. Combines directly with chlorine and oxygen \
and displaces hydrogen from dilute acids. \"\>"},
                {"\<\"Element of group 15. Multiple allotropic forms. The \
stable form of antimony is a blue-white metal. Yellow and black antimony are \
unstable non-metals. Used in flame-proofing, paints, ceramics, enamels, and \
rubber. Attacked by oxidizing acids and halogens. First reported by Tholden \
in 1450. \"\>"},
                {"\<\"Silvery metalloid element of group 16. Eight natural \
isotopes, nine radioactive isotopes. Used in semiconductors and to a degree \
in some steels. Chemistry is similar to {sulphur}. Discovered in 1782 by \
Franz Miller. \"\>"},
                {"\<\"Dark violet nonmetallic element, belongs to group 17 of \
the periodic table. Insoluble in water. Required as a trace element for \
living organisms. One stable isotope, I-127 exists, in addition to fourteen \
radioactive isotopes. Chemically the least reactive of the halogens, and the \
most electropositive metallic halogen. Discovered in 1812 by Courtois. \
\"\>"},
                {"\<\"Colourless, odourless gas belonging to group 18 on the \
periodic table (the noble gases.) Nine natural isotopes and seven radioactive \
isotopes are known. Xenon was part of the first noble-gas compound \
synthesized. Several others involving Xenon have been found since then. Xenon \
was discovered by Ramsey and Travers in 1898. \"\>"},
                {"\<\"Soft silvery-white metallic element belonging to group \
1 of the periodic table. One of the three metals which are liquid at room \
temperature. Cs-133 is the natural, and only stable, isotope. Fifteen other \
radioisotopes exist. Caesium reacts explosively with cold water, and ice at \
temperatures above 157K. Caesium hydroxide is the strongest base known. \
Caesium is the most electropositive, most alkaline and has the least \
ionization potential of all the elements. Known uses include the basis of \
atomic clocks, catalyst for the hydrogenation of some organic compounds, and \
in photoelectric cells. Caesium was discovered by Gustav Kirchoff and Robert \
Bunsen in Germany in 1860 spectroscopically. Its identification was based \
upon the bright blue lines in its spectrum. The name comes from the latin \
word caesius, which means sky blue. Caesium should be considered highly \
toxic. Some of the radioisotopes are even more toxic. \"\>"},
                {"\<\"Silvery-white reactive element, belonging to group 2 of \
the periodic table. Soluble barium compounds are extremely poisonous. \
Identified in 1774 by Karl Scheele and extracted in 1808 by Humphry Davy. \
\"\>"},
                {"\<\"(From the Greek word lanthanein, to lie hidden) Silvery \
metallic element belonging to group 3 of the periodic table and oft \
considered to be one of the lanthanoids. Found in some rare-earth minerals. \
Twenty-five natural isotopes exist. La-139 which is stable, and La-138 which \
has a half-life of 10^10 to 10^15 years. The other twenty-three isotopes are \
radioactive. It resembles the lanthanoids chemically. Lanthanum has a low to \
moderate level of toxicity, and should be handled with care. Discovered in \
1839 by C.G. Mosander. \"\>"},
                {"\<\"Silvery metallic element, belongs to the lanthanoids. \
Four natural isotopes exist, and fifteen radioactive isotopes have been \
identified. Used in some rare-earth alloys. The oxidized form is used in the \
glass industry. Discovered by Martin .H. Klaproth in 1803. \"\>"},
                {"\<\"Soft silvery metallic element, belongs to the \
lanthanoids. Only natural isotope is Pr-141 which is not radioactive.Fourteen \
radioactive isotopes have been artificially produced. Used in rare-earth \
alloys. Discovered in 1885 by C.A. von Welsbach. \"\>"},
                {\(". Neodymium should be considered highly toxic, however \
evidence would seem to show that it acts as little more than a skin and eye \
irritant. The dust however, presents a fire and explosion hazard. "\ "Soft \
bright silvery metallic element, belongs to the lanthanoids. Seven natural \
isotopes, Nd-144 being the only radioactive one with a half-life of 10^10 to \
10^15 years. Six artificial radioisotopes have been produced. The metal is \
used in glass works to color glass a shade of violet-purple and make it \
dichroic. One of the more reactive rare-earth metals, quickly reacts with \
air. Used in some rare-earth alloys. Neodymium is used to color the glass \
used in welders' glasses. Neodymium is also used in very powerful, permanent \
magnets (Nd2Fe14B). Discovered by Carl F. Auer von Welsbach in Austria in \
1885 by separating didymium into its elemental components {praseodymium} and \
neodymium. The name comes from the Greek words "\ " which means "\ didymos\ \
neos\ new\ twin\)},
                {"\<\"Soft silvery metallic element, belongs to the \
lanthanoids. Pm-147, the only natural isotope, is radioactive and has a \
half-life of 252 years. Eighteen radioisotopes have been produced, but all \
have very short half-lives. Found only in nuclear decay waste. Pm-147 is of \
interest as a beta-decay source, however Pm-146 and Pm-148 have to be removed \
from it first, as they generate gamma radiation. Discovered by J.A. Marinsky, \
L.E. Glendenin and C.D. Coryell in 1947. \"\>"},
                {"\<\"Soft silvery metallic element, belongs to the \
lanthanoids. Seven natural isotopes, Sm-147 is the only radioisotope, and has \
a half-life of 2.5*10^11 years. Used for making special alloys needed in the \
production of nuclear reactors. Also used as a neutron absorber. Small \
quantities of samarium oxide is used in special optical glasses. The largest \
use of the element is its ferromagnetic alloy which produces permanent \
magnets that are five times stronger than magnets produced by any other \
material. Discovered by Francois Lecoq de Boisbaudran in 1879. \"\>"},
                {"\<\"Soft silvery metallic element belonging to the \
lanthanoids. Eu-151 and Eu-153 are the only two stable isotopes, both of \
which are {neutron} absorbers. Discovered in 1889 by Sir William Crookes. \
\"\>"},
                {"\<\"Soft silvery metallic element belonging to the \
lanthanoids. Seven natural, stable isotopes are known in addition to eleven \
artificial isotopes. Gd-155 and Gd-157 and the best neutron absorbers of all \
elements. Gadolinium compounds are used in electronics. Discovered by J.C.G \
Marignac in 1880. \"\>"},
                {"\<\"Silvery metallic element belonging to the lanthanoids. \
Tb-159 is the only stable isotope, there are seventeen artificial isotopes. \
Discovered by G.G. Mosander in 1843. \"\>"},
                {"\<\"Metallic with a bright silvery-white lustre. Dysprosium \
belongs to the lanthanoids. It is relatively stable in air at room \
temperatures, it will however dissolve in mineral acids, evolving hydrogen. \
It is found in from rare-earth minerals. There are seven natural isotopes of \
dysprosium, and eight radioisotopes, Dy-154 being the most stable with a \
half-life of 3*10^6 years. Dysprosium is used as a neutron absorber in \
nuclear fission reactions, and in compact disks. It was discovered by Paul \
Emile Lecoq de Boisbaudran in 1886 in France. Its name comes from the Greek \
word dysprositos, which means hard to obtain. \"\>"},
                {"\<\"Relatively soft and malleable silvery-white metallic \
element, which is stable in dry air at room temperature. It oxidizes in moist \
air and at high temperatures. It belongs to the lanthanoids. A rare-earth \
metal, it is found in the minerals monazite and gadolinite. It possesses \
unusual magnetic properties. One natural isotope, Ho-165 exists, six \
radioisotopes exist, the most stable being Ho-163 with a half-life of 4570 \
years. Holmium is used in some metal alloys, it is also said to stimulate the \
metabolism. Discovered by Per Theodor Cleve and J.L. Soret in Switzerland in \
1879. The name homium comes from the Greek word Holmia which means Sweden. \
While all holmium compounds should be considered highly toxic, initial \
evidence seems to indicate that they do not pose much danger. The metal's \
dust however, is a fire hazard. \"\>"},
                {"\<\"Soft silvery metallic element which belongs to the \
lanthanoids. Six natural isotopes that are stable. Twelve artificial isotopes \
are known. Used in nuclear technology as a neutron absorber. It is being \
investigated for other possible uses. Discovered by Carl G. Mosander in 1843. \
\"\>"},
                {"\<\"Soft grey metallic element that belongs to the \
lanthanoids. One natural isotope exists, Tm-169, and seventeen artificial \
isotopes have been produced. No known uses for the element. Discovered in \
1879 by Per Theodor Cleve. \"\>"},
                {"\<\"Silvery metallic element of the lanthanoids. Seven \
natural isotopes and ten artificial isotopes are known.Used in certain \
steels. Discovered by J.D.G. Marignac in 1878. \"\>"},
                {"\<\"Silvery-white rare-earth metal which is relatively \
stable in air. It happens to be the most expensive rare-earth metal. Its \
found with almost all rare-earth metals, but is very difficult to separate \
from other elements. Least abundant of all natural elements. Used in metal \
alloys, and as a catalyst in various processes. There are two natural, stable \
isotopes, and seven radioisotopes, the most stable being Lu-174 with a \
half-life of 3.3 years. The separation of lutetium from {ytterbium} was \
described by Georges Urbain in 1907. It was discovered at approximately the \
same time by Carl Auer von Welsbach. The name comes from the Greek word \
lutetia which means Paris. \"\>"},
                {"\<\"Silvery lustrous metallic transition element. Used in \
tungsten alloys in filaments and electrodes, also acts as a neutron absorber. \
First reported by Urbain in 1911, existence was finally established in 1923 \
by D. Coster, G.C. de Hevesy in 1923. \"\>"},
                {"\<\"Heavy blue-grey metallic transition element. Ta-181 is \
a stable isotope, and Ta-180 is a radioactive isotope, with a half-life in \
excess of 10^7 years. Used in surgery as it is unreactive. Forms a passive \
oxide layer in air. Identified in 1802 by Ekeberg and isolated in 1820 by \
Jons J. Berzelius. \"\>"},
                {"\<\"White or grey metallic transition element, formerly \
called {wolfram}. Forms a protective oxide in air and can be oxidized at high \
temperature. First isolated by Jose and Fausto de Elhuyer in 1783. \"\>"},
                {"\<\"Silvery-white metallic transition element. Obtained as \
a by-product of molybdenum refinement. Rhenium-molybdenum alloys are \
superconducting. \"\>"},
                {"\<\"Hard blue-white metallic transition element. Found with \
platinum and used in some alloys with platinum and iridium. \"\>"},
                {"\<\"Very hard and brittle, silvery metallic transition \
element. It has a yellowish cast to it. Salts of iridium are highly colored. \
It is the most corrosion resistant metal known, not attacked by any acid, but \
is attacked by molten salts. There are two natural isotopes of iridium, and 4 \
radioisotopes, the most stable being Ir-192 with a half-life of 73.83 days. \
Ir-192 decays into {platinum}, while the other radioisotopes decay into \
{osmium}. Iridium is used in high temperature apparatus, electrical contacts, \
and as a hardening agent for platinum. Discovered in 1803 by Smithson Tennant \
in England. The name comes from the Greek word iris, which means rainbow. \
Iridium metal is generally non-toxic due to its relative unreactivity, but \
iridium compounds should be considered highly toxic. \"\>"},
                {"\<\"Attractive greyish-white metal. When pure, it is \
malleable and ductile. Does not oxidize in air, insoluble in hydrochloric and \
nitric acid. Corroded by halogens, cyanides, sulphur and alkalis. {Hydrogen} \
and {oxygen} react explosively in the presence of platinum. There are six \
stable isotopes and three radioisotopes, the most stable being Pt-193 with a \
half-life of 60 years. Platinum is used in jewelry, laboratory equipment, \
electrical contacts, dentistry, and anti-pollution devices in cars. \
PtCl2(NH3)2 is used to treat some forms of cancer. Platinum-{cobalt} alloys \
have magnetic properties. It is also used in the definition of the Standard \
Hydrogen Electrode. Discovered by Antonio de Ulloa in South America in 1735. \
The name comes from the Spanish word platina which means silver. Platinum \
metal is generally not a health concern due to its unreactivity, however \
platinum compounds should be considered highly toxic. \"\>"},
                {"\<\"Gold is gold colored. It is the most malleable and \
ductile metal known. There is only one stable isotope of gold, and five \
radioisotopes of gold, Au-195 being the most stable with a half-life of 186 \
days. Gold is used as a monetary standard, in jewelry, dentistry, \
electronics. Au-198 is used in treating cancer and some other medical \
conditions. Gold has been known to exist as far back as 2600 BC. Gold comes \
from the Anglo-Saxon word gold. Its symbol, Au, comes from the Latin word \
aurum, which means gold. Gold is not particularly toxic, however it is known \
to cause damage to the liver and kidneys in some. \"\>"},
                {"\<\"Heavy silvery liquid metallic element, belongs to the \
zinc group. Used in thermometers, barometers and other scientific apparatus. \
Less reactive than zinc and cadmium, does not displace hydrogen from acids. \
Forms a number of complexes and organomercury compounds. \"\>"},
                {"\<\"Pure, unreacted thallium appears silvery-white and \
exhibits a metallic lustre. Upon reacting with air, it begins to turn \
bluish-grey and looks like lead. It is very malleable, and can be cut with a \
knife. There are two stable isotopes, and four radioisotopes, Tl-204 being \
the most stable with a half-life of 3.78 years. Thallium sulphate was used as \
a rodenticide. Thallium sulphine's conductivity changes with exposure to \
infrared light, this gives it a use in infrared detectors. Discovered by Sir \
William Crookes via spectroscopy. Its name comes from the Greek word thallos, \
which means green twig. Thallium and its compounds are toxic and can cause \
cancer. \"\>"},
                {"\<\"Heavy dull grey ductile metallic element, belongs to \
group 14. Used in building construction, lead-plate accumulators, bullets and \
shot, and is part of solder, pewter, bearing metals, type metals and fusible \
alloys. \"\>"},
                {"\<\"White crystalline metal with a pink tinge, belongs to \
group 15. Most diamagnetic of all metals and has the lowest thermal \
conductivity of all the elements except mercury. Lead-free bismuth compounds \
are used in cosmetics and medical procedures. Burns in the air and produces a \
blue flame. In 1753, C.G. Junine first demonstrated that it was different \
from lead. \"\>"},
                {"\<\"Rare radioactive metallic element, belongs to group 16 \
of the periodic table. Over 30 known isotopes exist, the most of all \
elements. Po-209 has a half-life of 103 years. Possible uses in heating \
spacecraft. Discovered by Marie Curie in 1898 in a sample of pitchblende. \
\"\>"},
                {"\<\"Radioactive halogen element. Occurs naturally from \
uranium and thorium decay. At least 20 known isotopes. At-210, the most \
stable, has a half-life of 8.3 hours. Synthesized by nuclear bombardment in \
1940 by D.R. Corson, K.R. MacKenzie and E. Segre at the University of \
California. \"\>"},
                {"\<\"Colorless radioactive gaseous element, belongs to the \
noble gases. Of the twenty known isotopes, the most stable is Rn-222 with a \
half-life of 3.8 days. Formed by the radioactive decay of {Radium}-226. Radon \
itself decays into {polonium}. Used in radiotherapy. As a noble gas, it is \
effectively inert, though radon fluoride has been synthesized. First isolated \
in 1908 by Ramsey and Gray. \"\>"},
                {"\<\"Radioactive element, belongs to group 1 of the periodic \
table. Found in uranium and thorium ores. The 22 known isotopes are all \
radioactive, with the most stable being Fr-223. Its existence was confirmed \
in 1939 by Marguerite Perey. \"\>"},
                {"\<\"Radioactive metallic transuranic element, belongs to \
group 2 of the periodic table. Most stable isotope, Ra-226 has a half-life of \
1602 years, which decays into radon. Isolated from pitchblende in 1898 Marie \
and Pierre Curie. \"\>"},
                {"\<\"Silvery radioactive metallic element, belongs to group \
3 of the periodic table. The most stable isotope, Ac-227, has a half-life of \
217 years. Ac-228 (half-life of 6.13 hours) also occurs in nature. There are \
22 other artificial isotopes, all radioactive and having very short \
half-lives. Chemistry similar to lanthanum. Used as a source of alpha \
particles. Discovered by A. Debierne in 1899. \"\>"},
                {"\<\"Grey radioactive metallic element. Belongs to \
actinoids. Found in monazite sand in Brazil, India and the US.Thorium-232 has \
a half-life of 1.39x10^10 years. Can be used as a nuclear fuel for breeder \
reactors. Thorium-232 captures slow {neutron}s and breeds uranium-233. \
Discovered by Jons J. Berzelius in 1829. \"\>"},
                {"\<\"Radioactive metallic element, belongs to the actinoids. \
The most stable isotope, Pa-231 has a half-life of 2.43*10^4 years. At least \
10 other radioactive isotopes are known. No practical applications are known. \
Discovered in 1917 by Lise Meitner and Otto Hahn. \"\>"},
                {"\<\"White radioactive metallic element belonging to the \
actinoids. Three natural isotopes, U-238, U-235 and U-234. Uranium-235 is \
used as the fuel for nuclear reactors and weapons. Discovered by Martin H. \
Klaproth in 1789. \"\>"},
                {"\<\"Radioactive metallic transuranic element, belongs to \
the actinoids. Np-237, the most stable isotope, has a half-life of 2.2*10^6 \
years and is a by product of nuclear reactors. The other known isotopes have \
mass numbers 229 through 236, and 238 through 241. Np-236 has a half-life of \
5*10^3 years. First produced by Edwin M. McMillan and P.H. Abelson in 1940. \
\"\>"},
                {"\<\"Dense silvery radioactive metallic transuranic element, \
belongs to the actinoids. Pu-244 is the most stable isotope with a half-life \
of 7.6*10^7 years. Thirteen isotopes are known. Pu-239 is the most important, \
it undergoes nuclear fission with slow neutrons and is hence important to \
nuclear weapons and reactors. Plutonium production is monitored down to the \
gram to prevent military misuse. First produced by Gleen T. Seaborg, Edwin M. \
McMillan, J.W. Kennedy and A.C. Wahl in 1940. \"\>"},
                {"\<\"Radioactive metallic transuranic element, belongs to \
the actinoids. Ten known isotopes. Am-243 is the most stable isotope, with a \
half-life of 7.95*10^3 years. Discovered by Glenn T. Seaborg and associates \
in 1945, it was obtained by bombarding {uranium}-238 with alpha particles. \"\
\>"},
                {"\<\"Radioactive metallic transuranic element. Belongs to \
actinoid series. Nine known isotopes, Cm-247 has a half-life of 1.64*10^7 \
years. First identified by Glenn T. Seaborg and associates in 1944, first \
produced by L.B. Werner and I. Perlman in 1947 by bombarding americium-241 \
with {neutron}s. Named for Marie Curie. \"\>"},
                {"\<\"Radioactive metallic transuranic element. Belongs to \
actinoid series. Eight known isotopes, the most common Bk-247, has a \
half-life of 1.4*10^3 years. First produced by Glenn T. Seaborg and \
associates in 1949 by bombarding americium-241 with alpha particles. \"\>"},
                {"\<\"Radioactive metallic transuranic element. Belongs to \
actinoid series. Cf-251 has a half life of about 700 years. Nine isotopes are \
known. Cf-252 is an intense {neutron} source, which makes it an intense \
{neutron} source and gives it a use in {neutron} activation analysis and a \
possible use as a radiation source in medicine. First produced by Glenn T. \
Seaborg and associates in 1950. \"\>"},
                {"\<\"Appearance is unknown, however it is most probably \
metallic and silver or gray in color. Radioactive metallic transuranic \
element belonging to the actinoids. Es-254 has the longest half-life of the \
eleven known isotopes at 270 days. First identified by Albert Ghiorso and \
associates in the debris of the 1952 hydrogen bomb explosion. In 1961 the \
first microgram quantities of Es-232 were separated. While einsteinium never \
exists naturally, if a sufficient amount was assembled, it would pose a \
radiation hazard. \"\>"},
                {"\<\"Radioactive metallic transuranic element, belongs to \
the actinoids. Ten known isotopes, most stable is Fm-257 with a half-life of \
10 days. First identified by Albert Ghiorso and associates in the debris of \
the first hydrogen-bomb explosion in 1952. \"\>"},
                {"\<\"Radioactive metallic transuranic element. Belongs to \
the actinoid series. Only known isotope, Md-256 has a half-life of 1.3 hours. \
First identified by Glenn T. Seaborg, Albert Ghiorso and associates in 1955. \
Alternative name {unnilunium} has been proposed. Named after the 'inventor' \
of the periodic table, Dmitri Mendeleev. \"\>"},
                {"\<\"Radioactive metallic transuranic element, belongs to \
the actinoids. Seven known isotopes exist, the most stable being No-254 with \
a half-life of 255 seconds. First identified with certainty by Albert Ghiorso \
and Glenn T. Seaborg in 1966. {Unnilbium} has been proposed as an alternative \
name. \"\>"},
                {"\<\"Appearance unknown, however it is most likely \
silvery-white or grey and metallic. Lawrencium is a synthetic rare-earth \
metal. There are eight known radioisotopes, the most stable being Lr-262 with \
a half-life of 3.6 hours. Due to the short half-life of lawrencium, and its \
radioactivity, there are no known uses for it. Identified by Albert Ghiorso \
in 1961 at Berkeley. It was produced by bombarding californium with boron \
ions. The name is temporary {IUPAC} nomenclature, the origin of the name \
comes from Ernest O. Lawrence, the inventor of the cyclotron. If sufficient \
amounts of lawrencium were produced, it would pose a radiation hazard. \
\"\>"},
                {"\<\"Appearance unknown, however it is most likely \
silvery-white or grey and metallic. Lawrencium is a synthetic rare-earth \
metal. There are eight known radioisotopes, the most stable being Lr-262 with \
a half-life of 3.6 hours. Due to the short half-life of lawrencium, and its \
radioactivity, there are no known uses for it. Identified by Albert Ghiorso \
in 1961 at Berkeley. It was produced by bombarding californium with boron \
ions. The name is temporary {IUPAC} nomenclature, the origin of the name \
comes from Ernest O. Lawrence, the inventor of the cyclotron. If sufficient \
amounts of lawrencium were produced, it would pose a radiation hazard. \
\"\>"},
                {"\<\"Appearance unknown, however it is most likely \
silvery-white or grey and metallic. Lawrencium is a synthetic rare-earth \
metal. There are eight known radioisotopes, the most stable being Lr-262 with \
a half-life of 3.6 hours. Due to the short half-life of lawrencium, and its \
radioactivity, there are no known uses for it. Identified by Albert Ghiorso \
in 1961 at Berkeley. It was produced by bombarding californium with boron \
ions. The name is temporary {IUPAC} nomenclature, the origin of the name \
comes from Ernest O. Lawrence, the inventor of the cyclotron. If sufficient \
amounts of lawrencium were produced, it would pose a radiation hazard. \
\"\>"},
                {"\<\"Appearance unknown, however it is most likely \
silvery-white or grey and metallic. Lawrencium is a synthetic rare-earth \
metal. There are eight known radioisotopes, the most stable being Lr-262 with \
a half-life of 3.6 hours. Due to the short half-life of lawrencium, and its \
radioactivity, there are no known uses for it. Identified by Albert Ghiorso \
in 1961 at Berkeley. It was produced by bombarding californium with boron \
ions. The name is temporary {IUPAC} nomenclature, the origin of the name \
comes from Ernest O. Lawrence, the inventor of the cyclotron. If sufficient \
amounts of lawrencium were produced, it would pose a radiation hazard. \
\"\>"},
                {"\<\"Appearance unknown, however it is most likely \
silvery-white or grey and metallic. Lawrencium is a synthetic rare-earth \
metal. There are eight known radioisotopes, the most stable being Lr-262 with \
a half-life of 3.6 hours. Due to the short half-life of lawrencium, and its \
radioactivity, there are no known uses for it. Identified by Albert Ghiorso \
in 1961 at Berkeley. It was produced by bombarding californium with boron \
ions. The name is temporary {IUPAC} nomenclature, the origin of the name \
comes from Ernest O. Lawrence, the inventor of the cyclotron. If sufficient \
amounts of lawrencium were produced, it would pose a radiation hazard. \
\"\>"},
                {"\<\"Appearance unknown, however it is most likely \
silvery-white or grey and metallic. Lawrencium is a synthetic rare-earth \
metal. There are eight known radioisotopes, the most stable being Lr-262 with \
a half-life of 3.6 hours. Due to the short half-life of lawrencium, and its \
radioactivity, there are no known uses for it. Identified by Albert Ghiorso \
in 1961 at Berkeley. It was produced by bombarding californium with boron \
ions. The name is temporary {IUPAC} nomenclature, the origin of the name \
comes from Ernest O. Lawrence, the inventor of the cyclotron. If sufficient \
amounts of lawrencium were produced, it would pose a radiation hazard. \
\"\>"},
                {"\<\"Half-life of approximately 5ms. The creation of this \
element demonstrated that fusion techniques could indeed be used to make new, \
heavy nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. \"\>"},
                {"\<\"Half-life of approximately 5ms. The creation of this \
element demonstrated that fusion techniques could indeed be used to make new, \
heavy nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. \"\>"},
                {"\<\"Half-life of approximately 5ms. The creation of this \
element demonstrated that fusion techniques could indeed be used to make new, \
heavy nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. \"\>"},
                {"\<\"Half-life of approximately 5ms. The creation of this \
element demonstrated that fusion techniques could indeed be used to make new, \
heavy nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. \"\>"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{{Hydrogen, Helium, Lithium, Beryllium, Boron, Carbon, 
        Nitrogen, Oxygen, Fluorine, Neon, Sodium, Magnesium, Aluminium, 
        Silicon, Phosphorus, Sulfur, Chlorine, Argon, Potassium, Calcium, 
        Scandium, Titanium, Vanadium, Chromium, Manganese, Iron, Cobalt, 
        Nickel, Copper, Zinc, Gallium, Germanium, Arsenic, Selenium, Bromine, 
        Krypton, Rubidium, Strontium, Yttrium, Zirconium, Niobium, Molybdenum,
         Technetium, Ruthenium, Rhodium, Palladium, Silver, Cadmium, Indium, 
        Tin, Antimony, Tellurium, Iodine, Xenon, Caesium, Barium, Lanthanum, 
        Cerium, Praseodymium, Neodymium, Promethium, Samarium, Europium, 
        Gadolinium, Terbium, Dysprosium, Holmium, Erbium, Thulium, Ytterbium, 
        Lutetium, Hafnium, Tantalum, Tungsten, Rhenium, Osmium, Iridium, 
        Platinum, Gold, Mercury, Thallium, Lead, Bismuth, Polonium, Astatine, 
        Radon, Francium, Radium, Actinium, Thorium, Protactinium, Uranium, 
        Neptunium, Plutonium, Americium, Curium, Berkelium, Californium, 
        Einsteinium, Fermium, Mendelevium, Nobelium, Lawrencium, 
        Rutherfordium, Dubnium, Seaborgium, Bohrium, Hassium, Meitnerium, 
        Ununnilium, Unununium, Ununbium}, {"H", "He", "Li", "Be", "B", "C", 
        "N", "O", "F", "Ne", "Na", "Mg", "Al", "Si", "P", "S", "Cl", "Ar", 
        "K", "Ca", "Sc", "Ti", "V", "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", 
        "Ga", "Ge", "As", "Se", "Br", "Kr", "Rb", "Sr", "Y", "Zr", "Nb", "Mo",
         "Tc", "Ru", "Rh", "Pd", "Ag", "Cd", "In", "Sn", "Sb", "Te", "I", 
        "Xe", "Cs", "Ba", "La", "Ce", "Pr", "Nd", "Pm", "Sm", "Eu", "Gd", 
        "Tb", "Dy", "Ho", "Er", "Tm", "Yb", "Lu", "Hf", "Ta", "W", "Re", "Os",
         "Ir", "Pt", "Au", "Hg", "Tl", "Pb", "Bi", "Po", "At", "Rn", "Fr", 
        "Ra", "Ac", "Th", "Pa", "U", "Np", "Pu", "Am", "Cm", "Bk", "Cf", "Es",
         "Fm", "Md", "No", "Lr", "Rf", "Db", "Sg", "Bh", "Hs", "Mt", "Uun", 
        "Uuu", "Uub"}, {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
         17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
        34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 
        51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 
        68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 
        85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 
        102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112}, {
        "Colourless, odourless gaseous chemical element. Lightest and most \
abundant element in the universe. Present in water and in all organic \
compounds. Chemically reacts with most elements. Discovered by Henry \
Cavendish in 1776. ", 
        "Colourless, odourless gaseous nonmetallic element. Belongs to group \
18 of the periodic table. Lowest boiling point of all elements and can only \
be solidified under pressure. Chemically inert, no known compounds. \
Discovered in the solar spectrum in 1868 by Lockyer. ", 
        "Socket silvery metal. First member of group 1 of the periodic table. \
Lithium salts are used in psychomedicine. ", 
        "Grey metallic element of group 2 of the periodic table. Is toxic and \
can cause severe lung diseases and dermatitis. Shows high covalent character. \
It was isolated independently by F. Wohler and A.A. Bussy in 1828. ", 
        "An element of group 13 of the periodic table. There are two \
allotropes, amorphous boron is a brown power, but metallic boron is black. \
The metallic form is hard (9.3 on Mohs' scale) and a bad conductor in room \
temperatures. It is never found free in nature. Boron-10 is used in nuclear \
reactor control rods and shields. It was discovered in 1808 by Sir Humphry \
Davy and by J.L. Gay-Lussac and L.J. Thenard. ", 
        "Carbon is a member of group 14 of the periodic table. It has three \
allotropic forms of it, diamonds, graphite and fullerite. Carbon-14 is \
commonly used in radioactive dating. Carbon occurs in all organic life and is \
the basis of organic chemistry. Carbon has the interesting chemical property \
of being able to bond with itself, and a wide variety of other elements. ", 
        "Colourless, gaseous element which belongs to group 15 of the \
periodic table. Constitutes ~78% of the atmosphere and is an essential part \
of the ecosystem. Nitrogen for industrial purposes is acquired by the \
fractional distillation of liquid air. Chemically inactive, reactive \
generally only at high temperatures or in electrical discharges. It was \
discovered in 1772 by D. Rutherford. ", 
        "A colourless, odourless gaseous element belonging to group 16 of the \
periodic table. It is the most abundant element present in the earth's crust. \
It also makes up 20.8% of the Earth's atmosphere. For industrial purposes, it \
is separated from liquid air by fractional distillation. It is used in high \
temperature welding, and in breathing. It commonly comes in the form of \
Oxygen, but is found as Ozone in the upper atmosphere. It was discovered by \
Priestley in 1774. ", 
        "A poisonous pale yellow gaseous element belonging to group 17 of the \
periodic table (The halogens). It is the most chemically reactive and \
electronegative element. It is highly dangerous, causing severe chemical \
burns on contact with flesh. Fluorine was identified by Scheele in 1771 and \
first isolated by Moissan in 1886. ", 
        "Colourless gaseous element of group 18 on the periodic table (noble \
gases). Neon occurs in the atmosphere, and comprises 0.0018% of the volume of \
the atmosphere. It has a distinct reddish glow when used in discharge tubes \
and neon based lamps. It forms almost no chemical compounds. Neon was \
discovered in 1898 by Sir William Ramsey and M.W. Travers. ", 
        "Soft silvery reactive element belonging to group 1 of the periodic \
table (alkali metals). It is highly reactive, oxidizing in air and reacting \
violently with water, forcing it to be kept under oil. It was first isolated \
by Humphrey Davy in 1807. ", 
        "Silvery metallic element belonging to group 2 of the periodic table \
(alkaline-earth metals). It is essential for living organisms, and is used in \
a number of light alloys. Chemically very reactive, it forms a protective \
oxide coating when exposed to air and burns with an intense white flame. It \
also reacts with sulphur, nitrogen and the halogens. First isolated by Bussy \
in 1828. ", 
        "Silvery metallic element belonging to group 2 of the periodic table \
(alkaline-earth metals). It is essential for living organisms, and is used in \
a number of light alloys. Chemically very reactive, it forms a protective \
oxide coating when exposed to air and burns with an intense white flame. It \
also reacts with sulphur, nitrogen and the halogens. First isolated by Bussy \
in 1828. ", 
        "Metalloid element belonging to group 14 of the periodic table. It is \
the second most abundant element in the Earth's crust, making up 25.7% of it \
by weight. Chemically less reactive than carbon. First identified by \
Lavoisier in 1787 and first isolated in 1823 by Berzelius. ", 
        "Non-metallic element belonging to group 15 of the periodic table. \
Has a multiple allotropic forms. Essential element for living organisms. It \
was discovered by Brandt in 1669. ", 
        "Non-metallic element belonging to group 15 of the periodic table. \
Has a multiple allotropic forms. Essential element for living organisms. It \
was discovered by Brandt in 1669. ", 
        "Halogen element. Poisonous greenish-yellow gas. Occurs widely in \
nature as sodium chloride in seawater. Reacts directly with many elements and \
compounds, strong oxidizing agent. Discovered by Karl Scheele in 1774. \
Humphrey David confirmed it as an element in 1810. ", 
        "Monatomic noble gas. Makes up 0.93% of the air. Colourless, \
odorless. Is inert and has no true compounds. Lord Rayleigh and Sir William \
Ramsey identified argon in 1894. ", 
        "Soft silvery metallic element belonging to group 1 of the periodic \
table (alkali metals). Occurs naturally in seawater and a many minerals. \
Highly reactive, chemically, it resembles sodium in its behavior and \
compounds. Discovered by Sir Humphry Davy in 1807. ", 
        "Soft grey metallic element belonging to group 2 of the periodic \
table. Used a reducing agent in the extraction of thorium, zirconium and \
uranium. Essential element for living organisms. ", 
        "Rare soft silvery metallic element belonging to group 3 of the \
periodic table. There are ten isotopes, nine of which are radioactive and \
have short half-lives. Predicted in 1869 by Mendeleev, isolated by Nilson in \
1879. ", "White metallic transition element. Occurs in numerous minerals. \
Used in strong, light corrosion-resistant alloys. Forms a passive oxide \
coating when exposed to air. First discovered by Gregor in 1789. ", 
        "Soft and ductile, bright white metal. Good resistance to corrosion \
by alkalis, sulphuric and hydrochloric acid. It oxidizes readily about 933K. \
There are two naturally occurring isotopes of vanadium, and 5 radioisotopes, \
V-49 having the longest half-life at 337 days. Vanadium has nuclear \
applications, the foil is used in cladding titanium to steel, and \
vanadium-gallium tape is used to produce a superconductive magnet. Originally \
discovered by Andres Manuel del Rio of Mexico City in 1801. His discovery \
went unheeded, however, and in 1820, Nils Gabriel Sefstron of Sweden \
rediscovered it. Metallic vanadium was isolated by Henry Enfield Roscoe in \
1867. The name vanadium comes from {Vanadis}, a goddess of Scandinavian \
mythology. Silvery-white metallic transition element. Vanadium is essential \
to {ascidian}s. Rats and chickens are also known to require it. Metal powder \
is a fire hazard, and vanadium compounds should be considered highly toxic. \
May cause lung cancer if inhaled. ", 
        "Hard silvery transition element. Used in decorative electroplating. \
Discovered in 1797 by Vauquelin. ", 
        "Grey brittle metallic transition element. Rather electropositive, \
combines with some non-metals when heated. Discovered in 1774 by Scheele. ", 
        "Silvery malleable and ductile metallic transition element. Has nine \
isotopes and is the fourth most abundant element in the earth's crust. \
Required by living organisms as a trace element (used in hemoglobin in \
humans.) Quite reactive, oxidizes in moist air, displaces hydrogen from \
dilute acids and combines with nonmetallic elements. ", 
        "Light grey transition element. Some meteorites contain small amounts \
of metallic cobalt. Generally alloyed for use. Mammals require small amounts \
of cobalt salts. Cobalt-60, an artificially produced radioactive isotope of \
Cobalt is an important radioactive tracer and cancer-treatment agent. \
Discovered by G. Brandt in 1737. ", 
        "Malleable ductile silvery metallic transition element. Discovered by \
A.F. Cronstedt in 1751. ", 
        "Red-brown transition element. Known by the Romans as 'cuprum.' \
Extracted and used for thousands of years. Malleable, ductile and an \
excellent conductor of heat and electricity. When in moist conditions, a \
greenish layer forms on the outside. ", 
        "Blue-white metallic element. Occurs in multiple compounds naturally. \
Five stable isotopes and six radioactive isotopes have been found. Chemically \
a reactive metal, combines with oxygen and other non-metals, reacts with \
dilute acids to release hydrogen. ", 
        "Soft silvery metallic element, belongs to group 13 of the periodic \
table. The two stable isotopes are Ga-69 and Ga-71. Eight radioactive \
isotopes are known, all having short half-lives. Gallium Arsenide is used as \
a semiconductor. Corrodes most other metals by diffusing into their lattice. \
First identified by Francois Lecoq de Boisbaudran in 1875. ", 
        "Lustrous hard metalloid element, belongs to group 14 of the periodic \
table. Forms a large number of organometallic compounds. Predicted by \
Mendeleev in 1871, it was actually found in 1886 by Winkler. ", 
        "Metalloid element of group 15. There are three allotropes, yellow, \
black, and grey. Reacts with halogens, concentrated oxidizing acids and hot \
alkalis. Albertus Magnus is believed to have been the first to isolate the \
element in 1250. ", 
        "Metalloid element, belongs to group 16 of the periodic table. \
Multiple allotropic forms exist. Chemically resembles sulphur. Discovered in \
1817 by Jons J. Berzelius. ", 
        "Halogen element. Red volatile liquid at room temperature. Its \
reactivity is somewhere between chlorine and iodine. Harmful to human tissue \
in a liquid state, the vapour irritates eyes and throat. Discovered in 1826 \
by Antoine Balard. ", 
        "Colorless gaseous element, belongs to the noble gases. Occurs in the \
air, 0.0001% by volume. It can be extracted from liquid air by fractional \
distillation. Generally not isolated, but used with other inert gases in \
fluorescent lamps. Five natural isotopes, and five radioactive isotopes. \
Kr-85, the most stable radioactive isotope, has a half-life of 10.76 years \
and is produced in fission reactors. Practically inert, though known to form \
compounds with {fluorine}. ", 
        "Soft silvery metallic element, belongs to group 1 of the periodic \
table. Rb-97, the naturally occurring isotope, is radioactive. It is highly \
reactive, with properties similar to other elements in group 1, like igniting \
spontaneously in air. Discovered spectroscopically in 1861 by W. Bunsen and \
G.R. Kirchoff. ", 
        "Soft yellowish metallic element, belongs to group 2 of the periodic \
table. Highly reactive chemically. Sr-90 is present in radioactive fallout \
and has a half-life of 28 years. Discovered in 1798 by Klaproth and Hope, \
isolated in 1808 by Humphry Davy. ", 
        "Silvery-grey metallic element of group 3 on the periodic table. \
Found in uranium ores. The only natural isotope is Y-89, there are 14 other \
artificial isotopes. Chemically resembles the lanthanoids. Stable in the air \
below 400 degrees, celsius. Discovered in 1828 by Friedrich Wohler. ", 
        "Grey-white metallic transition element. Five natural isotopes and \
six radioactive isotopes are known. Used in nuclear reactors for a {neutron} \
absorber. Discovered in 1789 by Martin Klaproth, isolated in 1824 by \
Berzelius. ", 
        "Soft, ductile grey-blue metallic transition element. Used in special \
steels and in welded joints to increase strength. Combines with halogens and \
oxidizes in air at 200 degrees celsius. Discovered by Charles Hatchett in \
1801 and isolated by Blomstrand in 1864. Called {columbium} originally. ", 
        "Silvery-white, hard metallic transition element. It is chemically \
unreactive and is not affected by most acids. It oxidizes at high \
temperatures. There are seven natural isotopes, and four radioisotopes, Mo-93 \
being the most stable with a half-life of 3500 years. Molybdenum is used in \
almost all high-strength steels, it has nuclear applications, and is a \
catalyst in petroleum refining. Discovered in 1778 by Carl Welhelm Scheele of \
Sweden. Impure metal was prepared in 1782 by Peter Jacob Hjelm. The name \
comes from the Greek word molybdos which means lead. Trace amounts of \
molybdenum are required for all known forms of life. All molybdenum compounds \
should be considered highly toxic, and will also cause severe birth defects. \
", "Radioactive metallic transition element. Can be detected in some stars \
and the fission products of uranium. First made by Perrier and Segre by \
bombarding molybdenum with deutrons, giving them Tc-97. Tc-99 is the most \
stable isotope with a half-life of 2.6*10^6 years. Sixteen isotopes are \
known. Organic technetium compounds are used in bone imaging. Chemical \
properties are intermediate between rhenium and manganese. ", 
        "Hard white metallic transition element. Found with platinum, used as \
a catalyst in some platinum alloys. Dissolves in fused alkalis, and is not \
attacked by acids. Reacts with halogens and oxygen at high temperatures. \
Isolated in 1844 by K.K. Klaus. ", 
        "Silvery white metallic transition element. Found with platinum and \
used in some platinum alloys. Not attacked by acids, dissolves only in aqua \
regia. Discovered in 1803 by W.H. Wollaston. ", 
        "Soft white ductile transition element. Found with some copper and \
nickel ores. Does not react with oxygen at normal temperatures. Dissolves \
slowly in hydrochloric acid. Discovered in 1803 by W.H. Wollaston. ", 
        "White lustrous soft metallic transition element. Found in both its \
elemental form and in minerals. Used in jewelry, tableware and so on. Less \
reactive than silver, chemically. ", 
        "Soft bluish metal belonging to group 12 of the periodic table. \
Extremely toxic even in low concentrations. Chemically similar to zinc, but \
lends itself to more complex compounds. Discovered in 1817 by F. Stromeyer. ",
         "Soft silvery element belonging to group 13 of the periodic table. \
The most common natural isotope is In-115, which has a half-life of 6*10^4 \
years. Five other radioisotopes exist. Discovered in 1863 by Reich and \
Richter. ", 
        "Silvery malleable metallic element belonging to group 14 of the \
periodic table. Twenty-six isotopes are known, five of which are radioactive. \
Chemically reactive. Combines directly with chlorine and oxygen and displaces \
hydrogen from dilute acids. ", 
        "Element of group 15. Multiple allotropic forms. The stable form of \
antimony is a blue-white metal. Yellow and black antimony are unstable \
non-metals. Used in flame-proofing, paints, ceramics, enamels, and rubber. \
Attacked by oxidizing acids and halogens. First reported by Tholden in 1450. \
", "Silvery metalloid element of group 16. Eight natural isotopes, nine \
radioactive isotopes. Used in semiconductors and to a degree in some steels. \
Chemistry is similar to {sulphur}. Discovered in 1782 by Franz Miller. ", 
        "Dark violet nonmetallic element, belongs to group 17 of the periodic \
table. Insoluble in water. Required as a trace element for living organisms. \
One stable isotope, I-127 exists, in addition to fourteen radioactive \
isotopes. Chemically the least reactive of the halogens, and the most \
electropositive metallic halogen. Discovered in 1812 by Courtois. ", 
        "Colourless, odourless gas belonging to group 18 on the periodic \
table (the noble gases.) Nine natural isotopes and seven radioactive isotopes \
are known. Xenon was part of the first noble-gas compound synthesized. \
Several others involving Xenon have been found since then. Xenon was \
discovered by Ramsey and Travers in 1898. ", 
        "Soft silvery-white metallic element belonging to group 1 of the \
periodic table. One of the three metals which are liquid at room temperature. \
Cs-133 is the natural, and only stable, isotope. Fifteen other radioisotopes \
exist. Caesium reacts explosively with cold water, and ice at temperatures \
above 157K. Caesium hydroxide is the strongest base known. Caesium is the \
most electropositive, most alkaline and has the least ionization potential of \
all the elements. Known uses include the basis of atomic clocks, catalyst for \
the hydrogenation of some organic compounds, and in photoelectric cells. \
Caesium was discovered by Gustav Kirchoff and Robert Bunsen in Germany in \
1860 spectroscopically. Its identification was based upon the bright blue \
lines in its spectrum. The name comes from the latin word caesius, which \
means sky blue. Caesium should be considered highly toxic. Some of the \
radioisotopes are even more toxic. ", 
        "Silvery-white reactive element, belonging to group 2 of the periodic \
table. Soluble barium compounds are extremely poisonous. Identified in 1774 \
by Karl Scheele and extracted in 1808 by Humphry Davy. ", 
        "(From the Greek word lanthanein, to lie hidden) Silvery metallic \
element belonging to group 3 of the periodic table and oft considered to be \
one of the lanthanoids. Found in some rare-earth minerals. Twenty-five \
natural isotopes exist. La-139 which is stable, and La-138 which has a \
half-life of 10^10 to 10^15 years. The other twenty-three isotopes are \
radioactive. It resembles the lanthanoids chemically. Lanthanum has a low to \
moderate level of toxicity, and should be handled with care. Discovered in \
1839 by C.G. Mosander. ", 
        "Silvery metallic element, belongs to the lanthanoids. Four natural \
isotopes exist, and fifteen radioactive isotopes have been identified. Used \
in some rare-earth alloys. The oxidized form is used in the glass industry. \
Discovered by Martin .H. Klaproth in 1803. ", 
        "Soft silvery metallic element, belongs to the lanthanoids. Only \
natural isotope is Pr-141 which is not radioactive.Fourteen radioactive \
isotopes have been artificially produced. Used in rare-earth alloys. \
Discovered in 1885 by C.A. von Welsbach. ", 
        Times[ 
        ". Neodymium should be considered highly toxic, however evidence \
would seem to show that it acts as little more than a skin and eye irritant. \
The dust however, presents a fire and explosion hazard. ", 
          "Soft bright silvery metallic element, belongs to the lanthanoids. \
Seven natural isotopes, Nd-144 being the only radioactive one with a \
half-life of 10^10 to 10^15 years. Six artificial radioisotopes have been \
produced. The metal is used in glass works to color glass a shade of \
violet-purple and make it dichroic. One of the more reactive rare-earth \
metals, quickly reacts with air. Used in some rare-earth alloys. Neodymium is \
used to color the glass used in welders' glasses. Neodymium is also used in \
very powerful, permanent magnets (Nd2Fe14B). Discovered by Carl F. Auer von \
Welsbach in Austria in 1885 by separating didymium into its elemental \
components {praseodymium} and neodymium. The name comes from the Greek words \
", " which means ", didymos, neos, new, twin], 
        "Soft silvery metallic element, belongs to the lanthanoids. Pm-147, \
the only natural isotope, is radioactive and has a half-life of 252 years. \
Eighteen radioisotopes have been produced, but all have very short \
half-lives. Found only in nuclear decay waste. Pm-147 is of interest as a \
beta-decay source, however Pm-146 and Pm-148 have to be removed from it \
first, as they generate gamma radiation. Discovered by J.A. Marinsky, L.E. \
Glendenin and C.D. Coryell in 1947. ", 
        "Soft silvery metallic element, belongs to the lanthanoids. Seven \
natural isotopes, Sm-147 is the only radioisotope, and has a half-life of \
2.5*10^11 years. Used for making special alloys needed in the production of \
nuclear reactors. Also used as a neutron absorber. Small quantities of \
samarium oxide is used in special optical glasses. The largest use of the \
element is its ferromagnetic alloy which produces permanent magnets that are \
five times stronger than magnets produced by any other material. Discovered \
by Francois Lecoq de Boisbaudran in 1879. ", 
        "Soft silvery metallic element belonging to the lanthanoids. Eu-151 \
and Eu-153 are the only two stable isotopes, both of which are {neutron} \
absorbers. Discovered in 1889 by Sir William Crookes. ", 
        "Soft silvery metallic element belonging to the lanthanoids. Seven \
natural, stable isotopes are known in addition to eleven artificial isotopes. \
Gd-155 and Gd-157 and the best neutron absorbers of all elements. Gadolinium \
compounds are used in electronics. Discovered by J.C.G Marignac in 1880. ", 
        "Silvery metallic element belonging to the lanthanoids. Tb-159 is the \
only stable isotope, there are seventeen artificial isotopes. Discovered by \
G.G. Mosander in 1843. ", 
        "Metallic with a bright silvery-white lustre. Dysprosium belongs to \
the lanthanoids. It is relatively stable in air at room temperatures, it will \
however dissolve in mineral acids, evolving hydrogen. It is found in from \
rare-earth minerals. There are seven natural isotopes of dysprosium, and \
eight radioisotopes, Dy-154 being the most stable with a half-life of 3*10^6 \
years. Dysprosium is used as a neutron absorber in nuclear fission reactions, \
and in compact disks. It was discovered by Paul Emile Lecoq de Boisbaudran in \
1886 in France. Its name comes from the Greek word dysprositos, which means \
hard to obtain. ", 
        "Relatively soft and malleable silvery-white metallic element, which \
is stable in dry air at room temperature. It oxidizes in moist air and at \
high temperatures. It belongs to the lanthanoids. A rare-earth metal, it is \
found in the minerals monazite and gadolinite. It possesses unusual magnetic \
properties. One natural isotope, Ho-165 exists, six radioisotopes exist, the \
most stable being Ho-163 with a half-life of 4570 years. Holmium is used in \
some metal alloys, it is also said to stimulate the metabolism. Discovered by \
Per Theodor Cleve and J.L. Soret in Switzerland in 1879. The name homium \
comes from the Greek word Holmia which means Sweden. While all holmium \
compounds should be considered highly toxic, initial evidence seems to \
indicate that they do not pose much danger. The metal's dust however, is a \
fire hazard. ", 
        "Soft silvery metallic element which belongs to the lanthanoids. Six \
natural isotopes that are stable. Twelve artificial isotopes are known. Used \
in nuclear technology as a neutron absorber. It is being investigated for \
other possible uses. Discovered by Carl G. Mosander in 1843. ", 
        "Soft grey metallic element that belongs to the lanthanoids. One \
natural isotope exists, Tm-169, and seventeen artificial isotopes have been \
produced. No known uses for the element. Discovered in 1879 by Per Theodor \
Cleve. ", 
        "Silvery metallic element of the lanthanoids. Seven natural isotopes \
and ten artificial isotopes are known.Used in certain steels. Discovered by \
J.D.G. Marignac in 1878. ", 
        "Silvery-white rare-earth metal which is relatively stable in air. It \
happens to be the most expensive rare-earth metal. Its found with almost all \
rare-earth metals, but is very difficult to separate from other elements. \
Least abundant of all natural elements. Used in metal alloys, and as a \
catalyst in various processes. There are two natural, stable isotopes, and \
seven radioisotopes, the most stable being Lu-174 with a half-life of 3.3 \
years. The separation of lutetium from {ytterbium} was described by Georges \
Urbain in 1907. It was discovered at approximately the same time by Carl Auer \
von Welsbach. The name comes from the Greek word lutetia which means Paris. ",
         "Silvery lustrous metallic transition element. Used in tungsten \
alloys in filaments and electrodes, also acts as a neutron absorber. First \
reported by Urbain in 1911, existence was finally established in 1923 by D. \
Coster, G.C. de Hevesy in 1923. ", 
        "Heavy blue-grey metallic transition element. Ta-181 is a stable \
isotope, and Ta-180 is a radioactive isotope, with a half-life in excess of \
10^7 years. Used in surgery as it is unreactive. Forms a passive oxide layer \
in air. Identified in 1802 by Ekeberg and isolated in 1820 by Jons J. \
Berzelius. ", 
        "White or grey metallic transition element, formerly called \
{wolfram}. Forms a protective oxide in air and can be oxidized at high \
temperature. First isolated by Jose and Fausto de Elhuyer in 1783. ", 
        "Silvery-white metallic transition element. Obtained as a by-product \
of molybdenum refinement. Rhenium-molybdenum alloys are superconducting. ", 
        "Hard blue-white metallic transition element. Found with platinum and \
used in some alloys with platinum and iridium. ", 
        "Very hard and brittle, silvery metallic transition element. It has a \
yellowish cast to it. Salts of iridium are highly colored. It is the most \
corrosion resistant metal known, not attacked by any acid, but is attacked by \
molten salts. There are two natural isotopes of iridium, and 4 radioisotopes, \
the most stable being Ir-192 with a half-life of 73.83 days. Ir-192 decays \
into {platinum}, while the other radioisotopes decay into {osmium}. Iridium \
is used in high temperature apparatus, electrical contacts, and as a \
hardening agent for platinum. Discovered in 1803 by Smithson Tennant in \
England. The name comes from the Greek word iris, which means rainbow. \
Iridium metal is generally non-toxic due to its relative unreactivity, but \
iridium compounds should be considered highly toxic. ", 
        "Attractive greyish-white metal. When pure, it is malleable and \
ductile. Does not oxidize in air, insoluble in hydrochloric and nitric acid. \
Corroded by halogens, cyanides, sulphur and alkalis. {Hydrogen} and {oxygen} \
react explosively in the presence of platinum. There are six stable isotopes \
and three radioisotopes, the most stable being Pt-193 with a half-life of 60 \
years. Platinum is used in jewelry, laboratory equipment, electrical \
contacts, dentistry, and anti-pollution devices in cars. PtCl2(NH3)2 is used \
to treat some forms of cancer. Platinum-{cobalt} alloys have magnetic \
properties. It is also used in the definition of the Standard Hydrogen \
Electrode. Discovered by Antonio de Ulloa in South America in 1735. The name \
comes from the Spanish word platina which means silver. Platinum metal is \
generally not a health concern due to its unreactivity, however platinum \
compounds should be considered highly toxic. ", 
        "Gold is gold colored. It is the most malleable and ductile metal \
known. There is only one stable isotope of gold, and five radioisotopes of \
gold, Au-195 being the most stable with a half-life of 186 days. Gold is used \
as a monetary standard, in jewelry, dentistry, electronics. Au-198 is used in \
treating cancer and some other medical conditions. Gold has been known to \
exist as far back as 2600 BC. Gold comes from the Anglo-Saxon word gold. Its \
symbol, Au, comes from the Latin word aurum, which means gold. Gold is not \
particularly toxic, however it is known to cause damage to the liver and \
kidneys in some. ", 
        "Heavy silvery liquid metallic element, belongs to the zinc group. \
Used in thermometers, barometers and other scientific apparatus. Less \
reactive than zinc and cadmium, does not displace hydrogen from acids. Forms \
a number of complexes and organomercury compounds. ", 
        "Pure, unreacted thallium appears silvery-white and exhibits a \
metallic lustre. Upon reacting with air, it begins to turn bluish-grey and \
looks like lead. It is very malleable, and can be cut with a knife. There are \
two stable isotopes, and four radioisotopes, Tl-204 being the most stable \
with a half-life of 3.78 years. Thallium sulphate was used as a rodenticide. \
Thallium sulphine's conductivity changes with exposure to infrared light, \
this gives it a use in infrared detectors. Discovered by Sir William Crookes \
via spectroscopy. Its name comes from the Greek word thallos, which means \
green twig. Thallium and its compounds are toxic and can cause cancer. ", 
        "Heavy dull grey ductile metallic element, belongs to group 14. Used \
in building construction, lead-plate accumulators, bullets and shot, and is \
part of solder, pewter, bearing metals, type metals and fusible alloys. ", 
        "White crystalline metal with a pink tinge, belongs to group 15. Most \
diamagnetic of all metals and has the lowest thermal conductivity of all the \
elements except mercury. Lead-free bismuth compounds are used in cosmetics \
and medical procedures. Burns in the air and produces a blue flame. In 1753, \
C.G. Junine first demonstrated that it was different from lead. ", 
        "Rare radioactive metallic element, belongs to group 16 of the \
periodic table. Over 30 known isotopes exist, the most of all elements. \
Po-209 has a half-life of 103 years. Possible uses in heating spacecraft. \
Discovered by Marie Curie in 1898 in a sample of pitchblende. ", 
        "Radioactive halogen element. Occurs naturally from uranium and \
thorium decay. At least 20 known isotopes. At-210, the most stable, has a \
half-life of 8.3 hours. Synthesized by nuclear bombardment in 1940 by D.R. \
Corson, K.R. MacKenzie and E. Segre at the University of California. ", 
        "Colorless radioactive gaseous element, belongs to the noble gases. \
Of the twenty known isotopes, the most stable is Rn-222 with a half-life of \
3.8 days. Formed by the radioactive decay of {Radium}-226. Radon itself \
decays into {polonium}. Used in radiotherapy. As a noble gas, it is \
effectively inert, though radon fluoride has been synthesized. First isolated \
in 1908 by Ramsey and Gray. ", 
        "Radioactive element, belongs to group 1 of the periodic table. Found \
in uranium and thorium ores. The 22 known isotopes are all radioactive, with \
the most stable being Fr-223. Its existence was confirmed in 1939 by \
Marguerite Perey. ", 
        "Radioactive metallic transuranic element, belongs to group 2 of the \
periodic table. Most stable isotope, Ra-226 has a half-life of 1602 years, \
which decays into radon. Isolated from pitchblende in 1898 Marie and Pierre \
Curie. ", 
        "Silvery radioactive metallic element, belongs to group 3 of the \
periodic table. The most stable isotope, Ac-227, has a half-life of 217 \
years. Ac-228 (half-life of 6.13 hours) also occurs in nature. There are 22 \
other artificial isotopes, all radioactive and having very short half-lives. \
Chemistry similar to lanthanum. Used as a source of alpha particles. \
Discovered by A. Debierne in 1899. ", 
        "Grey radioactive metallic element. Belongs to actinoids. Found in \
monazite sand in Brazil, India and the US.Thorium-232 has a half-life of \
1.39x10^10 years. Can be used as a nuclear fuel for breeder reactors. \
Thorium-232 captures slow {neutron}s and breeds uranium-233. Discovered by \
Jons J. Berzelius in 1829. ", 
        "Radioactive metallic element, belongs to the actinoids. The most \
stable isotope, Pa-231 has a half-life of 2.43*10^4 years. At least 10 other \
radioactive isotopes are known. No practical applications are known. \
Discovered in 1917 by Lise Meitner and Otto Hahn. ", 
        "White radioactive metallic element belonging to the actinoids. Three \
natural isotopes, U-238, U-235 and U-234. Uranium-235 is used as the fuel for \
nuclear reactors and weapons. Discovered by Martin H. Klaproth in 1789. ", 
        "Radioactive metallic transuranic element, belongs to the actinoids. \
Np-237, the most stable isotope, has a half-life of 2.2*10^6 years and is a \
by product of nuclear reactors. The other known isotopes have mass numbers \
229 through 236, and 238 through 241. Np-236 has a half-life of 5*10^3 years. \
First produced by Edwin M. McMillan and P.H. Abelson in 1940. ", 
        "Dense silvery radioactive metallic transuranic element, belongs to \
the actinoids. Pu-244 is the most stable isotope with a half-life of 7.6*10^7 \
years. Thirteen isotopes are known. Pu-239 is the most important, it \
undergoes nuclear fission with slow neutrons and is hence important to \
nuclear weapons and reactors. Plutonium production is monitored down to the \
gram to prevent military misuse. First produced by Gleen T. Seaborg, Edwin M. \
McMillan, J.W. Kennedy and A.C. Wahl in 1940. ", 
        "Radioactive metallic transuranic element, belongs to the actinoids. \
Ten known isotopes. Am-243 is the most stable isotope, with a half-life of \
7.95*10^3 years. Discovered by Glenn T. Seaborg and associates in 1945, it \
was obtained by bombarding {uranium}-238 with alpha particles. ", 
        "Radioactive metallic transuranic element. Belongs to actinoid \
series. Nine known isotopes, Cm-247 has a half-life of 1.64*10^7 years. First \
identified by Glenn T. Seaborg and associates in 1944, first produced by L.B. \
Werner and I. Perlman in 1947 by bombarding americium-241 with {neutron}s. \
Named for Marie Curie. ", 
        "Radioactive metallic transuranic element. Belongs to actinoid \
series. Eight known isotopes, the most common Bk-247, has a half-life of \
1.4*10^3 years. First produced by Glenn T. Seaborg and associates in 1949 by \
bombarding americium-241 with alpha particles. ", 
        "Radioactive metallic transuranic element. Belongs to actinoid \
series. Cf-251 has a half life of about 700 years. Nine isotopes are known. \
Cf-252 is an intense {neutron} source, which makes it an intense {neutron} \
source and gives it a use in {neutron} activation analysis and a possible use \
as a radiation source in medicine. First produced by Glenn T. Seaborg and \
associates in 1950. ", 
        "Appearance is unknown, however it is most probably metallic and \
silver or gray in color. Radioactive metallic transuranic element belonging \
to the actinoids. Es-254 has the longest half-life of the eleven known \
isotopes at 270 days. First identified by Albert Ghiorso and associates in \
the debris of the 1952 hydrogen bomb explosion. In 1961 the first microgram \
quantities of Es-232 were separated. While einsteinium never exists \
naturally, if a sufficient amount was assembled, it would pose a radiation \
hazard. ", 
        "Radioactive metallic transuranic element, belongs to the actinoids. \
Ten known isotopes, most stable is Fm-257 with a half-life of 10 days. First \
identified by Albert Ghiorso and associates in the debris of the first \
hydrogen-bomb explosion in 1952. ", 
        "Radioactive metallic transuranic element. Belongs to the actinoid \
series. Only known isotope, Md-256 has a half-life of 1.3 hours. First \
identified by Glenn T. Seaborg, Albert Ghiorso and associates in 1955. \
Alternative name {unnilunium} has been proposed. Named after the 'inventor' \
of the periodic table, Dmitri Mendeleev. ", 
        "Radioactive metallic transuranic element, belongs to the actinoids. \
Seven known isotopes exist, the most stable being No-254 with a half-life of \
255 seconds. First identified with certainty by Albert Ghiorso and Glenn T. \
Seaborg in 1966. {Unnilbium} has been proposed as an alternative name. ", 
        "Appearance unknown, however it is most likely silvery-white or grey \
and metallic. Lawrencium is a synthetic rare-earth metal. There are eight \
known radioisotopes, the most stable being Lr-262 with a half-life of 3.6 \
hours. Due to the short half-life of lawrencium, and its radioactivity, there \
are no known uses for it. Identified by Albert Ghiorso in 1961 at Berkeley. \
It was produced by bombarding californium with boron ions. The name is \
temporary {IUPAC} nomenclature, the origin of the name comes from Ernest O. \
Lawrence, the inventor of the cyclotron. If sufficient amounts of lawrencium \
were produced, it would pose a radiation hazard. ", 
        "Appearance unknown, however it is most likely silvery-white or grey \
and metallic. Lawrencium is a synthetic rare-earth metal. There are eight \
known radioisotopes, the most stable being Lr-262 with a half-life of 3.6 \
hours. Due to the short half-life of lawrencium, and its radioactivity, there \
are no known uses for it. Identified by Albert Ghiorso in 1961 at Berkeley. \
It was produced by bombarding californium with boron ions. The name is \
temporary {IUPAC} nomenclature, the origin of the name comes from Ernest O. \
Lawrence, the inventor of the cyclotron. If sufficient amounts of lawrencium \
were produced, it would pose a radiation hazard. ", 
        "Appearance unknown, however it is most likely silvery-white or grey \
and metallic. Lawrencium is a synthetic rare-earth metal. There are eight \
known radioisotopes, the most stable being Lr-262 with a half-life of 3.6 \
hours. Due to the short half-life of lawrencium, and its radioactivity, there \
are no known uses for it. Identified by Albert Ghiorso in 1961 at Berkeley. \
It was produced by bombarding californium with boron ions. The name is \
temporary {IUPAC} nomenclature, the origin of the name comes from Ernest O. \
Lawrence, the inventor of the cyclotron. If sufficient amounts of lawrencium \
were produced, it would pose a radiation hazard. ", 
        "Appearance unknown, however it is most likely silvery-white or grey \
and metallic. Lawrencium is a synthetic rare-earth metal. There are eight \
known radioisotopes, the most stable being Lr-262 with a half-life of 3.6 \
hours. Due to the short half-life of lawrencium, and its radioactivity, there \
are no known uses for it. Identified by Albert Ghiorso in 1961 at Berkeley. \
It was produced by bombarding californium with boron ions. The name is \
temporary {IUPAC} nomenclature, the origin of the name comes from Ernest O. \
Lawrence, the inventor of the cyclotron. If sufficient amounts of lawrencium \
were produced, it would pose a radiation hazard. ", 
        "Appearance unknown, however it is most likely silvery-white or grey \
and metallic. Lawrencium is a synthetic rare-earth metal. There are eight \
known radioisotopes, the most stable being Lr-262 with a half-life of 3.6 \
hours. Due to the short half-life of lawrencium, and its radioactivity, there \
are no known uses for it. Identified by Albert Ghiorso in 1961 at Berkeley. \
It was produced by bombarding californium with boron ions. The name is \
temporary {IUPAC} nomenclature, the origin of the name comes from Ernest O. \
Lawrence, the inventor of the cyclotron. If sufficient amounts of lawrencium \
were produced, it would pose a radiation hazard. ", 
        "Appearance unknown, however it is most likely silvery-white or grey \
and metallic. Lawrencium is a synthetic rare-earth metal. There are eight \
known radioisotopes, the most stable being Lr-262 with a half-life of 3.6 \
hours. Due to the short half-life of lawrencium, and its radioactivity, there \
are no known uses for it. Identified by Albert Ghiorso in 1961 at Berkeley. \
It was produced by bombarding californium with boron ions. The name is \
temporary {IUPAC} nomenclature, the origin of the name comes from Ernest O. \
Lawrence, the inventor of the cyclotron. If sufficient amounts of lawrencium \
were produced, it would pose a radiation hazard. ", 
        "Half-life of approximately 5ms. The creation of this element \
demonstrated that fusion techniques could indeed be used to make new, heavy \
nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. ", 
        "Half-life of approximately 5ms. The creation of this element \
demonstrated that fusion techniques could indeed be used to make new, heavy \
nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. ", 
        "Half-life of approximately 5ms. The creation of this element \
demonstrated that fusion techniques could indeed be used to make new, heavy \
nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. ", 
        "Half-life of approximately 5ms. The creation of this element \
demonstrated that fusion techniques could indeed be used to make new, heavy \
nuclei. Made and identified by physicists of the Heavy Ion Research \
Laboratory, Darmstadt, West Germany in 1982. Named in honor of Lise Meitner \
the Austrian physicist. "}}}]]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart Key { efunsab , efuns , unit , efun usage }", "Subsubsection"],

Cell[BoxData[
    \(\(Key = \[IndentingNewLine]FlattenAt[{\[IndentingNewLine]Table[\
\[IndentingNewLine]{\[IndentingNewLine]efunsab[\([j]\)], \
\[IndentingNewLine]efuns[\([j]\)], \[IndentingNewLine]efunsunitsb[\([j]\)], \
\[IndentingNewLine]\(Evaluate[
                    efuns[\([j]\)]]\)::usage\[IndentingNewLine]}, {j, 1, 
                Length[efuns]}\[IndentingNewLine]]\[IndentingNewLine], {"\<\
\[Element]\>", "\<Element\>", "\<\>", Elements::usage}\[IndentingNewLine]}, 
          1];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Key // TableForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Ab \"\>", 
            "Abbreviation", "\<\"\"\>", "\<\"Abbreviation[element] gives the \
standard abbreviation of the specified element.\"\>"},
          {"\<\"AN \"\>", 
            "AtomicNumber", "\<\"\"\>", "\<\"AtomicNumber[element] gives the \
atomic number of the specified element.\"\>"},
          {"\<\"AW \"\>", 
            "AtomicWeight", \(Gram\/Mole\), "\<\"AtomicWeight[element] gives \
the atomic weight of the specified element.\"\>"},
          {"\<\"SI \"\>", 
            "StableIsotopes", "\<\"\"\>", "\<\"StableIsotopes[element] gives \
a list of the stable isotopes of the specified element.\"\>"},
          {"\<\"Tm \"\>", "MeltingPoint", 
            "Kelvin", "\<\"MeltingPoint[element] gives the melting point of \
the specified element.\"\>"},
          {"\<\"Tb \"\>", "BoilingPoint", 
            "Kelvin", "\<\"BoilingPoint[element] gives the boiling point of \
the specified element.\"\>"},
          {"\<\"Lf \"\>", 
            "HeatOfFusion", \(\(Joule\ Kilo\)\/Mole\), \
"\<\"HeatOfFusion[element] gives the heat of fusion of the  specified \
element.\"\>"},
          {"\<\"Lv \"\>", 
            "HeatOfVaporization", \(\(Joule\ Kilo\)\/Mole\), \
"\<\"HeatOfVaporization[element] gives the heat of vaporization of the \
specified element.\"\>"},
          {"\<\"p  \"\>", 
            "Density", \(Kilogram\/Meter\^3\), "\<\"Density[element] gives \
the density of the specified element, usually at 298 Kelvin.  A message is \
issued for other temperatures and for special forms of the element.\"\>"},
          {"\<\"Qs \"\>", 
            "ThermalConductivity", \(Watt\/\(Kelvin\ Meter\)\), \
"\<\"ThermalConductivity[element] gives the thermal conductivity of the \
specified element at 300 K.\"\>"},
          {"\<\"FIP\"\>", "IonizationPotential", 
            "ElectronVolt", "\<\"IonizationPotential[element] gives the \
ionization potential of the specified element.\"\>"},
          {"\<\"Qc \"\>", 
            "SpecificHeat", \(\(Joule\ Kelvin\)\/Gram\), \
"\<\"SpecificHeat[element] gives the specific heat of the specified \
element.\"\>"},
          {"\<\"SsA\"\>", "SolarSystemAbundance", 
            "Percent", "\<\"SolarSystemAbundance[element] gives the relative \
abundance in the solar system of the specified element.\"\>"},
          {"\<\"EcA\"\>", "EarthCrustAbundance", 
            "Percent", "\<\"EarthCrustAbundance[element] gives the relative \
abundance in the Earth's crust of the specified element.\"\>"},
          {"\<\"EoA\"\>", "EarthOceanAbundance", 
            "Percent", "\<\"EarthOceanAbundance[element] gives the relative \
abundance in the Earth's oceans of the specified element.\"\>"},
          {"\<\"OS \"\>", 
            "OxidationStates", "\<\"\"\>", "\<\"OxidationStates[element] \
gives a list of the oxidation numbers of the specified element.\"\>"},
          {"\<\"EN \"\>", "ElectronNegativity", 
            "ElectronVolt", "\<\"ElectonNegativity[element] gives a list of \
the electron negativity of the specified element.\"\>"},
          {"\<\"EA \"\>", 
            "ElectronAffinity", \(\(Joule\ Kilo\)\/Mole\), \
"\<\"ElectronAffinity[element] gives a list of the electron affinity of the \
specified element.\"\>"},
          {"\<\"AR \"\>", "AtomicRadius", 
            "Angstrom", "\<\"AtomicRadius[element] gives a list of the atomic \
radii of the specified element.\"\>"},
          {"\<\"EC \"\>", 
            "ElectronConfiguration", "\<\"\"\>", \
"\<\"ElectronConfiguration[element] depicts the electron configuration of the \
specified element in a list of the form \
{{1s},{2s,2p},{3s,3p,3d},{4s,4p,4d,4f},{5s,5p,5d,5f},{6s,6p,6d},{7s}}.\"\>"},
          {"\<\"ECF\"\>", 
            "ElectronConfigurationFormat", "\<\"\"\>", \
"\<\"ElectronConfigurationFormat[element] puts the electron configuration of \
the specified element in standard notation.\"\>"},
          {"\<\"\[Element]\"\>", "\<\"Element\"\>", "\<\"\"\>", "\<\"Elements \
is a list of the chemical elements described in the ChemicalElements package.\
\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart FullElement { all efun values , any message per }", \
"Subsubsection"],

Cell[BoxData[
    \(FullElement[
        i_] := \[IndentingNewLine]FlattenAt[{{i, Element}, 
          Table[\[IndentingNewLine]Miscellaneous`ChemicalElements`Private`\
mess = {}; \[IndentingNewLine]{\(efuns[\([j]\)]\)[
                i], \[IndentingNewLine]m2\[IndentingNewLine]}, {j, 1, 
              Length[efuns]}\[IndentingNewLine]]}, 2]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(FullElement[Helium] // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"Helium", "Element"},
          {"\<\"He\"\>", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"2", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"4.002602`", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {GridBox[{
                {"3"},
                {"4"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], 
            InterpretationBox["\<\"\"\>",
              {}]},
          {\(0.95`\ Kelvin\), 
            InterpretationBox["\<\"\"\>",
              {}]},
          {\(4.216`\ Kelvin\), 
            InterpretationBox["\<\"\"\>",
              {}]},
          {\(\(0.021`\ Joule\ Kilo\)\/Mole\), 
            InterpretationBox["\<\"\"\>",
              {}]},
          {\(\(0.082`\ Joule\ Kilo\)\/Mole\), 
            InterpretationBox["\<\"\"\>",
              {}]},
          {\(\(124.8`\ Kilogram\)\/Meter\^3\), GridBox[{
                {"\<\"Density is for the Helium form of 4 at liquid Kelvin.\"\
\>"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {\(\(0.152`\ Watt\)\/\(Kelvin\ Meter\)\), GridBox[{
                {"\<\"Thermal conductivity is for the Helium form of gaseous.\
\"\>"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {\(24.587`\ ElectronVolt\), 
            InterpretationBox["\<\"\"\>",
              {}]},
          {\(\(5.193`\ Joule\ Kelvin\)\/Gram\), 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"0.089`", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"8.`*^-9", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"7.`*^-12", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {GridBox[{
                {"0"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"Unknown", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"0", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {"Unknown", 
            InterpretationBox["\<\"\"\>",
              {}]},
          {GridBox[{
                {"2"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], 
            InterpretationBox["\<\"\"\>",
              {}]},
          {
            InterpretationBox[
              
              RowBox[{"\<\"1\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
                "\[InvisibleSpace]", 
                InterpretationBox[\(\[Null]\^2\),
                  Superscript[ 2],
                  Editable->False]}],
              SequenceForm[ "1", "s", 
                Superscript[ 2]],
              Editable->False], 
            InterpretationBox["\<\"\"\>",
              {}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{Helium, Element}, {"He", {}}, {2, {}}, {
        4.0026020000000004, {}}, {{3, 4}, {}}, {
        Times[ 0.94999999999999996, Kelvin], {}}, {
        Times[ 4.2160000000000002, Kelvin], {}}, {
        Times[ 0.021000000000000001, Joule, Kilo, 
          Power[ Mole, -1]], {}}, {
        Times[ 0.082000000000000003, Joule, Kilo, 
          Power[ Mole, -1]], {}}, {
        Times[ 124.8, Kilogram, 
          Power[ Meter, -3]], {
        "Density is for the Helium form of 4 at liquid Kelvin."}}, {
        Times[ 0.152, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], {
        "Thermal conductivity is for the Helium form of gaseous."}}, {
        Times[ 24.587, ElectronVolt], {}}, {
        Times[ 5.1929999999999996, 
          Power[ Gram, -1], Joule, Kelvin], {}}, {0.088999999999999996, {}}, {
        8.0000000000000005*^-09, {}}, {7.0000000000000001*^-12, {}}, {{
        0}, {}}, {Unknown, {}}, {0, {}}, {Unknown, {}}, {{{2}}, {}}, {
        SequenceForm[ "1", "s", 
          Superscript[ 2]], {}}}]]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart ElementData { all efuns values }", "Subsubsection"],

Cell[BoxData[
    \(ElementData[
        i_] := \[IndentingNewLine]Flatten[{i, {\[IndentingNewLine]Table[\
\[IndentingNewLine]{\(efuns[\([j]\)]\)[i]}, {j, 1, 
                Length[efuns]}\[IndentingNewLine]]}}]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ElementData[Hydrogen] // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"Hydrogen"},
          {"\<\"H\"\>"},
          {"1"},
          {"1.00794`"},
          {"1"},
          {"2"},
          {\(14.01`\ Kelvin\)},
          {\(20.28`\ Kelvin\)},
          {\(\(0.12`\ Joule\ Kilo\)\/Mole\)},
          {\(\(0.46`\ Joule\ Kilo\)\/Mole\)},
          {\(\(76.`\ Kilogram\)\/Meter\^3\)},
          {\(\(0.1815`\ Watt\)\/\(Kelvin\ Meter\)\)},
          {\(13.598`\ ElectronVolt\)},
          {\(\(14.304`\ Joule\ Kelvin\)\/Gram\)},
          {"0.91`"},
          {"0.0014`"},
          {"0.108`"},
          {\(-1\)},
          {"1"},
          {\(2.2`\ ElectronVolt\)},
          {\(\(72.77`\ Joule\ Kilo\)\/Mole\)},
          {\(0.37`\ Angstrom\)},
          {"1"},
          {
            InterpretationBox[
              
              RowBox[{"\<\"1\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
                "\[InvisibleSpace]", 
                InterpretationBox[\(\[Null]\^1\),
                  Superscript[ 1],
                  Editable->False]}],
              SequenceForm[ "1", "s", 
                Superscript[ 1]],
              Editable->False]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {Hydrogen, "H", 1, 1.0079400000000001, 1, 2, 
        Times[ 14.01, Kelvin], 
        Times[ 20.280000000000001, Kelvin], 
        Times[ 0.12, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 0.46000000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 76.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 0.18149999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 13.598000000000001, ElectronVolt], 
        Times[ 14.304, 
          Power[ Gram, -1], Joule, Kelvin], 0.91000000000000003, 0.0014, 
        0.108, -1, 1, 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 72.769999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 0.37, Angstrom], 1, 
        SequenceForm[ "1", "s", 
          Superscript[ 1]]}]]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart ColumnChart { efunsab , all efuns values }", "Subsubsection"],

Cell[BoxData[
    \(ColumnChart[] \
:= \[IndentingNewLine]Table[\[IndentingNewLine]Flatten[{efunsab[\([j]\)], \
\(efuns[\([j]\)]\)[Elements]}]\[IndentingNewLine], {j, 1, 
          Length[efuns] - 2}\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ColumnChart[]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Ab \"\>", "\<\"H\"\>", "\<\"He\"\>", "\<\"Li\"\>", \
"\<\"Be\"\>", "\<\"B\"\>", "\<\"C\"\>", "\<\"N\"\>", "\<\"O\"\>", \
"\<\"F\"\>", "\<\"Ne\"\>", "\<\"Na\"\>", "\<\"Mg\"\>", "\<\"Al\"\>", \
"\<\"Si\"\>", "\<\"P\"\>", "\<\"S\"\>", "\<\"Cl\"\>", "\<\"Ar\"\>", \
"\<\"K\"\>", "\<\"Ca\"\>", "\<\"Sc\"\>", "\<\"Ti\"\>", "\<\"V\"\>", "\<\"Cr\"\
\>", "\<\"Mn\"\>", "\<\"Fe\"\>", "\<\"Co\"\>", "\<\"Ni\"\>", "\<\"Cu\"\>", \
"\<\"Zn\"\>", "\<\"Ga\"\>", "\<\"Ge\"\>", "\<\"As\"\>", "\<\"Se\"\>", "\<\"Br\
\"\>", "\<\"Kr\"\>", "\<\"Rb\"\>", "\<\"Sr\"\>", "\<\"Y\"\>", "\<\"Zr\"\>", "\
\<\"Nb\"\>", "\<\"Mo\"\>", "\<\"Tc\"\>", "\<\"Ru\"\>", "\<\"Rh\"\>", \
"\<\"Pd\"\>", "\<\"Ag\"\>", "\<\"Cd\"\>", "\<\"In\"\>", "\<\"Sn\"\>", "\<\"Sb\
\"\>", "\<\"Te\"\>", "\<\"I\"\>", "\<\"Xe\"\>", "\<\"Cs\"\>", "\<\"Ba\"\>", "\
\<\"La\"\>", "\<\"Ce\"\>", "\<\"Pr\"\>", "\<\"Nd\"\>", "\<\"Pm\"\>", \
"\<\"Sm\"\>", "\<\"Eu\"\>", "\<\"Gd\"\>", "\<\"Tb\"\>", "\<\"Dy\"\>", "\<\"Ho\
\"\>", "\<\"Er\"\>", "\<\"Tm\"\>", "\<\"Yb\"\>", "\<\"Lu\"\>", "\<\"Hf\"\>", \
"\<\"Ta\"\>", "\<\"W\"\>", "\<\"Re\"\>", "\<\"Os\"\>", "\<\"Ir\"\>", \
"\<\"Pt\"\>", "\<\"Au\"\>", "\<\"Hg\"\>", "\<\"Tl\"\>", "\<\"Pb\"\>", "\<\"Bi\
\"\>", "\<\"Po\"\>", "\<\"At\"\>", "\<\"Rn\"\>", "\<\"Fr\"\>", "\<\"Ra\"\>", \
"\<\"Ac\"\>", "\<\"Th\"\>", "\<\"Pa\"\>", "\<\"U\"\>", "\<\"Np\"\>", \
"\<\"Pu\"\>", "\<\"Am\"\>", "\<\"Cm\"\>", "\<\"Bk\"\>", "\<\"Cf\"\>", "\<\"Es\
\"\>", "\<\"Fm\"\>", "\<\"Md\"\>", "\<\"No\"\>", "\<\"Lr\"\>", "\<\"Rf\"\>", \
"\<\"Db\"\>", "\<\"Sg\"\>", "\<\"Bh\"\>", "\<\"Hs\"\>", "\<\"Mt\"\>", \
"\<\"Uun\"\>", "\<\"Uuu\"\>", "\<\"Uub\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"AN \"\>", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", 
            "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", 
            "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", 
            "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", 
            "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", 
            "55", "56", "57", "58", "59", "60", "61", "62", "63", "64", "65", 
            "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", 
            "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", 
            "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", "98", 
            "99", "100", "101", "102", "103", "104", "105", "106", "107", 
            "108", "109", "110", "111", 
            "112", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"AW \"\>", "1.00794`", "4.002602`", "6.941`", "9.012182`", 
            "10.81`", "12.0107`", "14.00674`", "15.9994`", "18.9984032`", 
            "20.1797`", "22.98977`", "24.305`", "26.981538`", "28.0855`", 
            "30.973761`", "32.066`", "35.4527`", "39.948`", "39.0983`", 
            "40.078`", "44.95591`", "47.867`", "50.9415`", "51.9961`", 
            "54.938049`", "55.845`", "58.9332`", "58.6934`", "63.546`", 
            "65.39`", "69.723`", "72.61`", "74.9216`", "78.96`", "79.904`", 
            "83.8`", "85.4678`", "87.62`", "88.90585`", "91.224`", 
            "92.90638`", "95.94`", "98", "101.07`", "102.9055`", "106.42`", 
            "107.8682`", "112.411`", "114.818`", "118.71`", "121.76`", 
            "127.6`", "126.90447`", "131.29`", "132.90545`", "137.327`", 
            "138.9055`", "140.116`", "140.90765`", "144.24`", "145", 
            "150.36`", "151.964`", "157.25`", "158.92534`", "162.5`", 
            "164.93032`", "167.26`", "168.93421`", "173.04`", "174.967`", 
            "178.49`", "180.9479`", "183.84`", "186.207`", "190.23`", 
            "192.217`", "195.078`", "196.96655`", "200.59`", "204.3833`", 
            "207.2`", "208.98038`", "209", "210", "222", "223", "226", "227", 
            "232.0381`", "231.03588`", "238.0289`", "237", "244", "243", 
            "247", "247", "251", "252", "257", "258", "259", "262", "261", 
            "262", "263", "262", "265", "266", "269", "272", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"SI \"\>", "1", "2", "3", "4", "6", "7", "9", "10", "11", "12",
             "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23",
             "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34",
             "36", "35", "37", "36", "38", "40", "39", "41", "40", "42", "43",
             "44", "46", "48", "45", "46", "47", "48", "49", "50", "51", "50",
             "52", "53", "54", "55", "54", "56", "57", "58", "59", "58", "60",
             "61", "62", "64", "63", "65", "66", "67", "68", "70", "69", "71",
             "70", "72", "73", "74", "76", "75", "74", "76", "77", "78", "80",
             "82", "79", "81", "78", "80", "82", "83", "84", "86", "85", "84",
             "86", "87", "88", "89", "90", "91", "92", "94", "93", "92", "94",
             "95", "96", "97", "98", "100", "96", "98", "99", "100", "101", 
            "102", "104", "103", "102", "104", "105", "106", "108", "110", 
            "107", "109", "106", "108", "110", "111", "112", "113", "114", 
            "116", "113", "112", "114", "115", "116", "117", "118", "119", 
            "120", "122", "124", "121", "123", "120", "122", "124", "125", 
            "126", "128", "130", "127", "129", "130", "131", "132", "134", 
            "136", "133", "130", "132", "134", "135", "136", "137", "138", 
            "138", "136", "138", "140", "142", "141", "142", "143", "145", 
            "146", "148", "150", "144", "150", "152", "154", "151", "153", 
            "154", "155", "156", "157", "158", "160", "159", "156", "158", 
            "160", "161", "162", "163", "164", "165", "162", "164", "166", 
            "167", "168", "170", "169", "168", "170", "171", "172", "173", 
            "174", "176", "175", "176", "177", "178", "179", "180", "181", 
            "180", "182", "183", "184", "186", "185", "184", "186", "187", 
            "188", "189", "190", "192", "191", "193", "194", "195", "196", 
            "198", "197", "196", "198", "199", "200", "201", "202", "204", 
            "203", "205", "204", "206", "207", "208", "209"},
          {"\<\"Tm \"\>", \(14.01`\ Kelvin\), \(0.95`\ Kelvin\), \(453.69`\ \
Kelvin\), \(1551.`\ Kelvin\), \(2573.`\ Kelvin\), \(3820.`\ Kelvin\), \
\(63.29`\ Kelvin\), \(54.8`\ Kelvin\), \(53.53`\ Kelvin\), \(24.48`\ \
Kelvin\), \(370.96`\ Kelvin\), \(922.`\ Kelvin\), \(933.5`\ Kelvin\), \
\(1683.`\ Kelvin\), \(317.3`\ Kelvin\), \(386.`\ Kelvin\), \(172.2`\ \
Kelvin\), \(83.8`\ Kelvin\), \(336.8`\ Kelvin\), \(1112.`\ Kelvin\), \(1814.`\
\ Kelvin\), \(1933.`\ Kelvin\), \(2160.`\ Kelvin\), \(2130.`\ Kelvin\), \
\(1517.`\ Kelvin\), \(1808.`\ Kelvin\), \(1768.`\ Kelvin\), \(1726.`\ \
Kelvin\), \(1356.6`\ Kelvin\), \(692.73`\ Kelvin\), \(302.93`\ Kelvin\), \
\(1210.6`\ Kelvin\), \(83.78`\ Kelvin\), \(490.`\ Kelvin\), \(265.9`\ \
Kelvin\), \(116.6`\ Kelvin\), \(312.2`\ Kelvin\), \(1042.`\ Kelvin\), \
\(1795.`\ Kelvin\), \(2125.`\ Kelvin\), \(2741.`\ Kelvin\), \(2890.`\ \
Kelvin\), \(2445.`\ Kelvin\), \(2583.`\ Kelvin\), \(2239.`\ Kelvin\), \
\(1825.`\ Kelvin\), \(1235.08`\ Kelvin\), \(594.1`\ Kelvin\), \(429.32`\ \
Kelvin\), \(505.118`\ Kelvin\), \(903.89`\ Kelvin\), \(722.7`\ Kelvin\), \
\(386.7`\ Kelvin\), \(161.3`\ Kelvin\), \(301.55`\ Kelvin\), \(1002.`\ Kelvin\
\), \(1194.`\ Kelvin\), \(1072.`\ Kelvin\), \(1204.`\ Kelvin\), \(1294.`\ \
Kelvin\), \(1441.`\ Kelvin\), \(1350.`\ Kelvin\), \(1095.`\ Kelvin\), \
\(1586.`\ Kelvin\), \(1629.`\ Kelvin\), \(1685.`\ Kelvin\), \(1747.`\ \
Kelvin\), \(1802.`\ Kelvin\), \(1818.`\ Kelvin\), \(1097.`\ Kelvin\), \
\(1936.`\ Kelvin\), \(2503.`\ Kelvin\), \(3269.`\ Kelvin\), \(3680.`\ \
Kelvin\), \(3453.`\ Kelvin\), \(3327.`\ Kelvin\), \(2683.`\ Kelvin\), \
\(2045.`\ Kelvin\), \(1337.58`\ Kelvin\), \(234.28`\ Kelvin\), \(576.6`\ \
Kelvin\), \(600.65`\ Kelvin\), \(544.5`\ Kelvin\), \(527.`\ Kelvin\), \(575.`\
\ Kelvin\), \(202.`\ Kelvin\), \(300.`\ Kelvin\), \(973.`\ Kelvin\), \(1320.`\
\ Kelvin\), \(2023.`\ Kelvin\), \(2113.`\ Kelvin\), \(1405.5`\ Kelvin\), \
\(913.`\ Kelvin\), \(914.`\ Kelvin\), \(1267.`\ Kelvin\), \(1610.`\ Kelvin\), 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"Tb \"\>", \(20.28`\ Kelvin\), \(4.216`\ Kelvin\), \(1620.`\ \
Kelvin\), \(3243.`\ Kelvin\), \(3931.`\ Kelvin\), \(5100.`\ Kelvin\), \(77.4`\
\ Kelvin\), \(90.19`\ Kelvin\), \(85.01`\ Kelvin\), \(27.1`\ Kelvin\), \
\(1156.1`\ Kelvin\), \(1363.`\ Kelvin\), \(2740.`\ Kelvin\), \(2628.`\ Kelvin\
\), \(553.`\ Kelvin\), \(717.824`\ Kelvin\), \(239.6`\ Kelvin\), \(87.3`\ \
Kelvin\), \(1047.`\ Kelvin\), \(1757.`\ Kelvin\), \(3104.`\ Kelvin\), \
\(3560.`\ Kelvin\), \(3650.`\ Kelvin\), \(2945.`\ Kelvin\), \(2235.`\ \
Kelvin\), \(3023.`\ Kelvin\), \(3143.`\ Kelvin\), \(3005.`\ Kelvin\), \(2840\ \
Kelvin\), \(1180.`\ Kelvin\), \(2676.`\ Kelvin\), \(3103.`\ Kelvin\), \(889\ \
Kelvin\), \(958.1`\ Kelvin\), \(331.9`\ Kelvin\), \(120.85`\ Kelvin\), \
\(961.`\ Kelvin\), \(1657\ Kelvin\), \(3611.`\ Kelvin\), \(4650.`\ Kelvin\), \
\(5015.`\ Kelvin\), \(4885.`\ Kelvin\), \(5150.`\ Kelvin\), \(4173.`\ \
Kelvin\), \(4000.`\ Kelvin\), \(3413.`\ Kelvin\), \(2485.`\ Kelvin\), \
\(1038.`\ Kelvin\), \(2353.`\ Kelvin\), \(2543.`\ Kelvin\), \(1908.`\ \
Kelvin\), \(1263.`\ Kelvin\), \(457.5`\ Kelvin\), \(166.1`\ Kelvin\), \
\(951.6`\ Kelvin\), \(1910.`\ Kelvin\), \(3730.`\ Kelvin\), \(3699.`\ \
Kelvin\), \(3785.`\ Kelvin\), \(3341.`\ Kelvin\), \(3000.`\ Kelvin\), \
\(2064.`\ Kelvin\), \(1870.`\ Kelvin\), \(3539.`\ Kelvin\), \(3396.`\ \
Kelvin\), \(2835.`\ Kelvin\), \(2968.`\ Kelvin\), \(3136.`\ Kelvin\), \
\(2220.`\ Kelvin\), \(1466.`\ Kelvin\), \(3668.`\ Kelvin\), \(5470.`\ \
Kelvin\), \(5698.`\ Kelvin\), \(5930.`\ Kelvin\), \(5900.`\ Kelvin\), \
\(5300.`\ Kelvin\), \(4403.`\ Kelvin\), \(4100.`\ Kelvin\), \(3080.`\ \
Kelvin\), \(629.73`\ Kelvin\), \(1730.`\ Kelvin\), \(2013.`\ Kelvin\), \
\(1883.`\ Kelvin\), \(1235.`\ Kelvin\), \(610.`\ Kelvin\), \(211.4`\ \
Kelvin\), \(950.`\ Kelvin\), \(1413.`\ Kelvin\), \(3470.`\ Kelvin\), \(5060.`\
\ Kelvin\), \(4300.`\ Kelvin\), \(4018.`\ Kelvin\), \(4175.`\ Kelvin\), \
\(3505.`\ Kelvin\), \(2880.`\ Kelvin\), "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"Lf \"\>", \(\(0.12`\ Joule\ Kilo\)\/Mole\), \(\(0.021`\ Joule\
\ Kilo\)\/Mole\), \(\(4.6`\ Joule\ Kilo\)\/Mole\), \(\(9.8`\ Joule\ \
Kilo\)\/Mole\), \(\(22.2`\ Joule\ Kilo\)\/Mole\), \(\(105.`\ Joule\ \
Kilo\)\/Mole\), \(\(0.72`\ Joule\ Kilo\)\/Mole\), \(\(0.444`\ Joule\ \
Kilo\)\/Mole\), \(\(1.02`\ Joule\ Kilo\)\/Mole\), \(\(0.324`\ Joule\ \
Kilo\)\/Mole\), \(\(2.64`\ Joule\ Kilo\)\/Mole\), \(\(9.04`\ Joule\ \
Kilo\)\/Mole\), \(\(10.67`\ Joule\ Kilo\)\/Mole\), \(\(39.6`\ Joule\ \
Kilo\)\/Mole\), \(\(2.51`\ Joule\ Kilo\)\/Mole\), \(\(1.23`\ Joule\ \
Kilo\)\/Mole\), \(\(6.41`\ Joule\ Kilo\)\/Mole\), \(\(1.21`\ Joule\ \
Kilo\)\/Mole\), \(\(2.4`\ Joule\ Kilo\)\/Mole\), \(\(9.33`\ Joule\ \
Kilo\)\/Mole\), \(\(15.9`\ Joule\ Kilo\)\/Mole\), \(\(20.9`\ Joule\ \
Kilo\)\/Mole\), \(\(17.6`\ Joule\ Kilo\)\/Mole\), \(\(15.3`\ Joule\ \
Kilo\)\/Mole\), \(\(14.4`\ Joule\ Kilo\)\/Mole\), \(\(14.9`\ Joule\ \
Kilo\)\/Mole\), \(\(15.2`\ Joule\ Kilo\)\/Mole\), \(\(17.6`\ Joule\ \
Kilo\)\/Mole\), \(\(13.`\ Joule\ Kilo\)\/Mole\), \(\(6.67`\ Joule\ \
Kilo\)\/Mole\), \(\(5.59`\ Joule\ Kilo\)\/Mole\), \(\(34.7`\ Joule\ \
Kilo\)\/Mole\), \(\(27.7`\ Joule\ Kilo\)\/Mole\), \(\(5.1`\ Joule\ \
Kilo\)\/Mole\), \(\(10.8`\ Joule\ Kilo\)\/Mole\), \(\(1.64`\ Joule\ \
Kilo\)\/Mole\), \(\(2.2`\ Joule\ Kilo\)\/Mole\), \(\(9.16`\ Joule\ \
Kilo\)\/Mole\), \(\(17.2`\ Joule\ Kilo\)\/Mole\), \(\(23.`\ Joule\ \
Kilo\)\/Mole\), \(\(27.2`\ Joule\ Kilo\)\/Mole\), \(\(27.6`\ Joule\ \
Kilo\)\/Mole\), \(\(23.81`\ Joule\ Kilo\)\/Mole\), \(\(23.7`\ Joule\ \
Kilo\)\/Mole\), \(\(21.55`\ Joule\ Kilo\)\/Mole\), \(\(17.2`\ Joule\ \
Kilo\)\/Mole\), \(\(11.3`\ Joule\ Kilo\)\/Mole\), \(\(6.11`\ Joule\ \
Kilo\)\/Mole\), \(\(3.27`\ Joule\ Kilo\)\/Mole\), \(\(7.2`\ Joule\ \
Kilo\)\/Mole\), \(\(20.9`\ Joule\ Kilo\)\/Mole\), \(\(13.5`\ Joule\ \
Kilo\)\/Mole\), \(\(15.27`\ Joule\ Kilo\)\/Mole\), \(\(3.1`\ Joule\ \
Kilo\)\/Mole\), \(\(2.09`\ Joule\ Kilo\)\/Mole\), \(\(7.66`\ Joule\ \
Kilo\)\/Mole\), \(\(10.04`\ Joule\ Kilo\)\/Mole\), \(\(8.87`\ Joule\ \
Kilo\)\/Mole\), \(\(11.3`\ Joule\ Kilo\)\/Mole\), \(\(7.113`\ Joule\ \
Kilo\)\/Mole\), \(\(12.6`\ Joule\ Kilo\)\/Mole\), \(\(10.9`\ Joule\ \
Kilo\)\/Mole\), \(\(10.5`\ Joule\ Kilo\)\/Mole\), \(\(15.5`\ Joule\ \
Kilo\)\/Mole\), \(\(16.3`\ Joule\ Kilo\)\/Mole\), \(\(17.2`\ Joule\ \
Kilo\)\/Mole\), \(\(17.2`\ Joule\ Kilo\)\/Mole\), \(\(17.2`\ Joule\ \
Kilo\)\/Mole\), \(\(18.4`\ Joule\ Kilo\)\/Mole\), \(\(9.2`\ Joule\ \
Kilo\)\/Mole\), \(\(19.2`\ Joule\ Kilo\)\/Mole\), \(\(25.5`\ Joule\ \
Kilo\)\/Mole\), \(\(31.4`\ Joule\ Kilo\)\/Mole\), \(\(35.2`\ Joule\ \
Kilo\)\/Mole\), \(\(33.1`\ Joule\ Kilo\)\/Mole\), \(\(29.3`\ Joule\ \
Kilo\)\/Mole\), \(\(26.4`\ Joule\ Kilo\)\/Mole\), \(\(19.7`\ Joule\ \
Kilo\)\/Mole\), \(\(12.7`\ Joule\ Kilo\)\/Mole\), \(\(2.331`\ Joule\ \
Kilo\)\/Mole\), \(\(4.31`\ Joule\ Kilo\)\/Mole\), \(\(5.121`\ Joule\ \
Kilo\)\/Mole\), \(\(10.48`\ Joule\ Kilo\)\/Mole\), \(\(10.`\ Joule\ \
Kilo\)\/Mole\), \(\(23.8`\ Joule\ Kilo\)\/Mole\), \(\(2.7`\ Joule\ \
Kilo\)\/Mole\), 
            "Unknown", \(\(7.15`\ Joule\ Kilo\)\/Mole\), \(\(14.2`\ Joule\ \
Kilo\)\/Mole\), \(\(19.2`\ Joule\ Kilo\)\/Mole\), \(\(16.7`\ Joule\ \
Kilo\)\/Mole\), \(\(15.5`\ Joule\ Kilo\)\/Mole\), \(\(9.46`\ Joule\ \
Kilo\)\/Mole\), \(\(2.8`\ Joule\ Kilo\)\/Mole\), \(\(14.4`\ Joule\ \
Kilo\)\/Mole\), "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"Lv \"\>", \(\(0.46`\ Joule\ Kilo\)\/Mole\), \(\(0.082`\ Joule\
\ Kilo\)\/Mole\), \(\(147.7`\ Joule\ Kilo\)\/Mole\), \(\(308.8`\ Joule\ \
Kilo\)\/Mole\), \(\(504.5`\ Joule\ Kilo\)\/Mole\), \(\(710.9`\ Joule\ \
Kilo\)\/Mole\), \(\(5.577`\ Joule\ Kilo\)\/Mole\), \(\(6.82`\ Joule\ \
Kilo\)\/Mole\), \(\(3.26`\ Joule\ Kilo\)\/Mole\), \(\(1.736`\ Joule\ \
Kilo\)\/Mole\), \(\(99.2`\ Joule\ Kilo\)\/Mole\), \(\(127.6`\ Joule\ \
Kilo\)\/Mole\), \(\(290.8`\ Joule\ Kilo\)\/Mole\), \(\(383.3`\ Joule\ \
Kilo\)\/Mole\), \(\(51.9`\ Joule\ Kilo\)\/Mole\), \(\(9.62`\ Joule\ \
Kilo\)\/Mole\), \(\(20.4033`\ Joule\ Kilo\)\/Mole\), \(\(6.53`\ Joule\ Kilo\)\
\/Mole\), \(\(79.1`\ Joule\ Kilo\)\/Mole\), \(\(150.6`\ Joule\ \
Kilo\)\/Mole\), \(\(376.1`\ Joule\ Kilo\)\/Mole\), \(\(425.5`\ Joule\ \
Kilo\)\/Mole\), \(\(459.7`\ Joule\ Kilo\)\/Mole\), \(\(341.8`\ Joule\ \
Kilo\)\/Mole\), \(\(220.5`\ Joule\ Kilo\)\/Mole\), \(\(340.2`\ Joule\ \
Kilo\)\/Mole\), \(\(382.4`\ Joule\ Kilo\)\/Mole\), \(\(374.8`\ Joule\ \
Kilo\)\/Mole\), \(\(306.7`\ Joule\ Kilo\)\/Mole\), \(\(114.2`\ Joule\ \
Kilo\)\/Mole\), \(\(270.3`\ Joule\ Kilo\)\/Mole\), \(\(327.6`\ Joule\ \
Kilo\)\/Mole\), \(\(31.9`\ Joule\ Kilo\)\/Mole\), \(\(90.`\ Joule\ \
Kilo\)\/Mole\), \(\(30.5`\ Joule\ Kilo\)\/Mole\), \(\(9.05`\ Joule\ \
Kilo\)\/Mole\), \(\(75.7`\ Joule\ Kilo\)\/Mole\), \(\(154.4`\ Joule\ \
Kilo\)\/Mole\), \(\(367.4`\ Joule\ Kilo\)\/Mole\), \(\(566.7`\ Joule\ \
Kilo\)\/Mole\), \(\(680.19`\ Joule\ Kilo\)\/Mole\), \(\(589.9`\ Joule\ Kilo\)\
\/Mole\), \(\(585.22`\ Joule\ Kilo\)\/Mole\), \(\(567.`\ Joule\ \
Kilo\)\/Mole\), \(\(494.34`\ Joule\ Kilo\)\/Mole\), \(\(361.5`\ Joule\ Kilo\)\
\/Mole\), \(\(257.7`\ Joule\ Kilo\)\/Mole\), \(\(100.`\ Joule\ \
Kilo\)\/Mole\), \(\(231.8`\ Joule\ Kilo\)\/Mole\), \(\(296.2`\ Joule\ \
Kilo\)\/Mole\), \(\(165.8`\ Joule\ Kilo\)\/Mole\), \(\(104.6`\ Joule\ \
Kilo\)\/Mole\), \(\(41.67`\ Joule\ Kilo\)\/Mole\), \(\(12.65`\ Joule\ \
Kilo\)\/Mole\), \(\(66.5`\ Joule\ Kilo\)\/Mole\), \(\(150.9`\ Joule\ \
Kilo\)\/Mole\), \(\(402.1`\ Joule\ Kilo\)\/Mole\), \(\(398.`\ Joule\ \
Kilo\)\/Mole\), \(\(357.`\ Joule\ Kilo\)\/Mole\), \(\(328.`\ Joule\ \
Kilo\)\/Mole\), 
            "Unknown", \(\(164.8`\ Joule\ Kilo\)\/Mole\), \(\(176.`\ Joule\ \
Kilo\)\/Mole\), \(\(301.`\ Joule\ Kilo\)\/Mole\), \(\(391.`\ Joule\ \
Kilo\)\/Mole\), \(\(293.`\ Joule\ Kilo\)\/Mole\), \(\(303.`\ Joule\ \
Kilo\)\/Mole\), \(\(280.`\ Joule\ Kilo\)\/Mole\), \(\(247.`\ Joule\ \
Kilo\)\/Mole\), \(\(159.`\ Joule\ Kilo\)\/Mole\), \(\(428.`\ Joule\ \
Kilo\)\/Mole\), \(\(570.7`\ Joule\ Kilo\)\/Mole\), \(\(758.22`\ Joule\ Kilo\)\
\/Mole\), \(\(824.2`\ Joule\ Kilo\)\/Mole\), \(\(704.25`\ Joule\ Kilo\)\/Mole\
\), \(\(738.06`\ Joule\ Kilo\)\/Mole\), \(\(612.1`\ Joule\ Kilo\)\/Mole\), \(\
\(469.`\ Joule\ Kilo\)\/Mole\), \(\(343.1`\ Joule\ Kilo\)\/Mole\), \(\(59.11`\
\ Joule\ Kilo\)\/Mole\), \(\(166.1`\ Joule\ Kilo\)\/Mole\), \(\(177.8`\ Joule\
\ Kilo\)\/Mole\), \(\(179.1`\ Joule\ Kilo\)\/Mole\), \(\(100.8`\ Joule\ \
Kilo\)\/Mole\), "Unknown", \(\(18.1`\ Joule\ Kilo\)\/Mole\), 
            "Unknown", \(\(136.7`\ Joule\ Kilo\)\/Mole\), \(\(293\ Joule\ \
Kilo\)\/Mole\), \(\(513.67`\ Joule\ Kilo\)\/Mole\), \(\(481.`\ Joule\ \
Kilo\)\/Mole\), \(\(417.1`\ Joule\ Kilo\)\/Mole\), \(\(336.6`\ Joule\ \
Kilo\)\/Mole\), \(\(343.5`\ Joule\ Kilo\)\/Mole\), \(\(238.5`\ Joule\ \
Kilo\)\/Mole\), "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"p  \"\>", \(\(76.`\ Kilogram\)\/Meter\^3\), \(\(124.8`\ \
Kilogram\)\/Meter\^3\), \(\(534.`\ Kilogram\)\/Meter\^3\), \(\(1847.7`\ \
Kilogram\)\/Meter\^3\), \(\(2340.`\ Kilogram\)\/Meter\^3\), \(\(3513.`\ \
Kilogram\)\/Meter\^3\), \(\(1026.`\ Kilogram\)\/Meter\^3\), \(\(2000.`\ \
Kilogram\)\/Meter\^3\), \(\(1516.`\ Kilogram\)\/Meter\^3\), \(\(1444.`\ \
Kilogram\)\/Meter\^3\), \(\(971.`\ Kilogram\)\/Meter\^3\), \(\(1738.`\ \
Kilogram\)\/Meter\^3\), \(\(2698.`\ Kilogram\)\/Meter\^3\), \(\(2329.`\ \
Kilogram\)\/Meter\^3\), \(\(1820.`\ Kilogram\)\/Meter\^3\), \(\(2070.`\ \
Kilogram\)\/Meter\^3\), \(\(2030.`\ Kilogram\)\/Meter\^3\), \(\(1656.`\ \
Kilogram\)\/Meter\^3\), \(\(862.`\ Kilogram\)\/Meter\^3\), \(\(1550.`\ \
Kilogram\)\/Meter\^3\), \(\(2989.`\ Kilogram\)\/Meter\^3\), \(\(4540.`\ \
Kilogram\)\/Meter\^3\), \(\(6110.`\ Kilogram\)\/Meter\^3\), \(\(7190.`\ \
Kilogram\)\/Meter\^3\), \(\(7440.`\ Kilogram\)\/Meter\^3\), \(\(7874.`\ \
Kilogram\)\/Meter\^3\), \(\(8900.`\ Kilogram\)\/Meter\^3\), \(\(8902.`\ \
Kilogram\)\/Meter\^3\), \(\(8960.`\ Kilogram\)\/Meter\^3\), \(\(7133.`\ \
Kilogram\)\/Meter\^3\), \(\(5907.`\ Kilogram\)\/Meter\^3\), \(\(5323.`\ \
Kilogram\)\/Meter\^3\), \(\(5780.`\ Kilogram\)\/Meter\^3\), \(\(4790.`\ \
Kilogram\)\/Meter\^3\), \(\(4050.`\ Kilogram\)\/Meter\^3\), \(\(2823.`\ \
Kilogram\)\/Meter\^3\), \(\(1532.`\ Kilogram\)\/Meter\^3\), \(\(2540.`\ \
Kilogram\)\/Meter\^3\), \(\(4469.`\ Kilogram\)\/Meter\^3\), \(\(6506.`\ \
Kilogram\)\/Meter\^3\), \(\(8570.`\ Kilogram\)\/Meter\^3\), \(\(10220.`\ \
Kilogram\)\/Meter\^3\), \(\(11500.`\ Kilogram\)\/Meter\^3\), \(\(12370.`\ \
Kilogram\)\/Meter\^3\), \(\(12410.`\ Kilogram\)\/Meter\^3\), \(\(12020.`\ \
Kilogram\)\/Meter\^3\), \(\(10500.`\ Kilogram\)\/Meter\^3\), \(\(8650.`\ \
Kilogram\)\/Meter\^3\), \(\(7310.`\ Kilogram\)\/Meter\^3\), \(\(7310.`\ \
Kilogram\)\/Meter\^3\), \(\(6691.`\ Kilogram\)\/Meter\^3\), \(\(6240.`\ \
Kilogram\)\/Meter\^3\), \(\(4930.`\ Kilogram\)\/Meter\^3\), \(\(3540.`\ \
Kilogram\)\/Meter\^3\), \(\(1873.`\ Kilogram\)\/Meter\^3\), \(\(3594.`\ \
Kilogram\)\/Meter\^3\), \(\(6145.`\ Kilogram\)\/Meter\^3\), \(\(8240.`\ \
Kilogram\)\/Meter\^3\), \(\(6773.`\ Kilogram\)\/Meter\^3\), \(\(7007.`\ \
Kilogram\)\/Meter\^3\), \(\(7220.`\ Kilogram\)\/Meter\^3\), \(\(7520.`\ \
Kilogram\)\/Meter\^3\), \(\(5243.`\ Kilogram\)\/Meter\^3\), \(\(7900.4`\ \
Kilogram\)\/Meter\^3\), \(\(8229.`\ Kilogram\)\/Meter\^3\), \(\(8550.`\ \
Kilogram\)\/Meter\^3\), \(\(8795.`\ Kilogram\)\/Meter\^3\), \(\(9066.`\ \
Kilogram\)\/Meter\^3\), \(\(9321.`\ Kilogram\)\/Meter\^3\), \(\(6965.`\ \
Kilogram\)\/Meter\^3\), \(\(9840.`\ Kilogram\)\/Meter\^3\), \(\(13310.`\ \
Kilogram\)\/Meter\^3\), \(\(16654.`\ Kilogram\)\/Meter\^3\), \(\(19300.`\ \
Kilogram\)\/Meter\^3\), \(\(21020.`\ Kilogram\)\/Meter\^3\), \(\(22590.`\ \
Kilogram\)\/Meter\^3\), \(\(22420.`\ Kilogram\)\/Meter\^3\), \(\(21450.`\ \
Kilogram\)\/Meter\^3\), \(\(19320.`\ Kilogram\)\/Meter\^3\), \(\(13546.`\ \
Kilogram\)\/Meter\^3\), \(\(11850.`\ Kilogram\)\/Meter\^3\), \(\(11350.`\ \
Kilogram\)\/Meter\^3\), \(\(9747.`\ Kilogram\)\/Meter\^3\), \(\(9320.`\ \
Kilogram\)\/Meter\^3\), "Unknown", \(\(4400.`\ Kilogram\)\/Meter\^3\), 
            "Unknown", \(\(5000.`\ Kilogram\)\/Meter\^3\), \(\(10060.`\ \
Kilogram\)\/Meter\^3\), \(\(11720.`\ Kilogram\)\/Meter\^3\), \(\(15370.`\ \
Kilogram\)\/Meter\^3\), \(\(18950.`\ Kilogram\)\/Meter\^3\), \(\(20250.`\ \
Kilogram\)\/Meter\^3\), \(\(19840.`\ Kilogram\)\/Meter\^3\), \(\(13670.`\ \
Kilogram\)\/Meter\^3\), \(\(13300.`\ Kilogram\)\/Meter\^3\), \(\(14790.`\ \
Kilogram\)\/Meter\^3\), "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"Qs \"\>", \(\(0.1815`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(0.152`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(84.7`\ Watt\)\/\(Kelvin\ Meter\)\
\), \(\(200.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(27.`\ Watt\)\/\(Kelvin\ Meter\
\)\), \(\(1960.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(0.02598`\ Watt\)\/\(Kelvin\
\ Meter\)\), \(\(0.02674`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(0.0279`\ Watt\)\/\
\(Kelvin\ Meter\)\), \(\(0.0493`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(141.`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(156.`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(237.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(148\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(0.235`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(0.269`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(0.0089`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(0.01772`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(102.4`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(200.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(15.8`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(21.9`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(30.7`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(93.7`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(7.82`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(80.2`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(100.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(90.7`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(401.`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(116.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(40.6`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(59.9`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(50.`\ Watt\)\/\(Kelvin\
\ Meter\)\), \(\(2.04`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(0.122`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(0.00949`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(58.2`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(35.3`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(17.2`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(22.7`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(53.7`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(138.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(50.6`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(117.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(150.`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(71.8`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(429.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(96.8`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(81.6`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(66.6`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(243.`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(2.35`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(0.449`\ Watt\)\/\(Kelvin\ Meter\)\
\), \(\(0.00569`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(35.9`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(18.4`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(13.5`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(11.4`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(12.5`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(16.5`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(17.9`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(13.3`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(13.9`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(10.6`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(11.1`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(10.7`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(16.2`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(14.3`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(16.8`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(34.9`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(16.4`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(23.`\ Watt\)\/\(Kelvin\
\ Meter\)\), \(\(57.5`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(174.`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(47.9`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(87.6`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(147.`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(71.6`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(317.`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(8.34`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(46.1`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(35.3`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(7.87`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(20.`\ Watt\)\/\(Kelvin\
\ Meter\)\), \(\(1.7`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(0.00364`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(15.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(18.6`\
\ Watt\)\/\(Kelvin\ Meter\)\), \(\(12.`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(54.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(47.`\ Watt\)\/\(Kelvin\ Meter\)\), \
\(\(27.6`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(6.3`\ Watt\)\/\(Kelvin\ \
Meter\)\), \(\(6.74`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ Watt\)\/\(Kelvin\
\ Meter\)\), \(\(10.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ \
Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ Watt\)\/\(Kelvin\ Meter\)\), \(\(10.`\ \
Watt\)\/\(Kelvin\ Meter\)\), "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"FIP\"\>", \(13.598`\ ElectronVolt\), \(24.587`\ \
ElectronVolt\), \(5.392`\ ElectronVolt\), \(9.323`\ ElectronVolt\), \(8.298`\ \
ElectronVolt\), \(11.26`\ ElectronVolt\), \(14.534`\ ElectronVolt\), \
\(13.618`\ ElectronVolt\), \(17.423`\ ElectronVolt\), \(21.565`\ ElectronVolt\
\), \(5.139`\ ElectronVolt\), \(7.646`\ ElectronVolt\), \(5.986`\ \
ElectronVolt\), \(8.152`\ ElectronVolt\), \(10.487`\ ElectronVolt\), \(10.36`\
\ ElectronVolt\), \(12.968`\ ElectronVolt\), \(15.76`\ ElectronVolt\), \
\(4.341`\ ElectronVolt\), \(6.113`\ ElectronVolt\), \(6.561`\ ElectronVolt\), \
\(6.828`\ ElectronVolt\), \(6.746`\ ElectronVolt\), \(6.767`\ ElectronVolt\), \
\(7.434`\ ElectronVolt\), \(7.902`\ ElectronVolt\), \(7.881`\ ElectronVolt\), \
\(7.64`\ ElectronVolt\), \(7.726`\ ElectronVolt\), \(9.394`\ ElectronVolt\), \
\(5.999`\ ElectronVolt\), \(7.9`\ ElectronVolt\), \(9.815`\ ElectronVolt\), \
\(9.752`\ ElectronVolt\), \(11.814`\ ElectronVolt\), \(14\ ElectronVolt\), \
\(4.177`\ ElectronVolt\), \(5.695`\ ElectronVolt\), \(6.217`\ ElectronVolt\), \
\(6.634`\ ElectronVolt\), \(6.759`\ ElectronVolt\), \(7.092`\ ElectronVolt\), \
\(7.28`\ ElectronVolt\), \(7.361`\ ElectronVolt\), \(7.459`\ ElectronVolt\), \
\(8.337`\ ElectronVolt\), \(7.576`\ ElectronVolt\), \(8.994`\ ElectronVolt\), \
\(5.786`\ ElectronVolt\), \(7.344`\ ElectronVolt\), \(8.64`\ ElectronVolt\), \
\(9.01`\ ElectronVolt\), \(10.451`\ ElectronVolt\), \(12.13`\ ElectronVolt\), \
\(3.894`\ ElectronVolt\), \(5.212`\ ElectronVolt\), \(5.577`\ ElectronVolt\), \
\(5.539`\ ElectronVolt\), \(5.464`\ ElectronVolt\), \(5.525`\ ElectronVolt\), \
\(5.55`\ ElectronVolt\), \(5.644`\ ElectronVolt\), \(5.67`\ ElectronVolt\), \
\(6.15`\ ElectronVolt\), \(5.864`\ ElectronVolt\), \(5.939`\ ElectronVolt\), \
\(6.022`\ ElectronVolt\), \(6.108`\ ElectronVolt\), \(6.184`\ ElectronVolt\), \
\(6.254`\ ElectronVolt\), \(5.426`\ ElectronVolt\), \(6.825`\ ElectronVolt\), \
\(7.89`\ ElectronVolt\), \(7.98`\ ElectronVolt\), \(7.88`\ ElectronVolt\), \
\(8.7`\ ElectronVolt\), \(9.1`\ ElectronVolt\), \(9.`\ ElectronVolt\), \
\(9.226`\ ElectronVolt\), \(10.438`\ ElectronVolt\), \(6.108`\ \
ElectronVolt\), \(7.417`\ ElectronVolt\), \(7.289`\ ElectronVolt\), \(8.417`\ \
ElectronVolt\), "Unknown", \(10.749`\ ElectronVolt\), 
            "Unknown", \(5.279`\ ElectronVolt\), \(5.17`\ ElectronVolt\), \
\(6.08`\ ElectronVolt\), \(5.89`\ ElectronVolt\), \(6.194`\ ElectronVolt\), \
\(6.266`\ ElectronVolt\), \(6.06`\ ElectronVolt\), \(5.993`\ ElectronVolt\), \
\(6.02`\ ElectronVolt\), \(6.23`\ ElectronVolt\), \(6.3`\ ElectronVolt\), \
\(6.42`\ ElectronVolt\), \(6.5`\ ElectronVolt\), \(6.58`\ ElectronVolt\), \
\(6.65`\ ElectronVolt\), "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"Qc \"\>", \(\(14.304`\ Joule\ Kelvin\)\/Gram\), \(\(5.193`\ \
Joule\ Kelvin\)\/Gram\), \(\(3.582`\ Joule\ Kelvin\)\/Gram\), \(\(1.825`\ \
Joule\ Kelvin\)\/Gram\), \(\(1.026`\ Joule\ Kelvin\)\/Gram\), \(\(0.709`\ \
Joule\ Kelvin\)\/Gram\), \(\(1.04`\ Joule\ Kelvin\)\/Gram\), \(\(0.918`\ \
Joule\ Kelvin\)\/Gram\), \(\(0.824`\ Joule\ Kelvin\)\/Gram\), \(\(1.03`\ \
Joule\ Kelvin\)\/Gram\), \(\(1.228`\ Joule\ Kelvin\)\/Gram\), 
            "Unknown", \(\(0.897`\ Joule\ Kelvin\)\/Gram\), \(\(0.705`\ Joule\
\ Kelvin\)\/Gram\), \(\(0.769`\ Joule\ Kelvin\)\/Gram\), \(\(0.71`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.479`\ Joule\ Kelvin\)\/Gram\), \(\(0.52`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.757`\ Joule\ Kelvin\)\/Gram\), \(\(0.647`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.568`\ Joule\ Kelvin\)\/Gram\), \(\(0.523`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.489`\ Joule\ Kelvin\)\/Gram\), \(\(0.449`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.479`\ Joule\ Kelvin\)\/Gram\), \(\(0.449`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.421`\ Joule\ Kelvin\)\/Gram\), \(\(0.444`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.385`\ Joule\ Kelvin\)\/Gram\), \(\(0.388`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.371`\ Joule\ Kelvin\)\/Gram\), \(\(0.32`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.329`\ Joule\ Kelvin\)\/Gram\), \(\(0.321`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.226`\ Joule\ Kelvin\)\/Gram\), \(\(0.248`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.363`\ Joule\ Kelvin\)\/Gram\), \(\(0.301`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.298`\ Joule\ Kelvin\)\/Gram\), \(\(0.278`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.265`\ Joule\ Kelvin\)\/Gram\), \(\(0.251`\ Joule\ \
Kelvin\)\/Gram\), 
            "Unknown", \(\(0.238`\ Joule\ Kelvin\)\/Gram\), \(\(0.243`\ Joule\
\ Kelvin\)\/Gram\), \(\(0.244`\ Joule\ Kelvin\)\/Gram\), \(\(0.235`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.232`\ Joule\ Kelvin\)\/Gram\), \(\(0.233`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.228`\ Joule\ Kelvin\)\/Gram\), \(\(0.207`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.202`\ Joule\ Kelvin\)\/Gram\), \(\(0.145`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.158`\ Joule\ Kelvin\)\/Gram\), \(\(0.242`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.204`\ Joule\ Kelvin\)\/Gram\), \(\(0.195`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.192`\ Joule\ Kelvin\)\/Gram\), \(\(0.193`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.19`\ Joule\ Kelvin\)\/Gram\), 
            "Unknown", \(\(0.197`\ Joule\ Kelvin\)\/Gram\), \(\(0.182`\ Joule\
\ Kelvin\)\/Gram\), \(\(0.236`\ Joule\ Kelvin\)\/Gram\), \(\(0.182`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.173`\ Joule\ Kelvin\)\/Gram\), \(\(0.165`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.168`\ Joule\ Kelvin\)\/Gram\), \(\(0.16`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.155`\ Joule\ Kelvin\)\/Gram\), \(\(0.154`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.144`\ Joule\ Kelvin\)\/Gram\), \(\(0.14`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.132`\ Joule\ Kelvin\)\/Gram\), \(\(0.137`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.13`\ Joule\ Kelvin\)\/Gram\), \(\(0.131`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.133`\ Joule\ Kelvin\)\/Gram\), \(\(0.129`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.14`\ Joule\ Kelvin\)\/Gram\), \(\(0.129`\ Joule\ \
Kelvin\)\/Gram\), \(\(0.129`\ Joule\ Kelvin\)\/Gram\), \(\(0.122`\ Joule\ \
Kelvin\)\/Gram\), "Unknown", "Unknown", \(\(0.094`\ Joule\ Kelvin\)\/Gram\), 
            "Unknown", "Unknown", 
            "Unknown", \(\(0.113`\ Joule\ Kelvin\)\/Gram\), 
            "Unknown", \(\(0.116`\ Joule\ Kelvin\)\/Gram\), "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"SsA\"\>", "0.91`", "0.089`", "1.8600000000000002`*^-9", 
            "2.3799999999999998`*^-11", "6.9`*^-10", "0.00033`", "0.000102`", 
            "0.00078`", "2.7`*^-8", "0.000112`", "1.87`*^-6", "0.000035`", 
            "2.77`*^-6", "0.0000326`", "3.4`*^-7", "0.0000326`", "1.7`*^-7", 
            "3.29`*^-6", "1.23`*^-7", "2.`*^-6", "1.12`*^-9", "7.8`*^-8", 
            "9.6`*^-9", "4.4`*^-7", "3.1`*^-7", "0.0000294`", "7.3`*^-9", 
            "1.61`*^-6", "1.7`*^-8", "4.1100000000000004`*^-8", 
            "1.2299999999999999`*^-9", "3.9`*^-9", "2.1`*^-10", "2.03`*^-9", 
            "2.03`*^-9", "1.5`*^-9", "2.31`*^-10", "7.7`*^-10", "1.51`*^-10", 
            "3.72`*^-10", "2.2799999999999998`*^-11", 
            "8.300000000000001`*^-11", "Unknown", "6.1`*^-11", "1.12`*^-11", 
            "4.5`*^-11", "1.58`*^-11", "5.3`*^-11", "6.`*^-10", "1.25`*^-10", 
            "1.01`*^-11", "1.57`*^-10", "2.9`*^-11", "1.5`*^-10", 
            "1.2099999999999999`*^-11", "1.4599999999999999`*^-10", 
            "1.45`*^-11", "3.7`*^-11", "5.44`*^-12", "2.7`*^-11", "Unknown", 
            "8.42`*^-12", "3.17`*^-12", "1.0700000000000001`*^-11", 
            "1.97`*^-12", "1.286`*^-11", "2.8999999999999998`*^-12", 
            "8.18`*^-12", "1.23`*^-12", "8.08`*^-12", "1.197`*^-12", 
            "5.019999999999999`*^-12", "6.75`*^-13", "4.34`*^-12", 
            "1.6899999999999999`*^-12", "2.2`*^-11", 
            "2.1600000000000002`*^-11", "4.4`*^-11", 
            "6.0999999999999995`*^-12", "1.11`*^-11", "6.`*^-12", "1.03`*^-8",
             "4.7`*^-10", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "1.0900000000000001`*^-10", "Unknown", 
            "2.9399999999999997`*^-11", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"EcA\"\>", "0.0014`", "8.`*^-9", "0.00002`", "2.8`*^-6", 
            "0.00001`", "0.0002`", "0.000019`", "0.461`", "0.000585`", 
            "5.`*^-9", "0.0236`", "0.0233`", "0.0823`", "0.282`", "0.00105`", 
            "0.00035`", "0.000145`", "3.5`*^-6", "0.0209`", "0.0415`", 
            "0.000022`", "0.00565`", "0.00012`", "0.000102`", "0.00095`", 
            "0.0563`", "0.000025`", "0.000084`", "0.00006`", "0.00007`", 
            "0.000019`", "1.5`*^-6", "1.8000000000000001`*^-6", "5.`*^-8", 
            "2.4`*^-6", "1.`*^-10", "0.00009`", "0.00037`", "0.000033`", 
            "0.000165`", "0.00002`", "1.2`*^-6", "Unknown", "1.`*^-9", 
            "1.`*^-9", "1.5`*^-8", "7.5`*^-8", "1.5`*^-7", "2.5`*^-7", 
            "2.3`*^-6", "2.`*^-7", "1.`*^-9", "4.5`*^-7", "3.`*^-11", 
            "3.`*^-6", "0.000425`", "0.000039`", "0.0000665`", "9.2`*^-6", 
            "0.0000415`", "Unknown", "7.049999999999999`*^-6", "2.`*^-6", 
            "6.2`*^-6", "1.2`*^-6", "5.2`*^-6", "1.3`*^-6", "3.5`*^-6", 
            "5.2`*^-7", "3.2000000000000003`*^-6", "8.`*^-7", "3.`*^-6", 
            "2.`*^-6", "1.25`*^-6", "7.`*^-10", "1.5`*^-9", "1.`*^-9", 
            "5.`*^-9", "4.`*^-9", "8.5`*^-8", "8.5`*^-7", "0.000014`", 
            "8.5`*^-9", "2.`*^-16", "Unknown", "4.`*^-19", "Unknown", 
            "9.`*^-13", "5.5`*^-16", "9.6`*^-6", "1.3999999999999999`*^-12", 
            "2.7`*^-6", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"EoA\"\>", "0.108`", "7.`*^-12", "1.8`*^-7", 
            "5.5999999999999996`*^-12", "4.440000000000001`*^-6", "0.000028`",
             "5.`*^-7", "0.857`", "1.3`*^-6", "1.2`*^-10", "0.0108`", 
            "0.00129`", "2.`*^-9", "2.2`*^-6", "6.`*^-8", "0.000905`", 
            "0.0194`", "4.5`*^-7", "0.000399`", "0.000412`", "6.`*^-13", 
            "1.`*^-9", "2.5`*^-9", "3.`*^-10", "2.`*^-10", "2.`*^-9", 
            "2.`*^-11", "5.599999999999999`*^-10", "2.5`*^-10", "4.9`*^-9", 
            "3.`*^-11", "5.`*^-11", "3.7`*^-9", "2.`*^-9", "0.0000673`", 
            "2.1`*^-10", "1.2`*^-7", "7.9`*^-6", "1.1999999999999999`*^-11", 
            "3.`*^-11", "1.`*^-11", "1.`*^-8", "Unknown", "7.`*^-13", 
            "Unknown", "Unknown", "4.`*^-11", "1.1000000000000001`*^-10", 
            "2.`*^-8", "4.`*^-12", "2.4`*^-10", "Unknown", "6.`*^-8", 
            "5.`*^-11", "3.`*^-10", "1.3`*^-8", "3.4`*^-12", "1.2`*^-12", 
            "6.4`*^-13", "2.7999999999999998`*^-12", "Unknown", "4.5`*^-13", 
            "1.3`*^-13", "7.`*^-13", "1.3999999999999998`*^-13", "9.1`*^-13", 
            "2.2000000000000002`*^-13", "8.699999999999999`*^-13", 
            "1.7`*^-13", "8.199999999999999`*^-13", "1.5`*^-13", "7.`*^-12", 
            "2.`*^-12", "1.`*^-10", "4.`*^-12", "Unknown", "Unknown", 
            "Unknown", "4.`*^-12", "3.`*^-11", "1.9`*^-11", "3.`*^-11", 
            "2.`*^-11", "1.5`*^-20", "Unknown", "6.`*^-22", "Unknown", 
            "8.9`*^-17", "Unknown", "1.`*^-12", "5.`*^-17", "3.2`*^-9", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"OS \"\>", \(-1\), "1", "0", "1", "2", "3", \(-4\), "2", 
            "4", \(-3\), \(-2\), \(-1\), "1", "2", "3", "4", 
            "5", \(-2\), \(-1\), "0", "1", "2", "3", \(-4\), "2", "4", \(-3\),
             "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "7", "0", "1", "2",
             "3", "2", "3", "4", "2", "3", "4", "5", "2", "3", "6", "2", "3", 
            "4", "7", "2", "3", "2", "3", "2", "3", "1", "2", "2", "3", "2", 
            "4", \(-3\), "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "0", 
            "1", "2", "3", "4", "3", "5", "6", "4", "6", "7", "3", "3", "2", 
            "4", "1", "2", "3", "2", "4", \(-3\), "3", "5", \(-2\), "4", 
            "6", \(-1\), "1", "5", "7", "0", "1", "2", "3", "3", "4", "3", 
            "3", "3", "2", "3", "2", "3", "3", "3", "3", "3", "3", "3", "2", 
            "3", "3", "4", "5", "6", "4", "6", "7", "3", "4", "3", "4", "2", 
            "4", "1", "3", "1", "2", "1", "3", "2", "4", "3", "5", "2", "4", 
            "0", "1", "2", "3", "4", "4", "5", "3", "4", "5", "6", "3", "4", 
            "5", "6", "3", "4", "5", "6", "3", "4", "5", "6", "3", "3", "4", 
            "3", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"EN \"\>", \(2.2`\ ElectronVolt\), 
            "Unknown", \(0.98`\ ElectronVolt\), \(1.57`\ ElectronVolt\), \
\(2.04`\ ElectronVolt\), \(2.55`\ ElectronVolt\), \(3.04`\ ElectronVolt\), \
\(3.44`\ ElectronVolt\), \(3.98`\ ElectronVolt\), 
            "Unknown", \(0.93`\ ElectronVolt\), \(1.31`\ ElectronVolt\), \
\(1.61`\ ElectronVolt\), \(1.9`\ ElectronVolt\), \(2.19`\ ElectronVolt\), \
\(2.58`\ ElectronVolt\), \(3.16`\ ElectronVolt\), 
            "Unknown", \(0.82`\ ElectronVolt\), \(1.`\ ElectronVolt\), \
\(1.36`\ ElectronVolt\), \(1.54`\ ElectronVolt\), \(1.63`\ ElectronVolt\), \
\(1.66`\ ElectronVolt\), \(1.55`\ ElectronVolt\), \(1.83`\ ElectronVolt\), \
\(1.88`\ ElectronVolt\), \(1.91`\ ElectronVolt\), \(1.9`\ ElectronVolt\), \
\(1.65`\ ElectronVolt\), \(1.81`\ ElectronVolt\), \(2.01`\ ElectronVolt\), \
\(2.18`\ ElectronVolt\), \(2.55`\ ElectronVolt\), \(2.9`\ ElectronVolt\), 
            "Unknown", \(0.82`\ ElectronVolt\), \(0.95`\ ElectronVolt\), \
\(1.22`\ ElectronVolt\), \(1.33`\ ElectronVolt\), \(1.6`\ ElectronVolt\), \
\(2.16`\ ElectronVolt\), \(1.9`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \
\(2.28`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \(1.93`\ ElectronVolt\), \
\(1.69`\ ElectronVolt\), \(1.78`\ ElectronVolt\), \(1.96`\ ElectronVolt\), \
\(2.05`\ ElectronVolt\), \(2.1`\ ElectronVolt\), \(2.66`\ ElectronVolt\), \
\(2.6`\ ElectronVolt\), \(0.79`\ ElectronVolt\), \(0.89`\ ElectronVolt\), \
\(1.1`\ ElectronVolt\), \(1.12`\ ElectronVolt\), \(1.13`\ ElectronVolt\), \
\(1.14`\ ElectronVolt\), \(1.13`\ ElectronVolt\), \(1.17`\ ElectronVolt\), \
\(1.2`\ ElectronVolt\), \(1.2`\ ElectronVolt\), \(1.1`\ ElectronVolt\), \
\(1.22`\ ElectronVolt\), \(1.23`\ ElectronVolt\), \(1.24`\ ElectronVolt\), \
\(1.25`\ ElectronVolt\), \(1.1`\ ElectronVolt\), \(1.27`\ ElectronVolt\), \
\(1.3`\ ElectronVolt\), \(1.5`\ ElectronVolt\), \(2.36`\ ElectronVolt\), \
\(1.9`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \
\(2.28`\ ElectronVolt\), \(2.54`\ ElectronVolt\), \(2.`\ ElectronVolt\), \
\(2.04`\ ElectronVolt\), \(2.33`\ ElectronVolt\), \(2.02`\ ElectronVolt\), \
\(2.`\ ElectronVolt\), \(2.2`\ ElectronVolt\), 
            
            "Unknown", \(0.7`\ ElectronVolt\), \(0.9`\ ElectronVolt\), \(1.1`\
\ ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.5`\ ElectronVolt\), \(1.38`\ \
ElectronVolt\), \(1.36`\ ElectronVolt\), \(1.28`\ ElectronVolt\), \(1.3`\ \
ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ \
ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ \
ElectronVolt\), \(1.3`\ ElectronVolt\), "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"EA \"\>", \(\(72.77`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(59.63`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(26.7`\ Joule\ Kilo\)\/Mole\), \(\(121.85`\ Joule\ Kilo\)\
\/Mole\), 
            "0", \(\(140.97676`\ Joule\ Kilo\)\/Mole\), \(\(328.`\ Joule\ \
Kilo\)\/Mole\), "0", \(\(52.867`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(42.6`\ Joule\ Kilo\)\/Mole\), \(\(133.6`\ Joule\ \
Kilo\)\/Mole\), \(\(72.03`\ Joule\ Kilo\)\/Mole\), \(\(200.4116`\ Joule\ Kilo\
\)\/Mole\), \(\(349.`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(48.384`\ Joule\ Kilo\)\/Mole\), \(\(2.369`\ Joule\ \
Kilo\)\/Mole\), \(\(18.1`\ Joule\ Kilo\)\/Mole\), \(\(7.6`\ Joule\ \
Kilo\)\/Mole\), \(\(50.7`\ Joule\ Kilo\)\/Mole\), \(\(64.3`\ Joule\ \
Kilo\)\/Mole\), 
            "0", \(\(14.57`\ Joule\ Kilo\)\/Mole\), \(\(63.8`\ Joule\ \
Kilo\)\/Mole\), \(\(111.5`\ Joule\ Kilo\)\/Mole\), \(\(118.5`\ Joule\ \
Kilo\)\/Mole\), 
            "0", \(\(29\ Joule\ Kilo\)\/Mole\), \(-\(\(120\ Joule\ \
Kilo\)\/Mole\)\), \(-\(\(80\ Joule\ Kilo\)\/Mole\)\), \(\(194.967`\ Joule\ \
Kilo\)\/Mole\), \(\(324.7`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(46.884`\ Joule\ Kilo\)\/Mole\), \(\(4.6`\ Joule\ \
Kilo\)\/Mole\), \(\(29.6`\ Joule\ Kilo\)\/Mole\), \(\(41.1`\ Joule\ \
Kilo\)\/Mole\), \(\(86.2`\ Joule\ Kilo\)\/Mole\), \(\(72.`\ Joule\ \
Kilo\)\/Mole\), \(-\(\(53\ Joule\ Kilo\)\/Mole\)\), \(-\(\(100\ Joule\ Kilo\)\
\/Mole\)\), \(\(110\ Joule\ Kilo\)\/Mole\), \(\(54.22`\ Joule\ \
Kilo\)\/Mole\), \(\(125.6`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(29\ Joule\ Kilo\)\/Mole\), \(\(101.`\ Joule\ \
Kilo\)\/Mole\), \(\(103\ Joule\ Kilo\)\/Mole\), \(\(190.15`\ Joule\ \
Kilo\)\/Mole\), \(\(295.2`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(45.505`\ Joule\ Kilo\)\/Mole\), \(\(14.47`\ Joule\ \
Kilo\)\/Mole\), \(-\(\(50\ Joule\ Kilo\)\/Mole\)\), "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", \(-\(\(50\ Joule\ Kilo\)\/Mole\)\), 
            "0", \(\(31.1`\ Joule\ Kilo\)\/Mole\), \(\(78.6`\ Joule\ \
Kilo\)\/Mole\), \(-\(\(14\ Joule\ Kilo\)\/Mole\)\), \(-\(\(106\ Joule\ Kilo\)\
\/Mole\)\), \(\(151\ Joule\ Kilo\)\/Mole\), \(\(205.1`\ Joule\ \
Kilo\)\/Mole\), \(\(222.737`\ Joule\ Kilo\)\/Mole\), 
            "0", \(-\(\(20\ Joule\ Kilo\)\/Mole\)\), \(\(35.1`\ Joule\ Kilo\)\
\/Mole\), \(\(91.3`\ Joule\ Kilo\)\/Mole\), \(-\(\(180\ Joule\ Kilo\)\/Mole\)\
\), \(-\(\(270\ Joule\ Kilo\)\/Mole\)\), "0", \(\(44\ Joule\ Kilo\)\/Mole\), 
            "0", "0", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"},
          {"\<\"AR \"\>", \(0.37`\ Angstrom\), 
            "Unknown", \(1.52`\ Angstrom\), \(1.13`\ Angstrom\), \(0.8`\ \
Angstrom\), \(0.77`\ Angstrom\), \(0.7`\ Angstrom\), \(0.66`\ Angstrom\), \
\(0.64`\ Angstrom\), \(0.51`\ Angstrom\), \(1.86`\ Angstrom\), \(1.6`\ \
Angstrom\), \(1.43`\ Angstrom\), \(1.17`\ Angstrom\), \(1.1`\ Angstrom\), \
\(1.04`\ Angstrom\), \(0.99`\ Angstrom\), \(0.88`\ Angstrom\), \(2.27`\ \
Angstrom\), \(1.97`\ Angstrom\), \(1.61`\ Angstrom\), \(1.45`\ Angstrom\), \
\(1.31`\ Angstrom\), \(1.25`\ Angstrom\), \(1.37`\ Angstrom\), \(1.24`\ \
Angstrom\), \(1.25`\ Angstrom\), \(1.25`\ Angstrom\), \(1.28`\ Angstrom\), \
\(1.34`\ Angstrom\), \(1.53`\ Angstrom\), \(1.2`\ Angstrom\), \(1.21`\ \
Angstrom\), \(1.17`\ Angstrom\), \(1.14`\ Angstrom\), \(1.03`\ Angstrom\), \
\(2.47`\ Angstrom\), \(2.15`\ Angstrom\), \(1.78`\ Angstrom\), \(1.6`\ \
Angstrom\), \(1.49`\ Angstrom\), \(1.36`\ Angstrom\), \(1.35`\ Angstrom\), \
\(1.32`\ Angstrom\), \(1.34`\ Angstrom\), \(1.38`\ Angstrom\), \(1.44`\ \
Angstrom\), \(1.49`\ Angstrom\), \(1.63`\ Angstrom\), \(1.4`\ Angstrom\), \
\(1.41`\ Angstrom\), \(1.43`\ Angstrom\), \(1.33`\ Angstrom\), \(1.24`\ \
Angstrom\), \(2.65`\ Angstrom\), \(2.22`\ Angstrom\), \(1.88`\ Angstrom\), \
\(1.82`\ Angstrom\), \(1.82`\ Angstrom\), \(1.81`\ Angstrom\), \(1.81`\ \
Angstrom\), \(1.8`\ Angstrom\), \(2.`\ Angstrom\), \(1.79`\ Angstrom\), \
\(1.76`\ Angstrom\), \(1.75`\ Angstrom\), \(1.74`\ Angstrom\), \(1.73`\ \
Angstrom\), \(1.72`\ Angstrom\), \(1.94`\ Angstrom\), \(1.72`\ Angstrom\), \
\(1.67`\ Angstrom\), \(1.49`\ Angstrom\), \(1.37`\ Angstrom\), \(1.37`\ \
Angstrom\), \(1.34`\ Angstrom\), \(1.36`\ Angstrom\), \(1.37`\ Angstrom\), \
\(1.44`\ Angstrom\), \(1.5`\ Angstrom\), \(1.47`\ Angstrom\), \(1.75`\ \
Angstrom\), \(1.82`\ Angstrom\), \(1.67`\ Angstrom\), \(1.4`\ Angstrom\), \
\(1.34`\ Angstrom\), \(\(-2.7`\)\ Angstrom\), \(2.33`\ Angstrom\), \(1.88`\ \
Angstrom\), \(1.8`\ Angstrom\), \(1.61`\ Angstrom\), \(1.38`\ Angstrom\), \
\(1.3`\ Angstrom\), \(1.51`\ Angstrom\), \(1.84`\ Angstrom\), "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{"Ab ", "H", "He", "Li", "Be", "B", "C", "N", "O", "F", 
        "Ne", "Na", "Mg", "Al", "Si", "P", "S", "Cl", "Ar", "K", "Ca", "Sc", 
        "Ti", "V", "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", "Ga", "Ge", "As",
         "Se", "Br", "Kr", "Rb", "Sr", "Y", "Zr", "Nb", "Mo", "Tc", "Ru", 
        "Rh", "Pd", "Ag", "Cd", "In", "Sn", "Sb", "Te", "I", "Xe", "Cs", "Ba",
         "La", "Ce", "Pr", "Nd", "Pm", "Sm", "Eu", "Gd", "Tb", "Dy", "Ho", 
        "Er", "Tm", "Yb", "Lu", "Hf", "Ta", "W", "Re", "Os", "Ir", "Pt", "Au",
         "Hg", "Tl", "Pb", "Bi", "Po", "At", "Rn", "Fr", "Ra", "Ac", "Th", 
        "Pa", "U", "Np", "Pu", "Am", "Cm", "Bk", "Cf", "Es", "Fm", "Md", "No",
         "Lr", "Rf", "Db", "Sg", "Bh", "Hs", "Mt", "Uun", "Uuu", "Uub"}, {
        "AN ", 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
        19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 
        36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 
        53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 
        70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 
        87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 
        103, 104, 105, 106, 107, 108, 109, 110, 111, 112}, {"AW ", 
        1.0079400000000001, 4.0026020000000004, 6.9409999999999998, 
        9.0121819999999992, 10.81, 12.0107, 14.006740000000001, 15.9994, 
        18.998403199999998, 20.1797, 22.98977, 24.305, 26.981538, 28.0855, 
        30.973761, 32.066000000000003, 35.4527, 39.948, 39.098300000000002, 
        40.078000000000003, 44.955910000000003, 47.866999999999997, 
        50.941499999999998, 51.996099999999998, 54.938048999999999, 
        55.844999999999999, 58.933199999999999, 58.693399999999997, 
        63.545999999999999, 65.390000000000001, 69.722999999999999, 
        72.609999999999999, 74.921599999999998, 78.959999999999994, 
        79.903999999999996, 83.799999999999997, 85.467799999999997, 
        87.620000000000005, 88.905850000000001, 91.224000000000004, 
        92.906379999999999, 95.939999999999998, 98, 101.06999999999999, 
        102.9055, 106.42, 107.8682, 112.411, 114.818, 118.70999999999999, 
        121.76000000000001, 127.59999999999999, 126.90447, 131.28999999999999,
         132.90545, 137.327, 138.90549999999999, 140.11600000000001, 
        140.90764999999999, 144.24000000000001, 145, 150.36000000000001, 
        151.964, 157.25, 158.92534000000001, 162.5, 164.93031999999999, 
        167.25999999999999, 168.93421000000001, 173.03999999999999, 
        174.96700000000001, 178.49000000000001, 180.9479, 183.84, 
        186.20699999999999, 190.22999999999999, 192.21700000000001, 195.078, 
        196.96655000000001, 200.59, 204.38329999999999, 207.19999999999999, 
        208.98038, 209, 210, 222, 223, 226, 227, 232.03809999999999, 
        231.03587999999999, 238.02889999999999, 237, 244, 243, 247, 247, 251, 
        252, 257, 258, 259, 262, 261, 262, 263, 262, 265, 266, 269, 272, 
        Unknown}, {"SI ", 1, 2, 3, 4, 6, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17,
         18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 
        36, 35, 37, 36, 38, 40, 39, 41, 40, 42, 43, 44, 46, 48, 45, 46, 47, 
        48, 49, 50, 51, 50, 52, 53, 54, 55, 54, 56, 57, 58, 59, 58, 60, 61, 
        62, 64, 63, 65, 66, 67, 68, 70, 69, 71, 70, 72, 73, 74, 76, 75, 74, 
        76, 77, 78, 80, 82, 79, 81, 78, 80, 82, 83, 84, 86, 85, 84, 86, 87, 
        88, 89, 90, 91, 92, 94, 93, 92, 94, 95, 96, 97, 98, 100, 96, 98, 99, 
        100, 101, 102, 104, 103, 102, 104, 105, 106, 108, 110, 107, 109, 106, 
        108, 110, 111, 112, 113, 114, 116, 113, 112, 114, 115, 116, 117, 118, 
        119, 120, 122, 124, 121, 123, 120, 122, 124, 125, 126, 128, 130, 127, 
        129, 130, 131, 132, 134, 136, 133, 130, 132, 134, 135, 136, 137, 138, 
        138, 136, 138, 140, 142, 141, 142, 143, 145, 146, 148, 150, 144, 150, 
        152, 154, 151, 153, 154, 155, 156, 157, 158, 160, 159, 156, 158, 160, 
        161, 162, 163, 164, 165, 162, 164, 166, 167, 168, 170, 169, 168, 170, 
        171, 172, 173, 174, 176, 175, 176, 177, 178, 179, 180, 181, 180, 182, 
        183, 184, 186, 185, 184, 186, 187, 188, 189, 190, 192, 191, 193, 194, 
        195, 196, 198, 197, 196, 198, 199, 200, 201, 202, 204, 203, 205, 204, 
        206, 207, 208, 209}, {"Tm ", 
        Times[ 14.01, Kelvin], 
        Times[ 0.94999999999999996, Kelvin], 
        Times[ 453.69, Kelvin], 
        Times[ 1551.0, Kelvin], 
        Times[ 2573.0, Kelvin], 
        Times[ 3820.0, Kelvin], 
        Times[ 63.289999999999999, Kelvin], 
        Times[ 54.799999999999997, Kelvin], 
        Times[ 53.530000000000001, Kelvin], 
        Times[ 24.48, Kelvin], 
        Times[ 370.95999999999998, Kelvin], 
        Times[ 922.0, Kelvin], 
        Times[ 933.5, Kelvin], 
        Times[ 1683.0, Kelvin], 
        Times[ 317.30000000000001, Kelvin], 
        Times[ 386.0, Kelvin], 
        Times[ 172.19999999999999, Kelvin], 
        Times[ 83.799999999999997, Kelvin], 
        Times[ 336.80000000000001, Kelvin], 
        Times[ 1112.0, Kelvin], 
        Times[ 1814.0, Kelvin], 
        Times[ 1933.0, Kelvin], 
        Times[ 2160.0, Kelvin], 
        Times[ 2130.0, Kelvin], 
        Times[ 1517.0, Kelvin], 
        Times[ 1808.0, Kelvin], 
        Times[ 1768.0, Kelvin], 
        Times[ 1726.0, Kelvin], 
        Times[ 1356.5999999999999, Kelvin], 
        Times[ 692.73000000000002, Kelvin], 
        Times[ 302.93000000000001, Kelvin], 
        Times[ 1210.5999999999999, Kelvin], 
        Times[ 83.780000000000001, Kelvin], 
        Times[ 490.0, Kelvin], 
        Times[ 265.89999999999998, Kelvin], 
        Times[ 116.59999999999999, Kelvin], 
        Times[ 312.19999999999999, Kelvin], 
        Times[ 1042.0, Kelvin], 
        Times[ 1795.0, Kelvin], 
        Times[ 2125.0, Kelvin], 
        Times[ 2741.0, Kelvin], 
        Times[ 2890.0, Kelvin], 
        Times[ 2445.0, Kelvin], 
        Times[ 2583.0, Kelvin], 
        Times[ 2239.0, Kelvin], 
        Times[ 1825.0, Kelvin], 
        Times[ 1235.0799999999999, Kelvin], 
        Times[ 594.10000000000002, Kelvin], 
        Times[ 429.31999999999999, Kelvin], 
        Times[ 505.11799999999999, Kelvin], 
        Times[ 903.88999999999999, Kelvin], 
        Times[ 722.70000000000005, Kelvin], 
        Times[ 386.69999999999999, Kelvin], 
        Times[ 161.30000000000001, Kelvin], 
        Times[ 301.55000000000001, Kelvin], 
        Times[ 1002.0, Kelvin], 
        Times[ 1194.0, Kelvin], 
        Times[ 1072.0, Kelvin], 
        Times[ 1204.0, Kelvin], 
        Times[ 1294.0, Kelvin], 
        Times[ 1441.0, Kelvin], 
        Times[ 1350.0, Kelvin], 
        Times[ 1095.0, Kelvin], 
        Times[ 1586.0, Kelvin], 
        Times[ 1629.0, Kelvin], 
        Times[ 1685.0, Kelvin], 
        Times[ 1747.0, Kelvin], 
        Times[ 1802.0, Kelvin], 
        Times[ 1818.0, Kelvin], 
        Times[ 1097.0, Kelvin], 
        Times[ 1936.0, Kelvin], 
        Times[ 2503.0, Kelvin], 
        Times[ 3269.0, Kelvin], 
        Times[ 3680.0, Kelvin], 
        Times[ 3453.0, Kelvin], 
        Times[ 3327.0, Kelvin], 
        Times[ 2683.0, Kelvin], 
        Times[ 2045.0, Kelvin], 
        Times[ 1337.5799999999999, Kelvin], 
        Times[ 234.28, Kelvin], 
        Times[ 576.60000000000002, Kelvin], 
        Times[ 600.64999999999998, Kelvin], 
        Times[ 544.5, Kelvin], 
        Times[ 527.0, Kelvin], 
        Times[ 575.0, Kelvin], 
        Times[ 202.0, Kelvin], 
        Times[ 300.0, Kelvin], 
        Times[ 973.0, Kelvin], 
        Times[ 1320.0, Kelvin], 
        Times[ 2023.0, Kelvin], 
        Times[ 2113.0, Kelvin], 
        Times[ 1405.5, Kelvin], 
        Times[ 913.0, Kelvin], 
        Times[ 914.0, Kelvin], 
        Times[ 1267.0, Kelvin], 
        Times[ 1610.0, Kelvin], Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown}, {"Tb ", 
        Times[ 20.280000000000001, Kelvin], 
        Times[ 4.2160000000000002, Kelvin], 
        Times[ 1620.0, Kelvin], 
        Times[ 3243.0, Kelvin], 
        Times[ 3931.0, Kelvin], 
        Times[ 5100.0, Kelvin], 
        Times[ 77.400000000000006, Kelvin], 
        Times[ 90.189999999999998, Kelvin], 
        Times[ 85.010000000000005, Kelvin], 
        Times[ 27.100000000000001, Kelvin], 
        Times[ 1156.0999999999999, Kelvin], 
        Times[ 1363.0, Kelvin], 
        Times[ 2740.0, Kelvin], 
        Times[ 2628.0, Kelvin], 
        Times[ 553.0, Kelvin], 
        Times[ 717.82399999999996, Kelvin], 
        Times[ 239.59999999999999, Kelvin], 
        Times[ 87.299999999999997, Kelvin], 
        Times[ 1047.0, Kelvin], 
        Times[ 1757.0, Kelvin], 
        Times[ 3104.0, Kelvin], 
        Times[ 3560.0, Kelvin], 
        Times[ 3650.0, Kelvin], 
        Times[ 2945.0, Kelvin], 
        Times[ 2235.0, Kelvin], 
        Times[ 3023.0, Kelvin], 
        Times[ 3143.0, Kelvin], 
        Times[ 3005.0, Kelvin], 
        Times[ 2840, Kelvin], 
        Times[ 1180.0, Kelvin], 
        Times[ 2676.0, Kelvin], 
        Times[ 3103.0, Kelvin], 
        Times[ 889, Kelvin], 
        Times[ 958.10000000000002, Kelvin], 
        Times[ 331.89999999999998, Kelvin], 
        Times[ 120.84999999999999, Kelvin], 
        Times[ 961.0, Kelvin], 
        Times[ 1657, Kelvin], 
        Times[ 3611.0, Kelvin], 
        Times[ 4650.0, Kelvin], 
        Times[ 5015.0, Kelvin], 
        Times[ 4885.0, Kelvin], 
        Times[ 5150.0, Kelvin], 
        Times[ 4173.0, Kelvin], 
        Times[ 4000.0, Kelvin], 
        Times[ 3413.0, Kelvin], 
        Times[ 2485.0, Kelvin], 
        Times[ 1038.0, Kelvin], 
        Times[ 2353.0, Kelvin], 
        Times[ 2543.0, Kelvin], 
        Times[ 1908.0, Kelvin], 
        Times[ 1263.0, Kelvin], 
        Times[ 457.5, Kelvin], 
        Times[ 166.09999999999999, Kelvin], 
        Times[ 951.60000000000002, Kelvin], 
        Times[ 1910.0, Kelvin], 
        Times[ 3730.0, Kelvin], 
        Times[ 3699.0, Kelvin], 
        Times[ 3785.0, Kelvin], 
        Times[ 3341.0, Kelvin], 
        Times[ 3000.0, Kelvin], 
        Times[ 2064.0, Kelvin], 
        Times[ 1870.0, Kelvin], 
        Times[ 3539.0, Kelvin], 
        Times[ 3396.0, Kelvin], 
        Times[ 2835.0, Kelvin], 
        Times[ 2968.0, Kelvin], 
        Times[ 3136.0, Kelvin], 
        Times[ 2220.0, Kelvin], 
        Times[ 1466.0, Kelvin], 
        Times[ 3668.0, Kelvin], 
        Times[ 5470.0, Kelvin], 
        Times[ 5698.0, Kelvin], 
        Times[ 5930.0, Kelvin], 
        Times[ 5900.0, Kelvin], 
        Times[ 5300.0, Kelvin], 
        Times[ 4403.0, Kelvin], 
        Times[ 4100.0, Kelvin], 
        Times[ 3080.0, Kelvin], 
        Times[ 629.73000000000002, Kelvin], 
        Times[ 1730.0, Kelvin], 
        Times[ 2013.0, Kelvin], 
        Times[ 1883.0, Kelvin], 
        Times[ 1235.0, Kelvin], 
        Times[ 610.0, Kelvin], 
        Times[ 211.40000000000001, Kelvin], 
        Times[ 950.0, Kelvin], 
        Times[ 1413.0, Kelvin], 
        Times[ 3470.0, Kelvin], 
        Times[ 5060.0, Kelvin], 
        Times[ 4300.0, Kelvin], 
        Times[ 4018.0, Kelvin], 
        Times[ 4175.0, Kelvin], 
        Times[ 3505.0, Kelvin], 
        Times[ 2880.0, Kelvin], Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"Lf ", 
        Times[ 0.12, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 0.021000000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 4.5999999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.8000000000000007, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 22.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 105.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 0.71999999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 0.44400000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 1.02, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 0.32400000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.6400000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.0399999999999991, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 10.67, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 39.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.5099999999999998, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 1.23, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 6.4100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 1.21, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.3999999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.3300000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 15.9, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 20.899999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 17.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 15.300000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 14.4, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 14.9, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 15.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 17.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 13.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 6.6699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 5.5899999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 34.700000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 27.699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 5.0999999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 10.800000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 1.6399999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.2000000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.1600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 17.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 23.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 27.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 27.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 23.809999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 23.699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 21.550000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 17.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 11.300000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 6.1100000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 3.27, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 7.2000000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 20.899999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 13.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 15.27, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 3.1000000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.0899999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 7.6600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 10.039999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 8.8699999999999992, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 11.300000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 7.1130000000000004, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 12.6, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 10.9, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 10.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 15.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 16.300000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 17.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 17.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 17.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 18.399999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.1999999999999993, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 19.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 25.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 31.399999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 35.200000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 33.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 29.300000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 26.399999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 19.699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 12.699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.331, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 4.3099999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 5.1210000000000004, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 10.48, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 10.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 23.800000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.7000000000000002, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, 
        Times[ 7.1500000000000004, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 14.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 19.199999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 16.699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 15.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.4600000000000009, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.7999999999999998, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 14.4, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"Lv ", 
        Times[ 0.46000000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 0.082000000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 147.69999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 308.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 504.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 710.89999999999998, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 5.577, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 6.8200000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 3.2599999999999998, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 1.736, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 99.200000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 127.59999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 290.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 383.30000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 51.899999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.6199999999999992, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 20.403300000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 6.5300000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 79.099999999999994, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 150.59999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 376.10000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 425.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 459.69999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 341.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 220.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 340.19999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 382.39999999999998, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 374.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 306.69999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 114.2, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 270.30000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 327.60000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 31.899999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 90.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 30.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 9.0500000000000007, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 75.700000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 154.40000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 367.39999999999998, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 566.70000000000005, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 680.19000000000005, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 589.89999999999998, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 585.22000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 567.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 494.33999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 361.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 257.69999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 100.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 231.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 296.19999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 165.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 104.59999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 41.670000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 12.65, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 66.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 150.90000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 402.10000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 398.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 357.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 328.0, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, 
        Times[ 164.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 176.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 301.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 391.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 293.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 303.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 280.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 247.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 159.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 428.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 570.70000000000005, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 758.22000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 824.20000000000005, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 704.25, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 738.05999999999995, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 612.10000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 469.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 343.10000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 59.109999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 166.09999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 177.80000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 179.09999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 100.8, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, 
        Times[ 18.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, 
        Times[ 136.69999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 293, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 513.66999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 481.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 417.10000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 336.60000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 343.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 238.5, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"p  ", 
        Times[ 76.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 124.8, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 534.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1847.7, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2340.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 3513.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1026.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2000.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1516.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1444.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 971.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1738.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2698.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2329.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1820.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2070.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2030.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1656.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 862.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1550.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2989.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 4540.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 6110.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7190.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7440.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7874.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8900.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8902.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8960.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7133.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 5907.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 5323.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 5780.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 4790.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 4050.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2823.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1532.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 2540.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 4469.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 6506.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8570.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 10220.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 11500.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 12370.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 12410.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 12020.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 10500.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8650.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7310.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7310.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 6691.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 6240.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 4930.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 3540.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 1873.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 3594.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 6145.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8240.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 6773.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7007.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7220.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7520.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 5243.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 7900.3999999999996, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8229.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8550.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 8795.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 9066.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 9321.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 6965.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 9840.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 13310.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 16654.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 19300.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 21020.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 22590.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 22420.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 21450.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 19320.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 13546.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 11850.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 11350.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 9747.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 9320.0, Kilogram, 
          Power[ Meter, -3]], Unknown, 
        Times[ 4400.0, Kilogram, 
          Power[ Meter, -3]], Unknown, 
        Times[ 5000.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 10060.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 11720.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 15370.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 18950.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 20250.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 19840.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 13670.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 13300.0, Kilogram, 
          Power[ Meter, -3]], 
        Times[ 14790.0, Kilogram, 
          Power[ Meter, -3]], Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown}, {"Qs ", 
        Times[ 0.18149999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.152, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 84.700000000000003, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 200.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 27.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 1960.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.02598, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.02674, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.027900000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.049299999999999997, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 141.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 156.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 237.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 148, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.23499999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.26900000000000002, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.0088999999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.01772, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 102.40000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 200.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 15.800000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 21.899999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 30.699999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 93.700000000000003, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 7.8200000000000003, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 80.200000000000003, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 100.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 90.700000000000003, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 401.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 116.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 40.600000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 59.899999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 50.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 2.04, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.122, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.0094900000000000002, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 58.200000000000003, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 35.299999999999997, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 17.199999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 22.699999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 53.700000000000003, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 138.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 50.600000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 117.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 150.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 71.799999999999997, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 429.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 96.799999999999997, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 81.599999999999994, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 66.599999999999994, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 243.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 2.3500000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.44900000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.0056899999999999997, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 35.899999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 18.399999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 13.5, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 11.4, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 12.5, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 16.5, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 17.899999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 13.300000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 13.9, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.6, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 11.1, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.699999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 16.199999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 14.300000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 16.800000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 34.899999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 16.399999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 23.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 57.5, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 174.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 47.899999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 87.599999999999994, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 147.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 71.599999999999994, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 317.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 8.3399999999999999, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 46.100000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 35.299999999999997, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 7.8700000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 20.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 1.7, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 0.00364, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 15.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 18.600000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 12.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 54.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 47.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 27.600000000000001, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 6.2999999999999998, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 6.7400000000000002, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], 
        Times[ 10.0, 
          Power[ Kelvin, -1], 
          Power[ Meter, -1], Watt], Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"FIP", 
        Times[ 13.598000000000001, ElectronVolt], 
        Times[ 24.587, ElectronVolt], 
        Times[ 5.3920000000000003, ElectronVolt], 
        Times[ 9.3230000000000004, ElectronVolt], 
        Times[ 8.298, ElectronVolt], 
        Times[ 11.26, ElectronVolt], 
        Times[ 14.534000000000001, ElectronVolt], 
        Times[ 13.618, ElectronVolt], 
        Times[ 17.422999999999998, ElectronVolt], 
        Times[ 21.565000000000001, ElectronVolt], 
        Times[ 5.1390000000000002, ElectronVolt], 
        Times[ 7.6459999999999999, ElectronVolt], 
        Times[ 5.9859999999999998, ElectronVolt], 
        Times[ 8.1519999999999992, ElectronVolt], 
        Times[ 10.487, ElectronVolt], 
        Times[ 10.359999999999999, ElectronVolt], 
        Times[ 12.968, ElectronVolt], 
        Times[ 15.76, ElectronVolt], 
        Times[ 4.3410000000000002, ElectronVolt], 
        Times[ 6.1130000000000004, ElectronVolt], 
        Times[ 6.5609999999999999, ElectronVolt], 
        Times[ 6.8280000000000003, ElectronVolt], 
        Times[ 6.7460000000000004, ElectronVolt], 
        Times[ 6.7670000000000003, ElectronVolt], 
        Times[ 7.4340000000000002, ElectronVolt], 
        Times[ 7.9020000000000001, ElectronVolt], 
        Times[ 7.8810000000000002, ElectronVolt], 
        Times[ 7.6399999999999997, ElectronVolt], 
        Times[ 7.726, ElectronVolt], 
        Times[ 9.3940000000000001, ElectronVolt], 
        Times[ 5.9989999999999997, ElectronVolt], 
        Times[ 7.9000000000000004, ElectronVolt], 
        Times[ 9.8149999999999995, ElectronVolt], 
        Times[ 9.7520000000000007, ElectronVolt], 
        Times[ 11.814, ElectronVolt], 
        Times[ 14, ElectronVolt], 
        Times[ 4.1769999999999996, ElectronVolt], 
        Times[ 5.6950000000000003, ElectronVolt], 
        Times[ 6.2169999999999996, ElectronVolt], 
        Times[ 6.6340000000000003, ElectronVolt], 
        Times[ 6.7590000000000003, ElectronVolt], 
        Times[ 7.0919999999999996, ElectronVolt], 
        Times[ 7.2800000000000002, ElectronVolt], 
        Times[ 7.3609999999999998, ElectronVolt], 
        Times[ 7.4589999999999996, ElectronVolt], 
        Times[ 8.3369999999999997, ElectronVolt], 
        Times[ 7.5759999999999996, ElectronVolt], 
        Times[ 8.9939999999999998, ElectronVolt], 
        Times[ 5.7859999999999996, ElectronVolt], 
        Times[ 7.3440000000000003, ElectronVolt], 
        Times[ 8.6400000000000006, ElectronVolt], 
        Times[ 9.0099999999999998, ElectronVolt], 
        Times[ 10.451000000000001, ElectronVolt], 
        Times[ 12.130000000000001, ElectronVolt], 
        Times[ 3.8940000000000001, ElectronVolt], 
        Times[ 5.2119999999999997, ElectronVolt], 
        Times[ 5.577, ElectronVolt], 
        Times[ 5.5389999999999997, ElectronVolt], 
        Times[ 5.4640000000000004, ElectronVolt], 
        Times[ 5.5250000000000004, ElectronVolt], 
        Times[ 5.5499999999999998, ElectronVolt], 
        Times[ 5.6440000000000001, ElectronVolt], 
        Times[ 5.6699999999999999, ElectronVolt], 
        Times[ 6.1500000000000004, ElectronVolt], 
        Times[ 5.8639999999999999, ElectronVolt], 
        Times[ 5.9390000000000001, ElectronVolt], 
        Times[ 6.0220000000000002, ElectronVolt], 
        Times[ 6.1079999999999997, ElectronVolt], 
        Times[ 6.1840000000000002, ElectronVolt], 
        Times[ 6.2539999999999996, ElectronVolt], 
        Times[ 5.4260000000000002, ElectronVolt], 
        Times[ 6.8250000000000002, ElectronVolt], 
        Times[ 7.8899999999999997, ElectronVolt], 
        Times[ 7.9800000000000004, ElectronVolt], 
        Times[ 7.8799999999999999, ElectronVolt], 
        Times[ 8.6999999999999993, ElectronVolt], 
        Times[ 9.0999999999999996, ElectronVolt], 
        Times[ 9.0, ElectronVolt], 
        Times[ 9.2260000000000009, ElectronVolt], 
        Times[ 10.438000000000001, ElectronVolt], 
        Times[ 6.1079999999999997, ElectronVolt], 
        Times[ 7.4169999999999998, ElectronVolt], 
        Times[ 7.2889999999999997, ElectronVolt], 
        Times[ 8.4169999999999998, ElectronVolt], Unknown, 
        Times[ 10.749000000000001, ElectronVolt], Unknown, 
        Times[ 5.2789999999999999, ElectronVolt], 
        Times[ 5.1699999999999999, ElectronVolt], 
        Times[ 6.0800000000000001, ElectronVolt], 
        Times[ 5.8899999999999997, ElectronVolt], 
        Times[ 6.194, ElectronVolt], 
        Times[ 6.266, ElectronVolt], 
        Times[ 6.0599999999999996, ElectronVolt], 
        Times[ 5.9930000000000003, ElectronVolt], 
        Times[ 6.0199999999999996, ElectronVolt], 
        Times[ 6.2300000000000004, ElectronVolt], 
        Times[ 6.2999999999999998, ElectronVolt], 
        Times[ 6.4199999999999999, ElectronVolt], 
        Times[ 6.5, ElectronVolt], 
        Times[ 6.5800000000000001, ElectronVolt], 
        Times[ 6.6500000000000004, ElectronVolt], Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown}, {
        "Qc ", 
        Times[ 14.304, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 5.1929999999999996, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 3.5819999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 1.825, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 1.026, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.70899999999999996, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 1.04, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.91800000000000004, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.82399999999999995, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 1.03, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 1.228, 
          Power[ Gram, -1], Joule, Kelvin], Unknown, 
        Times[ 0.89700000000000002, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.70499999999999996, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.76900000000000002, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.70999999999999996, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.47899999999999998, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.52000000000000002, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.75700000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.64700000000000002, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.56799999999999995, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.52300000000000002, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.48899999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.44900000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.47899999999999998, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.44900000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.42099999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.44400000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.38500000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.38800000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.371, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.32000000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.32900000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.32100000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.22600000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.248, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.36299999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.30099999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.29799999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.27800000000000002, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.26500000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.251, 
          Power[ Gram, -1], Joule, Kelvin], Unknown, 
        Times[ 0.23799999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.24299999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.24399999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.23499999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.23200000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.23300000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.22800000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.20699999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.20200000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.14499999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.158, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.24199999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.20399999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.19500000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.192, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.193, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.19, 
          Power[ Gram, -1], Joule, Kelvin], Unknown, 
        Times[ 0.19700000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.182, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.23599999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.182, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.17299999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.16500000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.16800000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.16, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.155, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.154, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.14399999999999999, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.14000000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.13200000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.13700000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.13, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.13100000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.13300000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.129, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.14000000000000001, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.129, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.129, 
          Power[ Gram, -1], Joule, Kelvin], 
        Times[ 0.122, 
          Power[ Gram, -1], Joule, Kelvin], Unknown, Unknown, 
        Times[ 0.094, 
          Power[ Gram, -1], Joule, Kelvin], Unknown, Unknown, Unknown, 
        Times[ 0.113, 
          Power[ Gram, -1], Joule, Kelvin], Unknown, 
        Times[ 0.11600000000000001, 
          Power[ Gram, -1], Joule, Kelvin], Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown}, {"SsA", 0.91000000000000003, 
        0.088999999999999996, 1.8600000000000002*^-09, 
        2.3799999999999998*^-11, 6.9*^-10, 0.00033, 0.000102, 
        0.00077999999999999999, 2.7*^-08, 0.000112, 1.8700000000000001*^-06, 
        3.4999999999999997*^-05, 2.7700000000000002*^-06, 3.26*^-05, 
        3.3999999999999997*^-07, 3.26*^-05, 1.6999999999999999*^-07, 
        3.2899999999999998*^-06, 1.23*^-07, 1.9999999999999999*^-06, 
        1.1200000000000001*^-09, 7.7999999999999997*^-08, 
        9.5999999999999999*^-09, 4.4000000000000002*^-07, 3.1*^-07, 2.94*^-05,
         7.3*^-09, 1.61*^-06, 1.7*^-08, 4.1100000000000004*^-08, 
        1.2299999999999999*^-09, 3.9000000000000002*^-09, 2.1*^-10, 
        2.0299999999999998*^-09, 2.0299999999999998*^-09, 1.5*^-09, 2.31*^-10,
         7.7000000000000003*^-10, 1.51*^-10, 3.7200000000000001*^-10, 
        2.2799999999999998*^-11, 8.3000000000000011*^-11, Unknown, 
        6.0999999999999996*^-11, 1.1200000000000001*^-11, 4.5*^-11, 1.58*^-11,
         5.2999999999999998*^-11, 6*^-10, 1.2500000000000001*^-10, 
        1.0099999999999999*^-11, 1.57*^-10, 2.9*^-11, 1.5*^-10, 
        1.2099999999999999*^-11, 1.4599999999999999*^-10, 1.45*^-11, 
        3.7000000000000001*^-11, 5.4400000000000002*^-12, 2.7*^-11, Unknown, 
        8.4200000000000001*^-12, 3.17*^-12, 1.0700000000000001*^-11, 
        1.9699999999999999*^-12, 1.286*^-11, 2.8999999999999998*^-12, 
        8.1799999999999995*^-12, 1.23*^-12, 8.0799999999999995*^-12, 
        1.197*^-12, 5.0199999999999992*^-12, 6.7499999999999995*^-13, 
        4.3399999999999997*^-12, 1.6899999999999999*^-12, 
        2.2000000000000002*^-11, 2.1600000000000002*^-11, 
        4.4000000000000003*^-11, 6.0999999999999995*^-12, 
        1.1100000000000001*^-11, 6.0000000000000003*^-12, 1.03*^-08, 
        4.7000000000000003*^-10, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, 1.0900000000000001*^-10, Unknown, 2.9399999999999997*^-11, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown}, {"EcA", 0.0014,
         8.0000000000000005*^-09, 2.0000000000000002*^-05, 
        2.7999999999999999*^-06, 1.0000000000000001*^-05, 
        0.00020000000000000001, 1.9000000000000001*^-05, 0.46100000000000002, 
        0.00058500000000000002, 5.0000000000000001*^-09, 0.023599999999999999,
         0.023300000000000001, 0.082299999999999998, 0.28199999999999997, 
        0.0010499999999999999, 0.00035, 0.000145, 3.4999999999999999*^-06, 
        0.020899999999999998, 0.041500000000000002, 2.1999999999999999*^-05, 
        0.0056499999999999996, 0.00012, 0.000102, 0.00095, 
        0.056300000000000003, 2.5000000000000001*^-05, 
        8.3999999999999995*^-05, 6.0000000000000002*^-05, 
        6.9999999999999994*^-05, 1.9000000000000001*^-05, 1.5*^-06, 
        1.8000000000000001*^-06, 4.9999999999999998*^-08, 
        2.3999999999999999*^-06, 1*^-10, 9.0000000000000006*^-05, 
        0.00036999999999999999, 3.3000000000000003*^-05, 0.000165, 
        2.0000000000000002*^-05, 1.1999999999999999*^-06, Unknown, 
        1.0000000000000001*^-09, 1.0000000000000001*^-09, 
        1.4999999999999999*^-08, 7.4999999999999997*^-08, 
        1.4999999999999999*^-07, 2.4999999999999999*^-07, 2.3*^-06, 
        1.9999999999999999*^-07, 1.0000000000000001*^-09, 
        4.4999999999999998*^-07, 3*^-11, 3.0000000000000001*^-06, 
        0.00042499999999999998, 3.8999999999999999*^-05, 
        6.6500000000000004*^-05, 9.2*^-06, 4.1499999999999999*^-05, Unknown, 
        7.0499999999999994*^-06, 1.9999999999999999*^-06, 
        6.1999999999999999*^-06, 1.1999999999999999*^-06, 
        5.2000000000000002*^-06, 1.3*^-06, 3.4999999999999999*^-06, 5.2*^-07, 
        3.2000000000000003*^-06, 7.9999999999999996*^-07, 
        3.0000000000000001*^-06, 1.9999999999999999*^-06, 
        1.2500000000000001*^-06, 6.9999999999999996*^-10, 1.5*^-09, 
        1.0000000000000001*^-09, 5.0000000000000001*^-09, 
        4.0000000000000002*^-09, 8.4999999999999994*^-08, 
        8.5000000000000001*^-07, 1.4*^-05, 8.5*^-09, 2*^-16, Unknown, 
        3.9999999999999999*^-19, Unknown, 9*^-13, 5.4999999999999996*^-16, 
        9.5999999999999996*^-06, 1.3999999999999999*^-12, 2.7*^-06, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"EoA", 0.108, 
        7.0000000000000001*^-12, 1.8*^-07, 5.5999999999999996*^-12, 
        4.4400000000000007*^-06, 2.8*^-05, 4.9999999999999998*^-07, 
        0.85699999999999998, 1.3*^-06, 1.2*^-10, 0.010800000000000001, 
        0.0012899999999999999, 2.0000000000000001*^-09, 
        2.2000000000000001*^-06, 5.9999999999999995*^-08, 
        0.00090499999999999999, 0.019400000000000001, 4.4999999999999998*^-07,
         0.00039899999999999999, 0.00041199999999999999, 
        5.9999999999999997*^-13, 1.0000000000000001*^-09, 
        2.5000000000000001*^-09, 3*^-10, 2.0000000000000001*^-10, 
        2.0000000000000001*^-09, 1.9999999999999999*^-11, 
        5.5999999999999993*^-10, 2.5000000000000002*^-10, 4.9*^-09, 3*^-11, 
        5.0000000000000002*^-11, 3.7*^-09, 2.0000000000000001*^-09, 
        6.7299999999999996*^-05, 2.1*^-10, 1.1999999999999999*^-07, 
        7.9000000000000006*^-06, 1.1999999999999999*^-11, 3*^-11, 
        9.9999999999999994*^-12, 1*^-08, Unknown, 7.0000000000000005*^-13, 
        Unknown, Unknown, 3.9999999999999998*^-11, 1.1000000000000001*^-10, 
        2*^-08, 3.9999999999999999*^-12, 2.4*^-10, Unknown, 
        5.9999999999999995*^-08, 5.0000000000000002*^-11, 3*^-10, 
        1.3000000000000001*^-08, 3.4000000000000001*^-12, 
        1.1999999999999999*^-12, 6.4*^-13, 2.7999999999999998*^-12, Unknown, 
        4.5*^-13, 1.3*^-13, 7.0000000000000005*^-13, 1.3999999999999998*^-13, 
        9.0999999999999996*^-13, 2.2000000000000002*^-13, 
        8.6999999999999993*^-13, 1.7000000000000001*^-13, 
        8.1999999999999994*^-13, 1.4999999999999999*^-13, 
        7.0000000000000001*^-12, 2*^-12, 1*^-10, 3.9999999999999999*^-12, 
        Unknown, Unknown, Unknown, 3.9999999999999999*^-12, 3*^-11, 
        1.8999999999999999*^-11, 3*^-11, 1.9999999999999999*^-11, 
        1.5000000000000001*^-20, Unknown, 5.9999999999999998*^-22, Unknown, 
        8.9000000000000004*^-17, Unknown, 9.9999999999999998*^-13, 
        4.9999999999999999*^-17, 3.2000000000000001*^-09, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown}, {"OS ", -1, 1, 0, 1, 2, 3, -4, 2,
         4, -3, -2, -1, 1, 2, 3, 4, 5, -2, -1, 0, 1, 2, 3, -4, 2, 4, -3, 3, 
        5, -2, 4, 6, -1, 1, 5, 7, 0, 1, 2, 3, 2, 3, 4, 2, 3, 4, 5, 2, 3, 6, 2,
         3, 4, 7, 2, 3, 2, 3, 2, 3, 1, 2, 2, 3, 2, 4, -3, 3, 5, -2, 4, 6, -1, 
        1, 5, 0, 1, 2, 3, 4, 3, 5, 6, 4, 6, 7, 3, 3, 2, 4, 1, 2, 3, 2, 4, -3, 
        3, 5, -2, 4, 6, -1, 1, 5, 7, 0, 1, 2, 3, 3, 4, 3, 3, 3, 2, 3, 2, 3, 3,
         3, 3, 3, 3, 3, 2, 3, 3, 4, 5, 6, 4, 6, 7, 3, 4, 3, 4, 2, 4, 1, 3, 1, 
        2, 1, 3, 2, 4, 3, 5, 2, 4, 0, 1, 2, 3, 4, 4, 5, 3, 4, 5, 6, 3, 4, 5, 
        6, 3, 4, 5, 6, 3, 4, 5, 6, 3, 3, 4, 3}, {"EN ", 
        Times[ 2.2000000000000002, ElectronVolt], Unknown, 
        Times[ 0.97999999999999998, ElectronVolt], 
        Times[ 1.5700000000000001, ElectronVolt], 
        Times[ 2.04, ElectronVolt], 
        Times[ 2.5499999999999998, ElectronVolt], 
        Times[ 3.04, ElectronVolt], 
        Times[ 3.4399999999999999, ElectronVolt], 
        Times[ 3.98, ElectronVolt], Unknown, 
        Times[ 0.93000000000000005, ElectronVolt], 
        Times[ 1.3100000000000001, ElectronVolt], 
        Times[ 1.6100000000000001, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 2.1899999999999999, ElectronVolt], 
        Times[ 2.5800000000000001, ElectronVolt], 
        Times[ 3.1600000000000001, ElectronVolt], Unknown, 
        Times[ 0.81999999999999995, ElectronVolt], 
        Times[ 1.0, ElectronVolt], 
        Times[ 1.3600000000000001, ElectronVolt], 
        Times[ 1.54, ElectronVolt], 
        Times[ 1.6299999999999999, ElectronVolt], 
        Times[ 1.6599999999999999, ElectronVolt], 
        Times[ 1.55, ElectronVolt], 
        Times[ 1.8300000000000001, ElectronVolt], 
        Times[ 1.8799999999999999, ElectronVolt], 
        Times[ 1.9099999999999999, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 1.6499999999999999, ElectronVolt], 
        Times[ 1.8100000000000001, ElectronVolt], 
        Times[ 2.0099999999999998, ElectronVolt], 
        Times[ 2.1800000000000002, ElectronVolt], 
        Times[ 2.5499999999999998, ElectronVolt], 
        Times[ 2.8999999999999999, ElectronVolt], Unknown, 
        Times[ 0.81999999999999995, ElectronVolt], 
        Times[ 0.94999999999999996, ElectronVolt], 
        Times[ 1.22, ElectronVolt], 
        Times[ 1.3300000000000001, ElectronVolt], 
        Times[ 1.6000000000000001, ElectronVolt], 
        Times[ 2.1600000000000001, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 2.2799999999999998, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 1.9299999999999999, ElectronVolt], 
        Times[ 1.6899999999999999, ElectronVolt], 
        Times[ 1.78, ElectronVolt], 
        Times[ 1.96, ElectronVolt], 
        Times[ 2.0499999999999998, ElectronVolt], 
        Times[ 2.1000000000000001, ElectronVolt], 
        Times[ 2.6600000000000001, ElectronVolt], 
        Times[ 2.6000000000000001, ElectronVolt], 
        Times[ 0.79000000000000004, ElectronVolt], 
        Times[ 0.89000000000000001, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.1200000000000001, ElectronVolt], 
        Times[ 1.1299999999999999, ElectronVolt], 
        Times[ 1.1399999999999999, ElectronVolt], 
        Times[ 1.1299999999999999, ElectronVolt], 
        Times[ 1.1699999999999999, ElectronVolt], 
        Times[ 1.2, ElectronVolt], 
        Times[ 1.2, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.22, ElectronVolt], 
        Times[ 1.23, ElectronVolt], 
        Times[ 1.24, ElectronVolt], 
        Times[ 1.25, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.27, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.5, ElectronVolt], 
        Times[ 2.3599999999999999, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 2.2799999999999998, ElectronVolt], 
        Times[ 2.54, ElectronVolt], 
        Times[ 2.0, ElectronVolt], 
        Times[ 2.04, ElectronVolt], 
        Times[ 2.3300000000000001, ElectronVolt], 
        Times[ 2.02, ElectronVolt], 
        Times[ 2.0, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], Unknown, 
        Times[ 0.69999999999999996, ElectronVolt], 
        Times[ 0.90000000000000002, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.5, ElectronVolt], 
        Times[ 1.3799999999999999, ElectronVolt], 
        Times[ 1.3600000000000001, ElectronVolt], 
        Times[ 1.28, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown}, {"EA ", 
        Times[ 72.769999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 59.630000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 26.699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 121.84999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 140.97676000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 328.0, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 52.866999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 42.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 133.59999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 72.030000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 200.41159999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 349.0, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 48.384, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.3690000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 18.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 7.5999999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 50.700000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 64.299999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 14.57, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 63.799999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 111.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 118.5, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 29, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -120, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -80, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 194.96700000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 324.69999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 46.884, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 4.5999999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 29.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 41.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 86.200000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 72.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -53, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -100, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 110, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 54.219999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 125.59999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 29, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 101.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 103, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 190.15000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 295.19999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 45.505000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 14.470000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -50, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, 
        Times[ -50, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 31.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 78.599999999999994, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -14, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -106, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 151, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 205.09999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 222.73699999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ -20, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 35.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 91.299999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -180, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -270, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 44, Joule, Kilo, 
          Power[ Mole, -1]], 0, 0, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"AR ", 
        Times[ 0.37, Angstrom], Unknown, 
        Times[ 1.52, Angstrom], 
        Times[ 1.1299999999999999, Angstrom], 
        Times[ 0.80000000000000004, Angstrom], 
        Times[ 0.77000000000000002, Angstrom], 
        Times[ 0.69999999999999996, Angstrom], 
        Times[ 0.66000000000000003, Angstrom], 
        Times[ 0.64000000000000001, Angstrom], 
        Times[ 0.51000000000000001, Angstrom], 
        Times[ 1.8600000000000001, Angstrom], 
        Times[ 1.6000000000000001, Angstrom], 
        Times[ 1.4299999999999999, Angstrom], 
        Times[ 1.1699999999999999, Angstrom], 
        Times[ 1.1000000000000001, Angstrom], 
        Times[ 1.04, Angstrom], 
        Times[ 0.98999999999999999, Angstrom], 
        Times[ 0.88, Angstrom], 
        Times[ 2.27, Angstrom], 
        Times[ 1.97, Angstrom], 
        Times[ 1.6100000000000001, Angstrom], 
        Times[ 1.45, Angstrom], 
        Times[ 1.3100000000000001, Angstrom], 
        Times[ 1.25, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.24, Angstrom], 
        Times[ 1.25, Angstrom], 
        Times[ 1.25, Angstrom], 
        Times[ 1.28, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ 1.53, Angstrom], 
        Times[ 1.2, Angstrom], 
        Times[ 1.21, Angstrom], 
        Times[ 1.1699999999999999, Angstrom], 
        Times[ 1.1399999999999999, Angstrom], 
        Times[ 1.03, Angstrom], 
        Times[ 2.4700000000000002, Angstrom], 
        Times[ 2.1499999999999999, Angstrom], 
        Times[ 1.78, Angstrom], 
        Times[ 1.6000000000000001, Angstrom], 
        Times[ 1.49, Angstrom], 
        Times[ 1.3600000000000001, Angstrom], 
        Times[ 1.3500000000000001, Angstrom], 
        Times[ 1.3200000000000001, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ 1.3799999999999999, Angstrom], 
        Times[ 1.4399999999999999, Angstrom], 
        Times[ 1.49, Angstrom], 
        Times[ 1.6299999999999999, Angstrom], 
        Times[ 1.3999999999999999, Angstrom], 
        Times[ 1.4099999999999999, Angstrom], 
        Times[ 1.4299999999999999, Angstrom], 
        Times[ 1.3300000000000001, Angstrom], 
        Times[ 1.24, Angstrom], 
        Times[ 2.6499999999999999, Angstrom], 
        Times[ 2.2200000000000002, Angstrom], 
        Times[ 1.8799999999999999, Angstrom], 
        Times[ 1.8200000000000001, Angstrom], 
        Times[ 1.8200000000000001, Angstrom], 
        Times[ 1.8100000000000001, Angstrom], 
        Times[ 1.8100000000000001, Angstrom], 
        Times[ 1.8, Angstrom], 
        Times[ 2.0, Angstrom], 
        Times[ 1.79, Angstrom], 
        Times[ 1.76, Angstrom], 
        Times[ 1.75, Angstrom], 
        Times[ 1.74, Angstrom], 
        Times[ 1.73, Angstrom], 
        Times[ 1.72, Angstrom], 
        Times[ 1.9399999999999999, Angstrom], 
        Times[ 1.72, Angstrom], 
        Times[ 1.6699999999999999, Angstrom], 
        Times[ 1.49, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ 1.3600000000000001, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.4399999999999999, Angstrom], 
        Times[ 1.5, Angstrom], 
        Times[ 1.47, Angstrom], 
        Times[ 1.75, Angstrom], 
        Times[ 1.8200000000000001, Angstrom], 
        Times[ 1.6699999999999999, Angstrom], 
        Times[ 1.3999999999999999, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ -2.7000000000000002, Angstrom], 
        Times[ 2.3300000000000001, Angstrom], 
        Times[ 1.8799999999999999, Angstrom], 
        Times[ 1.8, Angstrom], 
        Times[ 1.6100000000000001, Angstrom], 
        Times[ 1.3799999999999999, Angstrom], 
        Times[ 1.3, Angstrom], 
        Times[ 1.51, Angstrom], 
        Times[ 1.8400000000000001, Angstrom], Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown}}]]], "Output"]
}, Closed]],

Cell["\<\
13 supposes that SsA is at 13 and the rest are for this \"ex mini \
chart\"\
\>", "Text"],

Cell[BoxData[
    \(ColumnChart2[] \
:= \[IndentingNewLine]Table[\[IndentingNewLine]Flatten[{efunsab[\([j]\)], \
\(efuns[\([j]\)]\)[Elements]}]\[IndentingNewLine], {j, 13, 
          Length[efuns] - 2}\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(TableForm[ColumnChart2[]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"SsA\"\>", "0.91`", "0.089`", "1.8600000000000002`*^-9", 
            "2.3799999999999998`*^-11", "6.9`*^-10", "0.00033`", "0.000102`", 
            "0.00078`", "2.7`*^-8", "0.000112`", "1.87`*^-6", "0.000035`", 
            "2.77`*^-6", "0.0000326`", "3.4`*^-7", "0.0000326`", "1.7`*^-7", 
            "3.29`*^-6", "1.23`*^-7", "2.`*^-6", "1.12`*^-9", "7.8`*^-8", 
            "9.6`*^-9", "4.4`*^-7", "3.1`*^-7", "0.0000294`", "7.3`*^-9", 
            "1.61`*^-6", "1.7`*^-8", "4.1100000000000004`*^-8", 
            "1.2299999999999999`*^-9", "3.9`*^-9", "2.1`*^-10", "2.03`*^-9", 
            "2.03`*^-9", "1.5`*^-9", "2.31`*^-10", "7.7`*^-10", "1.51`*^-10", 
            "3.72`*^-10", "2.2799999999999998`*^-11", 
            "8.300000000000001`*^-11", "Unknown", "6.1`*^-11", "1.12`*^-11", 
            "4.5`*^-11", "1.58`*^-11", "5.3`*^-11", "6.`*^-10", "1.25`*^-10", 
            "1.01`*^-11", "1.57`*^-10", "2.9`*^-11", "1.5`*^-10", 
            "1.2099999999999999`*^-11", "1.4599999999999999`*^-10", 
            "1.45`*^-11", "3.7`*^-11", "5.44`*^-12", "2.7`*^-11", "Unknown", 
            "8.42`*^-12", "3.17`*^-12", "1.0700000000000001`*^-11", 
            "1.97`*^-12", "1.286`*^-11", "2.8999999999999998`*^-12", 
            "8.18`*^-12", "1.23`*^-12", "8.08`*^-12", "1.197`*^-12", 
            "5.019999999999999`*^-12", "6.75`*^-13", "4.34`*^-12", 
            "1.6899999999999999`*^-12", "2.2`*^-11", 
            "2.1600000000000002`*^-11", "4.4`*^-11", 
            "6.0999999999999995`*^-12", "1.11`*^-11", "6.`*^-12", "1.03`*^-8",
             "4.7`*^-10", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "1.0900000000000001`*^-10", "Unknown", 
            "2.9399999999999997`*^-11", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
          {"\<\"EcA\"\>", "0.0014`", "8.`*^-9", "0.00002`", "2.8`*^-6", 
            "0.00001`", "0.0002`", "0.000019`", "0.461`", "0.000585`", 
            "5.`*^-9", "0.0236`", "0.0233`", "0.0823`", "0.282`", "0.00105`", 
            "0.00035`", "0.000145`", "3.5`*^-6", "0.0209`", "0.0415`", 
            "0.000022`", "0.00565`", "0.00012`", "0.000102`", "0.00095`", 
            "0.0563`", "0.000025`", "0.000084`", "0.00006`", "0.00007`", 
            "0.000019`", "1.5`*^-6", "1.8000000000000001`*^-6", "5.`*^-8", 
            "2.4`*^-6", "1.`*^-10", "0.00009`", "0.00037`", "0.000033`", 
            "0.000165`", "0.00002`", "1.2`*^-6", "Unknown", "1.`*^-9", 
            "1.`*^-9", "1.5`*^-8", "7.5`*^-8", "1.5`*^-7", "2.5`*^-7", 
            "2.3`*^-6", "2.`*^-7", "1.`*^-9", "4.5`*^-7", "3.`*^-11", 
            "3.`*^-6", "0.000425`", "0.000039`", "0.0000665`", "9.2`*^-6", 
            "0.0000415`", "Unknown", "7.049999999999999`*^-6", "2.`*^-6", 
            "6.2`*^-6", "1.2`*^-6", "5.2`*^-6", "1.3`*^-6", "3.5`*^-6", 
            "5.2`*^-7", "3.2000000000000003`*^-6", "8.`*^-7", "3.`*^-6", 
            "2.`*^-6", "1.25`*^-6", "7.`*^-10", "1.5`*^-9", "1.`*^-9", 
            "5.`*^-9", "4.`*^-9", "8.5`*^-8", "8.5`*^-7", "0.000014`", 
            "8.5`*^-9", "2.`*^-16", "Unknown", "4.`*^-19", "Unknown", 
            "9.`*^-13", "5.5`*^-16", "9.6`*^-6", "1.3999999999999999`*^-12", 
            "2.7`*^-6", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
             "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
          {"\<\"EoA\"\>", "0.108`", "7.`*^-12", "1.8`*^-7", 
            "5.5999999999999996`*^-12", "4.440000000000001`*^-6", "0.000028`",
             "5.`*^-7", "0.857`", "1.3`*^-6", "1.2`*^-10", "0.0108`", 
            "0.00129`", "2.`*^-9", "2.2`*^-6", "6.`*^-8", "0.000905`", 
            "0.0194`", "4.5`*^-7", "0.000399`", "0.000412`", "6.`*^-13", 
            "1.`*^-9", "2.5`*^-9", "3.`*^-10", "2.`*^-10", "2.`*^-9", 
            "2.`*^-11", "5.599999999999999`*^-10", "2.5`*^-10", "4.9`*^-9", 
            "3.`*^-11", "5.`*^-11", "3.7`*^-9", "2.`*^-9", "0.0000673`", 
            "2.1`*^-10", "1.2`*^-7", "7.9`*^-6", "1.1999999999999999`*^-11", 
            "3.`*^-11", "1.`*^-11", "1.`*^-8", "Unknown", "7.`*^-13", 
            "Unknown", "Unknown", "4.`*^-11", "1.1000000000000001`*^-10", 
            "2.`*^-8", "4.`*^-12", "2.4`*^-10", "Unknown", "6.`*^-8", 
            "5.`*^-11", "3.`*^-10", "1.3`*^-8", "3.4`*^-12", "1.2`*^-12", 
            "6.4`*^-13", "2.7999999999999998`*^-12", "Unknown", "4.5`*^-13", 
            "1.3`*^-13", "7.`*^-13", "1.3999999999999998`*^-13", "9.1`*^-13", 
            "2.2000000000000002`*^-13", "8.699999999999999`*^-13", 
            "1.7`*^-13", "8.199999999999999`*^-13", "1.5`*^-13", "7.`*^-12", 
            "2.`*^-12", "1.`*^-10", "4.`*^-12", "Unknown", "Unknown", 
            "Unknown", "4.`*^-12", "3.`*^-11", "1.9`*^-11", "3.`*^-11", 
            "2.`*^-11", "1.5`*^-20", "Unknown", "6.`*^-22", "Unknown", 
            "8.9`*^-17", "Unknown", "1.`*^-12", "5.`*^-17", "3.2`*^-9", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
          {"\<\"OS \"\>", \(-1\), "1", "0", "1", "2", "3", \(-4\), "2", 
            "4", \(-3\), \(-2\), \(-1\), "1", "2", "3", "4", 
            "5", \(-2\), \(-1\), "0", "1", "2", "3", \(-4\), "2", "4", \(-3\),
             "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "7", "0", "1", "2",
             "3", "2", "3", "4", "2", "3", "4", "5", "2", "3", "6", "2", "3", 
            "4", "7", "2", "3", "2", "3", "2", "3", "1", "2", "2", "3", "2", 
            "4", \(-3\), "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "0", 
            "1", "2", "3", "4", "3", "5", "6", "4", "6", "7", "3", "3", "2", 
            "4", "1", "2", "3", "2", "4", \(-3\), "3", "5", \(-2\), "4", 
            "6", \(-1\), "1", "5", "7", "0", "1", "2", "3", "3", "4", "3", 
            "3", "3", "2", "3", "2", "3", "3", "3", "3", "3", "3", "3", "2", 
            "3", "3", "4", "5", "6", "4", "6", "7", "3", "4", "3", "4", "2", 
            "4", "1", "3", "1", "2", "1", "3", "2", "4", "3", "5", "2", "4", 
            "0", "1", "2", "3", "4", "4", "5", "3", "4", "5", "6", "3", "4", 
            "5", "6", "3", "4", "5", "6", "3", "4", "5", "6", "3", "3", "4", 
            "3"},
          {"\<\"EN \"\>", \(2.2`\ ElectronVolt\), 
            "Unknown", \(0.98`\ ElectronVolt\), \(1.57`\ ElectronVolt\), \
\(2.04`\ ElectronVolt\), \(2.55`\ ElectronVolt\), \(3.04`\ ElectronVolt\), \
\(3.44`\ ElectronVolt\), \(3.98`\ ElectronVolt\), 
            "Unknown", \(0.93`\ ElectronVolt\), \(1.31`\ ElectronVolt\), \
\(1.61`\ ElectronVolt\), \(1.9`\ ElectronVolt\), \(2.19`\ ElectronVolt\), \
\(2.58`\ ElectronVolt\), \(3.16`\ ElectronVolt\), 
            "Unknown", \(0.82`\ ElectronVolt\), \(1.`\ ElectronVolt\), \
\(1.36`\ ElectronVolt\), \(1.54`\ ElectronVolt\), \(1.63`\ ElectronVolt\), \
\(1.66`\ ElectronVolt\), \(1.55`\ ElectronVolt\), \(1.83`\ ElectronVolt\), \
\(1.88`\ ElectronVolt\), \(1.91`\ ElectronVolt\), \(1.9`\ ElectronVolt\), \
\(1.65`\ ElectronVolt\), \(1.81`\ ElectronVolt\), \(2.01`\ ElectronVolt\), \
\(2.18`\ ElectronVolt\), \(2.55`\ ElectronVolt\), \(2.9`\ ElectronVolt\), 
            "Unknown", \(0.82`\ ElectronVolt\), \(0.95`\ ElectronVolt\), \
\(1.22`\ ElectronVolt\), \(1.33`\ ElectronVolt\), \(1.6`\ ElectronVolt\), \
\(2.16`\ ElectronVolt\), \(1.9`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \
\(2.28`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \(1.93`\ ElectronVolt\), \
\(1.69`\ ElectronVolt\), \(1.78`\ ElectronVolt\), \(1.96`\ ElectronVolt\), \
\(2.05`\ ElectronVolt\), \(2.1`\ ElectronVolt\), \(2.66`\ ElectronVolt\), \
\(2.6`\ ElectronVolt\), \(0.79`\ ElectronVolt\), \(0.89`\ ElectronVolt\), \
\(1.1`\ ElectronVolt\), \(1.12`\ ElectronVolt\), \(1.13`\ ElectronVolt\), \
\(1.14`\ ElectronVolt\), \(1.13`\ ElectronVolt\), \(1.17`\ ElectronVolt\), \
\(1.2`\ ElectronVolt\), \(1.2`\ ElectronVolt\), \(1.1`\ ElectronVolt\), \
\(1.22`\ ElectronVolt\), \(1.23`\ ElectronVolt\), \(1.24`\ ElectronVolt\), \
\(1.25`\ ElectronVolt\), \(1.1`\ ElectronVolt\), \(1.27`\ ElectronVolt\), \
\(1.3`\ ElectronVolt\), \(1.5`\ ElectronVolt\), \(2.36`\ ElectronVolt\), \
\(1.9`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \(2.2`\ ElectronVolt\), \
\(2.28`\ ElectronVolt\), \(2.54`\ ElectronVolt\), \(2.`\ ElectronVolt\), \
\(2.04`\ ElectronVolt\), \(2.33`\ ElectronVolt\), \(2.02`\ ElectronVolt\), \
\(2.`\ ElectronVolt\), \(2.2`\ ElectronVolt\), 
            "Unknown", \(0.7`\ ElectronVolt\), \(0.9`\ ElectronVolt\), \(1.1`\
\ ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.5`\ ElectronVolt\), \(1.38`\ \
ElectronVolt\), \(1.36`\ ElectronVolt\), \(1.28`\ ElectronVolt\), \(1.3`\ \
ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ \
ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ ElectronVolt\), \(1.3`\ \
ElectronVolt\), \(1.3`\ ElectronVolt\), "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
          {"\<\"EA \"\>", \(\(72.77`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(59.63`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(26.7`\ Joule\ Kilo\)\/Mole\), \(\(121.85`\ Joule\ Kilo\)\
\/Mole\), 
            "0", \(\(140.97676`\ Joule\ Kilo\)\/Mole\), \(\(328.`\ Joule\ \
Kilo\)\/Mole\), "0", \(\(52.867`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(42.6`\ Joule\ Kilo\)\/Mole\), \(\(133.6`\ Joule\ \
Kilo\)\/Mole\), \(\(72.03`\ Joule\ Kilo\)\/Mole\), \(\(200.4116`\ Joule\ Kilo\
\)\/Mole\), \(\(349.`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(48.384`\ Joule\ Kilo\)\/Mole\), \(\(2.369`\ Joule\ \
Kilo\)\/Mole\), \(\(18.1`\ Joule\ Kilo\)\/Mole\), \(\(7.6`\ Joule\ \
Kilo\)\/Mole\), \(\(50.7`\ Joule\ Kilo\)\/Mole\), \(\(64.3`\ Joule\ \
Kilo\)\/Mole\), 
            "0", \(\(14.57`\ Joule\ Kilo\)\/Mole\), \(\(63.8`\ Joule\ \
Kilo\)\/Mole\), \(\(111.5`\ Joule\ Kilo\)\/Mole\), \(\(118.5`\ Joule\ \
Kilo\)\/Mole\), 
            "0", \(\(29\ Joule\ Kilo\)\/Mole\), \(-\(\(120\ Joule\ \
Kilo\)\/Mole\)\), \(-\(\(80\ Joule\ Kilo\)\/Mole\)\), \(\(194.967`\ Joule\ \
Kilo\)\/Mole\), \(\(324.7`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(46.884`\ Joule\ Kilo\)\/Mole\), \(\(4.6`\ Joule\ \
Kilo\)\/Mole\), \(\(29.6`\ Joule\ Kilo\)\/Mole\), \(\(41.1`\ Joule\ \
Kilo\)\/Mole\), \(\(86.2`\ Joule\ Kilo\)\/Mole\), \(\(72.`\ Joule\ \
Kilo\)\/Mole\), \(-\(\(53\ Joule\ Kilo\)\/Mole\)\), \(-\(\(100\ Joule\ Kilo\)\
\/Mole\)\), \(\(110\ Joule\ Kilo\)\/Mole\), \(\(54.22`\ Joule\ \
Kilo\)\/Mole\), \(\(125.6`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(29\ Joule\ Kilo\)\/Mole\), \(\(101.`\ Joule\ \
Kilo\)\/Mole\), \(\(103\ Joule\ Kilo\)\/Mole\), \(\(190.15`\ Joule\ \
Kilo\)\/Mole\), \(\(295.2`\ Joule\ Kilo\)\/Mole\), 
            "0", \(\(45.505`\ Joule\ Kilo\)\/Mole\), \(\(14.47`\ Joule\ \
Kilo\)\/Mole\), \(-\(\(50\ Joule\ Kilo\)\/Mole\)\), "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", \(-\(\(50\ Joule\ Kilo\)\/Mole\)\), 
            
            "0", \(\(31.1`\ Joule\ Kilo\)\/Mole\), \(\(78.6`\ Joule\ \
Kilo\)\/Mole\), \(-\(\(14\ Joule\ Kilo\)\/Mole\)\), \(-\(\(106\ Joule\ Kilo\)\
\/Mole\)\), \(\(151\ Joule\ Kilo\)\/Mole\), \(\(205.1`\ Joule\ \
Kilo\)\/Mole\), \(\(222.737`\ Joule\ Kilo\)\/Mole\), 
            "0", \(-\(\(20\ Joule\ Kilo\)\/Mole\)\), \(\(35.1`\ Joule\ Kilo\)\
\/Mole\), \(\(91.3`\ Joule\ Kilo\)\/Mole\), \(-\(\(180\ Joule\ Kilo\)\/Mole\)\
\), \(-\(\(270\ Joule\ Kilo\)\/Mole\)\), "0", \(\(44\ Joule\ Kilo\)\/Mole\), 
            "0", "0", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"},
          {"\<\"AR \"\>", \(0.37`\ Angstrom\), 
            "Unknown", \(1.52`\ Angstrom\), \(1.13`\ Angstrom\), \(0.8`\ \
Angstrom\), \(0.77`\ Angstrom\), \(0.7`\ Angstrom\), \(0.66`\ Angstrom\), \
\(0.64`\ Angstrom\), \(0.51`\ Angstrom\), \(1.86`\ Angstrom\), \(1.6`\ \
Angstrom\), \(1.43`\ Angstrom\), \(1.17`\ Angstrom\), \(1.1`\ Angstrom\), \
\(1.04`\ Angstrom\), \(0.99`\ Angstrom\), \(0.88`\ Angstrom\), \(2.27`\ \
Angstrom\), \(1.97`\ Angstrom\), \(1.61`\ Angstrom\), \(1.45`\ Angstrom\), \
\(1.31`\ Angstrom\), \(1.25`\ Angstrom\), \(1.37`\ Angstrom\), \(1.24`\ \
Angstrom\), \(1.25`\ Angstrom\), \(1.25`\ Angstrom\), \(1.28`\ Angstrom\), \
\(1.34`\ Angstrom\), \(1.53`\ Angstrom\), \(1.2`\ Angstrom\), \(1.21`\ \
Angstrom\), \(1.17`\ Angstrom\), \(1.14`\ Angstrom\), \(1.03`\ Angstrom\), \
\(2.47`\ Angstrom\), \(2.15`\ Angstrom\), \(1.78`\ Angstrom\), \(1.6`\ \
Angstrom\), \(1.49`\ Angstrom\), \(1.36`\ Angstrom\), \(1.35`\ Angstrom\), \
\(1.32`\ Angstrom\), \(1.34`\ Angstrom\), \(1.38`\ Angstrom\), \(1.44`\ \
Angstrom\), \(1.49`\ Angstrom\), \(1.63`\ Angstrom\), \(1.4`\ Angstrom\), \
\(1.41`\ Angstrom\), \(1.43`\ Angstrom\), \(1.33`\ Angstrom\), \(1.24`\ \
Angstrom\), \(2.65`\ Angstrom\), \(2.22`\ Angstrom\), \(1.88`\ Angstrom\), \
\(1.82`\ Angstrom\), \(1.82`\ Angstrom\), \(1.81`\ Angstrom\), \(1.81`\ \
Angstrom\), \(1.8`\ Angstrom\), \(2.`\ Angstrom\), \(1.79`\ Angstrom\), \
\(1.76`\ Angstrom\), \(1.75`\ Angstrom\), \(1.74`\ Angstrom\), \(1.73`\ \
Angstrom\), \(1.72`\ Angstrom\), \(1.94`\ Angstrom\), \(1.72`\ Angstrom\), \
\(1.67`\ Angstrom\), \(1.49`\ Angstrom\), \(1.37`\ Angstrom\), \(1.37`\ \
Angstrom\), \(1.34`\ Angstrom\), \(1.36`\ Angstrom\), \(1.37`\ Angstrom\), \
\(1.44`\ Angstrom\), \(1.5`\ Angstrom\), \(1.47`\ Angstrom\), \(1.75`\ \
Angstrom\), \(1.82`\ Angstrom\), \(1.67`\ Angstrom\), \(1.4`\ Angstrom\), \
\(1.34`\ Angstrom\), \(\(-2.7`\)\ Angstrom\), \(2.33`\ Angstrom\), \(1.88`\ \
Angstrom\), \(1.8`\ Angstrom\), \(1.61`\ Angstrom\), \(1.38`\ Angstrom\), \
\(1.3`\ Angstrom\), \(1.51`\ Angstrom\), \(1.84`\ Angstrom\), "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", 
            "Unknown", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{"SsA", 0.91000000000000003, 0.088999999999999996, 
        1.8600000000000002*^-09, 2.3799999999999998*^-11, 6.9*^-10, 0.00033, 
        0.000102, 0.00077999999999999999, 2.7*^-08, 0.000112, 
        1.8700000000000001*^-06, 3.4999999999999997*^-05, 
        2.7700000000000002*^-06, 3.26*^-05, 3.3999999999999997*^-07, 
        3.26*^-05, 1.6999999999999999*^-07, 3.2899999999999998*^-06, 
        1.23*^-07, 1.9999999999999999*^-06, 1.1200000000000001*^-09, 
        7.7999999999999997*^-08, 9.5999999999999999*^-09, 
        4.4000000000000002*^-07, 3.1*^-07, 2.94*^-05, 7.3*^-09, 1.61*^-06, 
        1.7*^-08, 4.1100000000000004*^-08, 1.2299999999999999*^-09, 
        3.9000000000000002*^-09, 2.1*^-10, 2.0299999999999998*^-09, 
        2.0299999999999998*^-09, 1.5*^-09, 2.31*^-10, 7.7000000000000003*^-10,
         1.51*^-10, 3.7200000000000001*^-10, 2.2799999999999998*^-11, 
        8.3000000000000011*^-11, Unknown, 6.0999999999999996*^-11, 
        1.1200000000000001*^-11, 4.5*^-11, 1.58*^-11, 5.2999999999999998*^-11,
         6*^-10, 1.2500000000000001*^-10, 1.0099999999999999*^-11, 1.57*^-10, 
        2.9*^-11, 1.5*^-10, 1.2099999999999999*^-11, 1.4599999999999999*^-10, 
        1.45*^-11, 3.7000000000000001*^-11, 5.4400000000000002*^-12, 2.7*^-11,
         Unknown, 8.4200000000000001*^-12, 3.17*^-12, 1.0700000000000001*^-11,
         1.9699999999999999*^-12, 1.286*^-11, 2.8999999999999998*^-12, 
        8.1799999999999995*^-12, 1.23*^-12, 8.0799999999999995*^-12, 
        1.197*^-12, 5.0199999999999992*^-12, 6.7499999999999995*^-13, 
        4.3399999999999997*^-12, 1.6899999999999999*^-12, 
        2.2000000000000002*^-11, 2.1600000000000002*^-11, 
        4.4000000000000003*^-11, 6.0999999999999995*^-12, 
        1.1100000000000001*^-11, 6.0000000000000003*^-12, 1.03*^-08, 
        4.7000000000000003*^-10, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, 1.0900000000000001*^-10, Unknown, 2.9399999999999997*^-11, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown}, {"EcA", 0.0014,
         8.0000000000000005*^-09, 2.0000000000000002*^-05, 
        2.7999999999999999*^-06, 1.0000000000000001*^-05, 
        0.00020000000000000001, 1.9000000000000001*^-05, 0.46100000000000002, 
        0.00058500000000000002, 5.0000000000000001*^-09, 0.023599999999999999,
         0.023300000000000001, 0.082299999999999998, 0.28199999999999997, 
        0.0010499999999999999, 0.00035, 0.000145, 3.4999999999999999*^-06, 
        0.020899999999999998, 0.041500000000000002, 2.1999999999999999*^-05, 
        0.0056499999999999996, 0.00012, 0.000102, 0.00095, 
        0.056300000000000003, 2.5000000000000001*^-05, 
        8.3999999999999995*^-05, 6.0000000000000002*^-05, 
        6.9999999999999994*^-05, 1.9000000000000001*^-05, 1.5*^-06, 
        1.8000000000000001*^-06, 4.9999999999999998*^-08, 
        2.3999999999999999*^-06, 1*^-10, 9.0000000000000006*^-05, 
        0.00036999999999999999, 3.3000000000000003*^-05, 0.000165, 
        2.0000000000000002*^-05, 1.1999999999999999*^-06, Unknown, 
        1.0000000000000001*^-09, 1.0000000000000001*^-09, 
        1.4999999999999999*^-08, 7.4999999999999997*^-08, 
        1.4999999999999999*^-07, 2.4999999999999999*^-07, 2.3*^-06, 
        1.9999999999999999*^-07, 1.0000000000000001*^-09, 
        4.4999999999999998*^-07, 3*^-11, 3.0000000000000001*^-06, 
        0.00042499999999999998, 3.8999999999999999*^-05, 
        6.6500000000000004*^-05, 9.2*^-06, 4.1499999999999999*^-05, Unknown, 
        7.0499999999999994*^-06, 1.9999999999999999*^-06, 
        6.1999999999999999*^-06, 1.1999999999999999*^-06, 
        5.2000000000000002*^-06, 1.3*^-06, 3.4999999999999999*^-06, 5.2*^-07, 
        3.2000000000000003*^-06, 7.9999999999999996*^-07, 
        3.0000000000000001*^-06, 1.9999999999999999*^-06, 
        1.2500000000000001*^-06, 6.9999999999999996*^-10, 1.5*^-09, 
        1.0000000000000001*^-09, 5.0000000000000001*^-09, 
        4.0000000000000002*^-09, 8.4999999999999994*^-08, 
        8.5000000000000001*^-07, 1.4*^-05, 8.5*^-09, 2*^-16, Unknown, 
        3.9999999999999999*^-19, Unknown, 9*^-13, 5.4999999999999996*^-16, 
        9.5999999999999996*^-06, 1.3999999999999999*^-12, 2.7*^-06, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"EoA", 0.108, 
        7.0000000000000001*^-12, 1.8*^-07, 5.5999999999999996*^-12, 
        4.4400000000000007*^-06, 2.8*^-05, 4.9999999999999998*^-07, 
        0.85699999999999998, 1.3*^-06, 1.2*^-10, 0.010800000000000001, 
        0.0012899999999999999, 2.0000000000000001*^-09, 
        2.2000000000000001*^-06, 5.9999999999999995*^-08, 
        0.00090499999999999999, 0.019400000000000001, 4.4999999999999998*^-07,
         0.00039899999999999999, 0.00041199999999999999, 
        5.9999999999999997*^-13, 1.0000000000000001*^-09, 
        2.5000000000000001*^-09, 3*^-10, 2.0000000000000001*^-10, 
        2.0000000000000001*^-09, 1.9999999999999999*^-11, 
        5.5999999999999993*^-10, 2.5000000000000002*^-10, 4.9*^-09, 3*^-11, 
        5.0000000000000002*^-11, 3.7*^-09, 2.0000000000000001*^-09, 
        6.7299999999999996*^-05, 2.1*^-10, 1.1999999999999999*^-07, 
        7.9000000000000006*^-06, 1.1999999999999999*^-11, 3*^-11, 
        9.9999999999999994*^-12, 1*^-08, Unknown, 7.0000000000000005*^-13, 
        Unknown, Unknown, 3.9999999999999998*^-11, 1.1000000000000001*^-10, 
        2*^-08, 3.9999999999999999*^-12, 2.4*^-10, Unknown, 
        5.9999999999999995*^-08, 5.0000000000000002*^-11, 3*^-10, 
        1.3000000000000001*^-08, 3.4000000000000001*^-12, 
        1.1999999999999999*^-12, 6.4*^-13, 2.7999999999999998*^-12, Unknown, 
        4.5*^-13, 1.3*^-13, 7.0000000000000005*^-13, 1.3999999999999998*^-13, 
        9.0999999999999996*^-13, 2.2000000000000002*^-13, 
        8.6999999999999993*^-13, 1.7000000000000001*^-13, 
        8.1999999999999994*^-13, 1.4999999999999999*^-13, 
        7.0000000000000001*^-12, 2*^-12, 1*^-10, 3.9999999999999999*^-12, 
        Unknown, Unknown, Unknown, 3.9999999999999999*^-12, 3*^-11, 
        1.8999999999999999*^-11, 3*^-11, 1.9999999999999999*^-11, 
        1.5000000000000001*^-20, Unknown, 5.9999999999999998*^-22, Unknown, 
        8.9000000000000004*^-17, Unknown, 9.9999999999999998*^-13, 
        4.9999999999999999*^-17, 3.2000000000000001*^-09, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown}, {"OS ", -1, 1, 0, 1, 2, 3, -4, 2,
         4, -3, -2, -1, 1, 2, 3, 4, 5, -2, -1, 0, 1, 2, 3, -4, 2, 4, -3, 3, 
        5, -2, 4, 6, -1, 1, 5, 7, 0, 1, 2, 3, 2, 3, 4, 2, 3, 4, 5, 2, 3, 6, 2,
         3, 4, 7, 2, 3, 2, 3, 2, 3, 1, 2, 2, 3, 2, 4, -3, 3, 5, -2, 4, 6, -1, 
        1, 5, 0, 1, 2, 3, 4, 3, 5, 6, 4, 6, 7, 3, 3, 2, 4, 1, 2, 3, 2, 4, -3, 
        3, 5, -2, 4, 6, -1, 1, 5, 7, 0, 1, 2, 3, 3, 4, 3, 3, 3, 2, 3, 2, 3, 3,
         3, 3, 3, 3, 3, 2, 3, 3, 4, 5, 6, 4, 6, 7, 3, 4, 3, 4, 2, 4, 1, 3, 1, 
        2, 1, 3, 2, 4, 3, 5, 2, 4, 0, 1, 2, 3, 4, 4, 5, 3, 4, 5, 6, 3, 4, 5, 
        6, 3, 4, 5, 6, 3, 4, 5, 6, 3, 3, 4, 3}, {"EN ", 
        Times[ 2.2000000000000002, ElectronVolt], Unknown, 
        Times[ 0.97999999999999998, ElectronVolt], 
        Times[ 1.5700000000000001, ElectronVolt], 
        Times[ 2.04, ElectronVolt], 
        Times[ 2.5499999999999998, ElectronVolt], 
        Times[ 3.04, ElectronVolt], 
        Times[ 3.4399999999999999, ElectronVolt], 
        Times[ 3.98, ElectronVolt], Unknown, 
        Times[ 0.93000000000000005, ElectronVolt], 
        Times[ 1.3100000000000001, ElectronVolt], 
        Times[ 1.6100000000000001, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 2.1899999999999999, ElectronVolt], 
        Times[ 2.5800000000000001, ElectronVolt], 
        Times[ 3.1600000000000001, ElectronVolt], Unknown, 
        Times[ 0.81999999999999995, ElectronVolt], 
        Times[ 1.0, ElectronVolt], 
        Times[ 1.3600000000000001, ElectronVolt], 
        Times[ 1.54, ElectronVolt], 
        Times[ 1.6299999999999999, ElectronVolt], 
        Times[ 1.6599999999999999, ElectronVolt], 
        Times[ 1.55, ElectronVolt], 
        Times[ 1.8300000000000001, ElectronVolt], 
        Times[ 1.8799999999999999, ElectronVolt], 
        Times[ 1.9099999999999999, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 1.6499999999999999, ElectronVolt], 
        Times[ 1.8100000000000001, ElectronVolt], 
        Times[ 2.0099999999999998, ElectronVolt], 
        Times[ 2.1800000000000002, ElectronVolt], 
        Times[ 2.5499999999999998, ElectronVolt], 
        Times[ 2.8999999999999999, ElectronVolt], Unknown, 
        Times[ 0.81999999999999995, ElectronVolt], 
        Times[ 0.94999999999999996, ElectronVolt], 
        Times[ 1.22, ElectronVolt], 
        Times[ 1.3300000000000001, ElectronVolt], 
        Times[ 1.6000000000000001, ElectronVolt], 
        Times[ 2.1600000000000001, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 2.2799999999999998, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 1.9299999999999999, ElectronVolt], 
        Times[ 1.6899999999999999, ElectronVolt], 
        Times[ 1.78, ElectronVolt], 
        Times[ 1.96, ElectronVolt], 
        Times[ 2.0499999999999998, ElectronVolt], 
        Times[ 2.1000000000000001, ElectronVolt], 
        Times[ 2.6600000000000001, ElectronVolt], 
        Times[ 2.6000000000000001, ElectronVolt], 
        Times[ 0.79000000000000004, ElectronVolt], 
        Times[ 0.89000000000000001, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.1200000000000001, ElectronVolt], 
        Times[ 1.1299999999999999, ElectronVolt], 
        Times[ 1.1399999999999999, ElectronVolt], 
        Times[ 1.1299999999999999, ElectronVolt], 
        Times[ 1.1699999999999999, ElectronVolt], 
        Times[ 1.2, ElectronVolt], 
        Times[ 1.2, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.22, ElectronVolt], 
        Times[ 1.23, ElectronVolt], 
        Times[ 1.24, ElectronVolt], 
        Times[ 1.25, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.27, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.5, ElectronVolt], 
        Times[ 2.3599999999999999, ElectronVolt], 
        Times[ 1.8999999999999999, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], 
        Times[ 2.2799999999999998, ElectronVolt], 
        Times[ 2.54, ElectronVolt], 
        Times[ 2.0, ElectronVolt], 
        Times[ 2.04, ElectronVolt], 
        Times[ 2.3300000000000001, ElectronVolt], 
        Times[ 2.02, ElectronVolt], 
        Times[ 2.0, ElectronVolt], 
        Times[ 2.2000000000000002, ElectronVolt], Unknown, 
        Times[ 0.69999999999999996, ElectronVolt], 
        Times[ 0.90000000000000002, ElectronVolt], 
        Times[ 1.1000000000000001, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.5, ElectronVolt], 
        Times[ 1.3799999999999999, ElectronVolt], 
        Times[ 1.3600000000000001, ElectronVolt], 
        Times[ 1.28, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], 
        Times[ 1.3, ElectronVolt], Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown}, {"EA ", 
        Times[ 72.769999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 59.630000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 26.699999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 121.84999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 140.97676000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 328.0, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 52.866999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 42.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 133.59999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 72.030000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 200.41159999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 349.0, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 48.384, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 2.3690000000000002, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 18.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 7.5999999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 50.700000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 64.299999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 14.57, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 63.799999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 111.5, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 118.5, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 29, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -120, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -80, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 194.96700000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 324.69999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 46.884, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 4.5999999999999996, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 29.600000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 41.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 86.200000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 72.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -53, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -100, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 110, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 54.219999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 125.59999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 29, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 101.0, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 103, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 190.15000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 295.19999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 45.505000000000003, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 14.470000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -50, Joule, Kilo, 
          Power[ Mole, -1]], Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, 
        Times[ -50, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 31.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 78.599999999999994, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -14, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -106, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 151, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 205.09999999999999, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 222.73699999999999, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ -20, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 35.100000000000001, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ 91.299999999999997, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -180, Joule, Kilo, 
          Power[ Mole, -1]], 
        Times[ -270, Joule, Kilo, 
          Power[ Mole, -1]], 0, 
        Times[ 44, Joule, Kilo, 
          Power[ Mole, -1]], 0, 0, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown}, {"AR ", 
        Times[ 0.37, Angstrom], Unknown, 
        Times[ 1.52, Angstrom], 
        Times[ 1.1299999999999999, Angstrom], 
        Times[ 0.80000000000000004, Angstrom], 
        Times[ 0.77000000000000002, Angstrom], 
        Times[ 0.69999999999999996, Angstrom], 
        Times[ 0.66000000000000003, Angstrom], 
        Times[ 0.64000000000000001, Angstrom], 
        Times[ 0.51000000000000001, Angstrom], 
        Times[ 1.8600000000000001, Angstrom], 
        Times[ 1.6000000000000001, Angstrom], 
        Times[ 1.4299999999999999, Angstrom], 
        Times[ 1.1699999999999999, Angstrom], 
        Times[ 1.1000000000000001, Angstrom], 
        Times[ 1.04, Angstrom], 
        Times[ 0.98999999999999999, Angstrom], 
        Times[ 0.88, Angstrom], 
        Times[ 2.27, Angstrom], 
        Times[ 1.97, Angstrom], 
        Times[ 1.6100000000000001, Angstrom], 
        Times[ 1.45, Angstrom], 
        Times[ 1.3100000000000001, Angstrom], 
        Times[ 1.25, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.24, Angstrom], 
        Times[ 1.25, Angstrom], 
        Times[ 1.25, Angstrom], 
        Times[ 1.28, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ 1.53, Angstrom], 
        Times[ 1.2, Angstrom], 
        Times[ 1.21, Angstrom], 
        Times[ 1.1699999999999999, Angstrom], 
        Times[ 1.1399999999999999, Angstrom], 
        Times[ 1.03, Angstrom], 
        Times[ 2.4700000000000002, Angstrom], 
        Times[ 2.1499999999999999, Angstrom], 
        Times[ 1.78, Angstrom], 
        Times[ 1.6000000000000001, Angstrom], 
        Times[ 1.49, Angstrom], 
        Times[ 1.3600000000000001, Angstrom], 
        Times[ 1.3500000000000001, Angstrom], 
        Times[ 1.3200000000000001, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ 1.3799999999999999, Angstrom], 
        Times[ 1.4399999999999999, Angstrom], 
        Times[ 1.49, Angstrom], 
        Times[ 1.6299999999999999, Angstrom], 
        Times[ 1.3999999999999999, Angstrom], 
        Times[ 1.4099999999999999, Angstrom], 
        Times[ 1.4299999999999999, Angstrom], 
        Times[ 1.3300000000000001, Angstrom], 
        Times[ 1.24, Angstrom], 
        Times[ 2.6499999999999999, Angstrom], 
        Times[ 2.2200000000000002, Angstrom], 
        Times[ 1.8799999999999999, Angstrom], 
        Times[ 1.8200000000000001, Angstrom], 
        Times[ 1.8200000000000001, Angstrom], 
        Times[ 1.8100000000000001, Angstrom], 
        Times[ 1.8100000000000001, Angstrom], 
        Times[ 1.8, Angstrom], 
        Times[ 2.0, Angstrom], 
        Times[ 1.79, Angstrom], 
        Times[ 1.76, Angstrom], 
        Times[ 1.75, Angstrom], 
        Times[ 1.74, Angstrom], 
        Times[ 1.73, Angstrom], 
        Times[ 1.72, Angstrom], 
        Times[ 1.9399999999999999, Angstrom], 
        Times[ 1.72, Angstrom], 
        Times[ 1.6699999999999999, Angstrom], 
        Times[ 1.49, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ 1.3600000000000001, Angstrom], 
        Times[ 1.3700000000000001, Angstrom], 
        Times[ 1.4399999999999999, Angstrom], 
        Times[ 1.5, Angstrom], 
        Times[ 1.47, Angstrom], 
        Times[ 1.75, Angstrom], 
        Times[ 1.8200000000000001, Angstrom], 
        Times[ 1.6699999999999999, Angstrom], 
        Times[ 1.3999999999999999, Angstrom], 
        Times[ 1.3400000000000001, Angstrom], 
        Times[ -2.7000000000000002, Angstrom], 
        Times[ 2.3300000000000001, Angstrom], 
        Times[ 1.8799999999999999, Angstrom], 
        Times[ 1.8, Angstrom], 
        Times[ 1.6100000000000001, Angstrom], 
        Times[ 1.3799999999999999, Angstrom], 
        Times[ 1.3, Angstrom], 
        Times[ 1.51, Angstrom], 
        Times[ 1.8400000000000001, Angstrom], Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown, Unknown, Unknown, Unknown, Unknown, Unknown, 
        Unknown}}]]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Remove[xxx, xxx2];\)\)], "Input"],

Cell[BoxData[
    \(\(xxx2 := 
        Module[{i, j, m, n, z, v}\[IndentingNewLine], 
          v = ColumnChart[]; \[IndentingNewLine]m = 
            Length[v]; \[IndentingNewLine]n = 
            Length[v[\([1]\)]]; \[IndentingNewLine]Table[\[IndentingNewLine]z \
= v[\([i, j]\)]; \[IndentingNewLine]If[
              Head[z] =!= String, \[IndentingNewLine]If[Head[z] === Times, 
                z = Take[z, 1]]; \[IndentingNewLine]z = \(efunsnum[\([i]\)]\)[
                  z]\[IndentingNewLine]]; \[IndentingNewLine]z\
\[IndentingNewLine], {i, 13, m}\[IndentingNewLine], {j, 1, 
              n}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(xxx2;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"SsA\"\>", "\<\"9.1\[ThinSpace]d\"\>", "\<\"8.9\[ThinSpace]c\"\
\>", "\<\"1.860\[ThinSpace]n\"\>", "\<\"23.79\[ThinSpace]p\"\>", "\<\"6.9\
\[ThinSpace]e-10\"\>", "\<\"3.3\[ThinSpace]e-4\"\>", "\<\"102\[ThinSpace]\
\[Micro]\"\>", "\<\"7.8\[ThinSpace]e-4\"\>", "\<\"27\[ThinSpace]n\"\>", \
"\<\"112\[ThinSpace]\[Micro]\"\>", "\<\"1.87\[ThinSpace]\[Micro]\"\>", \
"\<\"35\[ThinSpace]\[Micro]\"\>", "\<\"2.77\[ThinSpace]\[Micro]\"\>", \
"\<\"32.6\[ThinSpace]\[Micro]\"\>", "\<\"3.4\[ThinSpace]e-7\"\>", "\<\"32.6\
\[ThinSpace]\[Micro]\"\>", "\<\"1.7\[ThinSpace]e-7\"\>", \
"\<\"3.29\[ThinSpace]\[Micro]\"\>", "\<\"123\[ThinSpace]n\"\>", "\<\"2\
\[ThinSpace]\[Micro]\"\>", "\<\"1.12\[ThinSpace]n\"\>", \
"\<\"78\[ThinSpace]n\"\>", "\<\"9.6\[ThinSpace]n\"\>", \
"\<\"4.4\[ThinSpace]e-7\"\>", "\<\"3.1\[ThinSpace]e-7\"\>", "\<\"29.4\
\[ThinSpace]\[Micro]\"\>", "\<\"7.3\[ThinSpace]n\"\>", "\<\"1.61\[ThinSpace]\
\[Micro]\"\>", "\<\"17\[ThinSpace]n\"\>", "\<\"41.10\[ThinSpace]n\"\>", \
"\<\"1.229\[ThinSpace]n\"\>", "\<\"3.9\[ThinSpace]n\"\>", \
"\<\"2.1\[ThinSpace]e-10\"\>", "\<\"2.03\[ThinSpace]n\"\>", "\<\"2.03\
\[ThinSpace]n\"\>", "\<\"1.5\[ThinSpace]n\"\>", "\<\"231\[ThinSpace]p\"\>", "\
\<\"7.7\[ThinSpace]e-10\"\>", "\<\"151\[ThinSpace]p\"\>", \
"\<\"372\[ThinSpace]p\"\>", "\<\"22.79\[ThinSpace]p\"\>", "\<\"83.00\
\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), "\<\"61\[ThinSpace]p\"\>", "\<\"11.2\[ThinSpace]p\"\
\>", "\<\"45\[ThinSpace]p\"\>", "\<\"15.8\[ThinSpace]p\"\>", "\<\"53\
\[ThinSpace]p\"\>", "\<\"6\[ThinSpace]e-10\"\>", "\<\"125\[ThinSpace]p\"\>", \
"\<\"10.1\[ThinSpace]p\"\>", "\<\"157\[ThinSpace]p\"\>", "\<\"29\[ThinSpace]p\
\"\>", "\<\"1.5\[ThinSpace]e-10\"\>", "\<\"12.09\[ThinSpace]p\"\>", \
"\<\"145.9\[ThinSpace]p\"\>", "\<\"14.5\[ThinSpace]p\"\>", \
"\<\"37\[ThinSpace]p\"\>", "\<\"5.44\[ThinSpace]p\"\>", \
"\<\"27\[ThinSpace]p\"\>", \(fNBookForm2[
              
              Unknown]\), "\<\"8.42\[ThinSpace]p\"\>", "\<\"3.17\[ThinSpace]p\
\"\>", "\<\"10.70\[ThinSpace]p\"\>", "\<\"1.97\[ThinSpace]p\"\>", "\<\"12.86\
\[ThinSpace]p\"\>", "\<\"2.899\[ThinSpace]p\"\>", \
"\<\"8.18\[ThinSpace]p\"\>", "\<\"1.23\[ThinSpace]p\"\>", "\<\"8.08\
\[ThinSpace]p\"\>", "\<\"1.197\[ThinSpace]p\"\>", \
"\<\"5.019\[ThinSpace]p\"\>", "\<\"675\[ThinSpace]f\"\>", "\<\"4.34\
\[ThinSpace]p\"\>", "\<\"1.689\[ThinSpace]p\"\>", "\<\"22\[ThinSpace]p\"\>", \
"\<\"21.60\[ThinSpace]p\"\>", "\<\"44\[ThinSpace]p\"\>", "\<\"6.099\
\[ThinSpace]p\"\>", "\<\"11.1\[ThinSpace]p\"\>", "\<\"6\[ThinSpace]p\"\>", \
"\<\"10.3\[ThinSpace]n\"\>", "\<\"4.7\[ThinSpace]e-10\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[
              Unknown]\), "\<\"109.0\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), "\<\"29.39\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\)},
          {"\<\"EcA\"\>", "\<\"1.4\[ThinSpace]m\"\>", \
"\<\"8\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]e-5\"\>", "\<\"2.8\[ThinSpace]\
\[Micro]\"\>", "\<\"1\[ThinSpace]e-5\"\>", "\<\"2\[ThinSpace]e-4\"\>", \
"\<\"19\[ThinSpace]\[Micro]\"\>", "\<\"4.61\[ThinSpace]d\"\>", "\<\"585\
\[ThinSpace]\[Micro]\"\>", "\<\"5\[ThinSpace]n\"\>", "\<\"2.36\[ThinSpace]c\"\
\>", "\<\"2.33\[ThinSpace]c\"\>", "\<\"8.23\[ThinSpace]c\"\>", "\<\"2.82\
\[ThinSpace]d\"\>", "\<\"1.05\[ThinSpace]m\"\>", \
"\<\"3.5\[ThinSpace]e-4\"\>", "\<\"145\[ThinSpace]\[Micro]\"\>", "\<\"3.5\
\[ThinSpace]\[Micro]\"\>", "\<\"2.09\[ThinSpace]c\"\>", \
"\<\"4.15\[ThinSpace]c\"\>", "\<\"22\[ThinSpace]\[Micro]\"\>", "\<\"5.65\
\[ThinSpace]m\"\>", "\<\"1.2\[ThinSpace]e-4\"\>", \
"\<\"102\[ThinSpace]\[Micro]\"\>", "\<\"9.5\[ThinSpace]e-4\"\>", "\<\"5.63\
\[ThinSpace]c\"\>", "\<\"25\[ThinSpace]\[Micro]\"\>", "\<\"84\[ThinSpace]\
\[Micro]\"\>", "\<\"6\[ThinSpace]e-5\"\>", "\<\"7\[ThinSpace]e-5\"\>", \
"\<\"19\[ThinSpace]\[Micro]\"\>", "\<\"1.5\[ThinSpace]\[Micro]\"\>", \
"\<\"1.800\[ThinSpace]\[Micro]\"\>", "\<\"5\[ThinSpace]e-8\"\>", "\<\"2.4\
\[ThinSpace]\[Micro]\"\>", "\<\"1\[ThinSpace]e-10\"\>", "\<\"9\[ThinSpace]e-5\
\"\>", "\<\"3.7\[ThinSpace]e-4\"\>", "\<\"33\[ThinSpace]\[Micro]\"\>", \
"\<\"165\[ThinSpace]\[Micro]\"\>", "\<\"2\[ThinSpace]e-5\"\>", "\<\"1.2\
\[ThinSpace]\[Micro]\"\>", \(fNBookForm2[
              Unknown]\), "\<\"1\[ThinSpace]n\"\>", "\<\"1\[ThinSpace]n\"\>", \
"\<\"15\[ThinSpace]n\"\>", "\<\"75\[ThinSpace]n\"\>", "\<\"1.5\[ThinSpace]e-7\
\"\>", "\<\"2.5\[ThinSpace]e-7\"\>", "\<\"2.3\[ThinSpace]\[Micro]\"\>", \
"\<\"2\[ThinSpace]e-7\"\>", "\<\"1\[ThinSpace]n\"\>", "\<\"4.5\[ThinSpace]e-7\
\"\>", "\<\"3\[ThinSpace]e-11\"\>", "\<\"3\[ThinSpace]\[Micro]\"\>", "\<\"425\
\[ThinSpace]\[Micro]\"\>", "\<\"39\[ThinSpace]\[Micro]\"\>", "\<\"66.5\
\[ThinSpace]\[Micro]\"\>", "\<\"9.2\[ThinSpace]\[Micro]\"\>", "\<\"41.5\
\[ThinSpace]\[Micro]\"\>", \(fNBookForm2[
              Unknown]\), "\<\"7.049\[ThinSpace]\[Micro]\"\>", "\<\"2\
\[ThinSpace]\[Micro]\"\>", "\<\"6.2\[ThinSpace]\[Micro]\"\>", "\<\"1.2\
\[ThinSpace]\[Micro]\"\>", "\<\"5.2\[ThinSpace]\[Micro]\"\>", "\<\"1.3\
\[ThinSpace]\[Micro]\"\>", "\<\"3.5\[ThinSpace]\[Micro]\"\>", "\<\"5.2\
\[ThinSpace]e-7\"\>", "\<\"3.200\[ThinSpace]\[Micro]\"\>", \
"\<\"8\[ThinSpace]e-7\"\>", "\<\"3\[ThinSpace]\[Micro]\"\>", "\<\"2\
\[ThinSpace]\[Micro]\"\>", "\<\"1.25\[ThinSpace]\[Micro]\"\>", "\<\"7\
\[ThinSpace]e-10\"\>", "\<\"1.5\[ThinSpace]n\"\>", "\<\"1\[ThinSpace]n\"\>", \
"\<\"5\[ThinSpace]n\"\>", "\<\"4\[ThinSpace]n\"\>", \
"\<\"85\[ThinSpace]n\"\>", "\<\"8.5\[ThinSpace]e-7\"\>", "\<\"14\[ThinSpace]\
\[Micro]\"\>", "\<\"8.5\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]e-16\"\>", \
\(fNBookForm2[Unknown]\), "\<\"4\[ThinSpace]e-19\"\>", \(fNBookForm2[
              Unknown]\), "\<\"9\[ThinSpace]e-13\"\>", \
"\<\"5.5\[ThinSpace]e-16\"\>", "\<\"9.6\[ThinSpace]\[Micro]\"\>", "\<\"1.399\
\[ThinSpace]p\"\>", "\<\"2.7\[ThinSpace]\[Micro]\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\)},
          {"\<\"EoA\"\>", "\<\"1.08\[ThinSpace]d\"\>", \
"\<\"7\[ThinSpace]p\"\>", "\<\"1.8\[ThinSpace]e-7\"\>", \
"\<\"5.599\[ThinSpace]p\"\>", "\<\"4.440\[ThinSpace]\[Micro]\"\>", "\<\"28\
\[ThinSpace]\[Micro]\"\>", "\<\"5\[ThinSpace]e-7\"\>", "\<\"8.57\[ThinSpace]d\
\"\>", "\<\"1.3\[ThinSpace]\[Micro]\"\>", "\<\"1.2\[ThinSpace]e-10\"\>", \
"\<\"1.08\[ThinSpace]c\"\>", "\<\"1.29\[ThinSpace]m\"\>", "\<\"2\[ThinSpace]n\
\"\>", "\<\"2.2\[ThinSpace]\[Micro]\"\>", "\<\"6\[ThinSpace]e-8\"\>", \
"\<\"905\[ThinSpace]\[Micro]\"\>", "\<\"1.94\[ThinSpace]c\"\>", "\<\"4.5\
\[ThinSpace]e-7\"\>", "\<\"399\[ThinSpace]\[Micro]\"\>", "\<\"412\[ThinSpace]\
\[Micro]\"\>", "\<\"6\[ThinSpace]e-13\"\>", "\<\"1\[ThinSpace]n\"\>", \
"\<\"2.5\[ThinSpace]n\"\>", "\<\"3\[ThinSpace]e-10\"\>", \
"\<\"2\[ThinSpace]e-10\"\>", "\<\"2\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]e-11\
\"\>", "\<\"559.9\[ThinSpace]p\"\>", "\<\"2.5\[ThinSpace]e-10\"\>", "\<\"4.9\
\[ThinSpace]n\"\>", "\<\"3\[ThinSpace]e-11\"\>", "\<\"5\[ThinSpace]e-11\"\>", \
"\<\"3.7\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]n\"\>", "\<\"67.3\[ThinSpace]\
\[Micro]\"\>", "\<\"2.1\[ThinSpace]e-10\"\>", "\<\"1.2\[ThinSpace]e-7\"\>", "\
\<\"7.9\[ThinSpace]\[Micro]\"\>", "\<\"11.99\[ThinSpace]p\"\>", "\<\"3\
\[ThinSpace]e-11\"\>", "\<\"1\[ThinSpace]e-11\"\>", \
"\<\"1\[ThinSpace]e-8\"\>", \(fNBookForm2[
              Unknown]\), "\<\"7\[ThinSpace]e-13\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[
              Unknown]\), "\<\"4\[ThinSpace]e-11\"\>", \
"\<\"110.0\[ThinSpace]p\"\>", "\<\"2\[ThinSpace]e-8\"\>", "\<\"4\[ThinSpace]p\
\"\>", "\<\"2.4\[ThinSpace]e-10\"\>", \(fNBookForm2[
              Unknown]\), "\<\"6\[ThinSpace]e-8\"\>", \
"\<\"5\[ThinSpace]e-11\"\>", "\<\"3\[ThinSpace]e-10\"\>", \
"\<\"13\[ThinSpace]n\"\>", "\<\"3.4\[ThinSpace]p\"\>", \
"\<\"1.2\[ThinSpace]p\"\>", "\<\"6.4\[ThinSpace]e-13\"\>", "\<\"2.799\
\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), "\<\"4.5\[ThinSpace]e-13\"\>", \
"\<\"1.3\[ThinSpace]e-13\"\>", "\<\"7\[ThinSpace]e-13\"\>", "\<\"139.9\
\[ThinSpace]f\"\>", "\<\"9.1\[ThinSpace]e-13\"\>", \
"\<\"220.0\[ThinSpace]f\"\>", "\<\"869.9\[ThinSpace]f\"\>", "\<\"1.7\
\[ThinSpace]e-13\"\>", "\<\"819.9\[ThinSpace]f\"\>", "\<\"1.5\[ThinSpace]e-13\
\"\>", "\<\"7\[ThinSpace]p\"\>", "\<\"2\[ThinSpace]p\"\>", \
"\<\"1\[ThinSpace]e-10\"\>", "\<\"4\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), "\<\"4\[ThinSpace]p\"\>", \
"\<\"3\[ThinSpace]e-11\"\>", "\<\"19\[ThinSpace]p\"\>", \
"\<\"3\[ThinSpace]e-11\"\>", "\<\"2\[ThinSpace]e-11\"\>", \
"\<\"15\[ThinSpace]z\"\>", \(fNBookForm2[
              Unknown]\), "\<\"6\[ThinSpace]e-22\"\>", \(fNBookForm2[
              Unknown]\), "\<\"89\[ThinSpace]a\"\>", \(fNBookForm2[
              Unknown]\), "\<\"1\[ThinSpace]p\"\>", \
"\<\"5\[ThinSpace]e-17\"\>", "\<\"3.2\[ThinSpace]n\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\)},
          {"\<\"OS \"\>", \(-1\), "1", "0", "1", "2", "3", \(-4\), "2", 
            "4", \(-3\), \(-2\), \(-1\), "1", "2", "3", "4", 
            "5", \(-2\), \(-1\), "0", "1", "2", "3", \(-4\), "2", "4", \(-3\),
             "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "7", "0", "1", "2",
             "3", "2", "3", "4", "2", "3", "4", "5", "2", "3", "6", "2", "3", 
            "4", "7", "2", "3", "2", "3", "2", "3", "1", "2", "2", "3", "2", 
            "4", \(-3\), "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "0", 
            "1", "2", "3", "4", "3", "5", "6", "4", "6", "7", "3", "3", "2", 
            "4", "1", "2", "3", "2", "4", \(-3\), "3", "5", \(-2\), "4", 
            "6", \(-1\), "1", "5", "7", "0", "1", "2", "3", "3", "4", "3"},
          {"\<\"EN \"\>", "2.2`", "Unknown", "0.98`", "1.57`", "2.04`", 
            "2.55`", "3.04`", "3.44`", "3.98`", "Unknown", "0.93`", "1.31`", 
            "1.61`", "1.9`", "2.19`", "2.58`", "3.16`", "Unknown", "0.82`", 
            "1.`", "1.36`", "1.54`", "1.63`", "1.66`", "1.55`", "1.83`", 
            "1.88`", "1.91`", "1.9`", "1.65`", "1.81`", "2.01`", "2.18`", 
            "2.55`", "2.9`", "Unknown", "0.82`", "0.95`", "1.22`", "1.33`", 
            "1.6`", "2.16`", "1.9`", "2.2`", "2.28`", "2.2`", "1.93`", 
            "1.69`", "1.78`", "1.96`", "2.05`", "2.1`", "2.66`", "2.6`", 
            "0.79`", "0.89`", "1.1`", "1.12`", "1.13`", "1.14`", "1.13`", 
            "1.17`", "1.2`", "1.2`", "1.1`", "1.22`", "1.23`", "1.24`", 
            "1.25`", "1.1`", "1.27`", "1.3`", "1.5`", "2.36`", "1.9`", "2.2`",
             "2.2`", "2.28`", "2.54`", "2.`", "2.04`", "2.33`", "2.02`", 
            "2.`", "2.2`", "Unknown", "0.7`", "0.9`", "1.1`", "1.3`", "1.5`", 
            "1.38`", "1.36`", "1.28`", "1.3`", "1.3`", "1.3`", "1.3`", "1.3`",
             "1.3`", "1.3`", "1.3`", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown"},
          {"\<\"EA \"\>", "72.77`", "0", "59.63`", "0", "26.7`", "121.85`", 
            "0", "140.97676`", "328.`", "0", "52.867`", "0", "42.6`", 
            "133.6`", "72.03`", "200.4116`", "349.`", "0", "48.384`", 
            "2.369`", "18.1`", "7.6`", "50.7`", "64.3`", "0", "14.57`", 
            "63.8`", "111.5`", "118.5`", "0", "29", \(-120\), \(-80\), 
            "194.967`", "324.7`", "0", "46.884`", "4.6`", "29.6`", "41.1`", 
            "86.2`", "72.`", \(-53\), \(-100\), "110", "54.22`", "125.6`", 
            "0", "29", "101.`", "103", "190.15`", "295.2`", "0", "45.505`", 
            "14.47`", \(-50\), "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", \(-50\), "0", "31.1`", 
            "78.6`", \(-14\), \(-106\), "151", "205.1`", "222.737`", 
            "0", \(-20\), "35.1`", "91.3`", \(-180\), \(-270\), "0", "44", 
            "0", "0", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown"},
          {"\<\"AR \"\>", "0.37`", "Unknown", "1.52`", "1.13`", "0.8`", 
            "0.77`", "0.7`", "0.66`", "0.64`", "0.51`", "1.86`", "1.6`", 
            "1.43`", "1.17`", "1.1`", "1.04`", "0.99`", "0.88`", "2.27`", 
            "1.97`", "1.61`", "1.45`", "1.31`", "1.25`", "1.37`", "1.24`", 
            "1.25`", "1.25`", "1.28`", "1.34`", "1.53`", "1.2`", "1.21`", 
            "1.17`", "1.14`", "1.03`", "2.47`", "2.15`", "1.78`", "1.6`", 
            "1.49`", "1.36`", "1.35`", "1.32`", "1.34`", "1.38`", "1.44`", 
            "1.49`", "1.63`", "1.4`", "1.41`", "1.43`", "1.33`", "1.24`", 
            "2.65`", "2.22`", "1.88`", "1.82`", "1.82`", "1.81`", "1.81`", 
            "1.8`", "2.`", "1.79`", "1.76`", "1.75`", "1.74`", "1.73`", 
            "1.72`", "1.94`", "1.72`", "1.67`", "1.49`", "1.37`", "1.37`", 
            "1.34`", "1.36`", "1.37`", "1.44`", "1.5`", "1.47`", "1.75`", 
            "1.82`", "1.67`", "1.4`", "1.34`", \(-2.7`\), "2.33`", "1.88`", 
            "1.8`", "1.61`", "1.38`", "1.3`", "1.51`", "1.84`", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(xxx := 
        Module[{i, j, m, n, z, v}\[IndentingNewLine], 
          v = ColumnChart[]; \[IndentingNewLine]m = 
            Length[v]; \[IndentingNewLine]n = 
            Length[v[\([1]\)]]; \[IndentingNewLine]Table[\[IndentingNewLine]z \
= v[\([i, j]\)]; \[IndentingNewLine]If[
              Head[z] =!= String, \[IndentingNewLine]If[Head[z] === Times, 
                z = Take[z, 1]]; \[IndentingNewLine]z = \(efunsnum[\([i]\)]\)[
                  z]\[IndentingNewLine]]; \[IndentingNewLine]z\
\[IndentingNewLine], {i, 1, m}\[IndentingNewLine], {j, 1, 
              n}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(xxx;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"Ab \"\>", "\<\"H\"\>", "\<\"He\"\>", "\<\"Li\"\>", \
"\<\"Be\"\>", "\<\"B\"\>", "\<\"C\"\>", "\<\"N\"\>", "\<\"O\"\>", \
"\<\"F\"\>", "\<\"Ne\"\>", "\<\"Na\"\>", "\<\"Mg\"\>", "\<\"Al\"\>", \
"\<\"Si\"\>", "\<\"P\"\>", "\<\"S\"\>", "\<\"Cl\"\>", "\<\"Ar\"\>", \
"\<\"K\"\>", "\<\"Ca\"\>", "\<\"Sc\"\>", "\<\"Ti\"\>", "\<\"V\"\>", "\<\"Cr\"\
\>", "\<\"Mn\"\>", "\<\"Fe\"\>", "\<\"Co\"\>", "\<\"Ni\"\>", "\<\"Cu\"\>", \
"\<\"Zn\"\>", "\<\"Ga\"\>", "\<\"Ge\"\>", "\<\"As\"\>", "\<\"Se\"\>", "\<\"Br\
\"\>", "\<\"Kr\"\>", "\<\"Rb\"\>", "\<\"Sr\"\>", "\<\"Y\"\>", "\<\"Zr\"\>", "\
\<\"Nb\"\>", "\<\"Mo\"\>", "\<\"Tc\"\>", "\<\"Ru\"\>", "\<\"Rh\"\>", \
"\<\"Pd\"\>", "\<\"Ag\"\>", "\<\"Cd\"\>", "\<\"In\"\>", "\<\"Sn\"\>", "\<\"Sb\
\"\>", "\<\"Te\"\>", "\<\"I\"\>", "\<\"Xe\"\>", "\<\"Cs\"\>", "\<\"Ba\"\>", "\
\<\"La\"\>", "\<\"Ce\"\>", "\<\"Pr\"\>", "\<\"Nd\"\>", "\<\"Pm\"\>", \
"\<\"Sm\"\>", "\<\"Eu\"\>", "\<\"Gd\"\>", "\<\"Tb\"\>", "\<\"Dy\"\>", "\<\"Ho\
\"\>", "\<\"Er\"\>", "\<\"Tm\"\>", "\<\"Yb\"\>", "\<\"Lu\"\>", "\<\"Hf\"\>", \
"\<\"Ta\"\>", "\<\"W\"\>", "\<\"Re\"\>", "\<\"Os\"\>", "\<\"Ir\"\>", \
"\<\"Pt\"\>", "\<\"Au\"\>", "\<\"Hg\"\>", "\<\"Tl\"\>", "\<\"Pb\"\>", "\<\"Bi\
\"\>", "\<\"Po\"\>", "\<\"At\"\>", "\<\"Rn\"\>", "\<\"Fr\"\>", "\<\"Ra\"\>", \
"\<\"Ac\"\>", "\<\"Th\"\>", "\<\"Pa\"\>", "\<\"U\"\>", "\<\"Np\"\>", \
"\<\"Pu\"\>", "\<\"Am\"\>", "\<\"Cm\"\>", "\<\"Bk\"\>", "\<\"Cf\"\>", "\<\"Es\
\"\>", "\<\"Fm\"\>", "\<\"Md\"\>", "\<\"No\"\>", "\<\"Lr\"\>", "\<\"Rf\"\>", \
"\<\"Db\"\>", "\<\"Sg\"\>", "\<\"Bh\"\>", "\<\"Hs\"\>", "\<\"Mt\"\>", \
"\<\"Uun\"\>", "\<\"Uuu\"\>", "\<\"Uub\"\>"},
          {"\<\"AN \"\>", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", 
            "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", 
            "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", 
            "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43", 
            "44", "45", "46", "47", "48", "49", "50", "51", "52", "53", "54", 
            "55", "56", "57", "58", "59", "60", "61", "62", "63", "64", "65", 
            "66", "67", "68", "69", "70", "71", "72", "73", "74", "75", "76", 
            "77", "78", "79", "80", "81", "82", "83", "84", "85", "86", "87", 
            "88", "89", "90", "91", "92", "93", "94", "95", "96", "97", "98", 
            "99", "100", "101", "102", "103", "104", "105", "106", "107", 
            "108", "109", "110", "111", "112"},
          {"\<\"AW \"\>", "1.00794`", "4.002602`", "6.941`", "9.012182`", 
            "10.81`", "12.0107`", "14.00674`", "15.9994`", "18.9984032`", 
            "20.1797`", "22.98977`", "24.305`", "26.981538`", "28.0855`", 
            "30.973761`", "32.066`", "35.4527`", "39.948`", "39.0983`", 
            "40.078`", "44.95591`", "47.867`", "50.9415`", "51.9961`", 
            "54.938049`", "55.845`", "58.9332`", "58.6934`", "63.546`", 
            "65.39`", "69.723`", "72.61`", "74.9216`", "78.96`", "79.904`", 
            "83.8`", "85.4678`", "87.62`", "88.90585`", "91.224`", 
            "92.90638`", "95.94`", "98", "101.07`", "102.9055`", "106.42`", 
            "107.8682`", "112.411`", "114.818`", "118.71`", "121.76`", 
            "127.6`", "126.90447`", "131.29`", "132.90545`", "137.327`", 
            "138.9055`", "140.116`", "140.90765`", "144.24`", "145", 
            "150.36`", "151.964`", "157.25`", "158.92534`", "162.5`", 
            "164.93032`", "167.26`", "168.93421`", "173.04`", "174.967`", 
            "178.49`", "180.9479`", "183.84`", "186.207`", "190.23`", 
            "192.217`", "195.078`", "196.96655`", "200.59`", "204.3833`", 
            "207.2`", "208.98038`", "209", "210", "222", "223", "226", "227", 
            "232.0381`", "231.03588`", "238.0289`", "237", "244", "243", 
            "247", "247", "251", "252", "257", "258", "259", "262", "261", 
            "262", "263", "262", "265", "266", "269", "272", "Unknown"},
          {"\<\"SI \"\>", "1", "2", "3", "4", "6", "7", "9", "10", "11", "12",
             "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23",
             "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34",
             "36", "35", "37", "36", "38", "40", "39", "41", "40", "42", "43",
             "44", "46", "48", "45", "46", "47", "48", "49", "50", "51", "50",
             "52", "53", "54", "55", "54", "56", "57", "58", "59", "58", "60",
             "61", "62", "64", "63", "65", "66", "67", "68", "70", "69", "71",
             "70", "72", "73", "74", "76", "75", "74", "76", "77", "78", "80",
             "82", "79", "81", "78", "80", "82", "83", "84", "86", "85", "84",
             "86", "87", "88", "89", "90", "91", "92", "94", "93", "92", "94",
             "95", "96", "97"},
          {"\<\"Tm \"\>", "14.01`", "0.95`", "453.69`", "1551.`", "2573.`", 
            "3820.`", "63.29`", "54.8`", "53.53`", "24.48`", "370.96`", 
            "922.`", "933.5`", "1683.`", "317.3`", "386.`", "172.2`", "83.8`",
             "336.8`", "1112.`", "1814.`", "1933.`", "2160.`", "2130.`", 
            "1517.`", "1808.`", "1768.`", "1726.`", "1356.6`", "692.73`", 
            "302.93`", "1210.6`", "83.78`", "490.`", "265.9`", "116.6`", 
            "312.2`", "1042.`", "1795.`", "2125.`", "2741.`", "2890.`", 
            "2445.`", "2583.`", "2239.`", "1825.`", "1235.08`", "594.1`", 
            "429.32`", "505.118`", "903.89`", "722.7`", "386.7`", "161.3`", 
            "301.55`", "1002.`", "1194.`", "1072.`", "1204.`", "1294.`", 
            "1441.`", "1350.`", "1095.`", "1586.`", "1629.`", "1685.`", 
            "1747.`", "1802.`", "1818.`", "1097.`", "1936.`", "2503.`", 
            "3269.`", "3680.`", "3453.`", "3327.`", "2683.`", "2045.`", 
            "1337.58`", "234.28`", "576.6`", "600.65`", "544.5`", "527.`", 
            "575.`", "202.`", "300.`", "973.`", "1320.`", "2023.`", "2113.`", 
            "1405.5`", "913.`", "914.`", "1267.`", "1610.`", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown"},
          {"\<\"Tb \"\>", "20.28`", "4.216`", "1620.`", "3243.`", "3931.`", 
            "5100.`", "77.4`", "90.19`", "85.01`", "27.1`", "1156.1`", 
            "1363.`", "2740.`", "2628.`", "553.`", "717.824`", "239.6`", 
            "87.3`", "1047.`", "1757.`", "3104.`", "3560.`", "3650.`", 
            "2945.`", "2235.`", "3023.`", "3143.`", "3005.`", "2840", 
            "1180.`", "2676.`", "3103.`", "889", "958.1`", "331.9`", 
            "120.85`", "961.`", "1657", "3611.`", "4650.`", "5015.`", 
            "4885.`", "5150.`", "4173.`", "4000.`", "3413.`", "2485.`", 
            "1038.`", "2353.`", "2543.`", "1908.`", "1263.`", "457.5`", 
            "166.1`", "951.6`", "1910.`", "3730.`", "3699.`", "3785.`", 
            "3341.`", "3000.`", "2064.`", "1870.`", "3539.`", "3396.`", 
            "2835.`", "2968.`", "3136.`", "2220.`", "1466.`", "3668.`", 
            "5470.`", "5698.`", "5930.`", "5900.`", "5300.`", "4403.`", 
            "4100.`", "3080.`", "629.73`", "1730.`", "2013.`", "1883.`", 
            "1235.`", "610.`", "211.4`", "950.`", "1413.`", "3470.`", 
            "5060.`", "4300.`", "4018.`", "4175.`", "3505.`", "2880.`", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown"},
          {"\<\"Lf \"\>", "0.12`", "0.021`", "4.6`", "9.8`", "22.2`", "105.`",
             "0.72`", "0.444`", "1.02`", "0.324`", "2.64`", "9.04`", "10.67`",
             "39.6`", "2.51`", "1.23`", "6.41`", "1.21`", "2.4`", "9.33`", 
            "15.9`", "20.9`", "17.6`", "15.3`", "14.4`", "14.9`", "15.2`", 
            "17.6`", "13.`", "6.67`", "5.59`", "34.7`", "27.7`", "5.1`", 
            "10.8`", "1.64`", "2.2`", "9.16`", "17.2`", "23.`", "27.2`", 
            "27.6`", "23.81`", "23.7`", "21.55`", "17.2`", "11.3`", "6.11`", 
            "3.27`", "7.2`", "20.9`", "13.5`", "15.27`", "3.1`", "2.09`", 
            "7.66`", "10.04`", "8.87`", "11.3`", "7.113`", "12.6`", "10.9`", 
            "10.5`", "15.5`", "16.3`", "17.2`", "17.2`", "17.2`", "18.4`", 
            "9.2`", "19.2`", "25.5`", "31.4`", "35.2`", "33.1`", "29.3`", 
            "26.4`", "19.7`", "12.7`", "2.331`", "4.31`", "5.121`", "10.48`", 
            "10.`", "23.8`", "2.7`", "Unknown", "7.15`", "14.2`", "19.2`", 
            "16.7`", "15.5`", "9.46`", "2.8`", "14.4`", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown"},
          {"\<\"Lv \"\>", "0.46`", "0.082`", "147.7`", "308.8`", "504.5`", 
            "710.9`", "5.577`", "6.82`", "3.26`", "1.736`", "99.2`", "127.6`",
             "290.8`", "383.3`", "51.9`", "9.62`", "20.4033`", "6.53`", 
            "79.1`", "150.6`", "376.1`", "425.5`", "459.7`", "341.8`", 
            "220.5`", "340.2`", "382.4`", "374.8`", "306.7`", "114.2`", 
            "270.3`", "327.6`", "31.9`", "90.`", "30.5`", "9.05`", "75.7`", 
            "154.4`", "367.4`", "566.7`", "680.19`", "589.9`", "585.22`", 
            "567.`", "494.34`", "361.5`", "257.7`", "100.`", "231.8`", 
            "296.2`", "165.8`", "104.6`", "41.67`", "12.65`", "66.5`", 
            "150.9`", "402.1`", "398.`", "357.`", "328.`", "Unknown", 
            "164.8`", "176.`", "301.`", "391.`", "293.`", "303.`", "280.`", 
            "247.`", "159.`", "428.`", "570.7`", "758.22`", "824.2`", 
            "704.25`", "738.06`", "612.1`", "469.`", "343.1`", "59.11`", 
            "166.1`", "177.8`", "179.1`", "100.8`", "Unknown", "18.1`", 
            "Unknown", "136.7`", "293", "513.67`", "481.`", "417.1`", 
            "336.6`", "343.5`", "238.5`", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown"},
          {"\<\"p  \"\>", "76.`", "124.8`", "534.`", "1847.7`", "2340.`", 
            "3513.`", "1026.`", "2000.`", "1516.`", "1444.`", "971.`", 
            "1738.`", "2698.`", "2329.`", "1820.`", "2070.`", "2030.`", 
            "1656.`", "862.`", "1550.`", "2989.`", "4540.`", "6110.`", 
            "7190.`", "7440.`", "7874.`", "8900.`", "8902.`", "8960.`", 
            "7133.`", "5907.`", "5323.`", "5780.`", "4790.`", "4050.`", 
            "2823.`", "1532.`", "2540.`", "4469.`", "6506.`", "8570.`", 
            "10220.`", "11500.`", "12370.`", "12410.`", "12020.`", "10500.`", 
            "8650.`", "7310.`", "7310.`", "6691.`", "6240.`", "4930.`", 
            "3540.`", "1873.`", "3594.`", "6145.`", "8240.`", "6773.`", 
            "7007.`", "7220.`", "7520.`", "5243.`", "7900.4`", "8229.`", 
            "8550.`", "8795.`", "9066.`", "9321.`", "6965.`", "9840.`", 
            "13310.`", "16654.`", "19300.`", "21020.`", "22590.`", "22420.`", 
            "21450.`", "19320.`", "13546.`", "11850.`", "11350.`", "9747.`", 
            "9320.`", "Unknown", "4400.`", "Unknown", "5000.`", "10060.`", 
            "11720.`", "15370.`", "18950.`", "20250.`", "19840.`", "13670.`", 
            "13300.`", "14790.`", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown"},
          {"\<\"Qs \"\>", "0.1815`", "0.152`", "84.7`", "200.`", "27.`", 
            "1960.`", "0.02598`", "0.02674`", "0.0279`", "0.0493`", "141.`", 
            "156.`", "237.`", "148", "0.235`", "0.269`", "0.0089`", 
            "0.01772`", "102.4`", "200.`", "15.8`", "21.9`", "30.7`", "93.7`",
             "7.82`", "80.2`", "100.`", "90.7`", "401.`", "116.`", "40.6`", 
            "59.9`", "50.`", "2.04`", "0.122`", "0.00949`", "58.2`", "35.3`", 
            "17.2`", "22.7`", "53.7`", "138.`", "50.6`", "117.`", "150.`", 
            "71.8`", "429.`", "96.8`", "81.6`", "66.6`", "243.`", "2.35`", 
            "0.449`", "0.00569`", "35.9`", "18.4`", "13.5`", "11.4`", "12.5`",
             "16.5`", "17.9`", "13.3`", "13.9`", "10.6`", "11.1`", "10.7`", 
            "16.2`", "14.3`", "16.8`", "34.9`", "16.4`", "23.`", "57.5`", 
            "174.`", "47.9`", "87.6`", "147.`", "71.6`", "317.`", "8.34`", 
            "46.1`", "35.3`", "7.87`", "20.`", "1.7`", "0.00364`", "15.`", 
            "18.6`", "12.`", "54.`", "47.`", "27.6`", "6.3`", "6.74`", "10.`",
             "10.`", "10.`", "10.`", "10.`", "10.`", "10.`", "10.`", "10.`", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown"},
          {"\<\"FIP\"\>", "13.598`", "24.587`", "5.392`", "9.323`", "8.298`", 
            "11.26`", "14.534`", "13.618`", "17.423`", "21.565`", "5.139`", 
            "7.646`", "5.986`", "8.152`", "10.487`", "10.36`", "12.968`", 
            "15.76`", "4.341`", "6.113`", "6.561`", "6.828`", "6.746`", 
            "6.767`", "7.434`", "7.902`", "7.881`", "7.64`", "7.726`", 
            "9.394`", "5.999`", "7.9`", "9.815`", "9.752`", "11.814`", "14", 
            "4.177`", "5.695`", "6.217`", "6.634`", "6.759`", "7.092`", 
            "7.28`", "7.361`", "7.459`", "8.337`", "7.576`", "8.994`", 
            "5.786`", "7.344`", "8.64`", "9.01`", "10.451`", "12.13`", 
            "3.894`", "5.212`", "5.577`", "5.539`", "5.464`", "5.525`", 
            "5.55`", "5.644`", "5.67`", "6.15`", "5.864`", "5.939`", "6.022`",
             "6.108`", "6.184`", "6.254`", "5.426`", "6.825`", "7.89`", 
            "7.98`", "7.88`", "8.7`", "9.1`", "9.`", "9.226`", "10.438`", 
            "6.108`", "7.417`", "7.289`", "8.417`", "Unknown", "10.749`", 
            "Unknown", "5.279`", "5.17`", "6.08`", "5.89`", "6.194`", 
            "6.266`", "6.06`", "5.993`", "6.02`", "6.23`", "6.3`", "6.42`", 
            "6.5`", "6.58`", "6.65`", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown"},
          {"\<\"Qc \"\>", "14.304`", "5.193`", "3.582`", "1.825`", "1.026`", 
            "0.709`", "1.04`", "0.918`", "0.824`", "1.03`", "1.228`", 
            "Unknown", "0.897`", "0.705`", "0.769`", "0.71`", "0.479`", 
            "0.52`", "0.757`", "0.647`", "0.568`", "0.523`", "0.489`", 
            "0.449`", "0.479`", "0.449`", "0.421`", "0.444`", "0.385`", 
            "0.388`", "0.371`", "0.32`", "0.329`", "0.321`", "0.226`", 
            "0.248`", "0.363`", "0.301`", "0.298`", "0.278`", "0.265`", 
            "0.251`", "Unknown", "0.238`", "0.243`", "0.244`", "0.235`", 
            "0.232`", "0.233`", "0.228`", "0.207`", "0.202`", "0.145`", 
            "0.158`", "0.242`", "0.204`", "0.195`", "0.192`", "0.193`", 
            "0.19`", "Unknown", "0.197`", "0.182`", "0.236`", "0.182`", 
            "0.173`", "0.165`", "0.168`", "0.16`", "0.155`", "0.154`", 
            "0.144`", "0.14`", "0.132`", "0.137`", "0.13`", "0.131`", 
            "0.133`", "0.129`", "0.14`", "0.129`", "0.129`", "0.122`", 
            "Unknown", "Unknown", "0.094`", "Unknown", "Unknown", "Unknown", 
            "0.113`", "Unknown", "0.116`", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown"},
          {"\<\"SsA\"\>", "\<\"9.1\[ThinSpace]d\"\>", "\<\"8.9\[ThinSpace]c\"\
\>", "\<\"1.860\[ThinSpace]n\"\>", "\<\"23.79\[ThinSpace]p\"\>", "\<\"6.9\
\[ThinSpace]e-10\"\>", "\<\"3.3\[ThinSpace]e-4\"\>", "\<\"102\[ThinSpace]\
\[Micro]\"\>", "\<\"7.8\[ThinSpace]e-4\"\>", "\<\"27\[ThinSpace]n\"\>", \
"\<\"112\[ThinSpace]\[Micro]\"\>", "\<\"1.87\[ThinSpace]\[Micro]\"\>", \
"\<\"35\[ThinSpace]\[Micro]\"\>", "\<\"2.77\[ThinSpace]\[Micro]\"\>", \
"\<\"32.6\[ThinSpace]\[Micro]\"\>", "\<\"3.4\[ThinSpace]e-7\"\>", "\<\"32.6\
\[ThinSpace]\[Micro]\"\>", "\<\"1.7\[ThinSpace]e-7\"\>", \
"\<\"3.29\[ThinSpace]\[Micro]\"\>", "\<\"123\[ThinSpace]n\"\>", "\<\"2\
\[ThinSpace]\[Micro]\"\>", "\<\"1.12\[ThinSpace]n\"\>", \
"\<\"78\[ThinSpace]n\"\>", "\<\"9.6\[ThinSpace]n\"\>", \
"\<\"4.4\[ThinSpace]e-7\"\>", "\<\"3.1\[ThinSpace]e-7\"\>", "\<\"29.4\
\[ThinSpace]\[Micro]\"\>", "\<\"7.3\[ThinSpace]n\"\>", "\<\"1.61\[ThinSpace]\
\[Micro]\"\>", "\<\"17\[ThinSpace]n\"\>", "\<\"41.10\[ThinSpace]n\"\>", \
"\<\"1.229\[ThinSpace]n\"\>", "\<\"3.9\[ThinSpace]n\"\>", \
"\<\"2.1\[ThinSpace]e-10\"\>", "\<\"2.03\[ThinSpace]n\"\>", "\<\"2.03\
\[ThinSpace]n\"\>", "\<\"1.5\[ThinSpace]n\"\>", "\<\"231\[ThinSpace]p\"\>", "\
\<\"7.7\[ThinSpace]e-10\"\>", "\<\"151\[ThinSpace]p\"\>", \
"\<\"372\[ThinSpace]p\"\>", "\<\"22.79\[ThinSpace]p\"\>", "\<\"83.00\
\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), "\<\"61\[ThinSpace]p\"\>", "\<\"11.2\[ThinSpace]p\"\
\>", "\<\"45\[ThinSpace]p\"\>", "\<\"15.8\[ThinSpace]p\"\>", "\<\"53\
\[ThinSpace]p\"\>", "\<\"6\[ThinSpace]e-10\"\>", "\<\"125\[ThinSpace]p\"\>", \
"\<\"10.1\[ThinSpace]p\"\>", "\<\"157\[ThinSpace]p\"\>", "\<\"29\[ThinSpace]p\
\"\>", "\<\"1.5\[ThinSpace]e-10\"\>", "\<\"12.09\[ThinSpace]p\"\>", \
"\<\"145.9\[ThinSpace]p\"\>", "\<\"14.5\[ThinSpace]p\"\>", \
"\<\"37\[ThinSpace]p\"\>", "\<\"5.44\[ThinSpace]p\"\>", \
"\<\"27\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), "\<\"8.42\[ThinSpace]p\"\>", "\<\"3.17\[ThinSpace]p\
\"\>", "\<\"10.70\[ThinSpace]p\"\>", "\<\"1.97\[ThinSpace]p\"\>", "\<\"12.86\
\[ThinSpace]p\"\>", "\<\"2.899\[ThinSpace]p\"\>", \
"\<\"8.18\[ThinSpace]p\"\>", "\<\"1.23\[ThinSpace]p\"\>", "\<\"8.08\
\[ThinSpace]p\"\>", "\<\"1.197\[ThinSpace]p\"\>", \
"\<\"5.019\[ThinSpace]p\"\>", "\<\"675\[ThinSpace]f\"\>", "\<\"4.34\
\[ThinSpace]p\"\>", "\<\"1.689\[ThinSpace]p\"\>", "\<\"22\[ThinSpace]p\"\>", \
"\<\"21.60\[ThinSpace]p\"\>", "\<\"44\[ThinSpace]p\"\>", "\<\"6.099\
\[ThinSpace]p\"\>", "\<\"11.1\[ThinSpace]p\"\>", "\<\"6\[ThinSpace]p\"\>", \
"\<\"10.3\[ThinSpace]n\"\>", "\<\"4.7\[ThinSpace]e-10\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[
              Unknown]\), "\<\"109.0\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), "\<\"29.39\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\)},
          {"\<\"EcA\"\>", "\<\"1.4\[ThinSpace]m\"\>", \
"\<\"8\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]e-5\"\>", "\<\"2.8\[ThinSpace]\
\[Micro]\"\>", "\<\"1\[ThinSpace]e-5\"\>", "\<\"2\[ThinSpace]e-4\"\>", \
"\<\"19\[ThinSpace]\[Micro]\"\>", "\<\"4.61\[ThinSpace]d\"\>", "\<\"585\
\[ThinSpace]\[Micro]\"\>", "\<\"5\[ThinSpace]n\"\>", "\<\"2.36\[ThinSpace]c\"\
\>", "\<\"2.33\[ThinSpace]c\"\>", "\<\"8.23\[ThinSpace]c\"\>", "\<\"2.82\
\[ThinSpace]d\"\>", "\<\"1.05\[ThinSpace]m\"\>", \
"\<\"3.5\[ThinSpace]e-4\"\>", "\<\"145\[ThinSpace]\[Micro]\"\>", "\<\"3.5\
\[ThinSpace]\[Micro]\"\>", "\<\"2.09\[ThinSpace]c\"\>", \
"\<\"4.15\[ThinSpace]c\"\>", "\<\"22\[ThinSpace]\[Micro]\"\>", "\<\"5.65\
\[ThinSpace]m\"\>", "\<\"1.2\[ThinSpace]e-4\"\>", \
"\<\"102\[ThinSpace]\[Micro]\"\>", "\<\"9.5\[ThinSpace]e-4\"\>", "\<\"5.63\
\[ThinSpace]c\"\>", "\<\"25\[ThinSpace]\[Micro]\"\>", "\<\"84\[ThinSpace]\
\[Micro]\"\>", "\<\"6\[ThinSpace]e-5\"\>", "\<\"7\[ThinSpace]e-5\"\>", \
"\<\"19\[ThinSpace]\[Micro]\"\>", "\<\"1.5\[ThinSpace]\[Micro]\"\>", \
"\<\"1.800\[ThinSpace]\[Micro]\"\>", "\<\"5\[ThinSpace]e-8\"\>", "\<\"2.4\
\[ThinSpace]\[Micro]\"\>", "\<\"1\[ThinSpace]e-10\"\>", "\<\"9\[ThinSpace]e-5\
\"\>", "\<\"3.7\[ThinSpace]e-4\"\>", "\<\"33\[ThinSpace]\[Micro]\"\>", \
"\<\"165\[ThinSpace]\[Micro]\"\>", "\<\"2\[ThinSpace]e-5\"\>", "\<\"1.2\
\[ThinSpace]\[Micro]\"\>", \(fNBookForm2[
              Unknown]\), "\<\"1\[ThinSpace]n\"\>", "\<\"1\[ThinSpace]n\"\>", \
"\<\"15\[ThinSpace]n\"\>", "\<\"75\[ThinSpace]n\"\>", "\<\"1.5\[ThinSpace]e-7\
\"\>", "\<\"2.5\[ThinSpace]e-7\"\>", "\<\"2.3\[ThinSpace]\[Micro]\"\>", \
"\<\"2\[ThinSpace]e-7\"\>", "\<\"1\[ThinSpace]n\"\>", "\<\"4.5\[ThinSpace]e-7\
\"\>", "\<\"3\[ThinSpace]e-11\"\>", "\<\"3\[ThinSpace]\[Micro]\"\>", "\<\"425\
\[ThinSpace]\[Micro]\"\>", "\<\"39\[ThinSpace]\[Micro]\"\>", "\<\"66.5\
\[ThinSpace]\[Micro]\"\>", "\<\"9.2\[ThinSpace]\[Micro]\"\>", "\<\"41.5\
\[ThinSpace]\[Micro]\"\>", \(fNBookForm2[
              Unknown]\), "\<\"7.049\[ThinSpace]\[Micro]\"\>", "\<\"2\
\[ThinSpace]\[Micro]\"\>", "\<\"6.2\[ThinSpace]\[Micro]\"\>", "\<\"1.2\
\[ThinSpace]\[Micro]\"\>", "\<\"5.2\[ThinSpace]\[Micro]\"\>", "\<\"1.3\
\[ThinSpace]\[Micro]\"\>", "\<\"3.5\[ThinSpace]\[Micro]\"\>", "\<\"5.2\
\[ThinSpace]e-7\"\>", "\<\"3.200\[ThinSpace]\[Micro]\"\>", \
"\<\"8\[ThinSpace]e-7\"\>", "\<\"3\[ThinSpace]\[Micro]\"\>", "\<\"2\
\[ThinSpace]\[Micro]\"\>", "\<\"1.25\[ThinSpace]\[Micro]\"\>", "\<\"7\
\[ThinSpace]e-10\"\>", "\<\"1.5\[ThinSpace]n\"\>", "\<\"1\[ThinSpace]n\"\>", \
"\<\"5\[ThinSpace]n\"\>", "\<\"4\[ThinSpace]n\"\>", \
"\<\"85\[ThinSpace]n\"\>", "\<\"8.5\[ThinSpace]e-7\"\>", "\<\"14\[ThinSpace]\
\[Micro]\"\>", "\<\"8.5\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]e-16\"\>", \
\(fNBookForm2[Unknown]\), "\<\"4\[ThinSpace]e-19\"\>", \(fNBookForm2[
              Unknown]\), "\<\"9\[ThinSpace]e-13\"\>", \
"\<\"5.5\[ThinSpace]e-16\"\>", "\<\"9.6\[ThinSpace]\[Micro]\"\>", "\<\"1.399\
\[ThinSpace]p\"\>", "\<\"2.7\[ThinSpace]\[Micro]\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\)},
          {"\<\"EoA\"\>", "\<\"1.08\[ThinSpace]d\"\>", \
"\<\"7\[ThinSpace]p\"\>", "\<\"1.8\[ThinSpace]e-7\"\>", \
"\<\"5.599\[ThinSpace]p\"\>", "\<\"4.440\[ThinSpace]\[Micro]\"\>", "\<\"28\
\[ThinSpace]\[Micro]\"\>", "\<\"5\[ThinSpace]e-7\"\>", "\<\"8.57\[ThinSpace]d\
\"\>", "\<\"1.3\[ThinSpace]\[Micro]\"\>", "\<\"1.2\[ThinSpace]e-10\"\>", \
"\<\"1.08\[ThinSpace]c\"\>", "\<\"1.29\[ThinSpace]m\"\>", "\<\"2\[ThinSpace]n\
\"\>", "\<\"2.2\[ThinSpace]\[Micro]\"\>", "\<\"6\[ThinSpace]e-8\"\>", \
"\<\"905\[ThinSpace]\[Micro]\"\>", "\<\"1.94\[ThinSpace]c\"\>", "\<\"4.5\
\[ThinSpace]e-7\"\>", "\<\"399\[ThinSpace]\[Micro]\"\>", "\<\"412\[ThinSpace]\
\[Micro]\"\>", "\<\"6\[ThinSpace]e-13\"\>", "\<\"1\[ThinSpace]n\"\>", \
"\<\"2.5\[ThinSpace]n\"\>", "\<\"3\[ThinSpace]e-10\"\>", \
"\<\"2\[ThinSpace]e-10\"\>", "\<\"2\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]e-11\
\"\>", "\<\"559.9\[ThinSpace]p\"\>", "\<\"2.5\[ThinSpace]e-10\"\>", "\<\"4.9\
\[ThinSpace]n\"\>", "\<\"3\[ThinSpace]e-11\"\>", "\<\"5\[ThinSpace]e-11\"\>", \
"\<\"3.7\[ThinSpace]n\"\>", "\<\"2\[ThinSpace]n\"\>", "\<\"67.3\[ThinSpace]\
\[Micro]\"\>", "\<\"2.1\[ThinSpace]e-10\"\>", "\<\"1.2\[ThinSpace]e-7\"\>", "\
\<\"7.9\[ThinSpace]\[Micro]\"\>", "\<\"11.99\[ThinSpace]p\"\>", "\<\"3\
\[ThinSpace]e-11\"\>", "\<\"1\[ThinSpace]e-11\"\>", \
"\<\"1\[ThinSpace]e-8\"\>", \(fNBookForm2[
              Unknown]\), "\<\"7\[ThinSpace]e-13\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[
              Unknown]\), "\<\"4\[ThinSpace]e-11\"\>", \
"\<\"110.0\[ThinSpace]p\"\>", "\<\"2\[ThinSpace]e-8\"\>", "\<\"4\[ThinSpace]p\
\"\>", "\<\"2.4\[ThinSpace]e-10\"\>", \(fNBookForm2[
              Unknown]\), "\<\"6\[ThinSpace]e-8\"\>", \
"\<\"5\[ThinSpace]e-11\"\>", "\<\"3\[ThinSpace]e-10\"\>", \
"\<\"13\[ThinSpace]n\"\>", "\<\"3.4\[ThinSpace]p\"\>", \
"\<\"1.2\[ThinSpace]p\"\>", "\<\"6.4\[ThinSpace]e-13\"\>", "\<\"2.799\
\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), "\<\"4.5\[ThinSpace]e-13\"\>", \
"\<\"1.3\[ThinSpace]e-13\"\>", "\<\"7\[ThinSpace]e-13\"\>", "\<\"139.9\
\[ThinSpace]f\"\>", "\<\"9.1\[ThinSpace]e-13\"\>", \
"\<\"220.0\[ThinSpace]f\"\>", "\<\"869.9\[ThinSpace]f\"\>", "\<\"1.7\
\[ThinSpace]e-13\"\>", "\<\"819.9\[ThinSpace]f\"\>", "\<\"1.5\[ThinSpace]e-13\
\"\>", "\<\"7\[ThinSpace]p\"\>", "\<\"2\[ThinSpace]p\"\>", \
"\<\"1\[ThinSpace]e-10\"\>", "\<\"4\[ThinSpace]p\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), "\<\"4\[ThinSpace]p\"\>", \
"\<\"3\[ThinSpace]e-11\"\>", "\<\"19\[ThinSpace]p\"\>", \
"\<\"3\[ThinSpace]e-11\"\>", "\<\"2\[ThinSpace]e-11\"\>", \
"\<\"15\[ThinSpace]z\"\>", \(fNBookForm2[
              Unknown]\), "\<\"6\[ThinSpace]e-22\"\>", \(fNBookForm2[
              Unknown]\), "\<\"89\[ThinSpace]a\"\>", \(fNBookForm2[
              
              Unknown]\), "\<\"1\[ThinSpace]p\"\>", \
"\<\"5\[ThinSpace]e-17\"\>", "\<\"3.2\[ThinSpace]n\"\>", \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\), \(fNBookForm2[
              Unknown]\), \(fNBookForm2[Unknown]\)},
          {"\<\"OS \"\>", \(-1\), "1", "0", "1", "2", "3", \(-4\), "2", 
            "4", \(-3\), \(-2\), \(-1\), "1", "2", "3", "4", 
            "5", \(-2\), \(-1\), "0", "1", "2", "3", \(-4\), "2", "4", \(-3\),
             "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "7", "0", "1", "2",
             "3", "2", "3", "4", "2", "3", "4", "5", "2", "3", "6", "2", "3", 
            "4", "7", "2", "3", "2", "3", "2", "3", "1", "2", "2", "3", "2", 
            "4", \(-3\), "3", "5", \(-2\), "4", "6", \(-1\), "1", "5", "0", 
            "1", "2", "3", "4", "3", "5", "6", "4", "6", "7", "3", "3", "2", 
            "4", "1", "2", "3", "2", "4", \(-3\), "3", "5", \(-2\), "4", 
            "6", \(-1\), "1", "5", "7", "0", "1", "2", "3", "3", "4", "3"},
          {"\<\"EN \"\>", "2.2`", "Unknown", "0.98`", "1.57`", "2.04`", 
            "2.55`", "3.04`", "3.44`", "3.98`", "Unknown", "0.93`", "1.31`", 
            "1.61`", "1.9`", "2.19`", "2.58`", "3.16`", "Unknown", "0.82`", 
            "1.`", "1.36`", "1.54`", "1.63`", "1.66`", "1.55`", "1.83`", 
            "1.88`", "1.91`", "1.9`", "1.65`", "1.81`", "2.01`", "2.18`", 
            "2.55`", "2.9`", "Unknown", "0.82`", "0.95`", "1.22`", "1.33`", 
            "1.6`", "2.16`", "1.9`", "2.2`", "2.28`", "2.2`", "1.93`", 
            "1.69`", "1.78`", "1.96`", "2.05`", "2.1`", "2.66`", "2.6`", 
            "0.79`", "0.89`", "1.1`", "1.12`", "1.13`", "1.14`", "1.13`", 
            "1.17`", "1.2`", "1.2`", "1.1`", "1.22`", "1.23`", "1.24`", 
            "1.25`", "1.1`", "1.27`", "1.3`", "1.5`", "2.36`", "1.9`", "2.2`",
             "2.2`", "2.28`", "2.54`", "2.`", "2.04`", "2.33`", "2.02`", 
            "2.`", "2.2`", "Unknown", "0.7`", "0.9`", "1.1`", "1.3`", "1.5`", 
            "1.38`", "1.36`", "1.28`", "1.3`", "1.3`", "1.3`", "1.3`", "1.3`",
             "1.3`", "1.3`", "1.3`", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown"},
          {"\<\"EA \"\>", "72.77`", "0", "59.63`", "0", "26.7`", "121.85`", 
            "0", "140.97676`", "328.`", "0", "52.867`", "0", "42.6`", 
            "133.6`", "72.03`", "200.4116`", "349.`", "0", "48.384`", 
            "2.369`", "18.1`", "7.6`", "50.7`", "64.3`", "0", "14.57`", 
            "63.8`", "111.5`", "118.5`", "0", "29", \(-120\), \(-80\), 
            "194.967`", "324.7`", "0", "46.884`", "4.6`", "29.6`", "41.1`", 
            "86.2`", "72.`", \(-53\), \(-100\), "110", "54.22`", "125.6`", 
            "0", "29", "101.`", "103", "190.15`", "295.2`", "0", "45.505`", 
            "14.47`", \(-50\), "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", \(-50\), "0", "31.1`", 
            "78.6`", \(-14\), \(-106\), "151", "205.1`", "222.737`", 
            "0", \(-20\), "35.1`", "91.3`", \(-180\), \(-270\), "0", "44", 
            "0", "0", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown"},
          {"\<\"AR \"\>", "0.37`", "Unknown", "1.52`", "1.13`", "0.8`", 
            "0.77`", "0.7`", "0.66`", "0.64`", "0.51`", "1.86`", "1.6`", 
            "1.43`", "1.17`", "1.1`", "1.04`", "0.99`", "0.88`", "2.27`", 
            "1.97`", "1.61`", "1.45`", "1.31`", "1.25`", "1.37`", "1.24`", 
            "1.25`", "1.25`", "1.28`", "1.34`", "1.53`", "1.2`", "1.21`", 
            "1.17`", "1.14`", "1.03`", "2.47`", "2.15`", "1.78`", "1.6`", 
            "1.49`", "1.36`", "1.35`", "1.32`", "1.34`", "1.38`", "1.44`", 
            "1.49`", "1.63`", "1.4`", "1.41`", "1.43`", "1.33`", "1.24`", 
            "2.65`", "2.22`", "1.88`", "1.82`", "1.82`", "1.81`", "1.81`", 
            "1.8`", "2.`", "1.79`", "1.76`", "1.75`", "1.74`", "1.73`", 
            "1.72`", "1.94`", "1.72`", "1.67`", "1.49`", "1.37`", "1.37`", 
            "1.34`", "1.36`", "1.37`", "1.44`", "1.5`", "1.47`", "1.75`", 
            "1.82`", "1.67`", "1.4`", "1.34`", \(-2.7`\), "2.33`", "1.88`", 
            "1.8`", "1.61`", "1.38`", "1.3`", "1.51`", "1.84`", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", 
            "Unknown", "Unknown", "Unknown", "Unknown"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(EarthCrustAbundance[Helium]\)], "Input"],

Cell[BoxData[
    \(8.`*^-9\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\(8.`*^-9\)\)\)], "Input"],

Cell[BoxData[
    \(8.`*^-9\)], "Output"]
}, Closed]],

Cell[TextData[{
  "NOTE:  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " provided bogus data: Accuracy should be 1 not \"machine\" I'd guess."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ScientificForm[%, 3]\)], "Input"],

Cell[BoxData[
    TagBox[
      InterpretationBox[\("8."\[Times]10\^"-9"\),
        8.0000000000000005*^-09,
        AutoDelete->True],
      (ScientificForm[ #, 3]&)]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
ScientificForm[%,3,NumberFormat \
->(SequenceForm[#1,\"e\",#3]&)]\
\>", "Input",
  CellTags->"S2.8.7"],

Cell[BoxData[
    TagBox[
      InterpretationBox[
        InterpretationBox[\("8."\[InvisibleSpace]"e"\[InvisibleSpace]"-9"\),
          SequenceForm[ "8.", "e", "-9"],
          Editable->False],
        8.0000000000000005*^-09,
        Editable->False],
      (ScientificForm[ #, 3, NumberFormat -> (
        SequenceForm[ #, "e", #3]&)]&)]], "Output"]
}, Closed]],

Cell["take 1st (cull units the easy way)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(efunsnum[\([1]\)]\)[1.111111111*10\^9]\)], "Input"],

Cell[BoxData[
    \(1.111111111`*^9\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    TagBox[
      RowBox[{"Take", "[", 
        RowBox[{
          FractionBox[
            RowBox[{
              RowBox[{"(", 
                InterpretationBox[\("\<8.24\>"\[Times]10\^"\<-1\>"\),
                  0.82399999999999995,
                  AutoDelete->True], ")"}], " ", "Joule", " ", "Kelvin"}], 
            "Gram"], ",", "1"}], "]"}],
      (ScientificForm[ #, 5]&)]], "Input"],

Cell[BoxData[
    \(0.824`\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Remove[xxx, xxx2];\)\)], "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Electron Configuration", "Section"],

Cell[CellGroupData[{

Cell["spec", "Subsubsection"],

Cell["\<\
note thsi is way oversimplified for how complex the real problem is \
!!\
\>", "Text"],

Cell[TextData[{
  "\telectron fill order is ...\n\tdecide WHERE e are ",
  StyleBox["GENERALLY",
    FontSlant->"Italic"],
  " (counted up from AtN)\n\t\tCRAP - my chembook gave a \"rule\"\n\t\tit's \
",
  StyleBox["WRONG  (not always true)",
    FontSlant->"Italic"],
  "\n\torder in CHART is by AtN\n\tcan be sorted to SHOW\n\t\t1) THOSE IN \
OUTER-MOST SHELL\n\t\t2) SHELL LAST ELECTRON FILLED"
}], "Text"],

Cell["\<\
subshell type NAMES in fill order , partitioned by subshell and ?
\t? fill order within a line of the typical periodic chart
\t? why grouped this way ?\
\>", "Text"],

Cell["\<\
expand to matrices having one position for each electron ; grouped \
by subshell / type\
\>", "Text"],

Cell["\<\
electrons partitioned by subshell type in fill order , and \
\"character\" names
shell level the nth subshell the above is filling
\tgrouping : maybe by period (already grouped by Group)
CRAP - WRONG
\tmy \"chem book\" never mentioned excetions.
\teither: proceede and poke in exceptions or drop the whole idea
Oh well!
\tmay as well - since I think calculating orbit
\tapparently also does not work (without tweaking to cause it to)\
\>", "Text"],

Cell[TextData[{
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s periodic palette uses cell boxes and decides placement with \"\" \
entries."
}], "Text"],

Cell["\<\
ChemicalElements.m stores eC, periodic uses\"\"

Due to the above - simply an ability to fill arrays / use them is enough.
\tit's \"preferred\" to use chem.m's arrays HOWEVER
\tthey are not fill ordered or necessarily always compatible\
\>", "Text"],

Cell["\<\
this fills all in order easily
\tOOPS
\t\tfill is one thing
\t\t\toddly ordered
\t\tBUT outer shell is for BONDING
\t\t\te in [highest] level
\t\t\t\tdoes NOT incl. even those after not
\t\t\t\tin that level
want
\tpartial fills
\t\tdo by removal
\treport when asked
\t\tshell last is in, OK
\t\t\tshells[]
\t\tsubshell last is in, OK
\t\t\tordnum[]
\t\torbital last is in
\t\t\t1st, 2nd, num
\t\t\tinord[]
\touter?most  shell report
\t\t\tinord[]\
\>", "Text"],

Cell["\<\
what if any are needed ?  at least first 2 ...
\tmathematica has 1 , but is the array format compat ?

ElectronFillOrder[ Element[[i]] ]
ElectronShellOrder[ Element[[i]] ]
ElectronLastShell[ Element[[i]] ]
\tshells[i]
ElectronLastSubshell[ Element[[i]] ]
\tsubshell
\t\t? in fill order ?
\t\t? in shell order ?
ElectronLastOrbit[ Element[[i]] ]
\tLength[ subshell ]
\t\t? in fill order ?
\t\t? in shell order ?
ElectronShells[ Element[[i]] ]
\t? returns list \
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["data - static / manual arrays", "Subsubsection"],

Cell[BoxData[{
    \(\(asubshells = {"\<s\>", "\<p\>", "\<d\>", "\<f\>"};\)\), "\n", 
    \(\(nsubshells = {1, 3, 5, 7};\)\), "\n", 
    \(\(\[Rho]subshells = {1, 2/3, 3/2, 4};\)\), "\n", 
    \(\(porb[c_] := \(Position[asubshells, c]\)[\([1, 1]\)];\)\), "\n", 
    \(\(zorb[c_] := nsubshells[\([porb[c]]\)];\)\[IndentingNewLine]\), "\n", 
    \(\(nord = {1, 2, 2, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6, 
          7};\)\), "\n", 
    \(\(cord = {"\<s\>", "\<s\>", "\<p\>", "\<s\>", "\<p\>", "\<d\>", \
"\<s\>", "\<p\>", "\<d\>", "\<f\>", "\<s\>", "\<p\>", "\<d\>", "\<f\>", \
"\<s\>", "\<p\>", "\<d\>", "\<s\>"};\)\), "\n", 
    \(\(gcord = {{"\<s\>"}, {"\<s\>", "\<p\>"}, {"\<s\>", "\<p\>", "\<d\>"}, \
{"\<s\>", "\<p\>", "\<d\>", "\<f\>"}, {"\<s\>", "\<p\>", "\<d\>", "\<f\>"}, \
{"\<s\>", "\<p\>", "\<d\>"}, {"\<s\>"}};\)\), "\n", 
    \(\(gnord = {{1}, {2, 3}, {4, 5, 6}, {7, 8, 9, 10}, {11, 12, 13, 
            14}, {15, 16, 17}, {18}};\)\[IndentingNewLine]\), "\n", 
    \(\(fnord = {1, 2, 2, 3, 3, 4, 3, 4, 5, 4, 5, 6, 4, 5, 6, 7, 5, 
          6};\)\), "\n", 
    \(\(fcord = {"\<s\>", "\<s\>", "\<p\>", "\<s\>", "\<p\>", "\<s\>", \
"\<d\>", "\<p\>", "\<s\>", "\<d\>", "\<p\>", "\<s\>", "\<f\>", "\<d\>", \
"\<p\>", "\<s\>", "\<f\>", "\<d\>"};\)\), "\n", 
    \(\(fgcord = {{"\<s\>"}, {"\<s\>", "\<p\>"}, {"\<s\>", "\<p\>"}, \
{"\<s\>", "\<d\>", "\<p\>"}, {"\<s\>", "\<d\>", "\<p\>"}, {"\<s\>", "\<f\>", \
"\<d\>", "\<p\>"}, {"\<s\>", "\<f\>", "\<d\>"}};\)\), "\[IndentingNewLine]", 
    \(\(fgnord = {{1}, {2, 3}, {4, 5, 7}, {6, 8, 10, 13}, {9, 11, 14, 
            17}, {12, 15, 18}, {16}};\)\[IndentingNewLine] (*\ 
      FGNORD\ IS\ WRONG\ *) \), "\[IndentingNewLine]", 
    \(\(fgnord3 = {{1}, {2, 2}, {3, 3}, {4, 3, 4}, {5, 4, 5}, {6, 4, 5, 
            6}, {7, 5, 6}};\)\[IndentingNewLine] (*\ 
      note\ incremental\ numbering\ may\ not\ be\ useful\ *) \), "\
\[IndentingNewLine]", 
    \(\(fgnord2 = {{1}, {2, 3}, {4, 5}, {6, 7, 8}, {9, 10, 11}, {12, 13, 14, 
            15}, {16, 17, 18}};\)\)}], "Input"],

Cell[BoxData[
    \(\(ncord = 
        Table[{nord[\([i]\)], cord[\([i]\)]}, {i, 1, 18}];\)\)], "Input"],

Cell[BoxData[
    \(\(fncord = 
        Table[{fnord[\([i]\)], fcord[\([i]\)]}, {i, 1, 18}];\)\)], "Input"],

Cell[BoxData[
    \(\(gncord = Table[{i, gcord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell["\<\
f\t\tg\t\tn\t\tc\t\t\tord
fill order,  grouped by shell, having number and letter for subshell, for \
each subshell\
\>", "Text"],

Cell[BoxData[
    \(\(fgncord = Table[{i, fgcord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell[BoxData[
    \(\(gnnord = Table[{i, gnord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell[BoxData[
    \(\(fgnnord = Table[{i, fgnord[\([i]\)]}, {i, 1, 7}];\)\)], "Input"],

Cell["\<\
ncord is not useful with partially filled e[]
becuase shell nums positionally change (try showe[] to see this)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ncord\)], "Input"],

Cell[BoxData[
    \({{1, "s"}, {2, "s"}, {2, "p"}, {3, "s"}, {3, "p"}, {3, "d"}, {4, 
        "s"}, {4, "p"}, {4, "d"}, {4, "f"}, {5, "s"}, {5, "p"}, {5, "d"}, {5, 
        "f"}, {6, "s"}, {6, "p"}, {6, "d"}, {7, "s"}}\)], "Output"]
}, Closed]],

Cell["this can be used against any fe[]", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fgnnord\)], "Input"],

Cell[BoxData[
    \({{1, {1}}, {2, {2, 3}}, {3, {4, 5, 7}}, {4, {6, 8, 10, 13}}, {5, {9, 
          11, 14, 17}}, {6, {12, 15, 18}}, {7, {16}}}\)], "Output"]
}, Closed]],

Cell["\<\
s is left, d middle, p right , and f (lanthanide / actinide \
seriers)\
\>", "Text"],

Cell[BoxData[
    \(fe[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, f1}; \[IndentingNewLine]ford = {s, s, p, s, p, s, d, p, s, 
            d, p, s, f, d, p, s, f, d}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(gfe[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, 
            f1}; \[IndentingNewLine]gford = {{s}, {s, p}, {s, p}, {s, d, 
              p}, {s, d, p}, {s . f, d, p}, {s, f, 
              d}}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(e[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, f1}; \[IndentingNewLine]ord = {s, s, p, s, p, d, s, p, d, f, 
            s, p, d, f, s, p, d, s}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(ge[] := 
      Module[{s1, s, p1, p, d1, d, f1, f, ford}, \[IndentingNewLine]s1 = 1; 
        s = {s1, s1}; p1 = {1, 1, 1}; p = {p1, p1}; d1 = {1, 1, 1, 1, 1}; 
        d = {d1, d1}; f1 = {1, 1, 1, 1, 1, 1, 1}; 
        f = {f1, 
            f1}; \[IndentingNewLine]gford = {{s}, {s, p}, {s, p, d}, {s, p, 
              d, f}, {s, p, d, f}, {s, p, 
              d}, {s}}\[IndentingNewLine]]\)], "Input"],

Cell["quantum chart isn't used in elements chart, currently unused", "Text"],

Cell[BoxData[
    \(\(pqnlabel = \[IndentingNewLine]{"\<n\>", "\<\[ScriptL]\>", \
\*"\"\<\!\(m\_\[ScriptL]\)\>\"", \*"\"\<\!\(m\_s\)\>\"", \*"\"\<\!\(1\/2\)\
\[HBar]\>\"", \*"\"\<-\!\(1\/2\)\[HBar]\>\""};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["quantum number state tables with function to create", "Subsubsection"],

Cell["NOTE:  abbreviated but making full is easy, see chart below", "Text"],

Cell["\<\
fixme ?  CRC 52nd 1972 lists \"O-P-Q\" on shell 7,  but Serway Phy \
3rd I used shows only \"...\".   I'd believe anything over P is unused by \
known elements except CRC says yes.  Thus I've added a guess for Q e 7 not \
yet checked against the / a book.  (the guess is that \"e\" is arrived at the \
same way h, g, f, ... meaning, looking at last two pqnlabel, no new state is \
added.  OOOH CRC says Q is shell 7.  ok\
\>", "Text"],

Cell[BoxData[
    \(\(pqnlevel = {"\<K\>", "\<L\>", "\<M\>", "\<O\>", "\<N\>", "\<P\>", \
"\<Q\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(oqnlevel = {"\<s\>", "\<p\>", "\<d\>", "\<f\>", "\<g\>", "\<h\>", \
"\<e\>"};\)\)], "Input"],

Cell[BoxData[
    \(\(pqnstate::usage = "\<pqnstate[number of shells] := \
{shells,subshells,electrons states} where each is a running total across all \
(principle quantum number state totals)\>";\)\)], "Input"],

Cell[BoxData[
    \(pqnstate[n_] := 
      Module[{j, k}, \[IndentingNewLine]{n, \[Sum]\+\(j = 1\)\%n j, 
          n + \[Sum]\+\(j = 1\)\%\(n - 1\)\(\[Sum]\+\(k = 1\)\%j\((2  k + 
                    1)\)\)\[IndentingNewLine], 
          2 \((n + \[Sum]\+\(j = 1\)\%\(n - 1\)\(\[Sum]\+\(k = 1\)\%j\((2  
                          k + 1)\)\))\)}]\)], "Input"],

Cell["\<\
a chart from a physics books use during introducing n,l,ml,ms
\tsee notes above: guess / Q / 7 is a guess I haven't bothered checking\
\>", \
"Text"],

Cell[BoxData[
    \(\(create::usage = \*"\"\<create[n Shells]  creates a quantum state \
table (emperical allowable energies of hydrogen, also the periodic table \
(fill order aside)). n=K,L,M... are the shells (principle qauntum number \
p.q.n.), n-1=\[ScriptL]=s,p,d... are subshells (orbital q.n.), \!\(m\_\
\[ScriptL]\) = -\[ScriptL]...\[ScriptL] the (o. magnetic q.n.), and \
\!\(m\_s\) the opposing radial energy pair of electrons.  n must be a whole \
number by observation, an easy explanation by de Broglie is an n standing \
wave division, \!\(m\_\[ScriptL]\) (yet more spectrum lines) are due to \
submagnets of electron motion\>\"";\)\)], "Input"],

Cell["\<\
... and no two electrons can occupy the same space: which fills the \
table above when exclusions (due to n being integral) are made.  where a \
state is not allowed, latent energy is held between states (observed).  the \
integer model in the table fits the spectrum grouping of absorbed or released \
wavelengths of hydrogen.  note the table does not match the periodic table \
exactly for several elements (yet more dynamic issues).  m_s integral(2) and \
not a span of vectors why? due to the precision uncertainty of using anything \
< h in any calculation, but the result of pairs matches the spectral lines \
where standing waves patters are seen.  p=yh (h is related to energy and \
frequency), so whole measures of h or n, and standing wave numbers, is not \
coincidence.\
\>", "Text"],

Cell[BoxData[
    \(create[nx_] := 
      Module[{v, p, d, k, n, 
          z}, \[IndentingNewLine]p[d : 7] := {pqnlabel[\([6]\)], 
            pqnlabel[\([7]\)]}; \  (*\ 
          guess\ *) \[IndentingNewLine]p[d : 5] := {pqnlabel[\([5]\)], 
            pqnlabel[\([6]\)]}; \[IndentingNewLine]p[d : 4] := 
          ToEach[Range[\(-k\), k], p[d + 1]]; \[IndentingNewLine]p[d : 3] := 
          Table[{oqnlevel[\([k + 1]\)], p[d + 1]}, {k, 0, 
              n - 1}]; \[IndentingNewLine]p[d : 2] := {pqnlevel[\([n]\)], 
            p[d + 1]}; \[IndentingNewLine]p[d : 1] := 
          Table[k = \(-1\); p[d + 1], {n, 1, nx}]; \[IndentingNewLine]p[
            d : 0] := {"\<Allowable Quantum States\>", 
            p[d + 1]}; \[IndentingNewLine]p[0]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(create[3] // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"Allowable Quantum States\"\>", "\<\"\"\>", "\<\"\"\>"},
          {GridBox[{
                {"\<\"K\"\>"},
                {GridBox[{
                      {"\<\"s\"\>"},
                      {GridBox[{
                            {"0", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"L\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"\<\"s\"\>"},
                      {GridBox[{
                            {"0", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"\<\"p\"\>", "\<\"\"\>", "\<\"\"\>"},
                      {GridBox[{
                            {\(-1\), "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}], GridBox[{
                {"\<\"M\"\>", "\<\"\"\>", "\<\"\"\>"},
                {GridBox[{
                      {"\<\"s\"\>"},
                      {GridBox[{
                            {"0", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"\<\"p\"\>", "\<\"\"\>", "\<\"\"\>"},
                      {GridBox[{
                            {\(-1\), "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}], GridBox[{
                      {"\<\"d\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>"},
                      {GridBox[{
                            {\(-2\), "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {\(-1\), "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"0", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"1", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}], GridBox[{
                            {"2", "\<\"\"\>"},
                            {"\<\"\\!\\(1\\/2\\)\[HBar]\"\>", \
"\<\"-\\!\\(1\\/2\\)\[HBar]\"\>"}
                            },
                          RowSpacings->0.25,
                          ColumnSpacings->1,
                          RowAlignments->Baseline,
                          ColumnAlignments->{Left}]}
                      },
                    RowSpacings->0.25,
                    ColumnSpacings->1,
                    RowAlignments->Baseline,
                    ColumnAlignments->{Left}]}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {"Allowable Quantum States", {{"K", {{"s", {{0, {
        "\!\(1\/2\)\[HBar]", "-\!\(1\/2\)\[HBar]"}}}}}}, {"L", {{"s", {{0, {
        "\!\(1\/2\)\[HBar]", "-\!\(1\/2\)\[HBar]"}}}}, {"p", {{-1, {
        "\!\(1\/2\)\[HBar]", "-\!\(1\/2\)\[HBar]"}}, {0, {"\!\(1\/2\)\[HBar]",
         "-\!\(1\/2\)\[HBar]"}}, {1, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}}}}}, {"M", {{"s", {{0, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}}}, {"p", {{-1, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}, {0, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}, {1, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}}}, {"d", {{-2, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}, {-1, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}, {0, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}, {1, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}, {2, {"\!\(1\/2\)\[HBar]", 
        "-\!\(1\/2\)\[HBar]"}}}}}}}}]]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pqnstate[3]\)], "Input"],

Cell[BoxData[
    \({3, 6, 14, 28}\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
stateskel:
(makes an \"allowed quant num states\" array of just the allowed states given \
n\
\>", "Subsubsection"],

Cell["\<\
Quantum states show us why we have \"s, p, d, f\" and their size.  \
However note they do not predict \"irregularities\" and infact irregularities \
are questionably calculated and arguable in modern physics.  (in this program \
the corrections are given not calculated by any favorite formula)\
\>", "Text"],

Cell[BoxData[
    \(stateskel[n_] := 
      Module[{l, ml, ms}, \[IndentingNewLine]l = 
          Range[0, n - 1]; \[IndentingNewLine]ml = 
          Range[\(-l\), l]; \[IndentingNewLine]ms = 
          Range[\(-1\)/2, 1/2]; \[IndentingNewLine]{l, ml, 
          ms}\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(stateskel[3]\)], "Input"],

Cell[BoxData[
    \({{0, 1, 
        2}, {{0}, {\(-1\), 0, 1}, {\(-2\), \(-1\), 0, 1, 2}}, {\(-\(1\/2\)\), 
        1\/2}}\)], "Output"]
}, Closed]],

Cell["\<\
as in Serway Phy 3rd p. 1227 tab 42.3 \"allowed quantum num for an \
atom\"
\tNOTE: create[] table above is easier to use / make table of\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({\[IndentingNewLine]{pqnlabel[\([1]\)], {3}}, \
\[IndentingNewLine]{"\<\>"}, \[IndentingNewLine]{pqnlabel[\([2]\)], \
\(stateskel[
              3]\)[\([1]\)]}, \[IndentingNewLine]{"\<\>"}, \
\[IndentingNewLine]{pqnlabel[\([3]\)], \(stateskel[
              3]\)[\([2]\)]}, \[IndentingNewLine]{"\<\>"}, \
\[IndentingNewLine]{pqnlabel[\([4]\)], \(stateskel[
              3]\)[\([3]\)]}\[IndentingNewLine]} // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"n\"\>", GridBox[{
                {"3"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"\<\"\"\>", "\<\"\"\>"},
          {"\<\"\[ScriptL]\"\>", GridBox[{
                {"0"},
                {"1"},
                {"2"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"\<\"\"\>", "\<\"\"\>"},
          {"\<\"\\!\\(m\\_\[ScriptL]\\)\"\>", GridBox[{
                {"0", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
                {\(-1\), "0", "1", "\<\"\"\>", "\<\"\"\>"},
                {\(-2\), \(-1\), "0", "1", "2"}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]},
          {"\<\"\"\>", "\<\"\"\>"},
          {"\<\"\\!\\(m\\_s\\)\"\>", GridBox[{
                {\(-\(1\/2\)\)},
                {\(1\/2\)}
                },
              RowSpacings->0.25,
              ColumnSpacings->1,
              RowAlignments->Baseline,
              ColumnAlignments->{Left}]}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{"n", {3}}, {""}, {"\[ScriptL]", {0, 1, 2}}, {""}, {
        "\!\(m\_\[ScriptL]\)", {{0}, {-1, 0, 1}, {-2, -1, 0, 1, 2}}}, {""}, {
        "\!\(m\_s\)", {
        Rational[ -1, 2], 
        Rational[ 1, 2]}}}]]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["funs - variety of utility funs", "Subsubsection"],

Cell["\<\
IMPORTANT:  felements / elements are built from these further below \
(aren't be avail yet)\
\>", "Text"],

Cell["\<\
total electrons so far for the Nth subshell
\t* note flatten is used to count 1's
\t* use ecnt[x][[subshell]] for a one subshell\
\>", "Text"],

Cell[BoxData[
    \(\(ecnt[e_List] := 
        Table[\[IndentingNewLine]Length[
            Flatten[Take[e, i]]]\[IndentingNewLine], {i, 1, 
            Length[e]}\[IndentingNewLine]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ecnt[felements[\([90]\)]]\)], "Input"],

Cell[BoxData[
    \({2, 4, 10, 12, 18, 20, 30, 36, 38, 48, 54, 56, 70, 80, 86, 88, 88, 
      90}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(ecnt[an_Symbol] := 
        ecnt[elements[\([AtomicNumber[an]]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(fecnt[an_Symbol] := 
        ecnt[felements[\([AtomicNumber[an]]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(ecnt[an_Integer] := ecnt[elements[\([an]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(fecnt[an_Integer] := ecnt[felements[\([an]\)]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ecnt[fe[]]\)], "Input"],

Cell[BoxData[
    \({2, 4, 10, 12, 18, 20, 30, 36, 38, 48, 54, 56, 70, 80, 86, 88, 102, 
      112}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(ecnt[] := ecnt[e[]]\)], "Input"],

Cell[BoxData[
    \(fecnt[] := ecnt[fe[]]\)], "Input"],

Cell[BoxData[
    \(fecnt[e_List] := ecnt[e]\)], "Input"],

Cell[BoxData[
    \(\(height[e_] := Length[e];\)\)], "Input"],

Cell[BoxData[
    \(width[e_] := 
      Module[{h}, h = height[e]; 
        Max[Table[\ Length[e[\([i]\)]], {i, 1, h}]]]\)], "Input"],

Cell["sub length , len at each width position", "Text"],

Cell[BoxData[
    \(subheight[e_] := 
      Module[{h}, h = height[e]; 
        Table[\ Length[e[\([i]\)]], {i, 1, h}]]\)], "Input"],

Cell[BoxData[
    \(subwidth[e_] := 
      Module[{w}, w = width[e]; 
        Table[\ Length[e[\([i]\)]], {i, 1, w}]]\)], "Input"],

Cell["shell level elem is in ElectronConfiguration", "Text"],

Cell[BoxData[
    \(shells[x_Integer] := \[IndentingNewLine]Module[{ec, len}, 
        len = 0; \[IndentingNewLine]If[
          x > 0 && \ x \[LessEqual] Length[Elements], \[IndentingNewLine]ec = 
            ElectronConfiguration[Elements[\([x]\)]]; \[IndentingNewLine]If[
            SameQ[ec, Unknown], len = 7, 
            len = Length[
                ec]]; \[IndentingNewLine]If[\(! SameQ[ec, Unknown]\) && 
              Length[ec[\([len]\)]] > 2, len + 1, 
            len]\[IndentingNewLine]]]\)], "Input"],

Cell["shell level elem is in ElectronConfiguration", "Text"],

Cell[BoxData[
    \(shells[n_Symbol] := \[IndentingNewLine]Module[{ec, len, x}, 
        len = 0; \[IndentingNewLine]x = 
          AtomicNumber[n]; \[IndentingNewLine]If[
          x > 0 && \ x \[LessEqual] Length[Elements], \[IndentingNewLine]ec = 
            ElectronConfiguration[Elements[\([x]\)]]; \[IndentingNewLine]If[
            SameQ[ec, Unknown], len = 7, 
            len = Length[
                ec]]; \[IndentingNewLine]If[\(! SameQ[ec, Unknown]\) && 
              Length[ec[\([len]\)]] > 2, len + 1, 
            len]\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(\(shells[e_List] := Max[Take[fnord, {1, Length[e]}]];\)\)], "Input"],

Cell["shellsarr [ Atomic Number ] == outermost shell of element", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(shellsarr = Table[shells[i], {i, 1, Length[Elements]}]\)], "Input"],

Cell[BoxData[
    \({1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 
      4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 
      5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 
      6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7, 7, 7, 7, 7, 7, 
      7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7}\)], "Output"]
}, Closed]],

Cell["\<\
counts of e in each of [1-18] orbitals separately (unlike ecnt not \
a running sum)\
\>", "Text"],

Cell[BoxData[
    \(ineachsubshell[an_Integer] := 
      Table[\[IndentingNewLine]Length[
          Flatten[\(felements[\([an]\)]\)[\([i]\)]]]\[IndentingNewLine], {i, 
          1, Length[felements[\([an]\)]]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(ineachsubshell[e_List] := 
      Table[\[IndentingNewLine]Length[
          Flatten[e[\([i]\)]]]\[IndentingNewLine], {i, 1, 
          Length[e]}\[IndentingNewLine]]\)], "Input"],

Cell["ignore these", "Text"],

Cell[BoxData[
    \(inorb2[elem_, n_] := 
      Length[Flatten[Part[elem, Flatten[Position[nord, n]]]]]\)], "Input"],

Cell[BoxData[
    \(finorb2[felem_, n_] := 
      Length[Flatten[Part[felem, Flatten[Position[fnord, n]]]]]\)], "Input"],

Cell["\<\
counts of e in Orbital n (of 7 orbitals) : not the same as e in a \
shell for fill order\
\>", "Text"],

Cell[BoxData[
    \(fineashell[elem_, n_] := 
      Module[{len, sublist, v, nn, once}, \[IndentingNewLine]once = 0; 
        len = Length[elem]; \[IndentingNewLine]sublist = 
          Flatten[Position[fnord, 
              n]]; \[IndentingNewLine]v = {}; \[IndentingNewLine]Do[\
\[IndentingNewLine]If[sublist[\([i]\)] \[LessEqual] len, 
            once = 1; \[IndentingNewLine]v = 
              Append[v, 
                Part[elem, sublist[\([i]\)]]]\[IndentingNewLine]], {i, 1, 
            Length[sublist]}\[IndentingNewLine]]; \[IndentingNewLine]nn = 
          Length[Flatten[v]]; \[IndentingNewLine]If[once \[Equal] 1, 
          nn]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(ineashell[elem_, n_] := fineashell[ord2ford[elem], n];\)\)], "Input"],

Cell["\<\
counts of e in subshell n
\tThis works but is same as inorb / finorb\
\>", "Text"],

Cell[BoxData[
    \( (*\[IndentingNewLine]finord[elem_, n_] := 
        Module[{len, sublist, v, nn}, \[IndentingNewLine]len = 
            Length[elem]; \[IndentingNewLine]sublist = 
            fgnord[\([n]\)]; \[IndentingNewLine]v = {}; \
\[IndentingNewLine]Do[\[IndentingNewLine]If[
              sublist[\([i]\)] \[LessEqual] len, 
              v = Append[v, 
                  Part[elem, sublist[\([i]\)]]]\[IndentingNewLine]], {i, 1, 
              Length[sublist]}\[IndentingNewLine]]; \[IndentingNewLine]nn = 
            Length[Flatten[v]]; \[IndentingNewLine]If[nn =!= 0, 
            nn]\[IndentingNewLine]]\[IndentingNewLine]*) \)], "Input"],

Cell[BoxData[
    \( (*\ \(inord[elem_, n_] := finord[ord2ford[elem], n];\)\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Table[ineashell[elements[\([55]\)], i], {i, 1, 7}]\)], "Input"],

Cell[BoxData[
    \({2, 8, 18, 18, 8, 1, Null}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ineachsubshell[felements[\([55]\)]]\)], "Input"],

Cell[BoxData[
    \({2, 2, 6, 2, 6, 2, 10, 6, 2, 10, 6, 1}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ineachsubshell[elements[\([55]\)]]\)], "Input"],

Cell[BoxData[
    \({2, 2, 6, 2, 6, 10, 2, 6, 10, 2, 6, 1}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(ecnt[felements[\([55]\)]]\)[\([12]\)] - \(ecnt[
          felements[\([55]\)]]\)[\([11]\)]\)], "Input"],

Cell[BoxData[
    \(1\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(shellsarr[\([55]\)]\)], "Input"],

Cell[BoxData[
    \(6\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ecnt[felements[\([55]\)]]\)], "Input"],

Cell[BoxData[
    \({2, 4, 10, 12, 18, 20, 30, 36, 38, 48, 54, 55}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(showfe[Caesium]\)], "Input"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {"1", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"3", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"4", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"5", "\<\"s\"\>", \({1, 1}\)},
              {"4", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"5", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"6", "\<\"s\"\>", \({1}\)}
              }], "\[NoBreak]", ")"}],
        (MatrixForm[ #]&)],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell["\<\
ignore:  ordnum
\tornum does NOT count irregularities
\tfor that use felements[]
\tNOTE:  nothing uses these
for example,
\tgiven n an AtomicNumber
\tthe position in fcord or fcord being filled (last subshell)
\twhich is the nth s,p,d or f (there are 18 subshells for 112th elem)
\tNOTE: exact input (full felements[]) is NOT needed\
\>", "Text"],

Cell[BoxData[
    \(ordnum[n_] := 
      Module[\[IndentingNewLine]{i}, i = 0; 
        If[n < 1 || n > ELEMENTS, 
          False, \[IndentingNewLine]While[\(++i\) < 
                18 && \(ecnt[]\)[\([i]\)] < 
                n]; \[IndentingNewLine]i]]\)], "Input"],

Cell[BoxData[
    \(fordnum[n_] := 
      Module[\[IndentingNewLine]{i}, i = 0; 
        If[n < 1 || n > ELEMENTS, 
          False, \[IndentingNewLine]While[\(++i\) < 
                18 && \(fecnt[]\)[\([i]\)] < 
                n]; \[IndentingNewLine]i]]\)], "Input"],

Cell["\<\
Map[ordnum,Table[i,{i,1,112}]]
Map[fordnum,Table[i,{i,1,112}]]\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ 
      ex . \ Boron\ will\ fill\ first\ 3\ \((s\ s\ p)\)\ \((not\ all)\)\ \
*) \)\(\[IndentingNewLine]\)\(ordnum[5] \[Equal] 3\)\)\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Closed]],

Cell["\<\
IMPORTANT:  see notes above
\tcovert ord -> ford or ford -> ord\
\>", "Text"],

Cell[BoxData[
    \(ford2ord[
        e_List] := \(Sort[\[IndentingNewLine]Table[{fnord[\([i]\)], 
              porb[fcord[\([i]\)]], i, e[\([i]\)]}\[IndentingNewLine], {i, 1, 
              Length[e]}]]\)[\([All, 4]\)]\)], "Input"],

Cell[BoxData[
    \(\(ford2ordarr[
          e_] := \(Sort[\[IndentingNewLine]Table[{fnord[\([i]\)], 
                porb[fcord[\([i]\)]], i, e[\([i]\)]}\[IndentingNewLine], {i, 
                1, Length[e]}]]\)[\([All, 3]\)];\)\)], "Input"],

Cell["\<\
more complicated: but \"easy\" if taken as reverse of order \
ford2ord would do\
\>", "Text"],

Cell[BoxData[
    \(ord2ford[
        e_] := \(Module[{sarr}, \[IndentingNewLine]sarr = ford2ordarr[e]; 
          Sort[\[IndentingNewLine]Table[{sarr[\([i]\)], e[\([i]\)]}, {i, 1, 
                Length[e]}]\[IndentingNewLine]]]\)[\([All, 2]\)]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ford2ord[fe[]] \[Equal] e[]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Closed]],

Cell["\<\
Table Below:
\t* INTERESTING: right column shows orbital fill order for this element
\t* porb[ fcord[[i]] ] fcord[[i]] is [1-18]th \"s,p,d,f\" in fcord
\t   (that's the orbital being / that is last filled at i) and porb shows \
[1-4]
\t   (and is not req. to show or for sorting)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\( (*\ 
      works\ only\ after\ felements\ built\ *) \)\(\ \
\)\(\[IndentingNewLine]\)\(\(Table[{fnord[\([i]\)], porb[fcord[\([i]\)]], 
            i, \(felements[\([57]\)]\)[\([i]\)]}, {i, 1, 
            Length[felements[\([57]\)]]}] // Sort\) // 
      MatrixForm\)\)\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "1", "1", \({1, 1}\)},
            {"2", "1", "2", \({1, 1}\)},
            {"2", "2", "3", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"3", "1", "4", \({1, 1}\)},
            {"3", "2", "5", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"3", "3", "7", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"4", "1", "6", \({1, 1}\)},
            {"4", "2", "8", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"4", "3", "10", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"4", "4", "13", \({{}}\)},
            {"5", "1", "9", \({1, 1}\)},
            {"5", "2", "11", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"5", "3", "14", \({1}\)},
            {"6", "1", "12", \({1, 1}\)}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell[BoxData[
    \(showfe[e_List] := 
      Table[{fnord[\([i]\)], fcord[\([i]\)], 
            e[\([i]\)]}\[IndentingNewLine], {i, 1, Length[e]}] // 
        MatrixForm\)], "Input"],

Cell[BoxData[
    \(showfe[x_Symbol] := 
      Module[{an, z}, \[IndentingNewLine]an = 
            AtomicNumber[x]; \[IndentingNewLine]showfe[
            felements[\([an]\)]]\[IndentingNewLine]] // MatrixForm\)], "Input"],

Cell["\<\
note how showfe won't work for showe - would mistake shells / \
orbits\
\>", "Text"],

Cell[BoxData[
    \(showe[e_List] := 
      Module[{v, w}, 
          v = ord2ford[e]; \[IndentingNewLine]w = 
            Table[\[IndentingNewLine]{fnord[\([i]\)], porb[fcord[\([i]\)]], 
                fcord[\([i]\)], v[\([i]\)]}\[IndentingNewLine], {i, 1, 
                Length[v]}\[IndentingNewLine]]; \[IndentingNewLine]v = 
            Sort[w]; \[IndentingNewLine]Map[\((Delete[#, 2] &)\), 
            v]\[IndentingNewLine]] // MatrixForm\)], "Input"],

Cell[BoxData[
    \(showe[x_Symbol] := 
      Module[{an, z}, \[IndentingNewLine]an = 
            AtomicNumber[x]; \[IndentingNewLine]showe[
            elements[\([an]\)]]\[IndentingNewLine]] // MatrixForm\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["create elements elec. tables 1's format", "Subsubsection"],

Cell["\<\
begins with fe[] (112) and removes one at a time.
\tstandard form used is to include only non-empty orbits (to remove empties)
\tso Helium is just {{1,1}} which is 110 removals from 112\
\>", "Text"],

Cell["\<\
laste returns: Position[] of the last electron in e given (Deleted \
once to get each element).  also used by correct[] further below\
\>", "Text"],

Cell[BoxData[
    \(laste[e_] := 
      Module[{d, l, v}, \[IndentingNewLine]v = e; l = Length[v]; 
        d = {}; \[IndentingNewLine]While[
          l > 0, \[IndentingNewLine]d = Append[d, l]; \[IndentingNewLine]v = 
            Last[v]; \[IndentingNewLine]l = 
            Length[v];]; \[IndentingNewLine] (*\(If[v \[Equal] {}, 
              d = Append[d, 1]];\)*) \[IndentingNewLine]d]\)], "Input"],

Cell[BoxData[
    \(\(Module[{v, w}, v = e[]; 
        w = {}; \[IndentingNewLine]While[v \[NotEqual] w, w = v; 
          v = Last[v]]; v];\)\)], "Input"],

Cell["\<\
takee is not general
\tit assumes last is the object to be deleted
\tit removes empties\
\>", "Text"],

Cell[BoxData[
    \(takee[e_] := 
      Module[{v}, \[IndentingNewLine]v = 
          Delete[e, laste[e]]; \[IndentingNewLine] (*\ 
          empties\ are\ not\ kept\ *) \[IndentingNewLine]While[
          Extract[v, laste[v]] \[Equal] {} && Length[v] \[NotEqual] 0, 
          v = Delete[v, laste[v]]]; \[IndentingNewLine]v]\)], "Input"],

Cell["\<\
empties not kepts as variously Length[] is used to count electrons \
and {} would count as 1\
\>", "Text"],

Cell[BoxData[
    \(takee[e_, n_] := 
      Module[{i, v}, \[IndentingNewLine]i = n; 
        v = e; \[IndentingNewLine]While[\(i--\) \[NotEqual] 0, 
          v = takee[v]]; \[IndentingNewLine]v]\)], "Input"],

Cell["create table of elements of full electron table", "Text"],

Cell[BoxData[
    \(\(\(Clear[felements, elements]\)\(\[IndentingNewLine]\)\( (*\ 
      oops\ showfe\ uses\ already\ Remove[felements, 
          elements]\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(Module[{i, f}, i = 113; 
      felements = Array[f, ELEMENTS]; \[IndentingNewLine]While[\(--i\) > 0, 
        felements[\([i]\)] = 
          takee[fe[], ELEMENTS - i]]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(elements = 
        Table[ford2ord[felements[\([i]\)]], {i, 1, ELEMENTS}];\)\)], "Input"],

Cell[BoxData[
    \(Module[{i, f}, i = 113; 
      elements = Array[f, ELEMENTS]; \[IndentingNewLine]While[\(--i\) > 0, 
        elements[\([i]\)] = 
          takee[e[], ELEMENTS - i]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell["\<\
keep for later is sometimes useful to see non-adjusted for \
comparison\
\>", "Text"],

Cell[BoxData[
    \(\(elementsNa = elements;\)\)], "Input"],

Cell[BoxData[
    \(\(felementsNa = felements;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["correct the \"irregularities\"", "Subsubsection"],

Cell["\<\
takes e here , add e there , but ... not as easy as hoped / planned

\tNO ERROR CHECKING (ie, none there to take)
\t** corrections should be know to be applicable before tried
\t** probably manual correction / replacements would have better
\tnote we correct fe / fill order only and convert to e[] after corrections\
\
\>", "Text"],

Cell["\<\
correct:\t \tadd e to last , take from next to last
correct2x:\tadd e to last , take from next to last, done twice
correct2:\tadd e to last , take from 2 before last
correct2x2:\tadd e to last , take from 2 before last, done twice
rcorrect: \tadd e after last, take from last
rcorrect2: \tadd e after last, take from last, add e to last take from last \
(correct)\
\>", "Text"],

Cell[BoxData[
    \(rnullpat[e_] := 
      Module[{p}, \[IndentingNewLine]p = 
          Position[e, {_, {}}]; \[IndentingNewLine]If[
          Length[p] == 1, \[IndentingNewLine]Delete[e, 
            Flatten[{p, 2}]]\[IndentingNewLine], 
          e\[IndentingNewLine]]]\)], "Input"],

Cell["\<\
special case to remove dangling {}
\t(standard form when created / include only non-empty orbits)
\tsome code won't expect dangling {}\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(rnullpat[{{1, 1}, {}}]\)], "Input"],

Cell[BoxData[
    \({{1, 1}}\)], "Output"]
}, Closed]],

Cell["\<\
add e to last , take from next to last
\tworks nice but removes\
\>", "Text"],

Cell[BoxData[
    \(correct[e_] := 
      Module[{v, w}, \[IndentingNewLine]v = 
          Take[e, \(-1\)]; \[IndentingNewLine]v = 
          Insert[v, 1, laste[v]]; \[IndentingNewLine]w = 
          Take[e, Length[e] - 1]; \[IndentingNewLine] (*\ \(w = 
              takee[w];\)*) \[IndentingNewLine]w = 
          Delete[w, laste[w]]; \[IndentingNewLine]Append[w, 
          v]\[IndentingNewLine]]\)], "Input"],

Cell["add e to last , take from 2 before last", "Text"],

Cell[BoxData[
    \(correct2[e_] := 
      Module[{v, w, x}, \[IndentingNewLine]x = 
          Take[e, \(-2\)]; \[IndentingNewLine]w = 
          Take[e, Length[e] - 2]; \[IndentingNewLine]v = 
          Last[x]; \[IndentingNewLine]x = \(Take[x, 
              Length[x] - 1]\)[\([1]\)]; \[IndentingNewLine]v = 
          Insert[v, 1, laste[v]]; \[IndentingNewLine]w = 
          Delete[w, laste[w]]; \[IndentingNewLine]Append[Append[w, x], 
          v]\[IndentingNewLine]]\)], "Input"],

Cell["add e after last, take from last", "Text"],

Cell[BoxData[
    \(rcorrect[e_] := 
      Module[{l, v, w}, \[IndentingNewLine]w = 
          Delete[e, laste[e]]; \[IndentingNewLine]rnullpat[
          Append[w, {1}]]\[IndentingNewLine]]\)], "Input"],

Cell["this appears to take 1 e but add 2 e - test before using it", "Text"],

Cell[BoxData[
    \(rcorrect2[e_] := 
      Module[{l, v, w}, \[IndentingNewLine]w = 
          Delete[e, laste[e]]; \[IndentingNewLine]w = 
          Delete[w, laste[w]]; \[IndentingNewLine]rnullpat[
          Append[w, {{1, 1}}]]\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(rcorrect2[felementsNa[\([90]\)]] \[Equal] 
      correct[rcorrect[felementsNa[\([90]\)]]]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(correctlistb[v_, f_] := 
      Module[{n, an, i}, \[IndentingNewLine]n = Length[v]; 
        i = 0; \[IndentingNewLine]While[\(++i\) \[LessEqual] 
            n, \[IndentingNewLine]an = AtomicNumber[v[\([i]\)]]; 
          felements[\([an]\)] = 
            f[felements[\([an]\)]]; \[IndentingNewLine]elements[\([an]\)] = 
            ford2ord[
              felements[\([an]\)]];\[IndentingNewLine]]; \[IndentingNewLine]v\
\  (*\ allow\ nesting\ *) \[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(correctlist[v_] := correctlistb[v, correct]\)], "Input"],

Cell[BoxData[
    \(correctlist2[v_] := correctlistb[v, correct2]\)], "Input"],

Cell[BoxData[
    \(rcorrectlist[v_] := correctlistb[v, rcorrect]\)], "Input"],

Cell[BoxData[
    \(rcorrectlist2[v_] := correctlistb[v, rcorrect2]\)], "Input"],

Cell["preffered", "Text"],

Cell[BoxData[
    \(rcorrectlist2[v_] := \((correctlistb[v, rcorrect]; 
        correctlistb[v, correct])\)\)], "Input"],

Cell[BoxData[
    \(correctlist2x[v_] := correctlist[correctlist[v]]\)], "Input"],

Cell[BoxData[
    \(correctlist2x[v_] := \((correctlist[v]; correctlist[v])\)\)], "Input"],

Cell[BoxData[
    \(correctlist2x2[v_] := correctlist2[correctlist2[v]]\)], "Input"],

Cell[BoxData[
    \(correctlist2x2[v_] := \((correctlist2[v]; correctlist2[v])\)\)], "Input"],

Cell[BoxData[
    \(correct2x[v_] := correct[correct[v]]\)], "Input"],

Cell[BoxData[
    \(correct2x2[v_] := correct2[correct2[v]]\)], "Input"],

Cell["quick test rcorrect before overwriting corrections", "Text"],

Cell[BoxData[
    \(\(rcorrect[felements[\([AtomicNumber[Cm]]\)]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(showfe[%]\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "\<\"s\"\>", \({1, 1}\)},
            {"2", "\<\"s\"\>", \({1, 1}\)},
            {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"3", "\<\"s\"\>", \({1, 1}\)},
            {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"4", "\<\"s\"\>", \({1, 1}\)},
            {"3", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"5", "\<\"s\"\>", \({1, 1}\)},
            {"4", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"5", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"6", "\<\"s\"\>", \({1, 1}\)},
            {
              "4", "\<\"f\"\>", \({{1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 
                  1}}\)},
            {"5", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"6", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"7", "\<\"s\"\>", \({1, 1}\)},
            {"5", "\<\"f\"\>", \({{1, 1, 1, 1, 1, 1, 1}}\)},
            {"6", "\<\"d\"\>", \({1}\)}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell["\<\
ACTUALLY CORRECT felements and elements
\tcorrect list ended up a pain in the butt but is easier to read ...\
\>", \
"Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(correctlist[{Cr, Cu, Nb, Mo, Tc, Ru, Rh, Ag}]\)], "Input"],

Cell[BoxData[
    \({Cr, Cu, Nb, Mo, Tc, Ru, Rh, Ag}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(correctlist2x[{Pd}]\)], "Input"],

Cell[BoxData[
    \({Pd}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(rcorrectlist[{La, Gd, Ac, Pa, U, Np, Cm}]\)], "Input"],

Cell[BoxData[
    \({La, Gd, Ac, Pa, U, Np, Cm}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(correctlist2x2[{Ir}]\)], "Input"],

Cell[BoxData[
    \({Ir}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(correctlist2[{Pt, Au}]\)], "Input"],

Cell[BoxData[
    \({Pt, Au}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(rcorrectlist2[{Th}]\)], "Input"],

Cell[BoxData[
    \({Th}\)], "Output"]
}, Closed]],

Cell["\<\
tell us which elem gets which correction (used as lookup later to \
show config)\
\>", "Text"],

Cell[BoxData[
    \(\(correctarr = {{"\<Cr\>", correct}, {"\<Cu\>", correct}, {"\<Nb\>", 
            correct}, {"\<Mo\>", correct}, {"\<Tc\>", correct}, {"\<Ru\>", 
            correct}, {"\<Rh\>", correct}, {"\<Ag\>", correct}, {"\<Pd\>", 
            correct2x}, {"\<La\>", rcorrect}, {"\<Gd\>", 
            rcorrect}, {"\<Ac\>", rcorrect}, {"\<Pa\>", rcorrect}, {"\<U\>", 
            rcorrect}, {"\<Np\>", rcorrect}, {"\<Cm\>", rcorrect}, {"\<Ir\>", 
            correct2x2}, {"\<Pt\>", correct2}, {"\<Au\>", 
            correct2}, {"\<Th\>", rcorrect2}};\)\)], "Input"],

Cell[BoxData[
    \(correction[an_] := 
      Module[{p, s}, \[IndentingNewLine]s = 
          Abbreviation[an]; \[IndentingNewLine]p = 
          Position[correctarr, {ToString[s], _}]; \[IndentingNewLine]If[
          p =!= {}, \(correctarr[\([p[\([1]\)]]\)]\)[\([1, 
              2]\)], {}]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ correction[e_, an_] := 
        Module[{f}, \[IndentingNewLine]f = correction[an]; 
            f[e]]\ useless\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(correction[Ac]\)], "Input"],

Cell[BoxData[
    \(rcorrect\)], "Output"]
}, Closed]],

Cell["as is Use: Apply[correction[Ac], elem]", "Text"],

Cell["note: no data on Uuu or Uub", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(showe[Uun]\)], "Input"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {"1", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"3", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"3", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"4", "\<\"s\"\>", \({1, 1}\)},
              {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"4", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {
                "4", "\<\"f\"\>", \({{1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 
                    1, 1}}\)},
              {"5", "\<\"s\"\>", \({1, 1}\)},
              {"5", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"5", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {
                "5", "\<\"f\"\>", \({{1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 
                    1, 1}}\)},
              {"6", "\<\"s\"\>", \({1, 1}\)},
              {"6", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"6", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1}}\)},
              {"7", "\<\"s\"\>", \({1, 1}\)}
              }], "\[NoBreak]", ")"}],
        (MatrixForm[ #]&)],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ElectronConfigurationFormat[Uuu]\)], "Input"],

Cell[BoxData[
    \(Unknown\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ElectronConfiguration[Uun]\)], "Input"],

Cell[BoxData[
    \({{2}, {2, 6}, {2, 6, 10}, {2, 6, 10, 14}, {2, 6, 10, 14}, {2, 6, 
        8}, {2}}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(AtomicNumber[Ir]\)], "Input"],

Cell[BoxData[
    \(77\)], "Output"]
}, Closed]],

Cell["Keep a close eye on double corrected elems like Ir.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ElectronConfigurationFormat[Ir]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"1\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"2\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"2\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"3\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"3\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\"3\"\>", 
        "\[InvisibleSpace]", "\<\"d\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^10\),
          Superscript[ 10],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"4\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"4\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\"4\"\>", 
        "\[InvisibleSpace]", "\<\"d\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^10\),
          Superscript[ 10],
          Editable->False], "\[InvisibleSpace]", "\<\"4\"\>", 
        "\[InvisibleSpace]", "\<\"f\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^14\),
          Superscript[ 14],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"5\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"5\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\"5\"\>", 
        "\[InvisibleSpace]", "\<\"d\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^7\),
          Superscript[ 7],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"6\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False]}],
      SequenceForm[ "1", "s", 
        Superscript[ 2], " ", "2", "s", 
        Superscript[ 2], "2", "p", 
        Superscript[ 6], " ", "3", "s", 
        Superscript[ 2], "3", "p", 
        Superscript[ 6], "3", "d", 
        Superscript[ 10], " ", "4", "s", 
        Superscript[ 2], "4", "p", 
        Superscript[ 6], "4", "d", 
        Superscript[ 10], "4", "f", 
        Superscript[ 14], " ", "5", "s", 
        Superscript[ 2], "5", "p", 
        Superscript[ 6], "5", "d", 
        Superscript[ 7], " ", "6", "s", 
        Superscript[ 2]],
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(showe[Ir]\)], "Input"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {"1", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"3", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"3", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"4", "\<\"s\"\>", \({1, 1}\)},
              {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"4", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {
                "4", "\<\"f\"\>", \({{1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 
                    1, 1}}\)},
              {"5", "\<\"s\"\>", \({1, 1}\)},
              {"5", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"5", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1}}\)},
              {"6", "\<\"s\"\>", \({}\)}
              }], "\[NoBreak]", ")"}],
        (MatrixForm[ #]&)],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(showfe[Ir]\)], "Input"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {"1", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"3", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"4", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"5", "\<\"s\"\>", \({1, 1}\)},
              {"4", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"5", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"6", "\<\"s\"\>", \({}\)},
              {
                "4", "\<\"f\"\>", \({{1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 
                    1, 1}}\)},
              {"5", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1}}\)}
              }], "\[NoBreak]", ")"}],
        (MatrixForm[ #]&)],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(showe[felementsNa[\([77]\)]]\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "\<\"s\"\>", \({1, 1}\)},
            {"2", "\<\"s\"\>", \({1, 1}\)},
            {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"3", "\<\"s\"\>", \({1, 1}\)},
            {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"3", "\<\"d\"\>", \({1, 1}\)},
            {"4", "\<\"s\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"4", "\<\"d\"\>", \({1, 1}\)},
            {"4", "\<\"f\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"5", "\<\"s\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"5", "\<\"p\"\>", \({1, 1}\)},
            {
              "5", "\<\"d\"\>", \({{1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 
                  1}}\)},
            {"6", "\<\"s\"\>", \({{1, 1, 1, 1, 1}, {1, 1}}\)}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["elecfmtv - printing electron conf. from arrays", "Subsubsection"],

Cell[TextData[{
  "IMPORTANT:  DO NOT USE   elecfmt[List] OR elecfmtv[List]  with  elements[] \
 USE ONLY  felements[].  (see examples, List is for fill order only, Symbol \
goes by ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s array from chem.m)"
}], "Text"],

Cell["\<\
this uses mathematica's array to show electronconfig
\t* it does not yet work for 1's format
\t\t? why not use this to make the 1's output ?
\t\t** see section above
\t* it's formatting is more appropriate later use w/ Boxes\
\>", "Text"],

Cell[TextData[{
  "origional order / shell order (uses ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s array)"
}], "Text"],

Cell[BoxData[
    \(elecfmtv[elem_Symbol] := 
      Module[{I, i, j}, 
        I = ElectronConfiguration[elem]; \[IndentingNewLine]Partition[
          Flatten[\[IndentingNewLine]Table[
              Table[\[IndentingNewLine]{i, asubshells[\([j]\)], 
                  I[\([i, j]\)]}, \[IndentingNewLine]{j, 1, 
                  Length[I[\([i]\)]]}\[IndentingNewLine]], {i, 1, 
                Length[I]}\[IndentingNewLine]]], 3]]\)], "Input"],

Cell["fill order / uses felements", "Text"],

Cell[BoxData[
    \(elecfmtv[e_List] := 
      Module[{i, n}, \[IndentingNewLine]n = 
          Length[e]; \[IndentingNewLine]Partition[
          Flatten[\[IndentingNewLine]Table[\[IndentingNewLine]{fnord[\([i]\)],\
 fcord[\([i]\)], Length[Flatten[e[\([i]\)]]]}\[IndentingNewLine], {i, 1, 
                n}\[IndentingNewLine]]], 3]]\)], "Input"],

Cell["add irregularities indication if Element is 2nd parameter", "Text"],

Cell["\<\
correct:\t \tadd e to last , take from next to last
correct2x:\tadd e to last , take from next to last, done twice
correct2:\tadd e to last , take from 2 before last
correct2x2:\tadd e to last , take from 2 before last, done twice
rcorrect: \tadd e after last, take from last
rcorrect2: \tadd e after last, take from last, add e to last take from last \
(correct)\
\>", "Text"],

Cell[BoxData[
    \(elecfmtv[e_List, an_Symbol] := 
      Module[{i, n, c, cc}, \[IndentingNewLine]n = 
          Length[e]; \[IndentingNewLine]cc = 
          correction[an]; \[IndentingNewLine]Partition[
          Flatten[\[IndentingNewLine]Table[\[IndentingNewLine]\
\[IndentingNewLine]c = cc; \[IndentingNewLine]If[
                c =!= {}, \[IndentingNewLine]If[
                  c \[Equal] correct && i \[Equal] n, 
                  c = "\<+\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct && i \[Equal] n - 1, 
                  c = "\<-\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x && i \[Equal] n, 
                  c = "\<++\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x && i \[Equal] n - 1, 
                  c = "\<--\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2 && i \[Equal] n, 
                  c = "\<+\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2 && i \[Equal] n - 2, 
                  c = "\<-\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x2 && i \[Equal] n, 
                  c = "\<++\>"]; \[IndentingNewLine]If[
                  c \[Equal] correct2x2 && i \[Equal] n - 2, 
                  c = "\<--\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect && i \[Equal] n, 
                  c = "\<+\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect && i \[Equal] n - 1, 
                  c = "\<-\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect2 && i \[Equal] n, 
                  c = "\<++\>"]; \[IndentingNewLine]If[
                  c \[Equal] rcorrect2 && i \[Equal] n - 1, 
                  c = "\<--\>"]; \[IndentingNewLine]\[IndentingNewLine]If[
                  c \[Equal] correct || c \[Equal] correct2x || 
                    c \[Equal] rcorrect || c \[Equal] rcorrect2 || 
                    c \[Equal] correct2 || c \[Equal] correct2x2, 
                  c = {}];\[IndentingNewLine]]; \[IndentingNewLine]If[
                c =!= {}, \[IndentingNewLine]{fnord[\([i]\)], fcord[\([i]\)], 
                  Length[Flatten[e[\([i]\)]]], 
                  c}, \[IndentingNewLine]{fnord[\([i]\)], fcord[\([i]\)], 
                  Length[Flatten[
                      e[\([i]\)]]], "\<\>"}\[IndentingNewLine]]\
\[IndentingNewLine], {i, 1, n}\[IndentingNewLine]]], 4]]\)], "Input"],

Cell["\<\
unused for charts.  The text of.  Difficult to use to make 2D text \
with: it will pre-evaluate and remove essentials with, ie, \
ToExpression.\
\>", "Text"],

Cell[BoxData[
    \(elecfmt[e_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> "\<\>" <> \[IndentingNewLine]ToString[
              x[\([i, 2]\)]] <> "\<^\>" <> \[IndentingNewLine]ToString[
              x[\([i, 3]\)]]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(elecfmt[e_, an_Symbol] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e, an]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> "\<\>" <> \[IndentingNewLine]ToString[
              x[\([i, 2]\)]] <> "\<^\>" <> \[IndentingNewLine]ToString[
              x[\([i, 3]\)]] <> "\< \>" <> 
            x[\([i, 4]\)]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[TextData[{
  "specific to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Text"],

Cell[BoxData[
    \(elecfmtm[e_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> "\<\!\(\>" <> \[IndentingNewLine]ToString[
              x[\([i, 2]\)]] <> "\<\^\>" <> \[IndentingNewLine]ToString[
              x[\([i, 3]\)]] <> "\<\)\>"\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell["uses extra boxing wrap to keep \"++\"  with exp", "Text"],

Cell[BoxData[
    \(elecfmtm[e_, an_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e, an]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]ToString[
              x[\([i, 1]\)]]\  <> \[IndentingNewLine]"\<\!\(\>" <> 
            ToString[x[\([i, 2]\)]]\[IndentingNewLine] <> "\<\^\(\>" <> 
            ToString[x[\([i, 3]\)]] <> 
            x[\([i, 4]\)]\[IndentingNewLine] <> \
"\<\)\)\>"\[IndentingNewLine], {i, 1, len}\[IndentingNewLine]]]\)], "Input"],

Cell[TextData[{
  "less specific to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"]
}], "Text"],

Cell[BoxData[
    \(elecfmtb[e_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]RowBox[{ToString[
                x[\([i, 1]\)]], "\< \>", 
              SuperscriptBox[ToString[x[\([i, 2]\)]], 
                ToString[x[\([i, 3]\)]]]}]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtb[e_, an_] := 
      Module[{x, s, p, d, f, len, v}, 
        x = 0; \[IndentingNewLine]x = elecfmtv[e, an]; 
        len = Length[
            x]; \[IndentingNewLine]Table[\[IndentingNewLine]RowBox[{ToString[
                x[\([i, 1]\)]], "\< \>", 
              SuperscriptBox[ToString[x[\([i, 2]\)]], 
                ToString[x[\([i, 3]\)]]\  <> 
                  x[\([i, 4]\)]\ \ ]}]\[IndentingNewLine], {i, 1, 
            len}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpb[
        e_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtb[e], "\< \>"]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpb[e_, 
        an_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtb[e, an], "\< \>"]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpm[
        e_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtm[e], "\< \>"]]]\)], "Input"],

Cell[BoxData[
    \(elecfmtpm[e_, 
        an_] := \[IndentingNewLine]SequenceForm[\[IndentingNewLine]Sequence @@ 
          Flatten[ToEach[elecfmtm[e, an], "\< \>"]]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmt[Lanthanum]\)], "Input"],

Cell[BoxData[
    \({"1s^2", "2s^2", "2p^6", "3s^2", "3p^6", "3d^10", "4s^2", "4p^6", 
      "4d^10", "5s^2", "5p^6", "5d^1", "6s^2"}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmt[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell[BoxData[
    \({"1s^2", "2s^2", "2p^6", "3s^2", "3p^6", "4s^2", "3d^10", "4p^6", 
      "5s^2", "4d^10", "5p^6", "6s^2", "4f^0", "5d^1"}\)], "Output"]
}, Closed]],

Cell["\<\
IMPORTANT:  DO NOT USE   elecfmt[List] OR elecfmtv[List]  with  \
elements[]  USE ONLY  felements[].  (see examples)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(elecfmt[elements[\([AtomicNumber[Lanthanum]]\)]]\)\(\ \)\( (*\ 
      WRONG\ *) \)\)\)], "Input"],

Cell[BoxData[
    \({"1s^2", "2s^2", "2p^6", "3s^2", "3p^6", "4s^10", "3d^2", "4p^6", 
      "5s^10", "4d^0", "5p^2", "6s^6", "4f^1", "5d^2"}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(elecfmtv[elements[\([AtomicNumber[Lanthanum]]\)]]\)\( (*\ 
      WRONG\ *) \)\)\)], "Input"],

Cell[BoxData[
    \({{1, "s", 2}, {2, "s", 2}, {2, "p", 6}, {3, "s", 2}, {3, "p", 6}, {4, 
        "s", 10}, {3, "d", 2}, {4, "p", 6}, {5, "s", 10}, {4, "d", 0}, {5, 
        "p", 2}, {6, "s", 6}, {4, "f", 1}, {5, "d", 2}}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmtb[felements[\([AtomicNumber[Lanthanum]]\)]] // 
      DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[\({1\ s\^2, 2\ s\^2, 2\ p\^6, 3\ s\^2, 3\ p\^6, 4\ s\^2, 3\ d\^10, 
        4\ p\^6, 5\ s\^2, 4\ d\^10, 5\ p\^6, 6\ s\^2, 4\ f\^0, 5\ d\^1}\),
      DisplayForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmtm[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell[BoxData[
    \({"1\!\(s\^2\)", "2\!\(s\^2\)", "2\!\(p\^6\)", "3\!\(s\^2\)", 
      "3\!\(p\^6\)", "4\!\(s\^2\)", "3\!\(d\^10\)", "4\!\(p\^6\)", 
      "5\!\(s\^2\)", "4\!\(d\^10\)", "5\!\(p\^6\)", "6\!\(s\^2\)", 
      "4\!\(f\^0\)", "5\!\(d\^1\)"}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmtpm[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\("1\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"2\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"2\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"3\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"3\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"4\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"3\!\(d\^10\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"4\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"5\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"4\!\(d\^10\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"5\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"6\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"4\!\(f\^0\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"5\!\(d\^1\)"\[InvisibleSpace]" "\),
      SequenceForm[ 
      "1\!\(s\^2\)", " ", "2\!\(s\^2\)", " ", "2\!\(p\^6\)", " ", 
        "3\!\(s\^2\)", " ", "3\!\(p\^6\)", " ", "4\!\(s\^2\)", " ", 
        "3\!\(d\^10\)", " ", "4\!\(p\^6\)", " ", "5\!\(s\^2\)", " ", 
        "4\!\(d\^10\)", " ", "5\!\(p\^6\)", " ", "6\!\(s\^2\)", " ", 
        "4\!\(f\^0\)", " ", "5\!\(d\^1\)", " "],
      Editable->False]], "Output"]
}, Closed]],

Cell[TextData[{
  "FIXME / OOPS - note how ",
  StyleBox["Mathematica's",
    FontSlant->"Italic"],
  " array omitts 4f^0.  but fixing it might pooch their modules.  it's a \
preference thing anyhow."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmtpm[Lanthanum]\)], "Input"],

Cell[BoxData[
    InterpretationBox[\("1\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"2\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"2\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"3\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"3\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"3\!\(d\^10\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"4\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"4\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"4\!\(d\^10\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"5\!\(s\^2\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"5\!\(p\^6\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"5\!\(d\^1\)"\[InvisibleSpace]" \
"\[InvisibleSpace]"6\!\(s\^2\)"\[InvisibleSpace]" "\),
      SequenceForm[ 
      "1\!\(s\^2\)", " ", "2\!\(s\^2\)", " ", "2\!\(p\^6\)", " ", 
        "3\!\(s\^2\)", " ", "3\!\(p\^6\)", " ", "3\!\(d\^10\)", " ", 
        "4\!\(s\^2\)", " ", "4\!\(p\^6\)", " ", "4\!\(d\^10\)", " ", 
        "5\!\(s\^2\)", " ", "5\!\(p\^6\)", " ", "5\!\(d\^1\)", " ", 
        "6\!\(s\^2\)", " "],
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ElectronConfiguration[Lanthanum]\)], "Input"],

Cell[BoxData[
    \({{2}, {2, 6}, {2, 6, 10}, {2, 6, 10}, {2, 6, 1}, {2}}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmtpb[felements[\([AtomicNumber[Lanthanum]]\)]] // 
      DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[
      InterpretationBox[\(\(1\ s\^2\)\[InvisibleSpace]" "\[InvisibleSpace]\(2\
\ s\^2\)\[InvisibleSpace]" "\[InvisibleSpace]\(2\ p\^6\)\[InvisibleSpace]" "\
\[InvisibleSpace]\(3\ s\^2\)\[InvisibleSpace]" "\[InvisibleSpace]\(3\ p\^6\)\
\[InvisibleSpace]" "\[InvisibleSpace]\(4\ s\^2\)\[InvisibleSpace]" "\
\[InvisibleSpace]\(3\ d\^10\)\[InvisibleSpace]" "\[InvisibleSpace]\(4\ p\^6\)\
\[InvisibleSpace]" "\[InvisibleSpace]\(5\ s\^2\)\[InvisibleSpace]" "\
\[InvisibleSpace]\(4\ d\^10\)\[InvisibleSpace]" "\[InvisibleSpace]\(5\ p\^6\)\
\[InvisibleSpace]" "\[InvisibleSpace]\(6\ s\^2\)\[InvisibleSpace]" "\
\[InvisibleSpace]\(4\ f\^0\)\[InvisibleSpace]" "\[InvisibleSpace]\(5\ d\^1\)\
\[InvisibleSpace]" "\),
        SequenceForm[ 
          RowBox[ {"1", " ", 
            SuperscriptBox[ "s", "2"]}], " ", 
          RowBox[ {"2", " ", 
            SuperscriptBox[ "s", "2"]}], " ", 
          RowBox[ {"2", " ", 
            SuperscriptBox[ "p", "6"]}], " ", 
          RowBox[ {"3", " ", 
            SuperscriptBox[ "s", "2"]}], " ", 
          RowBox[ {"3", " ", 
            SuperscriptBox[ "p", "6"]}], " ", 
          RowBox[ {"4", " ", 
            SuperscriptBox[ "s", "2"]}], " ", 
          RowBox[ {"3", " ", 
            SuperscriptBox[ "d", "10"]}], " ", 
          RowBox[ {"4", " ", 
            SuperscriptBox[ "p", "6"]}], " ", 
          RowBox[ {"5", " ", 
            SuperscriptBox[ "s", "2"]}], " ", 
          RowBox[ {"4", " ", 
            SuperscriptBox[ "d", "10"]}], " ", 
          RowBox[ {"5", " ", 
            SuperscriptBox[ "p", "6"]}], " ", 
          RowBox[ {"6", " ", 
            SuperscriptBox[ "s", "2"]}], " ", 
          RowBox[ {"4", " ", 
            SuperscriptBox[ "f", "0"]}], " ", 
          RowBox[ {"5", " ", 
            SuperscriptBox[ "d", "1"]}], " "],
        Editable->False],
      DisplayForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToBoxes[\(elecfmtm[
          felements[\([AtomicNumber[Lanthanum]]\)]]\)[\([1]\)]]\)], "Input"],

Cell[BoxData[
    \("\"1\\!\\(s\\^2\\)\""\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ToBoxes[\*"\"\<1\!\(s\^0\)\>\""]\)], "Input"],

Cell[BoxData[
    \("\"1\\!\\(s\\^0\\)\""\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ElectronConfigurationFormat[Lanthanum]\)], "Input"],

Cell[BoxData[
    InterpretationBox[
      RowBox[{"\<\"1\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"2\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"2\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"3\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"3\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\"3\"\>", 
        "\[InvisibleSpace]", "\<\"d\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^10\),
          Superscript[ 10],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"4\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"4\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\"4\"\>", 
        "\[InvisibleSpace]", "\<\"d\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^10\),
          Superscript[ 10],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"5\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False], "\[InvisibleSpace]", "\<\"5\"\>", 
        "\[InvisibleSpace]", "\<\"p\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^6\),
          Superscript[ 6],
          Editable->False], "\[InvisibleSpace]", "\<\"5\"\>", 
        "\[InvisibleSpace]", "\<\"d\"\>", "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^1\),
          Superscript[ 1],
          Editable->False], "\[InvisibleSpace]", "\<\" \"\>", 
        "\[InvisibleSpace]", "\<\"6\"\>", "\[InvisibleSpace]", "\<\"s\"\>", 
        "\[InvisibleSpace]", 
        InterpretationBox[\(\[Null]\^2\),
          Superscript[ 2],
          Editable->False]}],
      SequenceForm[ "1", "s", 
        Superscript[ 2], " ", "2", "s", 
        Superscript[ 2], "2", "p", 
        Superscript[ 6], " ", "3", "s", 
        Superscript[ 2], "3", "p", 
        Superscript[ 6], "3", "d", 
        Superscript[ 10], " ", "4", "s", 
        Superscript[ 2], "4", "p", 
        Superscript[ 6], "4", "d", 
        Superscript[ 10], " ", "5", "s", 
        Superscript[ 2], "5", "p", 
        Superscript[ 6], "5", "d", 
        Superscript[ 1], " ", "6", "s", 
        Superscript[ 2]],
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmt[La]\)], "Input"],

Cell[BoxData[
    \({"1s^2", "2s^2", "2p^6", "3s^2", "3p^6", "3d^10", "4s^2", "4p^6", 
      "4d^10", "5s^2", "5p^6", "5d^1", "6s^2"}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(elecfmt[felements[\([AtomicNumber[Lanthanum]]\)]]\)], "Input"],

Cell[BoxData[
    \({"1s^2", "2s^2", "2p^6", "3s^2", "3p^6", "4s^2", "3d^10", "4p^6", 
      "5s^2", "4d^10", "5p^6", "6s^2", "4f^0", "5d^1"}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(showe[felements[\([AtomicNumber[Lanthanum]]\)]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(showfe[Lanthanum]\)], "Input"],

Cell[BoxData[
    TagBox[
      TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
              {"1", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"s\"\>", \({1, 1}\)},
              {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"3", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"4", "\<\"s\"\>", \({1, 1}\)},
              {"3", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"5", "\<\"s\"\>", \({1, 1}\)},
              {"4", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
              {"5", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
              {"6", "\<\"s\"\>", \({1, 1}\)},
              {"4", "\<\"f\"\>", \({{}}\)},
              {"5", "\<\"d\"\>", \({1}\)}
              }], "\[NoBreak]", ")"}],
        (MatrixForm[ #]&)],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell[TextData[{
  "Assume 1's aren't needed to be generated or on chart anywhere ,\nAssume \
wish to move from elecfmtv to fill order same fmt.\n\tI'm LEARY there is no \
measure to check against\n\tfor fill order , due to corrections , using ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s alone\n\t\twhich is one reason I though 1s would be easier\n\ndang - \
also the sort trick above won't work for elecfmtv ...\n\tmathematic omitts {} \
... alignment\n\t... and ford2ordarr doesn't include \"corrections\" (fall \
forward / back)\nPosition might work\n\twith {} left to remove ... and NOT \
remove ?\n\t\nThat being said and 1's being done\n\n\tnew elecfmt1 is easier \
i think"
}], "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart trials - template, 2D, 3D tests", "Section"],

Cell[CellGroupData[{

Cell["trials", "Subsection"],

Cell["\<\
trials show Graphics3D is better for this task:
\t3D is harder at outset but mathematica has best support of
\t\t+ allows after-thought adding, re-scaling, anything
\tediting complex things in RTF editor ...
\t\t- seems attractive : ends up frustrating and timely too\
\>", "Text"],

Cell["chart Names into Shells by Lists length", "Text"],

Cell[BoxData[
    \(period = Table[{i}, {i, 7}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Table[\[IndentingNewLine]{\[IndentingNewLine]AppendTo[\
\[IndentingNewLine]\ period[\([shellsarr[\([i]\)]]\)], 
            Abbreviation[
              Elements[\([i]\)]]\[IndentingNewLine]]\[IndentingNewLine]}, {i, 
          Length[Elements]}\ \[IndentingNewLine] (*\ \(-2\)\ as\ eC\ is\ 0\ \
for\ 111\ and\ 112\ *) \[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Drop[period, 0, 1];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(% // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(per = Drop[period, 0, 1];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(perlens = 
        Table[Length[per[\([i]\)]], {i, 1, Length[per]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(mw = 
        Max[Table[Length[per[\([i]\)]], {i, 1, Length[per]}]];\)\)], "Input",
  Evaluatable->False],

Cell["\<\
Start with periodic which is already laid out by period.  Also \
Insert to spread right.\
\>", "Text"],

Cell[BoxData[
    \(\(ch2 = 
        Module[{gap, h, w, j, i, lst}, \[IndentingNewLine]ch1 = 
            per; \[IndentingNewLine]h = 
            Length[ch1]; \[IndentingNewLine]Table[\[IndentingNewLine]gap = 
              mw - perlens[\([i]\)]; \[IndentingNewLine]w = 
              mw - gap; \[IndentingNewLine]lst = 
              Table["\<\[CenterDot]\>", {j, 1, 
                  gap}]; \[IndentingNewLine]Flatten[\[IndentingNewLine]If[
                gap \[NotEqual] 0, \[IndentingNewLine]Insert[ch1[\([i]\)], 
                  lst, If[i > 1, 1, 0] + 
                    2], \[IndentingNewLine]ch1[\([i]\)]\[IndentingNewLine]]]\
\[IndentingNewLine], {i, 1, h}\[IndentingNewLine]]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(StyleBox["\<bob\>", FontWeight \[Rule] "\<Bold\>"]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch3 = ch2; 
    Table[\[IndentingNewLine]Table[\[IndentingNewLine]DisplayForm[\
\[IndentingNewLine]StyleBox[ch3[\([i, j]\)], 
            FontWeight \[Rule] "\<Bold\>"]\[IndentingNewLine]]\
\[IndentingNewLine], {j, 1, 
          Length[ch3[\([i]\)]]}\[IndentingNewLine]]\[IndentingNewLine], {i, 
        1, Length[ch3]}\[IndentingNewLine]];\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch3 = %;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch3[\([1, 1]\)]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(% // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Append[ch3, 
        Table[If[i \[LessEqual] 16, "\<-\>", "\<+\>"], {i, 1, mw}]] // 
      MatrixForm\)], "Input",
  Evaluatable->False],

Cell["\<\
Can use Take at 7,3 8,3 for (Lanthanum/Actinum) for \"lanthanide \
actinide series\"\
\>", "Text"],

Cell["Dang - there's a bad problem.  See below (below chart).", "Text"],

Cell[BoxData[
    \(Append[%, \[IndentingNewLine]Table[\[IndentingNewLine]Take[\
\[IndentingNewLine]elecfmtpm[\[IndentingNewLine]Elements[\([\(Position[
                      Abbreviation[Elements], ch1[\([6, i]\)]]\)[\([1, 
                      1]\)]]\)]\[IndentingNewLine]]\[IndentingNewLine], \
\(-4\)]\[IndentingNewLine], {i, 1, 
            mw}\[IndentingNewLine]]\[IndentingNewLine]] // 
      MatrixForm\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell[TextData[{
  "***************\nnothing \"easy\" from here maybe\n\nwith boxes:\n\t\
perfect result\n\tcan use simple editor\n\t\tHOWEVER editing is difficult\n\t\
\tand limited to limited rules conflicting with goal\n\tkerned\nwith boxes \
you have to have to build up or hack away\n\n\t(wrong , try again)\n\t",
  Cell[BoxData[
      \(Append[ch3[\([1, 1]\)], "\<bob\>"]\)], "Input"],
  "\n\t",
  Cell[BoxData[
      \(DisplayForm[
        StyleBox["H", \[IndentingNewLine]FontWeight \[Rule] "Bold"], 
        "bob"]\)], "Output"]
}], "Text"],

Cell["\<\
with graphics
\tperfection only if you hit on the right method you don't know

\t* 4 main \"paths\"
\t\tgraphics array
\t\t\teasy for 32x7
\t\t\t\"CANNOT BE COMBINED WITH
\t\t\t~Graphics~\"\t\t\t
\t\tarray of 2D graphics
\t\t3D graphics
\t\tShow combines 2D and 3D
\t* if you go by unit you must
\t\t0) no one can use editor / (is ps, maybe not svg ?)
\t\t1a) task of positioning units
\t\t1b) units get hard-coded , task of scaling each
\t\t3) loose any relations between blocks
\t\t\tie, cannot set property that applies to all\
\>", "Text"],

Cell["\<\
\t* gr needs vert as :
\t\teach item (each text, each pos, a matrix )
\t\teach vert must be functions
\t\titem style must be functions
\t\t\t\"a box\"
\t\t\tcontiains placeholders
\t\t\tscaling / ops can occur

\t* 2D may NOT be easier
\t\tno way to include 3D , diff. to convert to
\t\tmore \"built in interpretations\"\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["...", "Subsubsection"],

Cell["\<\
Graphics[Text[\"H\", 
  Scaled[{0, 0.3}, 
   {0.5, 0.5}], TextStyle -> 
   {FontSize -> 16, 
    FontWeight -> \"Bold\", 
    FontSlant -> \"Italic\"}, 
  Background -> Hue[0.5]]]\
\>", "Output"],

Cell[BoxData[
    \(\(tpos = \[IndentingNewLine]Table[\[IndentingNewLine]{j, 
            i}\[IndentingNewLine], {i, 1, 7}\[IndentingNewLine], {j, 1, 
            32}\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(tpos = Partition[Flatten[tpos], 2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(txt = \[IndentingNewLine]Table[\[IndentingNewLine]ch2[\([7 - i + 1, 
              j]\)]\[IndentingNewLine], {i, 1, 7}\[IndentingNewLine], {j, 1, 
            32}\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(txt = Flatten[txt];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[{
    \(\(Remove[gtxt1];\)\), "\[IndentingNewLine]", 
    \(\(gtxt1 = Table[i, {i, 1, 2\ ELEMENTS}];\)\)}], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Module[{i}, \[IndentingNewLine]i = 
        0; \[IndentingNewLine]While[\(++i\) \[LessEqual] 
          2\ ELEMENTS, \[IndentingNewLine]\(gtxt1[\([i]\)] = 
            Graphics[\[IndentingNewLine]sc = {N[1/\((1.1\ 32)\)], 
                  N[1/\((1.1\ 7)\)]}; \[IndentingNewLine]Text[\
\[IndentingNewLine]txt[\([i]\)]\[IndentingNewLine] (*\(,\)\(Scaled[
                    sc*tpos[\([i]\)], { .01,  .01}]\)*) \[IndentingNewLine] \
(*\ \(,\)\(r[{0.015, \(- .01\)} + 
                      sc*tpos[\([i]\)]]\)\ *) \[IndentingNewLine], {0, 
                  0}\[IndentingNewLine], 
                TextStyle -> {FontSize \[Rule] 8, 
                    FontSlant \[Rule] "\<Italic\>"}, 
                Background \[Rule] 
                  Hue[ .50]\[IndentingNewLine]]\[IndentingNewLine]];\)\
\[IndentingNewLine]]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(r[n_] := Rotate2D[n, N[2  \[Pi]]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Rotate2D[{1, 1}, N[\[Pi]]]\)], "Input",
  Evaluatable->False],

Cell["\<\

***********************************************
\
\>", "Text"],

Cell[BoxData[{
    \(\(Remove[gtxt];\)\), "\[IndentingNewLine]", 
    \(\(gtxt = Table[i, {i, 1, 2\ ELEMENTS}];\)\)}], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Module[{i}, \[IndentingNewLine]i = 
        0; \[IndentingNewLine]While[\(++i\) \[LessEqual] 
          2\ ELEMENTS, \[IndentingNewLine]sc = {N[1/\((1.1\ 32)\)], 
            N[1/\((1.1\ 7)\)]}; \[IndentingNewLine]gtxt[\([i]\)] = 
          Text[\[IndentingNewLine]txt[\([i]\)]\[IndentingNewLine] \
(*\(,\)\(Scaled[sc*tpos[\([i]\)], { .01,  .01}]\)*) \[IndentingNewLine], 
            r[{ .5, \(- .5\)} + {30, i}*tpos[\([i]\)]]\[IndentingNewLine], 
            TextStyle -> {FontSize \[Rule] 8, 
                FontSlant \[Rule] "\<Italic\>"}, 
            Background \[Rule] 
              Hue[ .50]\[IndentingNewLine]]\[IndentingNewLine]]\
\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(p = 
        Graphics[\[IndentingNewLine]{\[IndentingNewLine]GrayLevel[
              0.85]\[IndentingNewLine], 
            Rectangle[\[IndentingNewLine]r[{0, 0}], 
              r[{1000, 
                  1000}]\[IndentingNewLine]]\[IndentingNewLine]}\
\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(r[n_] := Rotate2D[n, \(-N[\[Pi]/2]\)];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go = 
      Show[p, \[IndentingNewLine]Graphics[\[IndentingNewLine]Table[
            gtxt[\([i]\)], {i, 1, 2\ ELEMENTS}]\[IndentingNewLine], 
          RotateLabel \[Rule] False\[IndentingNewLine], 
          ImageSize \[Rule] {6\ 72, 4\ 72}\[IndentingNewLine], 
          ImageRotated \[Rule] False\[IndentingNewLine], 
          PlotRange \[Rule] { .5,  \
.5}\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(gtxt2 = Partition[gtxt1, 32];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(gtxt3 = Array[f, {7, 32}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(i = 0; 
    While[\(++i\) \[LessEqual] 
        7, \[IndentingNewLine]\(gtxt3[\([i]\)] = 
          gtxt2[\([7 - i + 1]\)];\)\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g5 = GraphicsArray[gtxt3]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[GraphicsArray[gtxt3]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[p, g5]\)], "Input",
  Evaluatable->False],

Cell["Scaled moves L normal units from normal coord center R", "Text"],

Cell[BoxData[
    \(\(vertices = {{0, 0}, {0, 1}, {0, 1}, {1, 0}, {1, 1}};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(p = 
        Graphics[{GrayLevel[0.85], Rectangle[{0, 0}, {1, 1}]}];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(l = 
        Graphics[{Thickness[ .02], RGBColor[0, 0, 1], 
            Line[{{0, 1}, {0, 0}, {0, 0}, {1, 0}}]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(t1 = 
      Graphics[\[IndentingNewLine]Text[\[IndentingNewLine]ch2[\([1, 
              1]\)]\[IndentingNewLine], 
          Scaled[{0,  .3}, { .5,  .5}]\[IndentingNewLine], 
          TextStyle -> {FontSize \[Rule] 16, FontWeight \[Rule] "\<Bold\>", 
              FontSlant \[Rule] "\<Italic\>"}, 
          Background \[Rule] 
            Hue[ .50]\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(InputForm[%]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(t2 = 
      Graphics[\[IndentingNewLine]Text[\[IndentingNewLine]elecfmtpm[
            H]\[IndentingNewLine], { .5,  .5}\[IndentingNewLine], 
          TextStyle -> {FontSize \[Rule] 16, FontWeight \[Rule] "\<Bold\>", 
              FontSlant \[Rule] "\<Italic\>"}, 
          Background \[Rule] 
            Automatic\[IndentingNewLine]]\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g2 = Show[t1, t2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g1 = Show[p, l];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Show[g1, g2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Show[p, l, t1, t2];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g1 = 
      Graphics3D[{\[IndentingNewLine]Cuboid[\[IndentingNewLine]Scaled[{ .5,  \
.5,  .5}]\[IndentingNewLine], 
            Scaled[{ .6,  .6,  .6}]\[IndentingNewLine]]}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g2 = 
      Graphics3D[{\[IndentingNewLine]Cuboid[\[IndentingNewLine]Scaled[{ .8,  \
.5, 0}]\[IndentingNewLine], 
            Scaled[{ .9,  .9,  .9}]\[IndentingNewLine]]}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(g3 = 
      Graphics3D[\[IndentingNewLine]{\[IndentingNewLine]Text[\
\[IndentingNewLine]"\<hi bob !\>"\[IndentingNewLine], 
            Scaled[{ .5,  .1,  .5}]\[IndentingNewLine]\[IndentingNewLine], 
            TextStyle \[Rule] \[IndentingNewLine]{FontSize \[Rule] 8, 
                FontSlant \[Rule] "\<Italic\>"}\[IndentingNewLine], 
            Background \[Rule] 
              Hue[ .50]\[IndentingNewLine]\[IndentingNewLine]]\
\[IndentingNewLine]}\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(InputForm[%]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]{Point[{0, 0, 0}], 
              Point[Scaled[{0, 0, 0}, {0, 
                    0, \(- .2\)}]]}\[IndentingNewLine], {Text["\<a point\>", 
                Scaled[{ .5,  .5,  .5}]]}\[IndentingNewLine]}];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]\[IndentingNewLine]{Line[{{0, 0, 
                    0}, {1, 0, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 1, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 0, 
                    1}}]}\[IndentingNewLine]\[IndentingNewLine]\
\[IndentingNewLine], {Line[ .95 {{0, 0, 0}, {1, 0, 
                      0}, { .95,  .1,  .1}}]}\[IndentingNewLine], {Line[ .95 \
{{0, 0, 0}, {0, 1, 
                      0}, { .1,  .95,  .1}}]}\[IndentingNewLine], {Line[ .95 \
{{0, 0, 0}, {0, 0, 
                      1}, { .1,  .1,  .95}}]}\[IndentingNewLine]\
\[IndentingNewLine]\[IndentingNewLine], {Text["\<+X1\>", 
                Scaled[{ .1,  .05,  .05},  .80 {1, 0, 
                      0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<+Y1\>", 
                Scaled[{ .01,  .1,  .01},  .80 {0, 1, 
                      0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<+Z1\>", 
                Scaled[{ .01,  .01,  .1},  .80 {0, 0, 
                      1}]]}\[IndentingNewLine]\[IndentingNewLine]\
\[IndentingNewLine], {Text["\<X0\>", 
                Scaled[{ .01,  .01,  .01}, { .1, 0, 
                    0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<Y0\>", 
                Scaled[{ .01,  .01,  .01}, {0,  .1, 
                    0}]]}\[IndentingNewLine]\[IndentingNewLine], \
{Text["\<Z0\>", 
                Scaled[{ .01,  .01,  .01}, {0, 
                    0,  .1}]]}\[IndentingNewLine]\[IndentingNewLine]}\
\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[g1, g2, g3, g4]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Remove[p, l, r, g1, g2, g3, g4, g5, t1, t2, vertices, gtxt, gtxt1, 
        gtxt2, period, per, perlens, mw, ch2, ch3, tpos, txt, sc, 
        go];\)\)], "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart generation", "Subsubtitle",
  FontSize->21,
  Background->GrayLevel[0.900008]],

Cell["\<\
after any changes made re-evaluate this section (or parts of).  the \
above text charts / chem data are assume to be made.\
\>", "Text"],

Cell[CellGroupData[{

Cell["discussions", "Section"],

Cell[CellGroupData[{

Cell["Discuss / Editing Element Data Directions", "Subsubsection"],

Cell[TextData[{
  "copy and past a data item.  change it's data source.  see layout below \
(placement offset relative to center of cell).\n\nadvanced: makes template \
table , data items fill data where in chart the template has elem  and uses \
layout3 as to placement from center of cell, then use cmat (offset, rotation, \
scale) to do any \"whole chart\" translation.  legends are handled separately \
(except helpcell is made automatically)\n\nbad news is it's free form.  good \
news is it's free form.  each item is placed separately (though with helper \
fun for positions) so there are no firm rules as to what can be done. **\n\n\
The below makes 2D color, 2D black & white, 3D chart.\n\nIf there is one \
glitch in the process below (and it's turning out to be a one) it is that \
it's not easy to go between color and b&w fonts because ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " adds neer unknowable offsets for \"boxing\".  Unless you can export math \
fonts for your purpose one needs to avoid symbols: meaning one can't truely \
avoid it if \"/\" will be printed (see geninit) - and really it must be - \
which is why b&w chart was first viewed.\n\nKeep in mind the above prepares \
to provide data and below to make the chart and are completely separate \
projects per say: the 3D chart is complete hobbish due to (snip story).  \
Arguably it'd be better to have a Cell to edit which has markers where to \
assign data and program copy these.  However if that is done the 3D ability \
is ruined.  Unless one about hacks into ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " and PS boxing, kerning, etc to get per-character positions: the value of \
that is at least as highly questionable.  Maybe a good argument is to drop \
automated 3D assembling of the table of elements.  Maybe so but it is hobby \
work\n\n-----------------------------------\n\n** while it's a clunky to \
provide a position for [most/each] text  specifically - when it comes to ways \
and means to print: it means things are not jumping around and ruining graph. \
 boxing problems can be endless if you choose \"an imperfect choice\" toward \
getting a layout.  See \"Group Alias\" section for an example."
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["TODO  warnings for chart", "Subsubsection"],

Cell["\<\
check other pre-made charts above or even arrays
\tpage 2
\tdon't put (most desired) in plot but on normal page\
\>", "Text"],

Cell["trends in notes ascii or spcl arrows & text", "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["chart template ch2b - template of the periodic table", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
To make it \"doable\".  needs to be \"use or not\" able
\t*  text / data tables in 32x7 format (if not edited otherwise)
\t*  vert. in 32x7 tables (add, scaling, rot)
\t*  each data attrib , font size  font face, separately
\t*  flatten : ++ i  scanned

* use functions ... allow unexpected changes
* generic loop may reduce the above
* \"rule\" : remember Ac / La are moved later , lines later
* { x \[RightArrow] , y (into) , z \[UpArrow] }  from LL screen\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["ch2 / base", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(period = Table[{i}, {i, 7}]\)], "Input"],

Cell[BoxData[
    \({{1}, {2}, {3}, {4}, {5}, {6}, {7}}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Table[\[IndentingNewLine]{\[IndentingNewLine]AppendTo[\
\[IndentingNewLine]\ period[\([shellsarr[\([i]\)]]\)], 
            Abbreviation[
              Elements[\([i]\)]]\[IndentingNewLine]]\[IndentingNewLine]}, {i, 
          Length[Elements]}\ \[IndentingNewLine] (*\ \(-2\)\ as\ eC\ is\ 0\ \
for\ 111\ and\ 112\ *) \[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Drop[period, 0, 1];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"\<\"H\"\>", "\<\"He\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"Li\"\>", "\<\"Be\"\>", "\<\"B\"\>", "\<\"C\"\>", "\<\"N\"\>", \
"\<\"O\"\>", "\<\"F\"\>", "\<\"Ne\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\
\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"Na\"\>", "\<\"Mg\"\>", "\<\"Al\"\>", "\<\"Si\"\>", \
"\<\"P\"\>", "\<\"S\"\>", "\<\"Cl\"\>", "\<\"Ar\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"K\"\>", "\<\"Ca\"\>", "\<\"Sc\"\>", "\<\"Ti\"\>", \
"\<\"V\"\>", "\<\"Cr\"\>", "\<\"Mn\"\>", "\<\"Fe\"\>", "\<\"Co\"\>", \
"\<\"Ni\"\>", "\<\"Cu\"\>", "\<\"Zn\"\>", "\<\"Ga\"\>", "\<\"Ge\"\>", "\<\"As\
\"\>", "\<\"Se\"\>", "\<\"Br\"\>", "\<\"Kr\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"Rb\"\>", "\<\"Sr\"\>", "\<\"Y\"\>", "\<\"Zr\"\>", \
"\<\"Nb\"\>", "\<\"Mo\"\>", "\<\"Tc\"\>", "\<\"Ru\"\>", "\<\"Rh\"\>", "\<\"Pd\
\"\>", "\<\"Ag\"\>", "\<\"Cd\"\>", "\<\"In\"\>", "\<\"Sn\"\>", "\<\"Sb\"\>", \
"\<\"Te\"\>", "\<\"I\"\>", "\<\"Xe\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"\<\"Cs\"\>", "\<\"Ba\"\>", "\<\"La\"\>", "\<\"Ce\"\>", \
"\<\"Pr\"\>", "\<\"Nd\"\>", "\<\"Pm\"\>", "\<\"Sm\"\>", "\<\"Eu\"\>", "\<\"Gd\
\"\>", "\<\"Tb\"\>", "\<\"Dy\"\>", "\<\"Ho\"\>", "\<\"Er\"\>", "\<\"Tm\"\>", \
"\<\"Yb\"\>", "\<\"Lu\"\>", "\<\"Hf\"\>", "\<\"Ta\"\>", "\<\"W\"\>", \
"\<\"Re\"\>", "\<\"Os\"\>", "\<\"Ir\"\>", "\<\"Pt\"\>", "\<\"Au\"\>", "\<\"Hg\
\"\>", "\<\"Tl\"\>", "\<\"Pb\"\>", "\<\"Bi\"\>", "\<\"Po\"\>", "\<\"At\"\>", \
"\<\"Rn\"\>"},
          {"\<\"Fr\"\>", "\<\"Ra\"\>", "\<\"Ac\"\>", "\<\"Th\"\>", \
"\<\"Pa\"\>", "\<\"U\"\>", "\<\"Np\"\>", "\<\"Pu\"\>", "\<\"Am\"\>", \
"\<\"Cm\"\>", "\<\"Bk\"\>", "\<\"Cf\"\>", "\<\"Es\"\>", "\<\"Fm\"\>", "\<\"Md\
\"\>", "\<\"No\"\>", "\<\"Lr\"\>", "\<\"Rf\"\>", "\<\"Db\"\>", "\<\"Sg\"\>", \
"\<\"Bh\"\>", "\<\"Hs\"\>", "\<\"Mt\"\>", "\<\"Uun\"\>", "\<\"Uuu\"\>", \
"\<\"Uub\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{"H", "He"}, {"Li", "Be", "B", "C", "N", "O", "F", "Ne"}, {
        "Na", "Mg", "Al", "Si", "P", "S", "Cl", "Ar"}, {"K", "Ca", "Sc", "Ti",
         "V", "Cr", "Mn", "Fe", "Co", "Ni", "Cu", "Zn", "Ga", "Ge", "As", 
        "Se", "Br", "Kr"}, {"Rb", "Sr", "Y", "Zr", "Nb", "Mo", "Tc", "Ru", 
        "Rh", "Pd", "Ag", "Cd", "In", "Sn", "Sb", "Te", "I", "Xe"}, {"Cs", 
        "Ba", "La", "Ce", "Pr", "Nd", "Pm", "Sm", "Eu", "Gd", "Tb", "Dy", 
        "Ho", "Er", "Tm", "Yb", "Lu", "Hf", "Ta", "W", "Re", "Os", "Ir", "Pt",
         "Au", "Hg", "Tl", "Pb", "Bi", "Po", "At", "Rn"}, {"Fr", "Ra", "Ac", 
        "Th", "Pa", "U", "Np", "Pu", "Am", "Cm", "Bk", "Cf", "Es", "Fm", "Md",
         "No", "Lr", "Rf", "Db", "Sg", "Bh", "Hs", "Mt", "Uun", "Uuu", 
        "Uub"}}]]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(per = Drop[period, 0, 1];\)\)], "Input"],

Cell["OOPS - need full names more really...", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(periodlong = Table[{i}, {i, 7}]\)], "Input"],

Cell[BoxData[
    \({{1}, {2}, {3}, {4}, {5}, {6}, {7}}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Table[\[IndentingNewLine]{AppendTo[\[IndentingNewLine]\ 
            periodlong[\([shellsarr[\([i]\)]]\)], 
            Elements[\([i]\)]\[IndentingNewLine]]}, {i, 
          Length[Elements]}\ ];\)\)], "Input"],

Cell[BoxData[
    \(\(Drop[periodlong, 0, 1];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // TableForm\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"Hydrogen", 
            "Helium", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>"},
          {"Lithium", "Beryllium", "Boron", "Carbon", "Nitrogen", "Oxygen", 
            "Fluorine", 
            "Neon", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"},
          {"Sodium", "Magnesium", "Aluminium", "Silicon", "Phosphorus", 
            "Sulfur", "Chlorine", 
            "Argon", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"},
          {"Potassium", "Calcium", "Scandium", "Titanium", "Vanadium", 
            "Chromium", "Manganese", "Iron", "Cobalt", "Nickel", "Copper", 
            "Zinc", "Gallium", "Germanium", "Arsenic", "Selenium", "Bromine", 
            "Krypton", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"Rubidium", "Strontium", "Yttrium", "Zirconium", "Niobium", 
            "Molybdenum", "Technetium", "Ruthenium", "Rhodium", "Palladium", 
            "Silver", "Cadmium", "Indium", "Tin", "Antimony", "Tellurium", 
            "Iodine", 
            "Xenon", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {"Caesium", "Barium", "Lanthanum", "Cerium", "Praseodymium", 
            "Neodymium", "Promethium", "Samarium", "Europium", "Gadolinium", 
            "Terbium", "Dysprosium", "Holmium", "Erbium", "Thulium", 
            "Ytterbium", "Lutetium", "Hafnium", "Tantalum", "Tungsten", 
            "Rhenium", "Osmium", "Iridium", "Platinum", "Gold", "Mercury", 
            "Thallium", "Lead", "Bismuth", "Polonium", "Astatine", "Radon"},
          {"Francium", "Radium", "Actinium", "Thorium", "Protactinium", 
            "Uranium", "Neptunium", "Plutonium", "Americium", "Curium", 
            "Berkelium", "Californium", "Einsteinium", "Fermium", 
            "Mendelevium", "Nobelium", "Lawrencium", "Rutherfordium", 
            "Dubnium", "Seaborgium", "Bohrium", "Hassium", "Meitnerium", 
            "Ununnilium", "Unununium", 
            "Ununbium", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {{Hydrogen, Helium}, {Lithium, Beryllium, Boron, Carbon, 
        Nitrogen, Oxygen, Fluorine, Neon}, {Sodium, Magnesium, Aluminium, 
        Silicon, Phosphorus, Sulfur, Chlorine, Argon}, {Potassium, Calcium, 
        Scandium, Titanium, Vanadium, Chromium, Manganese, Iron, Cobalt, 
        Nickel, Copper, Zinc, Gallium, Germanium, Arsenic, Selenium, Bromine, 
        Krypton}, {Rubidium, Strontium, Yttrium, Zirconium, Niobium, 
        Molybdenum, Technetium, Ruthenium, Rhodium, Palladium, Silver, 
        Cadmium, Indium, Tin, Antimony, Tellurium, Iodine, Xenon}, {Caesium, 
        Barium, Lanthanum, Cerium, Praseodymium, Neodymium, Promethium, 
        Samarium, Europium, Gadolinium, Terbium, Dysprosium, Holmium, Erbium, 
        Thulium, Ytterbium, Lutetium, Hafnium, Tantalum, Tungsten, Rhenium, 
        Osmium, Iridium, Platinum, Gold, Mercury, Thallium, Lead, Bismuth, 
        Polonium, Astatine, Radon}, {Francium, Radium, Actinium, Thorium, 
        Protactinium, Uranium, Neptunium, Plutonium, Americium, Curium, 
        Berkelium, Californium, Einsteinium, Fermium, Mendelevium, Nobelium, 
        Lawrencium, Rutherfordium, Dubnium, Seaborgium, Bohrium, Hassium, 
        Meitnerium, Ununnilium, Unununium, Ununbium}}]]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(perlong = Drop[periodlong, 0, 1];\)\)], "Input"],

Cell[BoxData[
    \(\(perlens = 
        Table[Length[per[\([i]\)]], {i, 1, Length[per]}];\)\)], "Input"],

Cell[BoxData[
    \(\(mw = 
        Max[Table[Length[per[\([i]\)]], {i, 1, Length[per]}]];\)\)], "Input"],

Cell["\<\
Start with periodic which is already laid out by period.  Also \
Insert to spread right.\
\>", "Text"],

Cell[BoxData[
    \(\(ch2 = 
        Module[{gap, h, w, j, i, lst}, \[IndentingNewLine]ch1 = 
            per; \[IndentingNewLine]h = 
            Length[ch1]; \[IndentingNewLine]Table[\[IndentingNewLine]gap = 
              mw - perlens[\([i]\)]; \[IndentingNewLine]w = 
              mw - gap; \[IndentingNewLine]lst = 
              Table["\<\>", {j, 1, 
                  gap}]; \[IndentingNewLine]Flatten[\[IndentingNewLine]If[
                gap \[NotEqual] 0, \[IndentingNewLine]Insert[ch1[\([i]\)], 
                  lst, If[i > 1, 1, 0] + 
                    2], \[IndentingNewLine]ch1[\([i]\)]\[IndentingNewLine]]]\
\[IndentingNewLine], {i, 1, h}\[IndentingNewLine]]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ch2\  // TableForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"\<\"H\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"He\"\>"},
          {"\<\"Li\"\>", "\<\"Be\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"B\"\>", "\<\"C\"\>", "\<\"N\"\>", \
"\<\"O\"\>", "\<\"F\"\>", "\<\"Ne\"\>"},
          {"\<\"Na\"\>", "\<\"Mg\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"Al\"\>", "\<\"Si\"\>", "\<\"P\"\>", \
"\<\"S\"\>", "\<\"Cl\"\>", "\<\"Ar\"\>"},
          {"\<\"K\"\>", "\<\"Ca\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\
\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"Sc\"\>", "\<\
\"Ti\"\>", "\<\"V\"\>", "\<\"Cr\"\>", "\<\"Mn\"\>", "\<\"Fe\"\>", \
"\<\"Co\"\>", "\<\"Ni\"\>", "\<\"Cu\"\>", "\<\"Zn\"\>", "\<\"Ga\"\>", "\<\"Ge\
\"\>", "\<\"As\"\>", "\<\"Se\"\>", "\<\"Br\"\>", "\<\"Kr\"\>"},
          {"\<\"Rb\"\>", "\<\"Sr\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"Y\"\>", "\<\"Zr\"\
\>", "\<\"Nb\"\>", "\<\"Mo\"\>", "\<\"Tc\"\>", "\<\"Ru\"\>", "\<\"Rh\"\>", \
"\<\"Pd\"\>", "\<\"Ag\"\>", "\<\"Cd\"\>", "\<\"In\"\>", "\<\"Sn\"\>", "\<\"Sb\
\"\>", "\<\"Te\"\>", "\<\"I\"\>", "\<\"Xe\"\>"},
          {"\<\"Cs\"\>", "\<\"Ba\"\>", "\<\"La\"\>", "\<\"Ce\"\>", \
"\<\"Pr\"\>", "\<\"Nd\"\>", "\<\"Pm\"\>", "\<\"Sm\"\>", "\<\"Eu\"\>", "\<\"Gd\
\"\>", "\<\"Tb\"\>", "\<\"Dy\"\>", "\<\"Ho\"\>", "\<\"Er\"\>", "\<\"Tm\"\>", \
"\<\"Yb\"\>", "\<\"Lu\"\>", "\<\"Hf\"\>", "\<\"Ta\"\>", "\<\"W\"\>", \
"\<\"Re\"\>", "\<\"Os\"\>", "\<\"Ir\"\>", "\<\"Pt\"\>", "\<\"Au\"\>", "\<\"Hg\
\"\>", "\<\"Tl\"\>", "\<\"Pb\"\>", "\<\"Bi\"\>", "\<\"Po\"\>", "\<\"At\"\>", \
"\<\"Rn\"\>"},
          {"\<\"Fr\"\>", "\<\"Ra\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"Ac\"\>", "\<\"Th\"\>", "\<\"Pa\"\>", \
"\<\"U\"\>", "\<\"Np\"\>", "\<\"Pu\"\>", "\<\"Am\"\>", "\<\"Cm\"\>", \
"\<\"Bk\"\>", "\<\"Cf\"\>", "\<\"Es\"\>", "\<\"Fm\"\>", "\<\"Md\"\>", "\<\"No\
\"\>", "\<\"Lr\"\>", "\<\"Rf\"\>", "\<\"Db\"\>", "\<\"Sg\"\>", "\<\"Bh\"\>", \
"\<\"Hs\"\>", "\<\"Mt\"\>", "\<\"Uun\"\>", "\<\"Uuu\"\>", "\<\"Uub\"\>"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(ch2b = 
        Module[{gap, h, w, j, i, lst}, \[IndentingNewLine]ch1 = 
            perlong; \[IndentingNewLine]h = 
            Length[ch1]; \[IndentingNewLine]Table[\[IndentingNewLine]gap = 
              mw - perlens[\([i]\)]; \[IndentingNewLine]w = 
              mw - gap; \[IndentingNewLine]lst = 
              Table["\<\>", {j, 1, 
                  gap}]; \[IndentingNewLine]Flatten[\[IndentingNewLine]If[
                gap \[NotEqual] 0, \[IndentingNewLine]Insert[ch1[\([i]\)], 
                  lst, If[i > 1, 1, 0] + 
                    2], \[IndentingNewLine]ch1[\([i]\)]\[IndentingNewLine]]]\
\[IndentingNewLine], {i, 1, h}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(docolor = 1;\)\)], "Input"],

Cell["the chart code below assumes long names are used", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ch2b // TableForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            "Hydrogen", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "Helium"},
          {"Lithium", 
            "Beryllium", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "Boron", "Carbon", "Nitrogen", "Oxygen", "Fluorine", 
            "Neon"},
          {"Sodium", 
            "Magnesium", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "Aluminium", "Silicon", "Phosphorus", "Sulfur", "Chlorine",
             "Argon"},
          {"Potassium", 
            "Calcium", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "Scandium", "Titanium", "Vanadium",
             "Chromium", "Manganese", "Iron", "Cobalt", "Nickel", "Copper", 
            "Zinc", "Gallium", "Germanium", "Arsenic", "Selenium", "Bromine", 
            "Krypton"},
          {"Rubidium", 
            "Strontium", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", \
"\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\
\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "Yttrium", "Zirconium", "Niobium", 
            "Molybdenum", "Technetium", "Ruthenium", "Rhodium", "Palladium", 
            "Silver", "Cadmium", "Indium", "Tin", "Antimony", "Tellurium", 
            "Iodine", "Xenon"},
          {"Caesium", "Barium", "Lanthanum", "Cerium", "Praseodymium", 
            "Neodymium", "Promethium", "Samarium", "Europium", "Gadolinium", 
            "Terbium", "Dysprosium", "Holmium", "Erbium", "Thulium", 
            "Ytterbium", "Lutetium", "Hafnium", "Tantalum", "Tungsten", 
            "Rhenium", "Osmium", "Iridium", "Platinum", "Gold", "Mercury", 
            "Thallium", "Lead", "Bismuth", "Polonium", "Astatine", "Radon"},
          {"Francium", 
            "Radium", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\
\>", "\<\"\"\>", "Actinium", "Thorium", "Protactinium", "Uranium", 
            "Neptunium", "Plutonium", "Americium", "Curium", "Berkelium", 
            "Californium", "Einsteinium", "Fermium", "Mendelevium", 
            "Nobelium", "Lawrencium", "Rutherfordium", "Dubnium", 
            "Seaborgium", "Bohrium", "Hassium", "Meitnerium", "Ununnilium", 
            "Unununium", "Ununbium"}
          },
        RowSpacings->1,
        ColumnSpacings->3,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      (TableForm[ #]&)]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = Dimensions[ch2b]\)], "Input"],

Cell[BoxData[
    \({7, 32}\)], "Output"]
}, Closed]],

Cell["no clobber .ps filename", "Text"],

Cell[BoxData[
    \(\(widechart = True;\)\)], "Input"],

Cell[BoxData[
    \(\(ch2bsave = ch2b;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
(*   Optional:  Rearrange text of Table of Elements
ex. to make La / Ac series.   Mark this section as eval or non-eval.   \
*)\
\>", "Subsection",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
(* 
this secion works only for possibly col 4 min through col 16 max
\tit knows how to move around 2 rows only that is
*)\
\>", "Text"],

Cell[BoxData[
    \(\(widechart = False;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = ch2bsave;\)\)], "Input",
  Evaluatable->False],

Cell["\<\
(* see in lower / lan act series.  note things move to left 10 not \
11 *)\
\>", "Text"],

Cell[BoxData[
    \(\(groupdrop = {4, 11};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(groupdrop = {4, 10};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(groupdrop = {4, 13};\)\)], "Input",
  Evaluatable->False],

Cell["(* what to chop out of group if chart is squeezed *)", "Text"],

Cell[BoxData[
    \(\(n = Dimensions[ch2b];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(chartheight = n[\([1]\)];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(chartwidth = n[\([2]\)];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(n =. ;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch =. ; cw =. ;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch = chartheight; cw = chartwidth;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2bAlt = ch2b;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = ch2bAlt;\)\)], "Input",
  Evaluatable->False],

Cell["(* ignore , just show cell numbers we're moving down *)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Flatten[
      Table[Table[\((i - 1)\) 32 + j, {j, First[groupdrop], 
            Last[groupdrop]}], {i, 6, 7}]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \({164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 196, 197, 198, 199, 
      200, 201, 202, 203, 204, 205}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Append[{{1, 2}, {3, 4}}, {5, 6}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \({{1, 2}, {3, 4}, {5, 6}}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(ch2bAlt = ch2b;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = ch2bAlt;\)\)], "Input",
  Evaluatable->False],

Cell["\<\
(* add 3 rows at bottom of table *)
\t(* 32 across to start with , elements are const that way *)\
\>", "Text"],

Cell[BoxData[
    \(\(ch2b = Append[ch2b, Table["\<\>", {j, 32}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = Append[ch2b, Table["\<\>", {j, 32}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(ch2b = Append[ch2b, Table["\<\>", {j, 32}]];\)\)], "Input",
  Evaluatable->False],

Cell["\<\
(* copy 2 lines 3 down *)
\t(* here 6 7 refer to last two shell lines, 3 means we cp them 3 rows down \
*)\
\>", "Text"],

Cell[BoxData[
    \(Do[Do[\[IndentingNewLine]ch2b[\([i + 3, j]\)] = 
          ch2b[\([i, j]\)]; \[IndentingNewLine]ch2b[\([i, 
              j]\)] = "\<\>";\[IndentingNewLine], {j, First[groupdrop], 
          Last[groupdrop] + 1}]\[IndentingNewLine], {i, 6, 
        7}\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(ch2b[\([6 + 3, 4]\)]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Cerium\)], "Output"]
}, Closed]],

Cell["\<\
(* copy the right part of chart n spaces left (part one of moving \
left to squeeze chart in).  (could move 8 but one less, 7, is prettier it \
shows an empty cell for emphasis) *)\
\>", "Text"],

Cell[BoxData[
    \(Do[Do[\[IndentingNewLine]\(ch2b[\([i, 
                j - \((Last[groupdrop] - First[groupdrop] + 1)\)]\)] = 
            ch2b[\([i, j]\)];\)\[IndentingNewLine], {j, Last[groupdrop] + 2, 
          32}], {i, 
        1, \((Last[groupdrop] - First[groupdrop] - 1)\)}]\)], "Input",
  Evaluatable->False],

Cell["\<\
(* shows there's chaff on right to remove due to underlap / \
pinching *)\
\>", "Text"],

Cell[BoxData[
    \(ch2b // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \( (*\ Do[
        Do[\[IndentingNewLine]\(ch2b[\([i, 
                  j]\)] = "\<\>";\)\[IndentingNewLine], {j, 26, 32}], {i, 1, 
          7}]*) \)], "Input",
  Evaluatable->False],

Cell["\<\
(* this takes the chaff off left after col 32 do Copy to left - so \
as to finish a Move to left *)
\t(* 10 is number of row total == 7 old + 3 new *)\
\>", "Text"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]\(ch2b[\([i]\)] = 
          Take[ch2b[\([i]\)], 
            32 - \((Last[groupdrop] - First[groupdrop] + 
                  1)\)];\)\[IndentingNewLine], {i, 1, 10}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch2b // TableForm\)], "Input",
  Evaluatable->False],

Cell["(* ignore *)", "Text"],

Cell[BoxData[
    \(\(Flatten[
        Table[Table[\[IndentingNewLine]\((i - 1)\) 32\  + 
              j\[IndentingNewLine], {j, 12, 32}], {i, 1, 7}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Flatten[{\[IndentingNewLine]Range[0\ cw + 4, 
            0\ cw + 10 + 1], \[IndentingNewLine]Range[1\ cw + 4, 
            1\ cw + 10 + 1], \[IndentingNewLine]Range[\((ch - 1)\)\ cw + 
              4, \((ch - 1)\)\ cw + 10 + 
              1]\[IndentingNewLine]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Flatten[{\[IndentingNewLine]Range[0\ cw + 12, 
            1\ cw + cw], \[IndentingNewLine]Range[1\ cw + 12, 
            2\ cw + cw], \[IndentingNewLine]Range[2\ cw + 12, 
            3\ cw + cw], \[IndentingNewLine]Range[3\ cw + 12, 
            4\ cw + cw], \[IndentingNewLine]Range[4\ cw + 12, 
            5\ cw + cw], \[IndentingNewLine]Range[5\ cw + 12, 
            6\ cw + cw], \[IndentingNewLine]Range[6\ cw + 12, 
            6\ cw + cw]\[IndentingNewLine]}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch =. ; cw =. ;\)], "Input",
  Evaluatable->False],

Cell["\<\
(* one may want to quit kernel and re-eval notebook between changes \
though not required. *)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["finish up", "Subsection",
  Evaluatable->True],

Cell[BoxData[
    \(finish\ up\)], "Output"],

Cell["(* make sure dimensions are square and regular *)", "Text",
  Evaluatable->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(n = Dimensions[ch2b]\)], "Input"],

Cell[BoxData[
    \({7, 32}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(chartheight = n[\([1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(chartwidth = n[\([2]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(n =. ;\)\)], "Input"],

Cell["\<\
(* reset these here since there may be graphic leftovers seen if \
not HOWEVER don't do it after defining functions do it only before function \
def *)\
\>", "Text",
  Evaluatable->True],

Cell[BoxData[
    \(\(Remove[go, gr, go2D, gr2D];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[go2, gr2, go22D, gr22D, go2DBW];\)\)], "Input"],

Cell[BoxData[
    \(\(Remove[odat, opos, odir, oattr];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go =. ; gr =. ; go2D =. ; gr2D =. ;\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(gr2D\)\" is similar to \
existing symbol \"\!\(go2D\)\"."\)], "Message"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2 =. ; gr2 =. ; go22D =. ; gr22D =. ; go2DBW =. ;\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(go22D\)\" is similar to \
existing symbol \"\!\(go2D\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(gr22D\)\" is similar to \
existing symbols \!\({go22D, gr2D}\)."\)], "Message"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(odat =. ; opos =. ; odir =. ; oattr =. ;\)], "Input"],

Cell[BoxData[
    \(General::"spell" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(odat\)\" is similar to \
existing symbols \!\({dat, ddat}\)."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(opos\)\" is similar to \
existing symbol \"\!\(opts\)\"."\)], "Message"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(odir\)\" is similar to \
existing symbol \"\!\(dir\)\"."\)], "Message"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["elements text and data  (reset)", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["\<\
discuss pos / opos (discussion of Center of Cell graphics \
posotioning)\
\>", "Subsubsection"],

Cell[TextData[{
  StyleBox["(*\n\nMathematica",
    FontSlant->"Italic"],
  "'s default is { x \[RightArrow] , y \[CircleTimes] , z \[UpArrow] } from \
{LL, LL, Screen)\n(\[CircleDot] is out of, \[CircleTimes] is into)\neach \
element datum adds offset from center from where cell center is\nthat is: \n\t\
i , take whereami in ch2b element table (1,1 to 32,7) (centerpos)\n\tadd fake \
elements (ie, {1,1} to make room for labels) (centertrans)\n\tdialate or \
contract the table (centerscale)\n\trotate whole deal (centerrot)\n\tadd any \
final offset for plot fitting chart (plottrans)\n\t==> C center of element in \
table offset position from here\n\t(obviously Center of Cell has no offset)\n\
\t\t* now each item in chart sets layou[] and uses opos[]\n\t\t   so \
placement is relative to center of cell for element\nelements may rotate \
their offset to same rotation here (see layout),\n\t(table read horiz or \
vert)\nelements can deal with width by:\n\tpadding data\n\tor by using \
functional in it's layout[] entry\n\t\t(meaning has custom calc. from center \
C)\nbecuase it's a plot\n\textra data / graphics that don't fit into ch2b \
cells\n\twell would be overlaid later\n*)"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["common / graphics", "Subsection",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(*
Set up things so each thing plotted text is done by this:
\tTable [ Graphicsxx [ Text[ odat[o,i], opos[o,i], oattr[o,i] ] ] xx ]
\todat (ie elemnt name) , opos (use cmat to place text), attr (look of text)
Each of these are place in the plot separately.  (see below) opos per text \
uses convenience functions so that each element's text is grouped together by \
a center posotion for that element.
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["setup", "Subsubsection",
  Background->GrayLevel[0.900008]],

Cell[BoxData[
    \(\(defdepth =  .1;\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(do3D = 1\) \)\(;\)\(\ \)\( (*\ 
      whether\ to\ do\ 3  d\ chart\ as\ well\ *) \)\)\)], "Input"],

Cell["\<\
(* number of items per element defined below (tot. items per \
element).  could use ++objects per object but that is obstructive to some \
tasks *)\
\>", "Text"],

Cell[BoxData[
    \(\(textobjects = 38;\)\)], "Input",
  Background->RGBColor[0.8, 1, 1]],

Cell[BoxData[
    \(\(objects = 1;\)\)], "Input"],

Cell[BoxData[
    \(\(leftalign = 1;\)\)], "Input"],

Cell["(* ? have not set up units - that will be a pain later *)", "Text"],

Cell["(* other objects need for lookup *)", "Text"],

Cell["\<\
(* elem only names where atomic name from ch2b is in odat, all \
others start from 0 and up *)\
\>", "Text"],

Cell[BoxData[
    \(\(elem =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(\(elem = 1000;\)\(\ \)\( (*\ 
      odat[elem, n]\ is\ an\ atomic\ name\ *) \)\)\)], "Input"],

Cell["\<\
(* make element table flat \"since graphics are list\".  unsure if \
this is productive but all of the below use it this way and Show cannot show \
complex list graphics anyhow. *)\
\>", "Text"],

Cell[BoxData[
    \(\(elemdat = 
        Table[ch2b[\([chartheight - i + 1, j]\)], {i, 1, chartheight}, {j, 1, 
            chartwidth}];\)\)], "Input"],

Cell["(* generic item in chart *)", "Text"],

Cell[BoxData[
    \(\(elemdat = Flatten[elemdat];\)\)], "Input"],

Cell[BoxData[
    \(\(objlen = Length[elemdat];\)\)], "Input"],

Cell["\<\
(* odat is an empty array - each \"item\" in chart puts data into \
it below *)\
\>", "Text"],

Cell[BoxData[
    \(\(odat[elem, i_] := elemdat[\([i]\)];\)\)], "Input"],

Cell["\<\
(* table is numbered weird these might help ...
(there's likely no reason for table to be upside down from here on - though \
there had been in initial trials) *)\
\>", "Text"],

Cell[BoxData[
    \(whereis[s_Symbol] := 
      Module[{v}, v = Position[elemdat, s]; 
        If[v \[NotEqual] {}, v[\([1, 1]\)]]]\)], "Input"],

Cell[BoxData[
    \(whereis2D[s_Symbol] := 
      Module[{v}, v = Position[ch2b, s]; 
        If[v \[NotEqual] {}, v[\([1, 1]\)] = 8 - v[\([1, 1]\)]; 
          v[\([1]\)]]]\)], "Input"],

Cell[BoxData[
    \(whatis[i_Integer] := odat[elem, i]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \({whereis[Lanthanum], whatis[35], whereis2D[Lanthanum]}\)], "Input"],

Cell[BoxData[
    \({35, Lanthanum, {2, 3}}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(helpcell = whereis[Magnesium] + 4;\)\)], "Input"],

Cell[BoxData[
    \(\(helpcell = whereis[ (*Sodium*) Lithium] + 4;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(whereis[ (*Sodium*) Lithium] + 4\)], "Input"],

Cell[BoxData[
    \(165\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["cmat", "Subsubsection"],

Cell["\<\
fixme:   cmat was define below with layout but ...
\topos is used/evaluated in data/text 
\tand for some reason needs to be above now
cmat simply holds vecs for
\t{ centertrans, centerrot, centerscale,  plottrans }
\t* only centerscale is in use
\t** If one thinks cmat needs to be changed it probably doesn't.
\t* only centerscale is in use
\t* it only changes distance between cells
\t* it doesn't effect contents or data placements from the center
\t* if cells are added or remvoed doesn't effect this
\t   (holding all other things held constant)

---------------------------
** the plot is set so the smallest font, 1, works with two columns with \
normal accuracy numbers (it's atomic).  However!  See Show the fonts can be \
get \"spread out\" just by choosing ImageSize and subst fonts.  If needing to \
rotate or zoom in: use gv(1) it does that and has a zoom 64x pop-up.

Q:  when does cmat need to be changed ?
A:  most anything can be done elsewise (ie, see above, ie rotating is easier \
with print / viewer).  more likely only in 3D plot \"movement\" situations \
where the chart is itself only one item among others\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"cmatb", "=", GridBox[{
              {"0", "0", "0"},
              {\(1/\((1.1\ 32)\)\), "0", \(1/\((1.1\ 7)\)\)},
              {"0", "0", "0"},
              {"0", "0", "0"}
              }]}], ";"}], 
      RowBox[{"(*", " ", GridBox[{
            {\(extra\ elem\)},
            {\(ch\ scale\)},
            {\(ch\ rot\)},
            {\(plot\ \(\(off\)\(.\)\)\)}
            }], "*)"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{"cmat", "=", 
        RowBox[{"cmatb", " ", 
          RowBox[{"(", GridBox[{
                {"1", "1", "1"},
                {"12", "1", "3"},
                {"1", "1", "1"},
                {"1", "1", "1"}
                }], ")"}], " ", "100"}]}], ";"}]], "Input"],

Cell["\<\
for x lower numbers make cells thinner, for y smaller numbers make \
cells shorter\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{"cmat", "=", 
        RowBox[{"cmatb", " ", 
          RowBox[{"(", GridBox[{
                {"1", "1", "1"},
                {"10.2", "1", "2.70"},
                {"1", "1", "1"},
                {"1", "1", "1"}
                }], ")"}], " ", "100"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(cmat // MatrixForm\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0"},
            {"28.977272727272723`", "0", "35.064935064935064`"},
            {"0", "0", "0"},
            {"0", "0", "0"}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell["\<\
(* generic position helper function:
\tdata items per element to plot offset from centerpos of element's cell
\t\t* allows data plotting to follow the same placement for every element
\t\t   ie, place to put An within each element box if An is used at all
\t\t* see: discuss pos / opos in Center of Cell definition above *)\
\>", \
"Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["setup continued", "Subsubsection"],

Cell[BoxData[
    \(\(opos[o_, i_] := 
        N[\[IndentingNewLine]opos[1, 
              i] + \[IndentingNewLine]Rotate3D[\[IndentingNewLine]layout[\([o]\
\)]\[IndentingNewLine], Sequence @@ N[cmat[\([3]\)]]\[IndentingNewLine], 
              opos[1, i]\[IndentingNewLine]]\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \( (*\(opos[1, i_] := 
          N[plottrans + 
              centerrot[\[IndentingNewLine]\((centerscale\ \((centertrans + 
                        centerpos[\([i]\)])\))\)\[IndentingNewLine]]];\)*) \
\)], "Input"],

Cell["(* offset allows left aligned text *)", "Text"],

Cell["\<\
(* OOPs there is no z text direction and note no z offset  either \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        leftalign === 
          1, \[IndentingNewLine]ooffset[o_, i_] := {\(-1\), 
            0}, \[IndentingNewLine]ooffset[o_, i_] := {0, 
            0}\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
(* should allow verticle text - but does not comletely work (ok, \
unused anyhow) *)\
\>", "Text"],

Cell[BoxData[
    \(\(odir[o_, i_] := {1, 0, 0};\)\)], "Input"],

Cell["\<\
(* OOPs there is no z text direction and note no z offset  either \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(odir[o_, i_] := {1, 0};\)\)], "Input"],

Cell["(* and no default ooffset *)", "Text"],

Cell["\<\
(* used if efuns[[i]] (ie, Abbreviation) is same as text wanted for \
dat *)\
\>", "Text"],

Cell[BoxData[
    \(\(gendat[fun_, pad_] := 
        Module[{v}, \[IndentingNewLine]Table[\[IndentingNewLine]v = 
              odat[elem, i]; \[IndentingNewLine]v = 
              If[v =!= "\<\>", 
                fun[odat[elem, i]], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", 
              If[\[Not] StringQ[v], 
                v = ToString[v]]]; \[IndentingNewLine]padit[v, 
              pad]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(gendat[fun_] := 
        Module[{v}, \[IndentingNewLine]Table[\[IndentingNewLine]v = 
              odat[elem, i]; \[IndentingNewLine]v = 
              If[v =!= "\<\>", 
                fun[odat[elem, i]], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", 
              If[\[Not] StringQ[v], 
                v = ToString[
                    v]]]; \[IndentingNewLine]v\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ v = 
        StringJoin[
            v]\ join\ was\ for\ \(\(what\)\(\ \)\(?\)\)\ *) \)], "Input"],

Cell["\<\
(*

howto printing numbers the correct / long way
units:  First is allot easier to remove units and always works for many efuns
bookform:  only Abunances need fNbookForm, others are already ok for chart
Below: does it all

NOTE: most dat items set \"funname=getnum\" and call getdat[ fun ] which \
kinda preens it or at one time was needed for numbers.  getdat is expected to \
return text not expr.

*)\
\>", "Text"],

Cell[BoxData[
    \( (*\[IndentingNewLine]slightly\ improved\ one\ \
below\[IndentingNewLine]getnum[funname_, element_] := 
        Module[{fip, funnum, num}, \[IndentingNewLine]fip = 
            funname[element]; \[IndentingNewLine]If[fip === Unknown, 
            Return["\<?\>"]]; 
          funnum = \(Position[efuns, funname]\)[\([1, 
                1]\)]; \[IndentingNewLine]fip = 
            fip\ \((1/
                  efunsunits[\([funnum]\)])\); \[IndentingNewLine]num = \
\(efunsnum[\([funnum]\)]\)[
              fip]; \[IndentingNewLine]num\[IndentingNewLine] (*\ 
            Map[efunsnum[\([funnum]\)], 
              funname[Elements]\ \((1/
                    efunsunits[\([funnum]\)])\)\ ]\ *) \[IndentingNewLine] \
(*\ \(efunsnum[\([funnum]\)]\)[
                funname[element]]\ \((1/
                  efunsunits[\([funnum]\)])\)\ *) \[IndentingNewLine]]\
\[IndentingNewLine]*) \)], "Input"],

Cell[TextData[{
  "(*\npurpose:\n\t* if it's on the chart it needs to \"not lie\"\n\t* some \
things need message side , most can be on chart\n\t   avoid use of messages \
and don't want both surely\nnotes: \n\t* very specific to ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " chem data\n\t* ignore unstable isotopes that have known atomic weights, \
there are many\n\t* for old CRC OS dat, if {} the odat just leaves it blank, \
like chart was\n\t* for ElectronAffinity 0's don't show <0>0 or -0 and leave \
it as a note\n\t* there are only \n*)"
}], "Text"],

Cell[BoxData[
    \(ve[elem_Symbol | elem_String, fun_Symbol] := 
      Module[{v, p, ab, e}, \[IndentingNewLine]p = 
          Position[efuns, fun]; \[IndentingNewLine]If[p \[Equal] {}, 
          Return[Null]]; \[IndentingNewLine]p = 
          p[\([1, 1]\)]; \[IndentingNewLine]ab = 
          AbbreviationFromEither[elem]; \[IndentingNewLine]If[
          ab \[Equal] Null, Return[Null]]; \[IndentingNewLine]e = 
          ElementFromEither[
            elem]; \[IndentingNewLine]Miscellaneous`ChemicalElements`Private`\
mess = {}; \[IndentingNewLine]{fun[e], ab, efunsab[\([p]\)], 
          m2}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(ve2[elem_Symbol | elem_String, fun_Symbol] := 
      Module[{v}, \[IndentingNewLine]v = ve[elem, fun]; \[IndentingNewLine]If[
          v \[Equal] Null, Return[]]; \[IndentingNewLine]v = 
          Append[v, 0]; \[IndentingNewLine]If[v[\([1]\)] \[Equal] Unknown, 
          Return["\<?\>"]]; \[IndentingNewLine]If[
          v[\([4]\)] \[NotEqual] {}, \[IndentingNewLine]v[\([5]\)] = 
            1; \[IndentingNewLine]If[
            StringMatchQ[
              v[\([4, 1]\)], "\<No * exists.\>"], \[IndentingNewLine] (*\ 
              no\ stabel\ isotope\ , \ 
              show\ in\ chart\ *) \[IndentingNewLine]v[\([5]\)] = 
              2\[IndentingNewLine] (*\ 
              else\ its\ a\ needed\ message\ about\ data\ v[\([5]\)] \[Equal] 
                1\ already\ *) \[IndentingNewLine]];\[IndentingNewLine]]; \
\[IndentingNewLine]v\[IndentingNewLine]]\)], "Input"],

Cell["\<\
(*
purpose:
\t* just return string for number without units
\t* new: use ve2 to mark \"un\" unstable or \"*\" see notes
\t* baked
\t   should be done after returning number as to whether it is ok
\t   to convert num to string but that means doing it like 30 times
\t   anyhow the layout is for the same not for 2D boxed nums
*)\
\>", "Text"],

Cell[BoxData[
    \(\(\( (*\ 
      returns\ string\ not\ expr\ *) \)\(\[IndentingNewLine]\)\(getnum[
        funname_, element_] := 
      Module[{fip, funnum, num, v}, \[IndentingNewLine]fip = 
          funname[element]; \[IndentingNewLine]If[fip === Unknown, 
          Return["\<?\>"]]; \[IndentingNewLine]funnum = \(Position[efuns, 
              funname]\)[\([1, 1]\)]; \[IndentingNewLine]v = 
          ve2[element, funname]; \[IndentingNewLine]If[v \[Equal] Null, 
          Return["\<\>"]]; \[IndentingNewLine]If[
          v[\([1]\)] \[Equal] "\<none\>", 
          Return["\<none\>"]]; \ \[IndentingNewLine]fip = 
          fip\ \((1/
                efunsunits[\([funnum]\)])\); \[IndentingNewLine]num = \
\(efunsnum[\([funnum]\)]\)[fip]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          tostring\ to\ insure\ NumberMark\ is\ gone\ \ \
*) \[IndentingNewLine]If[NumberQ[num], num = ToString[num]]; \n
        If[StringTake[num, \(-1\)] \[Equal] "\<.\>", 
          num = StringDrop[num, \(-1\)]]; \n
        If[StringTake[num, \(-2\)] \[Equal] "\<.*\>", 
          num = StringDrop[
                n, \(-2\)] <> "\<*\>"]; \
\[IndentingNewLine]\[IndentingNewLine] (*\ \(If[v[\([5]\)] \[Equal] 2, 
              num = SuperscriptBox[num, u]];\)\ *) \[IndentingNewLine]If[
          v[\([5]\)] \[Equal] 2, 
          num = ToString[num] <> "\< un\>"]; \[IndentingNewLine]If[
          v[\([5]\)] \[Equal] 1, 
          num = ToString[
                num] <> "\<*\>"]; \
\[IndentingNewLine]num\[IndentingNewLine]]\)\)\)], "Input"],

Cell["\<\
If[NumberQ[num],num=ToString[num]];
If[StringTake[num,-1]\[Equal]\".\",
    num=StringDrop[num,-1];
    ];
If[StringTake[num,-2]\[Equal]\".*\",
    num=StringDrop[n,-2]<>\"*\";
    ];\
\>", "Text"],

Cell["\<\
(* Map[efunsnum[[funnum]],funname[Elements] \
(1/efunsunits[[funnum]]) ] *)
(* efunsnum[[funnum]][funname[element]] (1/efunsunits[[funnum]]) *)\
\>", \
"Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\[IndentingNewLine]\)\(getnum[Density, Hydrogen]\)\)\)], "Input"],

Cell[BoxData[
    \("76*"\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Density[Hydrogen]\ 1/efunsunits[\([9]\)]\)], "Input"],

Cell[BoxData[
    \(76.`\)], "Output"]
}, Closed]],

Cell["(* \"---\" looks better but ? means something *)", "Text"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["DATA / TEXT for Elements", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["Center of Cell", "Subsection"],

Cell["\tplace a \".\" in center to help when doing layout", "Text"],

Cell[BoxData[
    \(\(oncehelppos = False;\)\)], "Input"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(cdot =. ; 
    cdot = \[IndentingNewLine]Table[\[IndentingNewLine]"\<\>"\
\[IndentingNewLine], {i, 1, chartheight}\[IndentingNewLine], {j, 1, 
          chartwidth}\[IndentingNewLine]];\)], "Input"],

Cell[BoxData[
    \(\(cdot = Flatten[cdot];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[1, i_] := cdot[\([i]\)];\)\)], "Input"],

Cell["OOPs there is no z text offset", "Text"],

Cell[BoxData[
    \(\(ooffset[1, i_] := {0, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["pos ", "Subsubsection"],

Cell[BoxData[
    \(\(centerpos = \[IndentingNewLine]Table[\[IndentingNewLine]{j, 
            defdepth, \ i}\[IndentingNewLine], {i, 1, 
            chartheight}\[IndentingNewLine], {j, 1, 
            chartwidth}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(centerpos = Partition[Flatten[centerpos], 3];\)\)], "Input"],

Cell["\<\
(* cmat is below in layout because it can be though it could be \
here
only cmat[[2]] centerscale is used
\t* this only changes distance between cells
\t* it doesn't effect contents or data placements from the center *)\
\>", \
"Text"],

Cell[BoxData[
    \(\(centerscale := cmat[\([2]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(centertrans := cmat[\([1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(plottrans := cmat[\([4]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(centerrot[n_] := Rotate3D[n, Sequence @@ cmat[\([3]\)]];\)\)], "Input"],

Cell[BoxData[
    \(\(opos[1, i_] := 
        N[plottrans + 
            centerrot[\[IndentingNewLine]\((centerscale\ \((centertrans + 
                      centerpos[\([i]\)])\))\)\[IndentingNewLine]]];\)\)], \
"Input"],

Cell["\<\
(* cmat simply holds vecs for
\tplottrans, centerrot, centerscale, centertrans
(centerpos is done as ch2b's i, j)
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[1, i_] := 
      Sequence[\[IndentingNewLine]TextStyle -> {FontSize \[Rule] 3, 
            FontColor \[Rule] 
              RGBColor[1, 0, 0]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell["edit or add elemental data Below", "Subsection",
  Background->RGBColor[0.8, 1, 1]],

Cell[CellGroupData[{

Cell["Abbreviation", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \( (*\ \(old\ Table[
            ch2[\([7\  - \ i\  + \ 1, \ j]\)], \ {i, \ 1, \ 7}, \ {j, \ 1, \ 
              32}];\)\ *) \)], "Input"],

Cell[BoxData[
    \(txt =. ; txt = gendat[Abbreviation, 3];\)], "Input"],

Cell[BoxData[
    \(\(odat[2, i_] := 
        If[odat[elem, i] =!= "\<\>", txt[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[2, helpcell] := "\<Elem\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[2, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 4, 
            FontWeight \[Rule] "\<Bold\>", \[IndentingNewLine]FontColor \
\[Rule] RGBColor[ .85, 0, 
                0]}\[IndentingNewLine] (*\ \(,\)\(Background \[Rule] 
            Hue[ .50]\)\ *) \[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Shell Configuration - Outermost 2", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[TextData[{
  "(* IMPORTANT:  DO NOT USE   elecfmt[List] OR elecfmtv[List]  with  \
elements[]  USE ONLY  felements[].  (see examples, List is for fill order \
only, Symbol goes by ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s array from chem.m) *)"
}], "Text"],

Cell[BoxData[
    \(\(ecdat = 
        Module[{i, s, 
            n}, \[IndentingNewLine]Table[\[IndentingNewLine]If[\
\[IndentingNewLine]Head[odat[elem, i]] === Symbol, \[IndentingNewLine]s = 
                odat[elem, i]; \[IndentingNewLine]n = 
                Length[elecfmtpm[
                    s]]; \[IndentingNewLine]Take[\[IndentingNewLine]elecfmtpm[\
\[IndentingNewLine]odat[elem, i]\[IndentingNewLine]]\[IndentingNewLine], 
                If[n > 6, \(-6\), \(-n\)]\[IndentingNewLine]]\
\[IndentingNewLine], "\<\>"\[IndentingNewLine]]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[3, i_] := 
        If[odat[elem, i] =!= "\<\>", ecdat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[3, 
          helpcell] := "\<Shell Order Electron Configuration\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[3, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Shell Configuration - Fill Order 2
\tFIXME is 2 terms enough ? see crc tab\
\>", "Subsection"],

Cell[BoxData[
    \( (*\ Table[
        correction[Abbreviation[Element[\([i]\)]]], {i, 1, 
          112}]\ *) \)], "Input"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(fecdat = 
        Module[{i, s, n, an, e, 
            t}, \[IndentingNewLine]Table[\[IndentingNewLine]If[\
\[IndentingNewLine]Head[odat[elem, i]] === Symbol, \[IndentingNewLine]s = 
                odat[elem, i]; \[IndentingNewLine]an = 
                AtomicNumber[s]; \[IndentingNewLine]e = 
                felements[\([an]\)]; \[IndentingNewLine]t = 
                elecfmtpm[e, s]; \[IndentingNewLine]n = 
                Length[t]; \[IndentingNewLine]Take[
                t, \[IndentingNewLine]If[
                  n > 6, \(-6\), \(-n\)]\[IndentingNewLine]]\
\[IndentingNewLine], "\<\>"\[IndentingNewLine]]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[4, i_] := 
        If[odat[elem, i] =!= "\<\>", fecdat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[4, 
          helpcell] := "\<Fill Order Electron Configuration\>";\)\)], "Input"],

Cell[TextData[{
  "(* another ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " bug\n\tfile save corruption ...\n\tif the above has a superscript \
containing just 1 space then somehow\n\t.nb cell  markup symbols appear in \
string above after file is re-loaded\n\t(was being used to get text boxing to \
line up - but not worth it now) *)"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[4, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \( (*\ \(,\)\(Background \[Rule] RGBColor[ .9, 1,  .9]\)\ *) \)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Atomic Number", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \( (*\ \(gendat\ does\ this\ Module[{an}, \[IndentingNewLine]Table[
              an = AtomicNumber[odat[elem, i]]; \[IndentingNewLine]If[
                IntegerQ[an], ToString[an], "\<\>"]\[IndentingNewLine], {i, 
                1, objlen}]];\)\ *) \)], "Input"],

Cell["(* should be same result as if getnum is used *)", "Text"],

Cell[BoxData[
    \(andat =. ; andat = gendat[AtomicNumber, 3];\)], "Input"],

Cell[BoxData[
    \(\(odat[5, i_] := 
        If[odat[elem, i] =!= "\<\>", andat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[5, helpcell] := "\<Atomic Number\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[5, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 3, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[ .85, 0, 
                0]}\[IndentingNewLine] (*\ \(,\)\(Background \[Rule] 
            Hue[ .50]\)\ *) \[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Shell, Outer Electrons, Element", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(shfun[i_] := shellsarr[\([AtomicNumber[i]]\)];\)\)], "Input"],

Cell[BoxData[
    \( (*\ shdat = 
        Flatten[Table[{7 - i + 1, j}, {i, 1, 7}, {j, 1, 
              32}]]; \ \[IndentingNewLine]shdat = 
        Partition[shdat, 2];\ *) \)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(shdat = gendat[shfun]\ ;\)\)\)], "Input"],

Cell[BoxData[
    \(\(\(\ \)\(shdat2 = 
        Module[{dat, an, 
            shell}, \[IndentingNewLine]Table[\[IndentingNewLine]dat = 
              odat[elem, i]; \[IndentingNewLine]an = 
              AtomicNumber[dat]; \[IndentingNewLine]shell = 
              ToExpression[shdat[\([i]\)]]; \[IndentingNewLine]If[
              dat =!= "\<\>", \[IndentingNewLine]fineashell[
                felements[\([an]\)], shell]\[IndentingNewLine], 
              Null]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]\[IndentingNewLine]];\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fineashell[felements[\([77]\)], 5]\)], "Input"],

Cell[BoxData[
    \(17\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fineashell[felements[\([77]\)], 6]\)], "Input"],

Cell[BoxData[
    \(0\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(fineashell[felements[\([77]\)], 7]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(showfe[felements[\([77]\)]]\)], "Input"],

Cell[BoxData[
    TagBox[
      RowBox[{"(", "\[NoBreak]", GridBox[{
            {"1", "\<\"s\"\>", \({1, 1}\)},
            {"2", "\<\"s\"\>", \({1, 1}\)},
            {"2", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"3", "\<\"s\"\>", \({1, 1}\)},
            {"3", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"4", "\<\"s\"\>", \({1, 1}\)},
            {"3", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"4", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"5", "\<\"s\"\>", \({1, 1}\)},
            {"4", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1, 1}}\)},
            {"5", "\<\"p\"\>", \({{1, 1, 1}, {1, 1, 1}}\)},
            {"6", "\<\"s\"\>", \({}\)},
            {
              "4", "\<\"f\"\>", \({{1, 1, 1, 1, 1, 1, 1}, {1, 1, 1, 1, 1, 1, 
                  1}}\)},
            {"5", "\<\"d\"\>", \({{1, 1, 1, 1, 1}, {1, 1, 1, 1}}\)}
            }], "\[NoBreak]", ")"}],
      (MatrixForm[ #]&)]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(shdat3 = 
        Table[shdat[\([i]\)] <> \ "\<, \>"\  <> \ 
            ToString[shdat2[\([i]\)]] <> "\<  \>"\[IndentingNewLine] <> 
            ToString[odat[elem, i]], {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[6, i_] := 
        If[odat[elem, i] =!= "\<\>", shdat3[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[6, 
          helpcell] := "\<Shell, Outer Electrons, Element\>";\)\)], "Input"],

Cell[BoxData[
    \(\(ooffset[6, i_] := {0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(odir[6, i_] := {1, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[6, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0,  .55, 0]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FIP ab", "Subsection"],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(* First is easier than units and IP doesn't need bookform *)\
\>", \
"Text"],

Cell[BoxData[
    \( (*\ ipfun[i_] := 
        Module[{fip, n}, \[IndentingNewLine]fip = 
            IonizationPotential[i]; \[IndentingNewLine]n = 
            If[Head[fip] === Times, \ 
              First[fip], "\<\>"]; \[IndentingNewLine]n]\ *) \)], "Input"],

Cell["(* but use getnum anyho *)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, IonizationPotential]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(fipstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[7, i_] := 
        If[odat[elem, i] =!= "\<\>", fipstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[7, helpcell] := fipstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[7, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["FIP n", "Subsection"],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(* First is easier than units and IP doesn't need bookform *)\
\>", \
"Text"],

Cell[BoxData[
    \( (*\ ipfun[i_] := 
        Module[{fip, n}, \[IndentingNewLine]fip = 
            IonizationPotential[i]; \[IndentingNewLine]n = 
            If[Head[fip] === Times, \ 
              First[fip], "\<\>"]; \[IndentingNewLine]n]\ *) \)], "Input"],

Cell["(* but use getnum anyho *)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(ipfun[i_] := getnum[IonizationPotential, i];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\(ipdat =. \) \)\(;\)\(\(ipdat = 
        gendat[ipfun]\) \)\(;\)\(\ \)\( (*\ pad\ 6\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(StringTake::"take" \(\(:\)\(\ \)\) 
      "Cannot take positions \!\(-2\) through \!\(-1\) in \
\"\!\(\"9\"\)\"."\)], "Message"]
}, Closed]],

Cell[BoxData[
    \(\(odat[8, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ipdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[8, helpcell] := "\<Ionization Potential  eV\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[8, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_M\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, MeltingPoint]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(tmstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[9, i_] := 
        If[odat[elem, i] =!= "\<\>", tmstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[9, helpcell] := tmstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[9, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_M\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(tmfun[i_] := getnum[MeltingPoint, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(tmdat =. \) \)\(;\)\(\(tmdat = 
        gendat[tmfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[10, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[tmdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[10, helpcell] := "\<Melting Point  K\>"~padit~26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[10, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
    \("\!\(m\_A\)"\)]]], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(awfun[i_] := getnum[AtomicWeight, i];\)\)], "Input"],

Cell[BoxData[
    \(awdat =. ; awdat = gendat[awfun];\)], "Input"],

Cell[BoxData[
    \( (*\ \(funnum = \(Position[efuns, AtomicWeight]\)[\([1, 
              1]\)];\)\ *) \)], "Input"],

Cell[BoxData[
    \( (*\ \(awstr = efunsab[\([funnum]\)];\)\ *) \)], "Input"],

Cell["(* odat[9,i_]:=awstr<>\"  \"<>padit[awdat[[i]],10]; *)", "Text"],

Cell[BoxData[
    \( (*\ \(odat[11, i_] := 
          If[odat[elem, i] =!= "\<\>", 
            padit[awdat[\([i]\)], 8], "\<\>"];\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(odat[11, i_] := 
        If[odat[elem, i] =!= "\<\>", awdat[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        leftalign === 
          0, \[IndentingNewLine]odat[11, 
            helpcell] := "\<      Atomic Weight  amu\>", \
\[IndentingNewLine]odat[11, 
            helpcell] := "\<Atomic Weight  amu\>"];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[11, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[ .55, 0, 0]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SI ab", "Subsection"],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
(* First is easier than units and IP doesn't need bookform *)\
\>", \
"Text"],

Cell[BoxData[
    \( (*\ ipfun[i_] := 
        Module[{fip, n}, \[IndentingNewLine]fip = 
            IonizationPotential[i]; \[IndentingNewLine]n = 
            If[Head[fip] === Times, \ 
              First[fip], "\<\>"]; \[IndentingNewLine]n]\ *) \)], "Input"],

Cell["(* but use getnum anyho *)", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, StableIsotopes]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(sistr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[12, i_] := 
        If[odat[elem, i] =!= "\<\>", sistr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[12, helpcell] := sistr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[12, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["SI n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(StableIsotopes[Tin]\)], "Input"],

Cell[BoxData[
    \({112, 114, 115, 116, 117, 118, 119, 120, 122, 124}\)], "Output"]
}, Closed]],

Cell["(* for a condensed chart even this won't fit *)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(StableIsotopes[Tin] - Round[AtomicWeight[Tin]]\)], "Input"],

Cell[BoxData[
    \({\(-7\), \(-5\), \(-4\), \(-3\), \(-2\), \(-1\), 0, 1, 3, 
      5}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \( (*\ Table[
          StableIsotopes[Elements[\([i]\)]] - 
            Round[AtomicWeight[Elements[\([i]\)]]], {i, 1, 112}] // 
        TableForm\ *) \)], "Input"],

Cell[BoxData[
    \(\(sidat2 = 
        Module[{si, dat, 
            v}, \[IndentingNewLine]Table[\[IndentingNewLine]dat = 
              odat[elem, i]; \[IndentingNewLine]si = 
              StableIsotopes[odat[elem, i]]; \[IndentingNewLine]v = 
              If[dat =!= "\<\>" && si =!= {}, \[IndentingNewLine]ToString[
                  si - Round[
                      AtomicWeight[dat]]], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<{\>" \[Rule] "\<\>", "\<}\>" \[Rule] "\<\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>"}]; \[IndentingNewLine]v = \
"\<+\>" <> StringReplace[
                    v, {"\< \>" \[Rule] "\< +\>"}]; \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>", "\<+-\>" \[Rule] "\<-\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<+0\>" \[Rule] "\<0\>"}]; \[IndentingNewLine] (*\ 
                sqeeze\ a\ few\ long\ ones\ *) \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-5 -4 -3 -2 -1\>" \[Rule] "\<-5,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-4 -3 -2 -1\>" \[Rule] "\<-4,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-3 -2 -1\>" \[Rule] "\<-3,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-4 -2 -1\>" \[Rule] "\<-4,2,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<+1 +2 +4\>" \[Rule] \
"\<+1,2,4\>"}]\[IndentingNewLine], "\<\>"\[IndentingNewLine]]\
\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[13, i_] := 
        If[odat[elem, i] =!= "\<\>" && sidat2[\([i]\)] =!= "\<{0}\>", 
          sidat2[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[13, helpcell] := "\<Stable Isotopes *\>";\)\)], "Input"],

Cell[TextData[{
  "(* From what i see so far ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s chem.m may use {} to mean only natural isotope is exactly atomic weight \
or for (ie, Cs) {133} (cmp to 132.905) may mean nearly the same.  Being \
abbrev. \"\" is used in tab for both. *)"
}], "Text"],

Cell["(* {} are stripped because they don't render for Enc. PS *)", "Text"],

Cell[BoxData[
    \( (*\ \(dict[]\)[\([55]\)]\ *) \)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[13, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_B\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, BoilingPoint]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(tbstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[14, i_] := 
        If[odat[elem, i] =!= "\<\>", tbstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[14, helpcell] := tbstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[14, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`T\_B\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(tbfun[i_] := getnum[BoilingPoint, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(tbdat =. \) \)\(;\)\(\(tbdat = 
        gendat[tbfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[15, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[tbdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[15, helpcell] := "\<Boiling Point  K\>"~padit~26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[15, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`SsA\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, SolarSystemAbundance]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(ssastr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[16, i_] := 
        If[odat[elem, i] =!= "\<\>", ssastr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[16, helpcell] := ssastr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[16, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`SsA\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["\<\
\tMicro is a mathematica font.  at printing time mu or \"u\" will \
be easier for all.
\tbut font rendering may break \[Mu] in size 2 while allowing others!  plain \
u here.\
\>", "Text"],

Cell[BoxData[
    \(\(ssafun[i_] := getnum[SolarSystemAbundance, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(ssadat =. \) \)\(;\)\(\(ssadat = 
        gendat[ssafun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(ssadat = 
        Table[StringReplace[
            ssadat[\([i]\)], "\<\[Micro]\>" \[Rule] "\<u\>"], {i, 1, 
            Length@ssadat}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[17, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ssadat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[17, helpcell] := "\<Solar System Abundance %\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[17, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EcA\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, EarthCrustAbundance]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(ecastr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[18, i_] := 
        If[odat[elem, i] =!= "\<\>", ecastr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[18, helpcell] := ecastr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[18, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EcA\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(ecafun[i_] := getnum[EarthCrustAbundance, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(ecadat =. \) \)\(;\)\(\(ecadat = 
        gendat[ecafun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(ecadat = 
        Table[StringReplace[
            ecadat[\([i]\)], "\<\[Micro]\>" \[Rule] "\<u\>"], {i, 1, 
            Length@ecadat}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[19, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ecadat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[19, helpcell] := "\<Earth Crust Abundance  %\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[19, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EoA\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, EarthOceanAbundance]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(eoastr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[20, i_] := 
        If[odat[elem, i] =!= "\<\>", eoastr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[20, helpcell] := eoastr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[20, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(TraditionalForm\`EoA\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(eoafun[i_] := getnum[EarthOceanAbundance, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(eoadat =. \) \)\(;\)\(\(eoadat = 
        gendat[eoafun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(eoadat = 
        Table[StringReplace[
            eoadat[\([i]\)], "\<\[Micro]\>" \[Rule] "\<u\>"], {i, 1, 
            Length@eoadat}];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[21, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[eoadat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[21, helpcell] := "\<Earth Ocean Abundance  %\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[21, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\[Rho] ab", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, Density]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(dstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[22, i_] := 
        If[odat[elem, i] =!= "\<\>", dstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[22, helpcell] := dstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[22, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\[Rho] n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(dfun[i_] := getnum[Density, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(ddat =. \) \)\(;\)\(\(ddat = gendat[dfun]\) \)\(;\)\(\ \)\( (*\ 
      pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[23, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[ddat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[23, helpcell] := "\<Density  kg/m^3 @298K\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[23, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(L\_f\)"\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, HeatOfFusion]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(lfstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[24, i_] := 
        If[odat[elem, i] =!= "\<\>", lfstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[24, helpcell] := lfstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[24, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(L\_f\)"\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(lffun[i_] := getnum[HeatOfFusion, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(lfdat =. \) \)\(;\)\(\(lfdat = 
        gendat[lffun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[25, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[lfdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[25, helpcell] := "\<Heat of Fusion  kj/mol\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[25, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(L\_v\)]],
  " ab"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, HeatOfVaporization]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(lvstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[26, i_] := 
        If[odat[elem, i] =!= "\<\>", lvstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[26, helpcell] := lvstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[26, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \(L\_v\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(lvfun[i_] := getnum[HeatOfVaporization, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(lvdat =. \) \)\(;\)\(\(lvdat = 
        gendat[lvfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[27, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[lvdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[27, helpcell] := "\<Heat of Vaporization\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[27, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(Q\_c\)"\)]],
  " ab  (spec. heat qc)"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, SpecificHeat]\)[\([1, 1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(qcstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[28, i_] := 
        If[odat[elem, i] =!= "\<\>", qcstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[28, helpcell] := qcstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[28, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[BoxData[
      \("\!\(Q\_c\)"\)]],
  " n"
}], "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(qcfun[i_] := getnum[SpecificHeat, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(qcdat =. \) \)\(;\)\(\(qcdat = 
        gendat[qcfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[29, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[qcdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[29, helpcell] := "\<Specific Heat  kj/g\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[29, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Q\[Sigma] ab (therm. cond. tc)", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, ThermalConductivity]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(tcstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[30, i_] := 
        If[odat[elem, i] =!= "\<\>", tcstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[30, helpcell] := tcstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[30, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Q\[Sigma] n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(tcfun[i_] := getnum[ThermalConductivity, i];\)\)], "Input"],

Cell[BoxData[
    \(\(\(\(tcdat =. \) \)\(;\)\(\(tcdat = 
        gendat[tcfun]\) \)\(;\)\(\ \)\( (*\ pad\ 8\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(\(odat[31, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[tcdat[\([i]\)], 10], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[31, helpcell] := "\<Therm Conduct  W/Km @300K\>"~padit~
          26;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[31, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
              2}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
orig order ab  (shell order ab)\
\>", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* note borrowing of abbrev *)", "Text"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, ElectronConfiguration]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(oostr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[32, i_] := 
        If[odat[elem, i] =!= "\<\>", oostr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[32, helpcell] := oostr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[32, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["fill order ab", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* note borrowing of abbrev *)", "Text"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, ElectronConfigurationFormat]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(fostr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[33, i_] := 
        If[odat[elem, i] =!= "\<\>", fostr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[33, helpcell] := fostr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[33, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OS ab", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell[BoxData[
    \(\(funnum = \(Position[efuns, OxidationStates]\)[\([1, 
            1]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(osstr = efunsab[\([funnum]\)];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[34, i_] := 
        If[odat[elem, i] =!= "\<\>", osstr, "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[34, helpcell] := osstr;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[34, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, FontWeight \[Rule] "\<Bold\>", 
            FontColor \[Rule] 
              RGBColor[0, 0,  .55]}\[IndentingNewLine]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OS n", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* sifun[i_]:=StableIsotopes[i]; *)", "Text"],

Cell["(* sidat=.;sidat=gendat[StableIsotopes]; *)", "Text"],

Cell[BoxData[
    \(\(osdat2 = 
        Module[{si, dat, 
            v}, \[IndentingNewLine]Table[\[IndentingNewLine]dat = 
              odat[elem, i]; \[IndentingNewLine]si = 
              OxidationStates[odat[elem, i]]; \[IndentingNewLine]v = 
              If[dat =!= "\<\>" && si =!= {}, 
                ToString[si], "\<\>"]; \[IndentingNewLine]If[
              v =!= "\<\>", \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<{\>" \[Rule] "\<\>", "\<}\>" \[Rule] "\<\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>"}]; \[IndentingNewLine]v = \
"\<+\>" <> StringReplace[
                    v, {"\< \>" \[Rule] "\< +\>"}]; \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<,\>" \[Rule] "\<\>", "\<+-\>" \[Rule] "\<-\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<+0\>" \[Rule] "\<0\>"}]; \[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<-3 -2 -1\>" \[Rule] "\<-3,1\>"}]; \
\[IndentingNewLine]v = 
                StringReplace[
                  v, {"\<1 2 3\>" \[Rule] "\<+1,3\>"}]\[IndentingNewLine], \
"\<\>"\[IndentingNewLine]]\[IndentingNewLine], {i, 1, 
              objlen}\[IndentingNewLine]]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[35, i_] := 
        If[odat[elem, i] =!= "\<\>" && osdat2[\([i]\)] =!= "\<{0}\>", 
          osdat2[\([i]\)], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[35, helpcell] := "\<Oxidation States\>";\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[35, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2, 
            FontColor \[Rule] 
              RGBColor[ .55, 0, 0]}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(oattr[35, i_] := 
      Sequence[\[IndentingNewLine]TextStyle \[Rule] \
\[IndentingNewLine]{FontSize \[Rule] 2}\[IndentingNewLine]]\)], "Input"],

Cell["\<\
(* this renders text down but at 90deg unreadable rotation in \
gv/ggv maybe notebook 
too (ok - don't need it now).  to fix have to ? keep in mind chart is rotated \
i think
(but note -1 is to read down 1 to read up)
*)\
\>", "Text"],

Cell[BoxData[
    \( (*\ \(odir[35, i_] := {0, 0, \(-1\)};\)\ *) \)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["element type", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["\<\
(* was going to mark lyquid solid gas.  but really they are all \
abundantly obvious from what is already marked and need elemnt desc is \
better.  more is not always better. *)\
\>", "Text"],

Cell[BoxData[
    \(\(gases = {1, 2, 7, 8, 9, 10, 17, 18, 36, 54, 86};\)\)], "Input"],

Cell[BoxData[
    \(\(liquids = {35, 80};\)\)], "Input"],

Cell[BoxData[
    \(\(soids = 
        Complement[Range[1, ELEMENTS], Union[gases, liquids]];\)\)], "Input"],

Cell["(* skip - \"iupac 2003\" *)", "Text"],

Cell[BoxData[
    \(\(posttransitionmetals = {13, 31, 49, 50, 81, 82, 83, 84};\)\)], "Input"],

Cell["(* skip - \"uipac 2003\" *)", "Text"],

Cell[BoxData[
    \(\(\( (*\ if\ non - metals\ halogens, \ 
      nobels\ marked\ instead\ *) \)\(\[IndentingNewLine]\)\(nonmetals = {1, 
          6, 7, 8, 15, 16, 34};\)\)\)], "Input"],

Cell["instead be simpler by 3 parts", "Text"],

Cell[BoxData[
    \(\(nonmetals = {1, 2, 6, 7, 8, 9, 10, 15, 16, 17, 18, 34, 35, 36, 53, 
          54, 86};\)\)], "Input"],

Cell[BoxData[
    \(\(metalloids = {5, 14, 32, 33, 51, 52, 85};\)\)], "Input"],

Cell[BoxData[
    \(\(metals = 
        Complement[Range[1, ELEMENTS], 
          Union[nonmetals, metalloids]];\)\)], "Input"],

Cell["(* note: marked by col header *)", "Text"],

Cell[BoxData[
    \(\(nobels = {2, 10, 18, 36, 54, 86};\)\)], "Input"],

Cell[BoxData[
    \(\(halogens = {9, 17, 35, 53, 85};\)\)], "Input"],

Cell[BoxData[
    \(\(alkalineearthmetals = {4, 12, 20, 38, 56, 88};\)\)], "Input"],

Cell[BoxData[
    \(\(transitionmetals = 
        Range[21, 30] \[Union] Range[39, 48] \[Union] Range[72, 80] \[Union] 
          Range[104, 108] \[Union] {112};\)\)], "Input"],

Cell["(* note: marked in legend *)", "Text"],

Cell[BoxData[
    \(\(lanthenides = Range[58, 71];\)\)], "Input"],

Cell[BoxData[
    \(\(actinides = Range[90, 103];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Intersection[metals, nonmetals] == Intersection[metals, metalloids] == 
      Intersection[nonmetals, metalloids] \[Equal] {}\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Union[metals, nonmetals, metalloids] \[Equal] 
      Range[1, ELEMENTS]\)], "Input"],

Cell[BoxData[
    \(True\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(mtdat = Table["\<\>", {i, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(Module[{n}, 
        Do[\[IndentingNewLine]n = 
            AtomicNumber[odat[elem, i]]; \[IndentingNewLine]If[
            IntegerQ[n], \[IndentingNewLine]If[
              Intersection[{n}, metals] \[NotEqual] {}, 
              mtdat[\([i]\)] = "\<M\>"]; \[IndentingNewLine]If[
              Intersection[{n}, metalloids] \[NotEqual] {}, 
              mtdat[\([i]\)] = "\<L\>"]; \[IndentingNewLine]If[
              Intersection[{n}, nonmetals] \[NotEqual] {}, 
              mtdat[\([i]\)] = "\<n\>"];\[IndentingNewLine]]\
\[IndentingNewLine], {i, objlen}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[36, i_] := 
        If[odat[elem, i] =!= "\<\>", 
          padit[mtdat[\([i]\)], 2], "\<\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(odat[36, helpcell] := "\<non-Metal-Loid\>";\)\)], "Input"],

Cell[BoxData[
    \( (*\ Table[odat[36, i], {i, 224}]\ *) \)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[36, i_] := 
      Module[{n}, \[IndentingNewLine]n = 
          AtomicNumber[
            odat[elem, 
              i]]; \[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \
\[Rule] {\[IndentingNewLine]FontSize \[Rule] 
                2, \[IndentingNewLine]FontColor \[Rule] 
                RGBColor[\[IndentingNewLine]If[
                    Intersection[{n}, metals] \[NotEqual] {},  .90, 0], 
                  If[Intersection[{n}, nonmetals] \[NotEqual] {},  .90, 0], 
                  If[Intersection[{n}, metalloids] \[NotEqual] {},  .90, 
                    0]]\[IndentingNewLine]}]]\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["col alias", "Subsection"],

Cell[CellGroupData[{

Cell["\<\
graph discuss from far above (top chart graph discuss \
section)\
\>", "Subsubsection"],

Cell[TextData[{
  "(*\nthis \"easy task\" to print the below is a good example of how boxing \
and layout provided by front end can waste more time than save when it comes \
down to the line (literally).\n\n\t18\n\tnobel gases\n\nFrom Discussion (way \
above).  Below tying text together (coltxt) is tried and fails.  (we'd like \
to preserve, as form Output is very efficient and low cost to print).    When \
FormatType is changed text centering is lost (could try paditc) and worse: \
the spacing between text lines becomes variable depending upon how printed.  \
If boxing is used for this it caused a need to change geninit2D to wrap odat \
with DisplayForm which itself worked.  \n\t* point: making a layout that can \
print condensed (good use of space)\n\t   that remains readable and looking \
good: isn't easy\n\t* the row spacing changes depending upon FormatType\n\t* \
the row spacing for color gets doubled & doesn't fit\n\t* using the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " function to HALF RowSpacings->xxx\n\t\t* doesn't appear to change spacing\
\n\t\t* next question: when will it - when it does 1/2 will look wrong\n\t\t\
(",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " itself isn't perfect in all objectives)\n\t* the row spacing for color is \
OUTSIDE the box provided\n\t\ttrying to fix and tie in box and print row \
spacing size?\n\t\ti simply doubt it\n\nQ:  but it's so much harder.\nA:  not \
really: just cut & past an item and choose placement.  if you do it rather \
than think about it it's not bad.\n\nQ:  so why is boxing used to display \
exponents and a few other things ?\n A: because those are known to work (not \
alter chart) by trial and error and why they work is partly because they are \
place individualy by layout (if they change a little they are still within \
the space allotted , and also becaue they are horizontal and pertain to one \
item that is tied to nothing else, visibly speaking).\n \nbelow there was \
allot of problems with \"/\" dissapearing (now solved) due to font style \
which depended upon font availability and font mapping.  and still one should \
keep in mind to use even \"simple symbols like /\" unless the standard chart \
required it - and it doesn't hardly.\n\nQ:  what would the effect be of \
ignoring layout ?\nA:  allot of void in a printed chart and mismatch between \
sizes which would be awkward to print large to fix and in effect never be \
very useful except to see on screen maybe.  which would change (and even be \
wrong) depending on how printed\n\nQ: now you'll say: no way use the editor \
and print it.\nA1:  oh.  but if you change fonts (ie, not avail) your layout \
changes who knows how bad it may not print.  Guess what?  sometimes fonts \
with same name are not the same and this can change if you \"update\".\nA2:  \
you trying re-editing a whole chart for each \"editor limitation\" that pops \
up!@.  it's a big chart to re-edit.\n\nQ:  but individual layout requires \
allot of fixups in \"run geninit & do fix-ups\"\nA:  only for help cell - and \
it's a special convenience to have that be automatic\n*)"
}], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["old", "Subsubsection"],

Cell[BoxData[
    \(\(coltxt = {\[IndentingNewLine]"\<1\nH &\nAlkali Metals\>", \
\[IndentingNewLine]"\<2\nAlkaline Earth\nMetals\>", \[IndentingNewLine]"\<3\n\
Transition\nMetals\>", \[IndentingNewLine]"\<4\n->\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<5\>", \[IndentingNewLine]"\<6\>", \
\[IndentingNewLine]"\<7\>", \[IndentingNewLine]"\<8\>", \
\[IndentingNewLine]"\<9\>", \[IndentingNewLine]"\<10\>", \[IndentingNewLine]"\
\<11\n<-\>", \[IndentingNewLine]"\<12\nVolitile Metals\>", \
\[IndentingNewLine]"\<13\nEarth Metals\>", \[IndentingNewLine]"\<14\n\
Tetragens\>", \[IndentingNewLine]"\<15\nPnictogens\>", \
\[IndentingNewLine]"\<16\nChalcogens\>", \[IndentingNewLine]"\<17\n\
Halogens\>", \[IndentingNewLine]"\<18\nNobel \
Gases\>"\[IndentingNewLine]};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(coltxt = {\[IndentingNewLine]GridBox[{{"\<1\>"}, {"\<H &\>"}, \
{"\<Alkali Metals\>"}}], \[IndentingNewLine]GridBox[{{"\<2\>"}, {"\<Alkaline \
Earth\>"}, {"\<Metals\>"}}], \[IndentingNewLine]GridBox[{{"\<3\>"}, \
{"\<Transition\>"}, {"\<Metals\>"}}], \[IndentingNewLine]GridBox[{{"\<4\>"}, \
{"\<->\>"}}], \[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<4\>", \[IndentingNewLine]"\<4\>", \
\[IndentingNewLine]"\<5\>", \[IndentingNewLine]"\<6\>", \
\[IndentingNewLine]"\<7\>", \[IndentingNewLine]"\<8\>", \
\[IndentingNewLine]"\<9\>", \[IndentingNewLine]"\<10\>", \
\[IndentingNewLine]GridBox[{{"\<11\>"}, {"\<<-\>"}}], \
\[IndentingNewLine]GridBox[{{"\<12\>"}, {"\<Volitile Metals\>"}}], \
\[IndentingNewLine]GridBox[{{"\<13\>"}, {"\<Earth Metals\>"}}], \
\[IndentingNewLine]GridBox[{{"\<14\>"}, {"\<Tetragens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<15\>"}, {"\<Pnictogens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<16\>"}, {"\<Chalcogens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<17\>"}, {"\<Halogens\>"}}], \
\[IndentingNewLine]GridBox[{{"\<18\>"}, {"\<Nobel Gases\>"}}]\
\[IndentingNewLine]};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(x =. ;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(coltxt = 
        coltxt /. GridBox[{x__}, y___] \[Rule] 
            GridBox[{x}, y, ColumnAlignments \[Rule] Center, 
              RowSpacings \[Rule]  .2];\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* use opos[ i , coltops[i] ] for placing directly above *)", "Text"],

Cell[BoxData[
    \(\(coltops = {7, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 4, 4, 
          4, 4, 4, 4, 4, 4, 4, 6, 6, 6, 6, 6, 7};\)\)], "Input"],

Cell["\<\
(* note: WHAT this uses boxing to tie rows?  here we tied to text \
lines together which is OK as long as we know there  are no effects and \
accept the look of it (hardly worth the thinking it takes - MAKING ANOTHER \
DATA ITEM to begin with might be wiser *)\
\>", "Text"],

Cell[BoxData[
    \(\(coltxt = {\[IndentingNewLine]"\<H &\nAlkali Metals\>", \
\[IndentingNewLine]"\<Alkaline Earth\nMetals\>", \
\[IndentingNewLine]"\<Transition\nMetals \[RightArrow]\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<\>", \[IndentingNewLine]"\<\>", \
\[IndentingNewLine]"\<Volitile Metals\>", \[IndentingNewLine]"\<Earth \
Metals\>", \[IndentingNewLine]"\<Tetragens\>", \
\[IndentingNewLine]"\<Pnictogens\>", \[IndentingNewLine]"\<Chalcogens\>", \
\[IndentingNewLine]"\<Halogens\>", \[IndentingNewLine]"\<Nobel Gases\>"\
\[IndentingNewLine]};\)\)], "Input"],

Cell[BoxData[
    \(If[widechart \[Equal] 
        False, \n\(coltxt = 
          Drop[coltxt, groupdrop];\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(odat[37, i_] := 
      If[i \[LessEqual] objlen && 
          i \[GreaterEqual] \((objlen - chartwidth + 1)\), 
        coltxt[\([i - \((objlen - chartwidth)\)]\)], "\<\>"]\)], "Input"],

Cell[BoxData[
    \( (*\ Table[odat[37, i], {i, 1, 224}]\ *) \)], "Input"],

Cell[BoxData[
    \(\(odat[37, helpcell] := "\<Group Alias\>";\)\)], "Input"],

Cell[BoxData[
    \(\(ooffset[37, i_] := {0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(odir[37, i_] := {1, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[37, i_] := 
      Module[{n, clr, cw}, \[IndentingNewLine]cw = 
          chartwidth; \[IndentingNewLine]n = 
          i - \((objlen - cw)\); \[IndentingNewLine]clr = 
          FontColor \[Rule] RGBColor[0, 0, 0]; \[IndentingNewLine]If[
          n \[Equal] cw, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .5,  .8]]; \[IndentingNewLine]If[
          n \[Equal] cw - 1, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .7,  .4]]; \[IndentingNewLine]If[
          n \[Equal] cw - 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .9,  .4, 0]]; \[IndentingNewLine]If[n \[Equal] 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .4, 0,  .4]]; \[IndentingNewLine]If[n \[Equal] 1, 
          clr = FontColor \[Rule] 
              RGBColor[
                1,  .2,  .5]]; \
\[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \
\[Rule] 3, clr}]]\)], "Input"],

Cell[BoxData[
    \(oattr[37, helpcell] := 
      Module[{n, clr, cw}, \[IndentingNewLine]cw = 
          chartwidth; \[IndentingNewLine]n = 
          i - \((objlen - cw)\); \[IndentingNewLine]clr = 
          FontColor \[Rule] RGBColor[0, 0, 0]; \[IndentingNewLine]If[
          n \[Equal] cw, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .5,  .8]]; \[IndentingNewLine]If[
          n \[Equal] cw - 1, 
          clr = FontColor \[Rule] 
              RGBColor[0,  .7,  .4]]; \[IndentingNewLine]If[
          n \[Equal] cw - 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .9,  .4, 0]]; \[IndentingNewLine]If[n \[Equal] 2, 
          clr = FontColor \[Rule] 
              RGBColor[ .4, 0,  .4]]; \[IndentingNewLine]If[n \[Equal] 1, 
          clr = FontColor \[Rule] 
              RGBColor[
                1,  .2,  .5]]; \
\[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \[Rule] {FontSize \
\[Rule] 2, clr}]]\)], "Input"],

Cell[BoxData[
    \( (*\ \(If[Intersection[{n}, {32, 31, 30, 2, 1}] \[Equal] {}, 
          FontColor \[Rule] RGBColor[0, 0, 0]];\)\ *) \)], "Input"],

Cell[BoxData[
    \( (*\(Show[
          Graphics[
            Text[DisplayForm[coltxt[\([1]\)]], {1, 1}, 
              TextStyle \[Rule] {FontSize \[Rule] 12, 
                  FontColor \[Rule] 
                    RGBColor[ .9,  .4, 0]}]]];\)*) \)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["col group", "Subsection"],

Cell[CellGroupData[{

Cell["dat", "Subsubsection"],

Cell["(* use opos[ i , coltops[i] ] for placing directly above *)", "Text"],

Cell[BoxData[
    \( (*\ \(coltops = {7, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 4, 
            4, 4, 4, 4, 4, 4, 4, 4, 6, 6, 6, 6, 6, 7};\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(grptxt = {\[IndentingNewLine]"\<1a, 1\>", \[IndentingNewLine]"\<2a, 2\
\>", \[IndentingNewLine]"\<3b, 3\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<4b, 4\>", \[IndentingNewLine]"\<4b, 4\>", \
\[IndentingNewLine]"\<5b, 5\>", \[IndentingNewLine]"\<6b, 6\>", \
\[IndentingNewLine]"\<7b, 7\>", \[IndentingNewLine]"\<8,  8\>", \
\[IndentingNewLine]"\<8,  9\>", \[IndentingNewLine]"\<8,  10\>", \
\[IndentingNewLine]"\<1b, 11\>", \[IndentingNewLine]"\<2b, 12\>", \
\[IndentingNewLine]"\<3a, 13\>", \[IndentingNewLine]"\<4a 4b, 14\>", \
\[IndentingNewLine]"\<5a, 15\>", \[IndentingNewLine]"\<6a, 16\>", \
\[IndentingNewLine]"\<7a, 17\>", \[IndentingNewLine]"\<8a-0, 18\>"\
\[IndentingNewLine]};\)\)], "Input"],

Cell[BoxData[
    \(If[widechart \[Equal] 
        False, \n\(grptxt = 
          Drop[grptxt, groupdrop];\)\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(odat[38, i_] := 
      If[i \[LessEqual] objlen && 
          i \[GreaterEqual] \((objlen - chartwidth + 1)\), 
        grptxt[\([i - \((objlen - chartwidth)\)]\)], "\<\>"]\)], "Input"],

Cell[BoxData[
    \( (*\ Table[odat[38, i], {i, 1, 224}]\ *) \)], "Input"],

Cell[BoxData[
    \(\(odat[38, helpcell] := "\<Group old ref, new\>";\)\)], "Input"],

Cell[BoxData[
    \(\(ooffset[38, i_] := {0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(odir[38, i_] := {1, 0};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["attr", "Subsubsection"],

Cell[BoxData[
    \(oattr[38, 
        i_] := \[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \
\[Rule] {FontSize \[Rule] 3}]\)], "Input"],

Cell[BoxData[
    \(oattr[38, 
        helpcell] := \[IndentingNewLine]Sequence[\[IndentingNewLine]TextStyle \
\[Rule] {FontSize \[Rule] 2}]\)], "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["layout and Graphics setup", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["define funs (geninit, boxpt, snaptxt, printcell, etc)", "Subsection",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["DISCUSS  layout of data", "Subsubsection"],

Cell["\<\
big note is odta gets wrapped  DisplayForm [ odat ... ]
\twhich should only help not hurt with reliable layout

\t\t--> it is NOT required , should not be relied on
\t\t and if found to be problematic can be removed\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxpts[ cent , sc , .... , two? ]
boxgr[ boxpts ]\
\>", "Subsubsection"],

Cell[BoxData[
    \(\(boxpts[cent_, sc_, ul_, ll_, lr_, ur_, two_:  True] := \ 
        Module[{pt}, \[IndentingNewLine]pt = {cent + ul\ sc, cent + ll\ sc, 
              cent + lr\ sc, cent\  + ur\ sc, 
              cent + ul\ sc}\ ; \[IndentingNewLine]If[
            two === True, \[IndentingNewLine]Delete[
              pt, \[IndentingNewLine]{{1, 2}, {2, 2}, {3, 2}, {4, 2}, {5, 
                  2}}\[IndentingNewLine]]\[IndentingNewLine], 
            pt]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(boxgr[boxpts_] := 
      Graphics[{\[IndentingNewLine]Thickness[ .0001], 
          RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[
            boxpts]\[IndentingNewLine]}]\)], "Input"],

Cell[BoxData[
    \(boxgr3D[boxpts_] := 
      Graphics3D[{\[IndentingNewLine]Thickness[ .0001], 
          RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[
            boxpts]\[IndentingNewLine]}]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxcurvecorners2D[ pt , linemul, curvemul ]
no 3D , uses Spline of type Graphic\
\>", "Subsubsection"],

Cell["\<\
lovely but spline, if portable, only works with Graphics, do a 3D \
plot and cols could loose boxes.  this is \"liveable\" for legends but would \
be a pain for col headers\
\>", "Text"],

Cell[BoxData[
    \(boxcurvecorners2D[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, \(-dh\)}; \
\[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 
            0}; \[IndentingNewLine]\[IndentingNewLine]s1 = {l1[\([2]\)], \
\((l1[\([2]\)] + l2[\([1]\)])\)/2, 
            l2[\([1]\)]}; \[IndentingNewLine]s2 = {l2[\([2]\)], \
\((l2[\([2]\)] + l3[\([1]\)])\)/2, 
            l3[\([1]\)]}; \[IndentingNewLine]s3 = {l3[\([2]\)], \
\((l3[\([2]\)] + l4[\([1]\)])\)/2, 
            l4[\([1]\)]}; \[IndentingNewLine]s4 = {l4[\([2]\)], \
\((l4[\([2]\)] + l1[\([1]\)])\)/2, 
            l1[\([1]\)]}; \[IndentingNewLine]s1[\([2]\)] += {\(-dw\), \
\(-dh\)}/curvemul; \[IndentingNewLine]s2[\([2]\)] += {dw, \(-dh\)}/
            curvemul; \[IndentingNewLine]s3[\([2]\)] += {dw, dh}/
            curvemul; \[IndentingNewLine]s4[\([2]\)] += {\(-dw\), dh}/
            curvemul; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = Line[l4]; \[IndentingNewLine]s1 = 
          Spline[s1, CompositeBezier]; \[IndentingNewLine]s2 = 
          Spline[s2, CompositeBezier]; \[IndentingNewLine]s3 = 
          Spline[s3, CompositeBezier]; \[IndentingNewLine]s4 = 
          Spline[s4, 
            CompositeBezier]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          Graphics[{l1, l2, l3, l4, \ s1, s2, s3, 
              s4}]\ *) \[IndentingNewLine]{l1, s1, l2, s2, l3, s3, l4, 
          s4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxcurvecorners2D[
          v,  .1, 2]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Show[Graphics[%]];\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxnocorners[ pt , linemul, curvemul ]
 is 2D or 3D dep. on pt\
\>", "Subsubsection"],

Cell[BoxData[
    \(boxnocorners3D[pt_, linemul_, 
        curvemul___] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, 0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 0, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, 
            0, \(-dh\)}; \[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 0, 
            0}; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = 
          Line[l4]; \[IndentingNewLine]\[IndentingNewLine]{l1, l2, l3, 
          l4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxnocorners2D[pt_, linemul_, 
        curvemul___] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, \(-dh\)}; \
\[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 
            0}; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = 
          Line[l4]; \[IndentingNewLine]\[IndentingNewLine]{l1, l2, l3, 
          l4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxnocorners[pt_, linemul_, 
        curvemul___] := \(If[Length[pt[\([1]\)]] === 2, boxnocorners2D, 
          boxnocorners3D]\)[pt, linemul]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxnocorners[
          v,  .1]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics[%]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.485622 0.0340136 -0.298023 0.0173119 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .54446 m
.02381 .07358 L
s
.11905 .01472 m
.88095 .01472 L
s
.97619 .07358 m
.97619 .54446 L
s
.88095 .60332 m
.11905 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo000RoooK000Sool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<0
0?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`ko
o`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3o
ool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?oo
ool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03
003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007
ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Ko
o`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00oooo
o`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo000RoooK000Sool00?oo
ob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {14.2408, 17.2147, 0.102693, \
0.201767}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics[{First[%%], Take[%%, \(-2\)]}]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.485622 0.0340136 -0.398172 0.0192354 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .53792 m
.02381 .01472 L
s
.97619 .01472 m
.97619 .53792 L
s
.88095 .60332 m
.11905 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo000RoooK000Sool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {14.2408, 20.6998, 0.102693, \
0.18159}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            False]; \[IndentingNewLine]\[IndentingNewLine]boxnocorners[
          v,  .1]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics3D[%]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.29616 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.192623 1.34078 -0.0446149 1.34078 [
[ 0 0 0 0 ]
[ 1 1.29616 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.04124 1.29616 L
s
.04124 1.29616 m
.10811 .33677 L
s
.10811 .33677 m
.07399 .30079 L
s
.88524 0 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.88524 0 m
.07399 .30079 L
s
.10811 .33677 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.04124 1.29616 L
s
.04124 1.29616 m
.10811 .33677 L
s
0 0 m
1 0 L
1 1.29616 L
0 1.29616 L
closepath
clip
newpath
.5 Mabswid
.17917 .3056 m
.79667 .07963 L
s
.05078 1.14299 m
.10192 .41117 L
s
.88635 .13085 m
.94753 .89401 L
s
.85687 1.03228 m
.12702 1.22646 L
s
.25 Mabswid
.88524 0 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.88524 0 m
.07399 .30079 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{222.188, 287.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003N00017a000`40n007h00O`_oo0P006_oo002o
ool300000ooo0000000Iool00;goo`8000Coo`8001Woo`00^_oo0`001_oo00<00?oo00006?oo002g
ool30009ool01000ooooo`005ooo002eool2000<ool01000ooooo`005ooo002bool3000?ool01000
ooooo`005_oo002_ool3000Bool01@00oooooooo00005Ooo002/ool3000Eool01@00oooooooo0000
5Ooo002Zool2000Hool01000oooooooo0P005?oo002Wool3000Jool400000ooo003oo`0Cool00:Co
o`<001coo`8000Coo`03003ooooo01;oo`00X_oo0P007?oo0`0000?oo`00ool00ooo00<00?ooool0
4_oo002Oool3000Kool30004ool00`00ooooo`02ool00`00ooooo`0Bool009coo`<001_oo`<000Oo
o`03003ooooo00;oo`03003ooooo01;oo`00VOoo0`007?oo0P002_oo00<00?ooool00ooo00<00?oo
ool04Ooo002Gool2000Lool3000<ool00`00ooooo`03ool00`00ooooo`0Aool009Coo`<001Soo`80
0004ool00000000?ool00`00ooooo`03ool00`00ooooo`0Aool0097oo`<001Soo`H001?oo`03003o
oooo00;oo`03003ooooo017oo`00Sooo0P006Ooo0P0000?oo`0000005_oo00<00?ooool00_oo00<0
0?ooool04Ooo002<ool3000Hool6000Hool00`00ooooo`02ool00`00ooooo`0Aool008Woo`<001So
o`H001_oo`03003ooooo00;oo`03003ooooo017oo`00Q_oo0`006?oo0`0000?oo`0000007_oo00<0
0?ooool00_oo00<00?ooool04Ooo0024ool2000Iool200001?oo000000008?oo00<00?ooool00_oo
00<00?ooool04Ooo0021ool3000Hool6000Sool00`00ooooo`02ool00`00ooooo`0Aool007koo`<0
01Soo`H002Koo`03003ooooo00;oo`03003ooooo017oo`00O?oo0P006?oo0`0000?oo`000000:Ooo
00<00?ooool00ooo00<00?ooool04?oo001iool3000Hool200001?oo00000000:ooo00<00?ooool0
0ooo00<00?ooool04?oo001fool3000Hool6000^ool00`00ooooo`03ool00`00ooooo`0@ool007?o
o`<001Soo`H0033oo`8000Goo`03003ooooo013oo`00LOoo0P006Ooo0P0000?oo`000000<ooo00<0
0?oo00001?oo00<00?ooool04?oo001^ool3000Hool6000eool00`00ool00004ool00`00ooooo`0@
ool006_oo`<001Soo`H003Soo`03003oo`0000Coo`03003ooooo013oo`00JOoo0P006?oo1P00>ooo
00<00?oo00001?oo00<00?ooool04?oo001Vool3000Hool200000ooo0000000nool00`00ool00004
ool00`00ooooo`0@ool006?oo`<001Soo`H0043oo`03003oo`0000Coo`03003ooooo013oo`00HOoo
0P006?oo1P00A?oo0P001?oo00<00?ooool04?oo001Nool3000Gool60017ool20005ool00`00oooo
o`0?ool005_oo`<001Soo`800003ool0000004[oo`8000Goo`03003ooooo00ooo`00F?oo0`006?oo
1P00C?oo0P001Ooo00<00?ooool03ooo001Fool2000Hool6001?ool20005ool00`00ooooo`0?ool0
05?oo`<001Ooo`H005;oo`8000Goo`03003ooooo00ooo`00D?oo0`006?oo0P0000?oo`000000EOoo
00<00?oo00001?oo00<00?ooool03ooo001>ool2000Hool6001Gool00`00ool00004ool00`00oooo
o`0?ool004_oo`<001Ooo`H005[oo`03003oo`0000Coo`03003ooooo00ooo`00B?oo0`005ooo0`00
00?oo`000000GOoo00<00?oo00001?oo00<00?ooool03ooo0015ool3000Hool200001?oo00000000
Gooo00<00?oo00001?oo00<00?ooool03ooo0013ool2000Hool6001Rool00`00ool00004ool00`00
ooooo`0?ool0043oo`<001Ooo`H006Goo`03003oo`0000Goo`03003ooooo00koo`00?Ooo0`005ooo
0`0000?oo`000000JOoo0P001Ooo00<00?ooool03_oo000kool2000Hool200001?oo00000000Jooo
0P001Ooo00<00?ooool03_oo000hool3000Gool6001^ool20005ool00`00ooooo`0>ool003Goo`<0
01Ooo`H0077oo`8000Goo`03003ooooo00koo`00<_oo0`005ooo0`0000?oo`000000M?oo00<00?oo
00001?oo00<00?ooool03_oo000`ool2000Hool200001?oo00000000M_oo00<00?oo00001?oo00<0
0?ooool03_oo000]ool3000Gool6001iool00`00ool00004ool00`00ooooo`0>ool002[oo`<001Oo
o`H007coo`03003oo`0000Coo`03003ooooo00koo`00:?oo0P006?oo0P0000?oo`000000Oooo00<0
0?oo00001?oo00<00?ooool03_oo000Uool3000Gool60021ool00`00ool00004ool00`00ooooo`0>
ool002;oo`<001Ooo`H008Coo`03003oo`0000Goo`03003ooooo00goo`007ooo0`005ooo1P00Qooo
00<00?oo00001Ooo00<00?ooool03Ooo000Mool2000Hool200000ooo0000002:ool00`00ool00005
ool00`00ooooo`0=ool001[oo`<001Ooo`H008goo`8000Goo`03003ooooo00goo`005ooo0`005ooo
1P00T?oo0P001Ooo00<00?ooool03Ooo000Eool2000Gool300000ooo0000002Cool20005ool00`00
ooooo`0=ool001;oo`<001Ooo`800004ool00000002Eool00`00ool00004ool00`00ooooo`0=ool0
013oo`8001Ooo`H009Soo`03003oo`0000Coo`03003ooooo00goo`004?oo0P005Ooo1@00Vooo00<0
0?oo00001?oo00<00?ooool03Ooo000@ool00`00ool0000Dool2002Nool00`00ool00004ool00`00
ooooo`0=ool0013oo`04003ooooo000@ool3002Pool00`00ool00004ool00`00ooooo`0=ool0013o
o`04003ooooo000=ool3002Sool00`00ool00004ool00`00ooooo`0=ool0013oo`05003oooooool0
0009ool3002Vool00`00ool00005ool00`00ooooo`0<ool0013oo`03003ooooo00;oo`03003ooooo
00Coo`800:Woo`03003oo`0000Goo`03003ooooo00coo`003ooo00<00?ooool01?oo00<00?ooool0
0`00Zooo00<00?oo00001Ooo00<00?ooool03?oo000?ool00`00ooooo`05ool2002^ool00`00ool0
0005ool00`00ooooo`0<ool000ooo`03003ooooo00Goo`03003ooooo0:koo`8000Goo`03003ooooo
00coo`003ooo00<00?ooool01Ooo00<00?ooool0[_oo0P001Ooo00<00?ooool03?oo000?ool00`00
ooooo`05ool00`00ooooo`2^ool00`00ool00004ool00`00ooooo`0<ool000ooo`03003ooooo00Go
o`03003ooooo0:koo`03003oo`0000Coo`03003ooooo00coo`003ooo00<00?ooool01Ooo00<00?oo
ool0[_oo00<00?oo00001?oo00<00?ooool03?oo000?ool00`00ooooo`05ool00`00ooooo`2^ool0
0`00ool00004ool00`00ooooo`0<ool000ooo`03003ooooo00Goo`03003ooooo0:koo`03003oo`00
00Coo`03003ooooo00coo`003ooo00<00?ooool01?oo00<00?ooool0[ooo00<00?oo00001Ooo00<0
0?ooool02ooo000?ool00`00ooooo`04ool00`00ooooo`2_ool00`00ool00005ool00`00ooooo`0;
ool000ooo`03003ooooo00Coo`03003ooooo0:ooo`03003oo`0000Goo`03003ooooo00_oo`003ooo
00<00?ooool01?oo00<00?ooool0[ooo00<00?oo00001Ooo00<00?ooool02ooo000?ool00`00oooo
o`04ool00`00ooooo`2_ool00`00ool00005ool00`00ooooo`0;ool000koo`03003ooooo00Goo`03
003ooooo0:ooo`03003oo`0000Goo`03003ooooo00_oo`003_oo00<00?ooool01Ooo00<00?ooool0
/?oo0P001Ooo00<00?ooool02ooo000>ool00`00ooooo`05ool00`00ooooo`2`ool00`00ool00004
ool00`00ooooo`0;ool000koo`03003ooooo00Goo`03003ooooo0;3oo`03003oo`0000Coo`03003o
oooo00_oo`003_oo00<00?ooool01Ooo00<00?ooool0/?oo00<00?oo00001?oo00<00?ooool02ooo
000>ool00`00ooooo`05ool00`00ooooo`2`ool00`00ool00004ool00`00ooooo`0;ool000koo`03
003ooooo00Goo`03003ooooo0;3oo`03003oo`0000Goo`03003ooooo00[oo`003_oo00<00?ooool0
1Ooo00<00?ooool0/?oo00<00?oo00001Ooo00<00?ooool02_oo000>ool00`00ooooo`05ool00`00
ooooo`2`ool00`00ool00005ool00`00ooooo`0:ool000koo`03003ooooo00Goo`03003ooooo0;3o
o`03003oo`0000Goo`03003ooooo00[oo`003_oo00<00?ooool01?oo0P00/_oo00<00?oo00001Ooo
00<00?ooool02_oo000>ool00`00ooooo`04ool2002bool00`00ool00005ool00`00ooooo`0:ool0
00koo`03003ooooo00Coo`03003ooooo0;7oo`03003oo`0000Goo`03003ooooo00[oo`003Ooo00<0
0?ooool01Ooo00<00?ooool0/Ooo00@00?ooool000Coo`03003ooooo00[oo`003Ooo00<00?ooool0
1Ooo00<00?ooool0/_oo00<00?oo00001?oo00<00?ooool02_oo000=ool00`00ooooo`05ool00`00
ooooo`2bool00`00ool00004ool00`00ooooo`0:ool000goo`03003ooooo00Goo`03003ooooo0;;o
o`03003oo`0000Coo`03003ooooo00[oo`003Ooo00<00?ooool01Ooo00<00?ooool0/_oo00<00?oo
00001Ooo00<00?ooool02Ooo000=ool00`00ooooo`05ool00`00ooooo`2bool00`00ool00005ool0
0`00ooooo`09ool000goo`03003ooooo00Goo`03003ooooo0;;oo`03003oo`0000Goo`03003ooooo
00Woo`003Ooo00<00?ooool01Ooo00<00?ooool0/_oo00<00?oo00001Ooo00<00?ooool02Ooo000=
ool00`00ooooo`05ool00`00ooooo`2bool00`00ool00005ool00`00ooooo`09ool000goo`03003o
oooo00Goo`03003ooooo0;;oo`03003oo`0000Goo`03003ooooo00Woo`003Ooo00<00?ooool01Ooo
00<00?ooool0/_oo00<00?oo00001Ooo00<00?ooool02Ooo000=ool00`00ooooo`05ool00`00oooo
o`2bool00`00ool00005ool00`00ooooo`09ool000goo`03003ooooo00Coo`800;Coo`04003ooooo
0004ool00`00ooooo`09ool000coo`03003ooooo00Goo`03003ooooo0;?oo`04003ooooo0004ool0
0`00ooooo`09ool000coo`03003ooooo00Goo`03003ooooo0;Coo`03003oo`0000Coo`03003ooooo
00Woo`003?oo00<00?ooool01Ooo00<00?ooool0]?oo00<00?oo00001Ooo00<00?ooool02?oo000<
ool00`00ooooo`05ool00`00ooooo`2dool00`00ool00005ool00`00ooooo`08ool000coo`03003o
oooo00Goo`03003ooooo0;Coo`03003oo`0000Goo`03003ooooo00Soo`003?oo00<00?ooool01Ooo
00<00?ooool0]?oo00<00?oo00001Ooo00<00?ooool02?oo000<ool00`00ooooo`05ool00`00oooo
o`2dool00`00ool00005ool00`00ooooo`08ool000coo`03003ooooo00Goo`03003ooooo0;Coo`03
003oo`0000Goo`03003ooooo00Soo`003?oo00<00?ooool01Ooo00<00?ooool0]?oo00<00?oo0000
1Ooo00<00?ooool02?oo000<ool00`00ooooo`05ool00`00ooooo`2dool00`00ool00005ool00`00
ooooo`08ool000coo`03003ooooo00Goo`03003ooooo0;Coo`03003oo`0000Goo`03003ooooo00So
o`003?oo00<00?ooool01Ooo00<00?ooool0]?oo00@00?ooool000Coo`03003ooooo00Soo`003?oo
00<00?ooool01Ooo00<00?ooool0]?oo00@00?ooool000Coo`03003ooooo00Soo`003?oo00<00?oo
ool01Ooo00<00?ooool0]Ooo00<00?oo00001Ooo00<00?ooool01ooo000;ool00`00ooooo`06ool0
0`00ooooo`2eool00`00ool00005ool00`00ooooo`07ool000_oo`03003ooooo00Goo`03003ooooo
0;Koo`03003oo`0000Goo`03003ooooo00Ooo`002ooo00<00?ooool01Ooo00<00?ooool0]_oo00<0
0?oo00001Ooo00<00?ooool01ooo000;ool00`00ooooo`05ool00`00ooooo`2fool00`00ool00005
ool00`00ooooo`07ool000_oo`03003ooooo00Goo`03003ooooo0;Koo`03003oo`0000Goo`03003o
oooo00Ooo`002ooo00<00?ooool01Ooo00<00?ooool0]_oo00<00?oo00001Ooo00<00?ooool01ooo
000;ool00`00ooooo`05ool00`00ooooo`2fool00`00ool00005ool00`00ooooo`07ool000_oo`03
003ooooo00Goo`03003ooooo0;Koo`03003oo`0000Goo`03003ooooo00Ooo`002ooo00<00?ooool0
1Ooo00<00?ooool0]_oo00@00?ooool000Coo`03003ooooo00Ooo`002ooo00<00?ooool01Ooo00<0
0?ooool0]_oo00@00?ooool000Coo`03003ooooo00Ooo`002ooo00<00?ooool01Ooo00<00?ooool0
]_oo00@00?ooool000Goo`03003ooooo00Koo`002ooo00<00?ooool01Ooo00<00?ooool0]_oo00@0
0?ooool000Goo`03003ooooo00Koo`002ooo00<00?ooool01Ooo00<00?ooool0]ooo00<00?oo0000
1Ooo00<00?ooool01_oo000:ool00`00ooooo`06ool00`00ooooo`2gool00`00ool00005ool00`00
ooooo`06ool000[oo`03003ooooo00Koo`03003ooooo0;Ooo`03003oo`0000Goo`03003ooooo00Ko
o`002_oo00<00?ooool01_oo00<00?ooool0]ooo00<00?oo00001Ooo00<00?ooool01_oo000:ool0
0`00ooooo`05ool00`00ooooo`2hool00`00ool00005ool00`00ooooo`06ool000[oo`03003ooooo
00Goo`03003ooooo0;Soo`03003oo`0000Goo`03003ooooo00Koo`002_oo00<00?ooool01Ooo00<0
0?ooool0^?oo00<00?oo00001Ooo00<00?ooool01_oo000:ool00`00ooooo`05ool00`00ooooo`2h
ool00`00ool00005ool00`00ooooo`06ool000[oo`03003ooooo00Goo`03003ooooo0;Soo`04003o
oooo0004ool00`00ooooo`06ool000[oo`03003ooooo00Goo`03003ooooo0;Soo`04003ooooo0005
ool00`00ooooo`05ool000[oo`03003ooooo00Goo`03003ooooo0;Soo`04003ooooo0005ool00`00
ooooo`05ool000[oo`03003ooooo00Goo`03003ooooo0;Soo`04003ooooo0005ool00`00ooooo`05
ool000[oo`03003ooooo00Goo`03003ooooo0;Soo`04003ooooo0005ool00`00ooooo`05ool000[o
o`03003ooooo00Goo`03003ooooo0;Woo`03003oo`0000Goo`03003ooooo00Goo`002Ooo00<00?oo
ool01_oo00<00?ooool0^Ooo00<00?oo00001Ooo00<00?ooool01Ooo0009ool00`00ooooo`06ool0
0`00ooooo`2iool00`00ool00005ool00`00ooooo`05ool000Woo`03003ooooo00Koo`03003ooooo
0;Woo`03003oo`0000Goo`03003ooooo00Goo`002Ooo00<00?ooool01_oo00<00?ooool0^Ooo00<0
0?oo00001Ooo00<00?ooool01Ooo0009ool00`00ooooo`05ool2002kool00`00ool00005ool00`00
ooooo`05ool000Woo`03003ooooo00Goo`03003ooooo0;[oo`03003oo`0000Goo`03003ooooo00Go
o`002Ooo00<00?ooool01Ooo00<00?ooool0^_oo00@00?ooool000Goo`03003ooooo00Coo`002Ooo
00<00?ooool01Ooo00<00?ooool0^_oo00@00?ooool000Goo`03003ooooo00Coo`002Ooo00<00?oo
ool01Ooo00<00?ooool0^_oo00@00?ooool000Goo`03003ooooo00Coo`002Ooo00<00?ooool01Ooo
00<00?ooool0^_oo00@00?ooool000Goo`03003ooooo00Coo`002Ooo00<00?ooool01Ooo00<00?oo
ool0^_oo00@00?ooool000Goo`03003ooooo00Coo`002Ooo00<00?ooool01Ooo00<00?ooool0^_oo
00@00?ooool000Goo`03003ooooo00Coo`002Ooo00<00?ooool01Ooo00<00?ooool0^ooo00<00?oo
00001Ooo00<00?ooool01?oo0009ool00`00ooooo`05ool00`00ooooo`2kool00`00ool00005ool0
0`00ooooo`04ool000Soo`03003ooooo00Koo`03003ooooo0;_oo`03003oo`0000Goo`03003ooooo
00Coo`002?oo00<00?ooool01_oo00<00?ooool0^ooo00<00?oo00001Ooo00<00?ooool01?oo0008
ool00`00ooooo`06ool00`00ooooo`2kool00`00ool00005ool00`00ooooo`04ool000Soo`03003o
oooo00Koo`03003ooooo0;_oo`03003oo`0000Koo`03003ooooo00?oo`002?oo00<00?ooool01_oo
00<00?ooool0^ooo00@00?ooool000Goo`03003ooooo00?oo`002?oo00<00?ooool01Ooo0P00_Ooo
00@00?ooool000Goo`03003ooooo00?oo`002?oo00<00?ooool01Ooo00<00?ooool0_?oo00@00?oo
ool000Goo`03003ooooo00?oo`002?oo00<00?ooool01Ooo00<00?ooool0_?oo00@00?ooool000Go
o`03003ooooo00?oo`002?oo00<00?ooool01Ooo00<00?ooool0_?oo00@00?ooool000Goo`03003o
oooo00?oo`002?oo00<00?ooool01Ooo00<00?ooool0_?oo00@00?ooool000Goo`03003ooooo00?o
o`002?oo00<00?ooool01Ooo00<00?ooool0_?oo00@00?ooool000Goo`03003ooooo00?oo`002?oo
00<00?ooool01Ooo00<00?ooool0_Ooo00<00?oo00001Ooo00<00?ooool00ooo0008ool00`00oooo
o`05ool00`00ooooo`2mool00`00ool00005ool00`00ooooo`03ool000Ooo`03003ooooo00Koo`03
003ooooo0;goo`03003oo`0000Goo`03003ooooo00?oo`001ooo00<00?ooool01_oo00<00?ooool0
_Ooo00<00?oo00001Ooo00<00?ooool00ooo0007ool00`00ooooo`06ool00`00ooooo`2mool01000
ooooo`001Ooo00<00?ooool00_oo0007ool00`00ooooo`06ool00`00ooooo`2mool01000ooooo`00
1Ooo00<00?ooool00_oo0007ool00`00ooooo`06ool00`00ooooo`2mool01000ooooo`001Ooo00<0
0?ooool00_oo0007ool00`00ooooo`06ool00`00ooooo`2mool01000ooooo`001Ooo00<00?ooool0
0_oo0007ool00`00ooooo`06ool00`00ooooo`2mool01000ooooo`001Ooo00<00?ooool00_oo0007
ool00`00ooooo`05ool2002oool01000ooooo`001Ooo00<00?ooool00_oo0007ool00`00ooooo`05
ool00`00ooooo`2nool01000ooooo`001Ooo00<00?ooool00_oo0007ool00`00ooooo`05ool00`00
ooooo`2nool01000ooooo`001Ooo00<00?ooool00_oo0007ool00`00ooooo`05ool00`00ooooo`2n
ool01000ooooo`001Ooo00<00?ooool00_oo0007ool00`00ooooo`05ool00`00ooooo`2oool00`00
ool00005ool00`00ooooo`02ool000Ooo`03003ooooo00Goo`03003ooooo0;ooo`03003oo`0000Go
o`03003ooooo00;oo`001ooo00<00?ooool01Ooo00<00?ooool0_ooo00<00?oo00001_oo00<00?oo
ool00Ooo0006ool00`00ooooo`06ool00`00ooooo`2oool01000ooooo`001Ooo00<00?ooool00Ooo
0006ool00`00ooooo`06ool00`00ooooo`2oool01000ooooo`001Ooo00<00?ooool00Ooo0006ool0
0`00ooooo`06ool00`00ooooo`2oool01000ooooo`001Ooo00<00?ooool00Ooo0006ool00`00oooo
o`06ool00`00ooooo`2oool01000ooooo`001Ooo00<00?ooool00Ooo0006ool00`00ooooo`06ool0
0`00ooooo`32ool00`00ooooo`03ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo
0<;oo`03003ooooo00?oo`03003ooooo007oo`001_oo00<00?ooool01_oo00<00?ooool0`_oo00<0
0?ooool00ooo00<00?ooool00Ooo0006ool00`00ooooo`05ool20034ool00`00ooooo`03ool00`00
ooooo`01ool000Koo`03003ooooo00Goo`800<Coo`03003ooooo00?oo`03003ooooo007oo`001_oo
00<00?ooool01Ooo00<00?ooool0`ooo00<00?ooool00ooo00<00?ooool00Ooo0006ool00`00oooo
o`05ool00`00ooooo`33ool00`00ooooo`04ool10001ool1ool000Koo`03003ooooo00Goo`03003o
oooo0<?oo`03003ooooo00Coo`40007oo`7oo`001_oo00<00?ooool01Ooo00<00?ooool0a?oo00<0
0?ooool00ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`34ool00`00ooooo`03ool1
0001ool1ool000Goo`03003ooooo00Koo`03003ooooo0<Coo`03003ooooo00?oo`40007oo`7oo`00
1Ooo00<00?ooool01_oo00<00?ooool0a?oo00<00?ooool00ooo0@000Ooo0Ooo0005ool00`00oooo
o`06ool00`00ooooo`34ool00`00ooooo`03ool10001ool1ool000Goo`03003ooooo00Koo`03003o
oooo0<Coo`03003ooooo00?oo`40007oo`7oo`001Ooo00<00?ooool01_oo00<00?ooool0a?oo00<0
0?ooool00ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`34ool00`00ooooo`03ool1
0001ool1ool000Goo`03003ooooo00Koo`03003ooooo0<Coo`03003ooooo00?oo`40007oo`7oo`00
1Ooo00<00?ooool01_oo00<00?ooool0a?oo00<00?ooool01?oo0@000Ooo0005ool00`00ooooo`05
ool20036ool00`00ooooo`04ool10001ool000Goo`03003ooooo00Goo`800<Koo`03003ooooo00Co
o`40007oo`001Ooo00<00?ooool01Ooo00<00?ooool0a_oo00<00?ooool00ooo0@000Ooo0005ool0
0`00ooooo`05ool00`00ooooo`36ool00`00ooooo`03ool10001ool000Coo`03003ooooo00Koo`03
003ooooo0<Koo`03003ooooo00?oo`40007oo`001?oo00<00?ooool01_oo00<00?ooool0a_oo00<0
0?ooool00ooo0@000Ooo0004ool00`00ooooo`06ool00`00ooooo`36ool00`00ooooo`03ool10001
ool000Coo`03003ooooo00Koo`03003ooooo0<Goo`8000Goo`40007oo`001?oo00<00?ooool01_oo
00<00?ooool0`Ooo10000_oo00<00?ooool00_oo0@000Ooo0004ool00`00ooooo`06ool00`00oooo
o`2mool40007ool01@00oooooooo00000Ooo0004ool00`00ooooo`06ool00`00ooooo`2iool4000<
ool01000oooooooo0@000004ool00`00ooooo`06ool00`00ooooo`2fool3000@ool01000oooooooo
0@000004ool00`00ooooo`06ool00`00ooooo`2/ool20004ool4000Dool00`00ooooo`01000000Co
o`03003ooooo00Koo`03003ooooo0:Soo`@000;oo`@001Woo`40007oo`4000001?oo00<00?ooool0
1_oo00<00?ooool0Y?oo10000_oo10007_oo0P000004ool00`00ooooo`05ool2002Rool40003ool3
000Rool2000000Coo`03003ooooo00Goo`8009ooo`<000?oo`@0027oo`@000;oo`001?oo00<00?oo
ool01Ooo0P00Vooo10000_oo10008Ooo10001_oo0003ool00`00ooooo`06ool00`00ooooo`2Fool4
0002ool4000Qool4000:ool000?oo`03003ooooo00Koo`03003ooooo09;oo`@000?oo`<0027oo`@0
00koo`000ooo00<00?ooool01_oo00<00?ooool0Sooo0`000ooo10008?oo10004_oo0003ool00`00
ooooo`06ool00`00ooooo`2;ool40002ool4000Pool4000Fool000?oo`03003ooooo00Koo`03003o
oooo08Ooo`@000;oo`@0027oo`<001[oo`000ooo00<00?ooool01_oo00<00?ooool0Pooo10000ooo
0`008Ooo10007Ooo0003ool00`00ooooo`06ool00`00ooooo`20ool30003ool4000Pool4000Qool0
00?oo`03003ooooo00Koo`03003ooooo07coo`@000;oo`@0023oo`@002Goo`000ooo00<00?ooool0
1_oo00<00?ooool0N?oo10000_oo10008?oo1000:Ooo0003ool00`00ooooo`06ool00`00ooooo`1d
ool40003ool3000Pool4000]ool000?oo`03003ooooo00Koo`03003ooooo077oo`<000?oo`@001oo
o`@0037oo`000ooo00<00?ooool01Ooo0P00Kooo10000_oo10008?oo0`00=Ooo0003ool00`00oooo
o`05ool2001[ool40002ool4000Pool4000hool000;oo`03003ooooo00Koo`8006Ooo`@000?oo`<0
023oo`@003coo`000_oo00<00?ooool01_oo0P00I?oo0`000ooo10007ooo1000@?oo0002ool00`00
ooooo`06ool00`00ooooo`1Oool40002ool4000Oool40014ool000;oo`03003ooooo00Koo`03003o
oooo05_oo`@000;oo`@001ooo`@004Soo`000_oo00<00?ooool01_oo00<00?ooool0F?oo0`000_oo
10007ooo1000C?oo0002ool00`00ooooo`06ool00`00ooooo`1Dool40002ool3000Pool3001@ool0
00;oo`03003ooooo00Koo`03003ooooo053oo`@000;oo`@001ooo`@005?oo`000_oo00<00?ooool0
1_oo00<00?ooool0C?oo10000_oo10007ooo1000Eooo0002ool00`00ooooo`06ool00`00ooooo`19
ool30002ool4000Oool4001Kool000;oo`03003ooooo00Koo`03003ooooo04Goo`@000;oo`<001oo
o`@005ooo`000_oo00<00?ooool01_oo00<00?ooool0@Ooo10000_oo10007_oo1000Hooo0002ool0
0`00ooooo`06ool00`00ooooo`0mool40002ool4000Nool4001Wool000;oo`03003ooooo00Koo`03
003ooooo03[oo`<000;oo`@001ooo`<006_oo`0000?oo`00ool02?oo00<00?ooool0=_oo10000_oo
0`007ooo1000K_oo00000ooo003oo`08ool00`00ooooo`0bool40002ool4000Nool4001bool00003
ool00?oo00Soo`03003ooooo02koo`@000;oo`@001koo`@007Koo`0000?oo`00ool02?oo00<00?oo
ool0:ooo0`000_oo10007_oo1000N_oo00000ooo003oo`07ool00`00ooooo`0Xool40002ool3000N
ool4001nool00003ool00?oo00Ooo`03003ooooo02Coo`@000;oo`@001koo`<008;oo`0000?oo`00
ool01ooo00<00?ooool08?oo10000_oo10007_oo1000QOoo00000ooo003oo`07ool00`00ooooo`0M
ool30002ool4000Nool40029ool00003ool00?oo00Ooo`03003ooooo01Woo`@000;oo`<001koo`@0
08goo`0000?oo`00ool01ooo00<00?ooool05Ooo10000_oo10007Ooo1000TOoo00000ooo003oo`07
ool00`00ooooo`0Aool40002ool4000Mool4002Eool00003ool00?oo00Ooo`03003ooooo00ooo`80
00;oo`@001goo`@009Woo`0000?oo`00ool01ooo00<00?ooool04?oo0`007_oo0`00WOoo00000ooo
003oo`07ool00`00ooooo`0<ool4000Mool4002Pool00003003ooooo00Ooo`03003ooooo00Soo`@0
01goo`@00:Coo`0000<00?ooool01ooo00<00?ooool01?oo10007Ooo1000Z?oo00000`00ooooo`07
ool01000oooooooo0`007Ooo1000[?oo00000`00ooooo`07ool4000Lool4002`ool00003003ooooo
00?oo`D001_oo`@00;Coo`0000<00?oo00000`000ooo00<00?ooool05ooo0`00^?oo00020007ool0
0`00ooooo`0Cool4002kool00003ool0000000Koo`03003ooooo00ooo`@00;ooo`000ooo00<00?oo
ool00ooo00<00?ooool02ooo1000`ooo0004ool20003ool00`00ooooo`07ool40037ool000Koo`04
003ooooo0005ool4003;ool000Ooo`<00003ool0000000800<ooo`002Ooo0P00dooo0000\
\>"],
  ImageRangeCache->{{{0, 221.188}, {286.938, 0}} -> {0.143661, 0.0328606, \
0.00337199, 0.00337199}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxwithcorners[ pt , linemul, curvemul ]
 is 2D or 3D dep. on pt\
\>", "Subsubsection"],

Cell[BoxData[
    \(boxwithcorners3D[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, 0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 0, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, 
            0, \(-dh\)}; \[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 0, 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 0, 
            0}; \[IndentingNewLine]\[IndentingNewLine]s1 = {l1[\([2]\)], \
\((l1[\([2]\)] + l2[\([1]\)])\)/2, 
            l2[\([1]\)]}; \[IndentingNewLine]s2 = {l2[\([2]\)], \
\((l2[\([2]\)] + l3[\([1]\)])\)/2, 
            l3[\([1]\)]}; \[IndentingNewLine]s3 = {l3[\([2]\)], \
\((l3[\([2]\)] + l4[\([1]\)])\)/2, 
            l4[\([1]\)]}; \[IndentingNewLine]s4 = {l4[\([2]\)], \
\((l4[\([2]\)] + l1[\([1]\)])\)/2, 
            l1[\([1]\)]}; \[IndentingNewLine]\[IndentingNewLine]s1[\([2]\)] += \
{\(-dw\), 0, \(-dh\)}/
            curvemul; \[IndentingNewLine]s2[\([2]\)] += {dw, 0, \(-dh\)}/
            curvemul; \[IndentingNewLine]s3[\([2]\)] += {dw, 0, dh}/
            curvemul; \[IndentingNewLine]s4[\([2]\)] += {\(-dw\), 0, dh}/
            curvemul; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = Line[l4]; \[IndentingNewLine]s1 = 
          Line[s1]; \[IndentingNewLine]s2 = Line[s2]; \[IndentingNewLine]s3 = 
          Line[s3]; \[IndentingNewLine]s4 = 
          Line[s4]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          Graphics[{l1, l2, l3, l4, \ s1, s2, s3, 
              s4}]\ *) \[IndentingNewLine]{l1, s1, l2, s2, l3, s3, l4, 
          s4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxwithcorners2D[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Module[{dh, 
          dw}, \[IndentingNewLine]\[IndentingNewLine]dh = 
          Last[pt[\([1]\)] - pt[\([2]\)]]\ linemul; \[IndentingNewLine]dw = 
          First[pt[\([4]\)] - 
                pt[\([5]\)]]\ linemul; \
\[IndentingNewLine]\[IndentingNewLine]l1 = {pt[\([1]\)], 
            pt[\([2]\)]}; \[IndentingNewLine]l2 = {pt[\([2]\)], 
            pt[\([3]\)]}; \[IndentingNewLine]l3 = {pt[\([3]\)], 
            pt[\([4]\)]}; \[IndentingNewLine]l4 = {pt[\([4]\)], 
            pt[\([5]\)]}; \[IndentingNewLine]\[IndentingNewLine]l1[\([1]\)] += \
{0, \(-dh\)}; \[IndentingNewLine]l1[\([2]\)] += {0, 
            dh}; \[IndentingNewLine]l2[\([1]\)] += {dw, 
            0}; \[IndentingNewLine]l2[\([2]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l3[\([1]\)] += {0, 
            dh}; \[IndentingNewLine]l3[\([2]\)] += {0, \(-dh\)}; \
\[IndentingNewLine]l4[\([1]\)] += {\(-dw\), 
            0}; \[IndentingNewLine]l4[\([2]\)] += {dw, 
            0}; \[IndentingNewLine]\[IndentingNewLine]s1 = {l1[\([2]\)], \
\((l1[\([2]\)] + l2[\([1]\)])\)/2, 
            l2[\([1]\)]}; \[IndentingNewLine]s2 = {l2[\([2]\)], \
\((l2[\([2]\)] + l3[\([1]\)])\)/2, 
            l3[\([1]\)]}; \[IndentingNewLine]s3 = {l3[\([2]\)], \
\((l3[\([2]\)] + l4[\([1]\)])\)/2, 
            l4[\([1]\)]}; \[IndentingNewLine]s4 = {l4[\([2]\)], \
\((l4[\([2]\)] + l1[\([1]\)])\)/2, 
            l1[\([1]\)]}; \[IndentingNewLine]s1[\([2]\)] += {\(-dw\), \
\(-dh\)}/curvemul; \[IndentingNewLine]s2[\([2]\)] += {dw, \(-dh\)}/
            curvemul; \[IndentingNewLine]s3[\([2]\)] += {dw, dh}/
            curvemul; \[IndentingNewLine]s4[\([2]\)] += {\(-dw\), dh}/
            curvemul; \[IndentingNewLine]\[IndentingNewLine]l1 = 
          Line[l1]; \[IndentingNewLine]l2 = Line[l2]; \[IndentingNewLine]l3 = 
          Line[l3]; \[IndentingNewLine]l4 = Line[l4]; \[IndentingNewLine]s1 = 
          Line[s1]; \[IndentingNewLine]s2 = Line[s2]; \[IndentingNewLine]s3 = 
          Line[s3]; \[IndentingNewLine]s4 = 
          Line[s4]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
          Graphics[{l1, l2, l3, l4, \ s1, s2, s3, 
              s4}]\ *) \[IndentingNewLine]{l1, s1, l2, s2, l3, s3, l4, 
          s4}\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(boxwithcorners[pt_, linemul_, 
        curvemul_] := \(If[Length[pt[\([1]\)]] === 2, boxwithcorners2D, 
          boxwithcorners3D]\)[pt, linemul, curvemul]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxwithcorners[
          v,  .1, \(-50\)]\[IndentingNewLine]\[IndentingNewLine]];\)\)], \
"Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics[%]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.485622 0.0340136 -0.298023 0.0173119 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .54446 m
.02381 .07358 L
s
.02381 .07358 m
.07333 .04532 L
.11905 .01472 L
s
.11905 .01472 m
.88095 .01472 L
s
.88095 .01472 m
.92667 .04532 L
.97619 .07358 L
s
.97619 .07358 m
.97619 .54446 L
s
.97619 .54446 m
.92667 .57271 L
.88095 .60332 L
s
.88095 .60332 m
.11905 .60332 L
s
.11905 .60332 m
.07333 .57271 L
.02381 .54446 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo000RoooK000Sool0023oo`800=_oo`80027oo`007ooo00<00?ooool0
gOoo00<00?ooool07_oo000Mool2003Qool2000Nool001coo`03003ooooo0>?oo`03003ooooo01_o
o`006ooo00<00?ooool0iOoo00<00?ooool06_oo000Iool2003Yool2000Jool001Soo`03003ooooo
0>_oo`03003ooooo01Ooo`005_oo0P00kooo0P005ooo000Eool00`00ooooo`3aool00`00ooooo`0D
ool001?oo`800?Goo`8001Coo`004Ooo0P00nOoo0P004_oo000?ool2003mool2000@ool000koo`03
003ooooo0?ooo`03003ooooo00goo`003?oo0P00oooo1?oo0P003Ooo000:ool2003oool8ool2000;
ool000Soo`800?ooo`coo`8000Woo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`002?oo0P00oooo3?oo0P002Ooo000:ool00`00ooooo`3oool8
ool00`00ooooo`09ool000_oo`800?ooo`Koo`8000coo`003Ooo00<00?ooool0oooo0Ooo0P003_oo
000>ool2003oool00`00ooooo`0>ool0013oo`800?_oo`80017oo`004_oo00<00?ooool0mooo00<0
0?ooool04Ooo000Cool2003eool2000Dool001Goo`03003ooooo0?7oo`03003ooooo01Coo`005_oo
0P00kooo0P005ooo000Hool2003[ool2000Iool001[oo`03003ooooo0>Ooo`03003ooooo01Woo`00
6ooo0P00iOoo0P007?oo000Mool00`00ooooo`3Qool00`00ooooo`0Lool001koo`800=ooo`8001oo
o`008?oo0P00fooo0P008Ooo000RoooK000Sool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {14.2408, 17.2147, 0.102693, \
0.201767}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics[{First[%%], Take[%%, \(-4\)]}]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.485622 0.0340136 -3.00205 0.0692475 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .36788 m
0 0 rlineto s
.02381 .36788 m
.02381 0 L
s
.97619 0 m
.97619 .36788 L
s
.97619 .36788 m
.92667 .48089 L
.88095 .60332 L
s
.88095 .60332 m
.11905 .60332 L
s
.11905 .60332 m
.07333 .48089 L
.02381 .36788 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00O1ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003o
oooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool0
0`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`00
1ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06
ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?oo
ool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03
003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>
ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0
oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Soo`03003o
oooo0?ooo`coo`03003ooooo00Ooo`002?oo00<00?ooool0oooo3?oo00<00?ooool01ooo0009ool0
0`00ooooo`3oool:ool00`00ooooo`08ool000Woo`03003ooooo0?ooo`[oo`03003ooooo00Soo`00
2_oo00<00?ooool0oooo2?oo00<00?ooool02Ooo000:ool00`00ooooo`3oool8ool00`00ooooo`09
ool000[oo`03003ooooo0?ooo`Soo`03003ooooo00Woo`002ooo00<00?ooool0oooo1_oo00<00?oo
ool02_oo000;ool00`00ooooo`3oool6ool00`00ooooo`0:ool000coo`03003ooooo0?ooo`Coo`03
003ooooo00_oo`003?oo00<00?ooool0oooo1?oo00<00?ooool02ooo000=ool00`00ooooo`3oool2
ool00`00ooooo`0<ool000goo`03003ooooo0?ooo`;oo`03003ooooo00coo`003_oo00<00?ooool0
oooo00<00?ooool03Ooo000>ool00`00ooooo`3oool00`00ooooo`0=ool000koo`03003ooooo0?oo
o`03003ooooo00goo`003ooo00<00?ooool0oOoo00<00?ooool03_oo000?ool00`00ooooo`3mool0
0`00ooooo`0>ool0013oo`03003ooooo0?_oo`03003ooooo00ooo`004?oo00<00?ooool0nooo00<0
0?ooool03ooo000Aool00`00ooooo`3iool00`00ooooo`0@ool0017oo`03003ooooo0?Woo`03003o
oooo013oo`004Ooo00<00?ooool0nOoo00<00?ooool04?oo000Bool00`00ooooo`3gool00`00oooo
o`0Aool001;oo`03003ooooo0?Ooo`03003ooooo017oo`004ooo00<00?ooool0mOoo00<00?ooool0
4_oo000Cool00`00ooooo`3eool00`00ooooo`0Bool001Coo`03003ooooo0??oo`03003ooooo01?o
o`005?oo00<00?ooool0looo00<00?ooool04ooo000Eool00`00ooooo`3aool00`00ooooo`0Dool0
01Goo`03003ooooo0?7oo`03003ooooo01Coo`005Ooo00<00?ooool0lOoo00<00?ooool05?oo000F
ool00`00ooooo`3_ool00`00ooooo`0Eool001Koo`03003ooooo0>ooo`03003ooooo01Goo`005_oo
00<00?ooool0kooo00<00?ooool05Ooo000Gool00`00ooooo`3]ool00`00ooooo`0Fool001Ooo`03
003ooooo0>goo`03003ooooo01Koo`006?oo00<00?ooool0jooo00<00?ooool05ooo000Hool00`00
ooooo`3[ool00`00ooooo`0Gool001Soo`03003ooooo0>_oo`03003ooooo01Ooo`006Ooo00<00?oo
ool0jOoo00<00?ooool06?oo000Iool00`00ooooo`3Yool00`00ooooo`0Hool001Woo`03003ooooo
0>Woo`03003ooooo01Soo`006_oo00<00?ooool0iooo00<00?ooool06Ooo000Jool00`00ooooo`3W
ool00`00ooooo`0Iool001_oo`03003ooooo0>Goo`03003ooooo01[oo`006ooo00<00?ooool0iOoo
00<00?ooool06_oo000Kool00`00ooooo`3Uool00`00ooooo`0Jool001coo`03003ooooo0>?oo`03
003ooooo01_oo`007?oo00<00?ooool0hooo00<00?ooool06ooo000Lool00`00ooooo`3Sool00`00
ooooo`0Kool001goo`03003ooooo0>7oo`03003ooooo01coo`007Ooo00<00?ooool0hOoo00<00?oo
ool07?oo000Nool00`00ooooo`3Oool00`00ooooo`0Mool001koo`03003ooooo0=ooo`03003ooooo
01goo`007_oo00<00?ooool0gooo00<00?ooool07Ooo000Oool00`00ooooo`3Mool00`00ooooo`0N
ool001ooo`03003ooooo0=goo`03003ooooo01koo`007ooo00<00?ooool0gOoo00<00?ooool07_oo
000Pool00`00ooooo`3Kool00`00ooooo`0Oool0023oo`03003ooooo0=_oo`03003ooooo01ooo`00
8Ooo00<00?ooool0fOoo00<00?ooool08?oo000Qool00`00ooooo`3Iool00`00ooooo`0Pool0027o
o`03003ooooo0=Woo`03003ooooo023oo`008_oo00<00?ooool0eooo00<00?ooool08Ooo000RoooK
000Sool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {14.2408, 43.3524, 0.102693, \
0.0504417}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            False]; \[IndentingNewLine]\[IndentingNewLine]boxwithcorners[
          v,  .1, \(-50\)]\[IndentingNewLine]\[IndentingNewLine]];\)\)], \
"Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics3D[%]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.29616 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.192623 1.34078 -0.0446149 1.34078 [
[ 0 0 0 0 ]
[ 1 1.29616 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.04124 1.29616 L
s
.04124 1.29616 m
.10811 .33677 L
s
.10811 .33677 m
.07399 .30079 L
s
.88524 0 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.88524 0 m
.07399 .30079 L
s
.10811 .33677 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.04124 1.29616 L
s
.04124 1.29616 m
.10811 .33677 L
s
0 0 m
1 0 L
1 1.29616 L
0 1.29616 L
closepath
clip
newpath
.5 Mabswid
.17917 .3056 m
.79667 .07963 L
s
.14202 .35927 m
.17917 .3056 L
s
.10192 .41117 m
.14202 .35927 L
s
.05078 1.14299 m
.10192 .41117 L
s
.79667 .07963 m
.8394 .10716 L
s
.8394 .10716 m
.88635 .13085 L
s
.88635 .13085 m
.94753 .89401 L
s
.09019 1.1816 m
.05078 1.14299 L
s
.12702 1.22646 m
.09019 1.1816 L
s
.85687 1.03228 m
.12702 1.22646 L
s
.94753 .89401 m
.90026 .96115 L
s
.90026 .96115 m
.85687 1.03228 L
s
.25 Mabswid
.88524 0 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.88524 0 m
.07399 .30079 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{222.188, 287.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003N00017a000`40n007h00O`_oo0P006_oo002o
ool300000ooo0000000Iool00;goo`8000Coo`8001Woo`00^_oo0`001_oo00<00?oo00006?oo002g
ool30009ool01000ooooo`005ooo002eool2000<ool01000ooooo`005ooo002bool3000?ool01000
ooooo`005_oo002_ool3000Bool01@00oooooooo00005Ooo002/ool3000Eool01@00oooooooo0000
5Ooo002Zool2000Hool01000oooooooo0P005?oo002Wool3000Jool400000ooo003oo`0Cool00:Co
o`<001coo`8000Coo`03003ooooo01;oo`00X_oo0P007?oo0`0000?oo`00ool00ooo00<00?ooool0
4_oo002Oool3000Kool30004ool00`00ooooo`02ool00`00ooooo`0Bool009coo`<001_oo`<000Oo
o`03003ooooo00;oo`03003ooooo01;oo`00VOoo0`007?oo0P002_oo00<00?ooool00ooo00<00?oo
ool04Ooo002Gool2000Lool3000<ool00`00ooooo`03ool00`00ooooo`0Aool009Coo`<001Soo`80
0004ool00000000?ool00`00ooooo`03ool00`00ooooo`0Aool0097oo`<001Soo`L001;oo`03003o
oooo00;oo`03003ooooo017oo`00Sooo0P006Ooo0P0000?oo`0000001?oo00<00?ooool03ooo00<0
0?ooool00_oo00<00?ooool04Ooo002<ool3000Hool60007ool2000?ool00`00ooooo`02ool00`00
ooooo`0Aool008Woo`<001Soo`H000coo`03003ooooo00coo`03003ooooo00;oo`03003ooooo017o
o`00Q_oo0`006?oo0`0000?oo`0000004?oo0P003?oo00<00?ooool00_oo00<00?ooool04Ooo0024
ool2000Iool200001?oo000000005?oo00<00?ooool02Ooo00<00?ooool00_oo00<00?ooool04Ooo
0021ool3000Hool6000Hool20009ool00`00ooooo`02ool00`00ooooo`0Aool007koo`<001Soo`H0
01goo`8000Ooo`03003ooooo00;oo`03003ooooo017oo`00O?oo0P006?oo0`0000?oo`0000008_oo
0P001Ooo00<00?ooool00ooo00<00?ooool04?oo001iool3000Hool200001?oo000000009_oo0P00
0ooo00<00?ooool00ooo00<00?ooool04?oo001fool3000Hool6000[ool200000ooo003oo`04ool0
0`00ooooo`0@ool007?oo`<001Soo`H0033oo`8000Goo`03003ooooo013oo`00LOoo0P006Ooo0P00
00?oo`000000<ooo00<00?oo00001?oo00<00?ooool04?oo001^ool3000Hool6000eool00`00ool0
0004ool00`00ooooo`0@ool006_oo`<001Soo`H003Soo`03003oo`0000Coo`03003ooooo013oo`00
JOoo0P006?oo1P00>ooo00<00?oo00001?oo00<00?ooool04?oo001Vool3000Hool200000ooo0000
000nool00`00ool00004ool00`00ooooo`0@ool006?oo`<001Soo`H0043oo`03003oo`0000Coo`03
003ooooo013oo`00HOoo0P006?oo1P00A?oo0P001?oo00<00?ooool04?oo001Nool3000Gool60017
ool20005ool00`00ooooo`0?ool005_oo`<001Soo`800003ool0000004[oo`8000Goo`03003ooooo
00ooo`00F?oo0`006?oo1P00C?oo0P001Ooo00<00?ooool03ooo001Fool2000Hool6001?ool20005
ool00`00ooooo`0?ool005?oo`<001Ooo`H005;oo`8000Goo`03003ooooo00ooo`00D?oo0`006?oo
0P0000?oo`000000EOoo00<00?oo00001?oo00<00?ooool03ooo001>ool2000Hool6001Gool00`00
ool00004ool00`00ooooo`0?ool004_oo`<001Ooo`H005[oo`03003oo`0000Coo`03003ooooo00oo
o`00B?oo0`005ooo0`0000?oo`000000GOoo00<00?oo00001?oo00<00?ooool03ooo0015ool3000H
ool200001?oo00000000Gooo00<00?oo00001?oo00<00?ooool03ooo0013ool2000Hool6001Rool0
0`00ool00004ool00`00ooooo`0?ool0043oo`<001Ooo`H006Goo`03003oo`0000Goo`03003ooooo
00koo`00?Ooo0`005ooo0`0000?oo`000000JOoo0P001Ooo00<00?ooool03_oo000kool2000Hool2
00001?oo00000000Jooo0P001Ooo00<00?ooool03_oo000hool3000Gool6001^ool20005ool00`00
ooooo`0>ool003Goo`<001Ooo`H0077oo`8000Goo`03003ooooo00koo`00<_oo0`005ooo0`0000?o
o`000000M?oo00<00?oo00001?oo00<00?ooool03_oo000`ool2000Hool200001?oo00000000M_oo
00<00?oo00001?oo00<00?ooool03_oo000]ool3000Gool6001iool00`00ool00004ool00`00oooo
o`0>ool002[oo`<001Ooo`H007coo`03003oo`0000Coo`03003ooooo00koo`00:?oo0P006?oo0P00
00?oo`000000Oooo00<00?oo00001?oo00<00?ooool03_oo000Uool3000Gool60021ool00`00ool0
0004ool00`00ooooo`0>ool002;oo`<001Ooo`H008Coo`03003oo`0000Goo`03003ooooo00goo`00
7ooo0`005ooo1P00Qooo00<00?oo00001Ooo00<00?ooool03Ooo000Mool2000Hool200000ooo0000
002:ool00`00ool00005ool00`00ooooo`0=ool001[oo`<001Ooo`H008goo`8000Goo`03003ooooo
00goo`005ooo0`005ooo1P00T?oo0P001Ooo00<00?ooool03Ooo000Eool2000Gool300000ooo0000
002Cool20005ool00`00ooooo`0=ool001;oo`<001Ooo`800004ool00000002Eool00`00ool00004
ool00`00ooooo`0=ool0013oo`8001Ooo`H009Soo`03003oo`0000Coo`03003ooooo00goo`004?oo
0P005Ooo1@00Vooo00<00?oo00001?oo00<00?ooool03Ooo000@ool00`00ool0000Cool3002Nool0
0`00ool00004ool00`00ooooo`0=ool0013oo`04003ooooo000@ool3002Pool00`00ool00004ool0
0`00ooooo`0=ool0013oo`04003ooooo000=ool300000ooo003oo`2Pool00`00ool00004ool00`00
ooooo`0=ool0013oo`05003oooooool00009ool30003ool00`00ooooo`2Pool00`00ool00005ool0
0`00ooooo`0<ool0013oo`03003ooooo00;oo`03003ooooo00Coo`8000Koo`03003ooooo0:3oo`03
003oo`0000Goo`03003ooooo00coo`003ooo00<00?ooool01?oo00<00?ooool00`001ooo00<00?oo
ool0XOoo00<00?oo00001Ooo00<00?ooool03?oo000?ool00`00ooooo`05ool20009ool00`00oooo
o`2Rool00`00ool00005ool00`00ooooo`0<ool000ooo`03003ooooo00Goo`03003ooooo00Soo`03
003ooooo0:?oo`8000Goo`03003ooooo00coo`003ooo00<00?ooool01Ooo00<00?ooool01ooo00<0
0?ooool0Y?oo0P001Ooo00<00?ooool03?oo000?ool00`00ooooo`05ool00`00ooooo`06ool00`00
ooooo`2Uool00`00ool00004ool00`00ooooo`0<ool000ooo`03003ooooo00Goo`03003ooooo00Ko
o`03003ooooo0:Goo`03003oo`0000Coo`03003ooooo00coo`003ooo00<00?ooool01Ooo00<00?oo
ool01Ooo00<00?ooool0Y_oo00<00?oo00001?oo00<00?ooool03?oo000?ool00`00ooooo`05ool0
0`00ooooo`04ool00`00ooooo`2Wool00`00ool00004ool00`00ooooo`0<ool000ooo`03003ooooo
00Goo`03003ooooo00Coo`03003ooooo0:Ooo`03003oo`0000Coo`03003ooooo00coo`003ooo00<0
0?ooool01?oo00<00?ooool01?oo00<00?ooool0Z?oo00<00?oo00001Ooo00<00?ooool02ooo000?
ool00`00ooooo`04ool00`00ooooo`03ool00`00ooooo`2Yool00`00ool00005ool00`00ooooo`0;
ool000ooo`03003ooooo00Coo`03003ooooo00;oo`03003ooooo0:[oo`03003oo`0000Goo`03003o
oooo00_oo`003ooo00<00?ooool01?oo00<00?ooool00_oo00<00?ooool0Z_oo00<00?oo00001Ooo
00<00?ooool02ooo000?ool00`00ooooo`04ool01@00oooooooo0000[Ooo00<00?oo00001Ooo00<0
0?ooool02ooo000>ool00`00ooooo`05ool01000ooooo`00[_oo00<00?oo00001Ooo00<00?ooool0
2ooo000>ool00`00ooooo`05ool00`00ool0002`ool20005ool00`00ooooo`0;ool000koo`03003o
oooo00Goo`03003oo`000;3oo`03003oo`0000Coo`03003ooooo00_oo`003_oo00<00?ooool01Ooo
0P00/Ooo00<00?oo00001?oo00<00?ooool02ooo000>ool00`00ooooo`05ool00`00ooooo`2`ool0
0`00ool00004ool00`00ooooo`0;ool000koo`03003ooooo00Goo`03003ooooo0;3oo`03003oo`00
00Coo`03003ooooo00_oo`003_oo00<00?ooool01Ooo00<00?ooool0/?oo00<00?oo00001Ooo00<0
0?ooool02_oo000>ool00`00ooooo`05ool00`00ooooo`2`ool00`00ool00005ool00`00ooooo`0:
ool000koo`03003ooooo00Goo`03003ooooo0;3oo`03003oo`0000Goo`03003ooooo00[oo`003_oo
00<00?ooool01Ooo00<00?ooool0/?oo00<00?oo00001Ooo00<00?ooool02_oo000>ool00`00oooo
o`04ool2002bool00`00ool00005ool00`00ooooo`0:ool000koo`03003ooooo00Coo`800;;oo`03
003oo`0000Goo`03003ooooo00[oo`003_oo00<00?ooool01?oo00<00?ooool0/Ooo00<00?oo0000
1Ooo00<00?ooool02_oo000=ool00`00ooooo`05ool00`00ooooo`2aool01000ooooo`001?oo00<0
0?ooool02_oo000=ool00`00ooooo`05ool00`00ooooo`2bool00`00ool00004ool00`00ooooo`0:
ool000goo`03003ooooo00Goo`03003ooooo0;;oo`03003oo`0000Coo`03003ooooo00[oo`003Ooo
00<00?ooool01Ooo00<00?ooool0/_oo00<00?oo00001?oo00<00?ooool02_oo000=ool00`00oooo
o`05ool00`00ooooo`2bool00`00ool00005ool00`00ooooo`09ool000goo`03003ooooo00Goo`03
003ooooo0;;oo`03003oo`0000Goo`03003ooooo00Woo`003Ooo00<00?ooool01Ooo00<00?ooool0
/_oo00<00?oo00001Ooo00<00?ooool02Ooo000=ool00`00ooooo`05ool00`00ooooo`2bool00`00
ool00005ool00`00ooooo`09ool000goo`03003ooooo00Goo`03003ooooo0;;oo`03003oo`0000Go
o`03003ooooo00Woo`003Ooo00<00?ooool01Ooo00<00?ooool0/_oo00<00?oo00001Ooo00<00?oo
ool02Ooo000=ool00`00ooooo`05ool00`00ooooo`2bool00`00ool00005ool00`00ooooo`09ool0
00goo`03003ooooo00Goo`03003ooooo0;;oo`03003oo`0000Goo`03003ooooo00Woo`003Ooo00<0
0?ooool01?oo0P00]?oo00@00?ooool000Coo`03003ooooo00Woo`003?oo00<00?ooool01Ooo00<0
0?ooool0/ooo00@00?ooool000Coo`03003ooooo00Woo`003?oo00<00?ooool01Ooo00<00?ooool0
]?oo00<00?oo00001?oo00<00?ooool02Ooo000<ool00`00ooooo`05ool00`00ooooo`2dool00`00
ool00005ool00`00ooooo`08ool000coo`03003ooooo00Goo`03003ooooo0;Coo`03003oo`0000Go
o`03003ooooo00Soo`003?oo00<00?ooool01Ooo00<00?ooool0]?oo00<00?oo00001Ooo00<00?oo
ool02?oo000<ool00`00ooooo`05ool00`00ooooo`2dool00`00ool00005ool00`00ooooo`08ool0
00coo`03003ooooo00Goo`03003ooooo0;Coo`03003oo`0000Goo`03003ooooo00Soo`003?oo00<0
0?ooool01Ooo00<00?ooool0]?oo00<00?oo00001Ooo00<00?ooool02?oo000<ool00`00ooooo`05
ool00`00ooooo`2dool00`00ool00005ool00`00ooooo`08ool000coo`03003ooooo00Goo`03003o
oooo0;Coo`03003oo`0000Goo`03003ooooo00Soo`003?oo00<00?ooool01Ooo00<00?ooool0]?oo
00<00?oo00001Ooo00<00?ooool02?oo000<ool00`00ooooo`05ool00`00ooooo`2dool01000oooo
o`001?oo00<00?ooool02?oo000<ool00`00ooooo`05ool00`00ooooo`2dool01000ooooo`001?oo
00<00?ooool02?oo000<ool00`00ooooo`05ool00`00ooooo`2eool00`00ool00005ool00`00oooo
o`07ool000_oo`03003ooooo00Koo`03003ooooo0;Goo`03003oo`0000Goo`03003ooooo00Ooo`00
2ooo00<00?ooool01Ooo00<00?ooool0]_oo00<00?oo00001Ooo00<00?ooool01ooo000;ool00`00
ooooo`05ool00`00ooooo`2fool00`00ool00005ool00`00ooooo`07ool000_oo`03003ooooo00Go
o`03003ooooo0;Koo`03003oo`0000Goo`03003ooooo00Ooo`002ooo00<00?ooool01Ooo00<00?oo
ool0]_oo00<00?oo00001Ooo00<00?ooool01ooo000;ool00`00ooooo`05ool00`00ooooo`2fool0
0`00ool00005ool00`00ooooo`07ool000_oo`03003ooooo00Goo`03003ooooo0;Koo`03003oo`00
00Goo`03003ooooo00Ooo`002ooo00<00?ooool01Ooo00<00?ooool0]_oo00<00?oo00001Ooo00<0
0?ooool01ooo000;ool00`00ooooo`05ool00`00ooooo`2fool01000ooooo`001?oo00<00?ooool0
1ooo000;ool00`00ooooo`05ool00`00ooooo`2fool01000ooooo`001?oo00<00?ooool01ooo000;
ool00`00ooooo`05ool00`00ooooo`2fool01000ooooo`001Ooo00<00?ooool01_oo000;ool00`00
ooooo`05ool00`00ooooo`2fool01000ooooo`001Ooo00<00?ooool01_oo000;ool00`00ooooo`05
ool00`00ooooo`2gool00`00ool00005ool00`00ooooo`06ool000[oo`03003ooooo00Koo`03003o
oooo0;Ooo`03003oo`0000Goo`03003ooooo00Koo`002_oo00<00?ooool01_oo00<00?ooool0]ooo
00<00?oo00001Ooo00<00?ooool01_oo000:ool00`00ooooo`06ool00`00ooooo`2gool00`00ool0
0005ool00`00ooooo`06ool000[oo`03003ooooo00Goo`03003ooooo0;Soo`03003oo`0000Goo`03
003ooooo00Koo`002_oo00<00?ooool01Ooo00<00?ooool0^?oo00<00?oo00001Ooo00<00?ooool0
1_oo000:ool00`00ooooo`05ool00`00ooooo`2hool00`00ool00005ool00`00ooooo`06ool000[o
o`03003ooooo00Goo`03003ooooo0;Soo`03003oo`0000Goo`03003ooooo00Koo`002_oo00<00?oo
ool01Ooo00<00?ooool0^?oo00@00?ooool000Coo`03003ooooo00Koo`002_oo00<00?ooool01Ooo
00<00?ooool0^?oo00@00?ooool000Goo`03003ooooo00Goo`002_oo00<00?ooool01Ooo00<00?oo
ool0^?oo00@00?ooool000Goo`03003ooooo00Goo`002_oo00<00?ooool01Ooo00<00?ooool0^?oo
00@00?ooool000Goo`03003ooooo00Goo`002_oo00<00?ooool01Ooo00<00?ooool0^?oo00@00?oo
ool000Goo`03003ooooo00Goo`002_oo00<00?ooool01Ooo00<00?ooool0^Ooo00<00?oo00001Ooo
00<00?ooool01Ooo0009ool00`00ooooo`06ool00`00ooooo`2iool00`00ool00005ool00`00oooo
o`05ool000Woo`03003ooooo00Koo`03003ooooo0;Woo`03003oo`0000Goo`03003ooooo00Goo`00
2Ooo00<00?ooool01_oo00<00?ooool0^Ooo00<00?oo00001Ooo00<00?ooool01Ooo0009ool00`00
ooooo`06ool00`00ooooo`2iool00`00ool00005ool00`00ooooo`05ool000Woo`03003ooooo00Go
o`800;_oo`03003oo`0000Goo`03003ooooo00Goo`002Ooo00<00?ooool01Ooo00<00?ooool0^_oo
00<00?oo00001Ooo00<00?ooool01Ooo0009ool00`00ooooo`05ool00`00ooooo`2jool01000oooo
o`001Ooo00<00?ooool01?oo0009ool00`00ooooo`05ool00`00ooooo`2jool01000ooooo`001Ooo
00<00?ooool01?oo0009ool00`00ooooo`05ool00`00ooooo`2jool01000ooooo`001Ooo00<00?oo
ool01?oo0009ool00`00ooooo`05ool00`00ooooo`2jool01000ooooo`001Ooo00<00?ooool01?oo
0009ool00`00ooooo`05ool00`00ooooo`2jool01000ooooo`001Ooo00<00?ooool01?oo0009ool0
0`00ooooo`05ool00`00ooooo`2jool01000ooooo`001Ooo00<00?ooool01?oo0009ool00`00oooo
o`05ool00`00ooooo`2kool00`00ool00005ool00`00ooooo`04ool000Woo`03003ooooo00Goo`03
003ooooo0;_oo`03003oo`0000Goo`03003ooooo00Coo`002?oo00<00?ooool01_oo00<00?ooool0
^ooo00<00?oo00001Ooo00<00?ooool01?oo0008ool00`00ooooo`06ool00`00ooooo`2kool00`00
ool00005ool00`00ooooo`04ool000Soo`03003ooooo00Koo`03003ooooo0;_oo`03003oo`0000Go
o`03003ooooo00Coo`002?oo00<00?ooool01_oo00<00?ooool0^ooo00<00?oo00001_oo00<00?oo
ool00ooo0008ool00`00ooooo`06ool00`00ooooo`2kool01000ooooo`001Ooo00<00?ooool00ooo
0008ool00`00ooooo`05ool2002mool01000ooooo`001Ooo00<00?ooool00ooo0008ool00`00oooo
o`05ool00`00ooooo`2lool01000ooooo`001Ooo00<00?ooool00ooo0008ool00`00ooooo`05ool0
0`00ooooo`2lool01000ooooo`001Ooo00<00?ooool00ooo0008ool00`00ooooo`05ool00`00oooo
o`2lool01000ooooo`001Ooo00<00?ooool00ooo0008ool00`00ooooo`05ool00`00ooooo`2lool0
1000ooooo`001Ooo00<00?ooool00ooo0008ool00`00ooooo`05ool00`00ooooo`2lool01000oooo
o`001Ooo00<00?ooool00ooo0008ool00`00ooooo`05ool00`00ooooo`2mool00`00ool00005ool0
0`00ooooo`03ool000Soo`03003ooooo00Goo`03003ooooo0;goo`03003oo`0000Goo`03003ooooo
00?oo`001ooo00<00?ooool01_oo00<00?ooool0_Ooo00<00?oo00001Ooo00<00?ooool00ooo0007
ool00`00ooooo`06ool00`00ooooo`2mool00`00ool00005ool00`00ooooo`03ool000Ooo`03003o
oooo00Koo`03003ooooo0;goo`04003ooooo0005ool00`00ooooo`02ool000Ooo`03003ooooo00Ko
o`03003ooooo0;goo`04003ooooo0005ool00`00ooooo`02ool000Ooo`03003ooooo00Koo`03003o
oooo0;goo`04003ooooo0005ool00`00ooooo`02ool000Ooo`03003ooooo00Koo`03003ooooo0;go
o`04003ooooo0005ool00`00ooooo`02ool000Ooo`03003ooooo00Koo`03003ooooo0;goo`04003o
oooo0005ool00`00ooooo`02ool000Ooo`03003ooooo00Goo`800;ooo`04003ooooo0005ool00`00
ooooo`02ool000Ooo`03003ooooo00Goo`03003ooooo0;koo`04003ooooo0005ool00`00ooooo`02
ool000Ooo`03003ooooo00Goo`03003ooooo0;koo`04003ooooo0005ool00`00ooooo`02ool000Oo
o`03003ooooo00Goo`03003ooooo0;koo`04003ooooo0005ool00`00ooooo`02ool000Ooo`03003o
oooo00Goo`03003ooooo0;ooo`03003oo`0000Goo`03003ooooo00;oo`001ooo00<00?ooool01Ooo
00<00?ooool0_ooo00<00?oo00001Ooo00<00?ooool00_oo0007ool00`00ooooo`05ool00`00oooo
o`2oool00`00ool00006ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo0;ooo`04
003ooooo0005ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo0;ooo`04003ooooo
0005ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo0;ooo`04003ooooo0005ool0
0`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo0;ooo`04003ooooo0005ool00`00oooo
o`01ool000Koo`03003ooooo00Koo`03003ooooo0;koo`05003oooooool00005ool00`00ooooo`01
ool000Koo`03003ooooo00Koo`03003ooooo0;koo`05003oooooool00005ool00`00ooooo`01ool0
00Koo`03003ooooo00Koo`03003ooooo0;goo`03003ooooo00;oo`03003ooooo00?oo`03003ooooo
007oo`001_oo00<00?ooool01Ooo0P00__oo00<00?ooool00ooo00<00?ooool00ooo00<00?ooool0
0Ooo0006ool00`00ooooo`05ool2002nool00`00ooooo`03ool00`00ooooo`03ool00`00ooooo`01
ool000Koo`03003ooooo00Goo`03003ooooo0;coo`03003ooooo00Coo`03003ooooo00?oo`03003o
oooo007oo`001_oo00<00?ooool01Ooo00<00?ooool0^ooo00<00?ooool01Ooo00<00?ooool01?oo
0@000Ooo0Ooo0006ool00`00ooooo`05ool00`00ooooo`2kool00`00ooooo`05ool00`00ooooo`04
ool10001ool1ool000Koo`03003ooooo00Goo`03003ooooo0;[oo`03003ooooo00Ooo`03003ooooo
00?oo`40007oo`7oo`001Ooo00<00?ooool01_oo00<00?ooool0^Ooo00<00?ooool02?oo00<00?oo
ool00ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`2iool00`00ooooo`08ool00`00
ooooo`03ool10001ool1ool000Goo`03003ooooo00Koo`03003ooooo0;Soo`03003ooooo00Woo`03
003ooooo00?oo`40007oo`7oo`001Ooo00<00?ooool01_oo00<00?ooool0]ooo00<00?ooool02_oo
00<00?ooool00ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`2gool00`00ooooo`0:
ool00`00ooooo`03ool10001ool1ool000Goo`03003ooooo00Koo`03003ooooo0;Koo`03003ooooo
00_oo`03003ooooo00?oo`40007oo`7oo`001Ooo00<00?ooool01_oo00<00?ooool0]Ooo00<00?oo
ool03?oo00<00?ooool00ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`2eool00`00
ooooo`0<ool00`00ooooo`03ool10001ool1ool000Goo`03003ooooo00Koo`03003ooooo0;Coo`03
003ooooo00goo`03003ooooo00Coo`40007oo`001Ooo00<00?ooool01Ooo0P00]_oo00<00?ooool0
3Ooo00<00?ooool01?oo0@000Ooo0005ool00`00ooooo`05ool2002eool00`00ooooo`0>ool00`00
ooooo`04ool10001ool000Goo`03003ooooo00Goo`03003ooooo0;?oo`03003ooooo013oo`03003o
oooo00?oo`40007oo`001Ooo00<00?ooool01Ooo00<00?ooool0/ooo00<00?ooool04?oo00<00?oo
ool00ooo0@000Ooo0004ool00`00ooooo`06ool00`00ooooo`2bool00`00ooooo`0Aool00`00oooo
o`03ool10001ool000Coo`03003ooooo00Koo`03003ooooo0;7oo`03003ooooo01;oo`03003ooooo
00?oo`40007oo`001?oo00<00?ooool01_oo00<00?ooool0/Ooo00<00?ooool04_oo00<00?ooool0
0ooo0@000Ooo0004ool00`00ooooo`06ool00`00ooooo`2`ool00`00ooooo`0Bool20005ool10001
ool000Coo`03003ooooo00Koo`03003ooooo0;3oo`03003ooooo00koo`@000;oo`03003ooooo00;o
o`40007oo`001?oo00<00?ooool01_oo00<00?ooool0[ooo00<00?ooool02ooo10001ooo00D00?oo
ooooo`00007oo`001?oo00<00?ooool01_oo00<00?ooool0[_oo00<00?ooool02?oo10003?oo00@0
0?ooooooo`4000001?oo00<00?ooool01_oo00<00?ooool0[_oo00<00?ooool01Ooo0`004?oo00@0
0?ooooooo`4000001?oo00<00?ooool01_oo00<00?ooool0[?oo0P001?oo10005?oo00<00?ooool0
0@000004ool00`00ooooo`06ool00`00ooooo`2Xool40002ool4000Iool10001ool1000000Coo`03
003ooooo00Koo`03003ooooo0:Coo`@000;oo`@001koo`8000001?oo00<00?ooool01Ooo0P00X_oo
10000ooo0`008_oo0P000004ool00`00ooooo`05ool2002Oool30003ool4000Qool40002ool000Co
o`03003ooooo00Goo`8009_oo`@000;oo`@0027oo`@000Koo`000ooo00<00?ooool01_oo00<00?oo
ool0U_oo10000_oo10008Ooo10002_oo0003ool00`00ooooo`06ool00`00ooooo`2Bool40003ool3
000Qool4000>ool000?oo`03003ooooo00Koo`03003ooooo08ooo`<000?oo`@0023oo`@001;oo`00
0ooo00<00?ooool01_oo00<00?ooool0Rooo10000_oo10008?oo10005_oo0003ool00`00ooooo`06
ool00`00ooooo`27ool40002ool4000Qool3000Jool000?oo`03003ooooo00Koo`03003ooooo08?o
o`@000?oo`<0027oo`@001goo`000ooo00<00?ooool01_oo00<00?ooool0P?oo0`000ooo10008?oo
10008Ooo0003ool00`00ooooo`06ool00`00ooooo`1lool40002ool4000Pool4000Uool000?oo`03
003ooooo00Koo`03003ooooo07Soo`@000;oo`@0023oo`@002Woo`000ooo00<00?ooool01_oo00<0
0?ooool0M?oo10000ooo0`008?oo1000;Ooo0003ool00`00ooooo`06ool00`00ooooo`1aool30003
ool4000Oool4000aool000?oo`03003ooooo00Goo`8006ooo`@000;oo`@0023oo`<003Goo`000ooo
00<00?ooool01Ooo0P00Jooo10000_oo10008?oo1000>?oo0002ool00`00ooooo`06ool2001Wool4
0003ool3000Pool4000lool000;oo`03003ooooo00Koo`8006Coo`<000?oo`@001ooo`@0043oo`00
0_oo00<00?ooool01_oo00<00?ooool0Gooo10000_oo10007ooo1000A?oo0002ool00`00ooooo`06
ool00`00ooooo`1Kool40002ool4000Oool40018ool000;oo`03003ooooo00Koo`03003ooooo05So
o`<000;oo`@001ooo`@004coo`000_oo00<00?ooool01_oo00<00?ooool0E?oo10000_oo0`008?oo
0`00D?oo0002ool00`00ooooo`06ool2001Aool40002ool4000Oool4001Cool000;oo`03003ooooo
00Koo`03003oo`0004coo`@000;oo`@001ooo`@005Ooo`000_oo00<00?ooool01_oo00@00?ooool0
04Soo`<000;oo`@001ooo`@005_oo`000_oo00<00?ooool01_oo00D00?ooooooo`0004?oo`@000;o
o`<001ooo`@005ooo`000_oo00<00?ooool01_oo00D00?ooooooo`0003ooo`@000;oo`@001koo`@0
06?oo`000_oo00<00?ooool01_oo00<00?ooool00_oo00<00?ooool0>?oo10000_oo10007_oo1000
Iooo0002ool00`00ooooo`06ool00`00ooooo`03ool00`00ooooo`0dool30002ool4000Oool3001[
ool00003ool00?oo00Soo`03003ooooo00Coo`03003ooooo02ooo`@000;oo`<001ooo`@006koo`00
00?oo`00ool02?oo00<00?ooool01Ooo00<00?ooool0:_oo10000_oo10007_oo1000L_oo00000ooo
003oo`08ool00`00ooooo`06ool00`00ooooo`0Uool40002ool4000Nool4001fool00003ool00?oo
00Soo`03003ooooo00Ooo`03003ooooo027oo`<000;oo`@001koo`@007[oo`0000?oo`00ool01ooo
00<00?ooool02Ooo00<00?ooool07?oo10000_oo0`007_oo1000O_oo00000ooo003oo`07ool00`00
ooooo`0:ool00`00ooooo`0Gool40002ool4000Nool30022ool00003ool00?oo00Ooo`03003ooooo
00[oo`03003ooooo01?oo`@000;oo`@001koo`@008Goo`0000?oo`00ool01ooo00<00?ooool02ooo
00<00?ooool03ooo0`000_oo10007_oo1000ROoo00000ooo003oo`07ool00`00ooooo`0<ool00`00
ooooo`0:ool40002ool3000Nool4002=ool00003ool00?oo00Ooo`03003ooooo00goo`03003ooooo
00Goo`@000;oo`@001goo`@0097oo`0000?oo`00ool01ooo00<00?ooool03_oo00<00?ooool01000
0_oo10007Ooo1000UOoo00000ooo003oo`07ool00`00ooooo`0?ool20002ool4000Mool4002Iool0
0003ool00?oo00Ooo`03003ooooo013oo`<001koo`<009goo`0000?oo`00ool01ooo00<00?ooool0
3?oo10007Ooo1000X?oo00000`00ooooo`07ool00`00ooooo`08ool4000Mool4002Tool00003003o
oooo00Ooo`03003ooooo00Coo`@001goo`@00:Soo`0000<00?ooool01ooo00@00?ooooooo`<001go
o`@00:coo`0000<00?ooool01ooo10007?oo1000/?oo00000`00ooooo`03ool5000Kool4002dool0
0003003oo`0000<000?oo`03003ooooo01Ooo`<00;Soo`000P001ooo00<00?ooool04ooo1000^ooo
00000ooo00000006ool00`00ooooo`0?ool4002oool000?oo`03003ooooo00?oo`03003ooooo00_o
o`@00<?oo`001?oo0P000ooo00<00?ooool01ooo1000aooo0006ool01000ooooo`001Ooo1000booo
0007ool300000ooo00000002003?ool000Woo`800=?oo`00\
\>"],
  ImageRangeCache->{{{0, 221.188}, {286.938, 0}} -> {0.143661, 0.0328606, \
0.00337199, 0.00337199}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics3D[{First[%%], Take[%%, \(-4\)]}]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .59994 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0506248 1.05062 -0.214019 1.05062 [
[ 0 0 0 0 ]
[ 1 .59994 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.0234 .31105 m
0 .56558 L
s
0 .56558 m
.0417 .59994 L
s
.0417 .59994 m
.06275 .34724 L
s
.06275 .34724 m
.0234 .31105 L
s
.94164 0 m
.9715 .04516 L
s
.9715 .04516 m
1 .31157 L
s
1 .31157 m
.96887 .26817 L
s
.96887 .26817 m
.94164 0 L
s
.0234 .31105 m
0 .56558 L
s
0 .56558 m
.96887 .26817 L
s
.96887 .26817 m
.94164 0 L
s
.94164 0 m
.0234 .31105 L
s
.06275 .34724 m
.9715 .04516 L
s
.9715 .04516 m
1 .31157 L
s
1 .31157 m
.0417 .59994 L
s
.0417 .59994 m
.06275 .34724 L
s
0 0 m
1 0 L
1 .59994 L
0 .59994 L
closepath
clip
newpath
.5 Mabswid
.06273 .32272 m
.05033 .47079 L
s
.08883 .50486 m
.05033 .47079 L
s
.12486 .54507 m
.08883 .50486 L
s
.857 .32198 m
.12486 .54507 L
s
.93245 .03088 m
.94781 .18617 L
s
.94781 .18617 m
.90045 .25227 L
s
.90045 .25227 m
.857 .32198 L
s
.25 Mabswid
.94164 0 m
.9715 .04516 L
s
.9715 .04516 m
1 .31157 L
s
1 .31157 m
.96887 .26817 L
s
.96887 .26817 m
.94164 0 L
s
.0234 .31105 m
0 .56558 L
s
0 .56558 m
.96887 .26817 L
s
.96887 .26817 m
.94164 0 L
s
.94164 0 m
.0234 .31105 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 172.75},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000[1000`40n007h00Ooooo3Ooo0P004_oo
003oool:ool300000ooo0000000Aool00?ooo`Ooo`<000Coo`80017oo`00oooo1?oo0`001ooo00<0
0?oo00004?oo003oool1ool3000:ool01000ooooo`003ooo003mool3000>ool00`00ool0000?ool0
0?[oo`<0017oo`04003ooooo000>ool00?Ooo`<001Coo`05003oooooool0000=ool00?Coo`<001Oo
o`03003ooooo00;oo`03003ooooo00[oo`00l_oo0P005ooo00@00?ooool000Coo`03003ooooo00[o
o`00kooo0`006Ooo00@00?ooool000Goo`03003ooooo00Woo`00k?oo0`007?oo00@00?ooool000Ko
o`03003ooooo00Soo`00jOoo0`007ooo00@00?ooool000Koo`03003ooooo00Soo`00i_oo0`008_oo
00@00?ooool000Koo`8000Woo`00hooo0`009Ooo00@00?ooool000?oo`<00003ool00?oo00Soo`00
h?oo0`00:Ooo00<00?ooool00`001?oo00<00?ooool01ooo003Mool3000/ool40006ool00`00oooo
o`07ool00=[oo`<002coo`@000;oo`03003ooooo00Coo`03003ooooo00Ooo`00eooo0`00;?oo0`00
0ooo00@00?ooool000Ooo`03003ooooo00Koo`00e?oo0`00;?oo0`001_oo00@00?ooool000Ooo`03
003ooooo00Koo`00dOoo0`00;?oo0`002Ooo00@00?ooool000Ooo`03003ooooo00Koo`00c_oo0`00
;?oo0`003?oo00@00?ooool000Ooo`03003ooooo00Koo`00booo0`00;?oo0`003ooo00@00?ooool0
00Ooo`03003ooooo00Koo`00b?oo0`00;?oo0`004_oo00@00?ooool000Ooo`03003ooooo00Koo`00
aOoo0`00;?oo0`005Ooo00@00?ooool000Ooo`03003ooooo00Koo`00`_oo0`00;?oo0`006?oo00D0
0?ooooooo`0000Koo`03003ooooo00Koo`00_ooo0`00;?oo0`007?oo00@00?ooool000Koo`03003o
oooo00Koo`00_Ooo0P00;?oo0`007ooo00@00?ooool000Koo`03003ooooo00Koo`00^_oo0`00:ooo
0`008_oo00@00?ooool000Ooo`03003ooooo00Goo`00]ooo0`00:ooo0`009Ooo00@00?ooool000Oo
o`03003ooooo00Goo`00]?oo0`00:ooo0`00:?oo00@00?ooool000Ooo`03003ooooo00Goo`00/Ooo
0`00:ooo0`00:ooo00@00?ooool000Ooo`03003ooooo00Goo`00[_oo0`00:ooo0`00;_oo00@00?oo
ool000Ooo`03003ooooo00Goo`00Zooo0`00:ooo0`00<Ooo00@00?ooool000Ooo`03003ooooo00Go
o`00Z?oo0`00:_oo1000=?oo00D00?ooooooo`0000Koo`03003ooooo00Goo`00YOoo0`00:_oo0`00
>?oo00D00?ooooooo`0000Koo`03003ooooo00Goo`00X_oo0`00:_oo0`00>ooo00D00?ooooooo`00
00Koo`03003ooooo00Goo`00Wooo0`00:_oo0`00?ooo00@00?ooool000Ooo`03003ooooo00Coo`00
W?oo0`00:_oo0`00@_oo00@00?ooool000Ooo`03003ooooo00Coo`00VOoo0`00:_oo0`00AOoo00@0
0?ooool000Ooo`03003ooooo00Coo`00U_oo0`00:_oo0`00B?oo00@00?ooool000Ooo`03003ooooo
00Coo`00Tooo0`00:_oo0`00Booo00@00?ooool000Ooo`03003ooooo00Coo`00T?oo0`00:_oo0`00
C_oo00@00?ooool000Ooo`03003ooooo00Coo`00SOoo0`00:_oo0`00DOoo00@00?ooool000Ooo`03
003ooooo00Coo`00R_oo0`00:_oo0`00E?oo00D00?ooooooo`0000Koo`03003ooooo00Coo`00R?oo
0P00:_oo0`00Eooo00D00?ooooooo`0000Koo`03003ooooo00Coo`00QOoo0`00:Ooo0`00F_oo00D0
0?ooooooo`0000Koo`03003ooooo00Coo`00P_oo0`00:Ooo0`00GOoo00D00?ooooooo`0000Ooo`03
003ooooo00?oo`00Oooo0`00:Ooo0`00HOoo00@00?ooool000Ooo`03003ooooo00?oo`00O?oo0`00
:Ooo0`00I?oo00@00?ooool000Ooo`03003ooooo00?oo`00NOoo0`00:Ooo0`00Iooo00@00?ooool0
00Ooo`03003ooooo00?oo`00M_oo0`00:Ooo0`00J_oo00@00?ooool000Ooo`03003ooooo00?oo`00
Looo0`00:Ooo0`00KOoo00@00?ooool000Ooo`03003ooooo00?oo`00L?oo0`00:Ooo0`00L?oo00D0
0?ooooooo`0000Koo`03003ooooo00?oo`00KOoo0`00:Ooo0`00L_oo00<00?ooool00_oo00<00?oo
ool01?oo00<00?ooool00ooo001Zool3000Yool3001eool00`00ooooo`02ool00`00ooooo`04ool0
0`00ooooo`03ool006Ooo`<002Woo`<007Ooo`03003ooooo00?oo`03003ooooo00Goo`03003ooooo
00;oo`00I?oo0`00:Ooo0`00NOoo00<00?ooool01?oo00<00?ooool01Ooo00<00?ooool00_oo001Q
ool3000Yool3001lool00`00ooooo`04ool00`00ooooo`05ool00`00ooooo`02ool005koo`<002Wo
o`<007koo`03003ooooo00Goo`03003ooooo00Goo`03003ooooo00;oo`00Fooo0`00:Ooo0`00P?oo
00<00?ooool01_oo00<00?ooool01Ooo00<00?ooool00_oo001Hool3000Yool30023ool00`00oooo
o`06ool00`00ooooo`05ool00`00ooooo`02ool005Koo`8002Woo`<008Goo`03003ooooo00Ooo`03
003ooooo00Goo`03003ooooo00;oo`00Dooo0`00:?oo0`00Qooo00<00?ooool02Ooo00<00?ooool0
1?oo00<00?ooool00_oo001@ool3000Xool30029ool00`00ooooo`0:ool00`00ooooo`04ool00`00
ooooo`02ool004goo`<002Soo`<008coo`03003ooooo00[oo`03003ooooo00Coo`03003ooooo00;o
o`00B_oo0`00:?oo0`00S_oo00<00?ooool02ooo00<00?ooool01Ooo00<00?ooool00Ooo0017ool3
000Xool3002@ool00`00ooooo`0<ool00`00ooooo`05ool00`00ooooo`01ool004Coo`<002Soo`<0
09?oo`03003ooooo00coo`03003ooooo00Goo`03003ooooo007oo`00@Ooo0`00:?oo0`00UOoo00<0
0?ooool03Ooo00<00?ooool01Ooo00<00?ooool00Ooo000nool3000Xool3002Gool00`00ooooo`0>
ool00`00ooooo`05ool00`00ooooo`01ool003_oo`<002Soo`<009[oo`03003ooooo00koo`03003o
oooo00Goo`03003ooooo007oo`00>?oo0`00:?oo0`00W?oo00<00?ooool03ooo00<00?ooool01Ooo
00<00?ooool00Ooo000eool3000Xool3002Nool00`00ooooo`0Aool00`00ooooo`04ool00`00oooo
o`01ool003;oo`<002Soo`<00:7oo`03003ooooo017oo`03003ooooo00Coo`03003ooooo007oo`00
;ooo0`00:?oo0`00Xooo00<00?ooool04_oo00<00?ooool01Ooo0@000Ooo0Ooo000/ool3000Xool3
002Uool00`00ooooo`0Cool00`00ooooo`05ool10001ool1ool002Woo`<002Ooo`@00:Soo`03003o
oooo01;oo`8000Ooo`40007oo`7oo`009_oo0`009ooo0`00Zooo00<00?ooool04?oo0`000_oo00<0
0?ooool01?oo0@000Ooo0Ooo000Sool3000Wool3002]ool00`00ooooo`0=ool40005ool00`00oooo
o`04ool10001ool1ool0027oo`8002Ooo`<00;3oo`03003ooooo00[oo`<000[oo`03003ooooo00?o
o`40007oo`7oo`007_oo0`009_oo0`00/_oo00<00?ooool02?oo0`003_oo00<00?ooool00_oo0@00
0Ooo0Ooo000Kool3000Vool3002eool00`00ooooo`05ool3000Bool01@00oooooooo00000_oo000H
ool3000Vool3002gool00`00ooooo`02ool4000Eool01@00oooooooo00000_oo000Eool3000Vool3
002iool00`00ooooo`03000Jool01000ooooo`000_oo000Bool3000Vool3002lool3000Nool01000
ooooo`000Ooo000?ool3000Vool3002lool3000Rool00`00ool00001ool000coo`<002Koo`<00;_o
o`@00003ool00?oo02;oo`03003oo`00007oo`002Ooo0`009_oo0`00^ooo0`001Ooo00<00?ooool0
8_oo0P000Ooo0007ool2000Vool3002kool30007ool00`00ooooo`0Sool20001ool000Ooo`8002?o
o`<00;_oo`<000Woo`03003ooooo023oo`@000?oo`001ooo00<00?oo00007ooo0`00^_oo10003?oo
00<00?ooool07Ooo0`001ooo0007ool01000ooooo`001ooo00<00?ooool04Ooo0`00^_oo0`003_oo
0P007Ooo0`002_oo0007ool01@00oooooooo00001_oo00<00?ooool03_oo0`00^_oo0`003_oo0`00
6ooo10003Ooo0007ool00`00ooooo`02ool20004ool00`00ooooo`0;ool3002iool4000=ool4000K
ool3000Aool000Koo`03003ooooo00Goo`05003oooooool0000:ool3002iool3000>ool3000Lool3
000Dool000Koo`03003ooooo00Koo`04003ooooo0007ool3002iool3000>ool3000Kool4000Gool0
00Koo`03003ooooo00Ooo`03003oo`0000Coo`<00;Woo`<000koo`<001_oo`<001_oo`001_oo00<0
0?ooool02?oo00<00?ooool00`00^?oo10003Ooo10006ooo0`007_oo0006ool00`00ooooo`08ool3
002hool3000>ool3000Kool4000Qool000Koo`03003ooooo00Soo`800;Koo`<000koo`<001_oo`<0
02Goo`001_oo00<00?ooool02?oo0P00/ooo0`003Ooo10006ooo0`00:?oo0006ool00`00ooooo`08
ool2002_ool4000=ool3000Kool4000[ool000Koo`03003ooooo00Soo`800:coo`<000koo`<001_o
o`<002ooo`001_oo00<00?ooool02?oo0P00ZOoo0`003_oo0`006ooo0`00<_oo0005ool00`00oooo
o`09ool2002Vool3000=ool4000Jool4000eool000Goo`03003ooooo00Woo`03003ooooo0:7oo`@0
00goo`<001_oo`<003Woo`001Ooo00<00?ooool02Ooo00<00?ooool0W_oo0`003_oo0`006ooo0`00
??oo0005ool00`00ooooo`09ool00`00ooooo`2Kool3000>ool3000Jool4000oool000Goo`03003o
oooo00Soo`8009[oo`<000goo`@001[oo`<004?oo`001Ooo00<00?ooool02?oo0P00U_oo10003Ooo
0`006ooo0`00A_oo0005ool00`00ooooo`08ool2002Cool3000>ool3000Jool40019ool000Goo`03
003ooooo00Soo`80093oo`<000koo`<001[oo`<004goo`001Ooo00<00?ooool02?oo0P00SOoo0`00
3Ooo10006_oo0`00D?oo0005ool00`00ooooo`08ool20029ool4000=ool3000Jool4001Cool000Go
o`03003ooooo00Soo`8008Koo`<000koo`<001[oo`<005Ooo`001?oo00<00?ooool02Ooo0P00Pooo
0`003Ooo10006_oo0`00F_oo0004ool00`00ooooo`09ool20020ool3000=ool3000Jool4001Mool0
00Coo`03003ooooo00Woo`03003ooooo07_oo`@000goo`<001[oo`<0067oo`001?oo00<00?ooool0
2?oo0P00N_oo0`003_oo0`006_oo0`00I?oo0004ool00`00ooooo`08ool2001gool3000=ool4000I
ool4001Wool000Coo`03003ooooo00Soo`8007?oo`@000goo`<001[oo`<006_oo`001?oo00<00?oo
ool02?oo0P00L?oo0`003_oo0`006_oo0`00K_oo0004ool00`00ooooo`08ool2001]ool3000>ool3
000Iool4001aool000Coo`03003ooooo00Soo`8006[oo`<000goo`@001Woo`<007Goo`001?oo00<0
0?ooool02?oo0P00I_oo10003Ooo0`006_oo0`00N?oo0003ool00`00ooooo`09ool2001Sool3000>
ool3000Iool4001kool000?oo`03003ooooo00Woo`80063oo`<000koo`<001Woo`<007ooo`000ooo
00<00?ooool02Ooo0P00GOoo0`003Ooo10006Ooo0`00P_oo0003ool00`00ooooo`09ool2001Iool4
000=ool3000Iool40025ool000?oo`03003ooooo00Soo`8005Ooo`<000koo`<001Woo`<008Woo`00
0ooo00<00?ooool02?oo0P00E?oo0`003_oo0`006?oo1000S?oo0003ool00`00ooooo`08ool2001A
ool3000=ool4000Hool3002@ool000?oo`03003ooooo00Soo`8004goo`@000goo`<001Woo`<009?o
o`000ooo00<00?ooool02?oo0P00B_oo0`003_oo0`006?oo1000U_oo0003ool00`00ooooo`08ool2
0017ool3000=ool4000Hool3002Jool000;oo`03003ooooo00[oo`03003ooooo04;oo`<000goo`<0
01Woo`<009goo`000_oo00<00?ooool02_oo0`00?_oo10003Ooo0`006?oo1000X?oo0002ool00`00
ooooo`0:ool01000ooooo`00>_oo0`003_oo0`006?oo0`00Y?oo0002ool00`00ooooo`0:ool01@00
oooooooo0000=_oo0`003Ooo10006?oo0`00Yooo0002ool00`00ooooo`0:ool00`00ooooo`02ool0
0`00ooooo`0`ool3000=ool3000Hool4002Zool000;oo`03003ooooo00[oo`03003ooooo00?oo`03
003ooooo02_oo`@000goo`<001Soo`<00:koo`000_oo00<00?ooool02Ooo00<00?ooool01Ooo0P00
:?oo0`003_oo0`006?oo0`00/Ooo0002ool00`00ooooo`09ool00`00ooooo`07ool00`00ooooo`0R
ool3000=ool4000Gool4002dool000;oo`03003ooooo00Woo`03003ooooo00Soo`03003ooooo01ko
o`<000goo`<001Soo`<00;Soo`000_oo00<00?ooool02Ooo00<00?ooool02Ooo00<00?ooool06Ooo
10003Ooo0`006?oo0`00^ooo0002ool00`00ooooo`09ool00`00ooooo`0:ool00`00ooooo`0Eool3
000>ool3000Gool4002nool00003ool00?oo00_oo`03003ooooo00_oo`03003ooooo017oo`<000go
o`@001Ooo`<00<;oo`0000?oo`00ool02ooo00<00?ooool03?oo00<00?ooool03?oo10003Ooo0`00
6?oo0`00aOoo00000ooo003oo`0;ool00`00ooooo`0=ool00`00ooooo`08ool3000>ool3000Gool4
0038ool00003ool00?oo00_oo`03003ooooo00goo`03003ooooo00Goo`<000goo`@001Ooo`<00<co
o`0000?oo`00ool02ooo00<00?ooool03_oo00@00?ooooooo`<000goo`<001Soo`<00<ooo`0000?o
o`00ool02ooo00<00?ooool03_oo10003Ooo0`005ooo1000d_oo00000ooo003oo`0;ool00`00oooo
o`0;ool30002ool00`00ooooo`09ool3000Gool3003Fool00003ool00?oo00[oo`03003ooooo00Wo
o`<000Koo`03003ooooo00Coo`@001Ooo`<00=Woo`0000?oo`00ool02_oo00<00?ooool01_oo0`00
2_oo00<00?ooool00`005ooo1000g?oo00000ooo003oo`0:ool00`00ooooo`02ool4000>ool2000G
ool3003Pool00003003ooooo00[oo`03003oo`00008002Soo`<00>?oo`0000<00?ooool02Ooo0`00
9ooo1000i_oo00000`00ooooo`06ool300000ooo003oo`0Tool3003Zool00003003ooooo00;oo`@0
00Coo`03003ooooo023oo`<00>goo`0000<00?oo00000P002?oo00<00?ooool07?oo1000l?oo0002
000;ool00`00ooooo`0Iool3003dool00003ool00?oo00[oo`03003ooooo01Koo`<00?Ooo`000_oo
0P002Ooo00<00?ooool04_oo1000n_oo0004ool00`00ooooo`06ool00`00ooooo`0?ool3003nool0
00Goo`03003ooooo00Coo`03003ooooo00goo`<00?ooo`;oo`001_oo0P001?oo00<00?ooool02Ooo
1000oooo1Ooo0008ool01@00oooooooo00002?oo0`00oooo2Ooo0009ool01000ooooo`001Ooo0`00
oooo3?oo000:ool300000ooo00000002003oool?ool000coo`800?oooa?oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {171.75, 0}} -> {0.0469817, 0.203704, \
0.00332483, 0.00332483}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
boxcorners[ pt , linemul, curvemul ] 
is 2D or 3D dep. on pt\
\>", "Subsubsection"],

Cell[BoxData[
    \(boxcorners[pt_, linemul_, 
        curvemul_] := \[IndentingNewLine]Extract[\[IndentingNewLine]\(If[
            Length[pt[\([1]\)]] === 2, boxwithcorners2D, boxwithcorners3D]\)[
          pt, linemul, 
          curvemul]\[IndentingNewLine], {{2}, {4}, {6}, {8}}\
\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            True]; \[IndentingNewLine]\[IndentingNewLine]boxcorners[v,  .1, 
          2]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics[%]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.485622 0.0340136 -0.298023 0.0173119 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.02381 .07358 m
.02381 .01472 L
.11905 .01472 L
s
.88095 .01472 m
.97619 .01472 L
.97619 .07358 L
s
.97619 .54446 m
.97619 .60332 L
.88095 .60332 L
s
.11905 .60332 m
.02381 .60332 L
.02381 .54446 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo0007oolL003IoolL0008ool000Ooo`03003ooooo0?ooo`koo`03003o
oooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool0
0`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo
3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo
0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00
ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo
00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool0
00Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool0
1_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003o
oooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo
8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool0
0?ooob7oo`00oooo8Ooo003ooolQool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo
00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool0
00Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool0
1_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003o
oooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool0
0`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo
3_oo00<00?ooool01_oo0007ool00`00ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo
0?ooo`koo`03003ooooo00Koo`001ooo00<00?ooool0oooo3_oo00<00?ooool01_oo0007ool00`00
ooooo`3oool>ool00`00ooooo`06ool000Ooo`03003ooooo0?ooo`koo`03003ooooo00Koo`001ooo
00<00?ooool0oooo3_oo00<00?ooool01_oo0007oolL003IoolL0008ool00?ooob7oo`00oooo8Ooo
003ooolQool00?ooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {14.2408, 17.2147, 0.102693, \
0.201767}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics[{%%[\([2]\)], %%[\([4]\)]}]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.485622 0.0340136 -0.298023 0.0173119 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
.5 Mabswid
[ ] 0 setdash
.88095 .01472 m
.97619 .01472 L
.97619 .07358 L
s
.11905 .60332 m
.02381 .60332 L
.02381 .54446 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003loolL0008ool00?oooaSoo`03003ooooo00Koo`00oooo6?oo00<0
0?ooool01_oo003ooolHool00`00ooooo`06ool00?oooaSoo`03003ooooo00Koo`00oooo6?oo00<0
0?ooool01_oo003ooolHool00`00ooooo`06ool00?oooaSoo`03003ooooo00Koo`00oooo6?oo00<0
0?ooool01_oo003ooolHool00`00ooooo`06ool00?oooaSoo`03003ooooo00Koo`00oooo6?oo00<0
0?ooool01_oo003ooolHool00`00ooooo`06ool00?oooaSoo`03003ooooo00Koo`00oooo6?oo00<0
0?ooool01_oo003ooolHool00`00ooooo`06ool00?oooaSoo`03003ooooo00Koo`00oooo6?oo00<0
0?ooool01_oo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7o
o`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003o
oolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool000Ooo`03
003ooooo0?oooaOoo`001ooo00<00?ooool0oooo5ooo0007ool00`00ooooo`3ooolGool000Ooo`03
003ooooo0?oooaOoo`001ooo00<00?ooool0oooo5ooo0007ool00`00ooooo`3ooolGool000Ooo`03
003ooooo0?oooaOoo`001ooo00<00?ooool0oooo5ooo0007ool00`00ooooo`3ooolGool000Ooo`03
003ooooo0?oooaOoo`001ooo00<00?ooool0oooo5ooo0007ool00`00ooooo`3ooolGool000Ooo`03
003ooooo0?oooaOoo`001ooo00<00?ooool0oooo5ooo0007ool00`00ooooo`3ooolGool000Ooo`03
003ooooo0?oooaOoo`001ooo00<00?ooool0oooo5ooo0007oolL003mool00?ooob7oo`00oooo8Ooo
003ooolQool00?ooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {14.2408, 17.2147, 0.102693, \
0.201767}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, 
          v}, \[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04\ }; \nll = {\(- .04\),  .01, \(- .04\)}; \n
        lr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]v = 
          boxpts[opos[1, 1], sc, ul, ll, lr, ur, 
            False]; \[IndentingNewLine]\[IndentingNewLine]boxcorners[v,  .1, 
          2]\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics3D[%]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.29616 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.192623 1.34078 -0.0446149 1.34078 [
[ 0 0 0 0 ]
[ 1 1.29616 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.04124 1.29616 L
s
.04124 1.29616 m
.10811 .33677 L
s
.10811 .33677 m
.07399 .30079 L
s
.88524 0 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.88524 0 m
.07399 .30079 L
s
.10811 .33677 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.04124 1.29616 L
s
.04124 1.29616 m
.10811 .33677 L
s
0 0 m
1 0 L
1 1.29616 L
0 1.29616 L
closepath
clip
newpath
.5 Mabswid
.10747 .33183 m
.17917 .3056 L
s
.10192 .41117 m
.10747 .33183 L
s
.79667 .07963 m
.87981 .0492 L
s
.87981 .0492 m
.88635 .13085 L
s
.04339 1.24871 m
.05078 1.14299 L
s
.12702 1.22646 m
.04339 1.24871 L
s
.94753 .89401 m
.95648 1.00578 L
s
.95648 1.00578 m
.85687 1.03228 L
s
.25 Mabswid
.88524 0 m
.91285 .04274 L
s
.91285 .04274 m
1 1.0461 L
s
1 1.0461 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.07399 .30079 m
0 1.26599 L
s
0 1.26599 m
.96803 1.00907 L
s
.96803 1.00907 m
.88524 0 L
s
.88524 0 m
.07399 .30079 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{222.188, 287.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40003N00017a000`40n007h00O`_oo0P006_oo002o
ool300000ooo0000000Iool00;goo`8000Coo`8001Woo`00^_oo0`001_oo00<00?oo00006?oo002g
ool30009ool01000ooooo`005ooo002eool2000<ool01000ooooo`005ooo002bool3000?ool01000
ooooo`005_oo002_ool3000Bool01@00oooooooo00005Ooo002/ool3000Eool01@00oooooooo0000
5Ooo002Zool2000Hool01000oooooooo0P005?oo002Wool3000Jool400000ooo003oo`0Cool00:Co
o`<001[oo`@000Coo`03003ooooo01;oo`00X_oo0P006_oo1@0000?oo`00ool00ooo00<00?ooool0
4_oo002Oool3000Iool50002ool00`00ool00004ool00`00ooooo`0Bool009coo`<001Woo`D000Go
o`03003oo`0000Coo`03003ooooo01;oo`00VOoo0`006Ooo1@002?oo00<00?oo00001Ooo00<00?oo
ool04Ooo002Gool2000Iool6000;ool20005ool00`00ooooo`0Aool009Coo`<001Woo`D000koo`80
00Goo`03003ooooo017oo`00TOoo0`006ooo0`004Ooo00<00?oo00001?oo00<00?ooool04Ooo002?
ool2000Lool2000Dool00`00ool00004ool00`00ooooo`0Aool008coo`<001_oo`<001Koo`03003o
o`0000Coo`03003ooooo017oo`00ROoo0`006ooo0`006Ooo00<00?oo00001?oo00<00?ooool04Ooo
0026ool3000Lool2000Lool00`00ool00004ool00`00ooooo`0Aool008Coo`8001coo`<001koo`03
003oo`0000Coo`03003ooooo017oo`00POoo0`006ooo0`008Ooo00<00?oo00001?oo00<00?ooool0
4Ooo001nool3000Kool3000Uool20004ool00`00ooooo`0Aool007coo`8001coo`8002Soo`8000Go
o`03003ooooo013oo`00NOoo0`006ooo0`00:_oo0P001Ooo00<00?ooool04?oo001fool3000Kool3
000]ool20005ool00`00ooooo`0@ool007?oo`<001_oo`<0033oo`8000Goo`03003ooooo013oo`00
LOoo0P007?oo0P00=Ooo00<00?ooool00_oo00<00?ooool04?oo001^ool3000Kool3000gool00`00
ooooo`02ool00`00ooooo`0@ool006_oo`<001_oo`<003[oo`03003ooooo00;oo`03003ooooo013o
o`00JOoo0P006ooo0`00?Ooo00<00?ooool00_oo00<00?ooool04?oo001Vool3000Kool20010ool0
0`00ooooo`02ool00`00ooooo`0@ool006?oo`<001_oo`<004;oo`03003ooooo00;oo`03003ooooo
013oo`00HOoo0P006ooo0`00AOoo00<00?ooool00_oo00<00?ooool04?oo001Nool3000Jool30018
ool00`00ooooo`03ool00`00ooooo`0?ool005_oo`<001_oo`8004_oo`03003ooooo00?oo`03003o
oooo00ooo`00F?oo0`006ooo0`00COoo00<00?ooool00ooo00<00?ooool03ooo001Fool2000Kool3
001@ool00`00ooooo`03ool00`00ooooo`0?ool005?oo`<001[oo`<005?oo`03003ooooo00?oo`03
003ooooo00ooo`00D?oo0`006ooo0P00Eooo00<00?ooool00_oo00<00?ooool03ooo001>ool2000K
ool3001Iool00`00ooooo`02ool00`00ooooo`0?ool004_oo`<001[oo`<005coo`03003ooooo00;o
o`03003ooooo00ooo`00B?oo0`006ooo0P00Gooo00<00?ooool00_oo00<00?ooool03ooo0015ool3
000Kool3001Qool00`00ooooo`02ool00`00ooooo`0?ool004?oo`8001_oo`<006Coo`03003ooooo
00;oo`03003ooooo00ooo`00@?oo0`006_oo0`00Iooo00<00?ooool00ooo00<00?ooool03_oo000m
ool3000Kool2001Zool00`00ooooo`03ool00`00ooooo`0>ool003_oo`8001_oo`<006coo`03003o
oooo00?oo`03003ooooo00koo`00>?oo0`006_oo0`00Kooo00<00?ooool00ooo00<00?ooool03_oo
000eool3000Jool3001bool00`00ooooo`03ool00`00ooooo`0>ool003;oo`<001_oo`8007Koo`03
003ooooo00;oo`03003ooooo00koo`00<?oo0P006ooo0`00N?oo00<00?ooool00_oo00<00?ooool0
3_oo000]ool3000Jool3001kool00`00ooooo`02ool00`00ooooo`0>ool002[oo`<001[oo`<007ko
o`03003ooooo00;oo`03003ooooo00koo`00:?oo0P006ooo0P00POoo00<00?ooool00_oo00<00?oo
ool03_oo000Uool3000Jool30023ool00`00ooooo`02ool00`00ooooo`0>ool002;oo`<001[oo`<0
08Koo`03003ooooo00?oo`03003ooooo00goo`007ooo0`006_oo0`00ROoo00<00?ooool00ooo00<0
0?ooool03Ooo000Mool2000Kool2002<ool00`00ooooo`03ool00`00ooooo`0=ool001[oo`<001[o
o`<008koo`03003ooooo00?oo`03003ooooo00goo`005ooo0`006_oo0`00TOoo00<00?ooool00ooo
00<00?ooool03Ooo000Eool2000Kool2002Dool00`00ooooo`03ool00`00ooooo`0=ool001;oo`<0
01[oo`<009Ooo`03003ooooo00;oo`03003ooooo00goo`004?oo0P006_oo0`00V_oo00<00?ooool0
0_oo00<00?ooool03Ooo000@ool2000Dool200001?oo00000000WOoo00<00?ooool00_oo00<00?oo
ool03Ooo000@ool00`00ool0000@ool300000ooo0000002Pool00`00ooooo`02ool00`00ooooo`0=
ool0013oo`04003ooooo000=ool200001?oo00000000X_oo00<00?ooool00_oo00<00?ooool03Ooo
000@ool01000ooooo`002_oo1P00YOoo00<00?ooool00_oo00<00?ooool03Ooo000@ool01@00oooo
oooo00001_oo1P00Z?oo00<00?ooool00ooo00<00?ooool03?oo000@ool00`00ooooo`02ool01000
oooooooo0P0000?oo`000000Zooo00<00?ooool00ooo00<00?ooool03?oo000?ool00`00ooooo`04
ool6002]ool00`00ooooo`03ool00`00ooooo`0<ool000ooo`03003ooooo00Goo`800;3oo`03003o
oooo00?oo`03003ooooo00coo`003ooo00<00?ooool01Ooo00<00?ooool0[ooo00<00?ooool00ooo
00<00?ooool03?oo000?ool00`00ooooo`05ool00`00ooooo`2_ool00`00ooooo`03ool00`00oooo
o`0<ool000ooo`03003ooooo00Goo`03003ooooo0;3oo`03003ooooo00;oo`03003ooooo00coo`00
3ooo00<00?ooool01Ooo00<00?ooool0/?oo00<00?ooool00_oo00<00?ooool03?oo000?ool00`00
ooooo`05ool00`00ooooo`2`ool00`00ooooo`02ool00`00ooooo`0<ool000ooo`03003ooooo00Go
o`03003ooooo0;3oo`03003ooooo00;oo`03003ooooo00coo`003ooo00<00?ooool01Ooo00<00?oo
ool0/?oo00<00?ooool00_oo00<00?ooool03?oo000?ool00`00ooooo`04ool2002bool00`00oooo
o`03ool00`00ooooo`0;ool000ooo`03003ooooo00Coo`03003ooooo0;7oo`03003ooooo00?oo`03
003ooooo00_oo`003ooo00<00?ooool01?oo00<00?ooool0/Ooo00<00?ooool00ooo00<00?ooool0
2ooo000?ool00`00ooooo`04ool00`00ooooo`2aool00`00ooooo`03ool00`00ooooo`0;ool000oo
o`03003ooooo00Coo`03003ooooo0;7oo`03003ooooo00?oo`03003ooooo00_oo`003_oo00<00?oo
ool01Ooo00<00?ooool0/Ooo00<00?ooool00ooo00<00?ooool02ooo000>ool00`00ooooo`05ool0
0`00ooooo`2aool00`00ooooo`03ool00`00ooooo`0;ool000koo`03003ooooo00Goo`03003ooooo
0;;oo`03003ooooo00;oo`03003ooooo00_oo`003_oo00<00?ooool01Ooo00<00?ooool0/_oo00<0
0?ooool00_oo00<00?ooool02ooo000>ool00`00ooooo`05ool00`00ooooo`2bool00`00ooooo`02
ool00`00ooooo`0;ool000koo`03003ooooo00Goo`03003ooooo0;;oo`03003ooooo00;oo`03003o
oooo00_oo`003_oo00<00?ooool01Ooo00<00?ooool0/_oo00<00?ooool00ooo00<00?ooool02_oo
000>ool00`00ooooo`05ool00`00ooooo`2bool00`00ooooo`03ool00`00ooooo`0:ool000koo`03
003ooooo00Goo`03003ooooo0;;oo`03003ooooo00?oo`03003ooooo00[oo`003_oo00<00?ooool0
1Ooo00<00?ooool0/_oo00<00?ooool00ooo00<00?ooool02_oo000>ool00`00ooooo`04ool00`00
ooooo`2cool00`00ooooo`03ool00`00ooooo`0:ool000koo`03003ooooo00Coo`03003ooooo0;?o
o`03003ooooo00?oo`03003ooooo00[oo`003_oo00<00?ooool01?oo00<00?ooool0/ooo00<00?oo
ool00ooo00<00?ooool02_oo000=ool00`00ooooo`05ool00`00ooooo`2dool00`00ooooo`02ool0
0`00ooooo`0:ool000goo`03003ooooo00Goo`03003ooooo0;Coo`03003ooooo00;oo`03003ooooo
00[oo`003Ooo00<00?ooool01Ooo00<00?ooool0]?oo00<00?ooool00_oo00<00?ooool02_oo000=
ool00`00ooooo`05ool00`00ooooo`2dool00`00ooooo`02ool00`00ooooo`0:ool000goo`03003o
oooo00Goo`03003ooooo0;Coo`03003ooooo00?oo`03003ooooo00Woo`003Ooo00<00?ooool01Ooo
00<00?ooool0]?oo00<00?ooool00ooo00<00?ooool02Ooo000=ool00`00ooooo`05ool00`00oooo
o`2dool00`00ooooo`03ool00`00ooooo`09ool000goo`03003ooooo00Goo`03003ooooo0;Coo`03
003ooooo00?oo`03003ooooo00Woo`003Ooo00<00?ooool01Ooo00<00?ooool0]?oo00<00?ooool0
0ooo00<00?ooool02Ooo000=ool00`00ooooo`05ool00`00ooooo`2dool00`00ooooo`03ool00`00
ooooo`09ool000goo`03003ooooo00Goo`03003ooooo0;Coo`03003ooooo00?oo`03003ooooo00Wo
o`003Ooo00<00?ooool01Ooo00<00?ooool0]?oo00<00?ooool00ooo00<00?ooool02Ooo000=ool0
0`00ooooo`04ool00`00ooooo`2fool00`00ooooo`02ool00`00ooooo`09ool000coo`03003ooooo
00Goo`03003ooooo0;Koo`03003ooooo00;oo`03003ooooo00Woo`003?oo00<00?ooool01Ooo00<0
0?ooool0]_oo00<00?ooool00_oo00<00?ooool02Ooo000<ool00`00ooooo`05ool00`00ooooo`2f
ool00`00ooooo`03ool00`00ooooo`08ool000coo`03003ooooo00Goo`03003ooooo0;Koo`03003o
oooo00?oo`03003ooooo00Soo`003?oo00<00?ooool01Ooo00<00?ooool0]_oo00<00?ooool00ooo
00<00?ooool02?oo000<ool00`00ooooo`05ool00`00ooooo`2fool00`00ooooo`03ool00`00oooo
o`08ool000coo`03003ooooo00Goo`03003ooooo0;Koo`03003ooooo00?oo`03003ooooo00Soo`00
3?oo00<00?ooool01Ooo00<00?ooool0]_oo00<00?ooool00ooo00<00?ooool02?oo000<ool00`00
ooooo`05ool00`00ooooo`2fool00`00ooooo`03ool00`00ooooo`08ool000coo`03003ooooo00Go
o`03003ooooo0;Koo`03003ooooo00?oo`03003ooooo00Soo`003?oo00<00?ooool01Ooo00<00?oo
ool0]_oo00<00?ooool00ooo00<00?ooool02?oo000<ool00`00ooooo`05ool00`00ooooo`2gool0
0`00ooooo`02ool00`00ooooo`08ool000coo`03003ooooo00Goo`03003ooooo0;Ooo`03003ooooo
00;oo`03003ooooo00Soo`003?oo00<00?ooool01Ooo00<00?ooool0]ooo00<00?ooool00ooo00<0
0?ooool01ooo000;ool00`00ooooo`06ool00`00ooooo`2gool00`00ooooo`03ool00`00ooooo`07
ool000_oo`03003ooooo00Goo`03003ooooo0;Soo`03003ooooo00?oo`03003ooooo00Ooo`002ooo
00<00?ooool01Ooo00<00?ooool0^?oo00<00?ooool00ooo00<00?ooool01ooo000;ool00`00oooo
o`05ool00`00ooooo`2hool00`00ooooo`03ool00`00ooooo`07ool000_oo`03003ooooo00Goo`03
003ooooo0;Soo`03003ooooo00?oo`03003ooooo00Ooo`002ooo00<00?ooool01Ooo00<00?ooool0
^?oo00<00?ooool00ooo00<00?ooool01ooo000;ool00`00ooooo`05ool00`00ooooo`2hool00`00
ooooo`03ool00`00ooooo`07ool000_oo`03003ooooo00Goo`03003ooooo0;Soo`03003ooooo00?o
o`03003ooooo00Ooo`002ooo00<00?ooool01Ooo00<00?ooool0^Ooo00<00?ooool00_oo00<00?oo
ool01ooo000;ool00`00ooooo`05ool00`00ooooo`2iool00`00ooooo`02ool00`00ooooo`07ool0
00_oo`03003ooooo00Goo`03003ooooo0;Woo`03003ooooo00?oo`03003ooooo00Koo`002ooo00<0
0?ooool01Ooo00<00?ooool0^Ooo00<00?ooool00ooo00<00?ooool01_oo000;ool00`00ooooo`05
ool00`00ooooo`2iool00`00ooooo`03ool00`00ooooo`06ool000[oo`03003ooooo00Koo`03003o
oooo0;Woo`03003ooooo00?oo`03003ooooo00Koo`002_oo00<00?ooool01_oo00<00?ooool0^Ooo
00<00?ooool00ooo00<00?ooool01_oo000:ool00`00ooooo`06ool00`00ooooo`2iool00`00oooo
o`03ool00`00ooooo`06ool000[oo`03003ooooo00Goo`03003ooooo0;[oo`03003ooooo00?oo`03
003ooooo00Koo`002_oo00<00?ooool01Ooo00<00?ooool0^_oo00<00?ooool00ooo00<00?ooool0
1_oo000:ool00`00ooooo`05ool00`00ooooo`2jool00`00ooooo`03ool00`00ooooo`06ool000[o
o`03003ooooo00Goo`03003ooooo0;[oo`03003ooooo00?oo`03003ooooo00Koo`002_oo00<00?oo
ool01Ooo00<00?ooool0^ooo00<00?ooool00_oo00<00?ooool01_oo000:ool00`00ooooo`05ool0
0`00ooooo`2kool00`00ooooo`03ool00`00ooooo`05ool000[oo`03003ooooo00Goo`03003ooooo
0;_oo`03003ooooo00?oo`03003ooooo00Goo`002_oo00<00?ooool01Ooo00<00?ooool0^ooo00<0
0?ooool00ooo00<00?ooool01Ooo000:ool00`00ooooo`05ool00`00ooooo`2kool00`00ooooo`03
ool00`00ooooo`05ool000[oo`03003ooooo00Goo`03003ooooo0;_oo`03003ooooo00?oo`03003o
oooo00Goo`002Ooo00<00?ooool01_oo00<00?ooool0^ooo00<00?ooool00ooo00<00?ooool01Ooo
0009ool00`00ooooo`06ool00`00ooooo`2kool00`00ooooo`03ool00`00ooooo`05ool000Woo`03
003ooooo00Koo`03003ooooo0;_oo`03003ooooo00?oo`03003ooooo00Goo`002Ooo00<00?ooool0
1_oo00<00?ooool0^ooo00<00?ooool00ooo00<00?ooool01Ooo0009ool00`00ooooo`06ool00`00
ooooo`2kool00`00ooooo`03ool00`00ooooo`05ool000Woo`03003ooooo00Goo`03003ooooo0;co
o`03003ooooo00?oo`03003ooooo00Goo`002Ooo00<00?ooool01Ooo00<00?ooool0_Ooo00<00?oo
ool00ooo00<00?ooool01?oo0009ool00`00ooooo`05ool00`00ooooo`2mool00`00ooooo`03ool0
0`00ooooo`04ool000Woo`03003ooooo00Goo`03003ooooo0;goo`03003ooooo00?oo`03003ooooo
00Coo`002Ooo00<00?ooool01Ooo00<00?ooool0_Ooo00<00?ooool00ooo00<00?ooool01?oo0009
ool00`00ooooo`05ool00`00ooooo`2mool00`00ooooo`03ool00`00ooooo`04ool000Woo`03003o
oooo00Goo`03003ooooo0;goo`03003ooooo00?oo`03003ooooo00Coo`002Ooo00<00?ooool01Ooo
00<00?ooool0_Ooo00<00?ooool00ooo00<00?ooool01?oo0009ool00`00ooooo`05ool00`00oooo
o`2mool00`00ooooo`03ool00`00ooooo`04ool000Soo`03003ooooo00Koo`03003ooooo0;goo`03
003ooooo00?oo`03003ooooo00Coo`002?oo00<00?ooool01_oo00<00?ooool0_Ooo00<00?ooool0
0ooo00<00?ooool01?oo0008ool00`00ooooo`06ool00`00ooooo`2mool00`00ooooo`03ool00`00
ooooo`04ool000Soo`03003ooooo00Koo`03003ooooo0;goo`03003ooooo00Coo`03003ooooo00?o
o`002?oo00<00?ooool01_oo00<00?ooool0__oo00<00?ooool00ooo00<00?ooool00ooo0008ool0
0`00ooooo`06ool00`00ooooo`2nool00`00ooooo`03ool00`00ooooo`03ool000Soo`03003ooooo
00Goo`03003ooooo0;ooo`03003ooooo00?oo`03003ooooo00?oo`002?oo00<00?ooool01Ooo00<0
0?ooool0_ooo00<00?ooool00ooo00<00?ooool00ooo0008ool00`00ooooo`05ool00`00ooooo`2o
ool00`00ooooo`03ool00`00ooooo`03ool000Soo`03003ooooo00Goo`03003ooooo0;ooo`03003o
oooo00?oo`03003ooooo00?oo`002?oo00<00?ooool01Ooo00<00?ooool0_ooo00<00?ooool00ooo
00<00?ooool00ooo0008ool00`00ooooo`05ool00`00ooooo`2oool00`00ooooo`03ool00`00oooo
o`03ool000Soo`03003ooooo00Goo`03003ooooo0;ooo`03003ooooo00?oo`03003ooooo00?oo`00
1ooo00<00?ooool01_oo00<00?ooool0_ooo00<00?ooool00ooo00<00?ooool00ooo0007ool00`00
ooooo`06ool00`00ooooo`2oool00`00ooooo`03ool00`00ooooo`03ool000Ooo`03003ooooo00Ko
o`03003ooooo0<3oo`03003ooooo00?oo`03003ooooo00;oo`001ooo00<00?ooool01_oo00<00?oo
ool0`?oo00<00?ooool00ooo00<00?ooool00_oo0007ool00`00ooooo`06ool00`00ooooo`30ool0
0`00ooooo`03ool00`00ooooo`02ool000Ooo`03003ooooo00Koo`03003ooooo0<3oo`03003ooooo
00?oo`03003ooooo00;oo`001ooo00<00?ooool01_oo00<00?ooool0`?oo00<00?ooool00ooo00<0
0?ooool00_oo0007ool00`00ooooo`06ool00`00ooooo`30ool00`00ooooo`03ool00`00ooooo`02
ool000Ooo`03003ooooo00Goo`03003ooooo0<7oo`03003ooooo00?oo`03003ooooo00;oo`001ooo
00<00?ooool01Ooo00<00?ooool0`Ooo00<00?ooool00ooo00<00?ooool00_oo0007ool00`00oooo
o`05ool00`00ooooo`31ool00`00ooooo`03ool00`00ooooo`02ool000Ooo`03003ooooo00Goo`03
003ooooo0<7oo`03003ooooo00?oo`03003ooooo00;oo`001ooo00<00?ooool01Ooo00<00?ooool0
`Ooo00<00?ooool00ooo00<00?ooool00_oo0007ool00`00ooooo`05ool00`00ooooo`31ool00`00
ooooo`04ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo0<;oo`03003ooooo00?o
o`03003ooooo007oo`001_oo00<00?ooool01_oo00<00?ooool0`_oo00<00?ooool00ooo00<00?oo
ool00Ooo0006ool00`00ooooo`06ool00`00ooooo`32ool00`00ooooo`03ool00`00ooooo`01ool0
00Koo`03003ooooo00Koo`03003ooooo0;ooo`04003ooooo0005ool00`00ooooo`01ool000Koo`03
003ooooo00Koo`03003ooooo0;ooo`04003ooooo0005ool00`00ooooo`01ool000Koo`03003ooooo
00Koo`03003ooooo0;ooo`04003ooooo0005ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03
003ooooo0;ooo`04003ooooo0005ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo
0;ooo`04003ooooo0005ool00`00ooooo`01ool000Koo`03003ooooo00Koo`03003ooooo0;ooo`04
003ooooo0005ool00`00ooooo`01ool000Koo`03003ooooo00Goo`03003ooooo0<3oo`04003ooooo
0005ool00`00ooooo`01ool000Koo`03003ooooo00Goo`03003ooooo0<7oo`03003oo`0000Koo`40
007oo`7oo`001_oo00<00?ooool01Ooo00<00?ooool0`Ooo00<00?oo00001_oo0@000Ooo0Ooo0006
ool00`00ooooo`05ool00`00ooooo`31ool01000ooooo`001Ooo0@000Ooo0Ooo0005ool00`00oooo
o`06ool00`00ooooo`31ool01000ooooo`001Ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00
ooooo`31ool01000ooooo`001Ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`31ool0
1000ooooo`001Ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`31ool01000ooooo`00
1Ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00ooooo`31ool01000ooooo`001Ooo0@000Ooo
0Ooo0005ool00`00ooooo`06ool00`00ooooo`31ool01000ooooo`001Ooo0@000Ooo0Ooo0005ool0
0`00ooooo`06ool00`00ooooo`31ool01000ooooo`001Ooo0@000Ooo0Ooo0005ool00`00ooooo`06
ool00`00ooooo`31ool01000ooooo`001Ooo0@000Ooo0Ooo0005ool00`00ooooo`06ool00`00oooo
o`31ool01000ooooo`001_oo0@000Ooo0005ool00`00ooooo`06ool00`00ooooo`32ool00`00ool0
0006ool10001ool000Goo`03003ooooo00Koo`03003ooooo0<;oo`03003oo`0000Koo`40007oo`00
1Ooo00<00?ooool01Ooo00<00?ooool0`ooo00@00?ooool000Goo`40007oo`001Ooo00<00?ooool0
1Ooo00<00?ooool0`ooo00@00?ooool000Goo`40007oo`001?oo00<00?ooool01_oo00<00?ooool0
`ooo00@00?ooool000Goo`40007oo`001?oo00<00?ooool01_oo00<00?ooool0`ooo00@00?ooool0
00Goo`40007oo`001?oo00<00?ooool01_oo00<00?ooool0`_oo0P000_oo00<00?ooool00ooo0@00
0Ooo0004ool00`00ooooo`06ool00`00ooooo`2nool40003ool20005ool10001ool000Coo`03003o
oooo00Koo`03003ooooo0;[oo`@000?oo`@000;oo`03003ooooo00;oo`40007oo`001?oo00<00?oo
ool01_oo00<00?ooool0]ooo0`000ooo10001ooo00D00?ooooooo`00007oo`001?oo00<00?ooool0
1_oo00<00?ooool0/ooo10000_oo10003?oo00@00?ooooooo`4000001?oo00<00?ooool01_oo00<0
0?ooool0[ooo10000ooo0`004?oo00@00?ooooooo`4000001?oo00<00?ooool01_oo00<00?ooool0
[Ooo0P000ooo10005?oo00<00?ooool00@000004ool00`00ooooo`06ool00`00ooooo`2^ool4000I
ool10001ool1000000Coo`03003ooooo00Koo`03003ooooo0:[oo`@001koo`8000001?oo00<00?oo
ool01_oo00<00?ooool0Yooo0`008_oo0P000004ool00`00ooooo`06ool00`00ooooo`2Sool4000Q
ool40002ool000Coo`03003ooooo00Koo`03003ooooo09ooo`@0027oo`@000Koo`000ooo00<00?oo
ool01_oo00<00?ooool0W?oo10008Ooo10002_oo0003ool00`00ooooo`06ool00`00ooooo`2Iool3
000Qool4000>ool000?oo`03003ooooo00Koo`03003ooooo09Goo`@0023oo`@001;oo`000ooo00<0
0?ooool01_oo00<00?ooool0TOoo10008?oo10005_oo0003ool00`00ooooo`06ool00`00ooooo`2=
ool4000Qool3000Jool000?oo`03003ooooo00Koo`03003ooooo08[oo`<0027oo`@001goo`000ooo
00<00?ooool01_oo00<00?ooool0Q_oo10008?oo10008Ooo0003ool00`00ooooo`06ool00`00oooo
o`22ool4000Pool4000Uool000?oo`03003ooooo00Koo`03003ooooo07koo`@0023oo`@002Woo`00
0ooo00<00?ooool01_oo00<00?ooool0Nooo0`008?oo1000;Ooo0003ool00`00ooooo`06ool00`00
ooooo`1gool4000Oool4000aool000?oo`03003ooooo00Koo`03003ooooo07?oo`@0023oo`<003Go
o`000ooo00<00?ooool01_oo00<00?ooool0Kooo10008?oo1000>?oo0002ool00`00ooooo`07ool0
0`00ooooo`1/ool3000Pool4000lool000;oo`03003ooooo00Ooo`03003ooooo06Soo`@001ooo`@0
043oo`000_oo00<00?ooool01_oo00<00?ooool0IOoo10007ooo1000A?oo0002ool00`00ooooo`06
ool00`00ooooo`1Qool4000Oool40018ool000;oo`03003ooooo00Koo`03003ooooo05goo`@001oo
o`@004coo`000_oo00<00?ooool01_oo00<00?ooool0F_oo0`008?oo0`00D?oo0002ool00`00oooo
o`06ool00`00ooooo`1Fool4000Oool4001Cool000;oo`03003ooooo00Koo`03003ooooo05;oo`@0
01ooo`@005Ooo`000_oo00<00?ooool01_oo00<00?ooool0C_oo10007ooo1000Fooo0002ool00`00
ooooo`06ool00`00ooooo`1;ool3000Oool4001Oool000;oo`03003ooooo00Koo`03003ooooo04Oo
o`@001koo`@006?oo`000_oo00<00?ooool01_oo00<00?ooool0@ooo10007_oo1000Iooo0002ool0
0`00ooooo`05ool20011ool4000Oool3001[ool00003ool00?oo00Ooo`8003koo`<001ooo`@006ko
o`0000?oo`00ool01ooo0P00>_oo10007_oo1000L_oo00000ooo003oo`07ool2000fool4000Nool4
001fool00003ool00?oo00Ooo`8003;oo`@001koo`@007[oo`0000?oo`00ool01ooo00<00?ooool0
;_oo0`007_oo1000O_oo00000ooo003oo`07ool00`00ooooo`0Zool4000Nool30022ool00003ool0
0?oo00Ooo`03003ooooo02Koo`@001koo`@008Goo`0000?oo`00ool01ooo00<00?ooool08_oo1000
7_oo1000ROoo00000ooo003oo`07ool00`00ooooo`0Oool3000Nool4002=ool00003ool00?oo00Oo
o`03003ooooo01_oo`@001goo`@0097oo`0000?oo`00ool01ooo00<00?ooool05ooo10007Ooo1000
UOoo00000ooo003oo`06ool2000@ool20003ool4000Mool4002Iool00003ool00?oo00Koo`8000co
o`@000;oo`<001koo`<009goo`0000?oo`00ool01_oo0P002?oo10000_oo10007Ooo1000X?oo0000
0`00ooooo`06ool20004ool40002ool4000Mool4002Tool00003003ooooo00Koo`H000;oo`@001go
o`@00:Soo`0000<00?ooool01_oo0P000ooo0`007Ooo1000[?oo00000`00ooooo`07ool4000Lool4
002`ool00003003ooooo00?oo`D001_oo`@00;Coo`0000<00?oo00000`000ooo00<00?ooool05ooo
0`00^?oo00020007ool00`00ooooo`0Cool4002kool00003ool0000000Koo`03003ooooo00ooo`@0
0;ooo`000ooo00<00?ooool00ooo00<00?ooool02ooo1000`ooo0004ool20003ool00`00ooooo`07
ool40037ool000Koo`04003ooooo0005ool4003;ool000Ooo`<00003ool0000000800<ooo`002Ooo
0P00dooo0000\
\>"],
  ImageRangeCache->{{{0, 221.188}, {286.938, 0}} -> {0.143661, 0.0328606, \
0.00337199, 0.00337199}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["showit", "Subsubsection"],

Cell[BoxData[
    \(showit[g1_, g2_, r_] := 
      Show[g1, g2\[IndentingNewLine], 
        ViewPoint \[Rule] {0, \(-1\), 0}\[IndentingNewLine], 
        LightSources \[Rule] {\[IndentingNewLine]{{0, \(-4\), 0}, 
              RGBColor[ .7,  .1,  .1]}\[IndentingNewLine], {{4, 0, 0}, 
              RGBColor[ .1,  .7,  .1]}\[IndentingNewLine], {{0, 0, 4}, 
              RGBColor[ .1,  .1,  .7]}\[IndentingNewLine], {{1.3, \(-2.4\), 
                2}, RGBColor[ .5,  .5,  .5]}\[IndentingNewLine], {{0, \(-2\), 
                0}, GrayLevel[ .5]}}\[IndentingNewLine], 
        AmbientLight \[Rule] 
          RGBColor[ .25,  .25,  .25]\[IndentingNewLine]\[IndentingNewLine], 
        Axes \[Rule] True, 
        AxesLabel \[Rule] {"\<x\>", "\<y\>", "\<z\>"}\[IndentingNewLine]\
\[IndentingNewLine], PlotRange \[Rule] r\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \(showit2D[g1_, g2_, r_] := 
      Show[g1, g2\[IndentingNewLine], Axes \[Rule] False\[IndentingNewLine], 
        PlotRange \[Rule] Delete[r, 2]\[IndentingNewLine]]\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
genboxes3D  named go2  gr2
\talso SET box size and style (placement is automatic)\
\>", "Subsubsection",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
(* shfun[i_]:=shells[AtomicNumber[i]]; *)
table of abbrev.
table of sci. num.\
\>", "Text"],

Cell[BoxData[
    \(\(genboxes3D[len_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, ni}, \[IndentingNewLine]n = 
            Length[len]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            low\ x\ is\ thinner, \ 
            high\ x\ is\ taller\ *) \[IndentingNewLine]sc = {3.5, 
                1, \((17.0/
                    4.0)\)}\ 100; \[IndentingNewLine]\(ul = {\(- .04\),  .01, \
 .04};\)\n\(ll = {\(- .04\),  .01, \(- .04\)};\)\n\(lr = { .04,  .01, \(- .04\
\)};\)\n\(ur = { .04,  .01,  .04}\); \
\[IndentingNewLine]\[IndentingNewLine]Do[\[IndentingNewLine]i = 
              len[\([ni]\)]; \[IndentingNewLine]If[
              odat[elem, i] =!= "\<\>" || 
                i === helpcell, \[IndentingNewLine]pt = 
                opos[1, i]; \[IndentingNewLine]v = 
                boxpts[opos[1, i], sc, ul, ll, lr, ur, 
                  False]; \[IndentingNewLine]gr2[\([1, i]\)] = 
                boxgr3D[v];\[IndentingNewLine], 
              gr2[\([1, i]\)] = Graphics3D[{}]\[IndentingNewLine]], {ni, 
              n}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go2 = 
            Table[i = len[\([ni]\)]; 
              gr2[\([o, i]\)], {o, 1, 1}, {ni, 1, 
                n}];\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
(* ooops gr2 == go2 now but don't assume that further below \
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["gentext3D  named go  gr", "Subsubsection"],

Cell["\<\
(* shfun[i_]:=shells[AtomicNumber[i]]; *)
table of abbrev.
table of sci. num.\
\>", "Text"],

Cell[BoxData[
    \(\(gentext3D[len_List, items_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, m, n, ni, 
            mo}, \[IndentingNewLine]n = Length[len]; \[IndentingNewLine]m = 
            Length[items]; \[IndentingNewLine]\[IndentingNewLine]Do[
            Do[\[IndentingNewLine]i = len[\([ni]\)]; \[IndentingNewLine]o = 
                items[\([mo]\)]; \[IndentingNewLine]gr[\([o, 
                    i]\)] = \[IndentingNewLine]If[
                  leftalign === 0, \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], opos[o, i], 
                    oattr[o, i]], \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], opos[o, i], ooffset[o, i], 
                    odir[o, i], oattr[o, i]]\[IndentingNewLine]], {ni, 
                n}\[IndentingNewLine]], {mo, 
              m}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go = 
            Graphics3D[\[IndentingNewLine]Table[i = len[\([ni]\)]; 
                o = items[\([mo]\)]; 
                gr[\([o, i]\)], {mo, 1, m}, {ni, 1, 
                  n}]\[IndentingNewLine]];\[IndentingNewLine]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
genboxes2D  named  go22D  gr22D
\talso SET box size and style (placement is automatic)\
\>", "Subsubsection",
  Background->RGBColor[0.8, 1, 1]],

Cell[BoxData[
    \(\(genboxes2D[len_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, v, n, 
            ni}, \[IndentingNewLine]n = 
            Length[len]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            low\ x\ is\ thinner, \ 
            high\ x\ is\ taller\ *) \[IndentingNewLine]sc = {3.5, 
                1, \((17.0/
                    4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
          ur = { .04,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]Do[\
\[IndentingNewLine]i = len[\([ni]\)]; \[IndentingNewLine]If[
              odat[elem, i] =!= "\<\>" || 
                i === helpcell, \[IndentingNewLine]v = 
                boxpts[opos[1, i], sc, ul, ll, lr, ur, 
                  True]; \[IndentingNewLine]gr22D[\([1, i]\)] = 
                boxgr[v];\[IndentingNewLine], 
              gr22D[\([1, i]\)] = Graphics[{}]\[IndentingNewLine]], {ni, 
              n}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go22D = 
            Table[i = len[\([ni]\)]; 
              gr22D[\([o, i]\)], {o, 1, 1}, {ni, 1, 
                n}];\[IndentingNewLine]\[IndentingNewLine]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["gentext2D  named  go2D  gr2D", "Subsubsection"],

Cell[BoxData[
    \(\(gentext2D[len_List, items_List] := 
        Module[{o, i, pt, ul, ll, lr, ur, sc, v, m, n, ni, 
            mo}, \[IndentingNewLine]n = Length[len]; \[IndentingNewLine]m = 
            Length[items]; \[IndentingNewLine]Do[
            Do[\[IndentingNewLine]i = len[\([ni]\)]; \[IndentingNewLine]o = 
                items[\([mo]\)]; \[IndentingNewLine]gr2D[\([o, 
                    i]\)] = \[IndentingNewLine]If[
                  leftalign === 0, \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], Delete[opos[o, i], 2], 
                    oattr[o, i]], \[IndentingNewLine]Text[
                    DisplayForm[odat[o, i]], Delete[opos[o, i], 2], 
                    ooffset[o, i], odir[o, i], 
                    oattr[o, i]]\[IndentingNewLine]], {ni, 
                n}\[IndentingNewLine]], {mo, 
              m}\[IndentingNewLine]]; \
\[IndentingNewLine]\[IndentingNewLine]go2D = 
            Graphics[\[IndentingNewLine]Table[i = len[\([ni]\)]; 
                o = items[\([mo]\)]; 
                gr2D[\([o, i]\)], {mo, 1, m}, {ni, 1, 
                  n}]\[IndentingNewLine]];\[IndentingNewLine]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["snaptxt[]    gets contents of cell above it (incl Cell)", \
"Subsubsection"],

Cell[BoxData[
    \(\(snaptxt[] := 
        Module[{nb, nbsel, newnb, cell}, \[IndentingNewLine]nb =. ; 
          newnb =. ; 
          nbsel =. ; \[IndentingNewLine]nb = 
            EvaluationNotebook[]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, EvaluationCell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, Cell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine] (*\ 
            fixed?\[IndentingNewLine]SelectionMove[nb, All, Cell, 
              AutoScroll \[Rule] False]; \[IndentingNewLine]nbsel = 
              NotebookSelection[nb]; \[IndentingNewLine]NotebookPrint[
              nbsel, "\<warntxt.3.eps\>"];\[IndentingNewLine]\
*) \[IndentingNewLine]SelectionMove[nb, All, TextParagraph, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]cell = 
            NotebookRead[nb]; \[IndentingNewLine] (*\ 
            WORKS\ newnb =. ; \[IndentingNewLine]newnb = 
              NotebookCreate[]; \[IndentingNewLine]NotebookWrite[newnb, 
              warntxt]; \[IndentingNewLine]NotebookPrint[
              newnb, "\<warntxt.2.eps\>"];\ \
*) \[IndentingNewLine]SelectionMove[nb, After, EvaluationCell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]nb =. ; newnb =. ; 
          nbsel =. ; \[IndentingNewLine]cell\[IndentingNewLine]];\)\)], \
"Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
printcell[file,nbopts]  print PS of cell abve,allow print options\
\
\>", "Subsubsection"],

Cell["\<\
this prints cell directly above it notebook.  intent was to print \
cell only (but Display can do cell per say)\
\>", "Text"],

Cell[BoxData[
    \(\(printcell[file_String, nbopts___] := 
        Module[{nb, nbsel, newnb, cell, v, xxx}, \[IndentingNewLine]nb =. ; 
          newnb =. ; 
          nbsel =. ; \[IndentingNewLine]nb = 
            EvaluationNotebook[]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, EvaluationCell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]SelectionMove[nb, 
            Previous, Cell, 
            AutoScroll \[Rule] False]; \[IndentingNewLine] (*\ 
            fixed?\[IndentingNewLine]SelectionMove[nb, All, Cell, 
              AutoScroll \[Rule] False]; \[IndentingNewLine]nbsel = 
              NotebookSelection[nb]; \[IndentingNewLine]NotebookPrint[
              nbsel, "\<warntxt.3.eps\>"];\[IndentingNewLine]\
*) \[IndentingNewLine]SelectionMove[nb, All, TextParagraph, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]cell = 
            NotebookRead[
              nb]; \[IndentingNewLine]newnb =. ; \[IndentingNewLine]newnb = 
            NotebookCreate[
              Visible \[Rule] False]; \[IndentingNewLine]SelectionMove[newnb, 
            All, Notebook, 
            AutoScroll \[Rule] 
              False]; \[IndentingNewLine] (*\ \[IndentingNewLine]bug\ if\ \
opts\ not\ defined\ short\ circuits\ most\ tests\[IndentingNewLine]\
*) \[IndentingNewLine]If[
            Length[{nbopts}] =!= 
              0, \[IndentingNewLine] (*\(SetOptions[EvaluationNotebook[], 
                  nbopts];\)*) \[IndentingNewLine]\(SetOptions[newnb, 
                nbopts];\)\[IndentingNewLine]]; \
\[IndentingNewLine]NotebookWrite[newnb, 
            cell]; \[IndentingNewLine]NotebookPrint[newnb, 
            file]; \[IndentingNewLine]SelectionMove[newnb, All, Notebook, 
            AutoScroll \[Rule] False]; \[IndentingNewLine]nbsel = 
            NotebookSelection[newnb]; \[IndentingNewLine]v = 
            Options[newnb]; \[IndentingNewLine]NotebookClose[
            newnb]; \[IndentingNewLine]nb =. ; newnb =. ; 
          nbsel =. ; \[IndentingNewLine]v\[IndentingNewLine]];\)\)], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Reset gr, cmat, layout", "Subsection",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["init gr tables and cmat (overall chart position vecs)", "Subsubsection"],

Cell["\<\
these are just resets for further below they hold graphics \
\"primatives\" text\
\>", "Text"],

Cell[BoxData[
    \(\(gr = Table[i, {o, 1, textobjects}, {i, 1, objlen}];\)\)], "Input"],

Cell["\<\
not a good idea - geninit will need to be redefined if this is done\
\
\>", "Text"],

Cell[BoxData[
    \( (*\ \(Remove[go, gr, go2D, gr2D];\)\ *) \)], "Input"],

Cell[BoxData[
    \(go =. ; gr =. ; go2D =. ; gr2D =. ;\)], "Input"],

Cell[BoxData[
    \(\(gr = Table[i, {o, 1, textobjects}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(gr2D = Table[i, {o, 1, textobjects}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \( (*\ \(Remove[go2, gr2, go22D, gr22D];\)\ *) \)], "Input"],

Cell[BoxData[
    \(go2 =. ; gr2 =. ; go22D =. ; gr22D =. ;\)], "Input"],

Cell[BoxData[
    \(\(gr2 = Table[i, {o, 1, objects}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(gr22D = Table[i, {o, 1, objects}, {i, 1, objlen}];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["old layout / work area", "Subsubsection"],

Cell["\<\
cram forms ~ 1000 x 100 plot.
below: 1-1 scalar multiply not dot product.  convenient row op!\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{"layout", "=", 
        RowBox[{
          RowBox[{"(", GridBox[{
                {"0", "0", "0"},
                {".01", "0", ".01"},
                {\(- .01\), "0", \(- .01\)},
                {".01", "0", \(- .01\)},
                {".009", "0", ".02"}
                }], ")"}], 
          RowBox[{"(", GridBox[{
                {"1", "1", "1"},
                {"3", "1", "0"},
                {"3", "1", "3"},
                {"3", "1", "3"},
                {"3", "1", "1"}
                }], ")"}], "200"}]}], ";"}]], "Input"],

Cell["\<\
\"corrections\"
\tallows various kinds of corrections to item or whole table
\tthese can be combined into a single column by: layout // MatrixForm
( x  z  y ) (scale of offsets)
\twhere each triplet is pos for object n for odat[n]
\twhere -x is left and -y is down\
\>", "Text"],

Cell[BoxData[
    \(add =. ; mul =. ; add2 =. ; add4 =. ; mul4 =. ;\)], "Input"],

Cell["older table, unused (actually, layout2 is same)", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout", "=", 
          RowBox[{
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {".005", "0", \(- .008\)},
                  {".001", "0", \(- .065\)},
                  {".001", "0", \(- .077\)},
                  {".005", "0", ".01"},
                  {"0", "0", ".06"},
                  {\(- .014\), "0", \(- .03\)},
                  {\(- .002\), "0", \(- .03\)},
                  {\(- .014\), "0", ".03"},
                  {\(- .002\), "0", ".03"},
                  {".002", "0", \(- .025\)},
                  {".015", "0", \(- .03\)},
                  {"0", "0", \(- .04\)},
                  {\(- .014\), "0", ".02"},
                  {\(- .002\), "0", ".02"},
                  {"0", "0", ".04"},
                  {".010", "0", ".04"},
                  {"0", "0", ".03"},
                  {".010", "0", ".03"},
                  {"0", "0", ".02"},
                  {".010", "0", ".02"},
                  {\(- .014\), "0", ".04"},
                  {\(- .002\), "0", ".04"},
                  {\(- .014\), "0", ".01"},
                  {\(- .002\), "0", ".01"},
                  {\(- .014\), "0", "0"},
                  {\(- .002\), "0", "0"},
                  {\(- .014\), "0", \(- .01\)},
                  {\(- .002\), "0", \(- .01\)},
                  {\(- .014\), "0", \(- .02\)},
                  {\(- .002\), "0", \(- .02\)},
                  {\(- .014\), "0", \(- .065\)},
                  {\(- .014\), "0", \(- .08\)},
                  {\(- .014\), "0", \(- .052\)},
                  {"0", "0", \(- .052\)}
                  }], ")"}], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"},
                  {"3", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"add2", "=", 
          RowBox[{"(", GridBox[{
                {"0", "0", "0"},
                {"0", "0", ".005"},
                {"0", "0", ".0025"},
                {"0", "0", "0"},
                {"0", "0", ".001"},
                {"0", "0", "0"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".005"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"},
                {"0", "0", ".0025"},
                {"0", "0", "0"},
                {"0", "0", ".0055"},
                {"0", "0", ".0055"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
this older table is ok if Text offset isn't left (though even with \
padding text won't alight well but looks ok if fonts aren't changed).  see \
thing about (\\\\220) in init below \"/\" (see discussion in init \
below)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout2", "=", 
          RowBox[{
            TagBox[
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0", "0", "0"},
                    {"6.4", "0", "1.2"},
                    {"4", "0", \(-10.5\)},
                    {"4", "0", \(-13.4\)},
                    {"6.4", "0", "4.2"},
                    {"3", "0", "14"},
                    {\(-10\), "0", \(-2.9\)},
                    {\(-3\), "0", \(-2.9\)},
                    {\(-10\), "0", "9.1"},
                    {\(-3\), "0", "9.1"},
                    {"4.6", "0", \(-2\)},
                    {\(-10\), "0", \(-4.9\)},
                    {"2", "0", \(-4.9\)},
                    {\(-10\), "0", "7.1"},
                    {\(-3\), "0", "7.1"},
                    {"2", "0", "11.1"},
                    {"9.4", "0", "11.1"},
                    {"2", "0", "9.1"},
                    {"9.4", "0", "9.1"},
                    {"2", "0", "7.1"},
                    {"9.4", "0", "7.1"},
                    {\(-10\), "0", "11.1"},
                    {\(-3\), "0", "11.1"},
                    {\(-10\), "0", "5.1"},
                    {\(-3\), "0", "5.1"},
                    {\(-10\), "0", "3.1"},
                    {\(-3\), "0", "3.1"},
                    {\(-10\), "0", "1.1"},
                    {\(-3\), "0", "1.1"},
                    {\(-10\), "0", \(-0.9\)},
                    {\(-3\), "0", \(-0.9\)},
                    {\(-10\), "0", \(-10.5\)},
                    {\(-10\), "0", \(-14\)},
                    {\(-10\), "0", \(-7.3\)},
                    {"2", "0", \(-7.3\)},
                    {"8", "0", "15"},
                    {"0", "0", "23"},
                    {"0", "0", "27"}
                    }], "\[NoBreak]", ")"}],
              (MatrixForm[ #]&)], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout3", "=", 
          RowBox[{
            TagBox[
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0", "0", "0"},
                    {"0", "0", "1.2"},
                    {\(-8\), "0", \(-10.5\)},
                    {\(-8\), "0", \(-14\)},
                    {"0", "0", "4.2"},
                    {"0", "0", "14"},
                    {\(-16\), "0", \(-2.9\)},
                    {\(-8\), "0", \(-2.9\)},
                    {\(-16\), "0", "9.1"},
                    {\(-8\), "0", "9.1"},
                    {"0", "0", \(-2\)},
                    {\(-16\), "0", \(-4.9\)},
                    {\(-8\), "0", \(-4.9\)},
                    {\(-16\), "0", "7.1"},
                    {\(-8\), "0", "7.1"},
                    {\(-4\), "0", "11.1"},
                    {"4", "0", "11.1"},
                    {\(-4\), "0", "9.1"},
                    {"4", "0", "9.1"},
                    {\(-4\), "0", "7.1"},
                    {"4", "0", "7.1"},
                    {\(-16\), "0", "11.1"},
                    {\(-8\), "0", "11.1"},
                    {\(-16\), "0", "5.1"},
                    {\(-8\), "0", "5.1"},
                    {\(-16\), "0", "3.1"},
                    {\(-8\), "0", "3.1"},
                    {\(-16\), "0", "1.1"},
                    {\(-8\), "0", "1.1"},
                    {\(-16\), "0", \(-0.9\)},
                    {\(-8\), "0", \(-0.9\)},
                    {\(-16\), "0", \(-10.5\)},
                    {\(-16\), "0", \(-14\)},
                    {\(-16\), "0", \(-7.3\)},
                    {\(-8\), "0", \(-7.3\)},
                    {"8", "0", "15"},
                    {"0", "0", "23"},
                    {"0", "0", "27"}
                    }], "\[NoBreak]", ")"}],
              (MatrixForm[ #]&)], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    \(\(If[leftalign === 1, layout2 = layout3];\)\)], "Input"],

Cell["\<\
unused: list of what is text (datem) or what is label
\t0 is label  1 is datem  2 datem / other kind
\t3 special datem  4 always centered datem\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"istxt", "=", 
          RowBox[{"(", GridBox[{
                {"4"},
                {"3"},
                {"2"},
                {"2"},
                {"3"},
                {"4"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"3"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"1"},
                {"4"},
                {"4"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
for help cell, what gets bumped to right
\tthis is usu. labels using mathfonts (ie, colored labels)
\t\t(these go left due to multiple of label space)
\thowever uses table because a few are work-arounds anyhow\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxthelp", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(co\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
for BW only, labels that also loose mathfonts and will need to be \
bumped right (see create go2DBW).  centered text or special are not \
bumped\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtbw", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
list of datem to disable use of MathMono-Bold for
\t(currently uses OutputFormt)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtfont", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell[BoxData[
    \(\(add = 
        Table[\[IndentingNewLine]If[
            layout[\([i, 1]\)] =!= 0, \[IndentingNewLine]If[
              layout[\([i, 1]\)] \[LessEqual] 0, {\(- .02\) +  .012, 0, 
                0 +  .01}, { .005 +  .012, 0, 
                0 +  .01}]\[IndentingNewLine], {0 +  .01, 0, 
              0 +  .01}]\[IndentingNewLine], {i, 1, 
            Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add2[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(add[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(mul = Table[{1, 1, 1}, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(mul4 = Table[{1, 1, 1}, {i, 1, Length[layout2]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add4 = Table[{0, 0, 0}, {i, 1, Length[layout2]}];\)\)], "Input"],

Cell[BoxData[
    \(\(mul[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(mul4[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(add4[\([1]\)] = {0, 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(layout = \((layout\  + add + add2)\) 200\ mul;\)\)], "Input"],

Cell[BoxData[
    \(\(layout2 = \((layout2\  + add4)\) 1\ mul4;\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[BoxData[
    \( (*\ layout // TableForm\ *) \)], "Input"],

Cell[BoxData[
    \(\(Remove[add, mul, add2];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["layout of data  (relative to any center)", "Subsubsection",
  Background->RGBColor[0.8, 1, 1]],

Cell["\<\
(*
give position of cell data relative to cell center.   also add1/0 as yes/no \
for what help, b&w, font fixes will be applied to item.
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"layout", "=", 
          RowBox[{
            TagBox[
              RowBox[{"(", "\[NoBreak]", GridBox[{
                    {"0", "0", "0"},
                    {"0", "0", "1.2"},
                    {\(-8\), "0", \(-10.5\)},
                    {\(-8\), "0", \(-14\)},
                    {"0", "0", "4.2"},
                    {"0", "0", "14"},
                    {\(-16\), "0", \(-2.9\)},
                    {\(-8\), "0", \(-2.9\)},
                    {\(-16\), "0", "9.1"},
                    {\(-8\), "0", "9.1"},
                    {"0", "0", \(-2\)},
                    {\(-16\), "0", \(-4.9\)},
                    {\(-8\), "0", \(-4.9\)},
                    {\(-16\), "0", "7.1"},
                    {\(-8\), "0", "7.1"},
                    {\(-4\), "0", "11.1"},
                    {"4", "0", "11.1"},
                    {\(-4\), "0", "9.1"},
                    {"4", "0", "9.1"},
                    {\(-4\), "0", "7.1"},
                    {"4", "0", "7.1"},
                    {\(-16\), "0", "11.1"},
                    {\(-8\), "0", "11.1"},
                    {\(-16\), "0", "5.1"},
                    {\(-8\), "0", "5.1"},
                    {\(-16\), "0", "3.1"},
                    {\(-8\), "0", "3.1"},
                    {\(-16\), "0", "1.1"},
                    {\(-8\), "0", "1.1"},
                    {\(-16\), "0", \(-0.9\)},
                    {\(-8\), "0", \(-0.9\)},
                    {\(-16\), "0", \(-10.5\)},
                    {\(-16\), "0", \(-14\)},
                    {\(-16\), "0", \(-7.3\)},
                    {\(-8\), "0", \(-7.3\)},
                    {"8", "0", "15"},
                    {"0", "0", "23"},
                    {"0", "0", "27"}
                    }], "\[NoBreak]", ")"}],
              (MatrixForm[ #]&)], 
            RowBox[{"(", GridBox[{
                  {"0", "0", "0"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"},
                  {"1", "1", "1"}
                  }], ")"}]}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
(*
for help cell, what gets bumped to right
\tthis is usu. labels using mathfonts (ie, colored labels)
\t\t(these go left due to multiple of label space)
\thowever uses table because a few are work-arounds anyhow
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxthelp", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(co\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
(*
for BW only, labels that also loose mathfonts and will need to be bumped \
right (see create go2DBW).  centered text or special are not bumped
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtbw", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"1"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"],

Cell["\<\
(*
list of datem to disable use of MathMono-Bold for
\t(currently uses OutputFormt)
*)\
\>", "Text"],

Cell[BoxData[
    RowBox[{
      RowBox[{
        RowBox[{"fixtxtfont", "=", 
          RowBox[{"(", GridBox[{
                {"0"},
                {"0"},
                {"1"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"},
                {"1"},
                {"0"},
                {"0"},
                {"0"}
                }], ")"}]}], ";"}], 
      RowBox[{"(*", 
        RowBox[{"(", GridBox[{
              {"\[CenterDot]"},
              {"ab"},
              {"oo"},
              {"fo"},
              {"an"},
              {"shell"},
              {\(fip\ ab\)},
              {\(fip\ n\)},
              {\(tm\ ab\)},
              {\(tm\ n\)},
              {"aw"},
              {\(si\ ab\)},
              {\(si\ n\)},
              {\(tb\ ab\)},
              {\(tb\ n\)},
              {\(ssa\ ab\)},
              {\(ssa\ n\)},
              {\(eca\ ab\)},
              {\(eca\ n\)},
              {\(eoa\ ab\)},
              {\(eoa\ n\)},
              {\(d\ ab\)},
              {\(d\ n\)},
              {\(lf\ ab\)},
              {\(lf\ n\)},
              {\(lv\ ab\)},
              {\(lv\ n\)},
              {\(qc\ ab\)},
              {\(qc\ n\[IndentingNewLine]
                tc\ ab\[IndentingNewLine]
                tc\ n\)},
              {\(oo\ ab\)},
              {\(fo\ ab\)},
              {\(os\ ab\)},
              {\(os\ n\)},
              {\(mt\ n\)},
              {\(col\ n\)},
              {\(grp\ n\)}
              }], ")"}], "*)"}]}]], "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
diversion
\tspecial fix bump down helpcell's col alias adn col group\
\>", "Subsection"],

Cell["\<\
(*
these mod bumps items col alias and col group down a little for help cell \
only
\tit requires re-evaluating Center of Cell above and layout if changed
\t\twon't work first time if left in Data and Text section above
\tprobably not the best way but it's a one-off deal so...
*)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(If[oncehelppos === False, opos[37, helpcell] += {0, 0, 17}]\)], "Input"],

Cell[BoxData[
    \({144.88636363636363`, 0.`, 250.38961038961037`}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(If[oncehelppos === False, opos[38, helpcell] += {0, 0, 17}]\)], "Input"],

Cell[BoxData[
    \({144.88636363636363`, 0.`, 254.38961038961037`}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(oncehelppos = True;\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "Run   geninit\n",
  StyleBox["and do fix-ups to automate making the helpcell",
    FontSize->11]
}], "Subsection"],

Cell[CellGroupData[{

Cell["generate and discuss", "Subsubsection"],

Cell["(* make go2 *)", "Text"],

Cell[BoxData[
    \(\(If[do3D === 1, genboxes3D[Range[1, objlen]]];\)\)], "Input"],

Cell["(* make go *)", "Text"],

Cell[BoxData[
    \(\(If[do3D === 1, 
        gentext3D[Range[1, objlen], Range[1, textobjects]]];\)\)], "Input"],

Cell[BoxData[
    \(\(genboxes2D[Range[1, objlen]];\)\)], "Input"],

Cell[BoxData[
    \(\(gentext2D[Range[1, objlen], Range[1, textobjects]];\)\)], "Input"],

Cell["\<\
(*
now replace some things so that each data item need not do so
\tnote: for easier rules it's assumed
\t\tTextStyle->FontSize is present for each datem
*)\
\>", "Text"],

Cell["\<\
(*
go / go2D  text graphics, made larger for front-end.  go is for Graphics3D
go4 go42D copy of text graphics \"condensed sizes\".  go4 is for Graphics3D
go2 go22D boxes.  same boxes used either way.  go2 is for Graphics3D
gr.... are same objects but not wrapped in Graphics (hardly different)
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["double go go2 fonts", "Subsubsection"],

Cell["\<\
(*
scale font sizes so we don't need to edit them
\told news: had 2x fonts when go4 was used
*)\
\>", "Text"],

Cell[BoxData[
    \(x =. ; y =. ; z =. ; w =. ; q =. ;\)], "Input"],

Cell[BoxData[
    \(\(go[\([1]\)] = 
        go[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .5)\), y}, w];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go[\([1, 2, 1]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"Fr \"\>",
          DisplayForm], 
        ",", \({28.977272727272723`, 0.`, 36.26493506493507`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 2.`, 
            FontWeight \[Rule] "Bold", 
            FontColor \[Rule] RGBColor[0.85`, 0, 0]}\)}], "]"}]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(go2D[\([1]\)] = 
        go2D[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .5)\), y}, w];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2D[\([1, 2, 1]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"Fr \"\>",
          DisplayForm], ",", \({28.977272727272723`, 36.26493506493507`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 2.`, 
            FontWeight \[Rule] "Bold", 
            FontColor \[Rule] RGBColor[0.85`, 0, 0]}\)}], "]"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["change some to NOT Math2Mono-Bold (use FormatType Output)", \
"Subsubsection"],

Cell[TextData[{
  StyleBox["(*\nMathematica",
    FontSlant->"Italic"],
  " uses \\\\220 for \"/\" Math2Mono-Bold and GhostScript won't like it (and \
also renders all strings one char at a time).  Maybe some option can force \
fonts to be included for EPS but instead FormatType is set so Math2Mono-Bold \
is not attempted.  I'd guess ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " does that so rendering expressions in plots is hands-free.\n\nBelow if \
one /. \"(\\\\220) show\" with \"(/) show\" AFTER Show[] that takes care of \
the only font problem this chart currently uses without (changing all fonts \
or messing with including fonts in output).  So it would need to be rendered \
2x every time.\n*)"
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Show[
        Graphics[{Text["\<W / Km\>", {0, 
                0}, \[IndentingNewLine]TextStyle \[Rule] {FontWeight \[Rule] 
                    7, FontFamily \[Rule] "\<Courier\>", 
                  FontColor \[Rule] 
                    RGBColor[0.85`, 0, 0]\[IndentingNewLine]}, 
              FormatType \[Rule] OutputForm]\[IndentingNewLine]}], 
        ImageSize \[Rule] {100, 50}];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
%%ImageSize: 100 50 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.5 0.47619 0.309017 0.294302 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
0 g
[(W / Km)] .5 .30902 0 0 Mshowa
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{100, 50},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40001T0000<Q000`40n007h00OI?oo001Tool006Co
o`00I?oo001Tool006Coo`00I?oo001Tool006Coo`00I?oo001Tool006Coo`00I?oo001Tool006Co
o`00I?oo001Tool006Coo`00I?oo001Tool006Coo`00I?oo000[ool00`00ooooo`0fool0023oo`03
003oo`0000Woo`03003ooooo00Soo`<000;oo`800003ool00?oo0080027oo`008?oo00<00?oo0000
2Ooo00<00?ooool02Ooo00X00?ooool00?oo003oo`00ool002;oo`007ooo00D00?oo003oo`0000Wo
o`03003ooooo00Soo`03003oo`0000;oo`05003oo`00ool0000Rool001ooo`05003oo`00ool00009
ool00`00ooooo`08ool20003ool01@00ool00?oo00008_oo000Oool01@00oooooooo00002_oo00<0
0?ooool01ooo00<00?oo00000_oo0P0000?oo`00ool08_oo000Nool300001?oo000000002Ooo00<0
0?ooool01_oo0P0000?oo`000000:?oo000_ool00`00ooooo`0bool006Coo`00I?oo001Tool006Co
o`00I?oo001Tool006Coo`00I?oo001Tool006Coo`00I?oo001Tool006Coo`00I?oo001Tool006Co
o`00I?oo001Tool006Coo`00I?oo0000\
\>"],
  ImageRangeCache->{{{0, 99}, {49, 0}} -> {-1.31112, -1.05001, 0.0264873, \
0.0428573}}]
}, Closed]],

Cell["\<\
(*
\tOOPS: FormatType doesn't allow color but renders allot faster
\tOOPS: without FormatType, FontFamily slows rendering terribly slow
\tHowever: together they create a nice Black & White chart
\tnote:  replace rule assumes nothing above added font family
*)\
\>", "Text"],

Cell["\<\
(*
test.
\trender nums / help strings as simplified text
\tfaster and less \"font needy\" but no color ? ...
*)\
\>", "Text"],

Cell[BoxData[
    \(x =. ; w =. ; z =. ; w =. ; q =. ;\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2D[\([1, 31, 1]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"15        \"\>",
          DisplayForm], ",", \({20.977272727272727`, 34.164935064935065`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 1.`}\)}], "]"}]], "Output"]
}, Closed]],

Cell[BoxData[
    \(Do[\[IndentingNewLine]\(If[
          fixtxtfont[\([j, 1]\)] === 
            1, \[IndentingNewLine]\(go2D[\([1, j]\)] = 
              go2D[\([1, j]\)] /. \[IndentingNewLine]Text[z__, 
                    TextStyle -> {y___}, 
                    w___] \[Rule] \[IndentingNewLine]Text[z, 
                    TextStyle -> {y\  (*\(,\)\(FontFamily \[Rule] \
"\<Courier\>"\)*) }, w\ , 
                    FormatType -> 
                      OutputForm];\)\[IndentingNewLine]];\)\[IndentingNewLine]\
, {j, textobjects}\[IndentingNewLine]]\)], "Input"],

Cell["\<\
(*
NEW
\t3D's go seems to want to be like go2D
\t3D was left somewhat un-tested a while
\tas noted for 2DBW both above and below
\tchange boxing for b&w nums only: but looks fine
\tonly OS n SI n even have squares to see and look maybe better
*)\
\>", "Text"],

Cell[BoxData[
    \(Do[\[IndentingNewLine]\(If[
          fixtxtfont[\([j, 1]\)] === 
            1, \[IndentingNewLine]\(go[\([1, j]\)] = 
              go[\([1, j]\)] /. \[IndentingNewLine]Text[z__, 
                    TextStyle -> {y___}, 
                    w___] \[Rule] \[IndentingNewLine]Text[z, 
                    TextStyle -> {y\  (*\(,\)\(FontFamily \[Rule] \
"\<Courier\>"\)*) }, w\ , 
                    FormatType -> 
                      OutputForm];\)\[IndentingNewLine]];\)\[IndentingNewLine]\
, {j, textobjects}\[IndentingNewLine]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2D[\([1, 31, 1]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"15        \"\>",
          DisplayForm], ",", \({20.977272727272727`, 34.164935064935065`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 1.`}\), 
        ",", \(FormatType \[Rule] OutputForm\)}], "]"}]], "Output"]
}, Closed]],

Cell["\<\
(* instead use OutputForm for most numbers, since none are \
formatted anyhow *)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["create go2DBW", "Subsubsection"],

Cell["\<\
(* unfortunately left align at {x, y} is not \"pure\" ...
\t\"boxed\" fonts do not line up with regular ps text
\t
magic 3 is added to x on all boxed fonts that aren't boxed for 2DBW

this is \"wrong\" as it causes boxing problems - a better way that is as \
efficient but for friendly needs to be found that works color, does ascii w/o \
require PS hacking or OutputForm
*)\
\>", "Text"],

Cell["\<\
Do[go2DBW[[1,o,i,2]]=+={3,0}; ,{i,objlen}];
(*\tis so slow as to be considered broken / not be usable
\tdamn can't remember there is a way that does work ?? v[[1]] *)\
\>", "Text"],

Cell[BoxData[
    \(\(add =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(layout2 = layout;\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout + Table[{3, 0, 0}, {i, 1, textobjects}];\)\)], "Input"],

Cell["\<\
(* could save go2D, remake new with geninit , swap back :   instead \
update effected ... *)\
\>", "Text"],

Cell[BoxData[
    \(\(go2DBW = go2D;\)\)], "Input"],

Cell[BoxData[
    \(If[leftalign === 
        1, \[IndentingNewLine]Do[\[IndentingNewLine]If[
          fixtxtfont[\([o, 1]\)] \[Equal] 0 && 
            fixtxtbw[\([o, 1]\)] \[Equal] 
              1, \[IndentingNewLine]Do[\[IndentingNewLine]go2DBW[\([1, o, 
                  i]\)] = \[IndentingNewLine]Text[DisplayForm[odat[o, i]], 
                Delete[opos[o, i], 2], ooffset[o, i], odir[o, i], 
                oattr[o, i]]\[IndentingNewLine], {i, 
              objlen}\[IndentingNewLine]]], {o, 
          textobjects}\[IndentingNewLine]]]\)], "Input"],

Cell[BoxData[
    \(If[leftalign === 
        1, \[IndentingNewLine]Do[\[IndentingNewLine]If[
          fixtxtfont[\([o, 1]\)] \[Equal] 0 && 
            fixtxtbw[\([o, 1]\)] \[Equal] 
              1, \[IndentingNewLine]Do[\[IndentingNewLine]\(go2DBW[\([1, 
                    o]\)] = 
                go2DBW[\([1, o, All]\)] /. 
                  Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                      w___] \[Rule] 
                    Text[z, TextStyle -> {FontSize -> \((x\ \  .5)\), y}, 
                      w];\)\[IndentingNewLine]]], {o, 
          textobjects}\[IndentingNewLine]]]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2DBW[\([1, 7, 1]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"FIP\"\>",
          DisplayForm], ",", \({15.977272727272727`, 32.164935064935065`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 1.`, 
            FontWeight \[Rule] "Bold", 
            FontColor \[Rule] RGBColor[0, 0, 0.55`]}\)}], "]"}]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2DBW[\([1, 7, 1]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"FIP\"\>",
          DisplayForm], ",", \({15.977272727272727`, 32.164935064935065`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 1.`, 
            FontWeight \[Rule] "Bold", 
            FontColor \[Rule] RGBColor[0, 0, 0.55`]}\)}], "]"}]], "Output"]
}, Closed]],

Cell["\<\
(* with that problem and the one below (that dialating causes wrong \
spacing) maybe
a template should be used to make element cells.  though note it's using the \
same layout
for both color and BW that causes a work-around *)\
\>", "Text"],

Cell[BoxData[
    \(\(go2DBW[\([1]\)] = 
        go2DBW[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {y___}, w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {y\  (*\ \(,\)\(FontFamily \[Rule] "\<Courier\>"\)\
\ *) \ }, w\ , FormatType -> OutputForm];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2DBW[\([1, 2, 1]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"Fr \"\>",
          DisplayForm], ",", \({31.977272727272723`, 36.26493506493507`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 2.`, 
            FontWeight \[Rule] "Bold", 
            FontColor \[Rule] RGBColor[0.85`, 0, 0]}\), 
        ",", \(FormatType \[Rule] OutputForm\)}], "]"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["double help cell font / move as necessary", "Subsubsection"],

Cell["(* change font bigger for helpcell *)", "Text"],

Cell[BoxData[
    \(\(Do[\(go[\([1, i, helpcell]\)] = 
            go[\([1, i, helpcell]\)] /. 
              Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                  w___] \[Rule] 
                Text[z, TextStyle -> {FontSize -> \((x\ \ 2)\), y}, 
                  w];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\(go2D[\([1, i, helpcell]\)] = 
            go2D[\([1, i, helpcell]\)] /. 
              Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                  w___] \[Rule] 
                Text[z, TextStyle -> {FontSize -> \((x\ \ 2)\), y}, 
                  w];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\(go2DBW[\([1, i, helpcell]\)] = 
            go2DBW[\([1, i, helpcell]\)] /. 
              Text[z__, TextStyle -> {FontSize \[Rule] x_, y___}, 
                  w___] \[Rule] 
                Text[z, TextStyle -> {FontSize -> \((x\ \ 2)\), y}, 
                  w];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go[\([1, 31, helpcell]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"Therm Conduct  W/Km @300K \"\>",
          DisplayForm], 
        ",", \({136.88636363636363`, 0.`, 209.48961038961036`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 2.`}\), 
        ",", \(FormatType \[Rule] OutputForm\)}], "]"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2D[\([1, 31, helpcell]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"Text", "[", 
      RowBox[{
        TagBox["\<\"Therm Conduct  W/Km @300K \"\>",
          DisplayForm], ",", \({136.88636363636363`, 209.48961038961036`}\), 
        ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
        ",", \(TextStyle \[Rule] {FontSize \[Rule] 2.`}\), 
        ",", \(FormatType \[Rule] OutputForm\)}], "]"}]], "Output"]
}, Closed]],

Cell["\<\
(* scale position of text for help cell (needs 2x tall and 4x wide) \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(layout2 = layout;\)\)], "Input"],

Cell["\<\
(* any other boxed pinned to benear help box below needs to know *)\
\
\>", "Text"],

Cell[BoxData[
    \(\(\(helpcellmul = {6, 1, 2};\)\(\ \)\)\)], "Input"],

Cell[BoxData[
    \(add =. ; mul =. ;\)], "Input"],

Cell[BoxData[
    \(\(mul = Table[helpcellmul, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add = 
        Table[{If[fixtxthelp[\([i]\)] === {0}, 35, 0], 0, 
            0} (*\(+{\(-850\), 0, \(-176\)}\)*) , {i, 1, 
            Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add = 
        Table[\[IndentingNewLine]{If[fixtxthelp[\([i, 1]\)] === 1, 35, 0], 0, 
            0}, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add[\([36]\)] += {\(-10\), 0, 0};\)\)], "Input"],

Cell["\<\
{-850,0,-176} if not using opos (that is, using mul and add \
directly on position)\
\>", "Text"],

Cell[BoxData[
    \(\(layout = \((layout\ mul)\) + add;\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\[IndentingNewLine]\(go[\([1, i, helpcell, 2]\)] = 
            opos[i, helpcell];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\[IndentingNewLine]\(go2D[\([1, i, helpcell, 2]\)] = 
            Delete[opos[i, helpcell], 2];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[BoxData[
    \(add2 =. ; mul2 =. ;\)], "Input"],

Cell[BoxData[
    \(\(layout2 = layout;\)\)], "Input"],

Cell[BoxData[
    \(\(mul2 = Table[helpcellmul, {i, 1, Length[layout]}];\)\)], "Input"],

Cell["\<\
(* if label or non-label and not fixed and not centered, add 35 \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(add2 = 
        Table[\[IndentingNewLine]{If[fixtxthelp[\([i, 1]\)] === 1, 35, 0], 0, 
            0}, {i, 1, Length[layout]}];\)\)], "Input"],

Cell[BoxData[
    \(\(add2[\([36]\)] += {\(-10\), 0, 0};\)\)], "Input"],

Cell[BoxData[
    \(\(layout = \((layout\ mul2)\) + add2;\)\)], "Input"],

Cell[BoxData[
    \(\(Do[\[IndentingNewLine]\(go2DBW[\([1, i, helpcell, 2]\)] = 
            Delete[opos[i, helpcell], 2];\)\[IndentingNewLine], {i, 
          textobjects}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(layout = layout2;\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2D[\([1, 2, {helpcell, 1}]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox["\<\"Elem\"\>",
              DisplayForm], 
            ",", \({179.88636363636363`, 212.78961038961037`}\), 
            ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 4.`, 
                FontWeight \[Rule] "Bold", 
                FontColor \[Rule] RGBColor[0.85`, 0, 0]}\)}], "]"}], ",", 
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox["\<\"Fr \"\>",
              DisplayForm], 
            ",", \({28.977272727272723`, 36.26493506493507`}\), 
            ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 2.`, 
                FontWeight \[Rule] "Bold", 
                FontColor \[Rule] RGBColor[0.85`, 0, 0]}\)}], "]"}]}], 
      "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2DBW[\([1, 2, {helpcell, 1}]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox["\<\"Elem\"\>",
              DisplayForm], 
            ",", \({179.88636363636363`, 212.78961038961037`}\), 
            ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 4.`, 
                FontWeight \[Rule] "Bold", 
                FontColor \[Rule] RGBColor[0.85`, 0, 0]}\), 
            ",", \(FormatType \[Rule] OutputForm\)}], "]"}], ",", 
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox["\<\"Fr \"\>",
              DisplayForm], 
            ",", \({31.977272727272723`, 36.26493506493507`}\), 
            ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 2.`, 
                FontWeight \[Rule] "Bold", 
                FontColor \[Rule] RGBColor[0.85`, 0, 0]}\), 
            ",", \(FormatType \[Rule] OutputForm\)}], "]"}]}], 
      "}"}]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go[\([1, 3, {200, 1}]\)]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox["\<\"\"\>",
              DisplayForm], 
            ",", \({223.81818181818178`, 0.`, 234.95454545454544`}\), 
            ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 1.`}\), 
            ",", \(FormatType \[Rule] OutputForm\)}], "]"}], ",", 
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox[
              
              InterpretationBox[\("6\!\(s\^2\)"\[InvisibleSpace]" "\
\[InvisibleSpace]"6\!\(p\^6\)"\[InvisibleSpace]" "\[InvisibleSpace]"7\!\(s\^1\
\)"\[InvisibleSpace]" "\),
                SequenceForm[ 
                "6\!\(s\^2\)", " ", "6\!\(p\^6\)", " ", "7\!\(s\^1\)", " "],
                Editable->False],
              DisplayForm], 
            ",", \({20.977272727272727`, 0.`, 24.564935064935064`}\), 
            ",", \({\(-1\), 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 1.`}\), 
            ",", \(FormatType \[Rule] OutputForm\)}], "]"}]}], 
      "}"}]], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["unused: make go4 series (same with diff font)", "Subsubsection"],

Cell["unused now", "Text"],

Cell["\<\
reduce font from 2x above to 1/4 (1/2 spec. that is) for printout
why ?
\t* to examine just 2 cells usin plotrange large font need
\t* instead BW is faster and EPS viewed with gv is better\
\>", "Text"],

Cell[BoxData[
    \(go4 = go; go42D = go2D; go42DBW = go2DBW;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go4[\([1]\)] = 
        go[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .25)\), y}, w];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(go42D[\([1]\)] = 
        go2D[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .25)\), y}, w];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(\(go42DBW[\([1]\)] = 
        go2DBW[\([1, All]\)] /. \[IndentingNewLine]Text[z__, 
              TextStyle -> {FontSize \[Rule] x_, y___}, 
              w___] \[Rule] \[IndentingNewLine]Text[z, 
              TextStyle -> {FontSize -> \((x\ \  .25)\), y}, w];\)\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(go42D[\([1, 34, {190, 1}]\)]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["help cell box", "Subsubsection"],

Cell["\<\
(*
double size box for help cell for 3D
\t.35 left visually appears to have too much margin because strings on right
\tare (too) long, so compensate ul,ll,lr,ur for that
*)\
\>", "Text"],

Cell[BoxData[
    \(\(go2 = Table[gr2[\([o, i]\)], {o, 1, 1}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(\( (*\ 
      scale\ box\ *) \)\(\[IndentingNewLine]\)\(Module[{o, i, pt, ul, ll, lr, 
          ur, sc, dx}, 
        i = 0; \[IndentingNewLine]\[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .0325\),  .01, \
 .04}; \n\(ll = {\(- .0325\),  .01, \(- .04\)};\)\n\(lr = { .0415,  .01, \(- \
.04\)};\)\n\(ur = { .0415,  .01,  .04}\); \[IndentingNewLine] (*\ 
          tighter\ *) \[IndentingNewLine]ul = {\(- .031\),  .01,  .04}; \n
        ll = {\(- .031\),  .01, \(- .04\)}; \n
        lr = { .040,  .01, \(- .04\)}; \n
        ur = { .040,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]dx = \
{3, 1, 1}; \[IndentingNewLine]i = 
          helpcell; \[IndentingNewLine]gr2[\([1, 
              i]\)] = \[IndentingNewLine]Graphics3D[{\[IndentingNewLine]\
Thickness[ .0001], RGBColor[ .1,  .1,  .6], 
              Line[boxpts[opos[1, i], sc\ 2, ul\ dx, ll\ dx, lr\ dx, ur\ dx, 
                  False]]\[IndentingNewLine]}]; \[IndentingNewLine]\
\[IndentingNewLine]go2[\([1, helpcell]\)] = 
          gr2[\([1, helpcell]\)];\[IndentingNewLine]];\)\)\)], "Input"],

Cell["ditto for 2D", "Text"],

Cell[BoxData[
    \(\(go22D = 
        Table[gr22D[\([o, i]\)], {o, 1, 1}, {i, 1, objlen}];\)\)], "Input"],

Cell[BoxData[
    \(\(\( (*\ 
      scale\ box\ *) \)\(\[IndentingNewLine]\)\(Module[{o, i, pt, ul, ll, lr, 
          ur, sc, dx}, 
        i = 0; \[IndentingNewLine]\[IndentingNewLine]sc = {3.5, 
              1, \((17.0/
                  4.0)\)}\ 100\ ; \[IndentingNewLine]ul = {\(- .0325\),  .01, \
 .04}; \nll = {\(- .0325\),  .01, \(- .04\)}; \n
        lr = { .0415,  .01, \(- .04\)}; \n
        ur = { .0415,  .01,  .04}; \[IndentingNewLine] (*\ 
          tighter\ *) \[IndentingNewLine]ul = {\(- .031\),  .01,  .04}; \n
        ll = {\(- .031\),  .01, \(- .04\)}; \n
        lr = { .040,  .01, \(- .04\)}; \n
        ur = { .040,  .01,  .04}; \[IndentingNewLine]\[IndentingNewLine]dx = \
{3, 1, 1}; \[IndentingNewLine]i = 
          helpcell; \[IndentingNewLine]gr22D[\([1, 
              i]\)] = \[IndentingNewLine]Graphics[{\[IndentingNewLine]\
Thickness[ .0001], 
              RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[
                boxpts[opos[1, i], sc\ 2, ul\ dx, ll\ dx, lr\ dx, ur\ dx, 
                  True]]\[IndentingNewLine]}]; \[IndentingNewLine]\
\[IndentingNewLine]go22D[\([1, helpcell]\)] = 
          gr22D[\([1, helpcell]\)];\[IndentingNewLine]];\)\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    RowBox[{"Show", "[", 
      RowBox[{"Graphics3D", "[", 
        RowBox[{"Text", "[", 
          RowBox[{
            TagBox["\"\<8a-0, 18\>\"",
              DisplayForm], 
            ",", \({724.4318181818181`, 0.`, 377.64935064935065`}\), 
            ",", \({0, 0}\), ",", \({1, 0}\), 
            ",", \(TextStyle \[Rule] {FontSize \[Rule] 3}\)}], "]"}], "]"}], 
      "]"}]], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .75966 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0593249 1.05932 -0.14551 1.05932 [
[ 0 0 0 0 ]
[ 1 .75966 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.03886 .31565 m
0 .759 L
s
0 .759 m
.00084 .75966 L
s
.00084 .75966 m
.03962 .31637 L
s
.03962 .31637 m
.03886 .31565 L
s
.95065 0 m
.95123 .0009 L
s
.95123 .0009 m
1 .46825 L
s
1 .46825 m
.99938 .46741 L
s
.99938 .46741 m
.95065 0 L
s
.03886 .31565 m
0 .759 L
s
0 .759 m
.99938 .46741 L
s
.99938 .46741 m
.95065 0 L
s
.95065 0 m
.03886 .31565 L
s
.03962 .31637 m
.95123 .0009 L
s
.95123 .0009 m
1 .46825 L
s
1 .46825 m
.00084 .75966 L
s
.00084 .75966 m
.03962 .31637 L
s
0 0 m
1 0 L
1 .75966 L
0 .75966 L
closepath
clip
newpath
gsave
.47034 .38415 -70 -6.15625 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 12.3125 translate 1 -1 scale
63.000 6.875 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 3.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 6.875 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 3.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
64.750 6.875 moveto
(a) show
66.500 6.875 moveto
%%IncludeResource: font Math1Mono
%%IncludeFont: Math1Mono
/Math1Mono findfont 3.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(-) show
68.250 6.875 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 3.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
70.000 6.875 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 3.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(,) show
73.500 6.875 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 3.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(18) show
77.000 6.875 moveto
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 3.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.95065 0 m
.95123 .0009 L
s
.95123 .0009 m
1 .46825 L
s
1 .46825 m
.99938 .46741 L
s
.99938 .46741 m
.95065 0 L
s
.03886 .31565 m
0 .759 L
s
0 .759 m
.99938 .46741 L
s
.99938 .46741 m
.95065 0 L
s
.95065 0 m
.03886 .31565 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 218.75},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000fQ000`40n007h00Ooooo4?oo0P003ooo
003oool=ool300000ooo003oo`0>ool00?ooo`[oo`<000Coo`03003ooooo00goo`00oooo1ooo0`00
1ooo00<00?ooool03Ooo003oool4ool3000:ool00`00ooooo`0=ool00?ooo`;oo`8000koo`03003o
oooo00coo`00o_oo0`004?oo00<00?ooool03?oo003kool3000Cool00`00ooooo`0<ool00?Soo`<0
01Koo`03003ooooo00coo`00mOoo0`006Ooo00<00?ooool03?oo003bool3000Lool00`00ooooo`0<
ool00>ooo`<001ooo`03003ooooo00coo`00k?oo0`008_oo00<00?ooool03?oo003Yool3000Uool0
0`00ooooo`0<ool00>Koo`<002Soo`03003ooooo00coo`00i?oo0P00;?oo00<00?ooool02ooo003Q
ool3000^ool00`00ooooo`0;ool00=koo`<0037oo`03003ooooo00_oo`00fooo0`00=?oo00<00?oo
ool02ooo003Hool3000gool00`00ooooo`0;ool00=Goo`<003[oo`03003ooooo00_oo`00d_oo0`00
?Ooo00<00?ooool02ooo003?ool30010ool00`00ooooo`0;ool00<coo`<004?oo`03003ooooo00_o
o`00bOoo0`00Aooo00<00?ooool02_oo0037ool2001:ool00`00ooooo`0:ool00<Coo`<004coo`03
003ooooo00[oo`00`Ooo0`00Cooo00<00?ooool02_oo002nool3001Bool00`00ooooo`0:ool00;_o
o`<005Goo`03003ooooo00[oo`00^?oo0`00F?oo00<00?ooool02_oo002eool3001Kool00`00oooo
o`0:ool00;;oo`<005koo`03003ooooo00[oo`00[ooo0`00HOoo00<00?ooool02_oo002/ool3001U
ool00`00ooooo`09ool00:[oo`8006Soo`03003ooooo00Woo`00Yooo0`00J_oo00<00?ooool02Ooo
002Tool3001]ool00`00ooooo`09ool00:7oo`<0073oo`03003ooooo00Woo`00W_oo0`00Looo00<0
0?ooool02Ooo002Kool3001fool00`00ooooo`09ool009Soo`<007Woo`03003ooooo00Woo`00UOoo
0`00O?oo00<00?ooool02Ooo002Bool3001oool00`00ooooo`09ool008ooo`<008?oo`03003ooooo
00Soo`00SOoo0P00Q_oo00<00?ooool02?oo002:ool30028ool00`00ooooo`08ool008Ooo`<008_o
o`03003ooooo00Soo`00Q?oo0`00S_oo00<00?ooool02?oo0021ool3002Aool00`00ooooo`08ool0
07koo`<009Coo`03003ooooo00Soo`00Nooo0`00Uooo00<00?ooool02?oo001hool3002Jool00`00
ooooo`08ool007Goo`<009koo`03003ooooo00Ooo`00L_oo0`00XOoo00<00?ooool01ooo001`ool2
002Tool00`00ooooo`07ool006goo`<00:Koo`03003ooooo00Ooo`00J_oo0`00ZOoo00<00?ooool0
1ooo001Wool3002/ool00`00ooooo`07ool006Coo`<00:ooo`03003ooooo00Ooo`00HOoo0`00/_oo
00<00?ooool01ooo001Nool3002eool00`00ooooo`07ool005_oo`<00;Soo`03003ooooo00Ooo`00
F?oo0`00_?oo00<00?ooool01_oo001Eool3002oool00`00ooooo`06ool005?oo`800<;oo`03003o
oooo00Koo`00D?oo0`00a?oo00<00?ooool01_oo001=ool30037ool00`00ooooo`06ool004[oo`<0
0<[oo`03003ooooo00Koo`00Aooo0`00cOoo00<00?ooool01_oo0014ool3003@ool00`00ooooo`06
ool0047oo`<00=?oo`03003ooooo00Koo`00?_oo0`00eooo00<00?ooool01Ooo000kool3003Jool0
0`00ooooo`05ool003Soo`<00=goo`03003ooooo00Goo`00=_oo0P00h?oo00<00?ooool01Ooo000c
ool3003Rool00`00ooooo`05ool0033oo`<00>Goo`03003ooooo00Goo`00;Ooo0`00j?oo00<00?oo
ool01Ooo000Zool3003[ool00`00ooooo`05ool002Ooo`<00>koo`03003ooooo00Goo`009?oo0`00
lOoo00<00?ooool01Ooo000Qool3003eool00`00ooooo`04ool001koo`<00?Soo`03003ooooo00Co
o`006ooo0`00nooo00<00?ooool01?oo000Iool2003nool00`00ooooo`04ool001Koo`<00?ooo`7o
o`03003ooooo00Coo`004ooo0`00oooo1?oo00<00?ooool01?oo000@ool3003oool7ool00`00oooo
o`04ool000goo`<00?ooo`[oo`03003ooooo00Coo`002ooo0P00oooo3Ooo00<00?ooool01?oo000;
ool00`00ooooo`3oool=ool00`00ooooo`03ool000_oo`03003ooooo0?ooo`goo`03003ooooo00?o
o`002ooo00<00?ooool0oooo3Ooo00<00?ooool00ooo000;ool00`00ooooo`3oool=ool00`00oooo
o`03ool000_oo`03003ooooo0?ooo`goo`03003ooooo00?oo`002_oo00<00?ooool0oooo3_oo00<0
0?ooool00ooo000:ool00`00ooooo`3oool>ool00`00ooooo`03ool000[oo`03003ooooo0?ooo`ko
o`03003ooooo00?oo`002_oo00<00?ooool0oooo3_oo00<00?ooool00ooo000:ool00`00ooooo`3o
ool>ool00`00ooooo`03ool000[oo`03003ooooo0?ooo`ooo`03003ooooo00;oo`002_oo00<00?oo
ool0oooo3ooo00<00?ooool00_oo000:ool00`00ooooo`3oool?ool00`00ooooo`02ool000[oo`03
003ooooo0?ooo`ooo`03003ooooo00;oo`002_oo00<00?ooool0oooo3ooo00<00?ooool00_oo000:
ool00`00ooooo`3oool?ool00`00ooooo`02ool000[oo`03003ooooo0?ooo`ooo`03003ooooo00;o
o`002Ooo00<00?ooool0oooo4?oo00<00?ooool00_oo0009ool00`00ooooo`3oool@ool00`00oooo
o`02ool000Woo`03003ooooo07Goo`8000;oo`<00004ool00000002?ool00`00ooooo`02ool000Wo
o`03003ooooo07Coo`8000?oo`8000?oo`04003oo`00002>ool00`00ooooo`01ool000Woo`03003o
oooo0?oooa7oo`03003ooooo007oo`002Ooo00<00?ooool0oooo4Ooo00<00?ooool00Ooo0009ool0
0`00ooooo`3ooolAool00`00ooooo`01ool000Woo`03003ooooo0?oooa7oo`03003ooooo007oo`00
2Ooo00<00?ooool0oooo4Ooo00<00?ooool00Ooo0009ool00`00ooooo`3ooolAool00`00ooooo`01
ool000Woo`03003ooooo0?oooa7oo`03003ooooo007oo`002?oo00<00?ooool0oooo4_oo00<00?oo
ool00Ooo0008ool00`00ooooo`3ooolCool10001ool1ool000Soo`03003ooooo0?oooa?oo`40007o
o`7oo`002?oo00<00?ooool0oooo4ooo0@000Ooo0Ooo0008ool00`00ooooo`3ooolCool10001ool1
ool000Soo`03003ooooo0?oooa?oo`40007oo`7oo`002?oo00<00?ooool0oooo4ooo0@000Ooo0Ooo
0008ool00`00ooooo`3ooolCool10001ool1ool000Soo`03003ooooo0?oooa?oo`40007oo`7oo`00
2?oo00<00?ooool0oooo4ooo0@000Ooo0Ooo0008ool00`00ooooo`3ooolCool10001ool1ool000So
o`03003ooooo0?oooaCoo`40007oo`001ooo00<00?ooool0oooo5Ooo0@000Ooo0007ool00`00oooo
o`3ooolEool10001ool000Ooo`03003ooooo0?oooaGoo`40007oo`001ooo00<00?ooool0oooo5?oo
0P000Ooo0007ool00`00ooooo`3oool@ool40003ool000Ooo`03003ooooo0?ooo`goo`<000Ooo`00
1ooo00<00?ooool0oooo2Ooo10002_oo0007ool00`00ooooo`3oool6ool3000>ool000Ooo`03003o
oooo0?ooo`?oo`<0017oo`001ooo00<00?ooool0o_oo10005?oo0007ool00`00ooooo`3kool3000H
ool000Koo`03003ooooo0?Soo`@001_oo`001_oo00<00?ooool0mOoo0`007ooo0006ool00`00oooo
o`3aool4000Rool000Koo`03003ooooo0>koo`<002Koo`001_oo00<00?ooool0j_oo1000:Ooo0006
ool00`00ooooo`3Wool3000]ool000Koo`03003ooooo0>Coo`<0033oo`001_oo00<00?ooool0h?oo
1000<ooo0006ool00`00ooooo`3Mool3000gool000Koo`03003ooooo0=Woo`@003[oo`001_oo00<0
0?ooool0e_oo0`00?_oo0006ool00`00ooooo`3Bool40011ool000Goo`03003ooooo0=3oo`<004Go
o`001Ooo00<00?ooool0c?oo1000B?oo0005ool00`00ooooo`39ool3001<ool000Goo`03003ooooo
0<Koo`<004ooo`001Ooo00<00?ooool0`_oo1000D_oo0005ool00`00ooooo`2oool3001Fool000Go
o`03003ooooo0;_oo`@005Woo`001Ooo00<00?ooool0^?oo0`00GOoo0005ool00`00ooooo`2dool4
001Pool000Goo`03003ooooo0;7oo`<006Coo`001Ooo00<00?ooool0[Ooo1000Iooo0005ool00`00
ooooo`2Zool3001[ool000Coo`03003ooooo0:Soo`<006koo`001?oo00<00?ooool0Y?oo1000LOoo
0004ool00`00ooooo`2Qool3001eool000Coo`03003ooooo09goo`@007Soo`001?oo00<00?ooool0
V_oo0`00O?oo0004ool00`00ooooo`2Fool4001oool000Coo`03003ooooo09?oo`<008?oo`001?oo
00<00?ooool0Sooo1000Q_oo0004ool00`00ooooo`2<ool3002:ool000Coo`03003ooooo08Soo`@0
08goo`001?oo00<00?ooool0QOoo0`00TOoo0003ool00`00ooooo`23ool3002Dool000?oo`03003o
oooo07ooo`@009Ooo`000ooo00<00?ooool0O?oo0`00Vooo0003ool00`00ooooo`1hool4002Nool0
00?oo`03003ooooo07Goo`<00:;oo`000ooo00<00?ooool0LOoo1000YOoo0003ool00`00ooooo`1^
ool3002Yool000?oo`03003ooooo06[oo`@00:coo`000ooo00<00?ooool0Iooo0`00/?oo0003ool0
0`00ooooo`1Tool3002cool000?oo`03003ooooo063oo`@00;Koo`000ooo00<00?ooool0GOoo0`00
^_oo0002ool00`00ooooo`1Jool4002mool000;oo`03003ooooo05Ooo`<00<7oo`000_oo00<00?oo
ool0Dooo1000a?oo0002ool00`00ooooo`1@ool30038ool000;oo`03003ooooo04coo`@00<_oo`00
0_oo00<00?ooool0BOoo0`00cooo0002ool00`00ooooo`16ool3003Bool000;oo`03003ooooo04;o
o`@00=Goo`000_oo00<00?ooool0?ooo0`00fOoo0002ool00`00ooooo`0kool4003Lool000;oo`03
003ooooo03Soo`<00>3oo`0000?oo`00ool0=_oo1000hooo00000ooo003oo`0cool3003Wool00003
ool00?oo02ooo`@00>[oo`0000?oo`00ool0;?oo0`00k_oo00000ooo003oo`0Yool3003aool00003
ool00?oo02Goo`@00?Coo`0000?oo`00ool08_oo0`00n?oo00000ooo003oo`0Nool4003kool00003
ool00?oo01_oo`<00?ooo`0000?oo`00ool05ooo1000oooo0ooo00000ooo003oo`0Dool3003oool7
ool00003ool00?oo013oo`@00?ooo`[oo`0000<00?ooool03Ooo0`00oooo3_oo00000`00ooooo`0:
ool3003ooolAool00003003ooooo00Koo`@00?oooaCoo`0000<00?ooool00ooo0`00oooo6?oo0000
0`00ool00003003ooolKool000800?oooaooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {217.75, 0}} -> {0.0554123, 0.137362, \
0.00329332, 0.00329332}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[Graphics3D[gr[\([2]\)]]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .55045 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0578873 1.05789 -0.244428 1.05789 [
[ 0 0 0 0 ]
[ 1 .55045 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02027 .31822 m
0 .54936 L
s
0 .54936 m
.0013 .55045 L
s
.0013 .55045 m
.02151 .31936 L
s
.02151 .31936 m
.02027 .31822 L
s
.97364 0 m
.97458 .00142 L
s
.97458 .00142 m
1 .24496 L
s
1 .24496 m
.99902 .2436 L
s
.99902 .2436 m
.97364 0 L
s
.02027 .31822 m
0 .54936 L
s
0 .54936 m
.99902 .2436 L
s
.99902 .2436 m
.97364 0 L
s
.97364 0 m
.02027 .31822 L
s
.02151 .31936 m
.97458 .00142 L
s
.97458 .00142 m
1 .24496 L
s
1 .24496 m
.0013 .55045 L
s
.0013 .55045 m
.02151 .31936 L
s
0 0 m
1 0 L
1 .55045 L
0 .55045 L
closepath
clip
newpath
gsave
.06396 .34005 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Fr) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.08989 .33151 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ra) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.11599 .32291 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.14225 .31426 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.16869 .30556 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.19529 .2968 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.22206 .28798 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.24901 .2791 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.27614 .27017 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ac) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.30344 .26118 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Th) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.33092 .25213 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Pa) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.35858 .24302 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(U) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.38642 .23385 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Np) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.41444 .22462 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Pu) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.44266 .21533 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Am) show
70.250 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47106 .20598 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Cm) show
70.250 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.49965 .19656 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Bk) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.52843 .18709 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Cf) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5574 .17754 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Es) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58657 .16794 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Fm) show
70.250 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.61594 .15827 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Md) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.6455 .14853 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(No) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.67527 .13873 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Lr) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.70524 .12886 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Rf) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.73542 .11892 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Db) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.76581 .10891 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Sg) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.7964 .09884 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Bh) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.82721 .08869 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Hs) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.85823 .07847 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Mt) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.88946 .06819 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Uun) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.92092 .05783 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Uuu) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.9526 .0474 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Uub) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.06154 .37068 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Cs) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.08762 .36219 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ba) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.11387 .35364 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(La) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.14028 .34504 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ce) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.16687 .33638 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Pr) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.19363 .32767 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Nd) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.22056 .3189 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Pm) show
70.250 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.24766 .31007 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Sm) show
70.250 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.27495 .30118 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Eu) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.30241 .29224 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Gd) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.33006 .28324 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Tb) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.35788 .27417 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Dy) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.3859 .26505 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ho) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.41409 .25587 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Er) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.44248 .24662 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Tm) show
70.250 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47106 .23732 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Yb) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.49982 .22795 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Lu) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.52879 .21852 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Hf) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.55794 .20902 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ta) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.5873 .19946 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.062 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(W) show
70.250 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.61686 .18984 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Re) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.64661 .18014 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Os) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.67658 .17039 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ir) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.70674 .16056 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Pt) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.73712 .15067 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Au) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.76771 .14071 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Hg) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.7985 .13068 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Tl) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.82952 .12058 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Pb) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.86075 .11041 -61 -6.59375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.1875 translate 1 -1 scale
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Bi) show
70.125 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.8922 .10017 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Po) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.92387 .08985 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(At) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.95577 .07946 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Rn) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.0591 .40168 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Rb) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.08533 .39324 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Sr) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.11172 .38474 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.13829 .37619 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.16503 .36758 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.19194 .35891 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.21903 .35019 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.2463 .34141 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.27375 .33258 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.30138 .32368 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.32919 .31473 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.35718 .30571 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.38537 .29664 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.41374 .2875 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.4423 .27831 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47106 .26905 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.50001 .25973 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Y) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.52915 .25035 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Zr) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.55849 .2409 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Nb) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58804 .23139 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Mo) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.61779 .22181 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Tc) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.64774 .21217 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ru) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.6779 .20246 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Rh) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.70826 .19268 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Pd) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.73884 .18283 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ag) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.76963 .17292 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Cd) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.80064 .16294 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(In) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.83186 .15288 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Sn) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.86331 .14276 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Sb) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.89497 .13257 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Te) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.92686 .1223 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(I) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.95898 .11196 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Xe) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.05663 .43306 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(K) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.083 .42466 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ca) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.10955 .41622 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.13627 .40771 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.16317 .39916 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.19024 .39054 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.21749 .38187 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.24492 .37314 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.27253 .36435 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.30033 .35551 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.32831 .34661 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.35648 .33764 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.38483 .32862 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.41338 .31954 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.44212 .31039 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47106 .30118 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.50019 .29191 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Sc) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.52952 .28258 -61 -6.59375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.1875 translate 1 -1 scale
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ti) show
70.125 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.55905 .27318 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(V) show
70.188 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58879 .26372 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Cr) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.61873 .25419 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Mn) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.64888 .2446 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Fe) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.67923 .23494 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Co) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.7098 .22521 -61 -6.59375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.1875 translate 1 -1 scale
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ni) show
70.125 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.74058 .21542 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Cu) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.77158 .20555 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Zn) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.8028 .19562 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ga) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.83424 .18562 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ge) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.8659 .17554 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(As) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.89778 .16539 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Se) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.92989 .15518 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Br) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.96224 .14488 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Kr) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.05412 .46481 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Na) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.08065 .45647 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Mg) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.10735 .44807 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.13423 .43962 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.16128 .43112 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.18851 .42256 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.21593 .41394 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.24352 .40526 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.2713 .39653 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.29926 .38774 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.32742 .37888 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.35576 .36997 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.38429 .361 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.41302 .35197 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.44194 .34288 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47106 .33372 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.50037 .3245 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.52989 .31522 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.55962 .30588 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.58955 .29647 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.61968 .28699 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.65003 .27745 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.68059 .26784 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.71136 .25817 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.74235 .24843 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.77356 .23861 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.80499 .22873 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Al) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.83664 .21878 -61 -6.59375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.1875 translate 1 -1 scale
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Si) show
70.125 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.86852 .20876 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(P) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.90063 .19866 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(S) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.93297 .18849 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Cl) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.96554 .17825 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ar) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.05159 .49695 -61 -6.59375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.1875 translate 1 -1 scale
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Li) show
70.125 7.625 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.07827 .48866 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Be) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.10513 .48032 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.13216 .47193 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.15937 .46348 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Elem) show
72.625 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.18677 .45497 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.21435 .4464 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.24211 .43778 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.27005 .4291 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.29819 .42037 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.32651 .41157 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.35503 .40271 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.38374 .3938 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.41265 .38482 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.44175 .37578 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47106 .36668 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.50056 .35752 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.53027 .34829 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.56019 .339 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.59031 .32964 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.62065 .32022 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.6512 .31073 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.68196 .30118 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.71294 .29156 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.74414 .28187 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.77556 .27211 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.80721 .26228 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(B) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.83908 .25239 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(C) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.87118 .24242 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(N) show
70.188 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.90351 .23238 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(O) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.93608 .22226 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(F) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.96888 .21207 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(Ne) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.04902 .52948 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(H) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.07586 .52125 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.10287 .51297 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.13007 .50463 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.15744 .49623 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.185 .48778 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.21274 .47927 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.24067 .47071 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.26879 .46209 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.2971 .45341 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.3256 .44467 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.35429 .43587 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.38319 .42701 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.41227 .41809 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.44156 .4091 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.47106 .40006 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.50075 .39095 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.53066 .38178 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.56077 .37255 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.59109 .36325 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.62163 .35389 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.65238 .34445 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.68335 .33496 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.71454 .32539 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.74595 .31576 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.77759 .30606 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.80945 .29629 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.84155 .28644 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.87387 .27653 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.90644 .26655 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.93923 .25649 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
gsave
.97227 .24636 -61 -6.53125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 13.0625 translate 1 -1 scale
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold
%%IncludeFont: Courier-Bold
%%BeginResource: font Courier-Bold-MISO
%%BeginFont: Courier-Bold-MISO
/Courier-Bold /Courier-Bold-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
(He) show
70.125 7.500 moveto
%%IncludeResource: font Courier-Bold-MISO
%%IncludeFont: Courier-Bold-MISO
/Courier-Bold-MISO findfont 4.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.850 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97364 0 m
.97458 .00142 L
s
.97458 .00142 m
1 .24496 L
s
1 .24496 m
.99902 .2436 L
s
.99902 .2436 m
.97364 0 L
s
.02027 .31822 m
0 .54936 L
s
0 .54936 m
.99902 .2436 L
s
.99902 .2436 m
.97364 0 L
s
.97364 0 m
.02027 .31822 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 158.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000WQ000`40n007h00Ooooo5ooo0P002?oo
003ooolDool300000ooo003oo`07ool00?oooa7oo`<000Coo`03003ooooo00Koo`00oooo3_oo0`00
1ooo00<00?ooool01_oo003oool;ool3000:ool00`00ooooo`06ool00?ooo`Soo`<000goo`03003o
oooo00Koo`00oooo1Ooo0`004Ooo00<00?ooool01Ooo003oool2ool3000Dool00`00ooooo`05ool0
0?koo`<001Ooo`03003ooooo00Goo`00nooo0`006_oo00<00?ooool01Ooo003hool3000Mool00`00
ooooo`05ool00?Goo`<0023oo`03003ooooo00Goo`00l_oo0`008ooo00<00?ooool01Ooo003_ool3
000Vool00`00ooooo`05ool00>coo`<002Coo`;H0004oooH0=P00002f005ool00>Woo`<002Ooo`;H
0004oooH0=P00002f005ool00>Koo`<002[oo`;H00Coo`03003ooooo00Coo`00hooo0`008ooo0]P0
00CoomP0f03oo`;H00Soo`03003ooooo00Coo`00h?oo0`009_oo0]P000CoomP0f03oo`;H00Soo`03
003ooooo00Coo`00gOoo0`00:Ooo0]P03_oo00<00?ooool01?oo003Jool3000Sool2f0001?oof03H
0?oo0]P04Ooo00<00?ooool01?oo003Gool3000Vool2f0001?oof03H0?oo0]P04Ooo00<00?ooool0
1?oo003Dool3000Qool2f002ool2f002ool2f00Gool00`00ooooo`04ool00=7oo`<002Coo`;H0004
oooH0=P0f00Eool2f0001Ooof03H0?oo00001_oo003>ool3000Wool2f002ool00mP0ooooo`0Dool2
f0001Ooof03H0?oo00001_oo003;ool3000Qool2f0000ooof03H000Oool2f004ool00`00ooooo`04
ool00<Soo`<002Coo`;H0003oooH0=P001Koo`?H0003oooH0=P000[oo`03003ooooo00?oo`00aOoo
0`009ooo0]P06Ooo00?H0?oof0000mP02_oo00<00?ooool00ooo0032ool3000Qool2f0000ooof03H
000Oool2f002ool00mP0ooooo`09ool00`00ooooo`03ool00;ooo`<002Coo`;H0003oooH0=P001Ko
o`;H0003oooH0=P001Coo`03003ooooo00?oo`00_?oo0`008Ooo0]P01?oo00CH0?oooooH01Ooo`;H
0003oooH0=P001Coo`03003ooooo00?oo`00^Ooo0`008Ooo0]P000?oomP0f0007ooo0]P05ooo00<0
0?ooool00ooo002fool3000Tool2f0000ooof03H000Fool2f0001?oof03H0=P05_oo0]P000GoomP0
f03oo`0000Goo`00/ooo0`009ooo0]P06Ooo0]P00_oo00?H0?ooool05_oo00KH0?oof03H0?oo0005
ool00;3oo`<0027oo`;H0003oooH0=P001ooo`03f03ooooo01Woo`;H00Coo`03003ooooo00?oo`00
[Ooo0`009?oo0]P000?oomP0f0005_oo0]P000?oomP0f0002?oo00?H0?ooool03?oo0mP03?oo00<0
0?ooool00ooo002Zool3000Wool2f0000ooof03oo`0Fool2f0000ooof03H000Hool00mP0ooooo`0<
ool00`00ooooo`02ool00:Ooo`<002;oo`;H00;oo`;H01Coo`KH00?oo`;H0003oooH0?oo01Ooo`?H
00goo`03003ooooo00;oo`00Y?oo0`009Ooo0]P00_oo0]P05Ooo00CH0?oooooH01Ooo`GH01Coo`03
003ooooo00;oo`00XOoo0`00:?oo0]P00_oo0]P03ooo0]P00ooo0mP000?oomP0ool05ooo00CH0?oo
f03H01Coo`03003ooooo00;oo`00W_oo0`008ooo0]P000?oomP0f0005Ooo0]P000?oomP0f0007ooo
0mP05_oo00<00?ooool00_oo002Kool3000Vool00mP0ooooo`02f00Eool2f0000ooof03H000Fool2
f0000ooof03H000Gool2f002ool2f0000`00ooooo`02ool009Soo`<002Woo`03f03ooooo01Ooo`;H
01Woo`;H0003oooH0=P001Ooo`04f03oooooool2f0000`00ooooo`02ool009Goo`<002?oo`;H0003
oooH0=P001Goo`GH01ooo`;H0003oooH0?oo01Ooo`;H00Coo`03003ooooo00;oo`00T_oo0`009_oo
0]P000?oomP0f0005Ooo00?H0?oof0000]P05_oo0]P000?oomP0f0005ooo0]P00_oo0]P02Ooo00<0
0?ooool00_oo002?ool3000Pool2f0000ooof03H0004ool2f00Hool2f00Iool2f0000ooof03H000G
ool2f002ool2f009ool00`00ooooo`02ool008coo`<002?oo`;H0003oooH0=P001Goo`;H00;oo`;H
01koo`;H01[oo`03f03ooooo00goo`03003ooooo007oo`00ROoo0`009_oo0]P000?oomP0f0005Ooo
0]P000CoomP0f03H01Goo`GH01Ooo`;H0003oooH0=P001Coo`03003ooooo007oo`00Q_oo0`008Ooo
00CH0?oooooH01koo`;H00;oo`03f03ooooo01Goo`04f03oomP0f00Gool2f0000ooof03H000Dool0
0`00ooooo`01ool008?oo`<002Coo`04f03ooooof00Fool3f0000ooof03H000Mool3f00Iool2f00G
ool00`00ooooo`01ool0083oo`<002Ooo`;H01Woo`03f03ooooo00;H01Coo`;H0003oooH0=P001Oo
o`GH01goo`03003ooooo007oo`00OOoo0`008Ooo0]P000?oomP0f0007_oo0mP04Ooo0]P01?oo00?H
0?ooool00]P05ooo00?H0?oof0000]P05ooo0mP000CoomP0f00000?oo`00N_oo0`009?oo0]P000?o
omP0f0005Ooo0]P000?oomP0f0005Ooo1MP01?oo0]P000?oomP0f0005ooo0]P06_oo00CH0?oof03o
o`;H0003003ooooo007oo`00Mooo0`009ooo0]P06?oo0]P000?oomP0f0005Ooo00?H0?oof0000]P0
5ooo0]P000?oomP0f0008?oo0]P01?oo00<00?ooool00Ooo001dool3000Rool2f002ool2f00Cool2
f0000ooof03H0004ool2f00Hool2f00Jool00mP0ooooo`02f00Gool2f0001?oof03H0=P02Ooo00<0
0?ooool00Ooo001aool3000Uool01=P0oooooooo0]P04ooo0]P000?oomP0f0005_oo0]P000?oomP0
f0007ooo0]P06_oo00GH0?ooooooomP000[oo`03003ooooo007oo`00K_oo0`008?oo0]P000?oomP0
f0000ooo0]P00_oo0]P04ooo0]P06Ooo0]P000?oomP0f0005_oo0]P000?oomP0f0008?oo0]P00_oo
00?H0?ooool02Ooo0@000Ooo0Ooo001[ool3000Sool2f0000ooof03H000Dool00mP0oooH000Pool2
f0000ooof03H000Fool00mP0ooooo`02f00Gool2f00Gool10001ool1ool006Soo`<002Koo`04f03o
oooof00Eool3f00Gool2f0000ooof03H000Oool2f00Jool2f00Gool10001ool1ool006Goo`<0027o
o`;H0003oooH0?oo01coo`03f03oomP001Ooo`;H0003oooH0=P001Koo`;H0003oooH0=P0023oo`;H
01Ooo`40007oo`7oo`00H_oo0`009?oo00CH0?oooooH01Goo`GH01goo`;H0003oooH0?oo01Koo`03
f03ooooo00;H01Koo`;H027oo`40007oo`7oo`00Gooo0`009ooo0]P06?oo00CH0?oof03H01Coo`;H
0003oooH0=P001ooo`;H01Woo`;H01_oo`;H0005oooH0=P0ool00002ool005coo`<002;oo`CH01go
o`?H01Koo`;H0003oooH0=P001Koo`;H0003oooH0=P001ooo`;H01_oo`;H0005oooH0=P0ool00002
ool005Woo`<002Goo`04f03oomP0f00Dool2f002ool2f00Dool5f003ool2f00Iool00mP0ooooo`02
f00Fool2f0001?oof03H0=P08?oo0]P01?oo0@000Ooo0Ooo001Fool3000Pool2f0000ooof03H0003
ool2f00Fool2f002ool2f00Eool01=P0oooH0=P05Ooo0]P000CoomP0f03H00?oo`;H01Woo`;H00;o
o`03f03ooooo01Koo`03f03ooooo00coo`40007oo`7oo`00Dooo0`008ooo0]P000?oomP0f0005?oo
1=P00ooo0]P00_oo0]P05?oo0mP05ooo0]P00_oo00?H0?ooool05?oo1]P00ooo0]P06ooo00?H0?oo
ool03?oo0@000Ooo0Ooo001@ool3000Qool2f003ool2f00Gool01=P0oooH0=P05?oo0]P000?oomP0
f0007_oo0]P06Ooo00GH0?oof03oomP000Soo`03f03ooooo01Koo`;H00koo`40007oo`00COoo0`00
8Ooo0]P000?oomP0f0007?oo00?H0?ooool05Ooo0]P000?oomP0f0005Ooo0]P000?oomP0f0002?oo
00?H0?ooool05?oo0]P00_oo00?H0?ooool05Ooo0]P06?oo0@000Ooo001:ool3000Tool2f0000ooo
f03H000Cool5f00Lool2f00Hool00mP0ooooo`02f00kool2f00Hool10001ool004Ooo`<002Ooo`;H
01Ooo`04f03oomP0f00Dool2f0000ooof03H000Mool2f00eool2f007ool2f00Hool10001ool004Co
o`<002;oo`;H01koo`04f03oomP0f00Eool2f0000ooof03H000Eool00mP0ooooo`02f00jool2f00P
ool20001ool0047oo`<002Goo`;H01Koo`CH01goo`;H0003oooH0?oo01Goo`03f03ooooo00;H03[o
o`;H01_oo`;H00<000?oo`00?_oo0`008?oo0]P000?oomP0f0000ooo0]P05ooo00?H0?oof0005?oo
0]P00_oo0]P07Ooo0]P0=?oo0]P08_oo100000?oomP0f0000ooo000kool3000Sool2f0000ooof03H
000Bool2f002ool2f003ool3f00Eool01=P0oooooooo0]P05?oo0]P000?oomP0f000>_oo00?H0?oo
ool07_oo0`000_oo0]P01_oo000hool3000Vool2f00Eool2f002ool2f00Cool3f005ool2f00Hool2
f0000ooof03H000jool2f00Lool3000=ool003Goo`<0027oo`GH01[oo`;H01Soo`03f03ooooo01Go
o`;H00;oo`;H00?oo`;H03Coo`;H027oo`@0013oo`00<_oo0`009Ooo00CH0?oof03H01;oo`;H0003
oooH0=P001coo`03f03oomP001Koo`04f03oooooool2f00iool2f00Nool3000Dool002ooo`<001oo
o`GH00?oo`CH00koo`03f03ooooo00;oo`;H0003oooH0=P003Goo`;H03goo`03f03ooooo01[oo`<0
01Ooo`00;?oo0`008_oo00?H0?oof0000]P04_oo0]P000?oomP0f0000ooo0]P0<?oo00?H0?ooool0
G_oo0`006_oo000Yool3000Uool2f00Eool2f0000ooof03H000eool2f01Kool4000Mool002Koo`<0
03ooo`;H03Soo`;H05Soo`<0027oo`008ooo0`00>_oo1MP0=?oo1]P0F_oo0`009?oo000Pool3000n
ool01=P0oooH0=P0=Ooo00CH0?oooooH05Ooo`@002Ooo`007Ooo0`00@?oo1=P0=Ooo0mP0E_oo0`00
:ooo000Jool3000kool2f0000ooof03H000dool2f0000ooof03H0007ool00mP0ooooo`1?ool3000^
ool001Ooo`<003koo`03f03ooooo00;H03Coo`;H0003oooH0=P005Koo`<0037oo`005?oo0`00>_oo
0]P000?oomP0f0000_oo0]P000?oomP0f000=?oo0]P0EOoo1000=?oo000Aool3000mool2f0000ooo
f03H002?ool3000hool000koo`<0043oo`;H08ooo`<003_oo`002ooo0`00>ooo0]P000?oomP0ool0
T?oo1000?_oo0008ool3000nool2f0000ooof03oo`2=ool30012ool000Koo`8003Woo`;H0003oooH
0?oo00?oo`;H08goo`<004Goo`001_oo00<00?ooool0>?oo0]P000?oomP0ool0Sooo0`00B?oo0006
ool00`00ooooo`0hool2f02>ool4001;ool000Koo`03003ooooo033oo`;H0003oooH0=P0093oo`<0
04ooo`001_oo00<00?ooool04ooo0]P000?oomP0f0006?oo0]P000?oomP0f000SOoo0`00D_oo0006
ool00`00ooooo`0Cool2f0000ooof03H000Aool2f002ool2f0001?oof03H0?oo0]P0ROoo1000EOoo
0005ool00`00ooooo`0<ool01=P0oooooooo0]P00_oo0]P05?oo0]P00_oo0]P0S?oo0`00FOoo0005
ool00`00ooooo`0<ool01=P0oooooooo0]P06?oo0]P0SOoo0`00G?oo0005ool00`00ooooo`0<ool2
f00Dool2f0000ooof03H002?ool3001Oool000Goo`03003ooooo02;oo`03f03ooooo00;H08_oo`@0
06;oo`001Ooo00<00?ooool07?oo1=P00_oo0]P0Rooo0`00I_oo0005ool00`00ooooo`0Lool01=P0
oooH0=P0S?oo0`00JOoo0005ool00`00ooooo`0Lool00mP0ooooo`29ool4001/ool000Goo`03003o
oooo01?oo`;H0003oooH0=P008goo`<0073oo`001Ooo00<00?ooool04ooo0]P000?oomP0f000R_oo
0`00Looo0005ool00`00ooooo`0<ool2f0000ooof03H0002ool00mP0ooooo`29ool3001fool000Go
o`03003ooooo00coo`03f03ooooo00;H08[oo`@007Woo`001?oo00<00?ooool03Ooo0]P0R_oo0`00
OOoo0004ool00`00ooooo`2Fool30020ool000Coo`03003ooooo09;oo`@008?oo`001?oo00<00?oo
ool0Sooo0`00Qooo0004ool00`00ooooo`2<ool3002:ool000Coo`03003ooooo01?oo`;H00;oo`;H
06ooo`@008goo`001?oo00<00?ooool04ooo0]P00_oo0]P0K?oo0`00TOoo0004ool00`00ooooo`0<
ool2f0000ooof03H0002ool2f01]ool3002Dool000Coo`03003ooooo00coo`;H0003oooH0=P006ko
o`<009Ooo`001?oo00<00?ooool03?oo0]P000?oomP0ool0J_oo1000V_oo0004ool00`00ooooo`1h
ool3002Nool000?oo`03003ooooo07Koo`<00:7oo`000ooo00<00?ooool0L_oo1000Y?oo0003ool0
0`00ooooo`1_ool3002Xool000?oo`03003ooooo01Coo`;H0003oooH0=P005?oo`<00:_oo`000ooo
00<00?ooool05?oo00?H0?ooool00]P0D?oo0`00[_oo0003ool00`00ooooo`0<ool2f006ool2f01?
ool4002aool000?oo`03003ooooo00coo`03f03ooooo05?oo`<00;Goo`000ooo00<00?ooool03?oo
0]P0DOoo0`00^?oo0003ool00`00ooooo`1Kool4002kool000?oo`03003ooooo05Soo`<00;ooo`00
0ooo00<00?ooool0EOoo0`00`_oo0002ool00`00ooooo`0Gool2f00jool30035ool000;oo`03003o
oooo01Coo`;H0003oooH0=P003Koo`@00<Soo`000_oo00<00?ooool05?oo0]P000?oomP0f000<ooo
0`00c?oo0002ool00`00ooooo`0<ool2f0000ooof03H0003ool2f00Eool2f0000ooof03H0003f000
0ooof03oo`0Cool3003?ool000;oo`03003ooooo00coo`;H0003oooH0=P001[oo`;H00;oo`06f03o
omP0f03oomP04?oo1000d_oo0002ool00`00ooooo`0<ool2f00Mool2f002ool00mP0ooooo`0@ool3
003Fool000;oo`03003ooooo03ooo`<00=Woo`000_oo00<00?ooool0??oo0`00g?oo0002ool00`00
ooooo`0hool4003Oool000;oo`03003ooooo03Goo`<00>?oo`000_oo00<00?ooool04ooo0]P000?o
omP0f0006_oo0`00i_oo00000ooo003oo`0Eool2f0000ooof03H000Fool4003Yool00003ool00?oo
00ooo`GH0003oooH0?oo01Koo`<00>goo`0000?oo`00ool03ooo00CH0?oooooH01Ooo`<00?3oo`00
00?oo`00ool03ooo00?H0?ooool05Ooo0`00looo00000ooo003oo`0Bool00mP0ooooo`0>ool4003f
ool00003ool00?oo023oo`<00?[oo`0000?oo`00ool07Ooo0`00oOoo00000ooo003oo`0Iool4003o
ool1ool00003ool00?oo01Koo`<00?ooo`Goo`0000?oo`00ool04ooo0`00oooo2?oo00000ooo003o
o`0@ool3003oool;ool00003003ooooo00coo`@00?ooo`koo`0000<00?ooool02Ooo0`0000?oomP0
f000oooo3ooo00000`00ooooo`06ool30004ool2f03oool?ool00003003ooooo00;oo`@00?oooaSo
o`0000<00?oo00000P00oooo7?oo0002003ooolOool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {157.5, 0}} -> {0.053277, 0.23105, 0.0033037, \
0.0033037}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go22D[\([1, 200]\)]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go22D[\([1, 201]\)]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[%, %%]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.952381 0.0147151 0.588604 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-0.0263022, -0.0250052, \
0.00366761, 0.00593432}},
  ImageCacheContents->"Empty"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2[\([1, 200]\)]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2[\([1, 201]\)]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[%, %%]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.0855 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0567234 1.16608 3.33392e-17 1.16608 [
[ 0 0 0 0 ]
[ 1 1.0855 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.08846 .24555 m
0 .80374 L
s
0 .80374 m
.40037 1.0855 L
s
.40037 1.0855 m
.41799 .58158 L
s
.41799 .58158 m
.08846 .24555 L
s
.67245 0 m
.92713 .41497 L
s
.92713 .41497 m
1 .94814 L
s
1 .94814 m
.70644 .58546 L
s
.70644 .58546 m
.67245 0 L
s
.08846 .24555 m
0 .80374 L
s
0 .80374 m
.70644 .58546 L
s
.70644 .58546 m
.67245 0 L
s
.67245 0 m
.08846 .24555 L
s
.41799 .58158 m
.92713 .41497 L
s
.92713 .41497 m
1 .94814 L
s
1 .94814 m
.40037 1.0855 L
s
.40037 1.0855 m
.41799 .58158 L
s
0 0 m
1 0 L
1 1.0855 L
0 1.0855 L
closepath
clip
newpath
.67245 0 m
.92713 .41497 L
s
.92713 .41497 m
1 .94814 L
s
1 .94814 m
.70644 .58546 L
s
.70644 .58546 m
.67245 0 L
s
.08846 .24555 m
0 .80374 L
s
0 .80374 m
.70644 .58546 L
s
.70644 .58546 m
.67245 0 L
s
.67245 0 m
.08846 .24555 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{265.312, 287.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004900017a000`40n007h00O/Ooo00<00?ooool0
EOoo002_ool4001Fool00:coo`<000;oo`03003oo`0005Goo`00Z_oo0P001Ooo00<00?oo0000EOoo
002Xool20007ool01000ooooo`00E?oo002Uool30009ool01@00oooooooo0000Dooo002Sool2000<
ool01@00oooooooo0000Dooo002Pool3000>ool00`00ooooo`02ool00`00ooooo`1@ool009koo`80
017oo`03003ooooo00?oo`03003ooooo04ooo`00W?oo0P004ooo00<00?ooool00ooo00<00?ooool0
Cooo002Iool3000Fool00`00ooooo`03ool00`00ooooo`1>ool009Ooo`8001Woo`03003ooooo00?o
o`03003ooooo04koo`00U?oo0`006ooo00<00?ooool01?oo00<00?ooool0COoo002Bool2000Nool0
0`00ooooo`05ool00`00ooooo`1<ool0093oo`80023oo`03003ooooo00Goo`03003ooooo04coo`00
SOoo0`008_oo00<00?ooool01_oo00<00?ooool0Booo002;ool2000Uool00`00ooooo`07ool00`00
ooooo`1:ool008Soo`<002Ooo`03003ooooo00Ooo`03003ooooo04[oo`00Q_oo0P00:_oo00<00?oo
ool02?oo00<00?ooool0BOoo0024ool2000/ool00`00ooooo`08ool00`00ooooo`19ool0087oo`<0
02koo`03003ooooo00Woo`03003ooooo04Soo`00Oooo0P00<Ooo00<00?ooool02_oo00<00?ooool0
Aooo001lool3000cool00`00ooooo`0:ool00`00ooooo`17ool007[oo`8003Koo`03003ooooo00_o
o`03003ooooo04Koo`00N?oo0P00>?oo00<00?ooool03?oo00<00?ooool0AOoo001eool3000jool0
0`00ooooo`0<ool00`00ooooo`15ool007?oo`8003goo`03003ooooo00goo`03003ooooo04Coo`00
L?oo0`00@?oo00<00?ooool03?oo00<00?ooool0A?oo001^ool20013ool00`00ooooo`0=ool00`00
ooooo`13ool006coo`8004Goo`03003ooooo00koo`03003ooooo04;oo`00JOoo0`00Aooo00<00?oo
ool03_oo00<00?ooool0@_oo001Wool2001:ool00`00ooooo`0?ool00`00ooooo`11ool006Coo`<0
04coo`03003ooooo013oo`03003ooooo043oo`00H_oo0P00Cooo00<00?ooool04?oo00<00?ooool0
@?oo001Oool3001Aool00`00ooooo`0Aool00`00ooooo`0oool005goo`8005Coo`03003ooooo017o
o`03003ooooo03ooo`00Fooo0P00E_oo00<00?ooool04_oo00<00?ooool0?_oo001Hool3001Hool0
0`00ooooo`0Cool00`00ooooo`0mool005Koo`8005_oo`03003ooooo01?oo`03003ooooo03goo`00
Dooo0`00GOoo00<00?ooool05?oo00<00?ooool0??oo001Aool2001Pool00`00ooooo`0Eool00`00
ooooo`0kool004ooo`8006;oo`03003ooooo01Goo`03003ooooo03_oo`00C?oo0`00I?oo00<00?oo
ool05_oo00<00?ooool0>_oo001:ool2001Wool00`00ooooo`0Fool00`00ooooo`0jool004Ooo`<0
06[oo`03003ooooo01Koo`03003ooooo03Woo`00AOoo0P00KOoo00<00?ooool05ooo00<00?ooool0
>?oo0013ool2001_ool00`00ooooo`0Gool00`00ooooo`0hool0043oo`<0077oo`03003ooooo01So
o`03003ooooo03Ooo`00?_oo0P00M?oo00<00?ooool06Ooo00<00?ooool0=_oo000kool3001fool0
0`00ooooo`0Iool00`00ooooo`0fool003Woo`8007Woo`03003ooooo01[oo`03003ooooo03Goo`00
=ooo0P00Nooo00<00?ooool06_oo00<00?ooool0=Ooo000dool3001mool00`00ooooo`0Kool00`00
ooooo`0dool003;oo`80083oo`03003ooooo01coo`03003ooooo03?oo`00;ooo0`00P_oo00<00?oo
ool07?oo00<00?ooool0<ooo000]ool20025ool00`00ooooo`0Mool00`00ooooo`0bool002_oo`80
08Ooo`03003ooooo01koo`03003ooooo037oo`00:?oo0`00ROoo00<00?ooool07_oo00<00?ooool0
<Ooo000Vool2002<ool00`00ooooo`0Oool00`00ooooo`0`ool002?oo`<008koo`03003ooooo01oo
o`03003ooooo033oo`008Ooo0P00TOoo00<00?ooool08?oo00<00?ooool0;ooo000Oool2002Dool0
0`00ooooo`0Pool00`00ooooo`0^ool001coo`<009Koo`03003ooooo023oo`03003ooooo02koo`00
6_oo0P00VOoo00<00?ooool08Ooo00<00?ooool0;Ooo000Gool3002Kool00`00ooooo`0Rool00`00
ooooo`0/ool001Ooo`03003ooooo09_oo`03003ooooo02;oo`03003ooooo02coo`005ooo0P00W?oo
00<00?ooool08ooo00<00?ooool0:ooo000Fool01000ooooo`00Vooo00<00?ooool08ooo00<00?oo
ool0:ooo000Fool01@00oooooooo0000V_oo00<00?ooool09?oo00<00?ooool0:_oo000Fool00`00
ooooo`02ool00`00ooooo`2Gool00`00ooooo`0Uool00`00ooooo`0Yool001Koo`03003ooooo00?o
o`03003ooooo09Koo`03003ooooo02Goo`03003ooooo02Woo`005_oo00<00?ooool01?oo00<00?oo
ool0UOoo00<00?ooool09_oo00<00?ooool0:?oo000Fool00`00ooooo`05ool00`00ooooo`2Dool0
0`00ooooo`0Wool00`00ooooo`0Wool001Goo`03003ooooo00Ooo`03003ooooo09?oo`03003ooooo
02Ooo`03003ooooo02Ooo`005Ooo00<00?ooool02?oo00<00?ooool0T_oo00<00?ooool0:?oo00<0
0?ooool09_oo000Eool00`00ooooo`09ool00`00ooooo`2Aool00`00ooooo`0Xool00`00ooooo`0V
ool001Goo`03003ooooo00[oo`03003ooooo093oo`03003ooooo02Woo`03003ooooo02Goo`005Ooo
00<00?ooool02ooo00<00?ooool0Sooo00<00?ooool0:_oo00<00?ooool09?oo000Eool00`00oooo
o`0<ool00`00ooooo`2>ool00`00ooooo`0Zool00`00ooooo`0Tool001Goo`03003ooooo00goo`03
003ooooo08koo`03003ooooo02[oo`03003ooooo02?oo`005?oo00<00?ooool03ooo00<00?ooool0
SOoo00<00?ooool0:ooo00<00?ooool08_oo000Dool00`00ooooo`0@ool00`00ooooo`2<ool00`00
ooooo`0[ool00`00ooooo`0Rool001Coo`03003ooooo017oo`03003ooooo08_oo`03003ooooo02co
o`03003ooooo027oo`005?oo00<00?ooool04_oo00<00?ooool0R_oo00<00?ooool0;?oo00<00?oo
ool08Ooo000Dool00`00ooooo`0Cool00`00ooooo`29ool00`00ooooo`0]ool00`00ooooo`0Pool0
01Coo`03003ooooo01Coo`03003ooooo08Soo`03003ooooo02koo`03003ooooo01ooo`004ooo00<0
0?ooool05_oo00<00?ooool0Qooo00<00?ooool0;_oo00<00?ooool07ooo000Cool00`00ooooo`0G
ool00`00ooooo`26ool00`00ooooo`0_ool00`00ooooo`0Nool001?oo`03003ooooo01Ooo`03003o
oooo08Koo`03003ooooo033oo`03003ooooo01goo`004ooo00<00?ooool06?oo00<00?ooool0QOoo
00<00?ooool0<?oo00<00?ooool07Ooo000Cool00`00ooooo`0Iool00`00ooooo`24ool00`00oooo
o`0aool00`00ooooo`0Lool001?oo`03003ooooo01[oo`03003ooooo08?oo`03003ooooo037oo`03
003ooooo01coo`004_oo00<00?ooool07?oo00<00?ooool0P_oo00<00?ooool0<_oo00<00?ooool0
6ooo000Bool00`00ooooo`0Mool00`00ooooo`21ool00`00ooooo`0cool00`00ooooo`0Jool001;o
o`03003ooooo01koo`03003ooooo083oo`03003ooooo03?oo`03003ooooo01[oo`004_oo00<00?oo
ool07ooo00<00?ooool0Oooo00<00?ooool0=?oo00<00?ooool06Ooo000Bool00`00ooooo`0Pool0
0`00ooooo`1oool00`00ooooo`0dool00`00ooooo`0Hool001;oo`03003ooooo027oo`03003ooooo
07koo`03003ooooo03Coo`03003ooooo01Soo`004_oo00<00?ooool08_oo00<00?ooool0OOoo00<0
0?ooool0=Ooo00<00?ooool05ooo000Aool00`00ooooo`0Tool00`00ooooo`1lool00`00ooooo`0e
ool00`00ooooo`0Gool0017oo`03003ooooo02Goo`03003ooooo07_oo`03003ooooo03Koo`03003o
oooo01Koo`004Ooo00<00?ooool09_oo00<00?ooool0N_oo00<00?ooool0=ooo00<00?ooool05Ooo
000Aool00`00ooooo`0Wool00`00ooooo`1iool00`00ooooo`0gool00`00ooooo`0Eool0017oo`03
003ooooo02Soo`03003ooooo07Soo`03003ooooo03Soo`03003ooooo01Coo`004Ooo00<00?ooool0
:Ooo00<00?ooool0Mooo00<00?ooool0>Ooo00<00?ooool04ooo000@ool00`00ooooo`0[ool00`00
ooooo`1fool00`00ooooo`0iool00`00ooooo`0Cool0013oo`03003ooooo02coo`03003ooooo07Go
o`03003ooooo03[oo`03003ooooo01;oo`004?oo00<00?ooool0;Ooo00<00?ooool0M?oo00<00?oo
ool0>_oo00<00?ooool04_oo000@ool00`00ooooo`0^ool00`00ooooo`1cool00`00ooooo`0kool0
0`00ooooo`0Aool0013oo`03003ooooo02ooo`03003ooooo07;oo`03003ooooo03Woo`<001?oo`00
4?oo00<00?ooool0<?oo00<00?ooool0LOoo00<00?ooool0=_oo0`000_oo00<00?ooool04Ooo000@
ool00`00ooooo`0aool00`00ooooo`1`ool00`00ooooo`0cool30005ool00`00ooooo`0Aool000oo
o`03003ooooo03?oo`03003ooooo06ooo`03003ooooo033oo`<000Woo`03003ooooo013oo`003ooo
00<00?ooool0=?oo00<00?ooool0Kooo00<00?ooool0;?oo0`003?oo00<00?ooool04?oo000?ool0
0`00ooooo`0eool00`00ooooo`1^ool00`00ooooo`0Yool3000?ool00`00ooooo`0@ool000ooo`03
003ooooo03Koo`03003ooooo06goo`03003ooooo02Koo`<001;oo`03003ooooo013oo`003ooo00<0
0?ooool0=ooo00<00?ooool0K?oo00<00?ooool08_oo10005Ooo00<00?ooool04?oo000?ool00`00
ooooo`0hool00`00ooooo`1[ool00`00ooooo`0Oool3000Iool00`00ooooo`0@ool000koo`03003o
oooo03[oo`03003ooooo06[oo`03003ooooo01coo`<001coo`03003ooooo013oo`003_oo00<00?oo
ool0>ooo00<00?ooool0JOoo00<00?ooool06Ooo0`007ooo00<00?ooool04?oo000>ool00`00oooo
o`0lool00`00ooooo`1Xool00`00ooooo`0Fool3000Sool00`00ooooo`0?ool000koo`03003ooooo
03goo`03003ooooo06Ooo`03003ooooo01?oo`<002Koo`03003ooooo00ooo`003_oo00<00?ooool0
?_oo00<00?ooool0I_oo00<00?ooool04?oo0`00:Ooo00<00?ooool03ooo000>ool00`00ooooo`0o
ool00`00ooooo`1Uool00`00ooooo`0=ool3000/ool00`00ooooo`0?ool000koo`03003ooooo043o
o`03003ooooo06Coo`03003ooooo00[oo`<002ooo`03003ooooo00ooo`003Ooo00<00?ooool0@_oo
00<00?ooool0Hooo00<00?ooool01ooo0`00<_oo00<00?ooool03ooo000=ool00`00ooooo`13ool0
0`00ooooo`1Rool00`00ooooo`04ool3000eool00`00ooooo`0?ool000goo`03003ooooo04Coo`03
003ooooo067oo`04003oooooool3000iool00`00ooooo`0>ool000goo`03003ooooo04Goo`03003o
oooo063oo`@003coo`03003ooooo00koo`003Ooo00<00?ooool0A_oo00<00?ooool0GOoo0`00?ooo
00<00?ooool03_oo000=ool00`00ooooo`17ool00`00ooooo`1Iool30003ool00`00ooooo`0lool0
0`00ooooo`0>ool000coo`03003ooooo04Woo`03003ooooo05Coo`@000Koo`03003ooooo03coo`03
003ooooo00koo`003?oo00<00?ooool0B_oo00<00?ooool0D?oo0`002_oo00<00?ooool0??oo00<0
0?ooool03_oo000<ool00`00ooooo`1;ool00`00ooooo`1<ool3000=ool00`00ooooo`0lool00`00
ooooo`0>ool000coo`03003ooooo04coo`03003ooooo04Soo`<0013oo`03003ooooo03goo`03003o
oooo00goo`003?oo00<00?ooool0COoo00<00?ooool0A?oo0`004ooo00<00?ooool0?Ooo00<00?oo
ool03Ooo000<ool00`00ooooo`1>ool00`00ooooo`10ool3000Fool00`00ooooo`0mool00`00oooo
o`0=ool000coo`03003ooooo04ooo`03003ooooo03coo`<001Woo`03003ooooo03goo`03003ooooo
00goo`002ooo00<00?ooool0DOoo00<00?ooool0>?oo0`007?oo00<00?ooool0?Ooo00<00?ooool0
3Ooo000;ool00`00ooooo`1Bool00`00ooooo`0dool3000Oool00`00ooooo`0mool00`00ooooo`0=
ool000_oo`03003ooooo05?oo`03003ooooo033oo`<002;oo`03003ooooo03goo`03003ooooo00go
o`002ooo00<00?ooool0E?oo00<00?ooool0;?oo0`009Ooo00<00?ooool0?Ooo00<00?ooool03Ooo
000;ool00`00ooooo`1Eool00`00ooooo`0Xool3000Xool00`00ooooo`0nool00`00ooooo`0<ool0
00_oo`03003ooooo05Koo`03003ooooo02Coo`<002_oo`03003ooooo03koo`03003ooooo00coo`00
2_oo00<00?ooool0F?oo00<00?ooool08?oo0`00;_oo00<00?ooool0?_oo00<00?ooool03?oo000:
ool00`00ooooo`1Iool00`00ooooo`0Lool3000aool00`00ooooo`0nool00`00ooooo`0<ool000[o
o`03003ooooo05[oo`03003ooooo01Ooo`@003Coo`03003ooooo03koo`03003ooooo00coo`002_oo
00<00?ooool0Fooo00<00?ooool04ooo0`00>Ooo00<00?ooool0?Ooo00<00?ooool03?oo000:ool0
0`00ooooo`1Lool00`00ooooo`0?ool3000lool00`00ooooo`0mool00`00ooooo`0<ool000[oo`03
003ooooo05goo`03003ooooo00_oo`<003ooo`03003ooooo03koo`03003ooooo00_oo`002Ooo00<0
0?ooool0Gooo00<00?ooool01ooo0`00@_oo00<00?ooool0?_oo00<00?ooool02ooo0009ool00`00
ooooo`1Pool00`00ooooo`03ool30015ool00`00ooooo`0nool00`00ooooo`0;ool000Woo`03003o
oooo067oo`03003oo`00008004Soo`03003ooooo03koo`03003ooooo00_oo`002Ooo00<00?ooool0
H_oo00<00?ooool0BOoo00<00?ooool0?_oo00<00?ooool02ooo0009ool00`00ooooo`1Rool00`00
ooooo`17ool30010ool00`00ooooo`0;ool000Woo`03003ooooo06;oo`03003ooooo04Coo`<000;o
o`03003ooooo03koo`03003ooooo00_oo`002Ooo00<00?ooool0H_oo00<00?ooool0@?oo10001_oo
00<00?ooool0?Ooo00<00?ooool02ooo0008ool00`00ooooo`1Sool00`00ooooo`0mool3000;ool0
0`00ooooo`0mool00`00ooooo`0:ool000Soo`03003ooooo06?oo`03003ooooo03[oo`<000koo`03
003ooooo03goo`03003ooooo00[oo`002?oo00<00?ooool0Hooo00<00?ooool0=ooo0`004_oo00<0
0?ooool0??oo00<00?ooool02_oo0008ool00`00ooooo`1Sool00`00ooooo`0dool3000Fool00`00
ooooo`0kool00`00ooooo`0:ool000Soo`03003ooooo06?oo`03003ooooo033oo`@001[oo`03003o
oooo03[oo`03003ooooo00[oo`002?oo00<00?ooool0Hooo00<00?ooool0;Ooo0`007ooo00<00?oo
ool0>Ooo00<00?ooool02_oo0007ool00`00ooooo`1Tool00`00ooooo`0Zool3000Rool00`00oooo
o`0iool00`00ooooo`0:ool000Ooo`03003ooooo06Coo`03003ooooo02Ooo`<002Koo`03003ooooo
03Woo`03003ooooo00Woo`001ooo00<00?ooool0I?oo00<00?ooool09?oo0`00:_oo00<00?ooool0
>?oo00<00?ooool02Ooo0007ool00`00ooooo`1Tool00`00ooooo`0Pool4000^ool00`00ooooo`0g
ool00`00ooooo`09ool000Ooo`03003ooooo06Coo`03003ooooo01goo`<003?oo`03003ooooo03Ko
o`03003ooooo00Woo`001ooo00<00?ooool0Hooo00<00?ooool06ooo0`00=ooo00<00?ooool0=Ooo
00<00?ooool02Ooo0007ool00`00ooooo`1Sool00`00ooooo`0Hool3000jool00`00ooooo`0eool0
0`00ooooo`09ool000Koo`03003ooooo06Coo`03003ooooo01Goo`<003koo`03003ooooo03Coo`03
003ooooo00Woo`001_oo00<00?ooool0I?oo00<00?ooool04Ooo1000@_oo00<00?ooool0<ooo00<0
0?ooool02Ooo0006ool00`00ooooo`1Tool00`00ooooo`0>ool30017ool00`00ooooo`0cool00`00
ooooo`08ool000Koo`03003ooooo06Coo`03003ooooo00_oo`<004_oo`03003ooooo03;oo`03003o
oooo00Soo`001_oo00<00?ooool0I?oo00<00?ooool02?oo0`00C_oo00<00?ooool0<_oo00<00?oo
ool02?oo0006ool00`00ooooo`1Tool00`00ooooo`05ool3001Bool00`00ooooo`0aool00`00oooo
o`08ool000Goo`03003ooooo06Goo`04003oooooool4001Fool00`00ooooo`0`ool00`00ooooo`08
ool000Goo`03003ooooo06Goo`@005_oo`03003ooooo02ooo`03003ooooo00Soo`001Ooo00<00?oo
ool0Hooo0`00Gooo00<00?ooool0;_oo00<00?ooool02?oo0005ool00`00ooooo`1Pool30002ool0
0`00ooooo`1Mool00`00ooooo`0_ool00`00ooooo`07ool000Goo`03003ooooo05goo`<000Goo`03
003ooooo05koo`03003ooooo02koo`03003ooooo00Ooo`001Ooo00<00?ooool0FOoo10002?oo00<0
0?ooool0Gooo00<00?ooool0;Ooo00<00?ooool01ooo0005ool00`00ooooo`1Fool3000<ool00`00
ooooo`1Pool00`00ooooo`0/ool00`00ooooo`07ool000Coo`03003ooooo05Coo`<000ooo`03003o
oooo067oo`03003ooooo02_oo`03003ooooo00Ooo`001?oo00<00?ooool0DOoo0`004_oo00<00?oo
ool0H_oo00<00?ooool0:_oo00<00?ooool01ooo0004ool00`00ooooo`1=ool4000Eool00`00oooo
o`1Rool00`00ooooo`0Zool00`00ooooo`07ool000Coo`03003ooooo04[oo`<001Woo`03003ooooo
06?oo`03003ooooo02[oo`03003ooooo00Koo`001?oo00<00?ooool0Aooo0`007?oo00<00?ooool0
I?oo00<00?ooool0:Ooo00<00?ooool01_oo0004ool00`00ooooo`14ool3000Oool00`00ooooo`1U
ool00`00ooooo`0Xool00`00ooooo`06ool000?oo`03003ooooo04;oo`<002;oo`03003ooooo06Ko
o`03003ooooo02Ooo`03003ooooo00Koo`000ooo00<00?ooool0?_oo10009Ooo00<00?ooool0I_oo
00<00?ooool09ooo00<00?ooool01_oo0003ool00`00ooooo`0kool3000Yool00`00ooooo`1Wool0
0`00ooooo`0Vool00`00ooooo`06ool000?oo`03003ooooo03Soo`<002coo`03003ooooo06Soo`03
003ooooo02Goo`03003ooooo00Koo`000ooo00<00?ooool0=Ooo0`00;ooo00<00?ooool0JOoo00<0
0?ooool09?oo00<00?ooool01_oo0003ool00`00ooooo`0bool3000aool00`00ooooo`1[ool00`00
ooooo`0Tool00`00ooooo`05ool000;oo`03003ooooo02ooo`@003Coo`03003ooooo06_oo`03003o
oooo02Coo`03003ooooo00Goo`000_oo00<00?ooool0;?oo0`00>?oo00<00?ooool0K?oo00<00?oo
ool08ooo00<00?ooool01Ooo0002ool00`00ooooo`0Yool3000kool00`00ooooo`1]ool00`00oooo
o`0Rool00`00ooooo`05ool000;oo`03003ooooo02Koo`<003koo`03003ooooo06koo`03003ooooo
027oo`03003ooooo00Goo`000_oo00<00?ooool08ooo0`00@Ooo00<00?ooool0Kooo00<00?ooool0
8?oo00<00?ooool01Ooo0002ool00`00ooooo`0Oool40014ool00`00ooooo`1`ool00`00ooooo`0O
ool00`00ooooo`05ool000;oo`03003ooooo01coo`<004Soo`03003ooooo073oo`03003ooooo023o
o`03003ooooo00Coo`0000?oo`00ool06ooo0`00Booo00<00?ooool0LOoo00<00?ooool07ooo00<0
0?ooool01?oo00000ooo003oo`0Hool3001>ool00`00ooooo`1bool00`00ooooo`0Nool00`00oooo
o`04ool00003ool00?oo01Goo`<0057oo`03003ooooo07?oo`03003ooooo01goo`03003ooooo00Co
o`0000?oo`00ool04Ooo1000E?oo00<00?ooool0M?oo00<00?ooool07?oo00<00?ooool01?oo0000
0ooo003oo`0>ool3001Hool00`00ooooo`1dool00`00ooooo`0Lool00`00ooooo`04ool00003ool0
0?oo00_oo`<005_oo`03003ooooo07Goo`03003ooooo01_oo`03003ooooo00Coo`0000<00?ooool0
2?oo0`00G_oo00<00?ooool0M_oo00<00?ooool06_oo00<00?ooool01?oo00000`00ooooo`05ool3
001Qool00`00ooooo`1gool00`00ooooo`0Jool00`00ooooo`03ool00004003oooooool4001Tool0
0`00ooooo`1hool00`00ooooo`0Iool00`00ooooo`03ool000@006Soo`03003ooooo07Soo`03003o
oooo01Woo`03003ooooo00?oo`0000<00?ooool0JOoo00<00?ooool0NOoo00<00?ooool06?oo00<0
0?ooool00ooo00000ooo003oo`1Yool00`00ooooo`1jool00`00ooooo`0Gool00`00ooooo`03ool0
00;oo`03003ooooo06Ooo`03003ooooo07_oo`03003ooooo01Koo`03003ooooo00?oo`000ooo00<0
0?ooool0I_oo00<00?ooool0O?oo00<00?ooool05Ooo00<00?ooool00ooo0004ool2001Vool00`00
ooooo`1mool00`00ooooo`0Eool00`00ooooo`02ool000Koo`03003ooooo06?oo`03003ooooo07go
o`03003ooooo01Goo`03003ooooo00;oo`001ooo0P00Hooo00<00?ooool0O_oo00<00?ooool05?oo
00<00?ooool00_oo0009ool00`00ooooo`1Pool00`00ooooo`1oool00`00ooooo`0Cool00`00oooo
o`02ool000[oo`80063oo`03003ooooo083oo`03003ooooo01;oo`03003ooooo00;oo`003?oo00<0
0?ooool0G?oo00<00?ooool0P_oo00<00?ooool04Ooo00<00?ooool00_oo000=ool00`00ooooo`1K
ool00`00ooooo`22ool00`00ooooo`0Aool00`00ooooo`02ool000koo`8005_oo`03003ooooo08?o
o`03003ooooo013oo`03003ooooo00;oo`004?oo00<00?ooool0F?oo00<00?ooool0Q?oo00<00?oo
ool04?oo00<00?ooool00Ooo000Aool2001Hool00`00ooooo`25ool00`00ooooo`0?ool00`00oooo
o`01ool001?oo`03003ooooo05Goo`03003ooooo08Koo`03003ooooo00koo`03003ooooo007oo`00
5?oo00<00?ooool0E?oo00<00?ooool0Q_oo00<00?ooool03_oo00<00?ooool00Ooo000Eool2001D
ool00`00ooooo`27ool00`00ooooo`0=ool00`00ooooo`01ool001Ooo`03003ooooo057oo`03003o
oooo08Soo`03003ooooo00coo`03003ooooo007oo`006?oo0P00DOoo00<00?ooool0ROoo00<00?oo
ool02ooo00<00?ooool00Ooo000Jool00`00ooooo`1>ool00`00ooooo`2:ool00`00ooooo`0;ool1
0001ool1ool001_oo`8004koo`03003ooooo08_oo`03003ooooo00[oo`40007oo`7oo`007Ooo00<0
0?ooool0Booo00<00?ooool0Rooo00<00?ooool02_oo0@000Ooo0Ooo000Nool00`00ooooo`1:ool0
0`00ooooo`2<ool00`00ooooo`09ool10001ool1ool001ooo`8004[oo`03003ooooo08goo`03003o
oooo00Soo`40007oo`7oo`008Ooo00<00?ooool0Aooo00<00?ooool0S_oo00<00?ooool01ooo0@00
0Ooo0Ooo000Rool20017ool00`00ooooo`2?ool00`00ooooo`06ool10001ool1ool002Coo`03003o
oooo04Coo`03003ooooo08ooo`03003ooooo00Ooo`40007oo`009Ooo0P00A?oo00<00?ooool0T?oo
00<00?ooool01_oo0@000Ooo000Wool00`00ooooo`11ool00`00ooooo`2Aool00`00ooooo`05ool1
0001ool002Soo`03003ooooo043oo`03003ooooo09;oo`03003ooooo00Coo`40007oo`00:Ooo0P00
@?oo00<00?ooool0Tooo00<00?ooool00ooo0@000Ooo000[ool00`00ooooo`0mool00`00ooooo`2C
ool00`00ooooo`03ool10001ool002coo`8003goo`03003ooooo09Coo`03003ooooo00;oo`40007o
o`00;_oo00<00?ooool0>_oo00<00?ooool0UOoo00D00?ooooooo`00007oo`00;ooo00<00?ooool0
>Ooo00<00?ooool0U_oo00@00?ooooooo`400000<?oo0P00>Ooo00<00?ooool0Uooo00<00?ooool0
0@00000bool00`00ooooo`0eool00`00ooooo`2Iool10001ool1000003?oo`8003Goo`03003ooooo
09[oo`800000=Ooo00<00?ooool0<_oo00<00?ooool0V_oo0P00000fool2000bool00`00ooooo`2F
ool40002ool003Soo`03003ooooo02ooo`03003ooooo097oo`D000Koo`00>Ooo00<00?ooool0;_oo
00<00?ooool0SOoo10002ooo000jool2000^ool00`00ooooo`29ool4000?ool003coo`03003ooooo
02_oo`03003ooooo08Coo`D001?oo`00?Ooo0P00:ooo00<00?ooool0P?oo10006?oo000oool00`00
ooooo`0Xool00`00ooooo`1kool5000Lool0043oo`03003ooooo02Ooo`03003ooooo07Ooo`@0027o
o`00@Ooo0P009ooo00<00?ooool0Looo10009Ooo0013ool00`00ooooo`0Tool00`00ooooo`1^ool5
000Yool004Coo`8002Coo`03003ooooo06[oo`@002koo`00A_oo00<00?ooool08Ooo00<00?ooool0
IOoo1@00<_oo0017ool2000Qool00`00ooooo`1Qool4000gool004Woo`03003ooooo01koo`03003o
oooo05coo`D003_oo`00B_oo00<00?ooool07Ooo00<00?ooool0F?oo1000@?oo001;ool2000Mool0
0`00ooooo`1Dool40014ool004goo`03003ooooo01[oo`03003ooooo04ooo`D004Soo`00C_oo0P00
6_oo00<00?ooool0Booo1000COoo001@ool00`00ooooo`0Gool00`00ooooo`16ool5001Aool0057o
o`8001Ooo`03003ooooo04;oo`@005Koo`00Dooo00<00?ooool05?oo00<00?ooool0?_oo1000F_oo
001Dool00`00ooooo`0Cool00`00ooooo`0iool5001Nool005Goo`8001?oo`03003ooooo03Goo`@0
06?oo`00Eooo00<00?ooool03ooo00<00?ooool0<Ooo1@00Iooo001Hool2000?ool00`00ooooo`0]
ool4001/ool005[oo`03003ooooo00coo`03003ooooo02Soo`D0073oo`00Fooo00<00?ooool02ooo
00<00?ooool09?oo1000MOoo001Lool2000;ool00`00ooooo`0Pool4001iool005koo`03003ooooo
00Soo`03003ooooo01_oo`D007goo`00Gooo0P002?oo00<00?ooool05ooo1000P_oo001Qool00`00
ooooo`05ool00`00ooooo`0Bool50026ool006;oo`8000Goo`03003ooooo00koo`@008_oo`00I?oo
00<00?ooool00_oo00<00?ooool02_oo1000Sooo001Uool01@00oooooooo00001ooo1@00Tooo001V
ool200000ooo003oo`02ool4002Hool006Soo`D009coo`00\
\>"],
  ImageRangeCache->{{{0, 264.312}, {286.938, 0}} -> {0.0486402, -4.72903*^-5, \
0.00324458, 0.00324458}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[go2]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5609 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0580714 1.05807 -0.239461 1.05807 [
[ 0 0 0 0 ]
[ 1 .5609 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02122 .31822 m
0 .56037 L
s
0 .56037 m
.00064 .5609 L
s
.00064 .5609 m
.02183 .31878 L
s
.02183 .31878 m
.02122 .31822 L
s
.97291 0 m
.97337 .0007 L
s
.97337 .0007 m
1 .25587 L
s
1 .25587 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.02122 .31822 m
0 .56037 L
s
0 .56037 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.97291 0 m
.02122 .31822 L
s
.02183 .31878 m
.97337 .0007 L
s
.97337 .0007 m
1 .25587 L
s
1 .25587 m
.00064 .5609 L
s
.00064 .5609 m
.02183 .31878 L
s
0 0 m
1 0 L
1 .5609 L
0 .5609 L
closepath
clip
newpath
.1 .1 .6 r
.0001 w
.05287 .32788 m
.07736 .31975 L
s
.05051 .35686 m
.05287 .32788 L
s
.07736 .31975 m
.07514 .34877 L
s
.07822 .31947 m
.10287 .31129 L
s
.076 .34849 m
.07822 .31947 L
s
.07514 .34877 m
.05051 .35686 L
s
.05044 .35778 m
.07507 .34969 L
s
.04805 .38709 m
.05044 .35778 L
s
.10287 .31129 m
.10078 .34035 L
s
.10078 .34035 m
.076 .34849 L
s
.07507 .34969 m
.07282 .37905 L
s
.07593 .34941 m
.10072 .34127 L
s
.07368 .37877 m
.07593 .34941 L
s
.07282 .37905 m
.04805 .38709 L
s
.04798 .38802 m
.07275 .37997 L
s
.04556 .41768 m
.04798 .38802 L
s
.10072 .34127 m
.0986 .37067 L
s
.10158 .34098 m
.12653 .33279 L
s
.09948 .37039 m
.10158 .34098 L
s
.0986 .37067 m
.07368 .37877 L
s
.07275 .37997 m
.07047 .40968 L
s
.07361 .37969 m
.09854 .3716 L
s
.07134 .4094 m
.07361 .37969 L
s
.12653 .33279 m
.12455 .36224 L
s
.1274 .33251 m
.1525 .32427 L
s
.12543 .36196 m
.1274 .33251 L
s
.07047 .40968 m
.04556 .41768 L
s
.04549 .41861 m
.0704 .41062 L
s
.04305 .44863 m
.04549 .41861 L
s
.12455 .36224 m
.09948 .37039 L
s
.09854 .3716 m
.0964 .40135 L
s
.1525 .32427 m
.15067 .35376 L
s
.15338 .32398 m
.17864 .31568 L
s
.15155 .35347 m
.15338 .32398 L
s
.0964 .40135 m
.07134 .4094 L
s
.0704 .41062 m
.06809 .44068 L
s
.07127 .41034 m
.09633 .40229 L
s
.06897 .4404 m
.07127 .41034 L
s
.15067 .35376 m
.12543 .36196 L
s
.17864 .31568 m
.17695 .34522 L
s
.17952 .31539 m
.20494 .30705 L
s
.17784 .34494 m
.17952 .31539 L
s
.06809 .44068 m
.04305 .44863 L
s
.04297 .44957 m
.06802 .44163 L
s
.0405 .47995 m
.04297 .44957 L
s
.09633 .40229 m
.09417 .4324 L
s
.17695 .34522 m
.15155 .35347 L
s
.20494 .30705 m
.20341 .33663 L
s
.20583 .30676 m
.23141 .29836 L
s
.2043 .33634 m
.20583 .30676 L
s
.26021 .25907 m
.28598 .25052 L
s
.259 .28839 m
.26021 .25907 L
s
.09417 .4324 m
.06897 .4404 L
s
.06802 .44163 m
.06569 .47205 L
s
.0689 .44135 m
.0941 .43335 L
s
.06657 .47177 m
.0689 .44135 L
s
.20341 .33663 m
.17784 .34494 L
s
.23141 .29836 m
.23003 .32799 L
s
.23231 .29806 m
.25806 .28961 L
s
.23093 .32769 m
.23231 .29806 L
s
.28598 .25052 m
.2849 .27988 L
s
.28688 .25022 m
.3128 .24161 L
s
.28581 .27958 m
.28688 .25022 L
s
.06569 .47205 m
.0405 .47995 L
s
.04042 .4809 m
.06561 .473 L
s
.03793 .51164 m
.04042 .4809 L
s
.0941 .43335 m
.09191 .46382 L
s
.23003 .32799 m
.2043 .33634 L
s
.2849 .27988 m
.259 .28839 L
s
.25806 .28961 m
.25682 .31928 L
s
.25896 .28931 m
.28487 .28081 L
s
.25773 .31899 m
.25896 .28931 L
s
.3128 .24161 m
.31188 .27102 L
s
.31371 .24131 m
.33981 .23265 L
s
.3128 .27072 m
.31371 .24131 L
s
.09191 .46382 m
.06657 .47177 L
s
.06561 .473 m
.06325 .50379 L
s
.06649 .47273 m
.09185 .46478 L
s
.06414 .50351 m
.06649 .47273 L
s
.10063 .44778 m
.23816 .40442 L
s
.09629 .50948 m
.10063 .44778 L
s
.25682 .31928 m
.23093 .32769 L
s
.31188 .27102 m
.28581 .27958 L
s
.28487 .28081 m
.28378 .31053 L
s
.28578 .28051 m
.31186 .27195 L
s
.2847 .31023 m
.28578 .28051 L
s
.33981 .23265 m
.33904 .2621 L
s
.34072 .23235 m
.36698 .22363 L
s
.33996 .2618 m
.34072 .23235 L
s
.06325 .50379 m
.03793 .51164 L
s
.03785 .51261 m
.06318 .50476 L
s
.03532 .54371 m
.03785 .51261 L
s
.09185 .46478 m
.08963 .49561 L
s
.28378 .31053 m
.25773 .31899 L
s
.33904 .2621 m
.3128 .27072 L
s
.31186 .27195 m
.31092 .30171 L
s
.31277 .27165 m
.33902 .26303 L
s
.31184 .30141 m
.31277 .27165 L
s
.36698 .22363 m
.36637 .25312 L
s
.3679 .22333 m
.39433 .21455 L
s
.3673 .25282 m
.3679 .22333 L
s
.08963 .49561 m
.06414 .50351 L
s
.06318 .50476 m
.06079 .53592 L
s
.31092 .30171 m
.2847 .31023 L
s
.36637 .25312 m
.33996 .2618 L
s
.33902 .26303 m
.33824 .29284 L
s
.33994 .26273 m
.36635 .25405 L
s
.33917 .29254 m
.33994 .26273 L
s
.39433 .21455 m
.39388 .24409 L
s
.06079 .53592 m
.03532 .54371 L
s
.39526 .21425 m
.42186 .20542 L
s
.39481 .24378 m
.39526 .21425 L
s
.33824 .29284 m
.31184 .30141 L
s
.39388 .24409 m
.3673 .25282 L
s
.36635 .25405 m
.36574 .28391 L
s
.36728 .25375 m
.39387 .24502 L
s
.36667 .2836 m
.36728 .25375 L
s
.42186 .20542 m
.42157 .235 L
s
.42279 .20511 m
.44957 .19622 L
s
.42251 .23469 m
.42279 .20511 L
s
.23538 .46665 m
.09629 .50948 L
s
.36574 .28391 m
.33917 .29254 L
s
.42157 .235 m
.39481 .24378 L
s
.39387 .24502 m
.39341 .27492 L
s
.3948 .24471 m
.42156 .23593 L
s
.39435 .27461 m
.3948 .24471 L
s
.44957 .19622 m
.44944 .22584 L
s
.45051 .19591 m
.47746 .18697 L
s
.45038 .22553 m
.45051 .19591 L
s
.39341 .27492 m
.36667 .2836 L
s
.23816 .40442 m
.23538 .46665 L
s
.44944 .22584 m
.42251 .23469 L
s
.42156 .23593 m
.42127 .26587 L
s
.4225 .23562 m
.44944 .22678 L
s
.42221 .26556 m
.4225 .23562 L
s
.47746 .18697 m
.4775 .21663 L
s
.4784 .18665 m
.50553 .17765 L
s
.47844 .21632 m
.4784 .18665 L
s
.42127 .26587 m
.39435 .27461 L
s
.4775 .21663 m
.45038 .22553 L
s
.44944 .22678 m
.44931 .25676 L
s
.45038 .22647 m
.4775 .21756 L
s
.45026 .25645 m
.45038 .22647 L
s
.50553 .17765 m
.50573 .20735 L
s
.50648 .17733 m
.53378 .16827 L
s
.50669 .20704 m
.50648 .17733 L
s
.44931 .25676 m
.42221 .26556 L
s
.50573 .20735 m
.47844 .21632 L
s
.4775 .21756 m
.47754 .24759 L
s
.47845 .21725 m
.50574 .20829 L
s
.47849 .24728 m
.47845 .21725 L
s
.53378 .16827 m
.53416 .19802 L
s
.53474 .16795 m
.56223 .15883 L
s
.53512 .1977 m
.53474 .16795 L
s
.47754 .24759 m
.45026 .25645 L
s
.53416 .19802 m
.50669 .20704 L
s
.50574 .20829 m
.50595 .23836 L
s
.5067 .20798 m
.53417 .19896 L
s
.50691 .23805 m
.5067 .20798 L
s
.56223 .15883 m
.56277 .18862 L
s
.56319 .15851 m
.59086 .14933 L
s
.56374 .1883 m
.56319 .15851 L
s
.50595 .23836 m
.47849 .24728 L
s
.47849 .24823 m
.50596 .23931 L
s
.47854 .27863 m
.47849 .24823 L
s
.56277 .18862 m
.53512 .1977 L
s
.53417 .19896 m
.53455 .22907 L
s
.53513 .19864 m
.56279 .18956 L
s
.53552 .22876 m
.53513 .19864 L
s
.59086 .14933 m
.59158 .17916 L
s
.59183 .14901 m
.61968 .13976 L
s
.59255 .17884 m
.59183 .14901 L
s
.53455 .22907 m
.50691 .23805 L
s
.50596 .23931 m
.50617 .26976 L
s
.50692 .239 m
.53456 .23002 L
s
.50713 .26945 m
.50692 .239 L
s
.59158 .17916 m
.56374 .1883 L
s
.56279 .18956 m
.56334 .21972 L
s
.56376 .18924 m
.5916 .1801 L
s
.56432 .2194 m
.56376 .18924 L
s
.61968 .13976 m
.62058 .16964 L
s
.62065 .13944 m
.64869 .13013 L
s
.62156 .16932 m
.62065 .13944 L
s
.50617 .26976 m
.47854 .27863 L
s
.47854 .27959 m
.50617 .27072 L
s
.47858 .31037 m
.47854 .27959 L
s
.56334 .21972 m
.53552 .22876 L
s
.53456 .23002 m
.53495 .26052 L
s
.53553 .22971 m
.56336 .22067 L
s
.53592 .2602 m
.53553 .22971 L
s
.62058 .16964 m
.59255 .17884 L
s
.5916 .1801 m
.59233 .21031 L
s
.59258 .17978 m
.6206 .17058 L
s
.59331 .20999 m
.59258 .17978 L
s
.64869 .13013 m
.64977 .16005 L
s
.64967 .12981 m
.6779 .12044 L
s
.65076 .15973 m
.64967 .12981 L
s
.53495 .26052 m
.50713 .26945 L
s
.50617 .27072 m
.50639 .30155 L
s
.50714 .27041 m
.53496 .26148 L
s
.50736 .30124 m
.50714 .27041 L
s
.59233 .21031 m
.56432 .2194 L
s
.56336 .22067 m
.56392 .25121 L
s
.56434 .22036 m
.59235 .21126 L
s
.5649 .2509 m
.56434 .22036 L
s
.64977 .16005 m
.62156 .16932 L
s
.6206 .17058 m
.62151 .20083 L
s
.62159 .17026 m
.6498 .16099 L
s
.6225 .20051 m
.62159 .17026 L
s
.6779 .12044 m
.67916 .1504 L
s
.67889 .12011 m
.7073 .11068 L
s
.68015 .15007 m
.67889 .12011 L
s
.50639 .30155 m
.47858 .31037 L
s
.56392 .25121 m
.53592 .2602 L
s
.53496 .26148 m
.53535 .29235 L
s
.53593 .26116 m
.56394 .25217 L
s
.53633 .29204 m
.53593 .26116 L
s
.62151 .20083 m
.59331 .20999 L
s
.59235 .21126 m
.59309 .24184 L
s
.59334 .21094 m
.62154 .20178 L
s
.59408 .24153 m
.59334 .21094 L
s
.67916 .1504 m
.65076 .15973 L
s
.6498 .16099 m
.65089 .19129 L
s
.65079 .16067 m
.6792 .15134 L
s
.65188 .19096 m
.65079 .16067 L
s
.7073 .11068 m
.70874 .14068 L
s
.7083 .11035 m
.7369 .10086 L
s
.70974 .14035 m
.7083 .11035 L
s
.53535 .29235 m
.50736 .30124 L
s
.59309 .24184 m
.5649 .2509 L
s
.56394 .25217 m
.56451 .2831 L
s
.56492 .25186 m
.59312 .24281 L
s
.56549 .28278 m
.56492 .25186 L
s
.65089 .19129 m
.6225 .20051 L
s
.62154 .20178 m
.62246 .23241 L
s
.62253 .20146 m
.65092 .19224 L
s
.62345 .23209 m
.62253 .20146 L
s
.70874 .14068 m
.68015 .15007 L
s
.6792 .15134 m
.68047 .18168 L
s
.68019 .15102 m
.70879 .14163 L
s
.68147 .18135 m
.68019 .15102 L
s
.7369 .10086 m
.73853 .1309 L
s
.73791 .10052 m
.7667 .09097 L
s
.73954 .13057 m
.73791 .10052 L
s
.56451 .2831 m
.53633 .29204 L
s
.62246 .23241 m
.59408 .24153 L
s
.59312 .24281 m
.59386 .27378 L
s
.5941 .24249 m
.62249 .23338 L
s
.59486 .27346 m
.5941 .24249 L
s
.68047 .18168 m
.65188 .19096 L
s
.65092 .19224 m
.65203 .22292 L
s
.65192 .19192 m
.68051 .18263 L
s
.65303 .22259 m
.65192 .19192 L
s
.73853 .1309 m
.70974 .14035 L
s
.70879 .14163 m
.71025 .17201 L
s
.70979 .1413 m
.73858 .13185 L
s
.71125 .17168 m
.70979 .1413 L
s
.7667 .09097 m
.76852 .12105 L
s
.76771 .09063 m
.79671 .08101 L
s
.76953 .12072 m
.76771 .09063 L
s
.59386 .27378 m
.56549 .28278 L
s
.65203 .22292 m
.62345 .23209 L
s
.62249 .23338 m
.62342 .26439 L
s
.62348 .23306 m
.65206 .22388 L
s
.62442 .26408 m
.62348 .23306 L
s
.71025 .17201 m
.68147 .18135 L
s
.68051 .18263 m
.6818 .21336 L
s
.68151 .18231 m
.71029 .17296 L
s
.6828 .21303 m
.68151 .18231 L
s
.76852 .12105 m
.73954 .13057 L
s
.73858 .13185 m
.74023 .16227 L
s
.73959 .13151 m
.76857 .122 L
s
.74124 .16194 m
.73959 .13151 L
s
.79671 .08101 m
.79871 .11113 L
s
.79772 .08067 m
.82691 .07098 L
s
.79973 .1108 m
.79772 .08067 L
s
.62342 .26439 m
.59486 .27346 L
s
.6818 .21336 m
.65303 .22259 L
s
.65206 .22388 m
.65318 .25495 L
s
.65306 .22356 m
.68184 .21432 L
s
.65419 .25463 m
.65306 .22356 L
s
.74023 .16227 m
.71125 .17168 L
s
.71029 .17296 m
.71177 .20373 L
s
.7113 .17264 m
.74028 .16323 L
s
.71278 .2034 m
.7113 .17264 L
s
.79871 .11113 m
.76953 .12072 L
s
.76857 .122 m
.77041 .15246 L
s
.76959 .12166 m
.79877 .11208 L
s
.77143 .15213 m
.76959 .12166 L
s
.82691 .07098 m
.82911 .10115 L
s
.82794 .07064 m
.85733 .06089 L
s
.83014 .10081 m
.82794 .07064 L
s
.65318 .25495 m
.62442 .26408 L
s
.71177 .20373 m
.6828 .21303 L
s
.68184 .21432 m
.68314 .24544 L
s
.68284 .214 m
.71181 .2047 L
s
.68416 .24511 m
.68284 .214 L
s
.77041 .15246 m
.74124 .16194 L
s
.74028 .16323 m
.74194 .19404 L
s
.74129 .1629 m
.77047 .15342 L
s
.74297 .19371 m
.74129 .1629 L
s
.82911 .10115 m
.79973 .1108 L
s
.79877 .11208 m
.8008 .14259 L
s
.7998 .11175 m
.82918 .1021 L
s
.80183 .14226 m
.7998 .11175 L
s
.85733 .06089 m
.85972 .0911 L
s
.85836 .06055 m
.88795 .05073 L
s
.86076 .09076 m
.85836 .06055 L
s
.68314 .24544 m
.65419 .25463 L
s
.74194 .19404 m
.71278 .2034 L
s
.71181 .2047 m
.71331 .23586 L
s
.71283 .20437 m
.742 .19501 L
s
.71433 .23554 m
.71283 .20437 L
s
.8008 .14259 m
.77143 .15213 L
s
.77047 .15342 m
.77233 .18428 L
s
.77149 .15309 m
.80087 .14355 L
s
.77336 .18395 m
.77149 .15309 L
s
.85972 .0911 m
.83014 .10081 L
s
.82918 .1021 m
.83141 .13265 L
s
.83021 .10176 m
.8598 .09205 L
s
.83244 .13232 m
.83021 .10176 L
s
.88795 .05073 m
.89054 .08097 L
s
.88898 .05038 m
.91878 .04049 L
s
.89158 .08063 m
.88898 .05038 L
s
.71331 .23586 m
.68416 .24511 L
s
.77233 .18428 m
.74297 .19371 L
s
.742 .19501 m
.74369 .22622 L
s
.74302 .19468 m
.77239 .18525 L
s
.74471 .22589 m
.74302 .19468 L
s
.83141 .13265 m
.80183 .14226 L
s
.80087 .14355 m
.80292 .17446 L
s
.8019 .14322 m
.83148 .13362 L
s
.80396 .17412 m
.8019 .14322 L
s
.89054 .08097 m
.86076 .09076 L
s
.8598 .09205 m
.86222 .12264 L
s
.86083 .09171 m
.89062 .08193 L
s
.86326 .1223 m
.86083 .09171 L
s
.91878 .04049 m
.92157 .07078 L
s
.91982 .04015 m
.94982 .03019 L
s
.92262 .07044 m
.91982 .04015 L
s
.74369 .22622 m
.71433 .23554 L
s
.80292 .17446 m
.77336 .18395 L
s
.77239 .18525 m
.77427 .21651 L
s
.77342 .18492 m
.80299 .17543 L
s
.77531 .21618 m
.77342 .18492 L
s
.86222 .12264 m
.83244 .13232 L
s
.83148 .13362 m
.83373 .16456 L
s
.83251 .13328 m
.8623 .12361 L
s
.83477 .16423 m
.83251 .13328 L
s
.92157 .07078 m
.89158 .08063 L
s
.89062 .08193 m
.89325 .11257 L
s
.89166 .08159 m
.92166 .07174 L
s
.8943 .11222 m
.89166 .08159 L
s
.94982 .03019 m
.95282 .06052 L
s
.77427 .21651 m
.74471 .22589 L
s
.83373 .16456 m
.80396 .17412 L
s
.80299 .17543 m
.80507 .20673 L
s
.80403 .1751 m
.8338 .16554 L
s
.80612 .2064 m
.80403 .1751 L
s
.89325 .11257 m
.86326 .1223 L
s
.8623 .12361 m
.86475 .1546 L
s
.86334 .12327 m
.89333 .11353 L
s
.8658 .15426 m
.86334 .12327 L
s
.95282 .06052 m
.92262 .07044 L
s
.92166 .07174 m
.92449 .10242 L
s
.92271 .07139 m
.95292 .06148 L
s
.92555 .10207 m
.92271 .07139 L
s
.80507 .20673 m
.77531 .21618 L
s
.77537 .21716 m
.80514 .20772 L
s
.77728 .24883 m
.77537 .21716 L
s
.86475 .1546 m
.83477 .16423 L
s
.8338 .16554 m
.83609 .19689 L
s
.83485 .1652 m
.86483 .15558 L
s
.83714 .19655 m
.83485 .1652 L
s
.92449 .10242 m
.8943 .11222 L
s
.89333 .11353 m
.89599 .14457 L
s
.89438 .11319 m
.92458 .10338 L
s
.89705 .14423 m
.89438 .11319 L
s
.95292 .06148 m
.95595 .0922 L
s
.83609 .19689 m
.80612 .2064 L
s
.80514 .20772 m
.80725 .23943 L
s
.80618 .20739 m
.83616 .19787 L
s
.8083 .2391 m
.80618 .20739 L
s
.89599 .14457 m
.8658 .15426 L
s
.86483 .15558 m
.86732 .18697 L
s
.86588 .15524 m
.89607 .14555 L
s
.86838 .18664 m
.86588 .15524 L
s
.95595 .0922 m
.92555 .10207 L
s
.92458 .10338 m
.92745 .13446 L
s
.92564 .10304 m
.95605 .09317 L
s
.92851 .13412 m
.92564 .10304 L
s
.80725 .23943 m
.77728 .24883 L
s
.77734 .24982 m
.80731 .24043 L
s
.77928 .2819 m
.77734 .24982 L
s
.86732 .18697 m
.83714 .19655 L
s
.83616 .19787 m
.83847 .22963 L
s
.83721 .19754 m
.8674 .18796 L
s
.83953 .2293 m
.83721 .19754 L
s
.92745 .13446 m
.89705 .14423 L
s
.89607 .14555 m
.89877 .17699 L
s
.89713 .14521 m
.92754 .13544 L
s
.89983 .17665 m
.89713 .14521 L
s
.95605 .09317 m
.95912 .12429 L
s
.83847 .22963 m
.8083 .2391 L
s
.80731 .24043 m
.80945 .27255 L
s
.80836 .2401 m
.83855 .23063 L
s
.81051 .27222 m
.80836 .2401 L
s
.89877 .17699 m
.86838 .18664 L
s
.8674 .18796 m
.86992 .21977 L
s
.86845 .18763 m
.89885 .17798 L
s
.87098 .21943 m
.86845 .18763 L
s
.95912 .12429 m
.92851 .13412 L
s
.92754 .13544 m
.93044 .16693 L
s
.9286 .1351 m
.95922 .12527 L
s
.93151 .16659 m
.9286 .1351 L
s
.80945 .27255 m
.77928 .2819 L
s
.86992 .21977 m
.83953 .2293 L
s
.83855 .23063 m
.84089 .26281 L
s
.8396 .2303 m
.87 .22077 L
s
.84195 .26248 m
.8396 .2303 L
s
.93044 .16693 m
.89983 .17665 L
s
.89885 .17798 m
.90158 .20983 L
s
.89992 .17764 m
.93053 .16793 L
s
.90266 .2095 m
.89992 .17764 L
s
.95922 .12527 m
.96234 .15681 L
s
.84089 .26281 m
.81051 .27222 L
s
.90158 .20983 m
.87098 .21943 L
s
.87 .22077 m
.87255 .253 L
s
.87106 .22044 m
.90167 .21084 L
s
.87362 .25266 m
.87106 .22044 L
s
.96234 .15681 m
.93151 .16659 L
s
.93053 .16793 m
.93348 .19983 L
s
.93161 .16759 m
.96244 .1578 L
s
.93456 .19949 m
.93161 .16759 L
s
.87255 .253 m
.84195 .26248 L
s
.93348 .19983 m
.90266 .2095 L
s
.90167 .21084 m
.90444 .24312 L
s
.90274 .2105 m
.93357 .20084 L
s
.90552 .24278 m
.90274 .2105 L
s
.96244 .1578 m
.9656 .18975 L
s
.90444 .24312 m
.87362 .25266 L
s
.9656 .18975 m
.93456 .19949 L
s
.93357 .20084 m
.93655 .23316 L
s
.93465 .2005 m
.96569 .19076 L
s
.93764 .23283 m
.93465 .2005 L
s
.93655 .23316 m
.90552 .24278 L
s
.96569 .19076 m
.9689 .22314 L
s
.9689 .22314 m
.93764 .23283 L
s
.93773 .23385 m
.969 .22416 L
s
.94076 .26661 m
.93773 .23385 L
s
.969 .22416 m
.97224 .25698 L
s
.97224 .25698 m
.94076 .26661 L
s
0 g
.25 Mabswid
.97291 0 m
.97337 .0007 L
s
.97337 .0007 m
1 .25587 L
s
1 .25587 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.02122 .31822 m
0 .56037 L
s
0 .56037 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.97291 0 m
.02122 .31822 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 161.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000XA000`40n007h00Ooooo5_oo0P002Ooo
003ooolCool300000ooo003oo`08ool00?oooa3oo`<000Coo`03003ooooo00Ooo`00oooo3Ooo0`00
1ooo00<00?ooool01ooo003oool:ool3000:ool00`00ooooo`07ool00?ooo`Ooo`<000koo`03003o
oooo00Koo`00oooo1?oo0`004Ooo00<00?ooool01_oo003oool1ool3000Dool00`00ooooo`06ool0
0?goo`<001Ooo`03003ooooo00Koo`00n_oo0`004Ooo0aSC1_oo00<00?ooool01_oo003gool3000@
ool46=<2ool00aSCooooo`04ool00`00ooooo`06ool00?Coo`<0013oo`<Hd`Koo`036=?ooooo00Co
o`03003ooooo00Koo`00lOoo0`004Ooo0aSC2?oo00<Hdoooool01?oo00<00?ooool01_oo003^ool3
000@ool46=<2ool00aSCooooo`06ool00aSCooooo`04ool00`00ooooo`06ool00>_oo`<0013oo`<H
d`Koo`036=?ooooo00Ooo`036=?ooooo00Coo`03003ooooo00Goo`00j?oo0`004Ooo0aSC2?oo00<H
doooool01ooo00<Hdoooool01?oo00<00?ooool01Ooo003Uool3000@ool46=<2ool00aSCooooo`06
ool26=<8ool00aSCooooo`04ool00`00ooooo`05ool00>;oo`<000ooo`@Hd`Koo`036=?ooooo00Oo
o`036=?ooooo00Goo`8Hd`Koo`03003ooooo00Goo`00gooo0`003ooo0aSC00?ooaSC6=<01ooo00<H
doooool01ooo00<Hdoooool00_oo1ASC1_oo00<00?ooool01Ooo003Lool3000@ool26=<4ool26=<7
ool26=<8ool00aSCoolHd`046=<2ool00aSCooooo`04ool00`00ooooo`05ool00=Woo`<0013oo`<H
d`Koo`8Hd`Soo`036=?ooooo00Goo`@Hd`Koo`036=?ooooo00Coo`03003ooooo00Goo`00e_oo0`00
4?oo0aSC00?ooaSCool01_oo0QSC2?oo00<Hdoooool00_oo1ASC2?oo00<Hdoooool01?oo00<00?oo
ool01Ooo003Cool3000@ool36=<4ool00aSCooooo`06ool00aSCooooo`06ool00aSCoolHd`046=<2
ool00aSCooooo`06ool00aSCooooo`04ool00`00ooooo`05ool00=3oo`<0013oo`<Hd`Ooo`036=?o
oooo00Koo`036=?ooooo00Goo`@Hd`Koo`036=?ooooo00Koo`036=?ooooo00Goo`03003ooooo00Co
o`00cOoo0`004?oo0aSC00?ooaSCool01ooo00<Hdoooool01_oo00<Hdoooool00_oo0aSC00?ooaSC
ool01ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<00?ooool01?oo003:ool3000Aool26=<4ool0
0aSCooooo`06ool00aSCooooo`06ool00aSCoolHd`026=<4ool00aSCooooo`06ool26=<7ool00aSC
ooooo`05ool00`00ooooo`04ool00<Ooo`<0013oo`@Hd`Koo`036=?ooooo00Koo`036=?ooooo00Go
o`<Hd`Ooo`036=?ooooo00Koo`8Hd`Koo`8Hd`Ooo`03003ooooo00Coo`00a?oo0`004?oo0aSC00?o
oaSC6=<01ooo00<Hdoooool01_oo00<Hdoooool00_oo0aSC00?ooaSCool01ooo00<Hdoooool01_oo
0QSC0ooo1ASC1ooo00<00?ooool01?oo0031ool3000Aool26=<4ool26=<7ool26=<7ool00aSCoolH
d`026=<4ool00aSCooooo`07ool00aSCooooo`05ool26=<00ooo6=<Hd`026=<2ool00aSCooooo`05
ool00`00ooooo`04ool00;koo`<0017oo`<Hd`Koo`8Hd`Ooo`8Hd`Koo`<Hd`Ooo`036=?ooooo00Oo
o`036=?ooooo00Coo`@Hd`Koo`036=?ooooo00Goo`03003ooooo00Coo`00^ooo0`004Ooo0aSC00?o
oaSCool01_oo0QSC1ooo0QSC0ooo0aSC00?ooaSCool01ooo00<Hdoooool01ooo00@Hdoooooooo`HH
d`Ooo`036=?ooooo00Goo`03003ooooo00Coo`00^?oo0`004_oo0QSC1?oo00<Hdoooool01_oo00<H
doooool01Ooo0QSC00?ooaSC6=<01?oo00<Hdoooool01ooo00<Hdoooool01_oo00<Hdooo6=<00aSC
0_oo0QSC1ooo00<Hdoooool01Ooo00<00?ooool01?oo002eool3000@ool56=<6ool00aSCooooo`06
ool00aSCooooo`04ool46=<6ool00aSCooooo`07ool00aSCooooo`05ool36=<6ool26=<8ool00aSC
ooooo`05ool00`00ooooo`03ool00;;oo`<000ooo`@Hd`;oo`8Hd`Ooo`036=?ooooo00Koo`046=?o
ooooool36=<00ooo6=<Hd`07ool00aSCooooo`07ool00aSCooooo`02ool36=<00ooo6=?oo`06ool2
6=<8ool00aSCooooo`05ool00`00ooooo`03ool00:ooo`<000ooo`<Hd`Koo`8Hd`Ooo`8Hd`Ooo`04
6=?ooaSC6=<4ool26=<8ool00aSCooooo`06ool00aSCoolHd`026=<4ool00aSCooooo`05ool00aSC
oolHd`07ool00aSCooooo`05ool00`00ooooo`03ool00:coo`<000ooo`<Hd`03oolHdooo00Koo`8H
d`Ooo`8Hd`Goo`@Hd`Koo`8Hd`Soo`036=?ooooo00Goo`<Hd`Ooo`036=?ooooo00Koo`8Hd`Ooo`03
6=?ooooo00Goo`03003ooooo00?oo`00ZOoo0`004?oo0QSC1?oo00<Hdoooool01Ooo0QSC1ooo0QSC
00?ooaSC6=<00aSC00?ooaSCool01_oo0QSC2?oo00<Hdoooool00_oo0aSC00?ooaSCool01ooo00<H
doooool01_oo0QSC1Ooo0aSC1ooo00<00?ooool00ooo002Vool3000@ool36=<6ool00aSCooooo`06
ool00aSCooooo`04ool66=<4ool00aSCooooo`06ool00aSCooooo`06ool00aSCoolHd`026=<4ool0
0aSCooooo`06ool26=<7ool26=<00ooo6=<Hd`036=<00ooo6=?oo`06ool00`00ooooo`03ool00:?o
o`<0013oo`<Hd`03oolHdooo00Koo`036=?ooooo00Koo`046=?oooooool76=<6ool00aSCooooo`06
ool00aSCooooo`05ool36=<7ool00aSCooooo`06ool26=<6ool66=<4ool00aSCooooo`05ool00`00
ooooo`03ool00:3oo`<0017oo`8Hd`Coo`036=?ooooo00Goo`8Hd`Ooo`036=?ooaSC00<Hd`;oo`8H
d`Ooo`036=?ooooo00Koo`036=?ooooo00;oo`<Hd`03oolHdooo00Ooo`036=?ooooo00Koo`8Hd`?o
o`LHd`Koo`036=?ooooo00Goo`03003ooooo00?oo`00WOoo0`004?oo11SC1_oo00<Hdoooool01Ooo
0QSC1_oo0aSC1_oo0QSC1ooo0QSC1ooo00<Hdooo6=<00QSC1?oo00<Hdoooool01_oo0QSC1ooo0QSC
00?ooaSC6=<00aSC00?ooaSC6=<01ooo00<Hdoooool01Ooo00<00?ooool00ooo002Jool3000@ool3
6=<00ooo6=<Hd`07ool00aSCooooo`05ool26=<3ool56=<7ool26=<7ool26=<6ool36=<7ool00aSC
ooooo`06ool26=<6ool66=<4ool26=<8ool00aSCooooo`04ool00`00ooooo`03ool009Ooo`<0017o
o`8Hd`Coo`8Hd`Ooo`036=?ooooo00Goo`8Hd`03oolHdaSC008Hd`;oo`036=?ooooo00Goo`8Hd`Oo
o`8Hd`?oo`<Hd`03oolHdooo00Ooo`036=?ooooo00Koo`8Hd`?oo`LHd`Koo`8Hd`Soo`036=?ooooo
00Goo`03003ooooo00;oo`00U?oo0`004?oo11SC1_oo0QSC1ooo00<Hdoooool01?oo11SC1_oo00<H
doooool01_oo00<Hdoooool01Ooo0QSC00?ooaSC6=<01?oo00<Hdoooool01_oo0QSC1ooo0QSC00?o
oaSC6=<00QSC0_oo0QSC1ooo0QSC2?oo00<Hdoooool01Ooo00<00?ooool00_oo002Aool3000?ool4
6=<2ool00aSCooooo`05ool26=<7ool011SCoooooooo0aSC00?ooaSC6=<01ooo00<Hdoooool01_oo
00<Hdoooool00ooo1ASC1_oo00<Hdoooool01_oo0QSC1_oo11SC1_oo0QSC2?oo00<Hdoooool01_oo
00<Hdoooool01Ooo00<00?ooool00_oo002>ool3000?ool36=<6ool00aSCooooo`06ool00aSCoooo
o`05ool011SCoolHdaSC1?oo0QSC1ooo00<Hdoooool01_oo00<Hdooo6=<011SC00?ooaSC6=<01ooo
00<Hdoooool01_oo0QSC0ooo1QSC1ooo0QSC2?oo00<Hdoooool01Ooo0QSC1ooo00<00?ooool00_oo
002<ool2000?ool36=<00ooo6=?oo`06ool00aSCooooo`06ool00aSCooooo`03ool46=<6ool26=<7
ool00aSCooooo`05ool56=<4ool26=<8ool00aSCooooo`05ool26=<00ooo6=<Hd`026=<2ool26=<7
ool26=<8ool00aSCooooo`02ool36=<00ooo6=?oo`06ool00`00ooooo`02ool008Woo`<000ooo`8H
d`Coo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC00@Hd`03oolHdooo00Koo`8Hd`Ooo`03
6=?ooooo00;oo`HHd`Koo`8Hd`Soo`036=?ooooo00Coo`@Hd`Koo`8Hd`Soo`036=?ooooo00Koo`03
6=?ooaSC008Hd`Coo`036=?ooooo00Goo`03003ooooo00;oo`00Q_oo0`003ooo0aSC1_oo00<Hdooo
ool01Ooo00<Hdoooool01_oo11SC1?oo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo6=<011SC
0_oo00<Hdoooool01Ooo0QSC2?oo00@Hdoooooooo`@Hd`03oolHdooo00Koo`8Hd`Soo`036=?ooooo
00Goo`@Hd`Koo`036=?ooooo00Goo`03003ooooo00;oo`00Pooo0`003ooo0aSC00?ooaSCool01_oo
00<Hdoooool01Ooo00<Hdoooool01?oo11SC1_oo00<Hdoooool01_oo00<Hdoooool01?oo11SC1_oo
00<Hdoooool01_oo00<Hdoooool01_oo00<Hdooo6=<00QSC1?oo00<Hdoooool01Ooo0QSC2?oo00<H
doooool00_oo0aSC00?ooaSC6=<01ooo00<Hdoooool01Ooo00<00?ooool00_oo0020ool3000@ool2
6=<4ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`046=<2ool00aSCooooo`05ool00aSC
ooooo`06ool011SCoooooooo0aSC00?ooaSCool01ooo00<Hdoooool01_oo00<Hdoooool01Ooo0aSC
1ooo00<Hdoooool01_oo00<Hdoooool01_oo00<Hdooo6=<00QSC1?oo0QSC2?oo00<Hdoooool01?oo
00<00?ooool00_oo001mool3000?ool46=<6ool00aSCooooo`05ool00aSCooooo`04ool46=<6ool0
0aSCooooo`05ool00aSCooooo`06ool011SCoolHdaSC1?oo00<Hdoooool01_oo00<Hdoooool01_oo
00<Hdoooool00_oo0aSC00?ooaSCool01ooo00<Hdoooool01_oo00<Hdoooool01?oo11SC1ooo0QSC
2?oo00<Hdoooool01Ooo00<00?ooool00Ooo001jool3000>ool46=<2ool00aSCooooo`05ool00aSC
ooooo`05ool011SCoooooooo1ASC2?oo00<Hdoooool01Ooo00<Hdoooool01Ooo0aSC1_oo00<Hdooo
ool01_oo0QSC1ooo00<Hdooo6=<00QSC1?oo00<Hdoooool01_oo00<Hdoooool01_oo00<Hdoooool0
1ASC00?ooaSCool01ooo0QSC2?oo00<Hdoooool01Ooo00<00?ooool00Ooo001gool3000>ool36=<6
ool00aSCooooo`05ool00aSCooooo`05ool00aSCoolHd`036=<2ool00aSCooooo`06ool00aSCoooo
o`05ool00aSCooooo`02ool36=<00ooo6=?oo`06ool00aSCooooo`06ool26=<5ool46=<7ool00aSC
ooooo`06ool00aSCooooo`05ool66=<4ool00aSCooooo`07ool00aSCooooo`06ool00aSCooooo`05
ool00`00ooooo`01ool007Coo`<000koo`<Hd`03oolHdooo00Koo`036=?ooooo00Goo`036=?ooooo
00Coo`<Hd`Koo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooaSC008Hd`Coo`036=?ooooo00Ko
o`036=?ooooo00Goo`8Hd`03oolHdaSC00<Hd`03oolHdooo00Ooo`036=?ooooo00Koo`036=?ooooo
00;oo`HHd`Ooo`036=?ooooo00Ooo`036=?ooooo00Goo`8Hd`Ooo`03003ooooo007oo`00LOoo0`00
3ooo0QSC1?oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdoooooooo`<Hd`03oolHdooo00Koo`03
6=?ooooo00Koo`036=?ooooo00?oo`@Hd`Ooo`036=?ooooo00Koo`036=?ooooo00Goo`DHd`Coo`03
6=?ooooo00Koo`8Hd`Ooo`036=?ooaSC00DHd`03oolHdooo00Ooo`036=?ooooo00Ooo`036=?ooooo
00;oo`DHd`Ooo`03003ooooo007oo`00K_oo0`003ooo0aSC1_oo00<Hdoooool01Ooo00<Hdoooool0
1Ooo00@Hdooo6=<Hd`Coo`036=?ooooo00Goo`8Hd`Ooo`036=?ooaSC00@Hd`03oolHdooo00Ooo`03
6=?ooooo00Koo`036=?ooooo00?oo`DHd`Koo`036=?ooooo00Koo`8Hd`Koo`HHd`Coo`036=?ooooo
00Ooo`036=?ooooo00Koo`036=?ooaSC00@Hd`;oo`036=?ooooo00Goo`03003ooooo007oo`00Jooo
0`003ooo0aSC00?ooaSCool01_oo00<Hdoooool01Ooo00<Hdoooool00ooo11SC1_oo00<Hdoooool0
1Ooo0QSC1_oo1ASC1?oo00<Hdoooool01_oo00<Hdoooool01_oo00<Hdooo6=<00aSC0_oo0QSC1ooo
00<Hdoooool01_oo0QSC0ooo1QSC1ooo00<Hdoooool01ooo00<Hdoooool01Ooo11SC1_oo00<Hdooo
ool01Ooo00<00?ooool00Ooo001Xool3000@ool26=<4ool00aSCooooo`05ool00aSCooooo`05ool0
0aSCoolHd`046=<00ooo6=?oo`06ool00aSCooooo`05ool26=<3ool66=<6ool00aSCooooo`06ool0
0aSCooooo`05ool36=<6ool26=<7ool26=<7ool26=<00ooo6=<Hd`026=<2ool00aSCooooo`06ool0
0aSCooooo`07ool00aSCooooo`02ool36=<00ooo6=?oo`07ool00aSCooooo`05ool00`00ooooo`01
ool006Goo`<000ooo`@Hd`Koo`036=?ooooo00Goo`036=?ooooo00Coo`DHd`Coo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`03oolHdaSC008Hd`;oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?o
oooo00;oo`DHd`Ooo`8Hd`Ooo`8Hd`Koo`@Hd`Koo`036=?ooooo00Ooo`036=?ooooo00Koo`036=?o
oaSC008Hd`Coo`036=?ooooo00Koo`036=?ooooo00Goo`03003ooooo007oo`00H_oo0`003_oo11SC
0_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdoooooooo`HHd`Koo`036=?ooooo00Goo`036=?o
oooo00Coo`@Hd`Koo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooaSC00@Hd`;oo`036=?ooooo
00Goo`8Hd`Ooo`8Hd`?oo`<Hd`03oolHdaSC00Ooo`036=?ooooo00Ooo`036=?ooooo00Goo`<Hd`Oo
o`036=?ooooo00Ooo`036=?ooooo00Goo`40007oo`7oo`00Gooo0`003_oo0aSC1_oo00<Hdoooool0
1Ooo00<Hdoooool01Ooo00<Hdooo6=<00aSC0_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdooo
ooooo`<Hd`03oolHdaSC00Ooo`036=?ooooo00Koo`036=?ooooo00Coo`@Hd`Koo`036=?ooooo00Ko
o`036=?ooooo00Goo`8Hd`03oolHdaSC00Coo`8Hd`Ooo`036=?ooooo00Ooo`036=?ooooo00;oo`<H
d`03oolHdooo00Ooo`036=?ooooo00Ooo`036=?ooooo00Goo`40007oo`7oo`00G?oo0`003_oo0aSC
00?ooaSCool01_oo00<Hdoooool01Ooo00<Hdoooool01?oo0aSC1_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo00@Hdooo6=<Hd`Coo`8Hd`Ooo`036=?ooooo00Koo`046=?oooooool36=<00ooo6=?oo`07
ool00aSCooooo`06ool00aSCooooo`04ool46=<6ool26=<8ool00aSCooooo`06ool00aSCoolHd`02
6=<4ool00aSCooooo`06ool00aSCooooo`07ool00aSCooooo`05ool10001ool1ool005Woo`<000oo
o`8Hd`Coo`036=?ooooo00Goo`036=?ooooo00Goo`046=?oooooool36=<00ooo6=?oo`06ool00aSC
ooooo`05ool00aSCooooo`03ool46=<6ool26=<7ool00aSCooooo`06ool011SCoolHdaSC1?oo00<H
doooool01_oo00<Hdoooool01_oo00@Hdoooooooo`<Hd`;oo`036=?ooooo00Goo`8Hd`Soo`036=?o
oooo00Goo`<Hd`Ooo`036=?ooooo00Ooo`036=?ooooo00Koo`036=?ooooo00Goo`40007oo`7oo`00
E_oo0`003_oo11SC1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdooo6=<Hd`Coo`036=?ooooo
00Goo`036=?ooooo00Goo`036=?ooaSC00@Hd`03oolHdooo00Koo`8Hd`Ooo`036=?ooooo00Coo`@H
d`Koo`036=?ooooo00Koo`036=?ooooo00Koo`046=?ooaSC6=<5ool00aSCooooo`05ool26=<8ool0
0aSCooooo`02ool36=<00ooo6=?oo`07ool00aSCooooo`07ool00aSCooooo`05ool26=<7ool10001
ool1ool005?oo`<000goo`@Hd`;oo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00?oo`@H
d`Koo`036=?ooooo00Goo`036=?ooooo00Goo`@Hd`Coo`036=?ooooo00Koo`036=?ooooo00Goo`03
6=?ooooo00DHd`03oolHdooo00Koo`036=?ooooo00Koo`036=?ooooo00Coo`@Hd`Ooo`036=?ooooo
00Koo`036=?ooooo00Koo`036=?ooaSC008Hd`Coo`036=?ooooo00Koo`8Hd`Soo`036=?ooooo00;o
o`<Hd`03oolHdooo00Koo`40007oo`7oo`00D?oo0`003_oo0QSC1_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo00<Hdooo6=<00aSC0_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool00ooo11SC
1_oo00<Hdoooool01_oo00<Hdoooool01Ooo1ASC1?oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool0
11SC2ooo00<Hdoooool01_oo00<Hdoooool01?oo11SC1ooo00<Hdoooool01ooo00<Hdoooool01_oo
00<Hdooo6=<00QSC1?oo00<Hdoooool01Ooo0@000Ooo0Ooo001=ool3000@ool26=<7ool00aSCoooo
o`05ool00aSCooooo`04ool36=<6ool00aSCooooo`05ool00aSCooooo`05ool00aSCoolHd`036=<2
ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`03ool46=<7ool00aSCooooo`05ool26=<6
ool46=<?ool00aSCooooo`06ool00aSCooooo`056=<00ooo6=?oo`07ool00aSCooooo`07ool00aSC
ooooo`04ool46=<7ool00aSCooooo`05ool10001ool1ool004[oo`<000ooo`@Hd`03oolHdooo00Ko
o`036=?ooooo00Goo`046=?oooooool56=<7ool00aSCooooo`05ool00aSCooooo`04ool36=<6ool0
0aSCooooo`05ool26=<7ool00aSCoolHd`036=<2ool00aSCooooo`06ool00aSCooooo`05ool26=<3
ool36=<Cool00aSCooooo`06ool56=<4ool00aSCooooo`07ool00aSCooooo`06ool00aSCooooo`04
6=<2ool00aSCooooo`06ool00aSCooooo`05ool10001ool1ool004Ooo`<000koo`@Hd`Goo`036=?o
oooo00Goo`036=?ooooo00Goo`036=?ooaSC00<Hd`;oo`036=?ooooo00Goo`036=?ooooo00Goo`04
6=?oooooool36=<00ooo6=?oo`06ool00aSCooooo`05ool26=<6ool36=<6ool00aSCooooo`06ool0
0aSCooooo`05ool26=<00ooo6=<Hd`0Fool00aSCooooo`04ool46=<7ool00aSCooooo`07ool00aSC
ooooo`06ool36=<6ool00aSCooooo`06ool00aSCooooo`06ool10001ool004Coo`<000ooo`8Hd`03
oolHdaSC00Koo`036=?ooooo00Goo`036=?ooooo00?oo`@Hd`Koo`036=?ooooo00Coo`8Hd`Ooo`04
6=?ooaSC6=<4ool00aSCooooo`05ool00aSCooooo`05ool26=<3ool36=<00ooo6=?oo`06ool00aSC
ooooo`06ool00aSCooooo`04ool46=<Hool00aSCooooo`046=<2ool00aSCooooo`06ool00aSCoooo
o`07ool00aSCooooo`04ool36=<8ool00aSCooooo`07ool00aSCooooo`05ool10001ool0047oo`<0
013oo`8Hd`?oo`8Hd`Koo`036=?ooooo00Goo`036=?ooaSC00@Hd`03oolHdooo00Koo`036=?ooooo
00Coo`8Hd`Goo`@Hd`Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`03oolHdaSC00Coo`036=?o
oooo00Goo`036=?ooooo00Koo`046=?oooooool36=<Lool36=<6ool00aSCooooo`07ool00aSCoooo
o`06ool00aSCooooo`046=<;ool00aSCooooo`07ool00aSCooooo`05ool10001ool003koo`<000oo
o`@Hd`Goo`8Hd`Koo`036=?ooooo00Coo`DHd`Coo`036=?ooooo00Goo`036=?ooooo00Coo`8Hd`03
oolHdaSC008Hd`;oo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00?oo`DHd`Koo`036=?o
oooo00Goo`8Hd`Ooo`046=?ooaSC6=<Oool00aSCooooo`06ool00aSCooooo`07ool00aSCooooo`05
ool46=<@ool00aSCooooo`06ool00aSCooooo`05ool10001ool003_oo`<000koo`@Hd`;oo`036=?o
oooo00Coo`8Hd`Koo`046=?oooooool66=<6ool00aSCooooo`04ool26=<5ool46=<6ool00aSCoooo
o`05ool00aSCooooo`05ool00aSCoolHd`046=<00ooo6=<Hd`07ool00aSCooooo`05ool26=<6ool3
6=<Qool00aSCooooo`06ool00aSCooooo`07ool00aSCooooo`02ool36=<Dool00aSCooooo`06ool0
0aSCooooo`04ool20001ool003Soo`<000ooo`8Hd`Koo`036=?ooooo00Coo`036=?ooooo00Goo`03
6=?ooaSC00<Hd`;oo`036=?ooooo00Goo`036=?ooooo00Coo`8Hd`?oo`8Hd`[oo`036=?ooooo00Go
o`036=?ooooo00Goo`@Hd`Coo`8Hd`Ooo`036=?ooooo00Goo`8Hd`?oo`<HdbCoo`036=?ooooo00Oo
o`036=?ooooo00Koo`036=?ooaSC008HdaOoo`036=?ooooo00Coo`<Hd`?oo`<000?oo`00=Ooo0`00
4_oo00<Hdoooool01Ooo00<Hdoooool01?oo00<Hdoooool00ooo11SC1_oo00<Hdoooool01Ooo00<H
doooool01?oo0QSC00?ooaSC6=<03?oo00<Hdoooool01Ooo00<Hdoooool00ooo11SC1_oo0QSC1ooo
00<Hdoooool01Ooo0QSC00?ooaSC6=<09ooo00<Hdoooool01ooo00<Hdoooool01Ooo0aSC6_oo00<H
doooool011SC0_oo10001_oo000bool3000Eool00aSCooooo`05ool00aSCooooo`04ool00aSCoolH
d`046=<00ooo6=?oo`06ool00aSCooooo`05ool00aSCooooo`03ool46=<>ool00aSCooooo`05ool0
0aSCoolHd`036=<2ool00aSCooooo`05ool26=<7ool00aSCooooo`03ool56=<Yool00aSCooooo`07
ool00aSCooooo`02ool36=<Mool36=<3ool3000:ool002ooo`<001Soo`036=?ooooo00Coo`8Hd`Ko
o`@Hd`Coo`036=?ooooo00Goo`036=?ooooo00Goo`046=?oooooool26=<Bool00aSCooooo`04ool3
6=<6ool00aSCooooo`05ool26=<7ool00aSCoolHd`036=<_ool00aSCooooo`06ool00aSCoolHd`02
6=<Sool3000=ool002coo`<001_oo`036=?ooooo00Coo`8Hd`Goo`<Hd`Koo`036=?ooooo00Goo`03
6=?ooooo00Goo`046=?ooaSC6=<Dool011SCoooooooo0aSC00?ooaSCool01_oo00<Hdoooool01Ooo
0QSC1_oo0aSC<ooo00<Hdoooool01Ooo0aSC8_oo10004?oo000Yool3000Nool00aSCooooo`04ool2
6=<00ooo6=<Hd`026=<00ooo6=?oo`06ool00aSCooooo`05ool00aSCooooo`03ool46=<Fool011SC
oolHdaSC1?oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC0ooo0aSC=_oo00<Hdoooool00_oo0aSC
8_oo0`005?oo000Vool3000Qool00aSCooooo`03ool46=<5ool00aSCooooo`05ool00aSCooooo`05
ool00aSCoolHd`036=<Jool26=<6ool00aSCooooo`05ool00aSCooooo`05ool26=<00ooo6=<Hd`0i
ool00aSCoolHd`026=<Rool3000Gool002?oo`<002Coo`046=?oooooool26=<00ooo6=<Hd`06ool0
0aSCooooo`05ool00aSCooooo`04ool36=<Nool00aSCooooo`05ool00aSCooooo`05ool00aSCoooo
o`04ool46=<kool26=<Rool3000Jool0023oo`<002Ooo`046=?ooaSC6=<3ool26=<6ool00aSCoooo
o`05ool011SCoooooooo0aSC8Ooo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdoooooooo`<Hdeoo
o`@001goo`007Ooo0`00:?oo11SC1Ooo0QSC1_oo00<Hdoooool01Ooo00@Hdooo6=<HdbCoo`036=?o
oooo00Goo`036=?ooooo00Goo`046=?ooaSC6==Oool3000Qool001[oo`<002Ooo`@Hd`;oo`036=?o
oooo00Coo`8Hd`Koo`036=?ooooo00?oo`@HdbKoo`036=?ooooo00Goo`036=?ooooo00?oo`@Hdeko
o`<002Coo`005ooo0`009ooo0aSC1_oo00<Hdoooool01?oo00<Hdoooool01Ooo00<Hdooo6=<00aSC
:_oo00<Hdoooool01Ooo00<Hdooo6=<00aSCG_oo10009ooo000Dool3000Xool26=<00ooo6=?oo`06
ool00aSCooooo`04ool00aSCooooo`04ool36=<^ool00aSCooooo`04ool36==Oool3000[ool0017o
o`<002Woo`8Hd`?oo`036=?ooooo00Goo`036=?ooooo00Coo`046=?oooooool36=<aool011SCoooo
oooo0aSCGooo0`00;_oo000>ool3000Xool46=<5ool00aSCooooo`04ool26=<6ool011SCoolHdaSC
=?oo00@Hdooo6=<Hdeooo`<0037oo`002ooo0`003_oo0QSC5ooo11SC0_oo00<Hdoooool01?oo00<H
doooool01?oo0QSC1Ooo0aSC=_oo0QSCGOoo1000=?oo0008ool3000=ool46=<00ooo6=?oo`0Cool3
6=<6ool00aSCooooo`04ool00aSCooooo`04ool26=<00ooo6=<Hd`026=>Eool3000hool000Koo`80
00goo`<Hd`Goo`036=?ooooo013oo`8Hd`03oolHdooo00Koo`036=?ooooo00Coo`036=?ooooo00?o
o`@HdiKoo`<003_oo`001_oo00<00?ooool02_oo0QSC00?ooaSCool01Ooo00<Hdoooool03_oo0QSC
0ooo00<Hdoooool01Ooo00<Hdoooool01?oo00@Hdoooooooo`8HdiKoo`@003koo`001_oo00<00?oo
ool02?oo0QSC0ooo00<Hdoooool01?oo00<Hdoooool02_oo11SC1Ooo00<Hdoooool01?oo00<Hdooo
ool01Ooo00@Hdooo6=<HdiGoo`<004;oo`001_oo00<00?ooool01_oo0QSC1Ooo00<Hdoooool01?oo
00<Hdoooool01_oo11SC0_oo00<Hdoooool01?oo00<Hdoooool01?oo00<Hdoooool00ooo11SCU?oo
0`00AOoo0006ool00`00ooooo`06ool00aSCooooo`04ool00aSCooooo`04ool00aSCooooo`03ool3
6=<6ool00aSCooooo`04ool00aSCooooo`04ool00aSCoolHd`036=>Eool30018ool000Koo`03003o
oooo00Koo`036=?ooooo00?oo`8Hd`Koo`046=?oooooool26=<00ooo6=?oo`06ool00aSCooooo`04
ool00aSCooooo`03ool36=>Eool4001;ool000Goo`03003ooooo00Ooo`036=?ooooo00?oo`8Hd`Go
o`8Hd`03oolHdaSC00?oo`036=?ooooo00Goo`036=?ooooo00Coo`046=?oooooool26=>Eool3001?
ool000Goo`03003ooooo00Ooo`036=?ooooo00?oo`8Hd`?oo`DHd`Goo`036=?ooooo00Coo`036=?o
oooo00Goo`046=?ooaSC6=>Dool3001Bool000Goo`03003ooooo00Koo`036=?ooooo00Coo`8Hd`03
oolHdaSC008Hd`03oolHdooo00Goo`036=?ooooo00Coo`036=?ooooo00?oo`@Hdi;oo`@005Goo`00
1Ooo00<00?ooool01_oo00<Hdoooool00ooo11SC1Ooo00<Hdoooool01?oo00<Hdoooool01?oo00<H
dooo6=<00aSCTooo0`00FOoo0005ool00`00ooooo`06ool00aSCoolHd`036=<00ooo6=<Hd`06ool0
0aSCooooo`04ool00aSCooooo`03ool36=>Dool3001Lool000Goo`03003ooooo00Koo`8Hd`Goo`8H
d`Koo`036=?ooooo00Coo`046=?oooooool26=>Dool3001Oool000Goo`03003ooooo00Koo`036=?o
oooo00Coo`8Hd`Goo`036=?ooooo00Goo`046=?ooaSC6=>Bool4001Rool000Goo`03003ooooo00Ko
o`036=?ooooo00Coo`8Hd`Goo`036=?ooooo00?oo`@Hdi7oo`<006Koo`001Ooo00<00?ooool01_oo
00<Hdoooool01?oo00<Hdoooool01?oo00<Hdooo6=<00aSCT_oo0`00JOoo0005ool00`00ooooo`06
ool00aSCooooo`04ool00aSCooooo`03ool36=>Bool4001/ool000Goo`03003ooooo00Koo`036=?o
oooo00Coo`036=?ooaSC00<Hd`03oolHdooo08ooo`<0073oo`001Ooo00<00?ooool01_oo00<Hdooo
ool00ooo1ASC0ooo00<Hdoooool0Rooo0`00Looo0004ool00`00ooooo`07ool011SCoooooooo1ASC
1Ooo00<Hdoooool0R?oo0`00M_oo0004ool00`00ooooo`07ool00aSCoolHd`036=<00ooo6=?oo`05
ool00aSCooooo`24ool4001iool000Coo`03003ooooo00Ooo`8Hd`Goo`036=?ooooo00Coo`036=?o
oooo087oo`<007goo`001?oo00<00?ooool01ooo00<Hdoooool01?oo00<Hdoooool01?oo00<Hdooo
ool0O_oo0`00P?oo0004ool00`00ooooo`07ool00aSCooooo`04ool00aSCooooo`04ool00aSCoooo
o`1jool40023ool000Coo`03003ooooo00Ooo`036=?ooooo00?oo`036=?ooooo00Goo`036=?ooooo
07Ooo`<008Ooo`001?oo00<00?ooool01ooo00<Hdoooool00ooo00<Hdoooool00ooo0aSCM_oo0`00
R_oo0004ool00`00ooooo`06ool00aSCooooo`04ool00aSCoolHd`036=<00ooo6=?oo`0Vool26==:
ool4002=ool000Coo`03003ooooo00Koo`036=?ooooo00?oo`<Hd`Goo`036=?ooooo02;oo`<Hd`03
oolHdooo04Koo`<0097oo`001?oo00<00?ooool01_oo00@Hdoooooooo`8Hd`03oolHdooo00Goo`03
6=?ooooo01koo`@Hd`Coo`036=?ooooo04;oo`<009Coo`001?oo00<00?ooool01_oo00@Hdooo6=<H
d`?oo`036=?ooooo00Coo`036=?ooooo01_oo`<Hd`Soo`036=?ooooo03ooo`<009Ooo`000ooo00<0
0?ooool01ooo0QSC1Ooo00<Hdoooool01?oo00<Hdoooool06?oo0aSC2ooo00<Hdoooool0>ooo1000
V_oo0003ool00`00ooooo`07ool00aSCooooo`04ool00aSCooooo`04ool00aSCooooo`0Eool36=<>
ool00aSCooooo`0hool3002Nool000?oo`03003ooooo00Ooo`036=?ooooo00?oo`8Hd`Koo`036=?o
oooo017oo`@Hda7oo`036=?ooooo03Goo`<00:7oo`000ooo00<00?ooool01ooo00<Hdoooool00ooo
0QSC1_oo00<Hdoooool03_oo0aSC5Ooo00<Hdoooool0<Ooo1000Y?oo0003ool00`00ooooo`07ool0
0aSCooooo`03ool26=<5ool26=<=ool36=<Hool00aSCooooo`0^ool3002Xool000?oo`03003ooooo
00Koo`036=?ooooo00Coo`8Hd`03oolHdaSC008Hd`03oolHdooo00Woo`<Hda_oo`036=?ooooo02_o
o`<00:_oo`000ooo00<00?ooool01_oo00<Hdoooool00ooo11SC1Ooo00<Hdoooool01?oo11SC7Ooo
00<Hdoooool0:Ooo0`00[_oo0003ool00`00ooooo`06ool00aSCoolHd`036=<00ooo6=<Hd`06ool0
11SCoooooooo0aSC8Ooo00<Hdoooool09Ooo1000/Ooo0003ool00`00ooooo`06ool46=<3ool26=<6
ool011SCoolHdaSC9?oo00<Hdoooool08_oo0`00]Ooo0003ool00`00ooooo`06ool26=<5ool26=<5
ool011SCoooooaSC9Ooo00<Hdoooool07ooo0`00^?oo0003ool00`00ooooo`06ool00aSCooooo`04
ool26=<5ool011SCoooooaSC9Ooo00<Hdoooool06ooo1000^ooo0003ool00`00ooooo`06ool00aSC
ooooo`04ool00aSCooooo`04ool011SCoooooaSC9Ooo00<Hdoooool06?oo0`00_ooo0002ool00`00
ooooo`07ool00aSCooooo`04ool00aSCooooo`04ool011SCoooooaSC9Ooo00<Hdoooool05Ooo0`00
`_oo0002ool00`00ooooo`07ool00aSCooooo`04ool00aSCooooo`03ool26=<00ooo6=?oo`0Uool0
0aSCooooo`0Bool30035ool000;oo`03003ooooo00Ooo`036=?ooooo00Coo`036=?ooaSC00<Hd`04
oolHdooo6=<Uool26=<@ool40038ool000;oo`03003ooooo00Ooo`036=?ooooo00?oo`<Hd`Goo`03
6=?ooaSC027oo`@Hd`ooo`<00<coo`000_oo00<00?ooool01ooo00<Hdooo6=<00aSC00?ooaSCool0
1Ooo00<Hdooo6=<07_oo0aSC4?oo0`00cooo0002ool00`00ooooo`07ool36=<4ool00aSCooooo`04
ool00aSCoolHd`0Kool36=<?ool4003Bool000;oo`03003ooooo00Koo`8Hd`Koo`036=?ooooo00Co
o`036=?ooaSC01Ooo`@Hd`ooo`<00=Koo`000_oo00<00?ooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01?oo00<Hdooo6=<05?oo0aSC4?oo0`00fOoo0002ool00`00ooooo`06ool00aSCooooo`04ool0
0aSCooooo`05ool00aSCoolHd`0Aool36=<@ool3003Lool000;oo`03003ooooo00Koo`036=?ooooo
00Coo`036=?ooooo00Goo`036=?ooaSC00goo`@Hd`ooo`@00=ooo`000_oo00<00?ooool01_oo00<H
doooool01?oo00<Hdoooool00ooo11SC2ooo0aSC4?oo0`00hooo00000ooo003oo`08ool00aSCoooo
o`04ool00aSCoolHd`036=<3ool00aSCooooo`06ool36=<@ool3003Vool00003ool00?oo00Soo`03
6=?ooooo00?oo`<Hd`Ooo`036=?ooooo00;oo`@Hd`ooo`@00>Woo`0000?oo`00ool02?oo00<Hdooo
6=<00aSC00?ooaSCool01ooo00<Hdooo6=<00QSC4?oo0`00kOoo00000ooo003oo`08ool46=<3ool0
0aSCooooo`06ool26=<@ool3003`ool00003ool00?oo00Soo`8Hd`Goo`036=?ooooo01Goo`<00??o
o`0000?oo`00ool02?oo00<Hdoooool01?oo00<Hdoooool04Ooo1000m_oo00000ooo003oo`08ool0
0aSCooooo`03ool00aSCooooo`0?ool3003jool00003ool00?oo00Soo`036=?ooooo00?oo`036=?o
oooo00coo`<00?goo`0000?oo`00ool02?oo00<Hdoooool00ooo00<Hdoooool02?oo1000oooo0Ooo
00000ooo003oo`07ool00aSCooooo`04ool00aSCooooo`05ool3003oool5ool00003ool00?oo00Oo
o`036=?ooooo00?oo`8Hd`Coo`<00?ooo`Soo`0000?oo`00ool01ooo00@Hdoooooooo`8Hd`?oo`<0
0?ooo`_oo`0000<00?ooool01ooo00DHdooo6=<Hdooo00@00?ooo`koo`0000<00?ooool01ooo0QSC
0`00oooo4_oo00000`00ooooo`06ool3003ooolEool00003003ooooo00;oo`@00?oooaSoo`0000<0
0?oo00000P00oooo7?oo0002003ooolOool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {160.5, 0}} -> {0.053476, 0.226319, 0.0033029, \
0.0033029}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[go22D]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0010118 0.0147151 0.00224269 [
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.1 .1 .6 r
.0001 w
[ ] 0 setdash
.03896 .13148 m
.03896 .05523 L
.06729 .05523 L
.06729 .13148 L
.03896 .13148 L
s
.06828 .13148 m
.06828 .05523 L
.09661 .05523 L
.09661 .13148 L
.06828 .13148 L
s
.27352 .13148 m
.27352 .05523 L
.30185 .05523 L
.30185 .13148 L
.27352 .13148 L
s
.30284 .13148 m
.30284 .05523 L
.33117 .05523 L
.33117 .13148 L
.30284 .13148 L
s
.33216 .13148 m
.33216 .05523 L
.36049 .05523 L
.36049 .13148 L
.33216 .13148 L
s
.36148 .13148 m
.36148 .05523 L
.38981 .05523 L
.38981 .13148 L
.36148 .13148 L
s
.39079 .13148 m
.39079 .05523 L
.41912 .05523 L
.41912 .13148 L
.39079 .13148 L
s
.42011 .13148 m
.42011 .05523 L
.44844 .05523 L
.44844 .13148 L
.42011 .13148 L
s
.44943 .13148 m
.44943 .05523 L
.47776 .05523 L
.47776 .13148 L
.44943 .13148 L
s
.47875 .13148 m
.47875 .05523 L
.50708 .05523 L
.50708 .13148 L
.47875 .13148 L
s
.50807 .13148 m
.50807 .05523 L
.5364 .05523 L
.5364 .13148 L
.50807 .13148 L
s
.53739 .13148 m
.53739 .05523 L
.56572 .05523 L
.56572 .13148 L
.53739 .13148 L
s
.56671 .13148 m
.56671 .05523 L
.59504 .05523 L
.59504 .13148 L
.56671 .13148 L
s
.59603 .13148 m
.59603 .05523 L
.62436 .05523 L
.62436 .13148 L
.59603 .13148 L
s
.62535 .13148 m
.62535 .05523 L
.65368 .05523 L
.65368 .13148 L
.62535 .13148 L
s
.65467 .13148 m
.65467 .05523 L
.683 .05523 L
.683 .13148 L
.65467 .13148 L
s
.68399 .13148 m
.68399 .05523 L
.71232 .05523 L
.71232 .13148 L
.68399 .13148 L
s
.71331 .13148 m
.71331 .05523 L
.74164 .05523 L
.74164 .13148 L
.71331 .13148 L
s
.74263 .13148 m
.74263 .05523 L
.77096 .05523 L
.77096 .13148 L
.74263 .13148 L
s
.77194 .13148 m
.77194 .05523 L
.80028 .05523 L
.80028 .13148 L
.77194 .13148 L
s
.80126 .13148 m
.80126 .05523 L
.82959 .05523 L
.82959 .13148 L
.80126 .13148 L
s
.83058 .13148 m
.83058 .05523 L
.85891 .05523 L
.85891 .13148 L
.83058 .13148 L
s
.8599 .13148 m
.8599 .05523 L
.88823 .05523 L
.88823 .13148 L
.8599 .13148 L
s
.88922 .13148 m
.88922 .05523 L
.91755 .05523 L
.91755 .13148 L
.88922 .13148 L
s
.91854 .13148 m
.91854 .05523 L
.94687 .05523 L
.94687 .13148 L
.91854 .13148 L
s
.94786 .13148 m
.94786 .05523 L
.97619 .05523 L
.97619 .13148 L
.94786 .13148 L
s
.03896 .21012 m
.03896 .13387 L
.06729 .13387 L
.06729 .21012 L
.03896 .21012 L
s
.06828 .21012 m
.06828 .13387 L
.09661 .13387 L
.09661 .21012 L
.06828 .21012 L
s
.0976 .21012 m
.0976 .13387 L
.12593 .13387 L
.12593 .21012 L
.0976 .21012 L
s
.12692 .21012 m
.12692 .13387 L
.15525 .13387 L
.15525 .21012 L
.12692 .21012 L
s
.15624 .21012 m
.15624 .13387 L
.18457 .13387 L
.18457 .21012 L
.15624 .21012 L
s
.18556 .21012 m
.18556 .13387 L
.21389 .13387 L
.21389 .21012 L
.18556 .21012 L
s
.21488 .21012 m
.21488 .13387 L
.24321 .13387 L
.24321 .21012 L
.21488 .21012 L
s
.2442 .21012 m
.2442 .13387 L
.27253 .13387 L
.27253 .21012 L
.2442 .21012 L
s
.27352 .21012 m
.27352 .13387 L
.30185 .13387 L
.30185 .21012 L
.27352 .21012 L
s
.30284 .21012 m
.30284 .13387 L
.33117 .13387 L
.33117 .21012 L
.30284 .21012 L
s
.33216 .21012 m
.33216 .13387 L
.36049 .13387 L
.36049 .21012 L
.33216 .21012 L
s
.36148 .21012 m
.36148 .13387 L
.38981 .13387 L
.38981 .21012 L
.36148 .21012 L
s
.39079 .21012 m
.39079 .13387 L
.41912 .13387 L
.41912 .21012 L
.39079 .21012 L
s
.42011 .21012 m
.42011 .13387 L
.44844 .13387 L
.44844 .21012 L
.42011 .21012 L
s
.44943 .21012 m
.44943 .13387 L
.47776 .13387 L
.47776 .21012 L
.44943 .21012 L
s
.47875 .21012 m
.47875 .13387 L
.50708 .13387 L
.50708 .21012 L
.47875 .21012 L
s
.50807 .21012 m
.50807 .13387 L
.5364 .13387 L
.5364 .21012 L
.50807 .21012 L
s
.53739 .21012 m
.53739 .13387 L
.56572 .13387 L
.56572 .21012 L
.53739 .21012 L
s
.56671 .21012 m
.56671 .13387 L
.59504 .13387 L
.59504 .21012 L
.56671 .21012 L
s
.59603 .21012 m
.59603 .13387 L
.62436 .13387 L
.62436 .21012 L
.59603 .21012 L
s
.62535 .21012 m
.62535 .13387 L
.65368 .13387 L
.65368 .21012 L
.62535 .21012 L
s
.65467 .21012 m
.65467 .13387 L
.683 .13387 L
.683 .21012 L
.65467 .21012 L
s
.68399 .21012 m
.68399 .13387 L
.71232 .13387 L
.71232 .21012 L
.68399 .21012 L
s
.71331 .21012 m
.71331 .13387 L
.74164 .13387 L
.74164 .21012 L
.71331 .21012 L
s
.74263 .21012 m
.74263 .13387 L
.77096 .13387 L
.77096 .21012 L
.74263 .21012 L
s
.77194 .21012 m
.77194 .13387 L
.80028 .13387 L
.80028 .21012 L
.77194 .21012 L
s
.80126 .21012 m
.80126 .13387 L
.82959 .13387 L
.82959 .21012 L
.80126 .21012 L
s
.83058 .21012 m
.83058 .13387 L
.85891 .13387 L
.85891 .21012 L
.83058 .21012 L
s
.8599 .21012 m
.8599 .13387 L
.88823 .13387 L
.88823 .21012 L
.8599 .21012 L
s
.88922 .21012 m
.88922 .13387 L
.91755 .13387 L
.91755 .21012 L
.88922 .21012 L
s
.91854 .21012 m
.91854 .13387 L
.94687 .13387 L
.94687 .21012 L
.91854 .21012 L
s
.94786 .21012 m
.94786 .13387 L
.97619 .13387 L
.97619 .21012 L
.94786 .21012 L
s
.03896 .28876 m
.03896 .21251 L
.06729 .21251 L
.06729 .28876 L
.03896 .28876 L
s
.06828 .28876 m
.06828 .21251 L
.09661 .21251 L
.09661 .28876 L
.06828 .28876 L
s
.50807 .28876 m
.50807 .21251 L
.5364 .21251 L
.5364 .28876 L
.50807 .28876 L
s
.53739 .28876 m
.53739 .21251 L
.56572 .21251 L
.56572 .28876 L
.53739 .28876 L
s
.56671 .28876 m
.56671 .21251 L
.59504 .21251 L
.59504 .28876 L
.56671 .28876 L
s
.59603 .28876 m
.59603 .21251 L
.62436 .21251 L
.62436 .28876 L
.59603 .28876 L
s
.62535 .28876 m
.62535 .21251 L
.65368 .21251 L
.65368 .28876 L
.62535 .28876 L
s
.65467 .28876 m
.65467 .21251 L
.683 .21251 L
.683 .28876 L
.65467 .28876 L
s
.68399 .28876 m
.68399 .21251 L
.71232 .21251 L
.71232 .28876 L
.68399 .28876 L
s
.71331 .28876 m
.71331 .21251 L
.74164 .21251 L
.74164 .28876 L
.71331 .28876 L
s
.74263 .28876 m
.74263 .21251 L
.77096 .21251 L
.77096 .28876 L
.74263 .28876 L
s
.77194 .28876 m
.77194 .21251 L
.80028 .21251 L
.80028 .28876 L
.77194 .28876 L
s
.80126 .28876 m
.80126 .21251 L
.82959 .21251 L
.82959 .28876 L
.80126 .28876 L
s
.83058 .28876 m
.83058 .21251 L
.85891 .21251 L
.85891 .28876 L
.83058 .28876 L
s
.8599 .28876 m
.8599 .21251 L
.88823 .21251 L
.88823 .28876 L
.8599 .28876 L
s
.88922 .28876 m
.88922 .21251 L
.91755 .21251 L
.91755 .28876 L
.88922 .28876 L
s
.91854 .28876 m
.91854 .21251 L
.94687 .21251 L
.94687 .28876 L
.91854 .28876 L
s
.94786 .28876 m
.94786 .21251 L
.97619 .21251 L
.97619 .28876 L
.94786 .28876 L
s
.03896 .3674 m
.03896 .29115 L
.06729 .29115 L
.06729 .3674 L
.03896 .3674 L
s
.06828 .3674 m
.06828 .29115 L
.09661 .29115 L
.09661 .3674 L
.06828 .3674 L
s
.50807 .3674 m
.50807 .29115 L
.5364 .29115 L
.5364 .3674 L
.50807 .3674 L
s
.53739 .3674 m
.53739 .29115 L
.56572 .29115 L
.56572 .3674 L
.53739 .3674 L
s
.56671 .3674 m
.56671 .29115 L
.59504 .29115 L
.59504 .3674 L
.56671 .3674 L
s
.59603 .3674 m
.59603 .29115 L
.62436 .29115 L
.62436 .3674 L
.59603 .3674 L
s
.62535 .3674 m
.62535 .29115 L
.65368 .29115 L
.65368 .3674 L
.62535 .3674 L
s
.65467 .3674 m
.65467 .29115 L
.683 .29115 L
.683 .3674 L
.65467 .3674 L
s
.68399 .3674 m
.68399 .29115 L
.71232 .29115 L
.71232 .3674 L
.68399 .3674 L
s
.71331 .3674 m
.71331 .29115 L
.74164 .29115 L
.74164 .3674 L
.71331 .3674 L
s
.74263 .3674 m
.74263 .29115 L
.77096 .29115 L
.77096 .3674 L
.74263 .3674 L
s
.77194 .3674 m
.77194 .29115 L
.80028 .29115 L
.80028 .3674 L
.77194 .3674 L
s
.80126 .3674 m
.80126 .29115 L
.82959 .29115 L
.82959 .3674 L
.80126 .3674 L
s
.83058 .3674 m
.83058 .29115 L
.85891 .29115 L
.85891 .3674 L
.83058 .3674 L
s
.8599 .3674 m
.8599 .29115 L
.88823 .29115 L
.88823 .3674 L
.8599 .3674 L
s
.88922 .3674 m
.88922 .29115 L
.91755 .29115 L
.91755 .3674 L
.88922 .3674 L
s
.91854 .3674 m
.91854 .29115 L
.94687 .29115 L
.94687 .3674 L
.91854 .3674 L
s
.94786 .3674 m
.94786 .29115 L
.97619 .29115 L
.97619 .3674 L
.94786 .3674 L
s
.03896 .44604 m
.03896 .36979 L
.06729 .36979 L
.06729 .44604 L
.03896 .44604 L
s
.06828 .44604 m
.06828 .36979 L
.09661 .36979 L
.09661 .44604 L
.06828 .44604 L
s
.80126 .44604 m
.80126 .36979 L
.82959 .36979 L
.82959 .44604 L
.80126 .44604 L
s
.83058 .44604 m
.83058 .36979 L
.85891 .36979 L
.85891 .44604 L
.83058 .44604 L
s
.8599 .44604 m
.8599 .36979 L
.88823 .36979 L
.88823 .44604 L
.8599 .44604 L
s
.88922 .44604 m
.88922 .36979 L
.91755 .36979 L
.91755 .44604 L
.88922 .44604 L
s
.91854 .44604 m
.91854 .36979 L
.94687 .36979 L
.94687 .44604 L
.91854 .44604 L
s
.94786 .44604 m
.94786 .36979 L
.97619 .36979 L
.97619 .44604 L
.94786 .44604 L
s
.03896 .52468 m
.03896 .44843 L
.06729 .44843 L
.06729 .52468 L
.03896 .52468 L
s
.06828 .52468 m
.06828 .44843 L
.09661 .44843 L
.09661 .52468 L
.06828 .52468 L
s
.10454 .5628 m
.10454 .4103 L
.2554 .4103 L
.2554 .5628 L
.10454 .5628 L
s
.80126 .52468 m
.80126 .44843 L
.82959 .44843 L
.82959 .52468 L
.80126 .52468 L
s
.83058 .52468 m
.83058 .44843 L
.85891 .44843 L
.85891 .52468 L
.83058 .52468 L
s
.8599 .52468 m
.8599 .44843 L
.88823 .44843 L
.88823 .52468 L
.8599 .52468 L
s
.88922 .52468 m
.88922 .44843 L
.91755 .44843 L
.91755 .52468 L
.88922 .52468 L
s
.91854 .52468 m
.91854 .44843 L
.94687 .44843 L
.94687 .52468 L
.91854 .52468 L
s
.94786 .52468 m
.94786 .44843 L
.97619 .44843 L
.97619 .52468 L
.94786 .52468 L
s
.03896 .60332 m
.03896 .52707 L
.06729 .52707 L
.06729 .60332 L
.03896 .60332 L
s
.94786 .60332 m
.94786 .52707 L
.97619 .52707 L
.97619 .60332 L
.94786 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/A000`40n007h00Ooooo8Ooo003ooolQ
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00
oooo8Ooo003ooolQool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`002ooo4QSC<OoobQSC
2?oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`0_ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSC
ooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05
ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSC
ooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo02ooo`036=?ooooo00Go
o`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?o
oooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Go
o`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0;ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo
ool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo
00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`0_ool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool0
0aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCoooo
o`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool0
0aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
02ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`03
6=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool0;ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<H
doooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06
ool00aSCooooo`0_ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06
ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo02ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Go
o`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool0;ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`0_ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo02ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8H
d`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`00
2ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0;ooo00<Hdoooool01Ooo0QSC1ooo00<H
doooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool0
1Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC
1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`0_ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSC
ooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05
ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSC
ooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo02ooo`036=?ooooo00Go
o`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?o
oooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Go
o`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0;ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo
ool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo
00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`0_ool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool0
0aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCoooo
o`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool0
0aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
02ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`03
6=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool0;ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<H
doooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06
ool00aSCooooo`0_ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06
ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo02ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Go
o`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool0;ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;oolB6=<aooo:
6=<8ool000_ooolHd`hHd`Soo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo
00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo
00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo
00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCoooo
o`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCoooo
o`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCoooo
o`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8H
d`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8H
d`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`00
2ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<H
doooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC
1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<H
doooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool0
1Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSC
ooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05
ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSC
ooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Oo
o`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Ko
o`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo
0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo
00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo
ool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool0
0aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool0
0aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCoooo
o`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool0
0aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`03
6=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo
00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC
1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool0
1Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool0
1Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<H
doooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05
ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSC
ooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05
ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06
ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Oo
o`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Go
o`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Oo
o`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCoooo
o`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`03
6=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC
1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool0
1Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0
1Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSC
ooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSC
ooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSC
ooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05
ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSC
ooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?o
oooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Go
o`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo
0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCoooo
o`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCoooo
o`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool0
00_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`03
6=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Goo`8H
d`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooooaSC
3QSC2?oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<H
doooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0
1Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSC
ooooo`1bool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05
ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSC
ooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05
ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo07;oo`036=?o
oooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Go
o`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Oo
o`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Ko
o`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCoooo
o`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool0
0aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`03
6=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`03
6=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0
L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool0
1Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<H
doooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCooooo`05
ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSC
ooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_o
o`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo
00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo
ool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool0
0aSCooooo`1bool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCoooo
o`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCoooo
o`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo07;oo`03
6=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8H
d`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo
00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC
1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<H
doooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool0
1Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSC
ooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06
ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Ko
o`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?o
oooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Go
o`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo
ool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo
00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo
00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCoooo
o`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool0
00_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool0
1Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<H
doooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;oolB6==doon76=<8ool000_ooa8HdgCo
ohLHd`Soo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo
0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCooooo`05ool26=<7ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCoooo
o`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`03
6=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0
1Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool0
1Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSC
ooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05
ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7
ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06
ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Oo
o`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo
00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCoooo
o`06ool00aSCooooo`1bool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool0
0aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCoooo
o`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool0
0aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`03
6=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`03
6=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool0
1Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC
1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<H
doooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;
ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCooooo`05ool26=<7ool00aSC
ooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Ko
o`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?o
oooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo
00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo
ool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo
00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCoooo
o`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCoooo
o`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8H
d`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo
00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<H
doooool01Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool0
1Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<H
doooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool0
1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`1bool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06
ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSC
ooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05
ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?o
oooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?o
oooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Go
o`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0L_oo00<Hdooo
ool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo
0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo
000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`1bool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo
00Goo`036=?ooooo00Koo`036=?ooooo07;oo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`03
6=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo4QSCM?ooQaSC2?oo000;ool00aSC
ooooo`05ool00aSCooooo`06ool00aSCooooo`36ool00aSCooooo`05ool26=<7ool00aSCooooo`05
ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?o
oooo00Goo`036=?ooooo00Koo`036=?ooooo0<Koo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool0a_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`36ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool0
0aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo
00Goo`036=?ooooo00Koo`036=?ooooo0<Koo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool0
1Ooo00<Hdoooool01_oo00<Hdoooool0a_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<H
doooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05
ool00aSCooooo`06ool00aSCooooo`36ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo0<Koo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool0a_oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool0
0aSCooooo`06ool00aSCooooo`36ool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCoooo
o`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`03
6=?ooooo00Koo`036=?ooooo0<Koo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo
00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<H
doooool01_oo00<Hdooo6=<0:aSCVooo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool0
0aSCooooo`06ool00aSCoolHd`0Zool00aSCooooo`2Iool00aSCooooo`05ool26=<7ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`03
6=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC02[oo`036=?ooooo09Woo`036=?ooooo00Goo`8H
d`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo
00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo6=<0:_oo00<Hdoooool0VOoo00<H
doooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool0
1Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCoolHd`0Zool00aSC
ooooo`2Iool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05
ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?o
oaSC02[oo`036=?ooooo09Woo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Ko
o`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdooo6=<0:_oo00<Hdoooool0VOoo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCoolHd`0Zool00aSCooooo`2Iool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool0
00_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC02[oo`036=?ooooo09Woo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`03
6=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo6=<0:_oo00<Hdoooool0
VOoo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<H
doooool01Ooo00<Hdoooool01_oo000;oolB6=<00ooo6=?oo`0Yool00aSCooooo`2Ioolc6=<8ool0
00_ooa8Hd`03oolHdooo02Woo`036=?ooooo09Wooc<Hd`Soo`002ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo00<Hdooo6=<0:_oo00<Hdoooool0VOoo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`06ool00aSCoolHd`0Zool00aSCooooo`2Iool00aSCooooo`05ool26=<7ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool0
00_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC02[oo`036=?ooooo09Woo`036=?ooooo
00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`03
6=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo6=<0:_oo00<Hdoooool0
VOoo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<H
doooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCoolHd`0Z
ool00aSCooooo`2Iool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSC
ooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Ko
o`036=?ooaSC02[oo`036=?ooooo09Woo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo
00<Hdoooool01_oo00<Hdooo6=<0:_oo00<Hdoooool0VOoo00<Hdoooool01Ooo0QSC1ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool0
0aSCooooo`05ool00aSCooooo`06ool00aSCoolHd`0Zool00aSCooooo`2Iool00aSCooooo`05ool2
6=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCoooo
o`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC02[oo`036=?ooooo09Woo`03
6=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo
00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo6=<0:_oo00<H
doooool0VOoo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool0
1Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSC
oolHd`0Zool00aSCooooo`2Iool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06
ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?o
oooo00Koo`036=?ooaSC02[oo`036=?ooooo09Woo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdooo
ool01Ooo00<Hdoooool01_oo00<Hdooo6=<0:_oo00<Hdoooool0VOoo00<Hdoooool01Ooo0QSC1ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo
000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCoolHd`0Zool00aSCooooo`2Iool00aSCoooo
o`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCooooo`05ool0
0aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC02[oo`036=?ooooo
09Woo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`03
6=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo6=<0
:_oo00<Hdoooool0VOoo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<H
doooool01Ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`06
ool00aSCoolHd`0Zool00aSCooooo`2Iool00aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSC
ooooo`06ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Go
o`036=?ooooo00Koo`036=?ooaSC02[oo`036=?ooooo09Woo`036=?ooooo00Goo`8Hd`Ooo`036=?o
oooo00Goo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo
00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdooo6=<0:_oo00<Hdoooool0VOoo00<Hdoooool01Ooo
0QSC1ooo00<Hdoooool01Ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdooo
ool01_oo000;ool00aSCooooo`05ool00aSCooooo`06ool00aSCoolHd`0Zool00aSCooooo`2Iool0
0aSCooooo`05ool26=<7ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`05ool00aSCoooo
o`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC02[oo`03
6=?ooooo09Woo`036=?ooooo00Goo`8Hd`Ooo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooooo
00Goo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo4QSC00?ooaSCool0:Ooo00<Hdoooool0VOoo
<aSC2?oo000;ool00aSCooooo`05ool00aSCooooo`08ool00aSCooooo`0Xool00aSCooooo`33ool0
0aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Soo`036=?ooooo
02Soo`036=?ooooo0<?oo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<H
doooool02?oo00<Hdoooool0:?oo00<Hdoooool0`ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;
ool00aSCooooo`05ool00aSCooooo`08ool00aSCooooo`0Xool00aSCooooo`33ool00aSCooooo`05
ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Soo`036=?ooooo02Soo`036=?o
oooo0<?oo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool02?oo
00<Hdoooool0:?oo00<Hdoooool0`ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`08ool00aSCooooo`0Xool00aSCooooo`33ool00aSCooooo`05ool00aSCoooo
o`06ool000_oo`036=?ooooo00Goo`036=?ooooo00Soo`036=?ooooo02Soo`036=?ooooo0<?oo`03
6=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool02?oo00<Hdoooool0
:?oo00<Hdoooool0`ooo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSC
ooooo`08ool00aSCooooo`0Xool00aSCooooo`33ool00aSCooooo`05ool00aSCooooo`06ool000_o
o`036=?ooooo00Goo`036=?ooooo00Soob`HdlGoo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo
00<Hdoooool01Ooo00<Hdoooool0nOoo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCoooo
o`05ool00aSCooooo`3iool00aSCooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`03
6=?ooooo0?Woo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool0
nOoo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool00aSCooooo`05ool00aSCooooo`3iool00aSC
ooooo`05ool00aSCooooo`06ool000_oo`036=?ooooo00Goo`036=?ooooo0?Woo`036=?ooooo00Go
o`036=?ooooo00Koo`002ooo00<Hdoooool01Ooo00<Hdoooool0nOoo00<Hdoooool01Ooo00<Hdooo
ool01_oo000;ool00aSCooooo`05ool00aSCooooo`3iool00aSCooooo`05ool00aSCooooo`06ool0
00_oo`036=?ooooo00Goo`036=?ooooo0?Woo`036=?ooooo00Goo`036=?ooooo00Koo`002ooo00<H
doooool01Ooo00<Hdoooool0nOoo00<Hdoooool01Ooo00<Hdoooool01_oo000;ool96=?kool96=<8
ool00?ooob7oo`00oooo8Ooo003ooolQool00?ooob7oo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {-24.7576, -6.56274, 3.45223, \
1.55749}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["make legends", "Subsection"],

Cell["\<\
(*
 most non-periodic table / text is not programatic they are just regular text \
(but uses opos to place is all)
*)\
\>", "Text"],

Cell[CellGroupData[{

Cell["disuss and print options", "Subsubsection"],

Cell["\<\
ps files have 612 x 792 sizes, condensed layout charts should fit \
landscape fine, 9.7\"x2.9\"\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \({700, 210}/72 // N\)], "Input"],

Cell[BoxData[
    \({9.722222222222221`, 2.9166666666666665`}\)], "Output"]
}, Closed]],

Cell[BoxData[
    RowBox[{
      RowBox[{"printopts", "=", 
        RowBox[{"Sequence", "[", "\[IndentingNewLine]", 
          RowBox[{
            RowBox[{
              StyleBox["FirstPageHeader",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{
              StyleBox["FirstPageFooter",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{
              StyleBox["RestPagesHeader",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{
              StyleBox["RestPagesFooter",
                FontFamily->"Courier"], "->", "False"}], ",", "\n", 
            RowBox[{"(*", " ", 
              RowBox[{
                RowBox[{
                  StyleBox["PageHeaderLines",
                    FontFamily->"Courier"], "\[Rule]", \({False, False}\)}], 
                ","}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{
              StyleBox["PrintRegistrationMarks",
                FontFamily->"Courier"], "->", "False"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
              StyleBox["IncludeSpecialFonts",
                FontFamily->"Courier"], "->", "True"}], ",", "\n", 
            RowBox[{
              StyleBox["IncludePostScriptResourceDirectives",
                FontFamily->"Courier"], "->", "True"}], ",", "\n", 
            RowBox[{
              StyleBox["UsePostScriptOutputFile",
                FontFamily->"Courier"], "->", "True"}], ",", "\n", 
            RowBox[{"(*", " ", 
              RowBox[{
                RowBox[{
                  StyleBox["PostScriptOutputFile",
                    FontFamily->"Courier"], "\[Rule]", "file"}], ","}], " ", 
              "*)"}], "\n", 
            RowBox[{
              StyleBox["Magnification",
                FontFamily->"Courier"], "\[Rule]", "1"}], ",", "\n", 
            RowBox[{
              StyleBox["PaperSize",
                FontFamily->"Courier"], "\[Rule]", \({700, 210}\)}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
              RowBox[{
                RowBox[{
                  StyleBox["PageSize",
                    FontFamily->"Courier"], "\[Rule]", \({700, 210}\)}], 
                ","}], " ", "*)"}], "\n", 
            RowBox[{
              StyleBox["PrintingMargins",
                FontFamily->"Courier"], "\[Rule]", \({{0, 0}, {0, 0}}\)}]}], 
          "\[IndentingNewLine]", "]"}]}], ";"}]], "Input"],

Cell["\<\
helpcell isn't considered a \"legend\" because it draws as if it's \
another element\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["powers table gr  (created far above in basic setup)", "Subsubsection"],

Cell["pin to top rows of chart since bottom moves around", "Text"],

Cell[BoxData[
    \( (*\ can\ also\ be\ \(used : \ whereis[Lithium] + 9\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(ptgrc = 
        go2D[\([1, 1, whereis[Boron] - 2, 2]\)] + {0, \(-10\)};\)\)], "Input"],

Cell["note bug FontSize>1 so that lines are visible", "Text"],

Cell[BoxData[
    \(\(ptgr = 
        Graphics[
          Text[powerstable, ptgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(ptgr3D = 
        Graphics3D[
          Text[powerstable, Insert[ptgrc, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["conversion table(s)  gr(s)  (several snaptxt)", "Subsubsection"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[AtomicMassUnit, Kilo\ Gram]\)], "Input"],

Cell[BoxData[
    \(1.6605402`*^-27\ Gram\ Kilo\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.6605402`*^-27\ 1000\)], "Input"],

Cell[BoxData[
    \(1.6605402`*^-24\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[1\ Mole, AvogadroConstant\ Mole]\)], "Input"],

Cell[BoxData[
    \(Mole\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[ElectronVolt, Kilo\ Joule]\)], "Input"],

Cell[BoxData[
    \(1.60217733`*^-22\ Joule\ Kilo\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[%, Joule]\)], "Input"],

Cell[BoxData[
    \(1.60217733`*^-19\ Joule\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Options[fNBookForm2]\)], "Input"],

Cell[BoxData[
    \({c2`p`sd \[Rule] 4, c2`p`u \[Rule] 3, c2`p`sep \[Rule] "\[ThinSpace]", 
      c2`p`showprec \[Rule] False, c2`p`printstate \[Rule] False, 
      c2`p`rounding \[Rule] 0, c2`p`commas \[Rule] False, 
      c2`p`fill \[Rule] False, c2`p`sigzeros \[Rule] False}\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[Angstrom, Meter] // N\)], "Input"],

Cell[BoxData[
    \(1.`*^-10\ Meter\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fNBookForm2[%/Meter]\)], "Input"],

Cell[BoxData[
    \("1\[ThinSpace]e-10"\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[Watt, Joule/\ Second] // InputForm\)], "Input"],

Cell["Joule/Second", "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[AtomicMassUnit, Gram/Mole]\)], "Input"],

Cell[BoxData[
    \(\(1.000000008024534`\ Gram\)\/Mole\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(12\)\(\ \)\(Gram\/6.0221367`*^23\)\( (*\ 
        one\ atom\ *) \)\)\)], "Input"],

Cell[BoxData[
    \(1.9926482240099268`*^-23\ Gram\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[\((1.66054\[Times]10\^\(-27\)\ Kilo\ Gram)\) 12, 
      Gram]\)], "Input"],

Cell[BoxData[
    \(1.992648`*^-23\ Gram\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(AvogadroConstant\)], "Input"],

Cell[BoxData[
    \(AvogadroConstant\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[1000\ 9.109\ \ 10\^\(-31\)\ \ Gram, Gram\ Yocto]\)], "Input"],

Cell[BoxData[
    \(0.0009109`\ Gram\ Yocto\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(910.9\ \[Micro]y\ Gram\)], "Input"],

Cell[BoxData[
    \(910.9`\ Gram\ \[Micro]y\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(9.109\ \(10\^\(-31\)\) k\ Gram\)], "Input"],

Cell[BoxData[
    \(9.109000000000001`*^-31\ Gram\ k\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(% // fNBookForm2\)], "Input"],

Cell[BoxData[
    \(fNBookForm2[9.109000000000001`*^-31\ Gram\ k]\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Convert[2.997`*^8, Mega]\)], "Input"],

Cell[BoxData[
    \(299.7`\ Mega\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(10\^\(-31\)\) 1000 // N\)], "Input"],

Cell[BoxData[
    \(1.0000000000000001`*^-28\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(29.97\ 10^6\)], "Input"],

Cell[BoxData[
    \(2.997`*^7\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(6.37\ 10\^6\  // fNBookForm2\)], "Input"],

Cell[BoxData[
    \("6.37\[ThinSpace]M"\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(6.37\ 10\^6\)], "Input"],

Cell[BoxData[
    \(6.37`*^6\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.66054\[Times]10\^\(-27\)\ \ 1000\)], "Input"],

Cell[BoxData[
    \(1.66054`*^-24\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.66054`*^-24 // fNBookForm2\)], "Input"],

Cell[BoxData[
    \("1.660\[ThinSpace]y"\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.60218\[Times]10\^\(-19\) // fNBookForm2\)], "Input"],

Cell[BoxData[
    \("160.2\[ThinSpace]z"\)], "Output"]
}, Closed]],

Cell["\<\
(*
this likely is less helpful - read the book you'd know to look

some facts seem very important , like \[CapitalDelta]EN , however there are \
very many such , like resitivity and triple points and ...

there's room for one or two extra charts try to stick to chemistry or very \
practical and for chemistry try to stick to most amazing numbers and trends \
(like pH 7 , ion donor , 22.4 L gas / mole).  look at highlights later maybe.
*)\
\>", "Text"],

Cell[BoxData[GridBox[{
        {"Trends", " ", " "},
        {"\[Placeholder]", " ", " "},
        {\(\(\(\[DownArrow]\)\(\ \)\(more\)\)\ metalic\), 
          " ", \(G13 \[RightArrow] \ less\ metalic\)},
        {\(Atomic\ Radius\), 
          " ", \(\(\[LeftArrow]\)\(\ \)\(\[DownArrow]\)\)},
        {"FIP", " ", \(\(\[RightArrow]\)\(\ \)\(\[UpArrow]\)\)},
        {"subshells", 
          "\[Placeholder]", \(fill\ one\ at\ a\ time\[IndentingNewLine]
          then\ double\ up\)},
        {\(s\ p\ d\ f\), "\[Placeholder]", \(2\ 3\ 5\ 7\)}
        }]], "Text"],

Cell[BoxData[GridBox[{
        {"amu", "AtomicMassUnit", 
          "=", \(Gram\ \ /\ \ \((Mole\ \ or\ \ N\_A)\)\)},
        {\(N\_A\), 
          FormBox["AvogadroConstant",
            "InputForm"], "=", \(6.02214\[Times]10\^23\ \ Atoms\)},
        {" ", \(one\ amu\ weighs\), 
          "=", \(1.66054\[Times]10\^\(-24\)\ \ Gram\)},
        {"eV", "ElectronVolt", "=", \(1.60217733`*^-22\ Joule\ \ Kilo\)},
        {"\[Angstrom]", "Angstrom", "=", \(1.`*^-10\ Meter\)},
        {"W", "Watt", "=", \(Joule/Second\)},
        {" ", \(La\ Ac\ elem\ series\), "=", \(58 - 71\ and\ 90 - 103\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt = snaptxt[];\)\)], "Input"],

Cell[BoxData[GridBox[{
        {"Brief", "Soluability", "Table"},
        {\(if\ free\ to\ mix\), \(ex . \ 
              dissolved\ in\ water\), \(\(\ \)\(terms\)\)},
        {\(ions\^-\), \(\(alkali\^+\) or\ \(NH\_4\%+\)\), "ammonia"},
        {\(ions\^+\), \(\(C\_2\) \(H\_3\) \(O\_2\%-\) \(NO\_3\%-\)\), 
          "acetate"},
        {\(compounds\ with\ SO\_4\%\(\(2\)\(-\)\)\), \(except\ with\ \
Ba\^\(\(2\)\(+\)\)\ \ Sr\^\(\(2\)\(+\)\)\ \ Pb\^\(\(2\)\(+\)\)\), "nitrate"},
        {\(comp\ with\ \(Br\^-\)\ \ Cl\^\(\(-\)\(\ \)\)\ \(I\^-\)\), \(except\
\ with\ \(Ag\^+\)\ \ Hg\^\(\(2\)\(+\)\)\ \ Pb\^\(\(2\)\(+\)\)\), "sulfate"},
        {\(compounds\ with\ \(HCO\_3\^-\)\), \(only\ with\ \(alkali\^+\)\ or\
\ \ \(NH\_4\%+\)\[IndentingNewLine]
          earth\ alkaline\^\(\(2\)\(+\)\)\), \(carbonic\[IndentingNewLine]
          acid\)},
        {\(OH\^-\), \(only\ with\ \
\(alkali\^+\)\ \ \(NH\_4\%+\)\ \ Ba\^\(\(2\)\(+\)\)\), "hydroxide"},
        {\(\(CO\_3\^-\)\ \ PO\_4\%\(\(3\)\(-\)\)\ \ S\^\(\(2\)\(-\)\)\), \
\(only\ with\ \(alkali\^+\)\ or\ \(NH\_4\%+\)\), \(carbonate\
\[IndentingNewLine]
          phosphate\)},
        {\(if\ dissasociation\[IndentingNewLine]
          or\ association\ or\[IndentingNewLine]
          \(\(equilibria\)\(\ \)\(shift\)\(\ \)\)\), \(froms\ \((more)\) 
            water\ salt\ precipitate\[IndentingNewLine]
          gas\ pressure\ heat\ light\ resistance\[IndentingNewLine]
          \(\(equilibria\)\(\ \)\(\[LeftArrow]\)\) \[Rule] \ 
            or\ weight\ change\), "titrates"}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt2 = snaptxt[];\)\)], "Input"],

Cell[BoxData[GridBox[{
        {" ", \(Other\ Data\), " ", " "},
        {\(m\_e\), \(Electron\ Mass\), 
          "=", \(9.109\[Times]10\^\(-28\)\ \ Gram\)},
        {"C", \(Electron\ Charge\), "=", \(eV\ \ \ Joules\ of\ Work\)},
        {"c", \(Speed\ of\ Light\), 
          "=", \(\(2.997\[Times]10\^6\)\ \ Meter\ /\ Second\)},
        {" ", "STP", "=", \(0\ \[Degree]\ Celsius\ , 1\ \ Atmosphere\)},
        {\(\(\ \)\(Vg\)\), \(Gas\ Volume\), 
          "=", \(22.4\ \ Liters\ /\ Mole\ \ @\ STP\)},
        {"R", \(Gas\ Constant\), "=", \(8.20\ c\ Vg\ , \ P\ V = mol\ R\ T\)},
        {"R", \(Gas\ Constant\), "=", \(8.314\ \ J/K\ mol\)},
        {" ", \(Earth\ Radius\), "=", \(6.37`*^6\ \ Meter\)},
        {"Ge", \(Earth\ Gravity\), "=", \(9.80\ Meter\ /\ Second\^2\)},
        {"G", \(Gravity\ \((m\ m`/r\^2)\)\), 
          "=", \(6.672\ \ 10\^\(-11\)\ N\ m\^2/kg\^2\)},
        {" ", \(Air\ Density\), 
          "=", \(1.2\ k\ Gram\ /\ \(Meter\^3\)\ \ @20  \[Degree]\ C\)},
        {" ", \(Water\ Density\), "=", \(10\^6\ \ Gram\ /\ Meter\^3\)},
        {"pH", "acids", "<", \(water\ \((7)\)\  < \ bases\)},
        {\(32  \[Degree]\ F\), \(273.15\ Kelvin\), 
          "=", \(32 + 0  Celsius\ 9/5\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt3 = snaptxt[];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(n\)], "Input"],

Cell[BoxData[
    \(224\)], "Output"]
}, Closed]],

Cell[BoxData[GridBox[{
        {" ", "Conversions", " ", " "},
        {"amu", "AtomicMassUnit", 
          "=", \(Gram\ \ /\ \ \((Mole\ \ or\ \ N\_A)\)\)},
        {\(N\_A\), 
          FormBox["AvogadroConstant",
            "InputForm"], "=", \(6.02214\[Times]10\^23\ \ Atoms\)},
        {" ", \(one\ amu\ weighs\), 
          "=", \(1.66054\[Times]10\^\(-24\)\ \ Gram\)},
        {"eV", "ElectronVolt", 
          "=", \(\(1.60218\[Times]10\^\(-19\)\)\ \ Joule\)},
        {"\[Angstrom]", "Angstrom", "=", \(1.`*^-10\ \ Meter\)},
        {"W", "Watt", "=", \(Joule\ /\ Second\)},
        {"\[Placeholder]", \(1\ \ Columb\), 
          "=", \(1\ \ eV\ \ Joule\ of\ Work\)},
        {\(32  \[Degree]\), \(F\  = \ 273.15\ Kelvin\), 
          "=", \(32 + 0  Celsius\ 9/5\)},
        {\(F\ d\), \(Work\  = \ Energy\), 
          "=", \(mass\ \ acceleration\ dist\)},
        {" ", "Lanthenides", "=", \(Elems\ \ 58 - 71\)},
        {" ", "Actinides", "=", \(Elems\ \ 90 - 103\)},
        {" ", \(acids\ donate\), "=", \(bases\ \(take : \ ions\)\)},
        {" ", "amu", "~", \(6.2\ /\ specific\ heat\)},
        {" ", \(ionic\ bonds\ pair\), "=", \(outer\ elec\ totaling\ 8\)},
        {" ", \( .5 < 1.5 < EN\), 
          "=", \(covalent < polar < ionic\[IndentingNewLine]
          polar\ if\ \ en1 \[NotEqual] en2\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxt4 = snaptxt[];\)\)], "Input"],

Cell[BoxData[
    \(\(Module[{v, 
          msg}, \[IndentingNewLine]msg = {}; \[IndentingNewLine]Do[\
\[IndentingNewLine]\(Do[\[IndentingNewLine]v = 
                ve2[Elements[\([i]\)], efuns[\([j]\)]]; \[IndentingNewLine]If[
                Length[v] \[NotEqual] 5, Return[v]]; \[IndentingNewLine]If[
                v[\([5]\)] \[Equal] 1, \[IndentingNewLine]msg = 
                  Append[msg, {v[\([2]\)], v[\([3]\)], 
                      v[\([4, 1]\)]}]; \[IndentingNewLine]\(Return[
                    msg];\)\[IndentingNewLine]];\[IndentingNewLine], {j, 
                Length[efuns] - 
                  2}\[IndentingNewLine]];\)\[IndentingNewLine], {i, 
            Length[Elements]}\[IndentingNewLine]]; \[IndentingNewLine]msg\
\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(Append[%, \[IndentingNewLine]{"\<un\>", "\<AW\>", "\<* Atomic Weight \
un unstable formation or decay of isotopes\>"}\[IndentingNewLine]];\)\)], \
"Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(convdisp5 = 
      GridBox[%, RowLines \[Rule] False, ColumnLines \[Rule] True, 
          GridFrame \[Rule] True, ColumnAlignments \[Rule] {Left}] // 
        DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {
            "H", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Hydrogen\ at\ 11\ \
\(\(Kelvin\)\(.\)\)\)},
          {
            "He", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ the\ Helium\ form\ \
of\ 4\ at\ liquid\ \(\(Kelvin\)\(.\)\)\)},
          {
            "C", \(\(Tm\)\(\ \)\), \(Melting\ point\ is\ for\ the\ Carbon\ \
form\ of\ \(\(diamond\)\(.\)\)\)},
          {
            "N", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Nitrogen\ at\ 21\ \
\(\(Kelvin\)\(.\)\)\)},
          {
            "O", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Oxygen\ at\ 55\ \
\(\(Kelvin\)\(.\)\)\)},
          {
            "F", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ the\ Fluorine\ form\ \
of\ 85\ at\ liquid\ \(\(Kelvin\)\(.\)\)\)},
          {
            "Ne", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Neon\ at\ 24\ \
\(\(Kelvin\)\(.\)\)\)},
          {
            "P", \(\(Tm\)\(\ \)\), \(Melting\ point\ is\ for\ the\ Phosphorus\
\ form\ of\ \(\(P4\)\(.\)\)\)},
          {
            "S", \(\(Tm\)\(\ \)\), \(Melting\ point\ is\ for\ the\ Sulfur\ \
form\ of\ \(\(alpha\)\(.\)\)\)},
          {
            "Cl", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Chlorine\ at\ 113\ \
\(\(Kelvin\)\(.\)\)\)},
          {
            "Ar", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Argon\ at\ 40\ \
\(\(Kelvin\)\(.\)\)\)},
          {
            "As", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ the\ Arsenic\ form\ \
of\ \(\(alpha\)\(.\)\)\)},
          {
            "Br", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Bromine\ at\ 123\ \(\
\(Kelvin\)\(.\)\)\)},
          {
            "Kr", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Krypton\ at\ 117\ \(\
\(Kelvin\)\(.\)\)\)},
          {
            "Sn", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ the\ Tin\ form\ of\ \
\(\(beta\)\(.\)\)\)},
          {
            "Xe", \(\(Qs\)\(\ \)\), \(Thermal\ conductivity\ is\ for\ the\ \
Xenon\ form\ of\ \(\(gaseous\)\(.\)\)\)},
          {
            "Ce", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ the\ Cerium\ form\ \
of\ \(\(alpha\)\(.\)\)\)},
          {
            "Hg", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ the\ Mercury\ form\ \
of\ \(\(liquid\)\(.\)\)\)},
          {
            "Bi", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ Bismuth\ at\ 293\ \(\
\(Kelvin\)\(.\)\)\)},
          {
            "Rn", \(\(p\)\(\ \ \)\), \(Density\ is\ for\ the\ Radon\ form\ of\
\ 211\ at\ liquid\ \(\(Kelvin\)\(.\)\)\)},
          {"un", 
            "AW", \(\(*\)\(\ \)\(Atomic\)\(\ \)\(Weight\)\(\ \)\(un\)\(\ \
\)\(unstable\)\(\ \)\(formation\)\(\ \)\(or\)\(\ \)\(decay\)\(\ \)\(of\)\(\ \
\)\(isotopes\)\)}
          },
        ColumnAlignments->{Left},
        GridFrame->True,
        RowLines->False,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(convdisp = 
      GridBox[convtxt[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"amu", "AtomicMassUnit", 
            "=", \(Gram\ \ /\ \ \((Mole\ \ or\ \ N\_A)\)\)},
          {\(N\_A\), 
            FormBox["AvogadroConstant",
              "InputForm"], "=", \(6.02214\[Times]10\^23\ \ Atoms\)},
          {" ", \(one\ amu\ weighs\), 
            "=", \(1.66054\[Times]10\^\(-24\)\ \ Gram\)},
          {"eV", "ElectronVolt", "=", \(1.60217733`*^-22\ Joule\ \ Kilo\)},
          {"\[Angstrom]", "Angstrom", "=", \(1.`*^-10\ Meter\)},
          {"W", "Watt", "=", \(Joule/Second\)},
          {" ", \(La\ Ac\ elem\ series\), "=", \(58 - 71\ and\ 90 - 103\)}
          },
        ColumnAlignments->{Center},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(convdisp2 = 
      GridBox[convtxt2[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {"Brief", "Soluability", "Table"},
          {\(if\ free\ to\ mix\), \(ex . \ 
                dissolved\ in\ water\), \(\(\ \)\(terms\)\)},
          {\(ions\^-\), \(\(alkali\^+\) or\ \(NH\_4\%+\)\), "ammonia"},
          {\(ions\^+\), \(\(C\_2\) \(H\_3\) \(O\_2\%-\) \(NO\_3\%-\)\), 
            "acetate"},
          {\(compounds\ with\ SO\_4\%\(\(2\)\(-\)\)\), \(except\ with\ Ba\^\(\
\(2\)\(+\)\)\ \ Sr\^\(\(2\)\(+\)\)\ \ Pb\^\(\(2\)\(+\)\)\), "nitrate"},
          {\(comp\ with\ \(Br\^-\)\ \ Cl\^\(\(-\)\(\ \)\)\ \(I\^-\)\), \
\(except\ with\ \(Ag\^+\)\ \ Hg\^\(\(2\)\(+\)\)\ \ Pb\^\(\(2\)\(+\)\)\), 
            "sulfate"},
          {\(compounds\ with\ \(HCO\_3\^-\)\), \(\(only\ with\ \(alkali\^+\)\ \
or\ \ \(NH\_4\%+\)\)\[IndentingNewLine]\(earth\ alkaline\^\(\(2\)\(+\)\)\)\), \
\(carbonic\[IndentingNewLine]acid\)},
          {\(OH\^-\), \(only\ with\ \
\(alkali\^+\)\ \ \(NH\_4\%+\)\ \ Ba\^\(\(2\)\(+\)\)\), "hydroxide"},
          {\(\(CO\_3\^-\)\ \ PO\_4\%\(\(3\)\(-\)\)\ \ S\^\(\(2\)\(-\)\)\), \
\(only\ with\ \(alkali\^+\)\ or\ \(NH\_4\%+\)\), \(carbonate\
\[IndentingNewLine]phosphate\)},
          {\(\(if\ dissasociation\)\[IndentingNewLine]\(or\ association\ or\)\
\[IndentingNewLine]\(\(equilibria\)\(\ \)\(shift\)\(\ \)\)\), \(\(froms\ \
\((more)\) 
              water\ salt\ precipitate\)\[IndentingNewLine]\(gas\ pressure\ \
heat\ light\ resistance\)\[IndentingNewLine]\(\(\(equilibria\)\(\ \)\(\
\[LeftArrow]\)\) \[Rule] \ or\ weight\ change\)\), "titrates"}
          },
        ColumnAlignments->{Center},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(convdisp3 = 
      GridBox[convtxt3[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {" ", \(Other\ Data\), " ", " "},
          {\(m\_e\), \(Electron\ Mass\), 
            "=", \(9.109\[Times]10\^\(-28\)\ \ Gram\)},
          {"C", \(Electron\ Charge\), "=", \(eV\ \ \ Joules\ of\ Work\)},
          {"c", \(Speed\ of\ Light\), 
            "=", \(\(2.997\[Times]10\^6\)\ \ Meter\ /\ Second\)},
          {" ", "STP", "=", \(0\ \[Degree]\ Celsius\ , 1\ \ Atmosphere\)},
          {\(\(\ \)\(Vg\)\), \(Gas\ Volume\), 
            "=", \(22.4\ \ Liters\ /\ Mole\ \ @\ STP\)},
          {"R", \(Gas\ Constant\), "=", \(8.20\ c\ Vg\ , \ 
            P\ V = mol\ R\ T\)},
          {"R", \(Gas\ Constant\), "=", \(8.314\ \ J/K\ mol\)},
          {" ", \(Earth\ Radius\), "=", \(6.37`*^6\ \ Meter\)},
          {"Ge", \(Earth\ Gravity\), "=", \(9.80\ Meter\ /\ Second\^2\)},
          {"G", \(Gravity\ \((m\ m`/r\^2)\)\), 
            "=", \(6.672\ \ 10\^\(-11\)\ N\ m\^2/kg\^2\)},
          {" ", \(Air\ Density\), 
            "=", \(1.2\ k\ Gram\ /\ \(Meter\^3\)\ \ @20  \[Degree]\ C\)},
          {" ", \(Water\ Density\), "=", \(10\^6\ \ Gram\ /\ Meter\^3\)},
          {"pH", "acids", "<", \(water\ \((7)\)\  < \ bases\)},
          {\(32  \[Degree]\ F\), \(273.15\ Kelvin\), 
            "=", \(32 + 0  Celsius\ 9/5\)}
          },
        ColumnAlignments->{Center},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(convdisp4 = 
      GridBox[convtxt4[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input"],

Cell[BoxData[
    TagBox[GridBox[{
          {" ", "Conversions", " ", " "},
          {"amu", "AtomicMassUnit", 
            "=", \(Gram\ \ /\ \ \((Mole\ \ or\ \ N\_A)\)\)},
          {\(N\_A\), 
            FormBox["AvogadroConstant",
              "InputForm"], "=", \(6.02214\[Times]10\^23\ \ Atoms\)},
          {" ", \(one\ amu\ weighs\), 
            "=", \(1.66054\[Times]10\^\(-24\)\ \ Gram\)},
          {"eV", "ElectronVolt", 
            "=", \(\(1.60218\[Times]10\^\(-19\)\)\ \ Joule\)},
          {"\[Angstrom]", "Angstrom", "=", \(1.`*^-10\ \ Meter\)},
          {"W", "Watt", "=", \(Joule\ /\ Second\)},
          {"\[Placeholder]", \(1\ \ Columb\), 
            "=", \(1\ \ eV\ \ Joule\ of\ Work\)},
          {\(32  \[Degree]\), \(F\  = \ 273.15\ Kelvin\), 
            "=", \(32 + 0  Celsius\ 9/5\)},
          {\(F\ d\), \(Work\  = \ Energy\), 
            "=", \(mass\ \ acceleration\ dist\)},
          {" ", "Lanthenides", "=", \(Elems\ \ 58 - 71\)},
          {" ", "Actinides", "=", \(Elems\ \ 90 - 103\)},
          {" ", \(acids\ donate\), "=", \(bases\ \(take : \ ions\)\)},
          {" ", "amu", "~", \(6.2\ /\ specific\ heat\)},
          {" ", \(ionic\ bonds\ pair\), "=", \(outer\ elec\ totaling\ 8\)},
          {" ", \( .5 < 1.5 < EN\), 
            "=", \(\(covalent < polar < 
              ionic\)\[IndentingNewLine]\(polar\ if\ \ en1 \[NotEqual] 
              en2\)\)}
          },
        ColumnAlignments->{Center},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell[BoxData[
    \( (*\ convdisp5\ done\ *) \)], "Input"],

Cell["(* pin to top rows of chart since bottom moves around *)", "Text"],

Cell[BoxData[
    \(dh =. ; dw =. ;\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(dh = \((opos[1, whereis[Lithium]] - 
            opos[1, whereis[Magnesium]])\)[\([3]\)]\)], "Input"],

Cell[BoxData[
    \(35.06493506493504`\)], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(dw = \((opos[1, whereis[Magnesium]] - 
            opos[1, whereis[Lithium]])\)[\([1]\)]\)], "Input"],

Cell[BoxData[
    \(28.977272727272723`\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(convgrc = 
        go2D[\([1, 1, \((\((chartheight - 2)\)\ chartwidth)\) + 13, 
              2]\)] + {14, \(-18\)};\)\)], "Input"],

Cell[BoxData[
    \(\(convgrc = 
        go2D[\([1, 1, whereis[Strontium] + 5, 2]\)] + {15, 10};\)\)], "Input"],

Cell[BoxData[
    \(\(If[
        widechart === False, \[IndentingNewLine]convgrc = 
          go2D[\([1, 1, whereis[Ununnilium] - 1, 2]\)] + {0, \(-dh\)\ 2.25}, 
        convgrc = 
          go2D[\([1, 1, whereis[Strontium] + 5, 2]\)] + {15, 
              10}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ go2D[\([1, 1, whereis[Beryllium] + 11, 2]\)]\ *) \)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(go2D[\([1, 1, whereis[Boron] - 7, 2]\)] + {0, 0}\n == 
      go2D[\([1, 1, whereis[Beryllium] + 11, 2]\)]\)], "Input"],

Cell[BoxData[
    \(False\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(convgrc2 = 
        go2D[\([1, 1, whereis[ (*Boron*) Carbon] - 6, 2]\)] + {\(-15\), 
            0};\)\)], "Input"],

Cell[BoxData[
    \(\(convgrc3 = 
        go2D[\([1, 1, \((\((chartheight - 2)\)\ chartwidth)\) + 13, 
              2]\)] + {14, \(-18\)};\)\)], "Input"],

Cell[BoxData[
    \(\(convgrc4 = 
        go2D[\([1, 1, \((\((chartheight - 2)\)\ chartwidth)\) + 13, 
              2]\)] + {14, \(-18\)};\)\)], "Input"],

Cell["\<\
(* if so this may change aspect ratio and would anyway may be \
chopped , so move it safely above with other stuff *)\
\>", "Text"],

Cell[BoxData[
    \(\(If[widechart === False, 
        convgrc5 = \[IndentingNewLine]go2D[\([1, 
                1, \[IndentingNewLine]whereis[Americium]\[IndentingNewLine] + 
                  Last[groupdrop] - First[groupdrop] + 
                  2, \[IndentingNewLine]2]\)] + {0, \(-dh\)\ 2.25}, \
\[IndentingNewLine]convgrc5 = 
          go2D[\([1, 1, whereis[Strontium] + 9, 2]\)] + {0, 
              15}\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr = 
        Graphics[
          Text[convdisp, convgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr3D = 
        Graphics3D[
          Text[convdisp, Insert[convgrc, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr2 = 
        Graphics[
          Text[convdisp2, convgrc2, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr23D = 
        Graphics3D[
          Text[convdisp2, Insert[convgrc2, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr3 = 
        Graphics[
          Text[convdisp3, convgrc3, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr33D = 
        Graphics3D[
          Text[convdisp3, Insert[convgrc3, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr4 = 
        Graphics[
          Text[convdisp4, convgrc4, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr43D = 
        Graphics3D[
          Text[convdisp4, Insert[convgrc4, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr5 = 
        Graphics[
          Text[convdisp5, convgrc5, 
            TextStyle \[Rule] {FontSize \[Rule] 1.1}]];\)\)], "Input"],

Cell[BoxData[
    \(\(convgr53D = 
        Graphics3D[
          Text[convdisp5, Insert[convgrc5, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.1}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
  "unused conversion table - OLD\n",
  StyleBox["\tOutputForm is broken / missing fonts for EPS with tables at \
least",
    FontSize->10]
}], "Subsubsection"],

Cell[BoxData[GridBox[{
        {"amu", "AtomicMassUnit", "=", \(1.6605402`*^-27\ Gram\ \ Kilo\)},
        {"mol", "Mole", "=", 
          FormBox[\(AvogadroConstant\ \ Atoms\),
            "InputForm"]},
        {\(N\_A\), 
          FormBox["AvogadroConstant",
            "InputForm"], "=", "6.0221367`*^23"},
        {"eV", "ElectronVolt", "=", \(1.60217733`*^-22\ Joule\ \ Kilo\)},
        {"A", "Angstrom", "=", \(1.`*^-10\ Meter\)},
        {"W", "Watt", "=", \(Joule/Second\)},
        {" ", "Lanthenides", "=", \(Elems\ \ 58, 17\)},
        {" ", "Actinides", "=", \(Elems\ \ 90, 103\)}
        }]], "Text"],

Cell[BoxData[
    \(\(convtxtbw = snaptxt[];\)\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(convdispbw = 
      GridBox[convtxtbw[\([1, 1, 1]\)], RowLines \[Rule] True, 
          ColumnLines \[Rule] True, GridFrame \[Rule] True, 
          ColumnAlignments \[Rule] {Center}] // DisplayForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[GridBox[{
          {"amu", "AtomicMassUnit", "=", \(1.6605402`*^-27\ Gram\ \ Kilo\)},
          {"mol", "Mole", "=", 
            FormBox[\(AvogadroConstant\ \ Atoms\),
              "InputForm"]},
          {\(N\_A\), 
            FormBox["AvogadroConstant",
              "InputForm"], "=", "6.0221367`*^23"},
          {"eV", "ElectronVolt", "=", \(1.60217733`*^-22\ Joule\ \ Kilo\)},
          {"A", "Angstrom", "=", \(1.`*^-10\ Meter\)},
          {"W", "Watt", "=", \(Joule/Second\)},
          {" ", "Lanthenides", "=", \(Elems\ \ 58, 17\)},
          {" ", "Actinides", "=", \(Elems\ \ 90, 103\)}
          },
        ColumnAlignments->{Center},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      DisplayForm]], "Output"]
}, Closed]],

Cell["\<\
Output form of table this is still broken, missing \"/\" fonts at \
least, for EPS and worse it spreads columsn way far apart if OutputForm is \
used.  Not interested in providing a fix or substitute for legends as they \
are easily made upon particular need.

OutputForm does boxing for expressions nicely, but it's table output is poor \
/ practically non-existent.

Because of this printcell[] is made.  This does B&W and Color both better \
than OutputForm (noting allot of odat[] data is still using Output form).  \
Tis broken with or without.\
\>", "Text"],

Cell[BoxData[
    \(\(convgrbw = 
        Graphics[
          Text[\(convdispbw, convgrc, 
                TextStyle \[Rule] {FontSize \[Rule] 1.5}\) (*\ 
                  BROKEN\ *) \ \ FormatType -> OutputForm\ ]];\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["notes gr   -  errata  (diff style)", "Subsubsection"],

Cell["\<\
\t* CRC 52nd B-3 reports: physical properties of elements may \
change
      drastically with small ammounts of impurity,also that some
      allotropes data's may be tentative.
\t** fill order CRC 52nd B-2,but shell order CRC 79th says chem.m
      (difference left \"as-is\").  fill order shows+-for irregularies to
      \"simple\" fill rule (actual rules can change)
\t* ElectronAffinity if shown will not indicate direction of a value
       of 0 and note EA is rather erratic and 0s  direction is erratic.
      \t* FIP, if 0, does not if know to be <0 or >0.\
\>", "Text"],

Cell[BoxData[
    TagBox[GridBox[{
          {\(\(\(*\)\(\ \)\(CRC\)\(\ \)\(52\)  \(nd\)\(\ \)\(B\)\) - 
              3\ \(\(reports\)\(:\)\)\ physical\ properties\ of\ elements\ \
may\ change\ drastically\ with\ small\ ammounts\ of\ \(\(impurity\)\(,\)\)\ \
also\ that\ some\ allotropes\ data' 
                s\ may\ be\ \(\(tentative\)\(.\)\(\ \ \ \ \ \ \ \ \ \ \ \ \ \ \
\ \ \ \ \ \)\)\)},
          {\(\(\(*\)\(\ \)\(fill\)\(\ \)\(order\)\(\ \)\(CRC\)\(\ \)\(52\)  \
\(nd\)\(\ \)\(B\)\) - 
              2\ but\ shell\ order\ CRC\ 79  
                th\ says\ chem . 
                  m\ \((difference\ left\ "as-is")\) . \ \ fill\ order\ shows\
\  + \(-\ 
                  for\)\ irregularies\ to\ "simple"\ fill\ rule\ \((actual\ \
rules\ can\ change)\)\)},
          {\(\(\(*\)\(\ \)\(ElectronAffinity\)\(\ \)\(if\)\(\ \)\(shown\)\(\ \
\)\(will\)\(\ \)\(not\)\(\ \)\(indicate\)\(\ \)\(direction\)\)\
\[IndentingNewLine]
            \ \ \ of\ a\ value\ of\ 0\ and\ note\ EA\ is\ erratic\ and\ \
direction\ as\ \(\(well\)\(.\)\)\)},
          {\(\(\(*\)\(\ \)\(ie . \ IIIA\)\(\ \)\(IIIB\)\), \ 
            B\ is\ used\ in\ various\ texts\ ad - hoc\)}
          },
        ColumnWidths->32,
        ColumnAlignments->{Left},
        GridFrame->True,
        RowLines->True,
        ColumnLines->True],
      (ColumnsEqual -> True)]], "Text"],

Cell[BoxData[
    \(\(notes = snaptxt[];\)\)], "Input"],

Cell[BoxData[
    \(\(notesdisp = 
        GridBox[notes[\([1, 1, 1, 1]\)], ColumnAlignments \[Rule] {Left}, 
            ColumnWidths \[Rule] 32, ColumnLines \[Rule] False, 
            RowSpacings \[Rule] 2.0, GridFrame \[Rule] False, 
            RowLines \[Rule] True, ColumnsEqual \[Rule] True] // 
          DisplayForm;\)\)], "Input"],

Cell[BoxData[
    \(dh =. ; dw =. ;\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(dh = \((opos[1, 1 + chartwidth] - opos[1, 1])\)[\([3]\)]\)], "Input"],

Cell[BoxData[
    \(35.064935064935064`\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(dh *= helpcellmul[\([3]\)];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(dw = \((opos[1, 2] - opos[1, 1])\)[\([1]\)]\)], "Input"],

Cell[BoxData[
    \(28.977272727272723`\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(dw *= helpcellmul[\([1]\)]/2;\)\)], "Input"],

Cell["\<\
pin just below helpcell slightly haphazardously, using most current \
values for it.\
\>", "Text"],

Cell[BoxData[
    \(\(notesgrc = 
        Delete[opos[1, helpcell], 2] + {\(-dw\)/2, \(-dh\)} + {20, 
            15};\)\)], "Input"],

Cell[BoxData[
    \(dh =. ; dw =. ;\)], "Input"],

Cell[BoxData[
    \(\(notesgr = 
        Graphics[
          Text[notesdisp, notesgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ Show[%]*) \)], "Input"],

Cell[BoxData[
    \(\(notesgr3D = 
        Graphics3D[
          Text[notesdisp, Insert[notesgrc, 1, 2], 
            TextStyle \[Rule] {FontSize \[Rule] 1.5}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
unused: warntxt same as notes but shows a way to snap plain text \
into plot\
\>", "Subsubsection"],

Cell["\<\
\t* CRC 52nd B-3 reports: physical properties of elements may \
change
      drastically with small ammounts of impurity,also that some
      allotropes data's may be tentative.
\t** fill order CRC 52nd B-2,but shell order CRC 79th says chem.m
      (difference left \"as-is\").  fill order shows+-for irregularies to
      \"simple\" fill rule (actual rules can change)\
\>", "Text"],

Cell[BoxData[
    \(\(warntxt = snaptxt[];\)\)], "Input"],

Cell["\<\
(*
WORKS better than NotebookCreate, but prolog et al are in this, and Graphics \
wants only \"included code\"
*)\
\>", "Text"],

Cell[BoxData[
    \( (*\ \(epstxt = 
          StringJoin[
            Import["\<warntxt.eps\>", "\<Lines\>"]];\)\ *) \)], "Input"],

Cell[TextData[{
  "(*\nanother bug: ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Import used Windows font though Options say not to and file uses \
\"Times\". \n*)"
}], "Text"],

Cell[TextData[{
  "(*\nanother bug: ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " writes PS differently than it reads it here.  Import takes (\"text\") \
show text literally.  But example \"\\)\" is ) but it BECOMES \
Text[\"\\)\",TextStyle->{FontFamily->Windows}] which ain't useful.  Obviously \
when Exported \")\" became \"\\)\" and gv likes or needs that.  Didn't expect \
perfect PS importi anyway i guess.  I've tried it before with no luck.  ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  "'s PS output is complex but it reader is not: it has no \"distiller\".\n\
*)"
}], "Text"],

Cell[BoxData[
    \( (*\ WORKS\ SOME\ Export["\<warntxt.eps\>", warntxt, "\<EPS\>"]; \n
      eps = Import["\<warntxt.eps\>", "\<EPS\>"]; Show[eps];*) \)], "Input"],

Cell["\<\
(*
SO.  Using Text to make Graphics is easier as far as getting things into the \
Plot.  Graphics can't combine eps into plots.
*)\
\>", "Text"],

Cell[BoxData[
    \(\(warntxtgrc = 
        go2D[\([1, 1, \((2\ chartwidth)\) + 5, 2]\)] + {\(-10\), 
            0};\)\)], "Input"],

Cell[BoxData[
    \(\(warntxtgr = 
        Graphics[
          Text[warntxt[\([1]\)], warntxtgrc + {0, 25}, 
            TextStyle \[Rule] {FontSize \[Rule] 1, 
                PageWidth \[Rule] 150}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["editors mark", "Subsubsection"],

Cell[BoxData[
    \(\(edgrc = go2D[\([1, 1, helpcell, 2]\)] + {70, \(-30\)};\)\)], "Input"],

Cell[BoxData[
    \(\(edgr = 
        Graphics[
          Text["\<-- JH\>", edgrc, 
            TextStyle \[Rule] {FontSize \[Rule] 1}]];\)\)], "Input"],

Cell[BoxData[
    \(\(edgr3D = 
        Graphics3D[
          Text["\<-- JH\>", 
            Insert[edgrc, 1, 
              2], \[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
                  1}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["title gr", "Subsubsection"],

Cell[BoxData[
    \(\(titlegrc = 
        go2D[\([1, 1, whereis[Helium] - 5, 2]\)] + {20, 7};\)\)], "Input"],

Cell[BoxData[
    \(\(titlegr = 
        Graphics[
          Text["\<Periodic Table of the Elements\>", titlegrc, 
            TextStyle \[Rule] {FontSize \[Rule] 6}]];\)\)], "Input"],

Cell[BoxData[
    \(\(titlegr3D = 
        Graphics3D[
          Text["\<Periodic Table of the Elements\>", 
            Insert[titlegrc, 1, 
              2], \[IndentingNewLine]TextStyle \[Rule] {FontSize \[Rule] 
                  6}]];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["colheadgr2D  xxx  boxes", "Subsubsection"],

Cell[BoxData[
    \(\(colhead2D =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(colhead2D = Table[{}, {i, chartwidth}];\)\)], "Input"],

Cell[BoxData[
    \(\(colhead3D =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(colhead3D = Table[{}, {i, chartwidth}];\)\)], "Input"],

Cell["unused:  use to get on top of / resting on", "Text"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, v, w, i, j, 
          dh}, \[IndentingNewLine]sc = {3.5, 
              1, \((10.0/
                  4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]dh = 
          opos[1, objlen] - 
            opos[1, objlen - 
                chartwidth]; \[IndentingNewLine]dh *=  .8; \
\[IndentingNewLine]w = {7, 6, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 4, 4, 
            4, 4, 4, 4, 4, 4, 4, 4, 6, 6, 6, 6, 6, 7}; \[IndentingNewLine]j = 
          Table[\[IndentingNewLine]\((\((w[\([i]\)] - 1)\)\ chartwidth)\) + 
              i\[IndentingNewLine], {i, 
              chartwidth}\[IndentingNewLine]]; \[IndentingNewLine]Do[\
\[IndentingNewLine]v = 
            boxpts[opos[1, j[\([i]\)]] + dh, sc, ul, ll, lr, ur, 
              True]; \[IndentingNewLine]colhead2D[\([i]\)] = 
            boxnocorners[v,  .1];\[IndentingNewLine], {i, 
            chartwidth}\[IndentingNewLine]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell["\<\
todo ? some like these designations # s[1-2] d[3-12] p[13-18] f[for \
actinide]\
\>", "Text"],

Cell[BoxData[
    \( (*\[IndentingNewLine]\(Do[\[IndentingNewLine]v = 
            boxpts[opos[1, \((\((chartheight - 1)\)\ chartwidth)\) + i] + dh, 
              sc, ul, ll, lr, ur, 
              True]; \[IndentingNewLine]colhead2D[\([i]\)] = 
            boxnocorners[v,  .1];\[IndentingNewLine], {i, 
            32}\[IndentingNewLine]];\)\[IndentingNewLine]*) \)], "Input"],

Cell[BoxData[
    \( (*\ \(Show[Graphics[{First[%%], Take[%%, \(-2\)]}]];\)\ *) \)], "Input"],

Cell["straight across top", "Text"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, v, w, i, j, 
          dh}, \[IndentingNewLine]sc = {3.5, 
              1, \((5.0/
                  4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]dh = 
          opos[1, objlen] - 
            opos[1, objlen - chartwidth]; \[IndentingNewLine]dh *=  .71;  (*\ 
          lower\ moves\ box\ down\ *) \[IndentingNewLine]Do[\
\[IndentingNewLine]v = 
            boxpts[opos[1, \((\((chartheight - 1)\)\ chartwidth)\) + i] + dh, 
              sc, ul, ll, lr, ur, 
              True]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            w = boxnocorners[
                v,  .1]; \[IndentingNewLine]colhead2D[\([i]\)] = {First[w], 
                Take[w, \(-2\)]};*) \[IndentingNewLine]\[IndentingNewLine]w = 
            boxcorners[v,  .1, 2]; \[IndentingNewLine]colhead2D[\([i]\)] = 
            w;\[IndentingNewLine]\[IndentingNewLine], {i, 
            chartwidth}\[IndentingNewLine]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(colhead2Dgr = 
        Graphics[{Thickness[ .0001], RGBColor[ .2, 0,  .2], 
            colhead2D}];\)\)], "Input"],

Cell["(* same for 3D *)", "Text"],

Cell[BoxData[
    \(\(Module[{sc, ul, ll, lr, ur, v, w, i, j, 
          dh}, \[IndentingNewLine]sc = {3.5, 
              1, \((5.0/
                  4.0)\)}\ 100; \[IndentingNewLine]ul = {\(- .04\),  .01,  \
.04}; \nll = {\(- .04\),  .01, \(- .04\)}; \nlr = { .04,  .01, \(- .04\)}; \n
        ur = { .04,  .01,  .04}; \[IndentingNewLine]dh = 
          opos[1, objlen] - 
            opos[1, objlen - chartwidth]; \[IndentingNewLine]dh *=  .71;  (*\ 
          lower\ moves\ box\ down\ *) \[IndentingNewLine]Do[\
\[IndentingNewLine]v = 
            boxpts[opos[1, \((\((chartheight - 1)\)\ chartwidth)\) + i] + dh, 
              sc, ul, ll, lr, ur, 
              False]; \[IndentingNewLine]\[IndentingNewLine] (*\ 
            w = boxnocorners[
                v,  .1]; \[IndentingNewLine]colhead3D[\([i]\)] = {First[w], 
                Take[w, \(-2\)]};*) \[IndentingNewLine]\[IndentingNewLine]w = 
            boxcorners[v,  .1, 2]; \[IndentingNewLine]colhead3D[\([i]\)] = 
            w;\[IndentingNewLine]\[IndentingNewLine], {i, 
            chartwidth}\[IndentingNewLine]];\[IndentingNewLine]];\)\)], \
"Input"],

Cell[BoxData[
    \(\(colhead3Dgr = 
        Graphics3D[{Thickness[ .0001], RGBColor[ .2, 0,  .2], 
            colhead3D}];\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["wtf  arrow", "Subsubsection"],

Cell[BoxData[
    \(\(laline = \[IndentingNewLine]Graphics[{Thickness[ .0001], 
            RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[{\
\[IndentingNewLine]go22D[\([1, whereis[Lanthanum], 1, 3, 1, 
                    3]\)], \[IndentingNewLine]go22D[\([1, whereis[Cerium], 1, 
                    3, 1, 1]\)]\[IndentingNewLine]}]\[IndentingNewLine]}];\)\)\
], "Input"],

Cell[BoxData[
    \(\(laline = 
        Module[{v, 
            w}, \[IndentingNewLine]v = {go22D[\([1, whereis[Lanthanum], 1, 3, 
                  1, 3]\)], \[IndentingNewLine]go22D[\([1, whereis[Cerium], 
                  1, 3, 1, 
                  1]\)]}; \[IndentingNewLine]\(w = \((v[\([2]\)] - 
                      v[\([1]\)])\)/
                  4;\)\[IndentingNewLine]\(v = {v[\([1]\)] + {4, \(-4\)}, 
                v[\([1]\)] + 
                  w + {4, \(-4\)}}\); \[IndentingNewLine]Graphics[{Thickness[ \
.0001], RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Arrow[v[\([1]\)], 
                v[\([2]\)], \ 
                HeadScaling \[Rule] 
                  Relative]\[IndentingNewLine]}]];\)\)], "Input"],

Cell["(* snafu - need to make arrow anyhow *)", "Text"],

Cell[BoxData[
    \(\(laline3D = 
        Module[{v, 
            w}, \[IndentingNewLine]v = {go2[\([1, whereis[Lanthanum], 1, 3, 
                  1, 3]\)], \[IndentingNewLine]go2[\([1, whereis[Cerium], 1, 
                  3, 1, 1]\)]}; \[IndentingNewLine]\(w = \((v[\([2]\)] - 
                      v[\([1]\)])\)/
                  4;\)\[IndentingNewLine]\(v = {v[\([1]\)] + {4, 0, \(-4\)}, 
                v[\([1]\)] + 
                  w + {4, 
                    0, \(-4\)}}\); \[IndentingNewLine]Graphics3D[{Thickness[ \
.0001], RGBColor[ .1,  .1,  .6], \[IndentingNewLine]Line[{v[\([1]\)], 
                  v[\([2]\)]}], \[IndentingNewLine]Line[{v[\([2]\)], 
                  v[\([2]\)] + {2, 0, 
                      4}}] (*\(,\)\(\[IndentingNewLine]\)\(\ \
\)\(Line[{v[\([2]\)], 
                    v[\([2]\)] + {\(-2\), 0, 
                        4}}]\)\ *) \[IndentingNewLine]}]\[IndentingNewLine]];\
\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[%]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 3.67954 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.44724 3.90169 -0.222153 3.90169 [
[ 0 0 0 0 ]
[ 1 3.67954 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.08139 .21494 m
0 3.39395 L
s
0 3.39395 m
.33417 3.67954 L
s
.33417 3.67954 m
.36073 .55144 L
s
.36073 .55144 m
.08139 .21494 L
s
.65374 0 m
.92074 .34936 L
s
.92074 .34936 m
1 3.50843 L
s
1 3.50843 m
.68335 3.20979 L
s
.68335 3.20979 m
.65374 0 L
s
.08139 .21494 m
0 3.39395 L
s
0 3.39395 m
.68335 3.20979 L
s
.68335 3.20979 m
.65374 0 L
s
.65374 0 m
.08139 .21494 L
s
.36073 .55144 m
.92074 .34936 L
s
.92074 .34936 m
1 3.50843 L
s
1 3.50843 m
.33417 3.67954 L
s
.33417 3.67954 m
.36073 .55144 L
s
0 0 m
1 0 L
1 3.67954 L
0 3.67954 L
closepath
clip
newpath
.1 .1 .6 r
.0001 w
.23541 .44427 m
.26908 2.35522 L
s
.26908 2.35522 m
.82671 3.27615 L
s
0 g
.25 Mabswid
.65374 0 m
.92074 .34936 L
s
.92074 .34936 m
1 3.50843 L
s
1 3.50843 m
.68335 3.20979 L
s
.68335 3.20979 m
.65374 0 L
s
.08139 .21494 m
0 3.39395 L
s
0 3.39395 m
.68335 3.20979 L
s
.68335 3.20979 m
.65374 0 L
s
.65374 0 m
.08139 .21494 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{78.25, 287.875},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40001>00017a000`40n007h00OC_oo000aool2000K
ool002ooo`800003ool0000001[oo`00;?oo0`000ooo00<00?oo00006Ooo000Yool30006ool00`00
ool0000Iool002Ooo`8000Woo`04003ooooo000Hool002Coo`<000_oo`05003oooooool0000Gool0
02;oo`8000koo`03003ooooo00;oo`03003ooooo01Coo`007ooo0`004?oo00<00?ooool00_oo00<0
0?ooool05?oo000Lool3000Cool00`00ooooo`03ool00`00ooooo`0Cool001[oo`8001Koo`03003o
oooo00Coo`03003ooooo01;oo`005ooo0`006?oo00<00?ooool01Ooo00<00?ooool04Ooo000Eool2
000Kool00`00ooooo`06ool00`00ooooo`0@ool001;oo`<001goo`03003ooooo00Koo`03003ooooo
013oo`004?oo0P008?oo00<00?ooool01ooo00<00?ooool03ooo000=ool3000Rool00`00ooooo`08
ool00`00ooooo`0>ool000[oo`<002Goo`03003ooooo00Woo`03003ooooo00goo`002?oo0P00:?oo
00<00?ooool02Ooo00<00?ooool03Ooo0006ool2000Zool00`00ooooo`0:ool00`00ooooo`0<ool0
00Koo`8002[oo`03003ooooo00_oo`03003ooooo00_oo`001_oo00<00?oo0000:Ooo00<00?ooool0
3?oo00<00?ooool02_oo0006ool00`00ool0000Yool00`00ooooo`0=ool00`00ooooo`09ool000Ko
o`04003ooooo000Xool00`00ooooo`0=ool00`00ooooo`09ool000Koo`05003oooooool0000Wool0
0`00ooooo`0>ool00`00ooooo`08ool000Koo`03003ooooo00;oo`03003ooooo02Coo`03003ooooo
00ooo`03003ooooo00Ooo`001_oo00<00?ooool00ooo00<00?ooool08ooo00<00?ooool04?oo00<0
0?ooool01_oo0006ool00`00ooooo`03ool00`00ooooo`0Sool00`00ooooo`0@ool00`00ooooo`06
ool000Koo`03003ooooo00Coo`03003ooooo02;oo`03003ooooo017oo`03003ooooo00Goo`001_oo
00<00?ooool01Ooo00<00?ooool08Ooo00<00?ooool04Ooo0P001_oo0006ool00`00ooooo`06ool0
0`00ooooo`0Pool00`00ooooo`0>ool300000ooo003oo`05ool000Koo`03003ooooo00Ooo`03003o
oooo01ooo`03003ooooo00coo`8000Coo`03003ooooo00Coo`001_oo00<00?ooool01ooo00<00?oo
ool07ooo00<00?ooool02Ooo0`001_oo00<00?ooool01?oo0006ool00`00ooooo`08ool00`00oooo
o`0Nool00`00ooooo`06ool30009ool00`00ooooo`04ool000Koo`03003ooooo00Woo`03003ooooo
01goo`03003ooooo00?oo`<000coo`03003ooooo00Coo`001_oo00<00?ooool02_oo00<00?ooool0
7?oo00@00?ooooooo`8000ooo`03003ooooo00Coo`001_oo00<00?ooool02Ooo00<Hdooo00007Ooo
10004Ooo00<00?ooool01?oo0006ool00`00ooooo`09ool011SCooooo`006_oo0`005?oo00<00?oo
ool01?oo0006ool00`00ooooo`09ool011SCooooo`005ooo0`000_oo00<00?ooool04_oo00<00?oo
ool01?oo0006ool00`00ooooo`09ool01ASCoooooooo00005?oo0P001Ooo00<00?ooool04_oo00<0
0?ooool01?oo0005ool00`00ooooo`0:ool00aSCooooo`02ool00`00ooooo`0>ool30007ool00`00
ooooo`0Bool00`00ooooo`04ool000Goo`03003ooooo00[oo`036=?ooooo00?oo`03003ooooo00[o
o`<000[oo`03003ooooo01;oo`03003ooooo00Coo`001Ooo00<00?ooool02_oo00<Hdoooool01?oo
00<00?ooool01_oo0`003Ooo00<00?ooool04_oo00<00?ooool01?oo0005ool00`00ooooo`0:ool0
0aSCooooo`04ool00`00ooooo`04ool2000@ool00`00ooooo`0Bool00`00ooooo`04ool000Goo`03
003ooooo00[oo`036=?ooooo00Goo`03003ooooo00<001;oo`03003ooooo01;oo`03003ooooo00Co
o`001Ooo00<00?ooool02_oo00<Hdoooool01_oo0P005Ooo00<00?ooool04_oo00<00?ooool01?oo
0005ool00`00ooooo`0:ool00aSCooooo`06ool00`00ooooo`0Dool00`00ooooo`0Bool00`00oooo
o`04ool000Goo`03003ooooo00[oo`036=?ooooo00Koo`03003ooooo01Coo`03003ooooo01;oo`03
003ooooo00Coo`001Ooo00<00?ooool02_oo00<Hdoooool01_oo00<00?ooool05?oo00<00?ooool0
4_oo00<00?ooool01?oo0005ool00`00ooooo`0:ool00aSCooooo`06ool00`00ooooo`0Dool00`00
ooooo`0Bool00`00ooooo`04ool000Goo`03003ooooo00[oo`036=?ooooo00Koo`03003ooooo01Co
o`03003ooooo01?oo`03003ooooo00?oo`001Ooo00<00?ooool02_oo00<Hdoooool01_oo00<00?oo
ool05?oo00<00?ooool04ooo00<00?ooool00ooo0005ool00`00ooooo`0:ool00aSCooooo`06ool0
0`00ooooo`0Dool00`00ooooo`0Cool00`00ooooo`03ool000Goo`03003ooooo00[oo`036=?ooooo
00Koo`03003ooooo01Coo`03003ooooo01?oo`03003ooooo00?oo`001Ooo00<00?ooool02_oo00<H
doooool01_oo00<00?ooool05?oo00<00?ooool04ooo00<00?ooool00ooo0005ool00`00ooooo`0:
ool00aSCooooo`06ool00`00ooooo`0Dool00`00ooooo`0Cool00`00ooooo`03ool000Goo`03003o
oooo00[oo`036=?ooooo00Koo`03003ooooo01Coo`03003ooooo01?oo`03003ooooo00?oo`001Ooo
00<00?ooool02_oo00<Hdoooool01_oo00<00?ooool05?oo00<00?ooool04ooo00<00?ooool00ooo
0005ool00`00ooooo`0:ool00aSCooooo`06ool00`00ooooo`0Dool00`00ooooo`0Cool00`00oooo
o`03ool000Goo`03003ooooo00[oo`036=?ooooo00Koo`03003ooooo01Coo`03003ooooo01?oo`03
003ooooo00?oo`001Ooo00<00?ooool02_oo00<Hdoooool01_oo00<00?ooool05?oo00<00?ooool0
4ooo00<00?ooool00ooo0005ool00`00ooooo`0:ool00aSCooooo`06ool00`00ooooo`0Dool00`00
ooooo`0Cool00`00ooooo`03ool000Goo`03003ooooo00[oo`036=?ooooo00Koo`03003ooooo01Co
o`03003ooooo01?oo`03003ooooo00?oo`001Ooo00<00?ooool02_oo00<Hdoooool01_oo00<00?oo
ool05?oo00<00?ooool04ooo00<00?ooool00ooo0005ool00`00ooooo`0:ool00aSCooooo`06ool0
0`00ooooo`0Dool00`00ooooo`0Cool00`00ooooo`03ool000Goo`03003ooooo00[oo`036=?ooooo
00Koo`03003ooooo01Goo`03003ooooo01;oo`03003ooooo00?oo`001Ooo00<00?ooool02_oo00<H
doooool01_oo00<00?ooool05Ooo00<00?ooool04_oo00<00?ooool00ooo0005ool00`00ooooo`0:
ool00aSCooooo`06ool00`00ooooo`0Eool00`00ooooo`0Bool00`00ooooo`03ool000Goo`03003o
oooo00[oo`036=?ooooo00Koo`03003ooooo01Goo`03003ooooo01;oo`03003ooooo00?oo`001Ooo
00<00?ooool02_oo00<Hdoooool01_oo00<00?ooool05Ooo00<00?ooool04_oo00<00?ooool00ooo
0005ool00`00ooooo`0:ool00aSCooooo`06ool00`00ooooo`0Eool00`00ooooo`0Bool00`00oooo
o`03ool000Goo`03003ooooo00[oo`036=?ooooo00Koo`03003ooooo01Goo`03003ooooo01;oo`03
003ooooo00?oo`001Ooo00<00?ooool02_oo00<Hdoooool01_oo00<00?ooool05Ooo00<00?ooool0
4_oo00<00?ooool00ooo0005ool00`00ooooo`0:ool00aSCooooo`06ool00`00ooooo`0Eool00`00
ooooo`0Bool00`00ooooo`03ool000Goo`03003ooooo00_oo`036=?ooooo00Goo`03003ooooo01Go
o`03003ooooo01;oo`03003ooooo00?oo`001Ooo00<00?ooool02ooo00<Hdoooool01Ooo00<00?oo
ool05Ooo00<00?ooool04_oo00<00?ooool00ooo0005ool00`00ooooo`0;ool00aSCooooo`05ool0
0`00ooooo`0Eool00`00ooooo`0Bool00`00ooooo`03ool000Goo`03003ooooo00_oo`036=?ooooo
00Goo`03003ooooo01Goo`03003ooooo01;oo`03003ooooo00?oo`001Ooo00<00?ooool02ooo00<H
doooool01Ooo00<00?ooool05Ooo00<00?ooool04_oo00<00?ooool00ooo0005ool00`00ooooo`0;
ool00aSCooooo`05ool00`00ooooo`0Eool00`00ooooo`0Bool00`00ooooo`03ool000Goo`03003o
oooo00_oo`036=?ooooo00Goo`03003ooooo01Goo`03003ooooo01;oo`03003ooooo00?oo`001?oo
00<00?ooool03?oo00<Hdoooool01Ooo00<00?ooool05Ooo00<00?ooool04_oo00<00?ooool00ooo
0004ool00`00ooooo`0<ool00aSCooooo`05ool00`00ooooo`0Eool00`00ooooo`0Bool00`00oooo
o`03ool000Coo`03003ooooo00coo`036=?ooooo00Goo`03003ooooo01Goo`03003ooooo01;oo`03
003ooooo00?oo`001?oo00<00?ooool03?oo00<Hdoooool01Ooo00<00?ooool05Ooo00<00?ooool0
4_oo00<00?ooool00ooo0004ool00`00ooooo`0<ool00aSCooooo`05ool00`00ooooo`0Eool00`00
ooooo`0Bool00`00ooooo`03ool000Coo`03003ooooo00coo`036=?ooooo00Goo`03003ooooo01Go
o`03003ooooo01;oo`03003ooooo00?oo`001?oo00<00?ooool03?oo00<Hdoooool01Ooo00<00?oo
ool05Ooo00<00?ooool04_oo00<00?ooool00ooo0004ool00`00ooooo`0<ool00aSCooooo`05ool0
0`00ooooo`0Eool00`00ooooo`0Bool00`00ooooo`03ool000Coo`03003ooooo00coo`036=?ooooo
00Goo`03003ooooo01Goo`03003ooooo01;oo`03003ooooo00?oo`001?oo00<00?ooool03?oo00<H
doooool01Ooo00<00?ooool05Ooo00<00?ooool04_oo00<00?ooool00ooo0004ool00`00ooooo`0<
ool00aSCooooo`05ool00`00ooooo`0Eool00`00ooooo`0Cool00`00ooooo`02ool000Coo`03003o
oooo00coo`036=?ooooo00Goo`03003ooooo01Goo`03003ooooo01?oo`03003ooooo00;oo`001?oo
00<00?ooool03?oo00<Hdoooool01Ooo00<00?ooool05Ooo00<00?ooool04ooo00<00?ooool00_oo
0004ool00`00ooooo`0<ool00aSCooooo`05ool00`00ooooo`0Eool00`00ooooo`0Cool00`00oooo
o`02ool000Coo`03003ooooo00coo`036=?ooooo00Goo`03003ooooo01Goo`03003ooooo01?oo`03
003ooooo00;oo`001?oo00<00?ooool03?oo00<Hdoooool01Ooo00<00?ooool05Ooo00<00?ooool0
4ooo00<00?ooool00_oo0004ool00`00ooooo`0<ool00aSCooooo`05ool00`00ooooo`0Eool00`00
ooooo`0Cool00`00ooooo`02ool000Coo`03003ooooo00coo`036=?ooooo00Goo`03003ooooo01Go
o`03003ooooo01?oo`03003ooooo00;oo`001?oo00<00?ooool03?oo00<Hdoooool01Ooo00<00?oo
ool05Ooo00<00?ooool04ooo00<00?ooool00_oo0004ool00`00ooooo`0<ool00aSCooooo`05ool0
0`00ooooo`0Eool00`00ooooo`0Cool00`00ooooo`02ool000Coo`03003ooooo00coo`036=?ooooo
00Goo`03003ooooo01Goo`03003ooooo01?oo`03003ooooo00;oo`001?oo00<00?ooool03?oo00<H
doooool01Ooo00<00?ooool05Ooo00<00?ooool04ooo00<00?ooool00_oo0004ool00`00ooooo`0<
ool00aSCooooo`05ool00`00ooooo`0Eool00`00ooooo`0Cool00`00ooooo`02ool000Coo`03003o
oooo00coo`036=?ooooo00Goo`03003ooooo01Goo`03003ooooo01?oo`03003ooooo00;oo`001?oo
00<00?ooool03?oo00<Hdoooool01Ooo00<00?ooool05Ooo00<00?ooool04ooo00<00?ooool00_oo
0004ool00`00ooooo`0<ool00aSCooooo`04ool00`00ooooo`0Fool00`00ooooo`0Cool00`00oooo
o`02ool000Coo`03003ooooo00coo`036=?ooooo00Coo`03003ooooo01Koo`03003ooooo01?oo`03
003ooooo00;oo`001?oo00<00?ooool03?oo00<Hdoooool01?oo00<00?ooool05_oo00<00?ooool0
4ooo00<00?ooool00_oo0004ool00`00ooooo`0<ool00aSCooooo`04ool00`00ooooo`0Fool00`00
ooooo`0Cool00`00ooooo`02ool000Coo`03003ooooo00coo`036=?ooooo00Coo`03003ooooo01Ko
o`03003ooooo01?oo`03003ooooo00;oo`001?oo00<00?ooool03?oo00<Hdoooool01?oo00<00?oo
ool05_oo00<00?ooool04ooo00<00?ooool00_oo0004ool00`00ooooo`0<ool00aSCooooo`04ool0
0`00ooooo`0Fool00`00ooooo`0Cool00`00ooooo`02ool000Coo`03003ooooo00coo`036=?ooooo
00Coo`03003ooooo01Koo`03003ooooo01?oo`03003ooooo00;oo`001?oo00<00?ooool03?oo00<H
doooool01?oo00<00?ooool05_oo00<00?ooool04ooo00<00?ooool00_oo0004ool00`00ooooo`0<
ool00aSCooooo`04ool00`00ooooo`0Fool00`00ooooo`0Cool00`00ooooo`02ool000Coo`03003o
oooo00coo`036=?ooooo00Coo`03003ooooo01Koo`03003ooooo01?oo`03003ooooo00;oo`001?oo
00<00?ooool03?oo00<Hdoooool01?oo00<00?ooool05_oo00<00?ooool04ooo00<00?ooool00_oo
0004ool00`00ooooo`0<ool00aSCooooo`04ool00`00ooooo`0Fool00`00ooooo`0Cool00`00oooo
o`02ool000Coo`03003ooooo00coo`036=?ooooo00Coo`03003ooooo01Koo`03003ooooo01?oo`03
003ooooo00;oo`001?oo00<00?ooool03?oo00<Hdoooool01?oo00<00?ooool05_oo00<00?ooool0
4ooo00<00?ooool00_oo0004ool00`00ooooo`0<ool00aSCooooo`04ool00`00ooooo`0Fool00`00
ooooo`0Cool00`00ooooo`02ool000?oo`03003ooooo00goo`036=?ooooo00Coo`03003ooooo01Ko
o`03003ooooo01?oo`03003ooooo00;oo`000ooo00<00?ooool03Ooo00<Hdoooool01?oo00<00?oo
ool05_oo00<00?ooool04ooo00<00?ooool00_oo0003ool00`00ooooo`0=ool00aSCooooo`04ool0
0`00ooooo`0Fool00`00ooooo`0Cool00`00ooooo`02ool000?oo`03003ooooo00goo`036=?ooooo
00Coo`03003ooooo01Koo`03003ooooo01?oo`03003ooooo00;oo`000ooo00<00?ooool03Ooo00<H
doooool01?oo00<00?ooool05_oo00<00?ooool04ooo00<00?ooool00_oo0003ool00`00ooooo`0=
ool00aSCooooo`04ool00`00ooooo`0Fool00`00ooooo`0Cool00`00ooooo`02ool000?oo`03003o
oooo00goo`036=?ooooo00Coo`03003ooooo01Koo`03003ooooo01?oo`03003ooooo00;oo`000ooo
00<00?ooool03Ooo00<Hdoooool01?oo00<00?ooool05_oo00<00?ooool04ooo00<00?ooool00_oo
0003ool00`00ooooo`0=ool00aSCooooo`04ool00`00ooooo`0Fool00`00ooooo`0Cool00`00oooo
o`02ool000?oo`03003ooooo00goo`036=?ooooo00Coo`03003ooooo01Koo`03003ooooo01Coo`03
003ooooo007oo`000ooo00<00?ooool03Ooo00<Hdoooool01?oo00<00?ooool05_oo00<00?ooool0
5?oo00<00?ooool00Ooo0003ool00`00ooooo`0=ool00aSCooooo`04ool00`00ooooo`0Fool00`00
ooooo`0Dool00`00ooooo`01ool000?oo`03003ooooo00goo`036=?ooooo00Coo`03003ooooo01Ko
o`03003ooooo01Coo`03003ooooo007oo`000ooo00<00?ooool03Ooo00<Hdoooool01?oo00<00?oo
ool05_oo00<00?ooool05?oo00<00?ooool00Ooo0003ool00`00ooooo`0=ool00aSCooooo`04ool0
0`00ooooo`0Fool00`00ooooo`0Dool00`00ooooo`01ool000?oo`03003ooooo00goo`036=?ooooo
00Coo`03003ooooo01Koo`03003ooooo01Coo`03003ooooo007oo`000ooo00<00?ooool03Ooo00<H
doooool01?oo00<00?ooool05_oo00<00?ooool05?oo00<00?ooool00Ooo0003ool00`00ooooo`0=
ool00aSCooooo`04ool00`00ooooo`0Fool00`00ooooo`0Dool00`00ooooo`01ool000?oo`03003o
oooo00goo`036=?ooooo00Coo`03003ooooo01Koo`03003ooooo01Coo`03003ooooo007oo`000ooo
00<00?ooool03Ooo00<Hdoooool01?oo00<00?ooool05_oo00<00?ooool05?oo00<00?ooool00Ooo
0003ool00`00ooooo`0=ool00aSCooooo`04ool00`00ooooo`0Fool00`00ooooo`0Dool00`00oooo
o`01ool000?oo`03003ooooo00goo`036=?ooooo00Coo`03003ooooo01Koo`03003ooooo01Coo`03
003ooooo007oo`000ooo00<00?ooool03Ooo00<Hdoooool01?oo00<00?ooool05_oo00<00?ooool0
5?oo00<00?ooool00Ooo0003ool00`00ooooo`0=ool00aSCooooo`04ool00`00ooooo`0Fool00`00
ooooo`0Dool00`00ooooo`01ool000?oo`03003ooooo00goo`036=?ooooo00Coo`03003ooooo01Ko
o`03003ooooo01Coo`03003ooooo007oo`000ooo00<00?ooool03Ooo00<Hdoooool01?oo00<00?oo
ool05_oo00<00?ooool05?oo00<00?ooool00Ooo0003ool00`00ooooo`0>ool00aSCooooo`03ool0
0`00ooooo`0Fool00`00ooooo`0Dool00`00ooooo`01ool000?oo`03003ooooo00koo`036=?ooooo
00?oo`03003ooooo01Koo`03003ooooo01Coo`03003ooooo007oo`000ooo00<00?ooool03_oo00<H
doooool00ooo00<00?ooool05_oo00<00?ooool05?oo00<00?ooool00Ooo0003ool00`00ooooo`0>
ool00aSCooooo`03ool00`00ooooo`0Fool00`00ooooo`0Dool00`00ooooo`01ool000?oo`03003o
oooo00koo`036=?ooooo00?oo`03003ooooo01Koo`03003ooooo01Coo`03003ooooo007oo`000ooo
00<00?ooool03_oo00<Hdoooool00ooo00<00?ooool05_oo00<00?ooool05?oo00<00?ooool00Ooo
0003ool00`00ooooo`0>ool00aSCooooo`03ool00`00ooooo`0Fool00`00ooooo`0Dool00`00oooo
o`01ool000?oo`03003ooooo00koo`036=?ooooo00?oo`03003ooooo01Koo`03003ooooo01Coo`03
003ooooo007oo`000ooo00<00?ooool03_oo00<Hdoooool00ooo00<00?ooool05_oo00<00?ooool0
5?oo00<00?ooool00Ooo0003ool00`00ooooo`0>ool00aSCooooo`03ool00`00ooooo`0Fool00`00
ooooo`0Dool00`00ooooo`01ool000?oo`03003ooooo00koo`036=?ooooo00?oo`03003ooooo01Ko
o`03003ooooo01Coo`03003ooooo007oo`000ooo00<00?ooool03_oo00<Hdoooool00ooo00<00?oo
ool05_oo00<00?ooool05?oo00<00?ooool00Ooo0003ool00`00ooooo`0>ool00aSCooooo`03ool0
0`00ooooo`0Fool00`00ooooo`0Dool00`00ooooo`01ool000?oo`03003ooooo00koo`036=?ooooo
00?oo`03003ooooo01Koo`03003ooooo01Coo`03003ooooo007oo`000_oo00<00?ooool03ooo00<H
doooool00ooo00<00?ooool05_oo00<00?ooool05?oo00<00?ooool00Ooo0002ool00`00ooooo`0?
ool00aSCooooo`03ool00`00ooooo`0Fool00`00ooooo`0Dool00`00ooooo`01ool000;oo`03003o
oooo00ooo`036=?ooooo00?oo`03003ooooo01Koo`03003ooooo01Coo`03003ooooo007oo`000_oo
00<00?ooool03ooo00<Hdoooool00ooo00<00?ooool05_oo00<00?ooool05?oo00<00?ooool00Ooo
0002ool00`00ooooo`0?ool00aSCooooo`03ool00`00ooooo`0Fool00`00ooooo`0Dool00`00oooo
o`01ool000;oo`03003ooooo00ooo`036=?ooooo00?oo`03003ooooo01Koo`03003ooooo01Coo`03
003ooooo007oo`000_oo00<00?ooool03ooo00<Hdoooool00ooo00<00?ooool05_oo00<00?ooool0
5?oo00<00?ooool00Ooo0002ool00`00ooooo`0?ool00aSCooooo`03ool00`00ooooo`0Fool00`00
ooooo`0Dool00`00ooooo`01ool000;oo`03003ooooo00ooo`036=?ooooo00?oo`03003ooooo01Ko
o`03003ooooo01Coo`03003ooooo007oo`000_oo00<00?ooool03ooo00<Hdoooool00ooo00<00?oo
ool05_oo00<00?ooool05?oo00<00?ooool00Ooo0002ool00`00ooooo`0?ool00aSCooooo`03ool0
0`00ooooo`0Fool00`00ooooo`0Eool10001ool1ool000;oo`03003ooooo00ooo`036=?ooooo00?o
o`03003ooooo01Koo`03003ooooo01Goo`40007oo`7oo`000_oo00<00?ooool03ooo00<Hdoooool0
0ooo00<00?ooool05_oo00<00?ooool05Ooo0@000Ooo0Ooo0002ool00`00ooooo`0?ool00aSCoooo
o`03ool00`00ooooo`0Fool00`00ooooo`0Eool10001ool1ool000;oo`03003ooooo00ooo`036=?o
oooo00?oo`03003ooooo01Koo`03003ooooo01Goo`40007oo`7oo`000_oo00<00?ooool03ooo00<H
doooool00ooo00<00?ooool05_oo00<00?ooool05Ooo0@000Ooo0Ooo0002ool00`00ooooo`0?ool0
0aSCooooo`03ool00`00ooooo`0Fool00`00ooooo`0Eool10001ool1ool000;oo`03003ooooo00oo
o`036=?ooooo00?oo`03003ooooo01Koo`03003ooooo01Goo`40007oo`7oo`000_oo00<00?ooool0
3ooo00<Hdoooool00ooo00<00?ooool05_oo00<00?ooool05Ooo0@000Ooo0Ooo0002ool00`00oooo
o`0?ool00aSCooooo`03ool00`00ooooo`0Fool00`00ooooo`0Eool10001ool1ool000;oo`03003o
oooo00ooo`036=?ooooo00?oo`03003ooooo01Koo`03003ooooo01Goo`40007oo`7oo`000_oo00<0
0?ooool03ooo00<Hdoooool00ooo00<00?ooool05_oo00<00?ooool05Ooo0@000Ooo0Ooo0002ool0
0`00ooooo`0?ool00aSCooooo`03ool00`00ooooo`0Fool00`00ooooo`0Eool10001ool1ool000;o
o`03003ooooo013oo`036=?ooooo00;oo`03003ooooo01Koo`03003ooooo01Goo`40007oo`7oo`00
0_oo00<00?ooool04?oo00<Hdoooool00_oo00<00?ooool05_oo00<00?ooool05Ooo0@000Ooo0Ooo
0002ool00`00ooooo`0Aool01ASCoooooooo00006?oo00<00?ooool05Ooo0@000Ooo0Ooo0002ool0
0`00ooooo`0Aool01ASCoooooooo00006?oo00<00?ooool05Ooo0@000Ooo0Ooo0002ool00`00oooo
o`0Bool011SCooooo`006Ooo00<00?ooool05?oo0@000Ooo0Ooo0002ool00`00ooooo`0Cool00aSC
ool0000Iool00`00ooooo`0Dool10001ool1ool000;oo`03003ooooo01?oo`036=?oo`0001Woo`03
003ooooo01Coo`40007oo`7oo`000_oo00<00?ooool05?oo00<Hd`00ool06?oo00<00?ooool05?oo
0@000Ooo0Ooo0002ool00`00ooooo`0Dool00aSC003oo`0Hool00`00ooooo`0Dool10001ool1ool0
00;oo`03003ooooo01Goo`036=?ooooo01Ooo`03003ooooo01Coo`40007oo`7oo`000_oo00<00?oo
ool05Ooo00<001SCool05ooo00<00?ooool05?oo0@000Ooo0Ooo0002ool00`00ooooo`0Eool00`00
6=?oo`0Gool00`00ooooo`0Dool10001ool1ool000;oo`03003ooooo01Goo`03003ooaSC01Ooo`03
003ooooo01Coo`40007oo`7oo`000_oo00<00?ooool05Ooo00<00?oo6=<05ooo00<00?ooool05?oo
0@000Ooo0Ooo0002ool00`00ooooo`0Eool01000oooooaSC5_oo00<00?ooool05?oo0@000Ooo0Ooo
0002ool00`00ooooo`0Eool01@00oooooooo6=<05Ooo00<00?ooool05?oo0@000Ooo0Ooo0002ool0
0`00ooooo`0Eool01@00oooooooo6=<05Ooo00<00?ooool05?oo0@000Ooo0Ooo0002ool00`00oooo
o`0Eool00`00ooooo`02ool00aSCooooo`0Bool00`00ooooo`0Dool10001ool1ool00003ool00?oo
01Ooo`03003ooooo00?oo`036=?ooooo017oo`03003ooooo01Coo`40007oo`7oo`0000?oo`00ool0
5ooo00<00?ooool00ooo00<Hdoooool04Ooo00<00?ooool05?oo0@000Ooo0Ooo00000ooo003oo`0G
ool00`00ooooo`04ool00aSCooooo`0@ool00`00ooooo`0Dool10001ool1ool00003ool00?oo01Oo
o`03003ooooo00Coo`036=?ooooo013oo`03003ooooo01Coo`40007oo`7oo`0000?oo`00ool05ooo
00<00?ooool01Ooo00<Hdoooool03ooo00<00?ooool05?oo0@000Ooo0Ooo00000ooo003oo`0Gool0
0`00ooooo`06ool00aSCooooo`0>ool00`00ooooo`0Dool10001ool1ool00003ool00?oo01Ooo`03
003ooooo00Koo`036=?ooooo00koo`03003ooooo01Coo`40007oo`7oo`0000?oo`00ool05ooo00<0
0?ooool01ooo00<Hdoooool03Ooo00<00?ooool05?oo0@000Ooo0Ooo00000ooo003oo`0Gool00`00
ooooo`07ool00aSCooooo`0=ool00`00ooooo`0Dool10001ool1ool00003ool00?oo01Ooo`03003o
oooo00Soo`036=?ooooo00coo`03003ooooo01Coo`40007oo`7oo`0000?oo`00ool05ooo00<00?oo
ool02Ooo00<Hdoooool02ooo00<00?ooool05Ooo0@000Ooo00000ooo003oo`0Gool00`00ooooo`09
ool00aSCooooo`0;ool00`00ooooo`0Eool10001ool00003ool00?oo01Ooo`03003ooooo00[oo`03
6=?ooooo00[oo`03003ooooo01Goo`40007oo`0000?oo`00ool05ooo00<00?ooool02_oo00<Hdooo
ool02_oo00<00?ooool05Ooo0@000Ooo00000ooo003oo`0Gool00`00ooooo`0;ool00aSCooooo`09
ool00`00ooooo`0Eool10001ool00003ool00?oo01Ooo`03003ooooo00coo`036=?ooooo00Soo`03
003ooooo01Goo`40007oo`0000?oo`00ool05ooo00<00?ooool03?oo00<Hdoooool02?oo00<00?oo
ool05Ooo0@000Ooo00000ooo003oo`0Gool00`00ooooo`0=ool00aSCooooo`07ool00`00ooooo`0E
ool10001ool00003ool00?oo01Ooo`03003ooooo00goo`036=?ooooo00Ooo`03003ooooo01Goo`40
007oo`0000?oo`00ool05ooo00<00?ooool03_oo00<Hdoooool01_oo00<00?ooool05Ooo0@000Ooo
00000ooo003oo`0Gool00`00ooooo`0?ool00aSCooooo`05ool00`00ooooo`0Eool10001ool00003
ool00?oo01Ooo`03003ooooo00ooo`036=?ooooo00Goo`03003ooooo01Goo`40007oo`0000?oo`00
ool05ooo00<00?ooool04?oo00<Hdoooool01?oo00<00?ooool05Ooo0@000Ooo00000ooo003oo`0F
ool00`00ooooo`0Aool00aSCooooo`04ool00`00ooooo`0Eool10001ool00003ool00?oo01Koo`03
003ooooo01;oo`036=?ooooo00?oo`03003ooooo01Goo`40007oo`0000?oo`00ool05_oo00<00?oo
ool04ooo00<Hdoooool00_oo00<00?ooool05Ooo0@000Ooo00000ooo003oo`0Fool00`00ooooo`0C
ool00aSCooooo`02ool00`00ooooo`0Eool10001ool00003ool00?oo01Koo`03003ooooo01Coo`05
6=?oooooool0000Gool10001ool00003ool00?oo01Koo`03003ooooo01Coo`056=?oooooool0000G
ool10001ool00003ool00?oo01Koo`03003ooooo01Goo`046=?ooooo000Gool10001ool00003ool0
0?oo01Koo`03003ooooo01Koo`036=?oo`0001Ooo`40007oo`0000?oo`00ool05_oo00<00?ooool0
5_oo00<Hdooo00005ooo0@000Ooo00000ooo003oo`0Fool00`00ooooo`0Gool00aSC003oo`0Fool1
0001ool00003ool00?oo01Koo`03003ooooo01Ooo`036=<00?oo01Koo`40007oo`0000?oo`00ool0
5_oo00<00?ooool06?oo00<00?ooool05Ooo0@000Ooo00000ooo003oo`0Fool00`00ooooo`0Hool0
0`006=?oo`0Eool10001ool00003ool00?oo01Koo`03003ooooo01Soo`03000Hdooo01Goo`40007o
o`0000?oo`00ool05_oo00<00?ooool06?oo00<00?oo6=<05Ooo0@000Ooo00000ooo003oo`0Fool0
0`00ooooo`0Hool01000oooooaSC5?oo0@000Ooo00000ooo003oo`0Fool00`00ooooo`0Hool01000
oooooaSC5?oo0@000Ooo00000ooo003oo`0Fool00`00ooooo`0Hool01@00oooooooo6=<04ooo0@00
0Ooo00000`00ooooo`0Fool00`00ooooo`0Hool01@00oooooooo6=<04ooo0@000Ooo00000`00oooo
o`0Fool00`00ooooo`0Hool00`00ooooo`02ool00aSCooooo`0@ool10001ool00003003ooooo01Ko
o`03003ooooo01Soo`03003ooooo00?oo`036=?ooooo00ooo`40007oo`0000<00?ooool05_oo00<0
0?ooool06?oo00<00?ooool00ooo00<Hdoooool03ooo0@000Ooo00000`00ooooo`0Fool00`00oooo
o`0Hool00`00ooooo`04ool00aSCooooo`0>ool10001ool00003003ooooo01Koo`03003ooooo01So
o`03003ooooo00Coo`036=?ooooo00koo`40007oo`0000<00?ooool05_oo00<00?ooool05ooo0P00
1ooo00<Hdoooool03Ooo0@000Ooo00000`00ooooo`0Fool00`00ooooo`0Cool40002ool00`00oooo
o`05ool00aSCooooo`0<ool10001ool00003003ooooo01Koo`03003ooooo00ooo`@000Ooo`03003o
oooo00Coo`036=?ooooo00coo`40007oo`0000<00?ooool05_oo00<00?ooool02ooo10003?oo00<0
0?ooool01?oo00<Hdoooool03?oo0@0000000`00ooooo`0Fool00`00ooooo`08ool3000Aool00`00
ooooo`03ool00aSCooooo`0<ool100000003003ooooo01Koo`03003ooooo00Coo`@001Goo`03003o
oooo00?oo`036=?ooooo00_oo`40000000<00?ooool05_oo00<00?ooool010006_oo0P004Ooo0@00
00000`00ooooo`0Fool3000Pool00`00ooooo`0>ool100000003003ooooo01;oo`D002?oo`03003o
oooo00goo`40000000<00?ooool03_oo10001?oo00<00?ooool08_oo00<00?ooool03?oo0@000000
0`00ooooo`0:ool40008ool00`00ooooo`0Sool00`00ooooo`0;ool100000003003ooooo00Ooo`<0
00coo`03003ooooo02Coo`03003ooooo00[oo`40000000<00?ooool00ooo10003ooo00<00?ooool0
9Ooo00<00?ooool02Ooo0@0000000`00ool00003000Cool00`00ooooo`0Vool00`00ooooo`08ool1
0000008001Ooo`03003ooooo02Ooo`03003ooooo00Ooo`40000000?oo`00ool05_oo00<00?ooool0
:?oo00<00?ooool01_oo0@000002ool00`00ooooo`0Dool00`00ooooo`0Yool00`00ooooo`05ool1
000000?oo`03003ooooo01?oo`03003ooooo02[oo`8000Goo`4000001?oo0P004ooo00<00?ooool0
;?oo00<00?ooool00_oo0@000006ool00`00ooooo`0@ool00`00ooooo`0]ool01000oooooooo0@00
0007ool00`00ooooo`0?ool00`00ooooo`0^ool00`00ooooo`01000000Soo`03003ooooo00koo`03
003ooooo02ooo`40007oo`4000002Ooo00<00?ooool03Ooo00<00?ooool0<?oo0P00000:ool00`00
ooooo`0<ool00`00ooooo`0_ool3000000_oo`03003ooooo00_oo`03003ooooo02_oo`@000?oo`00
3?oo0P002ooo00<00?ooool09ooo10001ooo000>ool00`00ooooo`08ool00`00ooooo`0Sool4000;
ool000ooo`03003ooooo00Ooo`03003ooooo01ooo`@000ooo`004?oo00<00?ooool01_oo00<00?oo
ool06ooo10004ooo000Aool00`00ooooo`05ool00`00ooooo`0Gool4000Gool001;oo`03003ooooo
00Coo`03003ooooo01?oo`@001_oo`004ooo00<00?ooool00ooo00<00?ooool03ooo10007ooo000D
ool20003ool00`00ooooo`0;ool4000Sool001Koo`04003ooooo0009ool4000Wool001Ooo`03003o
o`0000Goo`@002_oo`006?oo0P0000?oo`0000000P00;ooo000Iool2000cool004koo`00\
\>"],
  ImageRangeCache->{{{0, 77.25}, {286.875, 0}} -> {0.370925, 0.0525691, \
0.00331782, 0.00331782}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(If[widechart \[Equal] True, \(laline = Graphics[{}];\)]\)], "Input"],

Cell["\<\
(*
is for Graphics only so disable for now
*)\
\>", "Text"],

Cell[BoxData[
    \(If[widechart === True, \(laline3D = Graphics3D[{}];\)]\)], "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Show and Print the Charts", "Section",
  Background->GrayLevel[0.900008]],

Cell[CellGroupData[{

Cell["discuss", "Subsubsection"],

Cell["\<\
postcript page output is nice easy and quick.  always do that\
\>", \
"Text"],

Cell["\<\
image has problem: many conversion methods, for the color chart, \
take 500X the disk space (and time). 1/2 Gigabyte or more.  reason: i beleive \
papers size, it renders far too much that wasn't asked for (always does, but \
for small files one doesn't notice.)\
\>", "Text"],

Cell["\<\
gs can do the color chart, despite beginning with a 6mb file (7x \
the size of bw) in just seconds more.  and the output, nearly the same size \
file and dimensions.\
\>", "Text"],

Cell["\<\
there is one problem is fitting postscript itself is pagewidth \
limited to pages it knows of.  unless planning to ask everyone to hack in \
custom ones (and some distros make it impossible).  so another objective is \
while planning for image export to work at all well: not to alter the \
postscript in ways that would make printing or viewing unlikely.\
\>", "Text"],

Cell["\<\
SUMMARY: for image it seems a waste of time to calculate size to \
crop: doesn't mm do it (not) isn't it easier to photoshop?  until it's \
\"crunch time\" you'll wish you had taken a little time aside (if you knew \
to).  all kinds of crazy \"letter size\" things go on in .ps and options are \
difficult.  avoid it.  ps is excellent for anything that fits on pages so \
plan on a layout that by any scaling is in units of 72 pts than regular page \
size.\
\>", "Text"],

Cell["\<\
for mm Aspect and ImageSize are NOT img scale/skewing.  all things \
keep 1:1 aspect and centers are adjusted to fit across page (protects fonts). \
 too small things overlap, too large and there is useless white space in \
chart.  at \"perfect\" planned layout, as an editor's mark: the last digit of \
Tm (melting point) of Silver (Ag) and a few others overlaps the E of ECA. \
this one digit overlap \"mark\" shows good width.  height is more \
optional\
\>", "Text"],

Cell["\<\
chart shouldn't be width chopped if postscript print is used (it's \
possible to do)

psrender(1) won't do color (see dobw just below) and gs(1) has no crop \
options.

finally. all the psrender/gs options are a pain and very likely to \
frustratingly leave one short of actualy printing\
\>", "Text"],

Cell["the following is problematic when printing or converting !", "Text"],

Cell[BoxData[
    \(\(If[dobw \[Equal] 1, 
        g9 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2DBW, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] 
              Automatic, \[IndentingNewLine]ImageSize \[Rule] {\(700\/32\) 
                  chartwidth, 30\ chartheight}]];\)\)], "Text"],

Cell[TextData[{
  "i try setting aspect ratio. result is i end up with CROPPING probles. in \
",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " if aspect doesn't match img size, need cropping.  but whenever they are \
made to match: all scaling is removed."
}], "Text"],

Cell["\<\
((chartheight+(3/10)+(chartheight+(3/10)) \
(1/32))/((chartwidth+chartwidth (1/32))))
          
0.29253   FullOptions if Automatic is used (see above)
0.228125  actual h/w is too wide to fit in a .ps, not condensed
          needs more spacing on h (have more to burn here)
0.285714  1/3.5 is very close \
\>", "Text"],

Cell["\<\
squash=.3;spacew=1/32;

ara=(((chartheight+(3/10+spacew)+(chartheight+(3/10)) \
spacew))/(((chartwidth+chartwidth spacew))))((1+squash)/(1-squash));

imsi=55{(((chartwidth+chartwidth \
spacew)))/2,((chartheight+(3/10+spacew)+(chartheight+(3/10)) \
spacew))/2}{(1-squash),(1+squash)};\
\>", "Text"],

Cell["\<\
If[dobw\[Equal]1,g10=Show[
        colhead2Dgr,titlegr,edgr,notesgr,ptgr,convgr,convgr5,convgr2,go22D,\
go2DBW,laline,
        AspectRatio\[Rule]ara,
        ImageSize\[Rule]imsi,
        PlotRange\[Rule]{{5,950},{10,290}}
        ]];\
\>", "Text"],

Cell["\<\
gs likes this, places it same size, would need cropping (by hand).  \
but with aspect 1 there is no way to select spacing (except that the notebook \
above can when creating, or also multiplying all coord will).  but gs likes \
many things spuriously.

psrender displays nothing, though i assume selecting offsets woudl show \
results after efforts.  it's still bw.

problem with this is with a policy of absolute coordinates the whole chart \
would have to change for every resolution or layout or spacing change.  and \
while it'd seem an a safer route: there's no way to know what hang-ups are \
waiting\
\>", "Text"],

Cell["\<\
If[dobw\[Equal]1,g9=Show[
        colhead2Dgr,titlegr,edgr,notesgr,ptgr,convgr,convgr5,convgr2,go22D,\
go2DBW,laline,
        AspectRatio\[Rule]1,
        ImageSize\[Rule]{7 72,7 72},
        PlotRange\[Rule]{{5,950},{10,290}}
        ]];\
\>", "Text"],

Cell["\<\
by what magic i don't know but gs can render bw.ps and c.ps \
psrender cannot.  crashes on c.  and for bw the following is needed.  the \
result is good though.

psrender-bin -format gif -width 550 -height 200 -xoff -25 -yoff -585 -xdpi \
1000
-ydpi 1000 $outfile $*

very strange since mm uses psrender to make to .ps files !

not very strange: .gif for c.ps doesnt' work in shell or in mm. it's \
beleivable mm has env setup and uses all the right tricks and it won't work \
then at commandline it won't either.\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["BW", "Subsubsection"],

Cell[BoxData[
    \(\(file =. ;\)\)], "Input"],

Cell[BoxData[{
    \(\(If[widechart === True, file = "\<graph.bw\>", 
        file = "\<graph.bw.la\>"];\)\), "\[IndentingNewLine]", 
    \(\(doPSIbw = 0;\)\), "\n", 
    \(\(dobw = 1;\)\), "\n", 
    \(\(doGIFbw = 0;\)\), "\n", 
    \(\(doEPSbw = 0;\)\)}], "Input"],

Cell[BoxData[
    \(\(If[dobw === 1 && widechart === True, 
        g9 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2DBW, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((3\ 72 + 
                    34)\)/\((9\ 72 + 
                    34)\), \[IndentingNewLine]ImageSize \[Rule] {9\ 72 + 34, 
                3\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  950}, {10, 290}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell["\<\
printcell note! must have \";\" after Plot[]; cell directly above. \
also check % is a gr\
\>", "Text"],

Cell["Printed to .ps file Above ^^^", "Text",
  Background->RGBColor[0.8, 1, 1]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ImageSize \[Rule] {6\ 72 + 17, 4\ 72 + 34}\)], "Input"],

Cell[BoxData[
    \(ImageSize \[Rule] {449, 322}\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(If[dobw === 1 && widechart === False, 
        g9 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2DBW, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((4\ 72 + 
                    34)\)/\((6\ 72 + 
                    17)\), \[IndentingNewLine]ImageSize \[Rule] {6\ 72 + 17, 
                4\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  660}, {10, 390}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell[BoxData[
    \(\(\( (*\ a\ more\ general\ use\ subst*) \)\(\[IndentingNewLine]\)\( (*\ 
      AspectRatio \[Rule] Automatic, \ 
      ImageSize \[Rule] {\((700/32)\) chartwidth, 
          30\ chartheight}\ *) \)\)\)], "Text"],

Cell["\<\
----------------------
suggested:\
\>", "Text"],

Cell["Run[\"chart-to-jpeg-faster -r 1000 graph.bw.ps\"];", "Text"],

Cell["\<\
see: chart-to-jpeg-faster.  it will make an image in good time and \
crop too.\
\>", "Text"],

Cell["\<\
SUMMARY: why the suggestion?  mm 4 psrender / Display is slow and \
may inf wait on color chart. also don't expect gs or psrender to get a nice \
cropped results they aren't built for that: you'll need (a cropping \
tool)\
\>", "Text"],

Cell["\<\
-----------------------------------------
Edit->save selection as->EPS
\tdoes not work with gs at all , no png
\tpsrender needs -psinit switch and chops output
\t\tpsrender-gif doesn't add -psinit
\t\twhich sometimes works: other times it hangs, working off same Cell\
\>", \
"Text"],

Cell["\<\
EPS will chop the chart for wide chart.  it won't contain fonts \
others need to print.  it will be randomly \"poorly\" cropped (unless orig. \
is already correct)\
\>", "Text"],

Cell["\<\
gs and psrender have chopped output, while gv likes it\
\>", "Text"],

Cell[BoxData[
    \(\(If[doEPSbw \[Equal] 1, 
        Export[file <> "\<.ex.eps\>", g9, "\<EPS\>"]];\)\)], "Input"],

Cell[BoxData[
    \(\(If[doEPSbw \[Equal] 1, 
        Display[file <> "\<.eps\>", g9, "\<EPS\>"]];\)\)], "Input"],

Cell["\<\
note for psrender(1) read file ./psrender-graph about shell \
environment outside mm.\
\>", "Text"],

Cell["\<\
Display this seems like a good idea.  but it won't include fonts \
(will be missing) and for color takes 500x longer\
\>", "Text"],

Cell[BoxData[
    \(\(If[doGIFbw \[Equal] 1, 
        Display["\<graph.bw.gif\>", g9, "\<GIF\>", 
          ImageResolution \[Rule] {1500, 1500}]];\)\)], "Input"],

Cell["\<\
going route of using pdfimages(1) need img in .ps, again for color \
it will take too long\
\>", "Text"],

Cell[BoxData[
    \(\(If[
        doJPEGBW \[Equal] 1, \[IndentingNewLine]Export[file <> "\<.psi\>", 
          g9, "\<PsImage\>", 
          ImageResolution \[Rule] 
            1000]; \[IndentingNewLine]Run["\<chart-to-jpeg-faster\>" <> "\< \
\>" <> file <> "\<.psi\>"];\[IndentingNewLine]];\)\)], "Input"],

Cell["\<\
gs creates no png, psrender chops largess of chart, while gv likes \
it allot.\
\>", "Text"],

Cell[BoxData[
    \(\(If[True \[Equal] False, 
        Export["\<ex.eps\>", g9, "\<EPS\>"]];\)\)], "Input"],

Cell["\<\
mm 4 psrender run by psrender-bin can crop (using unknowable \
-height Y -width X  -xoff x -yoff y) but it won't do color .ps file anyway.  \
psrender-bin sometimes needs .ps edited to remove missing fonts.  it does eps \
(well) but gs hardly does eps.\
\>", "Text"],

Cell[BoxData[
    \(\(Remove[g9];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MemoryInUse[] // fNBookForm2\)], "Input"],

Cell[BoxData[
    \("15.26\[ThinSpace]M"\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Color", "Subsubsection"],

Cell[BoxData[
    \(\(filec =. ;\)\)], "Input"],

Cell[BoxData[{
    \(\(If[widechart === True, filec = "\<graph.c\>", 
        filec = "\<graph.c.la\>"];\)\), "\[IndentingNewLine]", 
    \(\(doPSIc = 0;\)\), "\n", 
    \(\(docolor = 1;\)\), "\n", 
    \(\(doGIFc = 0;\)\), "\n", 
    \(\(doEPSc = 0;\)\)}], "Input"],

Cell[BoxData[
    \(\(If[docolor === 1 && widechart === True, 
        g8 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2D, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((3\ 72 + 
                    34)\)/\((9\ 72 + 
                    34)\), \[IndentingNewLine]ImageSize \[Rule] {9\ 72 + 34, 
                3\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  950}, {10, 290}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell[BoxData[
    \(\(If[docolor === 1 && widechart === False, 
        g8 = Show[\[IndentingNewLine]colhead2Dgr, titlegr, edgr, notesgr, 
            ptgr, convgr, convgr5, convgr2, go22D, go2D, 
            laline, \[IndentingNewLine]AspectRatio \[Rule] \((4\ 72 + 
                    34)\)/\((6\ 72 + 
                    17)\), \[IndentingNewLine]ImageSize \[Rule] {6\ 72 + 17, 
                4\ 72 + 34}, \[IndentingNewLine]PlotRange \[Rule] {{5, 
                  660}, {10, 390}}\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(filec <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"],

Cell["\<\
----------------------
suggested:\
\>", "Text"],

Cell["Run[\"chart-to-jpeg-faster -r 1000 graph.c.ps\"];", "Text"],

Cell["\<\
----------------------
not suggested\
\>", "Text"],

Cell["warning: this doesn't create file (in many minutes waiting)", "Text"],

Cell["\<\
Display[\"graph.c.gif\",g8,\"GIF\",ImageResolution\[Rule]{1000,1000}\
];\
\>", "Text"],

Cell["\<\
warning: this works well, creates file quickly, but hangs \
infinitely waiting for psrender to exit.  but really it's just getting a .ps \
from mm and outputing a .ps so shouldn't it work ?\
\>", "Text"],

Cell["Display[\"disp.c.eps\",g8,\"EPS\"];", "Text"],

Cell["\<\
this takes 3x as long file is 33x the size, enlarges (ie, see in \
gv), but does not hang\
\>", "Text"],

Cell["Export[\"ex.c.eps\",g8,\"EPS\"];", "Text"],

Cell[BoxData[
    \(\(Remove[g8];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MemoryInUse[] // fNBookForm2\)], "Input"],

Cell[BoxData[
    \("25.60\[ThinSpace]M"\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["3D Color", "Subsubsection"],

Cell[BoxData[
    \(\(file3 =. ;\)\)], "Input"],

Cell[BoxData[
    \(\(If[widechart === True, file3 = "\<graph.c.3d\>", 
        file3 = "\<graph.c.3d.la\>"];\)\)], "Input"],

Cell[BoxData[
    \(\(\(do3D = 0;\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\( (*\ 
      note\ this\ is\ in\ general\ setup\ too\ to\ control\ if\ 3  
        D\ gr\ arrays\ are\ even\ made\ *) \)\)\)], "Input"],

Cell[BoxData[
    \( (*\[IndentingNewLine]ImageSize \[Rule] {\(700\/32\) chartwidth, 
          30\ chartheight}; \[IndentingNewLine]ImageSize \[Rule] {700, 
          210};  (*\ old\ *) \[IndentingNewLine]*) \)], "Text"],

Cell[BoxData[
    \(\(If[do3D === 1, 
        g8 = Show[colhead3Dgr, titlegr3D, edgr3D, notesgr3D, ptgr3D, 
            convgr3D, convgr53D, convgr23D, go2, go, 
            laline3D, \[IndentingNewLine]\[IndentingNewLine]AspectRatio \
\[Rule] Automatic, \[IndentingNewLine]ImageSize \[Rule] {\(700\/32\) 
                  chartwidth, \((30)\)\ chartheight}, \
\[IndentingNewLine]ViewPoint \[Rule] {0, \(-1\), 
                0}, \[IndentingNewLine]LightSources \[Rule] {{{0, \(-4\), 0}, 
                  RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
                  RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
                  RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
                  RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, 
                  GrayLevel[ .5]}}, 
            AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], 
            Axes \[Rule] False\[IndentingNewLine]]];\)\)], "Input"],

Cell[BoxData[
    RowBox[{"If", "[", 
      RowBox[{\(widechart === True\), ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file3 <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], ";"}], 
        "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
        RowBox[{
          RowBox[{"If", "[", 
            
            RowBox[{\(Head[%] \[Equal] Graphics\), ",", "\[IndentingNewLine]",
               
              RowBox[{"printcell", "[", 
                RowBox[{\(file3 <> "\<.ps\>"\), ",", 
                  StyleBox[\(PrintingOptions -> {printopts}\),
                    FontFamily->"Courier"], 
                  StyleBox[",",
                    FontFamily->"Courier"], 
                  RowBox[{
                    StyleBox["PageHeaderLines",
                      FontFamily->"Courier"], 
                    "\[Rule]", \({False, False}\)}]}], "]"}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["ThreeScript  but  broken", "Subsubsection"],

Cell["\<\
(*
\tThreeScript can't do Text[].
\tCould Render each Text to image separately and put in Graphics3D maybe
\t\tBut no benefit as only \"gain\" is text could
\t\tanimate / rotate separately from boxes - so what.
\t\tOther apps can rotate whole deal as 3D anyhow.
AHA !!!
\tcan replace Text[] with function that renders a primative it does know
\tthen use that to awk text in saved pov file mathview3d makes.
At any rate not \"worth it\".
\tit's work i have no order for
\tlikely someone has a .ps to 3d tool
\tlikely ML for browser or xml'ish .ps for browser exists
*)\
\>", "Text"],

Cell["(* about what u get *)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[go2[\([1]\)]]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .5609 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0580714 1.05807 -0.239461 1.05807 [
[ 0 0 0 0 ]
[ 1 .5609 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02122 .31822 m
0 .56037 L
s
0 .56037 m
.00064 .5609 L
s
.00064 .5609 m
.02183 .31878 L
s
.02183 .31878 m
.02122 .31822 L
s
.97291 0 m
.97337 .0007 L
s
.97337 .0007 m
1 .25587 L
s
1 .25587 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.02122 .31822 m
0 .56037 L
s
0 .56037 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.97291 0 m
.02122 .31822 L
s
.02183 .31878 m
.97337 .0007 L
s
.97337 .0007 m
1 .25587 L
s
1 .25587 m
.00064 .5609 L
s
.00064 .5609 m
.02183 .31878 L
s
0 0 m
1 0 L
1 .5609 L
0 .5609 L
closepath
clip
newpath
.1 .1 .6 r
.0001 w
.05287 .32788 m
.07736 .31975 L
s
.05051 .35686 m
.05287 .32788 L
s
.07736 .31975 m
.07514 .34877 L
s
.07822 .31947 m
.10287 .31129 L
s
.076 .34849 m
.07822 .31947 L
s
.07514 .34877 m
.05051 .35686 L
s
.05044 .35778 m
.07507 .34969 L
s
.04805 .38709 m
.05044 .35778 L
s
.10287 .31129 m
.10078 .34035 L
s
.10078 .34035 m
.076 .34849 L
s
.07507 .34969 m
.07282 .37905 L
s
.07593 .34941 m
.10072 .34127 L
s
.07368 .37877 m
.07593 .34941 L
s
.07282 .37905 m
.04805 .38709 L
s
.04798 .38802 m
.07275 .37997 L
s
.04556 .41768 m
.04798 .38802 L
s
.10072 .34127 m
.0986 .37067 L
s
.10158 .34098 m
.12653 .33279 L
s
.09948 .37039 m
.10158 .34098 L
s
.0986 .37067 m
.07368 .37877 L
s
.07275 .37997 m
.07047 .40968 L
s
.07361 .37969 m
.09854 .3716 L
s
.07134 .4094 m
.07361 .37969 L
s
.12653 .33279 m
.12455 .36224 L
s
.1274 .33251 m
.1525 .32427 L
s
.12543 .36196 m
.1274 .33251 L
s
.07047 .40968 m
.04556 .41768 L
s
.04549 .41861 m
.0704 .41062 L
s
.04305 .44863 m
.04549 .41861 L
s
.12455 .36224 m
.09948 .37039 L
s
.09854 .3716 m
.0964 .40135 L
s
.1525 .32427 m
.15067 .35376 L
s
.15338 .32398 m
.17864 .31568 L
s
.15155 .35347 m
.15338 .32398 L
s
.0964 .40135 m
.07134 .4094 L
s
.0704 .41062 m
.06809 .44068 L
s
.07127 .41034 m
.09633 .40229 L
s
.06897 .4404 m
.07127 .41034 L
s
.15067 .35376 m
.12543 .36196 L
s
.17864 .31568 m
.17695 .34522 L
s
.17952 .31539 m
.20494 .30705 L
s
.17784 .34494 m
.17952 .31539 L
s
.06809 .44068 m
.04305 .44863 L
s
.04297 .44957 m
.06802 .44163 L
s
.0405 .47995 m
.04297 .44957 L
s
.09633 .40229 m
.09417 .4324 L
s
.17695 .34522 m
.15155 .35347 L
s
.20494 .30705 m
.20341 .33663 L
s
.20583 .30676 m
.23141 .29836 L
s
.2043 .33634 m
.20583 .30676 L
s
.26021 .25907 m
.28598 .25052 L
s
.259 .28839 m
.26021 .25907 L
s
.09417 .4324 m
.06897 .4404 L
s
.06802 .44163 m
.06569 .47205 L
s
.0689 .44135 m
.0941 .43335 L
s
.06657 .47177 m
.0689 .44135 L
s
.20341 .33663 m
.17784 .34494 L
s
.23141 .29836 m
.23003 .32799 L
s
.23231 .29806 m
.25806 .28961 L
s
.23093 .32769 m
.23231 .29806 L
s
.28598 .25052 m
.2849 .27988 L
s
.28688 .25022 m
.3128 .24161 L
s
.28581 .27958 m
.28688 .25022 L
s
.06569 .47205 m
.0405 .47995 L
s
.04042 .4809 m
.06561 .473 L
s
.03793 .51164 m
.04042 .4809 L
s
.0941 .43335 m
.09191 .46382 L
s
.23003 .32799 m
.2043 .33634 L
s
.2849 .27988 m
.259 .28839 L
s
.25806 .28961 m
.25682 .31928 L
s
.25896 .28931 m
.28487 .28081 L
s
.25773 .31899 m
.25896 .28931 L
s
.3128 .24161 m
.31188 .27102 L
s
.31371 .24131 m
.33981 .23265 L
s
.3128 .27072 m
.31371 .24131 L
s
.09191 .46382 m
.06657 .47177 L
s
.06561 .473 m
.06325 .50379 L
s
.06649 .47273 m
.09185 .46478 L
s
.06414 .50351 m
.06649 .47273 L
s
.10063 .44778 m
.23816 .40442 L
s
.09629 .50948 m
.10063 .44778 L
s
.25682 .31928 m
.23093 .32769 L
s
.31188 .27102 m
.28581 .27958 L
s
.28487 .28081 m
.28378 .31053 L
s
.28578 .28051 m
.31186 .27195 L
s
.2847 .31023 m
.28578 .28051 L
s
.33981 .23265 m
.33904 .2621 L
s
.34072 .23235 m
.36698 .22363 L
s
.33996 .2618 m
.34072 .23235 L
s
.06325 .50379 m
.03793 .51164 L
s
.03785 .51261 m
.06318 .50476 L
s
.03532 .54371 m
.03785 .51261 L
s
.09185 .46478 m
.08963 .49561 L
s
.28378 .31053 m
.25773 .31899 L
s
.33904 .2621 m
.3128 .27072 L
s
.31186 .27195 m
.31092 .30171 L
s
.31277 .27165 m
.33902 .26303 L
s
.31184 .30141 m
.31277 .27165 L
s
.36698 .22363 m
.36637 .25312 L
s
.3679 .22333 m
.39433 .21455 L
s
.3673 .25282 m
.3679 .22333 L
s
.08963 .49561 m
.06414 .50351 L
s
.06318 .50476 m
.06079 .53592 L
s
.31092 .30171 m
.2847 .31023 L
s
.36637 .25312 m
.33996 .2618 L
s
.33902 .26303 m
.33824 .29284 L
s
.33994 .26273 m
.36635 .25405 L
s
.33917 .29254 m
.33994 .26273 L
s
.39433 .21455 m
.39388 .24409 L
s
.06079 .53592 m
.03532 .54371 L
s
.39526 .21425 m
.42186 .20542 L
s
.39481 .24378 m
.39526 .21425 L
s
.33824 .29284 m
.31184 .30141 L
s
.39388 .24409 m
.3673 .25282 L
s
.36635 .25405 m
.36574 .28391 L
s
.36728 .25375 m
.39387 .24502 L
s
.36667 .2836 m
.36728 .25375 L
s
.42186 .20542 m
.42157 .235 L
s
.42279 .20511 m
.44957 .19622 L
s
.42251 .23469 m
.42279 .20511 L
s
.23538 .46665 m
.09629 .50948 L
s
.36574 .28391 m
.33917 .29254 L
s
.42157 .235 m
.39481 .24378 L
s
.39387 .24502 m
.39341 .27492 L
s
.3948 .24471 m
.42156 .23593 L
s
.39435 .27461 m
.3948 .24471 L
s
.44957 .19622 m
.44944 .22584 L
s
.45051 .19591 m
.47746 .18697 L
s
.45038 .22553 m
.45051 .19591 L
s
.39341 .27492 m
.36667 .2836 L
s
.23816 .40442 m
.23538 .46665 L
s
.44944 .22584 m
.42251 .23469 L
s
.42156 .23593 m
.42127 .26587 L
s
.4225 .23562 m
.44944 .22678 L
s
.42221 .26556 m
.4225 .23562 L
s
.47746 .18697 m
.4775 .21663 L
s
.4784 .18665 m
.50553 .17765 L
s
.47844 .21632 m
.4784 .18665 L
s
.42127 .26587 m
.39435 .27461 L
s
.4775 .21663 m
.45038 .22553 L
s
.44944 .22678 m
.44931 .25676 L
s
.45038 .22647 m
.4775 .21756 L
s
.45026 .25645 m
.45038 .22647 L
s
.50553 .17765 m
.50573 .20735 L
s
.50648 .17733 m
.53378 .16827 L
s
.50669 .20704 m
.50648 .17733 L
s
.44931 .25676 m
.42221 .26556 L
s
.50573 .20735 m
.47844 .21632 L
s
.4775 .21756 m
.47754 .24759 L
s
.47845 .21725 m
.50574 .20829 L
s
.47849 .24728 m
.47845 .21725 L
s
.53378 .16827 m
.53416 .19802 L
s
.53474 .16795 m
.56223 .15883 L
s
.53512 .1977 m
.53474 .16795 L
s
.47754 .24759 m
.45026 .25645 L
s
.53416 .19802 m
.50669 .20704 L
s
.50574 .20829 m
.50595 .23836 L
s
.5067 .20798 m
.53417 .19896 L
s
.50691 .23805 m
.5067 .20798 L
s
.56223 .15883 m
.56277 .18862 L
s
.56319 .15851 m
.59086 .14933 L
s
.56374 .1883 m
.56319 .15851 L
s
.50595 .23836 m
.47849 .24728 L
s
.47849 .24823 m
.50596 .23931 L
s
.47854 .27863 m
.47849 .24823 L
s
.56277 .18862 m
.53512 .1977 L
s
.53417 .19896 m
.53455 .22907 L
s
.53513 .19864 m
.56279 .18956 L
s
.53552 .22876 m
.53513 .19864 L
s
.59086 .14933 m
.59158 .17916 L
s
.59183 .14901 m
.61968 .13976 L
s
.59255 .17884 m
.59183 .14901 L
s
.53455 .22907 m
.50691 .23805 L
s
.50596 .23931 m
.50617 .26976 L
s
.50692 .239 m
.53456 .23002 L
s
.50713 .26945 m
.50692 .239 L
s
.59158 .17916 m
.56374 .1883 L
s
.56279 .18956 m
.56334 .21972 L
s
.56376 .18924 m
.5916 .1801 L
s
.56432 .2194 m
.56376 .18924 L
s
.61968 .13976 m
.62058 .16964 L
s
.62065 .13944 m
.64869 .13013 L
s
.62156 .16932 m
.62065 .13944 L
s
.50617 .26976 m
.47854 .27863 L
s
.47854 .27959 m
.50617 .27072 L
s
.47858 .31037 m
.47854 .27959 L
s
.56334 .21972 m
.53552 .22876 L
s
.53456 .23002 m
.53495 .26052 L
s
.53553 .22971 m
.56336 .22067 L
s
.53592 .2602 m
.53553 .22971 L
s
.62058 .16964 m
.59255 .17884 L
s
.5916 .1801 m
.59233 .21031 L
s
.59258 .17978 m
.6206 .17058 L
s
.59331 .20999 m
.59258 .17978 L
s
.64869 .13013 m
.64977 .16005 L
s
.64967 .12981 m
.6779 .12044 L
s
.65076 .15973 m
.64967 .12981 L
s
.53495 .26052 m
.50713 .26945 L
s
.50617 .27072 m
.50639 .30155 L
s
.50714 .27041 m
.53496 .26148 L
s
.50736 .30124 m
.50714 .27041 L
s
.59233 .21031 m
.56432 .2194 L
s
.56336 .22067 m
.56392 .25121 L
s
.56434 .22036 m
.59235 .21126 L
s
.5649 .2509 m
.56434 .22036 L
s
.64977 .16005 m
.62156 .16932 L
s
.6206 .17058 m
.62151 .20083 L
s
.62159 .17026 m
.6498 .16099 L
s
.6225 .20051 m
.62159 .17026 L
s
.6779 .12044 m
.67916 .1504 L
s
.67889 .12011 m
.7073 .11068 L
s
.68015 .15007 m
.67889 .12011 L
s
.50639 .30155 m
.47858 .31037 L
s
.56392 .25121 m
.53592 .2602 L
s
.53496 .26148 m
.53535 .29235 L
s
.53593 .26116 m
.56394 .25217 L
s
.53633 .29204 m
.53593 .26116 L
s
.62151 .20083 m
.59331 .20999 L
s
.59235 .21126 m
.59309 .24184 L
s
.59334 .21094 m
.62154 .20178 L
s
.59408 .24153 m
.59334 .21094 L
s
.67916 .1504 m
.65076 .15973 L
s
.6498 .16099 m
.65089 .19129 L
s
.65079 .16067 m
.6792 .15134 L
s
.65188 .19096 m
.65079 .16067 L
s
.7073 .11068 m
.70874 .14068 L
s
.7083 .11035 m
.7369 .10086 L
s
.70974 .14035 m
.7083 .11035 L
s
.53535 .29235 m
.50736 .30124 L
s
.59309 .24184 m
.5649 .2509 L
s
.56394 .25217 m
.56451 .2831 L
s
.56492 .25186 m
.59312 .24281 L
s
.56549 .28278 m
.56492 .25186 L
s
.65089 .19129 m
.6225 .20051 L
s
.62154 .20178 m
.62246 .23241 L
s
.62253 .20146 m
.65092 .19224 L
s
.62345 .23209 m
.62253 .20146 L
s
.70874 .14068 m
.68015 .15007 L
s
.6792 .15134 m
.68047 .18168 L
s
.68019 .15102 m
.70879 .14163 L
s
.68147 .18135 m
.68019 .15102 L
s
.7369 .10086 m
.73853 .1309 L
s
.73791 .10052 m
.7667 .09097 L
s
.73954 .13057 m
.73791 .10052 L
s
.56451 .2831 m
.53633 .29204 L
s
.62246 .23241 m
.59408 .24153 L
s
.59312 .24281 m
.59386 .27378 L
s
.5941 .24249 m
.62249 .23338 L
s
.59486 .27346 m
.5941 .24249 L
s
.68047 .18168 m
.65188 .19096 L
s
.65092 .19224 m
.65203 .22292 L
s
.65192 .19192 m
.68051 .18263 L
s
.65303 .22259 m
.65192 .19192 L
s
.73853 .1309 m
.70974 .14035 L
s
.70879 .14163 m
.71025 .17201 L
s
.70979 .1413 m
.73858 .13185 L
s
.71125 .17168 m
.70979 .1413 L
s
.7667 .09097 m
.76852 .12105 L
s
.76771 .09063 m
.79671 .08101 L
s
.76953 .12072 m
.76771 .09063 L
s
.59386 .27378 m
.56549 .28278 L
s
.65203 .22292 m
.62345 .23209 L
s
.62249 .23338 m
.62342 .26439 L
s
.62348 .23306 m
.65206 .22388 L
s
.62442 .26408 m
.62348 .23306 L
s
.71025 .17201 m
.68147 .18135 L
s
.68051 .18263 m
.6818 .21336 L
s
.68151 .18231 m
.71029 .17296 L
s
.6828 .21303 m
.68151 .18231 L
s
.76852 .12105 m
.73954 .13057 L
s
.73858 .13185 m
.74023 .16227 L
s
.73959 .13151 m
.76857 .122 L
s
.74124 .16194 m
.73959 .13151 L
s
.79671 .08101 m
.79871 .11113 L
s
.79772 .08067 m
.82691 .07098 L
s
.79973 .1108 m
.79772 .08067 L
s
.62342 .26439 m
.59486 .27346 L
s
.6818 .21336 m
.65303 .22259 L
s
.65206 .22388 m
.65318 .25495 L
s
.65306 .22356 m
.68184 .21432 L
s
.65419 .25463 m
.65306 .22356 L
s
.74023 .16227 m
.71125 .17168 L
s
.71029 .17296 m
.71177 .20373 L
s
.7113 .17264 m
.74028 .16323 L
s
.71278 .2034 m
.7113 .17264 L
s
.79871 .11113 m
.76953 .12072 L
s
.76857 .122 m
.77041 .15246 L
s
.76959 .12166 m
.79877 .11208 L
s
.77143 .15213 m
.76959 .12166 L
s
.82691 .07098 m
.82911 .10115 L
s
.82794 .07064 m
.85733 .06089 L
s
.83014 .10081 m
.82794 .07064 L
s
.65318 .25495 m
.62442 .26408 L
s
.71177 .20373 m
.6828 .21303 L
s
.68184 .21432 m
.68314 .24544 L
s
.68284 .214 m
.71181 .2047 L
s
.68416 .24511 m
.68284 .214 L
s
.77041 .15246 m
.74124 .16194 L
s
.74028 .16323 m
.74194 .19404 L
s
.74129 .1629 m
.77047 .15342 L
s
.74297 .19371 m
.74129 .1629 L
s
.82911 .10115 m
.79973 .1108 L
s
.79877 .11208 m
.8008 .14259 L
s
.7998 .11175 m
.82918 .1021 L
s
.80183 .14226 m
.7998 .11175 L
s
.85733 .06089 m
.85972 .0911 L
s
.85836 .06055 m
.88795 .05073 L
s
.86076 .09076 m
.85836 .06055 L
s
.68314 .24544 m
.65419 .25463 L
s
.74194 .19404 m
.71278 .2034 L
s
.71181 .2047 m
.71331 .23586 L
s
.71283 .20437 m
.742 .19501 L
s
.71433 .23554 m
.71283 .20437 L
s
.8008 .14259 m
.77143 .15213 L
s
.77047 .15342 m
.77233 .18428 L
s
.77149 .15309 m
.80087 .14355 L
s
.77336 .18395 m
.77149 .15309 L
s
.85972 .0911 m
.83014 .10081 L
s
.82918 .1021 m
.83141 .13265 L
s
.83021 .10176 m
.8598 .09205 L
s
.83244 .13232 m
.83021 .10176 L
s
.88795 .05073 m
.89054 .08097 L
s
.88898 .05038 m
.91878 .04049 L
s
.89158 .08063 m
.88898 .05038 L
s
.71331 .23586 m
.68416 .24511 L
s
.77233 .18428 m
.74297 .19371 L
s
.742 .19501 m
.74369 .22622 L
s
.74302 .19468 m
.77239 .18525 L
s
.74471 .22589 m
.74302 .19468 L
s
.83141 .13265 m
.80183 .14226 L
s
.80087 .14355 m
.80292 .17446 L
s
.8019 .14322 m
.83148 .13362 L
s
.80396 .17412 m
.8019 .14322 L
s
.89054 .08097 m
.86076 .09076 L
s
.8598 .09205 m
.86222 .12264 L
s
.86083 .09171 m
.89062 .08193 L
s
.86326 .1223 m
.86083 .09171 L
s
.91878 .04049 m
.92157 .07078 L
s
.91982 .04015 m
.94982 .03019 L
s
.92262 .07044 m
.91982 .04015 L
s
.74369 .22622 m
.71433 .23554 L
s
.80292 .17446 m
.77336 .18395 L
s
.77239 .18525 m
.77427 .21651 L
s
.77342 .18492 m
.80299 .17543 L
s
.77531 .21618 m
.77342 .18492 L
s
.86222 .12264 m
.83244 .13232 L
s
.83148 .13362 m
.83373 .16456 L
s
.83251 .13328 m
.8623 .12361 L
s
.83477 .16423 m
.83251 .13328 L
s
.92157 .07078 m
.89158 .08063 L
s
.89062 .08193 m
.89325 .11257 L
s
.89166 .08159 m
.92166 .07174 L
s
.8943 .11222 m
.89166 .08159 L
s
.94982 .03019 m
.95282 .06052 L
s
.77427 .21651 m
.74471 .22589 L
s
.83373 .16456 m
.80396 .17412 L
s
.80299 .17543 m
.80507 .20673 L
s
.80403 .1751 m
.8338 .16554 L
s
.80612 .2064 m
.80403 .1751 L
s
.89325 .11257 m
.86326 .1223 L
s
.8623 .12361 m
.86475 .1546 L
s
.86334 .12327 m
.89333 .11353 L
s
.8658 .15426 m
.86334 .12327 L
s
.95282 .06052 m
.92262 .07044 L
s
.92166 .07174 m
.92449 .10242 L
s
.92271 .07139 m
.95292 .06148 L
s
.92555 .10207 m
.92271 .07139 L
s
.80507 .20673 m
.77531 .21618 L
s
.77537 .21716 m
.80514 .20772 L
s
.77728 .24883 m
.77537 .21716 L
s
.86475 .1546 m
.83477 .16423 L
s
.8338 .16554 m
.83609 .19689 L
s
.83485 .1652 m
.86483 .15558 L
s
.83714 .19655 m
.83485 .1652 L
s
.92449 .10242 m
.8943 .11222 L
s
.89333 .11353 m
.89599 .14457 L
s
.89438 .11319 m
.92458 .10338 L
s
.89705 .14423 m
.89438 .11319 L
s
.95292 .06148 m
.95595 .0922 L
s
.83609 .19689 m
.80612 .2064 L
s
.80514 .20772 m
.80725 .23943 L
s
.80618 .20739 m
.83616 .19787 L
s
.8083 .2391 m
.80618 .20739 L
s
.89599 .14457 m
.8658 .15426 L
s
.86483 .15558 m
.86732 .18697 L
s
.86588 .15524 m
.89607 .14555 L
s
.86838 .18664 m
.86588 .15524 L
s
.95595 .0922 m
.92555 .10207 L
s
.92458 .10338 m
.92745 .13446 L
s
.92564 .10304 m
.95605 .09317 L
s
.92851 .13412 m
.92564 .10304 L
s
.80725 .23943 m
.77728 .24883 L
s
.77734 .24982 m
.80731 .24043 L
s
.77928 .2819 m
.77734 .24982 L
s
.86732 .18697 m
.83714 .19655 L
s
.83616 .19787 m
.83847 .22963 L
s
.83721 .19754 m
.8674 .18796 L
s
.83953 .2293 m
.83721 .19754 L
s
.92745 .13446 m
.89705 .14423 L
s
.89607 .14555 m
.89877 .17699 L
s
.89713 .14521 m
.92754 .13544 L
s
.89983 .17665 m
.89713 .14521 L
s
.95605 .09317 m
.95912 .12429 L
s
.83847 .22963 m
.8083 .2391 L
s
.80731 .24043 m
.80945 .27255 L
s
.80836 .2401 m
.83855 .23063 L
s
.81051 .27222 m
.80836 .2401 L
s
.89877 .17699 m
.86838 .18664 L
s
.8674 .18796 m
.86992 .21977 L
s
.86845 .18763 m
.89885 .17798 L
s
.87098 .21943 m
.86845 .18763 L
s
.95912 .12429 m
.92851 .13412 L
s
.92754 .13544 m
.93044 .16693 L
s
.9286 .1351 m
.95922 .12527 L
s
.93151 .16659 m
.9286 .1351 L
s
.80945 .27255 m
.77928 .2819 L
s
.86992 .21977 m
.83953 .2293 L
s
.83855 .23063 m
.84089 .26281 L
s
.8396 .2303 m
.87 .22077 L
s
.84195 .26248 m
.8396 .2303 L
s
.93044 .16693 m
.89983 .17665 L
s
.89885 .17798 m
.90158 .20983 L
s
.89992 .17764 m
.93053 .16793 L
s
.90266 .2095 m
.89992 .17764 L
s
.95922 .12527 m
.96234 .15681 L
s
.84089 .26281 m
.81051 .27222 L
s
.90158 .20983 m
.87098 .21943 L
s
.87 .22077 m
.87255 .253 L
s
.87106 .22044 m
.90167 .21084 L
s
.87362 .25266 m
.87106 .22044 L
s
.96234 .15681 m
.93151 .16659 L
s
.93053 .16793 m
.93348 .19983 L
s
.93161 .16759 m
.96244 .1578 L
s
.93456 .19949 m
.93161 .16759 L
s
.87255 .253 m
.84195 .26248 L
s
.93348 .19983 m
.90266 .2095 L
s
.90167 .21084 m
.90444 .24312 L
s
.90274 .2105 m
.93357 .20084 L
s
.90552 .24278 m
.90274 .2105 L
s
.96244 .1578 m
.9656 .18975 L
s
.90444 .24312 m
.87362 .25266 L
s
.9656 .18975 m
.93456 .19949 L
s
.93357 .20084 m
.93655 .23316 L
s
.93465 .2005 m
.96569 .19076 L
s
.93764 .23283 m
.93465 .2005 L
s
.93655 .23316 m
.90552 .24278 L
s
.96569 .19076 m
.9689 .22314 L
s
.9689 .22314 m
.93764 .23283 L
s
.93773 .23385 m
.969 .22416 L
s
.94076 .26661 m
.93773 .23385 L
s
.969 .22416 m
.97224 .25698 L
s
.97224 .25698 m
.94076 .26661 L
s
0 g
.25 Mabswid
.97291 0 m
.97337 .0007 L
s
.97337 .0007 m
1 .25587 L
s
1 .25587 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.02122 .31822 m
0 .56037 L
s
0 .56037 m
.99952 .2552 L
s
.99952 .2552 m
.97291 0 L
s
.97291 0 m
.02122 .31822 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 161.5},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000XA000`40n007h00Ooooo5_oo0P002Ooo
003ooolCool300000ooo003oo`08ool00?oooa3oo`<000Coo`03003ooooo00Ooo`00oooo3Ooo0`00
1ooo00<00?ooool01ooo003oool:ool3000:ool00`00ooooo`07ool00?ooo`Ooo`<000koo`03003o
oooo00Koo`00oooo1?oo0`004Ooo00<00?ooool01_oo003oool1ool3000Dool00`00ooooo`06ool0
0?goo`<001Ooo`03003ooooo00Koo`00n_oo0`004Ooo0aSC1_oo00<00?ooool01_oo003gool3000@
ool46=<2ool00aSCooooo`04ool00`00ooooo`06ool00?Coo`<0013oo`<Hd`Koo`036=?ooooo00Co
o`03003ooooo00Koo`00lOoo0`004Ooo0aSC2?oo00<Hdoooool01?oo00<00?ooool01_oo003^ool3
000@ool46=<2ool00aSCooooo`06ool00aSCooooo`04ool00`00ooooo`06ool00>_oo`<0013oo`<H
d`Koo`036=?ooooo00Ooo`036=?ooooo00Coo`03003ooooo00Goo`00j?oo0`004Ooo0aSC2?oo00<H
doooool01ooo00<Hdoooool01?oo00<00?ooool01Ooo003Uool3000@ool46=<2ool00aSCooooo`06
ool26=<8ool00aSCooooo`04ool00`00ooooo`05ool00>;oo`<000ooo`@Hd`Koo`036=?ooooo00Oo
o`036=?ooooo00Goo`8Hd`Koo`03003ooooo00Goo`00gooo0`003ooo0aSC00?ooaSC6=<01ooo00<H
doooool01ooo00<Hdoooool00_oo1ASC1_oo00<00?ooool01Ooo003Lool3000@ool26=<4ool26=<7
ool26=<8ool00aSCoolHd`046=<2ool00aSCooooo`04ool00`00ooooo`05ool00=Woo`<0013oo`<H
d`Koo`8Hd`Soo`036=?ooooo00Goo`@Hd`Koo`036=?ooooo00Coo`03003ooooo00Goo`00e_oo0`00
4?oo0aSC00?ooaSCool01_oo0QSC2?oo00<Hdoooool00_oo1ASC2?oo00<Hdoooool01?oo00<00?oo
ool01Ooo003Cool3000@ool36=<4ool00aSCooooo`06ool00aSCooooo`06ool00aSCoolHd`046=<2
ool00aSCooooo`06ool00aSCooooo`04ool00`00ooooo`05ool00=3oo`<0013oo`<Hd`Ooo`036=?o
oooo00Koo`036=?ooooo00Goo`@Hd`Koo`036=?ooooo00Koo`036=?ooooo00Goo`03003ooooo00Co
o`00cOoo0`004?oo0aSC00?ooaSCool01ooo00<Hdoooool01_oo00<Hdoooool00_oo0aSC00?ooaSC
ool01ooo00<Hdoooool01_oo00<Hdoooool01Ooo00<00?ooool01?oo003:ool3000Aool26=<4ool0
0aSCooooo`06ool00aSCooooo`06ool00aSCoolHd`026=<4ool00aSCooooo`06ool26=<7ool00aSC
ooooo`05ool00`00ooooo`04ool00<Ooo`<0013oo`@Hd`Koo`036=?ooooo00Koo`036=?ooooo00Go
o`<Hd`Ooo`036=?ooooo00Koo`8Hd`Koo`8Hd`Ooo`03003ooooo00Coo`00a?oo0`004?oo0aSC00?o
oaSC6=<01ooo00<Hdoooool01_oo00<Hdoooool00_oo0aSC00?ooaSCool01ooo00<Hdoooool01_oo
0QSC0ooo1ASC1ooo00<00?ooool01?oo0031ool3000Aool26=<4ool26=<7ool26=<7ool00aSCoolH
d`026=<4ool00aSCooooo`07ool00aSCooooo`05ool26=<00ooo6=<Hd`026=<2ool00aSCooooo`05
ool00`00ooooo`04ool00;koo`<0017oo`<Hd`Koo`8Hd`Ooo`8Hd`Koo`<Hd`Ooo`036=?ooooo00Oo
o`036=?ooooo00Coo`@Hd`Koo`036=?ooooo00Goo`03003ooooo00Coo`00^ooo0`004Ooo0aSC00?o
oaSCool01_oo0QSC1ooo0QSC0ooo0aSC00?ooaSCool01ooo00<Hdoooool01ooo00@Hdoooooooo`HH
d`Ooo`036=?ooooo00Goo`03003ooooo00Coo`00^?oo0`004_oo0QSC1?oo00<Hdoooool01_oo00<H
doooool01Ooo0QSC00?ooaSC6=<01?oo00<Hdoooool01ooo00<Hdoooool01_oo00<Hdooo6=<00aSC
0_oo0QSC1ooo00<Hdoooool01Ooo00<00?ooool01?oo002eool3000@ool56=<6ool00aSCooooo`06
ool00aSCooooo`04ool46=<6ool00aSCooooo`07ool00aSCooooo`05ool36=<6ool26=<8ool00aSC
ooooo`05ool00`00ooooo`03ool00;;oo`<000ooo`@Hd`;oo`8Hd`Ooo`036=?ooooo00Koo`046=?o
ooooool36=<00ooo6=<Hd`07ool00aSCooooo`07ool00aSCooooo`02ool36=<00ooo6=?oo`06ool2
6=<8ool00aSCooooo`05ool00`00ooooo`03ool00:ooo`<000ooo`<Hd`Koo`8Hd`Ooo`8Hd`Ooo`04
6=?ooaSC6=<4ool26=<8ool00aSCooooo`06ool00aSCoolHd`026=<4ool00aSCooooo`05ool00aSC
oolHd`07ool00aSCooooo`05ool00`00ooooo`03ool00:coo`<000ooo`<Hd`03oolHdooo00Koo`8H
d`Ooo`8Hd`Goo`@Hd`Koo`8Hd`Soo`036=?ooooo00Goo`<Hd`Ooo`036=?ooooo00Koo`8Hd`Ooo`03
6=?ooooo00Goo`03003ooooo00?oo`00ZOoo0`004?oo0QSC1?oo00<Hdoooool01Ooo0QSC1ooo0QSC
00?ooaSC6=<00aSC00?ooaSCool01_oo0QSC2?oo00<Hdoooool00_oo0aSC00?ooaSCool01ooo00<H
doooool01_oo0QSC1Ooo0aSC1ooo00<00?ooool00ooo002Vool3000@ool36=<6ool00aSCooooo`06
ool00aSCooooo`04ool66=<4ool00aSCooooo`06ool00aSCooooo`06ool00aSCoolHd`026=<4ool0
0aSCooooo`06ool26=<7ool26=<00ooo6=<Hd`036=<00ooo6=?oo`06ool00`00ooooo`03ool00:?o
o`<0013oo`<Hd`03oolHdooo00Koo`036=?ooooo00Koo`046=?oooooool76=<6ool00aSCooooo`06
ool00aSCooooo`05ool36=<7ool00aSCooooo`06ool26=<6ool66=<4ool00aSCooooo`05ool00`00
ooooo`03ool00:3oo`<0017oo`8Hd`Coo`036=?ooooo00Goo`8Hd`Ooo`036=?ooaSC00<Hd`;oo`8H
d`Ooo`036=?ooooo00Koo`036=?ooooo00;oo`<Hd`03oolHdooo00Ooo`036=?ooooo00Koo`8Hd`?o
o`LHd`Koo`036=?ooooo00Goo`03003ooooo00?oo`00WOoo0`004?oo11SC1_oo00<Hdoooool01Ooo
0QSC1_oo0aSC1_oo0QSC1ooo0QSC1ooo00<Hdooo6=<00QSC1?oo00<Hdoooool01_oo0QSC1ooo0QSC
00?ooaSC6=<00aSC00?ooaSC6=<01ooo00<Hdoooool01Ooo00<00?ooool00ooo002Jool3000@ool3
6=<00ooo6=<Hd`07ool00aSCooooo`05ool26=<3ool56=<7ool26=<7ool26=<6ool36=<7ool00aSC
ooooo`06ool26=<6ool66=<4ool26=<8ool00aSCooooo`04ool00`00ooooo`03ool009Ooo`<0017o
o`8Hd`Coo`8Hd`Ooo`036=?ooooo00Goo`8Hd`03oolHdaSC008Hd`;oo`036=?ooooo00Goo`8Hd`Oo
o`8Hd`?oo`<Hd`03oolHdooo00Ooo`036=?ooooo00Koo`8Hd`?oo`LHd`Koo`8Hd`Soo`036=?ooooo
00Goo`03003ooooo00;oo`00U?oo0`004?oo11SC1_oo0QSC1ooo00<Hdoooool01?oo11SC1_oo00<H
doooool01_oo00<Hdoooool01Ooo0QSC00?ooaSC6=<01?oo00<Hdoooool01_oo0QSC1ooo0QSC00?o
oaSC6=<00QSC0_oo0QSC1ooo0QSC2?oo00<Hdoooool01Ooo00<00?ooool00_oo002Aool3000?ool4
6=<2ool00aSCooooo`05ool26=<7ool011SCoooooooo0aSC00?ooaSC6=<01ooo00<Hdoooool01_oo
00<Hdoooool00ooo1ASC1_oo00<Hdoooool01_oo0QSC1_oo11SC1_oo0QSC2?oo00<Hdoooool01_oo
00<Hdoooool01Ooo00<00?ooool00_oo002>ool3000?ool36=<6ool00aSCooooo`06ool00aSCoooo
o`05ool011SCoolHdaSC1?oo0QSC1ooo00<Hdoooool01_oo00<Hdooo6=<011SC00?ooaSC6=<01ooo
00<Hdoooool01_oo0QSC0ooo1QSC1ooo0QSC2?oo00<Hdoooool01Ooo0QSC1ooo00<00?ooool00_oo
002<ool2000?ool36=<00ooo6=?oo`06ool00aSCooooo`06ool00aSCooooo`03ool46=<6ool26=<7
ool00aSCooooo`05ool56=<4ool26=<8ool00aSCooooo`05ool26=<00ooo6=<Hd`026=<2ool26=<7
ool26=<8ool00aSCooooo`02ool36=<00ooo6=?oo`06ool00`00ooooo`02ool008Woo`<000ooo`8H
d`Coo`036=?ooooo00Goo`036=?ooooo00Koo`036=?ooaSC00@Hd`03oolHdooo00Koo`8Hd`Ooo`03
6=?ooooo00;oo`HHd`Koo`8Hd`Soo`036=?ooooo00Coo`@Hd`Koo`8Hd`Soo`036=?ooooo00Koo`03
6=?ooaSC008Hd`Coo`036=?ooooo00Goo`03003ooooo00;oo`00Q_oo0`003ooo0aSC1_oo00<Hdooo
ool01Ooo00<Hdoooool01_oo11SC1?oo00<Hdoooool01_oo00<Hdoooool01Ooo00<Hdooo6=<011SC
0_oo00<Hdoooool01Ooo0QSC2?oo00@Hdoooooooo`@Hd`03oolHdooo00Koo`8Hd`Soo`036=?ooooo
00Goo`@Hd`Koo`036=?ooooo00Goo`03003ooooo00;oo`00Pooo0`003ooo0aSC00?ooaSCool01_oo
00<Hdoooool01Ooo00<Hdoooool01?oo11SC1_oo00<Hdoooool01_oo00<Hdoooool01?oo11SC1_oo
00<Hdoooool01_oo00<Hdoooool01_oo00<Hdooo6=<00QSC1?oo00<Hdoooool01Ooo0QSC2?oo00<H
doooool00_oo0aSC00?ooaSC6=<01ooo00<Hdoooool01Ooo00<00?ooool00_oo0020ool3000@ool2
6=<4ool00aSCooooo`05ool00aSCooooo`05ool00aSCooooo`046=<2ool00aSCooooo`05ool00aSC
ooooo`06ool011SCoooooooo0aSC00?ooaSCool01ooo00<Hdoooool01_oo00<Hdoooool01Ooo0aSC
1ooo00<Hdoooool01_oo00<Hdoooool01_oo00<Hdooo6=<00QSC1?oo0QSC2?oo00<Hdoooool01?oo
00<00?ooool00_oo001mool3000?ool46=<6ool00aSCooooo`05ool00aSCooooo`04ool46=<6ool0
0aSCooooo`05ool00aSCooooo`06ool011SCoolHdaSC1?oo00<Hdoooool01_oo00<Hdoooool01_oo
00<Hdoooool00_oo0aSC00?ooaSCool01ooo00<Hdoooool01_oo00<Hdoooool01?oo11SC1ooo0QSC
2?oo00<Hdoooool01Ooo00<00?ooool00Ooo001jool3000>ool46=<2ool00aSCooooo`05ool00aSC
ooooo`05ool011SCoooooooo1ASC2?oo00<Hdoooool01Ooo00<Hdoooool01Ooo0aSC1_oo00<Hdooo
ool01_oo0QSC1ooo00<Hdooo6=<00QSC1?oo00<Hdoooool01_oo00<Hdoooool01_oo00<Hdoooool0
1ASC00?ooaSCool01ooo0QSC2?oo00<Hdoooool01Ooo00<00?ooool00Ooo001gool3000>ool36=<6
ool00aSCooooo`05ool00aSCooooo`05ool00aSCoolHd`036=<2ool00aSCooooo`06ool00aSCoooo
o`05ool00aSCooooo`02ool36=<00ooo6=?oo`06ool00aSCooooo`06ool26=<5ool46=<7ool00aSC
ooooo`06ool00aSCooooo`05ool66=<4ool00aSCooooo`07ool00aSCooooo`06ool00aSCooooo`05
ool00`00ooooo`01ool007Coo`<000koo`<Hd`03oolHdooo00Koo`036=?ooooo00Goo`036=?ooooo
00Coo`<Hd`Koo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooaSC008Hd`Coo`036=?ooooo00Ko
o`036=?ooooo00Goo`8Hd`03oolHdaSC00<Hd`03oolHdooo00Ooo`036=?ooooo00Koo`036=?ooooo
00;oo`HHd`Ooo`036=?ooooo00Ooo`036=?ooooo00Goo`8Hd`Ooo`03003ooooo007oo`00LOoo0`00
3ooo0QSC1?oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdoooooooo`<Hd`03oolHdooo00Koo`03
6=?ooooo00Koo`036=?ooooo00?oo`@Hd`Ooo`036=?ooooo00Koo`036=?ooooo00Goo`DHd`Coo`03
6=?ooooo00Koo`8Hd`Ooo`036=?ooaSC00DHd`03oolHdooo00Ooo`036=?ooooo00Ooo`036=?ooooo
00;oo`DHd`Ooo`03003ooooo007oo`00K_oo0`003ooo0aSC1_oo00<Hdoooool01Ooo00<Hdoooool0
1Ooo00@Hdooo6=<Hd`Coo`036=?ooooo00Goo`8Hd`Ooo`036=?ooaSC00@Hd`03oolHdooo00Ooo`03
6=?ooooo00Koo`036=?ooooo00?oo`DHd`Koo`036=?ooooo00Koo`8Hd`Koo`HHd`Coo`036=?ooooo
00Ooo`036=?ooooo00Koo`036=?ooaSC00@Hd`;oo`036=?ooooo00Goo`03003ooooo007oo`00Jooo
0`003ooo0aSC00?ooaSCool01_oo00<Hdoooool01Ooo00<Hdoooool00ooo11SC1_oo00<Hdoooool0
1Ooo0QSC1_oo1ASC1?oo00<Hdoooool01_oo00<Hdoooool01_oo00<Hdooo6=<00aSC0_oo0QSC1ooo
00<Hdoooool01_oo0QSC0ooo1QSC1ooo00<Hdoooool01ooo00<Hdoooool01Ooo11SC1_oo00<Hdooo
ool01Ooo00<00?ooool00Ooo001Xool3000@ool26=<4ool00aSCooooo`05ool00aSCooooo`05ool0
0aSCoolHd`046=<00ooo6=?oo`06ool00aSCooooo`05ool26=<3ool66=<6ool00aSCooooo`06ool0
0aSCooooo`05ool36=<6ool26=<7ool26=<7ool26=<00ooo6=<Hd`026=<2ool00aSCooooo`06ool0
0aSCooooo`07ool00aSCooooo`02ool36=<00ooo6=?oo`07ool00aSCooooo`05ool00`00ooooo`01
ool006Goo`<000ooo`@Hd`Koo`036=?ooooo00Goo`036=?ooooo00Coo`DHd`Coo`036=?ooooo00Go
o`036=?ooooo00Goo`8Hd`03oolHdaSC008Hd`;oo`036=?ooooo00Goo`036=?ooooo00Koo`036=?o
oooo00;oo`DHd`Ooo`8Hd`Ooo`8Hd`Koo`@Hd`Koo`036=?ooooo00Ooo`036=?ooooo00Koo`036=?o
oaSC008Hd`Coo`036=?ooooo00Koo`036=?ooooo00Goo`03003ooooo007oo`00H_oo0`003_oo11SC
0_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdoooooooo`HHd`Koo`036=?ooooo00Goo`036=?o
oooo00Coo`@Hd`Koo`036=?ooooo00Koo`036=?ooooo00Goo`036=?ooaSC00@Hd`;oo`036=?ooooo
00Goo`8Hd`Ooo`8Hd`?oo`<Hd`03oolHdaSC00Ooo`036=?ooooo00Ooo`036=?ooooo00Goo`<Hd`Oo
o`036=?ooooo00Ooo`036=?ooooo00Goo`40007oo`7oo`00Gooo0`003_oo0aSC1_oo00<Hdoooool0
1Ooo00<Hdoooool01Ooo00<Hdooo6=<00aSC0_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdooo
ooooo`<Hd`03oolHdaSC00Ooo`036=?ooooo00Koo`036=?ooooo00Coo`@Hd`Koo`036=?ooooo00Ko
o`036=?ooooo00Goo`8Hd`03oolHdaSC00Coo`8Hd`Ooo`036=?ooooo00Ooo`036=?ooooo00;oo`<H
d`03oolHdooo00Ooo`036=?ooooo00Ooo`036=?ooooo00Goo`40007oo`7oo`00G?oo0`003_oo0aSC
00?ooaSCool01_oo00<Hdoooool01Ooo00<Hdoooool01?oo0aSC1_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo00@Hdooo6=<Hd`Coo`8Hd`Ooo`036=?ooooo00Koo`046=?oooooool36=<00ooo6=?oo`07
ool00aSCooooo`06ool00aSCooooo`04ool46=<6ool26=<8ool00aSCooooo`06ool00aSCoolHd`02
6=<4ool00aSCooooo`06ool00aSCooooo`07ool00aSCooooo`05ool10001ool1ool005Woo`<000oo
o`8Hd`Coo`036=?ooooo00Goo`036=?ooooo00Goo`046=?oooooool36=<00ooo6=?oo`06ool00aSC
ooooo`05ool00aSCooooo`03ool46=<6ool26=<7ool00aSCooooo`06ool011SCoolHdaSC1?oo00<H
doooool01_oo00<Hdoooool01_oo00@Hdoooooooo`<Hd`;oo`036=?ooooo00Goo`8Hd`Soo`036=?o
oooo00Goo`<Hd`Ooo`036=?ooooo00Ooo`036=?ooooo00Koo`036=?ooooo00Goo`40007oo`7oo`00
E_oo0`003_oo11SC1_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdooo6=<Hd`Coo`036=?ooooo
00Goo`036=?ooooo00Goo`036=?ooaSC00@Hd`03oolHdooo00Koo`8Hd`Ooo`036=?ooooo00Coo`@H
d`Koo`036=?ooooo00Koo`036=?ooooo00Koo`046=?ooaSC6=<5ool00aSCooooo`05ool26=<8ool0
0aSCooooo`02ool36=<00ooo6=?oo`07ool00aSCooooo`07ool00aSCooooo`05ool26=<7ool10001
ool1ool005?oo`<000goo`@Hd`;oo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00?oo`@H
d`Koo`036=?ooooo00Goo`036=?ooooo00Goo`@Hd`Coo`036=?ooooo00Koo`036=?ooooo00Goo`03
6=?ooooo00DHd`03oolHdooo00Koo`036=?ooooo00Koo`036=?ooooo00Coo`@Hd`Ooo`036=?ooooo
00Koo`036=?ooooo00Koo`036=?ooaSC008Hd`Coo`036=?ooooo00Koo`8Hd`Soo`036=?ooooo00;o
o`<Hd`03oolHdooo00Koo`40007oo`7oo`00D?oo0`003_oo0QSC1_oo00<Hdoooool01Ooo00<Hdooo
ool01Ooo00<Hdooo6=<00aSC0_oo00<Hdoooool01Ooo00<Hdoooool01Ooo00<Hdoooool00ooo11SC
1_oo00<Hdoooool01_oo00<Hdoooool01Ooo1ASC1?oo00<Hdoooool01Ooo0QSC1ooo00<Hdoooool0
11SC2ooo00<Hdoooool01_oo00<Hdoooool01?oo11SC1ooo00<Hdoooool01ooo00<Hdoooool01_oo
00<Hdooo6=<00QSC1?oo00<Hdoooool01Ooo0@000Ooo0Ooo001=ool3000@ool26=<7ool00aSCoooo
o`05ool00aSCooooo`04ool36=<6ool00aSCooooo`05ool00aSCooooo`05ool00aSCoolHd`036=<2
ool00aSCooooo`05ool00aSCooooo`06ool00aSCooooo`03ool46=<7ool00aSCooooo`05ool26=<6
ool46=<?ool00aSCooooo`06ool00aSCooooo`056=<00ooo6=?oo`07ool00aSCooooo`07ool00aSC
ooooo`04ool46=<7ool00aSCooooo`05ool10001ool1ool004[oo`<000ooo`@Hd`03oolHdooo00Ko
o`036=?ooooo00Goo`046=?oooooool56=<7ool00aSCooooo`05ool00aSCooooo`04ool36=<6ool0
0aSCooooo`05ool26=<7ool00aSCoolHd`036=<2ool00aSCooooo`06ool00aSCooooo`05ool26=<3
ool36=<Cool00aSCooooo`06ool56=<4ool00aSCooooo`07ool00aSCooooo`06ool00aSCooooo`04
6=<2ool00aSCooooo`06ool00aSCooooo`05ool10001ool1ool004Ooo`<000koo`@Hd`Goo`036=?o
oooo00Goo`036=?ooooo00Goo`036=?ooaSC00<Hd`;oo`036=?ooooo00Goo`036=?ooooo00Goo`04
6=?oooooool36=<00ooo6=?oo`06ool00aSCooooo`05ool26=<6ool36=<6ool00aSCooooo`06ool0
0aSCooooo`05ool26=<00ooo6=<Hd`0Fool00aSCooooo`04ool46=<7ool00aSCooooo`07ool00aSC
ooooo`06ool36=<6ool00aSCooooo`06ool00aSCooooo`06ool10001ool004Coo`<000ooo`8Hd`03
oolHdaSC00Koo`036=?ooooo00Goo`036=?ooooo00?oo`@Hd`Koo`036=?ooooo00Coo`8Hd`Ooo`04
6=?ooaSC6=<4ool00aSCooooo`05ool00aSCooooo`05ool26=<3ool36=<00ooo6=?oo`06ool00aSC
ooooo`06ool00aSCooooo`04ool46=<Hool00aSCooooo`046=<2ool00aSCooooo`06ool00aSCoooo
o`07ool00aSCooooo`04ool36=<8ool00aSCooooo`07ool00aSCooooo`05ool10001ool0047oo`<0
013oo`8Hd`?oo`8Hd`Koo`036=?ooooo00Goo`036=?ooaSC00@Hd`03oolHdooo00Koo`036=?ooooo
00Coo`8Hd`Goo`@Hd`Koo`036=?ooooo00Goo`036=?ooooo00Goo`8Hd`03oolHdaSC00Coo`036=?o
oooo00Goo`036=?ooooo00Koo`046=?oooooool36=<Lool36=<6ool00aSCooooo`07ool00aSCoooo
o`06ool00aSCooooo`046=<;ool00aSCooooo`07ool00aSCooooo`05ool10001ool003koo`<000oo
o`@Hd`Goo`8Hd`Koo`036=?ooooo00Coo`DHd`Coo`036=?ooooo00Goo`036=?ooooo00Coo`8Hd`03
oolHdaSC008Hd`;oo`036=?ooooo00Goo`036=?ooooo00Goo`036=?ooooo00?oo`DHd`Koo`036=?o
oooo00Goo`8Hd`Ooo`046=?ooaSC6=<Oool00aSCooooo`06ool00aSCooooo`07ool00aSCooooo`05
ool46=<@ool00aSCooooo`06ool00aSCooooo`05ool10001ool003_oo`<000koo`@Hd`;oo`036=?o
oooo00Coo`8Hd`Koo`046=?oooooool66=<6ool00aSCooooo`04ool26=<5ool46=<6ool00aSCoooo
o`05ool00aSCooooo`05ool00aSCoolHd`046=<00ooo6=<Hd`07ool00aSCooooo`05ool26=<6ool3
6=<Qool00aSCooooo`06ool00aSCooooo`07ool00aSCooooo`02ool36=<Dool00aSCooooo`06ool0
0aSCooooo`04ool20001ool003Soo`<000ooo`8Hd`Koo`036=?ooooo00Coo`036=?ooooo00Goo`03
6=?ooaSC00<Hd`;oo`036=?ooooo00Goo`036=?ooooo00Coo`8Hd`?oo`8Hd`[oo`036=?ooooo00Go
o`036=?ooooo00Goo`@Hd`Coo`8Hd`Ooo`036=?ooooo00Goo`8Hd`?oo`<HdbCoo`036=?ooooo00Oo
o`036=?ooooo00Koo`036=?ooaSC008HdaOoo`036=?ooooo00Coo`<Hd`?oo`<000?oo`00=Ooo0`00
4_oo00<Hdoooool01Ooo00<Hdoooool01?oo00<Hdoooool00ooo11SC1_oo00<Hdoooool01Ooo00<H
doooool01?oo0QSC00?ooaSC6=<03?oo00<Hdoooool01Ooo00<Hdoooool00ooo11SC1_oo0QSC1ooo
00<Hdoooool01Ooo0QSC00?ooaSC6=<09ooo00<Hdoooool01ooo00<Hdoooool01Ooo0aSC6_oo00<H
doooool011SC0_oo10001_oo000bool3000Eool00aSCooooo`05ool00aSCooooo`04ool00aSCoolH
d`046=<00ooo6=?oo`06ool00aSCooooo`05ool00aSCooooo`03ool46=<>ool00aSCooooo`05ool0
0aSCoolHd`036=<2ool00aSCooooo`05ool26=<7ool00aSCooooo`03ool56=<Yool00aSCooooo`07
ool00aSCooooo`02ool36=<Mool36=<3ool3000:ool002ooo`<001Soo`036=?ooooo00Coo`8Hd`Ko
o`@Hd`Coo`036=?ooooo00Goo`036=?ooooo00Goo`046=?oooooool26=<Bool00aSCooooo`04ool3
6=<6ool00aSCooooo`05ool26=<7ool00aSCoolHd`036=<_ool00aSCooooo`06ool00aSCoolHd`02
6=<Sool3000=ool002coo`<001_oo`036=?ooooo00Coo`8Hd`Goo`<Hd`Koo`036=?ooooo00Goo`03
6=?ooooo00Goo`046=?ooaSC6=<Dool011SCoooooooo0aSC00?ooaSCool01_oo00<Hdoooool01Ooo
0QSC1_oo0aSC<ooo00<Hdoooool01Ooo0aSC8_oo10004?oo000Yool3000Nool00aSCooooo`04ool2
6=<00ooo6=<Hd`026=<00ooo6=?oo`06ool00aSCooooo`05ool00aSCooooo`03ool46=<Fool011SC
oolHdaSC1?oo00<Hdoooool01Ooo00<Hdoooool01Ooo0QSC0ooo0aSC=_oo00<Hdoooool00_oo0aSC
8_oo0`005?oo000Vool3000Qool00aSCooooo`03ool46=<5ool00aSCooooo`05ool00aSCooooo`05
ool00aSCoolHd`036=<Jool26=<6ool00aSCooooo`05ool00aSCooooo`05ool26=<00ooo6=<Hd`0i
ool00aSCoolHd`026=<Rool3000Gool002?oo`<002Coo`046=?oooooool26=<00ooo6=<Hd`06ool0
0aSCooooo`05ool00aSCooooo`04ool36=<Nool00aSCooooo`05ool00aSCooooo`05ool00aSCoooo
o`04ool46=<kool26=<Rool3000Jool0023oo`<002Ooo`046=?ooaSC6=<3ool26=<6ool00aSCoooo
o`05ool011SCoooooooo0aSC8Ooo00<Hdoooool01Ooo00<Hdoooool01Ooo00@Hdoooooooo`<Hdeoo
o`@001goo`007Ooo0`00:?oo11SC1Ooo0QSC1_oo00<Hdoooool01Ooo00@Hdooo6=<HdbCoo`036=?o
oooo00Goo`036=?ooooo00Goo`046=?ooaSC6==Oool3000Qool001[oo`<002Ooo`@Hd`;oo`036=?o
oooo00Coo`8Hd`Koo`036=?ooooo00?oo`@HdbKoo`036=?ooooo00Goo`036=?ooooo00?oo`@Hdeko
o`<002Coo`005ooo0`009ooo0aSC1_oo00<Hdoooool01?oo00<Hdoooool01Ooo00<Hdooo6=<00aSC
:_oo00<Hdoooool01Ooo00<Hdooo6=<00aSCG_oo10009ooo000Dool3000Xool26=<00ooo6=?oo`06
ool00aSCooooo`04ool00aSCooooo`04ool36=<^ool00aSCooooo`04ool36==Oool3000[ool0017o
o`<002Woo`8Hd`?oo`036=?ooooo00Goo`036=?ooooo00Coo`046=?oooooool36=<aool011SCoooo
oooo0aSCGooo0`00;_oo000>ool3000Xool46=<5ool00aSCooooo`04ool26=<6ool011SCoolHdaSC
=?oo00@Hdooo6=<Hdeooo`<0037oo`002ooo0`003_oo0QSC5ooo11SC0_oo00<Hdoooool01?oo00<H
doooool01?oo0QSC1Ooo0aSC=_oo0QSCGOoo1000=?oo0008ool3000=ool46=<00ooo6=?oo`0Cool3
6=<6ool00aSCooooo`04ool00aSCooooo`04ool26=<00ooo6=<Hd`026=>Eool3000hool000Koo`80
00goo`<Hd`Goo`036=?ooooo013oo`8Hd`03oolHdooo00Koo`036=?ooooo00Coo`036=?ooooo00?o
o`@HdiKoo`<003_oo`001_oo00<00?ooool02_oo0QSC00?ooaSCool01Ooo00<Hdoooool03_oo0QSC
0ooo00<Hdoooool01Ooo00<Hdoooool01?oo00@Hdoooooooo`8HdiKoo`@003koo`001_oo00<00?oo
ool02?oo0QSC0ooo00<Hdoooool01?oo00<Hdoooool02_oo11SC1Ooo00<Hdoooool01?oo00<Hdooo
ool01Ooo00@Hdooo6=<HdiGoo`<004;oo`001_oo00<00?ooool01_oo0QSC1Ooo00<Hdoooool01?oo
00<Hdoooool01_oo11SC0_oo00<Hdoooool01?oo00<Hdoooool01?oo00<Hdoooool00ooo11SCU?oo
0`00AOoo0006ool00`00ooooo`06ool00aSCooooo`04ool00aSCooooo`04ool00aSCooooo`03ool3
6=<6ool00aSCooooo`04ool00aSCooooo`04ool00aSCoolHd`036=>Eool30018ool000Koo`03003o
oooo00Koo`036=?ooooo00?oo`8Hd`Koo`046=?oooooool26=<00ooo6=?oo`06ool00aSCooooo`04
ool00aSCooooo`03ool36=>Eool4001;ool000Goo`03003ooooo00Ooo`036=?ooooo00?oo`8Hd`Go
o`8Hd`03oolHdaSC00?oo`036=?ooooo00Goo`036=?ooooo00Coo`046=?oooooool26=>Eool3001?
ool000Goo`03003ooooo00Ooo`036=?ooooo00?oo`8Hd`?oo`DHd`Goo`036=?ooooo00Coo`036=?o
oooo00Goo`046=?ooaSC6=>Dool3001Bool000Goo`03003ooooo00Koo`036=?ooooo00Coo`8Hd`03
oolHdaSC008Hd`03oolHdooo00Goo`036=?ooooo00Coo`036=?ooooo00?oo`@Hdi;oo`@005Goo`00
1Ooo00<00?ooool01_oo00<Hdoooool00ooo11SC1Ooo00<Hdoooool01?oo00<Hdoooool01?oo00<H
dooo6=<00aSCTooo0`00FOoo0005ool00`00ooooo`06ool00aSCoolHd`036=<00ooo6=<Hd`06ool0
0aSCooooo`04ool00aSCooooo`03ool36=>Dool3001Lool000Goo`03003ooooo00Koo`8Hd`Goo`8H
d`Koo`036=?ooooo00Coo`046=?oooooool26=>Dool3001Oool000Goo`03003ooooo00Koo`036=?o
oooo00Coo`8Hd`Goo`036=?ooooo00Goo`046=?ooaSC6=>Bool4001Rool000Goo`03003ooooo00Ko
o`036=?ooooo00Coo`8Hd`Goo`036=?ooooo00?oo`@Hdi7oo`<006Koo`001Ooo00<00?ooool01_oo
00<Hdoooool01?oo00<Hdoooool01?oo00<Hdooo6=<00aSCT_oo0`00JOoo0005ool00`00ooooo`06
ool00aSCooooo`04ool00aSCooooo`03ool36=>Bool4001/ool000Goo`03003ooooo00Koo`036=?o
oooo00Coo`036=?ooaSC00<Hd`03oolHdooo08ooo`<0073oo`001Ooo00<00?ooool01_oo00<Hdooo
ool00ooo1ASC0ooo00<Hdoooool0Rooo0`00Looo0004ool00`00ooooo`07ool011SCoooooooo1ASC
1Ooo00<Hdoooool0R?oo0`00M_oo0004ool00`00ooooo`07ool00aSCoolHd`036=<00ooo6=?oo`05
ool00aSCooooo`24ool4001iool000Coo`03003ooooo00Ooo`8Hd`Goo`036=?ooooo00Coo`036=?o
oooo087oo`<007goo`001?oo00<00?ooool01ooo00<Hdoooool01?oo00<Hdoooool01?oo00<Hdooo
ool0O_oo0`00P?oo0004ool00`00ooooo`07ool00aSCooooo`04ool00aSCooooo`04ool00aSCoooo
o`1jool40023ool000Coo`03003ooooo00Ooo`036=?ooooo00?oo`036=?ooooo00Goo`036=?ooooo
07Ooo`<008Ooo`001?oo00<00?ooool01ooo00<Hdoooool00ooo00<Hdoooool00ooo0aSCM_oo0`00
R_oo0004ool00`00ooooo`06ool00aSCooooo`04ool00aSCoolHd`036=<00ooo6=?oo`0Vool26==:
ool4002=ool000Coo`03003ooooo00Koo`036=?ooooo00?oo`<Hd`Goo`036=?ooooo02;oo`<Hd`03
oolHdooo04Koo`<0097oo`001?oo00<00?ooool01_oo00@Hdoooooooo`8Hd`03oolHdooo00Goo`03
6=?ooooo01koo`@Hd`Coo`036=?ooooo04;oo`<009Coo`001?oo00<00?ooool01_oo00@Hdooo6=<H
d`?oo`036=?ooooo00Coo`036=?ooooo01_oo`<Hd`Soo`036=?ooooo03ooo`<009Ooo`000ooo00<0
0?ooool01ooo0QSC1Ooo00<Hdoooool01?oo00<Hdoooool06?oo0aSC2ooo00<Hdoooool0>ooo1000
V_oo0003ool00`00ooooo`07ool00aSCooooo`04ool00aSCooooo`04ool00aSCooooo`0Eool36=<>
ool00aSCooooo`0hool3002Nool000?oo`03003ooooo00Ooo`036=?ooooo00?oo`8Hd`Koo`036=?o
oooo017oo`@Hda7oo`036=?ooooo03Goo`<00:7oo`000ooo00<00?ooool01ooo00<Hdoooool00ooo
0QSC1_oo00<Hdoooool03_oo0aSC5Ooo00<Hdoooool0<Ooo1000Y?oo0003ool00`00ooooo`07ool0
0aSCooooo`03ool26=<5ool26=<=ool36=<Hool00aSCooooo`0^ool3002Xool000?oo`03003ooooo
00Koo`036=?ooooo00Coo`8Hd`03oolHdaSC008Hd`03oolHdooo00Woo`<Hda_oo`036=?ooooo02_o
o`<00:_oo`000ooo00<00?ooool01_oo00<Hdoooool00ooo11SC1Ooo00<Hdoooool01?oo11SC7Ooo
00<Hdoooool0:Ooo0`00[_oo0003ool00`00ooooo`06ool00aSCoolHd`036=<00ooo6=<Hd`06ool0
11SCoooooooo0aSC8Ooo00<Hdoooool09Ooo1000/Ooo0003ool00`00ooooo`06ool46=<3ool26=<6
ool011SCoolHdaSC9?oo00<Hdoooool08_oo0`00]Ooo0003ool00`00ooooo`06ool26=<5ool26=<5
ool011SCoooooaSC9Ooo00<Hdoooool07ooo0`00^?oo0003ool00`00ooooo`06ool00aSCooooo`04
ool26=<5ool011SCoooooaSC9Ooo00<Hdoooool06ooo1000^ooo0003ool00`00ooooo`06ool00aSC
ooooo`04ool00aSCooooo`04ool011SCoooooaSC9Ooo00<Hdoooool06?oo0`00_ooo0002ool00`00
ooooo`07ool00aSCooooo`04ool00aSCooooo`04ool011SCoooooaSC9Ooo00<Hdoooool05Ooo0`00
`_oo0002ool00`00ooooo`07ool00aSCooooo`04ool00aSCooooo`03ool26=<00ooo6=?oo`0Uool0
0aSCooooo`0Bool30035ool000;oo`03003ooooo00Ooo`036=?ooooo00Coo`036=?ooaSC00<Hd`04
oolHdooo6=<Uool26=<@ool40038ool000;oo`03003ooooo00Ooo`036=?ooooo00?oo`<Hd`Goo`03
6=?ooaSC027oo`@Hd`ooo`<00<coo`000_oo00<00?ooool01ooo00<Hdooo6=<00aSC00?ooaSCool0
1Ooo00<Hdooo6=<07_oo0aSC4?oo0`00cooo0002ool00`00ooooo`07ool36=<4ool00aSCooooo`04
ool00aSCoolHd`0Kool36=<?ool4003Bool000;oo`03003ooooo00Koo`8Hd`Koo`036=?ooooo00Co
o`036=?ooaSC01Ooo`@Hd`ooo`<00=Koo`000_oo00<00?ooool01_oo00<Hdoooool01Ooo00<Hdooo
ool01?oo00<Hdooo6=<05?oo0aSC4?oo0`00fOoo0002ool00`00ooooo`06ool00aSCooooo`04ool0
0aSCooooo`05ool00aSCoolHd`0Aool36=<@ool3003Lool000;oo`03003ooooo00Koo`036=?ooooo
00Coo`036=?ooooo00Goo`036=?ooaSC00goo`@Hd`ooo`@00=ooo`000_oo00<00?ooool01_oo00<H
doooool01?oo00<Hdoooool00ooo11SC2ooo0aSC4?oo0`00hooo00000ooo003oo`08ool00aSCoooo
o`04ool00aSCoolHd`036=<3ool00aSCooooo`06ool36=<@ool3003Vool00003ool00?oo00Soo`03
6=?ooooo00?oo`<Hd`Ooo`036=?ooooo00;oo`@Hd`ooo`@00>Woo`0000?oo`00ool02?oo00<Hdooo
6=<00aSC00?ooaSCool01ooo00<Hdooo6=<00QSC4?oo0`00kOoo00000ooo003oo`08ool46=<3ool0
0aSCooooo`06ool26=<@ool3003`ool00003ool00?oo00Soo`8Hd`Goo`036=?ooooo01Goo`<00??o
o`0000?oo`00ool02?oo00<Hdoooool01?oo00<Hdoooool04Ooo1000m_oo00000ooo003oo`08ool0
0aSCooooo`03ool00aSCooooo`0?ool3003jool00003ool00?oo00Soo`036=?ooooo00?oo`036=?o
oooo00coo`<00?goo`0000?oo`00ool02?oo00<Hdoooool00ooo00<Hdoooool02?oo1000oooo0Ooo
00000ooo003oo`07ool00aSCooooo`04ool00aSCooooo`05ool3003oool5ool00003ool00?oo00Oo
o`036=?ooooo00?oo`8Hd`Coo`<00?ooo`Soo`0000?oo`00ool01ooo00@Hdoooooooo`8Hd`?oo`<0
0?ooo`_oo`0000<00?ooool01ooo00DHdooo6=<Hdooo00@00?ooo`koo`0000<00?ooool01ooo0QSC
0`00oooo4_oo00000`00ooooo`06ool3003ooolEool00003003ooooo00;oo`@00?oooaSoo`0000<0
0?oo00000P00oooo7?oo0002003ooolOool00001\
\>"],
  ImageRangeCache->{{{0, 287}, {160.5, 0}} -> {0.053476, 0.226319, 0.0033029, \
0.0033029}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(If[
        do3D === 1, \[IndentingNewLine]ThreeScript["\<object.ts\>", 
          g8]\[IndentingNewLine]];\)\)], "Input"],

Cell[BoxData[
    \( (*\ \(! \(! object . ts\)\)\ *) \)], "Input"],

Cell[BoxData[
    \( (*\ \(Run["\<~/mgl/MathView3D/Source/mathview3d -mvfile \
~/PeriodicTableOfElements/object.ts object.pov\>"];\)\ *) \)], "Input"],

Cell[BoxData[
    \(\(Remove[g8];\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(MemoryInUse[] // fNBookForm2\)], "Input"],

Cell[BoxData[
    \("25.59\[ThinSpace]M"\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["OLD   b&w  lanthanide / actinide  (modified)", "Subsubsection"],

Cell["\<\
each cell can be moved around easy enough for any preferred layout
one thing to keep in mind (seeing below) is where NOT to put things
so they are not trapped by parts of the chart moving around\
\>", "Text"],

Cell["\<\
this was written quickly and works terribly slowly - and maybe \
there's a easier better way considering

it needs to be modified for Group and due to recent changes the offsets are a \
little \"off\" 

maybe just let it eat.  but it shows ANYTHING can be done - and howto

another method would be drawing part of chart (gen funs take ranges) , \
changing cmat , drawing the rest

however changing the template to start with is far easier and that's why it \
began there was the hope / idea\
\>", "Text"],

Cell[BoxData[
    \(\(gobw = go2D;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(gobwbox = go22D;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Module[{yoff, voff, n, m}, \[IndentingNewLine]xoff = 0; 
        yoff = \(-87\); 
        voff = Table[{0, yoff/34.8}, {n, 5}]; \[IndentingNewLine]Do[
          Do[Do[\[IndentingNewLine]m = \((\((chartheight - 
                          i)\)\ chartwidth)\) + 
                  j; \[IndentingNewLine]gobw[\([1, k, m, 2]\)] += {xoff, 
                  yoff}; \[IndentingNewLine]If[
                gobwbox[\([1, m, 
                      1]\)] \[NotEqual] {}, \
\[IndentingNewLine]\(gobwbox[\([1, m, 1, 3, 1]\)] += 
                    voff;\)\[IndentingNewLine]]\[IndentingNewLine], {k, 
                textobjects}\[IndentingNewLine]], {j, 4, 11}], {i, 6, 
            7}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Module[{xoff, voff, n, m}, \[IndentingNewLine]xoff = \(-180\); 
        yoff = 0; 
        voff = Table[{xoff/34.8, 0}, {n, 5}]; \[IndentingNewLine]Do[
          Do[Do[\[IndentingNewLine]m = \((\((chartheight - 
                          i)\)\ chartwidth)\) + 
                  j; \[IndentingNewLine]gobw[\([1, k, m, 2]\)] += {xoff, 
                  yoff}; \[IndentingNewLine]If[
                gobwbox[\([1, m, 
                      1]\)] \[NotEqual] {}, \
\[IndentingNewLine]\(gobwbox[\([1, m, 1, 3, 1]\)] += 
                    voff;\)\[IndentingNewLine]]\[IndentingNewLine], {k, 
                textobjects}\[IndentingNewLine]], {j, 12, chartwidth}], {i, 
            1, chartheight}]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(laline = 
        Graphics[{Hue[
              0], \[IndentingNewLine]Arrow[\[IndentingNewLine]gobwbox[\([1, 
                  35, 1, 3, 1, 3]\)], \[IndentingNewLine]gobwbox[\([1, 36, 1, 
                  3, 1, 1]\)], \[IndentingNewLine]HeadScaling \[Rule] 
                Relative\[IndentingNewLine]]\[IndentingNewLine] (*\(,\)\(\
\[IndentingNewLine]\)\(Spline[{\[IndentingNewLine]gobwbox[\([1, 35, 1, 3, 1, 
                      3]\)], \[IndentingNewLine]gobwbox[\([1, 36, 1, 3, 1, 
                      1]\)], \[IndentingNewLine]gobwbox[\([1, 43, 1, 3, 1, 
                      4]\)]\[IndentingNewLine]}, 
                CompositeBezier]\)\[IndentingNewLine]*) \[IndentingNewLine]}];\
\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Show[colhead2Dgr, titlegr, edgr, notesgr, ptgr, convgr, gobw, 
        gobwbox, 
        laline, \[IndentingNewLine]AspectRatio \[Rule] 
          Automatic, \[IndentingNewLine]ImageSize \[Rule] {600, 
            300}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    RowBox[{
      RowBox[{"printcell", "[", 
        RowBox[{"\"\<graph.3.ps\>\"", ",", 
          StyleBox[\(PrintingOptions -> {printopts}\),
            FontFamily->"Courier"], 
          StyleBox[",",
            FontFamily->"Courier"], 
          RowBox[{
            StyleBox["PageHeaderLines",
              FontFamily->"Courier"], "\[Rule]", \({False, False}\)}]}], 
        "]"}], ";"}]], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["old / short / 2 cell larger font", "Subsubsection"],

Cell["\<\
good news is 2d adn 3d charts superimpose well.  don't forget \
WARNINGS & tables\
\>", "Text"],

Cell[BoxData[
    \(go8a =. ; go8b =. ;\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go8a = Table[go2D[\([1, All, i]\)], {i, 1, 64}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go8b = Table[go22D[\([1, i]\)], {i, 1, 64}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(showit2D[Graphics[go8a], 
      go8b, {{110, 175}, {\(-1\), 1}, {40, 100}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(showit2D[go2D, go22D, {{10, 86}, {\(-1\), 1}, {1, 48}}]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["etc format output", "Subsubsection"],

Cell["\<\
(* 
ABOVE:
to render EPS (post script encapsulated / one page)
ImageSize is needed to:
\t limit width (won't fit on page)
\tlock font size to box size (otherwise fonts are 2x size / dont' fit in box)
not PlotRange: apparently this doesn't effect output (see help: says \"\")
*)\
\>", "Text"],

Cell[BoxData[
    \(Display[go7, \ ImageRotated \[Rule] True]\)], "Input",
  Evaluatable->False],

Cell["\<\
(* this works but takes a good long while - 15 min i'd guess \
*)\
\>", "Text"],

Cell[BoxData[
    \(\(Display["\<graph.eps\>", 
        Plot[Cos[x], {x, 0, 2  \[Pi]}], "\<EPS\>"];\)\)], "Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(2 + 2\)], "Input"],

Cell[BoxData[
    \(4\)], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(Display["\<graph.jpg\>", g7, "\<JPG\>"];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(Display["\<graph.pdf\>", 
        Plot[Cos[x], {x, 0, 2  \[Pi]}], "\<PDF\>"];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(do3D = 1;\)\)], "Input"],

Cell[BoxData[
    \(\(If[do3D === 1, 
        Show[go, go2, AspectRatio \[Rule] Automatic, 
          ImageSize \[Rule] {700, 210}\[IndentingNewLine], 
          ViewPoint \[Rule] {0, \(-1\), 0}, 
          LightSources \[Rule] {{{0, \(-4\), 0}, 
                RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
                RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
                RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
                RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, GrayLevel[ .5]}}, 
          AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], 
          Axes \[Rule] False\[IndentingNewLine]]];\)\)], "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["scratch", "Subsubtitle"],

Cell[CellGroupData[{

Cell["etc primatives (none of these used, genit does now)", "Subsection"],

Cell["\<\
p is backdrop for 2d cell: Rectangle is 2d only (line is \
both)\
\>", "Text"],

Cell[BoxData[
    \(\(p = 
        Graphics[{GrayLevel[0.85], Rectangle[{0, 0}, {1, 1}]}];\)\)], "Input",\

  Evaluatable->False],

Cell["l is the L shaped in Section trials above", "Text"],

Cell[BoxData[
    \(\(l = 
        Graphics[{Thickness[ .02], RGBColor[0, 0, 1], 
            Line[{{0, 1}, {0, 0}, {0, 0}, {1, 0}}]}];\)\)], "Input",
  Evaluatable->False],

Cell["junk from  Section trials above", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(g2 = 
      Graphics3D[{\[IndentingNewLine]Cuboid[\[IndentingNewLine]Scaled[{ .8,  \
.5, 0}]\[IndentingNewLine], 
            Scaled[{ .9,  .9,  .9}]\[IndentingNewLine]]}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]{Point[{0, 0, 0}], 
              Point[Scaled[{0, 0, 0}, {0, 
                    0, \(- .2\)}]]}\[IndentingNewLine], {Text["\<a point\>", 
                Scaled[{ .5,  .5,  .5}]]}\[IndentingNewLine]}\
\[IndentingNewLine]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(g4 = 
        Graphics3D[{\[IndentingNewLine]\[IndentingNewLine]{Line[{{0, 0, 
                    0}, {1, 0, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 1, 0}}]}\[IndentingNewLine], {Line[{{0, 0, 
                    0}, {0, 0, 
                    1}}]}\[IndentingNewLine]\[IndentingNewLine] \
(*\[IndentingNewLine]\(,\)\({Line[ .95 {{0, 0, 0}, {1, 0, 
                        0}, { .95,  .1,  .1}}]}\)\(\[IndentingNewLine]\)\(,\)\
\({Line[ .95 {{0, 0, 0}, {0, 1, 
                        0}, { .1,  .95,  .1}}]}\)\(\[IndentingNewLine]\)\(,\)\
\({Line[ .95 {{0, 0, 0}, {0, 0, 
                        1}, { .1,  .1,  .95}}]}\)\(\[IndentingNewLine]\)\(\
\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(,\)\({Text["\<+X1\>", 
                  Scaled[{ .1,  .05,  .05},  .80 {1, 0, 
                        0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\
\(,\)\({Text["\<+Y1\>", 
                  Scaled[{ .01,  .1,  .01},  .80 {0, 1, 
                        0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\
\(,\)\({Text["\<+Z1\>", 
                  Scaled[{ .01,  .01,  .1},  .80 {0, 0, 
                        1}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\
\(\[IndentingNewLine]\)\(,\)\({Text["\<X0\>", 
                  Scaled[{ .01,  .01,  .01}, { .1, 0, 
                      0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(,\
\)\({Text["\<Y0\>", 
                  Scaled[{ .01,  .01,  .01}, {0,  .1, 
                      0}]]}\)\(\[IndentingNewLine]\)\(\[IndentingNewLine]\)\(,\
\)\({Text["\<Z0\>", 
                  Scaled[{ .01,  .01,  .01}, {0, 
                      0,  .1}]]}\)\[IndentingNewLine]*) \[IndentingNewLine]\
\[IndentingNewLine]}\[IndentingNewLine]\[IndentingNewLine]\[IndentingNewLine] \
(*\[IndentingNewLine]\(,\)\(FaceGrids \[Rule] 
              All\)\(\[IndentingNewLine]\)\(,\)\(BoxRatios \[Rule] {1, 1, 
                1}\)\(\[IndentingNewLine]\)\(,\)\(PlotRange \[Rule] {{0, 
                  1}, {0, 1}, {0, 
                  1}}\)\[IndentingNewLine]*) \[IndentingNewLine]];\)\)], \
"Input",
  Evaluatable->False],

Cell[CellGroupData[{

Cell[BoxData[
    \(g5 = 
      Graphics3D[AxesLabel \[Rule] {"\<x\>", "\<y\>", "\<z\>"}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
    \(g1 = 
      Graphics3D[\[IndentingNewLine]{\[IndentingNewLine]Cuboid[\
\[IndentingNewLine]1.1 { .25,  .04,  .25}\[IndentingNewLine], 
            1.3 { .75,  .04,  .75}\[IndentingNewLine]]\[IndentingNewLine]}\
\[IndentingNewLine]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Closed]],

Cell[BoxData[
    \(Remove[p, l, g1, g2, g3, g4, g5]\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
GraphicsArray OLD broken split chart into 3 separate combinable \
pieces\
\>", "Subsection"],

Cell["\<\
(* { go[[1,2,1]],go[[1,3,1]]};
genit[2 32]; showit[{{15,70},{-1,1},{1,40}}] *)\
\>", "Text"],

Cell["\<\
CANNOT get 3D or 2D  Graphics array to display right and done with \
trying.
\t* top guess is that PlotRange isn't copying to go5 what it shows
\t* could be GraphicsArray doesn't like that boxes and text are together in \
each
\t* doubt the go arrays contain \"shadow copies\" that GraphicsArray is doing
FIXME
\t* I used arrays of graphics and graphics array didn't like arrays
\t   to split the chart into 6 parts for \"printing easier\"
\t    (could try re-organizing arrays)
\t* I used Show to pre-render and graphics array
\t   refuses to consider each block rendered as being the same size
\t   it always dialates and contracts the parts rendered and
\t   after trying 1hr i don't yet see the option to turn it off\
\>", "Text"],

Cell[BoxData[
    \(showit[{{15, 175}, {\(-1\), 1}, {1, 100}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[go, go2, ViewPoint \[Rule] {0, \(-1\), 0}, 
      LightSources \[Rule] {{{0, \(-4\), 0}, 
            RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
            RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
            RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
            RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, GrayLevel[ .5]}}, 
      AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], Axes \[Rule] False, 
      PlotRange \[Rule] {{10, 596}, {\(-1\), 1}, {10, 300}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[go, go2, ViewPoint \[Rule] {0, \(-1\), 0}, 
      LightSources \[Rule] {{{0, \(-4\), 0}, 
            RGBColor[ .7,  .1,  .1]}, {{4, 0, 0}, 
            RGBColor[ .1,  .7,  .1]}, {{0, 0, 4}, 
            RGBColor[ .1,  .1,  .7]}, {{1.3, \(-2.4\), 2}, 
            RGBColor[ .5,  .5,  .5]}, {{0, \(-2\), 0}, GrayLevel[ .5]}}, 
      AmbientLight \[Rule] RGBColor[ .25,  .25,  .25], Axes \[Rule] False, 
      PlotRange \[Rule] {{597, 1109}, {\(-1\), 1}, {10, 300}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5 = Table[i, {j, 1, 2}, {i, 1, 3}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 1]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{10, 363 + 29}, {135, 300}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 2]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{363 - 12, \((363*2)\) + 41}, {135, 
                300}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 3]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{41 + 363*2, 363*3 + 20}, {135, 
                300}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 1]\)] = 
      Show[go42D, go22D, Axes \[Rule] False, 
        PlotRange \[Rule] {{10, 363 + 29}, {10, 135}}]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 2]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{363 - 12, \((363*2)\)} + 41, {10, 
                135}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 3]\)] = 
        Show[go42D, go22D, Axes \[Rule] False, 
          PlotRange \[Rule] {{41 + 363*2, 363*3 + 20}, {10, 
                135}}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[ch2]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{{go5[\([1, 1]\)], go5[\([1, 2]\)], 
            go5[\([1, 3]\)]}\[IndentingNewLine], {go5[\([2, 1]\)], 
            go5[\([2, 2]\)], 
            go5[\([2, 
                3]\)]}\ \[IndentingNewLine]}\[IndentingNewLine]]]\)], "Input",\

  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[ch2]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(ch2 // TableForm\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5 = Table[i, {j, 1, 7}, {i, 1, 3}];\)\)], "Input",
  Evaluatable->False],

Cell["note: runs LL (Francium) to UR (He) L-R", "Text"],

Cell[BoxData[
    \(\(go5[\([1, 1]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 0, 
            3}, {i, 1, 11}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([1, 1]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 1]\)] = Flatten[go5[\([1, 1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([1, 1]\)] = 
      Show[go5[\([1, 1]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 2]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 0, 
            3}, {i, 12, 12 + 10}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([1, 2]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 2]\)] = Flatten[go5[\([1, 2]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([1, 2]\)] = 
      Show[go5[\([1, 2]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 3]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 0, 
            3}, {i, 12 + 11, 12 + 11 + 10 - 1}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([1, 3]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([1, 3]\)] = Flatten[go5[\([1, 3]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([1, 3]\)] = 
      Show[go5[\([1, 3]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell["note: runs LL (Francium) to UR (He) L-R", "Text"],

Cell[BoxData[
    \(\(go5[\([2, 1]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 4, 
            6}, {i, 1, 11}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([2, 1]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 1]\)] = Flatten[go5[\([2, 1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 1]\)] = 
      Show[go5[\([2, 1]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 2]\)] = 
        Table[\[IndentingNewLine]{Graphics[
              go42D[\([1, All, i + \((j*32)\)]\)]], 
            go22D[\([1, i + \((j*32)\)]\)]}\[IndentingNewLine], {j, 4, 
            6}, {i, 12, 12 + 10}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([2, 2]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 2]\)] = Flatten[go5[\([2, 2]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 2]\)] = 
      Show[go5[\([2, 2]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 3]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 4, 
            6}, {i, 12 + 11, 12 + 11 + 10 - 1}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Dimensions[go5[\([2, 3]\)]]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5[\([2, 3]\)] = Flatten[go5[\([2, 1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go5[\([2, 3]\)] = 
      Show[go5[\([2, 3]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{go5[\([2, 1]\)], 
          go5[\([2, 2]\)]}\[IndentingNewLine]], 
      GraphicsSpacing \[Rule] \(- .035\), 
      AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{{go5[\([2, 1]\)], go5[\([2, 2]\)], 
            go5[\([2, 3]\)]}\[IndentingNewLine], {go5[\([1, 1]\)], 
            go5[\([1, 2]\)], 
            go5[\([1, 3]\)]}\ \[IndentingNewLine]}\[IndentingNewLine]], 
      GraphicsSpacing \[Rule] \(- .035\), 
      AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go5 =. ;\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6 = {1, 2, 3};\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([1]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 7, 
            0, \(-1\)}, {i, 1, 11}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([1]\)] = Flatten[go6[\([1]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go6[\([1]\)] = 
      Show[go6[\([1]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([2]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 7, 
            1, \(-1\)}, {i, 12, 12 + 10}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([2]\)] = Flatten[go6[\([2]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go6[\([2]\)] = 
      Show[go6[\([2]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([3]\)] = 
        Table[\[IndentingNewLine]If[
            i + \((j*32)\) <= 
              2\ ELEMENTS, \[IndentingNewLine]{Graphics[
                go42D[\([1, All, i + \((j*32)\)]\)]], 
              go22D[\([1, 
                  i + \((j*32)\)]\)]}\[IndentingNewLine], {Graphics[{}], 
              Graphics[{}]}\[IndentingNewLine]]\[IndentingNewLine], {j, 7, 
            1, \(-1\)}, {i, 12 + 11, 12 + 11 + 10 - 1}];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6[\([3]\)] = Flatten[go6[\([3]\)]];\)\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(go6[\([3]\)] = 
      Show[go6[\([3]\)], AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(Show[
      GraphicsArray[\[IndentingNewLine]{go6[\([1]\)], go6[\([2]\)], 
          go6[\([3]\)]}\[IndentingNewLine]], 
      GraphicsSpacing \[Rule] \(- .05\), 
      AspectRatio \[Rule] Automatic]\)], "Input",
  Evaluatable->False],

Cell[BoxData[
    \(\(go6 =. ;\)\)], "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{

Cell["scratch area", "Subsection"],

Cell["\<\
(*
showit[{{1,1200},{-1,1},{1,300}}]
{8.5,11}2
{1110/4,300/2}//N
go3={1,1,1,1,1,1};
go3=Table[
    Show[go,go2
      ,ViewPoint\[Rule]{0,-1,0}
      ,LightSources\[Rule]{
          {{0,-4,0},RGBColor[.7,.1,.1]}
          ,{{4,0,0},RGBColor[.1,.7,.1]}
          ,{{0,0,4},RGBColor[.1,.1,.7]}
          ,{{1.3,-2.4,2},RGBColor[.5,.5,.5]}
          ,{{0,-2,0},GrayLevel[.5]}}
      ,AmbientLight\[Rule]RGBColor[.25,.25,.25]
      ,Axes\[Rule]False,PlotRange\[Rule]{{10+(1109/3)(i-1),10+(1109/3) \
i},{-1,1},{10+150(j-1),10+150 j}}]
    ,{i,1,3},{j,1,2}
    ]
Show[GraphicsArray[go3[[All]]]]
Remove[go3]
PlotRange\[Rule]{{597,1109},{-1,1},{10,300}};
*)\
\>", "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["scratch area", "Subsection"],

Cell["\<\
ViewPoint\tcannot go inside bounding box
{0,0,0}\t\twhere camera points
{1.3,-2.4,2}  \tdefault is above and right
{0,-1,0}\t\tfront
ViewPoint\[Rule]{1.3,-2.4,2},
ViewPoint\[Rule]{0,-1,0},

(*
  Graphics3D[{
      {Line[{{0,0,0},{.1,0,0}}]}
      ,{Line[{{0,0,0},{0,.1,0}}]}
      ,{Line[{{0,0,0},{0,0,.1}}]}
      }],
  *)
,FaceGrids\[Rule]All
,BoxRatios\[Rule]{1,1,1}
(* ,PlotRange\[Rule]{{.025,.035},{-.1,.1},{.13,.14}} *)
,Axes\[Rule]True,AxesLabel\[Rule]{\"x\",\"y\",\"z\"}
  (*
  ,FaceGrids\[Rule]All
  ,BoxRatios\[Rule]{1,1,1}
  ,PlotRange\[Rule]{{0,1},{0,1},{0,1}}
  *)\
\>", "Text"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics3D  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell[BoxData[
    \($Aborted\)], "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["END PACKAGE", "Subsubtitle"],

Cell[BoxData[
    \(\(End[];\)\)], "Input",
  InitializationCell->True],

Cell[BoxData[
    \(\(EndPackage[];\)\)], "Input",
  InitializationCell->True]
}, Closed]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1280}, {0, 1024}},
AutoGeneratedPackage->None,
ShowPageBreaks->False,
Evaluator->"Local",
PrintAction->"SeparateCells",
WindowSize->{793, 635},
WindowMargins->{{Automatic, 119}, {30, Automatic}},
PrintingPageRange->{Automatic, Automatic},
PageHeaderLines->{False, False},
PrintingOptions->{"PrintingMargins"->{{0, 0}, {0, 0}},
"PaperSize"->{700, 210},
"PaperOrientation"->"Portrait",
"PrintCellBrackets"->False,
"PrintRegistrationMarks"->False,
"PrintMultipleHorizontalPages"->False,
"FirstPageHeader"->False,
"FirstPageFooter"->False,
"RestPagesHeader"->False,
"RestPagesFooter"->False,
"IncludeSpecialFonts"->True,
"IncludePostScriptResourceDirectives"->True,
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "jdh", \
"PeriodicTableOfElements"}, "x.ps", CharacterEncoding -> "ISO8859-1"],
"UsePostScriptOutputFile"->True,
"Magnification"->1},
IndexCreationOptions->{"Format"->"Hyperlinks"},
ShowCellTags->True,
InputAutoReplacements->{},
Magnification->1
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "S2.8.7"->{
    Cell[587851, 12708, 112, 4, 40, "Input",
      CellTags->"S2.8.7"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"S2.8.7", 1542198, 43183}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 278, 5, 65, "Text"],

Cell[CellGroupData[{
Cell[2020, 58, 47, 0, 42, "Subsubsection"],
Cell[2070, 60, 147, 5, 32, "Text"],
Cell[2220, 67, 176, 5, 50, "Text"],
Cell[2399, 74, 112, 2, 32, "Text"],
Cell[2514, 78, 23, 0, 31, "Text"],
Cell[2540, 80, 749, 11, 133, "Text"],
Cell[3292, 93, 114, 3, 31, "Text"],
Cell[3409, 98, 587, 12, 133, "Text"],
Cell[3999, 112, 131, 3, 48, "Text"],
Cell[4133, 117, 440, 7, 82, "Text"],
Cell[4576, 126, 195, 4, 48, "Text"],
Cell[4774, 132, 208, 4, 48, "Text"],
Cell[4985, 138, 170, 5, 32, "Text"],
Cell[5158, 145, 307, 7, 66, "Text"],
Cell[5468, 154, 920, 16, 152, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[6425, 175, 135, 4, 44, "Subsubsection"],
Cell[6563, 181, 199, 6, 49, "Text"],

Cell[CellGroupData[{
Cell[6787, 191, 92, 1, 27, "Input"],
Cell[6882, 194, 69, 1, 70, "Output"]
}, Closed]],
Cell[6966, 198, 136, 4, 65, "Text"],
Cell[7105, 204, 361, 11, 116, "Text"],
Cell[7469, 217, 56, 1, 27, "Input"],
Cell[7528, 220, 52, 1, 27, "Input"],
Cell[7583, 223, 54, 1, 27, "Input"],
Cell[7640, 226, 56, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[7721, 231, 46, 1, 27, "Input"],
Cell[7770, 234, 41, 1, 70, "Output"]
}, Closed]],
Cell[7826, 238, 2008, 31, 577, "Text"],
Cell[9837, 271, 32, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[9906, 276, 79, 0, 29, "Subsection"],

Cell[CellGroupData[{
Cell[10010, 280, 46, 0, 42, "Subsubsection"],
Cell[10059, 282, 461, 14, 111, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[10557, 301, 40, 0, 42, "Subsubsection"],
Cell[10600, 303, 808, 20, 263, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[11445, 328, 54, 0, 42, "Subsubsection"],
Cell[11502, 330, 114, 3, 31, "Text"],
Cell[11619, 335, 131, 3, 31, "Text"],
Cell[11753, 340, 1491, 37, 415, "Text"],
Cell[13247, 379, 240, 5, 65, "Text"],
Cell[13490, 386, 964, 35, 118, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[14491, 426, 55, 0, 42, "Subsubsection"],
Cell[14549, 428, 106, 3, 31, "Text"],
Cell[14658, 433, 1298, 32, 505, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[15993, 470, 64, 0, 42, "Subsubsection"],
Cell[16060, 472, 195, 4, 48, "Text"],
Cell[16258, 478, 133, 3, 48, "Text"],
Cell[16394, 483, 614, 18, 185, "Text"],
Cell[17011, 503, 100, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[17148, 511, 55, 0, 42, "Subsubsection"],
Cell[17206, 513, 256, 5, 65, "Text"],
Cell[17465, 520, 96, 3, 31, "Text"],
Cell[17564, 525, 2174, 48, 849, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[19775, 578, 71, 0, 42, "Subsubsection"],
Cell[19849, 580, 246, 7, 49, "Text"],
Cell[20098, 589, 1121, 29, 351, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[21256, 623, 48, 0, 42, "Subsubsection"],
Cell[21307, 625, 67, 0, 31, "Text"],
Cell[21377, 627, 158, 3, 48, "Text"],
Cell[21538, 632, 855, 22, 245, "Text"],
Cell[22396, 656, 130, 3, 48, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[22563, 664, 110, 3, 42, "Subsubsection"],
Cell[22676, 669, 837, 13, 202, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[23562, 688, 35, 0, 29, "Subsection"],
Cell[23600, 690, 71, 1, 27, "Input"],
Cell[23674, 693, 82, 1, 27, "Input"],
Cell[23759, 696, 83, 1, 27, "Input"],
Cell[23845, 699, 68, 0, 27, "Input"],
Cell[23916, 701, 69, 1, 27, "Input"],
Cell[23988, 704, 67, 1, 27, "Input"],
Cell[24058, 707, 71, 1, 27, "Input"],
Cell[24132, 710, 67, 1, 27, "Input"],
Cell[24202, 713, 77, 1, 27, "Input"],
Cell[24282, 716, 70, 1, 27, "Input"],
Cell[24355, 719, 48, 0, 27, "Input"],
Cell[24406, 721, 44, 0, 27, "Input"],
Cell[24453, 723, 70, 1, 27, "Input"],
Cell[24526, 726, 67, 1, 27, "Input"],
Cell[24596, 729, 27, 0, 31, "Text"],
Cell[24626, 731, 58, 1, 27, "Input"],
Cell[24687, 734, 63, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[24787, 740, 67, 1, 56, "Section"],
Cell[24857, 743, 142, 3, 48, "Text"],
Cell[25002, 748, 190, 4, 48, "Text"],
Cell[25195, 754, 537, 8, 107, "Input",
  InitializationCell->True],
Cell[25735, 764, 88, 2, 27, "Input",
  InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{
Cell[25860, 771, 65, 0, 40, "Section"],

Cell[CellGroupData[{
Cell[25950, 775, 33, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[26008, 779, 44, 0, 42, "Subsubsection"],
Cell[26055, 781, 102, 2, 27, "Input"],

Cell[CellGroupData[{
Cell[26182, 787, 47, 1, 27, "Input"],
Cell[26232, 790, 110, 2, 70, "Output"],
Cell[26345, 794, 116, 3, 45, "Output"]
}, Closed]],
Cell[26476, 800, 66, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[26579, 805, 52, 0, 42, "Subsubsection"],
Cell[26634, 807, 95, 2, 27, "Input",
  Evaluatable->False],
Cell[26732, 811, 111, 2, 27, "Input",
  Evaluatable->False],
Cell[26846, 815, 208, 4, 43, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[27079, 823, 159, 3, 27, "Input",
  Evaluatable->False],
Cell[27241, 828, 97, 2, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[27375, 835, 146, 3, 27, "Input",
  Evaluatable->False],
Cell[27524, 840, 90, 1, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[27651, 846, 101, 2, 27, "Input",
  Evaluatable->False],
Cell[27755, 850, 128, 3, 23, "Print"]
}, Closed]],
Cell[27898, 856, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[27997, 860, 69, 2, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[28091, 866, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[28166, 870, 114, 3, 44, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[28317, 878, 98, 2, 27, "Input",
  Evaluatable->False],
Cell[28418, 882, 127, 3, 27, "Output"]
}, Closed]],
Cell[28560, 888, 95, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[28692, 895, 74, 0, 42, "Subsubsection"],
Cell[28769, 897, 451, 15, 184, "Text"],
Cell[29223, 914, 29, 0, 31, "Text"],
Cell[29255, 916, 74, 1, 27, "Input"],
Cell[29332, 919, 195, 4, 43, "Input"],
Cell[29530, 925, 265, 5, 59, "Input"],
Cell[29798, 932, 86, 1, 27, "Input"],
Cell[29887, 935, 87, 1, 27, "Input"],
Cell[29977, 938, 482, 7, 91, "Input"],
Cell[30462, 947, 368, 5, 43, "Input"],
Cell[30833, 954, 287, 4, 43, "Input"],
Cell[31123, 960, 65, 1, 27, "Input"],
Cell[31191, 963, 322, 7, 66, "Text"],
Cell[31516, 972, 103, 3, 31, "Text"],
Cell[31622, 977, 403, 6, 103, "Input"],
Cell[32028, 985, 437, 7, 101, "Input"],
Cell[32468, 994, 108, 3, 31, "Text"],
Cell[32579, 999, 76, 0, 31, "Text"],
Cell[32658, 1001, 87, 3, 31, "Text"],
Cell[32748, 1006, 295, 5, 91, "Input"],

Cell[CellGroupData[{
Cell[33068, 1015, 72, 1, 27, "Input"],
Cell[33143, 1018, 48, 1, 70, "Output"]
}, Closed]],
Cell[33206, 1022, 134, 3, 27, "Input"],
Cell[33343, 1027, 493, 10, 123, "Input"],

Cell[CellGroupData[{
Cell[33861, 1041, 86, 1, 27, "Input"],
Cell[33950, 1044, 70, 1, 70, "Output"]
}, Closed]],
Cell[34035, 1048, 543, 11, 123, "Input"],

Cell[CellGroupData[{
Cell[34603, 1063, 91, 1, 27, "Input"],
Cell[34697, 1066, 58, 1, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[34804, 1073, 87, 1, 42, "Subsubsection"],
Cell[34894, 1076, 188, 3, 59, "Input"],
Cell[35085, 1081, 66, 1, 27, "Input"],
Cell[35154, 1084, 267, 5, 59, "Input"],
Cell[35424, 1091, 419, 6, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[35892, 1103, 34, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[35951, 1107, 79, 0, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[36055, 1111, 383, 6, 171, "Input"],
Cell[36441, 1119, 189445, 5058, 70, "Output"]
}, Closed]],
Cell[225901, 6180, 87, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[226025, 6186, 114, 3, 42, "Subsubsection"],
Cell[226142, 6191, 512, 9, 155, "Input"],

Cell[CellGroupData[{
Cell[226679, 6204, 71, 1, 27, "Input"],
Cell[226753, 6207, 4728, 87, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[231530, 6300, 79, 0, 42, "Subsubsection"],
Cell[231612, 6302, 212, 4, 59, "Input"],
Cell[231827, 6308, 169, 3, 43, "Input"],

Cell[CellGroupData[{
Cell[232021, 6315, 50, 1, 27, "Input"],
Cell[232074, 6318, 97637, 1599, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[329760, 7923, 74, 0, 42, "Subsubsection"],
Cell[329837, 7925, 509, 8, 203, "Input"],

Cell[CellGroupData[{
Cell[330371, 7937, 49, 1, 27, "Input"],
Cell[330423, 7940, 4260, 82, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[334732, 8028, 82, 1, 42, "Subsubsection"],
Cell[334817, 8031, 357, 6, 123, "Input"],

Cell[CellGroupData[{
Cell[335199, 8041, 65, 1, 27, "Input"],
Cell[335267, 8044, 4564, 131, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[339880, 8181, 63, 0, 42, "Subsubsection"],
Cell[339946, 8183, 225, 4, 91, "Input"],

Cell[CellGroupData[{
Cell[340196, 8191, 67, 1, 27, "Input"],
Cell[340266, 8194, 2142, 62, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[342457, 8262, 73, 0, 42, "Subsubsection"],
Cell[342533, 8264, 232, 4, 91, "Input"],

Cell[CellGroupData[{
Cell[342790, 8272, 57, 1, 27, "Input"],
Cell[342850, 8275, 154642, 2935, 70, "Output"]
}, Closed]],
Cell[497507, 11213, 99, 3, 31, "Text"],
Cell[497609, 11218, 234, 4, 91, "Input"],

Cell[CellGroupData[{
Cell[497868, 11226, 58, 1, 27, "Input"],
Cell[497929, 11229, 40727, 711, 70, "Output"]
}, Closed]],
Cell[538671, 11943, 55, 1, 27, "Input"],
Cell[538729, 11946, 638, 11, 235, "Input"],
Cell[539370, 11959, 42, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[539437, 11964, 47, 1, 27, "Input"],
Cell[539487, 11967, 15588, 231, 70, "Output"]
}, Closed]],
Cell[555090, 12201, 636, 11, 235, "Input"],
Cell[555729, 12214, 41, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[555795, 12219, 47, 1, 27, "Input"],
Cell[555845, 12222, 31252, 443, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[587134, 12670, 60, 1, 27, "Input"],
Cell[587197, 12673, 41, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[587275, 12679, 54, 1, 27, "Input"],
Cell[587332, 12682, 41, 1, 70, "Output"]
}, Closed]],
Cell[587388, 12686, 166, 5, 32, "Text"],

Cell[CellGroupData[{
Cell[587579, 12695, 53, 1, 27, "Input"],
Cell[587635, 12698, 179, 5, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[587851, 12708, 112, 4, 40, "Input",
  CellTags->"S2.8.7"],
Cell[587966, 12714, 355, 9, 70, "Output"]
}, Closed]],
Cell[588336, 12726, 50, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[588411, 12730, 73, 1, 31, "Input"],
Cell[588487, 12733, 49, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[588573, 12739, 410, 11, 46, "Input"],
Cell[588986, 12752, 40, 1, 70, "Output"]
}, Closed]],
Cell[589041, 12756, 55, 1, 27, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[589157, 12764, 41, 0, 40, "Section"],

Cell[CellGroupData[{
Cell[589223, 12768, 29, 0, 42, "Subsubsection"],
Cell[589255, 12770, 96, 3, 31, "Text"],
Cell[589354, 12775, 409, 10, 152, "Text"],
Cell[589766, 12787, 175, 4, 65, "Text"],
Cell[589944, 12793, 111, 3, 31, "Text"],
Cell[590058, 12798, 457, 11, 167, "Text"],
Cell[590518, 12811, 162, 5, 32, "Text"],
Cell[590683, 12818, 259, 6, 99, "Text"],
Cell[590945, 12826, 471, 22, 371, "Text"],
Cell[591419, 12850, 483, 18, 303, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[591939, 12873, 54, 0, 28, "Subsubsection"],
Cell[591996, 12875, 2031, 32, 347, "Input"],
Cell[594030, 12909, 104, 2, 27, "Input"],
Cell[594137, 12913, 107, 2, 27, "Input"],
Cell[594247, 12917, 84, 1, 27, "Input"],
Cell[594334, 12920, 139, 4, 48, "Text"],
Cell[594476, 12926, 86, 1, 27, "Input"],
Cell[594565, 12929, 84, 1, 27, "Input"],
Cell[594652, 12932, 86, 1, 27, "Input"],
Cell[594741, 12935, 134, 3, 48, "Text"],

Cell[CellGroupData[{
Cell[594900, 12942, 38, 1, 27, "Input"],
Cell[594941, 12945, 232, 3, 70, "Output"]
}, Closed]],
Cell[595188, 12951, 49, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[595262, 12955, 40, 1, 27, "Input"],
Cell[595305, 12958, 157, 2, 70, "Output"]
}, Closed]],
Cell[595477, 12963, 94, 3, 31, "Text"],
Cell[595574, 12968, 380, 6, 91, "Input"],
Cell[595957, 12976, 427, 8, 91, "Input"],
Cell[596387, 12986, 378, 6, 91, "Input"],
Cell[596768, 12994, 425, 8, 91, "Input"],
Cell[597196, 13004, 76, 0, 31, "Text"],
Cell[597275, 13006, 219, 3, 62, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[597531, 13014, 76, 0, 28, "Subsubsection"],
Cell[597610, 13016, 75, 0, 31, "Text"],
Cell[597688, 13018, 444, 7, 82, "Text"],
Cell[598135, 13027, 114, 2, 27, "Input"],
Cell[598252, 13031, 114, 2, 27, "Input"],
Cell[598369, 13035, 212, 3, 59, "Input"],
Cell[598584, 13040, 359, 6, 126, "Input"],
Cell[598946, 13048, 159, 4, 48, "Text"],
Cell[599108, 13054, 659, 9, 139, "Input"],
Cell[599770, 13065, 804, 12, 150, "Text"],
Cell[600577, 13079, 764, 13, 155, "Input"],

Cell[CellGroupData[{
Cell[601366, 13096, 55, 1, 27, "Input"],
Cell[601424, 13099, 8958, 199, 97, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[610419, 13303, 44, 1, 24, "Input"],
Cell[610466, 13306, 48, 1, 27, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[610563, 13313, 125, 4, 44, "Subsubsection"],
Cell[610691, 13319, 318, 5, 65, "Text"],
Cell[611012, 13326, 299, 6, 107, "Input"],

Cell[CellGroupData[{
Cell[611336, 13336, 45, 1, 27, "Input"],
Cell[611384, 13339, 136, 3, 70, "Output"]
}, Closed]],
Cell[611535, 13345, 161, 4, 48, "Text"],

Cell[CellGroupData[{
Cell[611721, 13353, 451, 8, 155, "Input"],
Cell[612175, 13363, 1698, 47, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[613922, 13416, 55, 0, 28, "Subsubsection"],
Cell[613980, 13418, 115, 3, 31, "Text"],
Cell[614098, 13423, 152, 4, 65, "Text"],
Cell[614253, 13429, 199, 4, 75, "Input"],

Cell[CellGroupData[{
Cell[614477, 13437, 58, 1, 27, "Input"],
Cell[614538, 13440, 111, 2, 70, "Output"]
}, Closed]],
Cell[614664, 13445, 104, 2, 27, "Input"],
Cell[614771, 13449, 106, 2, 27, "Input"],
Cell[614880, 13453, 82, 1, 27, "Input"],
Cell[614965, 13456, 84, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[615074, 13461, 43, 1, 27, "Input"],
Cell[615120, 13464, 113, 2, 70, "Output"]
}, Closed]],
Cell[615248, 13469, 52, 1, 27, "Input"],
Cell[615303, 13472, 54, 1, 27, "Input"],
Cell[615360, 13475, 57, 1, 27, "Input"],
Cell[615420, 13478, 61, 1, 27, "Input"],
Cell[615484, 13481, 133, 3, 27, "Input"],
Cell[615620, 13486, 55, 0, 31, "Text"],
Cell[615678, 13488, 132, 3, 27, "Input"],
Cell[615813, 13493, 130, 3, 27, "Input"],
Cell[615946, 13498, 60, 0, 31, "Text"],
Cell[616009, 13500, 517, 9, 123, "Input"],
Cell[616529, 13511, 60, 0, 31, "Text"],
Cell[616592, 13513, 570, 10, 139, "Input"],
Cell[617165, 13525, 88, 1, 27, "Input"],
Cell[617256, 13528, 73, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[617354, 13532, 87, 1, 27, "Input"],
Cell[617444, 13535, 398, 5, 70, "Output"]
}, Closed]],
Cell[617857, 13543, 107, 3, 31, "Text"],
Cell[617967, 13548, 242, 4, 75, "Input"],
Cell[618212, 13554, 198, 4, 75, "Input"],
Cell[618413, 13560, 28, 0, 31, "Text"],
Cell[618444, 13562, 116, 2, 27, "Input"],
Cell[618563, 13566, 120, 2, 27, "Input"],
Cell[618686, 13570, 112, 3, 31, "Text"],
Cell[618801, 13575, 676, 12, 203, "Input"],
Cell[619480, 13589, 91, 1, 27, "Input"],
Cell[619574, 13592, 92, 3, 48, "Text"],
Cell[619669, 13597, 655, 11, 219, "Input"],
Cell[620327, 13610, 93, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[620445, 13615, 83, 1, 27, "Input"],
Cell[620531, 13618, 60, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[620628, 13624, 68, 1, 27, "Input"],
Cell[620699, 13627, 72, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[620808, 13633, 67, 1, 27, "Input"],
Cell[620878, 13636, 72, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[620987, 13642, 125, 2, 27, "Input"],
Cell[621115, 13646, 35, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[621187, 13652, 52, 1, 27, "Input"],
Cell[621242, 13655, 35, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[621314, 13661, 58, 1, 27, "Input"],
Cell[621375, 13664, 80, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[621492, 13670, 48, 1, 27, "Input"],
Cell[621543, 13673, 856, 18, 70, "Output"]
}, Closed]],
Cell[622414, 13694, 356, 10, 167, "Text"],
Cell[622773, 13706, 268, 6, 75, "Input"],
Cell[623044, 13714, 270, 6, 75, "Input"],
Cell[623317, 13722, 86, 3, 48, "Text"],

Cell[CellGroupData[{
Cell[623428, 13729, 172, 3, 43, "Input"],
Cell[623603, 13734, 38, 1, 70, "Output"]
}, Closed]],
Cell[623656, 13738, 87, 3, 48, "Text"],
Cell[623746, 13743, 233, 4, 59, "Input"],
Cell[623982, 13749, 243, 4, 59, "Input"],
Cell[624228, 13755, 103, 3, 31, "Text"],
Cell[624334, 13760, 259, 4, 75, "Input"],

Cell[CellGroupData[{
Cell[624618, 13768, 60, 1, 27, "Input"],
Cell[624681, 13771, 38, 1, 70, "Output"]
}, Closed]],
Cell[624734, 13775, 303, 7, 99, "Text"],

Cell[CellGroupData[{
Cell[625062, 13786, 307, 6, 59, "Input"],
Cell[625372, 13794, 835, 18, 70, "Output"]
}, Closed]],
Cell[626222, 13815, 183, 4, 43, "Input"],
Cell[626408, 13821, 223, 4, 75, "Input"],
Cell[626634, 13827, 94, 3, 31, "Text"],
Cell[626731, 13832, 460, 8, 139, "Input"],
Cell[627194, 13842, 220, 4, 75, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[627451, 13851, 64, 0, 28, "Subsubsection"],
Cell[627518, 13853, 209, 4, 65, "Text"],
Cell[627730, 13859, 157, 3, 48, "Text"],
Cell[627890, 13864, 404, 7, 139, "Input"],
Cell[628297, 13873, 155, 3, 43, "Input"],
Cell[628455, 13878, 111, 4, 65, "Text"],
Cell[628569, 13884, 338, 6, 91, "Input"],
Cell[628910, 13892, 116, 3, 31, "Text"],
Cell[629029, 13897, 209, 4, 75, "Input"],
Cell[629241, 13903, 63, 0, 31, "Text"],
Cell[629307, 13905, 178, 3, 43, "Input"],
Cell[629488, 13910, 221, 4, 59, "Input"],
Cell[629712, 13916, 111, 2, 27, "Input"],
Cell[629826, 13920, 240, 5, 59, "Input",
  Evaluatable->False],
Cell[630069, 13927, 95, 3, 31, "Text"],
Cell[630167, 13932, 59, 1, 27, "Input"],
Cell[630229, 13935, 61, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[630327, 13941, 55, 0, 28, "Subsubsection"],
Cell[630385, 13943, 342, 8, 116, "Text"],
Cell[630730, 13953, 387, 8, 116, "Text"],
Cell[631120, 13963, 285, 6, 107, "Input"],
Cell[631408, 13971, 158, 4, 65, "Text"],

Cell[CellGroupData[{
Cell[631591, 13979, 55, 1, 27, "Input"],
Cell[631649, 13982, 42, 1, 70, "Output"]
}, Closed]],
Cell[631706, 13986, 87, 3, 48, "Text"],
Cell[631796, 13991, 413, 8, 139, "Input"],
Cell[632212, 14001, 55, 0, 31, "Text"],
Cell[632270, 14003, 487, 9, 155, "Input"],
Cell[632760, 14014, 48, 0, 31, "Text"],
Cell[632811, 14016, 203, 4, 75, "Input"],
Cell[633017, 14022, 75, 0, 31, "Text"],
Cell[633095, 14024, 264, 5, 91, "Input"],

Cell[CellGroupData[{
Cell[633384, 14033, 122, 2, 27, "Input"],
Cell[633509, 14037, 38, 1, 70, "Output"]
}, Closed]],
Cell[633562, 14041, 503, 9, 139, "Input"],
Cell[634068, 14052, 76, 1, 27, "Input"],
Cell[634147, 14055, 78, 1, 27, "Input"],
Cell[634228, 14058, 78, 1, 27, "Input"],
Cell[634309, 14061, 80, 1, 27, "Input"],
Cell[634392, 14064, 25, 0, 31, "Text"],
Cell[634420, 14066, 120, 2, 27, "Input"],
Cell[634543, 14070, 81, 1, 27, "Input"],
Cell[634627, 14073, 90, 1, 27, "Input"],
Cell[634720, 14076, 84, 1, 27, "Input"],
Cell[634807, 14079, 93, 1, 27, "Input"],
Cell[634903, 14082, 69, 1, 27, "Input"],
Cell[634975, 14085, 72, 1, 27, "Input"],
Cell[635050, 14088, 66, 0, 31, "Text"],
Cell[635119, 14090, 81, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[635225, 14095, 42, 1, 27, "Input"],
Cell[635270, 14098, 1185, 24, 70, "Output"]
}, Closed]],
Cell[636470, 14125, 134, 4, 48, "Text"],

Cell[CellGroupData[{
Cell[636629, 14133, 78, 1, 27, "Input"],
Cell[636710, 14136, 66, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[636813, 14142, 52, 1, 27, "Input"],
Cell[636868, 14145, 38, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[636943, 14151, 74, 1, 27, "Input"],
Cell[637020, 14154, 61, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[637118, 14160, 53, 1, 27, "Input"],
Cell[637174, 14163, 38, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[637249, 14169, 55, 1, 27, "Input"],
Cell[637307, 14172, 42, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[637386, 14178, 52, 1, 27, "Input"],
Cell[637441, 14181, 38, 1, 70, "Output"]
}, Closed]],
Cell[637494, 14185, 104, 3, 31, "Text"],
Cell[637601, 14190, 577, 8, 91, "Input"],
Cell[638181, 14200, 327, 6, 91, "Input"],
Cell[638511, 14208, 153, 3, 43, "Input"],

Cell[CellGroupData[{
Cell[638689, 14215, 47, 1, 27, "Input"],
Cell[638739, 14218, 42, 1, 70, "Output"]
}, Closed]],
Cell[638796, 14222, 54, 0, 31, "Text"],
Cell[638853, 14224, 43, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[638921, 14228, 43, 1, 27, "Input"],
Cell[638967, 14231, 1357, 28, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[640361, 14264, 65, 1, 27, "Input"],
Cell[640429, 14267, 41, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[640507, 14273, 59, 1, 27, "Input"],
Cell[640569, 14276, 116, 2, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[640722, 14283, 49, 1, 27, "Input"],
Cell[640774, 14286, 36, 1, 70, "Output"]
}, Closed]],
Cell[640825, 14290, 67, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[640917, 14294, 64, 1, 27, "Input"],
Cell[640984, 14297, 3584, 79, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[644605, 14381, 42, 1, 27, "Input"],
Cell[644650, 14384, 1050, 22, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[645737, 14411, 43, 1, 27, "Input"],
Cell[645783, 14414, 1050, 22, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[646870, 14441, 61, 1, 27, "Input"],
Cell[646934, 14444, 970, 20, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[647953, 14470, 71, 0, 28, "Subsubsection"],
Cell[648027, 14472, 274, 7, 49, "Text"],
Cell[648304, 14481, 248, 6, 99, "Text"],
Cell[648555, 14489, 135, 5, 32, "Text"],
Cell[648693, 14496, 444, 8, 123, "Input"],
Cell[649140, 14506, 43, 0, 31, "Text"],
Cell[649186, 14508, 348, 6, 123, "Input"],
Cell[649537, 14516, 73, 0, 31, "Text"],
Cell[649613, 14518, 387, 8, 116, "Text"],
Cell[650003, 14528, 2397, 41, 491, "Input"],
Cell[652403, 14571, 167, 4, 48, "Text"],
Cell[652573, 14577, 471, 9, 139, "Input"],
Cell[653047, 14588, 527, 10, 139, "Input"],
Cell[653577, 14600, 96, 4, 32, "Text"],
Cell[653676, 14606, 489, 9, 139, "Input"],
Cell[654168, 14617, 63, 0, 31, "Text"],
Cell[654234, 14619, 536, 10, 155, "Input"],
Cell[654773, 14631, 101, 4, 32, "Text"],
Cell[654877, 14637, 446, 9, 107, "Input"],
Cell[655326, 14648, 497, 10, 123, "Input"],
Cell[655826, 14660, 171, 3, 59, "Input"],
Cell[656000, 14665, 180, 3, 59, "Input"],
Cell[656183, 14670, 171, 3, 59, "Input"],
Cell[656357, 14675, 180, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[656562, 14682, 51, 1, 27, "Input"],
Cell[656616, 14685, 147, 2, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[656800, 14692, 82, 1, 27, "Input"],
Cell[656885, 14695, 155, 2, 70, "Output"]
}, Closed]],
Cell[657055, 14700, 140, 3, 48, "Text"],

Cell[CellGroupData[{
Cell[657220, 14707, 121, 2, 27, "Input"],
Cell[657344, 14711, 155, 2, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[657536, 14718, 116, 2, 27, "Input"],
Cell[657655, 14722, 236, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[657928, 14730, 105, 2, 27, "Input"],
Cell[658036, 14734, 198, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[658271, 14742, 83, 1, 27, "Input"],
Cell[658357, 14745, 267, 4, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[658661, 14754, 84, 1, 27, "Input"],
Cell[658748, 14757, 1133, 21, 70, "Output"]
}, Closed]],
Cell[659896, 14781, 212, 6, 49, "Text"],

Cell[CellGroupData[{
Cell[660133, 14791, 53, 1, 27, "Input"],
Cell[660189, 14794, 1061, 20, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[661287, 14819, 65, 1, 27, "Input"],
Cell[661355, 14822, 87, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[661479, 14828, 106, 2, 27, "Input"],
Cell[661588, 14832, 1890, 42, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[663515, 14879, 116, 2, 27, "Input"],
Cell[663634, 14883, 55, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[663726, 14889, 65, 1, 31, "Input"],
Cell[663794, 14892, 55, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[663886, 14898, 71, 1, 27, "Input"],
Cell[663960, 14901, 3349, 74, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[667346, 14980, 44, 1, 27, "Input"],
Cell[667393, 14983, 147, 2, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[667577, 14990, 82, 1, 27, "Input"],
Cell[667662, 14993, 155, 2, 70, "Output"]
}, Closed]],
Cell[667832, 14998, 85, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[667942, 15003, 50, 1, 27, "Input"],
Cell[667995, 15006, 946, 20, 70, "Output"]
}, Closed]],
Cell[668956, 15029, 708, 12, 270, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[669713, 15047, 56, 0, 40, "Section"],

Cell[CellGroupData[{
Cell[669794, 15051, 28, 0, 45, "Subsection"],
Cell[669825, 15053, 291, 6, 99, "Text"],
Cell[670119, 15061, 55, 0, 31, "Text"],
Cell[670177, 15063, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[670262, 15067, 398, 7, 139, "Input",
  Evaluatable->False],
Cell[670663, 15076, 78, 2, 27, "Input",
  Evaluatable->False],
Cell[670744, 15080, 69, 2, 27, "Input",
  Evaluatable->False],
Cell[670816, 15084, 84, 2, 27, "Input",
  Evaluatable->False],
Cell[670903, 15088, 127, 3, 27, "Input",
  Evaluatable->False],
Cell[671033, 15093, 127, 3, 27, "Input",
  Evaluatable->False],
Cell[671163, 15098, 112, 3, 31, "Text"],
Cell[671278, 15103, 730, 13, 235, "Input",
  Evaluatable->False],
Cell[672011, 15118, 105, 2, 27, "Input",
  Evaluatable->False],
Cell[672119, 15122, 395, 8, 155, "Input",
  Evaluatable->False],
Cell[672517, 15132, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[672587, 15136, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[672660, 15140, 69, 2, 27, "Input",
  Evaluatable->False],
Cell[672732, 15144, 156, 4, 27, "Input",
  Evaluatable->False],
Cell[672891, 15150, 108, 3, 31, "Text"],
Cell[673002, 15155, 71, 0, 31, "Text"],
Cell[673076, 15157, 446, 8, 171, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[673547, 15169, 32, 0, 42, "Subsubsection"],
Cell[673582, 15171, 548, 12, 266, "Text"],
Cell[674133, 15185, 553, 18, 303, "Text"],
Cell[674689, 15205, 344, 12, 201, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[675070, 15222, 28, 0, 42, "Subsubsection"],
Cell[675101, 15224, 205, 8, 117, "Output"],
Cell[675309, 15234, 224, 4, 107, "Input",
  Evaluatable->False],
Cell[675536, 15240, 94, 2, 27, "Input",
  Evaluatable->False],
Cell[675633, 15244, 242, 4, 107, "Input",
  Evaluatable->False],
Cell[675878, 15250, 78, 2, 27, "Input",
  Evaluatable->False],
Cell[675959, 15254, 151, 3, 43, "Input",
  Evaluatable->False],
Cell[676113, 15259, 871, 16, 235, "Input",
  Evaluatable->False],
Cell[676987, 15277, 93, 2, 27, "Input",
  Evaluatable->False],
Cell[677083, 15281, 81, 2, 27, "Input",
  Evaluatable->False],
Cell[677167, 15285, 73, 4, 65, "Text"],
Cell[677243, 15291, 149, 3, 43, "Input",
  Evaluatable->False],
Cell[677395, 15296, 718, 13, 203, "Input",
  Evaluatable->False],
Cell[678116, 15311, 336, 8, 139, "Input",
  Evaluatable->False],
Cell[678455, 15321, 97, 2, 27, "Input",
  Evaluatable->False],
Cell[678555, 15325, 457, 9, 155, "Input",
  Evaluatable->False],
Cell[679015, 15336, 88, 2, 27, "Input",
  Evaluatable->False],
Cell[679106, 15340, 85, 2, 27, "Input",
  Evaluatable->False],
Cell[679194, 15344, 200, 5, 59, "Input",
  Evaluatable->False],
Cell[679397, 15351, 80, 2, 27, "Input",
  Evaluatable->False],
Cell[679480, 15355, 81, 2, 27, "Input",
  Evaluatable->False],
Cell[679564, 15359, 66, 2, 27, "Input",
  Evaluatable->False],
Cell[679633, 15363, 70, 0, 31, "Text"],
Cell[679706, 15365, 111, 2, 27, "Input",
  Evaluatable->False],
Cell[679820, 15369, 129, 4, 27, "Input",
  Evaluatable->False],
Cell[679952, 15375, 172, 4, 27, "Input",
  Evaluatable->False],
Cell[680127, 15381, 447, 9, 139, "Input",
  Evaluatable->False],
Cell[680577, 15392, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[680647, 15396, 413, 8, 139, "Input",
  Evaluatable->False],
Cell[681063, 15406, 77, 2, 27, "Input",
  Evaluatable->False],
Cell[681143, 15410, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[681221, 15414, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[681296, 15418, 78, 2, 27, "Input",
  Evaluatable->False],
Cell[681377, 15422, 228, 5, 91, "Input",
  Evaluatable->False],
Cell[681608, 15429, 226, 5, 91, "Input",
  Evaluatable->False],
Cell[681837, 15436, 531, 10, 219, "Input",
  Evaluatable->False],
Cell[682371, 15448, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[682441, 15452, 310, 7, 75, "Input",
  Evaluatable->False],
Cell[682754, 15461, 1611, 32, 443, "Input",
  Evaluatable->False],
Cell[684368, 15495, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[684446, 15499, 206, 4, 43, "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[684713, 15510, 90, 2, 68, "Subsubtitle"],
Cell[684806, 15514, 146, 3, 48, "Text"],

Cell[CellGroupData[{
Cell[684977, 15521, 30, 0, 60, "Section"],

Cell[CellGroupData[{
Cell[685032, 15525, 66, 0, 42, "Subsubsection"],
Cell[685101, 15527, 2236, 33, 560, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[687374, 15565, 49, 0, 42, "Subsubsection"],
Cell[687426, 15567, 135, 4, 65, "Text"],
Cell[687564, 15573, 59, 0, 31, "Text"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[687672, 15579, 106, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[687803, 15584, 32, 0, 42, "Subsubsection"],
Cell[687838, 15586, 482, 11, 184, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[688357, 15602, 35, 0, 28, "Subsubsection"],

Cell[CellGroupData[{
Cell[688417, 15606, 60, 1, 27, "Input"],
Cell[688480, 15609, 69, 1, 70, "Output"]
}, Closed]],
Cell[688564, 15613, 376, 6, 139, "Input"],
Cell[688943, 15621, 56, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[689024, 15626, 47, 1, 27, "Input"],
Cell[689074, 15629, 4032, 61, 70, "Output"]
}, Closed]],
Cell[693121, 15693, 62, 1, 27, "Input"],
Cell[693186, 15696, 53, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[693264, 15700, 64, 1, 27, "Input"],
Cell[693331, 15703, 69, 1, 70, "Output"]
}, Closed]],
Cell[693415, 15707, 233, 4, 75, "Input"],
Cell[693651, 15713, 60, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[693736, 15718, 47, 1, 27, "Input"],
Cell[693786, 15721, 4521, 71, 70, "Output"]
}, Closed]],
Cell[698322, 15795, 70, 1, 27, "Input"],
Cell[698395, 15798, 105, 2, 27, "Input"],
Cell[698503, 15802, 105, 2, 27, "Input"],
Cell[698611, 15806, 112, 3, 31, "Text"],
Cell[698726, 15811, 696, 12, 235, "Input"],

Cell[CellGroupData[{
Cell[699447, 15827, 51, 1, 27, "Input"],
Cell[699501, 15830, 3258, 50, 70, "Output"]
}, Closed]],
Cell[702774, 15883, 701, 12, 235, "Input"],
Cell[703478, 15897, 49, 1, 27, "Input"],
Cell[703530, 15900, 64, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[703619, 15904, 50, 1, 27, "Input"],
Cell[703672, 15907, 3285, 56, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[706994, 15968, 53, 1, 27, "Input"],
Cell[707050, 15971, 41, 1, 70, "Output"]
}, Closed]],
Cell[707106, 15975, 39, 0, 31, "Text"],
Cell[707148, 15977, 54, 1, 27, "Input"],
Cell[707205, 15980, 53, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[707295, 15986, 192, 5, 62, "Subsection"],
Cell[707490, 15993, 145, 5, 82, "Text"],
Cell[707638, 16000, 77, 2, 27, "Input",
  Evaluatable->False],
Cell[707718, 16004, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[707796, 16008, 98, 3, 31, "Text"],
Cell[707897, 16013, 79, 2, 27, "Input",
  Evaluatable->False],
Cell[707979, 16017, 79, 2, 27, "Input",
  Evaluatable->False],
Cell[708061, 16021, 79, 2, 27, "Input",
  Evaluatable->False],
Cell[708143, 16025, 68, 0, 31, "Text"],
Cell[708214, 16027, 80, 2, 27, "Input",
  Evaluatable->False],
Cell[708297, 16031, 84, 2, 27, "Input",
  Evaluatable->False],
Cell[708384, 16035, 83, 2, 27, "Input",
  Evaluatable->False],
Cell[708470, 16039, 65, 2, 27, "Input",
  Evaluatable->False],
Cell[708538, 16043, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[708611, 16047, 89, 2, 27, "Input",
  Evaluatable->False],
Cell[708703, 16051, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[708780, 16055, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[708857, 16059, 71, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[708953, 16063, 167, 4, 27, "Input",
  Evaluatable->False],
Cell[709123, 16069, 141, 2, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[709301, 16076, 87, 2, 24, "Input",
  Evaluatable->False],
Cell[709391, 16080, 58, 1, 27, "Output"]
}, Closed]],
Cell[709464, 16084, 74, 2, 24, "Input",
  Evaluatable->False],
Cell[709541, 16088, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[709618, 16092, 121, 3, 48, "Text"],
Cell[709742, 16097, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[709848, 16101, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[709954, 16105, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[710060, 16109, 130, 4, 48, "Text"],
Cell[710193, 16115, 326, 6, 107, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[710544, 16125, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[710622, 16129, 40, 1, 27, "Output"]
}, Closed]],
Cell[710677, 16133, 204, 4, 45, "Text"],
Cell[710884, 16139, 322, 6, 59, "Input",
  Evaluatable->False],
Cell[711209, 16147, 97, 3, 31, "Text"],
Cell[711309, 16152, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[711384, 16156, 202, 5, 59, "Input",
  Evaluatable->False],
Cell[711589, 16163, 174, 4, 48, "Text"],
Cell[711766, 16169, 243, 5, 59, "Input",
  Evaluatable->False],
Cell[712012, 16176, 72, 2, 27, "Input",
  Evaluatable->False],
Cell[712087, 16180, 28, 0, 31, "Text"],
Cell[712118, 16182, 189, 4, 59, "Input",
  Evaluatable->False],
Cell[712310, 16188, 325, 6, 91, "Input",
  Evaluatable->False],
Cell[712638, 16196, 529, 9, 155, "Input",
  Evaluatable->False],
Cell[713170, 16207, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[713243, 16211, 117, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[713397, 16219, 52, 1, 29, "Subsection",
  Evaluatable->True],
Cell[713452, 16222, 44, 1, 70, "Output"],
Cell[713499, 16225, 86, 1, 31, "Text",
  Evaluatable->True],

Cell[CellGroupData[{
Cell[713610, 16230, 53, 1, 27, "Input"],
Cell[713666, 16233, 41, 1, 70, "Output"]
}, Closed]],
Cell[713722, 16237, 62, 1, 27, "Input"],
Cell[713787, 16240, 61, 1, 27, "Input"],
Cell[713851, 16243, 43, 1, 27, "Input"],
Cell[713897, 16246, 196, 5, 48, "Text",
  Evaluatable->True],
Cell[714096, 16253, 64, 1, 27, "Input"],
Cell[714163, 16256, 76, 1, 27, "Input"],
Cell[714242, 16259, 69, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[714336, 16264, 68, 1, 27, "Input"],
Cell[714407, 16267, 181, 3, 70, "Message"]
}, Closed]],

Cell[CellGroupData[{
Cell[714625, 16275, 84, 1, 27, "Input"],
Cell[714712, 16278, 182, 3, 70, "Message"],
Cell[714897, 16283, 187, 3, 70, "Message"]
}, Closed]],

Cell[CellGroupData[{
Cell[715121, 16291, 73, 1, 27, "Input"],
Cell[715197, 16294, 184, 3, 70, "Message"],
Cell[715384, 16299, 181, 3, 70, "Message"],
Cell[715568, 16304, 180, 3, 70, "Message"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[715809, 16314, 85, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[715919, 16319, 105, 3, 42, "Subsubsection"],
Cell[716027, 16324, 1203, 18, 442, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[717267, 16347, 74, 1, 45, "Subsection"],

Cell[CellGroupData[{
Cell[717366, 16352, 32, 0, 42, "Subsubsection"],
Cell[717401, 16354, 428, 9, 133, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[717866, 16368, 65, 1, 58, "Subsubsection"],
Cell[717934, 16371, 52, 1, 27, "Input"],
Cell[717989, 16374, 124, 2, 27, "Input"],
Cell[718116, 16378, 171, 4, 48, "Text"],
Cell[718290, 16384, 89, 2, 43, "Input"],
Cell[718382, 16388, 49, 1, 27, "Input"],
Cell[718434, 16391, 51, 1, 27, "Input"],
Cell[718488, 16394, 73, 0, 31, "Text"],
Cell[718564, 16396, 51, 0, 31, "Text"],
Cell[718618, 16398, 118, 3, 31, "Text"],
Cell[718739, 16403, 46, 1, 27, "Input"],
Cell[718788, 16406, 115, 2, 27, "Input"],
Cell[718906, 16410, 204, 4, 48, "Text"],
Cell[719113, 16416, 152, 3, 27, "Input"],
Cell[719268, 16421, 43, 0, 31, "Text"],
Cell[719314, 16423, 64, 1, 27, "Input"],
Cell[719381, 16426, 62, 1, 27, "Input"],
Cell[719446, 16429, 103, 3, 31, "Text"],
Cell[719552, 16434, 72, 1, 27, "Input"],
Cell[719627, 16437, 186, 4, 65, "Text"],
Cell[719816, 16443, 144, 3, 27, "Input"],
Cell[719963, 16448, 186, 4, 43, "Input"],
Cell[720152, 16454, 67, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[720244, 16459, 87, 1, 27, "Input"],
Cell[720334, 16462, 57, 1, 70, "Output"]
}, Closed]],
Cell[720406, 16466, 71, 1, 27, "Input"],
Cell[720480, 16469, 81, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[720586, 16474, 65, 1, 27, "Input"],
Cell[720654, 16477, 37, 1, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[720740, 16484, 29, 0, 42, "Subsubsection"],
Cell[720772, 16486, 1154, 24, 388, "Text"],
Cell[721929, 16512, 462, 14, 81, "Input"],
Cell[722394, 16528, 310, 9, 81, "Input"],
Cell[722707, 16539, 106, 3, 31, "Text"],
Cell[722816, 16544, 315, 9, 81, "Input"],

Cell[CellGroupData[{
Cell[723156, 16557, 51, 1, 27, "Input"],
Cell[723210, 16560, 293, 8, 70, "Output"]
}, Closed]],
Cell[723518, 16571, 349, 7, 99, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[723904, 16583, 40, 0, 42, "Subsubsection"],
Cell[723947, 16585, 313, 6, 139, "Input"],
Cell[724263, 16593, 233, 5, 59, "Input"],
Cell[724499, 16600, 53, 0, 31, "Text"],
Cell[724555, 16602, 94, 3, 31, "Text"],
Cell[724652, 16607, 219, 5, 75, "Input"],
Cell[724874, 16614, 108, 3, 31, "Text"],
Cell[724985, 16619, 63, 1, 27, "Input"],
Cell[725051, 16622, 94, 3, 31, "Text"],
Cell[725148, 16627, 60, 1, 27, "Input"],
Cell[725211, 16630, 44, 0, 31, "Text"],
Cell[725258, 16632, 100, 3, 31, "Text"],
Cell[725361, 16637, 502, 10, 139, "Input"],
Cell[725866, 16649, 490, 10, 139, "Input"],
Cell[726359, 16661, 123, 3, 27, "Input"],
Cell[726485, 16666, 427, 13, 201, "Text"],
Cell[726915, 16681, 919, 18, 203, "Input"],
Cell[727837, 16701, 571, 10, 219, "Text"],
Cell[728411, 16713, 633, 11, 171, "Input"],
Cell[729047, 16726, 899, 15, 251, "Input"],
Cell[729949, 16743, 351, 10, 167, "Text"],
Cell[730303, 16755, 1545, 29, 347, "Input"],
Cell[731851, 16786, 207, 8, 133, "Text"],
Cell[732061, 16796, 169, 5, 48, "Text"],

Cell[CellGroupData[{
Cell[732255, 16805, 89, 1, 43, "Input"],
Cell[732347, 16808, 39, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[732423, 16814, 73, 1, 27, "Input"],
Cell[732499, 16817, 38, 1, 70, "Output"]
}, Closed]],
Cell[732552, 16821, 64, 0, 31, "Text"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[732677, 16828, 78, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[732780, 16833, 36, 0, 45, "Subsection"],
Cell[732819, 16835, 67, 0, 31, "Text"],
Cell[732889, 16837, 57, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[732971, 16842, 28, 0, 42, "Subsubsection"],
Cell[733002, 16844, 218, 4, 107, "Input"],
Cell[733223, 16850, 58, 1, 27, "Input"],
Cell[733284, 16853, 66, 1, 27, "Input"],
Cell[733353, 16856, 46, 0, 31, "Text"],
Cell[733402, 16858, 62, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[733501, 16864, 29, 0, 42, "Subsubsection"],
Cell[733533, 16866, 250, 4, 107, "Input"],
Cell[733786, 16872, 82, 1, 27, "Input"],
Cell[733871, 16875, 245, 7, 82, "Text"],
Cell[734119, 16884, 66, 1, 27, "Input"],
Cell[734188, 16887, 66, 1, 27, "Input"],
Cell[734257, 16890, 64, 1, 27, "Input"],
Cell[734324, 16893, 93, 1, 27, "Input"],
Cell[734420, 16896, 221, 5, 59, "Input"],
Cell[734644, 16903, 140, 5, 82, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[734821, 16913, 29, 0, 42, "Subsubsection"],
Cell[734853, 16915, 202, 4, 59, "Input"]
}, Closed]]
}, Closed]],
Cell[735082, 16923, 89, 1, 61, "Subsection"],

Cell[CellGroupData[{
Cell[735196, 16928, 34, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[735255, 16932, 28, 0, 42, "Subsubsection"],
Cell[735286, 16934, 156, 3, 27, "Input"],
Cell[735445, 16939, 72, 1, 27, "Input"],
Cell[735520, 16942, 112, 2, 27, "Input"],
Cell[735635, 16946, 69, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[735741, 16952, 29, 0, 42, "Subsubsection"],
Cell[735773, 16954, 364, 7, 107, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[736186, 16967, 55, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[736266, 16971, 28, 0, 42, "Subsubsection"],
Cell[736297, 16973, 280, 7, 66, "Text"],
Cell[736580, 16982, 634, 11, 267, "Input"],
Cell[737217, 16995, 114, 2, 27, "Input"],
Cell[737334, 16999, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[737481, 17006, 29, 0, 42, "Subsubsection"],
Cell[737513, 17008, 163, 3, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[737725, 17017, 104, 3, 62, "Subsection"],
Cell[737832, 17022, 125, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[737982, 17029, 28, 0, 42, "Subsubsection"],
Cell[738013, 17031, 726, 13, 267, "Input"],
Cell[738742, 17046, 115, 2, 27, "Input"],
Cell[738860, 17050, 109, 2, 27, "Input"],
Cell[738972, 17054, 361, 8, 100, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[739370, 17067, 29, 0, 42, "Subsubsection"],
Cell[739402, 17069, 163, 3, 75, "Input"],
Cell[739568, 17074, 92, 1, 27, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[739709, 17081, 35, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[739769, 17085, 28, 0, 42, "Subsubsection"],
Cell[739800, 17087, 283, 4, 75, "Input"],
Cell[740086, 17093, 64, 0, 31, "Text"],
Cell[740153, 17095, 76, 1, 27, "Input"],
Cell[740232, 17098, 114, 2, 27, "Input"],
Cell[740349, 17102, 78, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[740464, 17108, 29, 0, 42, "Subsubsection"],
Cell[740496, 17110, 358, 7, 91, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[740903, 17123, 53, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[740981, 17127, 28, 0, 42, "Subsubsection"],
Cell[741012, 17129, 83, 1, 27, "Input"],
Cell[741098, 17132, 188, 4, 43, "Input"],
Cell[741289, 17138, 71, 1, 27, "Input"],
Cell[741363, 17141, 572, 10, 187, "Input"],

Cell[CellGroupData[{
Cell[741960, 17155, 67, 1, 27, "Input"],
Cell[742030, 17158, 36, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[742103, 17164, 67, 1, 27, "Input"],
Cell[742173, 17167, 35, 1, 70, "Output"]
}, Closed]],
Cell[742223, 17171, 67, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[742315, 17176, 60, 1, 27, "Input"],
Cell[742378, 17179, 972, 20, 70, "Output"]
}, Closed]],
Cell[743365, 17202, 224, 4, 43, "Input"],
Cell[743592, 17208, 115, 2, 27, "Input"],
Cell[743710, 17212, 107, 2, 27, "Input"],
Cell[743820, 17216, 62, 1, 27, "Input"],
Cell[743885, 17219, 59, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[743981, 17225, 29, 0, 42, "Subsubsection"],
Cell[744013, 17227, 262, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[744324, 17238, 28, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[744377, 17242, 32, 0, 42, "Subsubsection"],
Cell[744412, 17244, 87, 3, 31, "Text"],
Cell[744502, 17249, 263, 5, 75, "Input"],
Cell[744768, 17256, 42, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[744847, 17261, 28, 0, 42, "Subsubsection"],
Cell[744878, 17263, 112, 2, 27, "Input"],
Cell[744993, 17267, 68, 1, 27, "Input"],
Cell[745064, 17270, 106, 2, 27, "Input"],
Cell[745173, 17274, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[745275, 17280, 29, 0, 42, "Subsubsection"],
Cell[745307, 17282, 262, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[745618, 17293, 27, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[745670, 17297, 32, 0, 42, "Subsubsection"],
Cell[745705, 17299, 87, 3, 31, "Text"],
Cell[745795, 17304, 263, 5, 75, "Input"],
Cell[746061, 17311, 42, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[746140, 17316, 28, 0, 42, "Subsubsection"],
Cell[746171, 17318, 81, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[746277, 17323, 130, 2, 27, "Input"],
Cell[746410, 17327, 148, 3, 70, "Message"]
}, Closed]],
Cell[746573, 17333, 136, 3, 27, "Input"],
Cell[746712, 17338, 109, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[746858, 17345, 29, 0, 42, "Subsubsection"],
Cell[746890, 17347, 157, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[747096, 17356, 92, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[747213, 17364, 28, 0, 42, "Subsubsection"],
Cell[747244, 17366, 92, 1, 27, "Input"],
Cell[747339, 17369, 67, 1, 27, "Input"],
Cell[747409, 17372, 105, 2, 27, "Input"],
Cell[747517, 17376, 64, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[747618, 17382, 29, 0, 42, "Subsubsection"],
Cell[747650, 17384, 262, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[747961, 17395, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[748077, 17403, 28, 0, 42, "Subsubsection"],
Cell[748108, 17405, 74, 1, 27, "Input"],
Cell[748185, 17408, 130, 2, 27, "Input"],
Cell[748318, 17412, 137, 3, 27, "Input"],
Cell[748458, 17417, 91, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[748586, 17423, 29, 0, 42, "Subsubsection"],
Cell[748618, 17425, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[748825, 17434, 66, 1, 43, "Subsection"],

Cell[CellGroupData[{
Cell[748916, 17439, 28, 0, 42, "Subsubsection"],
Cell[748947, 17441, 74, 1, 27, "Input"],
Cell[749024, 17444, 66, 1, 27, "Input"],
Cell[749093, 17447, 117, 2, 27, "Input"],
Cell[749213, 17451, 77, 1, 27, "Input"],
Cell[749293, 17454, 70, 0, 31, "Text"],
Cell[749366, 17456, 150, 3, 27, "Input"],
Cell[749519, 17461, 115, 2, 27, "Input"],
Cell[749637, 17465, 245, 6, 59, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[749919, 17476, 29, 0, 42, "Subsubsection"],
Cell[749951, 17478, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[750263, 17489, 27, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[750315, 17493, 32, 0, 42, "Subsubsection"],
Cell[750350, 17495, 87, 3, 31, "Text"],
Cell[750440, 17500, 263, 5, 75, "Input"],
Cell[750706, 17507, 42, 0, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[750785, 17512, 28, 0, 42, "Subsubsection"],
Cell[750816, 17514, 107, 2, 27, "Input"],
Cell[750926, 17518, 67, 1, 27, "Input"],
Cell[750996, 17521, 106, 2, 27, "Input"],
Cell[751105, 17525, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[751207, 17531, 29, 0, 42, "Subsubsection"],
Cell[751239, 17533, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[751551, 17544, 26, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[751602, 17548, 28, 0, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[751655, 17552, 52, 1, 27, "Input"],
Cell[751710, 17555, 84, 1, 70, "Output"]
}, Closed]],
Cell[751809, 17559, 63, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[751897, 17563, 79, 1, 27, "Input"],
Cell[751979, 17566, 101, 2, 70, "Output"]
}, Closed]],
Cell[752095, 17571, 183, 4, 43, "Input"],
Cell[752281, 17577, 1845, 39, 379, "Input"],
Cell[754129, 17618, 160, 3, 27, "Input"],
Cell[754292, 17623, 83, 1, 27, "Input"],
Cell[754378, 17626, 307, 7, 66, "Text"],
Cell[754688, 17635, 75, 0, 31, "Text"],
Cell[754766, 17637, 63, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[754866, 17643, 29, 0, 42, "Subsubsection"],
Cell[754898, 17645, 164, 3, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[755111, 17654, 92, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[755228, 17662, 28, 0, 42, "Subsubsection"],
Cell[755259, 17664, 92, 1, 27, "Input"],
Cell[755354, 17667, 67, 1, 27, "Input"],
Cell[755424, 17670, 106, 2, 27, "Input"],
Cell[755533, 17674, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[755635, 17680, 29, 0, 42, "Subsubsection"],
Cell[755667, 17682, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[755979, 17693, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[756095, 17701, 28, 0, 42, "Subsubsection"],
Cell[756126, 17703, 74, 1, 27, "Input"],
Cell[756203, 17706, 130, 2, 27, "Input"],
Cell[756336, 17710, 137, 3, 27, "Input"],
Cell[756476, 17715, 91, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[756604, 17721, 29, 0, 42, "Subsubsection"],
Cell[756636, 17723, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[756843, 17732, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[756959, 17740, 28, 0, 42, "Subsubsection"],
Cell[756990, 17742, 113, 2, 27, "Input"],
Cell[757106, 17746, 68, 1, 27, "Input"],
Cell[757177, 17749, 107, 2, 27, "Input"],
Cell[757287, 17753, 66, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[757390, 17759, 29, 0, 42, "Subsubsection"],
Cell[757422, 17761, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[757734, 17772, 90, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[757849, 17780, 28, 0, 42, "Subsubsection"],
Cell[757880, 17782, 197, 5, 48, "Text"],
Cell[758080, 17789, 83, 1, 27, "Input"],
Cell[758166, 17792, 133, 2, 27, "Input"],
Cell[758302, 17796, 174, 4, 27, "Input"],
Cell[758479, 17802, 138, 3, 27, "Input"],
Cell[758620, 17807, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[758767, 17814, 29, 0, 42, "Subsubsection"],
Cell[758799, 17816, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[759006, 17825, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[759122, 17833, 28, 0, 42, "Subsubsection"],
Cell[759153, 17835, 112, 2, 27, "Input"],
Cell[759268, 17839, 68, 1, 27, "Input"],
Cell[759339, 17842, 107, 2, 27, "Input"],
Cell[759449, 17846, 66, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[759552, 17852, 29, 0, 42, "Subsubsection"],
Cell[759584, 17854, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[759896, 17865, 90, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[760011, 17873, 28, 0, 42, "Subsubsection"],
Cell[760042, 17875, 82, 1, 27, "Input"],
Cell[760127, 17878, 133, 2, 27, "Input"],
Cell[760263, 17882, 174, 4, 27, "Input"],
Cell[760440, 17888, 138, 3, 27, "Input"],
Cell[760581, 17893, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[760728, 17900, 29, 0, 42, "Subsubsection"],
Cell[760760, 17902, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[760967, 17911, 91, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[761083, 17919, 28, 0, 42, "Subsubsection"],
Cell[761114, 17921, 112, 2, 27, "Input"],
Cell[761229, 17925, 68, 1, 27, "Input"],
Cell[761300, 17928, 107, 2, 27, "Input"],
Cell[761410, 17932, 66, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[761513, 17938, 29, 0, 42, "Subsubsection"],
Cell[761545, 17940, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[761857, 17951, 90, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[761972, 17959, 28, 0, 42, "Subsubsection"],
Cell[762003, 17961, 82, 1, 27, "Input"],
Cell[762088, 17964, 133, 2, 27, "Input"],
Cell[762224, 17968, 174, 4, 27, "Input"],
Cell[762401, 17974, 138, 3, 27, "Input"],
Cell[762542, 17979, 110, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[762689, 17986, 29, 0, 42, "Subsubsection"],
Cell[762721, 17988, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[762928, 17997, 31, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[762984, 18001, 28, 0, 42, "Subsubsection"],
Cell[763015, 18003, 87, 1, 27, "Input"],
Cell[763105, 18006, 66, 1, 27, "Input"],
Cell[763174, 18009, 105, 2, 27, "Input"],
Cell[763282, 18013, 64, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[763383, 18019, 29, 0, 42, "Subsubsection"],
Cell[763415, 18021, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[763727, 18032, 30, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[763782, 18036, 28, 0, 42, "Subsubsection"],
Cell[763813, 18038, 68, 1, 27, "Input"],
Cell[763884, 18041, 125, 2, 27, "Input"],
Cell[764012, 18045, 136, 3, 27, "Input"],
Cell[764151, 18050, 107, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[764295, 18057, 29, 0, 42, "Subsubsection"],
Cell[764327, 18059, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[764534, 18068, 83, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[764642, 18076, 28, 0, 42, "Subsubsection"],
Cell[764673, 18078, 92, 1, 27, "Input"],
Cell[764768, 18081, 67, 1, 27, "Input"],
Cell[764838, 18084, 106, 2, 27, "Input"],
Cell[764947, 18088, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[765049, 18094, 29, 0, 42, "Subsubsection"],
Cell[765081, 18096, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[765393, 18107, 82, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[765500, 18115, 28, 0, 42, "Subsubsection"],
Cell[765531, 18117, 74, 1, 27, "Input"],
Cell[765608, 18120, 130, 2, 27, "Input"],
Cell[765741, 18124, 137, 3, 27, "Input"],
Cell[765881, 18129, 108, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[766026, 18136, 29, 0, 42, "Subsubsection"],
Cell[766058, 18138, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[766265, 18147, 75, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[766365, 18155, 28, 0, 42, "Subsubsection"],
Cell[766396, 18157, 111, 2, 27, "Input"],
Cell[766510, 18161, 67, 1, 27, "Input"],
Cell[766580, 18164, 106, 2, 27, "Input"],
Cell[766689, 18168, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[766791, 18174, 29, 0, 42, "Subsubsection"],
Cell[766823, 18176, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[767135, 18187, 74, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[767234, 18195, 28, 0, 42, "Subsubsection"],
Cell[767265, 18197, 80, 1, 27, "Input"],
Cell[767348, 18200, 130, 2, 27, "Input"],
Cell[767481, 18204, 137, 3, 27, "Input"],
Cell[767621, 18209, 106, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[767764, 18216, 29, 0, 42, "Subsubsection"],
Cell[767796, 18218, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[768003, 18227, 100, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[768128, 18235, 28, 0, 42, "Subsubsection"],
Cell[768159, 18237, 92, 1, 27, "Input"],
Cell[768254, 18240, 67, 1, 27, "Input"],
Cell[768324, 18243, 106, 2, 27, "Input"],
Cell[768433, 18247, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[768535, 18253, 29, 0, 42, "Subsubsection"],
Cell[768567, 18255, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[768879, 18266, 82, 4, 45, "Subsection"],

Cell[CellGroupData[{
Cell[768986, 18274, 28, 0, 42, "Subsubsection"],
Cell[769017, 18276, 74, 1, 27, "Input"],
Cell[769094, 18279, 130, 2, 27, "Input"],
Cell[769227, 18283, 137, 3, 27, "Input"],
Cell[769367, 18288, 105, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[769509, 18295, 29, 0, 42, "Subsubsection"],
Cell[769541, 18297, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[769748, 18306, 52, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[769825, 18310, 28, 0, 42, "Subsubsection"],
Cell[769856, 18312, 112, 2, 27, "Input"],
Cell[769971, 18316, 67, 1, 27, "Input"],
Cell[770041, 18319, 106, 2, 27, "Input"],
Cell[770150, 18323, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[770252, 18329, 29, 0, 42, "Subsubsection"],
Cell[770284, 18331, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[770596, 18342, 33, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[770654, 18346, 28, 0, 42, "Subsubsection"],
Cell[770685, 18348, 81, 1, 27, "Input"],
Cell[770769, 18351, 130, 2, 27, "Input"],
Cell[770902, 18355, 137, 3, 27, "Input"],
Cell[771042, 18360, 111, 2, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[771190, 18367, 29, 0, 42, "Subsubsection"],
Cell[771222, 18369, 158, 3, 59, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[771429, 18378, 61, 2, 45, "Subsection"],

Cell[CellGroupData[{
Cell[771515, 18384, 28, 0, 42, "Subsubsection"],
Cell[771546, 18386, 46, 0, 31, "Text"],
Cell[771595, 18388, 114, 2, 27, "Input"],
Cell[771712, 18392, 67, 1, 27, "Input"],
Cell[771782, 18395, 106, 2, 27, "Input"],
Cell[771891, 18399, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[771993, 18405, 29, 0, 42, "Subsubsection"],
Cell[772025, 18407, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[772337, 18418, 35, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[772397, 18422, 28, 0, 42, "Subsubsection"],
Cell[772428, 18424, 46, 0, 31, "Text"],
Cell[772477, 18426, 120, 2, 27, "Input"],
Cell[772600, 18430, 67, 1, 27, "Input"],
Cell[772670, 18433, 106, 2, 27, "Input"],
Cell[772779, 18437, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[772881, 18443, 29, 0, 42, "Subsubsection"],
Cell[772913, 18445, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[773225, 18456, 27, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[773277, 18460, 28, 0, 42, "Subsubsection"],
Cell[773308, 18462, 108, 2, 27, "Input"],
Cell[773419, 18466, 67, 1, 27, "Input"],
Cell[773489, 18469, 106, 2, 27, "Input"],
Cell[773598, 18473, 65, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[773700, 18479, 29, 0, 42, "Subsubsection"],
Cell[773732, 18481, 263, 5, 75, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[774044, 18492, 26, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[774095, 18496, 28, 0, 42, "Subsubsection"],
Cell[774126, 18498, 51, 0, 31, "Text"],
Cell[774180, 18500, 59, 0, 31, "Text"],
Cell[774242, 18502, 1337, 27, 299, "Input"],
Cell[775582, 18531, 160, 3, 27, "Input"],
Cell[775745, 18536, 82, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[775864, 18542, 29, 0, 42, "Subsubsection"],
Cell[775896, 18544, 232, 5, 75, "Input"],
Cell[776131, 18551, 164, 3, 75, "Input"],
Cell[776298, 18556, 244, 7, 82, "Text"],
Cell[776545, 18565, 78, 1, 27, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[776672, 18572, 34, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[776731, 18576, 28, 0, 42, "Subsubsection"],
Cell[776762, 18578, 201, 4, 48, "Text"],
Cell[776966, 18584, 85, 1, 27, "Input"],
Cell[777054, 18587, 56, 1, 27, "Input"],
Cell[777113, 18590, 108, 2, 27, "Input"],
Cell[777224, 18594, 43, 0, 31, "Text"],
Cell[777270, 18596, 93, 1, 27, "Input"],
Cell[777366, 18599, 43, 0, 31, "Text"],
Cell[777412, 18601, 186, 3, 43, "Input"],
Cell[777601, 18606, 45, 0, 31, "Text"],
Cell[777649, 18608, 123, 2, 27, "Input"],
Cell[777775, 18612, 78, 1, 27, "Input"],
Cell[777856, 18615, 127, 3, 27, "Input"],
Cell[777986, 18620, 48, 0, 31, "Text"],
Cell[778037, 18622, 70, 1, 27, "Input"],
Cell[778110, 18625, 68, 1, 27, "Input"],
Cell[778181, 18628, 83, 1, 27, "Input"],
Cell[778267, 18631, 176, 3, 27, "Input"],
Cell[778446, 18636, 44, 0, 31, "Text"],
Cell[778493, 18638, 65, 1, 27, "Input"],
Cell[778561, 18641, 64, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[778650, 18646, 158, 2, 43, "Input"],
Cell[778811, 18650, 38, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[778886, 18656, 104, 2, 27, "Input"],
Cell[778993, 18660, 38, 1, 70, "Output"]
}, Closed]],
Cell[779046, 18664, 72, 1, 27, "Input"],
Cell[779121, 18667, 619, 11, 155, "Input"],
Cell[779743, 18680, 136, 3, 27, "Input"],
Cell[779882, 18685, 80, 1, 27, "Input"],
Cell[779965, 18688, 71, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[780073, 18694, 29, 0, 42, "Subsubsection"],
Cell[780105, 18696, 639, 12, 155, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[780793, 18714, 31, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[780849, 18718, 97, 3, 42, "Subsubsection"],
Cell[780949, 18723, 3152, 45, 917, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[784138, 18773, 28, 0, 42, "Subsubsection"],
Cell[784169, 18775, 1190, 20, 555, "Input",
  Evaluatable->False],
Cell[785362, 18797, 1474, 24, 555, "Input",
  Evaluatable->False],
Cell[786839, 18823, 65, 2, 27, "Input",
  Evaluatable->False],
Cell[786907, 18827, 218, 5, 43, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[787162, 18837, 28, 0, 42, "Subsubsection"],
Cell[787193, 18839, 75, 0, 31, "Text"],
Cell[787271, 18841, 155, 2, 27, "Input"],
Cell[787429, 18845, 284, 5, 65, "Text"],
Cell[787716, 18852, 1113, 19, 555, "Input"],
Cell[788832, 18873, 141, 3, 59, "Input"],
Cell[788976, 18878, 205, 4, 27, "Input"],
Cell[789184, 18884, 74, 1, 27, "Input"],
Cell[789261, 18887, 77, 1, 27, "Input"],
Cell[789341, 18890, 63, 1, 27, "Input"],
Cell[789407, 18893, 60, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[789504, 18899, 29, 0, 42, "Subsubsection"],
Cell[789536, 18901, 962, 21, 187, "Input"],
Cell[790501, 18924, 968, 21, 187, "Input"],
Cell[791472, 18947, 149, 2, 27, "Input"],
Cell[791624, 18951, 263, 6, 43, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[791936, 18963, 31, 0, 45, "Subsection"],

Cell[CellGroupData[{
Cell[791992, 18967, 28, 0, 42, "Subsubsection"],
Cell[792023, 18969, 75, 0, 31, "Text"],
Cell[792101, 18971, 167, 2, 27, "Input"],
Cell[792271, 18975, 1136, 17, 555, "Input"],
Cell[793410, 18994, 141, 3, 59, "Input"],
Cell[793554, 18999, 205, 4, 27, "Input"],
Cell[793762, 19005, 74, 1, 27, "Input"],
Cell[793839, 19008, 84, 1, 27, "Input"],
Cell[793926, 19011, 63, 1, 27, "Input"],
Cell[793992, 19014, 60, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[794089, 19020, 29, 0, 42, "Subsubsection"],
Cell[794121, 19022, 147, 3, 59, "Input"],
Cell[794271, 19027, 153, 3, 59, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[794485, 19037, 79, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[794589, 19042, 110, 1, 61, "Subsection"],

Cell[CellGroupData[{
Cell[794724, 19047, 48, 0, 42, "Subsubsection"],
Cell[794775, 19049, 239, 6, 99, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[795051, 19060, 82, 3, 58, "Subsubsection"],
Cell[795136, 19065, 501, 8, 139, "Input"],
Cell[795640, 19075, 207, 4, 75, "Input"],
Cell[795850, 19081, 211, 4, 75, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[796098, 19090, 112, 3, 58, "Subsubsection"],
Cell[796213, 19095, 196, 4, 48, "Text"],
Cell[796412, 19101, 2419, 41, 667, "Input"],
Cell[798834, 19144, 567, 10, 203, "Input"],
Cell[799404, 19156, 77, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[799518, 19163, 95, 3, 58, "Subsubsection"],
Cell[799616, 19168, 1380, 23, 443, "Input"],
Cell[800999, 19193, 1345, 23, 443, "Input"],
Cell[802347, 19218, 175, 3, 43, "Input"],
Cell[802525, 19223, 559, 10, 203, "Input"],

Cell[CellGroupData[{
Cell[803109, 19237, 50, 1, 27, "Input"],
Cell[803162, 19240, 7361, 137, 70, 765, 51, "GraphicsData", "PostScript", \
"Graphics"],
Cell[810526, 19379, 130, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[810693, 19387, 78, 1, 27, "Input"],
Cell[810774, 19390, 7840, 140, 70, 731, 48, "GraphicsData", "PostScript", \
"Graphics"],
Cell[818617, 19532, 130, 3, 70, "Output"]
}, Closed]],
Cell[818762, 19538, 560, 10, 203, "Input"],

Cell[CellGroupData[{
Cell[819347, 19552, 52, 1, 27, "Input"],
Cell[819402, 19555, 19997, 357, 70, 1528, 125, "GraphicsData", "PostScript", \
"Graphics"],
Cell[839402, 19914, 132, 3, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[839583, 19923, 97, 3, 58, "Subsubsection"],
Cell[839683, 19928, 2378, 40, 667, "Input"],
Cell[842064, 19970, 2318, 39, 667, "Input"],
Cell[844385, 20011, 189, 3, 43, "Input"],
Cell[844577, 20016, 572, 11, 203, "Input"],

Cell[CellGroupData[{
Cell[845174, 20031, 50, 1, 27, "Input"],
Cell[845227, 20034, 8173, 161, 70, 965, 67, "GraphicsData", "PostScript", \
"Graphics"],
Cell[853403, 20197, 130, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[853570, 20205, 78, 1, 27, "Input"],
Cell[853651, 20208, 8431, 156, 70, 850, 58, "GraphicsData", "PostScript", \
"Graphics"],
Cell[862085, 20366, 130, 3, 70, "Output"]
}, Closed]],
Cell[862230, 20372, 573, 11, 203, "Input"],

Cell[CellGroupData[{
Cell[862828, 20387, 52, 1, 27, "Input"],
Cell[862883, 20390, 21298, 394, 70, 1800, 149, "GraphicsData", "PostScript", \
"Graphics"],
Cell[884184, 20786, 132, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[884353, 20794, 80, 1, 27, "Input"],
Cell[884436, 20797, 12018, 267, 70, 1586, 134, "GraphicsData", "PostScript", \
"Graphics"],
Cell[896457, 21066, 132, 3, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[896638, 21075, 93, 3, 58, "Subsubsection"],
Cell[896734, 21080, 318, 6, 91, "Input"],
Cell[897055, 21088, 560, 10, 203, "Input"],

Cell[CellGroupData[{
Cell[897640, 21102, 50, 1, 27, "Input"],
Cell[897693, 21105, 4169, 101, 70, 829, 55, "GraphicsData", "PostScript", \
"Graphics"],
Cell[901865, 21208, 130, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[902032, 21216, 75, 1, 27, "Input"],
Cell[902110, 21219, 3502, 86, 70, 729, 47, "GraphicsData", "PostScript", \
"Graphics"],
Cell[905615, 21307, 130, 3, 70, "Output"]
}, Closed]],
Cell[905760, 21313, 561, 10, 203, "Input"],

Cell[CellGroupData[{
Cell[906346, 21327, 52, 1, 27, "Input"],
Cell[906401, 21330, 19751, 365, 70, 1666, 137, "GraphicsData", "PostScript", \
"Graphics"],
Cell[926155, 21697, 132, 3, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[926336, 21706, 31, 0, 42, "Subsubsection"],
Cell[926370, 21708, 853, 14, 235, "Input"],
Cell[927226, 21724, 196, 3, 75, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[927459, 21732, 149, 4, 74, "Subsubsection"],
Cell[927611, 21738, 101, 4, 65, "Text"],
Cell[927715, 21744, 1281, 23, 379, "Input"],
Cell[928999, 21769, 88, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[929124, 21777, 48, 0, 42, "Subsubsection"],
Cell[929175, 21779, 101, 4, 65, "Text"],
Cell[929279, 21785, 1140, 19, 331, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[930456, 21809, 154, 4, 74, "Subsubsection"],
Cell[930613, 21815, 1231, 22, 363, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[931881, 21842, 53, 0, 42, "Subsubsection"],
Cell[931937, 21844, 1171, 20, 331, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[933145, 21869, 82, 1, 42, "Subsubsection"],
Cell[933230, 21872, 1365, 24, 331, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[934632, 21901, 100, 3, 42, "Subsubsection"],
Cell[934735, 21906, 135, 3, 48, "Text"],
Cell[934873, 21911, 2057, 36, 507, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[936979, 21953, 79, 1, 61, "Subsection"],

Cell[CellGroupData[{
Cell[937083, 21958, 78, 0, 42, "Subsubsection"],
Cell[937164, 21960, 104, 3, 31, "Text"],
Cell[937271, 21965, 88, 1, 27, "Input"],
Cell[937362, 21968, 93, 3, 31, "Text"],
Cell[937458, 21973, 74, 1, 27, "Input"],
Cell[937535, 21976, 68, 1, 27, "Input"],
Cell[937606, 21979, 88, 1, 27, "Input"],
Cell[937697, 21982, 90, 1, 27, "Input"],
Cell[937790, 21985, 78, 1, 27, "Input"],
Cell[937871, 21988, 72, 1, 27, "Input"],
Cell[937946, 21991, 85, 1, 27, "Input"],
Cell[938034, 21994, 87, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[938158, 22000, 47, 0, 42, "Subsubsection"],
Cell[938208, 22002, 117, 3, 48, "Text"],
Cell[938328, 22007, 579, 17, 99, "Input"],
Cell[938910, 22026, 288, 7, 116, "Text"],
Cell[939201, 22035, 80, 1, 27, "Input"],
Cell[939284, 22038, 63, 0, 31, "Text"],
Cell[939350, 22040, 4044, 116, 639, "Input"],
Cell[943397, 22158, 2484, 78, 639, "Input"],
Cell[945884, 22238, 244, 5, 65, "Text"],
Cell[946131, 22245, 4402, 127, 693, "Input"],
Cell[950536, 22374, 4409, 127, 693, "Input"],
Cell[954948, 22503, 76, 1, 27, "Input"],
Cell[955027, 22506, 167, 4, 65, "Text"],
Cell[955197, 22512, 2166, 84, 693, "Input"],
Cell[957366, 22598, 233, 5, 82, "Text"],
Cell[957602, 22605, 2170, 84, 693, "Input"],
Cell[959775, 22691, 168, 4, 48, "Text"],
Cell[959946, 22697, 2169, 84, 693, "Input"],
Cell[962118, 22783, 104, 3, 48, "Text"],
Cell[962225, 22788, 2171, 84, 693, "Input"],
Cell[964399, 22874, 406, 8, 91, "Input"],
Cell[964808, 22884, 63, 1, 27, "Input"],
Cell[964874, 22887, 62, 1, 27, "Input"],
Cell[964939, 22890, 84, 1, 27, "Input"],
Cell[965026, 22893, 86, 1, 27, "Input"],
Cell[965115, 22896, 86, 1, 27, "Input"],
Cell[965204, 22899, 62, 1, 27, "Input"],
Cell[965269, 22902, 63, 1, 27, "Input"],
Cell[965335, 22905, 63, 1, 27, "Input"],
Cell[965401, 22908, 83, 1, 27, "Input"],
Cell[965487, 22911, 78, 1, 27, "Input"],
Cell[965568, 22914, 54, 1, 27, "Input"],
Cell[965625, 22917, 62, 1, 27, "Input"],
Cell[965690, 22920, 60, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[965787, 22926, 100, 1, 58, "Subsubsection"],
Cell[965890, 22929, 163, 5, 82, "Text"],
Cell[966056, 22936, 4408, 127, 693, "Input"],
Cell[970467, 23065, 239, 7, 116, "Text"],
Cell[970709, 23074, 2170, 84, 693, "Input"],
Cell[972882, 23160, 172, 5, 82, "Text"],
Cell[973057, 23167, 2169, 84, 693, "Input"],
Cell[975229, 23253, 110, 5, 82, "Text"],
Cell[975342, 23260, 2171, 84, 693, "Input"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[977562, 23350, 98, 3, 62, "Subsection"],
Cell[977663, 23355, 304, 8, 116, "Text"],

Cell[CellGroupData[{
Cell[977992, 23367, 92, 1, 27, "Input"],
Cell[978087, 23370, 81, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[978205, 23376, 92, 1, 27, "Input"],
Cell[978300, 23379, 81, 1, 70, "Output"]
}, Closed]],
Cell[978396, 23383, 56, 1, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[978489, 23389, 133, 4, 58, "Subsection"],

Cell[CellGroupData[{
Cell[978647, 23397, 45, 0, 42, "Subsubsection"],
Cell[978695, 23399, 30, 0, 31, "Text"],
Cell[978728, 23401, 82, 1, 27, "Input"],
Cell[978813, 23404, 29, 0, 31, "Text"],
Cell[978845, 23406, 113, 2, 27, "Input"],
Cell[978961, 23410, 66, 1, 27, "Input"],
Cell[979030, 23413, 88, 1, 27, "Input"],
Cell[979121, 23416, 179, 6, 99, "Text"],
Cell[979303, 23424, 320, 7, 116, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[979660, 23436, 44, 0, 42, "Subsubsection"],
Cell[979707, 23438, 119, 5, 82, "Text"],
Cell[979829, 23445, 67, 1, 27, "Input"],
Cell[979899, 23448, 286, 5, 59, "Input"],

Cell[CellGroupData[{
Cell[980210, 23457, 50, 1, 27, "Input"],
Cell[980263, 23460, 396, 9, 70, "Output"]
}, Closed]],
Cell[980674, 23472, 290, 5, 59, "Input"],

Cell[CellGroupData[{
Cell[980989, 23481, 52, 1, 27, "Input"],
Cell[981044, 23484, 382, 8, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[981475, 23498, 84, 1, 42, "Subsubsection"],
Cell[981562, 23501, 734, 14, 187, "Text"],

Cell[CellGroupData[{
Cell[982321, 23519, 427, 8, 75, "Input"],
Cell[982751, 23529, 1652, 55, 70, 647, 39, "GraphicsData", "PostScript", \
"Graphics"]
}, Closed]],
Cell[984418, 23587, 283, 7, 116, "Text"],
Cell[984704, 23596, 135, 6, 99, "Text"],
Cell[984842, 23604, 67, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[984934, 23609, 53, 1, 27, "Input"],
Cell[984990, 23612, 296, 6, 70, "Output"]
}, Closed]],
Cell[985301, 23621, 571, 11, 139, "Input"],
Cell[985875, 23634, 269, 9, 150, "Text"],
Cell[986147, 23645, 567, 11, 139, "Input"],

Cell[CellGroupData[{
Cell[986739, 23660, 53, 1, 27, "Input"],
Cell[986795, 23663, 345, 7, 70, "Output"]
}, Closed]],
Cell[987155, 23673, 104, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[987296, 23681, 38, 0, 42, "Subsubsection"],
Cell[987337, 23683, 398, 10, 150, "Text"],
Cell[987738, 23695, 190, 4, 65, "Text"],
Cell[987931, 23701, 45, 1, 27, "Input"],
Cell[987979, 23704, 54, 1, 27, "Input"],
Cell[988036, 23707, 93, 1, 27, "Input"],
Cell[988132, 23710, 116, 3, 31, "Text"],
Cell[988251, 23715, 51, 1, 27, "Input"],
Cell[988305, 23718, 562, 10, 155, "Input"],
Cell[988870, 23730, 626, 12, 139, "Input"],

Cell[CellGroupData[{
Cell[989521, 23746, 54, 1, 27, "Input"],
Cell[989578, 23749, 383, 8, 70, "Output"]
}, Closed]],
Cell[989976, 23760, 54, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[990055, 23765, 54, 1, 27, "Input"],
Cell[990112, 23768, 383, 8, 70, "Output"]
}, Closed]],
Cell[990510, 23779, 250, 6, 65, "Text"],
Cell[990763, 23787, 315, 5, 59, "Input"],

Cell[CellGroupData[{
Cell[991103, 23796, 54, 1, 27, "Input"],
Cell[991160, 23799, 431, 9, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[991640, 23814, 66, 0, 42, "Subsubsection"],
Cell[991709, 23816, 53, 0, 31, "Text"],
Cell[991765, 23818, 372, 7, 107, "Input"],
Cell[992140, 23827, 376, 7, 107, "Input"],
Cell[992519, 23836, 380, 7, 107, "Input"],

Cell[CellGroupData[{
Cell[992924, 23847, 58, 1, 27, "Input"],
Cell[992985, 23850, 375, 8, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[993397, 23863, 60, 1, 27, "Input"],
Cell[993460, 23866, 361, 7, 70, "Output"]
}, Closed]],
Cell[993836, 23876, 96, 3, 31, "Text"],
Cell[993935, 23881, 54, 1, 27, "Input"],
Cell[993992, 23884, 93, 3, 31, "Text"],
Cell[994088, 23889, 71, 1, 27, "Input"],
Cell[994162, 23892, 50, 1, 27, "Input"],
Cell[994215, 23895, 86, 1, 27, "Input"],
Cell[994304, 23898, 190, 4, 27, "Input"],
Cell[994497, 23904, 163, 3, 43, "Input"],
Cell[994663, 23909, 70, 1, 27, "Input"],
Cell[994736, 23912, 107, 3, 31, "Text"],
Cell[994846, 23917, 70, 1, 27, "Input"],
Cell[994919, 23920, 193, 3, 75, "Input"],
Cell[995115, 23925, 206, 3, 75, "Input"],
Cell[995324, 23930, 54, 1, 27, "Input"],
Cell[995381, 23933, 52, 1, 27, "Input"],
Cell[995436, 23936, 54, 1, 27, "Input"],
Cell[995493, 23939, 87, 1, 27, "Input"],
Cell[995583, 23942, 92, 3, 31, "Text"],
Cell[995678, 23947, 164, 3, 43, "Input"],
Cell[995845, 23952, 71, 1, 27, "Input"],
Cell[995919, 23955, 72, 1, 27, "Input"],
Cell[995994, 23958, 208, 3, 75, "Input"],
Cell[996205, 23963, 54, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[996284, 23968, 64, 1, 27, "Input"],
Cell[996351, 23971, 887, 21, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[997275, 23997, 66, 1, 27, "Input"],
Cell[997344, 24000, 993, 23, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[998374, 24028, 57, 1, 27, "Input"],
Cell[998434, 24031, 1114, 26, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[999597, 24063, 70, 0, 42, "Subsubsection"],
Cell[999670, 24065, 26, 0, 31, "Text"],
Cell[999699, 24067, 212, 5, 82, "Text"],
Cell[999914, 24074, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[1000013, 24078, 312, 7, 59, "Input",
  Evaluatable->False],
Cell[1000328, 24087, 316, 7, 59, "Input",
  Evaluatable->False],
Cell[1000647, 24096, 320, 7, 59, "Input",
  Evaluatable->False],
Cell[1000970, 24105, 83, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[1001090, 24112, 38, 0, 42, "Subsubsection"],
Cell[1001131, 24114, 196, 6, 99, "Text"],
Cell[1001330, 24122, 93, 1, 27, "Input"],
Cell[1001426, 24125, 1160, 20, 395, "Input"],
Cell[1002589, 24147, 28, 0, 31, "Text"],
Cell[1002620, 24149, 106, 2, 27, "Input"],
Cell[1002729, 24153, 1205, 22, 395, "Input"],

Cell[CellGroupData[{
Cell[1003959, 24179, 408, 10, 43, "Input"],
Cell[1004370, 24191, 10906, 289, 70, 3333, 191, "GraphicsData", "PostScript", \
"Graphics"],
Cell[1015279, 24482, 132, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1015448, 24490, 62, 1, 27, "Input"],
Cell[1015513, 24493, 254070, 10110, 70, 243822, 9979, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1269586, 34605, 132, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1269755, 34613, 52, 1, 27, "Input"],
Cell[1269810, 34616, 130, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1269977, 34624, 52, 1, 27, "Input"],
Cell[1270032, 34627, 130, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1270199, 34635, 44, 1, 27, "Input"],
Cell[1270246, 34638, 2853, 69, 70, 598, 36, "GraphicsData", "PostScript", \
"Graphics"],
Cell[1273102, 34709, 130, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1273269, 34717, 50, 1, 27, "Input"],
Cell[1273322, 34720, 132, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1273491, 34728, 50, 1, 27, "Input"],
Cell[1273544, 34731, 132, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1273713, 34739, 44, 1, 27, "Input"],
Cell[1273760, 34742, 19715, 342, 70, 1347, 111, "GraphicsData", "PostScript", \
"Graphics"],
Cell[1293478, 35086, 132, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1293647, 35094, 42, 1, 27, "Input"],
Cell[1293692, 35097, 38972, 1753, 70, 16500, 1471, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1332667, 36852, 132, 3, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1332836, 36860, 44, 1, 27, "Input"],
Cell[1332883, 36863, 51225, 1233, 70, 9791, 717, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1384111, 38098, 130, 3, 70, "Output"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1384302, 38108, 34, 0, 45, "Subsection"],
Cell[1384339, 38110, 141, 5, 82, "Text"],

Cell[CellGroupData[{
Cell[1384505, 38119, 49, 0, 42, "Subsubsection"],
Cell[1384557, 38121, 119, 3, 31, "Text"],

Cell[CellGroupData[{
Cell[1384701, 38128, 51, 1, 27, "Input"],
Cell[1384755, 38131, 75, 1, 70, "Output"]
}, Closed]],
Cell[1384845, 38135, 2489, 58, 267, "Input"],
Cell[1387337, 38195, 108, 3, 31, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1387482, 38203, 76, 0, 42, "Subsubsection"],
Cell[1387561, 38205, 66, 0, 31, "Text"],
Cell[1387630, 38207, 91, 1, 27, "Input"],
Cell[1387724, 38210, 109, 2, 27, "Input"],
Cell[1387836, 38214, 61, 0, 31, "Text"],
Cell[1387900, 38216, 154, 4, 27, "Input"],
Cell[1388057, 38222, 172, 4, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1388266, 38231, 70, 0, 42, "Subsubsection"],

Cell[CellGroupData[{
Cell[1388361, 38235, 68, 1, 27, "Input"],
Cell[1388432, 38238, 61, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1388530, 38244, 54, 1, 27, "Input"],
Cell[1388587, 38247, 49, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1388673, 38253, 73, 1, 27, "Input"],
Cell[1388749, 38256, 38, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1388824, 38262, 67, 1, 27, "Input"],
Cell[1388894, 38265, 63, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1388994, 38271, 50, 1, 27, "Input"],
Cell[1389047, 38274, 57, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1389141, 38280, 53, 1, 27, "Input"],
Cell[1389197, 38283, 291, 4, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1389525, 38292, 62, 1, 27, "Input"],
Cell[1389590, 38295, 49, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1389676, 38301, 53, 1, 27, "Input"],
Cell[1389732, 38304, 53, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1389822, 38310, 75, 1, 27, "Input"],
Cell[1389900, 38313, 30, 0, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1389967, 38318, 67, 1, 27, "Input"],
Cell[1390037, 38321, 68, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1390142, 38327, 105, 2, 43, "Input"],
Cell[1390250, 38331, 64, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1390351, 38337, 102, 2, 31, "Input"],
Cell[1390456, 38341, 54, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1390547, 38347, 49, 1, 27, "Input"],
Cell[1390599, 38350, 50, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1390686, 38356, 89, 1, 31, "Input"],
Cell[1390778, 38359, 57, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1390872, 38365, 55, 1, 27, "Input"],
Cell[1390930, 38368, 57, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1391024, 38374, 63, 1, 29, "Input"],
Cell[1391090, 38377, 66, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1391193, 38383, 49, 1, 27, "Input"],
Cell[1391245, 38386, 79, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1391361, 38392, 57, 1, 27, "Input"],
Cell[1391421, 38395, 46, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1391504, 38401, 58, 1, 29, "Input"],
Cell[1391565, 38404, 58, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1391660, 38410, 44, 1, 27, "Input"],
Cell[1391707, 38413, 43, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1391787, 38419, 61, 1, 29, "Input"],
Cell[1391851, 38422, 53, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1391941, 38428, 44, 1, 29, "Input"],
Cell[1391988, 38431, 42, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1392067, 38437, 67, 1, 29, "Input"],
Cell[1392137, 38440, 47, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1392221, 38446, 61, 1, 27, "Input"],
Cell[1392285, 38449, 54, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1392376, 38455, 74, 1, 29, "Input"],
Cell[1392453, 38458, 54, 1, 70, "Output"]
}, Closed]],
Cell[1392522, 38462, 464, 11, 184, "Text"],
Cell[1392989, 38475, 565, 12, 153, "Text"],
Cell[1393557, 38489, 612, 12, 145, "Text"],
Cell[1394172, 38503, 57, 1, 27, "Input"],
Cell[1394232, 38506, 1554, 28, 267, "Text"],
Cell[1395789, 38536, 58, 1, 27, "Input"],
Cell[1395850, 38539, 1234, 22, 295, "Text"],
Cell[1397087, 38563, 58, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[1397170, 38568, 34, 1, 27, "Input"],
Cell[1397207, 38571, 37, 1, 70, "Output"]
}, Closed]],
Cell[1397259, 38575, 1340, 27, 323, "Text"],
Cell[1398602, 38604, 58, 1, 27, "Input"],
Cell[1398663, 38607, 782, 13, 267, "Input"],
Cell[1399448, 38622, 177, 3, 59, "Input"],

Cell[CellGroupData[{
Cell[1399650, 38629, 204, 4, 59, "Input"],
Cell[1399857, 38635, 2754, 71, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1402648, 38711, 227, 4, 59, "Input"],
Cell[1402878, 38717, 782, 18, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1403697, 38740, 229, 4, 59, "Input"],
Cell[1403929, 38746, 1689, 32, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1405655, 38783, 229, 4, 59, "Input"],
Cell[1405887, 38789, 1437, 29, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1407361, 38823, 229, 4, 59, "Input"],
Cell[1407593, 38829, 1565, 34, 70, "Output"]
}, Closed]],
Cell[1409173, 38866, 58, 1, 27, "Input"],
Cell[1409234, 38869, 72, 0, 31, "Text"],
Cell[1409309, 38871, 48, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[1409382, 38876, 121, 2, 27, "Input"],
Cell[1409506, 38880, 52, 1, 70, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1409595, 38886, 121, 2, 27, "Input"],
Cell[1409719, 38890, 53, 1, 70, "Output"]
}, Closed]],
Cell[1409787, 38894, 153, 3, 27, "Input"],
Cell[1409943, 38899, 111, 2, 27, "Input"],
Cell[1410057, 38903, 297, 6, 75, "Input"],
Cell[1410357, 38911, 87, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[1410469, 38916, 138, 2, 43, "Input"],
Cell[1410610, 38920, 39, 1, 70, "Output"]
}, Closed]],
Cell[1410664, 38924, 137, 3, 27, "Input"],
Cell[1410804, 38929, 154, 3, 27, "Input"],
Cell[1410961, 38934, 154, 3, 27, "Input"],
Cell[1411118, 38939, 141, 3, 48, "Text"],
Cell[1411262, 38944, 447, 8, 123, "Input"],
Cell[1411712, 38954, 155, 4, 27, "Input"],
Cell[1411870, 38960, 173, 4, 27, "Input"],
Cell[1412046, 38966, 158, 4, 27, "Input"],
Cell[1412207, 38972, 176, 4, 27, "Input"],
Cell[1412386, 38978, 158, 4, 27, "Input"],
Cell[1412547, 38984, 176, 4, 27, "Input"],
Cell[1412726, 38990, 158, 4, 27, "Input"],
Cell[1412887, 38996, 176, 4, 27, "Input"],
Cell[1413066, 39002, 158, 4, 27, "Input"],
Cell[1413227, 39008, 176, 4, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1413440, 39017, 175, 5, 56, "Subsubsection"],
Cell[1413618, 39024, 615, 13, 163, "Text"],
Cell[1414236, 39039, 81, 2, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1414342, 39045, 253, 5, 59, "Input",
  Evaluatable->False],
Cell[1414598, 39052, 787, 19, 175, "Output"]
}, Closed]],
Cell[1415400, 39074, 573, 12, 167, "Text"],
Cell[1415976, 39088, 254, 6, 59, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[1416267, 39099, 59, 0, 42, "Subsubsection"],
Cell[1416329, 39101, 589, 11, 167, "Text"],
Cell[1416921, 39114, 1353, 29, 177, "Text"],
Cell[1418277, 39145, 55, 1, 27, "Input"],
Cell[1418335, 39148, 341, 6, 59, "Input"],
Cell[1418679, 39156, 48, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[1418752, 39161, 89, 1, 27, "Input"],
Cell[1418844, 39164, 53, 1, 70, "Output"]
}, Closed]],
Cell[1418912, 39168, 64, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[1419001, 39173, 76, 1, 27, "Input"],
Cell[1419080, 39176, 53, 1, 70, "Output"]
}, Closed]],
Cell[1419148, 39180, 66, 1, 27, "Input"],
Cell[1419217, 39183, 108, 3, 31, "Text"],
Cell[1419328, 39188, 133, 3, 27, "Input"],
Cell[1419464, 39193, 48, 1, 27, "Input"],
Cell[1419515, 39196, 158, 4, 27, "Input"],
Cell[1419676, 39202, 48, 1, 27, "Input"],
Cell[1419727, 39205, 176, 4, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1419940, 39214, 109, 3, 42, "Subsubsection"],
Cell[1420052, 39219, 394, 8, 116, "Text"],
Cell[1420449, 39229, 57, 1, 27, "Input"],
Cell[1420509, 39232, 137, 5, 82, "Text"],
Cell[1420649, 39239, 131, 3, 27, "Input"],
Cell[1420783, 39244, 190, 6, 66, "Text"],
Cell[1420976, 39252, 610, 13, 135, "Text"],
Cell[1421589, 39267, 164, 2, 43, "Input"],
Cell[1421756, 39271, 154, 5, 82, "Text"],
Cell[1421913, 39278, 132, 3, 27, "Input"],
Cell[1422048, 39283, 217, 5, 43, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1422302, 39293, 37, 0, 42, "Subsubsection"],
Cell[1422342, 39295, 91, 1, 27, "Input"],
Cell[1422436, 39298, 152, 4, 27, "Input"],
Cell[1422591, 39304, 223, 6, 43, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1422851, 39315, 33, 0, 42, "Subsubsection"],
Cell[1422887, 39317, 108, 2, 27, "Input"],
Cell[1422998, 39321, 183, 4, 27, "Input"],
Cell[1423184, 39327, 254, 6, 43, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1423475, 39338, 48, 0, 42, "Subsubsection"],
Cell[1423526, 39340, 51, 1, 27, "Input"],
Cell[1423580, 39343, 76, 1, 27, "Input"],
Cell[1423659, 39346, 51, 1, 27, "Input"],
Cell[1423713, 39349, 76, 1, 27, "Input"],
Cell[1423792, 39352, 58, 0, 31, "Text"],
Cell[1423853, 39354, 1108, 20, 315, "Input"],
Cell[1424964, 39376, 103, 3, 31, "Text"],
Cell[1425070, 39381, 379, 6, 123, "Input"],
Cell[1425452, 39389, 93, 1, 27, "Input"],
Cell[1425548, 39392, 35, 0, 31, "Text"],
Cell[1425586, 39394, 1123, 20, 331, "Input"],
Cell[1426712, 39416, 137, 3, 27, "Input"],
Cell[1426852, 39421, 33, 0, 31, "Text"],
Cell[1426888, 39423, 1124, 20, 331, "Input"],
Cell[1428015, 39445, 139, 3, 27, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1428191, 39453, 35, 0, 42, "Subsubsection"],
Cell[1428229, 39455, 375, 6, 123, "Input"],
Cell[1428607, 39463, 730, 14, 139, "Input"],
Cell[1429340, 39479, 55, 0, 31, "Text"],
Cell[1429398, 39481, 940, 18, 187, "Input"],

Cell[CellGroupData[{
Cell[1430363, 39503, 40, 1, 27, "Input"],
Cell[1430406, 39506, 23263, 394, 70, 1477, 121, "GraphicsData", "PostScript", \
"Graphics"],
Cell[1453672, 39902, 132, 3, 70, "Output"]
}, Closed]],
Cell[1453819, 39908, 88, 1, 27, "Input"],
Cell[1453910, 39911, 69, 4, 65, "Text"],
Cell[1453982, 39917, 87, 1, 27, "Input"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1454130, 39925, 79, 1, 56, "Section"],

Cell[CellGroupData[{
Cell[1454234, 39930, 32, 0, 42, "Subsubsection"],
Cell[1454269, 39932, 87, 3, 31, "Text"],
Cell[1454359, 39937, 286, 5, 65, "Text"],
Cell[1454648, 39944, 189, 4, 48, "Text"],
Cell[1454840, 39950, 379, 6, 82, "Text"],
Cell[1455222, 39958, 480, 8, 99, "Text"],
Cell[1455705, 39968, 480, 8, 99, "Text"],
Cell[1456188, 39978, 311, 9, 116, "Text"],
Cell[1456502, 39989, 74, 0, 31, "Text"],
Cell[1456579, 39991, 377, 6, 104, "Text"],
Cell[1456959, 39999, 278, 7, 49, "Text"],
Cell[1457240, 40008, 329, 8, 116, "Text"],
Cell[1457572, 40018, 307, 9, 133, "Text"],
Cell[1457882, 40029, 258, 8, 116, "Text"],
Cell[1458143, 40039, 630, 13, 184, "Text"],
Cell[1458776, 40054, 262, 8, 116, "Text"],
Cell[1459041, 40064, 537, 14, 184, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1459615, 40083, 27, 0, 28, "Subsubsection"],
Cell[1459645, 40085, 46, 1, 40, "Input"],
Cell[1459694, 40088, 266, 6, 104, "Input"],
Cell[1459963, 40096, 525, 8, 136, "Input"],
Cell[1460491, 40106, 1486, 34, 136, "Input"],
Cell[1461980, 40142, 113, 3, 31, "Text"],
Cell[1462096, 40147, 80, 1, 47, "Text"],

Cell[CellGroupData[{
Cell[1462201, 40152, 75, 1, 40, "Input"],
Cell[1462279, 40155, 62, 1, 40, "Output"]
}, Closed]],
Cell[1462356, 40159, 526, 8, 133, "Input"],
Cell[1462885, 40169, 1486, 34, 136, "Input"],
Cell[1464374, 40205, 231, 4, 45, "Text"],
Cell[1464608, 40211, 57, 3, 48, "Text"],
Cell[1464668, 40216, 66, 0, 31, "Text"],
Cell[1464737, 40218, 102, 3, 31, "Text"],
Cell[1464842, 40223, 245, 5, 65, "Text"],
Cell[1465090, 40230, 293, 8, 116, "Text"],
Cell[1465386, 40240, 187, 4, 48, "Text"],
Cell[1465576, 40246, 78, 2, 31, "Text"],
Cell[1465657, 40250, 115, 2, 40, "Input"],
Cell[1465775, 40254, 113, 2, 40, "Input"],
Cell[1465891, 40258, 109, 3, 31, "Text"],
Cell[1466003, 40263, 140, 3, 48, "Text"],
Cell[1466146, 40268, 162, 3, 40, "Input"],
Cell[1466311, 40273, 114, 3, 31, "Text"],
Cell[1466428, 40278, 308, 6, 88, "Input"],
Cell[1466739, 40286, 102, 3, 31, "Text"],
Cell[1466844, 40291, 107, 2, 40, "Input"],
Cell[1466954, 40295, 276, 5, 65, "Text"],
Cell[1467233, 40302, 48, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[1467306, 40307, 61, 1, 40, "Input"],
Cell[1467370, 40310, 54, 1, 40, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1467473, 40317, 30, 0, 42, "Subsubsection"],
Cell[1467506, 40319, 47, 1, 40, "Input"],
Cell[1467556, 40322, 266, 6, 104, "Input"],
Cell[1467825, 40330, 526, 8, 136, "Input"],
Cell[1468354, 40340, 1488, 34, 136, "Input"],
Cell[1469845, 40376, 527, 8, 136, "Input"],
Cell[1470375, 40386, 1488, 34, 136, "Input"],
Cell[1471866, 40422, 57, 3, 48, "Text"],
Cell[1471926, 40427, 65, 0, 31, "Text"],
Cell[1471994, 40429, 60, 3, 48, "Text"],
Cell[1472057, 40434, 75, 0, 31, "Text"],
Cell[1472135, 40436, 96, 3, 31, "Text"],
Cell[1472234, 40441, 213, 4, 48, "Text"],
Cell[1472450, 40447, 51, 0, 31, "Text"],
Cell[1472504, 40449, 113, 3, 31, "Text"],
Cell[1472620, 40454, 48, 0, 31, "Text"],
Cell[1472671, 40456, 48, 1, 40, "Input"],

Cell[CellGroupData[{
Cell[1472744, 40461, 61, 1, 40, "Input"],
Cell[1472808, 40464, 54, 1, 40, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1472911, 40471, 33, 0, 28, "Subsubsection"],
Cell[1472947, 40473, 47, 1, 27, "Input"],
Cell[1472997, 40476, 124, 2, 27, "Input"],
Cell[1473124, 40480, 217, 3, 59, "Input"],
Cell[1473344, 40485, 221, 3, 85, "Text"],
Cell[1473568, 40490, 899, 15, 217, "Input"],
Cell[1474470, 40507, 1488, 34, 123, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1475995, 40546, 49, 0, 28, "Subsubsection"],
Cell[1476047, 40548, 591, 15, 252, "Text"],
Cell[1476641, 40565, 38, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[1476704, 40569, 51, 1, 27, "Input"],
Cell[1476758, 40572, 38972, 1753, 70, 16500, 1471, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1515733, 42327, 132, 3, 70, "Output"]
}, Closed]],
Cell[1515880, 42333, 144, 3, 59, "Input"],
Cell[1516027, 42338, 66, 1, 27, "Input"],
Cell[1516096, 42341, 150, 2, 43, "Input"],
Cell[1516249, 42345, 48, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[1516322, 42350, 61, 1, 27, "Input"],
Cell[1516386, 42353, 54, 1, 70, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1516489, 42360, 69, 0, 28, "Subsubsection"],
Cell[1516561, 42362, 218, 4, 65, "Text"],
Cell[1516782, 42368, 514, 14, 218, "Text"],
Cell[1517299, 42384, 71, 2, 27, "Input",
  Evaluatable->False],
Cell[1517373, 42388, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[1517451, 42392, 736, 14, 171, "Input",
  Evaluatable->False],
Cell[1518190, 42408, 756, 14, 171, "Input",
  Evaluatable->False],
Cell[1518949, 42424, 754, 13, 235, "Input",
  Evaluatable->False],
Cell[1519706, 42439, 279, 6, 59, "Input",
  Evaluatable->False],
Cell[1519988, 42447, 443, 12, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[1520468, 42464, 57, 0, 28, "Subsubsection"],
Cell[1520528, 42466, 105, 3, 31, "Text"],
Cell[1520636, 42471, 74, 2, 27, "Input",
  Evaluatable->False],
Cell[1520713, 42475, 107, 2, 27, "Input",
  Evaluatable->False],
Cell[1520823, 42479, 103, 2, 27, "Input",
  Evaluatable->False],
Cell[1520929, 42483, 130, 3, 27, "Input",
  Evaluatable->False],
Cell[1521062, 42488, 110, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[1521209, 42495, 42, 0, 28, "Subsubsection"],
Cell[1521254, 42497, 301, 9, 150, "Text"],
Cell[1521558, 42508, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[1521657, 42512, 89, 3, 31, "Text"],
Cell[1521749, 42517, 136, 3, 27, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1521910, 42524, 38, 1, 27, "Input"],
Cell[1521951, 42527, 35, 1, 70, "Output"]
}, Closed]],
Cell[1522001, 42531, 99, 2, 27, "Input",
  Evaluatable->False],
Cell[1522103, 42535, 136, 3, 27, "Input",
  Evaluatable->False],
Cell[1522242, 42540, 46, 1, 27, "Input"],
Cell[1522291, 42543, 646, 12, 107, "Input",
  Evaluatable->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1522998, 42562, 30, 0, 42, "Subsubtitle"],

Cell[CellGroupData[{
Cell[1523053, 42566, 73, 0, 45, "Subsection"],
Cell[1523129, 42568, 88, 3, 31, "Text"],
Cell[1523220, 42573, 129, 4, 27, "Input",
  Evaluatable->False],
Cell[1523352, 42579, 57, 0, 31, "Text"],
Cell[1523412, 42581, 172, 4, 27, "Input",
  Evaluatable->False],
Cell[1523587, 42587, 47, 0, 31, "Text"],

Cell[CellGroupData[{
Cell[1523659, 42591, 226, 5, 91, "Input",
  Evaluatable->False],
Cell[1523888, 42598, 132, 3, 27, "Output"]
}, Closed]],
Cell[1524035, 42604, 329, 7, 91, "Input",
  Evaluatable->False],
Cell[1524367, 42613, 2131, 38, 571, "Input",
  Evaluatable->False],

Cell[CellGroupData[{
Cell[1526523, 42655, 124, 3, 27, "Input",
  Evaluatable->False],
Cell[1526650, 42660, 132, 3, 27, "Output"]
}, Closed]],

Cell[CellGroupData[{
Cell[1526819, 42668, 285, 6, 139, "Input",
  Evaluatable->False],
Cell[1527107, 42676, 132, 3, 27, "Output"]
}, Closed]],
Cell[1527254, 42682, 87, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[1527378, 42689, 102, 3, 45, "Subsection"],
Cell[1527483, 42694, 102, 3, 48, "Text"],
Cell[1527588, 42699, 744, 15, 218, "Text"],
Cell[1528335, 42716, 97, 2, 27, "Input",
  Evaluatable->False],
Cell[1528435, 42720, 522, 9, 91, "Input",
  Evaluatable->False],
Cell[1528960, 42731, 524, 9, 91, "Input",
  Evaluatable->False],
Cell[1529487, 42742, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[1529586, 42746, 184, 4, 27, "Input",
  Evaluatable->False],
Cell[1529773, 42752, 215, 5, 27, "Input",
  Evaluatable->False],
Cell[1529991, 42759, 211, 5, 27, "Input",
  Evaluatable->False],
Cell[1530205, 42766, 174, 4, 27, "Input",
  Evaluatable->False],
Cell[1530382, 42772, 214, 5, 27, "Input",
  Evaluatable->False],
Cell[1530599, 42779, 210, 5, 27, "Input",
  Evaluatable->False],
Cell[1530812, 42786, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[1530885, 42790, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[1530958, 42794, 325, 8, 91, "Input",
  Evaluatable->False],
Cell[1531286, 42804, 70, 2, 27, "Input",
  Evaluatable->False],
Cell[1531359, 42808, 71, 2, 27, "Input",
  Evaluatable->False],
Cell[1531433, 42812, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[1531532, 42816, 55, 0, 31, "Text"],
Cell[1531590, 42818, 275, 6, 59, "Input",
  Evaluatable->False],
Cell[1531868, 42826, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[1531953, 42830, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[1532058, 42834, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[1532193, 42839, 281, 6, 59, "Input",
  Evaluatable->False],
Cell[1532477, 42847, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[1532562, 42851, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[1532667, 42855, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[1532802, 42860, 295, 6, 59, "Input",
  Evaluatable->False],
Cell[1533100, 42868, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[1533185, 42872, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[1533290, 42876, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[1533425, 42881, 55, 0, 31, "Text"],
Cell[1533483, 42883, 275, 6, 59, "Input",
  Evaluatable->False],
Cell[1533761, 42891, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[1533846, 42895, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[1533951, 42899, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[1534086, 42904, 281, 6, 59, "Input",
  Evaluatable->False],
Cell[1534370, 42912, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[1534455, 42916, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[1534560, 42920, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[1534695, 42925, 483, 10, 107, "Input",
  Evaluatable->False],
Cell[1535181, 42937, 82, 2, 27, "Input",
  Evaluatable->False],
Cell[1535266, 42941, 102, 2, 27, "Input",
  Evaluatable->False],
Cell[1535371, 42945, 132, 3, 27, "Input",
  Evaluatable->False],
Cell[1535506, 42950, 247, 6, 59, "Input",
  Evaluatable->False],
Cell[1535756, 42958, 387, 8, 91, "Input",
  Evaluatable->False],
Cell[1536146, 42968, 67, 2, 27, "Input",
  Evaluatable->False],
Cell[1536216, 42972, 75, 2, 27, "Input",
  Evaluatable->False],
Cell[1536294, 42976, 468, 10, 107, "Input",
  Evaluatable->False],
Cell[1536765, 42988, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[1536864, 42992, 126, 3, 27, "Input",
  Evaluatable->False],
Cell[1536993, 42997, 474, 10, 107, "Input",
  Evaluatable->False],
Cell[1537470, 43009, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[1537569, 43013, 126, 3, 27, "Input",
  Evaluatable->False],
Cell[1537698, 43018, 488, 10, 107, "Input",
  Evaluatable->False],
Cell[1538189, 43030, 96, 2, 27, "Input",
  Evaluatable->False],
Cell[1538288, 43034, 126, 3, 27, "Input",
  Evaluatable->False],
Cell[1538417, 43039, 254, 6, 59, "Input",
  Evaluatable->False],
Cell[1538674, 43047, 67, 2, 27, "Input",
  Evaluatable->False]
}, Closed]],

Cell[CellGroupData[{
Cell[1538778, 43054, 34, 0, 45, "Subsection"],
Cell[1538815, 43056, 672, 24, 388, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[1539524, 43085, 34, 0, 45, "Subsection"],
Cell[1539561, 43087, 601, 24, 405, "Text"],
Cell[1540165, 43113, 130, 3, 27, "Output"],
Cell[1540298, 43118, 132, 3, 27, "Output"],
Cell[1540433, 43123, 42, 1, 27, "Output"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[1540524, 43130, 34, 0, 42, "Subsubtitle"],
Cell[1540561, 43132, 71, 2, 27, "Input",
  InitializationCell->True],
Cell[1540635, 43136, 78, 2, 27, "Input",
  InitializationCell->True]
}, Closed]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

